/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs

/* First part of user prologue.  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2006-2010, Greenplum inc
 * Portions Copyright (c) 2012-Present Pivotal Software, Inc.
 * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"
#include "cdb/cdbutil.h"
#include "cdb/cdbvars.h"
#include "cdb/cdbpartition.h"

#include "utils/guc.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);

static void checkWindowExclude(void);
static Node *makeIsNotDistinctFromNode(Node *expr, int position);


#line 255 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    IDENT = 258,                   /* IDENT  */
    FCONST = 259,                  /* FCONST  */
    SCONST = 260,                  /* SCONST  */
    BCONST = 261,                  /* BCONST  */
    XCONST = 262,                  /* XCONST  */
    Op = 263,                      /* Op  */
    ICONST = 264,                  /* ICONST  */
    PARAM = 265,                   /* PARAM  */
    TYPECAST = 266,                /* TYPECAST  */
    DOT_DOT = 267,                 /* DOT_DOT  */
    COLON_EQUALS = 268,            /* COLON_EQUALS  */
    ABORT_P = 269,                 /* ABORT_P  */
    ABSOLUTE_P = 270,              /* ABSOLUTE_P  */
    ACCESS = 271,                  /* ACCESS  */
    ACTION = 272,                  /* ACTION  */
    ADD_P = 273,                   /* ADD_P  */
    ADMIN = 274,                   /* ADMIN  */
    AFTER = 275,                   /* AFTER  */
    AGGREGATE = 276,               /* AGGREGATE  */
    ALL = 277,                     /* ALL  */
    ALSO = 278,                    /* ALSO  */
    ALTER = 279,                   /* ALTER  */
    ALWAYS = 280,                  /* ALWAYS  */
    ANALYSE = 281,                 /* ANALYSE  */
    ANALYZE = 282,                 /* ANALYZE  */
    AND = 283,                     /* AND  */
    ANY = 284,                     /* ANY  */
    ARRAY = 285,                   /* ARRAY  */
    AS = 286,                      /* AS  */
    ASC = 287,                     /* ASC  */
    ASSERTION = 288,               /* ASSERTION  */
    ASSIGNMENT = 289,              /* ASSIGNMENT  */
    ASYMMETRIC = 290,              /* ASYMMETRIC  */
    AT = 291,                      /* AT  */
    ATTRIBUTE = 292,               /* ATTRIBUTE  */
    AUTHORIZATION = 293,           /* AUTHORIZATION  */
    BACKWARD = 294,                /* BACKWARD  */
    BEFORE = 295,                  /* BEFORE  */
    BEGIN_P = 296,                 /* BEGIN_P  */
    BETWEEN = 297,                 /* BETWEEN  */
    BIGINT = 298,                  /* BIGINT  */
    BINARY = 299,                  /* BINARY  */
    BIT = 300,                     /* BIT  */
    BOOLEAN_P = 301,               /* BOOLEAN_P  */
    BOTH = 302,                    /* BOTH  */
    BY = 303,                      /* BY  */
    CACHE = 304,                   /* CACHE  */
    CALLED = 305,                  /* CALLED  */
    CASCADE = 306,                 /* CASCADE  */
    CASCADED = 307,                /* CASCADED  */
    CASE = 308,                    /* CASE  */
    CAST = 309,                    /* CAST  */
    CATALOG_P = 310,               /* CATALOG_P  */
    CHAIN = 311,                   /* CHAIN  */
    CHAR_P = 312,                  /* CHAR_P  */
    CHARACTER = 313,               /* CHARACTER  */
    CHARACTERISTICS = 314,         /* CHARACTERISTICS  */
    CHECK = 315,                   /* CHECK  */
    CHECKPOINT = 316,              /* CHECKPOINT  */
    CLASS = 317,                   /* CLASS  */
    CLOSE = 318,                   /* CLOSE  */
    CLUSTER = 319,                 /* CLUSTER  */
    COALESCE = 320,                /* COALESCE  */
    COLLATE = 321,                 /* COLLATE  */
    COLLATION = 322,               /* COLLATION  */
    COLUMN = 323,                  /* COLUMN  */
    COMMENT = 324,                 /* COMMENT  */
    COMMENTS = 325,                /* COMMENTS  */
    COMMIT = 326,                  /* COMMIT  */
    COMMITTED = 327,               /* COMMITTED  */
    CONCURRENCY = 328,             /* CONCURRENCY  */
    CONCURRENTLY = 329,            /* CONCURRENTLY  */
    CONFIGURATION = 330,           /* CONFIGURATION  */
    CONNECTION = 331,              /* CONNECTION  */
    CONSTRAINT = 332,              /* CONSTRAINT  */
    CONSTRAINTS = 333,             /* CONSTRAINTS  */
    CONTENT_P = 334,               /* CONTENT_P  */
    CONTINUE_P = 335,              /* CONTINUE_P  */
    CONVERSION_P = 336,            /* CONVERSION_P  */
    COPY = 337,                    /* COPY  */
    COST = 338,                    /* COST  */
    CREATE = 339,                  /* CREATE  */
    CROSS = 340,                   /* CROSS  */
    CSV = 341,                     /* CSV  */
    CURRENT_P = 342,               /* CURRENT_P  */
    CURRENT_CATALOG = 343,         /* CURRENT_CATALOG  */
    CURRENT_DATE = 344,            /* CURRENT_DATE  */
    CURRENT_ROLE = 345,            /* CURRENT_ROLE  */
    CURRENT_SCHEMA = 346,          /* CURRENT_SCHEMA  */
    CURRENT_TIME = 347,            /* CURRENT_TIME  */
    CURRENT_TIMESTAMP = 348,       /* CURRENT_TIMESTAMP  */
    CURRENT_USER = 349,            /* CURRENT_USER  */
    CURSOR = 350,                  /* CURSOR  */
    CYCLE = 351,                   /* CYCLE  */
    DATA_P = 352,                  /* DATA_P  */
    DATABASE = 353,                /* DATABASE  */
    DAY_P = 354,                   /* DAY_P  */
    DEALLOCATE = 355,              /* DEALLOCATE  */
    DEC = 356,                     /* DEC  */
    DECIMAL_P = 357,               /* DECIMAL_P  */
    DECLARE = 358,                 /* DECLARE  */
    DEFAULT = 359,                 /* DEFAULT  */
    DEFAULTS = 360,                /* DEFAULTS  */
    DEFERRABLE = 361,              /* DEFERRABLE  */
    DEFERRED = 362,                /* DEFERRED  */
    DEFINER = 363,                 /* DEFINER  */
    DELETE_P = 364,                /* DELETE_P  */
    DELIMITER = 365,               /* DELIMITER  */
    DELIMITERS = 366,              /* DELIMITERS  */
    DESC = 367,                    /* DESC  */
    DICTIONARY = 368,              /* DICTIONARY  */
    DISABLE_P = 369,               /* DISABLE_P  */
    DISCARD = 370,                 /* DISCARD  */
    DISTINCT = 371,                /* DISTINCT  */
    DO = 372,                      /* DO  */
    DOCUMENT_P = 373,              /* DOCUMENT_P  */
    DOMAIN_P = 374,                /* DOMAIN_P  */
    DOUBLE_P = 375,                /* DOUBLE_P  */
    DROP = 376,                    /* DROP  */
    EACH = 377,                    /* EACH  */
    ELSE = 378,                    /* ELSE  */
    ENABLE_P = 379,                /* ENABLE_P  */
    ENCODING = 380,                /* ENCODING  */
    ENCRYPTED = 381,               /* ENCRYPTED  */
    END_P = 382,                   /* END_P  */
    ENUM_P = 383,                  /* ENUM_P  */
    ESCAPE = 384,                  /* ESCAPE  */
    EVENT = 385,                   /* EVENT  */
    EXCEPT = 386,                  /* EXCEPT  */
    EXCLUDE = 387,                 /* EXCLUDE  */
    EXCLUDING = 388,               /* EXCLUDING  */
    EXCLUSIVE = 389,               /* EXCLUSIVE  */
    EXECUTE = 390,                 /* EXECUTE  */
    EXISTS = 391,                  /* EXISTS  */
    EXPLAIN = 392,                 /* EXPLAIN  */
    EXTENSION = 393,               /* EXTENSION  */
    EXTERNAL = 394,                /* EXTERNAL  */
    EXTRACT = 395,                 /* EXTRACT  */
    FALSE_P = 396,                 /* FALSE_P  */
    FAMILY = 397,                  /* FAMILY  */
    FETCH = 398,                   /* FETCH  */
    FILTER = 399,                  /* FILTER  */
    FIRST_P = 400,                 /* FIRST_P  */
    FLOAT_P = 401,                 /* FLOAT_P  */
    FOLLOWING = 402,               /* FOLLOWING  */
    FOR = 403,                     /* FOR  */
    FORCE = 404,                   /* FORCE  */
    FOREIGN = 405,                 /* FOREIGN  */
    FORWARD = 406,                 /* FORWARD  */
    FREEZE = 407,                  /* FREEZE  */
    FROM = 408,                    /* FROM  */
    FULL = 409,                    /* FULL  */
    FUNCTION = 410,                /* FUNCTION  */
    FUNCTIONS = 411,               /* FUNCTIONS  */
    GLOBAL = 412,                  /* GLOBAL  */
    GRANT = 413,                   /* GRANT  */
    GRANTED = 414,                 /* GRANTED  */
    GREATEST = 415,                /* GREATEST  */
    GROUP_P = 416,                 /* GROUP_P  */
    HANDLER = 417,                 /* HANDLER  */
    HAVING = 418,                  /* HAVING  */
    HEADER_P = 419,                /* HEADER_P  */
    HOLD = 420,                    /* HOLD  */
    HOUR_P = 421,                  /* HOUR_P  */
    IDENTITY_P = 422,              /* IDENTITY_P  */
    IF_P = 423,                    /* IF_P  */
    ILIKE = 424,                   /* ILIKE  */
    IMMEDIATE = 425,               /* IMMEDIATE  */
    IMMUTABLE = 426,               /* IMMUTABLE  */
    IMPLICIT_P = 427,              /* IMPLICIT_P  */
    IN_P = 428,                    /* IN_P  */
    INCLUDING = 429,               /* INCLUDING  */
    INCREMENT = 430,               /* INCREMENT  */
    INDEX = 431,                   /* INDEX  */
    INDEXES = 432,                 /* INDEXES  */
    INHERIT = 433,                 /* INHERIT  */
    INHERITS = 434,                /* INHERITS  */
    INITIALLY = 435,               /* INITIALLY  */
    INLINE_P = 436,                /* INLINE_P  */
    INNER_P = 437,                 /* INNER_P  */
    INOUT = 438,                   /* INOUT  */
    INPUT_P = 439,                 /* INPUT_P  */
    INSENSITIVE = 440,             /* INSENSITIVE  */
    INSERT = 441,                  /* INSERT  */
    INSTEAD = 442,                 /* INSTEAD  */
    INT_P = 443,                   /* INT_P  */
    INTEGER = 444,                 /* INTEGER  */
    INTERSECT = 445,               /* INTERSECT  */
    INTERVAL = 446,                /* INTERVAL  */
    INTO = 447,                    /* INTO  */
    INVOKER = 448,                 /* INVOKER  */
    IS = 449,                      /* IS  */
    ISNULL = 450,                  /* ISNULL  */
    ISOLATION = 451,               /* ISOLATION  */
    JOIN = 452,                    /* JOIN  */
    KEY = 453,                     /* KEY  */
    LABEL = 454,                   /* LABEL  */
    LANGUAGE = 455,                /* LANGUAGE  */
    LARGE_P = 456,                 /* LARGE_P  */
    LAST_P = 457,                  /* LAST_P  */
    LATERAL_P = 458,               /* LATERAL_P  */
    LC_COLLATE_P = 459,            /* LC_COLLATE_P  */
    LC_CTYPE_P = 460,              /* LC_CTYPE_P  */
    LEADING = 461,                 /* LEADING  */
    LEAKPROOF = 462,               /* LEAKPROOF  */
    LEAST = 463,                   /* LEAST  */
    LEFT = 464,                    /* LEFT  */
    LEVEL = 465,                   /* LEVEL  */
    LIKE = 466,                    /* LIKE  */
    LIMIT = 467,                   /* LIMIT  */
    LISTEN = 468,                  /* LISTEN  */
    LOAD = 469,                    /* LOAD  */
    LOCAL = 470,                   /* LOCAL  */
    LOCALTIME = 471,               /* LOCALTIME  */
    LOCALTIMESTAMP = 472,          /* LOCALTIMESTAMP  */
    LOCATION = 473,                /* LOCATION  */
    LOCK_P = 474,                  /* LOCK_P  */
    MAPPING = 475,                 /* MAPPING  */
    MATCH = 476,                   /* MATCH  */
    MATERIALIZED = 477,            /* MATERIALIZED  */
    MAXVALUE = 478,                /* MAXVALUE  */
    MEMORY_LIMIT = 479,            /* MEMORY_LIMIT  */
    MEMORY_SHARED_QUOTA = 480,     /* MEMORY_SHARED_QUOTA  */
    MEMORY_SPILL_RATIO = 481,      /* MEMORY_SPILL_RATIO  */
    MINUTE_P = 482,                /* MINUTE_P  */
    MINVALUE = 483,                /* MINVALUE  */
    MODE = 484,                    /* MODE  */
    MONTH_P = 485,                 /* MONTH_P  */
    MOVE = 486,                    /* MOVE  */
    NAME_P = 487,                  /* NAME_P  */
    NAMES = 488,                   /* NAMES  */
    NATIONAL = 489,                /* NATIONAL  */
    NATURAL = 490,                 /* NATURAL  */
    NCHAR = 491,                   /* NCHAR  */
    NEXT = 492,                    /* NEXT  */
    NO = 493,                      /* NO  */
    NONE = 494,                    /* NONE  */
    NOT = 495,                     /* NOT  */
    NOTHING = 496,                 /* NOTHING  */
    NOTIFY = 497,                  /* NOTIFY  */
    NOTNULL = 498,                 /* NOTNULL  */
    NOWAIT = 499,                  /* NOWAIT  */
    NULL_P = 500,                  /* NULL_P  */
    NULLIF = 501,                  /* NULLIF  */
    NULLS_P = 502,                 /* NULLS_P  */
    NUMERIC = 503,                 /* NUMERIC  */
    OBJECT_P = 504,                /* OBJECT_P  */
    OF = 505,                      /* OF  */
    OFF = 506,                     /* OFF  */
    OFFSET = 507,                  /* OFFSET  */
    OIDS = 508,                    /* OIDS  */
    ON = 509,                      /* ON  */
    ONLY = 510,                    /* ONLY  */
    OPERATOR = 511,                /* OPERATOR  */
    OPTION = 512,                  /* OPTION  */
    OPTIONS = 513,                 /* OPTIONS  */
    OR = 514,                      /* OR  */
    ORDER = 515,                   /* ORDER  */
    ORDINALITY = 516,              /* ORDINALITY  */
    OUT_P = 517,                   /* OUT_P  */
    OUTER_P = 518,                 /* OUTER_P  */
    OVER = 519,                    /* OVER  */
    OVERLAPS = 520,                /* OVERLAPS  */
    OVERLAY = 521,                 /* OVERLAY  */
    OWNED = 522,                   /* OWNED  */
    OWNER = 523,                   /* OWNER  */
    PARSER = 524,                  /* PARSER  */
    PARTIAL = 525,                 /* PARTIAL  */
    PARTITION = 526,               /* PARTITION  */
    PASSING = 527,                 /* PASSING  */
    PASSWORD = 528,                /* PASSWORD  */
    PLACING = 529,                 /* PLACING  */
    PLANS = 530,                   /* PLANS  */
    POSITION = 531,                /* POSITION  */
    PRECEDING = 532,               /* PRECEDING  */
    PRECISION = 533,               /* PRECISION  */
    PRESERVE = 534,                /* PRESERVE  */
    PREPARE = 535,                 /* PREPARE  */
    PREPARED = 536,                /* PREPARED  */
    PRIMARY = 537,                 /* PRIMARY  */
    PRIOR = 538,                   /* PRIOR  */
    PRIVILEGES = 539,              /* PRIVILEGES  */
    PROCEDURAL = 540,              /* PROCEDURAL  */
    PROCEDURE = 541,               /* PROCEDURE  */
    PROGRAM = 542,                 /* PROGRAM  */
    QUOTE = 543,                   /* QUOTE  */
    RANGE = 544,                   /* RANGE  */
    READ = 545,                    /* READ  */
    REAL = 546,                    /* REAL  */
    REASSIGN = 547,                /* REASSIGN  */
    RECHECK = 548,                 /* RECHECK  */
    RECURSIVE = 549,               /* RECURSIVE  */
    REF = 550,                     /* REF  */
    REFERENCES = 551,              /* REFERENCES  */
    REFRESH = 552,                 /* REFRESH  */
    REINDEX = 553,                 /* REINDEX  */
    RELATIVE_P = 554,              /* RELATIVE_P  */
    RELEASE = 555,                 /* RELEASE  */
    RENAME = 556,                  /* RENAME  */
    REPEATABLE = 557,              /* REPEATABLE  */
    REPLACE = 558,                 /* REPLACE  */
    REPLICA = 559,                 /* REPLICA  */
    RESET = 560,                   /* RESET  */
    RESTART = 561,                 /* RESTART  */
    RESTRICT = 562,                /* RESTRICT  */
    RETURNING = 563,               /* RETURNING  */
    RETURNS = 564,                 /* RETURNS  */
    REVOKE = 565,                  /* REVOKE  */
    RIGHT = 566,                   /* RIGHT  */
    ROLE = 567,                    /* ROLE  */
    ROLLBACK = 568,                /* ROLLBACK  */
    ROW = 569,                     /* ROW  */
    ROWS = 570,                    /* ROWS  */
    RULE = 571,                    /* RULE  */
    SAVEPOINT = 572,               /* SAVEPOINT  */
    SCHEMA = 573,                  /* SCHEMA  */
    SCROLL = 574,                  /* SCROLL  */
    SEARCH = 575,                  /* SEARCH  */
    SECOND_P = 576,                /* SECOND_P  */
    SECURITY = 577,                /* SECURITY  */
    SELECT = 578,                  /* SELECT  */
    SEQUENCE = 579,                /* SEQUENCE  */
    SEQUENCES = 580,               /* SEQUENCES  */
    SERIALIZABLE = 581,            /* SERIALIZABLE  */
    SERVER = 582,                  /* SERVER  */
    SESSION = 583,                 /* SESSION  */
    SESSION_USER = 584,            /* SESSION_USER  */
    SET = 585,                     /* SET  */
    SETOF = 586,                   /* SETOF  */
    SHARE = 587,                   /* SHARE  */
    SHOW = 588,                    /* SHOW  */
    SIMILAR = 589,                 /* SIMILAR  */
    SIMPLE = 590,                  /* SIMPLE  */
    SMALLINT = 591,                /* SMALLINT  */
    SNAPSHOT = 592,                /* SNAPSHOT  */
    SOME = 593,                    /* SOME  */
    STABLE = 594,                  /* STABLE  */
    STANDALONE_P = 595,            /* STANDALONE_P  */
    START = 596,                   /* START  */
    STATEMENT = 597,               /* STATEMENT  */
    STATISTICS = 598,              /* STATISTICS  */
    STDIN = 599,                   /* STDIN  */
    STDOUT = 600,                  /* STDOUT  */
    STORAGE = 601,                 /* STORAGE  */
    STRICT_P = 602,                /* STRICT_P  */
    STRIP_P = 603,                 /* STRIP_P  */
    SUBSTRING = 604,               /* SUBSTRING  */
    SYMMETRIC = 605,               /* SYMMETRIC  */
    SYSID = 606,                   /* SYSID  */
    SYSTEM_P = 607,                /* SYSTEM_P  */
    TABLE = 608,                   /* TABLE  */
    TABLES = 609,                  /* TABLES  */
    TABLESPACE = 610,              /* TABLESPACE  */
    TEMP = 611,                    /* TEMP  */
    TEMPLATE = 612,                /* TEMPLATE  */
    TEMPORARY = 613,               /* TEMPORARY  */
    TEXT_P = 614,                  /* TEXT_P  */
    THEN = 615,                    /* THEN  */
    TIME = 616,                    /* TIME  */
    TIMESTAMP = 617,               /* TIMESTAMP  */
    TO = 618,                      /* TO  */
    TRAILING = 619,                /* TRAILING  */
    TRANSACTION = 620,             /* TRANSACTION  */
    TREAT = 621,                   /* TREAT  */
    TRIGGER = 622,                 /* TRIGGER  */
    TRIM = 623,                    /* TRIM  */
    TRUE_P = 624,                  /* TRUE_P  */
    TRUNCATE = 625,                /* TRUNCATE  */
    TRUSTED = 626,                 /* TRUSTED  */
    TYPE_P = 627,                  /* TYPE_P  */
    TYPES_P = 628,                 /* TYPES_P  */
    UNBOUNDED = 629,               /* UNBOUNDED  */
    UNCOMMITTED = 630,             /* UNCOMMITTED  */
    UNENCRYPTED = 631,             /* UNENCRYPTED  */
    UNION = 632,                   /* UNION  */
    UNIQUE = 633,                  /* UNIQUE  */
    UNKNOWN = 634,                 /* UNKNOWN  */
    UNLISTEN = 635,                /* UNLISTEN  */
    UNLOGGED = 636,                /* UNLOGGED  */
    UNTIL = 637,                   /* UNTIL  */
    UPDATE = 638,                  /* UPDATE  */
    USER = 639,                    /* USER  */
    USING = 640,                   /* USING  */
    VACUUM = 641,                  /* VACUUM  */
    VALID = 642,                   /* VALID  */
    VALIDATE = 643,                /* VALIDATE  */
    VALIDATOR = 644,               /* VALIDATOR  */
    VALUE_P = 645,                 /* VALUE_P  */
    VALUES = 646,                  /* VALUES  */
    VARCHAR = 647,                 /* VARCHAR  */
    VARIADIC = 648,                /* VARIADIC  */
    VARYING = 649,                 /* VARYING  */
    VERBOSE = 650,                 /* VERBOSE  */
    VERSION_P = 651,               /* VERSION_P  */
    VIEW = 652,                    /* VIEW  */
    VIEWS = 653,                   /* VIEWS  */
    VOLATILE = 654,                /* VOLATILE  */
    WHEN = 655,                    /* WHEN  */
    WHERE = 656,                   /* WHERE  */
    WHITESPACE_P = 657,            /* WHITESPACE_P  */
    WINDOW = 658,                  /* WINDOW  */
    WITH = 659,                    /* WITH  */
    WITHIN = 660,                  /* WITHIN  */
    WITHOUT = 661,                 /* WITHOUT  */
    WORK = 662,                    /* WORK  */
    WRAPPER = 663,                 /* WRAPPER  */
    WRITE = 664,                   /* WRITE  */
    XML_P = 665,                   /* XML_P  */
    XMLATTRIBUTES = 666,           /* XMLATTRIBUTES  */
    XMLCONCAT = 667,               /* XMLCONCAT  */
    XMLELEMENT = 668,              /* XMLELEMENT  */
    XMLEXISTS = 669,               /* XMLEXISTS  */
    XMLFOREST = 670,               /* XMLFOREST  */
    XMLPARSE = 671,                /* XMLPARSE  */
    XMLPI = 672,                   /* XMLPI  */
    XMLROOT = 673,                 /* XMLROOT  */
    XMLSERIALIZE = 674,            /* XMLSERIALIZE  */
    YEAR_P = 675,                  /* YEAR_P  */
    YES_P = 676,                   /* YES_P  */
    ZONE = 677,                    /* ZONE  */
    ACTIVE = 678,                  /* ACTIVE  */
    CONTAINS = 679,                /* CONTAINS  */
    CPUSET = 680,                  /* CPUSET  */
    CPU_RATE_LIMIT = 681,          /* CPU_RATE_LIMIT  */
    CREATEEXTTABLE = 682,          /* CREATEEXTTABLE  */
    CUBE = 683,                    /* CUBE  */
    DECODE = 684,                  /* DECODE  */
    DENY = 685,                    /* DENY  */
    DISTRIBUTED = 686,             /* DISTRIBUTED  */
    DXL = 687,                     /* DXL  */
    ERRORS = 688,                  /* ERRORS  */
    EVERY = 689,                   /* EVERY  */
    EXCHANGE = 690,                /* EXCHANGE  */
    EXPAND = 691,                  /* EXPAND  */
    FIELDS = 692,                  /* FIELDS  */
    FILL = 693,                    /* FILL  */
    FORMAT = 694,                  /* FORMAT  */
    FULLSCAN = 695,                /* FULLSCAN  */
    GROUP_ID = 696,                /* GROUP_ID  */
    GROUPING = 697,                /* GROUPING  */
    HASH = 698,                    /* HASH  */
    HOST = 699,                    /* HOST  */
    IGNORE_P = 700,                /* IGNORE_P  */
    INCLUSIVE = 701,               /* INCLUSIVE  */
    INITPLAN = 702,                /* INITPLAN  */
    LIST = 703,                    /* LIST  */
    LOG_P = 704,                   /* LOG_P  */
    MASTER = 705,                  /* MASTER  */
    MEDIAN = 706,                  /* MEDIAN  */
    MISSING = 707,                 /* MISSING  */
    MODIFIES = 708,                /* MODIFIES  */
    NEWLINE = 709,                 /* NEWLINE  */
    NOCREATEEXTTABLE = 710,        /* NOCREATEEXTTABLE  */
    NOOVERCOMMIT = 711,            /* NOOVERCOMMIT  */
    ORDERED = 712,                 /* ORDERED  */
    OTHERS = 713,                  /* OTHERS  */
    OVERCOMMIT = 714,              /* OVERCOMMIT  */
    PARTITIONS = 715,              /* PARTITIONS  */
    PERCENT = 716,                 /* PERCENT  */
    PERSISTENTLY = 717,            /* PERSISTENTLY  */
    PROTOCOL = 718,                /* PROTOCOL  */
    QUEUE = 719,                   /* QUEUE  */
    RANDOMLY = 720,                /* RANDOMLY  */
    READABLE = 721,                /* READABLE  */
    READS = 722,                   /* READS  */
    REJECT_P = 723,                /* REJECT_P  */
    REPLICATED = 724,              /* REPLICATED  */
    RESOURCE = 725,                /* RESOURCE  */
    ROLLUP = 726,                  /* ROLLUP  */
    ROOTPARTITION = 727,           /* ROOTPARTITION  */
    SCATTER = 728,                 /* SCATTER  */
    SEGMENT = 729,                 /* SEGMENT  */
    SEGMENTS = 730,                /* SEGMENTS  */
    SETS = 731,                    /* SETS  */
    SPLIT = 732,                   /* SPLIT  */
    SQL = 733,                     /* SQL  */
    SUBPARTITION = 734,            /* SUBPARTITION  */
    THRESHOLD = 735,               /* THRESHOLD  */
    TIES = 736,                    /* TIES  */
    VALIDATION = 737,              /* VALIDATION  */
    WEB = 738,                     /* WEB  */
    WRITABLE = 739,                /* WRITABLE  */
    NULLS_FIRST = 740,             /* NULLS_FIRST  */
    NULLS_LAST = 741,              /* NULLS_LAST  */
    WITH_ORDINALITY = 742,         /* WITH_ORDINALITY  */
    WITH_TIME = 743,               /* WITH_TIME  */
    POSTFIXOP = 744,               /* POSTFIXOP  */
    UMINUS = 745                   /* UMINUS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 189 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 832 "gram.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_FCONST = 4,                     /* FCONST  */
  YYSYMBOL_SCONST = 5,                     /* SCONST  */
  YYSYMBOL_BCONST = 6,                     /* BCONST  */
  YYSYMBOL_XCONST = 7,                     /* XCONST  */
  YYSYMBOL_Op = 8,                         /* Op  */
  YYSYMBOL_ICONST = 9,                     /* ICONST  */
  YYSYMBOL_PARAM = 10,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 11,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 12,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 13,              /* COLON_EQUALS  */
  YYSYMBOL_ABORT_P = 14,                   /* ABORT_P  */
  YYSYMBOL_ABSOLUTE_P = 15,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 16,                    /* ACCESS  */
  YYSYMBOL_ACTION = 17,                    /* ACTION  */
  YYSYMBOL_ADD_P = 18,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 19,                     /* ADMIN  */
  YYSYMBOL_AFTER = 20,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 21,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 22,                       /* ALL  */
  YYSYMBOL_ALSO = 23,                      /* ALSO  */
  YYSYMBOL_ALTER = 24,                     /* ALTER  */
  YYSYMBOL_ALWAYS = 25,                    /* ALWAYS  */
  YYSYMBOL_ANALYSE = 26,                   /* ANALYSE  */
  YYSYMBOL_ANALYZE = 27,                   /* ANALYZE  */
  YYSYMBOL_AND = 28,                       /* AND  */
  YYSYMBOL_ANY = 29,                       /* ANY  */
  YYSYMBOL_ARRAY = 30,                     /* ARRAY  */
  YYSYMBOL_AS = 31,                        /* AS  */
  YYSYMBOL_ASC = 32,                       /* ASC  */
  YYSYMBOL_ASSERTION = 33,                 /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 34,                /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 35,                /* ASYMMETRIC  */
  YYSYMBOL_AT = 36,                        /* AT  */
  YYSYMBOL_ATTRIBUTE = 37,                 /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 38,             /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 39,                  /* BACKWARD  */
  YYSYMBOL_BEFORE = 40,                    /* BEFORE  */
  YYSYMBOL_BEGIN_P = 41,                   /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 42,                   /* BETWEEN  */
  YYSYMBOL_BIGINT = 43,                    /* BIGINT  */
  YYSYMBOL_BINARY = 44,                    /* BINARY  */
  YYSYMBOL_BIT = 45,                       /* BIT  */
  YYSYMBOL_BOOLEAN_P = 46,                 /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 47,                      /* BOTH  */
  YYSYMBOL_BY = 48,                        /* BY  */
  YYSYMBOL_CACHE = 49,                     /* CACHE  */
  YYSYMBOL_CALLED = 50,                    /* CALLED  */
  YYSYMBOL_CASCADE = 51,                   /* CASCADE  */
  YYSYMBOL_CASCADED = 52,                  /* CASCADED  */
  YYSYMBOL_CASE = 53,                      /* CASE  */
  YYSYMBOL_CAST = 54,                      /* CAST  */
  YYSYMBOL_CATALOG_P = 55,                 /* CATALOG_P  */
  YYSYMBOL_CHAIN = 56,                     /* CHAIN  */
  YYSYMBOL_CHAR_P = 57,                    /* CHAR_P  */
  YYSYMBOL_CHARACTER = 58,                 /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 59,           /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 60,                     /* CHECK  */
  YYSYMBOL_CHECKPOINT = 61,                /* CHECKPOINT  */
  YYSYMBOL_CLASS = 62,                     /* CLASS  */
  YYSYMBOL_CLOSE = 63,                     /* CLOSE  */
  YYSYMBOL_CLUSTER = 64,                   /* CLUSTER  */
  YYSYMBOL_COALESCE = 65,                  /* COALESCE  */
  YYSYMBOL_COLLATE = 66,                   /* COLLATE  */
  YYSYMBOL_COLLATION = 67,                 /* COLLATION  */
  YYSYMBOL_COLUMN = 68,                    /* COLUMN  */
  YYSYMBOL_COMMENT = 69,                   /* COMMENT  */
  YYSYMBOL_COMMENTS = 70,                  /* COMMENTS  */
  YYSYMBOL_COMMIT = 71,                    /* COMMIT  */
  YYSYMBOL_COMMITTED = 72,                 /* COMMITTED  */
  YYSYMBOL_CONCURRENCY = 73,               /* CONCURRENCY  */
  YYSYMBOL_CONCURRENTLY = 74,              /* CONCURRENTLY  */
  YYSYMBOL_CONFIGURATION = 75,             /* CONFIGURATION  */
  YYSYMBOL_CONNECTION = 76,                /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 77,                /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 78,               /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 79,                 /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 80,                /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 81,              /* CONVERSION_P  */
  YYSYMBOL_COPY = 82,                      /* COPY  */
  YYSYMBOL_COST = 83,                      /* COST  */
  YYSYMBOL_CREATE = 84,                    /* CREATE  */
  YYSYMBOL_CROSS = 85,                     /* CROSS  */
  YYSYMBOL_CSV = 86,                       /* CSV  */
  YYSYMBOL_CURRENT_P = 87,                 /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 88,           /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 89,              /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 90,              /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 91,            /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 92,              /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 93,         /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 94,              /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 95,                    /* CURSOR  */
  YYSYMBOL_CYCLE = 96,                     /* CYCLE  */
  YYSYMBOL_DATA_P = 97,                    /* DATA_P  */
  YYSYMBOL_DATABASE = 98,                  /* DATABASE  */
  YYSYMBOL_DAY_P = 99,                     /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 100,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 101,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 102,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 103,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 104,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 105,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 106,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 107,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 108,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 109,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 110,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 111,               /* DELIMITERS  */
  YYSYMBOL_DESC = 112,                     /* DESC  */
  YYSYMBOL_DICTIONARY = 113,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 114,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 115,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 116,                 /* DISTINCT  */
  YYSYMBOL_DO = 117,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 118,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 119,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 120,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 121,                     /* DROP  */
  YYSYMBOL_EACH = 122,                     /* EACH  */
  YYSYMBOL_ELSE = 123,                     /* ELSE  */
  YYSYMBOL_ENABLE_P = 124,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 125,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 126,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 127,                    /* END_P  */
  YYSYMBOL_ENUM_P = 128,                   /* ENUM_P  */
  YYSYMBOL_ESCAPE = 129,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 130,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 131,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 132,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 133,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 134,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 135,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 136,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 137,                  /* EXPLAIN  */
  YYSYMBOL_EXTENSION = 138,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 139,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 140,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 141,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 142,                   /* FAMILY  */
  YYSYMBOL_FETCH = 143,                    /* FETCH  */
  YYSYMBOL_FILTER = 144,                   /* FILTER  */
  YYSYMBOL_FIRST_P = 145,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 146,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 147,                /* FOLLOWING  */
  YYSYMBOL_FOR = 148,                      /* FOR  */
  YYSYMBOL_FORCE = 149,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 150,                  /* FOREIGN  */
  YYSYMBOL_FORWARD = 151,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 152,                   /* FREEZE  */
  YYSYMBOL_FROM = 153,                     /* FROM  */
  YYSYMBOL_FULL = 154,                     /* FULL  */
  YYSYMBOL_FUNCTION = 155,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 156,                /* FUNCTIONS  */
  YYSYMBOL_GLOBAL = 157,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 158,                    /* GRANT  */
  YYSYMBOL_GRANTED = 159,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 160,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 161,                  /* GROUP_P  */
  YYSYMBOL_HANDLER = 162,                  /* HANDLER  */
  YYSYMBOL_HAVING = 163,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 164,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 165,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 166,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 167,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 168,                     /* IF_P  */
  YYSYMBOL_ILIKE = 169,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 170,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 171,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 172,               /* IMPLICIT_P  */
  YYSYMBOL_IN_P = 173,                     /* IN_P  */
  YYSYMBOL_INCLUDING = 174,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 175,                /* INCREMENT  */
  YYSYMBOL_INDEX = 176,                    /* INDEX  */
  YYSYMBOL_INDEXES = 177,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 178,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 179,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 180,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 181,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 182,                  /* INNER_P  */
  YYSYMBOL_INOUT = 183,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 184,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 185,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 186,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 187,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 188,                    /* INT_P  */
  YYSYMBOL_INTEGER = 189,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 190,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 191,                 /* INTERVAL  */
  YYSYMBOL_INTO = 192,                     /* INTO  */
  YYSYMBOL_INVOKER = 193,                  /* INVOKER  */
  YYSYMBOL_IS = 194,                       /* IS  */
  YYSYMBOL_ISNULL = 195,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 196,                /* ISOLATION  */
  YYSYMBOL_JOIN = 197,                     /* JOIN  */
  YYSYMBOL_KEY = 198,                      /* KEY  */
  YYSYMBOL_LABEL = 199,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 200,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 201,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 202,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 203,                /* LATERAL_P  */
  YYSYMBOL_LC_COLLATE_P = 204,             /* LC_COLLATE_P  */
  YYSYMBOL_LC_CTYPE_P = 205,               /* LC_CTYPE_P  */
  YYSYMBOL_LEADING = 206,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 207,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 208,                    /* LEAST  */
  YYSYMBOL_LEFT = 209,                     /* LEFT  */
  YYSYMBOL_LEVEL = 210,                    /* LEVEL  */
  YYSYMBOL_LIKE = 211,                     /* LIKE  */
  YYSYMBOL_LIMIT = 212,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 213,                   /* LISTEN  */
  YYSYMBOL_LOAD = 214,                     /* LOAD  */
  YYSYMBOL_LOCAL = 215,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 216,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 217,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 218,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 219,                   /* LOCK_P  */
  YYSYMBOL_MAPPING = 220,                  /* MAPPING  */
  YYSYMBOL_MATCH = 221,                    /* MATCH  */
  YYSYMBOL_MATERIALIZED = 222,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 223,                 /* MAXVALUE  */
  YYSYMBOL_MEMORY_LIMIT = 224,             /* MEMORY_LIMIT  */
  YYSYMBOL_MEMORY_SHARED_QUOTA = 225,      /* MEMORY_SHARED_QUOTA  */
  YYSYMBOL_MEMORY_SPILL_RATIO = 226,       /* MEMORY_SPILL_RATIO  */
  YYSYMBOL_MINUTE_P = 227,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 228,                 /* MINVALUE  */
  YYSYMBOL_MODE = 229,                     /* MODE  */
  YYSYMBOL_MONTH_P = 230,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 231,                     /* MOVE  */
  YYSYMBOL_NAME_P = 232,                   /* NAME_P  */
  YYSYMBOL_NAMES = 233,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 234,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 235,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 236,                    /* NCHAR  */
  YYSYMBOL_NEXT = 237,                     /* NEXT  */
  YYSYMBOL_NO = 238,                       /* NO  */
  YYSYMBOL_NONE = 239,                     /* NONE  */
  YYSYMBOL_NOT = 240,                      /* NOT  */
  YYSYMBOL_NOTHING = 241,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 242,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 243,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 244,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 245,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 246,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 247,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 248,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 249,                 /* OBJECT_P  */
  YYSYMBOL_OF = 250,                       /* OF  */
  YYSYMBOL_OFF = 251,                      /* OFF  */
  YYSYMBOL_OFFSET = 252,                   /* OFFSET  */
  YYSYMBOL_OIDS = 253,                     /* OIDS  */
  YYSYMBOL_ON = 254,                       /* ON  */
  YYSYMBOL_ONLY = 255,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 256,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 257,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 258,                  /* OPTIONS  */
  YYSYMBOL_OR = 259,                       /* OR  */
  YYSYMBOL_ORDER = 260,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 261,               /* ORDINALITY  */
  YYSYMBOL_OUT_P = 262,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 263,                  /* OUTER_P  */
  YYSYMBOL_OVER = 264,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 265,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 266,                  /* OVERLAY  */
  YYSYMBOL_OWNED = 267,                    /* OWNED  */
  YYSYMBOL_OWNER = 268,                    /* OWNER  */
  YYSYMBOL_PARSER = 269,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 270,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 271,                /* PARTITION  */
  YYSYMBOL_PASSING = 272,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 273,                 /* PASSWORD  */
  YYSYMBOL_PLACING = 274,                  /* PLACING  */
  YYSYMBOL_PLANS = 275,                    /* PLANS  */
  YYSYMBOL_POSITION = 276,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 277,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 278,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 279,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 280,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 281,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 282,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 283,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 284,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 285,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 286,                /* PROCEDURE  */
  YYSYMBOL_PROGRAM = 287,                  /* PROGRAM  */
  YYSYMBOL_QUOTE = 288,                    /* QUOTE  */
  YYSYMBOL_RANGE = 289,                    /* RANGE  */
  YYSYMBOL_READ = 290,                     /* READ  */
  YYSYMBOL_REAL = 291,                     /* REAL  */
  YYSYMBOL_REASSIGN = 292,                 /* REASSIGN  */
  YYSYMBOL_RECHECK = 293,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 294,                /* RECURSIVE  */
  YYSYMBOL_REF = 295,                      /* REF  */
  YYSYMBOL_REFERENCES = 296,               /* REFERENCES  */
  YYSYMBOL_REFRESH = 297,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 298,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 299,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 300,                  /* RELEASE  */
  YYSYMBOL_RENAME = 301,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 302,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 303,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 304,                  /* REPLICA  */
  YYSYMBOL_RESET = 305,                    /* RESET  */
  YYSYMBOL_RESTART = 306,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 307,                 /* RESTRICT  */
  YYSYMBOL_RETURNING = 308,                /* RETURNING  */
  YYSYMBOL_RETURNS = 309,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 310,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 311,                    /* RIGHT  */
  YYSYMBOL_ROLE = 312,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 313,                 /* ROLLBACK  */
  YYSYMBOL_ROW = 314,                      /* ROW  */
  YYSYMBOL_ROWS = 315,                     /* ROWS  */
  YYSYMBOL_RULE = 316,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 317,                /* SAVEPOINT  */
  YYSYMBOL_SCHEMA = 318,                   /* SCHEMA  */
  YYSYMBOL_SCROLL = 319,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 320,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 321,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 322,                 /* SECURITY  */
  YYSYMBOL_SELECT = 323,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 324,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 325,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 326,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 327,                   /* SERVER  */
  YYSYMBOL_SESSION = 328,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 329,             /* SESSION_USER  */
  YYSYMBOL_SET = 330,                      /* SET  */
  YYSYMBOL_SETOF = 331,                    /* SETOF  */
  YYSYMBOL_SHARE = 332,                    /* SHARE  */
  YYSYMBOL_SHOW = 333,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 334,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 335,                   /* SIMPLE  */
  YYSYMBOL_SMALLINT = 336,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 337,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 338,                     /* SOME  */
  YYSYMBOL_STABLE = 339,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 340,             /* STANDALONE_P  */
  YYSYMBOL_START = 341,                    /* START  */
  YYSYMBOL_STATEMENT = 342,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 343,               /* STATISTICS  */
  YYSYMBOL_STDIN = 344,                    /* STDIN  */
  YYSYMBOL_STDOUT = 345,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 346,                  /* STORAGE  */
  YYSYMBOL_STRICT_P = 347,                 /* STRICT_P  */
  YYSYMBOL_STRIP_P = 348,                  /* STRIP_P  */
  YYSYMBOL_SUBSTRING = 349,                /* SUBSTRING  */
  YYSYMBOL_SYMMETRIC = 350,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 351,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 352,                 /* SYSTEM_P  */
  YYSYMBOL_TABLE = 353,                    /* TABLE  */
  YYSYMBOL_TABLES = 354,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 355,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 356,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 357,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 358,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 359,                   /* TEXT_P  */
  YYSYMBOL_THEN = 360,                     /* THEN  */
  YYSYMBOL_TIME = 361,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 362,                /* TIMESTAMP  */
  YYSYMBOL_TO = 363,                       /* TO  */
  YYSYMBOL_TRAILING = 364,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 365,              /* TRANSACTION  */
  YYSYMBOL_TREAT = 366,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 367,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 368,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 369,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 370,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 371,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 372,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 373,                  /* TYPES_P  */
  YYSYMBOL_UNBOUNDED = 374,                /* UNBOUNDED  */
  YYSYMBOL_UNCOMMITTED = 375,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 376,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 377,                    /* UNION  */
  YYSYMBOL_UNIQUE = 378,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 379,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 380,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 381,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 382,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 383,                   /* UPDATE  */
  YYSYMBOL_USER = 384,                     /* USER  */
  YYSYMBOL_USING = 385,                    /* USING  */
  YYSYMBOL_VACUUM = 386,                   /* VACUUM  */
  YYSYMBOL_VALID = 387,                    /* VALID  */
  YYSYMBOL_VALIDATE = 388,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 389,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 390,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 391,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 392,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 393,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 394,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 395,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 396,                /* VERSION_P  */
  YYSYMBOL_VIEW = 397,                     /* VIEW  */
  YYSYMBOL_VIEWS = 398,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 399,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 400,                     /* WHEN  */
  YYSYMBOL_WHERE = 401,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 402,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 403,                   /* WINDOW  */
  YYSYMBOL_WITH = 404,                     /* WITH  */
  YYSYMBOL_WITHIN = 405,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 406,                  /* WITHOUT  */
  YYSYMBOL_WORK = 407,                     /* WORK  */
  YYSYMBOL_WRAPPER = 408,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 409,                    /* WRITE  */
  YYSYMBOL_XML_P = 410,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 411,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 412,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 413,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 414,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 415,                /* XMLFOREST  */
  YYSYMBOL_XMLPARSE = 416,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 417,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 418,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 419,             /* XMLSERIALIZE  */
  YYSYMBOL_YEAR_P = 420,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 421,                    /* YES_P  */
  YYSYMBOL_ZONE = 422,                     /* ZONE  */
  YYSYMBOL_ACTIVE = 423,                   /* ACTIVE  */
  YYSYMBOL_CONTAINS = 424,                 /* CONTAINS  */
  YYSYMBOL_CPUSET = 425,                   /* CPUSET  */
  YYSYMBOL_CPU_RATE_LIMIT = 426,           /* CPU_RATE_LIMIT  */
  YYSYMBOL_CREATEEXTTABLE = 427,           /* CREATEEXTTABLE  */
  YYSYMBOL_CUBE = 428,                     /* CUBE  */
  YYSYMBOL_DECODE = 429,                   /* DECODE  */
  YYSYMBOL_DENY = 430,                     /* DENY  */
  YYSYMBOL_DISTRIBUTED = 431,              /* DISTRIBUTED  */
  YYSYMBOL_DXL = 432,                      /* DXL  */
  YYSYMBOL_ERRORS = 433,                   /* ERRORS  */
  YYSYMBOL_EVERY = 434,                    /* EVERY  */
  YYSYMBOL_EXCHANGE = 435,                 /* EXCHANGE  */
  YYSYMBOL_EXPAND = 436,                   /* EXPAND  */
  YYSYMBOL_FIELDS = 437,                   /* FIELDS  */
  YYSYMBOL_FILL = 438,                     /* FILL  */
  YYSYMBOL_FORMAT = 439,                   /* FORMAT  */
  YYSYMBOL_FULLSCAN = 440,                 /* FULLSCAN  */
  YYSYMBOL_GROUP_ID = 441,                 /* GROUP_ID  */
  YYSYMBOL_GROUPING = 442,                 /* GROUPING  */
  YYSYMBOL_HASH = 443,                     /* HASH  */
  YYSYMBOL_HOST = 444,                     /* HOST  */
  YYSYMBOL_IGNORE_P = 445,                 /* IGNORE_P  */
  YYSYMBOL_INCLUSIVE = 446,                /* INCLUSIVE  */
  YYSYMBOL_INITPLAN = 447,                 /* INITPLAN  */
  YYSYMBOL_LIST = 448,                     /* LIST  */
  YYSYMBOL_LOG_P = 449,                    /* LOG_P  */
  YYSYMBOL_MASTER = 450,                   /* MASTER  */
  YYSYMBOL_MEDIAN = 451,                   /* MEDIAN  */
  YYSYMBOL_MISSING = 452,                  /* MISSING  */
  YYSYMBOL_MODIFIES = 453,                 /* MODIFIES  */
  YYSYMBOL_NEWLINE = 454,                  /* NEWLINE  */
  YYSYMBOL_NOCREATEEXTTABLE = 455,         /* NOCREATEEXTTABLE  */
  YYSYMBOL_NOOVERCOMMIT = 456,             /* NOOVERCOMMIT  */
  YYSYMBOL_ORDERED = 457,                  /* ORDERED  */
  YYSYMBOL_OTHERS = 458,                   /* OTHERS  */
  YYSYMBOL_OVERCOMMIT = 459,               /* OVERCOMMIT  */
  YYSYMBOL_PARTITIONS = 460,               /* PARTITIONS  */
  YYSYMBOL_PERCENT = 461,                  /* PERCENT  */
  YYSYMBOL_PERSISTENTLY = 462,             /* PERSISTENTLY  */
  YYSYMBOL_PROTOCOL = 463,                 /* PROTOCOL  */
  YYSYMBOL_QUEUE = 464,                    /* QUEUE  */
  YYSYMBOL_RANDOMLY = 465,                 /* RANDOMLY  */
  YYSYMBOL_READABLE = 466,                 /* READABLE  */
  YYSYMBOL_READS = 467,                    /* READS  */
  YYSYMBOL_REJECT_P = 468,                 /* REJECT_P  */
  YYSYMBOL_REPLICATED = 469,               /* REPLICATED  */
  YYSYMBOL_RESOURCE = 470,                 /* RESOURCE  */
  YYSYMBOL_ROLLUP = 471,                   /* ROLLUP  */
  YYSYMBOL_ROOTPARTITION = 472,            /* ROOTPARTITION  */
  YYSYMBOL_SCATTER = 473,                  /* SCATTER  */
  YYSYMBOL_SEGMENT = 474,                  /* SEGMENT  */
  YYSYMBOL_SEGMENTS = 475,                 /* SEGMENTS  */
  YYSYMBOL_SETS = 476,                     /* SETS  */
  YYSYMBOL_SPLIT = 477,                    /* SPLIT  */
  YYSYMBOL_SQL = 478,                      /* SQL  */
  YYSYMBOL_SUBPARTITION = 479,             /* SUBPARTITION  */
  YYSYMBOL_THRESHOLD = 480,                /* THRESHOLD  */
  YYSYMBOL_TIES = 481,                     /* TIES  */
  YYSYMBOL_VALIDATION = 482,               /* VALIDATION  */
  YYSYMBOL_WEB = 483,                      /* WEB  */
  YYSYMBOL_WRITABLE = 484,                 /* WRITABLE  */
  YYSYMBOL_NULLS_FIRST = 485,              /* NULLS_FIRST  */
  YYSYMBOL_NULLS_LAST = 486,               /* NULLS_LAST  */
  YYSYMBOL_WITH_ORDINALITY = 487,          /* WITH_ORDINALITY  */
  YYSYMBOL_WITH_TIME = 488,                /* WITH_TIME  */
  YYSYMBOL_489_ = 489,                     /* '='  */
  YYSYMBOL_490_ = 490,                     /* '<'  */
  YYSYMBOL_491_ = 491,                     /* '>'  */
  YYSYMBOL_POSTFIXOP = 492,                /* POSTFIXOP  */
  YYSYMBOL_493_ = 493,                     /* '+'  */
  YYSYMBOL_494_ = 494,                     /* '-'  */
  YYSYMBOL_495_ = 495,                     /* '*'  */
  YYSYMBOL_496_ = 496,                     /* '/'  */
  YYSYMBOL_497_ = 497,                     /* '%'  */
  YYSYMBOL_498_ = 498,                     /* '^'  */
  YYSYMBOL_UMINUS = 499,                   /* UMINUS  */
  YYSYMBOL_500_ = 500,                     /* '['  */
  YYSYMBOL_501_ = 501,                     /* ']'  */
  YYSYMBOL_502_ = 502,                     /* '('  */
  YYSYMBOL_503_ = 503,                     /* ')'  */
  YYSYMBOL_504_ = 504,                     /* '.'  */
  YYSYMBOL_505_ = 505,                     /* ';'  */
  YYSYMBOL_506_ = 506,                     /* ','  */
  YYSYMBOL_507_ = 507,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 508,                 /* $accept  */
  YYSYMBOL_stmtblock = 509,                /* stmtblock  */
  YYSYMBOL_stmtmulti = 510,                /* stmtmulti  */
  YYSYMBOL_stmt = 511,                     /* stmt  */
  YYSYMBOL_CreateQueueStmt = 512,          /* CreateQueueStmt  */
  YYSYMBOL_OptQueueList = 513,             /* OptQueueList  */
  YYSYMBOL_OptQueueElem = 514,             /* OptQueueElem  */
  YYSYMBOL_AlterQueueStmt = 515,           /* AlterQueueStmt  */
  YYSYMBOL_DropQueueStmt = 516,            /* DropQueueStmt  */
  YYSYMBOL_CreateResourceGroupStmt = 517,  /* CreateResourceGroupStmt  */
  YYSYMBOL_DropResourceGroupStmt = 518,    /* DropResourceGroupStmt  */
  YYSYMBOL_AlterResourceGroupStmt = 519,   /* AlterResourceGroupStmt  */
  YYSYMBOL_OptResourceGroupList = 520,     /* OptResourceGroupList  */
  YYSYMBOL_OptResourceGroupElem = 521,     /* OptResourceGroupElem  */
  YYSYMBOL_CreateRoleStmt = 522,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 523,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 524,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 525,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOnlyOptRoleElem = 526,     /* AlterOnlyOptRoleElem  */
  YYSYMBOL_AlterOptRoleElem = 527,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 528,        /* CreateOptRoleElem  */
  YYSYMBOL_deny_login_role = 529,          /* deny_login_role  */
  YYSYMBOL_deny_interval = 530,            /* deny_interval  */
  YYSYMBOL_deny_day_specifier = 531,       /* deny_day_specifier  */
  YYSYMBOL_deny_point = 532,               /* deny_point  */
  YYSYMBOL_opt_time = 533,                 /* opt_time  */
  YYSYMBOL_exttab_auth_list = 534,         /* exttab_auth_list  */
  YYSYMBOL_keyvalue_list = 535,            /* keyvalue_list  */
  YYSYMBOL_keyvalue_pair = 536,            /* keyvalue_pair  */
  YYSYMBOL_CreateUserStmt = 537,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 538,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 539,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 540,         /* AlterRoleSetStmt  */
  YYSYMBOL_AlterUserStmt = 541,            /* AlterUserStmt  */
  YYSYMBOL_AlterUserSetStmt = 542,         /* AlterUserSetStmt  */
  YYSYMBOL_DropRoleStmt = 543,             /* DropRoleStmt  */
  YYSYMBOL_DropUserStmt = 544,             /* DropUserStmt  */
  YYSYMBOL_CreateGroupStmt = 545,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 546,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 547,                 /* add_drop  */
  YYSYMBOL_DropGroupStmt = 548,            /* DropGroupStmt  */
  YYSYMBOL_CreateSchemaStmt = 549,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaName = 550,            /* OptSchemaName  */
  YYSYMBOL_OptSchemaEltList = 551,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 552,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 553,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 554,                 /* set_rest  */
  YYSYMBOL_generic_set = 555,              /* generic_set  */
  YYSYMBOL_set_rest_more = 556,            /* set_rest_more  */
  YYSYMBOL_var_name = 557,                 /* var_name  */
  YYSYMBOL_var_list = 558,                 /* var_list  */
  YYSYMBOL_var_value = 559,                /* var_value  */
  YYSYMBOL_iso_level = 560,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 561,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 562,               /* zone_value  */
  YYSYMBOL_opt_encoding = 563,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 564, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 565,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 566,               /* reset_rest  */
  YYSYMBOL_generic_reset = 567,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 568,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 569,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 570,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 571,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 572,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 573,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 574,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 575,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 576,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 577,         /* alter_table_cmds  */
  YYSYMBOL_alter_table_cmd = 578,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 579,     /* alter_column_default  */
  YYSYMBOL_opt_drop_behavior = 580,        /* opt_drop_behavior  */
  YYSYMBOL_opt_collate_clause = 581,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 582,              /* alter_using  */
  YYSYMBOL_replica_identity = 583,         /* replica_identity  */
  YYSYMBOL_reloptions = 584,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 585,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 586,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 587,           /* reloption_elem  */
  YYSYMBOL_opt_table_partition_split_into = 588, /* opt_table_partition_split_into  */
  YYSYMBOL_opt_table_partition_exchange_validate = 589, /* opt_table_partition_exchange_validate  */
  YYSYMBOL_alter_table_partition_id_spec = 590, /* alter_table_partition_id_spec  */
  YYSYMBOL_alter_table_partition_id_spec_with_opt_default = 591, /* alter_table_partition_id_spec_with_opt_default  */
  YYSYMBOL_alter_table_partition_cmd = 592, /* alter_table_partition_cmd  */
  YYSYMBOL_AlterCompositeTypeStmt = 593,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 594,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 595,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 596,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 597,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 598,                /* copy_from  */
  YYSYMBOL_opt_program = 599,              /* opt_program  */
  YYSYMBOL_skip_external_partition = 600,  /* skip_external_partition  */
  YYSYMBOL_copy_file_name = 601,           /* copy_file_name  */
  YYSYMBOL_copy_options = 602,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 603,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 604,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 605,               /* opt_binary  */
  YYSYMBOL_opt_oids = 606,                 /* opt_oids  */
  YYSYMBOL_copy_delimiter = 607,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 608,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 609,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 610,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 611,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 612, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 613, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 614,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 615,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 616,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 617, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 618,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 619,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 620,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 621,        /* TypedTableElement  */
  YYSYMBOL_column_reference_storage_directive = 622, /* column_reference_storage_directive  */
  YYSYMBOL_columnDef = 623,                /* columnDef  */
  YYSYMBOL_columnOptions = 624,            /* columnOptions  */
  YYSYMBOL_ColQualList = 625,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 626,            /* ColConstraint  */
  YYSYMBOL_opt_storage_encoding = 627,     /* opt_storage_encoding  */
  YYSYMBOL_ColConstraintElem = 628,        /* ColConstraintElem  */
  YYSYMBOL_ConstraintAttr = 629,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 630,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 631,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 632,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 633,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 634,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 635,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 636,          /* opt_column_list  */
  YYSYMBOL_columnList = 637,               /* columnList  */
  YYSYMBOL_columnElem = 638,               /* columnElem  */
  YYSYMBOL_distributed_by_list = 639,      /* distributed_by_list  */
  YYSYMBOL_distributed_by_elem = 640,      /* distributed_by_elem  */
  YYSYMBOL_key_match = 641,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 642,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 643,  /* ExclusionConstraintElem  */
  YYSYMBOL_ExclusionWhereClause = 644,     /* ExclusionWhereClause  */
  YYSYMBOL_key_actions = 645,              /* key_actions  */
  YYSYMBOL_key_update = 646,               /* key_update  */
  YYSYMBOL_key_delete = 647,               /* key_delete  */
  YYSYMBOL_key_action = 648,               /* key_action  */
  YYSYMBOL_OptInherit = 649,               /* OptInherit  */
  YYSYMBOL_OptWith = 650,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 651,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 652,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 653,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 654,            /* ExistingIndex  */
  YYSYMBOL_DistributedBy = 655,            /* DistributedBy  */
  YYSYMBOL_OptDistributedBy = 656,         /* OptDistributedBy  */
  YYSYMBOL_OptTabPartitionColumnEncList = 657, /* OptTabPartitionColumnEncList  */
  YYSYMBOL_TabPartitionColumnEncList = 658, /* TabPartitionColumnEncList  */
  YYSYMBOL_OptTabPartitionStorageAttr = 659, /* OptTabPartitionStorageAttr  */
  YYSYMBOL_OptTabPartitionSpec = 660,      /* OptTabPartitionSpec  */
  YYSYMBOL_OptTabSubPartitionSpec = 661,   /* OptTabSubPartitionSpec  */
  YYSYMBOL_TabPartitionElemList = 662,     /* TabPartitionElemList  */
  YYSYMBOL_TabSubPartitionElemList = 663,  /* TabSubPartitionElemList  */
  YYSYMBOL_tab_part_val_no_paran = 664,    /* tab_part_val_no_paran  */
  YYSYMBOL_tab_part_val = 665,             /* tab_part_val  */
  YYSYMBOL_TabPartitionBoundarySpecValList = 666, /* TabPartitionBoundarySpecValList  */
  YYSYMBOL_OptTabPartitionRangeInclusive = 667, /* OptTabPartitionRangeInclusive  */
  YYSYMBOL_TabPartitionBoundarySpecStart = 668, /* TabPartitionBoundarySpecStart  */
  YYSYMBOL_TabPartitionBoundarySpecEnd = 669, /* TabPartitionBoundarySpecEnd  */
  YYSYMBOL_OptTabPartitionBoundarySpecEvery = 670, /* OptTabPartitionBoundarySpecEvery  */
  YYSYMBOL_OptTabPartitionBoundarySpecEnd = 671, /* OptTabPartitionBoundarySpecEnd  */
  YYSYMBOL_TabPartitionBoundarySpec = 672, /* TabPartitionBoundarySpec  */
  YYSYMBOL_OptTabPartitionBoundarySpec = 673, /* OptTabPartitionBoundarySpec  */
  YYSYMBOL_multi_spec_value_list = 674,    /* multi_spec_value_list  */
  YYSYMBOL_part_values_single = 675,       /* part_values_single  */
  YYSYMBOL_part_values_clause = 676,       /* part_values_clause  */
  YYSYMBOL_part_values_or_spec_list = 677, /* part_values_or_spec_list  */
  YYSYMBOL_TabPartitionElem = 678,         /* TabPartitionElem  */
  YYSYMBOL_TabSubPartitionElem = 679,      /* TabSubPartitionElem  */
  YYSYMBOL_TabPartitionNameDecl = 680,     /* TabPartitionNameDecl  */
  YYSYMBOL_TabPartitionDefaultNameDecl = 681, /* TabPartitionDefaultNameDecl  */
  YYSYMBOL_TabSubPartitionNameDecl = 682,  /* TabSubPartitionNameDecl  */
  YYSYMBOL_TabSubPartitionDefaultNameDecl = 683, /* TabSubPartitionDefaultNameDecl  */
  YYSYMBOL_TabPartitionByType = 684,       /* TabPartitionByType  */
  YYSYMBOL_OptTabPartitionBy = 685,        /* OptTabPartitionBy  */
  YYSYMBOL_TabSubPartitionTemplate = 686,  /* TabSubPartitionTemplate  */
  YYSYMBOL_opt_list_subparts = 687,        /* opt_list_subparts  */
  YYSYMBOL_TabSubPartitionBy = 688,        /* TabSubPartitionBy  */
  YYSYMBOL_TabSubPartition = 689,          /* TabSubPartition  */
  YYSYMBOL_CreateAsStmt = 690,             /* CreateAsStmt  */
  YYSYMBOL_create_as_target = 691,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 692,            /* opt_with_data  */
  YYSYMBOL_CreateExternalStmt = 693,       /* CreateExternalStmt  */
  YYSYMBOL_OptWritable = 694,              /* OptWritable  */
  YYSYMBOL_OptWeb = 695,                   /* OptWeb  */
  YYSYMBOL_ExtTypedesc = 696,              /* ExtTypedesc  */
  YYSYMBOL_ext_on_clause_list = 697,       /* ext_on_clause_list  */
  YYSYMBOL_ext_on_clause_item = 698,       /* ext_on_clause_item  */
  YYSYMBOL_format_opt = 699,               /* format_opt  */
  YYSYMBOL_format_opt_list = 700,          /* format_opt_list  */
  YYSYMBOL_format_def_list = 701,          /* format_def_list  */
  YYSYMBOL_format_def_item = 702,          /* format_def_item  */
  YYSYMBOL_format_opt_item = 703,          /* format_opt_item  */
  YYSYMBOL_ext_options_opt = 704,          /* ext_options_opt  */
  YYSYMBOL_ext_options = 705,              /* ext_options  */
  YYSYMBOL_ext_options_list = 706,         /* ext_options_list  */
  YYSYMBOL_ext_options_item = 707,         /* ext_options_item  */
  YYSYMBOL_OptExtTableElementList = 708,   /* OptExtTableElementList  */
  YYSYMBOL_ExtTableElementList = 709,      /* ExtTableElementList  */
  YYSYMBOL_ExtTableElement = 710,          /* ExtTableElement  */
  YYSYMBOL_ExtcolumnDef = 711,             /* ExtcolumnDef  */
  YYSYMBOL_OptSingleRowErrorHandling = 712, /* OptSingleRowErrorHandling  */
  YYSYMBOL_OptLogErrorTable = 713,         /* OptLogErrorTable  */
  YYSYMBOL_ExtSingleRowErrorHandling = 714, /* ExtSingleRowErrorHandling  */
  YYSYMBOL_ExtLogErrorTable = 715,         /* ExtLogErrorTable  */
  YYSYMBOL_OptSrehLimitType = 716,         /* OptSrehLimitType  */
  YYSYMBOL_ext_opt_encoding_list = 717,    /* ext_opt_encoding_list  */
  YYSYMBOL_ext_opt_encoding_item = 718,    /* ext_opt_encoding_item  */
  YYSYMBOL_CreateMatViewStmt = 719,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 720,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 721,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 722,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 723,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 724,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 725,            /* OptSeqOptList  */
  YYSYMBOL_SeqOptList = 726,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 727,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 728,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 729,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 730,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 731,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 732,              /* opt_trusted  */
  YYSYMBOL_handler_name = 733,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 734,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 735,         /* validator_clause  */
  YYSYMBOL_opt_validator = 736,            /* opt_validator  */
  YYSYMBOL_DropPLangStmt = 737,            /* DropPLangStmt  */
  YYSYMBOL_opt_procedural = 738,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 739,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 740,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 741,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 742,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 743, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 744, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 745,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 746, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 747, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 748, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 749,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 750,               /* fdw_option  */
  YYSYMBOL_fdw_options = 751,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 752,          /* opt_fdw_options  */
  YYSYMBOL_DropFdwStmt = 753,              /* DropFdwStmt  */
  YYSYMBOL_AlterFdwStmt = 754,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 755,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 756,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 757,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 758, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 759, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 760,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 761,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 762,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 763,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 764,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 765,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 766, /* opt_foreign_server_version  */
  YYSYMBOL_DropForeignServerStmt = 767,    /* DropForeignServerStmt  */
  YYSYMBOL_AlterForeignServerStmt = 768,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 769,   /* CreateForeignTableStmt  */
  YYSYMBOL_AlterForeignTableStmt = 770,    /* AlterForeignTableStmt  */
  YYSYMBOL_CreateUserMappingStmt = 771,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 772,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 773,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 774,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreateTrigStmt = 775,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 776,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 777,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 778,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerForSpec = 779,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 780,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 781,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 782,              /* TriggerWhen  */
  YYSYMBOL_TriggerFuncArgs = 783,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 784,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 785,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 786,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 787,  /* ConstraintAttributeElem  */
  YYSYMBOL_DropTrigStmt = 788,             /* DropTrigStmt  */
  YYSYMBOL_CreateEventTrigStmt = 789,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 790,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 791,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 792, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 793,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 794,           /* enable_trigger  */
  YYSYMBOL_CreateAssertStmt = 795,         /* CreateAssertStmt  */
  YYSYMBOL_DropAssertStmt = 796,           /* DropAssertStmt  */
  YYSYMBOL_DefineStmt = 797,               /* DefineStmt  */
  YYSYMBOL_opt_ordered = 798,              /* opt_ordered  */
  YYSYMBOL_definition = 799,               /* definition  */
  YYSYMBOL_def_list = 800,                 /* def_list  */
  YYSYMBOL_def_elem = 801,                 /* def_elem  */
  YYSYMBOL_def_arg = 802,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 803,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 804,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 805,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 806,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 807,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 808,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 809,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 810,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 811,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 812,             /* opclass_item  */
  YYSYMBOL_opt_default = 813,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 814,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 815,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 816,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 817,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 818,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 819,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 820,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 821,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 822,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 823,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 824,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 825,                 /* DropStmt  */
  YYSYMBOL_drop_type = 826,                /* drop_type  */
  YYSYMBOL_any_name_list = 827,            /* any_name_list  */
  YYSYMBOL_any_name = 828,                 /* any_name  */
  YYSYMBOL_attrs = 829,                    /* attrs  */
  YYSYMBOL_TruncateStmt = 830,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 831,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 832,              /* CommentStmt  */
  YYSYMBOL_comment_type = 833,             /* comment_type  */
  YYSYMBOL_comment_text = 834,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 835,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 836,             /* opt_provider  */
  YYSYMBOL_security_label_type = 837,      /* security_label_type  */
  YYSYMBOL_security_label = 838,           /* security_label  */
  YYSYMBOL_FetchStmt = 839,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 840,               /* fetch_args  */
  YYSYMBOL_from_in = 841,                  /* from_in  */
  YYSYMBOL_opt_from_in = 842,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 843,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 844,               /* RevokeStmt  */
  YYSYMBOL_privileges = 845,               /* privileges  */
  YYSYMBOL_privilege_list = 846,           /* privilege_list  */
  YYSYMBOL_privilege = 847,                /* privilege  */
  YYSYMBOL_privilege_target = 848,         /* privilege_target  */
  YYSYMBOL_grantee_list = 849,             /* grantee_list  */
  YYSYMBOL_grantee = 850,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 851,   /* opt_grant_grant_option  */
  YYSYMBOL_function_with_argtypes_list = 852, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 853,   /* function_with_argtypes  */
  YYSYMBOL_GrantRoleStmt = 854,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 855,           /* RevokeRoleStmt  */
  YYSYMBOL_opt_grant_admin_option = 856,   /* opt_grant_admin_option  */
  YYSYMBOL_opt_granted_by = 857,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 858, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 859,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 860,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 861,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 862,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 863,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 864,               /* opt_unique  */
  YYSYMBOL_opt_concurrently = 865,         /* opt_concurrently  */
  YYSYMBOL_opt_index_name = 866,           /* opt_index_name  */
  YYSYMBOL_access_method_clause = 867,     /* access_method_clause  */
  YYSYMBOL_index_params = 868,             /* index_params  */
  YYSYMBOL_index_elem = 869,               /* index_elem  */
  YYSYMBOL_opt_collate = 870,              /* opt_collate  */
  YYSYMBOL_opt_class = 871,                /* opt_class  */
  YYSYMBOL_opt_asc_desc = 872,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 873,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 874,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 875,           /* opt_or_replace  */
  YYSYMBOL_func_args = 876,                /* func_args  */
  YYSYMBOL_func_args_list = 877,           /* func_args_list  */
  YYSYMBOL_func_args_with_defaults = 878,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 879, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 880,                 /* func_arg  */
  YYSYMBOL_arg_class = 881,                /* arg_class  */
  YYSYMBOL_param_name = 882,               /* param_name  */
  YYSYMBOL_func_return = 883,              /* func_return  */
  YYSYMBOL_func_type = 884,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 885,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 886,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 887,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 888,           /* aggr_args_list  */
  YYSYMBOL_createfunc_opt_list = 889,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 890,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 891,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 892,                  /* func_as  */
  YYSYMBOL_opt_definition = 893,           /* opt_definition  */
  YYSYMBOL_table_func_column = 894,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 895,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 896,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 897,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 898,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 899,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 900,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 901,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 902,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 903,             /* any_operator  */
  YYSYMBOL_DoStmt = 904,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 905,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 906,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 907,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 908,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 909,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 910,            /* opt_if_exists  */
  YYSYMBOL_ReindexStmt = 911,              /* ReindexStmt  */
  YYSYMBOL_reindex_type = 912,             /* reindex_type  */
  YYSYMBOL_opt_force = 913,                /* opt_force  */
  YYSYMBOL_AlterTypeStmt = 914,            /* AlterTypeStmt  */
  YYSYMBOL_AlterTblSpcStmt = 915,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 916,               /* RenameStmt  */
  YYSYMBOL_opt_column = 917,               /* opt_column  */
  YYSYMBOL_opt_set_data = 918,             /* opt_set_data  */
  YYSYMBOL_AlterObjectSchemaStmt = 919,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOwnerStmt = 920,           /* AlterOwnerStmt  */
  YYSYMBOL_RuleStmt = 921,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 922,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 923,          /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 924,           /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 925,    /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 926,                    /* event  */
  YYSYMBOL_opt_instead = 927,              /* opt_instead  */
  YYSYMBOL_DropRuleStmt = 928,             /* DropRuleStmt  */
  YYSYMBOL_NotifyStmt = 929,               /* NotifyStmt  */
  YYSYMBOL_notify_payload = 930,           /* notify_payload  */
  YYSYMBOL_ListenStmt = 931,               /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 932,             /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 933,          /* TransactionStmt  */
  YYSYMBOL_opt_transaction = 934,          /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 935,    /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 936,    /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 937, /* transaction_mode_list_or_empty  */
  YYSYMBOL_ViewStmt = 938,                 /* ViewStmt  */
  YYSYMBOL_opt_check_option = 939,         /* opt_check_option  */
  YYSYMBOL_LoadStmt = 940,                 /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 941,             /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 942,        /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_item = 943,        /* createdb_opt_item  */
  YYSYMBOL_opt_equal = 944,                /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 945,        /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 946,     /* AlterDatabaseSetStmt  */
  YYSYMBOL_alterdb_opt_list = 947,         /* alterdb_opt_list  */
  YYSYMBOL_alterdb_opt_item = 948,         /* alterdb_opt_item  */
  YYSYMBOL_DropdbStmt = 949,               /* DropdbStmt  */
  YYSYMBOL_AlterSystemStmt = 950,          /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 951,         /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 952,          /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 953,                   /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 954,    /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 955, /* AlterTSConfigurationStmt  */
  YYSYMBOL_CreateConversionStmt = 956,     /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 957,              /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 958, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 959,               /* VacuumStmt  */
  YYSYMBOL_vacuum_option_list = 960,       /* vacuum_option_list  */
  YYSYMBOL_vacuum_option_elem = 961,       /* vacuum_option_elem  */
  YYSYMBOL_AnalyzeStmt = 962,              /* AnalyzeStmt  */
  YYSYMBOL_analyze_keyword = 963,          /* analyze_keyword  */
  YYSYMBOL_opt_verbose = 964,              /* opt_verbose  */
  YYSYMBOL_opt_rootonly_all = 965,         /* opt_rootonly_all  */
  YYSYMBOL_opt_full = 966,                 /* opt_full  */
  YYSYMBOL_opt_freeze = 967,               /* opt_freeze  */
  YYSYMBOL_opt_name_list = 968,            /* opt_name_list  */
  YYSYMBOL_ExplainStmt = 969,              /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 970,          /* ExplainableStmt  */
  YYSYMBOL_opt_dxl = 971,                  /* opt_dxl  */
  YYSYMBOL_explain_option_list = 972,      /* explain_option_list  */
  YYSYMBOL_explain_option_elem = 973,      /* explain_option_elem  */
  YYSYMBOL_explain_option_name = 974,      /* explain_option_name  */
  YYSYMBOL_explain_option_arg = 975,       /* explain_option_arg  */
  YYSYMBOL_PrepareStmt = 976,              /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 977,         /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 978,           /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 979,              /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 980,     /* execute_param_clause  */
  YYSYMBOL_DeallocateStmt = 981,           /* DeallocateStmt  */
  YYSYMBOL_cdb_string_list = 982,          /* cdb_string_list  */
  YYSYMBOL_cdb_string = 983,               /* cdb_string  */
  YYSYMBOL_InsertStmt = 984,               /* InsertStmt  */
  YYSYMBOL_insert_rest = 985,              /* insert_rest  */
  YYSYMBOL_insert_column_list = 986,       /* insert_column_list  */
  YYSYMBOL_insert_column_item = 987,       /* insert_column_item  */
  YYSYMBOL_returning_clause = 988,         /* returning_clause  */
  YYSYMBOL_DeleteStmt = 989,               /* DeleteStmt  */
  YYSYMBOL_using_clause = 990,             /* using_clause  */
  YYSYMBOL_LockStmt = 991,                 /* LockStmt  */
  YYSYMBOL_opt_lock = 992,                 /* opt_lock  */
  YYSYMBOL_lock_type = 993,                /* lock_type  */
  YYSYMBOL_opt_nowait = 994,               /* opt_nowait  */
  YYSYMBOL_UpdateStmt = 995,               /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 996,          /* set_clause_list  */
  YYSYMBOL_set_clause = 997,               /* set_clause  */
  YYSYMBOL_single_set_clause = 998,        /* single_set_clause  */
  YYSYMBOL_multiple_set_clause = 999,      /* multiple_set_clause  */
  YYSYMBOL_set_target = 1000,              /* set_target  */
  YYSYMBOL_set_target_list = 1001,         /* set_target_list  */
  YYSYMBOL_DeclareCursorStmt = 1002,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1003,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1004,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1005,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1006,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1007,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1008,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1009,           /* select_clause  */
  YYSYMBOL_simple_select = 1010,           /* simple_select  */
  YYSYMBOL_with_clause = 1011,             /* with_clause  */
  YYSYMBOL_cte_list = 1012,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1013,       /* common_table_expr  */
  YYSYMBOL_opt_with_clause = 1014,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1015,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1016,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1017,               /* opt_table  */
  YYSYMBOL_opt_all = 1018,                 /* opt_all  */
  YYSYMBOL_opt_distinct = 1019,            /* opt_distinct  */
  YYSYMBOL_opt_sort_clause = 1020,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1021,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1022,             /* sortby_list  */
  YYSYMBOL_sortby = 1023,                  /* sortby  */
  YYSYMBOL_select_limit = 1024,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1025,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1026,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1027,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1028,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1029,     /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 1030, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 1031,            /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 1032,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1033,           /* first_or_next  */
  YYSYMBOL_group_clause = 1034,            /* group_clause  */
  YYSYMBOL_group_elem_list = 1035,         /* group_elem_list  */
  YYSYMBOL_group_elem = 1036,              /* group_elem  */
  YYSYMBOL_having_clause = 1037,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1038,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1039,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1040,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1041,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1042,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1043,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1044,           /* values_clause  */
  YYSYMBOL_from_clause = 1045,             /* from_clause  */
  YYSYMBOL_from_list = 1046,               /* from_list  */
  YYSYMBOL_table_ref = 1047,               /* table_ref  */
  YYSYMBOL_joined_table = 1048,            /* joined_table  */
  YYSYMBOL_alias_clause = 1049,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1050,        /* opt_alias_clause  */
  YYSYMBOL_func_alias_clause = 1051,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1052,               /* join_type  */
  YYSYMBOL_join_outer = 1053,              /* join_outer  */
  YYSYMBOL_join_qual = 1054,               /* join_qual  */
  YYSYMBOL_relation_expr = 1055,           /* relation_expr  */
  YYSYMBOL_relation_expr_list = 1056,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1057, /* relation_expr_opt_alias  */
  YYSYMBOL_func_table = 1058,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1059,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1060,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1061,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1062,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1063,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1064, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1065, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1066,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1067,        /* TableFuncElement  */
  YYSYMBOL_Typename = 1068,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1069,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1070,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1071,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1072,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1073,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1074,                 /* Numeric  */
  YYSYMBOL_opt_float = 1075,               /* opt_float  */
  YYSYMBOL_Bit = 1076,                     /* Bit  */
  YYSYMBOL_ConstBit = 1077,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1078,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1079,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1080,               /* Character  */
  YYSYMBOL_ConstCharacter = 1081,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1082,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1083,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1084,               /* character  */
  YYSYMBOL_opt_varying = 1085,             /* opt_varying  */
  YYSYMBOL_opt_charset = 1086,             /* opt_charset  */
  YYSYMBOL_ConstDatetime = 1087,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1088,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1089,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1090,            /* opt_interval  */
  YYSYMBOL_interval_second = 1091,         /* interval_second  */
  YYSYMBOL_a_expr = 1092,                  /* a_expr  */
  YYSYMBOL_b_expr = 1093,                  /* b_expr  */
  YYSYMBOL_c_expr = 1094,                  /* c_expr  */
  YYSYMBOL_scatter_clause = 1095,          /* scatter_clause  */
  YYSYMBOL_table_value_select_clause = 1096, /* table_value_select_clause  */
  YYSYMBOL_func_application = 1097,        /* func_application  */
  YYSYMBOL_func_expr = 1098,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1099,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1100, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1101,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1102, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1103,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1104,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1105,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1106,     /* document_or_content  */
  YYSYMBOL_xml_whitespace_option = 1107,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1108,      /* xmlexists_argument  */
  YYSYMBOL_within_group_clause = 1109,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1110,           /* filter_clause  */
  YYSYMBOL_window_clause = 1111,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1112,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1113,       /* window_definition  */
  YYSYMBOL_over_clause = 1114,             /* over_clause  */
  YYSYMBOL_window_specification = 1115,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1116, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1117,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1118,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1119,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1120,             /* frame_bound  */
  YYSYMBOL_window_frame_exclusion = 1121,  /* window_frame_exclusion  */
  YYSYMBOL_row = 1122,                     /* row  */
  YYSYMBOL_sub_type = 1123,                /* sub_type  */
  YYSYMBOL_all_Op = 1124,                  /* all_Op  */
  YYSYMBOL_MathOp = 1125,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1126,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1127,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1128,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1129,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1130,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1131,           /* func_arg_expr  */
  YYSYMBOL_type_list = 1132,               /* type_list  */
  YYSYMBOL_array_expr = 1133,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1134,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1135,            /* extract_list  */
  YYSYMBOL_extract_arg = 1136,             /* extract_arg  */
  YYSYMBOL_overlay_list = 1137,            /* overlay_list  */
  YYSYMBOL_overlay_placing = 1138,         /* overlay_placing  */
  YYSYMBOL_position_list = 1139,           /* position_list  */
  YYSYMBOL_substr_list = 1140,             /* substr_list  */
  YYSYMBOL_substr_from = 1141,             /* substr_from  */
  YYSYMBOL_substr_for = 1142,              /* substr_for  */
  YYSYMBOL_trim_list = 1143,               /* trim_list  */
  YYSYMBOL_in_expr = 1144,                 /* in_expr  */
  YYSYMBOL_case_expr = 1145,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1146,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1147,             /* when_clause  */
  YYSYMBOL_when_operand = 1148,            /* when_operand  */
  YYSYMBOL_case_default = 1149,            /* case_default  */
  YYSYMBOL_case_arg = 1150,                /* case_arg  */
  YYSYMBOL_decode_expr = 1151,             /* decode_expr  */
  YYSYMBOL_search_result_list = 1152,      /* search_result_list  */
  YYSYMBOL_search_result = 1153,           /* search_result  */
  YYSYMBOL_decode_default = 1154,          /* decode_default  */
  YYSYMBOL_columnref = 1155,               /* columnref  */
  YYSYMBOL_indirection_el = 1156,          /* indirection_el  */
  YYSYMBOL_indirection = 1157,             /* indirection  */
  YYSYMBOL_opt_indirection = 1158,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1159,          /* opt_asymmetric  */
  YYSYMBOL_ctext_expr = 1160,              /* ctext_expr  */
  YYSYMBOL_ctext_expr_list = 1161,         /* ctext_expr_list  */
  YYSYMBOL_ctext_row = 1162,               /* ctext_row  */
  YYSYMBOL_opt_target_list = 1163,         /* opt_target_list  */
  YYSYMBOL_target_list = 1164,             /* target_list  */
  YYSYMBOL_target_el = 1165,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1166,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1167,          /* qualified_name  */
  YYSYMBOL_name_list = 1168,               /* name_list  */
  YYSYMBOL_name = 1169,                    /* name  */
  YYSYMBOL_database_name = 1170,           /* database_name  */
  YYSYMBOL_access_method = 1171,           /* access_method  */
  YYSYMBOL_attr_name = 1172,               /* attr_name  */
  YYSYMBOL_index_name = 1173,              /* index_name  */
  YYSYMBOL_file_name = 1174,               /* file_name  */
  YYSYMBOL_func_name = 1175,               /* func_name  */
  YYSYMBOL_AexprConst = 1176,              /* AexprConst  */
  YYSYMBOL_Iconst = 1177,                  /* Iconst  */
  YYSYMBOL_Sconst = 1178,                  /* Sconst  */
  YYSYMBOL_RoleId = 1179,                  /* RoleId  */
  YYSYMBOL_QueueId = 1180,                 /* QueueId  */
  YYSYMBOL_role_list = 1181,               /* role_list  */
  YYSYMBOL_SignedIconst = 1182,            /* SignedIconst  */
  YYSYMBOL_ColId = 1183,                   /* ColId  */
  YYSYMBOL_type_function_name = 1184,      /* type_function_name  */
  YYSYMBOL_NonReservedWord = 1185,         /* NonReservedWord  */
  YYSYMBOL_ColLabel = 1186,                /* ColLabel  */
  YYSYMBOL_unreserved_keyword = 1187,      /* unreserved_keyword  */
  YYSYMBOL_ColLabelNoAs = 1188,            /* ColLabelNoAs  */
  YYSYMBOL_keywords_ok_in_alias_no_as = 1189, /* keywords_ok_in_alias_no_as  */
  YYSYMBOL_PartitionColId = 1190,          /* PartitionColId  */
  YYSYMBOL_PartitionIdentKeyword = 1191,   /* PartitionIdentKeyword  */
  YYSYMBOL_col_name_keyword = 1192,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1193,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1194         /* reserved_keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  804
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   104195

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  508
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  687
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3025
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5621

#define YYMAXUTOK   745


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   497,     2,     2,
     502,   503,   495,   493,   506,   494,   504,   496,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   507,   505,
     490,   489,   491,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   500,     2,   501,   498,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   492,   499
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1136,  1136,  1143,  1150,  1160,  1161,  1162,  1163,  1164,
    1165,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,
    1215,  1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1283,  1285,
    1295,  1305,  1321,  1322,  1326,  1331,  1336,  1341,  1346,  1360,
    1367,  1381,  1395,  1419,  1434,  1450,  1464,  1476,  1480,  1485,
    1489,  1493,  1497,  1501,  1514,  1525,  1526,  1535,  1536,  1540,
    1541,  1551,  1552,  1556,  1561,  1565,  1570,  1575,  1579,  1583,
    1587,  1591,  1595,  1599,  1604,  1608,  1612,  1666,  1668,  1672,
    1676,  1680,  1684,  1690,  1691,  1694,  1703,  1704,  1707,  1716,
    1717,  1721,  1722,  1726,  1727,  1731,  1745,  1763,  1774,  1775,
    1779,  1787,  1805,  1817,  1825,  1846,  1853,  1872,  1879,  1896,
    1914,  1925,  1926,  1938,  1945,  1962,  1975,  1985,  2003,  2021,
    2022,  2026,  2033,  2041,  2042,  2043,  2044,  2045,  2046,  2060,
    2066,  2072,  2081,  2089,  2097,  2101,  2109,  2117,  2124,  2134,
    2135,  2143,  2154,  2162,  2170,  2181,  2189,  2197,  2204,  2213,
    2223,  2224,  2228,  2229,  2232,  2234,  2238,  2239,  2240,  2241,
    2245,  2246,  2247,  2253,  2265,  2269,  2273,  2288,  2311,  2312,
    2313,  2317,  2318,  2319,  2323,  2324,  2328,  2332,  2333,  2340,
    2347,  2357,  2364,  2374,  2375,  2380,  2381,  2386,  2392,  2398,
    2404,  2410,  2420,  2430,  2431,  2435,  2436,  2444,  2459,  2465,
    2471,  2477,  2483,  2502,  2511,  2520,  2528,  2539,  2550,  2559,
    2568,  2579,  2590,  2599,  2608,  2617,  2626,  2635,  2644,  2655,
    2669,  2670,  2675,  2683,  2691,  2703,  2711,  2719,  2728,  2737,
    2746,  2755,  2765,  2778,  2793,  2802,  2810,  2825,  2833,  2843,
    2853,  2860,  2867,  2875,  2883,  2891,  2899,  2907,  2914,  2921,
    2929,  2936,  2943,  2951,  2959,  2967,  2975,  2983,  2992,  3000,
    3008,  3015,  3020,  3027,  3037,  3044,  3052,  3060,  3068,  3076,
    3083,  3093,  3094,  3098,  3099,  3100,  3104,  3112,  3116,  3117,
    3121,  3128,  3135,  3142,  3152,  3155,  3156,  3160,  3161,  3166,
    3180,  3184,  3189,  3196,  3208,  3212,  3213,  3214,  3218,  3226,
    3257,  3296,  3301,  3307,  3318,  3350,  3382,  3415,  3435,  3461,
    3491,  3517,  3546,  3565,  3580,  3643,  3658,  3680,  3702,  3738,
    3751,  3752,  3757,  3766,  3776,  3786,  3812,  3818,  3848,  3883,
    3908,  3909,  3913,  3914,  3918,  3919,  3928,  3929,  3930,  3933,
    3934,  3939,  3940,  3944,  3948,  3952,  3956,  3960,  3964,  3968,
    3972,  3976,  3980,  3984,  3988,  3992,  3996,  4000,  4004,  4008,
    4017,  4021,  4025,  4029,  4033,  4037,  4041,  4042,  4047,  4051,
    4058,  4065,  4066,  4067,  4068,  4069,  4073,  4077,  4085,  4096,
    4115,  4135,  4155,  4188,  4189,  4190,  4191,  4192,  4199,  4206,
    4207,  4211,  4212,  4216,  4217,  4221,  4225,  4232,  4236,  4243,
    4244,  4245,  4246,  4250,  4251,  4255,  4264,  4276,  4298,  4319,
    4320,  4324,  4332,  4333,  4334,  4349,  4350,  4369,  4376,  4383,
    4394,  4405,  4415,  4424,  4457,  4464,  4471,  4478,  4489,  4499,
    4500,  4501,  4505,  4506,  4507,  4508,  4509,  4510,  4519,  4527,
    4531,  4544,  4559,  4573,  4588,  4602,  4620,  4641,  4642,  4646,
    4647,  4651,  4652,  4655,  4662,  4663,  4683,  4694,  4698,  4706,
    4711,  4717,  4718,  4722,  4727,  4734,  4735,  4745,  4747,  4749,
    4751,  4754,  4757,  4760,  4764,  4765,  4766,  4767,  4768,  4771,
    4772,  4777,  4778,  4779,  4780,  4783,  4784,  4785,  4786,  4789,
    4790,  4793,  4794,  4797,  4800,  4808,  4816,  4826,  4827,  4832,
    4833,  4837,  4838,  4844,  4854,  4864,  4874,  4877,  4885,  4889,
    4897,  4901,  4902,  4906,  4907,  4911,  4912,  4916,  4920,  4923,
    4924,  4925,  4932,  4933,  4938,  4939,  4940,  4944,  4960,  4976,
    4984,  4988,  4989,  4994,  5002,  5015,  5030,  5031,  5034,  5044,
    5056,  5060,  5067,  5071,  5077,  5078,  5083,  5101,  5117,  5133,
    5140,  5157,  5173,  5189,  5195,  5200,  5206,  5212,  5219,  5220,
    5222,  5232,  5253,  5257,  5293,  5294,  5298,  5315,  5323,  5324,
    5330,  5352,  5375,  5389,  5390,  5391,  5401,  5461,  5462,  5463,
    5466,  5467,  5471,  5481,  5494,  5495,  5499,  5503,  5507,  5511,
    5515,  5519,  5526,  5527,  5528,  5529,  5533,  5537,  5544,  5548,
    5555,  5559,  5566,  5570,  5574,  5578,  5582,  5586,  5590,  5594,
    5598,  5602,  5606,  5613,  5614,  5618,  5619,  5623,  5627,  5634,
    5641,  5642,  5646,  5650,  5657,  5658,  5662,  5678,  5700,  5704,
    5723,  5724,  5727,  5749,  5753,  5754,  5758,  5759,  5760,  5767,
    5768,  5772,  5776,  5790,  5807,  5820,  5821,  5833,  5853,  5865,
    5873,  5884,  5885,  5888,  5889,  5892,  5896,  5900,  5904,  5908,
    5912,  5916,  5920,  5924,  5928,  5932,  5936,  5942,  5943,  5947,
    5948,  5949,  5954,  5957,  5958,  5970,  5982,  5997,  5998,  6006,
    6007,  6011,  6012,  6016,  6017,  6021,  6022,  6026,  6037,  6050,
    6051,  6061,  6072,  6073,  6086,  6093,  6110,  6118,  6129,  6132,
    6136,  6140,  6144,  6156,  6166,  6169,  6173,  6186,  6196,  6206,
    6215,  6224,  6233,  6243,  6252,  6262,  6272,  6282,  6291,  6300,
    6309,  6318,  6327,  6336,  6345,  6354,  6363,  6372,  6381,  6390,
    6399,  6417,  6428,  6429,  6430,  6431,  6435,  6436,  6440,  6441,
    6451,  6462,  6482,  6490,  6502,  6503,  6507,  6511,  6519,  6523,
    6527,  6534,  6538,  6543,  6548,  6555,  6562,  6567,  6577,  6591,
    6592,  6597,  6598,  6602,  6603,  6613,  6624,  6644,  6653,  6661,
    6678,  6693,  6718,  6727,  6745,  6757,  6758,  6759,  6769,  6777,
    6794,  6813,  6833,  6858,  6859,  6860,  6864,  6866,  6888,  6890,
    6892,  6894,  6896,  6901,  6906,  6916,  6917,  6921,  6922,  6926,
    6927,  6931,  6932,  6933,  6937,  6943,  6944,  6945,  6949,  6950,
    6955,  6956,  6983,  6984,  6985,  6986,  6987,  6988,  6993,  7004,
    7027,  7037,  7051,  7053,  7058,  7063,  7065,  7070,  7080,  7081,
    7082,  7083,  7095,  7115,  7138,  7148,  7159,  7169,  7179,  7190,
    7199,  7220,  7227,  7234,  7243,  7252,  7261,  7270,  7279,  7290,
    7291,  7294,  7297,  7298,  7301,  7315,  7322,  7324,  7325,  7326,
    7327,  7328,  7335,  7338,  7341,  7342,  7350,  7357,  7358,  7361,
    7363,  7374,  7384,  7394,  7406,  7407,  7423,  7438,  7439,  7443,
    7453,  7464,  7473,  7483,  7492,  7493,  7496,  7497,  7500,  7501,
    7502,  7505,  7519,  7524,  7534,  7543,  7555,  7556,  7560,  7568,
    7580,  7591,  7605,  7616,  7639,  7649,  7667,  7678,  7689,  7700,
    7714,  7715,  7716,  7717,  7718,  7719,  7720,  7721,  7722,  7723,
    7724,  7725,  7726,  7727,  7728,  7729,  7730,  7731,  7732,  7733,
    7737,  7738,  7741,  7742,  7745,  7747,  7760,  7771,  7772,  7773,
    7805,  7814,  7823,  7832,  7841,  7850,  7859,  7869,  7878,  7887,
    7896,  7905,  7914,  7926,  7927,  7928,  7929,  7930,  7931,  7932,
    7933,  7934,  7935,  7936,  7937,  7938,  7939,  7940,  7941,  7942,
    7943,  7944,  7945,  7946,  7947,  7948,  7949,  7950,  7954,  7955,
    7969,  7980,  7991,  8002,  8013,  8026,  8027,  8031,  8032,  8033,
    8034,  8035,  8036,  8037,  8038,  8039,  8040,  8041,  8042,  8043,
    8046,  8047,  8057,  8063,  8071,  8079,  8087,  8095,  8103,  8111,
    8119,  8127,  8135,  8143,  8151,  8159,  8167,  8175,  8183,  8191,
    8201,  8202,  8205,  8206,  8216,  8232,  8246,  8272,  8274,  8276,
    8278,  8285,  8294,  8295,  8298,  8305,  8312,  8319,  8333,  8341,
    8349,  8357,  8365,  8373,  8381,  8389,  8397,  8405,  8413,  8421,
    8429,  8437,  8445,  8453,  8461,  8473,  8474,  8477,  8487,  8501,
    8502,  8506,  8507,  8512,  8528,  8541,  8551,  8563,  8564,  8567,
    8568,  8578,  8588,  8589,  8593,  8597,  8601,  8612,  8625,  8639,
    8656,  8657,  8658,  8659,  8671,  8707,  8708,  8712,  8713,  8717,
    8718,  8722,  8723,  8726,  8727,  8735,  8746,  8757,  8770,  8771,
    8774,  8775,  8776,  8779,  8780,  8781,  8784,  8785,  8786,  8802,
    8814,  8827,  8842,  8843,  8846,  8847,  8851,  8852,  8860,  8861,
    8865,  8866,  8881,  8890,  8899,  8908,  8917,  8929,  8930,  8931,
    8932,  8933,  8939,  8943,  8958,  8959,  8965,  8975,  8979,  8984,
    8992,  9033,  9037,  9041,  9045,  9053,  9054,  9059,  9060,  9067,
    9071,  9075,  9079,  9083,  9087,  9091,  9095,  9099,  9103,  9107,
    9111,  9115,  9119,  9123,  9128,  9132,  9136,  9140,  9144,  9148,
    9152,  9156,  9163,  9167,  9171,  9175,  9181,  9182,  9189,  9190,
    9193,  9205,  9209,  9224,  9235,  9236,  9241,  9242,  9257,  9268,
    9282,  9293,  9307,  9318,  9332,  9340,  9342,  9344,  9349,  9351,
    9364,  9373,  9374,  9378,  9382,  9394,  9405,  9416,  9429,  9430,
    9431,  9435,  9448,  9449,  9463,  9471,  9481,  9494,  9495,  9498,
    9499,  9507,  9524,  9533,  9550,  9560,  9569,  9578,  9587,  9596,
    9606,  9615,  9625,  9634,  9643,  9653,  9663,  9672,  9681,  9691,
    9701,  9711,  9721,  9731,  9741,  9751,  9761,  9771,  9781,  9791,
    9801,  9812,  9823,  9834,  9845,  9855,  9866,  9877,  9887,  9897,
    9905,  9914,  9923,  9932,  9941,  9950,  9959,  9968,  9977,  9989,
    9999, 10000, 10003, 10004, 10014, 10024, 10033, 10042, 10051, 10060,
   10070, 10080, 10090, 10100, 10109, 10118, 10127, 10136, 10145, 10154,
   10163, 10172, 10181, 10190, 10199, 10208, 10217, 10226, 10243, 10252,
   10260, 10268, 10276, 10284, 10293, 10301, 10309, 10318, 10327, 10336,
   10344, 10352, 10360, 10368, 10376, 10384, 10392, 10400, 10417, 10434,
   10435, 10436, 10441, 10447, 10456, 10457, 10458, 10459, 10460, 10464,
   10465, 10468, 10469, 10470, 10471, 10475, 10476, 10477, 10482, 10493,
   10515, 10525, 10526, 10529, 10538, 10544, 10563, 10570, 10577, 10584,
   10591, 10598, 10605, 10613, 10621, 10629, 10637, 10645, 10652, 10659,
   10668, 10669, 10670, 10674, 10677, 10680, 10683, 10686, 10693, 10695,
   10697, 10702, 10704, 10716, 10729, 10742, 10760, 10781, 10782, 10783,
   10784, 10794, 10810, 10820, 10821, 10825, 10829, 10833, 10837, 10841,
   10845, 10849, 10853, 10857, 10861, 10865, 10869, 10873, 10877, 10881,
   10885, 10895, 10896, 10907, 10914, 10925, 10936, 10937, 10941, 10955,
   10962, 10980, 10986, 11002, 11015, 11024, 11032, 11040, 11049, 11060,
   11071, 11081, 11082, 11093, 11103, 11113, 11123, 11133, 11143, 11151,
   11172, 11195, 11203, 11212, 11223, 11224, 11236, 11252, 11268, 11282,
   11302, 11327, 11328, 11332, 11333, 11334, 11335, 11339, 11355, 11369,
   11381, 11396, 11397, 11401, 11402, 11406, 11407, 11410, 11411, 11414,
   11415, 11419, 11420, 11433, 11440, 11453, 11463, 11473, 11474, 11475,
   11476, 11477, 11478, 11479, 11480, 11481, 11482, 11491, 11492, 11496,
   11500, 11507, 11514, 11515, 11519, 11520, 11521, 11531, 11541, 11542,
   11546, 11547, 11548, 11549, 11559, 11566, 11584, 11585, 11595, 11601,
   11607, 11613, 11629, 11630, 11643, 11657, 11667, 11673, 11679, 11688,
   11690, 11695, 11706, 11707, 11718, 11732, 11733, 11744, 11755, 11756,
   11759, 11760, 11761, 11762, 11763, 11764, 11765, 11766, 11769, 11770,
   11781, 11799, 11800, 11804, 11805, 11809, 11817, 11845, 11856, 11857,
   11867, 11878, 11881, 11882, 11883, 11884, 11885, 11888, 11889, 11890,
   11938, 11939, 11943, 11944, 11959, 11960, 11967, 11975, 11983, 11991,
   11999, 12007, 12018, 12019, 12046, 12061, 12062, 12081, 12085, 12089,
   12104, 12111, 12121, 12122, 12125, 12137, 12138, 12142, 12154, 12162,
   12167, 12172, 12177, 12182, 12190, 12198, 12203, 12208, 12215, 12216,
   12219, 12220, 12221, 12228, 12229, 12230, 12231, 12235, 12236, 12240,
   12244, 12245, 12248, 12257, 12270, 12271, 12272, 12273, 12277, 12278,
   12282, 12284, 12300, 12302, 12307, 12310, 12315, 12316, 12324, 12344,
   12345, 12347, 12352, 12353, 12357, 12358, 12361, 12362, 12367, 12368,
   12372, 12373, 12377, 12378, 12385, 12392, 12399, 12404, 12405, 12409,
   12410, 12414, 12415, 12419, 12420, 12424, 12435, 12436, 12437, 12438,
   12442, 12443, 12448, 12454, 12472, 12473, 12477, 12478, 12484, 12489,
   12496, 12504, 12539, 12564, 12568, 12594, 12598, 12610, 12623, 12637,
   12648, 12663, 12669, 12674, 12680, 12687, 12688, 12696, 12700, 12704,
   12710, 12717, 12722, 12723, 12724, 12725, 12729, 12730, 12742, 12743,
   12748, 12755, 12762, 12769, 12780, 12781, 12794, 12798, 12805, 12826,
   12836, 12848, 12853, 12854, 12857, 12858, 12861, 12862, 12867, 12868,
   12873, 12874, 12882, 12887, 12888, 12892, 12896, 12902, 12932, 12937,
   12944, 12949, 12955, 12960, 12969, 12971, 12974, 12978, 12979, 12980,
   12981, 12982, 12983, 12988, 13018, 13019, 13020, 13021, 13032, 13038,
   13046, 13047, 13053, 13058, 13063, 13068, 13073, 13078, 13083, 13088,
   13094, 13100, 13106, 13113, 13135, 13144, 13148, 13156, 13160, 13168,
   13180, 13201, 13205, 13211, 13215, 13228, 13239, 13254, 13256, 13258,
   13260, 13262, 13264, 13269, 13270, 13274, 13275, 13282, 13291, 13299,
   13308, 13319, 13327, 13328, 13329, 13333, 13335, 13337, 13339, 13341,
   13343, 13345, 13350, 13355, 13361, 13369, 13374, 13381, 13388, 13392,
   13396, 13426, 13427, 13429, 13437, 13452, 13454, 13456, 13458, 13460,
   13462, 13464, 13466, 13468, 13470, 13472, 13475, 13477, 13479, 13482,
   13484, 13486, 13489, 13491, 13498, 13500, 13507, 13509, 13516, 13518,
   13526, 13533, 13540, 13547, 13564, 13571, 13578, 13585, 13592, 13608,
   13615, 13622, 13629, 13636, 13643, 13650, 13654, 13662, 13666, 13676,
   13683, 13690, 13703, 13716, 13735, 13756, 13766, 13773, 13789, 13794,
   13812, 13814, 13816, 13818, 13820, 13822, 13824, 13826, 13828, 13830,
   13832, 13834, 13836, 13838, 13840, 13842, 13844, 13848, 13853, 13857,
   13861, 13866, 13883, 13884, 13885, 13900, 13912, 13914, 13916, 13918,
   13928, 13951, 13961, 13971, 13979, 13986, 13998, 13999, 14000, 14004,
   14012, 14016, 14022, 14029, 14036, 14049, 14056, 14084, 14119, 14130,
   14131, 14138, 14144, 14170, 14180, 14193, 14201, 14214, 14224, 14237,
   14247, 14260, 14264, 14268, 14272, 14276, 14280, 14284, 14286, 14290,
   14299, 14304, 14311, 14326, 14333, 14337, 14341, 14345, 14349, 14356,
   14364, 14372, 14379, 14384, 14412, 14426, 14430, 14434, 14438, 14442,
   14446, 14460, 14473, 14477, 14486, 14490, 14494, 14499, 14513, 14515,
   14519, 14521, 14523, 14526, 14529, 14532, 14533, 14536, 14544, 14554,
   14555, 14558, 14559, 14560, 14565, 14569, 14573, 14577, 14588, 14589,
   14593, 14594, 14602, 14603, 14607, 14608, 14613, 14621, 14623, 14637,
   14640, 14667, 14668, 14671, 14672, 14683, 14704, 14712, 14721, 14738,
   14783, 14791, 14799, 14807, 14815, 14825, 14826, 14827, 14828, 14829,
   14843, 14844, 14845, 14848, 14849, 14850, 14853, 14854, 14857, 14858,
   14859, 14860, 14861, 14862, 14863, 14864, 14865, 14868, 14870, 14875,
   14877, 14882, 14884, 14886, 14888, 14890, 14892, 14904, 14908, 14915,
   14919, 14925, 14929, 14940, 14941, 14944, 14948, 14952, 14958, 14959,
   14964, 14968, 14975, 14976, 14977, 14978, 14979, 14980, 14981, 14982,
   14992, 14996, 15003, 15010, 15011, 15027, 15031, 15036, 15040, 15055,
   15060, 15064, 15067, 15070, 15071, 15072, 15075, 15082, 15092, 15106,
   15107, 15111, 15122, 15123, 15127, 15128, 15131, 15132, 15146, 15158,
   15159, 15163, 15174, 15175, 15179, 15183, 15190, 15194, 15198, 15205,
   15215, 15216, 15220, 15221, 15224, 15225, 15236, 15237, 15246, 15247,
   15255, 15265, 15266, 15270, 15271, 15274, 15296, 15304, 15312, 15320,
   15342, 15343, 15354, 15358, 15385, 15387, 15392, 15395, 15398, 15400,
   15402, 15404, 15414, 15416, 15427, 15431, 15435, 15439, 15443, 15452,
   15459, 15491, 15495, 15501, 15518, 15522, 15526, 15532, 15533, 15534,
   15535, 15537, 15539, 15543, 15544, 15545, 15561, 15562, 15563, 15568,
   15569, 15570, 15575, 15576, 15577, 15578, 15584, 15585, 15586, 15587,
   15588, 15608, 15609, 15610, 15611, 15612, 15613, 15614, 15615, 15616,
   15617, 15618, 15619, 15620, 15621, 15622, 15623, 15624, 15625, 15626,
   15627, 15628, 15629, 15630, 15631, 15632, 15633, 15634, 15635, 15636,
   15637, 15638, 15639, 15640, 15641, 15642, 15643, 15644, 15645, 15646,
   15647, 15648, 15649, 15650, 15651, 15652, 15653, 15654, 15655, 15656,
   15657, 15658, 15659, 15660, 15661, 15662, 15663, 15664, 15665, 15666,
   15667, 15668, 15669, 15670, 15671, 15672, 15673, 15674, 15675, 15676,
   15677, 15678, 15679, 15680, 15681, 15682, 15683, 15684, 15685, 15686,
   15687, 15688, 15689, 15690, 15691, 15692, 15693, 15694, 15695, 15696,
   15697, 15698, 15699, 15700, 15701, 15702, 15703, 15704, 15705, 15706,
   15707, 15708, 15709, 15710, 15711, 15712, 15713, 15714, 15715, 15716,
   15717, 15718, 15719, 15720, 15721, 15722, 15723, 15724, 15725, 15726,
   15727, 15728, 15729, 15730, 15731, 15732, 15733, 15734, 15735, 15736,
   15737, 15738, 15739, 15740, 15741, 15742, 15743, 15744, 15745, 15746,
   15747, 15748, 15749, 15750, 15751, 15752, 15753, 15754, 15755, 15756,
   15757, 15758, 15759, 15760, 15761, 15762, 15763, 15764, 15765, 15766,
   15767, 15768, 15769, 15770, 15771, 15772, 15773, 15774, 15775, 15776,
   15777, 15778, 15779, 15780, 15781, 15782, 15783, 15784, 15785, 15786,
   15787, 15788, 15789, 15790, 15791, 15792, 15793, 15794, 15795, 15796,
   15797, 15798, 15799, 15800, 15801, 15802, 15803, 15804, 15805, 15806,
   15807, 15808, 15809, 15810, 15811, 15812, 15813, 15814, 15815, 15816,
   15817, 15818, 15819, 15820, 15821, 15822, 15823, 15824, 15825, 15826,
   15827, 15828, 15829, 15830, 15831, 15832, 15833, 15834, 15835, 15836,
   15837, 15838, 15839, 15840, 15841, 15842, 15843, 15844, 15845, 15846,
   15847, 15848, 15849, 15850, 15851, 15852, 15853, 15854, 15855, 15856,
   15857, 15858, 15859, 15860, 15861, 15862, 15863, 15864, 15865, 15866,
   15867, 15868, 15869, 15870, 15871, 15872, 15873, 15874, 15875, 15876,
   15877, 15878, 15879, 15880, 15881, 15882, 15883, 15884, 15885, 15886,
   15887, 15888, 15889, 15890, 15891, 15892, 15893, 15894, 15895, 15896,
   15897, 15898, 15899, 15900, 15901, 15902, 15903, 15904, 15905, 15906,
   15907, 15908, 15909, 15910, 15911, 15912, 15913, 15914, 15915, 15916,
   15917, 15918, 15932, 15935, 15936, 15937, 15938, 15939, 15942, 15943,
   15946, 15947, 15948, 15949, 15950, 15951, 15952, 15953, 15954, 15955,
   15956, 15957, 15958, 15959, 15960, 15961, 15962, 15963, 15964, 15965,
   15966, 15967, 15968, 15969, 15970, 15971, 15972, 15973, 15974, 15975,
   15976, 15977, 15978, 15979, 15980, 15981, 15982, 15983, 15984, 15985,
   15986, 15987, 15988, 15989, 15990, 15991, 15992, 15993, 15994, 15995,
   15996, 15997, 15998, 15999, 16000, 16001, 16002, 16003, 16004, 16005,
   16006, 16007, 16008, 16009, 16010, 16011, 16012, 16013, 16014, 16015,
   16016, 16017, 16018, 16019, 16020, 16021, 16022, 16023, 16024, 16025,
   16026, 16027, 16028, 16029, 16030, 16031, 16032, 16033, 16034, 16035,
   16036, 16037, 16038, 16039, 16040, 16041, 16042, 16043, 16044, 16045,
   16046, 16047, 16048, 16049, 16050, 16051, 16052, 16053, 16054, 16055,
   16056, 16057, 16058, 16059, 16060, 16061, 16062, 16063, 16064, 16065,
   16066, 16067, 16068, 16069, 16070, 16071, 16072, 16073, 16074, 16075,
   16076, 16077, 16078, 16079, 16080, 16081, 16082, 16083, 16084, 16085,
   16086, 16087, 16088, 16089, 16090, 16091, 16092, 16093, 16094, 16095,
   16096, 16097, 16098, 16099, 16100, 16101, 16102, 16103, 16104, 16105,
   16106, 16107, 16108, 16109, 16110, 16111, 16112, 16113, 16114, 16115,
   16116, 16117, 16118, 16119, 16120, 16121, 16122, 16123, 16124, 16125,
   16126, 16127, 16128, 16129, 16130, 16131, 16132, 16133, 16134, 16135,
   16136, 16137, 16138, 16139, 16140, 16141, 16142, 16143, 16144, 16145,
   16146, 16147, 16148, 16149, 16150, 16151, 16152, 16153, 16154, 16155,
   16156, 16157, 16158, 16159, 16160, 16161, 16162, 16163, 16164, 16165,
   16166, 16167, 16168, 16169, 16170, 16171, 16172, 16173, 16174, 16175,
   16176, 16177, 16178, 16179, 16180, 16181, 16182, 16183, 16184, 16185,
   16186, 16187, 16188, 16189, 16190, 16191, 16192, 16193, 16194, 16195,
   16196, 16197, 16198, 16199, 16200, 16201, 16202, 16203, 16204, 16205,
   16206, 16207, 16208, 16209, 16210, 16211, 16212, 16213, 16214, 16215,
   16216, 16217, 16218, 16219, 16220, 16221, 16235, 16236, 16237, 16238,
   16239, 16240, 16241, 16242, 16243, 16244, 16245, 16246, 16247, 16248,
   16249, 16250, 16251, 16252, 16253, 16254, 16255, 16256, 16257, 16258,
   16259, 16260, 16261, 16262, 16263, 16264, 16265, 16266, 16267, 16268,
   16269, 16270, 16271, 16272, 16273, 16274, 16275, 16276, 16277, 16278,
   16279, 16280, 16281, 16282, 16283, 16284, 16285, 16286, 16300, 16301,
   16302, 16303, 16304, 16305, 16306, 16307, 16308, 16309, 16310, 16311,
   16312, 16313, 16314, 16315, 16316, 16317, 16318, 16319, 16320, 16321,
   16322, 16332, 16333, 16334, 16335, 16336, 16337, 16338, 16339, 16340,
   16341, 16342, 16343, 16344, 16345, 16346, 16347, 16348, 16349, 16350,
   16351, 16352, 16353, 16354, 16355, 16356, 16357, 16358, 16359, 16360,
   16361, 16362, 16363, 16364, 16365, 16366, 16367, 16368, 16369, 16370,
   16371, 16372, 16373, 16374, 16375, 16376, 16377, 16378, 16379, 16380,
   16381, 16382, 16383, 16384, 16385, 16386, 16387, 16388, 16389, 16390,
   16391, 16392, 16393, 16394, 16395, 16396, 16397, 16398, 16399, 16400,
   16401, 16402, 16403, 16404, 16405, 16406, 16407, 16408, 16409, 16410,
   16411, 16412, 16413, 16414, 16415, 16416
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "FCONST",
  "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION",
  "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENCY", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM",
  "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT",
  "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH",
  "MATERIALIZED", "MAXVALUE", "MEMORY_LIMIT", "MEMORY_SHARED_QUOTA",
  "MEMORY_SPILL_RATIO", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE",
  "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF",
  "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON",
  "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING",
  "PLANS", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETOF",
  "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC",
  "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE",
  "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "ACTIVE", "CONTAINS", "CPUSET",
  "CPU_RATE_LIMIT", "CREATEEXTTABLE", "CUBE", "DECODE", "DENY",
  "DISTRIBUTED", "DXL", "ERRORS", "EVERY", "EXCHANGE", "EXPAND", "FIELDS",
  "FILL", "FORMAT", "FULLSCAN", "GROUP_ID", "GROUPING", "HASH", "HOST",
  "IGNORE_P", "INCLUSIVE", "INITPLAN", "LIST", "LOG_P", "MASTER", "MEDIAN",
  "MISSING", "MODIFIES", "NEWLINE", "NOCREATEEXTTABLE", "NOOVERCOMMIT",
  "ORDERED", "OTHERS", "OVERCOMMIT", "PARTITIONS", "PERCENT",
  "PERSISTENTLY", "PROTOCOL", "QUEUE", "RANDOMLY", "READABLE", "READS",
  "REJECT_P", "REPLICATED", "RESOURCE", "ROLLUP", "ROOTPARTITION",
  "SCATTER", "SEGMENT", "SEGMENTS", "SETS", "SPLIT", "SQL", "SUBPARTITION",
  "THRESHOLD", "TIES", "VALIDATION", "WEB", "WRITABLE", "NULLS_FIRST",
  "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateQueueStmt", "OptQueueList", "OptQueueElem",
  "AlterQueueStmt", "DropQueueStmt", "CreateResourceGroupStmt",
  "DropResourceGroupStmt", "AlterResourceGroupStmt",
  "OptResourceGroupList", "OptResourceGroupElem", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOnlyOptRoleElem",
  "AlterOptRoleElem", "CreateOptRoleElem", "deny_login_role",
  "deny_interval", "deny_day_specifier", "deny_point", "opt_time",
  "exttab_auth_list", "keyvalue_list", "keyvalue_pair", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "opt_table_partition_split_into",
  "opt_table_partition_exchange_validate", "alter_table_partition_id_spec",
  "alter_table_partition_id_spec_with_opt_default",
  "alter_table_partition_cmd", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "skip_external_partition", "copy_file_name",
  "copy_options", "copy_opt_list", "copy_opt_item", "opt_binary",
  "opt_oids", "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement",
  "column_reference_storage_directive", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "opt_storage_encoding",
  "ColConstraintElem", "ConstraintAttr", "TableLikeClause",
  "TableLikeOptionList", "TableLikeOption", "TableConstraint",
  "ConstraintElem", "opt_no_inherit", "opt_column_list", "columnList",
  "columnElem", "distributed_by_list", "distributed_by_elem", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "ExistingIndex", "DistributedBy",
  "OptDistributedBy", "OptTabPartitionColumnEncList",
  "TabPartitionColumnEncList", "OptTabPartitionStorageAttr",
  "OptTabPartitionSpec", "OptTabSubPartitionSpec", "TabPartitionElemList",
  "TabSubPartitionElemList", "tab_part_val_no_paran", "tab_part_val",
  "TabPartitionBoundarySpecValList", "OptTabPartitionRangeInclusive",
  "TabPartitionBoundarySpecStart", "TabPartitionBoundarySpecEnd",
  "OptTabPartitionBoundarySpecEvery", "OptTabPartitionBoundarySpecEnd",
  "TabPartitionBoundarySpec", "OptTabPartitionBoundarySpec",
  "multi_spec_value_list", "part_values_single", "part_values_clause",
  "part_values_or_spec_list", "TabPartitionElem", "TabSubPartitionElem",
  "TabPartitionNameDecl", "TabPartitionDefaultNameDecl",
  "TabSubPartitionNameDecl", "TabSubPartitionDefaultNameDecl",
  "TabPartitionByType", "OptTabPartitionBy", "TabSubPartitionTemplate",
  "opt_list_subparts", "TabSubPartitionBy", "TabSubPartition",
  "CreateAsStmt", "create_as_target", "opt_with_data",
  "CreateExternalStmt", "OptWritable", "OptWeb", "ExtTypedesc",
  "ext_on_clause_list", "ext_on_clause_item", "format_opt",
  "format_opt_list", "format_def_list", "format_def_item",
  "format_opt_item", "ext_options_opt", "ext_options", "ext_options_list",
  "ext_options_item", "OptExtTableElementList", "ExtTableElementList",
  "ExtTableElement", "ExtcolumnDef", "OptSingleRowErrorHandling",
  "OptLogErrorTable", "ExtSingleRowErrorHandling", "ExtLogErrorTable",
  "OptSrehLimitType", "ext_opt_encoding_list", "ext_opt_encoding_item",
  "CreateMatViewStmt", "create_mv_target", "OptNoLog",
  "RefreshMatViewStmt", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "opt_ordered", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTypeStmt",
  "AlterTblSpcStmt", "RenameStmt", "opt_column", "opt_set_data",
  "AlterObjectSchemaStmt", "AlterOwnerStmt", "RuleStmt", "RuleActionList",
  "RuleActionMulti", "RuleActionStmt", "RuleActionStmtOrEmpty", "event",
  "opt_instead", "DropRuleStmt", "NotifyStmt", "notify_payload",
  "ListenStmt", "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_rootonly_all", "opt_full", "opt_freeze", "opt_name_list",
  "ExplainStmt", "ExplainableStmt", "opt_dxl", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "cdb_string_list",
  "cdb_string", "InsertStmt", "insert_rest", "insert_column_list",
  "insert_column_item", "returning_clause", "DeleteStmt", "using_clause",
  "LockStmt", "opt_lock", "lock_type", "opt_nowait", "UpdateStmt",
  "set_clause_list", "set_clause", "single_set_clause",
  "multiple_set_clause", "set_target", "set_target_list",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "select_fetch_first_value", "I_or_F_const",
  "row_or_rows", "first_or_next", "group_clause", "group_elem_list",
  "group_elem", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "rowsfrom_item",
  "rowsfrom_list", "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "scatter_clause", "table_value_select_clause",
  "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "window_frame_exclusion", "row", "sub_type", "all_Op",
  "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "when_operand", "case_default", "case_arg", "decode_expr",
  "search_result_list", "search_result", "decode_default", "columnref",
  "indirection_el", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst", "Sconst",
  "RoleId", "QueueId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "ColLabelNoAs", "keywords_ok_in_alias_no_as",
  "PartitionColId", "PartitionIdentKeyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,    61,
      60,    62,   744,    43,    45,    42,    47,    37,    94,   745,
      91,    93,    40,    41,    46,    59,    44,    58
};
#endif

#define YYPACT_NINF (-4945)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-2995)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    5943,    53,  9116, -4945, -4945,    53, -4945, 70606,    44,   777,
    1547,   161, 11180, 71088, 81210,   910,   331, 14115,    53, 81210,
     952, 54218, 67232, 81210,   440,   687, 54218, 81210, 81692,   781,
    1039,  1353, 82174, 71570, 66268,  1650, 81210,  1275,  1295, 82656,
   72052,  1162, 72534,   687, 49889,   107,  1090, 83138,  1725,  1609,
    1131, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945,    44, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945,  2814, -4945,  1344,
    2916,  1711,   249,  1172, -4945, -4945, -4945, 60966, 81210, 81210,
   81210,  1458, 81210,  1301, 81210,  1484,   800, 60966, 61448, 73016,
    1632,  1545, 45450, -4945, 58556, 81210, 81210, 83620, 81210,  1069,
   68678, 81210,  1569, 81210, 81210, 59038, 84102, 81210,   104,  1795,
    1566, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, 81210, 14473,   440, -4945, -4945, 81210,  1710, 81210,
    1634, 81210,  1805, 81210, -4945, 81210,  1812, 84584,   813,  1667,
   61448,  1930, 45946,  1901, 61448, 85066, 81210, 81210, -4945, -4945,
    1895, 81210, 81210, -4945,  2011, 61930, -4945, -4945,   120, -4945,
    2002,  2083,  2018,  2283,  2166,  2157,   175, -4945, 73498, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, 59520,   331, -4945,
   -4945, 62412, 81210,  2172, -4945, -4945, 85548, -4945,  1991, -4945,
    1042,   820, 62894, 63376,  2294,  1977, 46442,  2330, 63858, 86030,
   -4945, -4945, 86512, -4945, 86994,  2068, 87476, -4945, 64340, -4945,
   -4945,   208,  2182, 87958, -4945,  1894,  1686,  1988, 41042, -4945,
   -4945, -4945, -4945,    44, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945,   343,  1965,   277,   215,   335, -4945, -4945,   231,
     240,   247,   343,  2434,  2434, -4945, 81210, -4945, -4945,  1965,
      55,  1945,  1945,  1945,  2146,    52, -4945,  1945, -4945, -4945,
   -4945, -4945, 72534, -4945,  1974,   440,  2009,  2385,  2079, 81210,
   -4945, 81210, -4945, 81210, 81210, -4945, -4945,  2455,  2095,  2334,
    2031, -4945, -4945, -4945,  2302,  2317,  2301,    84,   440,  2232,
   -4945,  2441, -4945,  2368, 26166,   440, 73980, 88440,   218, 59520,
     440, 74462,  2194,  1437,  2381, -4945, -4945, -4945,   710, -4945,
    2634,  2235,  2481,  2031,  1566, 42998, -4945,  2193,  1703, 72534,
   -4945, -4945, -4945,   474,  2537, 26666, -4945, 81210,  2187, -4945,
    2228,  2246,  2247,  1711, -4945,  5943, 88922,  1341,  1341,  2711,
    1341,  1502,  2023, -4945,  3069, -4945,  2607,  2585, 72534,  1090,
     270, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945,  2281,  1703, -4945,   274, -4945,  1900,
    2286,  1915,  1839, -4945, -4945,  1518, 81210,  2469,   235,   726,
   72534,  2400, 74944,  2808,  2311, -4945,   849, -4945, -4945, -4945,
   -4945,  2655,  2699,  7046,   339, 75426, -4945, 81210, 81210, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  2345, -4945,
   -4945,  2357,  2687,  1512,  2612,   156,  2731, 10549,  1680, 75908,
   81210,  2701,  2759,  7246,  2013,  1023,  2632,  1443,  2687,  2748,
    1592,  2769,  7717,  2610,  2652, 81210, 61448, 81210, -4945,  2715,
    2820,   652, -4945,   349, -4945,  2546,  2683,   612, 60966,  2442,
   -4945, -4945, 81210, -4945, -4945, -4945,  2584, -4945,   833, 60966,
   -4945,  2706,  2559, 46938, -4945, 81210, -4945, -4945, -4945, -4945,
   -4945,  2645, 81210, -4945, -4945,   326,  2772, 81210, -4945,  1945,
    2689,  2914, 99008,   166, 81210,  2574,  2960, 81210,  2757,  2574,
    2590, 89404, -4945, -4945,  2574, -4945, -4945, 81210, 81210,  2501,
    1589,  2574,  2783,  3000,  3006,  2691,  2797,  1266,   363,   278,
    2919,  2574, 81210, 61448,  2674, 81210, 89886, 81210,  2592,  2684,
   60966, 81210,  3024, 60966, 81210, -4945,   724, -4945, -4945,   864,
   -4945, -4945, -4945, -4945,  2966,  2281,   883,  2974,  2627,  2976,
   -4945, -4945, -4945,  2761,  2725, -4945,  2998,  2311,  2999, -4945,
    2630, 90368, -4945, 90850, 91332,  3001,  2345, 61448,  3005,  2630,
    3008,  2888,  3009,   883,  3010, -4945,  1350,  3012,  2895,  3014,
    1980,  2630, 81210, 61448, 60002,  3015,   168, -4945, 29666, -4945,
    2799, -4945,  1081,  1090, -4945,  1886, -4945, 53736, -4945,  1988,
    1965, -4945, 81210,  1965, 81210,  1965, 81210,  1965, 81210,  1965,
   81210, 81210, 81210,  1965, -4945, -4945, -4945, 81210,  2656, 81210,
   81210, -4945, -4945, -4945, 67714, 61448, 68196, -4945, -4945,   134,
     440, -4945, -4945, 99008,  3126, 61448,  3024,  3013,  3013,  3013,
   -4945, -4945, -4945,  2949, 81210,  3016,  3017, 67714, 61448, -4945,
   91814, 59520,  2907,  2664, -4945, -4945, -4945, -4945, -4945,  1998,
    3162,   286,  3165, 29666,  2676,   244,   244,  2677,  3032, -4945,
   -4945, -4945,   279,  2680,  2681, -4945,   217,   217,  2909,  2688,
    2692, -4945,   291,  2693,  3180,  3184,   292,  2696,  2697,  2703,
    2351,   244, 29666, -4945,  2708,   217,  2712,  2714,  2716,  3188,
    2717, -4945,  3203,  2718,  2719,   267,   396,  2721,  2722, -4945,
    2688, -4945,   289,  2723,  2724,  2726,  2736,  2737,  2738,  2739,
    2743,  2744,  2745,  2747,  2749, 29666, 29666, -4945, 25166,  1703,
     440, -4945, -4945, -4945, -4945, -4945, -4945, -4945,   160, -4945,
     295, 48922, -4945,  2804, -4945, -4945,  2948, 29666, -4945, -4945,
   -4945,  3035,  2751, -4945,   296, -4945, -4945, -4945,  1703, -4945,
   -4945,   314,  2754, -4945,  2000, -4945, -4945, -4945, -4945, -4945,
   -4945, 57110,  3223, -4945,   443,   440,   349,   358,  3168, 52772,
   53254, -4945, -4945,  3046, -4945, 81210, -4945, -4945, 29666, 49407,
   -4945,  1703,   145, -4945, -4945, -4945,  1898, -4945, -4945, -4945,
      44, -4945, 13568, -4945,  1918,  2187, 81210, 81210,  3231, -4945,
   -4945, -4945, 81210, 76390, -4945,  2228, -4945, -4945,  1711,  1711,
   29666,  1711,   815,  1742, 27166, 30166,  3115,  3018,   907,  1423,
    3116, -4945,  3021,  1502,  2023, 72534, 81210, 92296,  2936, -4945,
   51335,  1953,  1703,  2905,  2913,  2965, 55182,  2780,  2923,  2925,
    2971,  2927,  2928, 92778, -4945, -4945, -4945, -4945,  1762,  1370,
    1520,  2929,   457,  1331,  3225, -4945,  1286,  2986, -4945, -4945,
   -4945,  4255,  8196, 81210,  3169,  9844,  3052,   339,  3053,  2993,
   -4945, -4945,  2830,  3109,  2955,  2957,  3072,   339,   819, 93260,
   -4945, -4945, -4945,  2848,  2856,  2858, -4945, -4945, -4945,  5895,
   23203, -4945,  2975,  2958,  2988, 81210, 64822,  1668,  3090,   668,
    1790,   610, 81210,  3167,  3097, 81210,  2844,  2987,   953,  3181,
    2847,  1891,   807,  3274,   807,  3003,  1097,  2846, -4945, -4945,
   -4945, -4945,   425,  2123,  3085, -4945,  3186,  3221, 11672,  2977,
    2979, 98062,   742, 47434,  3263,  1495,  3002, -4945,  1495, 81210,
    3007,  3011, 81210,   339, -4945,  3318,   339,   339,  2051,  3320,
    1142,   202,  2042,  2574,  2846,  1970, -4945,  3019,  3020,   943,
   -4945,  3113, -4945, -4945,  1349,  3023, 72534,  1054,  2190,  2846,
    3027,  3029,  2847,  2847, 81210, 81210, 81210, 81210, 81210,   220,
    3335,  3336,  3030,   230,   956,  2869, -4945,  1495, 57592,  3031,
   -4945,  1495, 81210,  1199,  2243,  2846,  3033,  3034,  3050, -4945,
   -4945,  1750,  1600, -4945, -4945, -4945,  1566, -4945, 81210, -4945,
   81210,  2281, 99008,  3127, -4945,  2994, -4945,  2311,   339, -4945,
   81210, 81210,  2345,  1330,  1464,  3130, -4945, -4945, 81210,  3201,
    2997, -4945,   257,  2901, -4945, -4945,  3025, -4945,  3025,  3025,
    2902,  2902,  2903, -4945, -4945, -4945,  2351,  3025,  2902, -4945,
   99954, -4945,  1294,  1345, -4945,  3378,  3381, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945,   934,  2022, -4945, 81210,
   55182, -4945,  3392, -4945, -4945, 99008,  3161,  3284, -4945, 81210,
    3182,  2924, -4945,  3317,  3040, -4945, -4945,   673, -4945,  3291,
   61448,   885,   440,  3036, 81210,  3211, 81210, 81210, 81210, 81210,
   -4945, -4945,  3185,   855,   113, -4945, 57592, -4945,  3037, -4945,
   81210,  1970,  3196,  3406,   604,  1945, -4945,  1619, 81210,  2937,
    3290, -4945, 81210,  2938,  3412, 81210,  3244, -4945,  2184, -4945,
    3131, -4945, 60966,   883, -4945, -4945, -4945, -4945, 99008, 81210,
   -4945, 93742, 60966,   883, 61448, 61448,  3309,   168,  3313,  3068,
    3321,  3073, 47434,   883,   173, 61448, 81210, 81210, 81210, -4945,
   81210, -4945, -4945, -4945, -4945, 81210, 81210, 61448, 57592,  3323,
   -4945, -4945,  3324,   883, 81210, 81210, -4945, 13568,  1922, -4945,
    1081, 58074, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  1081,
   81210, -4945, 81210, -4945, 81210, -4945, 81210, -4945, 81210, -4945,
   -4945, -4945, 81210, -4945, 81210,  1931, -4945, -4945,  1932,  1197,
   81210, 81210,   799, 60966, 81210,  3205, 81210, 81210, 81210, 81210,
   81210, 81210,  3099,  2754,     3, -4945,   908, 72534,  3219, -4945,
   -4945,  1936,  1725,   556, 81210, -4945, -4945, -4945, -4945, -4945,
   -4945, 68196, 67232,  3312,    99, 81210, -4945, -4945,  2707, 29666,
    1703, 25666, -4945, -4945, -4945,  2964, 13568,  3067, 29666, -4945,
   -4945, 29666,  2967,  2434,  2434, 29666, -4945, -4945, -4945, -4945,
     266,  2434, -4945, 29666, 29666,  2434,  2434,  3025,  3025, -4945,
    4614, 29666, -4945, 47434, 29666, 33666, 22221, 29666,  1725,  3107,
    3048,  2434, -4945,  2434, -4945, 29666, 24666, -4945, 29666,  3239,
   29666, 29666,   358,  3241, 29666,   358, 29666,  2983, 29666, 29666,
    3463,  3463, 42509,  1881,  7863,  2972,  1703, -4945,  3147,  2434,
   -4945,  2434,   787, -4945,   283, 99008, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, 29666, 55182, -4945, -4945,
    3118, -4945, -4945, -4945, -4945,   233, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, 81210, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, 29666, -4945, -4945,
   -4945,  2990, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945,  1872, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, 29666, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945,   243, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  2991, -4945,
   -4945, 29666, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945,  3122, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, 29666,
   29666, 29666, 29666, 29666, 29666, 29666, 29666, 29666, -4945, 36132,
     304, -4945, -4945, -4945,  3327,  3345,    28,  2212, 76872,  3337,
   26166, 21219, -4945,   254, -4945, -4945, -4945, 81210,  3223, -4945,
   -4945,  3129, -4945, -4945, -4945, -4945, -4945,   298, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945,  2989, -4945, -4945, -4945, -4945,
    2989, -4945,  2995,  6407, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  3329,  3332,
     883, 81210,   474, 69160,  3118,  2991, -4945, 26666, -4945,  1968,
   -4945,  3004,  2228, -4945,  2228, -4945,  3325, -4945,  2996, -4945,
   10702,  3325, -4945, -4945, 34160,  3175,  3310,  3255, -4945, -4945,
   -4945,  3022, 13568, 30666, 30666, -4945,  2151, 13568,  2254, -4945,
   -4945, -4945, -4945, -4945, -4945,  1694, -4945, 81210,  3219,  3115,
    1423,  3128,   758, 81210, -4945, 43487,  3249, -4945,  3468, -4945,
   99954, -4945,  3026, -4945, 99481, 97116, -4945, -4945,   843, -4945,
    1312,  3154,  3155,  3202, 61448, 81210, 81210, -4945, 55182, 61448,
   81210, 81210, 61448, 81210, 81210, -4945,  3443,    79, 67232,  3204,
   66750, -4945, -4945,  3028, 81210,  3136,  3326,  3343,    -3, -4945,
   -4945, 94224, -4945,  3282, 61448, 81210, 81210, 29666,  3289, 81210,
   81210, -4945,   281,  3179,  3183, -4945, 81210,  3187, 60966,  3041,
   81210, 81210, 81210,  3177,   860, 60966,  3148, 47930, 81210, 81210,
   81210, 81210,  3227, 81210, 81210,  3348,   807,  2846,  1102, 72534,
     321,  2408,  2846,  3304, -4945,   414,   924, -4945, -4945, 61448,
   81210,  3298, -4945, -4945, -4945, 77354,  3515,  3217, -4945, -4945,
    3458,  3459, -4945, 94706, -4945, -4945, -4945,  1978, -4945, 61448,
   61448, 81210, 11783, 81210,  3286,100900, -4945, -4945, 99008, -4945,
   81210,  3287,101369,  8196, 81210, 81210, 81210, 69642, 95188,  3288,
  101838,   883, 95670,  1128,  1388, 81210, 70124, -4945, 81210, -4945,
   -4945, 55664, 61448, 81210,  3198,   812, 55182, -4945, 81210,   605,
     290,   200,  3206, -4945, -4945,   883, 81210,  3158, -4945,  3293,
    3529,  8196, -4945, -4945,  3207,  3212, 81210,  1056,  2750,  2846,
   81210, 81210,  3062,  2006,  3208,  3251, -4945, 81210, 88440, -4945,
   61448,  2458, -4945,  3271, 61448, 81210, 12366, -4945, -4945,   339,
   -4945, -4945, -4945, -4945, -4945, 81210, 81210,   339, 81210,   339,
    1599, -4945, 61448, 81210, -4945, -4945, -4945, 81210, 13562, 81210,
   81210, 81210, 81210, 61448, 81210, -4945, -4945,  1739,  1185,  1738,
    1761,  3272, 81210,  3408, 81210, 96152, 61448, 81210, 81210,  3449,
   81210,  2152, -4945, -4945, -4945,  3250, -4945, 61448,  2458, -4945,
   13850, 81210, 81210, 81210, 61448,   889,  1088,  3216,  3220,   467,
    3292, -4945, -4945, -4945, -4945, -4945, -4945,  3386,  3555, 81210,
   -4945,  3393,  3394,  3209,  3210,  3395,  1124, 81210, -4945, -4945,
   -4945, -4945, 81210,  3398,  1124,  3340,   198, -4945, -4945,  2574,
   -4945, 29666,  3566, 99008,  3098,  3101,  3234,  3236,  3240, -4945,
    3102,  3242,  2434, -4945, -4945,  2124, -4945, -4945,  2010, -4945,
    3117,   855,  2407, -4945, 55182, 81210,   968,  1190,  3471, 65304,
    3096,  3460, 81210,  3214, 81210,  3096, 81210, -4945,  2005, 67232,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  3465,
   -4945,   440,  2501,  2501,  2501,  2501, -4945, -4945, -4945, -4945,
    3359,  1896, -4945,  3111,  2501, 81210,  3294,  3096,  2501,   848,
    3124, -4945,  1970,  3483,   944, 81210, 65304,  2264,  3228,  3280,
    3593,  1945, 51808, -4945,  2501,   440,  3373, -4945, 23676,  4817,
    3380,  2501, 59520,  3470,  3472,  3490, -4945,  2281, -4945,  3608,
   -4945,  3511,   883,  2311, -4945,  2630, -4945, 81210, -4945, 81210,
   81210, 81210, 81210,  2345, -4945, -4945,  2630,  3396,   883,   883,
   -4945,  3397,   883,  2630,  3328,  3500, 59520, -4945,   168, -4945,
   -4945, 29666, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945,  2012, -4945, 81210, -4945,  3480,  3481,  3485,  3150,  3153,
    3252, 81210,  3156, -4945,  3150,   339,  3150,  2754,  2754,  3150,
    3153,  3150, 60484,  3642,  3504,   203, -4945,   204,  1244,  3435,
   -4945, -4945, -4945, -4945, 99008, -4945, -4945, -4945, -4945, -4945,
   81210,  3261,   102,  3413,  3163, 60484,  3620,   883, -4945, 60966,
   -4945, -4945, -4945,  3307,  3322, 60966,  3427,  3281, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945,  3477, 81210,  2016, -4945, -4945,
    1764, -4945,  1786, 29666, 31166,   197, -4945, 11789,  2017, 29666,
    3191,  3192,  2033, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
    3193,  3530, -4945,  3194,  2060,  2070,  3197,  3199, -4945, -4945,
    4699,  3200, 12458,  3213, 33666, 33666,  1508, -4945, -4945, 33666,
    3218, -4945,  2072, 11033,  3176,  3222,  3215,  3226,  3262, -4945,
    3229,  3230, 12531, 27666, 29666, 27666, 27666, 12977,  3176,  3232,
    2080, 55182,  6522,  3414, 13030,  2094, -4945, 29666, 55182,  6960,
   29666,  7106, -4945,  2096,  8060, -4945, 29666, 81210,  3233,  3235,
   -4945, -4945,  4614, -4945,  3265, -4945, 33666, 33666, -4945,  2258,
   25166, -4945, -4945,  3532, -4945, -4945,  1892, -4945,  3189, -4945,
   -4945,  6549,   269, 29666,  2990, 29666,  3338, 47434, 11118, 29666,
    3042,  6256,  6256,   508,   508,   287,   287,   287,  1843,  2212,
   -4945, -4945, -4945,  3224,  3237,  3238,  3425,  2717, 29666, -4945,
    2288,  2320, 81210,  2419,  5456,  5692, -4945, -4945, 37610,  3303,
   -4945, 29666, 29666, 29666,  3243, -4945,  3677, 13568,    61, -4945,
    3686, -4945,  1566,  2434,   787, 53736, -4945, -4945, 29666, -4945,
   -4945, -4945,  2228, -4945, -4945, -4945, -4945, -4945, 81210,  1725,
   -4945, -4945, 29666, -4945, -4945,   896,  2063,   739,  3450,  2240,
    2240,  2151,  3451, -4945, -4945,  3330, -4945, 29666,  2319, -4945,
    2347, -4945, -4945, -4945, -4945,  2754, -4945, -4945, -4945, 37610,
    3306,  3319, 42020,  3400, -4945, -4945, 81210,   111, -4945, -4945,
   -4945,  3245, -4945, -4945, 97116,  2022, -4945, 99481, -4945, 99481,
   -4945,  2022,  3661, -4945, 97116,  1860, 61448, 81210, 81210, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  3502,
   -4945, 61448, 61448,  3469, 81210,  3467,  3474, 29666,   894, 81210,
    3246,  3247,   573,  3541, 81210, -4945,  3586,   883, -4945, -4945,
    3367, -4945, 13568, -4945, -4945, -4945, -4945, -4945, 61448, 81210,
   -4945, 59520, -4945,  2281, 99008, -4945, -4945, -4945, 81210,  3333,
   81210, -4945, 81210, 81210, 81210,  2345, -4945, -4945, -4945, -4945,
    1492, -4945, -4945, 81210, 81210,   167,  3368,  3384, 81210, -4945,
    1259,  3113, 13978, 81210, 81210, 81210,  3560,  3275, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945,  3506, -4945, -4945, -4945, -4945,
   97116, -4945,  2630,   144,  1230,  2846, -4945,101369, -4945,  3253,
    3254, -4945,  3256,  3257,   841,  3626,  3331, -4945,  1468, -4945,
   -4945, -4945,  3496, -4945,103245, -4945, -4945,  1317, -4945, -4945,
   -4945, -4945, -4945,  3621,   883,102307,  3624, -4945,  3627,   883,
   81210, 81210, 81210, 81210, -4945, -4945, -4945, -4945, -4945, 55182,
   55182, 55182,  2098, -4945, -4945,   440, -4945, -4945, -4945,  3759,
   -4945, -4945, -4945,  3594, -4945,  2104, -4945,  1606, -4945, -4945,
    3341, -4945, -4945,  3267, -4945, -4945,  3269, -4945, -4945,  3420,
  102776,  3276, -4945, 61448, 81210, 14049, 81210, 81210, 81210,  1971,
   -4945,   264, 99008, -4945, 98535, 61448, 81210, -4945, -4945, -4945,
    3562,  3346,  3507, -4945,  1210,  3509, 61448,  3401,  3277,   368,
    3277,   379, -4945, -4945, -4945,  3422, -4945, -4945,  1233,  2765,
    2846,  1970, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
    1307,  1130,  2771,  2846,  3423, -4945,  3424, -4945, -4945, -4945,
    3557,  3568,  3569,  3428,  3429,  3475,  3432,  3434,  3482, -4945,
    3436,  3484,  3438,  3487,  3440,   883, 99008,  3550,   440,  3476,
    3662,   883, -4945,  3445, -4945,  2501, -4945,  3772, -4945, 81210,
   -4945,  1257,  2954,  2846, -4945, -4945, -4945, -4945,   343,   343,
     343,   343,   440,   343, -4945, -4945,  3334,  2501,  2501,  3339,
    3342, -4945, -4945, -4945, 61448, 81210, -4945, -4945, -4945,  1124,
   99008,  3616,  1124,  1124, 81210, 81210,  1124, -4945, -4945, -4945,
    3617,  3618,  1124, -4945, -4945, -4945, -4945,  2689,  3311,  8262,
    3315,  3101,  3314,  2434,   226,   966,  1150,  3495,  2434,  3588,
    3347, -4945, -4945, 55182, 44954,  2062,  3609,  3344,  3344,  3344,
    3344,  3344,  3344,  3344, -4945,  1954,   318,  2574, 59520, 81210,
   59520, -4945,  1190,  3496, 81210, 81210,  3755, 81210,  3349,  3350,
   -4945, -4945, -4945, -4945, -4945, 61448,   209, 61448,  2434, -4945,
   -4945,  3452, -4945, 81210,  1945,  3789,  3006,   885,  3525,  2014,
    3732,  3228, -4945, -4945, -4945, -4945, 81210, 81210,   855,   440,
   -4945,  3351,  3352, -4945, 81210, -4945,  2501, 81210, 81210, 81210,
    3261,  3353,  3356, 99008,   642,  3578,  3580,  2847,  3801, 81210,
    1725,  3228,  3354,  2111, -4945, -4945,  3478, 81210, -4945,  2112,
     135, -4945,   440, 59520, 97589, -4945,  5351, -4945, -4945,   913,
   -4945,  3673, -4945, -4945,  1725,   883, 99008, 81210, -4945,   883,
     168,  3453,   883,  3454,   883,   883, 81210, -4945, -4945, 81210,
   -4945, 81210, 57592,   883, -4945, 13568, -4945, -4945,  3519,  3522,
    3526, 81210,  3150, 60966, -4945,  3355, 61448,   548, -4945, -4945,
    3591, -4945, -4945, -4945, -4945, -4945,  3715,  3719, -4945, -4945,
   -4945,  1159, -4945, 61448, 67714,   199, 61448, -4945,  2281, -4945,
   -4945,  2311,   339, -4945, 81210,  3670, -4945, -4945, -4945,  3369,
    2117,  3628, 13568,  3510, 29666, -4945,  3740, 99008, -4945,  8785,
   -4945, -4945, -4945, -4945, 29666, -4945, -4945, -4945, -4945, -4945,
   29666, -4945, 29666,  3718, -4945,  3862,  3862, 99008, 33666,  1927,
    2712, 33666, 33666, 33666, 33666, 33666, 33666, 33666, 33666, 33666,
   36632,   835, -4945, -4945, 29666, 29666,  3726,  3718, -4945,   212,
   -4945, -4945, -4945,   -10,   -10, 99008,  3372,  3176,  3374,  3375,
   29666, -4945, -4945,  2136, 29666, 35154,  3376, 55182, -4945, 29666,
   11377,  2137,  3486, 13527, 29666,  3370, -4945, -4945, -4945,  1703,
    8851, -4945,  3825,   440, 29666,  1117,  1590, 29666,  2142, 29666,
    3731, -4945, -4945, -4945,  3385, -4945, -4945, 99008, 29666, 33666,
   33666,  6907, -4945,  6996, 29666,  3383,  8337, 25166, -4945,  3630,
    3491, 43976, -4945,   687,   687,   687,   687, -4945, 81210, 81210,
   81210, 38099,  3738,  3402, 37121, 77836,  3389,  2356, -4945, 77836,
   78318, -4945,  3409, -4945,  3403,  1703, 29666,  3737,    67,    67,
    3630, -4945, 29666, 28166,  3404, -4945,   349,  3407, -4945, -4945,
   10522, -4945, -4945,  3410, -4945,  3416, -4945,  2063, -4945, -4945,
   -4945, -4945, -4945,  3648, -4945, -4945, -4945,  3389, 31666,  3400,
   -4945,  2148, -4945, -4945, 26166, -4945, -4945,  2153, 43487,  3306,
   26666,  1703,  2160,  1908, -4945, -4945, 97116, -4945,  3537, -4945,
   -4945, -4945,  3344,  2630,  2630,  1404,  3150,  3766,  1404,  8884,
   -4945, -4945, 38588, 81210, 81210, -4945, 81210,  2191,  1883, 81210,
   -4945, 81210, -4945, -4945, -4945, -4945,  3884, -4945, 81210, -4945,
   -4945,  3531,  3536, -4945, 81210, 81210, 81210, 81210, -4945, -4945,
    2286, -4945, -4945, 61448, 81210, -4945, -4945, -4945,  1384,  2982,
    2846, -4945,  3559, -4945, -4945, -4945,  3739, -4945,  3877,  3574,
   81210,   841, 39077, 39077, 39077, 39569,  3256,  3257,  1468, -4945,
    3331,  3433, -4945, 81210,  2501,  3439,  3441, -4945,  1883, -4945,
     263,  2847,   159, -4945, -4945,  3570, 81210, -4945,  3802,101369,
   81210, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   55664, -4945, -4945, -4945, 81210, -4945, 55182, 44954, 55182, -4945,
   81210,   947, 81210,  3626, 40061, -4945,  1413,  1405,  2985,  2846,
   -4945,  3577, -4945,  3582,  3583,  3629,  1254,  1243,  3585,  3587,
    3631,  3448,  3455,  3456, -4945, -4945,   343,  3804,   440, -4945,
   -4945,   440,  2630,   440, 55182, -4945,  3854,  2366, -4945, -4945,
   -4945, 81210, 81210, 81210, 81210, 81210,  3906,  3600, 81210, 81210,
   81210, 81210, 81210,  3812,   727,  2066, 61448, 81210, 81210, 61448,
   81210, 81210, 81210, 81210, 81210, 81210, 81210, -4945,  3895,  3826,
    2290,  3866,  3592, 81210, -4945, 81210, -4945,  3113, 81210, 81210,
   -4945, -4945, -4945, -4945, -4945, -4945,   339,  3565, -4945,   339,
     339, -4945, -4945, -4945,  3462,  1124, -4945, -4945,  3778,  3779,
   -4945,  1124,  1124, -4945,   257, 55182, -4945,  2053, -4945,  2434,
    2315,  3479, -4945,  3488, -4945, -4945, -4945, -4945, -4945, -4945,
    3473, -4945,   787, -4945, -4945,  3416, -4945,   425,  2123, -4945,
   -4945, -4945, -4945, -4945, -4945, 81210,  3344, -4945,   381,  1434,
    1527,  1536, 78800, 79282, 79764,  3464, 81210, 81210, 33666, -4945,
    1681,   822, -4945,  3777, 81210,  3573, -4945, -4945, -4945,  3692,
   81210, -4945, -4945, -4945, -4945, -4945,  3489,  3856,  3857, -4945,
    3652, 65304,  2630, 61448, 61448,  2630, -4945, 99008,  3492,  3228,
   61448,   885,  1619, 89886,  3576, -4945,  3493,  3837, -4945,  3494,
    3498, -4945, -4945, 81210,  3496, -4945,  2192,   689,  1894,  3341,
   65786,  2264,  3807, -4945, -4945, -4945,  3916,  3633, -4945,  1725,
    3499,  3261,  3633, 44954, -4945,  3987,   440,  3136, -4945, 97116,
   29666, 29666, -4945,  3501, -4945,  3503, 11993, -4945,  2501, -4945,
   -4945, -4945, -4945, -4945, -4945,  3632, 81210, -4945, -4945,  3497,
     883, -4945, -4945, 81210, -4945, 81210, -4945, -4945,   883,   883,
   -4945,  3675, -4945, 81210, 81210, 81210,  3150, -4945,   339, -4945,
    3848, 60484, -4945, -4945, -4945, -4945, -4945,  3911,    99,  3858,
   -4945, -4945,  3816,  3819,  3820,  3821,  1221, -4945, -4945,  3900,
   29666, 13568, -4945,  3514, -4945, 13568,  9356, 13568,  3726, -4945,
    2597,  3865, -4945,  1893,  3517,  2597,   644,   644,   394,   394,
     307,   307,   307,  3862,   835, 13568, 13568, -4945, -4945, 29666,
   -4945, -4945, -4945,  3520, -4945, -4945, -4945,  3176, -4945, 32166,
    9389,  3725,  3976, -4945, -4945, -4945,  3623,  3637,  3544, -4945,
   29666, 32666,  3527, 99954,  6489, 29666, -4945,  3546, -4945, -4945,
     787,  1778, 33666, 33666,  2491, -4945,   447, 29666, 99008,  2196,
    2491,  1663,  2291, 29666, 29666,  8406,   312, 29666,  9498,  3547,
   29666, 96634, -4945, -4945, 81210, 81210, 81210, 81210, -4945, -4945,
   -4945, 77836, 78318,  3554, 29666, 22713,  2356,  3556, 81210, -4945,
   -4945,  3558, 37610,  3831,  3769, -4945, 37610,  3769,  1544,  3769,
    3864, -4945, 44465, -4945, -4945,  3561, -4945, -4945, 21219,  1451,
   13568,  3986,  3901, 29666,  3564,  3567,  3571, 13568, 29666, -4945,
     440,   440, -4945, -4945, 47434, -4945, -4945,  3815, 13568, -4945,
    1725, 81210,  1703,  2751,  3579, 81210, -4945,  3400, -4945, -4945,
    3697,  2198, -4945,   343, -4945, -4945, -4945, -4945,  3708, 67232,
    3919, -4945, 29666,  2209, -4945,  3669,  4009,   143,  2210,  2211,
    1883, -4945,  3573, -4945,  1728,  3898,   258, -4945,   883, -4945,
   99008, -4945, 81210, 81210, -4945, -4945, -4945, -4945,  2780, -4945,
   -4945, 81210, 81210, 81210, 81210, -4945, 61448, 81210, -4945,  1468,
    3575, 52290, 52290,  4067, -4945,  2217,   306, -4945,  2226,   309,
    2234, 52290,  4067,  2255,  2262,  3439, -4945, 39077, -4945,  3724,
     503, -4945, 55182,  2952,  3835, -4945, -4945,  3836,   343, 81210,
   -4945, 99008,   883,   883,   883,   883, -4945, -4945, -4945, -4945,
    3595,  2263, -4945, 80246,   165,103714, -4945, -4945,  2267,  1468,
   -4945,   841,   841,  2332,  3890,  3257,  3581, -4945,  3589,  4035,
    3730, 81210, 81210, 81210, 81210, 61448, 81210, 81210,  2434,  2434,
   99008,  3584, -4945,  2434,  2434,  3590, -4945, 61448, 81210, 81210,
   -4945, -4945, -4945, -4945,  3854, -4945, -4945, -4945,  2268, -4945,
    3597,  4060,  3728, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   61448, 81210, -4945,  3734, -4945, -4945, -4945, 81210, 81210, 81210,
   81210,  3955, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, 81210, -4945, -4945,   440,   440, 99008,   883,
     883, -4945, -4945, -4945, -4945,  2501, -4945, -4945,  3899, -4945,
    1124,  1124, -4945, -4945,   441,  2289, -4945, 40553, -4945, -4945,
    2960,   440,  2960,  1747, -4945, -4945,  2960, -4945,  3625,  2960,
    3643,  2960, -4945,  1883,  3601,  1937,  3939, -4945, -4945, -4945,
   -4945,  3945,   343, -4945, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945, 29666, -4945,
    1263,  2597, -4945, -4945, -4945, -4945,  3573,  1945,  3716, 60966,
     380, -4945,  3930,   968, 65304,  2501,  2501,  1743, 81210, -4945,
    2630,  2630,  3721, 81210,  4073, -4945,   706, 81210,  3985,  3709,
   -4945,   440, -4945, -4945,  3228, 81210, 65304,  3261, -4945,  3839,
    2298, -4945, -4945, -4945,  3704,  3580,  3610,  2264,   898, 81210,
   -4945,  3707, 80728,  3341, -4945, -4945,  3354, -4945,  3965,  3619,
   -4945, 13568, 13568,   440,100427,  5351, -4945, 81210,  3938,   883,
   -4945,   883,   883, -4945, -4945, 81210,  3150,  3150,  3150, -4945,
    3863, -4945, -4945,   883, 60484,  1221,  1221,  1221,  1221, -4945,
   -4945, -4945,  3969, 13568, -4945, -4945, -4945, 33666,  3970, -4945,
    3622, 99008,  3176, -4945,  3649,  2303,  2312, -4945, 35643,  3830,
   -4945, -4945, -4945,  9535,  3736, 13568,  3787,  3636,  3647, -4945,
   29666,  7619, -4945, -4945,  1164,  1164,   447,  2318, -4945, 33666,
   33666,  2491,  2491, 29666,  2491, -4945, -4945,  9885,  3859, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, 56146,  7787, 77836,  3650,
   81210,  2356, 37610, -4945, -4945,  1840, -4945, 37610,  3931, -4945,
   37610, 81210,  3651, 81210,    61, 33166, 29666,  3729, -4945, -4945,
   -4945,  3630, -4945,   787,  3653, 81210, -4945, -4945,  1090, -4945,
   -4945, -4945, -4945, -4945, 60484,  3875, 60484,  1883,  9903,  3573,
   38588, 48426, 81210, 80246, 80246,  3838,  3573,  3716, -4945, -4945,
   -4945, -4945, -4945, -4945,  3656, -4945, -4945, -4945,  3768, -4945,
   -4945,    16,  3219,  3439, 39077,  4067,   232, 99008,   108, 39077,
   29666, -4945, 29666,   108,  2326, -4945,  3658, -4945, 52290, -4945,
    2327, 81210,  2338,  2343, -4945,  2501, -4945, -4945, -4945, -4945,
   -4945,  3895, -4945, -4945, -4945, -4945, 44954, -4945, 81210, 81210,
   -4945, -4945,103714, -4945, -4945,   503,  1948,  1468,  1468,  3672,
    3679, -4945,  3664, -4945,  3890, 61448, 81210, -4945,  3770, -4945,
   -4945, -4945, -4945, -4945, 41531, 47434, -4945,  1254,  3666,  3667,
    1243, -4945, -4945, -4945, -4945, -4945, 55182,   440,  3854,   440,
   -4945,    31,  3219, 81210,   577,  1072,  3751,  3150,  4016, -4945,
   -4945, -4945,  3895, -4945, -4945, -4945,  1124, -4945, -4945, -4945,
    2574,  4024, -4945, 55182, -4945, 56628, -4945, -4945, -4945,   440,
   -4945,   440,  3925, 81210, 50371,   440, -4945,   440,  3735,   440,
   -4945, 60966,  4140,  4140, 81210, -4945, -4945,  9936,  3932, -4945,
    3716,  3954,  4000, -4945,  3678, 81210,  3893,  3680,  3681, -4945,
   -4945,   450,   450,  3496, 81210,  2353,  1725,   885, 65304,  3496,
   -4945,  1756,  3683,  4048, -4945,  4155,  3353,  3684, -4945,  4141,
   -4945, -4945, 65786,  3937,  3633, 81210,  3580,  3873, -4945,  3885,
   -4945,  1578, -4945, -4945,  3687,  3693, -4945, -4945, 99008, -4945,
   81210, 38588, -4945, 99481, -4945,  2362, -4945, -4945,  3303, 81210,
     122, -4945, -4945, -4945, -4945, -4945, -4945,   199, -4945, -4945,
   -4945, -4945, 29666,   986, 33666, 99008,  2369, 29666, -4945, 29666,
   -4945,  4154, -4945, -4945, -4945,   112, -4945, -4945, 13568, -4945,
    1164,  1164,  2491, -4945,  4157,  3630, -4945,  2373,  4176, 29666,
   -4945, 81210,  2377, -4945, 29666,  3710, -4945, -4945, 37610,  1840,
    2387, 81210,  2391, 99008,  3712,  3711,   -43,  3714, 21720,  3713,
   -4945, 13568, 13568, 81210, -4945,  3720, -4945, -4945, -4945, -4945,
     548,  1404,   199,  4009,  3716, -4945,  3722, -4945, -4945,   365,
     365, 81210,  3716, -4945, -4945, 81210,  3867, -4945, -4945,  4194,
    4218, -4945, -4945, -4945, -4945, -4945,    67,    67, -4945, -4945,
   52290,  4067, -4945, -4945, -4945, -4945, 55182, -4945,  3845, -4945,
   -4945, -4945, -4945, -4945, -4945,  3439,  1948,  1948,  1948, -4945,
   -4945,   807, -4945,    43,  3219, 81210, 99008,  2311,    96, -4945,
   99008, 99008, -4945, -4945, -4945, -4945, -4945,  3876, -4945, -4945,
   81210, 81210, 81210, 81210, 81210,   883, -4945,  3311,   440, -4945,
   -4945,  2401, -4945, -4945, -4945, 81210,  3493, -4945,  3493, -4945,
   -4945, -4945, -4945,  4140,   340, -4945, -4945, -4945,  1873,  3995,
   -4945,   191,  3980,  3882,  3741, -4945, 60966,  4233,  3915, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  4101,  3228,
    3707, -4945, -4945, -4945, -4945, 29666,  3959,  1725,  2264,  3807,
      66, -4945, -4945,  3341,  2403,  3633, -4945, -4945,  4186,  3990,
    4188,   252, 80728, -4945, -4945,  2409, -4945, -4945, 11993,100427,
    4133, -4945,  3868, 81210, -4945, -4945, -4945, 13568,   986,  2411,
   -4945,  2415,  2424,  3956,  3869, -4945, 29666,   149,  3409, 56146,
    3750, -4945,  9999,  2432, -4945, 13568, 81210, -4945, -4945, -4945,
    2433, -4945, -4945, 29666,  3753, 29666, -4945, 33166,  3747, -4945,
    4225, -4945, -4945,  4105, -4945, 80246,  3860, 47434,  2063,  2063,
    1945, -4945,  1883, -4945, 81210, 99008, 99008,  3757,  3760,  2446,
   -4945, 29666, -4945, -4945, -4945,  3439,  3439,  3756,  3909, -4945,
   -4945,  2447, -4945,  1031,  3972,  4118,  2460,  2477, 81210,  3153,
    3870,  3153, -4945,  3150, -4945,  1715, -4945, -4945, 56628,  3493,
   -4945, -4945, -4945,  4145,  4090, -4945, -4945, -4945, -4945,   186,
   -4945,  4015,  4017, 81210, -4945,  3773, -4945,  2487, 81210, 81210,
    4239,  4241, -4945, 10349, 60966,  3707,  3580,  2264, -4945, -4945,
    3776,  1954,  3839, -4945,  3341,  4022, -4945,  4023,   440,  3780,
    3842, -4945,  3228, 38588,  5351, -4945,   878, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945,  2996, 28666, 28666,  3781, -4945, -4945,
   81210, -4945,  2496, -4945,  2504, 33166,  2505, -4945, 81210,  3783,
   60484,   365,  3784, -4945,  3786, -4945, -4945,  3954,  1883,  3219,
    3788, -4945,   440,   229, -4945, 13568, -4945, -4945,   807, 81210,
   60966,  4235, -4945, -4945, -4945,  3972, -4945, -4945,  3219, 81210,
    3861,  3847,  3813, -4945,  3981, -4945,   790,   790,  4181, -4945,
    3913, -4945, -4945,  3794, -4945,  4293,  3496, -4945,  1254,  1725,
   -4945,  3797, -4945,  3633,  3580, 81210, -4945,  3839, -4945, -4945,
   -4945,   440,   440,  3633, -4945, -4945, -4945, -4945,  1889, 34660,
    3989,  1192, 11943,  4169, -4945,  4169, -4945,  2510, -4945, -4945,
    2514, -4945, -4945, -4945,   199,  2063, 29666,  1883, -4945,  3980,
   -4945, -4945, -4945,  3803,  3219,  2311, 81210, -4945, -4945, -4945,
    4112,  4171, -4945,  3844,  3709, -4945,  4296, -4945,  1267, -4945,
   -4945, -4945, -4945, -4945,  3584,  3707, 54700,  3341,  3633,  2518,
   -4945,  4062,  2527, -4945, -4945,  3817,  3303, -4945,  2026, -4945,
   -4945, -4945, -4945, -4945, -4945, -4945,  4286, -4945, -4945, -4945,
   -4945, -4945,   179, -4945, -4945, -4945, -4945, -4945, -4945, 10409,
   -4945, -4945, -4945, -4945, -4945, 81210,  3871,  4109,  4182, -4945,
   -4945, -4945, -4945, -4945,  2529, -4945, -4945, -4945, -4945,  3839,
    3341,  3846,   459, -4945, -4945,   440, 20239,  4065, -4945,  2239,
   -4945, -4945,  2314,  2247, 29166,  4012, -4945,  3872, -4945, -4945,
    1883, -4945, -4945,  2434,  4041, -4945, 54700, -4945,  3839,  4280,
    3827,  3853, -4945, -4945,   440, -4945,  2434, -4945,  4062, -4945,
    3849,   189,   205,  1461,  3850,   294,   297,  3883,   300, -4945,
    1421,  2539, -4945, -4945,  3851,  3832, -4945, -4945,  2026, -4945,
   -4945, -4945,   708, 60966, -4945, -4945,    66,   245, -4945,   225,
    3846, -4945, -4945, -4945,   440,   440,  4092, 50853,   440,   440,
    3905,   440, -4945,  2960,  2960,  1461, -4945,  2960,  2960,  3883,
    2960, -4945, -4945, -4945, 55182, 24166, 20729, -4945,   151, -4945,
   -4945, -4945, -4945,  3841,  3843,   256,103714, -4945,  2548,  1468,
   -4945,   841,   841,  3852, -4945, -4945, -4945, 81210, -4945,  3493,
   -4945, -4945, -4945, -4945, -4945, 81210, -4945, -4945,  2549, -4945,
     440,  3344,  3917, -4945,  3341,  3886, -4945, 54700, 81210,103714,
   -4945, -4945,   245,  1948,  1468,  1468,   503,  3493,  2594, -4945,
   55182, -4945,  2366,   118, -4945,  3878,  2613,  2615, -4945, -4945,
    3439,  1948,  1948,  2619, -4945, -4945, -4945, -4945, -4945,  4132,
   -4945, -4945, -4945,  3439,  3439, -4945,  2434, -4945, -4945,   708,
   -4945
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    1676,  1462,   790,  1552,  1551,  1462,   297,     0,  1554,     0,
    1462,   461,  1213,     0,     0,     0,     0,   790,  1462,     0,
    1676,     0,     0,     0,     0,  1689,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1462,     0,     0,  1696,     0,
       0,     0,     0,  1689,     0,  1558,     0,     0,     0,     0,
       2,     4,    59,    20,    86,    60,    87,    21,    67,    68,
      23,    22,    34,    33,    92,    93,    53,    17,    81,    61,
     126,   125,   127,    40,    36,    75,    29,    30,    37,    41,
      63,    42,    48,    54,   104,    62,    24,    58,    85,    64,
      90,    47,    11,    12,    49,    79,    13,    50,    80,    14,
      51,    15,    69,    94,    32,    65,    91,    66,     5,    43,
      77,    73,    10,    55,    56,    57,    82,    83,    84,   109,
      89,   121,    39,   118,    98,    99,   115,   100,   116,     8,
     101,    52,    16,   112,   111,   113,    76,    44,    78,   110,
      31,    26,   114,    18,    19,   117,    88,   107,   103,   122,
     120,   128,   105,    70,     6,     7,    95,    25,    46,     9,
      28,    27,    45,    38,   124,    35,  1554,    97,   108,    96,
      71,   102,    74,   106,   123,    72,   119,  1651,  1650,  1698,
    1654,  1675,     0,  1665,  1461,  1460,  1446,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1472,  2256,  2271,  2272,  2273,  2274,  2276,  2277,  2278,  2279,
     427,  2280,  2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,
    2289,  2866,  2867,  2868,  2869,  2290,  2291,  2292,  2293,  2294,
    2295,  2296,  2870,  2871,  2297,  2298,  2299,  2300,  2301,  2872,
    2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2311,  2312,
    2313,  2314,  2315,  2319,  2321,  2322,  2323,  2324,  2325,  2326,
    2327,  2873,  2874,  2328,  2329,  2330,  2331,  2332,  2333,  2334,
    2336,  2337,  2338,  2339,  2340,  2341,  2342,  2344,  2345,  2346,
    2347,  2348,  2350,  2351,  2354,  2355,  2356,  2875,  2358,  2359,
    2360,  2876,  2361,  2364,  2365,  2877,  2366,  2368,  2370,  2371,
    2372,  2373,  2878,  2374,  2376,  2377,  2379,  2380,  2381,  2383,
    2384,  2385,  2386,  2388,  2389,  2390,  2391,  2392,  2394,  2881,
    2395,  2396,  2397,  2398,  2882,  2883,  2884,  2399,  2400,  2401,
    2402,  2403,  2404,  2405,  2406,  2407,  2408,  2885,  2409,  2411,
    2412,  2413,  2414,  2415,  2416,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2425,  2427,  2429,  2430,  2431,  2432,  2887,  2888,
    2434,  2435,  2889,  2438,  2439,  2440,  2890,  2441,  2891,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2450,  2892,  2452,  2893,
    2454,  2455,  2456,  2457,  2459,  2460,  2463,  2894,  2895,  2466,
    2464,  2465,  2467,  2468,  2469,  2470,  2471,  2474,  2476,  2477,
    2896,  2480,  2481,  2482,  2483,  2484,  2485,  2487,  2488,  2489,
    2490,  2491,  2492,  2494,  2496,  2497,  2498,  2499,  2500,  2501,
    2898,  2503,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2513,
    2514,  2515,  2516,  2517,  2518,  2899,  2519,  2520,  2521,  2901,
    2522,  2525,  2526,  2527,  2528,  2529,  2530,  2531,  2532,  2533,
    2534,  2902,  2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,
    2903,  2904,  2546,  2905,  2547,  2906,  2548,  2549,  2550,  2551,
    2552,  2553,  2554,  2555,  2556,  2557,  2558,  2559,  2560,  2561,
    2563,  2564,  2907,  2908,  2565,  2566,  2567,  2568,  2569,  2571,
    2572,  2573,  2574,  2575,  2577,  2578,  2909,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2579,  2580,  2581,  2275,  2310,
    2316,  2317,  2318,  2320,  2335,  2343,  2349,  2352,  2353,  2357,
    2362,  2363,  2367,  2369,  2880,  2879,  2375,  2378,  2382,  2387,
    2393,  2410,  2417,  2886,  2426,  2428,  2433,  2436,  2437,  2449,
    2451,  2453,  2458,  2461,  2462,  2472,  2473,  2475,  2478,  2479,
    2486,  2493,  2495,  2897,  2502,  2511,  2512,  2900,  2523,  2524,
    2535,  2544,  2545,  2562,  2570,  2576,   426,  1641,  2226,  2257,
    2258,  1553,  1532,   790,     0,  1449,   460,     0,     0,     0,
       0,     0,     0,     0,   984,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   220,     0,     0,   484,   483,
       0,     0,     0,  1185,   489,     0,   949,   678,     0,   677,
       0,     0,     0,     0,     0,     0,   778,  1600,  2464,  1598,
    1642,   298,   301,   302,   299,   300,  2248,     0,  1300,  1301,
    1303,     0,     0,  1313,  1021,  1022,     0,  1020,     0,  1024,
       0,     0,     0,     0,  1016,     0,     0,     0,     0,     0,
    1023,  1013,     0,  1010,     0,     0,     0,  1019,     0,  1014,
    1029,     0,     0,     0,  1450,  1597,   490,  1578,     0,  1576,
    1572,  1573,  1574,  1554,  1563,  1575,  1568,  1570,  1569,  1571,
    1567,  2247,  2272,  1123,  1123,  1123,  1123,  1120,  1121,  1123,
    1123,  1123,  2487,     0,     0,  1102,     0,  1104,  2253,  1123,
    1128,   550,   550,   550,     0,  1127,  1132,   550,  1443,  1481,
    2231,  1688,     0,  1103,  1442,  2546,  1589,     0,     0,     0,
    1317,     0,  1318,     0,  2505,  1454,   282,  2517,  2903,  2546,
     281,   276,   277,   250,  2277,     0,     0,  1127,     0,  1451,
    1452,  1086,  1695,  1693,  2212,  2295,  2309,  2413,   273,  2500,
    2506,  2517,  2903,  2546,  2578,   229,   239,   234,     0,   291,
    2517,  2903,  2546,   287,  1472,     0,  1666,  1790,  2222,     0,
    1445,  1444,  1557,     0,  1560,     0,  1752,  2482,  1670,  1672,
    1562,  1663,     0,     0,     1,  1676,  1556,  1692,  1692,     0,
    1692,     0,  1655,  1663,  1658,  1662,     0,     0,     0,     0,
    2256,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,  2934,  2935,  2936,  2937,
    2938,  2939,  2940,  2933,     0,     0,  2232,  2257,  2261,     0,
    1032,     0,   156,  2227,  1173,     0,     0,     0,     0,  2226,
       0,     0,     0,     0,     0,  2262,     0,  2249,  2263,  2264,
    2265,     0,  2381,     0,     0,     0,  2116,  2299,  2361,  2126,
    2124,  2125,  2118,  2119,  2120,  2121,  2122,  2123,     0,  1298,
    2117,     0,   198,   156,     0,     0,  2381,     0,     0,     0,
       0,     0,  2381,     0,     0,     0,     0,     0,   198,  2416,
     156,  2381,     0,     0,     0,     0,     0,     0,  1466,     0,
       0,     0,  1468,  1471,  1447,  1535,     0,  2222,     0,     0,
    1063,  1053,     0,  1064,  1054,  1059,     0,  1066,     0,     0,
    1056,     0,     0,     0,  1067,     0,  1055,  1057,  1069,  1058,
    1065,     0,     0,  1060,  1061,     0,     0,     0,  1458,   550,
     433,     0,     0,     0,     0,   156,  1522,     0,  2381,   156,
       0,     0,   488,   487,   156,   486,   485,  2299,  2361,     0,
    1212,   156,  2381,     0,   222,   860,   793,     0,     0,   938,
    2416,   156,     0,     0,     0,     0,     0,     0,   681,     0,
       0,     0,  1188,     0,     0,   777,   790,  1601,  1599,     0,
    1304,   275,   274,  1302,  2381,     0,   375,     0,     0,  2381,
    1509,  1018,  1011,     0,     0,  1017,  2381,     0,  2381,  2251,
     213,     0,  1015,  2299,  2361,  2381,     0,     0,  2381,   205,
    2381,     0,  2381,   375,  2381,   794,     0,  2381,     0,  2381,
    2416,   207,     0,     0,     0,  2381,   375,  1030,     0,  1594,
       0,  1577,  1676,  2907,  1583,     0,  1579,  1586,  1582,  1578,
    1123,  1122,     0,  1123,     0,  1123,     0,  1123,     0,  1123,
       0,     0,     0,  1123,  2254,  2255,  1105,     0,  1129,     0,
       0,  1136,  1135,  1134,     0,     0,     0,  1137,  1794,  1619,
       0,  1440,  1457,     0,     0,     0,  1188,  1320,  1320,  1320,
    1453,   280,   278,     0,     0,     0,     0,     0,     0,  1459,
       0,     0,     0,     0,  2235,  2237,  2238,  2127,  2202,     0,
    2867,  2868,  2869,  2187,     0,  2870,  2871,  2872,  2920,  2025,
    2012,  2021,  2026,  2013,  2015,  2022,  2873,  2874,  2341,  2875,
    2876,  2245,  2877,  2878,  2882,  2883,  2884,  2885,  2017,  2019,
    2887,  2888,     0,  2246,  2890,  2891,  2446,  2893,  2894,  2896,
    2898,  2023,  2901,  2902,     0,  2903,  2904,  2905,  2906,  2244,
       0,  2024,  2908,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,     0,  2880,  2879,  2886,     0,     0,  2219,     0,  1989,
       0,  1834,  1835,  1857,  1858,  1836,  1863,  1864,  1876,  1837,
       0,  2218,  1901,  2079,  1987,  2008,  1995,     0,  1986,  1988,
    1982,  1678,  2211,  2213,     0,  1983,  2234,  2236,  2194,   242,
     293,     0,   294,  2220,  2517,   230,   272,   244,   271,   245,
     243,     0,  2297,   231,     0,     0,   232,     0,     0,     0,
       0,   290,   288,     0,  1448,     0,  1792,  1791,     0,     0,
    2200,  2223,  1039,  1545,  1546,  1544,     0,  1541,  1543,  1559,
    1554,  2207,  2206,  2208,     0,  1671,     0,     0,     0,  1653,
    1652,     3,  2369,  2502,  1547,  1562,  1690,  1691,     0,     0,
       0,     0,     0,     0,     0,     0,  1742,  1706,  1707,  1709,
    1739,  1743,  1751,     0,  1659,     0,     0,  1796,     0,  1753,
       0,     0,  2233,     0,     0,     0,     0,  1033,     0,     0,
       0,     0,     0,     0,   155,  1507,   284,  1505,     0,     0,
       0,     0,     0,     0,     0,  1514,     0,     0,   211,   212,
     805,   790,     0,     0,  2381,     0,     0,     0,     0,     0,
    1252,  1259,     0,     0,     0,     0,     0,     0,     0,     0,
    1253,  1251,  1254,     0,     0,     0,   286,  1263,  1284,  1287,
       0,  1163,     0,     0,     0,     0,     0,  1371,     0,     0,
    1371,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   308,   320,   361,
     370,   769,     0,     0,     0,   772,     0,  2381,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,     0,
       0,     0,     0,     0,   756,   768,     0,     0,     0,     0,
       0,   765,     0,   156,   312,   749,   753,     0,     0,     0,
     869,   868,  1512,  1511,     0,     0,     0,  1371,     0,   303,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   419,   420,     0,     0,     0,
     160,     0,     0,     0,     0,   314,     0,     0,     0,   133,
    2250,     0,     0,  1467,  1464,  1465,     0,  1470,     0,  1531,
       0,     0,     0,     0,  1071,     0,  1068,     0,     0,  1062,
    2299,  2361,     0,     0,     0,     0,  1077,  1076,     0,     0,
     463,   432,     0,     0,  2259,  1845,  1874,  1852,  1874,  1874,
    1841,  1841,  1854,  1842,  1843,  1881,     0,  1874,  1841,  1846,
       0,  1844,  1884,  1884,  1869,     0,  1826,  1827,  1828,  1829,
    1855,  1856,  1830,  1861,  1862,  1831,  1898,  1841,  2260,     0,
       0,   947,     0,  1484,  1521,     0,     0,     0,   799,     0,
    2381,     0,   158,   985,     0,   936,   489,     0,   158,     0,
       0,   216,     0,   864,     0,     0,     0,     0,     0,     0,
     884,   883,     0,     0,     0,   937,     0,   158,     0,   133,
       0,   752,  2381,     0,   550,   550,   680,   490,     0,     0,
       0,  1187,  1190,     0,     0,     0,     0,  1645,  1647,  1646,
       0,  1644,     0,   375,   373,   374,   933,  1312,     0,     0,
    1012,     0,     0,   375,     0,     0,  2381,   375,  2381,     0,
    2381,     0,     0,   375,   375,     0,     0,     0,     0,   865,
       0,  1028,  1026,  1025,  1027,     0,     0,     0,     0,     0,
     145,   143,  2381,   375,     0,     0,  1007,  2137,     0,  1565,
    1676,     0,   261,   262,   260,  1584,   263,  1585,  1581,  1676,
       0,  1113,     0,  1117,     0,  1108,     0,  1114,     0,  1109,
    1106,  1107,     0,  1112,     0,     0,   551,   553,     0,     0,
    2325,  2340,     0,  2370,  2403,  2404,  2506,  2513,     0,  2539,
    2550,  2472,     0,  1138,  1168,  1133,     0,     0,  1629,  1441,
    2143,     0,  1676,     0,     0,  1319,  1316,  1315,  1314,   279,
     251,     0,     0,     0,  1170,  2505,  1456,  1085,   790,     0,
    1984,     0,  1992,  1993,  1873,  1860,  2186,     0,     0,  1868,
    1867,     0,     0,     0,     0,     0,  1850,  1849,  1848,  1991,
    2151,     0,  1847,     0,     0,     0,     0,  1874,  1874,  1872,
    1921,     0,  1851,     0,     0,  2164,     0,  2170,     0,     0,
       0,     0,  1880,     0,  1878,     0,     0,  1957,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1905,  1906,     0,  1989,  2137,     0,  1990,  2241,     0,     0,
    1866,     0,  1898,  2216,  2127,     0,  2590,  2591,  2592,  2593,
    2585,  2595,  2596,  2597,  2598,  2586,     0,     0,  2599,  2600,
    2587,  2860,  2601,  2602,  2603,  2205,  2820,  2861,  2821,  2822,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2613,
    2614,  2823,     0,  2615,  2616,  2617,  2618,  2619,  2620,  2622,
    2623,  2624,  2625,  2629,  2630,  2631,  2632,  2633,  2825,  2826,
    2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,  2643,
    2644,  2645,  2646,  2647,  2648,  2650,  2651,  2654,  2655,  2656,
    2827,  2657,  2658,  2828,  2661,  2829,  2662,  2664,  2862,  2665,
    2666,  2667,  2830,  2668,  2670,  2671,  2673,  2135,  2674,  2675,
    2676,     0,  2677,  2679,  2680,  2681,  2682,  2683,  2833,  2684,
    2685,  2686,  2687,  2834,  2835,  2836,  2688,     0,  1935,  2689,
    2690,  2691,  2692,  2693,  2837,  2694,  2133,  2696,  2697,  2698,
    2699,  2700,  2702,  2703,  2704,  2705,  2706,  2707,  2709,  2711,
    2712,  2713,  2838,  2839,  2715,  2716,  2840,     0,  2718,  2719,
    1937,  2720,  2841,  2721,  2842,  2722,  2723,  2724,  2725,  2726,
    2727,     0,  2843,  2864,  2844,  2730,  2731,  2732,  2734,  2845,
    2846,  2739,  2737,  2738,  2740,  2741,  2742,  2743,  2746,  2747,
    2748,  2847,  2749,  2750,  2751,  2752,  2753,  2754,  2755,  2756,
    2757,  2759,  2760,  2761,  2762,  2763,  2764,  2849,  2765,  2766,
    2767,  2768,  2769,  2770,  2771,  2774,  2775,  2776,  2777,  2850,
    2778,  2779,     0,  2780,  2852,  2783,  2784,  2785,  2786,  2787,
    2788,  2789,  2790,  2853,  2792,  2793,  2584,  2794,  2795,  2796,
    2854,  2855,  2799,  2856,  2800,  2857,  2801,  2802,  2803,  2804,
    2805,  2806,  2807,  2808,  2809,  2810,  2811,  2812,  2815,  2858,
    2859,  2865,  2813,  2814,  2816,  2817,  2818,  2819,  2594,  2621,
    2626,  2627,  2628,  2824,  2649,  2652,  2653,  2659,  2660,  2663,
    2831,  2832,  2669,  2672,  2678,  2695,  2863,  2701,  2708,  2710,
    2714,  2717,  2728,  2729,  2733,  2735,  2736,  2744,  2745,  2758,
    2848,  2772,  2773,  2851,  2781,  2782,  2791,  2797,  2798,  2126,
    2124,  2125,  2118,  2119,  2120,  2121,  2122,  2123,  2131,  1918,
       0,  2217,  2582,  2583,     0,  2081,     0,  1917,     0,  1755,
       0,     0,  2239,  2195,   295,   296,   292,     0,     0,   247,
     246,     0,   265,   269,   270,   241,   268,     0,   264,   249,
    2070,  2069,   248,   240,   237,   235,   252,   254,   255,   238,
     236,   289,     0,     0,  2266,  2941,  2942,  2943,  2944,  2945,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
    2956,  2957,  2958,  2959,  2960,  2961,  2962,  2963,  2965,  2966,
    2967,  2968,  2970,  2971,  2972,  2973,  2974,  2975,  2976,  2977,
    2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,  2997,
    2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3007,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  3018,
    3019,  3020,  3021,  3022,  3023,  3024,  3025,  2964,  2969,  3006,
    2197,  2196,  2229,  2267,  2268,  2269,  2270,  2201,     0,     0,
     375,  1539,     0,  1536,     0,     0,  2210,     0,  1673,     0,
    2224,     0,  1562,  1555,  1562,  1548,  1669,  1668,  1699,  1700,
    1205,  1667,  1726,  1727,     0,     0,     0,     0,  1748,  1746,
    1717,  1710,  1716,     0,     0,  1714,     0,  1718,  1901,  1741,
    1657,  1704,  1705,  1708,  1656,     0,  1744,     0,  1629,  1742,
    1709,  1616,     0,     0,  1797,     0,  1227,  1229,     0,  1228,
       0,  1231,     0,  1240,     0,     0,  1226,  1245,     0,  1234,
    1232,     0,     0,     0,     0,     0,     0,  1034,     0,     0,
       0,     0,     0,     0,  2539,   283,  1503,     0,     0,     0,
       0,  1172,  1171,     0,     0,  1192,     0,     0,     0,  1517,
     539,     0,   372,     0,     0,     0,     0,     0,     0,     0,
       0,   931,   928,     0,     0,   927,     0,   803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   305,   839,     0,
    1371,     0,   872,     0,  1261,     0,     0,  1264,  1260,     0,
       0,     0,  1262,  1257,  1258,  2506,  2517,  2546,   285,  1265,
       0,     0,  1286,     0,  1285,  1283,  1215,     0,  1216,     0,
       0,     0,     0,     0,     0,   637,   322,   335,     0,  1370,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     411,   375,     0,     0,     0,     0,     0,   356,     0,   364,
     363,     0,     0,     0,     0,     0,     0,   368,     0,     0,
       0,     0,     0,   367,   358,   375,     0,     0,   362,     0,
       0,     0,   770,   771,     0,     0,     0,  1371,     0,   316,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,   201,
       0,   197,   200,     0,     0,     0,     0,   755,   767,     0,
     759,   760,   757,   761,   762,     0,     0,     0,     0,     0,
       0,   754,     0,     0,   862,   861,   867,     0,     0,     0,
       0,     0,     0,     0,     0,  1323,  1322,     0,     0,     0,
       0,     0,     0,   975,     0,     0,     0,     0,     0,     0,
       0,     0,   204,   875,   876,     0,   877,     0,   202,   203,
       0,     0,     0,     0,     0,     0,   139,     0,     0,     0,
       0,   259,  1463,  1469,  1534,  2230,  1533,     0,     0,     0,
    1070,     0,     0,     0,     0,     0,     0,     0,  1072,  1073,
    1074,  1075,     0,     0,     0,     0,     0,   437,   438,   156,
     436,     0,  1826,     0,  1822,  1818,  1887,  1888,  1889,  1886,
    1899,  1885,     0,  1832,  1890,  1841,  1838,   948,     0,   952,
     955,     0,  1482,   510,     0,     0,   796,   839,     0,   492,
     209,     0,     0,     0,     0,   154,   220,   222,   490,     0,
     221,   223,   225,   226,   227,   224,   228,   859,   863,     0,
     792,     0,     0,     0,     0,     0,   885,   889,   888,   892,
     890,     0,   886,     0,     0,  1814,     0,   196,     0,   130,
       0,   748,   751,     0,     0,     0,   492,   584,   386,     0,
       0,   550,     0,   935,     0,     0,     0,  1189,     0,     0,
       0,     0,     0,     0,     0,     0,  1643,     0,  1290,     0,
    1510,  2381,   375,     0,  1288,   214,  2252,     0,  1008,     0,
       0,     0,     0,     0,  1292,  1004,   206,     0,   375,   375,
     795,     0,   375,   208,     0,     0,     0,   787,   375,  1031,
    1596,     0,  1566,  1580,  1564,  1110,  1119,  1118,  1116,  1115,
    1111,     0,  1130,     0,   549,     0,     0,     0,  1144,  1145,
       0,     0,  1143,  1161,  1146,     0,  1148,  1140,  1139,  1149,
    1151,  1150,     0,     0,  1170,     0,  1626,     0,  1624,     0,
    1795,  1628,  1617,  1588,     0,  1587,  1591,  1593,  1592,  1590,
       0,   675,     0,     0,  1127,     0,     0,   375,  1455,     0,
    1087,  1088,  1094,     0,     0,     0,     0,     0,  1095,  1091,
    1092,  1093,  1096,  1097,  1098,     0,     0,     0,  2203,  2147,
       0,  2148,     0,     0,     0,  2185,  2179,     0,     0,     0,
       0,     0,     0,  2152,  2155,  2156,  2157,  2154,  2158,  2153,
       0,     0,  2159,     0,     0,     0,     0,     0,  1871,  1870,
       0,     0,     0,     0,     0,     0,     0,  1960,  1995,     0,
       0,  2111,     0,  2137,  2169,     0,  1996,     0,     0,  1882,
       0,     0,     0,     0,     0,     0,     0,  2137,  2175,     0,
       0,     0,     0,  1901,  2068,     0,  2065,     0,     0,     0,
       0,     0,  2042,     0,     0,  2202,     0,     0,     0,     0,
    2242,  1902,  1919,  2215,     0,  2204,     0,     0,  1903,  1926,
       0,  2176,  1953,     0,  1958,  1941,     0,  1934,     0,  1939,
    1943,  1922,  2205,  2136,     0,  2134,     0,     0,  1920,     0,
    1915,  1913,  1914,  1907,  1908,  1909,  1910,  1911,  1912,  1916,
    2115,  2113,  2114,     0,     0,     0,  2089,     0,     0,  1938,
    2372,  2413,     0,  1689,  1689,  1689,  1677,  1687,     0,  1809,
    2214,     0,     0,     0,     0,  2000,     0,  2141,  1698,  2139,
    2232,  2221,     0,     0,  1898,     0,  1793,  2198,     0,  1037,
    1038,  1036,  1562,  1542,  1538,  1537,  2209,  1561,     0,  1676,
    1549,  1550,     0,  1203,  1204,     0,  1208,  2898,  2503,     0,
       0,     0,     0,  1719,  1749,     0,  1740,     0,  2235,  1720,
    2234,  1721,  1724,  1725,  1715,  1750,  1745,  1661,  1660,     0,
    1812,     0,     0,  1613,  1606,  1798,     0,  1755,  1631,  1633,
    1634,     0,  2202,  1230,     0,  1841,  1241,     0,  1225,     0,
    1224,  1841,     0,  1242,     0,  1841,     0,     0,     0,  1399,
    1325,  1375,  1035,  1400,  1326,  1376,  1401,  1327,  1504,     0,
    1506,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   910,  2381,   375,  1515,  1402,
       0,  1328,   371,  1516,  1377,  1520,   930,   929,     0,     0,
    1378,     0,   804,     0,     0,   809,   810,   811,     0,     0,
       0,   812,     0,  2299,  2361,     0,   817,   824,   829,   819,
       0,   830,   825,     0,     0,     0,     0,     0,     0,   836,
     843,     0,     0,     0,     0,     0,     0,     0,  1268,  1270,
    1269,  1255,  1256,  1403,  1331,     0,  1379,  1267,  1266,  1214,
       0,  1332,   210,     0,     0,   309,   323,     0,  2589,     0,
       0,  2725,  2784,  2858,   637,   632,   630,   636,   606,   633,
     398,  2588,   845,   910,   403,   401,   407,  1373,   342,   355,
     350,   351,   349,  2381,   375,   403,  2673,   410,  2381,   375,
       0,     0,     0,     0,   352,   347,   348,   344,   357,  2276,
    2342,  2518,     0,   849,   851,     0,   856,   365,  1346,     0,
     382,   381,   380,     0,   369,     0,   387,   390,   366,   340,
     360,   343,   341,     0,   595,   596,     0,   418,   337,     0,
     403,     0,   321,     0,     0,     0,     0,     0,     0,     0,
    2228,     0,     0,  1294,     0,     0,     0,   199,  1360,   176,
       0,     0,     0,   167,     0,     0,     0,     0,   192,     0,
     192,     0,   159,   161,   175,     0,  1409,  1336,     0,     0,
     313,   750,   758,   763,  1340,   766,  1389,   764,  1416,  1337,
       0,  1371,     0,   304,     0,  1338,     0,  1383,  1411,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1523,
       0,     0,     0,     0,     0,   375,     0,     0,     0,  1373,
    2381,   375,  1410,     0,  1367,     0,  1397,     0,   421,     0,
    1361,     0,     0,   315,  1342,  1391,  1369,  1412,     0,     0,
       0,     0,     0,     0,   146,   147,     0,     0,     0,     0,
       0,   138,   137,   132,     0,     0,   257,   256,   258,     0,
       0,     0,     0,     0,     0,     0,     0,  1079,  1046,  1078,
       0,     0,     0,  1040,   462,   430,   431,   433,   442,     0,
    1823,  1819,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1839,   951,     0,     0,     0,     0,  1502,  1502,  1502,
    1502,  1502,  1502,  1502,  1483,  1513,     0,   156,     0,     0,
       0,   798,   838,   845,     0,     0,     0,     0,     0,   491,
     495,   502,   499,   500,   501,     0,     0,     0,     0,   177,
     157,     0,   993,     0,   550,     0,   222,   215,     0,     0,
       0,   386,   946,   944,   943,   945,     0,     0,     0,   968,
     942,     0,  1813,  1815,     0,   144,     0,     0,     0,     0,
     675,   494,     0,   553,     0,     0,   588,     0,     0,     0,
       0,   386,  2259,     0,   964,   934,     0,     0,  1219,     0,
    1237,  1220,     0,     0,     0,  1274,  1279,  1275,  1247,     0,
     940,   775,  1648,  1649,     0,   375,     0,     0,   840,   375,
     375,     0,   375,     0,   375,   375,     0,  1438,   866,     0,
     918,     0,     0,   375,  1006,  2138,  1131,   552,     0,     0,
       0,     0,  1142,     0,   773,  1147,     0,  1160,  1155,  1157,
       0,  1164,  1627,  1620,  1622,  1621,     0,     0,  1618,  2144,
    1005,     0,   747,     0,     0,   375,     0,  1165,     0,  1089,
    1090,     0,     0,  1099,     0,     0,  1694,  2145,  2146,     0,
       0,  2928,  2182,     0,     0,  2180,     0,     0,  2038,     0,
    2014,  2016,  1840,  2028,     0,  1853,  2039,  2040,  2018,  2020,
       0,  2128,     0,     0,  2029,  1962,  1963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1975,  1974,  2030,  2110,     0,     0,  2167,  2168,  2031,     0,
    1999,  1994,  1883,  1884,  1884,     0,     0,  2174,     0,     0,
       0,  2036,  2045,     0,     0,     0,     0,     0,  2052,     0,
    2073,     0,     0,     0,     0,  2193,  2189,  2041,  2043,  1985,
    2138,  1875,  1876,     0,     0,     0,     0,     0,     0,     0,
       0,  1959,  1942,  1936,     0,  1940,  1944,     0,     0,     0,
       0,  1928,  1954,  1924,     0,     0,  1930,     0,  1955,     0,
       0,     0,  2007,  1689,  1689,  1689,  1689,  1686,     0,     0,
       0,     0,  2503,     0,     0,  1776,  1754,  1756,  1763,  1776,
    1781,  2009,  1807,  2010,     0,  2222,     0,  1729,  1698,  1698,
    1698,  2006,     0,     0,     0,  1697,   233,     0,   266,   253,
       0,  1540,  2225,     0,  1701,     0,  2129,  1208,  1206,  1207,
    1703,  1723,  1722,     0,  1713,  1747,  1711,  1615,     0,  1613,
    1608,     0,  1609,  2202,     0,  1605,  1638,     0,     0,  1812,
       0,  1637,     0,  1841,  1222,  1223,     0,  1246,     0,  1398,
    1324,  1374,  1502,  1175,  1176,     0,  1174,     0,     0,     0,
     538,  1191,     0,     0,     0,   910,     0,     0,   542,     0,
    1518,     0,  1417,  1359,   806,   807,     0,   818,     0,   827,
     826,     0,     0,   814,     0,     0,     0,     0,   813,   832,
     779,   833,   835,     0,     0,   834,   837,   842,  1371,     0,
     873,  1348,     0,  1395,  1249,  1271,     0,  1217,     0,     0,
       0,   637,     0,     0,     0,     0,     0,     0,   606,   631,
     630,     0,   635,     0,     0,   610,     0,   510,   336,   402,
       0,     0,     0,   324,   334,     0,     0,   339,  2673,     0,
       0,   332,   353,   345,   354,   346,   853,   854,   852,   848,
       0,   855,   857,   413,     0,   384,     0,     0,     0,   359,
       0,     0,     0,     0,     0,  1405,     0,  1371,     0,   317,
    1344,     0,  1393,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1406,  1380,     0,     0,     0,   164,
     163,     0,   174,     0,     0,   172,     0,     0,   183,   184,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   422,   377,     0,
     971,     0,     0,     0,   424,     0,  1321,     0,     0,     0,
     148,   152,   151,   153,   150,   149,     0,   140,   141,     0,
       0,  1404,  1333,  1041,     0,     0,  1042,  1050,     0,     0,
    1043,     0,     0,  1052,     0,     0,   429,   439,   910,     0,
       0,     0,  1824,     0,  1892,  1893,  1894,  1895,  1896,  1897,
       0,  1891,  1898,   953,   962,  2446,   957,  2118,  2119,   960,
     954,   956,   959,   961,   958,     0,  1502,  1501,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   524,
       0,     0,   518,     0,     0,  1279,   509,   512,   513,     0,
       0,   799,   802,   800,   801,   831,     0,     0,     0,   531,
       0,     0,   179,     0,     0,   180,   178,     0,     0,   386,
       0,   218,   490,     0,     0,   791,   891,   894,   887,     0,
     967,   969,   939,     0,   845,   131,     0,     0,  1597,   598,
       0,   584,   580,   582,   581,   583,     0,   590,   385,     0,
       0,   675,   590,     0,   963,     0,     0,  1192,  1218,     0,
       0,     0,  1272,  1276,  1273,     0,     0,  1233,     0,  1248,
    1211,  1433,  1434,  1431,  1432,     0,     0,  1640,  1291,     0,
     375,  1289,  1009,     0,  1000,     0,  1002,  1293,   375,   375,
     878,     0,   788,     0,     0,     0,  1141,  1162,     0,  1158,
       0,     0,  1124,  1167,  1625,  1623,   673,     0,  1170,     0,
    1125,  1169,     0,     0,     0,     0,     0,  2149,  1859,     0,
       0,  2184,  2178,     0,  2011,  2150,     0,  2162,  2161,  1961,
    2163,     0,  1980,     0,     0,  1972,  1970,  1971,  1964,  1965,
    1966,  1967,  1968,  1969,  1973,  2172,  2171,  2165,  2166,     0,
    1997,  1879,  1877,     0,  2033,  2034,  2035,  2173,  2046,     0,
       0,  2290,  2074,  2050,  2067,  2066,     0,     0,     0,  2054,
       0,     0,  2063,     0,     0,     0,  2190,     0,  2112,  1865,
    1898,  1904,     0,     0,  1927,  2177,  1945,     0,     0,     0,
    1923,     0,     0,     0,     0,  1932,  2128,     0,     0,     0,
       0,  2092,  2087,  2088,     0,     0,     0,     0,  1680,  1679,
    1685,  1776,  1781,     0,     0,  1663,     0,  1763,     0,  1775,
    1761,  1774,     0,     0,  1787,  1785,     0,  1787,     0,  1787,
       0,  1758,     0,  1777,  1759,  1774,  1806,  1799,     0,  2223,
    1808,     0,  1738,     0,     0,     0,     0,  2142,     0,  2140,
    2001,     0,  2199,  1674,     0,  1702,  1712,  2321,  1810,  1614,
       0,     0,  1611,  1612,     0,     0,  1632,  1613,  1635,  1243,
       0,     0,  1235,     0,  1181,  1182,  1180,  1183,     0,     0,
       0,   910,     0,     0,   561,     0,  1199,  1199,     0,     0,
     544,   593,  1279,   913,     0,     0,     0,   911,   375,  1329,
       0,   828,     0,     0,   823,   821,   820,   822,   780,  1415,
    1330,     0,     0,     0,     0,  1250,     0,     0,  1347,   606,
       0,     0,     0,   619,   622,     0,     0,   615,     0,     0,
       0,     0,   640,     0,     0,   610,   634,     0,   605,   604,
       0,   404,     0,   516,     0,   329,  1372,     0,     0,     0,
     328,     0,   375,   375,   375,   375,   850,   383,   388,   389,
     392,     0,   554,  1202,     0,     0,   415,   653,     0,   606,
     613,   637,   637,   397,   394,  2907,   644,   645,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   994,   977,     0,     0,   995,   996,     0,     0,     0,
    1296,  1297,  1295,   168,     0,   165,   166,   169,     0,   193,
       0,     0,   190,   187,   186,   171,   170,  1357,  1341,  1390,
       0,     0,  1339,     0,  1384,  1354,  1350,     0,     0,     0,
       0,     0,  1414,  1366,  1388,  1413,  1364,  1386,  1363,  1385,
    1365,  1387,  1358,     0,  1817,   974,     0,     0,     0,   375,
     375,   880,  1343,  1392,   135,     0,   134,   136,     0,  1044,
       0,     0,  1045,  1047,   465,     0,   468,   475,   443,   448,
    1522,     0,  1522,     0,   445,   449,  1522,   444,     0,  1522,
       0,  1522,   441,   932,     0,     0,     0,  1820,  1825,  1900,
    1833,   909,     0,  1493,  1492,  1491,  1495,  1494,  1497,  1496,
    1488,  1487,  1500,  1499,  1486,  1485,  1490,  1489,     0,   514,
       0,   522,   526,   527,   525,   517,  1279,   550,   592,     0,
       0,   922,     0,   797,   492,     0,     0,   528,     0,   496,
     182,   181,     0,     0,     0,   222,     0,     0,   896,   900,
     941,     0,  1816,   874,   386,     0,   492,   675,   597,   662,
       0,   497,   503,   504,     0,   588,     0,   584,     0,     0,
     672,  1480,   721,   598,   744,   966,     0,   965,     0,     0,
    1221,  1238,  1239,     0,     0,  1279,  1278,     0,   782,   375,
     841,   375,   375,  1439,   919,     0,  1154,  1153,  1152,   774,
       0,  1156,   674,   375,     0,     0,     0,     0,     0,  1101,
    1080,  1100,     0,  2181,  2027,  2037,  2160,     0,     0,  1981,
       0,     0,  1998,  2032,  2909,     0,     0,  2051,     0,     0,
    2071,  2072,  2053,     0,  2435,  2058,     0,     0,     0,  2044,
       0,  2192,  2188,  2243,  1951,  1949,  1946,     0,  1947,     0,
       0,  1929,  1925,     0,  1931,  1956,  2078,     0,  2094,  2091,
    1684,  1683,  1682,  1681,  1762,  1760,     0,     0,  1765,  1772,
       0,  1757,     0,  1786,  1782,     0,  1783,     0,     0,  1784,
       0,     0,  1772,     0,  1698,     0,     0,  2083,  2004,  2005,
    2002,  1698,  2240,  1898,     0,     0,  1607,  1610,     0,  1639,
    1630,  1236,  1244,  1508,     0,     0,     0,   540,     0,  1279,
       0,     0,     0,  1202,  1202,     0,  1279,   592,   915,   914,
     917,   912,   916,  1519,     0,   815,   816,  1349,     0,  1396,
    1355,     0,  1629,   610,     0,   618,     0,     0,   626,     0,
       0,   399,     0,   626,     0,   643,     0,   642,     0,   406,
       0,     0,     0,     0,   846,     0,   507,   325,   326,   327,
     330,   377,   338,   409,   408,   331,     0,   594,     0,     0,
    1200,   556,     0,   656,   414,     0,   600,   606,   606,     0,
       0,   412,     0,   416,   394,     0,     0,  1345,     0,  1394,
    1352,  1407,  1334,  1381,     0,     0,   983,     0,     0,     0,
       0,  1408,  1335,  1382,   162,   191,     0,     0,     0,     0,
     188,     0,  1629,     0,     0,     0,     0,  1528,     0,   376,
     973,   972,   377,   423,  1368,   142,     0,  1048,  1049,   466,
     156,     0,   440,     0,   473,     0,   471,   470,   472,     0,
     456,     0,     0,     0,     0,     0,   459,     0,     0,     0,
    1821,     0,  1310,  1310,     0,   910,  1498,     0,     0,   511,
     592,   560,     0,   519,     0,     0,     0,     0,     0,   505,
     506,     0,     0,   845,     0,     0,     0,   217,   492,   845,
     895,     0,     0,     0,   970,     0,   494,     0,  1595,     0,
     671,   493,     0,     0,   590,     0,   588,     0,   585,     0,
     589,     0,  1473,   725,     0,   720,   722,   724,     0,   743,
       0,     0,  1277,     0,  1281,     0,  1232,  1209,  1809,     0,
     786,  1311,  1001,  1003,   879,  1159,  1166,   375,  1081,  1082,
    1083,  1084,     0,  1976,     0,     0,     0,     0,  2047,     0,
    2048,  2076,  2075,  2055,  2059,     0,  2056,  2057,  2191,  1948,
    1952,  1950,  1933,  2080,     0,  1698,  1802,     0,  1805,     0,
    1764,     0,     0,  1766,     0,     0,  1768,  1770,     0,     0,
       0,     0,     0,  2226,     0,  2320,  2879,  2897,     0,  1728,
    1730,  1732,  1737,     0,  1664,     0,   267,  2130,  1811,  1636,
    1160,     0,   375,  1199,   592,   562,  2446,   563,  1198,  1205,
    1205,     0,   592,   910,   808,     0,     0,   310,   405,     0,
     620,   617,   625,   624,   628,   623,  1698,  1698,   627,   638,
       0,   641,   629,   603,   609,   844,     0,   515,   379,   391,
     555,  1201,   657,   614,   601,   610,   599,   600,   600,   395,
     396,     0,   417,     0,  1629,     0,     0,     0,   990,   978,
       0,     0,   997,   194,   195,   185,   189,     0,   306,  1351,
       0,     0,     0,     0,     0,   375,  1051,   442,     0,   469,
     478,     0,   476,   446,   451,     0,   455,   453,   452,   447,
     450,   457,   458,  1310,     0,  1307,  1306,   908,     0,   548,
     520,     0,   571,     0,     0,   923,     0,     0,     0,   537,
     536,   533,   532,   534,   535,   530,   529,   870,   987,   386,
    1480,   858,   897,   898,   893,     0,     0,     0,   584,   580,
     660,   498,   510,   598,     0,   590,   586,   587,     0,     0,
       0,     0,     0,   726,  1530,     0,  1193,  1280,     0,     0,
       0,   781,     0,     0,   785,   776,  1126,  2183,  1977,     0,
    1978,     0,     0,     0,  2061,  2060,     0,  2097,  1807,     0,
       0,  1801,     0,     0,  1773,  1789,     0,  1769,  1767,  1778,
       0,  1780,  2001,     0,     0,     0,  1736,     0,  2082,  2084,
       0,  2003,  1177,     0,  1178,  1202,   566,     0,  1208,  1208,
     550,   910,   541,  1356,     0,     0,     0,     0,     0,     0,
     847,     0,   333,   652,   602,   610,   610,     0,     0,   318,
    1353,     0,   981,     0,   992,   990,     0,     0,     0,  1524,
       0,  1525,  1526,  1529,   425,   728,   464,   474,     0,   454,
    1305,  1309,  1308,     0,     0,   521,   557,   558,   559,     0,
     523,   567,   568,     0,   920,     0,   925,     0,     0,     0,
       0,     0,  1474,     0,     0,  1480,   588,   584,   658,   659,
       0,   508,   662,   579,   598,     0,  1477,     0,     0,     0,
       0,   723,   386,     0,  1279,  1282,  1437,   784,   783,  1979,
    2064,  2049,  2077,  2062,  2093,     0,     0,     0,  1800,  1803,
       0,  1771,     0,  1779,     0,     0,     0,  1731,     0,     0,
       0,  1205,     0,   910,     0,  1196,  1195,   560,   543,  1629,
       0,   621,     0,     0,   639,   378,   650,   651,     0,     0,
       0,     0,   988,   991,   979,   992,   999,   998,  1629,     0,
       0,   435,     0,   477,     0,   547,     0,     0,     0,   569,
       0,   570,   591,     0,   924,     0,   845,   986,     0,     0,
     899,     0,  1475,   590,   588,     0,   481,   662,  1478,  1479,
     685,     0,     0,   590,  1194,  1210,  1436,  1435,  1676,  2866,
    2321,     0,     0,  2109,  2098,  2109,  2090,     0,  1788,  1734,
       0,  1733,  2085,  2086,   375,  1208,     0,   545,   564,   571,
     311,   616,   400,     0,  1629,     0,     0,   980,   307,  1527,
     730,     0,   428,     0,   900,   576,     0,   575,     0,   573,
     572,   921,   926,   871,   976,  1480,   903,   598,   590,     0,
     479,   683,     0,  1602,  1604,   695,  1809,  1419,  1676,  1418,
    1420,  1428,  1425,  1427,  1426,  1424,     0,  2102,  2101,  2100,
    2104,  2103,     0,  2095,  2096,  1804,  1735,  1179,  1197,     0,
     910,   393,   319,   982,   989,     0,     0,     0,     0,   574,
     578,   577,  1476,   905,     0,   901,   904,   906,   907,   662,
     598,   665,     0,   684,   685,     0,     0,   714,  1184,     0,
    1429,  1423,  1663,  1650,     0,     0,  2106,     0,  2107,   565,
     546,   729,   434,     0,     0,   881,     0,   482,   662,     0,
     608,   668,   664,   686,   688,   689,     0,   691,   682,  1603,
     704,  1522,  1522,  2366,   705,  1522,  1522,  2363,  1522,   694,
       0,     0,   698,   696,     0,     0,   740,  1421,  1676,  2099,
    2105,  2108,   738,     0,   902,   480,   660,     0,   661,     0,
     667,   669,   687,   690,     0,     0,     0,     0,     0,     0,
       0,     0,   704,  1522,  1522,     0,   705,  1522,  1522,     0,
    1522,   692,   697,   693,     0,     0,     0,   713,   733,  1422,
     736,   737,   727,     0,     0,     0,     0,   649,     0,   606,
     611,   637,   637,     0,   670,   702,   707,     0,   710,   709,
     703,   706,   711,   712,   699,     0,   700,   716,     0,   717,
       0,  1502,     0,   734,   598,     0,   739,   903,     0,     0,
     654,   607,     0,   600,   606,   606,     0,   708,     0,   715,
       0,   719,     0,   730,   676,     0,     0,     0,   655,   612,
     610,   600,   600,     0,   701,   718,   742,   741,   735,     0,
     882,   666,   648,   610,   610,   663,     0,   646,   647,   738,
     732
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4945, -4945, -4945,  3551, -4945,  2762, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945,  -861,    95,  2887, -4945,  -892,
   -4945, -4945, -4945, -4945, -3694, -4945,  1132, -4945,  -418, -4945,
   -4945,  1318, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  3505,
   -4945, -4945,  1735, -2544, -4945, -4945,   158,  3466, -1202,   139,
    3114,  1408, -4945, -1060, -4945, -4945,  -592,   150, -4945,  3508,
     838, -4945, -4945, -4945, -4945, -4945, -4945, -4945, -4945,  -779,
   -2002,  1222,  -662, -3103, -4945, -4945, -1324, -3285, -4945,   552,
    -382, -4945, -2276, -1332, -4945, -4945, -4945,  1834, -4945, -4945,
   -4945,  1040, -4945,   455,  -657, -4945, -4945, -4945, -4945, -4945,
   -4945, -4945,  -422, -4945, -4945,  -816,     2,    45, -2535,  -473,
   -4945, -4945,   393,  -476, -3687, -1213, -4945, -3665, -4945, -4945,
    -103, -4945, -4334, -4945,  -454, -1302,  1347, -4945,  -713, -1071,
    1656, -4945,  -348,  -881, -4945,  -283, -4945,  -961,  -812,  -810,
    -908,  -687, -3870, -4349, -3901, -3707,  1352, -3120, -4369, -4780,
   -4945, -3600, -4945, -4155, -4945, -4203, -3614, -2373, -3544,  -307,
    1208, -2935,   629, -4945, -3700, -3062, -4945, -4110,   587, -4945,
   -1170,  -332, -4945, -4945, -4945, -4945, -1092, -3702, -4945, -4945,
   -4945, -3528,   171, -4945, -3265, -4945, -4945, -4945, -4945, -1029,
   -4945, -4945, -4945, -4945, -1118, -1073, -4945, -4945, -4945, -1172,
   -4945, -4945,  -682, -4945, -4945, -1117, -4945, -4945, -1197, -4945,
   -4945,   181, -4945, -4945,   182,   183, -4945, -4945, -1416, -1356,
   -4945,  -596, -4945, -4945, -4945, -3009, -4945, -4945, -4945, -4945,
      83, -4945, -4945, -4945, -4945,   442, -4945, -4945, -4945, -4945,
   -4945, -4945, -2524,  1807,  1810, -4945, -4945, -3280, -4945,  -863,
   -4945,   619, -3059,  1261, -4945, -4945, -4945,  2860, -4945, -4945,
   -4945, -4945, -4945, -4945, -1496, -4945, -4945,   184, -4945,  1823,
    1029, -4945, -4945, -4945,  -936, -1138, -1026, -4945, -3055, -4945,
   -4945, -4945, -4945,  -394, -4945, -4945, -4945, -4945, -4945, -4945,
   -4945,  -813, -4945,  1089, -3725, -4945, -4945,   408, -4945, -4945,
   -4945, -4945, -4945,  -874,  -322,  2885, -4945,  -733,  -842, -4945,
   -4945, -4945,  -316, -4945, -4945, -4945, -4945, -4945, -4945,  -979,
   11189, -1460, -4945, -4945, -4945, -4945, -2507, -4945, -4945, -4945,
   -2225, -4945,  4429,  2316,  1481,   185, -4945,   -23,    81,  3361,
   -1054, -2724,   377,  -501, -4945, -1647, -4945, -4945, -4945, -2648,
   -4945, -4945, -4945, -4945, -3595,   188, -4945,  3357, -4945,   424,
   -4945, -4627, -4080, -4368, -4607, -3568, -4945, -4945, -1024, -4945,
   -4945, -4945, -1328,  2147, -1229, -4945, -2277,   426,  1440,  -968,
   -2821, -3887,  -646, -3366, -4945, -3807,  -643, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -1020,  -568, -4945, -4945,  3822, -4945,
   -4491, -4945, -4945, -4945, -4945,  1348, -4945, -4945, -4945, -1322,
    1188, -4945, -4945, -4945, -4945, -4945,  -869, -1025, -4945, -4945,
   -4945,   190, -4945, -4945, -4945, -4945,  2091,  -887,  -697,  3688,
     194, -4806, -4945, -4945, -4945, -4945, -3223, -4945, -4945, -4945,
   -4945, -4945, -4945, -4945, -4945,  -947, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945,  2223,  2225,    77,   -22, -4945, -4945, -4945,
   -1171, -4945,  -859,  3411, -4945,  2815, -4945, -4945, -4945, -4945,
    1510,   195,   463, -4945, -4945,  -963,     8, -4945, -4945,   242,
   -3485,    12, -4945, -4945, -4945, -4945, -2257,    13, -4945,   786,
   -4945, -4945, -2861, -4945,   196,    14, -4945, -4945,     1,    71,
     -42,    11,    21,     4,  3690,  3248, -4945, -4945, -4945,     7,
    2044, -4945,  -760,  -148,  -641,  1516,  -566,  2189,  3195,  3258,
   -4945,  1503,  2221, -2093, -2088, -4945, -4945,  -768,  -648, -4945,
    -560,  2201, -4945,  3259, -4945, -4945, -4945,  1494,  1506, -3496,
     865, -3481, -3450,   316,   302, -1325,  -427,    60,  3727,  3270,
     873,  -614, -4945, -4945,  -611, -4681,   821, -4945, -4437, -2433,
    -374,  1929, -1471, -4945, -4945, -1079,  3758, -4945, -4945, -4945,
    8097, 10370, -4945, -4945, 12075, 13667, -4945,  -923,   917, 13824,
    -387, -1111, -1762,  -804, 13026, -2275,   589, -4945, -4945, -2773,
   -4945, -3611, -2706, -4945, -4945, -4945,  -385,   936,  1342, -4945,
   -4945, -4945, -4945, -4945, -4945,  -745, -4945,  -743, -4945, -4945,
   -4945,  -729, -4944,  -817, -1592, -4945,  -168, -4945, 14833,  1554,
   -4945, -1028, -2846, -2816, -3464, -1646, -4945, -4945, -4945, -4945,
   -4945, -4945, -4945, -1835, -3345,  -440,  1628, -4945, -4945,  1729,
   -4945, -4945, -4945, -4945, -4945,   938, -4945, -4945, -1205,  -819,
   -2695,  1635, -2152, -4945,  -796, -4945,   850,  2425,  -751,   207,
   -1204, 13043,  -509, -2412, -1149, -1413, -4945,  -144, -3396,   -21,
       9,   -72,   641,  -639,    -4,  4004,  3060,  -627, -1158,  8195,
   -4945, -4945, -4191,  3365,   549, 10823, -3276
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  2556,  3313,    53,    54,    55,
      56,    57,  3304,  3305,    58,  1325,  2620,  2491,  3232,  3389,
    3390,  3234,  3858,  4392,  3859,  4780,  3855,  4388,  4389,    59,
      60,  1415,    61,    62,    63,    64,    65,    66,    67,  1341,
      68,    69,   983,  1571,  2630,    70,  2335,   776,   777,   778,
    2145,  2146,  2562,  2147,  2135,  1237,  1666,  1366,   751,   752,
    1327,  1367,    72,    73,  1231,  2126,    74,    75,    76,  1397,
    1398,  1335,  1616,  4424,  5172,  3184,  2463,  3428,  3185,  3186,
    4753,  4751,  3789,  2454,  1399,    77,  1465,  1466,    78,    79,
    3337,  1512,  5372,  2589,  3926,  3927,  4462,   597,  2586,  4800,
    4801,  4445,  4446,  4807,  5041,  5042,   689,  1567,  3422,  4021,
    3379,  4530,  3380,  4531,  3381,  3382,  4532,  3365,  3976,  4726,
    3977,  3978,  3383,  4507,  5075,  3384,  2350,  5205,  1091,  1688,
    1686,  4341,  4342,  5062,  4263,  4264,  5273,  5210,  5211,  5212,
    5379,  4537,  3426,  4027,  4540,  4833,  3055,  2464,  4529,  5005,
    5006,  3785,  5508,  4321,  5548,  4348,  4303,  4304,  4305,  4984,
    3135,  3136,  3782,  3780,  3137,  3138,  4313,  4314,  3139,  4358,
    5550,  4350,  5551,  5552,  4351,  4352,  5230,  4860,  5510,  5470,
    5471,  5472,   690,  1593,  3502,    82,   631,  1597,  5240,  5391,
    5443,  5447,  5490,  5491,  5492,  5493,  5496,  5537,  5568,  5569,
    4874,  4875,  4876,  4877,  5301,  5302,  5574,  5575,  5542,  5538,
    5576,   691,  2670,   632,   692,  2632,    86,  2661,  1435,  1436,
    2499,  3949,  3485,    87,  1006,  3749,  4890,  5114,  5115,    88,
     219,    89,  1575,    90,    91,  2616,  3371,    92,  2367,  3072,
      93,    94,  3099,  3100,  3101,    95,    96,  3787,  4723,  1400,
    3172,  3173,  3174,  3175,  3811,    97,  1573,  1441,  2639,    98,
      99,   100,   101,   102,  2545,   103,   104,  2633,  1583,  2651,
    2652,  4519,  4851,  5084,  4853,  5434,  5435,  4825,  3728,  4277,
     106,   107,  4500,  4501,  5217,   108,  2365,   109,   110,   111,
     633,  1551,  2608,  2609,  3950,  2673,  3433,  3434,  4009,  4010,
     112,  3278,   113,  4371,  4372,   634,  5220,  5184,  5294,   114,
     115,  4375,  4376,   116,   117,   118,   119,   120,   683,  1056,
    1057,  1317,   121,  2250,   122,   957,  3328,   123,  1122,  2796,
    4580,   124,   715,  1071,  1072,  2634,   126,   724,  2774,   726,
    1702,  3487,  3488,  4082,  2742,   863,   127,   128,  2754,  2777,
     129,  1328,  2341,  2342,  4258,  2635,   635,  1602,  2676,  3050,
    5105,  4265,  4683,  4741,  2976,  3680,   131,   636,  1371,  2417,
    2679,  3439,  2313,  2314,  2946,  4046,  2316,  3441,  2317,  1311,
    2318,  3446,  3447,  3448,  4042,  4050,  4884,  4885,   132,  1369,
    2415,   133,   134,   135,  1412,   888,   136,   648,   649,   137,
    5055,   138,  1018,   139,   743,  1716,   140,   141,   142,  2434,
    3795,   143,   144,   145,  5399,  5449,  5450,  5451,  4055,  5338,
     146,  5401,  1101,   148,   149,   150,   186,   922,   923,   924,
    2636,  4872,   152,   153,  2612,  3364,  3958,   154,   155,  2336,
    3040,   156,   157,   158,   159,  5514,   160,   161,   162,   163,
    1489,   164,  1266,  1267,   165,   166,   592,  1284,   794,  1270,
    1278,   167,   694,  1062,  1065,  1066,  1067,  1668,   168,  1104,
    2765,   695,  1059,   170,  5392,  5393,   696,  3003,  3691,  3692,
    3695,   697,  3000,   173,  1708,  2759,  2762,   698,  3007,  3008,
    3009,  3010,  3011,  3697,   699,   717,  1009,  2685,   700,  1199,
     178,   179,   180,   803,   798,   799,   182,  2119,  2936,   732,
    1288,   764,   811,  3665,  2268,  2269,  2293,  2294,  1297,  1298,
    2281,  2285,  2286,  2989,  2982,  2274,  4222,  4949,  4950,  4657,
    2289,  2290,  1300,  1301,  1302,  2298,   183,  2939,  3646,  3647,
    3648,  4199,  4200,  4214,  4210,  4644,  4936,  3649,  1099,  1308,
    3650,  4926,  4927,  5131,  4217,  3657,  3689,  3411,  3412,  3413,
    2319,  2595,  1536,  1200,  1537,  2606,  1201,  1752,  1539,  1202,
    1203,  1204,  1542,  1205,  1206,  1207,  1208,  1735,  1800,  1209,
    1210,  1772,  2603,  2604,  1657,  2836,  1212,  3570,  2847,  1213,
    1214,  3652,  1215,  4152,  4607,  4595,  2865,  2866,  2142,  4148,
    3586,  2115,  2926,  4954,  5148,  5149,  3632,  4182,  4628,  4925,
    5257,  5343,  5344,  5413,  1216,  2923,  2108,   890,  1217,  3952,
    2110,  2858,  2948,  2949,  1711,  1733,  2802,  2820,  2821,  2833,
    3543,  2840,  2845,  3566,  3567,  2859,  2892,  1218,  2805,  2806,
    3523,  3526,  1737,  1219,  3595,  3596,  4157,  1220,  1260,  1261,
    1730,  2887,  1273,  1274,   796,  1221,  1222,  1223,  1703,   787,
    4932,  2260,   852,  3209,  2241,   926,   729,  1224,  1225,  1226,
    1227,  1029,  1479,  1030,  1405,   588,   846,   867,  3176,   589,
    2111,  2112,  3140,  3141,   590,   848,  2246
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     718,   176,    80,  1623,   181,   718,   802,  1665,   171,  1092,
    1093,   756,   172,   174,  1097,  1232,  1633,   719,  1685,  1555,
    1012,   586,   719,  1309,   181,   650,  1312,  2349,   640,  1039,
    1658,   812,  1417,   730,   889,  1440,  1487,  3018,  3020,  1051,
    2880,  2996,  2418,   844,   979,  2433,  2743,  1613,  2441,  1470,
     789,  3505,  1627,   864,  1303,  1010,  2247,   630,  2442,  2592,
    2465,  1068,  2467,  1723,  2470,  1774,  2457,  1746,  1747,  3211,
    3819,   177,  3778,  2259,  2427,  2564,  1246,  3333,  3954,  2511,
    4049,  2315,   598,  3397,  3378,  2801,  1762,  2605,  3788,  3755,
    2656,   177,  4339,  3985,   965,  3658,  3659,   693,  1036,  3275,
     682,  2242,   786,   725,  1553,  2966,  3491,  2247,  1558,  4235,
    3806,  4266,  3808,  1562,  2265,   757,  4005,  4722,  1434,   801,
    1568,  4349,  4323,  4260,  1449,  2521,   866,  3660,  2525,  2526,
    1587,  4544,   893,  1475,  4347,  3959,  3960,  3961,  3962,  3963,
    3964,  2315,  1012,   910,   806,  3696,  4032,  1020,  4196,  3134,
      71,  4535,  2714,  4169,  4743,  4019,  3145,  2408,  2242,  4555,
    4719,  4312,  4391,  2426,  3145,  3651,  1565,  2327,  4498,  4213,
    1795,    81,   750,  2838,  4879,  2662,  1585,  1239,  4315,   783,
    3599,    83,    84,    85,   105,   125,  4864,  4684,   130,  2677,
     147,  2991,   814,  3702,   151,   169,   175,   775,  2994,  4211,
    3779,  4714,   815,  1659,  4239,   596,  -156,  5110,  4873,  4682,
    3392,  -156,  1739,  1740,  4940, -2365,  4942,  1368,  1798,  1614,
    1554,  4127, -1841,   646,  1614,  2248,  3651,  5175,  5176,  4308,
    4310, -2405,  3653,  3988,   646,   701,  1554,  1118,  1759,  4040,
   -2434,  2653,  4982,  4707,  5183,  1296,  1510, -2467,  3193, -1874,
    1614,  1299,   813,  1338,  5106,  3503,  4326,  2532,  2776, -2233,
    4129,   792,   646,  2357,  2938,   915,  5455,  2537,  2885,  2813,
     903,   646, -1884,  5506,  5222, -2259,  5571, -2287,  1404, -2260,
    4356,   992,  3836, -2259, -2923,  2902,   701, -2260,  3462,  1480,
    3464, -1874, -2923,  3653, -1869,  5306, -1854, -1881,  1805,  1073,
     646,   646, -1874,   646,  2885, -2116,  3066,  1706,  4545,  1584,
    5425,   646, -2116,  3375,   646,  4969,  4970,  3701,  3547,  1549,
    3524,   809,  1236,  2254,  3988,  1554,  2920,   809,  1554,  3751,
    1003,  1554,  5056,  2921, -2132, -2368,   646,  3492,  3494,  1088,
    5456, -2132,  2927,  1401,   701,  5206,  4976, -1869,   701,  5545,
    5124,  3335,   701,  1842,  3191,  5228,  1339,  1077,   816,  1487,
    5112,  5027,  5158,  5159,  4691,  2814,  1480,  2352,   707,  1052,
    3993, -2432,  3129,  5178,  5201,  1502,  4307,  4307,  4307,  4307,
    1796,  1639,  3053,  1580,   707,  3837,   646,  5238,   708,  2429,
     701,  3041,  2610,   707,  1656,  5406,  1769,  2973,  1634,  4327,
     707, -1884,  2654,  1581,   708,  3547,   873,  2753,  4835,  2123,
    3856,  3768,  2903,   708,   897,  1095,  2904,  5457,   184,  5322,
     708,  2124,  1774,   912,  1420,  2431,  1480,  1012,  4307,  2472,
     707,  3146,  2815,  5144,   701,   817,  3107,  2140,  5255,   591,
    1012,  1746,  1747,  3108,   889,   646,  2132,  1401,   646,  1762,
     708,  2249,   701,  3979,  2905,   918,  1704,  1421,  1805,  1788,
     185,  5207,  1653,  3042,  5256,  4687,  1713,  3857,   701,  3202,
    5239,  1667,  5069,  2571,  3769,  1615,  2141,  2974,  1770,  1724,
    1615,  5473,  2575,  2254,  2125,  4473,  2738,  1506,   707,  4253,
    2744,  1004,  2746,  2816,  1012,  2749,  2817,  2751,   889,  3054,
       3,     4,  4328,  4324,  5140,  4329,  1615,  1015,   708,  1625,
    5499,  5113,  5202,  1842,  5229,  4836,  5546,  5095,  1027,  1805,
    5070,  3994,  1625,  2567,  2929,  2798,  5208,  5579,  5071,  1727,
    2928,   647,  3838,  5125,  2355,  3493,  3495,  1625,   974,  3316,
    3861,  3954,   981,  3192,  2254,   919,  1005,  2133,  4978,  1625,
    1582,  5002,  -467,   991,  4983,  5072,  3752,  1089,  1096,  3545,
    3546,  3336,  5200,  2387,  3561,  3839,  2392,  3663,   916,  5307,
    2507,  3375,  2509,  4223,  1842,  1546,  3756,  2906,  2516,  5432,
    5608, -2432,  5553,  2886,   993,  3067,  3776,  2818,  1535,   920,
    1096,  2247,  2432,  2538,  3840,  1739,  1740,  2804,  1411,  2563,
    5572,  2587,  2588,   958,  1759,  1625,  1324,  4344,  1096,   793,
    2533,  3605,  3606,  2731,  1012,  2655,  5334,  3698,  1340,  3619,
    4349, -2116,  1012,  1012,  4041,  -731,  1263,  5073,  1264,  2479,
    3129,  2674,   818,  4347,  1525,  2443,  3777,  3721,  1734,   921,
    1707, -2995,  2922,  1258,  4742,  4692,   802,  1259,  2136,  2130,
   -2132,  1707,  1127,  2148,  2148,  3547,  1011,   650,  2134,  2883,
    5458,  2456,  1799,    48,  5355,  3194,  1304,  4866,  1550,  3195,
    4270,  1069,  1053,  1769,  1655,  2718,   956,  4130, -2333,  1625,
    1734,   718,  2838,   718,  3103,   718,  2819,  4705,  4706,  4830,
    4774,   718,  1084,  1085, -2350,  -156,  -156,  4312,  1070,  4703,
    1075,  2797,  1079,  2800,  4617,  4081,  4641, -2432,  1083,  4299,
    4645,  4213,  2739,  2808,  4514,  5448,  1546,  2812,  3980,  1745,
   -2365,  2750, -2432,  2414,  5232,  2824,  2825,  3932,  3081,  1710,
    1086,  1060,  5362,  4472,  4523,  4980, -2405,  2299,  2842,  2844,
    3704,  4634,  3705,  2300,  1102, -2434, -1874,   869,  4887,  4746,
    2860,  2394, -2467,   869,  1258,  1770, -2233,  3954,  1259,   801,
    2873,  2402,  4670,  4586,   869,  1064,  4543,  1119,  4873,  1771,
     713,   714, -2259,  4720,  1229,   889, -2260,  1238,  1011,  1240,
    1550, -2923, -2287, -2994,  1491,  2107, -2474,  5271, -1874, -2433,
    1507, -1869,  1098,  1751, -1881,  1497,  5074,  1801,  2121,   925,
    2953,  2722,  1769,  5600,   959,  3559,   176,    80,  4710,   181,
    2724,  4712,  3913,   171,   814,  3916,  3917,   172,   174,  3920,
    2356,  5613,  5614,  5347,   815,  3923,  4799,  2497,   713,   714,
    2500,  2501,  1402,  1403,  2828,  2829,   713,   714,  3549,  2592,
   -2368,  5375,  3317,  3862,  3776,  2486,  3547,  4229,  3756,  1098,
    5173,  3771,  4001,   718,  2665,  1486,  1599,  2137,  3189,  1603,
    3025,  3109,  3001,  1248,  3110,  5327, -2230,  1338,  3651,  1265,
    1268,  3651,  4964,  4463,   813,  4408,   177,  5323,  1307,  4972,
    5169,  2667,  2668,  5155,  1770,  4251,  2596,  2991,  4354,  3556,
    3557,  3558,  3559,  3683,  3777,  4023,  2740,   861,  1773,  4528,
    3550,  5336,  2572,  5474,   876,  4307,  4307,  1484,  1607,  5475,
     970,  2431,  3918,  3919,  2444,  4307,  3180,  1024,  2247,  2770,
    1342,  4307,  1345,  1546,  2755,  1235,  2445,  2403,  4494,  1243,
    1495,  3306,   641,  5476,  1614,  3653,  1402,  1403,  3653,  4525,
    2102,  2103,  2104,  2105,  2106,  2107,  2747,  2748,   646,  3651,
    1109,  2688,  4080,  2597,  2343,    71,  2665,  3079,  3053,  1608,
    2272,  2694,  3298,  5093,  2647,  2698,  3181,  2623,  3129,  2628,
    1339,  2704,  2705,  1233,  1796,  5388,    81,  2446,     3,     4,
    4973,  5030,  4345,  1546,  2436,  2695,    83,    84,    85,   105,
     125,  2717,  1256,   130, -1724,   147,  2706,  3547,  4242,   151,
     169,   175,  1326,  2104,  2105,  2106,  2107,  4867,  2713,   203,
    2484,  4999,  2404,  1285,  2598,  3375,  3653,  2599,  5439,  4868,
    5286,  5287,  4051,  5540,  1546,  4928,  2345, -1032,  5376,  3549,
    4409,   593,  3111,  2596,  1068,  2437,   686,  2483,   750,  1444,
     731,  2648,  2756,  2629,  2346,  4349,   718,  4558,   737,  1609,
    1292,  4344,  2273,  3182,  4081,    14, -1032,  2431,  4347,  5004,
    2539,  1485,  1625,  1011,  2703,  5337,   181,  4495,  3104,  4266,
    2624,  5468,  2485,  1249,  3129,  3724,  1011,  3951,  2432,  3419,
    3241,    38,  1408,  2968,  5025,  3017,  1671,    19,  1673,  1606,
    1675,  2970,  1677,  2971,  1679,  1680,  1681,  5377,  1454,  4052,
    2597,  1683,  1610,  3022,  4991,  1546,  2666,  1550,  2600,  1709,
    2690,    42,  1258,  3299,  3300,  3301,  1259,  3112,  2568,  1294,
    5378,  3368,  2429,  5060,  2429,  1127,  2741,  4906,  3547,   646,
    1011,  2519,  3934,   177, -2995, -2995,  1455,  3554,  3555,  3556,
    3557,  3558,  3559,  1546,  2456,  4162,  4933,  5007,  5008,    46,
    1372,  4937,  3675,   862,  4939,  3207,   802,  4930,  2431,   869,
    2431,  2598,    47,   869,  2599,   686,   971,  4047,  1546,  5541,
    2242,  3306,  1127,  1025,   869,  3547,  2347,  4869,  1561,  3032,
   -2995,  2613,  3776,  1611,    14,   642,  1496,  1605,  2514,  4049,
    1615,  4526,  3668,  3935,  5234,  2831,   869,  3183,  2429,  1250,
    1732,  2469,  1591,  1594,  1595,  5594,  4677,  2601,  4848,  1797,
    3126,  2408,   869,  3080,  1114,   646,    19,   869,  5226,  1802,
    1749,  5244,  2757,   718,  2432,  2649,   646,   869,   718,   718,
    1316,  1546,  3777,  2122,  2431,   643,  4053,   869,  2650,  4855,
    2758,  1766,  2838,  2838,  2689,   889,  2431,  2838,  2253,    30,
    1011,  1777,  3416,  2138,  2139,  2600,  4086,  5156,  1011,  1011,
    3002,   738,  4858,  4724,  3094,  5161,   644,    38,   645,  1793,
    4266,  3309,  2348,  4110,  2540,    38,  4115,  4116,  4117,  4118,
    4119,  4120,  4121,  4122,  4123,  4124,  3369,  2600,  3776,  4747,
    4748,  5291,  1456,  3310,  2838,  2838,  4054,    42,  3187,  2266,
    2267,  1233,  2271,  2431,  3311,    42,  2511,  3312,  4307,   815,
     815,  3549,   815,  4307,  3302,  3303,  2453,   762,   869,  5174,
    5004,  5004,  4307,  3965,  1233,  2432,   718,  2432,  3554,  3555,
    3556,  3557,  3558,  3559,  2431,    46,   718,  2431,  3777,  5408,
    3095,  1576, -1841,    46,  4171,  4172,  3023,   687,    47,  3024,
    3440,  5292,  3094,  2735,  2601,  5580,    47,  5324,  3549,   813,
     813,  2431,   813,  1286,  3370,  1307,  5153,  3968,  2432,  3327,
    3096,  5430,  4654,  3550,   899,  5031,  4312,  3937,    30,  1577,
    1457,  1084,  1085,  5603,  4669,   879,   880,   881,  5598,   882,
     883,   884,   885,   886,   887,  1022,  2546,  4087,  4373,   900,
    2361,  2432,   718,  3097,    38,   718,   718,  4229,  4439,  4368,
    2362,   763,  4661,  2432,  4442,  4443, -1841,  2520,  1546,  3206,
    3550,  3094,  5387,  4528,  2385,  1641,  4345,  5231,  3095,  3651,
    2343,  2881,  5396,  3651,    42,  2357,  2602,  5335,  3790,   646,
    4573,  5119,  5137,  2315,  3160,  5612,    48,  2344,  2515,  2315,
    4346,   739,  2429,  3266,   688,  3849,  3366,  1287,  5617,  5618,
    3954,  1459,  2152,  1642,   889,   869,  4579,  1460,  2687,  5409,
    2432,  2600,    46,  2429,   761,   807,  5032,   718,  2693,  3554,
    3555,  3556,  3557,  3558,  3559,    47,  3267,  5440,  2431,  2262,
    2264,  3098,  3307,  3868,  3308,  3161,  3653,  3095,  2627,  4374,
    3653,  2432,  2345,  4828,  2432,  2506,  2518,  5522,  3972,  2431,
    4369,  3309,  5431,  2302,  2546,  3268,  1127,  -838,  4928,  3547,
    2346,  2590,  2736,  4334,  2576,  1023,  3351,   784,  2432,   740,
    5326,  5523,   646,  3310,   808,  1578,  1329,  3482,  4476,  2578,
    3951,   646,   869,   918,  3311,  3973,  2995,  3312,  4248,   864,
    5524,  2737,  5181,  2696,  2363,  3703,  5186,  5187,  3496,  3974,
    4254,  3025,  2551,  5077,  1461,  1326,  1292,  3744,  1326,  5081,
    5525,  2358, -1841,  2631,  3866,  1386,  2546,  2579,  2968,  3098,
    4522,  2637,  2422,    48,  2577,  5526,   869,  2364,  2961,  2447,
    5275,  5276,   795,  3770,  4307,   889,  3864,  2351,  1127,  3233,
    4370,  3547,   869,   869,   809,  3745,  3551,  3552,  3553,   804,
    3554,  3555,  3556,  3557,  3558,  3559,   869,  1326,  4163,  1643,
    3898,  1326,  3791,  1579,  2352,  5390,  2493,  3497,  4998,  2496,
    5098,  4478,  4266,   919,  1589,  1294,   805,  3867,  5099,  1330,
    4480,  3975,  2669,  3125,   869,  1292,  3190,  3792,  3098,  2359,
    1293,  4561,  2347,  4562,   869,  2432,  3233,  3554,  3555,  3556,
    3557,  3558,  3559,  2625,   181,  2531,  5527,   869,   856,  3459,
     869,  1127,   918,   181,  3547,  1295,  2432,   920,   819,  2550,
    4359,  3548,  2657,  3465,  2725,  1414,  2726,  1550,  2727,  5035,
    2728,  4619,  2729,  4491,  1651,  2502,  2730,  2566,  4204,  2773,
    1769,  5516,  3549,  3583,  3162,   741,   742,  1644,  4108,  5528,
    3591,  1462,  1249,  2769,  1294,  3269,   181,  3240,  3460,  3455,
    2766,   810,  2810,  2811,  2767,  2768,  4205,   921,  3338,  4255,
    2823,   177,  4128,  2580,  2826,  2827,  2429,  5467,  1064,  3253,
     177,  4647,   854,  4360,  1463,  2430,   609,  4291,  2348,  5517,
    2850,  1769,  2851,  4207,  1295,  3163,  3951,  3260,  4256,  2822,
    2353,  3746,   919,  3261,  3550,  1414,  5505,  2760,  4361,  2846,
    5058,  3293,  2431,  1464,  1245,  3520,   609,  4257,  2878,  3157,
    2879,  3122,  1770,   177,  3549,  2315,  1331,  5418,  4492,  1805,
     869,  3671,  3767,  5100,  5221,  2315,  1771,  2660,   869,   869,
      33, -1841,  2772,  3197,   611,  2671,   920,  5549,  2244,  3085,
    5566,  2795, -1841,  1416,  1745, -1841,  1316,  -198, -1841,  1332,
    5547,  2581,  2503,  3783,  3037,  2488,  3577,  2504,   594,  3402,
    3403,  3404,  3405,  1770,   611,  4688,  4077,   860,  1250,   177,
    3716,  3410,  -198,   609,  1842,  3415,  3550,  1773,  1333,  3747,
    4897,  4493,   786,  1114,  1805,  4209,   921,  3549,  2429,  5529,
    3262,  3435,  3608,  3651,  4986,  2244,  4987,  2438,  3450,  3651,
    4695,  4696,  3784,  4097,  3651,  5530,  4841,  3651,  4049,  2254,
    5111,   874,  5549,  -490,  2288,  2511,  4349,  4614,  4615,   905,
    2559,  2315,  2275,  1469,  2439,  5547,  5004,  -198,  4689,  4347,
    1795,   611,  2560,  3242,  1233,  1233,  1334,  3651,  -746,  1842,
    2337,  3245,   184,  3247,  5004,  5004,  1324,  4842,  5162,  3550,
    2338,  2771,  -198,  1546,  5531,  4203,  2561,  1546,  1546,  3869,
    3653,   758,  2276,  4797,  4798,  2339,  3653,  5170,  1386,  2432,
    2275,  3653,   875,  5511,  3653,   618,  3351,   619,  1437,  5583,
    4960,  1258,  4962, -2233,   185,  1259,  2838,  5333,  3431,  2838,
    2838,  2838,  2838,  2838,  2838,  2838,  2838,  2838,  2838,  4838,
    1566,  4847,  2891,  4528,  3653,   618,  4071,   619,  3217,  4273,
    2276,  1438,  5554,  3727,  5601,  5602,  -490,  4812,  2893,  4273,
    2894,  4857,  4813,  2838,  4204,   917,  1324,  3551,  3552,  3553,
    1566,  3554,  3555,  3556,  3557,  3558,  3559,  3263,  3610,  4588,
    3611,  4589, -1663,  2895,  3965,   184,  3375,   869,  2557,  1423,
    3966,  5203,  4205,   972, -1663,   973,  2278,  2838,  2838, -1663,
    3458,  3967,  2277,  3612,    38,  4814,  5383,  4206,  1241,  3270,
    3264,  1546,   618,  4111,   619,  4112,  3467,  3468,    38,  4207,
    3470,  2558,  3376,  4274,  3142,  1012,  3474,   185,  3968,  2128,
    3969,  2440,  3272,  4274,    42,  3743,  1424,   624,  3271,  3265,
    5082, -1663,  2340,   960,  2278,  4208,  1439,  2279,    42,  3551,
    3552,  3553,   602,  3554,  3555,  3556,  3557,  3558,  3559,  1012,
    3451,  3273,  4821, -1663,  4934,  3817,   220,  4448,  5083,  2244,
    4024,   595,    46,  4028,  5248,  3735,  5278,  1321,  3651,   684,
    3818,  4275,  2896,  4276,  4528,  3507,    46,  2897,   707,   869,
    4822,  4275,  2898,  4276,  3473,  2279,   759,  2473,  1648,    47,
    5397,    27,   701, -1663,  3970,   869,   962,  3613,   708,  4449,
    1322, -1663,  3614,  4590,    33,  1425,  2954,  2502,  1649,  3484,
    3407,  4209,  3551,  3552,  3553,  3408,  3554,  3555,  3556,  3557,
    3558,  3559,   609,  4450,  5300,  3651, -1697,  4113,  1313,  1323,
    3287, -1697,   964,   869,   869,  3653,  1460,  4114,  4451,   967,
    4470, -1186,  4452,  1318,   869,  1074,  1076,  1078,  3664,  -731,
    1080,  1081,  1082,  1426,  3971,  2610,   869,   869,  1427,  3972,
    1087,  1314,  4453,  1258,   980,  4454,  1546,  1259,  2510,   889,
     869,  1418,    38,    48,  4410,   987,  1319,  4455,  5357,  3342,
     611,  2321,   998,  1805,  3073,  4935,  1467,    48,  1471,  2448,
    1315,   864,  3653,  -745,  4411, -1697,  3973,  1429,  3757,  3833,
     999,  2899,    42,  1324,  3681,  1320,  2458,  1001,  2254,   701,
    3974,  2900,  3029,  2489,  2322,  3666,  2492,  3033, -1663,  3954,
    3036,  3615,  2990,  2990,  3398,  3517,  1804,  4528,    27,  1805,
    2721,  3616,  3834,  1461,  2503, -1697,  1431,  4076,  1842,  2504,
      46,  1450,  3059,  2323,  3794,  1546,   975,  3518,   976,  5036,
    4288,  1546,  3519,    47,  2254,  2459,   994,  2460,  4456,  1127,
    1825,  3835,  3547,  3004,  1000,  2542,  4457,  4458,   994,  2549,
    4426,  1433,  4903,  4271,  1451,  3043,  3955,  3046,  1452,  4620,
    4528,  3408,  2461,  3760,  1842,  2937,   995,  3113,  1012,  1268,
    4427,  4979,  3975,  1002,  2951,  4006,  4985,   716,   995,  3625,
    1017,  4459,   716,  1453,  4920,  4921,  4016,  3121,  5592,    38,
    4898,  4899,  4900,  4901,  2837,   996,  3651,  3708,  1021,  2148,
    2508,   618,  1745,   619,  2328,  5460,  2244,  4003,  1031,  2863,
    2462,   646,   621,   177,  1032,   701,  2838,  1546,  1037,    42,
    3177,  1258,  1054,   623,  1279,  1259,  1566,  3607,  1046,  1660,
    3499,  5398,  1661,  2456,  2798,  3730,  1058,  2458,  4613,   997,
    1094,  2251,  3713,  3714,  2252,  4250,  1917,  1918,  1757,  1758,
    1745,   997,  2328,  3576,  1240,  3578,  3579,    46,  3218, -2540,
    1061,  2256,  3236,  3653,  2257,  2720,  3829, -2995,  2721,  4144,
      47,  1901,  5078,  1105,  2732,  2734,  4292,  2733,  2733,  2763,
    3248,  4203,  2764,   701,  1012,  4977,  2459,  1090,  2460,  3102,
    4089,  3258,  1917,  1918,  4528,  1950,  1717,  1718,  2962,  3951,
    2965,  3219,  4131,  4132,  3282,  2992,  2993,  4325,  4330, -2995,
    3651,  2967,  3896,  2461,  2968,  3290,  1106,  2315,   718,  3734,
    1100,  3119,  3297,  3356,  3120,  3549,   718,  4093,   718,  5584,
    5585,  4460,  3797,  1111,  3907,  3908,  2798,  3801,  1731,  1804,
      48,  1950,  1805, -2540,  1233,  4362,  3981,  4461,  2522,  3213,
    4204,  1103,  3214,  3352,  2255,  3476,  3353,  1112,  2733,  3516,
    3528,  2462,  2721,  2721,  1745,  5028,  1316,  2254,    48, -1430,
    1113, -1430,  3357,  1825,  3220,  1114,  3532,  3653,  4205,  2721,
    4092,  3936,  3938,  3939,  2456,  2458,  5354,  3550,  3678,  3679,
   -2540,  1670,  4137,  4206,  1672,  1117,  1674,  1842,  1676,  1115,
    1678,  2552, -2540,  3536,  1682,  4207,  2721, -2540, -1719, -1719,
    2838,  2838, -2540,  3537,  1116,  3563,  2721, -2540,  2721,  3221,
   -2540,  3350, -2540,  3582,  3222,  3329,  2721,  3852,  2683,  1121,
    2684,  4208, -2995,  3329,  2459,  1120,  2460,  3588,  2458,  3597,
    3589,  3809,  2721,  4015,  3810,  1127,  5107,  3815,  3547, -2540,
    3816,  3358,  3359,  3887,  4034,  4038,  1244,  4035,  4039,  3894,
    4098,  2461,  1123,  2721,  3351,  3360,  1745,  1546,  2328,  5118,
    1546, -2540,  1546, -1723, -1723,  3508,  3223,  1546,  1247,  4138,
    4149,  3511,  4139,  4150,  3633,  4165,  3634,  2459,  2721,  2460,
    3401,  4240,  4268,  4269,  4241,  3168,  4244,  1252,  3187,  4245,
    4340, -1722, -1722,  4249,  1901,  3420,  3024,  4209,  3424,  2462,
    3425, -2540,  1251,  3399,  2461,  3361,  3635,  1253,  3636, -2540,
    3489,  3999,  4608,  3205,  3436,  1917,  1918,  1546,  1257,  1269,
   -2540,  1011,  2456,  1276,  4272,  4524,  4390,  2733,  2733,  4618,
    3736,  4672,  2764,  3489,  3024,  2102,  2103,  2104,  2105,  2106,
    2107,  3440,  4679,  4685,  4686,  4680,  2733,  2733,  4533,  4465,
    4708,  4466,  2462,  4709,   718,  1011,  3105, -2540,  2779,  4711,
    1277,  3224,  4709,  1546,  1950,   177,  4749,  4713,  4750,   889,
    4709,  1012,  5497,  1012,  5498,  2456,  3992,  2255,  3995,  1279,
    1280,  2102,  2103,  2104,  2105,  2106,  2107,  5179,  4715,  1290,
    1305,  4716,  3362,  2458,  3363,  4717,  4737,  4447,  4718,  4738,
    4744,  4775,   731,  4745,  4776,  2780,  3982,  1306,  3984,  1487,
    3551,  3552,  3553,  1310,  3554,  3555,  3556,  3557,  3558,  3559,
    1316,  3549,  4802,  4058,  3654,  4803, -2540,  4061,  4062,  1337,
    4064,  4861,  4066,  4067,  4862,  2781,  4908,  3676,  1343,  4909,
    2315,  4072,  2459,  1370,  2460,  4910,  1012,  1279,  2721, -1651,
   -2540,  4919, -2540, -2540,  2764,  1546,  2782,  1546,  1374,  4989,
    4992,  3394,  4718,  4709,  3225,  1375,  4219,  2783,  3841,  2461,
    3843,  4994,  3226,  4090,  4745,  3227,  4995,  1411,   802,  4996,
   -2540,  4044,  1289,  3550,  1291,  3654,  5079,  2784,  1346,  2733,
    1414,  1413,  2785,  2983,  4088,  5108,  1419,  1422,  5109,  4566,
    4567,  4568,  5120,   869,  1445,  2764,  5128,  2244,   869,  5129,
    5134,   869,  4646,  2968,  4649,  3228,  1458,  2462,  3229,  1546,
    5139,  1347, -2540,  4013,  5141,  1446,  1468,  4013,  4224,  4225,
    4226,  4956,  3888,   869,  5197,  1472,  5233,  5198,  2786,  2127,
    2456,  1476,  5242,  3230,  5249,  5243,  4094,  2764,  5250, -2540,
    1477,  3589, -2540, -2540, -2540,  1482,  1483,  5251,  3231,  2787,
    2721,  1488,  3667,  1546,   718,  5261,  5263,  1490,  2968,  4013,
    3638,  3639,  3640,  1348,  1492, -1663,  3914,  1349,   869,  5284,
    5290,  1494,  4718,  2764,  3709,  1498,  1499, -1663,  3682,  3682,
     802,  1793, -1663,  5296,  1011,  1504,  2764,  1546,   869,   869,
    2769,  4319,  1508,   181,  1513,  2891,  1511,  2766,  1324,  1350,
    5297,  2767,  2768,  2764,  2102,  2103,  2104,  2105,  2106,  2107,
    5314,  1554,   203,  5315,  3628,  2838,  3732,  1557,  1559,  5348,
    2244,   869,  2968,  1550, -1663,  2244,  2838,  5349,  5351,  3645,
    2721,  2721,  3965,  5415,  2247,  1351,  4013,  5416,  3966,  2788,
    5147,  5441,  5360,  1569,  2733,  2789, -1663,  2838,  2838,  3967,
    5444,  2790,  5465,  5445,  4431,  5466,  1546,  2798,  1570,   869,
     177,  5368,  5533,   869,  -219,  5534,  1352, -1662,  1353,  3142,
    1804,  5581,  5589,  1805,  5582,  5590,  3968,  1546,  3969, -1662,
    2791,   869,  2792,  1572, -1662,  1574, -1663,  1586,  3208,  1546,
    3645,  1590,   869,   801, -1663,  1596,  1354,  4725,  2254,  2793,
    1011,  1598,  4059,  3865,  1825,   869,  3551,  3552,  3553,  3870,
    3554,  3555,  3556,  3557,  3558,  3559,   869,  5604,  1601,  3219,
    2733,  4592,  1612,   869,  2794,  2458, -1662,  5422,  1842,  1355,
    1617,  4596,  1619,    33,  1620,  3385,  5610,  1356,  5611,  5466,
    2458,  2733,  5615,  1357,  2867,  4745,  2458,  2870, -1662,  1618,
    1358,  3825,  3970,  1621,  1622,  1624,  1625,  1632,  1359,  3637,
    1546,  1635,  1637,  3844,  1636,  1638,  1640,  1360,  1645,  1646,
    1647,  1654,   996,  4103,  2459,  1361,  2460,  1712,  1684,  1719,
    1546,  1728,  1715,  2244,  1721,  1722,  1729, -1845, -1662,  2459,
   -1852,  2460,  3220,  4109,  5053,  2459, -1662,  2460,  1738,  1741,
    1742,  2461,  1743,  1744,  3812, -1842,  3676,  1748,  1546, -1843,
      48, -1663,  3971, -1846,  1750,  1753,  2461,  3972,  1754,  1755,
     807,  4133,  2461,  4784,  4785,  1756,  4787,  1362, -1844,  2114,
    1761,  1897, -1698,  2116,  1763,  1901,  1764, -1698,  1765,  1766,
    1767,  1768,  3222,  1775,  1776,  1778,  1779,  2118,  1780,  2462,
    1546,   869,  1363,  3850,  3973,  4556,  1917,  1918,  1781,  1782,
    1783,  1784,  3911,  1710,  2462,  1785,  1786,  1787,  3974,  1788,
    2462,  1789,  2456,  1926,  2131,  2143,  2151,  2120,  3951,   808,
    2127,  1364,  2261,  1293,  2295,   869,  2305,  2456,  2324,  3386,
    1295,  2297,  3899,  2456,  3223,  1365,  2325,   718,   718,   718,
     718, -1698,   718,  2326,  2328,  1950,  2329,  3890,  2330,  2331,
    2332,  2333,  2354, -1662,  3900,  3901,  3902,  3903,  2255,  3905,
    4293,   869,  2360,  4363,  2366,  2389,  2393,  2395,  2397,  2458,
    4434,  3904,  2838,  4436,  4437,  2396,  2398,  2401,  2399,  1546,
    2400, -1698,  3931,  3933,   869,  4883,  2409,  3940,  3329,   809,
    3975,  3329,  3329,   718,  2410,  3329,  2411,  2458,  2419,   864,
    2458,  3329,  2420,  2421,  2435,  2448,  2451,  2449,  2455,  2456,
    2452,  2466,  2471,  2474,  4510,  4511,  2468,  2476,  2459,  2475,
    2460,  2487,  2480,  3953,  2481,  2490,  2498,  3996,  2505,  3224,
    2494,  1386,  2534,  2535,  2495,  2541,  2012,  1011,  2517,  1011,
    2555,  2569,  2512,  2513,  2582,  2461,  2459,  4806,  2460,  2459,
    2523,  2460,  2524,  2536,  2547,  2584,  2553,  2554,  4560,  2631,
    2546,  2585,  2570,  2591,  1745,  1751,  4563,  4564,  3387,  2593,
    2244,  2594,  2611,  2461,  4079,  2614,  2461,  2244,  4011,  1734,
    2615,   604,  2618,  2837,  2837,  2622,  2619,  2626,  2837,  2641,
    1546,  4031,  1439,  2462,  4091,  2646,  2663,  2664,  2675,  2672,
    2678,  2658,  4845,  2680,  2682,  2697,   810,  3388,  1312,  2699,
    2686,  4043,  1011,  2700,  2745,  4057,  2456,  2701,  2702,  2715,
    2716,  2462,  2752,  2761,  2462,  2775,  2803,  2804,  2848,  2809,
    2849,  2861,  3225,  2868,  1805,  2837,  2837,  2877,  2876,  2884,
    3226,  4179,  4569,  3227,  2456,  2909,  2872,  2456,  2924,  2925,
    2938,   718,  2890,  2907,  2952,  2955,  2959,  3654,  2956,  2960,
    3654,   177,  2972,  4809,   869,  4811,  2969,  2984,  2985,  4815,
    2986,  3013,  4817,  2999,  4819,   808,  3014,  3026,  3027,  3039,
    3028,  3049,  3044,  3228,  3051,   177,  3229,  3058,  2987,  3016,
    3047,  2099,  2100,  2101,  3063,  2102,  2103,  2104,  2105,  2106,
    2107,  3052,  3068,  3074,  3078,  3082,  3069,  3090,  3093,  3106,
    3071,  3230,  3115,  1241,  1245,  3117,  3118,  3127,  3144,  3155,
    4533,  3179,  3199,  3196,  3200,  3201,  3231,  3204,  3212,  3216,
    3203,  3215,  3235,  3274,  3285,   869,  3277,  3289,  3654,  3314,
    3319,  3986,  3318,  3315,  3989,   802,  3320,  3322,  3323,  3326,
     869,   869,  3332,  3334,  3324,  3325,  3340,  3345,  3343,  3346,
    3998,  3344,   802,  3347,  3348,  3349,  3354,  3374,  3391,  3406,
    1546,  3393,  4160,  3409,  4007,  3400,  4693,   869,  4390,  3418,
     869,  3414,  4795,  4512,  3430,  4017,  3417,  3437,  4306,  4309,
    4306,  4306,  3427,  3429,  3449,  3452,  4030,  3453,  3454,  3456,
    4184,  4185,  4186,  4187,  4037,  4447,  1546,  3457,  3472,  3676,
    3466,  3469,  1546,  3478,  3479,  3471,  2968,  4701,  3480,  1655,
    3481,  3490,  3483,  2776,  3498,  3501,  4664,  3504,  3506,  1096,
    4732,  4733,  4734,  4735,  3509,  3510,  3512,  3514,  3513,  5177,
    4306,  4289,  2721,  3534,  3572,  3609,  3585,  3604,  3569,  3631,
    3662,  3617,  4839,  4840,  3530,  3531,  3533,  3535,  1793, -1232,
    3538,  3624,  3539,  3541,  3656, -1725,  3684,  3688,  3694,  3706,
    3690,  1233,  4191,  3685,  3712,  4195,  3544,  3726,  2244,  2244,
    2244,  3562,  3729,  3715,  3717,  3568,  3627,  5133,  3718,  3571,
    3731,  3753,  3573,  3574,  3700,  3581,  3602,  5133,  3603,  3629,
    3630,  3738,  5046,  5048,  3764,  5040,  3661,  3754,  3722,  3723,
    3765,  3766,   869,  3129,  3786,  3772,  3773,  3796,  3774,  3775,
    3799,  4781,  3813,  3800,   869,  3781,  1546,  4793,  4794,  3820,
    3814,  3821,  2461,  3822,  3846,   869,  3847,  3873,  3824,  3854,
    3848,  1546,  3851,  3853,  4831,  3863,  3871,  3872,  3874,  3875,
    3889,  3876,  3877,  3878,  1710,  3879,   718,  3880,  3893,  3882,
    3881,  3884,  3883,  3886,  4412,  3885,  3891,  4415,  3895,  2532,
    3915,  3921,  3922,  3925,  3906,  3929,  2600,  3930,  3941,  3909,
    1012,  3956,  3910,  3988,  3997,   718,  3953,  4000,  4002,  4004,
    5193,  4025,  4029,  3957,  4026,  4056,  4393,  4073,  4063,  4065,
    4074,  4036,  4383,  4033,  4075,  4188,  4189,  4190,  4083,  4084,
    3942,  4808,  3990,  4085,  4012,  4020,  3991,  4385,  4013,  4022,
    4386,  4078,  4387,   869,  4096,  3676,  4394,  4102,  4099,  1731,
    4100,  3565,  4959,  3547,  3564,  4134,  4155,  4135,  4136,  4143,
    4883,  5122,  4151,  1798,  4167,   718,  4176,  4168,   718,   718,
     809,  4193,  4180,  1546,  4944,  4202,  4216,  4891,  4221,  4892,
    4893,  4955,  2244,  4236,  4194,  4218,  4694,  4230,  4464,  4252,
    4231,  4896,  4997,  4233,  4259,  4280,  4282,   869,  4234,   869,
    1795,  4283,  4294,  4295,  3329,  4296,  1084,  1085,  4515,  4297,
    3329,  3329,  5262,  2590,   869,  4317,   869,  4474,  4333,  5037,
    4364,  4320,  4331,  4322,  1546,  4365,  4366,  4367,  4377,  4379,
    4378,  4380,  4384,  3857,  4400,  4401,  5363,  4731,  4381,  4382,
    4407,  4423,  4425,  4326,  4428,  4438,  4488,  4475,  4477,  4479,
    4481,  4435,  4440,  4441,  5199,  4496,  4469,  4048,  4499,  4508,
    4467,  4505,  4506,  1546,  4517,  4518,  4536,  4538,  4539,  4468,
    4546,  4504,   869,  5182,  4513,  4557,  4766,  4520,  5185,  2733,
    4559,  4542,  4565,  2631,  4521,  4554,  4570,  4553,  4572,  3489,
    4575,  4574,   718,  4576,  4577,  4578,  4582,  4584,  4587,  4591,
    4598,   869,  1547,  4593,  4599,  4600,   727,   728,  4642,  4353,
    4541,   734,  4643,  4606,  4655,   869,   745,   753,   727,  4601,
     760,  1546,  3953,   753,   753,  4548,   788,  4602,   791,  4612,
    4626,  5189,   869,  5191,  4792,   869,  4636,   718,  3654,  4638,
    4640,  4650,  3654,  4653,  4656,  4665,   889,  4658,  4668,  4671,
    4659,  4674,  4676,  4681,  4660,  4682,  4690,  4704,  4707,  4721,
    4727,  4728,  4752,  4755,  4736,  4756,  4777,  4709,  4778,  4779,
    4767,  4788,  4754,  4796,  4823,  4818,  4770,  4783,  4824,  4816,
     177,  4832,  4820,  4837,  4846,  4581,  4844,  4850,  4863,  4852,
    4859,  4871,  4865,  4967,  5094,  5264,  5013,  5266,  4880,  4889,
    4895,  4881,  4902,  4904,  4905,  4912,  4914,  4915,  4938,  4961,
    4924,  4975,  4953,  5015,  4971,  5038,  2244,  2837,  5040,  4916,
    2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    4917,  4907,  4931,  4941,  5009,  5033,  4957,  4306,  4306,  4974,
    4990,  5010,  4471,  1547,  5034,  5127,  5011,  4306,  5020,  5021,
    5045,  5054,  5051,  4306,  4142,  5061,  5063,  4495,  1012,  5066,
    5064,  4497,  5067,  5086,  5068,  5085,  5087,  5089,  5096,  5090,
    5101,   845,   850,   850,   853,  5092,   850,  5018,   859,  5102,
    5097,   845,  5123,   788,  1546,  5126,   891,  5130,  2837,  2837,
    4516,   788,  5136,  5143,   788,  5142,  5145,  1710,   850,  5147,
     788,   859,  5164,  5151,  5157,  5165,  5167,  5168,  5438,  5166,
    5171,  5188,   718,  5204,  5209,  5116,  4675,  5213,  5216,  4662,
    4663,  4666,  5218,  5219,  5214,  5224,  5235,  5236,  5237,  4673,
    5246,  5252,  5260,  5268,  5389,  5265,  5269,  5247,  5270,  5253,
    5282,  5272,  5288,  5283,  5289,  5293,  5183,  5304,  5305,  5308,
    5318,  5310,  5319,  3645,  5299,  5313,  2368,  3645,  5325,  5328,
    5329,  5332,  5331,  5366,  5346,  4181,  5356,  5373,  5494,  5358,
    5306,  5361,  5371,  4761,  5370,  5374,  5307,  5381,  5382,  5386,
    5154,  5412,   869,  5407,  5425,  4771,  5421,   718,  5438,  2369,
    5426,   177,  5427,  5429,  5454,  2122,  5442,  5464,  2122,  5446,
    1546,  5463,  2370,  5495,  4729,  5469,  5500,  5503,  5506,  5507,
    5501,  5462,  5509,  4981,  5536,  5520,  2371,  5557, -2319, -2376,
    5535,  5423,  5562,  5577,  5616,  5578,  5609,  4764,  4765,  1546,
    5593,  2659,  4768,  4769,  5586,  4834,  1281,  2548,  5023,  2244,
    5595,  3395,  3860,  3669,  2150,  2244,  1443,  2244,  4338,  3793,
    2320,  1373,  5012,  5194,  2372,  3288,  5494,  3924,  5570,  4444,
    5195,  5039,  5303,  5088,  4509,  2373,  5091,  4829,  5076,  3477,
    5000,  4630,  4631,  4632,  4633,  3720,  5359,  4965,  5420,  5380,
    5311,  5309,  5227,  2244,  3725,  2374,  4988,  1442,  3823,  4316,
    2375,  4357,  5599,  5003,  5544,  5478,  5564,  5532,  5605,  5438,
    5241,  5573,  5620,  4503,  3372,   869,   718,  3373,   869,  4336,
    2320,  3807,  5570,  2638,  3355,  4790,  4791,  4008,  5428,  5596,
    5504,  5065,  3943,  4547,  5384,  5019,  5559,  5277,  2621,  3329,
    3329,   718,  5295,  5367,  5022,   733,  1011,  1705,  4571,  5152,
    4810,  4549,  3019,  1714,  3707,  4550,  5245,  3892,  4826,  5400,
    1013,  1547,  1254,  5539,  2244,  2963,  2723,  2376,  2964,  3673,
    1669,  4527,  5479,  4667,  4246,  5254,  5587,  1275,  3674,  2998,
    3686,  1546,  3654,  2292,  5588,  2981,  1546,  5350,  3654,  5267,
    2997,  3699,  3489,  3654,  5103,  3687,  3654,  5597,  4635,  4197,
    4648,  2377,  5138,   889,  4192,  5259,  1262,  5258,  1546,  4159,
    4247,  3341,  5121,  5352,  2258,  4145,  5353,  5345,  5414,  3677,
    4854,  1710,  3622,  4156,  3525,  5515,  3654,  3620,  5518,  5519,
     203,  5521,   869,   869,  4243,  2940,     0,     0,     0,   869,
       0,     0,  1547,     0,     0,  2291,  1546,  2837,     0,  2296,
    4306,     0,  4882,     0,     0,  4306,     0,     0,  3676,  3888,
       0,  1012,     0,  2378,  4306,  2301,  2113,  5515,     0,  2379,
    5518,  5519,  2380,  5521,  4581,  4581,  4581,  4581,     0,  5274,
    1547,     0,     0,     0,     0,     0,   927,   889,     0,     0,
       0,   788,  3489,     0,  3489,   850,     0,   853,  2381,   850,
       0,     0,     0,     0,  2382,  1547,   891,     0,     0,   984,
    5017,     0,  1804,     0,     0,  1805,   850,  2383,     0,  1546,
     869,     0,     0,  1546,  1546,     0,     0,     0,     0,     0,
       0,     0,  1710,     0,     0,     0,  1710,  1710,     0,     0,
    2254,     0,  2384,     0,     0,   845,  1825,     0,     0,     0,
     853,     0,     0,     0,     0,     0,   845,     0,     0,     0,
     891,     0,     0,     0,     0,     0,     0,   864,  1547,  4958,
    1842,     0,     0,     0,     0,     0,     0,   850,     0,     0,
       0,     0,  5417,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1804,     0,     0,
    1805,     0,     0,  3645,     0,   718,     0,     0,  3645,     0,
    1538,  3645,     0,     0,     0,     0,     0,  1816,     0,     0,
       0,     0,     0,     0,     0,  2254,   788,  3654,     0,     0,
       0,  1825,     0,     0,     0,  3953,     0,   788,  1110,     0,
       0,  2837,  2837,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4888,  1842,     0,     0,  1228,     0,
     788,   753,     0,     0,     0,   753,     0,     0,  1546,  1546,
       0,     0,     0,  1897,     0,     0,  5024,  1901,  5026,   788,
       0,  5280,  5281,   788,  3654,     0,     0,     0,     0,  1228,
       0,     0,     0,     0,     0,  3329,     0,     0,  1917,  1918,
     788,     0,     0,     0,  1011,     0,     0,     0,  5043,     0,
    5044,     0,   788,     0,  5049,  1926,  5050,     0,  5052,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   869,  4306,  5080,  3442,  2631,
       0,     0,     0,     0,  1947,     0,     0,  1950,     0,     0,
       0,  1538,     0,     0,   788,  1547,   788,  1346,  1897,     0,
    2255,  2244,  1901,     0,     0,     0,     0,     0,     0,   788,
       0,   850,   850,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1917,  1918,     0,     0,     0,     0,     0,
    1347,     0,     0,   753,   753,     0,   802,     0,     0,     0,
    1926,     0,     0,     0,   869,     0,     0,   177,     0,     0,
       0,     0,  5215,     0,     0,     0,   869,     0,     0,     0,
       0,     0,   845,     0,     0,     0,     0,     0,     0,  1947,
       0,     0,  1950,   845,     0,     0,     0,   891,  2012,   869,
       0,     0,  1348,     0,     0,  2255,  1349,     0,  1961,     0,
       0,   850,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,     0,
       0,   850,   850,     0,     0,  3654,     0,     0,  1350,   889,
       0,     0,     0,     0,     0,     0,   869,     0,     0,   788,
     788,   788,     0,     0,   845,   850,     0,   845,     0,  3645,
       0,     0,     0,     0,     0,     0,     0,  3443,     0,  1793,
       0,     0,     0,     0,  1351,     0,     0,     0,     0,     0,
       0,  5057,     0,  2012,     0,   850,     0,   850,   850,     0,
       0,     0,     0,     0,     0,     0,     0,  5196,     0,     0,
       0,     0,     0,     0,     0,  1352,     0,  1353,     0,     0,
       0,     0,  1228,     0,     0,     0,     0,     0,  1538,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
    5321,     0,     0,     0,     0,     0,     0,     0,  5225,     0,
       0,     0,     0,  1687,  1687,     0,     0,     0,   788,  3654,
     727,     0,     0,  2099,  2100,  2101,     0,  2102,  2103,  2104,
    2105,  2106,  2107,     0,     0,     0,     0,     0,  1720,     0,
       0,   788,    33,   869,  1726,     0,  3444,     0,  1538,     0,
       0,     0,  1357,     0,     0,     0,     0,  1228,     0,  1358,
       0,     0,     0,     0,     0,     0,  5365,  2413,  1546,     0,
       0,     0,     0,     0,     0,     0,  1360,     0,   177,     0,
       0,     0,     0,     0,  1361,     0,  1228,     0,     0,  1538,
       0,     0,     0,     0,     0,     0,  2837,     0,  5160,     0,
       0,  2950,     0,     0,     0,     0,     0,  4911,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,  3489,  1228,
    1228,     0,  1228,     0,     0,  3540,     0,  1011,  2837,  2837,
       0,     0,     0,     0,     0,     0,  1362,     0,     0,     0,
    3445,  1228,     0,   869,     0,   869,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1363,     0,     0,     0,     0,     0,  5330,     0,     0,
    1538,     0,     0,     0,     0,     0,     0,     0,     0,   788,
       0,     0,  1228,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1365,     0,   788,   788,  1538,     0,
       0,  4662,  4662,     0,  1228,     0,     0,     0,  1228,  1228,
       0,     0,     0,     0,   869,     0,     0,     0,     0,   788,
     788,  2304,     0,  1538,     0,     0,     0,     0,     0,     0,
    5385,     0,     0,     0,     0,  2244,     0,   753,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5405,
    5394,  5395,   181,     0,     0,     0,  5402,     0,     0,     0,
    5403,  5404,  2244,     0,   869,     0,  5453,     0,     0,  5543,
       0,     0,     0,   753,     0,  5436,     0,  3676,     0,     0,
    3015,     0,     0,     0,  2320,  3021,  1538,     0,     0,   788,
    2428,     0,  3442,     0,     0,     0,   788,     0,     0,   850,
     177,     0,     0,     0,     0,  5437,     0,     0,     0,  5405,
       0,  1346,   181,     0,     0,     0,  5402,     0,     0,   177,
    5403,  5404,     0,     0,     0,     0,     0,   891,     0,     0,
       0,  5477,     0,   788,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,  1347,     0,     0,     0,     0,     0,
       0,     0,  5502,     0,     0,  5436,     0,     0,     0,     0,
     788,     0,     0,     0,  5394,  5513, -2542,     0,   850,   850,
     850,   850,   788,     0,     0,     0,     0,     0,     0,  5452,
       0,     0,     0,     0,     0,  5437,   788,     0,     0,     0,
       0,     0,     0,  5512,     0,     0,  1348,     0,  1547,     0,
    1349,     0,  2565,  2837,   788,     0,     0,     0,     0,  5405,
       0,     0,   181,     0,   850,   850,  5402,     0,     0,     0,
    5403,  5404,   850,     0,   718,     0,     0,     0,     0,     0,
       0,     0,  1350,  5555,  5556,     0,     0,  5560,  5561,     0,
    5563,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2542,     0,     0,     0,  3953,  2244,     0,     0,     0,     0,
       0,  3443,     0,   850,     0,     0,  5436,     0,  1351,     0,
       0,     0,     0,  1538,     0,     0,     0,     0,     0,   177,
       0,  5606,     0,     0,     0,     0,     0,     0,     0,  5591,
     850,   850,   850,   850,     0,     0,  5437, -2542,     0,  1352,
       0,  1353,     0,     0,   788,  5619,     0,     0,     0, -2542,
       0,  5607,   788,     0, -2542,     0,  2565,     0,     0, -2542,
       0,     0,     0,     0, -2542,     0,   845, -2542,     0, -2542,
       0,     0,     0,   853,     0,     0,   845,     0,     0,     0,
       0,     0,  5461,     0,     0,     0,   891,     0,     0,     0,
       0,   850,     0,     0,     0,     0, -2542,     0,     0,     0,
     850,     0,     0,  1547,     0,     0,    33,     0,   850,   850,
    1356,     0,     0,     0,     0,     0,  1357,     0, -2542,     0,
       0,     0,     0,  1358,     0,     0,     0,     0,     0,     0,
       0,  2413,     0,     0,     0,     0,     0,     0,  1687,     0,
    1360,     0, -2556,     0,     0,   850,     0,   845,  1361,     0,
       0,   788,   788,     0,   850,     0,     0,     0, -2542,     0,
       0,   788,     0,     0,     0,     0, -2542,     0,   788,     0,
       0,     0,     0,     0,     0,   727,   727, -2542,     0,  2778,
       0,     0,  2320,  1228,     0,  1228,     0,     0,  2320,     0,
       0,     0,  1228,     0,     0,  1228,     0,   869,     0,  1228,
    1362,     0,     0,     0,  3445,  4048,     0,  1228,  1228,     0,
       0,     0,     0,     0, -2542,  1228,     0,   891,  1228,  1228,
    1228,  1228,     0,     0,     0,  1363, -2556,     0,     0,  1228,
    1228,     0,  1228,     0,  1228,  1228,     0,     0,  1228,     0,
    1228,     0,  1228,  1228,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,   731,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,   869,
    1228,     0,     0, -2556,  1547,     0,     0,     0,     0,     0,
       0,     0,     0, -2542,     0, -2556,     0,     0,     0,     0,
   -2556,     0,     0,     0,     0, -2556,   850,     0,     0,     0,
   -2556,     0,     0, -2556,     0, -2556,     0, -2542,     0, -2542,
   -2542,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2556,     0,     0,     0,     0, -2542,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1228,     0,     0, -2556,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2542,
    1228,     0,     0,     0,     0,  2244,     0,     0,     0,     0,
       0,     0,     0,  -129, -2556,  1346,     0,     0,     0,     0,
       0,     0, -2556,     0,     0,     0, -2542,     1,     0, -2542,
   -2542, -2542,     0, -2556,     0,  1228,     0,     2,     0,     3,
       4,     0,     0,     0,     0,     0,     0,     0,  1347,     0,
       0,     0,     0,     0,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2244,     0,     0,     0,     0,
   -2556,  2950,  2950,  2950,     6,     0,     7,     8,     0,     0,
       0,     0,     9,     0,    10,  2244,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    11,     0,    12,     0,     0,
    1348,     0,     0,     0,  1349,     0,     0,     0,     0,     0,
       0,     0,     0,    13,     0,   731,    14,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    15,     0,
      16,     0,     0,     0,    17,     0,  1350,     0,  1538, -2556,
      18,     0,  1538,  1538,  2320,     0,     0,  3021,    19,  3021,
      20,     0,     0,  2244,  2320,  2244,    21,     0,     0,     0,
       0,     0,     0, -2556,     0, -2556, -2556,     0,     0,     0,
       0,    22,  1351,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,     0,  1228,     0,     0,     0,     0,     0,     0,
       0,     0,   788, -2556,  1228,  1228,  2244,     0,     0,     0,
       0,   788,     0,  1352,  1547,  1353,     0,     0,     0,  2244,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    23,    24,     0,     0,
       0,     0,    25,     0,     0, -2556,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
    2320,     0,     0,     0,     0,    27,  1538,     0,     0,     0,
       0,     0, -2556,     0,     0, -2556, -2556, -2556,     0,     0,
      33,     0,  2412,     0,  1356,     0,     0,     0,     0,     0,
    1357,     0,     0,     0,     0,     0,     0,  1358,     0,     0,
       0,     0,     0,    28,     0,  2413,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,    29,     0,     0,     0,     0,
      30,    31,  1361,    32,     0,     0,     0,     0,    33,     0,
       0,     0,     0,    34,     0,   788,    35,   788,     0,     0,
      36,  1228,     0,     0,  1804,    37,    38,  1805,     0,     0,
       0,     0,  1547,    39,  1547,     0,    40,     0,  1228,     0,
       0,     0,     0,     0,    41,     0,     0,  1228,  1228,     0,
       0,     0,  2254,     0,  1362,     0,    42,     0,  1825,     0,
       0,   788,     0,     0,     0,     0,     0,  3005,     0,  3012,
       0,     0,     0,    43,     0,     0,     0,     0,     0,  1363,
       0,     0,  1842,    44,     0,     0,     0,     0,     0,    45,
       0,     0,     0,     0,    46,     0,  1547,   853,     0,     0,
       0,     0,   727,     0,   727,     0,     0,    47,  1364,     0,
       0,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1228,  1365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   845,     0,   850,   850,   850,     0,     0,   845,
    1547,   891,     0,   850,     0,   850,     0,   850,   850,     0,
       0,     0,     0,   788,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3021,  1804,     0,   753,  1805,     0,
       0,     0,     0,     0,     0,  1897,     0,  2428,     0,  1901,
    1538,     0,     0,     0,     0,  1816,  1538,     0,  3147,     0,
       0,     0,     0,  2254,     0,    48,  3159,     0,  -129,  1825,
    1917,  1918,   788,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1926,     0,     0,
       0,     0,     0,  1842,     0,     0,     0,     0,     0,     0,
     788,     0,     0,  1547,  3210,  3210,     0,     0,     0,     0,
       0,   853,   753,     0,     0,     0,     0,  1804,     0,  1950,
    1805,     0,     0,     0,  3021,     0,     0,     0,     0,   850,
       0,     0,  2255,     0,     0,     0,  1547,  1816,     0,     0,
       0,     0,  1538,     0,     0,  2254,     0,     0,     0,     0,
    1804,  1825,     0,  1805,     0,     0,  3276,     0,  3279,  3281,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1816,     0,     0,     0,     0,  1842,     0,  1804,  2254,     0,
    1805,     0,     0,     0,  1825,     0,     0,     0,     0,     0,
       0,     0,     0,   850,     0,     0,  1897,     0,     0,     0,
    1901,   850,     0,     0,     0,  2254,   850,  1547,  1842,     0,
    2012,  1825,     0,     0,     0,  1228,     0,     0,     0,     0,
       0,  1917,  1918,     0,     0,     0,     0,  1547,     0,     0,
       0,     0,     0,     0,     0,  1842,     0,     0,  1926,     0,
       0,     0,     0,  2428,     0,     0,  3210,     0,   788,     0,
    3396,     0,     0,   727,     0,  1547,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1947,     0,     0,
    1950,     0,     0,     0,     0,     0,     0,     0,  1897,  3276,
       0,     0,  1901,  2255,     0,     0,  1961,     0,     0,   850,
    3423,     0,     0,     0,     0,     0,     0,  1547,  3618,     0,
       0,     0,     0,  1917,  1918,     0,     0,     0,     0,     0,
       0,  1897,     0,     0,     0,  1901,     0,     0,     0,     0,
    1926,   850,     0,   850,  3210,   850,  3210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1917,  1918, -2995,     0,
       0,     0,  1901,  2950,     0,  1228,     0,     0,     0,  1947,
       0,     0,  1950,  1926,     0,     0,     0,  1687,     0,     0,
       0,  2012,     0,  1917,  1918,  2255, -2995, -2995,  1961,  2102,
    2103,  2104,  2105,  2106,  2107,     0,     0,     0,     0,     0,
   -2995,     0,  1947,     0,     0,  1950,  2320,     0,     0,     0,
       0,     0,  1538,     0,     0,  1538,     0,  1538,  2255,     0,
       0,  1961,  1538,   845,     0,     0,     0,     0,     0,   845,
       0,     0,  1950,     0,     0,     0,     0,     0,     0,     0,
     850,     0,     0,     0,     0,  2255,     0,  1228,  1228,     0,
       0,     0,     0,  1228,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2012,     0,     0,     0,     0,     0,     0,
       0,     0,  1538,     0,     0,     0,     0,     0,  1228,  1228,
       0,     0,     0,  1228,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2012,  1228,  1228,  1228,
    1228,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1228,     0,     0,  1228,     0,     0,  3021,  1538,     0,
    1228,  3601,     0, -2995,     0,     0,     0,     0,     0,     0,
    1228,  1228,     0,     0,  1228,     0,  2099,  2100,  2101,     0,
    2102,  2103,  2104,  2105,  2106,  2107,     0,  1228,  2957,  1228,
       0,   891,     0,  1228,  2958,  1804,     0,     0,  1805,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1228,     0,     0,     0,   788,     0,     0,     0,
       0,     0,  3655,  2254,     0,  1228,  1228,  1228,     0,  1825,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1228,     0,     0,     0,     0,     0,  1804,     0,
    1538,  1805,  1538,  1842,     0,     0,  1228,     0,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,  1816,     0,
       0,  1228,  4609,     0,     0,  4610,  2254,     0,     0,     0,
       0,     0,  1825,  3655,  1804,     0,  3693,  1805,     0,     0,
    3012,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,
    2107,     0,     0,     0,     0,     0,  1842,     0,  3584,     0,
       0,     0,  2254,     0,  1538,     0,  4173,     0,  1825,     0,
       0,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,
       0,  1228,     0,  3210,     0,     0,     0,  1547,  1687,     0,
       0,     0,  1842,     0,  1376,     0,     0,     0,     0,     0,
    1377,     0,     0,     0,     0,     0, -2995,     0,  1538,     0,
    1901,     0,     0,     0,   850,     0,   850,   850,   850,     0,
       0,     0,     0,  3021,     0,     0,     0,     0,     0,  2320,
       0,  1917,  1918,     0,     0,     0,     0,     0,     0,     0,
    1378,     0,  1538,     0,  1804,     0,     0,  1805, -2995,     0,
       0,     0,     0,     0,     0,  4174,     0,     0,     0,  1897,
       0,     0,     0,  1901,  1816,     0,     0,     0,     0,     0,
       0,     0,  2254,     0,     0,     0,     0,     0,  1825,     0,
    1950,     0,     0,     0,  1917,  1918,     0,     0,     0,     0,
    1379,     0,     0,  2255,     0, -2995,     0,  1380,     0,  1901,
    1381,  1926,  1842,     0,     0,     0,     0,     0,     0,     0,
       0,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
    1917,  1918,     0,     0,     0,     0,     0,     0,     0,     0,
    1947,     0,  1538,  1950,     0,     0,     0, -2995,     0,     0,
       0,     0,     0,  1547,  1538,     0,  2255,     0,     0,  1961,
       0,     0,     0,     0,  1382,     0,     0,     0,  1547,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1950,
       0, -2995,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2255,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1376,     0,     0,     0,     0,     0,
    1377,     0,     0,     0,     0,  1897,     0,     0,  2950,  1901,
       0,     0,     0,  2950,  1383,  1538,  1384,     0,  2950,     0,
       0,     0,     0,     0,  2012,     0,  1385,     0,     0,     0,
    1917,  1918,     0,     0,  1386,  1538,     0,     0,     0,     0,
    1378,     0,     0,     0,  1387,     0,     0,  1926,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3210,  3210,
   -2995,     0,     0,  1538,     0,     0,     0,     0,     0,     0,
    1547,     0,     0,     0,     0,     0,  1947,  1388,     0,  1950,
    1389,  1390,     0,     0,     0,     0,     0,     0,     0,     0,
    1379,     0,  2255,     0,     0,  1961,     0,  1380,     0,     0,
    1381,     0,     0,     0,     0,  1538,  1391,     0,   788,  3987,
       0,   788,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1547,     0,     0,     0,     0,     0,   788,     0,     0,
    2102,  2103,  2104,  2105,  2106,  2107,     0,     0,     0,     0,
    1687,   788,     0,     0,     0,     0,  1392,     0,     0,     0,
       0,  1687,   788,     0,  1382,     0,     0,     0,     0,     0,
    1547,     0,     0,   788,  1393,     0,     0,     0,     0,     0,
    2012,   788,     0,     0,     0,     0,     0,     0,     0,  2099,
    2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,
       0,     0,     0,     0,  1538,     0,  3592,     0,     0,     0,
     850,     0,     0,   850,     0,     0,     0,     0,     0,     0,
       0,  1394,  1395,     0,  1383,     0,  1384,   845,  1547,  2102,
    2103,  2104,  2105,  2106,  2107,     0,  1385,     0,     0,     0,
       0,     0,     0,     0,  1386,     0,     0,     0,   788,     0,
       0,     0,     0,     0,  1387,     0,     0,     0,   850,     0,
       0,     0,     0,  1396,     0,     0,     0,     0,  1228,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1228,     0,
       0,     0,     0,     0,  1228,     0,  1228,  1447,     0,     0,
    1389,  1390,  1228,     0,     0,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,     0,     0,     0,  1228,  1228,
       0,     0,     0,     0,     0,  1538,  1448,     0,     0,     0,
       0,     0,     0,     0,  1228,     0,     0,     0,  1228,  1228,
       0,     0,     0,  1228,     0,  2099,  2100,  2101,  1228,  2102,
    2103,  2104,  2105,  2106,  2107,     0,     0,     0,  1228,     0,
       0,  1228,  3594,  1228,  4886,     0,  1392,     0,     0,     0,
       0,     0,  1228,  1228,  1228,     0,     0,  1804,  1228,     0,
    1805,  1228,     0,     0,  1393,  4183,     0,     0,     0,     0,
       0,     0,   788,   788,   788,   845,     0,  1816,  3655,  4201,
       0,  1547,     0,  4201,  4215,  2254,     0,     0,     0,     0,
    1228,  1825,     0,     0,     0,     0,  1228,  1228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1394,  1395,     0,     0,  1842,     0,     0,     0,     0,
       0,     0,  1228,     0,     0,     0,     0,     0,  1228,     0,
       0,     0,  3012,     0,  1228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1396,     0,     0,  4267,  1687,  1687,     0,
    2565,     0,     0,     0,     0,  1376,     0,     0,     0,     0,
       0,  1377,     0,     0,     0,     0,     0,     0,   850,   850,
     850,   850,     0,     0,     0,  1538,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1547,     0,     0,
    2950,     0,  2950,     0,     0,     0,   845,   845,   845,   845,
       0,  1378,     0,     0,     0,     0,     0,     0,  1897,     0,
       0,  1538,  1901,     0,     0,  1804,  3021,  1538,  1805,     0,
       0,     0,     0,     0,  4335,     0,     0,     0,     0,     0,
       0,     0,     0,  1917,  1918,  1816,     0,     0,     0,     0,
       0,     0,     0,  2254,  4343,     0,   788,     0,   845,  1825,
    1926,  1379,     0,     0,     0,     0,     0,     0,  1380,     0,
       0,  1381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1842,     0,     0,     0,     0,     0,  1947,
       0,     0,  1950,     0,     0,   850,   850,     0,     0,     0,
       0,  1804,     0,     0,  1805,  2255,     0,     0,  1961,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1816,     0,     0,     0,  1382,     0,  4429,     0,  2254,
       0,     0,     0,     0,     0,  1825,     0,     0,     0,     0,
       0,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1538,     0,     0,  1842,
       0,     0,     0,     0,     0,     0,     0,     0,  1547,     0,
       0,     0,     0,  3021,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2012,     0,  1383,  1897,  1384,     0,   788,
    1901,     0,     0,     0,     0,  1547,     0,  1385,     0,     0,
     850,     0,  1228,     0,     0,  1386,     0,     0,   788,     0,
       0,  1917,  1918,     0,  4502,  1387,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2428,     0,     0,  1926,     0,
       0,     0,     0,  1547,     0,     0,     0,   788,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3276,  1473,     0,
       0,  1389,  1390,     0,  4534,     0,     0,  1947,     0,     0,
    1950,     0,  1897,     0,     0,     0,  1901,     0,  1538,     0,
       0,     0,     0,  2255,  1228,  1228,  1961,  1474,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1917,  1918,     0,
       0,     0,     0,     0,     0,     0,     0,  3210,  1804,  3210,
       0,  1805,     0,     0,  1926,     0,  1547,     0,     0,     0,
    1547,  1547,     0,     0,     0,     0,     0,  1392,  1816,  1538,
       0,     0,     0,     0,     0,     0,  2254,     0,     0,     0,
       0,     0,  1825,  1947,  1228,  1393,  1950,     0,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,  2255,
       0,  2012,  1961,     0,     0,  4610,  1842,     0,  1538,     0,
       0,     0,     0,  1228,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1228,     0,     0,     0,     0,     0,     0,
       0,     0,  1394,  1395,  1228,  1228,     0,     0,     0,  1228,
       0,     0,     0,     0,     0,     0,  1228,  1228,     0,  4886,
       0,  1228,     0,     0,     0,     0,     0,  1228,  1228,     0,
       0,  1228,     0,     0,  1228,  4629,  1538,     0,   788,   788,
     788,   788,     0,     0,  1396,  4201,  4215,  2012,  1228,  4201,
       0,     0,  4639,     0,     0,     0,  3655,     0,     0,     0,
    3655,     0,     0,     0,  1376,     0,  4652,     0,     0,     0,
    1377,     0,  1228,     0,     0,  1547,  1547,  1228,     0,  1897,
       0,     0,  1228,  1901,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,     0,  3693,     0,     0,     0,  3012,
       0,     0,     0,     0,  1917,  1918,     0,     0,     0,     0,
    1378,     0,     0,   727,     0,     0,  1228,     0,     0,     0,
    1804,  1926,     0,  1805,     0,     0,  2099,  2100,  2101,     0,
    2102,  2103,  2104,  2105,  2106,  2107,  3210,  3210,     0,     0,
    1816,     0,     0,  4929,     0,     0,     0,     0,  2254,     0,
    1947,     0,     0,  1950,  1825,   845,   845,     0,     0,     0,
    1379,     0,     0,     0,     0,   845,  2255,  1380,     0,  1961,
    1381,   845,     0,     0,     0,     0,     0,     0,  1842,     0,
       0,     0,     0,  4730,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1804,     0,   850,  1805,  1538,
       0,     0,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,
    2106,  2107,     0,     0,     0,     0,  2875,     0,     0,     0,
       0,     0,     0,  2254,  1382,     0,     0,     0,     0,  1825,
       0,     0,   847,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   847,   868,  2012,     0,     0,     0,     0,   868,
       0,     0,     0,  1842,     0,     0,     0,     0,     0,     0,
     868,     0,     0,   850,  1804,     0,     0,  1805,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   850,     0,     0,
       0,  1897,     0,     0,  1383,  1901,  1384,     0,     0,     0,
       0,     0,  2254,     0,     0,     0,  1385,     0,  1825,     0,
       0,     0,     0,     0,  1386,     0,  1917,  1918,     0,     0,
       0,     0,     0,     0,  1387,  1538,  4177,     0,     0,     0,
       0,     0,  1842,  1926,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1228,     0,  1538,     0,     0,  2386,     0,     0,
    1389,  1390,  1947,   845,     0,  1950, -2995,     0,  2428,     0,
    1901,     0,     0,     0,     0,     0,     0,  1687,  2255,     0,
       0,  1961,     0,     0,     0,     0,  1391,     0,     0,   850,
    2428,  1917,  1918,     0,     0,  4623,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4878,     0, -2995,  2099,
    2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,
       0,   788,     0,  3598,     0,     0,  1392,     0,     0,     0,
       0,     0,     0,     0,     0, -2995,     0,     0,     0,  1901,
    1950,     0,     0,     0,  1393,     0,     0,     0,     0,     0,
       0,  1228,     0,  2255,     0,  3021,  2012,     0,     0,     0,
    1917,  1918,  1228,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1228,     0,     0, -2995,     0,     0,
       0,     0,     0,  1228,  1228,     0,     0,  1228,     0,     0,
       0,  1394,  1395,     0,     0,     0,  1538,     0,     0,     0,
     845,  1538,  4201,     0,     0,     0,  3655,     0,     0,  1950,
       0,  3655,     0,     0,  3655,  3276,     0,  4943,     0,  1228,
    1228,     0,  2255,  1538,     0,     0,     0,     0,     0,     0,
       0, -2995,     0,  1396,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4267,   891,   850,   850,   850,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1538,     0,     0,     0,     0,     0,     0,   845,     0,
       0,     0,     0,   845,  1228,     0,  1228,     0,     0,     0,
       0,     0,   845,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2995,     0,  4343,   850,     0,     0,     0,     0,     0,     0,
       0,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,
    2107,     0,     0,     0,     0,  3928,     0,     0,   845,   891,
       0,     0,     0,     0,  1538,     0,     0,     0,  1538,  1538,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1804,     0,     0,  1805,     0,     0,     0,
       0,     0,     0,     0,     0,   868,     0,     0,     0,   868,
       0,     0,     0,  1816,     0,     0,     0,  1687,  1687,     0,
     868,  2254,     0,     0,     0,   845,     0,  1825,   788,     0,
    2102,  2103,  2104,  2105,  2106,  2107,     0,     0,     0,  4502,
       0,     0,   868,     0,     0,     0,   847,     0,  3210,     0,
       0,  1842,  2428,     0,     0,     0,     0,   847,   868,  1804,
       0,     0,  1805,   868,     0,     0,  4534,     0,     0,   788,
       0,     0,     0,   868,     0,     0,     0,     0,     0,  1816,
       0,     0,     0,   868,   850,  4267,     0,  2254,     0,     0,
       0,     0,  1804,  1825,     0,  1805,     0,     0,     0,  2102,
    2103,  2104,  2105,  2106,  2107,     0,  1228,     0,  1228,     0,
       0,  1228,  1816,  1228,     0,     0,     0,  1842,     0,     0,
    2254,     0,     0,  1538,  1538,     0,  1825,     0,     0,     0,
       0,     0,     0,  1228,     0,     0,     0,     0,  1228,     0,
       0,     0,  3655,     0,     0,  4943,     0,     0,     0,     0,
    1842,     0,  1228,     0,  1897,     0,     0,  5150,  1901,   847,
       0,     0,     0,     0,   868,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,  1917,
    1918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     847,     0,     0,     0,   845,     0,  1926,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1897,     0,     0,     0,  1901,  1947,     0,     0,  1950,     0,
       0,     0,     0,     0,   850,   850,   850,   850,     0,     0,
       0,  2255,     0,     0,  1961,  1917,  1918,     0,     0,  1687,
       0,     0,     0,  1897,     0,     0,     0,  1901,     0,  1540,
       0,     0,  1926,     0,     0,     0,     0,     0,     0,     0,
     845,     0,     0,     0,     0,     0,     0,     0,  1917,  1918,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1228,
       0,  1947,     0,     0,  1950,  1926,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4878,  2255,     0,     0,
    1961,   868,     0,     0,     0,     0,     0,     0,     0,  2012,
       0,     0,     0,   847,  1947,     0,     0,  1950,     0,     0,
    1228,     0,     0,   845,   847,     0,     0,   187,     0,     0,
    2255,     0,     0,  1961,     0,     0,     0,  1228,     0,  1228,
       0,  1228,     0,     0,     0,     0,     0,  1548,     0,   850,
       0,   891,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1228,     0,     0,     0,     0,
       0,     0,     0,   188,     0,  2012,     0,     0,   868,     0,
       0,     0,     0,     0,     0,   847,     0,   189,   847,     0,
    1540,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   190,     0,     0,     0,  2012,     0,
     191,     0,     0,   850,     0,     0,     0,     0,   845,     0,
       0,     0,   868,     0,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,  4267,   868,   868,
       0,     0,     0,   847,   194,   195,     0,     0,     0,  1228,
    1228,     0,   868,     0,  3276,     0,   196,     0,     0,  1228,
       0,   197,  5150,     0,  2099,  2100,  2101,   198,  2102,  2103,
    2104,  2105,  2106,  2107,     0,     0,     0,     0,  4104,     0,
     868,     0,   199,  1538,   845,     0,     0,     0,  1548,     0,
     868,     0,     0,   850,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   868,     0,     0,   868,   200,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   847,  1687,
       0,     0,     0,     0,     0,     0,     0,     0,   201,     0,
    2099,  2100,  2101,  1228,  2102,  2103,  2104,  2105,  2106,  2107,
       0,     0,     0,     0,  4158,     0,     0,   847,     0,     0,
    1228,     0,     0,     0,  1804,     0,     0,  1805,     0,     0,
     850,     0,   202,  2099,  2100,  2101,     0,  2102,  2103,  2104,
    2105,  2106,  2107,     0,  1816,     0,     0,  4261,     0,     0,
     847,   847,  2254,   847,     0,     0,     0,  1804,  1825,     0,
    1805,   203,     0,     0,     0,     0,     0,  1540,     0,     0,
       0,     0,   847,     0,     0,     0,     0,  1816,     0,     0,
       0,     0,  1842,     0,     0,  2254,     0,     0,   204,   788,
       0,  1825,   205,     0,   206,     0,   868,     0,     0,     0,
     207,     0,     0,   208,   868,   868,     0,     0,     0,     0,
       0,     0,     0,   847,  2243,  1842,     0,     0,  1228,     0,
       0,     0,     0,     0,     0,     0,     0,  1540,   209,   210,
       0,   211,     0,     0,     0,   212,     0,     0,     0,     0,
       0,     0,     0,   213,     0,   847,     0,     0,   214,   847,
     847,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     215,     0,     0,     0,     0,  1548,  1804,   845,  1540,  1805,
       0,  2243,     0,   216,     0,     0,     0,     0,     0,     0,
       0,  1687,     0,     0,     0,  1897,  1816,     0,     0,  1901,
       0,     0,     0,     0,  2254,     0,     0,     0,     0,     0,
    1825,     0,     0,  1804,     0,     0,  1805,     0,     0,     0,
    1917,  1918,     0,     0,     0,     0,     0,     0,  1897,     0,
       0,  1687,  1901,  1816,  1842,  1548,     0,  1926,     0,  1687,
       0,  2254,     0,     0,     0,     0,     0,  1825,     0,   217,
       0,     0,  1687,  1917,  1918,     0,   218,     0,     0,  1540,
       0,     0,     0,     0,     0,     0,  1947,     0,     0,  1950,
    1926,  1842,     0,     0,     0,     0,  1548,     0,     0,     0,
       0,     0,  2255,     0,     0,  1961,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1540,     0,  1947,
       0,     0,  1950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2255,     0,     0,  1961,     0,
       0,     0,  1540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   868,     0,     0,     0,  1897,     0,     0,
       0,  1901,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1548,     0,     0,
    2012,     0,  1917,  1918,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1897,     0,     0,     0,  1901,  1926,
       0,     0,     0,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,  2012,     0,  1548,     0,     0,     0,  1917,
    1918,     0,     0,     0,     0,     0,     0,     0,  1947,     0,
       0,  1950,     0,     0,     0,  2243,  1926,     0,     0,     0,
    1548,     0,     0,     0,  2255,     0,     0,  1961,     0,     0,
       0,     0,     0,     0,     0,   868,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1947,     0,     0,  1950,     0,
       0,   868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2255,     0,     0,  1961,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   847,     0,     0,
       0,     0,     0,  1548,     0,     0,     0,   847,     0,   868,
     868,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     868,     0,  2012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   868,   868,     0,  2099,  2100,  2101,     0,  2102,
    2103,  2104,  2105,  2106,  2107,     0,   868,     0,     0,  4585,
       0,     0,  1376,     0,     0,     0,     0,     0,  1377,  2012,
       0,     0,     0,     0,     0,     0,     0,     0,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,   847,     0,
       0,     0,  4597,  1804,     0,     0,  1805,     0,     0,     0,
       0,     0,  1540,     0,     0,     0,     0,     0,  1378,     0,
       0,  1804,     0,  1816,  1805,     0,     0,     0,     0,     0,
       0,  2254,     0,     0,   847,     0,   847,  1825,     0,     0,
       0,  1816,     0,   847,     0,     0,   847,     0,     0,  2254,
     847,     0,     0,     0,  1804,  1825,     0,  1805,   847,   847,
       0,  1842,     0,     0,     0,     0,   847,     0,  1379,   847,
     847,   847,   847,     0,  1816,  1380,     0,     0,  1381,  1842,
     847,   847,  2254,   847,     0,   847,   847,     0,  1825,   847,
       0,   847,     0,   847,   847,     0,     0,  2099,  2100,  2101,
       0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,     0,
    1548,  4625,  1842,     0,     0,     0,     0,  1804,     0,     0,
    1805,   847,  2243,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1382,     0,  2099,  2100,  2101,  1816,  2102,  2103,
    2104,  2105,  2106,  2107,     0,  2254,     0,     0,  4913,     0,
       0,  1825,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1897,     0,     0,     0,  1901,     0,
       0,     0,     0,     0,     0,  1842,     0,     0,     0,     0,
       0,     0,  1897,     0,     0,     0,  1901,     0,     0,  1917,
    1918,     0,  1383,     0,  1384,     0,     0,     0,     0,     0,
       0,     0,   847,     0,  1385,     0,  1926,  1917,  1918,     0,
       0,     0,  1386,     0,     0,  1897,     0,     0,     0,  1901,
       0,     0,  1387,     0,  1926,     0,     0,     0,     0,     0,
       0,   847,     0,     0,     0,  1947,     0,     0,  1950,     0,
    1917,  1918,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2255,     0,  1947,  1961,  2390,  1950,  1926,  1389,  1390,
       0,     0,     0,     0,     0,     0,   847,     0,     0,  2255,
       0,     0,  1961,     0,     0,     0,     0,     0,  1897,     0,
       0,     0,  1901,     0,  2391,     0,  1947,     0,     0,  1950,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2255,  1917,  1918,  1961,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1926,     0,     0,     0,  1392,     0,     0,     0,     0,  2012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1393,     0,     0,     0,     0,  2012,     0,  1947,
       0,     0,  1950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2255,     0,     0,  1961,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2012,     0,     0,     0,     0,     0,     0,     0,     0,  1394,
    1395,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   847,   847,   847,   847,   847,   847,
     847,   847,   847,     0,   847,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   847,   847,     0,     0,     0,
       0,  1396,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1804,     0,     0,
    1805,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2099,  2100,  2101,  1816,  2102,  2103,
    2104,  2105,  2106,  2107,     0,  2254,     0,     0,  4923,     0,
       0,  1825,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,
    2106,  2107,     0,     0,     0,     0,  4963,  1540,     0,     0,
       0,  1540,  1540,     0,     0,  1842,     0,  1804,     0,     0,
    1805,     0,     0,     0,     0,  2099,  2100,  2101,     0,  2102,
    2103,  2104,  2105,  2106,  2107,     0,     0,  1816,     0,  5059,
       0,     0,     0,     0,     0,  2254,     0,     0,     0,     0,
       0,  1825,   847,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
       0,     0,     0,     0,     0,  1842,     0,     0,   847,   847,
       0,     0,     0,     0,     0,     0,     0,     0,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,
       0,     0,  4609,     0,     0,  1548,     0,     0,     0,  1548,
    1548,     0,     0,     0,     0,     0,     0,     0,  1897,   868,
       0,     0,  1901,  2243,   868,  1540,     0,   868,     0,     0,
    1804,     0,     0,  1805,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1917,  1918,     0,     0,     0,     0,   868,
    1816,     0,   847,     0,     0,     0,     0,     0,  2254,     0,
    1926,     0,     0,   847,  1825,     0,     0,  1376,     0,     0,
     847,     0,     0,  1377,     0,     0,     0,     0,  1897,     0,
       0,     0,  1901,     0,     0,     0,     0,     0,  1842,  1947,
       0,     0,  1950,     0,   868,     0,     0,     0,  1423,     0,
       0,     0,     0,  1917,  1918,  2255,     0,     0,  1961,     0,
       0,     0,     0,  1378,   868,   868,     0,     0,     0,     0,
    1926,     0,     0,  1548,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,  2243,   868,     0,  1947,
       0,  2243,  1950,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1379,     0,  2255,     0,     0,  1961,     0,
    1380,     0,     0,  1381,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2012,     0,   868,     0,     0,     0,   868,
    1540,  1897,     0,     0,     0,  1901,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   868,     0,     0,
    1804,     0,     0,  1805,     0,     0,  1917,  1918,   868,     0,
       0,     0,     0,     0,  1425,     0,     0,  1382,     0,     0,
    1816,   868,     0,  1926,  2973,     0,     0,     0,  2254,     0,
       0,     0,   868,  2012,  1825,     0,     0,     0,     0,   868,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1947,     0,     0,  1950,     0,     0,  1842,  1540,
       0,     0,  1426,     0,     0,  1540,     0,  1427,  2255,     0,
       0,  1961,     0,     0,     0,     0,   847,  1428,  1548,  1384,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1385,
       0,     0,     0,     0,     0,     0,     0,  1386,     0,  2243,
       0,     0,     0,     0,  2974,     0,  1429,  1387,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,
    1430,     0,  5320,  1389,  1390,  1431,  2012,     0,     0,     0,
       0,  1540,     0,     0,     0,     0,     0,  1548,     0,     0,
       0,  1897,     0,  1548,     0,  1901,     0,   868,     0,  1432,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1433,     0,     0,     0,     0,     0,  1917,  1918,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,
       0,   868,  5459,  1926,     0,     0,   847,     0,     0,  1392,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1393,     0,     0,
       0,     0,  1947,     0,     0,  1950,     0,   868,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2255,  1548,
       0,  1961,     0,     0,     0,     0,     0,     0,     0,     0,
     868,     0,     0,     0,   847,     0,     0,     0,     0,     0,
     847,     0,     0,     0,  1394,  1395,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   847,   847,
       0,     0,     0,     0,   847,     0,     0,     0,     0,     0,
       0,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,
    2107,   870,     0,  4232,     0,     0,  1396,   870,     0,   847,
     847,     0,     0,     0,   847,     0,  2012,     0,   870,     0,
       0,  1804,     0,     0,  1805,     0,     0,     0,   847,   847,
     847,   847,     0,     0,     0,     0,  2243,     0,     0,     0,
       0,  1816,   847,  2243,     0,   847,     0,     0,     0,  2254,
       0,   847,     0,     0,     0,  1825,     0,     0,     0,     0,
       0,   847,   847,     0,     0,   847,     0,  2975,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   847,  1842,
     847,     0,     0,     0,   847,     0,     0,     0,     0,     0,
       0,  1540,     0,     0,  1540,     0,  1540,     0,     0,     0,
       0,  1540,     0,   847,     0,     0,  1804,     0,     0,  1805,
       0,     0,     0,   847,     0,     0,   847,   847,   847,     0,
       0,     0,     0,     0,     0,     0,  1816,     0,     0,     0,
     868,     0,     0,   847,  2254,     0,     0,     0,     0,     0,
    1825,     0,     0,     0,     0,     0,     0,   847,     0,     0,
       0,  1540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3564,   847,     0,  1842,     0,  3565,     0,     0,     0,
       0,  2099,  2100,  2101,   847,  2102,  2103,  2104,  2105,  2106,
    2107,  -950,  1897,     0,     0,     0,  1901,     0,     0,  1548,
       0,     0,  1548,   599,  1548,     0,     0,  1540,     0,  1548,
       0,   868,     0,     0,     0,     0,     0,  1917,  1918,     0,
       0,     0,     0,     0,   600,     0,   868,   868,     0,     0,
       0,     0,   847,     0,  1926,     0,     0,   601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   602,     0,     0,
       0,  -985,     0,   868,     0,     0,   868,     0,     0,  1548,
       0,     0,     0,  1947,     0,     0,  1950,     0,   603,     0,
       0,     0,     0,     0,   604,     0,     0,  1897,     0,  2255,
       0,  1901,  1961,     0,     0,     0,     0,     0,     0,   605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1540,
     606,  1540,  1917,  1918,     0,  1548,     0,     0,   607,  -679,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1926,
     608,     0,  1541,     0,     0,     0,     0,   609,     0,     0,
       0,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1186,     0,  1947,     0,
       0,  1950,     0,     0,  2243,  2243,  2243,  2012,     0,     0,
       0,     0,     0,  1540,  2255,     0,     0,   849,   851,     0,
       0,   855,     0,   857,     0,  1804,     0,     0,  1805,     0,
       0,     0,     0,     0,     0,   611,     0,     0,   868,     0,
       0,     0,  -746,   907,     0,  1816,   913,  1548,     0,  1548,
     868,     0,     0,  2254,     0,     0,     0,  1540,     0,  1825,
       0,   868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,     0,     0,   612,   870,     0,   613,
       0,     0,     0,  1842,     0,     0,     0,     0,   870,     0,
       0,  1540,  2012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     870,  1548,     0,  1541,  -490,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   870,     0,     0,     0,
       0,   870,   614,     0,     0,     0,     0,     0,   615,     0,
       0,   870,     0,     0,  -490,     0,     0,   616,     0,   868,
       0,   870,     0,     0,     0,  1548,     0,     0,     0,     0,
    1540,     0,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,
    2106,  2107,     0,  -490,     0,   617,   618,     0,   619,   620,
       0,  1540,     0,     0,     0,     0,  1897,   621,  2243,  1548,
    1901,     0,   622,  1540,     0,     0,     0,     0,   623,     0,
       0,   624,     0,   868,   625,   868,     0,     0,     0,     0,
       0,  1917,  1918,     0,     0,     0,     0,  -490,     0,     0,
     868,     0,   868,     0,     0,     0,     0,     0,  1926,     0,
       0,     0,   870,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2099,  2100,  2101,
       0,  2102,  2103,  2104,  2105,  2106,  2107,  1947,  1548,     0,
    1950,     0,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,     0,  2255,     0,     0,  1961,   626,   868,  1548,
       0,     0,     0,     0,  1540,     0,   627,     0,     0,     0,
     628,  1548,     0,     0,     0,     0,  4146,     0,     0,     0,
       0,     0,     0,     0,   629,     0,     0,   868,     0,     0,
       0,     0,  1540,     0,     0,     0,     0,     0,   847,     0,
    1541,   868,     0,     0,     0,     0,     0,     0,     0,     0,
    1376,     0,     0,     0,     0,     0,  1377,     0,   868,     0,
       0,   868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2012,     0,     0,  1540,     0,     0,     0,     0,   847,
       0,     0,  1548,     0,     0,  4147,     0,     0,     0,   847,
       0,     0,     0,     0,     0,   847,  1378,   847,     0,   870,
    1541,     0,  1548,   847,     0,     0,   847,   847,   847,   847,
     847,   847,   847,   847,   847,   847,     0,     0,     0,   847,
     847,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1548,     0,     0,     0,     0,   847,     0,     0,     0,   847,
     847,  1541,  2243,     0,   847,     0,  1379,     0,     0,   847,
     963,     0,     0,  1380,   966,     0,  1381,  1804,     0,   847,
    1805,  1376,   847,  1540,   847,     0,     0,  1377,     0,     0,
       0,   989,  1548,   847,   847,   847,   870,  1816,     0,   847,
    3527,     0,   847,     0,     0,  2254,     0,     0,     0,     0,
       0,  1825,     0,     0,     0,     0,   847,     0,     0,   847,
       0,     0,     0,     0,     0,     0,     0,  1378,     0,     0,
    1382,   847,     0,     0,     0,  1842,     0,   847,   847,     0,
     870,     0,  1541,     0,     0,     0,  2099,  2100,  2101,     0,
    2102,  2103,  2104,  2105,  2106,  2107,   870,   870,     0,     0,
       0,     0,     0,   847,     0,     0,     0,     0,     0,   847,
     870,     0,     0,     0,     0,   847,     0,  1379,     0,     0,
    1541,  1548,     0,     0,  1380,     0,     0,  1381,     0,     0,
    1383,     0,  1384,     0,  1540,     0,     0,   847,   870,     0,
       0,     0,  1385,     0,     0,  1541,     0,     0,   870,     0,
    1386,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1387,   870,     0,     0,   870,     0,     0,     0,   868,     0,
       0,  1804,     0,     0,  1805,     0,     0,     0,  1897,     0,
       0,  1382,  1901,     0,     0,     0,     0,   847,   847,   847,
     847,  1816,     0,  2477,     0,     0,  1389,  1390,     0,  2254,
       0,     0,     0,  1917,  1918,  1825,     0,     0,  1541,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1926,     0,  2478,     0,     0,  2243,     0,     0,     0,  1842,
       0,  2243,  1548,  2243,     0,     0,     0,     0,     0,   847,
       0,  1383,     0,  1384,  3442,     0,     0,     0,     0,  1947,
       0,     0,  1950,  1385,     0,     0,     0,     0,     0,     0,
       0,  1386,  1392,  1346,     0,  2255,     0,     0,  1961,  2243,
       0,  1387,     0,     0,     0,     0,     0,     0,     0,     0,
    1393,     0,     0,     0,   870,     0,  1409,  1410,     0,     0,
       0,   868,   870,   870,   868,     0,  1347,     0,     0,     0,
       0,     0,  2245,     0,  3124,     0,     0,  1389,  1390,     0,
    5410,     0,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1394,  1395,     0,
       0,     0,  1897,  1391,     0,     0,  1901,     0,     0,     0,
    2243,     0,     0,  2012,     0,     0,     0,     0,  1348,     0,
    1540,     0,  1349,     0,     0,     0,  1540,  1917,  1918,  2245,
       0,     0,     0,     0,     0,     0,  1509,     0,     0,  1396,
       0,     0,     0,  1392,  1926,     0,     0,     0,     0,     0,
       0,     0,     0,   847,  1350,     0,  1563,  1564,     0,     0,
       0,  1393,     0,     0,     0,  1541,     0,     0,     0,     0,
       0,     0,     0,  1947,     0,     0,  1950,     0,   868,   868,
    1600,     0,  1548,  3443,     0,   868,     0,     0,     0,  2255,
    1351,     0,  1961,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1394,  1395,
    5411,     0,  1629,  1631,     0,     0,     0,     0,  1548,     0,
       0,  1352,     0,  1353,  1548,   847,   847,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1540,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1396,     0,     0,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   868,  2012,  2099,  2100,
    2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,
       0,   870,     0,     0,     0,   847,     0,     0,    33,     0,
       0,     0,  1356,     0,     0,     0,     0,     0,  1357,     0,
       0,     0,     0,     0,     0,  1358,     0,     0,     0,     0,
       0,     0,     0,  2413,   847,     0,     0,     0,     0,     0,
       0,     0,  1360,     0,   847,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,     0,   847,   847,     0,  1548,     0,
     847,     0,     0,     0,     0,     0,     0,   847,   847,     0,
       0,     0,   847,  1548,     0,     0,     0,     0,   847,   847,
       0,     0,   847,  2245,     0,   847,     0,  1540,     0,     0,
       0,     0,     0,     0,  1376,     0,     0,     0,     0,   847,
    1377,     0,  1362,   870,     0,     0,  3445,   847,     0,     0,
       0,   847,     0,     0,     0,     0,     0,     0,     0,   870,
       0,     0,     0,   847,     0,  1423,     0,  1363,   847,     0,
       0,     0,     0,   847,     0,     0,     0,     0,  1540,     0,
    1378,     0,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,
    2106,  2107,     0,     0,     0,     0,  1364,   870,   870,     0,
       0,     0,     0,     0,     0,     0,     0,   847,   870,     0,
    1365,     0,  1424,     0,     0,     0,  1804,  1540,     0,  1805,
     870,   870,     0,     0,     0,  1548,     0,     0,     0,     0,
    1379,     0,     0,     0,   870,     0,  1816,  1380,     0,     0,
    1381,   868,     0,     0,  2254,     0,   847,   847,     0,     0,
    1825,     0,     0,     0,     0,     0,   847,     0,     0,     0,
       0,     0,   847,     0,     0,     0,     0,  2243,     0,     0,
       0,     0,     0,     0,  1842,  1540,  1548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1804,
       0,  1425,  1805,     0,  1382,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1816,
     868,     0,  3575,     0,     0,  1548,     0,  2254,     0,     0,
       0,     0,   868,  1825,  2450,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,  1427,   868,     0,  1842,     0,     0,
       0,     0,     0,     0,  1428,     0,  1384,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1385,     0,     0,     0,
       0,     0,     0,  1548,  1386,     0,     0,  1897,     0,     0,
       0,  1901,     0,  1429,  1387,     0,     0,     0,     0,     0,
    2245,     0,   868,  2527,  2528,  2529,  2530,     0,     0,     0,
       0,     0,  1917,  1918,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3238,     0,  1926,
    1389,  1390,  1431,     0,     0,     0,     0,     0,     0,     0,
    1541,     0,     0,   847,  1541,  1541,     0,     0,  1540,  2573,
    2574,     0,     0,     0,   847,     0,  3239,  2583,  1947,     0,
    1897,  1950,     0,     0,  1901,     0,     0,  1433,     0,     0,
       0,     0,     0,     0,  2255,     0,     0,  1961,     0,     0,
       0,     0,     0,     0,     0,  1917,  1918,     0,     0,     0,
       0,     0,  3542,     0,     0,     0,  1392,     0,  2607,     0,
       0,     0,  1926,     0,     0,     0,     0,     0,     0,  1548,
       0,     0,     0,     0,  1393,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2642,  2643,  2644,  2645,   868,
       0,  1947,     0,     0,  1950,     0,     0,     0,     0,     0,
       0,     0,   847,     0,     0,     0,  1548,  2255,     0,     0,
    1961,     0,  2012,   847,     0,     0,     0,     0,  1541,     0,
       0,  1394,  1395,     0,  1540,   847,     0,     0,     0,     0,
       0,     0,     0,     0,   847,   847,     0,     0,   847,     0,
       0,     0,     0,     0,     0,     0,  2708,     0,     0,     0,
       0,   847,     0,  1540,     0,  2712,     0,   847,     0,     0,
       0,     0,   847,  1396,  2719,   847,     0,     0,     0,     0,
     847,   847,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2012,     0,     0,     0,   868,
       0,   868,     0,     0,     0,   847,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
       0,     0,  1548,     0,   847,   847,     0,   847,     0,     0,
       0,     0,     0,   847,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1548,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2099,  2100,  2101,
     868,  2102,  2103,  2104,  2105,  2106,  2107,     0,     0,   847,
       0,     0,     0,  1541,     0,     0,     0,     0,     0,     0,
       0,  2243,     0,     0,     0,  1540,     0,     0,     0,     0,
    1540,     0,     0,     0,     0,  1804,     0,     0,  1805,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2243,     0,
     868,     0,  1540,     0,     0,  1816,     0,     0,     0,     0,
       0,     0,     0,  2254,     0,     0,   847,     0,     0,  1825,
    2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,
       0,  2888,     0,     0,     0,     0,     0,  1543,  1804,     0,
    1540,  1805,  1541,  1842,     0,     0,     0,     0,  1541,     0,
     587,     0,     0,     0,     0,     0,   639,   587,  1816,     0,
       0,  3587,   685,     0,   587,     0,  2254,     0,     0,   587,
       0,   736,  1825,  1548,     0,     0,   847,     0,  1548,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     800,     0,     0,     0,     0,     0,  1842,   847,     0,   847,
    1548,     0,   847,     0,   847,     0,     0,     0,     0,     0,
       0,     0,     0,  1540,     0,     0,     0,  1540,  1540,     0,
       0,     0,     0,     0,   847,     0,     0,     0,     0,   847,
    3580,     0,     0,   847,  1541,     0,     0,     0,  1548,     0,
       0,     0,     0,   847,     0,     0,  1897,   870,     0,     0,
    1901,  2245,   870,     0,     0,   870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1917,  1918,     0,     0,     0,     0,   870,  1543,     0,
       0,     0,     0,     0,     0,   847,     0,     0,  1926,     0,
       0,  2243,     0,     0,     0,     0,     0,     0,     0,  1897,
       0,     0,     0,  1901,     0,     0,     0,     0,     0,     0,
       0,  1548,     0,     0,     0,  1548,  1548,  1947,     0,     0,
    1950,     0,   870,     0,  1917,  1918,     0,     0,     0,     0,
       0,     0,     0,  2255,     0,     0,  1961,   858,     0,     0,
       0,  1926,   870,   870,     0,     0,     0,     0,   894,   895,
       0,   898,     0,     0,   904,     0,   906,     0,     0,     0,
     914,   847,  1540,  1540,     0,     0,     0,     0,     0,     0,
    1947,     0,     0,  1950,  2245,   870,     0,     0,     0,  2245,
     847,     0,     0,     0,     0,     0,  2255,     0,     0,  1961,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1548,     0,     0,     0,     0,     0,
       0,  2012,     0,   870,     0,     0,     0,   870,     0,     0,
       0,   847,     0,     0,   847,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   870,     0,     0,   847,     0,
     847,     0,   847,     0,     0,     0,   870,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   870,
    1548,  1548,     0,     0,  2012,     0,   847,     0,     0,     0,
     870,     0,     0,     0,     0,     0,     0,   870,     0,     0,
       0,     0,     0,     0,  1541,  1543,     0,  1541,     0,  1541,
       0,     0,     0,   868,  1541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2245,   847,     0,
       0,     0,     0,     0,  1541,  1543,     0,     0,     0,     0,
     847,   847,     0,     0,     0,     0,     0,     0,     0,     0,
     847,     0,     0,     0,     0,   868,  2099,  2100,  2101,     0,
    2102,  2103,  2104,  2105,  2106,  2107,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   847,  1543,     0,     0,     0,
    1541,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   870,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2099,
    2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,     0,
       0,     0,     0,     0,   847,  1804,     0,     0,  1805,   870,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   847,     0,     0,     0,  1816,     0,     0,  4153,  3075,
    3076,  3077,     0,  2254,     0,     0,     0,  1543,  3087,  1825,
    3089,     0,  3091,  3092,     0,   870,  1804,     0,     0,  1805,
    1376,  2243,  1541,     0,  1541,     0,  1377,     0,     0,     0,
       0,     0,     0,  1842,     0,     0,  1816,     0,   870,     0,
       0,     0,     0,     0,  2254,  1543,     0,     0,     0,     0,
    1825,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1378,     0,     0,     0,
    1543,     0,  1540,     0,  1842,     0,     0,     0,     0,     0,
       0,  2243,   961,     0,     0,     0,  1541,     0,     0,   847,
     969,     0,     0,     0,     0,     0,     0,     0,     0,   985,
     986,  2243,     0,     0,   988,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1379,     0,     0,     0,
       0,  1008,     0,  1380,  2245,     0,  1381,     0,     0,     0,
    1541,  2245,     0,  1543,  3243,  1016,  1897,     0,   847,     0,
    1901,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,  1043,     0,  1045,     0,  1048,
       0,  1917,  1918,     0,  1541,     0,     0,     0,     0,  2243,
    1548,  2243,     0,     0,     0,     0,     0,  1897,  1926,     0,
    1382,  1901,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3321,   587,
       0,     0,  1917,  1918,     0,     0,  3330,  1947,     0,     0,
    1950,  3331,  2243,     0,     0,     0,     0,     0,   870,  1926,
       0,     0,  1107,  2255,  1108,  2243,  1961,     0,     0,     0,
    1211,     0,     0,  1541,     0,     0,     0,     0,     0,     0,
    1383,     0,  1384,     0,     0,     0,     0,     0,  1947,     0,
       0,  1950,  1385,     0,  1541,     0,     0,     0,     0,     0,
    1386,  1272,     0,     0,  2255,     0,  1541,  1961,     0,     0,
    1387,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     800,     0,     0,     0,     0,     0,     0,     0,     0,   870,
       0,     0,     0,     0,  3421,     0,     0,     0,     0,     0,
       0,  2012,     0,  3251,   870,   870,  1389,  1390,  1376,     0,
       0,     0,     0,     0,  1377,     0,     0,     0,     0,     0,
    1543,     0,     0,     0,     0,     0,     0,     0,  3461,     0,
    3463,   870,  3252,     0,   870,     0,     0,  1541,     0,  1336,
       0,     0,  2012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1378,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1392,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,     0,     0,     0,     0,
    1393,     0,     0,     0,     0,     0,     0,     0,  1478,     0,
    1481,     0,     0,     0,  1379,     0,     0,     0,     0,     0,
       0,  1380,     0,     0,  1381,  1493,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3515,     0,  1541,  1503,     0,
       0,     0,  2245,  2245,  2245,  1505,  1376,  1394,  1395,     0,
       0,     0,  1377,     0,     0,     0,     0,  1552,     0,     0,
    1556,     0,     0,     0,     0,     0,  2099,  2100,  2101,     0,
    2102,  2103,  2104,  2105,  2106,  2107,   870,     0,  1382,     0,
       0,     0,     0,     0,     0,  1588,     0,     0,   870,  1396,
       0,     0,  1378,     0,     0,     0,     0,  1604,     0,   870,
       0,     0,     0,     0,     0,     0,     0,  2099,  2100,  2101,
       0,  2102,  2103,  2104,  2105,  2106,  2107,  1376,     0,     0,
       0,     0,     0,  1377,     0,     0,  1541,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1383,     0,
    1384,     0,  1379,     0,     0,  1650,     0,     0,     0,  1380,
    1385,     0,  1381,     0,     0,     0,     0,     0,  1386,     0,
       0,     0,     0,  1378,     0,   587,     0,   587,  1387,   587,
       0,   587,     0,   587,   587,   587,     0,     0,     0,     0,
     587,     0,     0,     0,     0,     0,   651,   870,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   652,     0,
       0,  3291,     0,     0,  1389,  1390,  1382,     0,     0,  1736,
       0,     0,     0,  1379,     0,     0,     0,     0,     0,   653,
    1380,     0,     0,  1381,     0,     0,  2245,     0,     0,     0,
    3292,     0,   654,     0,     0,     0,     0,  1541,  1760,     0,
       0,   870,     0,   870,     0,     0,   655,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   870,     0,
     870,     0,     0,   656,     0,     0,  1383,     0,  1384,     0,
    1392,  1790,  1791,     0,  1794,     0,     0,  1382,  1385,     0,
       0,     0,     0,     0,   657,     0,  1386,     0,  1393,     0,
       0,     0,     0,  2117,     0,   658,  1387,     0,     0,     0,
       0,     0,     0,   659,   660,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   661,   870,     0,     0,  3739,
     662,  3740,  3741,  3742,     0,     0,   663,     0,     0,  3758,
       0,     0,  1389,  1390,  2153,  1394,  1395,  1383,     0,  1384,
       0,   664,     0,     0,     0,   870,     0,     0,     0,  1385,
       0,     0,     0,     0,     0,     0,     0,  1386,  3759,   870,
       0,     0,     0,     0,     0,     0,  2270,  1387,     0,   800,
    2282,  2287,     0,     0,     0,     0,   870,  1396,     0,   870,
       0,     0,     0,     0,     0,     0,     0,   665,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1392,     0,
    3827,     0,     0,  1389,  1390,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1393,  1541,     0,     0,
       0,   666,     0,     0,     0,     0,     0,     0,     0,  3828,
       0,     0,   667,     0,     0,  1543,  2388,     0,     0,  1543,
    1543,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,     0,     0,  1541,     0,     0,     0,     0,     0,  1541,
    2245,     0,     0,  1394,  1395,     0,     0,     0,     0,  1392,
       0,     0,     0,     0,     0,     0,     0,   668,     0,     0,
       0,   669,     0,   670,     0,     0,     0,  1393,     0,   671,
       0,     0,   672,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1396,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   673,     0,
     674,     0,     0,     0,   675,     0,     0,     0,     0,     0,
       0,     0,   676,     0,  1394,  1395,     0,   677,     0,     0,
       0,     0,     0,     0,   928,     0,     0,     0,     0,   678,
       0,     0,     0,  1543,     0,     0,     0,     0,     0,     0,
       0,     0,   679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,     0,  1396,   929,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1541,     0,
     930,   931,     0,     0,     0,     0,     0,     0,     0,     0,
     932,     0,     0,     0,   933,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   934,     0,     0,     0,     0,   870,     0,   680,     0,
       0,     0,     0,     0,     0,   681,     0,     0,     0,     0,
       0,     0,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2617,   936,     0,     0,     0,     0,     0,     0,
       0,   937,     0,     0,     0,     0,     0,  2640,     0,     0,
       0,     0,     0,   938,     0,     0,     0,     0,   939,  1544,
       0,     0,     0,  2245,     0,     0,     0,     0,     0,  2245,
       0,  2245,     0,     0,     0,     0,     0,     0,  2681,   940,
    1541,     0,     0,     0,     0,  4068,     0,     0,  4069,     0,
       0,     0,     0,     0,  2692,     0,     0,     0,  1543,     0,
       0,     0,     0,     0,   941,     0,     0,  2245,     0,  2707,
       0,  2709,     0,  2710,     0,     0,     0,     0,  2711,     0,
       0,     0,     0,     0,     0,   942,     0,     0,     0,   870,
       0,  1541,   870,  4095,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   587,     0,   587,     0,   587,     0,   587,
       0,   587,     0,     0,     0,   587,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1541,     0,     0,     0,     0,     0,     0,  1543,  2245,     0,
       0,     0,     0,  1543,     0,     0,     0,     0,   203,     0,
       0,     0,     0,     0,  2807,     0,     0,     0,     0,     0,
    1544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,  1545,  2830,     0,   945,
    2832,   946,     0,  2843,     0,     0,     0,   947,  1541,     0,
     948,  2852,  2857,     0,     0,     0,  2862,  2864,     0,     0,
    2869,     0,  2871,     0,     0,  2874,   870,   870,     0,     0,
       0,     0,     0,   870,     0,     0,   949,     0,   950,     0,
       0,     0,   951,     0,     0,     0,     0,     0,     0,  1543,
     952,     0,  2882,     0,     0,   953,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   870,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2889,     0,     0,     0,  1545,     0,     0,
       0,     0,     0,  4284,  4285,  4286,  4287,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,     0,     0,     0,
       0,     0,  2901,     0,     0,     0,     0,     0,     0,     0,
       0,  1541,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4395,  4396,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,  1544,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1543,
       0,     0,  1543,     0,  1543,     0,     0,     0,     0,  1543,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   870,
       0,     0,     0,     0,     0,  2910,  2911,  2912,  2913,  2914,
    2915,  2916,  2917,  2918,  1545,  2919,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2245,  1211,  2947,     0,  1543,
       0,     0,     0,     0,     0,  4489,     0,     0,     0,  1544,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   870,     0,
       0,     0,     0,     0,  1545,  1543,     0,  1544,     0,     0,
     870,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1544,   870,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1545,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1541,     0,
       0,     0,     0,  1541,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     870,     0,     0,     0,     0,  1541,     0,     0,     0,     0,
       0,     0,     0,  1272,     0,  1544,     0,  1543,     0,  1543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1790,
    1791,     0,     0,  1541,     0,     0,  1545,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,     0,     0,  1545,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3030,  3031,
       0,     0,     0,  3034,  3035,     0,     0,  3038,     0,  1545,
       0,     0,     0,  3062,     0,     0,  1541,  3048,     0,     0,
    1541,  1541,     0,     0,  3057,  1543,     0,   870,  3060,  3061,
       0,     0,  3064,  3065,     0,     0,     0,     0,     0,  3070,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3086,     0,  3088,     0,     0,     0,     0,     0,  1543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1545,  3114,     0,     0,     0,     0,  3116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3123,     0,     0,     0,     0,     0,
       0,     0,  1544,  3143,     0,     0,     0,     0,  3148,  3149,
    3152,  3154,     0,     0,     0,     0,     0,     0,  3164,  3167,
       0,     0,     0,     0,     0,     0,  3178,   870,  1543,   870,
       0,  3188,     0,     0,     0,     0,     0,     0,     0,  3198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,  4740,     0,     0,  1541,  1541,     0,  3237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3244,
       0,  3246,     0,     0,     0,     0,  3249,     0,     0,     0,
    3250,     0,  3254,  3255,  3256,  3257,     0,  3259,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   870,     0,
    3283,  3284,     0,  3286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3294,  3295,  3296,     0,  4786,  2245,
       0,     0,  1543,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4789,     0,     0,     0,     0,  3339,     0,     0,
       0,     0,  1543,     0,     0,     0,  2245,     0,   870,  1545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1543,     0,     0,     0,     0,     0,     0,     0,  3367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1543,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4856,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3475,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3500,     0,     0,     0,     0,     0,  2245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3522,     0,     0,     0,     0,  3529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4968,  4740,  4740,     0,     0,     0,     0,     0,  2857,
       0,  2857,  2857,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1543,  3590,     0,     0,  3593,     0,     0,     0,
       0,     0,  3600,     0,     0,  1541,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5001,  3621,
       0,  3623,     0,     0,     0,  3626,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2947,  2947,  2947,
       0,     0,     0,     0,     0,     0,     0,  1544,     0,     0,
       0,  1544,  1544,     0,  3670,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2270,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3672,     0,  2287,     0,     0,     0,     0,     0,     0,
       0,   870,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5104,
    3710,  3711,  1543,  3719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   870,     0,  1544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,  1543,     0,
       0,     0,  3733,     0,  1543,     0,     0,     0,     0,     0,
       0,  3737,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,     0,  3748,  3750,  1545,  1545,
       0,  3750,     0,     0,     0,     0,  3761,  3762,  3763,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3802,  3803,  3804,  3805,     0,     0,  2245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5190,     0,  5192,     0,     0,     0,     0,     0,  1543,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1543,     0,     0,     0,  3826,     0,  3830,
    3831,  3832,  1545,     0,     0,     0,     0,     0,     0,  3845,
    1544,     0,     0,     0,     0,     0,     0,     0,     0,  2245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3897,     0,     0,     0,     0,     0,     0,  1544,
       0,     0,     0,     0,  4740,  1544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1543,     0,  2245,  3912,  2245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2245,     0,     0,     0,     0,     0,  1543,     0,  5317,     0,
       0,     0,  3983,  2245,     0,     0,     0,  1545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1543,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4014,     0,     0,
       0,     0,  4018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5369,     0,
    2109,     0,     0,     0,     0,     0,  1545,     0,     0,     0,
    4060,     0,  1545,  1543,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4070,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4101,     0,     0,     0,     0,  5424,     0,     0,     0,     0,
    4105,     0,     0,     0,     0,     0,  4106,     0,  4107,  2109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1545,     0,
    4125,  4126,     0,  2109,     0,     0,     0,     0,  2839,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4140,     0,     0,     0,     0,  2864,     0,     0,     0,     0,
    4154,     0,     0,  2109,  2109,     0,     0,  2109,     0,     0,
    4161,     0,     0,  4164,     0,  4166,     0,     0,     0,     0,
       0,     0,     0,     0,  4170,     0,     0,     0,     0,     0,
    4175,     0,     0,  4178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1543,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1544,  4220,     0,  1544,     0,  1544,     0,  4227,  2947,
       0,  1544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4238,     0,     0,     0,     0,     0,
    1211,     0,     0,     0,     0,     0,  1272,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4278,     0,  4279,     0,     0,     0,     0,     0,
       0,  4281,  1543,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4290,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1543,     0,  4298,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1545,  4332,
       0,  1545,     0,  1545,     0,     0,     0,     0,  1545,     0,
       0,     0,     0,     0,     0,     0,     0,  4337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1544,
       0,  1544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1545,     0,
       0,     0,     0,     0,     0,     0,  4397,  4398,  4399,     0,
       0,  4402,  4403,  4404,  4405,  4406,     0,     0,     0,     0,
    4413,  4414,     0,  4416,  4417,  4418,  4419,  4420,  4421,  4422,
       0,     0,     0,     0,     0,     0,     0,     0,  4430,     0,
       0,  4432,  4433,  1544,  1545,     0,     0,     0,     0,     0,
    2109,     0,     0,  1543,     0,     0,     0,     0,  1543,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1543,     0,     0,     0,     0,     0,  2109,  1544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4483,  4485,  4487,     0,     0,
    4490,     0,     0,     0,     0,     0,     0,     0,  1543,     0,
       0,  1544,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1545,     0,  1545,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4551,  4552,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1544,  1543,     0,     0,     0,  1543,  1543,     0,     0,  3750,
    1545,     0,     0,  2109,     0,     0,     0,     0,     0,     0,
       0,  1544,     0,     0,     0,  2109,     0,     0,     0,     0,
    2109,     0,     0,  1544,     0,     0,  4583,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4603,  4605,  1545,     0,
       0,  4611,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4616,  1544,     0,     0,     0,     0,  4621,
    4622,     0,     0,  4624,     0,     0,  4627,     0,     0,     0,
       0,     0,     0,     0,  1544,     0,     0,     0,     0,     0,
    4637,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1543,  1543,  1544,     0,  2947,     0,     0,  1545,     0,  2947,
       0,     0,     0,     0,  2947,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1545,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1545,     0,     0,     0,  1544,     0,     0,     0,  4678,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4697,  4698,  4699,  4700,     0,     0,
    4702,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1545,     0,  1544,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1545,
       0,     0,     0,     0,  4757,  4758,  4759,  4760,     0,  4762,
    4763,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4772,  4773,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1545,     0,     0,  4782,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1544,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4827,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1545,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4843,     0,     0,     0,     0,     0,     0,     0,     0,
    4849,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4870,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4894,     0,
    1543,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4918,     0,     0,     0,
    2109,  1545,     0,     0,     0,     0,     0,     0,     0,  4922,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2109,  1544,  2109,     0,  2839,  2839,  3560,
       0,     0,  2839,     0,     0,     0,  2109,     0,     0,     0,
       0,  4951,  4952,     0,     0,  2109,     0,     0,     0,     0,
    2109,     0,     0,     0,     0,  2109,     0,  2109,     0,     0,
    1544,     0,  2109,     0,  2109,     0,  1544,  2109,   587,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,     0,  2839,
    2839,     0,  2109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2109,     0,  2947,     0,  2947,     0,
       0,  2109,     0,  2109,  2109,  2109,  2109,  2109,  2109,  2109,
    2109,  2109,  2109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4993,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5014,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1544,  1545,     0,     0,     0,     0,  5029,     0,     0,     0,
       0,     0,     0,     0,     0,  1544,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1545,     0,     0,
       0,     0,     0,  1545,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5117,     0,
       0,     0,  3750,  2864,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,  5132,     0,     0,     0,     0,
    5135,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1794,     0,     0,  1545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1545,     0,     0,     0,     0,     0,  1544,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1544,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5180,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1544,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,     0,     0,     0,     0,     0,
       0,  5223,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2270,     0,     0,  1545,  3750,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2109,  4951,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,     0,     0,  5285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5279,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1545,     0,     0,     0,  5312,     0,  1544,     0,
       0,  5316,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5342,  5342,     0,     0,     0,     0,     0,     0,     0,
       0,  4951,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5364,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,     0,     0,
       0,     0,  2109,     0,     0,  5342,     0,     0,     0,     0,
       0,     0,     0,     0,  1544,     0,     0,     0,  3560,  3560,
       0,  2839,  5419,     0,  2839,  2839,  2839,  2839,  2839,  2839,
    2839,  2839,  2839,  2839,  3560,     0,     0,     0,     0,     0,
       0,     0,     0,  1544,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1545,     0,     0,     0,     0,
       0,     0,     0,  2109,     0,     0,  2109,     0,     0,     0,
       0,     0,     0,  2109,     0,     0,     0,     0,  3560,  3560,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2839,  2839,  2109,     0,  2109,     0,     0,  2109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1544,     0,     0,     0,     0,
    1544,     0,  2109,     0,     0,     0,     0,     0,     0,     0,
    1545,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1544,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1544,     0,     0,     0,  1544,  1544,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1545,     0,     0,     0,     0,  1545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2839,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1544,  1544,     0,     0,     0,     0,     0,     0,
    1545,     0,     0,     0,  1545,  1545,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2109,     0,     0,     0,  2109,  2109,
    2109,     0,     0,  3560,     0,     0,     0,     0,  3560,  3560,
    3560,  3560,  3560,  3560,  3560,  3560,  3560,  3560,  2109,  2109,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2109,     0,  1545,
    1545,     0,     0,     0,  2109,  2839,  2839,  2109,     0,  2109,
       0,     0,     0,  2109,  3560,  3560,     0,     0,  2109,     0,
       0,  2109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2109,     0,     0,     0,     0,     0,     0,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3560,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1545,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2109,  2109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2109,     0,     0,     0,
    2839,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2109,     0,  2109,     0,
       0,     0,     0,     0,  2109,     0,     0,  3560,  3560,  2109,
       0,     0,  2839,  2839,  2109,  2109,     0,  2109,     0,     0,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3560,  2839,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2109,     0,  3560,  3560,  2109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2109,  2109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2109,  3560,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,  2109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2109,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2109,   222,   223,   224,   225,   226,   227,   228,
     229,  2155,   231,   232,   233,  2156,  2157,  2158,  2159,  2160,
    2161,  2162,   234,   235,  2163,   236,   237,   821,   238,   239,
     240,   241,   242,   822,   243,   244,  2164,   245,   246,   247,
     248,   249,  2165,  2166,   250,   251,   252,   253,   254,  2167,
     255,   256,   257,   258,   259,  2168,   823,  2169,   260,   261,
     262,   263,   264,   824,   265,   266,  2170,   267,   268,   269,
     270,   271,   272,  2171,   825,  5480,   274,  2172,  2173,  2174,
     826,  2175,  2176,  2177,   275,   276,   277,   278,   279,   280,
     281,   282,   283,  2178,   284,  2179,   285,   286,   287,  5481,
     289,  2180,   290,   291,   292,  2181,  2182,   293,   294,   295,
     296,   297,  2183,   298,   299,   300,  2184,   301,  5482,   303,
    2185,  2186,   304,   305,   306,   307,   308,   309,   310,   311,
    2187,   312,  2188,   313,   314,   315,  2189,  2190,  5483,  2191,
     317,   827,  2192,   828,   318,   319,   320,  2193,   321,   322,
    2194,   323,  2195,  5484,   325,   326,   327,   328,   829,   329,
     330,   331,  2196,   332,   333,   334,   335,   336,   337,  2197,
     338,   830,   339,   340,   341,   342,   343,   344,   345,  2198,
     346,  2199,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,  2200,   354,   355,  2201,   356,   357,   834,   358,
     835,  2202,   359,   360,   361,  2203,  2204,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   836,   379,   380,   381,   382,  2205,
     383,   384,   837,   385,  5485,   386,   387,   388,   389,   390,
     391,  2207,   392,  2208,  2209,   393,   394,   395,  2210,  2211,
     396,   397,   838,   398,   839,   399,   400,   401,   402,   403,
    2212,   404,   405,  2213,   406,   407,  2214,   408,   409,   410,
     411,  2215,   412,   413,   414,   415,   416,  5486,   418,   419,
     420,   421,   422,   423,   424,  2216,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  2217,   436,   437,
     840,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  2218,   449,   450,   451,   452,   453,  2219,   454,
     455,   456,   457,   841,   458,   459,   460,  2220,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,  2221,
     472,   473,  2222,   474,   475,   476,   477,   478,   479,  2223,
     480,   481,  2224,  2225,   482,   483,   484,   485,  2226,   486,
     487,   488,   489,  2227,   490,   491,  2228,  2229,   492,   493,
     494,   495,   496,  2230,  2231,   497,   498,   499,   500,   501,
     502,   503,  2232,   504,   842,   505,   506,   507,   508,  2233,
    2234,   509,  2235,  2236,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,  2237,   534,
    2238,   535,   536,   537,   538,   539,   540,  5487,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   843,   552,
     553,   554,   555,  5488,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,  2239,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,     0,  2154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5489,   222,   223,   224,   225,   226,   227,   228,
     229,  2155,   231,   232,   233,  2156,  2157,  2158,  2159,  2160,
    2161,  2162,   234,   235,  2163,   236,   237,   821,   238,   239,
     240,   241,   242,   822,   243,   244,  2164,   245,   246,   247,
     248,   249,  2165,  2166,   250,   251,   252,   253,   254,  2167,
     255,   256,   257,   258,   259,  2168,   823,  2169,   260,   261,
     262,   263,   264,   824,   265,   266,  2170,   267,   268,   269,
     270,   271,   272,  2171,   825,   273,   274,  2172,  2173,  2174,
     826,  2175,  2176,  2177,   275,   276,   277,   278,   279,   280,
     281,   282,   283,  2178,   284,  2179,   285,   286,   287,   288,
     289,  2180,   290,   291,   292,  2181,  2182,   293,   294,   295,
     296,   297,  2183,   298,   299,   300,  2184,   301,   302,   303,
    2185,  2186,   304,   305,   306,   307,   308,   309,   310,   311,
    2187,   312,  2188,   313,   314,   315,  2189,  2190,   316,  2191,
     317,   827,  2192,   828,   318,   319,   320,  2193,   321,   322,
    2194,   323,  2195,   324,   325,   326,   327,   328,   829,   329,
     330,   331,  2196,   332,   333,   334,   335,   336,   337,  2197,
     338,   830,   339,   340,   341,   342,   343,   344,   345,  2198,
     346,  2199,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,  2200,   354,   355,  2201,   356,   357,   834,   358,
     835,  2202,   359,   360,   361,  2203,  2204,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   836,   379,   380,   381,   382,  2205,
     383,   384,   837,   385,  2206,   386,   387,   388,   389,   390,
     391,  2207,   392,  2208,  2209,   393,   394,   395,  2210,  2211,
     396,   397,   838,   398,   839,   399,   400,   401,   402,   403,
    2212,   404,   405,  2213,   406,   407,  2214,   408,   409,   410,
     411,  2215,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  2216,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  2217,   436,   437,
     840,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  2218,   449,   450,   451,   452,   453,  2219,   454,
     455,   456,   457,   841,   458,   459,   460,  2220,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,  2221,
     472,   473,  2222,   474,   475,   476,   477,   478,   479,  2223,
     480,   481,  2224,  2225,   482,   483,   484,   485,  2226,   486,
     487,   488,   489,  2227,   490,   491,  2228,  2229,   492,   493,
     494,   495,   496,  2230,  2231,   497,   498,   499,   500,   501,
     502,   503,  2232,   504,   842,   505,   506,   507,   508,  2233,
    2234,   509,  2235,  2236,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,  2237,   534,
    2238,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   843,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,  2239,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,     0,   820,  1124,   646,  1125,  1126,  1127,   701,  1128,
       0,     0,  5567,   222,   223,   224,   225,   226,   227,   228,
     229,  2941,   231,   232,   233,     0,     0,     0,     0,  1129,
       0,     0,   234,   235,     0,   236,   237,   821,   238,   239,
     240,   241,  1130,   822,  1131,  1132,     0,   245,   246,   247,
     248,   249,  1133,  1134,   250,   251,  1135,  1136,   254,     0,
     255,   256,   257,   258,  1137,     0,  1138,     0,   260,   261,
     262,   263,   264,   824,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,   825,   273,   274,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,   280,
    1146,  1147,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,  2942,     0,   293,   294,  1148,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,  1149,   308,   309,   310,  1150,
    1151,   312,     0,   313,   314,  1152,     0,     0,   316,     0,
     317,   827,     0,   828,   318,   319,   320,     0,   321,  1153,
       0,   323,     0,   324,   325,   326,   327,   328,   829,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,   830,   339,   340,   341,   342,   343,  1154,  1155,     0,
    1156,     0,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,  1157,   834,   358,
     835,     0,   359,   360,   361,  1158,  1159,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1160,   836,  1161,   380,   381,   382,  1162,
     383,   384,   837,   385,  1163,  1164,   387,  1165,   389,   390,
     391,     0,   392,     0,     0,  1166,   394,   395,     0,     0,
     396,   397,   838,   398,   839,  1167,   400,   401,   402,   403,
       0,   404,   405,     0,   406,  1168,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
    1169,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
     840,   438,   439,  1170,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,  1171,   454,
     455,   456,   457,   841,   458,  1172,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,  1173,     0,
     472,   473,  1174,   474,   475,   476,   477,   478,   479,     0,
    1175,  1176,     0,     0,   482,  1177,   484,  1178,  1179,   486,
     487,   488,   489,     0,   490,   491,     0,  1180,   492,   493,
     494,   495,   496,  1181,     0,   497,   498,   499,   500,   501,
     502,  1182,  2943,   504,   842,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
     516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,   525,
     526,   527,   528,   529,   530,   531,   532,   533,  1191,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
    1192,  1193,   546,   547,   548,   549,   550,   551,   843,   552,
    1194,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,     0,  1195,  1196,  2944,     0,     0,     0,     0,     0,
       0,  1198,  2945,   820,  1124,   646,  1125,  1126,  1127,   701,
    1128,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
    1129,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,  1130,   822,  1131,  1132,     0,   245,   246,
     247,   248,   249,  1133,  1134,   250,   251,  1135,  1136,   254,
       0,   255,   256,   257,   258,  1137,     0,  1138,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,  1139,  1140,
    1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,
     280,  1146,  1147,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
    1148,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,  1149,   308,   309,   310,
    1150,  1151,   312,     0,   313,   314,  1152,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
    1153,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,  1154,  1155,
       0,  1156,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,  1157,   834,
     358,   835,     0,   359,   360,   361,  1158,  1159,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1160,   836,  1161,   380,   381,   382,
    1162,   383,   384,   837,   385,  1163,  1164,   387,  1165,   389,
     390,   391,     0,   392,     0,     0,  1166,   394,   395,     0,
       0,   396,   397,   838,   398,   839,  1167,   400,   401,   402,
     403,     0,   404,   405,     0,   406,  1168,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,  1169,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,  1170,   441,   442,   443,   444,   445,
     446,   447,   448,    38,   449,   450,   451,   452,   453,  1171,
     454,   455,   456,   457,   841,   458,  1172,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,  1173,
       0,   472,   473,  1792,   474,   475,   476,   477,   478,   479,
       0,  1175,  1176,     0,     0,   482,  1177,   484,  1178,  1179,
     486,   487,   488,   489,     0,   490,   491,     0,  1180,   492,
     493,   494,   495,   496,  1181,     0,   497,   498,   499,   500,
     501,  1063,  1182,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,    47,   510,   511,   512,   513,   514,
     515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  1191,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,  1192,  1193,   546,   547,   548,   549,   550,   551,   843,
     552,  1194,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,     0,
       0,     0,     0,  1195,  1196,     0,     0,     0,     0,     0,
       0,     0,  1198,  5146,   820,  1124,   646,  1125,  1126,  1127,
     701,  1128,     0,     0,     0,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,  1129,     0,     0,   234,   235,     0,   236,   237,   821,
     238,   239,   240,   241,  1130,   822,  1131,  1132,     0,   245,
     246,   247,   248,   249,  1133,  1134,   250,   251,  1135,  1136,
     254,     0,   255,   256,   257,   258,  1137,     0,  1138,     0,
     260,   261,   262,   263,   264,   824,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,   825,   273,   274,  1139,
    1140,  1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,
     279,   280,  1146,  1147,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,  1148,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,  1149,   308,   309,
     310,  1150,  1151,   312,     0,   313,   314,  1152,     0,     0,
     316,     0,   317,   827,     0,   828,   318,   319,   320,     0,
     321,  1153,     0,   323,     0,   324,   325,   326,   327,   328,
     829,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,   830,   339,   340,   341,   342,   343,  1154,
    1155,     0,  1156,     0,   347,   831,   832,   348,   833,   349,
     350,   351,   352,   353,     0,   354,   355,     0,   356,  1157,
     834,   358,   835,     0,   359,   360,   361,  1158,  1159,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1160,   836,  1161,   380,   381,
     382,  1162,   383,   384,   837,   385,  1163,  1164,   387,  1165,
     389,   390,   391,     0,   392,     0,     0,  1166,   394,   395,
       0,     0,   396,   397,   838,   398,   839,  1167,   400,   401,
     402,   403,     0,   404,   405,     0,   406,  1168,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,  1169,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   840,   438,   439,  1170,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,   453,
    1171,   454,   455,   456,   457,   841,   458,  1172,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
    1173,     0,   472,   473,  1174,   474,   475,   476,   477,   478,
     479,     0,  1175,  1176,     0,     0,   482,  1177,   484,  1178,
    1179,   486,   487,   488,   489,     0,   490,   491,     0,  1180,
     492,   493,   494,   495,   496,  1181,     0,   497,   498,   499,
     500,   501,   502,  1182,     0,   504,   842,   505,   506,   507,
     508,     0,     0,   509,     0,     0,   510,   511,   512,   513,
     514,   515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,
    1190,   525,   526,   527,   528,   529,   530,   531,   532,   533,
    1191,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,  1192,  1193,   546,   547,   548,   549,   550,   551,
     843,   552,  1194,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,     0,     0,
       0,     0,     0,     0,  1195,  1196,   221,     0,     0,     0,
       0,     0,     0,  1198,  2841,     0,     0,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   231,   232,   233,     0,
       0,     0,     0,     0,  4198,     0,   234,   235,     0,   236,
     237,     0,   238,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,     0,
       0,     0,   260,   261,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,     0, -1776,   273,
     274,     0,     0,     0,     0,     0,     0,     0,   275,   276,
     277,   278,   279,   280,   281,   282,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
       0,     0,   316,     0,   317,     0,     0, -1776,   318,   319,
     320,     0,   321,   322,     0,   323,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,     0,   338, -1776,   339,   340,   341,   342,
     343,   344,   345,     0,   346,     0,   347,     0,     0,   348,
   -1776,   349,   350,   351,   352,   353,     0,   354,   355,     0,
     356,   357, -1776,   358,     0,     0,   359,   360,   361,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378, -1776,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437, -1776,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,   453,     0,   454,   455,   456,   457,     0,   458,   459,
     460,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,     0,   472,   473,     0,   474,   475,   476,
     477,   478,   479,     0,   480,   481,     0,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,     0,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,     0,   497,
     498,   499,   500,   501,   502,   503,     0,   504,     0,   505,
     506,   507,   508,     0,     0,   509,     0,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,     0,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
       0,     0,     0,     0,     0,     0,  1514,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1279,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   231,   232,   233,     0,
       0,     0,     0,     0,     0,     0,   234,   235,     0,   236,
     237,   821,   238,   239,   240,     0,  1515,   822,  1516,  1517,
       0,   245,   246,   247,   248,   249,     0,     0,   250,   251,
    1518,  1519,   254,     0,   255,   256,   257,   258,     0,     0,
     823,     0,   260,   261,   262,   263,   264,   824,   265,   266,
       0,   267,   268,   269,   270,   271,   272,     0,   825,   273,
     274,     0,     0,     0,   826,     0,     0,     0,   275,   276,
     277,   278,   279,   280,  1520,  1521,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
       0,   293,   294,  1148,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,     0,     0,   304,   305,   306,     0,
     308,   309,   310,     0,     0,   312,     0,   313,   314,  1522,
       0,     0,   316,     0,   317,   827,     0,   828,   318,   319,
     320,     0,   321,     0,     0,   323,     0,   324,   325,   326,
     327,   328,   829,   329,   330,   331,  2306,   332,   333,   334,
     335,   336,   337,     0,   338,   830,  2307,   340,   341,   342,
     343,  1523,  1524,     0,  1525,     0,   347,   831,   832,   348,
     833,   349,   350,   351,   352,   353,     0,   354,   355,     0,
     356,     0,   834,   358,   835,     0,   359,   360,   361,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,  1526,   836,  1527,
     380,   381,     0,     0,   383,   384,   837,   385,     0,     0,
     387,  1528,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,  2309,   838,   398,   839,     0,
     400,   401,   402,   403,     0,   404,   405,     0,   406,     0,
       0,     0,   409,   410,   411,     0,   412,   413,   414,   415,
     416,   417,   418,   419,  1529,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,   840,   438,   439,     0,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,   453,     0,   454,  2310,   456,   457,   841,   458,  1531,
     460,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,     0,     0,   472,   473,     0,   474,   475,   476,
     477,   478,   479,     0,  1532,  1533,     0,     0,   482,     0,
     484,     0,     0,   486,   487,   488,   489,     0,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,     0,   497,
     498,   499,   500,   501,     0,  1534,  2311,   504,   842,   505,
     506,   507,   508,     0,     0,   509,     0,     0,   510,   511,
     512,   513,   514,   515,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,     0,     0,   546,   547,   548,   549,
     550,   551,   843,   552,     0,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,     0,   574,     0,   575,   576,  1514,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  2416,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,     0,  1515,
     822,  1516,  1517,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,  1518,  1519,   254,     0,   255,   256,   257,
     258,     0,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,  1520,  1521,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,     0,   308,   309,   310,     0,     0,   312,     0,
     313,   314,  1522,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,     0,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,  2306,
     332,   333,   334,   335,   336,   337,     0,   338,   830,  2307,
     340,   341,   342,   343,  1523,  1524,     0,  1525,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,     0,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1526,   836,  1527,   380,   381,     0,     0,   383,   384,   837,
     385,     0,     0,   387,  1528,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,  2309,   838,
     398,   839,     0,   400,   401,   402,   403,     0,   404,   405,
       0,   406,     0,     0,     0,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1529,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
       0,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,  2310,   456,   457,
     841,   458,  1531,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,  1532,  1533,     0,
       0,   482,     0,   484,     0,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,     0,  1534,  2311,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,     0,     0,   546,
     547,   548,   549,   550,   551,   843,   552,     0,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,     0,   574,     0,
     575,   576,     0,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1514,
    1401,   646,     0,     0,   876,   701,     0,     0,     0,  3438,
     222,   223,   224,   225,   226,   227,   228,   229,  2155,   231,
     232,   233,  2156,  2157,  2158,  2159,  2160,  2161,  2162,   234,
     235,  2163,   236,   237,   821,   238,   239,   240,     0,  1515,
     822,  1516,  1517,  2164,   245,   246,   247,   248,   249,  2165,
    2166,   250,   251,  1518,  1519,   254,  2167,   255,   256,   257,
     258,     0,  2168,   823,  2169,   260,   261,   262,   263,   264,
     824,   265,   266,  2170,   267,   268,   269,   270,   271,   272,
    2171,   825,   273,   274,  2172,  2173,  2174,   826,  2175,  2176,
    2177,   275,   276,   277,   278,   279,   280,  1520,  1521,   283,
    2178,   284,  2179,   285,   286,   287,   288,   289,  2180,   290,
     291,   292,  2181,  2182,   293,   294,  1148,   296,   297,  2183,
     298,   299,   300,  2184,   301,   302,   303,  2185,  2186,   304,
     305,   306,     0,   308,   309,   310,     0,  2187,   312,  2188,
     313,   314,  1522,  2189,  2190,   316,  2191,   317,   827,  2192,
     828,   318,   319,   320,  2193,   321,     0,  2194,   323,  2195,
     324,   325,   326,   327,   328,   829,   329,   330,   331,  2196,
     332,   333,   334,   335,   336,   337,  2197,   338,   830,     0,
     340,   341,   342,   343,  1523,  1524,  2198,  1525,  2199,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,  2200,
     354,   355,  2201,   356,     0,   834,   358,   835,  2202,   359,
     360,   361,  2203,  2204,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1526,   836,  1527,   380,   381,  3944,  2205,   383,   384,   837,
     385,  2206,     0,   387,  1528,   389,   390,   391,  2207,   392,
    2208,  2209,  3945,   394,   395,  2210,  2211,   396,     0,   838,
     398,   839,     0,   400,   401,   402,   403,  2212,   404,   405,
    2213,   406,     0,  2214,     0,   409,   410,   411,  2215,   412,
     413,   414,   415,   416,   417,   418,   419,  1529,   421,   422,
     423,   424,  2216,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  2217,   436,   437,   840,   438,   439,
    3946,   441,   442,   443,   444,   445,   446,   447,   448,  2218,
     449,   450,   451,   452,   453,  2219,   454,  2310,   456,   457,
     841,   458,  1531,   460,  2220,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,  2221,   472,   473,  2222,
     474,   475,   476,   477,   478,   479,  2223,  1532,  1533,  2224,
    2225,   482,     0,   484,     0,  2226,   486,   487,   488,   489,
    2227,   490,   491,  2228,  2229,   492,   493,   494,   495,   496,
    2230,  2231,   497,   498,   499,   500,   501,     0,  1534,  2232,
     504,   842,   505,   506,   507,   508,  2233,  2234,   509,  2235,
    2236,   510,   511,   512,   513,   514,   515,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  2237,   534,  2238,   535,   536,
     537,   538,   539,   540,   541,   542,   543,     0,     0,   546,
     547,   548,   549,   550,   551,   843,   552,     0,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,     0,   574,  2239,
     575,   576,     0,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,   879,   880,   881,     0,  3947,
    3948,   884,   885,   886,   887,     0,     0,     0,  5565,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,  2853,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,  2854,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,  2855,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
    2856,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,    38,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1792,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,  1063,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
      47,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,  1731,  2799,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,  1197,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
    1271,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,  2280,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,  2854,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,  4228,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,  5339,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,  5340,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
    5341,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,  5340,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
    5341,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  2283,
    2284,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    2988,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
    3521,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,  4237,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,  4594,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,  4604,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  1198,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,  1162,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,  1180,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,  4945,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  4946,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,  4947,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  1195,
    1196,     0,     0,     0,     0,     0,     0,     0,  4948,   820,
    1124,   646,  1125,  1126,  1127,   701,  1128,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,  1129,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,  1130,
     822,  1131,  1132,     0,   245,   246,   247,   248,   249,  1133,
    1134,   250,   251,  1135,  1136,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,  1146,  1147,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,  1149,   308,   309,   310,  1150,  1151,   312,     0,
     313,   314,  1152,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,  1154,  1155,     0,  1156,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1160,   836,  1161,   380,   381,   382,     0,   383,   384,   837,
     385,  1163,  1164,   387,  1165,   389,   390,   391,     0,   392,
       0,     0,  1166,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1169,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
    1170,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,  1172,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,  1174,
     474,   475,   476,   477,   478,   479,     0,  1175,  1176,     0,
       0,   482,  1177,   484,  1178,  1179,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,  1182,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  1191,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,     0,  2834,
    2835,     0,     0,   820,  1124,   646,  1125,  1126,  1198,   701,
    1128,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
    1129,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,  1130,   822,  1131,  1132,     0,   245,   246,
     247,   248,   249,  1133,  1134,   250,   251,  1135,  1136,   254,
       0,   255,   256,   257,   258,  1137,     0,  1138,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,  1139,  1140,
    1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,
     280,  1146,  1147,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
    1148,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,  1149,   308,   309,   310,
    1150,  1151,   312,     0,   313,   314,  1152,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
    1153,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,  1154,  1155,
       0,  1156,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,  1157,   834,
     358,   835,     0,   359,   360,   361,  1158,  1159,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1160,   836,  1161,   380,   381,   382,
       0,   383,   384,   837,   385,  1163,  1164,   387,  1165,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,  1167,   400,   401,   402,
     403,     0,   404,   405,     0,   406,  1168,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,  1169,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,  2977,  2978,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,  1171,
     454,   455,   456,   457,   841,   458,  1172,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,  1173,
       0,   472,   473,  1174,   474,   475,   476,   477,   478,   479,
       0,  1175,  1176,     0,     0,   482,  1177,   484,  1178,  1179,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,  1181,     0,   497,   498,   499,   500,
     501,   502,  1182,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  1191,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,  1192,  1193,   546,   547,   548,   549,   550,   551,   843,
     552,  1194,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,     0,
       0,     0,     0,  2979,  2980,     0,     0,     0,     0,     0,
       0,     0,  1198,   820,  1124,   646,  1125,  1126,  1127,   701,
    1128,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
    1129,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240, -2995,  1130,   822,  1131,  1132,     0,   245,   246,
     247,   248,   249,  1133,  1134,   250,   251,  1135,  1136,   254,
       0,   255,   256,   257,   258,  1137,     0,  1138,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,  5340,  1139,  1140,
    1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,
     280,  1146,  1147,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
    1148,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,  1149,   308,   309,   310,
    1150,  1151,   312,     0,   313,   314,  1152,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
    1153,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,  1154,  1155,
       0,  1156,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,  1157,   834,
     358,     0,     0,   359,   360,   361,  1158,  1159,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1160,   836,  1161,   380,   381,   382,
       0,   383,   384,   837,   385,  1163,  1164,   387,  1165,   389,
     390,   391,     0,   392,     0,     0,  1166,   394,   395,     0,
       0,   396,   397,   838,   398,   839,  1167,   400,   401,   402,
     403,     0,   404,   405,     0,   406,  1168,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,  1169,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,  1170,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,  1171,
     454,   455,   456,   457,     0,   458,  1172,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,  1173,
       0,   472,   473,  1174,   474,   475,   476,   477,   478,   479,
       0,  1175,  1176,     0,     0,   482,  1177,   484,  1178,  1179,
     486,   487,   488,   489,  5341,   490,   491,     0,  1180,   492,
     493,   494,   495,   496,  1181,     0,   497,   498,   499,   500,
     501,   502,  1182,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  1191,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,  1192,  1193,   546,   547,   548,   549,   550,   551,   843,
     552,  1194,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,     0,
       0,     0,     0,  1195,  1196,     0,     0,   820,  1124,   646,
    1125,  1126,  1198,   701,  1128,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,  1129,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,   241,  1130,   822,  1131,
    1132,     0,  4141,   246,   247,   248,   249,  1133,  1134,   250,
     251,  1135,  1136,   254,     0,   255,   256,   257,   258,  1137,
       0,  1138,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,  1139,  1140,  1141,  1142,  1143,  1144,  1145,   275,
     276,   277,   278,   279,   280,  1146,  1147,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,  1148,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
    1149,   308,   309,   310,  1150,  1151,   312,     0,   313,   314,
    1152,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,  1153,     0,   323,     0,   324,   325,
     326,   327,   328,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,   339,   340,   341,
     342,   343,  1154,  1155,     0,  1156,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,  1157,   834,   358,   835,     0,   359,   360,   361,
    1158,  1159,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1160,   836,
    1161,   380,   381,   382,     0,   383,   384,   837,   385,  1163,
    1164,   387,  1165,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   838,   398,   839,
    1167,   400,   401,   402,   403,     0,   404,   405,     0,   406,
    1168,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,  1169,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,  1170,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,  1171,   454,   455,   456,   457,   841,   458,
    1172,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,  1173,     0,   472,   473,  1174,   474,   475,
     476,   477,   478,   479,     0,  1175,  1176,     0,     0,   482,
    1177,   484,  1178,  1179,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,  1181,     0,
     497,   498,   499,   500,   501,   502,  1182,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,   525,   526,   527,   528,   529,   530,
     531,   532,   533,  1191,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,  1192,  1193,   546,   547,   548,
     549,   550,   551,   843,   552,  1194,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,     0,     0,     0,     0,     0,   820,  1124,   646,  1125,
    1126,     0,   701,  1128,     0,     0,  1198,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   231,   232,   233,     0,
       0,     0,     0,  1129,     0,     0,   234,   235,     0,   236,
     237,   821,   238,   239,   240,   241,  1130,   822,  1131,  1132,
       0,   245,   246,   247,   248,   249,  1133,  1134,   250,   251,
    1135,  1136,   254,     0,   255,   256,   257,   258,  1137,     0,
    1138,     0,   260,   261,   262,   263,   264,   824,   265,   266,
       0,   267,   268,   269,   270,   271,   272,     0,   825,   273,
     274,  1139,  1140,  1141,  1142,  1143,  1144,  1145,   275,   276,
     277,   278,   279,   280,  1146,  1147,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
       0,   293,   294,  1148,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,     0,     0,   304,   305,   306,  1149,
     308,   309,   310,  1150,  1151,   312,     0,   313,   314,  1152,
       0,     0,   316,     0,   317,   827,     0,   828,   318,   319,
     320,     0,   321,  1153,     0,   323,     0,   324,   325,   326,
     327,   328,   829,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,     0,   338,   830,   339,   340,   341,   342,
     343,  1154,  1155,     0,  1156,     0,   347,   831,   832,   348,
     833,   349,   350,   351,   352,   353,     0,   354,   355,     0,
     356,  1157,   834,   358,   835,     0,   359,   360,   361,  1158,
    1159,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,  1160,   836,  1161,
     380,   381,   382,     0,   383,   384,   837,   385,  1163,  1164,
     387,  1165,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,   838,   398,   839,  1167,
     400,   401,   402,   403,     0,   404,   405,     0,   406,  1168,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
     416,   417,   418,   419,  1169,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,   840,   438,   439,  1170,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,   453,  1171,   454,   455,   456,   457,   841,   458,  1172,
     460,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,  1173,     0,   472,   473,  1174,   474,   475,   476,
     477,   478,   479,     0,  1175,  1176,     0,     0,   482,  1177,
     484,  1178,  1179,   486,   487,   488,   489,     0,   490,   491,
       0,     0,   492,   493,   494,   495,   496,  1181,     0,   497,
     498,   499,   500,   501,   502,  1182,     0,   504,   842,   505,
     506,   507,   508,     0,     0,   509,     0,     0,   510,   511,
     512,   513,   514,   515,   516,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,   525,   526,   527,   528,   529,   530,   531,
     532,   533,  1191,   534,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,  1192,  1193,   546,   547,   548,   549,
     550,   551,   843,   552,  1194,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,     0,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
       0,     0,     0,     0,     0,   820,  1124,   646,  1125,  1126,
    1127,   701,  1128,     0,     0,  1198,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,  1129,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,     0,  1130,   822,  1131,  1132,     0,
     245,   246,   247,   248,   249,  1133,  1134,   250,   251,  1135,
    1136,   254,     0,   255,   256,   257,   258,  1137,     0,  1138,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
    1139,  1140,  1141,  1142,  1143,  1144,  1145,   275,   276,   277,
     278,   279,   280,  1146,  1147,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,  1148,   296,   297,     0,   298,   299,   300,     0,
     301,     0,   303,     0,     0,   304,   305,   306,  1149,   308,
     309,   310,  1150,  1151,   312,     0,   313,   314,  1152,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,  1153,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
    1154,  1155,     0,  1156,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
    1157,   834,   358,     0,     0,   359,   360,   361,  1158,  1159,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1160,   836,  1161,   380,
     381,   382,     0,   383,   384,   837,   385,  1163,  1164,   387,
    1165,   389,   390,   391,     0,   392,     0,     0,  1166,   394,
     395,     0,     0,   396,   397,   838,   398,   839,  1167,   400,
     401,   402,   403,     0,   404,   405,     0,   406,  1168,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,  1169,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,  1170,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,  1171,     0,   455,   456,   457,     0,   458,  1172,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,  1173,     0,   472,   473,  1174,   474,   475,   476,   477,
     478,   479,     0,  1175,  1176,     0,     0,   482,  1177,   484,
    1178,  1179,   486,   487,   488,   489,     0,   490,   491,     0,
    1180,   492,   493,   494,   495,   496,  1181,     0,   497,   498,
     499,   500,   501,   502,  1182,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,   525,   526,   527,   528,   529,   530,   531,   532,
     533,  1191,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,  1192,  1193,   546,   547,   548,   549,   550,
     551,   843,   552,  1194,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,     0,
       0,     0,     0,     0,     0,  1195,  1196,     0,     0,     0,
       0,     0,     0,     0,  1198,   820,  1124,   646,  1125,  1126,
    1127,   701,  1128,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,  1129,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,     0,  1130,   822,  1131,  1132,     0,
     245,   246,   247,   248,   249,  1133,  1134,   250,   251,  1135,
    1136,   254,     0,   255,   256,   257,   258,  1137,     0,  1138,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
    1139,  1140,  1141,  1142,  1143,  1144,  1145,   275,   276,   277,
     278,   279,   280,  1146,  1147,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,  1148,   296,   297,     0,   298,   299,   300,     0,
     301,     0,   303,     0,     0,   304,   305,   306,  1149,   308,
     309,   310,  1150,  1151,   312,     0,   313,   314,  1152,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,  1153,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
    1154,  1155,     0,  1156,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
    1157,   834,   358,     0,     0,   359,   360,   361,  1158,  1159,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1160,   836,  1161,   380,
     381,   382,     0,   383,   384,   837,   385,  1163,  1164,   387,
    1165,   389,   390,   391,     0,   392,     0,     0,  1166,   394,
     395,     0,     0,   396,   397,   838,   398,   839,  1167,   400,
     401,   402,   403,     0,   404,   405,     0,   406,  1168,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,  1169,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,  1170,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,  1171,     0,   455,   456,   457,     0,   458,  1172,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,  1173,     0,   472,   473,  1174,   474,   475,   476,   477,
     478,   479,     0,  1175,  1176,     0,     0,   482,  1177,   484,
    1178,  1179,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,  1181,     0,   497,   498,
     499,   500,   501,   502,  1182,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,   525,   526,   527,   528,   529,   530,   531,   532,
     533,  1191,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,  1192,  1193,   546,   547,   548,   549,   550,
     551,   843,   552,  1194,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,     0,
       0,     0,     0,     0,   820,  2834,  2835,     0,     0,     0,
       0,     0,     0,     0,  1198,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,   236,   237,   821,
     238,   239,   240,   241,   242,   822,   243,   244,     0,   245,
     246,   247,   248,   249,     0,  1134,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,  1137,     0,  1138,     0,
     260,   261,   262,   263,   264,   824,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,   825,   273,   274,  1139,
    1140,  1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,
     279,   280,   281,   282,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,   307,   308,   309,
     310,  1150,     0,   312,     0,   313,   314,   315,     0,     0,
     316,     0,   317,   827,     0,   828,   318,   319,   320,     0,
     321,  1153,     0,   323,     0,   324,   325,   326,   327,   328,
     829,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,   830,   339,   340,   341,   342,   343,   344,
     345,     0,   346,     0,   347,   831,   832,   348,   833,   349,
     350,   351,   352,   353,  3641,   354,   355,     0,   356,  1157,
     834,   358,   835,     0,   359,   360,   361,  1158,  1159,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   836,   379,   380,   381,
     382,     0,   383,   384,   837,   385,     0,  1164,   387,   388,
     389,   390,   391,     0,   392,     0,   785,   393,   394,   395,
       0,     0,   396,   397,   838,   398,   839,  1167,   400,   401,
     402,   403,     0,   404,   405,     0,   406,  1168,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   840,   438,   439,   440,  3642,   442,   443,   444,
     445,   446,   447,   448,    38,   449,   450,   451,   452,   453,
    1171,   454,   455,   456,   457,   841,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
    1173,     0,   472,   473,    42,   474,   475,   476,   477,   478,
     479,     0,   480,   481,     0,     0,   482,  1177,   484,  1178,
       0,   486,   487,   488,   489,     0,   490,   491,     0,     0,
     492,   493,   494,   495,   496,  1181,     0,   497,   498,   499,
     500,   501,  1063,   503,     0,   504,   842,   505,   506,   507,
     508,     0,     0,   509,     0,    47,   510,   511,   512,   513,
     514,   515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,
    1190,   525,   526,   527,   528,   529,   530,   531,   532,   533,
    3643,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,  1192,  1193,   546,   547,   548,   549,   550,   551,
     843,   552,  1194,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,     0,     0,
       0,     0,     0,   820,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3644,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,     0,   245,   246,
     247,   248,   249,     0,  1134,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,  1137,     0,  1138,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,  1139,  1140,
    1141,  1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
    1150,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
    1153,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,  3641,   354,   355,     0,   356,  1157,   834,
     358,   835,     0,   359,   360,   361,  1158,  1159,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
       0,   383,   384,   837,   385,     0,  1164,   387,   388,   389,
     390,   391,     0,   392,     0,   785,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,  1167,   400,   401,   402,
     403,     0,   404,   405,     0,   406,  1168,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,  3642,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,  1171,
     454,   455,   456,   457,   841,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,  1173,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,  1177,   484,  1178,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,  1181,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  3643,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,  1192,  1193,   546,   547,   548,   549,   550,   551,   843,
     552,  1194,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,     0,
       0,     0,   820,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3644,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,   234,   235,     0,   236,   237,   821,   238,   239,
     240,   241,   242,   822,   243,   244,     0,   245,   246,   247,
     248,   249,     0,  1134,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,  1137,     0,  1138,     0,   260,   261,
     262,   263,   264,   824,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,   825,   273,   274,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,   275,   276,   277,   278,   279,   280,
     281,   282,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,   307,   308,   309,   310,  1150,
       0,   312,     0,   313,   314,   315,     0,     0,   316,     0,
     317,   827,     0,   828,   318,   319,   320,     0,   321,  1153,
       0,   323,     0,   324,   325,   326,   327,   328,   829,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,   830,   339,   340,   341,   342,   343,   344,   345,     0,
     346,     0,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,  1157,   834,   358,
     835,     0,   359,   360,   361,  1158,  1159,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   836,   379,   380,   381,   382,     0,
     383,   384,   837,   385,     0,  1164,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   838,   398,   839,  1167,   400,   401,   402,   403,
       0,   404,   405,     0,   406,  1168,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
     840,   438,   439,   440,  3642,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,  1171,   454,
     455,   456,   457,   841,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,  1173,     0,
     472,   473,     0,   474,   475,   476,   477,   478,   479,     0,
     480,   481,     0,     0,   482,  1177,   484,  1178,     0,   486,
     487,   488,   489,     0,   490,   491,     0,     0,   492,   493,
     494,   495,   496,  1181,     0,   497,   498,   499,   500,   501,
     502,   503,     0,   504,   842,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
     516,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,   525,
     526,   527,   528,   529,   530,   531,   532,   533,  3643,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
    1192,  1193,   546,   547,   548,   549,   550,   551,   843,   552,
    1194,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,   820,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
     241,   242,   822,   243,   244,     0,   245,   246,   247,   248,
     249,     0,  1134,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,  1137,     0,  1138,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,  1139,  1140,  1141,  1142,
    1143,  1144,  1145,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,  1150,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,  1153,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,  1157,   834,   358,   835,
       0,   359,   360,   361,  1158,  1159,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   836,   379,   380,   381,   382,     0,   383,
     384,   837,   385,     0,  1164,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   838,   398,   839,  1167,   400,   401,   402,   403,     0,
     404,   405,     0,   406,  1168,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,  1171,   454,   455,
     456,   457,   841,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,  1173,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,  1177,   484,  1178,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,  1181,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,   525,   526,
     527,   528,   529,   530,   531,   532,   533,  3643,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,  1192,
    1193,   546,   547,   548,   549,   550,   551,   843,   552,  1194,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,     0,     0,     0,     0,     0,
     820,  1124,   646,  1125,  1126,     0,   701,     0,     0,     0,
    4262,   222,   223,   224,   225,   226,   227,   228,   229,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
     234,   235,     0,   236,   237,   821,   238,   239,   240,   241,
    1130,   822,  1131,  1132,     0,   245,   246,   247,   248,   249,
       0,  4300,   250,   251,  1135,  1136,   254,     0,   255,   256,
     257,   258,   259,     0,   823,     0,   260,   261,   262,   263,
     264,   824,   265,   266,     0,   267,   268,   269,   270,   271,
     272,     0,   825,   273,   274,     0,     0,     0,   826,     0,
       0,     0,   275,   276,   277,   278,   279,   280,  1146,  1147,
     283,     0,   284,     0,   285,   286,   287,   288,   289,     0,
     290,   291,   292,     0,     0,   293,   294,  1148,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,  1151,   312,
       0,   313,   314,  1152,     0,     0,   316,     0,   317,   827,
       0,   828,   318,   319,   320,     0,   321,   322,     0,   323,
       0,   324,   325,   326,   327,   328,   829,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,     0,   338,   830,
     339,   340,   341,   342,   343,  1154,  1155,     0,  1156,     0,
     347,   831,   832,   348,   833,   349,   350,   351,   352,   353,
       0,   354,   355,     0,   356,   357,   834,   358,   835,     0,
     359,   360,   361,     0,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  1160,   836,  1161,   380,   381,   382,     0,   383,   384,
     837,   385,  1163,   386,   387,  1165,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
     838,   398,   839,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,   416,   417,   418,   419,  1169,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,   840,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   841,   458,  1172,   460,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,     0,   472,   473,
       0,   474,   475,   476,   477,   478,   479,     0,  1175,  1176,
       0,     0,   482,   483,   484,   485,  1179,   486,   487,   488,
     489,     0,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,     0,   497,   498,   499,   500,   501,   502,  1182,
       0,   504,   842,   505,   506,   507,   508,     0,     0,   509,
       0,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   843,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
       0,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4301,   820,  1124,   646,  1125,  1126,     0,   701,  4302,
       0,     0,     0,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,   234,   235,     0,   236,   237,   821,   238,   239,
     240,   241,  1130,   822,  1131,  1132,     0,   245,   246,   247,
     248,   249,     0,  4300,   250,   251,  1135,  1136,   254,     0,
     255,   256,   257,   258,   259,     0,   823,     0,   260,   261,
     262,   263,   264,   824,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,   825,   273,   274,     0,     0,     0,
     826,     0,     0,     0,   275,   276,   277,   278,   279,   280,
    1146,  1147,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,     0,   293,   294,  1148,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
    1151,   312,     0,   313,   314,  1152,     0,     0,   316,     0,
     317,   827,     0,   828,   318,   319,   320,     0,   321,   322,
       0,   323,     0,   324,   325,   326,   327,   328,   829,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,   830,   339,   340,   341,   342,   343,  1154,  1155,     0,
    1156,     0,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,   357,   834,   358,
     835,     0,   359,   360,   361,     0,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1160,   836,  1161,   380,   381,   382,     0,
     383,   384,   837,   385,  1163,   386,   387,  1165,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,   838,   398,   839,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
    1169,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
     840,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   841,   458,  1172,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,     0,
     472,   473,     0,   474,   475,   476,   477,   478,   479,     0,
    1175,  1176,     0,     0,   482,   483,   484,   485,  1179,   486,
     487,   488,   489,     0,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,     0,   497,   498,   499,   500,   501,
     502,  1182,     0,   504,   842,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   843,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4301,   820,  1124,   646,  1125,  1126,     0,
     701,  4311,     0,     0,     0,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,   236,   237,   821,
     238,   239,   240,   241,  1130,   822,  1131,  1132,     0,   245,
     246,   247,   248,   249,     0,  4300,   250,   251,  1135,  1136,
     254,     0,   255,   256,   257,   258,   259,     0,   823,     0,
     260,   261,   262,   263,   264,   824,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,   825,   273,   274,     0,
       0,     0,   826,     0,     0,     0,   275,   276,   277,   278,
     279,   280,  1146,  1147,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,  1148,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,  1151,   312,     0,   313,   314,  1152,     0,     0,
     316,     0,   317,   827,     0,   828,   318,   319,   320,     0,
     321,   322,     0,   323,     0,   324,   325,   326,   327,   328,
     829,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,   830,   339,   340,   341,   342,   343,  1154,
    1155,     0,  1156,     0,   347,   831,   832,   348,   833,   349,
     350,   351,   352,   353,     0,   354,   355,     0,   356,   357,
     834,   358,   835,     0,   359,   360,   361,     0,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1160,   836,  1161,   380,   381,
     382,     0,   383,   384,   837,   385,  1163,   386,   387,  1165,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   838,   398,   839,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,  1169,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   840,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   841,   458,  1172,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,     0,   472,   473,     0,   474,   475,   476,   477,   478,
     479,     0,  1175,  1176,     0,     0,   482,   483,   484,   485,
    1179,   486,   487,   488,   489,     0,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,     0,   497,   498,   499,
     500,   501,  4355,  1182,     0,   504,   842,   505,   506,   507,
     508,     0,     0,   509,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     843,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4301,   865,  1401,   646,     0,
       0,     0,   701,  4302,     0,     0,     0,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   231,   232,   233,     0,
       0,     0,     0,     0,     0,     0,   234,   235,     0,   236,
     237,   821,   238,   239,   240,   241,   242,   822,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,     0,
     823,     0,   260,   261,   262,   263,   264,   824,   265,   266,
       0,   267,   268,   269,   270,   271,   272,     0,   825,   273,
     274,     0,     0,     0,   826,     0,     0,     0,   275,   276,
     277,   278,   279,   280,   281,   282,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,  1662,   312,     0,   313,   314,   315,
       0,     0,   316,     0,   317,   827,     0,   828,   318,   319,
     320,     0,   321,   322,     0,   323,     0,   324,   325,   326,
     327,   328,   829,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,     0,   338,   830,   339,   340,   341,   342,
     343,   344,   345,     0,   346,     0,   347,   831,   832,   348,
     833,   349,   350,   351,   352,   353,     0,   354,   355,     0,
     356,   357,   834,   358,   835,     0,   359,   360,   361,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   836,   379,
     380,   381,   382,     0,   383,   384,   837,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,  1663,     0,   393,
     394,   395,     0,     0,   396,   397,   838,   398,   839,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,   840,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   841,   458,   459,
     460,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,     0,   472,   473,     0,   474,   475,   476,
     477,   478,   479,     0,   480,   481,     0,     0,   482,   483,
     484,   485,  1664,   486,   487,   488,   489,     0,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,     0,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   842,   505,
     506,   507,   508,     0,     0,   509,     0,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   843,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,     0,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
       0,     0,     0,     0,     0,   865,  1402,  1403,  4804,     0,
       0,     0,     0,     0,     0,  4805,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     3,     4,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,     0,   383,   384,   837,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    38,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   841,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,    42,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,  1063,   503,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,    47,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,     0,
       0,     0,     0,     0,   820,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    48,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,   236,   237,   821,
     238,   239,   240,   241,   242,   822,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,     0,   823,     0,
     260,   261,   262,   263,   264,   824,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,   825,   273,   274,     0,
       0,     0,   826,     0,     0,     0,   275,   276,   277,   278,
     279,   280,   281,   282,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,     0,     0,
     316,     0,   317,   827,     0,   828,   318,   319,   320,     0,
     321,   322,     0,   323,     0,   324,   325,   326,   327,   328,
     829,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,   830,   339,   340,   341,   342,   343,   344,
     345,     0,   346,     0,   347,   831,   832,   348,   833,   349,
     350,   351,   352,   353,     0,   354,   355,     0,   356,   357,
     834,   358,   835,     0,   359,   360,   361,     0,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   836,   379,   380,   381,
     382,     0,   383,   384,   837,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,   838,   398,   839,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   840,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   841,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,     0,   472,   473,     0,   474,   475,   476,   477,   478,
     479,     0,   480,   481,     0,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,     0,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,     0,   497,   498,   499,
     500,   501,   502,   503,     0,   504,   842,   505,   506,   507,
     508,     0,     0,   509,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     843,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,     0,     0,
       0,     0,     0,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5016,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    38,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,    42,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,  1063,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,    47,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,     0,
       0,     0,   221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    48,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,   234,   235,     0,   236,   237,     0,   238,   239,
     240,   241,   242,     0,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,     0,     0,     0,   260,   261,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,     0,   273,   274,     0,     0,     0,
       0,     0,     0,     0,   275,   276,   277,   278,   279,   280,
     281,   282,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,     0,     0,   316,     0,
     317,     0,     0,     0,   318,   319,   320,     0,   321,   322,
       0,   323,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,     0,   339,   340,   341,   342,   343,   344,   345,     0,
     346,     0,   347,     0,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,   357,     0,   358,
       0,     0,   359,   360,   361,     0,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   785,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,     0,   454,
     455,   456,   457,     0,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,     0,
     472,   473,     0,   474,   475,   476,   477,   478,   479,     0,
     480,   481,     0,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,     0,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,     0,   497,   498,   499,   500,   501,
     502,   503,     0,   504,     0,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,     0,     0,     0,     0,
       0,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1768,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,     0,     0,     0,     0,     0,
     221,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1255,   222,   223,   224,   225,   226,   227,   228,   229,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
     234,   235,     0,   236,   237,     0,   238,   239,   240,   241,
     242,     0,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,   250,   251,   252,   253,   254,     0,   255,   256,
     257,   258,   259,     0,     0,     0,   260,   261,   262,   263,
     264,     0,   265,   266,     0,   267,   268,   269,   270,   271,
     272,     0,     0,   273,   274,     0,     0,     0,     0,     0,
       0,     0,   275,   276,   277,   278,   279,   280,   281,   282,
     283,     0,   284,     0,   285,   286,   287,   288,   289,     0,
     290,   291,   292,     0,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,     0,     0,   316,     0,   317,     0,
       0,     0,   318,   319,   320,     0,   321,   322,     0,   323,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,     0,   338,     0,
     339,   340,   341,   342,   343,   344,   345,     0,   346,     0,
     347,     0,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,   355,     0,   356,   357,     0,   358,     0,     0,
     359,   360,   361,     0,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,     0,   383,   384,
       0,   385,     0,   386,   387,   388,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,   397,
       0,   398,     0,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,     0,   408,   409,   410,   411,     0,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,   453,     0,   454,   455,   456,
     457,     0,   458,   459,   460,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,     0,   472,   473,
       0,   474,   475,   476,   477,   478,   479,     0,   480,   481,
       0,     0,   482,   483,   484,   485,     0,   486,   487,   488,
     489,     0,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,     0,   497,   498,   499,   500,   501,   502,   503,
       0,   504,     0,   505,   506,   507,   508,     0,     0,   509,
       0,     0,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,     0,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
       0,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,     0,     0,     0,     0,     0,     0,     0,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3006,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,     0,     0,     0,   221,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4181,   222,
     223,   224,   225,   226,   227,   228,   229,     0,   231,   232,
     233,     0,     0,     0,     0,     0,     0,     0,   234,   235,
       0,   236,   237,     0,   238,   239,   240,   241,   242,     0,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
     250,   251,   252,   253,   254,     0,   255,   256,   257,   258,
     259,     0,     0,     0,   260,   261,   262,   263,   264,     0,
     265,   266,     0,   267,   268,   269,   270,   271,   272,     0,
       0,   273,   274,     0,     0,     0,     0,     0,     0,     0,
     275,   276,   277,   278,   279,   280,   281,   282,   283,     0,
     284,     0,   285,   286,   287,   288,   289,     0,   290,   291,
     292,     0,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,     0,     0,   316,     0,   317,     0,     0,     0,
     318,   319,   320,     0,   321,   322,     0,   323,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,     0,   338,     0,   339,   340,
     341,   342,   343,   344,   345,     0,   346,     0,   347,     0,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
     355,     0,   356,   357,     0,   358,     0,     0,   359,   360,
     361,     0,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,     0,   383,   384,     0,   385,
       0,   386,   387,   388,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,   397,     0,   398,
       0,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,     0,   408,   409,   410,   411,     0,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,   453,     0,   454,   455,   456,   457,     0,
     458,   459,   460,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,     0,   472,   473,     0,   474,
     475,   476,   477,   478,   479,     0,   480,   481,     0,     0,
     482,   483,   484,   485,     0,   486,   487,   488,   489,     0,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
       0,   497,   498,   499,   500,   501,   502,   503,     0,   504,
       0,   505,   506,   507,   508,     0,     0,   509,     0,     0,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,     0,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,     0,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
       0,     0,     0,     0,     0,     0,     0,  1514,  1401,   646,
       0,     0,   876,   701,     0,     0,     0,  4651,   222,   223,
     224,   225,   226,   227,   228,   229,  2155,   231,   232,   233,
    2156,  2157,  2158,  2159,  2160,  2161,  2162,   234,   235,  2163,
     236,   237,   821,   238,   239,   240,     0,  1515,   822,  1516,
    1517,  2164,   245,   246,   247,   248,   249,  2165,  2166,   250,
     251,  1518,  1519,   254,  2167,   255,   256,   257,   258,     0,
    2168,   823,  2169,   260,   261,   262,   263,   264,   824,   265,
     266,  2170,   267,   268,   269,   270,   271,   272,  2171,   825,
     273,   274,  2172,  2173,  2174,   826,  2175,  2176,  2177,   275,
     276,   277,   278,   279,   280,  1520,  1521,   283,  2178,   284,
    2179,   285,   286,   287,   288,   289,  2180,   290,   291,   292,
    2181,  2182,   293,   294,  1148,   296,   297,  2183,   298,   299,
     300,  2184,   301,   302,   303,  2185,  2186,   304,   305,   306,
       0,   308,   309,   310,     0,  2187,   312,  2188,   313,   314,
    1522,  2189,  2190,   316,  2191,   317,   827,  2192,   828,   318,
     319,   320,  2193,   321,     0,  2194,   323,  2195,   324,   325,
     326,   327,   328,   829,   329,   330,   331,  2196,   332,   333,
     334,   335,   336,   337,  2197,   338,   830,     0,   340,   341,
     342,   343,  1523,  1524,  2198,  1525,  2199,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,  2200,   354,   355,
    2201,   356,     0,   834,   358,   835,  2202,   359,   360,   361,
    2203,  2204,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1526,   836,
    1527,   380,   381,  3944,  2205,   383,   384,   837,   385,  2206,
       0,   387,  1528,   389,   390,   391,  2207,   392,  2208,  2209,
    3945,   394,   395,  2210,  2211,   396,     0,   838,   398,   839,
       0,   400,   401,   402,   403,  2212,   404,   405,  2213,   406,
       0,  2214,     0,   409,   410,   411,  2215,   412,   413,   414,
     415,   416,   417,   418,   419,  1529,   421,   422,   423,   424,
    2216,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  2217,   436,   437,   840,   438,   439,  3946,   441,
     442,   443,   444,   445,   446,   447,   448,  2218,   449,   450,
     451,   452,   453,  2219,   454,  2310,   456,   457,   841,   458,
    1531,   460,  2220,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     0,  2221,   472,   473,  2222,   474,   475,
     476,   477,   478,   479,  2223,  1532,  1533,  2224,  2225,   482,
       0,   484,     0,  2226,   486,   487,   488,   489,  2227,   490,
     491,  2228,  2229,   492,   493,   494,   495,   496,  2230,  2231,
     497,   498,   499,   500,   501,     0,  1534,  2232,   504,   842,
     505,   506,   507,   508,  2233,  2234,   509,  2235,  2236,   510,
     511,   512,   513,   514,   515,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,  2237,   534,  2238,   535,   536,   537,   538,
     539,   540,   541,   542,   543,     0,     0,   546,   547,   548,
     549,   550,   551,   843,   552,     0,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,     0,   574,  2239,   575,   576,
       0,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,     0,     0,   879,   880,   881,     0,  3947,  3948,   884,
     885,   886,   887,   221,     0,     0,     0,     0,   876,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   877,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   878,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,   879,
     880,   881,     0,   882,   883,   884,   885,   886,   887,   221,
       0,     0,     0,     0,   876,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   977,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   978,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,   879,   880,   881,     0,   882,
     883,   884,   885,   886,   887,   221,     0,     0,     0,     0,
     876,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,  1033,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,  1034,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    1035,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,     0,
       0,   879,   880,   881,     0,   882,   883,   884,   885,   886,
     887,   221,     0,     0,     0,     0,   876,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
    1500,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
    1501,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,     0,     0,   879,   880,   881,
       0,   882,   883,   884,   885,   886,   887,   221,     0,     0,
       0,     0,   876,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,     0,     0,   879,   880,   881,     0,   882,   883,   884,
     885,   886,   887,   221,     0,     0,     0,     0,   876,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,  3083,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,  3084,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,     0,     0,   879,
     880,   881,     0,   882,   883,   884,   885,   886,   887,   221,
       0,     0,     0,     0,   876,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,  4966,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,     0,     0,   879,   880,   881,     0,   882,
     883,   884,   885,   886,   887,  1803,     0,     0,     0,     0,
    1804,     0,     0,  1805,     0,     0,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,     0,  1814,  1815,     0,     0,     0,
    1816,     0,     0,  1817,     0,  1818,  1819,     0,  1820,     0,
    1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,     0,
    1830,  1831,  1832,  1833,  1834,     0,     0,     0,  1835,     0,
       0,  1836,     0,  1837,  1838,  1839,  1840,  1841,  1842,     0,
       0,  1843,     0,  1844,  1845,  1846,     0,     0,  1847,     0,
    1848,  1849,     0,  1850,  1851,  1852,     0,     0,  1853,     0,
       0,     0,     0,     0,     0,     0,     0,  1854,  1855,     0,
    1856,     0,  1857,  1858,  1859,  1860,     0,  1861,     0,  1862,
    1863,  1864,  1865,  1866,     0,     0,  1867,     0,     0,     0,
       0,  1868,  1869,  1870,  1871,     0,  1872,  1873,  1874,     0,
    1875,  1876,     0,     0,     0,  1877,  1878,  1879,  1880,  1881,
       0,  1882,  1883,     0,     0,     0,     0,  1884,  1885,     0,
       0,  1886,     0,  1887,  1888,     0,     0,  1889,     0,  1890,
       0,  1891,  1892,     0,  1893,     0,  1894,  1895,     0,     0,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,     0,     0,     0,  1908,  1909,  1910,  1911,  1912,
    1913,  1914,     0,  1915,     0,  1916,  1917,  1918,  1919,     0,
    1920,     0,  1921,  1922,  1923,     0,     0,     0,     0,     0,
    1924,     0,  1925,  1926,     0,  1927,  1928,  1929,     0,     0,
    1930,  1931,     0,  1932,     0,  1933,  1934,  1935,  1936,     0,
    1937,  1938,     0,  1939,  1940,  1941,  1942,     0,  1943,  1944,
    1945,  1946,  1947,  1948,  1949,  1950,  1951,     0,  1952,  1953,
    1954,  1955,  1956,     0,     0,  1957,     0,     0,  1958,  1959,
    1960,  1961,     0,     0,  1962,  1963,     0,     0,  1964,  1965,
    1966,     0,  1967,     0,     0,  1968,     0,     0,  1969,     0,
    1970,  1971,  1972,  1973,     0,  1974,  1975,  1976,  1977,     0,
    1978,  1979,  1980,  1981,  1982,  1983,     0,     0,     0,     0,
    1984,  1985,  1986,  1987,  1988,  1989,     0,  1990,  1991,  1992,
       0,  1993,  1994,     0,  1995,  1996,  1997,  1998,  1999,  2000,
    2001,  2002,  2003,     0,  2004,     0,  2005,     0,  2006,     0,
    2007,     0,  2008,  2009,  2010,  2011,  2012,  2013,  2014,     0,
       0,  2015,     0,  2016,  2017,  2018,  2019,  2020,  2021,  2022,
       0,  2023,     0,  2024,  2025,     0,     0,  2026,  2027,  2028,
    2029,     0,     0,  2030,  2031,     0,     0,  2032,  2033,  2034,
    2035,     0,  2036,  2037,  2038,     0,     0,  2039,  2040,     0,
       0,  2041,  2042,     0,  2043,  2044,     0,     0,  2045,  2046,
       0,  2047,  2048,  2049,  2050,     0,     0,  2051,  2052,  2053,
       0,  2054,     0,     0,     0,     0,     0,     0,     0,  2055,
       0,  2056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2057,  2058,  2059,  2060,  2061,  2062,
    2063,     0,     0,     0,     0,  2064,  2065,  2066,     0,  2067,
    2068,  2069,     0,  2070,  2071,  2072,  2073,     0,  2074,     0,
    2075,  2076,  2077,     0,  2078,  2079,  2080,     0,  2081,     0,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,     0,     0,     0,
       0,     0,  2089,  2090,     0,     0,  2091,  2092,  2093,  2094,
    2095,  2096,  2097,  2098,     0,     0,     0,     0,     0,     0,
    2154,  2099,  2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,
    2107,   222,   223,   224,   225,   226,   227,   228,   229,  2155,
     231,   232,   233,  2156,  2157,  2158,  2159,  2160,  2161,  2162,
     234,   235,  2163,   236,   237,   821,   238,   239,   240,   241,
     242,   822,   243,   244,  2164,   245,   246,   247,   248,   249,
    2165,  2166,   250,   251,   252,   253,   254,  2167,   255,   256,
     257,   258,   259,  2168,   823,  2169,   260,   261,   262,   263,
     264,   824,   265,   266,  2170,   267,   268,   269,   270,   271,
     272,  2171,   825,   273,   274,  2172,  2173,  2174,   826,  2175,
    2176,  2177,   275,   276,   277,   278,   279,   280,   281,   282,
     283,  2178,   284,  2179,   285,   286,   287,   288,   289,  2180,
     290,   291,   292,  2181,  2182,   293,   294,   295,   296,   297,
    2183,   298,   299,   300,  2184,   301,   302,   303,  2185,  2186,
     304,   305,   306,   307,   308,   309,   310,   311,  2187,   312,
    2188,   313,   314,   315,  2189,  2190,   316,  2191,   317,   827,
    2192,   828,   318,   319,   320,  2193,   321,   322,  2194,   323,
    2195,   324,   325,   326,   327,   328,   829,   329,   330,   331,
    2196,   332,   333,   334,   335,   336,   337,  2197,   338,   830,
     339,   340,   341,   342,   343,   344,   345,  2198,   346,  2199,
     347,   831,   832,   348,   833,   349,   350,   351,   352,   353,
    2200,   354,   355,  2201,   356,   357,   834,   358,   835,  2202,
     359,   360,   361,  2203,  2204,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   836,   379,   380,   381,   382,  2205,   383,   384,
     837,   385,  2206,   386,   387,   388,   389,   390,   391,  2207,
     392,  2208,  2209,   393,   394,   395,  2210,  2211,   396,   397,
     838,   398,   839,   399,   400,   401,   402,   403,  2212,   404,
     405,  2213,   406,   407,  2214,   408,   409,   410,   411,  2215,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  2216,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  2217,   436,   437,   840,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
    2218,   449,   450,   451,   452,   453,  2219,   454,   455,   456,
     457,   841,   458,   459,   460,  2220,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,  2221,   472,   473,
    2222,   474,   475,   476,   477,   478,   479,  2223,   480,   481,
    2224,  2225,   482,   483,   484,   485,  2226,   486,   487,   488,
     489,  2227,   490,   491,  2228,  2229,   492,   493,   494,   495,
     496,  2230,  2231,   497,   498,   499,   500,   501,   502,   503,
    2232,   504,   842,   505,   506,   507,   508,  2233,  2234,   509,
    2235,  2236,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,  2237,   534,  2238,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   843,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
    2239,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2240,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,   234,   235,     0,   236,   237,     0,   238,   239,
     240,   241,   242,     0,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,   250,   251,   252,   253,   254,     0,
     255,   256,   257,   258,   259,     0,     0,     0,   260,   261,
     262,   263,   264,     0,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,     0,   273,   274,     0,     0,     0,
       0,     0,     0,     0,   275,   276,   277,   278,   279,   280,
     281,   282,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,     0,     0,   316,     0,
     317,     0,     0,     0,   318,   319,   320,     0,   321,   322,
       0,   323,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,     0,   339,   340,   341,   342,   343,   344,   345,     0,
     346,     0,   347,     0,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,   357,     0,   358,
       0,     0,   359,   360,   361,     0,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,     0,
     383,   384,     0,   385,     0,   386,   387,   388,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,   397,     0,   398,     0,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,     0,   408,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,     0,   454,
     455,   456,   457,     0,   458,   459,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,     0,
     472,   473,     0,   474,   475,   476,   477,   478,   479,     0,
     480,   481,     0,     0,   482,   483,   484,   485,     0,   486,
     487,   488,   489,     0,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,     0,   497,   498,   499,   500,   501,
     502,   503,     0,   504,     0,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,     0,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,     0,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   221,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   790,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,   236,   237,     0,
     238,   239,   240,   241,   242,     0,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,   250,   251,   252,   253,
     254,     0,   255,   256,   257,   258,   259,     0,     0,     0,
     260,   261,   262,   263,   264,     0,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,     0,   273,   274,     0,
       0,     0,     0,     0,     0,     0,   275,   276,   277,   278,
     279,   280,   281,   282,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,     0,     0,
     316,     0,   317,     0,     0,     0,   318,   319,   320,     0,
     321,   322,     0,   323,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,     0,   339,   340,   341,   342,   343,   344,
     345,     0,   346,     0,   347,     0,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,   355,     0,   356,   357,
       0,   358,     0,     0,   359,   360,   361,     0,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,     0,   383,   384,     0,   385,     0,   386,   387,   388,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,   397,     0,   398,     0,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,     0,   408,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,   453,
       0,   454,   455,   456,   457,     0,   458,   459,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,     0,   472,   473,     0,   474,   475,   476,   477,   478,
     479,     0,   480,   481,     0,     0,   482,   483,   484,   485,
       0,   486,   487,   488,   489,     0,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,     0,   497,   498,   499,
     500,   501,   502,   503,     0,   504,     0,   505,   506,   507,
     508,     0,     0,   509,     0,     0,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
       0,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5047,   222,   223,   224,
     225,   226,   227,   228,   229,     0,   231,   232,   233,     0,
       0,     0,     0,     0,     0,     0,   234,   235,     0,   236,
     237,     0,   238,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,   250,   251,
     252,   253,   254,     0,   255,   256,   257,   258,   259,     0,
       0,     0,   260,   261,   262,   263,   264,     0,   265,   266,
       0,   267,   268,   269,   270,   271,   272,     0,     0,   273,
     274,     0,     0,     0,     0,     0,     0,     0,   275,   276,
     277,   278,   279,   280,   281,   282,   283,     0,   284,     0,
     285,   286,   287,   288,   289,     0,   290,   291,   292,     0,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
       0,     0,   316,     0,   317,     0,     0,     0,   318,   319,
     320,     0,   321,   322,     0,   323,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
     335,   336,   337,     0,   338,     0,   339,   340,   341,   342,
     343,   344,   345,     0,   346,     0,   347,     0,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,   355,     0,
     356,   357,     0,   358,     0,     0,   359,   360,   361,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,     0,   383,   384,     0,   385,     0,   386,
     387,   388,   389,   390,   391,     0,   392,     0,     0,   393,
     394,   395,     0,     0,   396,   397,     0,   398,     0,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
       0,   408,   409,   410,   411,     0,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,     0,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,   451,
     452,   453,     0,   454,   455,   456,   457,     0,   458,   459,
     460,     0,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,     0,   472,   473,     0,   474,   475,   476,
     477,   478,   479,     0,   480,   481,     0,     0,   482,   483,
     484,   485,     0,   486,   487,   488,   489,     0,   490,   491,
       0,     0,   492,   493,   494,   495,   496,     0,     0,   497,
     498,   499,   500,   501,   502,   503,     0,   504,     0,   505,
     506,   507,   508,     0,     0,   509,     0,     0,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,     0,   534,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,     0,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,     0,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,  1514,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5558,   222,
     223,   224,   225,   226,   227,   228,   229,     0,   231,   232,
     233,     0,     0,     0,     0,     0,     0,     0,   234,   235,
       0,   236,   237,   821,   238,   239,   240,     0,  1515,   822,
    1516,  1517,     0,   245,   246,   247,   248,   249,     0,     0,
     250,   251,  1518,  1519,   254,     0,   255,   256,   257,   258,
       0,     0,   823,     0,   260,   261,   262,   263,   264,   824,
     265,   266,     0,   267,   268,   269,   270,   271,   272,     0,
     825,   273,   274,     0,     0,     0,   826,     0,     0,     0,
     275,   276,   277,   278,   279,   280,  1520,  1521,   283,     0,
     284,     0,   285,   286,   287,   288,   289,     0,   290,   291,
     292,     0,     0,   293,   294,  1148,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,     0,     0,   304,   305,
     306,     0,   308,   309,   310,     0,     0,   312,     0,   313,
     314,  1522,     0,     0,   316,     0,   317,   827,     0,   828,
     318,   319,   320,     0,   321,     0,     0,   323,     0,   324,
     325,   326,   327,   328,   829,   329,   330,   331,  2306,   332,
     333,   334,   335,   336,   337,     0,   338,   830,  2307,   340,
     341,   342,   343,  1523,  1524,     0,  1525,     0,   347,   831,
     832,   348,   833,   349,   350,   351,   352,   353,     0,   354,
     355,     0,   356,     0,   834,   358,   835,     0,   359,   360,
     361,     0,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,  1526,
     836,  1527,   380,   381,     0,     0,   383,   384,   837,   385,
       0,     0,   387,  1528,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,  2308,   396,  2309,   838,   398,
     839,     0,   400,   401,   402,   403,     0,   404,   405,     0,
     406,     0,     0,     0,   409,   410,   411,     0,   412,   413,
     414,   415,   416,   417,   418,   419,  1529,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   840,   438,   439,     0,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,   453,     0,   454,  2310,   456,   457,   841,
     458,  1531,   460,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   472,   473,     0,   474,
     475,   476,   477,   478,   479,     0,  1532,  1533,     0,     0,
     482,     0,   484,     0,     0,   486,   487,   488,   489,     0,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
       0,   497,   498,   499,   500,   501,     0,  1534,  2311,   504,
     842,   505,   506,   507,   508,     0,     0,   509,     0,     0,
     510,   511,   512,   513,   514,   515,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,     0,     0,   546,   547,
     548,   549,   550,   551,   843,   552,     0,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,     0,   574,     0,   575,
     576,  3432,   578,   579,   580,   581,   582,   583,   584,   585,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
    2312,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
       0,  1515,   822,  1516,  1517,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,  1518,  1519,   254,     0,   255,
     256,   257,   258,     0,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,  1520,
    1521,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,  1148,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,     0,   308,   309,   310,     0,     0,
     312,     0,   313,   314,  1522,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,     0,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,  2306,   332,   333,   334,   335,   336,   337,     0,   338,
     830,  2307,   340,   341,   342,   343,  1523,  1524,     0,  1525,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,     0,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1526,   836,  1527,   380,   381,     0,     0,   383,
     384,   837,   385,     0,     0,   387,  1528,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,  2308,   396,
    2309,   838,   398,   839,     0,   400,   401,   402,   403,     0,
     404,   405,     0,   406,     0,     0,     0,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,  1529,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,     0,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,  2310,
     456,   457,   841,   458,  1531,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,  1532,
    1533,     0,     0,   482,     0,   484,     0,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,     0,
    1534,  2311,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,     0,
       0,   546,   547,   548,   549,   550,   551,   843,   552,     0,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,     0,
     574,     0,   575,   576,     0,   578,   579,   580,   581,   582,
     583,   584,   585,   820,  1124,   646,  1125,  1126,     0,   701,
       0,     0,     0,  2312,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,  1130,   822,  1131,  1132,     0,   245,   246,
     247,   248,   249,     0,  4300,   250,   251,  1135,  1136,   254,
       0,   255,   256,   257,   258,   259,     0,   823,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,     0,     0,
       0,   826,     0,     0,     0,   275,   276,   277,   278,   279,
     280,  1146,  1147,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
    1148,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,  1151,   312,     0,   313,   314,  1152,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,  1154,  1155,
       0,  1156,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,   834,
     358,   835,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,  1160,   836,  1161,   380,   381,   382,
       0,   383,   384,   837,   385,  1163,   386,   387,  1165,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,  1169,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   841,   458,  1172,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,  1175,  1176,     0,     0,   482,   483,   484,   485,  1179,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,  1182,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   865,  1401,   646,     0,     0,
       0,   701,     0,     0,  4301,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,  2144,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,  1662,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,     0,   383,   384,   837,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,  1663,     0,   393,   394,
     395,     0,     0,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   841,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,  1664,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   865,  1401,   646,
       0,     0,     0,   701,     0,  1402,  1403,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,   241,   242,   822,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,   823,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,     0,     0,     0,   826,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,  2149,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,  1662,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,   834,   358,   835,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   836,
     379,   380,   381,   382,     0,   383,   384,   837,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,  1663,     0,
     393,   394,   395,     0,     0,   396,   397,   838,   398,   839,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   841,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,  1664,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   843,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   865,
    1401,   646,     0,     0,     0,   701,     0,  1402,  1403,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,   242,
     822,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,  1662,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   836,   379,   380,   381,   382,     0,   383,   384,   837,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
    1663,     0,   393,   394,   395,     0,     0,   396,   397,   838,
     398,   839,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     841,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,  1664,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   843,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,   701,     0,  1402,
    1403,     0,   222,   702,   224,   225,   226,   227,   228,   229,
     703,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   704,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   705,   315,     0,     0,   316,     0,   706,
       0,   707,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,   708,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     709,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   710,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   711,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   712,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,  2154,  5433,   646,     0,     0,     0,   701,
       0,   713,   714,     0,   222,   223,   224,   225,   226,   227,
     228,   229,  2155,   231,   232,   233,  2156,  2157,  2158,  2159,
    2160,  2161,  2162,   234,   235,  2163,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,  2164,   245,   246,
     247,   248,   249,  2165,  2166,   250,   251,   252,   253,   254,
    2167,   255,   256,   257,   258,   259,  2168,   823,  2169,   260,
     261,   262,   263,   264,   824,   265,   266,  2170,   267,   268,
     269,   270,   271,   272,  2171,   825,   273,   274,  2172,  2173,
    2174,   826,  2175,  2176,  2177,   275,   276,   277,   278,   279,
     280,   281,   282,   283,  2178,   284,  2179,   285,   286,   287,
     288,   289,  2180,   290,   291,   292,  2181,  2182,   293,   294,
     295,   296,   297,  2183,   298,   299,   300,  2184,   301,   302,
     303,  2185,  2186,   304,   305,   306,   307,   308,   309,   310,
     311,  2187,   312,  2188,   313,   314,   315,  2189,  2190,   316,
    2191,   317,   827,  2192,   828,   318,   319,   320,  2193,   321,
     322,  2194,   323,  2195,   324,   325,   326,   327,   328,   829,
     329,   330,   331,  2196,   332,   333,   334,   335,   336,   337,
    2197,   338,   830,   339,   340,   341,   342,   343,   344,   345,
    2198,   346,  2199,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,  2200,   354,   355,  2201,   356,   357,   834,
     358,   835,  2202,   359,   360,   361,  2203,  2204,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
    2205,   383,   384,   837,   385,  2206,   386,   387,   388,   389,
     390,   391,  2207,   392,  2208,  2209,   393,   394,   395,  2210,
    2211,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,  2212,   404,   405,  2213,   406,   407,  2214,   408,   409,
     410,   411,  2215,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,  2216,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  2217,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,  2218,   449,   450,   451,   452,   453,  2219,
     454,   455,   456,   457,   841,   458,   459,   460,  2220,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
    2221,   472,   473,  2222,   474,   475,   476,   477,   478,   479,
    2223,   480,   481,  2224,  2225,   482,   483,   484,   485,  2226,
     486,   487,   488,   489,  2227,   490,   491,  2228,  2229,   492,
     493,   494,   495,   496,  2230,  2231,   497,   498,   499,   500,
     501,   502,   503,  2232,   504,   842,   505,   506,   507,   508,
    2233,  2234,   509,  2235,  2236,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,  2237,
     534,  2238,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,  2239,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,  2154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,  2155,   231,   232,   233,  2156,  2157,
    2158,  2159,  2160,  2161,  2162,   234,   235,  2163,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,  2164,
     245,   246,   247,   248,   249,  2165,  2166,   250,   251,   252,
     253,   254,  2167,   255,   256,   257,   258,   259,  2168,   823,
    2169,   260,   261,   262,   263,   264,   824,   265,   266,  2170,
     267,   268,   269,   270,   271,   272,  2171,   825,   273,   274,
    2172,  2173,  2174,   826,  2175,  2176,  2177,   275,   276,   277,
     278,   279,   280,   281,   282,   283,  2178,   284,  2179,   285,
     286,   287,   288,   289,  2180,   290,   291,   292,  2181,  2182,
     293,   294,   295,   296,   297,  2183,   298,   299,   300,  2184,
     301,   302,   303,  2185,  2186,   304,   305,   306,   307,   308,
     309,   310,   311,  2187,   312,  2188,   313,   314,   315,  2189,
    2190,   316,  2191,   317,   827,  2192,   828,   318,   319,   320,
    2193,   321,   322,  2194,   323,  2195,   324,   325,   326,   327,
     328,   829,   329,   330,   331,  2196,   332,   333,   334,   335,
     336,   337,  2197,   338,   830,   339,   340,   341,   342,   343,
     344,   345,  2198,   346,  2199,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,  2200,   354,   355,  2201,   356,
     357,   834,   358,   835,  2202,   359,   360,   361,  2203,  2204,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,  2205,   383,   384,   837,   385,  2206,   386,   387,
     388,   389,   390,   391,  2207,   392,  2208,  2209,   393,   394,
     395,  2210,  2211,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,  2212,   404,   405,  2213,   406,   407,  2214,
     408,   409,   410,   411,  2215,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,  2216,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    2217,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,  2218,   449,   450,   451,   452,
     453,  2219,   454,   455,   456,   457,   841,   458,   459,   460,
    2220,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,  2221,   472,   473,  2222,   474,   475,   476,   477,
     478,   479,  2223,   480,   481,  2224,  2225,   482,   483,   484,
     485,  2226,   486,   487,   488,   489,  2227,   490,   491,  2228,
    2229,   492,   493,   494,   495,   496,  2230,  2231,   497,   498,
     499,   500,   501,   502,   503,  2232,   504,   842,   505,   506,
     507,   508,  2233,  2234,   509,  2235,  2236,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,  2237,   534,  2238,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,  2239,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,  2154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,  3169,   227,   228,   229,  2155,   231,   232,   233,
    2156,  2157,  2158,  2159,  2160,  2161,  2162,   234,   235,  2163,
     236,   237,   821,   238,   239,   240,   241,   242,   822,   243,
     244,  2164,   245,   246,   247,   248,   249,  2165,  2166,   250,
     251,   252,   253,   254,  2167,   255,   256,   257,   258,   259,
    2168,   823,  2169,   260,   261,   262,   263,   264,   824,   265,
     266,  2170,   267,   268,   269,   270,   271,   272,  2171,   825,
     273,   274,  2172,  2173,  2174,   826,  2175,  2176,  2177,   275,
     276,   277,   278,   279,   280,   281,   282,   283,  2178,   284,
    2179,   285,   286,   287,   288,   289,  2180,   290,   291,   292,
    2181,  2182,   293,   294,   295,  3170,   297,  2183,   298,   299,
     300,  2184,   301,   302,   303,  2185,  2186,   304,   305,   306,
     307,   308,   309,   310,   311,  2187,   312,  2188,   313,   314,
     315,  2189,  2190,   316,  2191,   317,   827,  2192,   828,   318,
     319,   320,  2193,   321,   322,  2194,   323,  2195,   324,   325,
     326,   327,   328,   829,   329,   330,   331,  2196,   332,   333,
     334,   335,   336,   337,  2197,   338,   830,   339,   340,   341,
     342,   343,   344,   345,  2198,   346,  2199,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,  2200,   354,   355,
    2201,   356,   357,   834,   358,   835,  2202,   359,   360,   361,
    2203,  2204,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   836,
     379,   380,   381,   382,  2205,   383,   384,   837,   385,  2206,
     386,   387,   388,   389,   390,   391,  2207,   392,  2208,  2209,
     393,   394,   395,  2210,  2211,   396,   397,   838,   398,   839,
     399,   400,   401,   402,   403,  2212,   404,   405,  2213,   406,
     407,  2214,   408,   409,   410,   411,  2215,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
    2216,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  2217,   436,   437,   840,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,  2218,   449,   450,
     451,   452,   453,  2219,  3171,   455,   456,   457,   841,   458,
     459,   460,  2220,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,  2221,   472,   473,  2222,   474,   475,
     476,   477,   478,   479,  2223,   480,   481,  2224,  2225,   482,
     483,   484,   485,  2226,   486,   487,   488,   489,  2227,   490,
     491,  2228,  2229,   492,   493,   494,   495,   496,  2230,  2231,
     497,   498,   499,   500,   501,   502,   503,  2232,   504,   842,
     505,   506,   507,   508,  2233,  2234,   509,  2235,  2236,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,  2237,   534,  2238,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   843,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,  2239,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   820,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,   242,
     822,   243,   244,     0,   245,   246,   247,   248,   249,     0,
    1134,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,  1137,     0,  1138,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,  1150,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,  1153,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,  1157,   834,   358,   835,     0,   359,
     360,   361,  1158,  1159,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   836,   379,   380,   381,   382,     0,   383,   384,   837,
     385,     0,  1164,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   838,
     398,   839,  1167,   400,   401,   402,   403,     0,   404,   405,
       0,   406,  1168,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,  1171,   454,   455,   456,   457,
     841,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,  1173,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,  1177,   484,  1178,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
    1181,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,   525,   526,   527,   528,
     529,   530,   531,   532,   533,  3643,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,  1192,  1193,   546,
     547,   548,   549,   550,   551,   843,   552,  1194,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   865,     0,   646,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
     241,   242,   822,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,  1662,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   836,   379,   380,   381,   382,     0,   383,
     384,   837,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,  1663,     0,   393,   394,   395,     0,     0,   396,
     397,   838,   398,   839,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   841,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,  1664,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   843,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   865,     0,   646,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,   823,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,     0,     0,
       0,   826,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,  2129,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,   834,
     358,   835,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
       0,   383,   384,   837,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   841,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   865,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,  2543,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,     0,   383,   384,   837,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   841,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,  2544,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   865,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       3,     4,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,   241,   242,   822,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,   823,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,     0,     0,     0,   826,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,   834,   358,   835,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   836,
     379,   380,   381,   382,     0,   383,   384,   837,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   838,   398,   839,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   841,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   843,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   865,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,   892,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,   242,
     822,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   836,   379,   380,   381,   382,     0,   383,   384,   837,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   838,
     398,   839,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     841,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   843,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   865,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
     908,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
     241,   242,   822,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   909,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   836,   379,   380,   381,   382,     0,   383,
     384,   837,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   838,   398,   839,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   841,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   843,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   865,     0,   646,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,   823,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,     0,     0,
       0,   826,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,   834,
     358,   835,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
       0,   383,   384,   837,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   841,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   865,     0,   646,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    1652,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,     0,   383,   384,   837,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   841,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   865,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,   241,   242,   822,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,   823,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,     0,     0,     0,   826,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,   322,  3486,   323,     0,   324,   325,
     326,   327,   328,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,   834,   358,   835,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   836,
     379,   380,   381,   382,     0,   383,   384,   837,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   838,   398,   839,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   841,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   843,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   820,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,   242,
     822,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   836,   379,   380,   381,   382,     0,   383,   384,   837,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   838,
     398,   839,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     841,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   843,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   865,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
     241,   242,   822,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   836,   379,   380,   381,   382,     0,   383,
     384,   837,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   838,   398,   839,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   841,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   843,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,   823,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,     0,     0,
       0,   826,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,   834,
     358,   835,     0,   359,   360,   361,     0,     0,   362,   363,
     990,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
       0,   383,   384,   837,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   841,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   820,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,   241,   242,   822,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    1014,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   836,   379,   380,
     381,   382,     0,   383,   384,   837,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,   838,   398,   839,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   841,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   843,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   820,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,   241,   242,   822,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,   823,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,     0,     0,     0,   826,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,  1026,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,   834,   358,   835,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   836,
     379,   380,   381,   382,     0,   383,   384,   837,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,   838,   398,   839,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   841,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   843,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   865,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,   241,   242,
     822,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,  1028,   829,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,   830,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   836,   379,   380,   381,   382,     0,   383,   384,   837,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,   838,
     398,   839,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     841,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   843,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   865,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
     241,   242,   822,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,  1038,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   836,   379,   380,   381,   382,     0,   383,
     384,   837,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,   838,   398,   839,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   841,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   843,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,   821,   238,
     239,   240,   241,   242,   822,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,   823,     0,   260,
     261,   262,   263,   264,   824,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,   825,   273,   274,     0,     0,
       0,   826,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,   827,     0,   828,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,  1049,   829,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,   830,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,   831,   832,   348,   833,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,   834,
     358,   835,     0,   359,   360,   361,     0,     0,   362,   363,
    1050,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   836,   379,   380,   381,   382,
       0,   383,   384,   837,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,   838,   398,   839,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   840,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   841,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,   842,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   843,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,  2343,   255,   256,   257,   258,   259,     0,     0,
    2423,   260,   261,   262,   263,   264,     0,   265,   266,  2344,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,  2424,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,  2345,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,  2346,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,  2425,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,  2347,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
    2348,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,  2343,   255,   256,   257,   258,   259,
       0,     0,  3375,   260,   261,   262,   263,   264,     0,   265,
     266,  2344,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,  3376,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,  2345,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,  2346,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,  3377,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,  2347,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,  2348,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,  2343,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,  2344,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,  2345,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,  2346,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,  2347,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,  2348,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   754,   228,   229,
     720,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,   721,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,   755,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   722,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   723,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,   720,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,   721,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,  3045,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   722,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   723,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,   720,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,   721,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   722,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   723,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,  1689,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,  1690,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,  1691,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,  1692,   317,     0,     0,     0,  1693,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,  1694,  1695,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,  1696,   445,   446,   447,   448,     0,  1697,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,  1698,   474,  1699,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,  1700,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,  1701,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
     721,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   722,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   723,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
     901,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   902,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   785,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     3,     4,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,  3150,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,  3151,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,  3165,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,  3166,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
     637,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   638,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,   746,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   747,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   748,   481,     0,     0,   749,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,   779,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     780,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   781,   481,     0,     0,   782,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   785,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,   871,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   872,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
    1007,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,  1230,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
    1241,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   765,   251,   252,
     253,  1242,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   768,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   769,   439,   440,   441,   442,   443,
     770,   445,   446,   447,   448,     0,   449,   450,   451,   452,
    1234,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   772,   481,     0,     0,   773,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   774,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,  1344,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   785,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,  1406,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,  1407,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
     746,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,  2263,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,  2930,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,  2931,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,  2932,   474,   475,  2933,   477,
    2934,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,  2935,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,   646,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,  4198,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,  4212,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,  4482,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,  4484,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,  4486,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,  4739,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,  3377,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   735,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   744,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   765,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   766,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   767,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   768,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   769,   439,
     440,   441,   442,   443,   770,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   771,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   772,   481,     0,
       0,   773,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   774,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   797,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   896,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     911,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   968,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   982,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,  1019,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,  1040,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    1042,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,  1044,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,  1047,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,  1055,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   765,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   768,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   769,   439,   440,   441,   442,   443,   770,   445,
     446,   447,   448,     0,   449,   450,   451,   452,  1234,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   772,   481,     0,     0,   773,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     774,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,  1282,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,  1283,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,  1560,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,  1592,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,  1626,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,  1628,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    1630,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,  1725,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,  2303,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,     0,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   480,   481,     0,
       0,   482,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   765,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   768,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     769,   439,   440,   441,   442,   443,   770,   445,   446,   447,
     448,     0,   449,   450,   451,   452,  1234,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,  2334,   476,   477,   478,   479,     0,   772,
     481,     0,     0,   773,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   774,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   765,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   768,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   769,   439,   440,   441,   442,   443,  2405,   445,
     446,   447,   448,     0,   449,   450,   451,   452,  2406,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   772,   481,     0,     0,  2407,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     774,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    2691,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,  3056,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,     0,   238,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,   765,   251,   252,   253,   254,     0,   255,   256,   257,
     258,   259,     0,     0,     0,   260,   261,   262,   263,   264,
       0,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,     0,   273,   274,     0,     0,     0,     0,     0,     0,
       0,   275,   276,   277,   278,   279,   280,   281,   282,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,     0,     0,   316,     0,   317,     0,     0,
       0,   318,   319,   320,     0,   321,   322,     0,   323,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,   335,   336,   337,     0,   338,     0,   339,
     340,   341,   342,   343,   344,   345,     0,   346,     0,   347,
       0,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,   357,     0,   358,     0,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   768,
     378,     0,   379,   380,   381,   382,     0,   383,   384,     0,
     385,     0,   386,   387,   388,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,   397,     0,
     398,     0,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,     0,   408,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   769,   439,
     440,   441,   442,   443,   770,   445,   446,   447,   448,     0,
     449,   450,   451,   452,  2406,     0,   454,   455,   456,   457,
       0,   458,   459,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,   772,   481,     0,
       0,  2407,   483,   484,   485,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,   502,   503,     0,
     504,     0,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   774,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,     0,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,     0,   238,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,   252,   253,   254,     0,   255,
     256,   257,   258,   259,     0,     0,     0,   260,   261,   262,
     263,   264,     0,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,     0,   273,   274,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,   278,   279,   280,   281,
     282,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,     0,     0,   316,     0,   317,
       0,     0,     0,   318,   319,   320,     0,   321,   322,     0,
     323,     0,   324,   325,   326,   327,  3153,     0,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
       0,   339,   340,   341,   342,   343,   344,   345,     0,   346,
       0,   347,     0,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,   357,     0,   358,     0,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,     0,   383,
     384,     0,   385,     0,   386,   387,   388,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
     397,     0,   398,     0,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,     0,   408,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,   455,
     456,   457,     0,   458,   459,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,   480,
     481,     0,     0,   482,   483,   484,   485,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,   502,
     503,     0,   504,     0,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,     0,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,   223,   224,   225,   226,   227,
     228,   229,     0,   231,   232,   233,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,   236,   237,     0,   238,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,   250,   251,   252,   253,   254,
       0,   255,   256,   257,   258,   259,     0,     0,     0,   260,
     261,   262,   263,   264,     0,   265,   266,     0,   267,   268,
     269,   270,   271,   272,     0,     0,   273,   274,     0,     0,
       0,     0,     0,     0,     0,   275,   276,   277,   278,   279,
     280,   281,   282,   283,     0,   284,     0,   285,   286,   287,
     288,   289,     0,   290,   291,   292,     0,     0,   293,   294,
     295,   296,   297,     0,   298,   299,   300,     0,   301,   302,
     303,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,     0,     0,   316,
       0,   317,     0,     0,     0,   318,   319,   320,     0,   321,
     322,     0,   323,     0,   324,   325,   326,   327,  3158,     0,
     329,   330,   331,     0,   332,   333,   334,   335,   336,   337,
       0,   338,     0,   339,   340,   341,   342,   343,   344,   345,
       0,   346,     0,   347,     0,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,   355,     0,   356,   357,     0,
     358,     0,     0,   359,   360,   361,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
       0,   383,   384,     0,   385,     0,   386,   387,   388,   389,
     390,   391,     0,   392,     0,     0,   393,   394,   395,     0,
       0,   396,   397,     0,   398,     0,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,     0,   408,   409,
     410,   411,     0,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,   451,   452,   453,     0,
     454,   455,   456,   457,     0,   458,   459,   460,     0,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
       0,   472,   473,     0,   474,   475,   476,   477,   478,   479,
       0,   480,   481,     0,     0,   482,   483,   484,   485,     0,
     486,   487,   488,   489,     0,   490,   491,     0,     0,   492,
     493,   494,   495,   496,     0,     0,   497,   498,   499,   500,
     501,   502,   503,     0,   504,     0,   505,   506,   507,   508,
       0,     0,   509,     0,     0,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,     0,
     534,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,     0,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
       0,   238,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
     253,   254,     0,   255,   256,   257,   258,   259,     0,     0,
       0,   260,   261,   262,   263,   264,     0,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,     0,   273,   274,
       0,     0,     0,     0,     0,     0,     0,   275,   276,   277,
     278,   279,   280,   281,   282,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,     0,
       0,   316,     0,   317,     0,     0,     0,   318,   319,   320,
       0,   321,   322,     0,   323,     0,   324,   325,   326,   327,
    3280,     0,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,     0,   339,   340,   341,   342,   343,
     344,   345,     0,   346,     0,   347,     0,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
     357,     0,   358,     0,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,     0,   383,   384,     0,   385,     0,   386,   387,
     388,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,   397,     0,   398,     0,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,     0,
     408,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,   455,   456,   457,     0,   458,   459,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,   480,   481,     0,     0,   482,   483,   484,
     485,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,   502,   503,     0,   504,     0,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,     0,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,     0,   238,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,   252,   253,   254,     0,   255,   256,   257,   258,   259,
       0,     0,     0,   260,   261,   262,   263,   264,     0,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,     0,
     273,   274,     0,     0,     0,     0,     0,     0,     0,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,   295,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,     0,     0,   316,     0,   317,     0,     0,     0,   318,
     319,   320,     0,   321,   322,     0,   323,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,     0,   339,   340,   341,
     342,   343,   344,   345,     0,   346,     0,   347,     0,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,   357,     0,   358,     0,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,     0,   383,   384,     0,   385,     0,
     386,   387,   388,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,   397,     0,   398,     0,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,     0,   408,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,     0,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   438,   439,   440,     0,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,   455,   456,   457,     0,   458,
     459,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,   480,   481,     0,     0,   482,
     483,   484,   485,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,   502,   503,     0,   504,     0,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,     0,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,  1514,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,   223,   224,   225,   226,   227,   228,   229,     0,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,   236,   237,   821,   238,   239,   240,     0,  1515,
     822,  1516,  1517,     0,   245,   246,   247,   248,   249,     0,
       0,   250,   251,  1518,  1519,   254,     0,   255,   256,   257,
     258,     0,     0,   823,     0,   260,   261,   262,   263,   264,
     824,   265,   266,     0,   267,   268,   269,   270,   271,   272,
       0,   825,   273,   274,     0,     0,     0,   826,     0,     0,
       0,   275,   276,   277,   278,   279,   280,  1520,  1521,   283,
       0,   284,     0,   285,   286,   287,   288,   289,     0,   290,
     291,   292,     0,     0,   293,   294,  1148,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,     0,     0,   304,
     305,   306,     0,   308,   309,   310,     0,     0,   312,     0,
     313,   314,  1522,     0,     0,   316,     0,   317,   827,     0,
     828,   318,   319,   320,     0,   321,     0,     0,   323,     0,
     324,   325,   326,   327,   328,   829,   329,   330,   331,  2306,
     332,   333,   334,   335,   336,   337,     0,   338,   830,  2307,
     340,   341,   342,   343,  1523,  1524,     0,  1525,     0,   347,
     831,   832,   348,   833,   349,   350,   351,   352,   353,     0,
     354,   355,     0,   356,     0,   834,   358,   835,     0,   359,
     360,   361,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1526,   836,  1527,   380,   381,     0,     0,   383,   384,   837,
     385,     0,     0,   387,  1528,   389,   390,   391,     0,   392,
       0,     0,   393,   394,   395,     0,     0,   396,  2309,   838,
     398,   839,     0,   400,   401,   402,   403,     0,   404,   405,
       0,   406,     0,     0,     0,   409,   410,   411,     0,   412,
     413,   414,   415,   416,   417,   418,   419,  1529,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   840,   438,   439,
       0,   441,   442,   443,   444,   445,   446,   447,   448,     0,
     449,   450,   451,   452,   453,     0,   454,  2310,   456,   457,
     841,   458,  1531,   460,     0,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,     0,     0,   472,   473,     0,
     474,   475,   476,   477,   478,   479,     0,  1532,  1533,     0,
       0,   482,     0,   484,     0,     0,   486,   487,   488,   489,
       0,   490,   491,     0,     0,   492,   493,   494,   495,   496,
       0,     0,   497,   498,   499,   500,   501,     0,  1534,  2311,
     504,   842,   505,   506,   507,   508,     0,     0,   509,     0,
       0,   510,   511,   512,   513,   514,   515,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   525,   526,   527,   528,
     529,   530,   531,   532,   533,     0,   534,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,     0,     0,   546,
     547,   548,   549,   550,   551,   843,   552,     0,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,     0,   574,     0,
     575,   576,  1514,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,   222,   223,   224,   225,   226,   227,   228,
     229,     0,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,   234,   235,     0,   236,   237,   821,   238,   239,
     240,     0,  1515,   822,  1516,  1517,     0,   245,   246,   247,
     248,   249,     0,     0,   250,   251,  1518,  1519,   254,     0,
     255,   256,   257,   258,     0,     0,   823,     0,   260,   261,
     262,   263,   264,   824,   265,   266,     0,   267,   268,   269,
     270,   271,   272,     0,   825,   273,   274,     0,     0,     0,
     826,     0,     0,     0,   275,   276,   277,   278,   279,   280,
    1520,  1521,   283,     0,   284,     0,   285,   286,   287,   288,
     289,     0,   290,   291,   292,     0,     0,   293,   294,  1148,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
       0,     0,   304,   305,   306,     0,   308,   309,   310,     0,
       0,   312,     0,   313,   314,  1522,     0,     0,   316,     0,
     317,   827,     0,   828,   318,   319,   320,     0,   321,     0,
       0,   323,     0,   324,   325,   326,   327,   328,   829,   329,
     330,   331,     0,   332,   333,   334,   335,   336,   337,     0,
     338,   830,     0,   340,   341,   342,   343,  1523,  1524,     0,
    1525,     0,   347,   831,   832,   348,   833,   349,   350,   351,
     352,   353,     0,   354,   355,     0,   356,     0,   834,   358,
     835,     0,   359,   360,   361,     0,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  1526,   836,  1527,   380,   381,     0,     0,
     383,   384,   837,   385,  2401,     0,   387,  1528,   389,   390,
     391,     0,   392,     0,     0,   393,   394,   395,     0,     0,
     396,     0,   838,   398,   839,     0,   400,   401,   402,   403,
       0,   404,   405,     0,   406,     0,     0,     0,   409,   410,
     411,     0,   412,   413,   414,   415,   416,   417,   418,   419,
    1529,   421,   422,   423,   424,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
     840,   438,   439,     0,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,   453,     0,   454,
    2310,   456,   457,   841,   458,  1531,   460,     0,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,     0,     0,
     472,   473,  4045,   474,   475,   476,   477,   478,   479,     0,
    1532,  1533,     0,     0,   482,     0,   484,     0,     0,   486,
     487,   488,   489,     0,   490,   491,     0,     0,   492,   493,
     494,   495,   496,     0,     0,   497,   498,   499,   500,   501,
       0,  1534,     0,   504,   842,   505,   506,   507,   508,     0,
       0,   509,     0,     0,   510,   511,   512,   513,   514,   515,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,     0,   534,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
       0,     0,   546,   547,   548,   549,   550,   551,   843,   552,
       0,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
       0,   574,     0,   575,   576,  1514,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,   222,   223,   224,   225,
     226,   227,   228,   229,     0,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,   236,   237,
     821,   238,   239,   240,     0,  1515,   822,  1516,  1517,     0,
     245,   246,   247,   248,   249,     0,     0,   250,   251,  1518,
    1519,   254,     0,   255,   256,   257,   258,     0,     0,   823,
       0,   260,   261,   262,   263,   264,   824,   265,   266,     0,
     267,   268,   269,   270,   271,   272,     0,   825,   273,   274,
       0,     0,     0,   826,     0,     0,     0,   275,   276,   277,
     278,   279,   280,  1520,  1521,   283,     0,   284,     0,   285,
     286,   287,   288,   289,     0,   290,   291,   292,     0,     0,
     293,   294,  1148,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,     0,     0,   304,   305,   306,     0,   308,
     309,   310,     0,     0,   312,     0,   313,   314,  1522,     0,
       0,   316,     0,   317,   827,     0,   828,   318,   319,   320,
       0,   321,     0,     0,   323,     0,   324,   325,   326,   327,
     328,   829,   329,   330,   331,     0,   332,   333,   334,   335,
     336,   337,     0,   338,   830,     0,   340,   341,   342,   343,
    1523,  1524,     0,  1525,     0,   347,   831,   832,   348,   833,
     349,   350,   351,   352,   353,     0,   354,   355,     0,   356,
       0,   834,   358,   835,     0,   359,   360,   361,     0,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,  1526,   836,  1527,   380,
     381,  2482,     0,   383,   384,   837,   385,     0,     0,   387,
    1528,   389,   390,   391,     0,   392,     0,     0,   393,   394,
     395,     0,     0,   396,     0,   838,   398,   839,     0,   400,
     401,   402,   403,     0,   404,   405,     0,   406,     0,     0,
       0,   409,   410,   411,     0,   412,   413,   414,   415,   416,
     417,   418,   419,  1529,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   840,   438,   439,     0,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,   451,   452,
     453,     0,   454,  1530,   456,   457,   841,   458,  1531,   460,
       0,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,     0,     0,   472,   473,     0,   474,   475,   476,   477,
     478,   479,     0,  1532,  1533,     0,     0,   482,     0,   484,
       0,     0,   486,   487,   488,   489,     0,   490,   491,     0,
       0,   492,   493,   494,   495,   496,     0,     0,   497,   498,
     499,   500,   501,     0,  1534,     0,   504,   842,   505,   506,
     507,   508,     0,     0,   509,     0,     0,   510,   511,   512,
     513,   514,   515,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   525,   526,   527,   528,   529,   530,   531,   532,
     533,     0,   534,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,     0,     0,   546,   547,   548,   549,   550,
     551,   843,   552,     0,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,     0,   574,     0,   575,   576,  1514,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,   222,
     223,   224,   225,   226,   227,   228,   229,     0,   231,   232,
     233,     0,     0,     0,     0,     0,     0,     0,   234,   235,
       0,   236,   237,   821,   238,   239,   240,     0,  1515,   822,
    1516,  1517,     0,   245,   246,   247,   248,   249,     0,     0,
     250,   251,  1518,  1519,   254,     0,   255,   256,   257,   258,
       0,     0,   823,     0,   260,   261,   262,   263,   264,   824,
     265,   266,     0,   267,   268,   269,   270,   271,   272,     0,
     825,   273,   274,     0,     0,     0,   826,     0,     0,     0,
     275,   276,   277,   278,   279,   280,  1520,  1521,   283,     0,
     284,     0,   285,   286,   287,   288,   289,     0,   290,   291,
     292,     0,     0,   293,   294,  1148,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,     0,     0,   304,   305,
     306,     0,   308,   309,   310,     0,     0,   312,     0,   313,
     314,  1522,     0,     0,   316,     0,   317,   827,     0,   828,
     318,   319,   320,     0,   321,     0,     0,   323,     0,   324,
     325,   326,   327,   328,   829,   329,   330,   331,     0,   332,
     333,   334,   335,   336,   337,     0,   338,   830,     0,   340,
     341,   342,   343,  1523,  1524,     0,  1525,     0,   347,   831,
     832,   348,   833,   349,   350,   351,   352,   353,     0,   354,
     355,     0,   356,     0,   834,   358,   835,     0,   359,   360,
     361,     0,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,  1526,
     836,  1527,   380,   381,  3842,     0,   383,   384,   837,   385,
       0,     0,   387,  1528,   389,   390,   391,     0,   392,     0,
       0,   393,   394,   395,     0,     0,   396,     0,   838,   398,
     839,     0,   400,   401,   402,   403,     0,   404,   405,     0,
     406,     0,     0,     0,   409,   410,   411,     0,   412,   413,
     414,   415,   416,   417,   418,   419,  1529,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   840,   438,   439,     0,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,   453,     0,   454,  1530,   456,   457,   841,
     458,  1531,   460,     0,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,     0,     0,   472,   473,     0,   474,
     475,   476,   477,   478,   479,     0,  1532,  1533,     0,     0,
     482,     0,   484,     0,     0,   486,   487,   488,   489,     0,
     490,   491,     0,     0,   492,   493,   494,   495,   496,     0,
       0,   497,   498,   499,   500,   501,     0,  1534,     0,   504,
     842,   505,   506,   507,   508,     0,     0,   509,     0,     0,
     510,   511,   512,   513,   514,   515,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,     0,   534,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,     0,     0,   546,   547,
     548,   549,   550,   551,   843,   552,     0,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,     0,   574,     0,   575,
     576,  1514,   578,   579,   580,   581,   582,   583,   584,   585,
       0,     0,   222,   223,   224,   225,   226,   227,   228,   229,
       0,   231,   232,   233,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,   236,   237,   821,   238,   239,   240,
       0,  1515,   822,  1516,  1517,     0,   245,   246,   247,   248,
     249,     0,     0,   250,   251,  1518,  1519,   254,     0,   255,
     256,   257,   258,     0,     0,   823,     0,   260,   261,   262,
     263,   264,   824,   265,   266,     0,   267,   268,   269,   270,
     271,   272,     0,   825,   273,   274,     0,     0,     0,   826,
       0,     0,     0,   275,   276,   277,   278,   279,   280,  1520,
    1521,   283,     0,   284,     0,   285,   286,   287,   288,   289,
       0,   290,   291,   292,     0,     0,   293,   294,  1148,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,     0,
       0,   304,   305,   306,     0,   308,   309,   310,     0,     0,
     312,     0,   313,   314,  1522,     0,     0,   316,     0,   317,
     827,     0,   828,   318,   319,   320,     0,   321,     0,     0,
     323,     0,   324,   325,   326,   327,   328,   829,   329,   330,
     331,     0,   332,   333,   334,   335,   336,   337,     0,   338,
     830,     0,   340,   341,   342,   343,  1523,  1524,     0,  1525,
       0,   347,   831,   832,   348,   833,   349,   350,   351,   352,
     353,     0,   354,   355,     0,   356,     0,   834,   358,   835,
       0,   359,   360,   361,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1526,   836,  1527,   380,   381,     0,     0,   383,
     384,   837,   385,     0,     0,   387,  1528,   389,   390,   391,
       0,   392,     0,     0,   393,   394,   395,     0,     0,   396,
       0,   838,   398,   839,     0,   400,   401,   402,   403,     0,
     404,   405,     0,   406,     0,     0,     0,   409,   410,   411,
       0,   412,   413,   414,   415,   416,   417,   418,   419,  1529,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,   840,
     438,   439,     0,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,   453,     0,   454,  1530,
     456,   457,   841,   458,  1531,   460,     0,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,     0,     0,   472,
     473,     0,   474,   475,   476,   477,   478,   479,     0,  1532,
    1533,     0,     0,   482,     0,   484,     0,     0,   486,   487,
     488,   489,     0,   490,   491,     0,     0,   492,   493,   494,
     495,   496,     0,     0,   497,   498,   499,   500,   501,     0,
    1534,     0,   504,   842,   505,   506,   507,   508,     0,     0,
     509,     0,     0,   510,   511,   512,   513,   514,   515,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   525,   526,
     527,   528,   529,   530,   531,   532,   533,     0,   534,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,     0,
       0,   546,   547,   548,   549,   550,   551,   843,   552,     0,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,     0,
     574,     0,   575,   576,  1514,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,   222,   223,   224,   225,   226,
     227,   228,   229,     0,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,   236,   237,   821,
     238,   239,   240,     0,  1515,   822,  1516,  1517,     0,   245,
     246,   247,   248,   249,     0,     0,   250,   251,  1518,  1519,
     254,     0,   255,   256,   257,   258,     0,     0,   823,     0,
     260,   261,   262,   263,   264,   824,   265,   266,     0,   267,
     268,   269,   270,   271,   272,     0,   825,   273,   274,     0,
       0,     0,   826,     0,     0,     0,   275,   276,   277,   278,
     279,   280,  1520,  1521,   283,     0,   284,     0,   285,   286,
     287,   288,   289,     0,   290,   291,   292,     0,     0,   293,
     294,  1148,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,     0,     0,   304,   305,   306,     0,   308,   309,
     310,     0,     0,   312,     0,   313,   314,  1522,     0,     0,
     316,     0,   317,   827,     0,   828,   318,   319,   320,     0,
     321,     0,     0,   323,     0,   324,   325,   326,   327,   328,
     829,   329,   330,   331,     0,   332,   333,   334,   335,   336,
     337,     0,   338,   830,     0,   340,   341,   342,   343,  1523,
    1524,     0,  1525,     0,   347,   831,   832,   348,   833,   349,
     350,   351,   352,   353,     0,   354,   355,     0,   356,     0,
     834,   358,   835,     0,   359,   360,   361,     0,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1526,   836,  1527,   380,   381,
       0,     0,   383,   384,   837,   385,     0,     0,   387,  1528,
     389,   390,   391,     0,   392,     0,     0,   393,   394,   395,
       0,     0,   396,     0,   838,   398,   839,     0,   400,   401,
     402,   403,     0,   404,   405,     0,   406,     0,     0,     0,
     409,   410,   411,     0,   412,   413,   414,   415,   416,   417,
     418,   419,  1529,   421,   422,   423,   424,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   840,   438,   439,     0,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,   453,
       0,   454,  2310,   456,   457,   841,   458,  1531,   460,     0,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
       0,     0,   472,   473,     0,   474,   475,   476,   477,   478,
     479,     0,  1532,  1533,     0,     0,   482,     0,   484,     0,
       0,   486,   487,   488,   489,     0,   490,   491,     0,     0,
     492,   493,   494,   495,   496,     0,     0,   497,   498,   499,
     500,   501,     0,  1534,     0,   504,   842,   505,   506,   507,
     508,     0,     0,   509,     0,     0,   510,   511,   512,   513,
     514,   515,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
       0,   534,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,     0,     0,   546,   547,   548,   549,   550,   551,
     843,   552,     0,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,     0,   574,     0,   575,   576,  1514,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   222,   223,
     224,   225,   226,   227,   228,   229,     0,   231,   232,   233,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
     236,   237,   821,   238,   239,   240,     0,  1515,   822,  1516,
    1517,     0,   245,   246,   247,   248,   249,     0,     0,   250,
     251,  1518,  1519,   254,     0,   255,   256,   257,   258,     0,
       0,   823,     0,   260,   261,   262,   263,   264,   824,   265,
     266,     0,   267,   268,   269,   270,   271,   272,     0,   825,
     273,   274,     0,     0,     0,   826,     0,     0,     0,   275,
     276,   277,   278,   279,   280,  1520,  1521,   283,     0,   284,
       0,   285,   286,   287,   288,   289,     0,   290,   291,   292,
       0,     0,   293,   294,  1148,   296,   297,     0,   298,   299,
     300,     0,   301,   302,   303,     0,     0,   304,   305,   306,
       0,   308,   309,   310,     0,     0,   312,     0,   313,   314,
    1522,     0,     0,   316,     0,   317,   827,     0,   828,   318,
     319,   320,     0,   321,     0,     0,   323,     0,   324,   325,
     326,   327,   328,   829,   329,   330,   331,     0,   332,   333,
     334,   335,   336,   337,     0,   338,   830,     0,   340,   341,
     342,   343,  1523,  1524,     0,  1525,     0,   347,   831,   832,
     348,   833,   349,   350,   351,   352,   353,     0,   354,   355,
       0,   356,     0,   834,   358,   835,     0,   359,   360,   361,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1526,   836,
    1527,   380,   381,     0,     0,   383,   384,   837,   385,     0,
       0,   387,  1528,   389,   390,   391,     0,   392,     0,     0,
     393,   394,   395,     0,     0,   396,     0,   838,   398,   839,
       0,   400,   401,   402,   403,     0,   404,   405,     0,   406,
       0,     0,     0,   409,   410,   411,     0,   412,   413,   414,
     415,   416,   417,   418,   419,  1529,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,   840,   438,   439,     0,   441,
     442,   443,   444,   445,   446,   447,   448,     0,   449,   450,
     451,   452,   453,     0,   454,     0,   456,   457,   841,   458,
    1531,   460,     0,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,     0,     0,   472,   473,     0,   474,   475,
     476,   477,   478,   479,     0,  1532,  1533,     0,     0,   482,
       0,   484,     0,     0,   486,   487,   488,   489,     0,   490,
     491,     0,     0,   492,   493,   494,   495,   496,     0,     0,
     497,   498,   499,   500,   501,     0,  1534,     0,   504,   842,
     505,   506,   507,   508,     0,     0,   509,     0,     0,   510,
     511,   512,   513,   514,   515,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   525,   526,   527,   528,   529,   530,
     531,   532,   533,     0,   534,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,     0,     0,   546,   547,   548,
     549,   550,   551,   843,   552,     0,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,     0,   574,     0,   575,   576,
    1514,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   222,   223,   224,   225,   226,   227,   228,   229,     0,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
     234,   235,     0,   236,   237,   821,   238,   239,   240,     0,
       0,   822,     0,     0,     0,   245,   246,   247,   248,   249,
       0,     0,   250,   251,     0,     0,   254,     0,   255,   256,
     257,   258,     0,     0,   823,     0,   260,   261,   262,   263,
     264,   824,   265,   266,     0,   267,   268,   269,   270,   271,
     272,     0,   825,   273,   274,     0,     0,     0,   826,     0,
       0,     0,   275,   276,   277,   278,   279,   280,     0,     0,
     283,     0,   284,     0,   285,   286,   287,   288,   289,     0,
     290,   291,   292,     0,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,     0,     0,
     304,   305,   306,     0,   308,   309,   310,     0,     0,   312,
       0,   313,   314,     0,     0,     0,   316,     0,   317,   827,
       0,   828,   318,   319,   320,     0,   321,     0,     0,   323,
       0,   324,   325,   326,   327,   328,   829,   329,   330,   331,
       0,   332,   333,   334,   335,   336,   337,     0,   338,   830,
       0,   340,   341,   342,   343,     0,     0,     0,     0,     0,
     347,   831,   832,   348,   833,   349,   350,   351,   352,   353,
       0,   354,   355,     0,   356,     0,   834,   358,   835,     0,
     359,   360,   361,     0,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   836,     0,   380,   381,     0,     0,   383,   384,
     837,   385,     0,     0,   387,     0,   389,   390,   391,     0,
     392,     0,     0,   393,   394,   395,     0,     0,   396,     0,
     838,   398,   839,     0,   400,   401,   402,   403,     0,   404,
     405,     0,   406,     0,     0,     0,   409,   410,   411,     0,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   421,
     422,   423,   424,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,   840,   438,
     439,     0,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,   451,   452,   453,     0,   454,     0,   456,
     457,   841,   458,     0,   460,     0,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,     0,     0,   472,   473,
       0,   474,   475,   476,   477,   478,   479,     0,     0,     0,
       0,     0,   482,     0,   484,     0,     0,   486,   487,   488,
     489,     0,   490,   491,     0,     0,   492,   493,   494,   495,
     496,     0,     0,   497,   498,   499,   500,   501,     0,     0,
       0,   504,   842,   505,   506,   507,   508,     0,     0,   509,
       0,     0,   510,   511,   512,   513,   514,   515,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   525,   526,   527,
     528,   529,   530,   531,   532,   533,     0,   534,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,     0,     0,
     546,   547,   548,   549,   550,   551,   843,   552,     0,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,     0,   574,
       0,   575,   576,  3128,   578,   579,   580,   581,   582,   583,
     584,   585,     0,     0,  1806,  1807,  1808,  1809,     0,  1811,
    1812,  1813,     0,  1814,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1818,  1819,     0,     0,     0,  1821,  1822,
    1823,  1824,     0,  1826,  1827,  1828,  1829,     0,  1830,  1831,
    1832,  1833,  1834,     0,     0,     0,  1835,     0,     0,  1836,
       0,  1837,  1838,  1839,  1840,  1841,     0,     0,     0,  1843,
       0,  1844,  1845,  1846,     0,     0,  1847,     0,  1848,  1849,
       0,  1850,  1851,  1852,     0,     0,  1853,     0,     0,     0,
       0,     0,     0,     0,     0,  1854,  1855,     0,  1856,     0,
    1857,  1858,  1859,  1860,     0,  1861,     0,  1862,  1863,  1864,
    1865,  1866,     0,     0,  1867,     0,     0,     0,     0,  1868,
    1869,  1870,  1871,     0,  1872,  1873,  1874,  3129,  1875,  1876,
       0,     0,     0,  1877,  1878,  1879,  1880,  1881,     0,  1882,
    1883,     0,     0,     0,     0,  1884,  1885,     0,  3130,  1886,
       0,  1887,  1888,     0,     0,  1889,     0,  1890,     0,  1891,
    1892,     0,  1893,     0,  1894,  1895,     0,     0,  1896,     0,
    1898,  1899,  1900,     0,  1902,  1903,  1904,  1905,  1906,  1907,
       0,     0,     0,  1908,  1909,  1910,  1911,  1912,  1913,  1914,
       0,  1915,     0,  1916,     0,     0,  1919,     0,  1920,     0,
    1921,  1922,  1923,     0,     0,     0,     0,     0,  1924,     0,
    1925,     0,     0,  1927,  1928,  1929,     0,     0,  1930,  1931,
       0,  1932,     0,  1933,  1934,  1935,  1936,     0,  1937,  1938,
       0,  1939,  1940,  1941,  1942,     0,  1943,  1944,  1945,  1946,
       0,  1948,  1949,     0,  1951,     0,  1952,  1953,  1954,  1955,
    1956,     0,     0,  1957,     0,     0,  3131,  1959,  1960,     0,
       0,     0,  1962,  1963,     0,     0,  1964,  1965,  1966,     0,
    1967,     0,     0,  1968,     0,     0,  1969,     0,  1970,  1971,
    1972,  1973,     0,  1974,  1975,  1976,  1977,     0,  1978,  1979,
    1980,  1981,  1982,  1983,     0,     0,     0,     0,  1984,  1985,
    1986,  1987,  1988,  1989,     0,  1990,  1991,  1992,     0,  1993,
    1994,     0,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,
    2003,     0,  2004,     0,  2005,     0,  2006,     0,  2007,     0,
    2008,  2009,  2010,  2011,     0,  2013,  2014,     0,     0,  2015,
       0,  3132,  2017,  2018,  2019,  2020,  2021,  2022,     0,  2023,
       0,  2024,  2025,     0,     0,     0,  2027,  2028,  2029,     0,
       0,  2030,  2031,     0,     0,  2032,  2033,  2034,  2035,     0,
    2036,  2037,  2038,     0,     0,  2039,  2040,     0,     0,  2041,
    2042,     0,  2043,  2044,     0,     0,  2045,  2046,     0,  2047,
    2048,  3133,  2050,     0,     0,  2051,  2052,  2053,     0,  2054,
       0,     0,     0,     0,     0,     0,     0,  2055,     0,  2056,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2057,  2058,  2059,  2060,  2061,  2062,  2063,     0,
       0,     0,     0,  2064,  2065,  2066,     0,  2067,  2068,  2069,
       0,  2070,  2071,  2072,  2073,     0,  2074,     0,  2075,  2076,
    2077,     0,  2078,  2079,  2080,     0,  2081,     0,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,     0,     0,     0,     0,     0,
    2089,  2090,  3128,     0,  2091,  2092,  2093,  2094,  2095,  2096,
    2097,  2098,     0,  1806,  1807,  1808,  1809,     0,  1811,  1812,
    1813,     0,  1814,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1818,  1819,     0,     0,     0,  1821,  1822,  1823,
    1824,     0,  1826,  1827,  1828,  1829,     0,  1830,  1831,  1832,
    1833,  1834,     0,     0,     0,  1835,     0,     0,  1836,     0,
    1837,  1838,  1839,  1840,  1841,     0,     0,     0,  1843,     0,
    1844,  1845,  1846,     0,     0,  1847,     0,  1848,  1849,     0,
    1850,  1851,  1852,     0,     0,  1853,     0,     0,     0,     0,
       0,     0,     0,     0,  1854,  1855,     0,  1856,     0,  1857,
    1858,  1859,  1860,     0,  1861,     0,  1862,  1863,  1864,  1865,
    1866,     0,     0,  1867,     0,     0,     0,     0,  1868,  1869,
    1870,  1871,     0,  1872,  1873,  1874,     0,  1875,  1876,     0,
       0,     0,  1877,  1878,  1879,  1880,  1881,     0,  1882,  1883,
       0,     0,     0,     0,  1884,  1885,     0,  3130,  1886,     0,
    1887,  1888,     0,     0,  1889,     0,  1890,     0,  1891,  1892,
       0,  1893,     0,  1894,  1895,     0,     0,  1896,     0,  1898,
    1899,  1900,     0,  1902,  1903,  1904,  1905,  1906,  1907,     0,
       0,     0,  1908,  1909,  1910,  1911,  1912,  1913,  1914,     0,
    1915,     0,  1916,     0,     0,  1919,     0,  1920,     0,  1921,
    1922,  1923,     0,     0,     0,     0,     0,  1924,     0,  1925,
       0,     0,  1927,  1928,  1929,     0,     0,  1930,  1931,     0,
    1932,     0,  1933,  1934,  1935,  1936,     0,  1937,  1938,     0,
    1939,  1940,  1941,  1942,     0,  1943,  1944,  1945,  1946,     0,
    1948,  1949,     0,  1951,     0,  1952,  1953,  1954,  1955,  1956,
       0,     0,  1957,     0,     0,  3131,  1959,  1960,     0,     0,
       0,  1962,  1963,     0,     0,  1964,  1965,  1966,     0,  1967,
       0,     0,  1968,     0,     0,  1969,     0,  1970,  1971,  1972,
    1973,     0,  1974,  1975,  1976,  1977,     0,  1978,  1979,  1980,
    1981,  1982,  1983,     0,     0,     0,     0,  1984,  1985,  1986,
    1987,  1988,  1989,     0,  1990,  1991,  1992,     0,  1993,  1994,
       0,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
       0,  2004,     0,  2005,     0,  2006,     0,  2007,     0,  2008,
    2009,  2010,  2011,     0,  2013,  2014,     0,     0,  2015,     0,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,     0,  2023,     0,
    2024,  2025,     0,     0,     0,  2027,  2028,  2029,     0,     0,
    2030,  2031,     0,     0,  2032,  2033,  2034,  2035,     0,  2036,
    2037,  2038,     0,     0,  2039,  2040,     0,     0,  2041,  2042,
       0,  2043,  2044,     0,     0,  2045,  2046,     0,  2047,  2048,
    2049,  2050,     0,     0,  2051,  2052,  2053,     0,  2054,     0,
       0,     0,     0,     0,     0,     0,  2055,     0,  2056,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2057,  2058,  2059,  2060,  2061,  2062,  2063,     0,     0,
       0,     0,  2064,  2065,  2066,     0,  2067,  2068,  2069,     0,
    2070,  2071,  2072,  2073,     0,  2074,     0,  2075,  2076,  2077,
       0,  2078,  2079,  2080,     0,  2081,     0,  2082,  2083,  2084,
    2085,  2086,  2087,  2088,     0,     0,     0,     0,     0,  2089,
    2090,  3128,     0,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,     0,  1806,  1807,  1808,  1809,     0,  1811,  1812,  1813,
       0,  1814,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,  1819,     0,     0,     0,  1821,  1822,  1823,  1824,
       0,  1826,  1827,  1828,  1829,     0,  1830,  1831,  1832,  1833,
    1834,     0,     0,     0,  1835,     0,     0,  1836,     0,  1837,
    1838,  1839,  1840,  1841,     0,     0,     0,  1843,     0,  1844,
    1845,  1846,     0,     0,  1847,     0,  1848,  1849,     0,  1850,
    1851,  1852,     0,     0,  1853,     0,     0,     0,     0,     0,
       0,     0,     0,  1854,  1855,     0,  1856,     0,  1857,  1858,
    1859,  1860,     0,  1861,     0,  1862,  1863,  1864,  1865,  1866,
       0,     0,  1867,     0,     0,     0,     0,  1868,  1869,  1870,
    1871,     0,  1872,  1873,  1874,     0,  1875,  1876,     0,     0,
       0,  1877,  1878,  1879,  1880,  1881,     0,  1882,  1883,     0,
       0,     0,     0,  1884,  1885,     0,  3130,  1886,     0,  1887,
    1888,     0,     0,  1889,     0,  1890,     0,  1891,  1892,     0,
    1893,     0,  1894,  1895,     0,     0,  3156,     0,  1898,  1899,
    1900,     0,  1902,  1903,  1904,  1905,  1906,  1907,     0,     0,
       0,  1908,  1909,  1910,  1911,  1912,  1913,  1914,     0,  1915,
       0,  1916,     0,     0,  1919,     0,  1920,     0,  1921,  1922,
    1923,     0,     0,     0,     0,     0,  1924,     0,  1925,     0,
       0,  1927,  1928,  1929,     0,     0,  1930,  1931,     0,  1932,
       0,  1933,  1934,  1935,  1936,     0,  1937,  1938,     0,  1939,
    1940,  1941,  1942,     0,  1943,  1944,  1945,  1946,     0,  1948,
    1949,     0,  1951,     0,  1952,  1953,  1954,  1955,  1956,     0,
       0,  1957,     0,     0,  3131,  1959,  1960,     0,     0,     0,
    1962,  1963,     0,     0,  1964,  1965,  1966,     0,  1967,     0,
       0,  1968,     0,     0,  1969,     0,  1970,  1971,  1972,  1973,
       0,  1974,  1975,  1976,  1977,     0,  1978,  1979,  1980,  1981,
    1982,  1983,     0,     0,     0,     0,  1984,  1985,  1986,  1987,
    1988,  1989,     0,  1990,  1991,  1992,     0,  1993,  1994,     0,
    1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,     0,
    2004,     0,  2005,     0,  2006,     0,  2007,     0,  2008,  2009,
    2010,  2011,     0,  2013,  2014,     0,     0,  2015,     0,  2016,
    2017,  2018,  2019,  2020,  2021,  2022,     0,  2023,     0,  2024,
    2025,     0,     0,     0,  2027,  2028,  2029,     0,     0,  2030,
    2031,     0,     0,  2032,  2033,  2034,  2035,     0,  2036,  2037,
    2038,     0,     0,  2039,  2040,     0,     0,  2041,  2042,     0,
    2043,  2044,     0,     0,  2045,  2046,     0,  2047,  2048,  2049,
    2050,     0,     0,  2051,  2052,  2053,     0,  2054,     0,     0,
       0,     0,     0,     0,     0,  2055,     0,  2056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,     0,     0,     0,
       0,  2064,  2065,  2066,     0,  2067,  2068,  2069,     0,  2070,
    2071,  2072,  2073,     0,  2074,     0,  2075,  2076,  2077,     0,
    2078,  2079,  2080,     0,  2081,     0,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,     0,     0,     0,     0,     0,  2089,  2090,
    3128,     0,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,
       0,  1806,  1807,  1808,  1809,     0,  1811,  1812,  1813,     0,
    1814,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1818,  1819,     0,     0,     0,  1821,  1822,  1823,  1824,     0,
    1826,  1827,  1828,  1829,     0,  1830,  1831,  1832,  1833,  1834,
       0,     0,     0,  1835,     0,     0,  1836,     0,  1837,  1838,
    1839,  1840,  1841,     0,     0,     0,  1843,     0,  1844,  1845,
    1846,     0,     0,  1847,     0,  1848,  1849,     0,  1850,  1851,
    1852,     0,     0,  1853,     0,     0,     0,     0,     0,     0,
       0,     0,  1854,  1855,     0,  1856,     0,  1857,  1858,  1859,
    1860,     0,  1861,     0,  1862,  1863,  1864,  1865,  1866,     0,
       0,  1867,     0,     0,     0,     0,  1868,  1869,  1870,  1871,
       0,  1872,  1873,  1874,     0,  1875,  1876,     0,     0,     0,
    1877,  1878,  1879,  1880,  1881,     0,  1882,  1883,     0,     0,
       0,     0,  1884,  1885,     0,  3130,  1886,     0,  1887,  1888,
       0,     0,  1889,     0,  1890,     0,  1891,  1892,     0,  1893,
       0,  1894,  1895,     0,     0,  3798,     0,  1898,  1899,  1900,
       0,  1902,  1903,  1904,  1905,  1906,  1907,     0,     0,     0,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,     0,  1915,     0,
    1916,     0,     0,  1919,     0,  1920,     0,  1921,  1922,  1923,
       0,     0,     0,     0,     0,  1924,     0,  1925,     0,     0,
    1927,  1928,  1929,     0,     0,  1930,  1931,     0,  1932,     0,
    1933,  1934,  1935,  1936,     0,  1937,  1938,     0,  1939,  1940,
    1941,  1942,     0,  1943,  1944,  1945,  1946,     0,  1948,  1949,
       0,  1951,     0,  1952,  1953,  1954,  1955,  1956,     0,     0,
    1957,     0,     0,  3131,  1959,  1960,     0,     0,     0,  1962,
    1963,     0,     0,  1964,  1965,  1966,     0,  1967,     0,     0,
    1968,     0,     0,  1969,     0,  1970,  1971,  1972,  1973,     0,
    1974,  1975,  1976,  1977,     0,  1978,  1979,  1980,  1981,  1982,
    1983,     0,     0,     0,     0,  1984,  1985,  1986,  1987,  1988,
    1989,     0,  1990,  1991,  1992,     0,  1993,  1994,     0,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,     0,  2004,
       0,  2005,     0,  2006,     0,  2007,     0,  2008,  2009,  2010,
    2011,     0,  2013,  2014,     0,     0,  2015,     0,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,     0,  2023,     0,  2024,  2025,
       0,     0,     0,  2027,  2028,  2029,     0,     0,  2030,  2031,
       0,     0,  2032,  2033,  2034,  2035,     0,  2036,  2037,  2038,
       0,     0,  2039,  2040,     0,     0,  2041,  2042,     0,  2043,
    2044,     0,     0,  2045,  2046,     0,  2047,  2048,  2049,  2050,
       0,     0,  2051,  2052,  2053,     0,  2054,     0,     0,     0,
       0,     0,     0,     0,  2055,     0,  2056,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,     0,     0,     0,     0,
    2064,  2065,  2066,     0,  2067,  2068,  2069,     0,  2070,  2071,
    2072,  2073,     0,  2074,     0,  2075,  2076,  2077,     0,  2078,
    2079,  2080,     0,  2081,     0,  2082,  2083,  2084,  2085,  2086,
    2087,  2088,     0,     0,     0,     0,     0,  2089,  2090,  3128,
       0,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,     0,
    1806,  1807,  1808,  1809,     0,  1811,  1812,  1813,     0,  1814,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1818,
    1819,     0,     0,     0,  1821,  1822,  1823,  1824,     0,  1826,
    1827,  1828,  1829,     0,  1830,  1831,  1832,  1833,  1834,     0,
       0,     0,  1835,     0,     0,  1836,     0,  1837,  1838,  1839,
    1840,  1841,     0,     0,     0,  1843,     0,  1844,  1845,  1846,
       0,     0,  1847,     0,  1848,  1849,     0,  1850,  1851,  1852,
       0,     0,  1853,     0,     0,     0,     0,     0,     0,     0,
       0,  1854,  1855,     0,  1856,     0,  1857,  1858,  1859,  1860,
       0,  1861,     0,  1862,  1863,  1864,  1865,  1866,     0,     0,
    1867,     0,     0,     0,     0,  1868,  1869,  1870,  1871,     0,
    1872,  1873,  1874,     0,  1875,  1876,     0,     0,     0,  1877,
    1878,  1879,  1880,  1881,     0,  1882,  1883,     0,     0,     0,
       0,  1884,  1885,     0,  3130,  1886,     0,  1887,  1888,     0,
       0,  1889,     0,  1890,     0,  1891,  1892,     0,  1893,     0,
    1894,  1895,     0,     0,  1896,     0,  1898,  1899,  1900,     0,
    1902,  1903,  1904,  1905,  1906,  1907,     0,     0,     0,  1908,
    1909,  1910,  1911,  1912,  1913,  1914,     0,  1915,     0,  1916,
       0,     0,  1919,     0,  1920,     0,  1921,  1922,  1923,     0,
       0,     0,     0,     0,  1924,     0,  1925,     0,     0,  1927,
    1928,  1929,     0,     0,  1930,  1931,     0,  1932,     0,  1933,
    1934,  1935,  1936,     0,  1937,  1938,     0,  1939,  1940,  1941,
    1942,     0,  1943,  1944,  1945,  1946,     0,  1948,  1949,     0,
    1951,     0,  1952,  1953,  1954,  1955,  1956,     0,     0,  1957,
       0,     0,  3131,  1959,  1960,     0,     0,     0,  1962,  1963,
       0,     0,  1964,  1965,  1966,     0,  1967,     0,     0,  1968,
       0,     0,  1969,     0,  1970,  1971,  1972,  1973,     0,  1974,
    1975,  1976,  1977,     0,  1978,  1979,  1980,  1981,  1982,  1983,
       0,     0,     0,     0,  1984,  1985,  1986,  1987,  1988,  1989,
       0,  1990,  1991,  1992,     0,  1993,  1994,     0,  1995,  1996,
    1997,  1998,  1999,  2000,  2001,  2002,  2003,     0,  2004,     0,
    2005,     0,  2006,     0,  2007,     0,  2008,  2009,  2010,  2011,
       0,  2013,  2014,     0,     0,  2015,     0,  3132,  2017,  2018,
    2019,  2020,  2021,  2022,     0,  2023,     0,  2024,  2025,     0,
       0,     0,  2027,  2028,  2029,     0,     0,  2030,  2031,     0,
       0,  2032,  2033,  2034,  2035,     0,  2036,  2037,  2038,     0,
       0,  2039,  2040,     0,     0,  2041,  2042,     0,  2043,  2044,
       0,     0,  2045,  2046,     0,  2047,  2048,  2049,  2050,     0,
       0,  2051,  2052,  2053,     0,  2054,     0,     0,     0,     0,
       0,     0,     0,  2055,     0,  2056,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2057,  2058,
    2059,  2060,  2061,  2062,  2063,     0,     0,     0,     0,  2064,
    2065,  2066,     0,  2067,  2068,  2069,     0,  2070,  2071,  2072,
    2073,     0,  2074,     0,  2075,  2076,  2077,     0,  2078,  2079,
    2080,     0,  2081,     0,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,     0,     0,     0,     0,     0,  2089,  2090,  3128,     0,
    2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,     0,  1806,
    1807,  1808,  1809,     0,  1811,  1812,  1813,     0,  1814,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1818,  1819,
       0,     0,     0,  1821,  1822,  1823,  1824,     0,  1826,  1827,
    1828,  1829,     0,  1830,  1831,  1832,  1833,  1834,     0,     0,
       0,  1835,     0,     0,  1836,     0,  1837,  1838,  1839,  1840,
    1841,     0,     0,     0,  1843,     0,  1844,  1845,  1846,     0,
       0,  1847,     0,  1848,  1849,     0,  1850,  1851,  1852,     0,
       0,  1853,     0,     0,     0,     0,     0,     0,     0,     0,
    1854,  1855,     0,  1856,     0,  1857,  1858,  1859,  1860,     0,
    1861,     0,  1862,  1863,  1864,  1865,  1866,     0,     0,  1867,
       0,     0,     0,     0,  1868,  1869,  1870,  1871,     0,  1872,
    1873,  1874,     0,  1875,  1876,     0,     0,     0,  1877,  1878,
    1879,  1880,  1881,     0,  1882,  1883,     0,     0,     0,     0,
    1884,  1885,     0,  3130,  1886,     0,  1887,  1888,     0,     0,
    1889,     0,  1890,     0,  1891,  1892,     0,  1893,     0,  1894,
    1895,     0,     0,  1896,     0,  1898,  1899,  1900,     0,  1902,
    1903,  1904,  1905,  1906,  1907,     0,     0,     0,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,     0,  1915,     0,  1916,     0,
       0,  1919,     0,  1920,     0,  1921,  1922,  1923,     0,     0,
       0,     0,     0,  1924,     0,  1925,     0,     0,  1927,  1928,
    1929,     0,     0,  1930,  1931,     0,  1932,     0,  1933,  1934,
    1935,  1936,     0,  1937,  1938,     0,  1939,  1940,  1941,  1942,
       0,  1943,  1944,  1945,  1946,     0,  1948,  1949,     0,  1951,
       0,  1952,  1953,  1954,  1955,  1956,     0,     0,  1957,     0,
       0,  3131,  1959,  1960,     0,     0,     0,  1962,  1963,     0,
       0,  1964,  1965,  1966,     0,  1967,     0,     0,  1968,     0,
       0,  1969,     0,  1970,  1971,  1972,  1973,     0,  1974,  1975,
    1976,  1977,     0,  1978,  1979,  1980,  1981,  1982,  1983,     0,
       0,     0,     0,  1984,  1985,  1986,  1987,  1988,  1989,     0,
    1990,  1991,  1992,     0,  1993,  1994,     0,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,     0,  2004,     0,  2005,
       0,  2006,     0,  2007,     0,     0,  2009,  2010,  2011,     0,
    2013,  2014,     0,     0,  2015,     0,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,     0,  2023,     0,  2024,  2025,     0,     0,
       0,  2027,  2028,  2029,     0,     0,  2030,  2031,     0,     0,
    2032,  2033,  2034,  2035,     0,  2036,  2037,  2038,     0,     0,
    2039,  2040,     0,     0,  2041,  2042,     0,  2043,  2044,     0,
       0,  2045,  2046,     0,  2047,  2048,  2049,  2050,     0,     0,
    2051,  2052,  2053,     0,  2054,     0,     0,     0,     0,     0,
       0,     0,  2055,     0,  2056,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,     0,     0,     0,     0,  2064,  2065,
    2066,     0,  2067,  2068,  2069,     0,  2070,  2071,  2072,  2073,
       0,  2074,     0,  2075,  2076,  2077,     0,  2078,  2079,  2080,
       0,  2081,     0,  2082,  2083,  2084,  2085,  2086,  2087,  2088,
       0,     0,     0,     0,     0,  2089,  2090,  3128,     0,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,     0,  1806,  1807,
    1808,  1809,     0,  1811,  1812,  1813,     0,  1814,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,  1819,     0,
       0,     0,  1821,  1822,  1823,  1824,     0,  1826,  1827,  1828,
    1829,     0,  1830,  1831,  1832,  1833,  1834,     0,     0,     0,
    1835,     0,     0,  1836,     0,  1837,  1838,  1839,  1840,  1841,
       0,     0,     0,  1843,     0,  1844,  1845,  1846,     0,     0,
    1847,     0,  1848,  1849,     0,  1850,  1851,  1852,     0,     0,
    1853,     0,     0,     0,     0,     0,     0,     0,     0,  1854,
    1855,     0,  1856,     0,  1857,  1858,  1859,  1860,     0,  1861,
       0,  1862,  1863,  1864,  1865,  1866,     0,     0,  1867,     0,
       0,     0,     0,  1868,  1869,  1870,  1871,     0,  1872,  1873,
    1874,     0,  1875,  1876,     0,     0,     0,  1877,  1878,  1879,
    1880,  1881,     0,  1882,  1883,     0,     0,     0,     0,  1884,
    1885,     0,     0,  1886,     0,  1887,  1888,     0,     0,  1889,
       0,  1890,     0,  1891,  1892,     0,  1893,     0,  1894,  1895,
       0,     0,  1896,     0,  1898,  1899,  1900,     0,  1902,  1903,
    1904,  1905,  1906,  1907,     0,     0,     0,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,     0,  1915,     0,  1916,     0,     0,
    1919,     0,  1920,     0,  1921,  1922,  1923,     0,     0,     0,
       0,     0,  1924,     0,  1925,     0,     0,  1927,  1928,  1929,
       0,     0,  1930,  1931,     0,  1932,     0,  1933,  1934,  1935,
    1936,     0,  1937,  1938,     0,  1939,  1940,  1941,  1942,     0,
    1943,  1944,  1945,  1946,     0,  1948,  1949,     0,  1951,     0,
    1952,  1953,  1954,  1955,  1956,     0,     0,  1957,     0,     0,
    3131,  1959,  1960,     0,     0,     0,  1962,  1963,     0,     0,
    1964,  1965,  1966,     0,  1967,     0,     0,  1968,     0,     0,
    1969,     0,  1970,  1971,  1972,  1973,     0,  1974,  1975,  1976,
    1977,     0,  1978,  1979,  1980,  1981,  1982,  1983,     0,     0,
       0,     0,  1984,  1985,  1986,  1987,  1988,  1989,     0,  1990,
    1991,  1992,     0,  1993,  1994,     0,  1995,  1996,  1997,  1998,
    1999,  2000,  2001,  2002,  2003,     0,  2004,     0,  2005,     0,
    2006,     0,  2007,     0,  2008,  2009,  2010,  2011,     0,  2013,
    2014,     0,     0,  2015,     0,  2016,  2017,  2018,  2019,  2020,
    2021,  2022,     0,  2023,     0,  2024,  2025,     0,     0,     0,
    2027,  2028,  2029,     0,     0,  2030,  2031,     0,     0,  2032,
    2033,  2034,  2035,     0,  2036,  2037,  2038,     0,     0,  2039,
    2040,     0,     0,  2041,  2042,     0,  2043,  2044,     0,     0,
    2045,  2046,     0,  2047,  2048,  2049,  2050,     0,     0,  2051,
    2052,  2053,     0,  2054,     0,     0,     0,     0,     0,     0,
       0,  2055,     0,  2056,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2057,  2058,  2059,  2060,
    2061,  2062,  2063,     0,     0,     0,     0,  2064,  2065,  2066,
       0,  2067,  2068,  2069,     0,  2070,  2071,  2072,  2073,     0,
    2074,     0,  2075,  2076,  2077,     0,  2078,  2079,  2080,     0,
    2081,     0,  2082,  2083,  2084,  2085,  2086,  2087,  2088,     0,
       0,     0,     0,     0,  2089,  2090,     0,     0,  2091,  2092,
    2093,  2094,  2095,  2096,  2097,  2098
};

static const yytype_int16 yycheck[] =
{
      21,     0,     0,  1027,     0,    26,    48,  1067,     0,   722,
     723,    34,     0,     0,   727,   766,  1036,    21,  1089,   966,
     647,     7,    26,   819,    20,    16,   845,  1329,    14,   668,
    1058,   179,   893,    24,   202,   898,   923,  2314,  2315,   678,
    1802,  2298,  1370,   187,   612,  1377,  1693,  1015,  1380,   910,
      43,  2775,  1031,   197,   814,   647,  1261,    12,  1380,  1530,
    1392,   688,  1394,  1117,  1396,  1176,  1390,  1146,  1147,  2481,
    3190,     0,  3134,  1277,  1376,  1488,   773,  2584,  3354,  1435,
    3446,  1310,    11,  2627,  2619,  1731,  1165,  1547,  3143,  3098,
    1586,    20,  3817,  3373,   603,  2941,  2942,    20,   666,  2532,
      17,  1259,    42,    22,   965,  2257,  2754,  1312,   969,  3677,
    3169,  3722,  3171,   974,  1285,    34,  3401,  4320,   897,    48,
     981,  3821,  3787,  3718,   903,  1447,   198,  2943,  1452,  1453,
     991,  4032,   204,   912,  3821,  3358,  3359,  3360,  3361,  3362,
    3363,  1370,   769,   215,   166,  3006,  3431,   656,  3644,  2425,
       0,  4021,  1648,  3617,  4345,  3420,  2432,  1359,  1316,  4046,
    4315,  3775,  3856,  1376,  2440,  2938,   979,  1316,  3975,  3650,
    1198,     0,    33,  1765,  4543,  1591,   989,   769,  3778,    40,
    2875,     0,     0,     0,     0,     0,  4535,  4267,     0,  1602,
       0,  2284,   181,  3014,     0,     0,     0,    39,  2286,  3649,
    3135,  4311,   181,  1062,  3689,    44,     4,  4888,  4542,    66,
    2622,     9,  1135,  1136,  4651,     0,  4653,   863,    58,    51,
      31,  3566,     5,     5,    51,    80,  2999,  5007,  5008,  3773,
    3774,     0,  2938,    68,     5,     9,    31,   153,  1161,   104,
       0,   128,   134,    11,   148,   811,   959,     0,    48,     5,
      51,   811,   181,    18,  4881,   153,    97,    37,   159,     5,
      48,   154,     5,   104,   153,   161,    87,    37,    35,     3,
     210,     5,     5,    48,  5080,     5,   125,     0,   874,     5,
    3824,   161,    18,    13,     5,    42,     9,    13,  2700,   916,
    2702,     5,    13,  2999,     5,   109,     5,     5,    11,    22,
       5,     5,    58,     5,    35,    22,    25,   173,  4033,    31,
     192,     5,    29,    68,     5,  4683,  4684,  3012,    11,   153,
     123,   260,   104,    36,    68,    31,    22,   260,    31,   162,
     155,    31,  4823,    29,    22,     0,     5,   134,   134,   284,
     161,    29,   314,     4,     9,   154,   330,    58,     9,   104,
     238,   153,     9,    66,    64,   289,   121,    22,   109,  1246,
     238,   330,  4969,  4970,   106,    99,   993,   104,   153,   161,
     161,   153,   127,   330,    34,   943,  3772,  3773,  3774,  3775,
    1199,  1043,   385,    20,   153,   121,     5,   135,   173,    68,
       9,   312,  1550,   153,  1056,  5339,   406,    32,  1037,   240,
     153,     5,   289,    40,   173,    11,   199,   404,    28,  1228,
      42,   267,   169,   173,   207,   363,   173,   238,   365,  5225,
     173,   107,  1533,   216,   268,   104,  1053,  1054,  3824,     4,
     153,  2433,   166,   476,     9,   186,    22,    79,   289,   395,
    1067,  1520,  1521,    29,   612,     5,     3,     4,     5,  1528,
     173,   306,     9,   135,   211,   106,  1095,   301,    11,   502,
     407,   270,  1054,   384,   315,  4272,  1105,    99,     9,  2471,
     218,  1067,    22,  1497,   330,   307,   118,   112,   488,  1118,
     307,    22,  1502,    36,   170,   104,  1690,   161,   153,  3712,
    1694,   316,  1696,   227,  1121,  1699,   230,  1701,   666,   502,
      26,    27,   343,   240,  4941,   346,   307,   651,   173,   506,
    5454,   389,   172,    66,   448,   135,   271,  4866,   662,    11,
      70,   312,   506,  1491,  2116,  1730,   335,   271,    78,  1121,
     502,   200,   268,   421,    77,   332,   332,   506,   610,    72,
     161,  3817,   614,   253,    36,   196,   371,   104,  4703,   506,
     187,  4742,   111,   625,   446,   105,   389,   502,   506,  2834,
    2835,   363,  5053,  1342,  2839,   301,  1345,   506,   464,   383,
    1431,    68,  1433,   506,    66,   962,  3100,   334,  1441,  5385,
     462,   363,   357,   350,   464,   304,   341,   321,   962,   240,
     506,  1796,   271,   363,   330,  1518,  1519,   400,   502,  1486,
     449,   344,   345,   594,  1527,   506,   404,   104,   506,   502,
     390,  2886,  2887,  1684,  1241,   502,  5243,   506,   383,   350,
    4320,   338,  1249,  1250,   489,   474,   152,   177,   154,  1408,
     127,  1599,   383,  4320,   191,    25,   391,  3049,   394,   290,
     506,   194,   338,   500,   479,   387,   688,   504,  1244,  1241,
     338,   506,     8,  1249,  1250,    11,   647,   648,   215,  1817,
     481,   502,   502,   502,  5271,   465,   814,  4537,   502,   469,
    3725,   693,   464,   406,   506,  1654,   593,   465,   489,   506,
     394,   702,  2274,   704,   363,   706,   420,  4301,  4302,  4496,
    4384,   712,   713,   714,   489,   493,   494,  4311,   702,  4299,
     704,  1729,   706,  1731,  4168,   506,  4202,   489,   712,  3771,
    4206,  4192,  1691,  1741,  3999,  5396,  1103,  1745,   400,   502,
     505,  1700,   504,  1369,  5093,  1753,  1754,   501,  2375,  1103,
     716,   686,   503,  3956,  4014,   503,   505,  1303,  1766,  1767,
    3017,  4191,  3019,  1303,   735,   505,   502,   198,  4555,  4349,
    1778,  1347,   505,   204,   500,   488,   502,  4033,   504,   688,
    1788,  1357,  4247,  4108,   215,   688,  4031,   758,  5102,   502,
     493,   494,   502,  4317,   765,   943,   502,   768,   769,   770,
     502,   502,   505,   489,   928,   498,   489,  5155,   502,   489,
     464,   502,   732,   502,   502,   939,   346,   502,   502,   592,
     502,  1660,   406,  5583,   597,   498,   805,   805,   502,   805,
    1669,   502,  3319,   805,   803,  3322,  3323,   805,   805,  3326,
     363,  5601,  5602,  5260,   803,  3332,   385,  1423,   493,   494,
    1426,  1427,   493,   494,  1757,  1758,   493,   494,   194,  2310,
     505,    51,   375,   464,   341,  1413,    11,  3663,  3372,   789,
    5005,  3127,  3396,   874,   250,   506,  1000,  1244,   253,  1003,
    2320,   447,   104,   153,   450,  5234,   254,    18,  3641,   395,
     793,  3644,  4679,  3928,   803,   148,   805,  5226,   818,  4686,
    4990,  1594,  1595,  4963,   488,  3706,    99,  2980,  3823,   495,
     496,   497,   498,  2981,   391,   253,    97,    97,   502,  4019,
     256,    23,  1498,   444,     8,  4301,  4302,   255,    44,   450,
      97,   104,  3324,  3325,   304,  4311,   104,    97,  2123,   363,
     860,  4317,   862,  1310,    16,   767,   316,   108,   106,   771,
      97,    83,    22,   474,    51,  3641,   493,   494,  3644,   250,
     493,   494,   495,   496,   497,   498,  1697,  1698,     5,  3722,
     743,  1613,   404,   166,    60,   805,   250,    97,   385,    95,
     145,  1623,    73,  4864,   109,  1627,   154,   294,   127,    84,
     121,  1633,  1634,   766,  1793,  5324,   805,   367,    26,    27,
    4687,   404,   479,  1370,   316,  1624,   805,   805,   805,   805,
     805,  1653,   785,   805,   255,   805,  1635,    11,  3693,   805,
     805,   805,   852,   495,   496,   497,   498,   109,  1647,   285,
     268,  4736,   193,   806,   227,    68,  3722,   230,  5387,   121,
    5175,  5176,   109,   315,  1411,  4636,   132,   301,   238,   194,
     303,   254,   108,    99,  1661,   367,    84,  1411,   899,   900,
     353,   186,   134,   158,   150,  4745,  1067,  4056,   267,   185,
     143,   104,   237,   241,   506,   103,   330,   104,  4745,  4746,
     104,   409,   506,  1054,  1632,   187,  1062,   245,  2390,  4680,
     397,  5440,   330,   363,   127,   502,  1067,  3354,   271,   135,
    2496,   323,   875,   506,  4778,  2314,  1072,   135,  1074,  1006,
    1076,  2262,  1078,  2264,  1080,  1081,  1082,   307,    75,   186,
     166,  1087,   238,   260,  4718,  1492,   502,   502,   321,  1100,
    1619,   353,   500,   224,   225,   226,   504,   193,  1492,   212,
     330,   153,    68,  4830,    68,     8,   327,  4591,    11,     5,
    1121,    77,   166,  1062,   490,   491,   113,   493,   494,   495,
     496,   497,   498,  1530,   502,    28,  4642,  4747,  4748,   391,
     301,  4647,   256,   353,  4650,  2477,  1198,  4638,   104,   610,
     104,   227,   404,   614,   230,    84,   353,  3444,  1555,   461,
    2328,    83,     8,   353,   625,    11,   282,   279,   971,  2328,
     194,  1555,   341,   319,   103,   275,   353,   463,   245,  4555,
     307,   502,  2954,   227,  5095,  1763,   647,   385,    68,   489,
    1129,   104,   995,   996,   997,  5574,  4261,   420,   502,  1200,
    2423,  2413,   663,   353,   504,     5,   135,   668,  5088,  1210,
    1149,  5108,   314,  1244,   271,   370,     5,   678,  1249,  1250,
     504,  1618,   391,  1224,   104,   325,   323,   688,   383,  4524,
     332,   502,  2834,  2835,  1618,  1413,   104,  2839,  1270,   297,
    1241,  1180,   404,  1244,  1245,   321,    97,  4964,  1249,  1250,
     502,   222,  4527,  4322,   162,  4972,   356,   323,   358,  1198,
    4881,   423,   378,  3548,   318,   323,  3551,  3552,  3553,  3554,
    3555,  3556,  3557,  3558,  3559,  3560,   318,   321,   341,  4351,
    4352,   260,   269,   445,  2886,  2887,   383,   353,  2456,  1288,
    1289,  1094,  1291,   104,   456,   353,  2662,   459,  4704,  1288,
    1289,   194,  1291,  4709,   425,   426,   363,    22,   769,  5006,
    5007,  5008,  4718,    60,  1117,   271,  1347,   271,   493,   494,
     495,   496,   497,   498,   104,   391,  1357,   104,   391,   147,
     238,    75,    30,   391,  3619,  3620,   503,   395,   404,   506,
    2678,   320,   162,   156,   420,  5546,   404,  5227,   194,  1288,
    1289,   104,  1291,    22,   396,  1305,  4961,   104,   271,   245,
     268,   104,  4218,   256,   305,   303,  4990,   227,   297,   113,
     357,  1402,  1403,  5586,  4245,   489,   490,   491,  5579,   493,
     494,   495,   496,   497,   498,   353,  1468,   238,   155,   330,
     114,   271,  1423,   301,   323,  1426,  1427,  4223,  3915,   155,
     124,   116,  4228,   271,  3921,  3922,   104,   363,  1805,   363,
     256,   162,  5323,  4543,  1341,    75,   479,  5092,   238,  4202,
      60,  1805,  5333,  4206,   353,   104,   502,  5244,   121,     5,
    4088,  4905,  4938,  2672,   316,  5600,   502,    77,  1439,  2678,
     503,    98,    68,   268,   502,   245,  2614,   116,  5613,  5614,
    4736,    18,  1255,   113,  1632,   916,   245,    24,  1612,   277,
     271,   321,   391,    68,   199,   131,   404,  1498,  1622,   493,
     494,   495,   496,   497,   498,   404,   301,  5388,   104,  1282,
    1283,   389,   404,   363,   406,   367,  4202,   238,  1570,   256,
    4206,   271,   132,   240,   271,   363,  1446,    86,   245,   104,
     256,   423,   245,  1306,  1586,   330,     8,   258,  5129,    11,
     150,  1512,   325,  3799,   194,   483,  2605,   365,   271,   176,
    5232,   110,     5,   445,   190,   269,    18,  2741,   104,    75,
    3817,     5,   993,   106,   456,   282,  2297,   459,  3700,  1693,
     129,   354,  5016,  1625,   268,  3015,  5020,  5021,   314,   296,
     156,  3021,   363,  4843,   121,  1415,   143,    75,  1418,  4849,
     149,   240,   260,  1571,   267,   258,  1648,   113,   506,   389,
    4013,  1572,  1375,   502,   254,   164,  1037,   301,  2250,  1382,
    5158,  5159,   502,   363,  4990,  1763,   363,    77,     8,  2491,
     346,    11,  1053,  1054,   260,   113,   489,   490,   491,     0,
     493,   494,   495,   496,   497,   498,  1067,  1467,    28,   269,
     363,  1471,   305,   357,   104,  5327,  1419,   383,  4731,  1422,
      52,   104,  5243,   196,   993,   212,   505,   330,    60,   121,
     104,   378,  1597,  2422,  1095,   143,  2459,   330,   389,   318,
     148,  4063,   282,  4065,  1105,   271,  2548,   493,   494,   495,
     496,   497,   498,  1568,  1660,  1458,   245,  1118,   367,  2693,
    1121,     8,   106,  1669,    11,   252,   271,   240,   506,  1472,
     267,   173,  1587,  2703,  1670,   173,  1672,   502,  1674,  4792,
    1676,    28,  1678,  3968,  1053,    96,  1682,  1490,   154,  1722,
     406,   240,   194,  2861,   316,   352,   353,   357,  3543,   288,
    2868,   268,   363,  1712,   212,  2528,  1712,  2496,  2697,  2687,
    1712,   377,  1743,  1744,  1712,  1712,   182,   290,  2589,   325,
    1751,  1660,  3567,   269,  1755,  1756,    68,  5439,  1661,  2518,
    1669,   197,   284,   330,   301,    77,   157,   363,   378,   288,
    1771,   406,  1773,   209,   252,   367,  4033,    18,   354,  1750,
     240,   269,   196,    24,   256,   173,  5468,  1707,   363,  1768,
    4825,  2550,   104,   330,   337,  2803,   157,   373,  1799,  2441,
    1801,  2420,   488,  1712,   194,  3014,   268,  5355,   107,    11,
    1241,  2962,  3120,   215,  5079,  3024,   502,  1590,  1249,  1250,
     305,   489,  1721,  2465,   215,  1598,   240,  5507,  1259,  2377,
    5535,  1728,   500,   301,   502,   503,   504,   305,   506,   301,
    5507,   357,   223,   355,  2333,   330,  2854,   228,   281,  2642,
    2643,  2644,  2645,   488,   215,   107,  3483,   353,   489,  1768,
    3044,  2654,   330,   157,    66,  2658,   256,   502,   330,   357,
    4574,   170,  1792,   504,    11,   311,   290,   194,    68,   438,
     121,  2674,  2890,  4636,  4710,  1316,  4712,    77,  2681,  4642,
    4282,  4283,   404,  3519,  4647,   454,   133,  4650,  5244,    36,
    4889,   249,  5582,   294,  1295,  3241,  5586,  4162,  4163,   320,
     290,  3120,   198,   301,   104,  5582,  5583,   305,   170,  5586,
    2928,   215,   302,  2499,  1697,  1698,   388,  4680,   222,    66,
     148,  2507,   365,  2509,  5601,  5602,   404,   174,  4973,   256,
     158,  1714,   330,  2310,   503,    85,   326,  2314,  2315,  3251,
    4636,   281,   238,  4440,  4441,   173,  4642,  4996,   258,   271,
     198,  4647,   397,  5471,  4650,   356,  3025,   358,   268,  5549,
    4674,   500,  4676,   502,   407,   504,  3548,  5242,  2671,  3551,
    3552,  3553,  3554,  3555,  3556,  3557,  3558,  3559,  3560,  4504,
     381,  4515,  1901,  5093,  4680,   356,  3472,   358,  2487,   106,
     238,   301,  5510,  3054,  5584,  5585,   397,   240,   116,   106,
     118,  4526,   245,  3585,   154,   200,   404,   489,   490,   491,
     381,   493,   494,   495,   496,   497,   498,   268,   116,   116,
     118,   118,   131,   141,    60,   365,    68,  1468,   268,    49,
      66,   148,   182,   356,   143,   358,   332,  3619,  3620,   148,
    2692,    77,   290,   141,   323,   288,  5316,   197,    38,   301,
     301,  2428,   356,   116,   358,   118,  2708,  2709,   323,   209,
    2712,   301,   104,   180,  2428,  2682,  2718,   407,   104,    59,
     106,   271,   301,   180,   353,  3085,    96,   381,   330,   330,
     314,   190,   310,   363,   332,   235,   396,   383,   353,   489,
     490,   491,    77,   493,   494,   495,   496,   497,   498,  2716,
    2682,   330,   155,   212,   254,   489,     5,    44,   342,  1550,
    3424,    10,   391,  3427,  5113,  3073,  5161,   268,  4881,    18,
     504,   238,   240,   240,  5234,  2777,   391,   245,   153,  1570,
     183,   238,   250,   240,  2716,   383,    35,     4,   148,   404,
     241,   242,     9,   252,   180,  1586,   502,   245,   173,    86,
     301,   260,   250,   250,   305,   175,  2137,    96,   168,  2745,
     254,   311,   489,   490,   491,   259,   493,   494,   495,   496,
     497,   498,   157,   110,   449,  4938,   143,   240,   268,   330,
      18,   148,   367,  1624,  1625,  4881,    24,   250,   125,   367,
    3942,   176,   129,   268,  1635,   704,   705,   706,  2948,   474,
     709,   710,   711,   223,   240,  3353,  1647,  1648,   228,   245,
     719,   301,   149,   500,   303,   152,  2593,   504,   238,  2377,
    1661,   893,   323,   502,   148,   320,   301,   164,  5273,  2593,
     215,   268,   139,    11,  2368,   385,   908,   502,   910,   178,
     330,  2375,  4938,   222,   168,   212,   282,   267,  3101,   268,
     222,   369,   353,   404,     4,   330,   355,    81,    36,     9,
     296,   379,  2324,  1415,   301,  2952,  1418,  2329,   377,  5535,
    2332,   369,  2283,  2284,   259,   501,     8,  5387,   242,    11,
     506,   379,   301,   121,   223,   252,   306,  3481,    66,   228,
     391,   268,  2354,   330,  3147,  2672,   356,   501,   358,  4796,
    3750,  2678,   506,   404,    36,   404,   294,   406,   245,     8,
      42,   330,    11,  2302,    21,  1467,   253,   254,   294,  1471,
      20,   341,  4587,  3726,   301,  2338,   254,  2340,   305,    28,
    5440,   259,   431,  3102,    66,  2118,   324,  2399,  2955,  2252,
      40,  4704,   378,   176,  2127,  3406,  4709,    21,   324,  2907,
     168,   288,    26,   330,  4619,  4620,  3417,  2419,  5571,   323,
    4575,  4576,  4577,  4578,  1765,   353,  5129,   497,   367,  2955,
     318,   356,   502,   358,   504,  5420,  1817,   353,    74,  1780,
     479,     5,   367,  2302,   397,     9,  3968,  2764,    48,   353,
    2452,   500,   200,   378,   503,   504,   381,   129,   320,   503,
    2764,   502,   506,   502,  3599,  3057,   502,   355,  4160,   397,
     254,   503,  3041,  3042,   506,   497,   194,   195,    57,    58,
     502,   397,   504,  2853,  2405,  2855,  2856,   391,  2490,     0,
     432,   503,  2494,  5129,   506,   503,  3205,   169,   506,  3587,
     404,   173,  4844,    48,   503,   503,  3758,   506,   506,   503,
    2512,    85,   506,     9,  3071,  4702,   404,   502,   406,  2389,
    3504,  2523,   194,   195,  5574,   243,  1108,  1109,  2251,  4736,
    2253,     3,  3573,  3574,  2536,   314,   315,  3791,  3792,   211,
    5243,   503,  3285,   431,   506,  2547,   397,  3706,  2499,  3071,
     506,   503,  2554,    76,   506,   194,  2507,  3511,  2509,  5551,
    5552,   438,  3154,    38,  3307,  3308,  3701,  3159,   500,     8,
     502,   243,    11,    84,  2297,  3827,  3367,   454,   318,   503,
     154,   502,   506,   503,   256,   503,   506,   422,   506,   503,
     503,   479,   506,   506,   502,  4782,   504,    36,   502,   503,
     196,   505,   125,    42,    76,   504,   503,  5243,   182,   506,
    3508,  3345,  3346,  3347,   502,   355,  5270,   256,   485,   486,
     131,  1070,  3580,   197,  1073,   254,  1075,    66,  1077,   257,
    1079,   318,   143,   503,  1083,   209,   506,   148,   314,   315,
    4162,  4163,   153,   503,   257,   503,   506,   158,   506,   121,
     161,  2602,   163,   503,   126,  2576,   506,  3226,   404,   148,
     406,   235,   334,  2584,   404,   363,   406,   503,   355,   503,
     506,   503,   506,  3416,   506,     8,  4883,   503,    11,   190,
     506,   204,   205,  3275,   503,   503,   422,   506,   506,  3281,
     503,   431,   254,   506,  3703,   218,   502,  3014,   504,  4904,
    3017,   212,  3019,   314,   315,  2779,   178,  3024,   257,   503,
     503,  2785,   506,   506,   356,   503,   358,   404,   506,   406,
    2641,   503,  3723,  3724,   506,  2448,   503,   422,  3816,   506,
    3818,   314,   315,   503,   173,  2664,   506,   311,   404,   479,
     406,   252,    38,  2628,   431,   268,   356,   196,   358,   260,
    2752,  3394,  4153,  2476,  2675,   194,   195,  3074,   495,   152,
     271,  2682,   502,   506,   503,   503,  3854,   506,   506,   503,
    3074,   503,   506,  2775,   506,   493,   494,   495,   496,   497,
     498,  4039,   503,   503,   503,   506,   506,   506,  4020,   404,
     503,   406,   479,   506,  2745,  2716,   318,   308,    21,   503,
     502,   273,   506,  3120,   243,  2664,   404,   503,   406,  2907,
     506,  3368,   503,  3370,   505,   502,  3385,   256,  3387,   503,
     503,   493,   494,   495,   496,   497,   498,  5014,   503,    48,
     153,   506,   355,   355,   357,   503,   503,  3925,   506,   506,
     503,   503,   353,   506,   506,    68,  3368,   192,  3370,  3666,
     489,   490,   491,   502,   493,   494,   495,   496,   497,   498,
     504,   194,   503,  3455,  2938,   506,   377,  3459,  3460,   330,
    3462,   503,  3464,  3465,   506,    98,   503,  2975,   408,   506,
    4039,  3473,   404,   502,   406,   503,  3443,   503,   506,   505,
     401,   503,   403,   404,   506,  3212,   119,  3214,   173,   503,
     503,  2624,   506,   506,   376,   136,  3655,   130,  3212,   431,
    3214,   503,   384,  3505,   506,   387,   503,   502,  2890,   506,
     431,  3443,   808,   256,   810,  2999,   503,   150,    50,   506,
     173,   504,   155,  2274,  3503,   503,   254,   136,   506,  4073,
    4074,  4075,   503,  2324,   173,   506,   503,  2328,  2329,   506,
     503,  2332,  4207,   506,  4209,   427,   254,   479,   430,  3276,
     503,    83,   473,   506,   503,   136,   148,   506,  3658,  3659,
    3660,  4663,  3276,  2354,   503,   136,   503,   506,   201,   506,
     502,   301,   503,   455,   503,   506,  3512,   506,   503,   500,
     268,   506,   503,   504,   505,   210,   106,   503,   470,   222,
     506,   385,  2953,  3320,  2955,   503,   503,   254,   506,   506,
    2933,  2934,  2935,   135,   502,   131,  3320,   139,  2399,   503,
     503,   367,   506,   506,  3026,   249,   397,   143,  2979,  2980,
    3002,  2890,   148,   503,  2955,   320,   506,  3354,  2419,  2420,
    2969,  3784,   200,  2969,    60,  2904,   287,  2969,   404,   171,
     503,  2969,  2969,   506,   493,   494,   495,   496,   497,   498,
     503,    31,   285,   506,  2923,  4587,  3068,   240,   408,   503,
    2451,  2452,   506,   502,   190,  2456,  4598,   503,   503,  2938,
     506,   506,    60,   503,  4219,   207,   506,   503,    66,   312,
     506,   503,  5279,   240,   506,   318,   212,  4619,  4620,    77,
     503,   324,   503,   506,  3897,   506,  3423,  4242,    38,  2490,
    2969,  5298,   503,  2494,    38,   506,   238,   131,   240,  3423,
       8,   503,   503,    11,   506,   506,   104,  3444,   106,   143,
     353,  2512,   355,   372,   148,   268,   252,   148,   318,  3456,
    2999,   397,  2523,  3002,   260,   483,   268,   125,    36,   372,
    3071,   397,  3456,   318,    42,  2536,   489,   490,   491,   318,
     493,   494,   495,   496,   497,   498,  2547,   503,    74,     3,
     506,  4129,   136,  2554,   397,   355,   190,  5364,    66,   301,
     136,  4139,   136,   305,   353,    19,   503,   309,   503,   506,
     355,   506,   503,   315,  1782,   506,   355,  1785,   212,   502,
     322,  3203,   180,   408,   136,   136,   506,   136,   330,  2932,
    3527,   136,   254,  3215,   136,   136,   136,   339,   136,   254,
     136,   136,   353,  3527,   404,   347,   406,    31,   502,   210,
    3547,   254,   149,  2614,   148,   148,   502,     5,   252,   404,
       5,   406,    76,  3547,  4821,   404,   260,   406,   502,   502,
     148,   431,   502,   502,  3175,     5,  3354,   278,  3575,     5,
     502,   377,   240,     5,   502,   502,   431,   245,   502,   502,
     131,  3575,   431,  4407,  4408,   502,  4410,   399,     5,   405,
     502,   169,   143,   265,   502,   173,   502,   148,   502,   502,
     502,   502,   126,   502,   502,   502,   502,   192,   502,   479,
    3617,  2682,   424,  3224,   282,  4048,   194,   195,   502,   502,
     502,   502,  3314,  3617,   479,   502,   502,   502,   296,   502,
     479,   502,   502,   211,    31,    87,   210,   506,  5535,   190,
     506,   453,    31,   148,   148,  2716,   330,   502,   363,   173,
     252,   250,   318,   502,   178,   467,   363,  3298,  3299,  3300,
    3301,   212,  3303,   318,   504,   243,   363,  3278,   363,   318,
     363,   363,   363,   377,  3298,  3299,  3300,  3301,   256,  3303,
     318,  2752,    77,   318,   318,   136,   254,   254,   478,   355,
    3906,  3302,  4904,  3909,  3910,   322,   207,   245,   363,  3706,
     363,   252,  3343,  3344,  2775,  4554,   478,  3348,  3319,   260,
     378,  3322,  3323,  3354,   478,  3326,   478,   355,   363,  3483,
     355,  3332,   384,   355,   254,   178,   502,   250,   167,   502,
     363,    77,   506,   268,  3993,  3994,   353,   136,   404,   173,
     406,    98,   385,  3354,   385,   363,    48,  3388,    48,   273,
     363,   258,    37,    37,   363,   506,   334,  3368,   355,  3370,
     330,   254,   363,   363,   254,   431,   404,  4447,   406,   404,
     363,   406,   363,   363,   363,   194,   363,   363,  4060,  3397,
    3472,   404,   408,   502,   502,   502,  4068,  4069,   312,    31,
    2861,    30,    20,   431,  3486,   254,   431,  2868,  3409,   394,
     136,   104,   240,  2834,  2835,   385,   502,   136,  2839,   218,
    3817,  3430,   396,   479,  3506,   250,   240,    31,   148,   502,
     502,   404,  4513,    31,   200,   136,   377,   351,  4267,   136,
     319,  3442,  3443,   385,   249,  3454,   502,   136,   385,   136,
     136,   479,   363,   244,   479,   153,   502,   400,   361,   502,
     422,   232,   376,   232,    11,  2886,  2887,   330,   506,   361,
     384,  3629,  4078,   387,   502,   363,   503,   502,   161,   144,
     153,  3512,   502,   502,   365,   506,   167,  3641,   503,   167,
    3644,  3430,   506,  4450,  2955,  4452,   502,   332,   198,  4456,
     255,   262,  4459,   385,  4461,   190,    48,   363,   363,    76,
     318,   385,   318,   427,   198,  3454,   430,   245,   506,   503,
     502,   489,   490,   491,   245,   493,   494,   495,   496,   497,
     498,   198,   363,   502,   367,   397,   363,   320,   200,   245,
     363,   455,   254,    38,   337,    97,    97,   271,   271,   271,
    4862,   363,   404,   357,   271,    36,   470,   355,   506,   318,
     363,   363,   301,   301,   125,  3026,   168,   327,  3722,   363,
     194,  3374,   290,   363,  3377,  3627,    31,   194,   194,   194,
    3041,  3042,   194,   253,   385,   385,    30,   363,   500,   363,
    3393,   500,  3644,   363,   502,   363,   489,   136,   148,   250,
    3997,   397,  3603,   502,  3407,   150,  4278,  3068,  4776,   136,
    3071,   327,  4435,  3997,    31,  3418,   502,   254,  3772,  3773,
    3774,  3775,   404,   353,   254,   165,  3429,   165,   148,    31,
    3633,  3634,  3635,  3636,  3437,  4803,  4033,   136,   148,  3817,
     254,   254,  4039,   173,   173,   327,   506,  4296,   173,   506,
     408,    19,   506,   159,   229,   404,  4234,   254,    48,   506,
    4332,  4333,  4334,  4335,   367,   353,   249,   200,   397,  5011,
    3824,  3753,   506,   153,   422,   153,   272,   422,   473,   264,
      13,   502,  4505,  4506,   503,   503,   503,   503,  3627,    13,
     503,   363,   503,   503,   401,   255,   255,   401,   308,    48,
     391,  3504,  3641,   383,   212,  3644,   503,   176,  3169,  3170,
    3171,   503,   136,   254,   257,   503,   502,  4931,   254,   503,
     363,   363,   503,   503,   489,   503,   503,  4941,   503,   502,
     502,   408,  4813,  4814,   184,  4805,   503,   363,   502,   502,
     475,   245,  3203,   127,   258,   502,   502,   136,   502,   502,
     136,  4400,     3,   136,  3215,   434,  4153,  4429,  4430,   502,
     176,   502,   431,   353,   212,  3226,   430,   220,   502,   502,
     273,  4168,   273,   382,  4497,   363,   363,   363,   220,   220,
     240,   363,   363,   318,  4168,   363,  3817,   363,   136,   363,
     318,   363,   318,   363,  3876,   318,   330,  3879,   363,    37,
     194,   194,   194,   502,   480,   500,   321,   503,   230,   480,
    4447,   212,   480,    68,   372,  3846,  3817,    38,   303,    97,
    5034,   253,    31,   489,   254,   162,  3857,   318,   385,   385,
     318,   363,  3846,   489,   318,  3638,  3639,  3640,   257,   134,
     503,  4447,   503,   134,   503,   502,   506,  3848,   506,   503,
    3851,   506,  3853,  3314,   194,  4033,  3857,   127,   240,   500,
     360,   153,  4668,    11,   148,   503,   506,   503,   503,   503,
    5109,  4909,   396,    58,   153,  3906,   503,   502,  3909,  3910,
     260,   153,   401,  4280,  4654,   506,   487,  4559,   161,  4561,
    4562,  4661,  3353,   255,   502,   502,  4280,   503,  3929,   372,
     503,  4573,  4725,   503,   148,    31,   385,  3368,   502,  3370,
    4948,   385,   363,   184,  3915,    48,  3947,  3948,  4000,   355,
    3921,  3922,  5136,  3924,  3385,   502,  3387,  3958,   136,  4800,
     363,   502,   372,   502,  4331,   363,   363,   318,   363,   318,
     363,   503,   148,    99,    48,   355,  5288,  4331,   503,   503,
     148,    66,   136,    97,   372,   503,   502,  3958,  3959,  3960,
    3961,   406,   194,   194,  5045,   198,   503,   404,   286,   327,
     501,   125,   125,  4370,   408,   148,   179,    71,   355,   501,
       3,   502,  3443,  5017,   502,   363,  4370,   503,  5018,   506,
     503,   502,   327,  4001,   506,   502,   158,   506,    97,  4081,
     194,   153,  4033,   194,   194,   194,   116,   503,   153,   502,
     295,  3472,   962,   503,    48,   402,    22,    23,   197,  3822,
    4029,    27,   263,   506,    48,  3486,    32,    33,    34,   402,
      36,  4428,  4033,    39,    40,  4036,    42,   503,    44,   503,
     503,  5030,  3503,  5032,  4428,  3506,   502,  4078,  4202,   503,
     502,   197,  4206,   502,   163,   250,  4234,   503,   489,   372,
     503,   363,   153,   404,   503,    66,   178,   502,    11,   355,
     245,   245,   192,    48,   489,   355,   489,   506,    28,   361,
     506,   136,   503,   194,   155,   452,   506,   363,   153,   474,
    4029,   385,   501,   173,    31,  4096,   385,   122,   404,   400,
     271,   404,   502,  4681,  4865,  5143,  4755,  5145,   153,   181,
     257,   502,   153,   153,   502,   295,   390,   340,   197,   254,
     271,   363,   403,   363,   296,   111,  3587,  3548,  5198,   503,
    3551,  3552,  3553,  3554,  3555,  3556,  3557,  3558,  3559,  3560,
     503,   502,   502,   502,   482,   404,   503,  4301,  4302,   503,
     502,   482,  3955,  1103,   148,  4925,   502,  4311,   502,   502,
     245,    31,   437,  4317,  3585,   221,   176,   245,  4805,   286,
     502,  3974,   502,   135,   503,   502,    31,   503,   315,    48,
     503,   187,   188,   189,   190,   258,   192,  4765,   194,   506,
     315,   197,    48,   199,  4591,    48,   202,    31,  3619,  3620,
    4003,   207,   502,   502,   210,   503,   502,  4591,   214,   506,
     216,   217,   355,   503,   502,    31,  4986,  4987,  5386,    11,
     385,   355,  4253,   238,   254,  4897,  4259,   355,     5,  4230,
    4231,  4240,   327,   142,   503,   286,    60,   257,    60,  4253,
     117,   295,   502,   506,  5325,   502,    31,   389,   153,   390,
     503,   401,   506,   503,   355,   293,   148,   122,   178,   254,
      31,   254,    31,  4202,   404,   502,    21,  4206,   502,   257,
     257,   439,   502,    48,   503,   502,   502,   474,  5446,   503,
     109,   503,   445,  4365,   433,   314,   383,   503,     5,   502,
    4962,   132,  3753,   314,   192,  4377,   503,  4328,  5466,    54,
     139,  4240,   468,    17,    28,  4306,   254,   135,  4309,   502,
    4707,   212,    67,   258,  4328,   479,   314,   286,    48,   502,
     458,   460,   479,  4707,   502,   452,    81,   245,   489,   489,
     489,  5365,   437,   502,   212,   502,   468,  4368,  4369,  4736,
     433,  1589,  4373,  4374,   502,  4499,   805,  1470,  4776,  3810,
     474,  2626,  3230,  2955,  1250,  3816,   900,  3818,  3816,  3147,
    1310,   866,  4754,  5035,   119,  2541,  5534,  3337,  5536,  3924,
    5037,  4803,  5198,  4856,  3991,   130,  4862,  4490,  4842,  2733,
    4738,  4184,  4185,  4186,  4187,  3048,  5277,  4680,  5359,  5307,
    5212,  5211,  5089,  3854,  3052,   150,  4713,   899,  3200,  3780,
     155,  3824,  5582,  4745,  5506,  5444,  5534,  5490,  5590,  5577,
    5102,  5538,  5619,  3981,  2617,  3876,  4447,  2617,  3879,  3810,
    1370,  3170,  5590,  1573,  2611,  4426,  4427,  3408,  5374,  5577,
    5466,  4835,  3353,  4035,  5318,  4767,  5517,  5160,  1563,  4440,
    4441,  4472,  5185,  5295,  4770,    26,  4447,  1096,  4081,  4960,
    4451,  4037,  2315,  1106,  3024,  4039,  5109,  3279,  4472,  5338,
     648,  1411,   784,  5498,  3925,  2252,  1661,   222,  2253,  2969,
    1069,  4018,  5445,  4241,  3698,  5126,  5557,   797,  2972,  2300,
    2987,  4878,  4636,  1298,  5565,  2274,  4883,  5265,  4642,  5147,
    2299,  3007,  4574,  4647,  4878,  2999,  4650,  5578,  4192,  3644,
    4208,   256,  4939,  4681,  3641,  5129,   789,  5128,  4905,  3602,
    3699,  2592,  4907,  5268,  1276,  3589,  5269,  5256,  5345,  2975,
    4521,  4905,  2904,  3595,  2805,  5482,  4680,  2902,  5485,  5486,
     285,  5488,  3993,  3994,  3694,  2120,    -1,    -1,    -1,  4000,
      -1,    -1,  1492,    -1,    -1,  1297,  4943,  3968,    -1,  1300,
    4704,    -1,  4553,    -1,    -1,  4709,    -1,    -1,  4736,  4943,
      -1,  5198,    -1,   318,  4718,  1305,  1211,  5524,    -1,   324,
    5527,  5528,   327,  5530,  4575,  4576,  4577,  4578,    -1,  5157,
    1530,    -1,    -1,    -1,    -1,    -1,   592,  4765,    -1,    -1,
      -1,   597,  4674,    -1,  4676,   601,    -1,   603,   353,   605,
      -1,    -1,    -1,    -1,   359,  1555,   612,    -1,    -1,   615,
    4764,    -1,     8,    -1,    -1,    11,   622,   372,    -1,  5016,
    4081,    -1,    -1,  5020,  5021,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5016,    -1,    -1,    -1,  5020,  5021,    -1,    -1,
      36,    -1,   397,    -1,    -1,   651,    42,    -1,    -1,    -1,
     656,    -1,    -1,    -1,    -1,    -1,   662,    -1,    -1,    -1,
     666,    -1,    -1,    -1,    -1,    -1,    -1,  4821,  1618,  4665,
      66,    -1,    -1,    -1,    -1,    -1,    -1,   683,    -1,    -1,
      -1,    -1,  5354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,  4642,    -1,  4736,    -1,    -1,  4647,    -1,
     962,  4650,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,   732,  4881,    -1,    -1,
      -1,    42,    -1,    -1,    -1,  4736,    -1,   743,   744,    -1,
      -1,  4162,  4163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4557,    66,    -1,    -1,   764,    -1,
     766,   767,    -1,    -1,    -1,   771,    -1,    -1,  5165,  5166,
      -1,    -1,    -1,   169,    -1,    -1,  4777,   173,  4779,   785,
      -1,  5165,  5166,   789,  4938,    -1,    -1,    -1,    -1,   795,
      -1,    -1,    -1,    -1,    -1,  4796,    -1,    -1,   194,   195,
     806,    -1,    -1,    -1,  4805,    -1,    -1,    -1,  4809,    -1,
    4811,    -1,   818,    -1,  4815,   211,  4817,    -1,  4819,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4296,  4990,  4846,    31,  4847,
      -1,    -1,    -1,    -1,   240,    -1,    -1,   243,    -1,    -1,
      -1,  1103,    -1,    -1,   860,  1805,   862,    50,   169,    -1,
     256,  4322,   173,    -1,    -1,    -1,    -1,    -1,    -1,   875,
      -1,   877,   878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,
      83,    -1,    -1,   899,   900,    -1,  4948,    -1,    -1,    -1,
     211,    -1,    -1,    -1,  4365,    -1,    -1,  4846,    -1,    -1,
      -1,    -1,  5066,    -1,    -1,    -1,  4377,    -1,    -1,    -1,
      -1,    -1,   928,    -1,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,   243,   939,    -1,    -1,    -1,   943,   334,  4400,
      -1,    -1,   135,    -1,    -1,   256,   139,    -1,   259,    -1,
      -1,   957,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   971,    -1,    -1,    -1,    -1,
      -1,   977,   978,    -1,    -1,  5129,    -1,    -1,   171,  5157,
      -1,    -1,    -1,    -1,    -1,    -1,  4447,    -1,    -1,   995,
     996,   997,    -1,    -1,  1000,  1001,    -1,  1003,    -1,  4938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,  4948,
      -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    -1,
      -1,  4824,    -1,   334,    -1,  1031,    -1,  1033,  1034,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5038,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,   240,    -1,    -1,
      -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,  1310,    -1,
      -1,    -1,  4865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5087,    -1,
      -1,    -1,    -1,  1089,  1090,    -1,    -1,    -1,  1094,  5243,
    1096,    -1,    -1,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,    -1,    -1,    -1,    -1,    -1,  1114,    -1,
      -1,  1117,   305,  4574,  1120,    -1,   309,    -1,  1370,    -1,
      -1,    -1,   315,    -1,    -1,    -1,    -1,  1133,    -1,   322,
      -1,    -1,    -1,    -1,    -1,    -1,  5290,   330,  5535,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,  5087,    -1,
      -1,    -1,    -1,    -1,   347,    -1,  1162,    -1,    -1,  1411,
      -1,    -1,    -1,    -1,    -1,    -1,  4587,    -1,  4971,    -1,
      -1,  2121,    -1,    -1,    -1,    -1,    -1,  4598,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,  5270,  1195,
    1196,    -1,  1198,    -1,    -1,   506,    -1,  5198,  4619,  4620,
      -1,    -1,    -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,
     403,  1217,    -1,  4674,    -1,  4676,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   424,    -1,    -1,    -1,    -1,    -1,  5238,    -1,    -1,
    1492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1255,
      -1,    -1,  1258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   467,    -1,  1282,  1283,  1530,    -1,
      -1,  5282,  5283,    -1,  1290,    -1,    -1,    -1,  1294,  1295,
      -1,    -1,    -1,    -1,  4755,    -1,    -1,    -1,    -1,  1305,
    1306,  1307,    -1,  1555,    -1,    -1,    -1,    -1,    -1,    -1,
    5319,    -1,    -1,    -1,    -1,  4776,    -1,  1323,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5338,
    5331,  5332,  5338,    -1,    -1,    -1,  5338,    -1,    -1,    -1,
    5338,  5338,  4803,    -1,  4805,    -1,  5398,    -1,    -1,  5503,
      -1,    -1,    -1,  1359,    -1,  5386,    -1,  5535,    -1,    -1,
    2310,    -1,    -1,    -1,  2314,  2315,  1618,    -1,    -1,  1375,
    1376,    -1,    31,    -1,    -1,    -1,  1382,    -1,    -1,  1385,
    5319,    -1,    -1,    -1,    -1,  5386,    -1,    -1,    -1,  5398,
      -1,    50,  5398,    -1,    -1,    -1,  5398,    -1,    -1,  5338,
    5398,  5398,    -1,    -1,    -1,    -1,    -1,  1413,    -1,    -1,
      -1,  5442,    -1,  1419,    -1,    -1,  1422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5463,    -1,    -1,  5466,    -1,    -1,    -1,    -1,
    1446,    -1,    -1,    -1,  5445,  5476,     0,    -1,  1454,  1455,
    1456,  1457,  1458,    -1,    -1,    -1,    -1,    -1,    -1,  5398,
      -1,    -1,    -1,    -1,    -1,  5466,  1472,    -1,    -1,    -1,
      -1,    -1,    -1,  5474,    -1,    -1,   135,    -1,  2428,    -1,
     139,    -1,  1488,  4904,  1490,    -1,    -1,    -1,    -1,  5498,
      -1,    -1,  5498,    -1,  1500,  1501,  5498,    -1,    -1,    -1,
    5498,  5498,  1508,    -1,  5535,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   171,  5514,  5515,    -1,    -1,  5518,  5519,    -1,
    5521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    -1,    -1,    -1,  5535,  4996,    -1,    -1,    -1,    -1,
      -1,   200,    -1,  1549,    -1,    -1,  5577,    -1,   207,    -1,
      -1,    -1,    -1,  1805,    -1,    -1,    -1,    -1,    -1,  5498,
      -1,  5592,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5570,
    1576,  1577,  1578,  1579,    -1,    -1,  5577,   131,    -1,   238,
      -1,   240,    -1,    -1,  1590,  5616,    -1,    -1,    -1,   143,
      -1,  5592,  1598,    -1,   148,    -1,  1602,    -1,    -1,   153,
      -1,    -1,    -1,    -1,   158,    -1,  1612,   161,    -1,   163,
      -1,    -1,    -1,  1619,    -1,    -1,  1622,    -1,    -1,    -1,
      -1,    -1,  5425,    -1,    -1,    -1,  1632,    -1,    -1,    -1,
      -1,  1637,    -1,    -1,    -1,    -1,   190,    -1,    -1,    -1,
    1646,    -1,    -1,  2593,    -1,    -1,   305,    -1,  1654,  1655,
     309,    -1,    -1,    -1,    -1,    -1,   315,    -1,   212,    -1,
      -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,  1684,    -1,
     339,    -1,     0,    -1,    -1,  1691,    -1,  1693,   347,    -1,
      -1,  1697,  1698,    -1,  1700,    -1,    -1,    -1,   252,    -1,
      -1,  1707,    -1,    -1,    -1,    -1,   260,    -1,  1714,    -1,
      -1,    -1,    -1,    -1,    -1,  1721,  1722,   271,    -1,  1725,
      -1,    -1,  2672,  1729,    -1,  1731,    -1,    -1,  2678,    -1,
      -1,    -1,  1738,    -1,    -1,  1741,    -1,  5198,    -1,  1745,
     399,    -1,    -1,    -1,   403,   404,    -1,  1753,  1754,    -1,
      -1,    -1,    -1,    -1,   308,  1761,    -1,  1763,  1764,  1765,
    1766,  1767,    -1,    -1,    -1,   424,    84,    -1,    -1,  1775,
    1776,    -1,  1778,    -1,  1780,  1781,    -1,    -1,  1784,    -1,
    1786,    -1,  1788,  1789,    -1,    -1,  1792,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   453,    -1,    -1,    -1,    -1,   353,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   467,  5270,
    1816,    -1,    -1,   131,  2764,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   377,    -1,   143,    -1,    -1,    -1,    -1,
     148,    -1,    -1,    -1,    -1,   153,  1842,    -1,    -1,    -1,
     158,    -1,    -1,   161,    -1,   163,    -1,   401,    -1,   403,
     404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   190,    -1,    -1,    -1,    -1,   431,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1897,    -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   473,
    1926,    -1,    -1,    -1,    -1,  5386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,   252,    50,    -1,    -1,    -1,    -1,
      -1,    -1,   260,    -1,    -1,    -1,   500,    14,    -1,   503,
     504,   505,    -1,   271,    -1,  1961,    -1,    24,    -1,    26,
      27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5446,    -1,    -1,    -1,    -1,
     308,  2941,  2942,  2943,    61,    -1,    63,    64,    -1,    -1,
      -1,    -1,    69,    -1,    71,  5466,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    82,    -1,    84,    -1,    -1,
     135,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,   353,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,   121,    -1,   171,    -1,  2310,   377,
     127,    -1,  2314,  2315,  3014,    -1,    -1,  3017,   135,  3019,
     137,    -1,    -1,  5534,  3024,  5536,   143,    -1,    -1,    -1,
      -1,    -1,    -1,   401,    -1,   403,   404,    -1,    -1,    -1,
      -1,   158,   207,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,    -1,  2109,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2118,   431,  2120,  2121,  5577,    -1,    -1,    -1,
      -1,  2127,    -1,   238,  3074,   240,    -1,    -1,    -1,  5590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,   214,    -1,    -1,
      -1,    -1,   219,    -1,    -1,   473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
    3120,    -1,    -1,    -1,    -1,   242,  2428,    -1,    -1,    -1,
      -1,    -1,   500,    -1,    -1,   503,   504,   505,    -1,    -1,
     305,    -1,   307,    -1,   309,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,    -1,    -1,   280,    -1,   330,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,   292,    -1,    -1,    -1,    -1,
     297,   298,   347,   300,    -1,    -1,    -1,    -1,   305,    -1,
      -1,    -1,    -1,   310,    -1,  2251,   313,  2253,    -1,    -1,
     317,  2257,    -1,    -1,     8,   322,   323,    11,    -1,    -1,
      -1,    -1,  3212,   330,  3214,    -1,   333,    -1,  2274,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,  2283,  2284,    -1,
      -1,    -1,    36,    -1,   399,    -1,   353,    -1,    42,    -1,
      -1,  2297,    -1,    -1,    -1,    -1,    -1,  2303,    -1,  2305,
      -1,    -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,   424,
      -1,    -1,    66,   380,    -1,    -1,    -1,    -1,    -1,   386,
      -1,    -1,    -1,    -1,   391,    -1,  3276,  2333,    -1,    -1,
      -1,    -1,  2338,    -1,  2340,    -1,    -1,   404,   453,    -1,
      -1,  2593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2357,   467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2368,    -1,  2370,  2371,  2372,    -1,    -1,  2375,
    3320,  2377,    -1,  2379,    -1,  2381,    -1,  2383,  2384,    -1,
      -1,    -1,    -1,  2389,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3354,     8,    -1,  2413,    11,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,  2423,    -1,   173,
    2672,    -1,    -1,    -1,    -1,    28,  2678,    -1,  2434,    -1,
      -1,    -1,    -1,    36,    -1,   502,  2442,    -1,   505,    42,
     194,   195,  2448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
    2476,    -1,    -1,  3423,  2480,  2481,    -1,    -1,    -1,    -1,
      -1,  2487,  2488,    -1,    -1,    -1,    -1,     8,    -1,   243,
      11,    -1,    -1,    -1,  3444,    -1,    -1,    -1,    -1,  2505,
      -1,    -1,   256,    -1,    -1,    -1,  3456,    28,    -1,    -1,
      -1,    -1,  2764,    -1,    -1,    36,    -1,    -1,    -1,    -1,
       8,    42,    -1,    11,    -1,    -1,  2532,    -1,  2534,  2535,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,    66,    -1,     8,    36,    -1,
      11,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2569,    -1,    -1,   169,    -1,    -1,    -1,
     173,  2577,    -1,    -1,    -1,    36,  2582,  3527,    66,    -1,
     334,    42,    -1,    -1,    -1,  2591,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,  3547,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,   211,    -1,
      -1,    -1,    -1,  2619,    -1,    -1,  2622,    -1,  2624,    -1,
    2626,    -1,    -1,  2629,    -1,  3575,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,  2655,
      -1,    -1,   173,   256,    -1,    -1,   259,    -1,    -1,  2665,
    2666,    -1,    -1,    -1,    -1,    -1,    -1,  3617,   129,    -1,
      -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,
     211,  2697,    -1,  2699,  2700,  2701,  2702,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,   195,   169,    -1,
      -1,    -1,   173,  3663,    -1,  2721,    -1,    -1,    -1,   240,
      -1,    -1,   243,   211,    -1,    -1,    -1,  2733,    -1,    -1,
      -1,   334,    -1,   194,   195,   256,   490,   491,   259,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,    -1,
     211,    -1,   240,    -1,    -1,   243,  3706,    -1,    -1,    -1,
      -1,    -1,  3014,    -1,    -1,  3017,    -1,  3019,   256,    -1,
      -1,   259,  3024,  2779,    -1,    -1,    -1,    -1,    -1,  2785,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2796,    -1,    -1,    -1,    -1,   256,    -1,  2803,  2804,    -1,
      -1,    -1,    -1,  2809,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3074,    -1,    -1,    -1,    -1,    -1,  2834,  2835,
      -1,    -1,    -1,  2839,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   334,  2853,  2854,  2855,
    2856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2867,    -1,    -1,  2870,    -1,    -1,  3817,  3120,    -1,
    2876,  2877,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,
    2886,  2887,    -1,    -1,  2890,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,    -1,  2903,   501,  2905,
      -1,  2907,    -1,  2909,   507,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2928,    -1,    -1,    -1,  2932,    -1,    -1,    -1,
      -1,    -1,  2938,    36,    -1,  2941,  2942,  2943,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2958,    -1,    -1,    -1,    -1,    -1,     8,    -1,
    3212,    11,  3214,    66,    -1,    -1,  2972,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    28,    -1,
      -1,  2987,   503,    -1,    -1,   506,    36,    -1,    -1,    -1,
      -1,    -1,    42,  2999,     8,    -1,  3002,    11,    -1,    -1,
    3006,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,    -1,    66,    -1,   506,    -1,
      -1,    -1,    36,    -1,  3276,    -1,   129,    -1,    42,    -1,
      -1,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,  3047,    -1,  3049,    -1,    -1,    -1,  3997,  3054,    -1,
      -1,    -1,    66,    -1,    18,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,    -1,   169,    -1,  3320,    -1,
     173,    -1,    -1,    -1,  3080,    -1,  3082,  3083,  3084,    -1,
      -1,    -1,    -1,  4033,    -1,    -1,    -1,    -1,    -1,  4039,
      -1,   194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,  3354,    -1,     8,    -1,    -1,    11,   211,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,   169,
      -1,    -1,    -1,   173,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,
     243,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,
     114,    -1,    -1,   256,    -1,   169,    -1,   121,    -1,   173,
     124,   211,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,  3444,   243,    -1,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,  4153,  3456,    -1,   256,    -1,    -1,   259,
      -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,  4168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
      -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,   169,    -1,    -1,  4218,   173,
      -1,    -1,    -1,  4223,   238,  3527,   240,    -1,  4228,    -1,
      -1,    -1,    -1,    -1,   334,    -1,   250,    -1,    -1,    -1,
     194,   195,    -1,    -1,   258,  3547,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,   268,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3324,  3325,
     334,    -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,    -1,
    4280,    -1,    -1,    -1,    -1,    -1,   240,   301,    -1,   243,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   256,    -1,    -1,   259,    -1,   121,    -1,    -1,
     124,    -1,    -1,    -1,    -1,  3617,   330,    -1,  3374,  3375,
      -1,  3377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4331,    -1,    -1,    -1,    -1,    -1,  3393,    -1,    -1,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,
    3406,  3407,    -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,
      -1,  3417,  3418,    -1,   178,    -1,    -1,    -1,    -1,    -1,
    4370,    -1,    -1,  3429,   388,    -1,    -1,    -1,    -1,    -1,
     334,  3437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,    -1,    -1,    -1,  3706,    -1,   506,    -1,    -1,    -1,
    3466,    -1,    -1,  3469,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,    -1,   238,    -1,   240,  3483,  4428,   493,
     494,   495,   496,   497,   498,    -1,   250,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,  3504,    -1,
      -1,    -1,    -1,    -1,   268,    -1,    -1,    -1,  3514,    -1,
      -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,  3524,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3534,    -1,
      -1,    -1,    -1,    -1,  3540,    -1,  3542,   301,    -1,    -1,
     304,   305,  3548,    -1,    -1,  3551,  3552,  3553,  3554,  3555,
    3556,  3557,  3558,  3559,  3560,    -1,    -1,    -1,  3564,  3565,
      -1,    -1,    -1,    -1,    -1,  3817,   330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3580,    -1,    -1,    -1,  3584,  3585,
      -1,    -1,    -1,  3589,    -1,   489,   490,   491,  3594,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,  3604,    -1,
      -1,  3607,   506,  3609,  4554,    -1,   370,    -1,    -1,    -1,
      -1,    -1,  3618,  3619,  3620,    -1,    -1,     8,  3624,    -1,
      11,  3627,    -1,    -1,   388,  3631,    -1,    -1,    -1,    -1,
      -1,    -1,  3638,  3639,  3640,  3641,    -1,    28,  3644,  3645,
      -1,  4591,    -1,  3649,  3650,    36,    -1,    -1,    -1,    -1,
    3656,    42,    -1,    -1,    -1,    -1,  3662,  3663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   435,   436,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,  3688,    -1,    -1,    -1,    -1,    -1,  3694,    -1,
      -1,    -1,  3698,    -1,  3700,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,    -1,    -1,  3722,  3723,  3724,    -1,
    3726,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,  3744,  3745,
    3746,  3747,    -1,    -1,    -1,  3997,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4707,    -1,    -1,
    4710,    -1,  4712,    -1,    -1,    -1,  3772,  3773,  3774,  3775,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,  4033,   173,    -1,    -1,     8,  4736,  4039,    11,    -1,
      -1,    -1,    -1,    -1,  3800,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,   195,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,  3820,    -1,  3822,    -1,  3824,    42,
     211,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,
      -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,   243,    -1,    -1,  3861,  3862,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,   256,    -1,    -1,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,   178,    -1,  3893,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,  4153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4878,    -1,
      -1,    -1,    -1,  4883,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,   238,   169,   240,    -1,  3955,
     173,    -1,    -1,    -1,    -1,  4905,    -1,   250,    -1,    -1,
    3966,    -1,  3968,    -1,    -1,   258,    -1,    -1,  3974,    -1,
      -1,   194,   195,    -1,  3980,   268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3991,    -1,    -1,   211,    -1,
      -1,    -1,    -1,  4943,    -1,    -1,    -1,  4003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4013,   301,    -1,
      -1,   304,   305,    -1,  4020,    -1,    -1,   240,    -1,    -1,
     243,    -1,   169,    -1,    -1,    -1,   173,    -1,  4280,    -1,
      -1,    -1,    -1,   256,  4040,  4041,   259,   330,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4063,     8,  4065,
      -1,    11,    -1,    -1,   211,    -1,  5016,    -1,    -1,    -1,
    5020,  5021,    -1,    -1,    -1,    -1,    -1,   370,    28,  4331,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,   240,  4100,   388,   243,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,   256,
      -1,   334,   259,    -1,    -1,   506,    66,    -1,  4370,    -1,
      -1,    -1,    -1,  4129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   435,   436,  4150,  4151,    -1,    -1,    -1,  4155,
      -1,    -1,    -1,    -1,    -1,    -1,  4162,  4163,    -1,  5109,
      -1,  4167,    -1,    -1,    -1,    -1,    -1,  4173,  4174,    -1,
      -1,  4177,    -1,    -1,  4180,  4181,  4428,    -1,  4184,  4185,
    4186,  4187,    -1,    -1,   477,  4191,  4192,   334,  4194,  4195,
      -1,    -1,  4198,    -1,    -1,    -1,  4202,    -1,    -1,    -1,
    4206,    -1,    -1,    -1,    18,    -1,  4212,    -1,    -1,    -1,
      24,    -1,  4218,    -1,    -1,  5165,  5166,  4223,    -1,   169,
      -1,    -1,  4228,   173,    -1,    -1,    -1,    -1,  4234,    -1,
      -1,    -1,    -1,    -1,    -1,  4241,    -1,    -1,    -1,  4245,
      -1,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,
      64,    -1,    -1,  4259,    -1,    -1,  4262,    -1,    -1,    -1,
       8,   211,    -1,    11,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,  4282,  4283,    -1,    -1,
      28,    -1,    -1,   506,    -1,    -1,    -1,    -1,    36,    -1,
     240,    -1,    -1,   243,    42,  4301,  4302,    -1,    -1,    -1,
     114,    -1,    -1,    -1,    -1,  4311,   256,   121,    -1,   259,
     124,  4317,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,
      -1,    -1,    -1,  4329,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,  4343,    11,  4591,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,   503,    -1,    -1,    -1,
      -1,    -1,    -1,    36,   178,    -1,    -1,    -1,    -1,    42,
      -1,    -1,   187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   197,   198,   334,    -1,    -1,    -1,    -1,   204,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
     215,    -1,    -1,  4409,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4423,    -1,    -1,
      -1,   169,    -1,    -1,   238,   173,   240,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,   250,    -1,    42,    -1,
      -1,    -1,    -1,    -1,   258,    -1,   194,   195,    -1,    -1,
      -1,    -1,    -1,    -1,   268,  4707,   129,    -1,    -1,    -1,
      -1,    -1,    66,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4488,    -1,  4736,    -1,    -1,   301,    -1,    -1,
     304,   305,   240,  4499,    -1,   243,   169,    -1,  4504,    -1,
     173,    -1,    -1,    -1,    -1,    -1,    -1,  4513,   256,    -1,
      -1,   259,    -1,    -1,    -1,    -1,   330,    -1,    -1,  4525,
    4526,   194,   195,    -1,    -1,   129,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4542,    -1,   211,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,  4557,    -1,   503,    -1,    -1,   370,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,   173,
     243,    -1,    -1,    -1,   388,    -1,    -1,    -1,    -1,    -1,
      -1,  4587,    -1,   256,    -1,  5535,   334,    -1,    -1,    -1,
     194,   195,  4598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4610,    -1,    -1,   211,    -1,    -1,
      -1,    -1,    -1,  4619,  4620,    -1,    -1,  4623,    -1,    -1,
      -1,   435,   436,    -1,    -1,    -1,  4878,    -1,    -1,    -1,
    4636,  4883,  4638,    -1,    -1,    -1,  4642,    -1,    -1,   243,
      -1,  4647,    -1,    -1,  4650,  4651,    -1,  4653,    -1,  4655,
    4656,    -1,   256,  4905,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   334,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4680,  4681,  4682,  4683,  4684,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4943,    -1,    -1,    -1,    -1,    -1,    -1,  4704,    -1,
      -1,    -1,    -1,  4709,  4710,    -1,  4712,    -1,    -1,    -1,
      -1,    -1,  4718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     334,    -1,  4738,  4739,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,   503,    -1,    -1,  4764,  4765,
      -1,    -1,    -1,    -1,  5016,    -1,    -1,    -1,  5020,  5021,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   610,    -1,    -1,    -1,   614,
      -1,    -1,    -1,    28,    -1,    -1,    -1,  4813,  4814,    -1,
     625,    36,    -1,    -1,    -1,  4821,    -1,    42,  4824,    -1,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,  4835,
      -1,    -1,   647,    -1,    -1,    -1,   651,    -1,  4844,    -1,
      -1,    66,  4848,    -1,    -1,    -1,    -1,   662,   663,     8,
      -1,    -1,    11,   668,    -1,    -1,  4862,    -1,    -1,  4865,
      -1,    -1,    -1,   678,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,   688,  4880,  4881,    -1,    36,    -1,    -1,
      -1,    -1,     8,    42,    -1,    11,    -1,    -1,    -1,   493,
     494,   495,   496,   497,   498,    -1,  4902,    -1,  4904,    -1,
      -1,  4907,    28,  4909,    -1,    -1,    -1,    66,    -1,    -1,
      36,    -1,    -1,  5165,  5166,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,  4929,    -1,    -1,    -1,    -1,  4934,    -1,
      -1,    -1,  4938,    -1,    -1,  4941,    -1,    -1,    -1,    -1,
      66,    -1,  4948,    -1,   169,    -1,    -1,  4953,   173,   764,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4971,    -1,    -1,    -1,   194,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     795,    -1,    -1,    -1,  4990,    -1,   211,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,   173,   240,    -1,    -1,   243,    -1,
      -1,    -1,    -1,    -1,  5030,  5031,  5032,  5033,    -1,    -1,
      -1,   256,    -1,    -1,   259,   194,   195,    -1,    -1,  5045,
      -1,    -1,    -1,   169,    -1,    -1,    -1,   173,    -1,   962,
      -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5085,
      -1,   240,    -1,    -1,   243,   211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5102,   256,    -1,    -1,
     259,   916,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,
      -1,    -1,    -1,   928,   240,    -1,    -1,   243,    -1,    -1,
    5126,    -1,    -1,  5129,   939,    -1,    -1,    21,    -1,    -1,
     256,    -1,    -1,   259,    -1,    -1,    -1,  5143,    -1,  5145,
      -1,  5147,    -1,    -1,    -1,    -1,    -1,   962,    -1,  5155,
      -1,  5157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5171,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,   334,    -1,    -1,   993,    -1,
      -1,    -1,    -1,    -1,    -1,  1000,    -1,    81,  1003,    -1,
    1103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   334,    -1,
     104,    -1,    -1,  5219,    -1,    -1,    -1,    -1,  5224,    -1,
      -1,    -1,  1037,    -1,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   130,  5243,  1053,  1054,
      -1,    -1,    -1,  1058,   138,   139,    -1,    -1,    -1,  5255,
    5256,    -1,  1067,    -1,  5260,    -1,   150,    -1,    -1,  5265,
      -1,   155,  5268,    -1,   489,   490,   491,   161,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,    -1,   503,    -1,
    1095,    -1,   176,  5535,  5290,    -1,    -1,    -1,  1103,    -1,
    1105,    -1,    -1,  5299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1118,    -1,    -1,  1121,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1133,  5325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,
     489,   490,   491,  5339,   493,   494,   495,   496,   497,   498,
      -1,    -1,    -1,    -1,   503,    -1,    -1,  1162,    -1,    -1,
    5356,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,
    5366,    -1,   256,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,    -1,    28,    -1,    -1,   503,    -1,    -1,
    1195,  1196,    36,  1198,    -1,    -1,    -1,     8,    42,    -1,
      11,   285,    -1,    -1,    -1,    -1,    -1,  1310,    -1,    -1,
      -1,    -1,  1217,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    36,    -1,    -1,   312,  5425,
      -1,    42,   316,    -1,   318,    -1,  1241,    -1,    -1,    -1,
     324,    -1,    -1,   327,  1249,  1250,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1258,  1259,    66,    -1,    -1,  5454,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1370,   352,   353,
      -1,   355,    -1,    -1,    -1,   359,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   367,    -1,  1290,    -1,    -1,   372,  1294,
    1295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     384,    -1,    -1,    -1,    -1,  1310,     8,  5503,  1411,    11,
      -1,  1316,    -1,   397,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5517,    -1,    -1,    -1,   169,    28,    -1,    -1,   173,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
     194,   195,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,  5557,   173,    28,    66,  1370,    -1,   211,    -1,  5565,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,   463,
      -1,    -1,  5578,   194,   195,    -1,   470,    -1,    -1,  1492,
      -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,   243,
     211,    66,    -1,    -1,    -1,    -1,  1411,    -1,    -1,    -1,
      -1,    -1,   256,    -1,    -1,   259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1530,    -1,   240,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,   259,    -1,
      -1,    -1,  1555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1468,    -1,    -1,    -1,   169,    -1,    -1,
      -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1492,    -1,    -1,
     334,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,   173,   211,
      -1,    -1,    -1,    -1,    -1,  1618,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,  1530,    -1,    -1,    -1,   194,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,   243,    -1,    -1,    -1,  1550,   211,    -1,    -1,    -1,
    1555,    -1,    -1,    -1,   256,    -1,    -1,   259,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1570,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,   243,    -1,
      -1,  1586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,   259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1612,    -1,    -1,
      -1,    -1,    -1,  1618,    -1,    -1,    -1,  1622,    -1,  1624,
    1625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1635,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1647,  1648,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,  1661,    -1,    -1,   503,
      -1,    -1,    18,    -1,    -1,    -1,    -1,    -1,    24,   334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,  1693,    -1,
      -1,    -1,   503,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,  1805,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      -1,     8,    -1,    28,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,  1729,    -1,  1731,    42,    -1,    -1,
      -1,    28,    -1,  1738,    -1,    -1,  1741,    -1,    -1,    36,
    1745,    -1,    -1,    -1,     8,    42,    -1,    11,  1753,  1754,
      -1,    66,    -1,    -1,    -1,    -1,  1761,    -1,   114,  1764,
    1765,  1766,  1767,    -1,    28,   121,    -1,    -1,   124,    66,
    1775,  1776,    36,  1778,    -1,  1780,  1781,    -1,    42,  1784,
      -1,  1786,    -1,  1788,  1789,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
    1805,   503,    66,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,  1816,  1817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,   489,   490,   491,    28,   493,   494,
     495,   496,   497,   498,    -1,    36,    -1,    -1,   503,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,   173,    -1,    -1,   194,
     195,    -1,   238,    -1,   240,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1897,    -1,   250,    -1,   211,   194,   195,    -1,
      -1,    -1,   258,    -1,    -1,   169,    -1,    -1,    -1,   173,
      -1,    -1,   268,    -1,   211,    -1,    -1,    -1,    -1,    -1,
      -1,  1926,    -1,    -1,    -1,   240,    -1,    -1,   243,    -1,
     194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,   240,   259,   301,   243,   211,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,  1961,    -1,    -1,   256,
      -1,    -1,   259,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   173,    -1,   330,    -1,   240,    -1,    -1,   243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   256,   194,   195,   259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,    -1,    -1,    -1,   370,    -1,    -1,    -1,    -1,   334,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   388,    -1,    -1,    -1,    -1,   334,    -1,   240,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,
     436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2099,  2100,  2101,  2102,  2103,  2104,
    2105,  2106,  2107,    -1,  2109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2120,  2121,    -1,    -1,    -1,
      -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,    28,   493,   494,
     495,   496,   497,   498,    -1,    36,    -1,    -1,   503,    -1,
      -1,    42,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,   503,  2310,    -1,    -1,
      -1,  2314,  2315,    -1,    -1,    66,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,    28,    -1,   503,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    42,  2257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2274,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,  2283,  2284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,    -1,   503,    -1,    -1,  2310,    -1,    -1,    -1,  2314,
    2315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,  2324,
      -1,    -1,   173,  2328,  2329,  2428,    -1,  2332,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,  2354,
      28,    -1,  2357,    -1,    -1,    -1,    -1,    -1,    36,    -1,
     211,    -1,    -1,  2368,    42,    -1,    -1,    18,    -1,    -1,
    2375,    -1,    -1,    24,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    66,   240,
      -1,    -1,   243,    -1,  2399,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,   194,   195,   256,    -1,    -1,   259,    -1,
      -1,    -1,    -1,    64,  2419,  2420,    -1,    -1,    -1,    -1,
     211,    -1,    -1,  2428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,  2451,  2452,    -1,   240,
      -1,  2456,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   256,    -1,    -1,   259,    -1,
     121,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,    -1,  2490,    -1,    -1,    -1,  2494,
    2593,   169,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2512,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,   194,   195,  2523,    -1,
      -1,    -1,    -1,    -1,   175,    -1,    -1,   178,    -1,    -1,
      28,  2536,    -1,   211,    32,    -1,    -1,    -1,    36,    -1,
      -1,    -1,  2547,   334,    42,    -1,    -1,    -1,    -1,  2554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,    -1,    -1,   243,    -1,    -1,    66,  2672,
      -1,    -1,   223,    -1,    -1,  2678,    -1,   228,   256,    -1,
      -1,   259,    -1,    -1,    -1,    -1,  2591,   238,  2593,   240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,  2614,
      -1,    -1,    -1,    -1,   112,    -1,   267,   268,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
     301,    -1,   503,   304,   305,   306,   334,    -1,    -1,    -1,
      -1,  2764,    -1,    -1,    -1,    -1,    -1,  2672,    -1,    -1,
      -1,   169,    -1,  2678,    -1,   173,    -1,  2682,    -1,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     341,    -1,    -1,    -1,    -1,    -1,   194,   195,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,  2716,   503,   211,    -1,    -1,  2721,    -1,    -1,   370,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,
      -1,    -1,   240,    -1,    -1,   243,    -1,  2752,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,  2764,
      -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2775,    -1,    -1,    -1,  2779,    -1,    -1,    -1,    -1,    -1,
    2785,    -1,    -1,    -1,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2803,  2804,
      -1,    -1,    -1,    -1,  2809,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,   198,    -1,   501,    -1,    -1,   477,   204,    -1,  2834,
    2835,    -1,    -1,    -1,  2839,    -1,   334,    -1,   215,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,  2853,  2854,
    2855,  2856,    -1,    -1,    -1,    -1,  2861,    -1,    -1,    -1,
      -1,    28,  2867,  2868,    -1,  2870,    -1,    -1,    -1,    36,
      -1,  2876,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,  2886,  2887,    -1,    -1,  2890,    -1,   385,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2903,    66,
    2905,    -1,    -1,    -1,  2909,    -1,    -1,    -1,    -1,    -1,
      -1,  3014,    -1,    -1,  3017,    -1,  3019,    -1,    -1,    -1,
      -1,  3024,    -1,  2928,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,  2938,    -1,    -1,  2941,  2942,  2943,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
    2955,    -1,    -1,  2958,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,  2972,    -1,    -1,
      -1,  3074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,  2987,    -1,    66,    -1,   153,    -1,    -1,    -1,
      -1,   489,   490,   491,  2999,   493,   494,   495,   496,   497,
     498,    21,   169,    -1,    -1,    -1,   173,    -1,    -1,  3014,
      -1,    -1,  3017,    33,  3019,    -1,    -1,  3120,    -1,  3024,
      -1,  3026,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,
      -1,    -1,    -1,    -1,    54,    -1,  3041,  3042,    -1,    -1,
      -1,    -1,  3047,    -1,   211,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    81,    -1,  3068,    -1,    -1,  3071,    -1,    -1,  3074,
      -1,    -1,    -1,   240,    -1,    -1,   243,    -1,    98,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   169,    -1,   256,
      -1,   173,   259,    -1,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3212,
     130,  3214,   194,   195,    -1,  3120,    -1,    -1,   138,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,
     150,    -1,   962,    -1,    -1,    -1,    -1,   157,    -1,    -1,
      -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,   240,    -1,
      -1,   243,    -1,    -1,  3169,  3170,  3171,   334,    -1,    -1,
      -1,    -1,    -1,  3276,   256,    -1,    -1,   188,   189,    -1,
      -1,   192,    -1,   194,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,   215,    -1,    -1,  3203,    -1,
      -1,    -1,   222,   214,    -1,    28,   217,  3212,    -1,  3214,
    3215,    -1,    -1,    36,    -1,    -1,    -1,  3320,    -1,    42,
      -1,  3226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   610,    -1,    -1,   256,   614,    -1,   259,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,   625,    -1,
      -1,  3354,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     647,  3276,    -1,  1103,   294,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   663,    -1,    -1,    -1,
      -1,   668,   312,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,   678,    -1,    -1,   324,    -1,    -1,   327,    -1,  3314,
      -1,   688,    -1,    -1,    -1,  3320,    -1,    -1,    -1,    -1,
    3423,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,   353,    -1,   355,   356,    -1,   358,   359,
      -1,  3444,    -1,    -1,    -1,    -1,   169,   367,  3353,  3354,
     173,    -1,   372,  3456,    -1,    -1,    -1,    -1,   378,    -1,
      -1,   381,    -1,  3368,   384,  3370,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,   397,    -1,    -1,
    3385,    -1,  3387,    -1,    -1,    -1,    -1,    -1,   211,    -1,
      -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,   240,  3423,    -1,
     243,    -1,    -1,    -1,  3527,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   256,    -1,    -1,   259,   457,  3443,  3444,
      -1,    -1,    -1,    -1,  3547,    -1,   466,    -1,    -1,    -1,
     470,  3456,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   484,    -1,    -1,  3472,    -1,    -1,
      -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,  3483,    -1,
    1310,  3486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,  3503,    -1,
      -1,  3506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   334,    -1,    -1,  3617,    -1,    -1,    -1,    -1,  3524,
      -1,    -1,  3527,    -1,    -1,   348,    -1,    -1,    -1,  3534,
      -1,    -1,    -1,    -1,    -1,  3540,    64,  3542,    -1,   916,
    1370,    -1,  3547,  3548,    -1,    -1,  3551,  3552,  3553,  3554,
    3555,  3556,  3557,  3558,  3559,  3560,    -1,    -1,    -1,  3564,
    3565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3575,    -1,    -1,    -1,    -1,  3580,    -1,    -1,    -1,  3584,
    3585,  1411,  3587,    -1,  3589,    -1,   114,    -1,    -1,  3594,
     601,    -1,    -1,   121,   605,    -1,   124,     8,    -1,  3604,
      11,    18,  3607,  3706,  3609,    -1,    -1,    24,    -1,    -1,
      -1,   622,  3617,  3618,  3619,  3620,   993,    28,    -1,  3624,
      31,    -1,  3627,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,  3641,    -1,    -1,  3644,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,
     178,  3656,    -1,    -1,    -1,    66,    -1,  3662,  3663,    -1,
    1037,    -1,  1492,    -1,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,  1053,  1054,    -1,    -1,
      -1,    -1,    -1,  3688,    -1,    -1,    -1,    -1,    -1,  3694,
    1067,    -1,    -1,    -1,    -1,  3700,    -1,   114,    -1,    -1,
    1530,  3706,    -1,    -1,   121,    -1,    -1,   124,    -1,    -1,
     238,    -1,   240,    -1,  3817,    -1,    -1,  3722,  1095,    -1,
      -1,    -1,   250,    -1,    -1,  1555,    -1,    -1,  1105,    -1,
     258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     268,  1118,    -1,    -1,  1121,    -1,    -1,    -1,  3753,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,   169,    -1,
      -1,   178,   173,    -1,    -1,    -1,    -1,  3772,  3773,  3774,
    3775,    28,    -1,   301,    -1,    -1,   304,   305,    -1,    36,
      -1,    -1,    -1,   194,   195,    42,    -1,    -1,  1618,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,    -1,   330,    -1,    -1,  3810,    -1,    -1,    -1,    66,
      -1,  3816,  3817,  3818,    -1,    -1,    -1,    -1,    -1,  3824,
      -1,   238,    -1,   240,    31,    -1,    -1,    -1,    -1,   240,
      -1,    -1,   243,   250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   258,   370,    50,    -1,   256,    -1,    -1,   259,  3854,
      -1,   268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     388,    -1,    -1,    -1,  1241,    -1,   877,   878,    -1,    -1,
      -1,  3876,  1249,  1250,  3879,    -1,    83,    -1,    -1,    -1,
      -1,    -1,  1259,    -1,   301,    -1,    -1,   304,   305,    -1,
     147,    -1,    -1,    -1,  3997,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,    -1,
      -1,    -1,   169,   330,    -1,    -1,   173,    -1,    -1,    -1,
    3925,    -1,    -1,   334,    -1,    -1,    -1,    -1,   135,    -1,
    4033,    -1,   139,    -1,    -1,    -1,  4039,   194,   195,  1316,
      -1,    -1,    -1,    -1,    -1,    -1,   957,    -1,    -1,   477,
      -1,    -1,    -1,   370,   211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3968,   171,    -1,   977,   978,    -1,    -1,
      -1,   388,    -1,    -1,    -1,  1805,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   240,    -1,    -1,   243,    -1,  3993,  3994,
    1001,    -1,  3997,   200,    -1,  4000,    -1,    -1,    -1,   256,
     207,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
     277,    -1,  1033,  1034,    -1,    -1,    -1,    -1,  4033,    -1,
      -1,   238,    -1,   240,  4039,  4040,  4041,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     477,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4081,   334,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,  1468,    -1,    -1,    -1,  4100,    -1,    -1,   305,    -1,
      -1,    -1,   309,    -1,    -1,    -1,    -1,    -1,   315,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   330,  4129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,  4139,    -1,    -1,    -1,    -1,    -1,
     347,    -1,    -1,    -1,    -1,  4150,  4151,    -1,  4153,    -1,
    4155,    -1,    -1,    -1,    -1,    -1,    -1,  4162,  4163,    -1,
      -1,    -1,  4167,  4168,    -1,    -1,    -1,    -1,  4173,  4174,
      -1,    -1,  4177,  1550,    -1,  4180,    -1,  4280,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,  4194,
      24,    -1,   399,  1570,    -1,    -1,   403,  4202,    -1,    -1,
      -1,  4206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1586,
      -1,    -1,    -1,  4218,    -1,    49,    -1,   424,  4223,    -1,
      -1,    -1,    -1,  4228,    -1,    -1,    -1,    -1,  4331,    -1,
      64,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,   453,  1624,  1625,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4262,  1635,    -1,
     467,    -1,    96,    -1,    -1,    -1,     8,  4370,    -1,    11,
    1647,  1648,    -1,    -1,    -1,  4280,    -1,    -1,    -1,    -1,
     114,    -1,    -1,    -1,  1661,    -1,    28,   121,    -1,    -1,
     124,  4296,    -1,    -1,    36,    -1,  4301,  4302,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,  4311,    -1,    -1,    -1,
      -1,    -1,  4317,    -1,    -1,    -1,    -1,  4322,    -1,    -1,
      -1,    -1,    -1,    -1,    66,  4428,  4331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,   175,    11,    -1,   178,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    4365,    -1,    31,    -1,    -1,  4370,    -1,    36,    -1,    -1,
      -1,    -1,  4377,    42,  1385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,   228,  4400,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,   240,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,
      -1,    -1,    -1,  4428,   258,    -1,    -1,   169,    -1,    -1,
      -1,   173,    -1,   267,   268,    -1,    -1,    -1,    -1,    -1,
    1817,    -1,  4447,  1454,  1455,  1456,  1457,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   301,    -1,   211,
     304,   305,   306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2310,    -1,    -1,  4488,  2314,  2315,    -1,    -1,  4591,  1500,
    1501,    -1,    -1,    -1,  4499,    -1,   330,  1508,   240,    -1,
     169,   243,    -1,    -1,   173,    -1,    -1,   341,    -1,    -1,
      -1,    -1,    -1,    -1,   256,    -1,    -1,   259,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,   370,    -1,  1549,    -1,
      -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,  4554,
      -1,    -1,    -1,    -1,   388,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1576,  1577,  1578,  1579,  4574,
      -1,   240,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4587,    -1,    -1,    -1,  4591,   256,    -1,    -1,
     259,    -1,   334,  4598,    -1,    -1,    -1,    -1,  2428,    -1,
      -1,   435,   436,    -1,  4707,  4610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4619,  4620,    -1,    -1,  4623,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1637,    -1,    -1,    -1,
      -1,  4636,    -1,  4736,    -1,  1646,    -1,  4642,    -1,    -1,
      -1,    -1,  4647,   477,  1655,  4650,    -1,    -1,    -1,    -1,
    4655,  4656,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   334,    -1,    -1,    -1,  4674,
      -1,  4676,    -1,    -1,    -1,  4680,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4704,
      -1,    -1,  4707,    -1,  4709,  4710,    -1,  4712,    -1,    -1,
      -1,    -1,    -1,  4718,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
    4755,   493,   494,   495,   496,   497,   498,    -1,    -1,  4764,
      -1,    -1,    -1,  2593,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4776,    -1,    -1,    -1,  4878,    -1,    -1,    -1,    -1,
    4883,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4803,    -1,
    4805,    -1,  4905,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,  4821,    -1,    -1,    42,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
      -1,  1842,    -1,    -1,    -1,    -1,    -1,   962,     8,    -1,
    4943,    11,  2672,    66,    -1,    -1,    -1,    -1,  2678,    -1,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    28,    -1,
      -1,    31,    19,    -1,    21,    -1,    36,    -1,    -1,    26,
      -1,    28,    42,  4878,    -1,    -1,  4881,    -1,  4883,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    66,  4902,    -1,  4904,
    4905,    -1,  4907,    -1,  4909,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5016,    -1,    -1,    -1,  5020,  5021,    -1,
      -1,    -1,    -1,    -1,  4929,    -1,    -1,    -1,    -1,  4934,
     153,    -1,    -1,  4938,  2764,    -1,    -1,    -1,  4943,    -1,
      -1,    -1,    -1,  4948,    -1,    -1,   169,  2324,    -1,    -1,
     173,  2328,  2329,    -1,    -1,  2332,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,  2354,  1103,    -1,
      -1,    -1,    -1,    -1,    -1,  4990,    -1,    -1,   211,    -1,
      -1,  4996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5016,    -1,    -1,    -1,  5020,  5021,   240,    -1,    -1,
     243,    -1,  2399,    -1,   194,   195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   256,    -1,    -1,   259,   194,    -1,    -1,
      -1,   211,  2419,  2420,    -1,    -1,    -1,    -1,   205,   206,
      -1,   208,    -1,    -1,   211,    -1,   213,    -1,    -1,    -1,
     217,  5066,  5165,  5166,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,    -1,   243,  2451,  2452,    -1,    -1,    -1,  2456,
    5085,    -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,   259,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5109,    -1,    -1,    -1,    -1,    -1,
      -1,   334,    -1,  2490,    -1,    -1,    -1,  2494,    -1,    -1,
      -1,  5126,    -1,    -1,  5129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2512,    -1,    -1,  5143,    -1,
    5145,    -1,  5147,    -1,    -1,    -1,  2523,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2536,
    5165,  5166,    -1,    -1,   334,    -1,  5171,    -1,    -1,    -1,
    2547,    -1,    -1,    -1,    -1,    -1,    -1,  2554,    -1,    -1,
      -1,    -1,    -1,    -1,  3014,  1310,    -1,  3017,    -1,  3019,
      -1,    -1,    -1,  5198,  3024,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5224,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2614,  5243,    -1,
      -1,    -1,    -1,    -1,  3074,  1370,    -1,    -1,    -1,    -1,
    5255,  5256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5265,    -1,    -1,    -1,    -1,  5270,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5290,  1411,    -1,    -1,    -1,
    3120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2682,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,    -1,    -1,    -1,  5339,     8,    -1,    -1,    11,  2716,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5356,    -1,    -1,    -1,    28,    -1,    -1,    31,  2370,
    2371,  2372,    -1,    36,    -1,    -1,    -1,  1492,  2379,    42,
    2381,    -1,  2383,  2384,    -1,  2752,     8,    -1,    -1,    11,
      18,  5386,  3212,    -1,  3214,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    28,    -1,  2775,    -1,
      -1,    -1,    -1,    -1,    36,  1530,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,
    1555,    -1,  5535,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,  5446,   599,    -1,    -1,    -1,  3276,    -1,    -1,  5454,
     607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   616,
     617,  5466,    -1,    -1,   621,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,
      -1,   638,    -1,   121,  2861,    -1,   124,    -1,    -1,    -1,
    3320,  2868,    -1,  1618,  2505,   652,   169,    -1,  5503,    -1,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   669,    -1,    -1,   672,    -1,   674,    -1,   676,
      -1,   194,   195,    -1,  3354,    -1,    -1,    -1,    -1,  5534,
    5535,  5536,    -1,    -1,    -1,    -1,    -1,   169,   211,    -1,
     178,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2569,   716,
      -1,    -1,   194,   195,    -1,    -1,  2577,   240,    -1,    -1,
     243,  2582,  5577,    -1,    -1,    -1,    -1,    -1,  2955,   211,
      -1,    -1,   739,   256,   741,  5590,   259,    -1,    -1,    -1,
     764,    -1,    -1,  3423,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,   240,    -1,    -1,    -1,    -1,    -1,   240,    -1,
      -1,   243,   250,    -1,  3444,    -1,    -1,    -1,    -1,    -1,
     258,   795,    -1,    -1,   256,    -1,  3456,   259,    -1,    -1,
     268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3026,
      -1,    -1,    -1,    -1,  2665,    -1,    -1,    -1,    -1,    -1,
      -1,   334,    -1,   301,  3041,  3042,   304,   305,    18,    -1,
      -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
    1805,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2699,    -1,
    2701,  3068,   330,    -1,  3071,    -1,    -1,  3527,    -1,   856,
      -1,    -1,   334,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    -1,  3547,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3575,    -1,    -1,    -1,    -1,
     388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   915,    -1,
     917,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,
      -1,   121,    -1,    -1,   124,   932,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2796,    -1,  3617,   945,    -1,
      -1,    -1,  3169,  3170,  3171,   952,    18,   435,   436,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,   964,    -1,    -1,
     967,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,  3203,    -1,   178,    -1,
      -1,    -1,    -1,    -1,    -1,   992,    -1,    -1,  3215,   477,
      -1,    -1,    64,    -1,    -1,    -1,    -1,  1004,    -1,  3226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    18,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,  3706,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
     240,    -1,   114,    -1,    -1,  1052,    -1,    -1,    -1,   121,
     250,    -1,   124,    -1,    -1,    -1,    -1,    -1,   258,    -1,
      -1,    -1,    -1,    64,    -1,  1072,    -1,  1074,   268,  1076,
      -1,  1078,    -1,  1080,  1081,  1082,    -1,    -1,    -1,    -1,
    1087,    -1,    -1,    -1,    -1,    -1,    21,  3314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,
      -1,   301,    -1,    -1,   304,   305,   178,    -1,    -1,  1133,
      -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,    -1,    54,
     121,    -1,    -1,   124,    -1,    -1,  3353,    -1,    -1,    -1,
     330,    -1,    67,    -1,    -1,    -1,    -1,  3817,  1162,    -1,
      -1,  3368,    -1,  3370,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3385,    -1,
    3387,    -1,    -1,    98,    -1,    -1,   238,    -1,   240,    -1,
     370,  1195,  1196,    -1,  1198,    -1,    -1,   178,   250,    -1,
      -1,    -1,    -1,    -1,   119,    -1,   258,    -1,   388,    -1,
      -1,    -1,    -1,  1217,    -1,   130,   268,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,  3443,    -1,    -1,  3080,
     155,  3082,  3083,  3084,    -1,    -1,   161,    -1,    -1,   301,
      -1,    -1,   304,   305,  1258,   435,   436,   238,    -1,   240,
      -1,   176,    -1,    -1,    -1,  3472,    -1,    -1,    -1,   250,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,   330,  3486,
      -1,    -1,    -1,    -1,    -1,    -1,  1290,   268,    -1,  1276,
    1294,  1295,    -1,    -1,    -1,    -1,  3503,   477,    -1,  3506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,
     301,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   388,  3997,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,   267,    -1,    -1,  2310,  1343,    -1,    -1,  2314,
    2315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,    -1,    -1,  4033,    -1,    -1,    -1,    -1,    -1,  4039,
    3587,    -1,    -1,   435,   436,    -1,    -1,    -1,    -1,   370,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,
      -1,   316,    -1,   318,    -1,    -1,    -1,   388,    -1,   324,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   367,    -1,   435,   436,    -1,   372,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,   384,
      -1,    -1,    -1,  2428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4153,    -1,    -1,   477,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4168,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,    -1,  3753,    -1,   463,    -1,
      -1,    -1,    -1,    -1,    -1,   470,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1559,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,    -1,  1574,    -1,    -1,
      -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,   155,   962,
      -1,    -1,    -1,  3810,    -1,    -1,    -1,    -1,    -1,  3816,
      -1,  3818,    -1,    -1,    -1,    -1,    -1,    -1,  1605,   176,
    4280,    -1,    -1,    -1,    -1,  3466,    -1,    -1,  3469,    -1,
      -1,    -1,    -1,    -1,  1621,    -1,    -1,    -1,  2593,    -1,
      -1,    -1,    -1,    -1,   201,    -1,    -1,  3854,    -1,  1636,
      -1,  1638,    -1,  1640,    -1,    -1,    -1,    -1,  1645,    -1,
      -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,  3876,
      -1,  4331,  3879,  3514,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1670,    -1,  1672,    -1,  1674,    -1,  1676,
      -1,  1678,    -1,    -1,    -1,  1682,    -1,    -1,    -1,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4370,    -1,    -1,    -1,    -1,    -1,    -1,  2672,  3925,    -1,
      -1,    -1,    -1,  2678,    -1,    -1,    -1,    -1,   285,    -1,
      -1,    -1,    -1,    -1,  1738,    -1,    -1,    -1,    -1,    -1,
    1103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,   962,  1761,    -1,   316,
    1764,   318,    -1,  1767,    -1,    -1,    -1,   324,  4428,    -1,
     327,  1775,  1776,    -1,    -1,    -1,  1780,  1781,    -1,    -1,
    1784,    -1,  1786,    -1,    -1,  1789,  3993,  3994,    -1,    -1,
      -1,    -1,    -1,  4000,    -1,    -1,   353,    -1,   355,    -1,
      -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,    -1,  2764,
     367,    -1,  1816,    -1,    -1,   372,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4081,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1897,    -1,    -1,    -1,  1103,    -1,    -1,
      -1,    -1,    -1,  3744,  3745,  3746,  3747,    -1,    -1,    -1,
      -1,    -1,    -1,   470,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4591,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1961,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3861,  3862,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4707,  1411,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3014,
      -1,    -1,  3017,    -1,  3019,    -1,    -1,    -1,    -1,  3024,
      -1,    -1,    -1,    -1,    -1,    -1,  4736,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4296,
      -1,    -1,    -1,    -1,    -1,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  1310,  2109,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4322,  2120,  2121,    -1,  3074,
      -1,    -1,    -1,    -1,    -1,  3966,    -1,    -1,    -1,  1492,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4365,    -1,
      -1,    -1,    -1,    -1,  1370,  3120,    -1,  1530,    -1,    -1,
    4377,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1555,  4400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1411,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4878,    -1,
      -1,    -1,    -1,  4883,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4447,    -1,    -1,    -1,    -1,  4905,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2257,    -1,  1618,    -1,  3212,    -1,  3214,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2283,
    2284,    -1,    -1,  4943,    -1,    -1,  1492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3276,    -1,    -1,  1530,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2325,  2326,
      -1,    -1,    -1,  2330,  2331,    -1,    -1,  2334,    -1,  1555,
      -1,    -1,    -1,  2357,    -1,    -1,  5016,  2344,    -1,    -1,
    5020,  5021,    -1,    -1,  2351,  3320,    -1,  4574,  2355,  2356,
      -1,    -1,  2359,  2360,    -1,    -1,    -1,    -1,    -1,  2366,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2378,    -1,  2380,    -1,    -1,    -1,    -1,    -1,  3354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1618,  2400,    -1,    -1,    -1,    -1,  2405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2421,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1805,  2430,    -1,    -1,    -1,    -1,  2435,  2436,
    2437,  2438,    -1,    -1,    -1,    -1,    -1,    -1,  2445,  2446,
      -1,    -1,    -1,    -1,    -1,    -1,  2453,  4674,  3423,  4676,
      -1,  2458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3444,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3456,  4343,    -1,    -1,  5165,  5166,    -1,  2495,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2506,
      -1,  2508,    -1,    -1,    -1,    -1,  2513,    -1,    -1,    -1,
    2517,    -1,  2519,  2520,  2521,  2522,    -1,  2524,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4755,    -1,
    2537,  2538,    -1,  2540,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2551,  2552,  2553,    -1,  4409,  4776,
      -1,    -1,  3527,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4423,    -1,    -1,    -1,    -1,  2591,    -1,    -1,
      -1,    -1,  3547,    -1,    -1,    -1,  4803,    -1,  4805,  1805,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2615,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4525,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2721,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2770,    -1,    -1,    -1,    -1,    -1,  4996,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2804,    -1,    -1,    -1,    -1,  2809,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4682,  4683,  4684,    -1,    -1,    -1,    -1,    -1,  2853,
      -1,  2855,  2856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3817,  2867,    -1,    -1,  2870,    -1,    -1,    -1,
      -1,    -1,  2876,    -1,    -1,  5535,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4739,  2903,
      -1,  2905,    -1,    -1,    -1,  2909,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2941,  2942,  2943,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2310,    -1,    -1,
      -1,  2314,  2315,    -1,  2958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2972,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2968,    -1,  2987,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1211,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4880,
    3027,  3028,  3997,  3047,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5270,    -1,  2428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1272,    -1,    -1,  4033,    -1,
      -1,    -1,  3069,    -1,  4039,    -1,    -1,    -1,    -1,    -1,
      -1,  3078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2310,    -1,  3093,  3094,  2314,  2315,
      -1,  3098,    -1,    -1,    -1,    -1,  3103,  3104,  3105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3160,  3161,  3162,  3163,    -1,    -1,  5386,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5031,    -1,  5033,    -1,    -1,    -1,    -1,    -1,  4153,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4168,    -1,    -1,    -1,  3204,    -1,  3206,
    3207,  3208,  2428,    -1,    -1,    -1,    -1,    -1,    -1,  3216,
    2593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5446,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3289,    -1,    -1,    -1,    -1,    -1,    -1,  2672,
      -1,    -1,    -1,    -1,  5155,  2678,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4280,    -1,  5534,  3315,  5536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5577,    -1,    -1,    -1,    -1,    -1,  4331,    -1,  5219,    -1,
      -1,    -1,  3369,  5590,    -1,    -1,    -1,  2593,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2764,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4370,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3414,    -1,    -1,
      -1,    -1,  3419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5299,    -1,
    1657,    -1,    -1,    -1,    -1,    -1,  2672,    -1,    -1,    -1,
    3457,    -1,  2678,  4428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3471,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3524,    -1,    -1,    -1,    -1,  5366,    -1,    -1,    -1,    -1,
    3534,    -1,    -1,    -1,    -1,    -1,  3540,    -1,  3542,  1736,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2764,    -1,
    3564,  3565,    -1,  1760,    -1,    -1,    -1,    -1,  1765,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3584,    -1,    -1,    -1,    -1,  3589,    -1,    -1,    -1,    -1,
    3594,    -1,    -1,  1790,  1791,    -1,    -1,  1794,    -1,    -1,
    3604,    -1,    -1,  3607,    -1,  3609,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3618,    -1,    -1,    -1,    -1,    -1,
    3624,    -1,    -1,  3627,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4591,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3014,  3656,    -1,  3017,    -1,  3019,    -1,  3662,  3663,
      -1,  3024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3688,    -1,    -1,    -1,    -1,    -1,
    3694,    -1,    -1,    -1,    -1,    -1,  3700,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3729,    -1,  3731,    -1,    -1,    -1,    -1,    -1,
      -1,  3738,  4707,    -1,    -1,    -1,    -1,  3120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3754,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4736,    -1,  3770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3783,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3014,  3796,
      -1,  3017,    -1,  3019,    -1,    -1,    -1,    -1,  3024,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3814,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3212,
      -1,  3214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3074,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3863,  3864,  3865,    -1,
      -1,  3868,  3869,  3870,  3871,  3872,    -1,    -1,    -1,    -1,
    3877,  3878,    -1,  3880,  3881,  3882,  3883,  3884,  3885,  3886,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3895,    -1,
      -1,  3898,  3899,  3276,  3120,    -1,    -1,    -1,    -1,    -1,
    2117,    -1,    -1,  4878,    -1,    -1,    -1,    -1,  4883,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4905,    -1,    -1,    -1,    -1,    -1,  2153,  3320,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3962,  3963,  3964,    -1,    -1,
    3967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4943,    -1,
      -1,  3354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3212,    -1,  3214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4040,  4041,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3423,  5016,    -1,    -1,    -1,  5020,  5021,    -1,    -1,  4056,
    3276,    -1,    -1,  2270,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3444,    -1,    -1,    -1,  2282,    -1,    -1,    -1,    -1,
    2287,    -1,    -1,  3456,    -1,    -1,  4100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3320,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4150,  4151,  3354,    -1,
      -1,  4155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4167,  3527,    -1,    -1,    -1,    -1,  4173,
    4174,    -1,    -1,  4177,    -1,    -1,  4180,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3547,    -1,    -1,    -1,    -1,    -1,
    4194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5165,  5166,  3575,    -1,  4218,    -1,    -1,  3423,    -1,  4223,
      -1,    -1,    -1,    -1,  4228,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3444,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3456,    -1,    -1,    -1,  3617,    -1,    -1,    -1,  4262,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4291,  4292,  4293,  4294,    -1,    -1,
    4297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3527,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3547,    -1,  3706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3575,
      -1,    -1,    -1,    -1,  4361,  4362,  4363,  4364,    -1,  4366,
    4367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4378,  4379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3617,    -1,    -1,  4401,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3817,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4488,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4508,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4565,    -1,
    5535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4610,    -1,    -1,    -1,
    2807,  3817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4623,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2830,  3997,  2832,    -1,  2834,  2835,  2836,
      -1,    -1,  2839,    -1,    -1,    -1,  2843,    -1,    -1,    -1,
      -1,  4655,  4656,    -1,    -1,  2852,    -1,    -1,    -1,    -1,
    2857,    -1,    -1,    -1,    -1,  2862,    -1,  2864,    -1,    -1,
    4033,    -1,  2869,    -1,  2871,    -1,  4039,  2874,  4665,    -1,
      -1,    -1,    -1,    -1,    -1,  2882,    -1,    -1,    -1,  2886,
    2887,    -1,  2889,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2901,    -1,  4710,    -1,  4712,    -1,
      -1,  2908,    -1,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,  2919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4756,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4153,  3997,    -1,    -1,    -1,    -1,  4783,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4033,    -1,    -1,
      -1,    -1,    -1,  4039,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4902,    -1,
      -1,    -1,  4889,  4907,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4280,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4929,    -1,    -1,    -1,    -1,
    4934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4948,    -1,    -1,  4153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,  4331,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5015,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4428,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4280,    -1,    -1,    -1,    -1,    -1,
      -1,  5085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5126,    -1,    -1,  4331,  5113,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3339,  5147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4370,    -1,    -1,  5171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4428,    -1,    -1,    -1,  5213,    -1,  4591,    -1,
      -1,  5218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5255,  5256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3475,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3522,    -1,    -1,    -1,    -1,
      -1,    -1,  3529,    -1,    -1,  5339,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4707,    -1,    -1,    -1,  3545,  3546,
      -1,  3548,  5356,    -1,  3551,  3552,  3553,  3554,  3555,  3556,
    3557,  3558,  3559,  3560,  3561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4736,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4591,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3590,    -1,    -1,  3593,    -1,    -1,    -1,
      -1,    -1,    -1,  3600,    -1,    -1,    -1,    -1,  3605,  3606,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3619,  3620,  3621,    -1,  3623,    -1,    -1,  3626,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3670,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4878,    -1,    -1,    -1,    -1,
    4883,    -1,  3719,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5016,    -1,    -1,    -1,  5020,  5021,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4878,    -1,    -1,    -1,    -1,  4883,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4905,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4943,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5165,  5166,    -1,    -1,    -1,    -1,    -1,    -1,
    5016,    -1,    -1,    -1,  5020,  5021,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,  4105,  4106,
    4107,    -1,    -1,  4110,    -1,    -1,    -1,    -1,  4115,  4116,
    4117,  4118,  4119,  4120,  4121,  4122,  4123,  4124,  4125,  4126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4140,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4154,    -1,  5165,
    5166,    -1,    -1,    -1,  4161,  4162,  4163,  4164,    -1,  4166,
      -1,    -1,    -1,  4170,  4171,  4172,    -1,    -1,  4175,    -1,
      -1,  4178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4220,    -1,    -1,    -1,    -1,    -1,    -1,
    4227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4491,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5535,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4551,  4552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4583,    -1,    -1,    -1,
    4587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4603,    -1,  4605,    -1,
      -1,    -1,    -1,    -1,  4611,    -1,    -1,  4614,  4615,  4616,
      -1,    -1,  4619,  4620,  4621,  4622,    -1,  4624,    -1,    -1,
    4627,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4903,  4904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4918,    -1,  4920,  4921,  4922,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4951,  4952,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5117,  5118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5132,    -1,    -1,  5135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5223,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5342,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5419,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,   503,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,   116,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,   495,    -1,    -1,    -1,    -1,    -1,
      -1,   502,   503,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,   503,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,    -1,    -1,   256,   257,   258,
      -1,    -1,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,   395,   396,   397,   398,
     399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,     3,    -1,    -1,    -1,
      -1,    -1,    -1,   502,   503,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
      -1,    -1,   149,    -1,   151,    -1,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,    -1,   241,   242,    -1,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,    -1,    -1,   256,
     257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,
     267,   268,   269,   270,    -1,   272,   273,    -1,   275,   276,
      -1,   278,   279,   280,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,    -1,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,   386,
     387,   388,   389,   390,   391,   392,    -1,   394,    -1,   396,
     397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   503,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,    -1,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
      -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,    -1,    -1,   241,   242,   243,   244,    -1,    -1,
     247,   248,   249,   250,   251,    -1,   253,    -1,    -1,   256,
     257,   258,    -1,    -1,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,    -1,   272,   273,    -1,   275,    -1,
      -1,    -1,   279,   280,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,    -1,    -1,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,    -1,   365,    -1,
     367,    -1,    -1,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,    -1,    -1,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,    -1,   472,    -1,   474,   475,     3,
     477,   478,   479,   480,   481,   482,   483,   484,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,   503,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,    -1,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,    -1,    -1,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,    -1,   367,    -1,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,   472,    -1,
     474,   475,    -1,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,   503,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,    -1,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,    -1,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,    -1,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,    -1,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,   472,   473,
     474,   475,    -1,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,   206,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,   500,   501,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,   495,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
     494,    -1,    -1,     3,     4,     5,     6,     7,   502,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,    -1,    -1,     3,     4,     5,
       6,     7,   502,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,     9,    10,    -1,    -1,   502,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
      -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,    -1,   253,    -1,    -1,   256,
     257,   258,    -1,    -1,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,    -1,   275,   276,
      -1,   278,   279,   280,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,    -1,   394,   395,   396,
     397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,   502,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,   493,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,    -1,   255,   256,   257,   258,
      -1,    -1,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,   395,   396,   397,   398,
     399,    -1,    -1,   402,    -1,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,   255,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,    -1,   394,   395,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,    -1,     9,    -1,    -1,    -1,
     502,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,    -1,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,    -1,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,    -1,
     253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,    -1,   275,   276,    -1,   278,   279,   280,   281,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,   354,   355,   356,   357,   358,   359,    -1,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,    -1,   386,   387,   388,   389,   390,   391,   392,
      -1,   394,   395,   396,   397,   398,   399,    -1,    -1,   402,
      -1,    -1,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   494,     3,     4,     5,     6,     7,    -1,     9,   502,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,   386,   387,   388,   389,   390,
     391,   392,    -1,   394,   395,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   494,     3,     4,     5,     6,     7,    -1,
       9,   502,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,    -1,   253,    -1,    -1,   256,   257,   258,
      -1,    -1,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,   395,   396,   397,   398,
     399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   494,     3,     4,     5,    -1,
      -1,    -1,     9,   502,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
      -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,   254,    -1,   256,
     257,   258,    -1,    -1,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,    -1,   275,   276,
      -1,   278,   279,   280,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,   386,
     387,   388,   389,   390,   391,   392,    -1,   394,   395,   396,
     397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,   493,   494,   495,    -1,
      -1,    -1,    -1,    -1,    -1,   502,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,    -1,    -1,   256,   257,   258,
      -1,    -1,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,   395,   396,   397,   398,
     399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,    -1,   255,   256,   257,   258,    -1,    -1,
     261,   262,    -1,   264,    -1,   266,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,   386,   387,   388,   389,   390,
     391,   392,    -1,   394,    -1,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,    -1,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
     253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,
      -1,   264,    -1,   266,   267,   268,   269,   270,    -1,   272,
     273,    -1,   275,   276,    -1,   278,   279,   280,   281,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,    -1,   335,   336,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,   354,   355,   356,   357,   358,   359,    -1,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,    -1,   386,   387,   388,   389,   390,   391,   392,
      -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,   402,
      -1,    -1,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,    -1,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
      -1,   246,   247,   248,   249,   250,   251,    -1,   253,    -1,
      -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,   264,
      -1,   266,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,   276,    -1,   278,   279,   280,   281,    -1,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,    -1,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
      -1,   386,   387,   388,   389,   390,   391,   392,    -1,   394,
      -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    -1,    -1,    -1,   502,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
      -1,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,    -1,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,   472,   473,   474,   475,
      -1,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    -1,    -1,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,     3,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    -1,    -1,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    -1,    -1,    -1,
      28,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    -1,    56,    -1,
      -1,    59,    -1,    61,    62,    63,    64,    65,    66,    -1,
      -1,    69,    -1,    71,    72,    73,    -1,    -1,    76,    -1,
      78,    79,    -1,    81,    82,    83,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    -1,
      98,    -1,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,    -1,   114,    -1,    -1,    -1,
      -1,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,    -1,    -1,   133,   134,   135,   136,   137,
      -1,   139,   140,    -1,    -1,    -1,    -1,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,    -1,   155,    -1,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,    -1,    -1,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,    -1,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,    -1,
     198,    -1,   200,   201,   202,    -1,    -1,    -1,    -1,    -1,
     208,    -1,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,    -1,    -1,   253,    -1,    -1,   256,   257,
     258,   259,    -1,    -1,   262,   263,    -1,    -1,   266,   267,
     268,    -1,   270,    -1,    -1,   273,    -1,    -1,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,    -1,    -1,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,    -1,   324,    -1,   326,    -1,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,    -1,
      -1,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,    -1,    -1,   375,   376,    -1,
      -1,   379,   380,    -1,   382,   383,    -1,    -1,   386,   387,
      -1,   389,   390,   391,   392,    -1,    -1,   395,   396,   397,
      -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   422,   423,   424,   425,   426,   427,
     428,    -1,    -1,    -1,    -1,   433,   434,   435,    -1,   437,
     438,   439,    -1,   441,   442,   443,   444,    -1,   446,    -1,
     448,   449,   450,    -1,   452,   453,   454,    -1,   456,    -1,
     458,   459,   460,   461,   462,   463,   464,    -1,    -1,    -1,
      -1,    -1,   470,   471,    -1,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,
       3,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   495,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,    -1,   246,   247,   248,   249,   250,
     251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
     261,   262,    -1,   264,    -1,   266,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,    -1,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,   386,   387,   388,   389,   390,
     391,   392,    -1,   394,    -1,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   495,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      69,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,   238,
     239,    -1,   241,   242,    -1,   244,    -1,   246,   247,   248,
     249,   250,   251,    -1,   253,    -1,    -1,   256,   257,   258,
      -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,    -1,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,    -1,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,    -1,   396,   397,   398,
     399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   495,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,    -1,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
      -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,    -1,   236,
     237,   238,   239,    -1,   241,   242,    -1,   244,    -1,   246,
     247,   248,   249,   250,   251,    -1,   253,    -1,    -1,   256,
     257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,
     267,   268,   269,   270,    -1,   272,   273,    -1,   275,   276,
      -1,   278,   279,   280,   281,    -1,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,    -1,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,    -1,   335,   336,
     337,    -1,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,    -1,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,    -1,   375,   376,
      -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,   386,
     387,   388,   389,   390,   391,   392,    -1,   394,    -1,   396,
     397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,    -1,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,    -1,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,
     145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    -1,    -1,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,    -1,
      -1,   256,   257,   258,    -1,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,    -1,    -1,   279,   280,   281,    -1,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,    -1,    -1,
     365,    -1,   367,    -1,    -1,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,    -1,   472,    -1,   474,
     475,     3,   477,   478,   479,   480,   481,   482,   483,   484,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
     495,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,    -1,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,    -1,    -1,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,    -1,   367,    -1,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
     472,    -1,   474,   475,    -1,   477,   478,   479,   480,   481,
     482,   483,   484,     3,     4,     5,     6,     7,    -1,     9,
      -1,    -1,    -1,   495,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,     4,     5,    -1,    -1,
      -1,     9,    -1,    -1,   494,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,   254,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,     4,     5,
      -1,    -1,    -1,     9,    -1,   493,   494,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,    -1,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,   493,   494,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
     254,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,     9,    -1,   493,
     494,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,   153,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,     4,     5,    -1,    -1,    -1,     9,
      -1,   493,   494,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,   254,    -1,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    -1,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,    -1,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,   395,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    -1,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,   150,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
     378,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,   150,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,   150,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,   378,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,   150,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,   255,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,   255,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,   255,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,   385,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,    -1,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,    -1,
     264,    -1,   266,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,   391,   392,    -1,
     394,    -1,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
     262,    -1,   264,    -1,   266,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,   391,
     392,    -1,   394,    -1,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,   251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,   261,   262,    -1,   264,    -1,   266,   267,   268,   269,
     270,    -1,   272,   273,    -1,   275,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,   337,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,    -1,   375,   376,    -1,    -1,   379,
     380,   381,   382,   383,    -1,    -1,   386,   387,   388,   389,
     390,   391,   392,    -1,   394,    -1,   396,   397,   398,   399,
      -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,    -1,
     430,    -1,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    69,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,   237,
     238,   239,    -1,   241,   242,    -1,   244,    -1,   246,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,   262,    -1,   264,    -1,   266,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,   276,    -1,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,    -1,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,   391,   392,    -1,   394,    -1,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,   391,   392,    -1,   394,    -1,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
     134,   135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,
     144,   145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,    -1,    -1,   241,   242,   243,
     244,    -1,    -1,   247,   248,   249,   250,   251,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,    -1,   272,   273,
      -1,   275,    -1,    -1,    -1,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,    -1,    -1,   351,   352,    -1,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
      -1,   365,    -1,   367,    -1,    -1,   370,   371,   372,   373,
      -1,   375,   376,    -1,    -1,   379,   380,   381,   382,   383,
      -1,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,    -1,   402,    -1,
      -1,   405,   406,   407,   408,   409,   410,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,
     424,   425,   426,   427,   428,    -1,   430,    -1,   432,   433,
     434,   435,   436,   437,   438,   439,   440,    -1,    -1,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,   472,    -1,
     474,   475,     3,   477,   478,   479,   480,   481,   482,   483,
     484,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,    -1,   133,   134,   135,    -1,   137,   138,   139,    -1,
      -1,   142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,    -1,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,    -1,    -1,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,   250,
     251,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
     261,    -1,   263,   264,   265,    -1,   267,   268,   269,   270,
      -1,   272,   273,    -1,   275,    -1,    -1,    -1,   279,   280,
     281,    -1,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,    -1,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,    -1,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,    -1,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,    -1,   365,    -1,   367,    -1,    -1,   370,
     371,   372,   373,    -1,   375,   376,    -1,    -1,   379,   380,
     381,   382,   383,    -1,    -1,   386,   387,   388,   389,   390,
      -1,   392,    -1,   394,   395,   396,   397,   398,   399,    -1,
      -1,   402,    -1,    -1,   405,   406,   407,   408,   409,   410,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,
     421,   422,   423,   424,   425,   426,   427,   428,    -1,   430,
      -1,   432,   433,   434,   435,   436,   437,   438,   439,   440,
      -1,    -1,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
      -1,   472,    -1,   474,   475,     3,   477,   478,   479,   480,
     481,   482,   483,   484,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,   134,   135,    -1,   137,
     138,   139,    -1,    -1,   142,    -1,   144,   145,   146,    -1,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,   241,   242,   243,   244,    -1,    -1,   247,
     248,   249,   250,   251,    -1,   253,    -1,    -1,   256,   257,
     258,    -1,    -1,   261,    -1,   263,   264,   265,    -1,   267,
     268,   269,   270,    -1,   272,   273,    -1,   275,    -1,    -1,
      -1,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,    -1,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,    -1,   365,    -1,   367,
      -1,    -1,   370,   371,   372,   373,    -1,   375,   376,    -1,
      -1,   379,   380,   381,   382,   383,    -1,    -1,   386,   387,
     388,   389,   390,    -1,   392,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,   421,   422,   423,   424,   425,   426,   427,
     428,    -1,   430,    -1,   432,   433,   434,   435,   436,   437,
     438,   439,   440,    -1,    -1,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,   472,    -1,   474,   475,     3,   477,
     478,   479,   480,   481,   482,   483,   484,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,    -1,   133,   134,
     135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,
     145,   146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,    -1,   241,   242,   243,   244,
      -1,    -1,   247,   248,   249,   250,   251,    -1,   253,    -1,
      -1,   256,   257,   258,    -1,    -1,   261,    -1,   263,   264,
     265,    -1,   267,   268,   269,   270,    -1,   272,   273,    -1,
     275,    -1,    -1,    -1,   279,   280,   281,    -1,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,    -1,   309,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,    -1,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    -1,    -1,   351,   352,    -1,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,    -1,    -1,
     365,    -1,   367,    -1,    -1,   370,   371,   372,   373,    -1,
     375,   376,    -1,    -1,   379,   380,   381,   382,   383,    -1,
      -1,   386,   387,   388,   389,   390,    -1,   392,    -1,   394,
     395,   396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,
     405,   406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,    -1,   432,   433,   434,
     435,   436,   437,   438,   439,   440,    -1,    -1,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,    -1,   472,    -1,   474,
     475,     3,   477,   478,   479,   480,   481,   482,   483,   484,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,   134,   135,    -1,   137,   138,   139,    -1,    -1,
     142,    -1,   144,   145,   146,    -1,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,    -1,    -1,   241,
     242,   243,   244,    -1,    -1,   247,   248,   249,   250,   251,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,
      -1,   263,   264,   265,    -1,   267,   268,   269,   270,    -1,
     272,   273,    -1,   275,    -1,    -1,    -1,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,    -1,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    -1,    -1,   351,
     352,    -1,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,    -1,   365,    -1,   367,    -1,    -1,   370,   371,
     372,   373,    -1,   375,   376,    -1,    -1,   379,   380,   381,
     382,   383,    -1,    -1,   386,   387,   388,   389,   390,    -1,
     392,    -1,   394,   395,   396,   397,   398,   399,    -1,    -1,
     402,    -1,    -1,   405,   406,   407,   408,   409,   410,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,
     422,   423,   424,   425,   426,   427,   428,    -1,   430,    -1,
     432,   433,   434,   435,   436,   437,   438,   439,   440,    -1,
      -1,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
     472,    -1,   474,   475,     3,   477,   478,   479,   480,   481,
     482,   483,   484,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,    -1,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,   146,    -1,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
      -1,    -1,   241,   242,   243,   244,    -1,    -1,   247,   248,
     249,   250,   251,    -1,   253,    -1,    -1,   256,   257,   258,
      -1,    -1,   261,    -1,   263,   264,   265,    -1,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,    -1,    -1,    -1,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,    -1,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,    -1,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
      -1,    -1,   351,   352,    -1,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,    -1,   365,    -1,   367,    -1,
      -1,   370,   371,   372,   373,    -1,   375,   376,    -1,    -1,
     379,   380,   381,   382,   383,    -1,    -1,   386,   387,   388,
     389,   390,    -1,   392,    -1,   394,   395,   396,   397,   398,
     399,    -1,    -1,   402,    -1,    -1,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   420,   421,   422,   423,   424,   425,   426,   427,   428,
      -1,   430,    -1,   432,   433,   434,   435,   436,   437,   438,
     439,   440,    -1,    -1,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,    -1,   472,    -1,   474,   475,     3,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,   134,   135,
      -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,    -1,   241,   242,   243,   244,    -1,
      -1,   247,   248,   249,   250,   251,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,   261,    -1,   263,   264,   265,
      -1,   267,   268,   269,   270,    -1,   272,   273,    -1,   275,
      -1,    -1,    -1,   279,   280,   281,    -1,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,   309,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,    -1,   330,    -1,   332,   333,   334,   335,
     336,   337,    -1,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,    -1,    -1,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,    -1,   365,
      -1,   367,    -1,    -1,   370,   371,   372,   373,    -1,   375,
     376,    -1,    -1,   379,   380,   381,   382,   383,    -1,    -1,
     386,   387,   388,   389,   390,    -1,   392,    -1,   394,   395,
     396,   397,   398,   399,    -1,    -1,   402,    -1,    -1,   405,
     406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   420,   421,   422,   423,   424,   425,
     426,   427,   428,    -1,   430,    -1,   432,   433,   434,   435,
     436,   437,   438,   439,   440,    -1,    -1,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,   472,    -1,   474,   475,
       3,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      -1,    44,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    -1,    -1,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,    -1,    -1,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,    -1,
     133,   134,   135,    -1,   137,   138,   139,    -1,    -1,   142,
      -1,   144,   145,    -1,    -1,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,   187,    -1,    -1,    -1,    -1,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,   235,    -1,   237,   238,    -1,    -1,   241,   242,
     243,   244,    -1,    -1,   247,    -1,   249,   250,   251,    -1,
     253,    -1,    -1,   256,   257,   258,    -1,    -1,   261,    -1,
     263,   264,   265,    -1,   267,   268,   269,   270,    -1,   272,
     273,    -1,   275,    -1,    -1,    -1,   279,   280,   281,    -1,
     283,   284,   285,   286,   287,   288,   289,   290,    -1,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,    -1,   309,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
      -1,   324,   325,   326,   327,   328,    -1,   330,    -1,   332,
     333,   334,   335,    -1,   337,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,    -1,    -1,   351,   352,
      -1,   354,   355,   356,   357,   358,   359,    -1,    -1,    -1,
      -1,    -1,   365,    -1,   367,    -1,    -1,   370,   371,   372,
     373,    -1,   375,   376,    -1,    -1,   379,   380,   381,   382,
     383,    -1,    -1,   386,   387,   388,   389,   390,    -1,    -1,
      -1,   394,   395,   396,   397,   398,   399,    -1,    -1,   402,
      -1,    -1,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,    -1,   432,
     433,   434,   435,   436,   437,   438,   439,   440,    -1,    -1,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,    -1,   472,
      -1,   474,   475,     3,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    14,    15,    16,    17,    -1,    19,
      20,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    -1,    -1,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    -1,    -1,    59,
      -1,    61,    62,    63,    64,    65,    -1,    -1,    -1,    69,
      -1,    71,    72,    73,    -1,    -1,    76,    -1,    78,    79,
      -1,    81,    82,    83,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    -1,    98,    -1,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,    -1,   114,    -1,    -1,    -1,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,   133,   134,   135,   136,   137,    -1,   139,
     140,    -1,    -1,    -1,    -1,   145,   146,    -1,   148,   149,
      -1,   151,   152,    -1,    -1,   155,    -1,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,    -1,    -1,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,    -1,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,    -1,
     200,   201,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
      -1,   241,   242,    -1,   244,    -1,   246,   247,   248,   249,
     250,    -1,    -1,   253,    -1,    -1,   256,   257,   258,    -1,
      -1,    -1,   262,   263,    -1,    -1,   266,   267,   268,    -1,
     270,    -1,    -1,   273,    -1,    -1,   276,    -1,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,    -1,    -1,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,    -1,   324,    -1,   326,    -1,   328,    -1,
     330,   331,   332,   333,    -1,   335,   336,    -1,    -1,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
      -1,   351,   352,    -1,    -1,    -1,   356,   357,   358,    -1,
      -1,   361,   362,    -1,    -1,   365,   366,   367,   368,    -1,
     370,   371,   372,    -1,    -1,   375,   376,    -1,    -1,   379,
     380,    -1,   382,   383,    -1,    -1,   386,   387,    -1,   389,
     390,   391,   392,    -1,    -1,   395,   396,   397,    -1,   399,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   422,   423,   424,   425,   426,   427,   428,    -1,
      -1,    -1,    -1,   433,   434,   435,    -1,   437,   438,   439,
      -1,   441,   442,   443,   444,    -1,   446,    -1,   448,   449,
     450,    -1,   452,   453,   454,    -1,   456,    -1,   458,   459,
     460,   461,   462,   463,   464,    -1,    -1,    -1,    -1,    -1,
     470,   471,     3,    -1,   474,   475,   476,   477,   478,   479,
     480,   481,    -1,    14,    15,    16,    17,    -1,    19,    20,
      21,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    -1,    -1,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    -1,    56,    -1,    -1,    59,    -1,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    69,    -1,
      71,    72,    73,    -1,    -1,    76,    -1,    78,    79,    -1,
      81,    82,    83,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    -1,    98,    -1,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
      -1,    -1,   133,   134,   135,   136,   137,    -1,   139,   140,
      -1,    -1,    -1,    -1,   145,   146,    -1,   148,   149,    -1,
     151,   152,    -1,    -1,   155,    -1,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,    -1,    -1,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
      -1,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,    -1,   200,
     201,   202,    -1,    -1,    -1,    -1,    -1,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,    -1,   246,   247,   248,   249,   250,
      -1,    -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,
      -1,   262,   263,    -1,    -1,   266,   267,   268,    -1,   270,
      -1,    -1,   273,    -1,    -1,   276,    -1,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,    -1,    -1,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,    -1,   324,    -1,   326,    -1,   328,    -1,   330,
     331,   332,   333,    -1,   335,   336,    -1,    -1,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,    -1,
     351,   352,    -1,    -1,    -1,   356,   357,   358,    -1,    -1,
     361,   362,    -1,    -1,   365,   366,   367,   368,    -1,   370,
     371,   372,    -1,    -1,   375,   376,    -1,    -1,   379,   380,
      -1,   382,   383,    -1,    -1,   386,   387,    -1,   389,   390,
     391,   392,    -1,    -1,   395,   396,   397,    -1,   399,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   422,   423,   424,   425,   426,   427,   428,    -1,    -1,
      -1,    -1,   433,   434,   435,    -1,   437,   438,   439,    -1,
     441,   442,   443,   444,    -1,   446,    -1,   448,   449,   450,
      -1,   452,   453,   454,    -1,   456,    -1,   458,   459,   460,
     461,   462,   463,   464,    -1,    -1,    -1,    -1,    -1,   470,
     471,     3,    -1,   474,   475,   476,   477,   478,   479,   480,
     481,    -1,    14,    15,    16,    17,    -1,    19,    20,    21,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    -1,    -1,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    -1,    56,    -1,    -1,    59,    -1,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    69,    -1,    71,
      72,    73,    -1,    -1,    76,    -1,    78,    79,    -1,    81,
      82,    83,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    -1,    98,    -1,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,    -1,
      -1,   133,   134,   135,   136,   137,    -1,   139,   140,    -1,
      -1,    -1,    -1,   145,   146,    -1,   148,   149,    -1,   151,
     152,    -1,    -1,   155,    -1,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,    -1,    -1,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,    -1,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,    -1,   200,   201,
     202,    -1,    -1,    -1,    -1,    -1,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,    -1,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,   238,   239,    -1,   241,
     242,    -1,   244,    -1,   246,   247,   248,   249,   250,    -1,
      -1,   253,    -1,    -1,   256,   257,   258,    -1,    -1,    -1,
     262,   263,    -1,    -1,   266,   267,   268,    -1,   270,    -1,
      -1,   273,    -1,    -1,   276,    -1,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,    -1,    -1,    -1,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,    -1,   324,    -1,   326,    -1,   328,    -1,   330,   331,
     332,   333,    -1,   335,   336,    -1,    -1,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,    -1,   349,    -1,   351,
     352,    -1,    -1,    -1,   356,   357,   358,    -1,    -1,   361,
     362,    -1,    -1,   365,   366,   367,   368,    -1,   370,   371,
     372,    -1,    -1,   375,   376,    -1,    -1,   379,   380,    -1,
     382,   383,    -1,    -1,   386,   387,    -1,   389,   390,   391,
     392,    -1,    -1,   395,   396,   397,    -1,   399,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,    -1,   409,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,   423,   424,   425,   426,   427,   428,    -1,    -1,    -1,
      -1,   433,   434,   435,    -1,   437,   438,   439,    -1,   441,
     442,   443,   444,    -1,   446,    -1,   448,   449,   450,    -1,
     452,   453,   454,    -1,   456,    -1,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,    -1,    -1,    -1,   470,   471,
       3,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
      -1,    14,    15,    16,    17,    -1,    19,    20,    21,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    -1,    -1,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    -1,    56,    -1,    -1,    59,    -1,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    69,    -1,    71,    72,
      73,    -1,    -1,    76,    -1,    78,    79,    -1,    81,    82,
      83,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    -1,    98,    -1,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
      -1,   114,    -1,    -1,    -1,    -1,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,    -1,    -1,
     133,   134,   135,   136,   137,    -1,   139,   140,    -1,    -1,
      -1,    -1,   145,   146,    -1,   148,   149,    -1,   151,   152,
      -1,    -1,   155,    -1,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,    -1,    -1,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,    -1,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,    -1,   200,   201,   202,
      -1,    -1,    -1,    -1,    -1,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,    -1,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,   238,   239,    -1,   241,   242,
      -1,   244,    -1,   246,   247,   248,   249,   250,    -1,    -1,
     253,    -1,    -1,   256,   257,   258,    -1,    -1,    -1,   262,
     263,    -1,    -1,   266,   267,   268,    -1,   270,    -1,    -1,
     273,    -1,    -1,   276,    -1,   278,   279,   280,   281,    -1,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,    -1,    -1,    -1,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
      -1,   324,    -1,   326,    -1,   328,    -1,   330,   331,   332,
     333,    -1,   335,   336,    -1,    -1,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,    -1,   349,    -1,   351,   352,
      -1,    -1,    -1,   356,   357,   358,    -1,    -1,   361,   362,
      -1,    -1,   365,   366,   367,   368,    -1,   370,   371,   372,
      -1,    -1,   375,   376,    -1,    -1,   379,   380,    -1,   382,
     383,    -1,    -1,   386,   387,    -1,   389,   390,   391,   392,
      -1,    -1,   395,   396,   397,    -1,   399,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   407,    -1,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
     423,   424,   425,   426,   427,   428,    -1,    -1,    -1,    -1,
     433,   434,   435,    -1,   437,   438,   439,    -1,   441,   442,
     443,   444,    -1,   446,    -1,   448,   449,   450,    -1,   452,
     453,   454,    -1,   456,    -1,   458,   459,   460,   461,   462,
     463,   464,    -1,    -1,    -1,    -1,    -1,   470,   471,     3,
      -1,   474,   475,   476,   477,   478,   479,   480,   481,    -1,
      14,    15,    16,    17,    -1,    19,    20,    21,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    -1,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    -1,    56,    -1,    -1,    59,    -1,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    69,    -1,    71,    72,    73,
      -1,    -1,    76,    -1,    78,    79,    -1,    81,    82,    83,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    -1,    98,    -1,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,    -1,
     114,    -1,    -1,    -1,    -1,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,    -1,    -1,   133,
     134,   135,   136,   137,    -1,   139,   140,    -1,    -1,    -1,
      -1,   145,   146,    -1,   148,   149,    -1,   151,   152,    -1,
      -1,   155,    -1,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,    -1,    -1,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,    -1,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,    -1,   200,   201,   202,    -1,
      -1,    -1,    -1,    -1,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,   238,   239,    -1,   241,   242,    -1,
     244,    -1,   246,   247,   248,   249,   250,    -1,    -1,   253,
      -1,    -1,   256,   257,   258,    -1,    -1,    -1,   262,   263,
      -1,    -1,   266,   267,   268,    -1,   270,    -1,    -1,   273,
      -1,    -1,   276,    -1,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,    -1,    -1,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,    -1,
     324,    -1,   326,    -1,   328,    -1,   330,   331,   332,   333,
      -1,   335,   336,    -1,    -1,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,    -1,   351,   352,    -1,
      -1,    -1,   356,   357,   358,    -1,    -1,   361,   362,    -1,
      -1,   365,   366,   367,   368,    -1,   370,   371,   372,    -1,
      -1,   375,   376,    -1,    -1,   379,   380,    -1,   382,   383,
      -1,    -1,   386,   387,    -1,   389,   390,   391,   392,    -1,
      -1,   395,   396,   397,    -1,   399,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,    -1,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,    -1,    -1,    -1,    -1,   433,
     434,   435,    -1,   437,   438,   439,    -1,   441,   442,   443,
     444,    -1,   446,    -1,   448,   449,   450,    -1,   452,   453,
     454,    -1,   456,    -1,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,    -1,    -1,    -1,   470,   471,     3,    -1,
     474,   475,   476,   477,   478,   479,   480,   481,    -1,    14,
      15,    16,    17,    -1,    19,    20,    21,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,    -1,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    -1,    -1,    59,    -1,    61,    62,    63,    64,
      65,    -1,    -1,    -1,    69,    -1,    71,    72,    73,    -1,
      -1,    76,    -1,    78,    79,    -1,    81,    82,    83,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    -1,    98,    -1,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,    -1,   114,
      -1,    -1,    -1,    -1,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,    -1,    -1,   133,   134,
     135,   136,   137,    -1,   139,   140,    -1,    -1,    -1,    -1,
     145,   146,    -1,   148,   149,    -1,   151,   152,    -1,    -1,
     155,    -1,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,    -1,    -1,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,    -1,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,    -1,   200,   201,   202,    -1,    -1,
      -1,    -1,    -1,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,    -1,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,   238,   239,    -1,   241,   242,    -1,   244,
      -1,   246,   247,   248,   249,   250,    -1,    -1,   253,    -1,
      -1,   256,   257,   258,    -1,    -1,    -1,   262,   263,    -1,
      -1,   266,   267,   268,    -1,   270,    -1,    -1,   273,    -1,
      -1,   276,    -1,   278,   279,   280,   281,    -1,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,    -1,
      -1,    -1,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,   322,    -1,   324,
      -1,   326,    -1,   328,    -1,    -1,   331,   332,   333,    -1,
     335,   336,    -1,    -1,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,    -1,   349,    -1,   351,   352,    -1,    -1,
      -1,   356,   357,   358,    -1,    -1,   361,   362,    -1,    -1,
     365,   366,   367,   368,    -1,   370,   371,   372,    -1,    -1,
     375,   376,    -1,    -1,   379,   380,    -1,   382,   383,    -1,
      -1,   386,   387,    -1,   389,   390,   391,   392,    -1,    -1,
     395,   396,   397,    -1,   399,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   407,    -1,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,   423,   424,
     425,   426,   427,   428,    -1,    -1,    -1,    -1,   433,   434,
     435,    -1,   437,   438,   439,    -1,   441,   442,   443,   444,
      -1,   446,    -1,   448,   449,   450,    -1,   452,   453,   454,
      -1,   456,    -1,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,    -1,    -1,    -1,   470,   471,     3,    -1,   474,
     475,   476,   477,   478,   479,   480,   481,    -1,    14,    15,
      16,    17,    -1,    19,    20,    21,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      -1,    -1,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    -1,    -1,    59,    -1,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    69,    -1,    71,    72,    73,    -1,    -1,
      76,    -1,    78,    79,    -1,    81,    82,    83,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    -1,    98,    -1,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,    -1,   114,    -1,
      -1,    -1,    -1,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,    -1,    -1,   133,   134,   135,
     136,   137,    -1,   139,   140,    -1,    -1,    -1,    -1,   145,
     146,    -1,    -1,   149,    -1,   151,   152,    -1,    -1,   155,
      -1,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
      -1,    -1,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,    -1,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,    -1,   200,   201,   202,    -1,    -1,    -1,
      -1,    -1,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,   238,   239,    -1,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,   250,    -1,    -1,   253,    -1,    -1,
     256,   257,   258,    -1,    -1,    -1,   262,   263,    -1,    -1,
     266,   267,   268,    -1,   270,    -1,    -1,   273,    -1,    -1,
     276,    -1,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,    -1,    -1,
      -1,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,    -1,   324,    -1,
     326,    -1,   328,    -1,   330,   331,   332,   333,    -1,   335,
     336,    -1,    -1,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,    -1,   351,   352,    -1,    -1,    -1,
     356,   357,   358,    -1,    -1,   361,   362,    -1,    -1,   365,
     366,   367,   368,    -1,   370,   371,   372,    -1,    -1,   375,
     376,    -1,    -1,   379,   380,    -1,   382,   383,    -1,    -1,
     386,   387,    -1,   389,   390,   391,   392,    -1,    -1,   395,
     396,   397,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   422,   423,   424,   425,
     426,   427,   428,    -1,    -1,    -1,    -1,   433,   434,   435,
      -1,   437,   438,   439,    -1,   441,   442,   443,   444,    -1,
     446,    -1,   448,   449,   450,    -1,   452,   453,   454,    -1,
     456,    -1,   458,   459,   460,   461,   462,   463,   464,    -1,
      -1,    -1,    -1,    -1,   470,   471,    -1,    -1,   474,   475,
     476,   477,   478,   479,   480,   481
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    82,    84,   100,   103,   115,   117,   121,   127,   135,
     137,   143,   158,   213,   214,   219,   231,   242,   280,   292,
     297,   298,   300,   305,   310,   313,   317,   322,   323,   330,
     333,   341,   353,   370,   380,   386,   391,   404,   502,   509,
     510,   511,   512,   515,   516,   517,   518,   519,   522,   537,
     538,   540,   541,   542,   543,   544,   545,   546,   548,   549,
     553,   565,   570,   571,   574,   575,   576,   593,   596,   597,
     614,   690,   693,   719,   722,   723,   724,   731,   737,   739,
     741,   742,   745,   748,   749,   753,   754,   763,   767,   768,
     769,   770,   771,   773,   774,   775,   788,   789,   793,   795,
     796,   797,   808,   810,   817,   818,   821,   822,   823,   824,
     825,   830,   832,   835,   839,   843,   844,   854,   855,   858,
     863,   874,   896,   899,   900,   901,   904,   907,   909,   911,
     914,   915,   916,   919,   920,   921,   928,   929,   931,   932,
     933,   938,   940,   941,   945,   946,   949,   950,   951,   952,
     954,   955,   956,   957,   959,   962,   963,   969,   976,   979,
     981,   984,   989,   991,   995,  1002,  1006,  1007,  1008,  1009,
    1010,  1011,  1014,  1044,   365,   407,   934,    21,    67,    81,
      98,   104,   119,   130,   138,   139,   150,   155,   161,   176,
     201,   222,   256,   285,   312,   316,   318,   324,   327,   352,
     353,   355,   359,   367,   372,   384,   397,   463,   470,   738,
     934,     3,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    33,    34,    36,    37,    39,    40,
      41,    42,    43,    45,    46,    48,    49,    50,    51,    52,
      55,    56,    57,    58,    59,    61,    62,    63,    64,    65,
      69,    70,    71,    72,    73,    75,    76,    78,    79,    80,
      81,    82,    83,    86,    87,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   105,   107,   108,   109,   110,   111,
     113,   114,   115,   118,   119,   120,   121,   122,   124,   125,
     126,   128,   129,   130,   133,   134,   135,   136,   137,   138,
     139,   140,   142,   144,   145,   146,   149,   151,   155,   156,
     157,   159,   160,   162,   164,   165,   166,   167,   168,   170,
     171,   172,   174,   175,   176,   177,   178,   179,   181,   183,
     184,   185,   186,   187,   188,   189,   191,   193,   196,   198,
     199,   200,   201,   202,   204,   205,   207,   208,   210,   213,
     214,   215,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   236,
     237,   238,   239,   241,   242,   244,   246,   247,   248,   249,
     250,   251,   253,   256,   257,   258,   261,   262,   264,   266,
     267,   268,   269,   270,   272,   273,   275,   276,   278,   279,
     280,   281,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   309,   310,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   324,
     325,   326,   327,   328,   330,   331,   332,   333,   335,   336,
     337,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   351,   352,   354,   355,   356,   357,   358,   359,
     361,   362,   365,   366,   367,   368,   370,   371,   372,   373,
     375,   376,   379,   380,   381,   382,   383,   386,   387,   388,
     389,   390,   391,   392,   394,   396,   397,   398,   399,   402,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   430,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1003,  1169,  1183,  1187,
    1192,   395,   964,   254,   281,   934,    44,   605,  1007,    33,
      54,    67,    77,    98,   104,   119,   130,   138,   150,   157,
     161,   215,   256,   259,   312,   318,   327,   355,   356,   358,
     359,   367,   372,   378,   381,   384,   457,   466,   470,   484,
     615,   694,   721,   798,   813,   864,   875,    22,   280,  1169,
    1003,    22,   275,   325,   356,   358,     5,   200,   905,   906,
    1178,    21,    33,    54,    67,    81,    98,   119,   130,   138,
     139,   150,   155,   161,   176,   222,   256,   267,   312,   316,
     318,   324,   327,   353,   355,   359,   367,   372,   384,   397,
     463,   470,   738,   826,   934,  1169,    84,   395,   502,   614,
     690,   719,   722,   963,   970,   979,   984,   989,   995,  1002,
    1006,     9,    15,    22,    39,   145,   151,   153,   173,   202,
     237,   283,   299,   493,   494,   840,   841,  1003,  1177,  1182,
      22,    84,   296,   323,   845,   846,   847,  1183,  1183,  1174,
    1178,   353,  1017,   840,  1183,   365,  1169,   267,   222,    98,
     176,   352,   353,   912,   317,  1183,    22,   328,   361,   365,
     557,   566,   567,  1183,    19,   158,   845,   846,   281,   934,
    1183,   199,    22,   116,  1019,    55,    78,   215,   233,   312,
     318,   328,   361,   365,   410,   554,   555,   556,   557,    22,
     328,   361,   365,   557,   365,   255,  1055,  1167,  1183,  1017,
     495,  1183,   154,   502,   966,   502,  1162,   294,  1012,  1013,
    1169,  1007,  1008,  1011,     0,   505,   964,   131,   190,   260,
     377,  1020,  1021,  1007,  1009,  1010,   109,   186,   383,   506,
       3,    38,    44,    67,    74,    85,    91,   152,   154,   169,
     182,   194,   195,   197,   209,   211,   235,   243,   263,   265,
     311,   334,   395,   449,  1175,  1183,  1184,  1187,  1193,   828,
    1183,   828,  1170,  1183,   284,   828,   367,   828,  1169,  1183,
     353,    97,   353,   853,  1175,     3,  1179,  1185,  1187,  1192,
    1193,    22,   168,  1167,   249,   397,     8,    62,   142,   489,
     490,   491,   493,   494,   495,   496,   497,   498,   903,  1124,
    1125,  1183,    22,  1179,  1169,  1169,   168,  1167,  1169,   305,
     330,    22,   168,  1055,  1169,   320,  1169,   828,    22,   220,
    1179,   168,  1167,   828,  1169,   161,   464,   200,   106,   196,
     240,   290,   935,   936,   937,  1167,  1173,  1183,    21,    54,
      67,    68,    77,    81,    98,   119,   130,   138,   150,   155,
     176,   201,   222,   256,   312,   316,   318,   324,   327,   353,
     355,   359,   367,   372,   397,   470,   738,   833,  1178,  1167,
     363,  1169,   502,   828,   367,  1170,   828,   367,   168,  1169,
      97,   353,   356,   358,  1179,   356,   358,    62,   142,   903,
     303,  1179,   168,   550,  1183,  1169,  1169,   320,  1169,   828,
     220,  1179,   161,   464,   294,   324,   353,   397,   139,   222,
      21,    81,   176,   155,   316,   371,   732,    22,  1169,  1004,
     564,  1178,  1185,   906,   168,  1175,  1169,   168,   910,   168,
    1170,   367,   353,   483,    97,   353,   168,  1175,   168,  1179,
    1181,    74,   397,    62,   142,   168,   903,    48,   168,  1181,
     168,  1169,   168,  1169,   168,  1169,   320,   168,  1169,   168,
     220,  1181,   161,   464,   200,   168,   827,   828,   502,   980,
     615,   432,   971,   391,   963,   972,   973,   974,  1185,   964,
    1182,   841,   842,    22,   842,  1182,   842,    22,   842,  1182,
     842,   842,   842,  1182,  1177,  1177,  1003,   842,   284,   502,
     502,   636,   636,   636,   254,   363,   506,   636,  1055,  1056,
     506,   930,  1178,   502,   977,    48,   397,  1169,  1169,  1167,
    1183,    38,   422,   196,   504,   257,   257,   254,   153,  1178,
     363,   148,   836,   254,     4,     6,     7,     8,    10,    30,
      43,    45,    46,    53,    54,    57,    58,    65,    67,    88,
      89,    90,    91,    92,    93,    94,   101,   102,   120,   136,
     140,   141,   146,   160,   188,   189,   191,   208,   216,   217,
     234,   236,   240,   245,   246,   248,   256,   266,   276,   291,
     314,   329,   336,   349,   353,   361,   362,   366,   368,   369,
     378,   384,   392,   412,   413,   414,   415,   416,   417,   418,
     419,   429,   441,   442,   451,   493,   494,   495,   502,  1007,
    1071,  1074,  1077,  1078,  1079,  1081,  1082,  1083,  1084,  1087,
    1088,  1092,  1094,  1097,  1098,  1100,  1122,  1126,  1145,  1151,
    1155,  1163,  1164,  1165,  1175,  1176,  1177,  1178,  1183,  1178,
      22,   572,  1166,  1167,   328,   554,   104,   563,  1178,   564,
    1178,    38,    59,   554,   422,   337,   936,   257,   153,   363,
     489,    38,   422,   196,   937,   502,  1167,   495,   500,   504,
    1156,  1157,  1056,   152,   154,   395,   960,   961,   963,   152,
     967,   104,  1092,  1160,  1161,  1012,   506,   502,   968,   503,
     503,   511,   440,   472,   965,  1167,    22,   116,  1018,  1018,
      48,  1018,   143,   148,   212,   252,  1024,  1026,  1027,  1038,
    1040,  1041,  1042,  1020,  1021,   153,   192,  1055,  1057,  1162,
     502,   887,  1157,   268,   301,   330,   504,   829,   268,   301,
     330,   268,   301,   330,   404,   523,   565,   568,   859,    18,
     121,   268,   301,   330,   388,   579,  1169,   330,    18,   121,
     383,   547,  1055,   408,   168,  1055,    50,    83,   135,   139,
     171,   207,   238,   240,   268,   301,   309,   315,   322,   330,
     339,   347,   399,   424,   453,   467,   565,   569,   890,   897,
     502,   876,   301,   547,   173,   136,    18,    24,    64,   114,
     121,   124,   178,   238,   240,   250,   258,   268,   301,   304,
     305,   330,   370,   388,   435,   436,   477,   577,   578,   592,
     757,     4,   493,   494,   729,  1182,    22,   168,  1167,   828,
     828,   502,   902,   504,   173,   539,   301,   523,   539,   254,
     268,   301,   136,    49,    96,   175,   223,   228,   238,   267,
     301,   306,   330,   341,   577,   726,   727,   268,   301,   396,
     757,   765,   567,   555,   557,   173,   136,   301,   330,   577,
     268,   301,   305,   330,    75,   113,   269,   357,   254,    18,
      24,   121,   268,   301,   330,   594,   595,   539,   148,   301,
     523,   539,   136,   301,   330,   577,   301,   268,  1169,  1180,
    1185,  1169,   210,   106,   255,   409,   506,   935,   385,   958,
     254,  1175,   502,  1169,   367,    97,   353,  1175,   249,   397,
      62,   142,   903,  1169,   320,  1169,   161,   464,   200,   828,
     636,   287,   599,    60,     3,    43,    45,    46,    57,    58,
     101,   102,   146,   188,   189,   191,   234,   236,   248,   291,
     331,   336,   361,   362,   392,  1068,  1070,  1072,  1074,  1076,
    1078,  1079,  1080,  1082,  1083,  1087,  1088,  1184,  1187,   153,
     502,   799,  1169,   523,    31,   953,  1169,   240,   523,   408,
     168,  1167,   523,   828,   828,   799,   381,   615,   523,   240,
      38,   551,   372,   764,   268,   740,    75,   113,   269,   357,
      20,    40,   187,   776,    31,   799,   148,   523,  1169,  1180,
     397,  1167,   168,   691,  1167,  1167,   483,   695,   397,  1175,
     828,    74,   865,  1175,  1169,   463,   738,    44,    95,   185,
     238,   319,   136,   887,    51,   307,   580,   136,   502,   136,
     353,   408,   136,   876,   136,   506,   168,   827,   168,   828,
     168,   828,   136,   902,  1181,   136,   136,   254,   136,   580,
     136,    75,   113,   269,   357,   136,   254,   136,   148,   168,
    1169,  1180,   168,   564,   136,   506,   580,  1092,  1129,   970,
     503,   506,   141,   254,   369,   561,   564,   729,   975,   971,
     842,  1003,   842,  1003,   842,  1003,   842,  1003,   842,  1003,
    1003,  1003,   842,  1003,   502,   637,   638,  1183,   637,    22,
      98,   119,   150,   155,   200,   201,   318,   324,   353,   355,
     372,   463,   848,  1166,  1181,   847,   173,   506,   992,  1178,
    1068,  1132,    31,  1181,   865,   149,   913,   913,   913,   210,
    1183,   148,   148,   848,  1181,   317,  1183,   564,   254,   502,
    1158,   500,  1007,  1133,   394,  1085,  1092,  1150,   502,  1085,
    1085,   502,   148,   502,   502,   502,  1073,  1073,   278,  1007,
     502,   502,  1075,   502,   502,   502,   502,    57,    58,  1085,
    1092,   502,  1073,   502,   502,   502,   502,   502,   502,   406,
     488,   502,  1089,   502,  1089,   502,   502,  1007,   502,   502,
     502,   502,   502,   502,   502,   502,   502,   502,   502,   502,
    1092,  1092,   353,  1007,  1092,  1129,  1157,  1178,    58,   502,
    1086,   502,  1178,     3,     8,    11,    14,    15,    16,    17,
      18,    19,    20,    21,    23,    24,    28,    31,    33,    34,
      36,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      48,    49,    50,    51,    52,    56,    59,    61,    62,    63,
      64,    65,    66,    69,    71,    72,    73,    76,    78,    79,
      81,    82,    83,    86,    95,    96,    98,   100,   101,   102,
     103,   105,   107,   108,   109,   110,   111,   114,   119,   120,
     121,   122,   124,   125,   126,   128,   129,   133,   134,   135,
     136,   137,   139,   140,   145,   146,   149,   151,   152,   155,
     157,   159,   160,   162,   164,   165,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   183,   184,
     185,   186,   187,   188,   189,   191,   193,   194,   195,   196,
     198,   200,   201,   202,   208,   210,   211,   213,   214,   215,
     218,   219,   221,   223,   224,   225,   226,   228,   229,   231,
     232,   233,   234,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   246,   247,   248,   249,   250,   253,   256,   257,
     258,   259,   262,   263,   266,   267,   268,   270,   273,   276,
     278,   279,   280,   281,   283,   284,   285,   286,   288,   289,
     290,   291,   292,   293,   298,   299,   300,   301,   302,   303,
     305,   306,   307,   309,   310,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   322,   324,   326,   328,   330,   331,
     332,   333,   334,   335,   336,   339,   341,   342,   343,   344,
     345,   346,   347,   349,   351,   352,   355,   356,   357,   358,
     361,   362,   365,   366,   367,   368,   370,   371,   372,   375,
     376,   379,   380,   382,   383,   386,   387,   389,   390,   391,
     392,   395,   396,   397,   399,   407,   409,   422,   423,   424,
     425,   426,   427,   428,   433,   434,   435,   437,   438,   439,
     441,   442,   443,   444,   446,   448,   449,   450,   452,   453,
     454,   456,   458,   459,   460,   461,   462,   463,   464,   470,
     471,   474,   475,   476,   477,   478,   479,   480,   481,   489,
     490,   491,   493,   494,   495,   496,   497,   498,  1124,  1126,
    1128,  1188,  1189,  1191,   405,  1109,   265,  1092,   192,  1015,
     506,   502,  1178,  1157,   107,   170,   573,   506,    59,   104,
     564,    31,     3,   104,   215,   562,   729,  1088,  1178,  1178,
      79,   118,  1106,    87,   104,   558,   559,   561,   729,   104,
     558,   210,  1167,  1092,     3,    22,    26,    27,    28,    29,
      30,    31,    32,    35,    47,    53,    54,    60,    66,    68,
      77,    84,    88,    89,    90,    92,    93,    94,   104,   106,
     112,   116,   117,   123,   127,   131,   132,   141,   143,   147,
     148,   150,   153,   158,   161,   163,   173,   180,   190,   192,
     203,   206,   212,   216,   217,   240,   245,   252,   254,   255,
     259,   260,   271,   274,   277,   282,   296,   308,   323,   329,
     338,   350,   353,   360,   363,   364,   369,   374,   377,   378,
     384,   385,   393,   400,   401,   403,   404,   429,   431,   473,
     495,  1172,  1186,  1187,  1192,  1193,  1194,  1156,    80,   306,
     831,   503,   506,   964,    36,   256,   503,   506,  1013,  1168,
    1169,    31,  1167,    22,  1167,   968,  1009,  1009,  1022,  1023,
    1092,  1009,   145,   237,  1033,   198,   238,   290,   332,   383,
      22,  1028,  1092,   493,   494,  1029,  1030,  1092,  1094,  1038,
    1039,  1027,  1026,  1024,  1025,   148,  1041,   250,  1043,  1024,
    1038,  1057,  1167,    31,  1183,   330,   173,   183,   260,   262,
     331,   393,   495,   880,   881,   882,   884,   886,   888,  1068,
    1184,   268,   301,   330,   363,   363,   318,  1172,   504,   363,
     363,   318,   363,   363,   355,   554,   947,   148,   158,   173,
     310,   860,   861,    60,    77,   132,   150,   282,   378,   633,
     634,    77,   104,   240,   363,    77,   363,   104,   240,   318,
      77,   114,   124,   268,   301,   794,   318,   746,    21,    54,
      67,    81,   119,   130,   150,   155,   222,   256,   318,   324,
     327,   353,   359,   372,   397,   738,   301,   577,  1169,   136,
     301,   330,   577,   254,   729,   254,   322,   478,   207,   363,
     363,   245,   729,   108,   193,   318,   328,   365,   556,   478,
     478,   478,   307,   330,   890,   898,   503,   877,   880,   363,
     384,   355,  1167,    68,   104,   271,   623,   633,  1183,    68,
      77,   104,   271,   591,   917,   254,   316,   367,    77,   104,
     271,   591,   917,    25,   304,   316,   367,  1167,   178,   250,
     828,   502,   363,   363,   591,   167,   502,   584,   355,   404,
     406,   431,   479,   584,   655,   591,    77,   591,   353,   104,
     591,   506,     4,     4,   268,   173,   136,   301,   330,   577,
     385,   385,   239,  1068,   268,   330,   903,    98,   330,   568,
     363,   525,   568,  1167,   363,   363,  1167,   729,    48,   728,
     729,   729,    96,   223,   228,    48,   363,   523,   318,   523,
     238,   727,   363,   363,   245,  1178,   757,   355,  1055,    77,
     363,   917,   318,   363,   363,   584,   584,   828,   828,   828,
     828,  1167,    37,   390,    37,    37,   363,    37,   363,   104,
     318,   506,   568,    94,   384,   772,  1179,   363,   525,   568,
    1167,   363,   318,   363,   363,   330,   513,   268,   301,   290,
     302,   326,   560,   935,  1173,  1183,  1167,   887,  1068,   254,
     408,   876,   729,   828,   828,   902,   194,   254,    75,   113,
     269,   357,   254,   828,   194,   404,   606,   344,   345,   601,
    1178,   502,  1070,    31,    30,  1069,    99,   166,   227,   230,
     321,   420,   502,  1090,  1091,   829,  1073,   828,   800,   801,
    1186,    20,   942,  1068,   254,   136,   743,  1169,   240,   502,
     524,   813,   385,   294,   397,   524,   136,  1179,    84,   158,
     552,   614,   723,   775,   843,   863,   938,  1178,   765,   766,
    1169,   218,   828,   828,   828,   828,   250,   109,   186,   370,
     383,   777,   778,   128,   289,   502,   772,   524,   404,   513,
    1167,   725,   726,   240,    31,   250,   502,   636,   636,   615,
     720,  1167,   502,   803,   887,   148,   866,  1173,   502,   878,
      31,  1169,   200,   404,   406,  1005,   319,  1175,   580,  1068,
    1170,   168,  1169,  1175,   580,  1181,  1179,   136,   580,   136,
     385,   136,   385,   903,   580,   580,  1181,  1169,   828,  1169,
    1169,  1169,   828,  1181,   772,   136,   136,   580,   827,   828,
     503,   506,   970,   973,   970,  1003,  1003,  1003,  1003,  1003,
    1003,   637,   503,   506,   503,   156,   325,   354,  1168,   827,
      97,   327,   852,   853,  1168,   249,  1168,  1166,  1166,  1168,
     827,  1168,   363,   404,   856,    16,   134,   314,   332,   993,
    1055,   244,   994,   503,   506,   978,   984,   989,   995,  1006,
     363,  1167,   846,   845,   846,   153,   159,   857,  1183,    21,
      68,    98,   119,   130,   150,   155,   201,   222,   312,   318,
     324,   353,   355,   372,   397,   738,   837,  1129,  1156,   501,
    1129,  1133,  1134,   502,   400,  1146,  1147,  1092,  1129,   502,
    1177,  1177,  1129,     3,    99,   166,   227,   230,   321,   420,
    1135,  1136,  1178,  1177,  1129,  1129,  1177,  1177,  1085,  1085,
    1092,   903,  1092,  1137,   493,   494,  1093,  1094,  1122,  1126,
    1139,   503,  1129,  1092,  1129,  1140,  1006,  1096,   361,   422,
    1177,  1177,  1092,    47,   153,   206,   364,  1092,  1129,  1143,
    1129,   232,  1092,  1094,  1092,  1104,  1105,  1106,   232,  1092,
    1106,  1092,   503,  1129,  1092,   503,   506,   330,  1177,  1177,
    1090,  1068,  1092,  1186,   361,    35,   350,  1159,   828,  1092,
     502,  1007,  1144,   116,   118,   141,   240,   245,   250,   369,
     379,  1092,    42,   169,   173,   211,   334,   502,  1092,   363,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
      22,    29,   338,  1123,   161,   144,  1110,   314,   502,  1122,
     157,   215,   353,   356,   358,   381,  1016,  1167,   153,  1045,
    1165,    22,   116,   393,   495,   503,   882,  1092,  1130,  1131,
    1184,  1167,   365,   502,  1178,   506,   503,   501,   507,   167,
     167,   580,  1167,   961,   962,  1167,  1160,   503,   506,   502,
     968,   968,   506,    32,   112,   385,   872,   314,   315,   493,
     494,  1030,  1032,  1094,   332,   198,   255,   506,     4,  1031,
    1177,  1031,   314,   315,  1032,  1166,   994,  1039,  1025,   385,
     990,   104,   502,   985,  1006,  1183,   502,   996,   997,   998,
     999,  1000,  1183,   262,    48,  1184,   503,   882,   884,   881,
     884,  1184,   260,   503,   506,   829,   363,   363,   318,  1179,
    1169,  1169,  1172,  1179,  1169,  1169,  1179,  1170,  1169,    76,
     948,   312,   384,   845,   318,   158,   845,   502,  1169,   385,
     867,   198,   198,   385,   502,   654,   168,  1169,   245,  1179,
    1169,  1169,  1092,   245,  1169,  1169,    25,   304,   363,   363,
    1169,   363,   747,  1175,   502,   828,   828,   828,   367,    97,
     353,   853,   397,    62,   142,   903,  1169,   828,  1169,   828,
     320,   828,   828,   200,   162,   238,   268,   301,   389,   750,
     751,   752,  1055,   363,   917,   318,   245,    22,    29,   447,
     450,   108,   193,  1179,  1169,   254,  1169,    97,    97,   503,
     506,  1179,  1181,  1169,   301,   577,   623,   271,     3,   127,
     148,   256,   341,   391,   590,   668,   669,   672,   673,   676,
    1190,  1191,  1068,  1169,   271,   590,   578,  1183,  1169,  1169,
      22,   384,  1169,   168,  1169,   271,   168,   580,   168,  1183,
     316,   367,   316,   367,  1169,    22,   384,  1169,  1167,    18,
     121,   330,   758,   759,   760,   761,  1186,  1179,  1169,   363,
     104,   154,   241,   385,   583,   586,   587,  1186,  1169,   253,
     799,    64,   253,    48,   465,   469,   357,   580,  1169,   404,
     271,    36,   578,   363,   355,  1167,   363,   917,   318,  1171,
    1183,  1171,   506,   503,   506,   363,   318,  1170,  1179,     3,
      76,   121,   126,   178,   273,   376,   384,   387,   427,   430,
     455,   470,   526,   527,   529,   301,  1179,  1169,   301,   330,
     577,   726,   729,   828,  1169,   729,  1169,   729,  1179,  1169,
    1169,   301,   330,   577,  1169,  1169,  1169,  1169,  1179,  1169,
      18,    24,   121,   268,   301,   330,   268,   301,   330,   799,
     301,   330,   301,   330,   301,  1067,  1183,   168,   809,  1183,
     168,  1183,  1179,  1169,  1169,   125,  1169,    18,   595,   327,
    1179,   301,   330,   577,  1169,  1169,  1169,  1179,    73,   224,
     225,   226,   425,   426,   520,   521,    83,   404,   406,   423,
     445,   456,   459,   514,   363,   363,    72,   375,   290,   194,
      31,   828,   194,   194,   385,   385,   194,   245,   834,  1178,
     828,   828,   194,   834,   253,   153,   363,   598,   523,  1092,
      30,  1069,  1068,   500,   500,   363,   363,   363,   502,   363,
    1177,  1073,   503,   506,   489,   777,    76,   125,   204,   205,
     218,   268,   355,   357,   943,   625,  1186,  1169,   153,   318,
     396,   744,   751,   752,   136,    68,   104,   211,   616,   618,
     620,   622,   623,   630,   633,    19,   173,   312,   351,   527,
     528,   148,  1171,   397,  1167,   550,  1183,   551,   259,   615,
     150,  1178,   799,   799,   799,   799,   250,   254,   259,   502,
     799,  1065,  1066,  1067,   327,   799,   404,   502,   136,   135,
    1006,   828,   616,  1183,   404,   406,   650,   404,   585,   353,
      31,   636,     3,   804,   805,   799,  1178,   254,   503,   879,
     880,   885,    31,   200,   309,   403,   889,   890,   891,   254,
     799,   564,   165,   165,   148,   887,    31,   136,   580,   876,
     827,   828,  1171,   828,  1171,   902,   254,   580,   580,   254,
     580,   327,   148,   564,   580,  1092,   503,   638,   173,   173,
     173,   408,  1168,   506,   729,   730,   161,   849,   850,  1179,
      19,   857,   134,   332,   134,   332,   314,   383,   229,  1068,
    1169,   404,   692,   153,   254,   849,    48,   580,  1175,   367,
     353,  1175,   249,   397,   200,   828,   503,   501,   501,   506,
    1129,   194,  1092,  1148,   123,  1147,  1149,    31,   503,  1092,
     503,   503,   503,   503,   153,   503,   503,   503,   503,   503,
     506,   503,   274,  1138,   503,  1093,  1093,    11,   173,   194,
     256,   489,   490,   491,   493,   494,   495,   496,   497,   498,
    1126,  1093,   503,   503,   148,   153,  1141,  1142,   503,   473,
    1095,   503,   422,   503,   503,    31,  1143,  1129,  1143,  1143,
     153,   503,   503,  1186,   506,   272,  1108,    31,   503,   506,
    1092,  1186,   506,  1092,   506,  1152,  1153,   503,   503,  1158,
    1092,  1183,   503,   503,   422,  1093,  1093,   129,  1129,   153,
     116,   118,   141,   245,   250,   369,   379,   502,   129,   350,
    1159,  1092,  1144,  1092,   363,   903,  1092,   502,  1007,   502,
     502,   264,  1114,   356,   358,   356,   358,  1167,  1017,  1017,
    1017,   203,   315,   429,   502,  1007,  1046,  1047,  1048,  1055,
    1058,  1097,  1099,  1100,  1175,  1183,   401,  1063,  1130,  1130,
    1131,   503,    13,   506,  1020,  1021,   936,  1177,  1090,   559,
    1092,   968,  1169,   978,  1023,   256,  1124,  1127,   485,   486,
     873,     4,  1177,  1032,   255,   383,  1029,  1046,   401,  1064,
     391,   986,   987,  1183,   308,   988,  1000,  1001,   506,  1045,
     489,  1158,   888,   829,   884,   884,    48,   886,   497,  1179,
    1169,  1169,   212,  1181,  1181,   254,  1168,   257,   254,  1092,
     634,  1171,   502,   502,   502,   654,   176,   637,   786,   136,
     580,   363,  1179,  1169,   564,   887,  1068,  1169,   408,   828,
     828,   828,   828,   902,    75,   113,   269,   357,  1169,   733,
    1169,   162,   389,   363,   363,   733,   750,   757,   301,   330,
     577,  1169,  1169,  1169,   184,   475,   245,   880,   267,   330,
     363,   590,   502,   502,   502,   502,   341,   391,   673,   669,
     671,   434,   670,   355,   404,   659,   258,   755,   786,   590,
     121,   305,   330,   579,   757,   918,   136,   580,   168,   136,
     136,   580,  1169,  1169,  1169,  1169,   760,   761,   760,   503,
     506,   762,  1178,     3,   176,   503,   506,   489,   504,   655,
     502,   502,   353,   668,   502,  1179,  1169,   301,   330,   577,
    1169,  1169,  1169,   268,   301,   330,    18,   121,   268,   301,
     330,  1068,   239,  1068,  1179,  1169,   212,   430,   273,   245,
    1178,   273,  1181,   382,   502,   534,    42,    99,   530,   532,
     534,   161,   464,   363,   363,   318,   267,   330,   363,   917,
     318,   363,   363,   220,   220,   220,   363,   363,   318,   363,
     363,   318,   363,   318,   363,   318,   363,   580,  1068,   240,
    1178,   330,   918,   136,   580,   363,   799,  1169,   363,   318,
    1182,  1182,  1182,  1182,  1178,  1182,   480,   799,   799,   480,
     480,  1179,  1169,   834,  1068,   194,   834,   834,  1171,  1171,
     834,   194,   194,   834,   599,   502,   602,   603,   503,   500,
     503,  1177,   501,  1177,   166,   227,  1091,   227,  1091,  1091,
    1177,   230,   503,   801,   239,   256,   314,   493,   494,   729,
     802,   884,  1127,  1178,  1194,   254,   212,   489,   944,   944,
     944,   944,   944,   944,   944,    60,    66,    77,   104,   106,
     180,   240,   245,   282,   296,   378,   626,   628,   629,   135,
     400,   523,   564,  1169,   564,   755,  1167,  1183,    68,  1167,
     503,   506,  1181,   161,   312,  1181,  1177,   372,  1167,   636,
      38,   551,   303,   353,    97,   585,   637,  1167,   778,   806,
     807,  1178,   503,   506,  1169,   799,   637,  1167,  1169,   692,
     502,   617,   503,   253,   584,   253,   254,   651,   584,    31,
    1167,  1006,   585,   489,   503,   506,   363,  1167,   503,   506,
     104,   489,   892,  1178,   564,   353,   883,   884,   404,   891,
     893,   109,   186,   323,   383,   926,   162,  1006,   580,  1068,
    1169,   580,   580,   385,   580,   385,   580,   580,   828,   828,
    1169,   772,   580,   318,   318,   318,  1168,   853,   506,  1179,
     404,   506,   851,   257,   134,   134,    97,   238,  1181,   848,
     580,  1179,   887,   876,   729,   828,   194,  1133,   503,   240,
     360,  1092,   127,  1068,   503,  1092,  1092,  1092,  1141,  1068,
    1093,   116,   118,   240,   250,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1092,  1092,  1142,  1141,    48,
     465,  1089,  1089,  1068,   503,   503,   503,  1129,   503,   506,
    1092,    48,  1094,   503,  1186,  1105,   279,   348,  1107,   503,
     506,   396,  1101,    31,  1092,   506,  1153,  1154,   503,  1086,
    1178,  1092,    28,    28,  1092,   503,  1092,   153,   502,  1132,
    1092,  1093,  1093,   129,   129,  1092,   503,   129,  1092,  1021,
     401,   502,  1115,  1183,  1017,  1017,  1017,  1017,  1167,  1167,
    1167,  1007,  1058,   153,   502,  1007,  1047,  1048,    31,  1049,
    1050,  1183,   506,    85,   154,   182,   197,   209,   235,   311,
    1052,  1050,    31,  1049,  1051,  1183,   487,  1062,   502,  1157,
    1092,   161,  1034,   506,  1020,  1020,  1020,  1092,   393,  1131,
     503,   503,   501,   503,   502,   873,   255,    87,  1092,   988,
     503,   506,  1158,  1164,   503,   506,   997,  1064,  1160,   503,
     497,   888,   372,   944,   156,   325,   354,   373,   862,   148,
     862,   503,   502,   642,   643,   869,  1099,  1183,   637,   637,
     786,  1173,   503,   106,   180,   238,   240,   787,  1169,  1169,
      31,  1169,   385,   385,   828,   828,   828,   828,   829,  1179,
    1169,   363,   917,   318,   363,   184,    48,   355,  1169,   673,
      54,   494,   502,   664,   665,   666,  1175,  1176,   666,  1175,
     666,   502,   664,   674,   675,   659,   670,   502,  1169,   799,
     502,   661,   502,   625,   240,   584,    97,   240,   343,   346,
     584,   372,  1169,   136,   590,  1183,   759,  1169,   587,   802,
    1186,   639,   640,  1183,   104,   479,   503,   622,   663,   672,
     679,   682,   683,  1167,   669,   391,   666,   676,   677,   267,
     330,   363,   917,   318,   363,   363,   363,   318,   155,   256,
     346,   811,   812,   155,   256,   819,   820,   363,   363,   318,
     503,   503,   503,  1182,   148,  1178,  1178,  1178,   535,   536,
    1186,   532,   531,  1177,  1178,   828,   828,  1169,  1169,  1169,
      48,   355,  1169,  1169,  1169,  1169,  1169,   148,   148,   303,
     148,   168,  1179,  1169,  1169,  1179,  1169,  1169,  1169,  1169,
    1169,  1169,  1169,    66,   581,   136,    20,    40,   372,  1183,
    1169,   757,  1169,  1169,   729,   406,   729,   729,   503,   834,
     194,   194,   834,   834,   601,   609,   610,  1186,    44,    86,
     110,   125,   129,   149,   152,   164,   245,   253,   254,   288,
     438,   454,   604,   786,  1177,   404,   406,   501,   501,   503,
    1090,  1167,   944,   104,  1177,  1178,   104,  1178,   104,  1178,
     104,  1178,   104,  1169,   104,  1169,   104,  1169,   502,   828,
    1169,  1093,   107,   170,   106,   245,   198,  1167,   893,   286,
     790,   791,  1183,   743,   502,   125,   125,   631,   327,   620,
    1181,  1181,  1068,   502,   585,  1179,  1167,   408,   148,   779,
     503,   506,  1067,   755,   503,   250,   502,   980,   655,   656,
     619,   621,   624,   633,  1183,   650,   179,   649,    71,   355,
     652,  1006,   502,   692,   652,   802,     3,   805,  1178,   867,
     885,  1092,  1092,   506,   502,   889,   799,   363,   733,   503,
     580,  1171,  1171,   580,   580,   327,  1168,  1168,  1168,   729,
     158,   850,    97,   857,   153,   194,   194,   194,   194,   245,
     838,  1178,   116,  1092,   503,   503,  1142,   153,   116,   118,
     250,   502,  1129,   503,   411,  1103,  1129,   503,   295,    48,
     402,   402,   503,  1092,   238,  1092,   506,  1102,  1070,   503,
     506,  1092,   503,  1090,  1093,  1093,  1092,  1132,   503,    28,
      28,  1092,  1092,   129,  1092,   503,   503,  1092,  1116,  1183,
    1167,  1167,  1167,  1167,  1050,  1051,   502,  1092,   503,  1183,
     502,  1047,   197,   263,  1053,  1047,  1053,   197,  1052,  1053,
     197,   502,  1183,   502,  1130,    48,   163,  1037,   503,   503,
     503,  1131,  1178,  1178,   903,   250,  1006,   987,   489,  1000,
     988,   372,   503,  1182,   363,   845,   153,   786,  1092,   503,
     506,   404,    66,   870,   870,   503,   503,   893,   107,   170,
     178,   106,   387,   580,  1068,  1171,  1171,  1169,  1169,  1169,
    1169,  1181,  1169,   659,   502,   664,   664,    11,   503,   506,
     502,   503,   502,   503,   675,   503,   506,   503,   506,   661,
     666,   355,   663,   756,   760,   125,   627,   245,   245,  1182,
    1183,  1068,   580,   580,   580,   580,   489,   503,   506,   385,
     828,   871,   479,  1190,   503,   506,   659,   673,   673,   404,
     406,   589,   192,   588,   503,    48,   355,  1169,  1169,  1169,
    1169,  1179,  1169,  1169,  1177,  1177,  1068,   506,  1177,  1177,
     506,  1179,  1169,  1169,   532,   503,   506,   489,    28,   361,
     533,  1181,  1169,   363,  1168,  1168,   828,  1168,   136,   828,
    1178,  1178,  1068,   580,   580,   799,   194,   834,   834,   385,
     607,   608,   503,   506,   495,   502,   561,   611,   729,   953,
    1178,   953,   240,   245,   288,   953,   474,   953,   452,   953,
     501,   155,   183,   155,   153,   785,  1182,  1092,   240,   628,
     893,   636,   385,   653,  1175,    28,   135,   173,   616,   799,
     799,   133,   174,  1169,   385,   637,    31,   551,   502,  1169,
     122,   780,   400,   782,  1178,   585,   828,   616,   692,   271,
     685,   503,   506,   404,   651,   502,   650,   109,   121,   279,
    1169,   404,   939,   630,   708,   709,   710,   711,  1183,   656,
     153,   502,  1178,   882,   894,   895,  1184,   893,  1167,   181,
     734,   580,   580,   580,  1169,   257,   580,   849,   838,   838,
     838,   838,   153,  1093,   153,   502,  1132,   502,   503,   506,
     503,  1094,   295,   503,   390,   340,   503,   503,  1092,   503,
    1093,  1093,  1092,   503,   271,  1117,  1059,  1060,  1099,   506,
    1049,   502,  1168,  1047,   254,   385,  1054,  1047,   197,  1047,
    1066,   502,  1066,  1183,  1020,   428,   442,   471,   502,  1035,
    1036,  1092,  1092,   403,  1111,  1020,  1090,   503,  1003,  1162,
     849,   254,   849,   503,   893,   643,   256,   903,   828,   871,
     871,   296,   893,   653,   503,   363,   330,   994,   661,   665,
     503,  1068,   134,   446,   667,   665,  1130,  1130,   667,   503,
     502,   664,   503,  1169,   503,   503,   506,   799,   581,   802,
     640,   828,  1190,   679,   622,   657,   658,   659,   659,   482,
     482,   502,   588,  1181,  1169,   363,   502,  1175,   903,   812,
     502,   502,   820,   536,  1178,   532,  1178,   330,   994,  1169,
     404,   303,   404,   404,   148,   581,   834,   523,   111,   610,
     561,   612,   613,  1178,  1178,   245,   637,   495,   637,  1178,
    1178,   437,  1178,   853,    31,   908,   908,  1167,   786,   503,
     653,   221,   641,   176,   502,   791,   286,   502,   503,    22,
      70,    78,   105,   177,   346,   632,   632,   755,  1171,   503,
    1006,   755,   314,   342,   781,   502,   135,    31,   617,   503,
      48,   621,   258,   652,  1166,   651,   315,   315,    52,    60,
     215,   503,   506,  1068,   828,   868,   869,   884,   503,   506,
    1063,   733,   238,   389,   735,   736,   580,  1092,  1093,  1132,
     503,  1104,  1129,    48,   238,   421,    48,  1020,   503,   506,
      31,  1061,  1092,  1168,   503,  1092,   502,  1047,  1054,   503,
    1066,   503,   503,   502,   476,   502,   503,   506,  1112,  1113,
    1183,   503,   851,   862,   580,   870,   653,   502,   872,   872,
    1167,   653,   786,  1169,   355,    31,    11,  1020,  1020,   675,
     760,   385,   582,   661,   622,   657,   657,   591,   330,   994,
    1169,  1132,   876,   148,   815,   902,  1132,  1132,   355,   827,
     828,   827,   828,  1168,   580,   602,  1178,   503,   506,   637,
     908,    34,   172,   148,   238,   635,   154,   270,   335,   254,
     645,   646,   647,   355,   503,  1175,     5,   792,   327,   142,
     814,   585,   939,  1092,   286,  1006,   650,   649,   289,   448,
     684,   625,   656,   503,   652,    60,   257,    60,   135,   218,
     696,   710,   503,   506,   889,   894,   117,   389,   733,   503,
     503,   503,   295,   390,  1022,   289,   315,  1118,  1062,  1059,
     502,   503,  1168,   503,  1129,   502,  1129,  1036,   506,    31,
     153,   871,   401,   644,   903,   873,   873,   636,   786,  1169,
    1068,  1068,   503,   503,   503,  1092,   661,   661,   506,   355,
     503,   260,   320,   293,   816,   815,   503,   503,  1169,   404,
     449,   712,   713,   613,   122,   178,   109,   383,   254,   647,
     254,   646,  1169,   502,   503,   506,  1169,   828,    31,    31,
     503,  1175,   939,   651,   650,   502,   685,   656,   257,   257,
    1178,   502,   439,   585,   869,   893,    23,   187,   927,    42,
      87,   374,  1092,  1119,  1120,  1119,   503,  1066,   503,   503,
    1035,   503,  1113,  1115,   849,   872,   502,   786,   503,   641,
     994,   503,   503,   591,  1169,  1175,    48,   816,   994,   828,
     433,   445,   600,   474,   314,    51,   238,   307,   330,   648,
     648,   503,     5,   755,   811,  1006,   502,   652,   651,   637,
     685,   697,   982,   983,  1178,  1178,   652,   241,   502,   922,
     924,   929,   984,   989,   995,  1006,  1120,   314,   147,   277,
     147,   277,   132,  1121,  1121,   503,   503,   580,   873,  1092,
     645,   503,   994,   876,   828,   192,   139,   468,   782,    17,
     104,   245,   939,     4,   783,   784,  1177,  1178,  1186,   656,
     652,   503,   254,   698,   503,   506,   502,   699,  1063,   923,
     924,   925,  1007,  1008,    28,    87,   161,   238,   481,   503,
     786,  1167,   460,   212,   135,   503,   506,   685,   656,   479,
     687,   688,   689,    22,   444,   450,   474,  1177,   697,   983,
      86,   110,   129,   149,   164,   245,   288,   438,   454,   503,
     700,   701,   702,   703,  1186,   258,   704,   503,   505,  1120,
     314,   458,  1177,   286,   784,   685,    48,   502,   660,   479,
     686,   689,  1178,  1177,   953,   953,   240,   288,   953,   953,
     452,   953,    86,   110,   129,   149,   164,   245,   288,   438,
     454,   503,   703,   503,   506,   489,   502,   705,   717,   925,
     315,   461,   716,  1175,   684,   104,   271,   622,   662,   672,
     678,   680,   681,   357,   689,  1178,  1178,   245,   495,   637,
    1178,  1178,   437,  1178,   702,   502,   802,   503,   706,   707,
    1186,   125,   449,   713,   714,   715,   718,   502,   502,   271,
    1190,   503,   506,   659,   673,   673,   502,   637,   637,   503,
     506,  1178,   944,   433,   656,   474,   783,   637,  1190,   678,
     657,   659,   659,   663,   503,   707,  1177,  1178,   462,   468,
     503,   503,   661,   657,   657,   503,   212,   661,   661,  1177,
     716
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   508,   509,   510,   510,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     512,   512,   513,   513,   514,   514,   514,   514,   514,   515,
     515,   515,   515,   516,   517,   518,   519,   520,   521,   521,
     521,   521,   521,   521,   522,   523,   523,   524,   524,   525,
     525,   526,   526,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   528,   528,   528,
     528,   528,   528,   529,   529,   530,   531,   531,   532,   533,
     533,   534,   534,   535,   535,   536,   537,   538,   539,   539,
     540,   540,   541,   542,   542,   543,   543,   544,   544,   545,
     546,   547,   547,   548,   548,   549,   549,   549,   549,   550,
     550,   551,   551,   552,   552,   552,   552,   552,   552,   553,
     553,   553,   554,   554,   554,   555,   555,   555,   555,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     557,   557,   558,   558,   559,   559,   560,   560,   560,   560,
     561,   561,   561,   561,   562,   562,   562,   562,   562,   562,
     562,   563,   563,   563,   564,   564,   565,   566,   566,   566,
     566,   567,   567,   568,   568,   569,   569,   570,   570,   570,
     570,   570,   571,   572,   572,   573,   573,   574,   575,   575,
     575,   575,   575,   576,   576,   576,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     577,   577,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   579,   579,   580,   580,   580,   581,   581,   582,   582,
     583,   583,   583,   583,   584,   585,   585,   586,   586,   587,
     587,   587,   587,   588,   588,   589,   589,   589,   590,   590,
     590,   591,   591,   591,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   593,
     594,   594,   595,   595,   595,   595,   596,   596,   597,   597,
     598,   598,   599,   599,   600,   600,   601,   601,   601,   602,
     602,   603,   603,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     605,   605,   606,   606,   607,   607,   608,   608,   609,   609,
     610,   611,   611,   611,   611,   611,   612,   612,   613,   614,
     614,   614,   614,   615,   615,   615,   615,   615,   615,   615,
     615,   616,   616,   617,   617,   618,   618,   619,   619,   620,
     620,   620,   620,   621,   621,   622,   622,   623,   624,   625,
     625,   626,   626,   626,   626,   627,   627,   628,   628,   628,
     628,   628,   628,   628,   629,   629,   629,   629,   630,   631,
     631,   631,   632,   632,   632,   632,   632,   632,   633,   633,
     634,   634,   634,   634,   634,   634,   634,   635,   635,   636,
     636,   637,   637,   638,   639,   639,   640,   641,   641,   641,
     641,   642,   642,   643,   643,   644,   644,   645,   645,   645,
     645,   645,   646,   647,   648,   648,   648,   648,   648,   649,
     649,   650,   650,   650,   650,   651,   651,   651,   651,   652,
     652,   653,   653,   654,   655,   655,   655,   656,   656,   657,
     657,   658,   658,   659,   659,   659,   659,   660,   660,   661,
     661,   662,   662,   663,   663,   664,   664,   664,   664,   665,
     665,   665,   666,   666,   667,   667,   667,   668,   669,   670,
     670,   671,   671,   672,   672,   672,   673,   673,   674,   674,
     675,   675,   676,   676,   677,   677,   678,   678,   678,   678,
     679,   679,   679,   679,   680,   681,   682,   683,   684,   684,
     684,   685,   685,   686,   687,   687,   688,   689,   689,   689,
     689,   690,   691,   692,   692,   692,   693,   694,   694,   694,
     695,   695,   696,   696,   697,   697,   698,   698,   698,   698,
     698,   698,   699,   699,   699,   699,   700,   700,   701,   701,
     702,   702,   703,   703,   703,   703,   703,   703,   703,   703,
     703,   703,   703,   704,   704,   705,   705,   706,   706,   707,
     708,   708,   709,   709,   710,   710,   711,   712,   712,   713,
     713,   713,   714,   714,   715,   715,   716,   716,   716,   717,
     717,   718,   718,   719,   720,   721,   721,   722,   723,   724,
     724,   725,   725,   726,   726,   727,   727,   727,   727,   727,
     727,   727,   727,   727,   727,   727,   727,   728,   728,   729,
     729,   729,   729,   730,   730,   731,   731,   732,   732,   733,
     733,   734,   734,   735,   735,   736,   736,   737,   737,   738,
     738,   739,   740,   740,   741,   741,   742,   742,   743,   743,
     744,   744,   744,   745,   746,   746,   747,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   749,   750,   750,   750,   750,   751,   751,   752,   752,
     753,   753,   754,   754,   755,   755,   756,   756,   757,   758,
     758,   759,   759,   759,   759,   760,   761,   762,   763,   764,
     764,   765,   765,   766,   766,   767,   767,   768,   768,   768,
     769,   769,   770,   770,   771,   772,   772,   772,   773,   773,
     774,   775,   775,   776,   776,   776,   777,   777,   778,   778,
     778,   778,   778,   779,   779,   780,   780,   781,   781,   782,
     782,   783,   783,   783,   784,   784,   784,   784,   785,   785,
     786,   786,   787,   787,   787,   787,   787,   787,   788,   788,
     789,   789,   790,   790,   791,   792,   792,   793,   794,   794,
     794,   794,   795,   796,   797,   797,   797,   797,   797,   797,
     797,   797,   797,   797,   797,   797,   797,   797,   797,   798,
     798,   799,   800,   800,   801,   801,   802,   802,   802,   802,
     802,   802,   802,   803,   804,   804,   805,   806,   806,   807,
     807,   808,   808,   808,   809,   809,   810,   811,   811,   812,
     812,   812,   812,   812,   813,   813,   814,   814,   815,   815,
     815,   816,   816,   817,   818,   818,   819,   819,   820,   820,
     821,   821,   822,   822,   823,   824,   825,   825,   825,   825,
     826,   826,   826,   826,   826,   826,   826,   826,   826,   826,
     826,   826,   826,   826,   826,   826,   826,   826,   826,   826,
     827,   827,   828,   828,   829,   829,   830,   831,   831,   831,
     832,   832,   832,   832,   832,   832,   832,   832,   832,   832,
     832,   832,   832,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   833,   833,
     833,   833,   833,   833,   833,   833,   833,   833,   834,   834,
     835,   835,   835,   835,   835,   836,   836,   837,   837,   837,
     837,   837,   837,   837,   837,   837,   837,   837,   837,   837,
     838,   838,   839,   839,   840,   840,   840,   840,   840,   840,
     840,   840,   840,   840,   840,   840,   840,   840,   840,   840,
     841,   841,   842,   842,   843,   844,   844,   845,   845,   845,
     845,   845,   846,   846,   847,   847,   847,   847,   848,   848,
     848,   848,   848,   848,   848,   848,   848,   848,   848,   848,
     848,   848,   848,   848,   848,   849,   849,   850,   850,   851,
     851,   852,   852,   853,   854,   855,   855,   856,   856,   857,
     857,   858,   859,   859,   860,   860,   860,   861,   861,   861,
     862,   862,   862,   862,   863,   864,   864,   865,   865,   866,
     866,   867,   867,   868,   868,   869,   869,   869,   870,   870,
     871,   871,   871,   872,   872,   872,   873,   873,   873,   874,
     874,   874,   875,   875,   876,   876,   877,   877,   878,   878,
     879,   879,   880,   880,   880,   880,   880,   881,   881,   881,
     881,   881,   882,   883,   884,   884,   884,   885,   885,   885,
     886,   887,   887,   887,   887,   888,   888,   889,   889,   890,
     890,   890,   890,   890,   890,   890,   890,   890,   890,   890,
     890,   890,   890,   890,   890,   890,   890,   890,   890,   890,
     890,   890,   891,   891,   891,   891,   892,   892,   893,   893,
     894,   895,   895,   896,   897,   897,   898,   898,   899,   899,
     900,   900,   901,   901,   902,   902,   902,   902,   903,   903,
     904,   905,   905,   906,   906,   907,   907,   907,   908,   908,
     908,   909,   910,   910,   911,   911,   911,   912,   912,   913,
     913,   914,   915,   915,   916,   916,   916,   916,   916,   916,
     916,   916,   916,   916,   916,   916,   916,   916,   916,   916,
     916,   916,   916,   916,   916,   916,   916,   916,   916,   916,
     916,   916,   916,   916,   916,   916,   916,   916,   916,   916,
     916,   916,   916,   916,   916,   916,   916,   916,   916,   916,
     917,   917,   918,   918,   919,   919,   919,   919,   919,   919,
     919,   919,   919,   919,   919,   919,   919,   919,   919,   919,
     919,   919,   919,   919,   919,   919,   919,   919,   920,   920,
     920,   920,   920,   920,   920,   920,   920,   920,   920,   920,
     920,   920,   920,   920,   920,   920,   920,   920,   921,   922,
     922,   922,   923,   923,   924,   924,   924,   924,   924,   925,
     925,   926,   926,   926,   926,   927,   927,   927,   928,   928,
     929,   930,   930,   931,   932,   932,   933,   933,   933,   933,
     933,   933,   933,   933,   933,   933,   933,   933,   933,   933,
     934,   934,   934,   935,   935,   935,   935,   935,   936,   936,
     936,   937,   937,   938,   938,   938,   938,   939,   939,   939,
     939,   940,   941,   942,   942,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
     943,   944,   944,   945,   945,   946,   947,   947,   948,   949,
     949,   950,   950,   951,   952,   952,   952,   952,   952,   952,
     952,   953,   953,   954,   955,   955,   955,   955,   955,   955,
     956,   957,   957,   957,   958,   958,   959,   959,   959,   959,
     959,   960,   960,   961,   961,   961,   961,   962,   962,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   967,
     967,   968,   968,   969,   969,   969,   969,   970,   970,   970,
     970,   970,   970,   970,   970,   970,   970,   971,   971,   972,
     972,   973,   974,   974,   975,   975,   975,   976,   977,   977,
     978,   978,   978,   978,   979,   979,   980,   980,   981,   981,
     981,   981,   982,   982,   983,   984,   985,   985,   985,   986,
     986,   987,   988,   988,   989,   990,   990,   991,   992,   992,
     993,   993,   993,   993,   993,   993,   993,   993,   994,   994,
     995,   996,   996,   997,   997,   998,   999,  1000,  1001,  1001,
    1002,  1003,  1004,  1004,  1004,  1004,  1004,  1005,  1005,  1005,
    1006,  1006,  1007,  1007,  1008,  1008,  1008,  1008,  1008,  1008,
    1008,  1008,  1009,  1009,  1010,  1010,  1010,  1010,  1010,  1010,
    1011,  1011,  1012,  1012,  1013,  1014,  1014,  1015,  1015,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1017,  1017,
    1018,  1018,  1018,  1019,  1019,  1019,  1019,  1020,  1020,  1021,
    1022,  1022,  1023,  1023,  1024,  1024,  1024,  1024,  1025,  1025,
    1026,  1026,  1026,  1026,  1027,  1027,  1028,  1028,  1029,  1030,
    1030,  1030,  1031,  1031,  1032,  1032,  1033,  1033,  1034,  1034,
    1035,  1035,  1036,  1036,  1036,  1036,  1036,  1037,  1037,  1038,
    1038,  1039,  1039,  1040,  1040,  1041,  1042,  1042,  1042,  1042,
    1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,  1047,  1047,
    1047,  1047,  1047,  1047,  1047,  1048,  1048,  1048,  1048,  1048,
    1048,  1049,  1049,  1049,  1049,  1050,  1050,  1051,  1051,  1051,
    1051,  1051,  1052,  1052,  1052,  1052,  1053,  1053,  1054,  1054,
    1055,  1055,  1055,  1055,  1056,  1056,  1057,  1057,  1057,  1058,
    1058,  1059,  1060,  1060,  1061,  1061,  1062,  1062,  1063,  1063,
    1064,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1068,  1068,
    1068,  1068,  1068,  1068,  1069,  1069,  1069,  1070,  1070,  1070,
    1070,  1070,  1070,  1070,  1071,  1071,  1071,  1071,  1072,  1072,
    1073,  1073,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1075,  1075,  1076,  1076,  1077,  1077,  1078,
    1079,  1080,  1080,  1081,  1081,  1082,  1083,  1084,  1084,  1084,
    1084,  1084,  1084,  1085,  1085,  1086,  1086,  1087,  1087,  1087,
    1087,  1088,  1089,  1089,  1089,  1090,  1090,  1090,  1090,  1090,
    1090,  1090,  1090,  1090,  1090,  1090,  1090,  1090,  1090,  1091,
    1091,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1095,  1095,  1095,  1096,
    1097,  1097,  1097,  1097,  1097,  1097,  1097,  1098,  1098,  1099,
    1099,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1101,  1101,
    1102,  1102,  1102,  1102,  1103,  1104,  1104,  1105,  1105,  1106,
    1106,  1107,  1107,  1107,  1108,  1108,  1108,  1108,  1109,  1109,
    1110,  1110,  1111,  1111,  1112,  1112,  1113,  1114,  1114,  1114,
    1115,  1116,  1116,  1117,  1117,  1118,  1118,  1118,  1119,  1119,
    1120,  1120,  1120,  1120,  1120,  1121,  1121,  1121,  1121,  1121,
    1122,  1122,  1122,  1123,  1123,  1123,  1124,  1124,  1125,  1125,
    1125,  1125,  1125,  1125,  1125,  1125,  1125,  1126,  1126,  1127,
    1127,  1128,  1128,  1128,  1128,  1128,  1128,  1129,  1129,  1130,
    1130,  1131,  1131,  1132,  1132,  1133,  1133,  1133,  1134,  1134,
    1135,  1135,  1136,  1136,  1136,  1136,  1136,  1136,  1136,  1136,
    1137,  1137,  1138,  1139,  1139,  1140,  1140,  1140,  1140,  1140,
    1140,  1141,  1142,  1143,  1143,  1143,  1144,  1144,  1145,  1146,
    1146,  1147,  1148,  1148,  1149,  1149,  1150,  1150,  1151,  1152,
    1152,  1153,  1154,  1154,  1155,  1155,  1156,  1156,  1156,  1156,
    1157,  1157,  1158,  1158,  1159,  1159,  1160,  1160,  1161,  1161,
    1162,  1163,  1163,  1164,  1164,  1165,  1165,  1165,  1165,  1165,
    1166,  1166,  1167,  1167,  1168,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1175,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1177,  1178,  1179,
    1180,  1181,  1181,  1182,  1182,  1182,  1183,  1183,  1183,  1184,
    1184,  1184,  1185,  1185,  1185,  1185,  1186,  1186,  1186,  1186,
    1186,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,  1187,
    1187,  1187,  1188,  1189,  1189,  1189,  1189,  1189,  1190,  1190,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,  1191,
    1191,  1191,  1191,  1191,  1191,  1191,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,
    1192,  1192,  1192,  1192,  1192,  1192,  1192,  1192,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       5,     7,     2,     0,     3,     3,     3,     1,     1,     5,
       7,     7,     9,     4,     6,     4,     6,     1,     2,     2,
       2,     2,     2,     2,     5,     1,     0,     2,     0,     2,
       0,     1,     4,     2,     2,     3,     3,     1,     3,     3,
       3,     3,     2,     2,     2,     1,     1,     1,     2,     2,
       2,     3,     3,     2,     2,     4,     1,     1,     3,     2,
       0,     3,     0,     1,     3,     3,     5,     5,     0,     3,
       5,     5,     5,     5,     5,     3,     5,     3,     5,     5,
       6,     1,     1,     3,     5,     6,     4,     9,     7,     1,
       0,     2,     0,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     2,     5,     1,     3,     3,     3,     3,     1,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       1,     3,     1,     3,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     6,     1,     1,
       1,     1,     1,     0,     1,     1,     2,     1,     2,     3,
       2,     1,     1,     2,     1,     2,     1,     2,     3,     4,
       3,     2,     4,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     4,     6,     5,    10,    13,     4,     6,
      10,    13,     4,     6,     4,     6,     5,     7,    11,    14,
       1,     3,     2,     3,     4,     6,     6,     6,     5,     5,
       6,     6,     4,     8,     4,     2,     4,     3,     6,     4,
       3,     3,     3,     3,     3,     4,     4,     3,     3,     3,
       3,     3,     3,     4,     4,     3,     2,     3,     2,     4,
       3,     1,     2,     2,     2,     3,     3,     2,     2,     3,
       1,     3,     2,     1,     1,     0,     2,     0,     2,     0,
       1,     1,     1,     3,     3,     2,     0,     1,     3,     3,
       1,     5,     3,     6,     0,     2,     2,     0,     1,     4,
       8,     2,     3,     2,     5,     7,     6,     3,     6,     6,
       3,     2,     6,     4,     6,     5,     6,     7,     3,     4,
       1,     3,     4,     6,     4,     8,     2,     2,    13,     7,
       1,     1,     1,     0,     3,     0,     1,     1,     1,     1,
       3,     2,     0,     1,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     3,     4,     3,     2,     3,     3,     2,
       1,     0,     2,     0,     3,     0,     1,     0,     1,     3,
       2,     1,     1,     1,     3,     0,     1,     3,     1,    13,
      16,    12,    15,     1,     1,     2,     2,     2,     2,     1,
       0,     1,     0,     3,     0,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     4,     4,     5,     4,     2,
       0,     3,     1,     1,     2,     2,     0,     2,     1,     3,
       4,     5,     2,     5,     1,     2,     2,     2,     3,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     3,     1,
       5,     7,     3,     8,     4,     9,    11,     2,     0,     3,
       0,     1,     3,     1,     1,     3,     2,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     2,     2,     4,
       0,     2,     2,     2,     0,     3,     4,     4,     0,     2,
       0,     4,     0,     3,     5,     2,     2,     1,     0,     1,
       0,     1,     2,     4,     2,     2,     0,     3,     0,     3,
       0,     1,     3,     1,     3,     1,     6,     3,     2,     1,
       3,     5,     1,     3,     1,     1,     0,     5,     5,     4,
       0,     1,     0,     1,     3,     2,     1,     0,     3,     5,
       1,     3,     4,     4,     1,     1,     5,     5,     4,     1,
       5,     5,     4,     1,     2,     3,     2,     3,     1,     1,
       0,     8,     0,     5,     1,     0,     6,     2,     1,     2,
       3,     9,     5,     2,     3,     0,    18,     1,     1,     0,
       1,     0,     5,     3,     2,     0,     2,     3,     2,     2,
       3,     2,     3,     3,     2,     0,     1,     2,     1,     3,
       3,     5,     3,     3,     1,     1,     3,     3,     4,     3,
       3,     3,     3,     2,     0,     3,     2,     1,     3,     2,
       1,     0,     1,     3,     1,     1,     2,     6,     0,     4,
       2,     0,     6,     0,     1,     3,     1,     1,     0,     2,
       0,     3,     3,     9,     4,     1,     0,     6,     5,     4,
       6,     1,     0,     1,     2,     2,     1,     2,     3,     2,
       2,     2,     2,     3,     3,     1,     3,     1,     0,     1,
       2,     2,     1,     1,     3,     6,    10,     1,     0,     1,
       2,     2,     0,     2,     2,     1,     0,     5,     7,     1,
       0,     7,     2,     0,     3,     5,     5,     8,     2,     0,
       2,     2,     2,     5,     2,     0,     2,     7,    10,     6,
       6,     6,     6,     7,     7,     9,     9,     6,     7,     6,
       8,     8,     8,     8,     6,     6,     7,     7,     8,     6,
       6,     7,     2,     2,     2,     2,     1,     2,     1,     0,
       6,     8,     7,     6,     4,     0,     1,     3,     4,     1,
       3,     1,     2,     2,     2,     2,     1,     1,    10,     2,
       0,     2,     2,     1,     0,     4,     6,     5,     4,     4,
      10,    13,     5,     7,     8,     1,     1,     1,     7,     9,
       8,    15,    20,     1,     1,     2,     1,     3,     1,     1,
       1,     3,     1,     3,     0,     1,     0,     1,     1,     4,
       0,     1,     3,     0,     1,     1,     1,     1,     2,     0,
       0,     2,     2,     1,     2,     2,     2,     2,     6,     8,
      11,    13,     1,     3,     5,     1,     3,     5,     1,     2,
       2,     1,     8,     4,     6,     5,     4,     4,     3,     7,
       6,     8,     6,     6,     6,     6,     6,     4,     5,     1,
       0,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     7,     9,     9,     3,     0,    13,     1,     3,     5,
       6,     4,     7,     2,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     6,     8,     8,     1,     3,     5,     5,
       7,     9,     7,     9,     5,     6,     6,     4,     5,     7,
       1,     2,     3,     1,     1,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     1,     2,     2,     3,     5,     2,     2,     0,
       6,     7,     7,     7,     8,     8,     6,     8,     9,     9,
       7,    10,     7,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     1,
       3,     2,     3,     3,     3,     3,     2,     2,     1,     1,
       8,     9,     9,     9,     9,     2,     0,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     2,     1,     2,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     3,     4,     4,
       1,     1,     1,     0,     7,     7,    10,     1,     1,     2,
       4,     5,     1,     3,     2,     2,     2,     2,     1,     2,
       2,     4,     3,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     5,     5,     5,     1,     3,     1,     2,     3,
       0,     1,     3,     2,     6,     6,     9,     3,     0,     3,
       0,     5,     2,     0,     3,     3,     3,     7,     7,    10,
       1,     1,     1,     1,    14,     1,     0,     1,     0,     1,
       0,     2,     0,     1,     3,     5,     5,     7,     2,     0,
       1,     2,     0,     1,     1,     0,     1,     1,     0,     9,
      12,     7,     2,     0,     3,     2,     1,     3,     3,     2,
       1,     3,     3,     3,     2,     2,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     4,     5,     1,     3,     3,
       1,     3,     3,     5,     6,     1,     3,     1,     2,     4,
       5,     1,     1,     1,     1,     3,     3,     2,     2,     1,
       2,     2,     2,     1,     2,     2,     3,     3,     3,     3,
       3,     4,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     7,     5,     5,     7,     6,     6,     6,     6,     8,
       8,     6,     6,     7,     9,     9,     6,     6,     6,     8,
       6,     8,     6,     8,     7,     9,     6,     8,     7,     9,
       8,    10,     9,    11,     8,     9,    11,     8,     8,     7,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     6,
       1,     0,     2,     0,     7,     6,     6,     6,     6,     6,
       7,     9,     9,     6,     8,     8,     8,     8,     8,     6,
       8,     6,     8,     7,     9,     7,     9,     6,     7,     6,
       6,     6,     6,     6,     7,     7,     7,     9,     9,     6,
       6,     6,     6,     8,     8,     8,     6,     7,    13,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     6,     8,
       3,     2,     0,     2,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     3,     2,     5,     4,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     2,     1,     3,
       2,     1,     0,     9,    11,    12,    14,     3,     4,     4,
       0,     2,     5,     2,     0,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     1,     0,     5,     6,     4,     2,     0,     4,     3,
       5,     4,     4,     6,     4,     6,     6,     5,     7,     9,
       6,     1,     0,     6,    11,    11,    11,    13,     9,    11,
      10,     4,     2,     5,     2,     0,     4,     5,     5,     4,
       6,     1,     3,     1,     1,     1,     1,     3,     4,     5,
       5,     1,     1,     1,     0,     2,     0,     1,     0,     1,
       0,     3,     0,     2,     5,     4,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     3,     0,
       1,     1,     1,     1,     3,     9,     3,     0,     2,     3,
       2,     3,     1,     3,     1,     6,     1,     4,     2,     1,
       3,     2,     2,     0,     7,     2,     0,     5,     3,     0,
       2,     2,     2,     3,     1,     3,     1,     2,     1,     0,
       8,     1,     3,     1,     1,     3,     5,     2,     1,     3,
       7,     1,     0,     3,     2,     2,     2,     0,     2,     2,
       1,     1,     3,     3,     1,     2,     4,     4,     2,     3,
       5,     5,     1,     1,     9,     1,     2,     4,     4,     4,
       2,     3,     1,     3,     6,     1,     0,     2,     0,     3,
       3,     4,     4,     4,     4,     3,     2,     1,     1,     0,
       1,     1,     0,     1,     5,     1,     0,     1,     0,     3,
       1,     3,     4,     3,     2,     2,     1,     1,     1,     0,
       2,     4,     5,     4,     2,     3,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     3,     0,
       1,     3,     1,     4,     4,     5,     2,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     2,
       3,     2,     3,     1,     4,     3,     4,     5,     4,     5,
       4,     5,     2,     4,     1,     1,     0,     1,     4,     5,
       4,     0,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     2,
       6,     2,     1,     3,     4,     0,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     1,     3,     3,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     5,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     5,     2,     2,     2,     1,
       3,     3,     2,     1,     0,     3,     0,     5,     2,     5,
       2,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     2,     3,     5,     4,     6,     3,     5,     4,     6,
       4,     6,     5,     7,     3,     2,     4,     2,     3,     3,
       4,     3,     4,     3,     4,     5,     6,     6,     7,     6,
       7,     6,     7,     3,     4,     4,     6,     2,     3,     4,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     5,     6,     6,     7,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     1,
       2,     2,     2,     2,     4,     1,     0,     2,     3,     2,
       3,     5,     6,     8,     6,     6,     4,     4,     1,     1,
       1,     5,     1,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       4,     4,     6,     5,     5,     5,     4,     6,     4,     4,
       4,     4,     3,     4,     6,     4,     5,     7,     7,     9,
       5,     6,     4,     6,     5,     7,     7,     7,     2,     3,
       3,     3,     4,     0,     4,     1,     3,     3,     1,     1,
       1,     2,     2,     0,     2,     4,     4,     6,     5,     0,
       5,     0,     2,     0,     1,     3,     3,     2,     2,     0,
       6,     1,     0,     3,     0,     3,     3,     0,     1,     4,
       2,     2,     2,     2,     2,     3,     2,     2,     3,     0,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       4,     1,     4,     1,     2,     1,     2,     1,     3,     1,
       3,     1,     3,     1,     3,     3,     3,     2,     1,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     2,     3,     0,     3,     3,     2,     2,     1,
       0,     2,     2,     3,     2,     1,     1,     3,     5,     1,
       2,     4,     1,     5,     2,     0,     1,     0,     6,     1,
       2,     4,     2,     0,     1,     2,     2,     2,     3,     5,
       1,     2,     0,     2,     1,     0,     1,     1,     1,     3,
       3,     1,     0,     1,     3,     3,     2,     2,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       6,     2,     3,     6,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, core_yyscan_t yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 1137 "gram.y"
                        {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 27066 "gram.c"
    break;

  case 3:
#line 1144 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 27077 "gram.c"
    break;

  case 4:
#line 1151 "gram.y"
                                {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 27088 "gram.c"
    break;

  case 129:
#line 1285 "gram.y"
                                { (yyval.node) = NULL; }
#line 27094 "gram.c"
    break;

  case 130:
#line 1296 "gram.y"
                                {
					CreateQueueStmt *n = makeNode(CreateQueueStmt);
					DefElem         *def1 = /* mark start of WITH items */
						makeDefElem("withliststart", 
									(Node *)makeInteger(TRUE));
					n->queue = (yyvsp[-1].str);
					n->options = list_concat(lappend((yyvsp[0].list), def1), NULL); 
					(yyval.node) = (Node *)n;
				}
#line 27108 "gram.c"
    break;

  case 131:
#line 1306 "gram.y"
                                {
					CreateQueueStmt *n    = makeNode(CreateQueueStmt);
					DefElem         *def1 = /* mark start of WITH items */
						makeDefElem("withliststart", 
									(Node *)makeInteger(TRUE));
					n->queue = (yyvsp[-3].str);
					n->options = list_concat(lappend((yyvsp[-2].list), def1), (yyvsp[0].list)); 
					(yyval.node) = (Node *)n;
				}
#line 27122 "gram.c"
    break;

  case 132:
#line 1321 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27128 "gram.c"
    break;

  case 133:
#line 1322 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 27134 "gram.c"
    break;

  case 134:
#line 1327 "gram.y"
                                {
					/* was "activelimit" */
					(yyval.defelt) = makeDefElem("active_statements", (Node *)(yyvsp[0].value));
				}
#line 27143 "gram.c"
    break;

  case 135:
#line 1332 "gram.y"
                                {
					/* was "costlimit" */
					(yyval.defelt) = makeDefElem("max_cost", (Node *)(yyvsp[0].value));
				}
#line 27152 "gram.c"
    break;

  case 136:
#line 1337 "gram.y"
                                {
					/* was "ignorecostlimit" */
					(yyval.defelt) = makeDefElem("min_cost", (Node *)(yyvsp[0].value));
				}
#line 27161 "gram.c"
    break;

  case 137:
#line 1342 "gram.y"
                                {
					/* was "overcommit" */
					(yyval.defelt) = makeDefElem("cost_overcommit", (Node *)makeInteger(TRUE));
				}
#line 27170 "gram.c"
    break;

  case 138:
#line 1347 "gram.y"
                                {
					/* was "overcommit" */
					(yyval.defelt) = makeDefElem("cost_overcommit", (Node *)makeInteger(FALSE));
				}
#line 27179 "gram.c"
    break;

  case 139:
#line 1361 "gram.y"
                                 {
					AlterQueueStmt *n = makeNode(AlterQueueStmt);
					n->queue = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27190 "gram.c"
    break;

  case 140:
#line 1368 "gram.y"
                                 {
					AlterQueueStmt *n    = makeNode(AlterQueueStmt);
					DefElem        *def1 = /* mark start of WITH items */
						makeDefElem("withliststart", 
									(Node *)makeInteger(TRUE));
					DefElem        *def2 = /* mark start of WITHOUT items */
						makeDefElem("withoutliststart", 
									(Node *)makeInteger(TRUE));
					n->queue = (yyvsp[-3].str);
					n->options = list_concat(lappend((yyvsp[-2].list), def1), (yyvsp[0].list)); 
					n->options = lappend(n->options, def2); 
					(yyval.node) = (Node *)n;
				 }
#line 27208 "gram.c"
    break;

  case 141:
#line 1382 "gram.y"
                                 {
					AlterQueueStmt *n    = makeNode(AlterQueueStmt);
					DefElem        *def1 = /* mark start of WITH items */
						makeDefElem("withliststart", 
									(Node *)makeInteger(TRUE));
					DefElem        *def2 = /* mark start of WITHOUT items */
						makeDefElem("withoutliststart", 
									(Node *)makeInteger(TRUE));
					n->queue = (yyvsp[-3].str);
					n->options = lappend((yyvsp[-2].list), def1); 
					n->options = list_concat(lappend(n->options, def2), (yyvsp[0].list)); 
					(yyval.node) = (Node *)n;
				 }
#line 27226 "gram.c"
    break;

  case 142:
#line 1397 "gram.y"
                                 {
					AlterQueueStmt *n    = makeNode(AlterQueueStmt);
					DefElem        *def1 = /* mark start of WITH items */
						makeDefElem("withliststart", 
									(Node *)makeInteger(TRUE));
					DefElem        *def2 = /* mark start of WITHOUT items */
						makeDefElem("withoutliststart", 
									(Node *)makeInteger(TRUE));
					n->queue = (yyvsp[-5].str);
					n->options = list_concat(lappend((yyvsp[-4].list), def1), (yyvsp[-2].list)); 
					n->options = list_concat(lappend(n->options, def2), (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				 }
#line 27244 "gram.c"
    break;

  case 143:
#line 1420 "gram.y"
                                 {
					DropQueueStmt *n = makeNode(DropQueueStmt);
					n->queue = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				 }
#line 27254 "gram.c"
    break;

  case 144:
#line 1435 "gram.y"
                                {
					CreateResourceGroupStmt *n = makeNode(CreateResourceGroupStmt);
					n->name = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27265 "gram.c"
    break;

  case 145:
#line 1451 "gram.y"
                                 {
					DropResourceGroupStmt *n = makeNode(DropResourceGroupStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				 }
#line 27275 "gram.c"
    break;

  case 146:
#line 1465 "gram.y"
                                 {
					AlterResourceGroupStmt *n = makeNode(AlterResourceGroupStmt);
					n->name = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27286 "gram.c"
    break;

  case 147:
#line 1476 "gram.y"
                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27292 "gram.c"
    break;

  case 148:
#line 1481 "gram.y"
                                {
					/* was "concurrency" */
					(yyval.defelt) = makeDefElem("concurrency", (Node *) makeInteger((yyvsp[0].ival)));
				}
#line 27301 "gram.c"
    break;

  case 149:
#line 1486 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cpu_rate_limit", (Node *) makeInteger((yyvsp[0].ival)));
				}
#line 27309 "gram.c"
    break;

  case 150:
#line 1490 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cpuset", (Node *) makeString((yyvsp[0].str)));
				}
#line 27317 "gram.c"
    break;

  case 151:
#line 1494 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("memory_shared_quota", (Node *) makeInteger((yyvsp[0].ival)));
				}
#line 27325 "gram.c"
    break;

  case 152:
#line 1498 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("memory_limit", (Node *) makeInteger((yyvsp[0].ival)));
				}
#line 27333 "gram.c"
    break;

  case 153:
#line 1502 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("memory_spill_ratio", (Node *) makeInteger((yyvsp[0].ival)));
				}
#line 27341 "gram.c"
    break;

  case 154:
#line 1515 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27353 "gram.c"
    break;

  case 155:
#line 1525 "gram.y"
                                                                                        {}
#line 27359 "gram.c"
    break;

  case 156:
#line 1526 "gram.y"
                                                                                                {}
#line 27365 "gram.c"
    break;

  case 157:
#line 1535 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27371 "gram.c"
    break;

  case 158:
#line 1536 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 27377 "gram.c"
    break;

  case 159:
#line 1540 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27383 "gram.c"
    break;

  case 160:
#line 1541 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 27389 "gram.c"
    break;

  case 161:
#line 1551 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 27395 "gram.c"
    break;

  case 162:
#line 1552 "gram.y"
                                                        { (yyval.defelt) = makeDefElem("drop_deny", (yyvsp[0].node)); }
#line 27401 "gram.c"
    break;

  case 163:
#line 1557 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 27410 "gram.c"
    break;

  case 164:
#line 1562 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 27418 "gram.c"
    break;

  case 165:
#line 1566 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 27427 "gram.c"
    break;

  case 166:
#line 1571 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 27436 "gram.c"
    break;

  case 167:
#line 1576 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 27444 "gram.c"
    break;

  case 168:
#line 1580 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 27452 "gram.c"
    break;

  case 169:
#line 1584 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 27460 "gram.c"
    break;

  case 170:
#line 1588 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("resourceQueue", (Node *)(yyvsp[0].list));
				}
#line 27468 "gram.c"
    break;

  case 171:
#line 1592 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("resourceGroup", (Node *)(yyvsp[0].list));
				}
#line 27476 "gram.c"
    break;

  case 172:
#line 1596 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exttabauth", (Node *)(yyvsp[0].list));
				}
#line 27484 "gram.c"
    break;

  case 173:
#line 1600 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exttabnoauth", (Node *)(yyvsp[0].list));
				}
#line 27492 "gram.c"
    break;

  case 174:
#line 1605 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 27500 "gram.c"
    break;

  case 175:
#line 1609 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("deny", (Node *)(yyvsp[0].node));
				}
#line 27508 "gram.c"
    break;

  case 176:
#line 1613 "gram.y"
                                {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 27563 "gram.c"
    break;

  case 177:
#line 1666 "gram.y"
                                                                { (yyval.defelt) = (yyvsp[0].defelt); }
#line 27569 "gram.c"
    break;

  case 178:
#line 1669 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 27577 "gram.c"
    break;

  case 179:
#line 1673 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 27585 "gram.c"
    break;

  case 180:
#line 1677 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 27593 "gram.c"
    break;

  case 181:
#line 1681 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 27601 "gram.c"
    break;

  case 182:
#line 1685 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 27609 "gram.c"
    break;

  case 183:
#line 1690 "gram.y"
                                    { (yyval.node) = (Node *)(yyvsp[0].node); }
#line 27615 "gram.c"
    break;

  case 184:
#line 1691 "gram.y"
                                          { (yyval.node) = (Node *)(yyvsp[0].node); }
#line 27621 "gram.c"
    break;

  case 185:
#line 1695 "gram.y"
                                {
					DenyLoginInterval *n = makeNode(DenyLoginInterval);
					n->start = (DenyLoginPoint *)(yyvsp[-2].node);
					n->end = (DenyLoginPoint *)(yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27632 "gram.c"
    break;

  case 186:
#line 1703 "gram.y"
                           { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 27638 "gram.c"
    break;

  case 187:
#line 1704 "gram.y"
                                 { (yyval.node) = (Node *)makeInteger((yyvsp[0].ival)); }
#line 27644 "gram.c"
    break;

  case 188:
#line 1708 "gram.y"
                                {
					DenyLoginPoint *n = makeNode(DenyLoginPoint);
					n->day = (Value *)(yyvsp[-1].node);
					n->time = (Value *)(yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27655 "gram.c"
    break;

  case 189:
#line 1716 "gram.y"
                      { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 27661 "gram.c"
    break;

  case 190:
#line 1717 "gram.y"
                                { (yyval.node) = NULL; }
#line 27667 "gram.c"
    break;

  case 191:
#line 1721 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 27673 "gram.c"
    break;

  case 192:
#line 1722 "gram.y"
                                                        { (yyval.list) = NIL; }
#line 27679 "gram.c"
    break;

  case 193:
#line 1726 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27685 "gram.c"
    break;

  case 194:
#line 1727 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 27691 "gram.c"
    break;

  case 195:
#line 1732 "gram.y"
                {
			(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)));
		}
#line 27699 "gram.c"
    break;

  case 196:
#line 1746 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27711 "gram.c"
    break;

  case 197:
#line 1764 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27723 "gram.c"
    break;

  case 198:
#line 1774 "gram.y"
                                                                        { (yyval.str) = NULL; }
#line 27729 "gram.c"
    break;

  case 199:
#line 1775 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 27735 "gram.c"
    break;

  case 200:
#line 1780 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27747 "gram.c"
    break;

  case 201:
#line 1788 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27759 "gram.c"
    break;

  case 202:
#line 1806 "gram.y"
                                 {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27771 "gram.c"
    break;

  case 203:
#line 1818 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27783 "gram.c"
    break;

  case 204:
#line 1826 "gram.y"
                                {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27795 "gram.c"
    break;

  case 205:
#line 1847 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27806 "gram.c"
    break;

  case 206:
#line 1854 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27817 "gram.c"
    break;

  case 207:
#line 1873 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27828 "gram.c"
    break;

  case 208:
#line 1880 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27839 "gram.c"
    break;

  case 209:
#line 1897 "gram.y"
                                {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27851 "gram.c"
    break;

  case 210:
#line 1915 "gram.y"
                                {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 27864 "gram.c"
    break;

  case 211:
#line 1925 "gram.y"
                                                                                        { (yyval.ival) = +1; }
#line 27870 "gram.c"
    break;

  case 212:
#line 1926 "gram.y"
                                                                                                { (yyval.ival) = -1; }
#line 27876 "gram.c"
    break;

  case 213:
#line 1939 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27887 "gram.c"
    break;

  case 214:
#line 1946 "gram.y"
                                {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27898 "gram.c"
    break;

  case 215:
#line 1963 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 27915 "gram.c"
    break;

  case 216:
#line 1976 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 27929 "gram.c"
    break;

  case 217:
#line 1986 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 27951 "gram.c"
    break;

  case 218:
#line 2004 "gram.y"
                                {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 27970 "gram.c"
    break;

  case 219:
#line 2021 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 27976 "gram.c"
    break;

  case 220:
#line 2022 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 27982 "gram.c"
    break;

  case 221:
#line 2027 "gram.y"
                                {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 27992 "gram.c"
    break;

  case 222:
#line 2033 "gram.y"
                                { (yyval.list) = NIL; }
#line 27998 "gram.c"
    break;

  case 229:
#line 2061 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28008 "gram.c"
    break;

  case 230:
#line 2067 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28018 "gram.c"
    break;

  case 231:
#line 2073 "gram.y"
                                {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28028 "gram.c"
    break;

  case 232:
#line 2082 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28040 "gram.c"
    break;

  case 233:
#line 2090 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28052 "gram.c"
    break;

  case 235:
#line 2102 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28064 "gram.c"
    break;

  case 236:
#line 2110 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28076 "gram.c"
    break;

  case 237:
#line 2118 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28087 "gram.c"
    break;

  case 238:
#line 2125 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28098 "gram.c"
    break;

  case 239:
#line 2134 "gram.y"
                                                                                {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 28104 "gram.c"
    break;

  case 240:
#line 2136 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28115 "gram.c"
    break;

  case 241:
#line 2144 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28130 "gram.c"
    break;

  case 242:
#line 2155 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 28142 "gram.c"
    break;

  case 243:
#line 2163 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28154 "gram.c"
    break;

  case 244:
#line 2171 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28169 "gram.c"
    break;

  case 245:
#line 2182 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28181 "gram.c"
    break;

  case 246:
#line 2190 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28193 "gram.c"
    break;

  case 247:
#line 2198 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28204 "gram.c"
    break;

  case 248:
#line 2205 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28216 "gram.c"
    break;

  case 249:
#line 2214 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28228 "gram.c"
    break;

  case 250:
#line 2223 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 28234 "gram.c"
    break;

  case 251:
#line 2225 "gram.y"
                                { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 28240 "gram.c"
    break;

  case 252:
#line 2228 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28246 "gram.c"
    break;

  case 253:
#line 2229 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28252 "gram.c"
    break;

  case 254:
#line 2233 "gram.y"
                                { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 28258 "gram.c"
    break;

  case 255:
#line 2235 "gram.y"
                                { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28264 "gram.c"
    break;

  case 256:
#line 2238 "gram.y"
                                                                                { (yyval.str) = "read uncommitted"; }
#line 28270 "gram.c"
    break;

  case 257:
#line 2239 "gram.y"
                                                                                        { (yyval.str) = "read committed"; }
#line 28276 "gram.c"
    break;

  case 258:
#line 2240 "gram.y"
                                                                                        { (yyval.str) = "repeatable read"; }
#line 28282 "gram.c"
    break;

  case 259:
#line 2241 "gram.y"
                                                                                        { (yyval.str) = "serializable"; }
#line 28288 "gram.c"
    break;

  case 260:
#line 2245 "gram.y"
                                                                                                { (yyval.str) = "true"; }
#line 28294 "gram.c"
    break;

  case 261:
#line 2246 "gram.y"
                                                                                                { (yyval.str) = "false"; }
#line 28300 "gram.c"
    break;

  case 262:
#line 2247 "gram.y"
                                                                                                { (yyval.str) = "on"; }
#line 28306 "gram.c"
    break;

  case 263:
#line 2253 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 28312 "gram.c"
    break;

  case 264:
#line 2266 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28320 "gram.c"
    break;

  case 265:
#line 2270 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28328 "gram.c"
    break;

  case 266:
#line 2274 "gram.y"
                                {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 28347 "gram.c"
    break;

  case 267:
#line 2289 "gram.y"
                                {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 28374 "gram.c"
    break;

  case 268:
#line 2311 "gram.y"
                                                                                        { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28380 "gram.c"
    break;

  case 269:
#line 2312 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 28386 "gram.c"
    break;

  case 270:
#line 2313 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 28392 "gram.c"
    break;

  case 271:
#line 2317 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 28398 "gram.c"
    break;

  case 272:
#line 2318 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 28404 "gram.c"
    break;

  case 273:
#line 2319 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 28410 "gram.c"
    break;

  case 274:
#line 2323 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 28416 "gram.c"
    break;

  case 275:
#line 2324 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 28422 "gram.c"
    break;

  case 276:
#line 2328 "gram.y"
                                                                                        { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 28428 "gram.c"
    break;

  case 277:
#line 2332 "gram.y"
                                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28434 "gram.c"
    break;

  case 278:
#line 2334 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 28445 "gram.c"
    break;

  case 279:
#line 2341 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 28456 "gram.c"
    break;

  case 280:
#line 2348 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28467 "gram.c"
    break;

  case 281:
#line 2358 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 28478 "gram.c"
    break;

  case 282:
#line 2365 "gram.y"
                                {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 28488 "gram.c"
    break;

  case 283:
#line 2374 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28494 "gram.c"
    break;

  case 284:
#line 2375 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28500 "gram.c"
    break;

  case 285:
#line 2380 "gram.y"
                                                                        { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28506 "gram.c"
    break;

  case 286:
#line 2381 "gram.y"
                                                                        { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28512 "gram.c"
    break;

  case 287:
#line 2387 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 28522 "gram.c"
    break;

  case 288:
#line 2393 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 28532 "gram.c"
    break;

  case 289:
#line 2399 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 28542 "gram.c"
    break;

  case 290:
#line 2405 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 28552 "gram.c"
    break;

  case 291:
#line 2411 "gram.y"
                                {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 28562 "gram.c"
    break;

  case 292:
#line 2421 "gram.y"
                                {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 28573 "gram.c"
    break;

  case 293:
#line 2430 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 28579 "gram.c"
    break;

  case 294:
#line 2431 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 28585 "gram.c"
    break;

  case 295:
#line 2435 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 28591 "gram.c"
    break;

  case 296:
#line 2436 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 28597 "gram.c"
    break;

  case 297:
#line 2445 "gram.y"
                                {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 28606 "gram.c"
    break;

  case 298:
#line 2460 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 28616 "gram.c"
    break;

  case 299:
#line 2466 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28626 "gram.c"
    break;

  case 300:
#line 2472 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28636 "gram.c"
    break;

  case 301:
#line 2478 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 28646 "gram.c"
    break;

  case 302:
#line 2484 "gram.y"
                                {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 28656 "gram.c"
    break;

  case 303:
#line 2503 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28669 "gram.c"
    break;

  case 304:
#line 2512 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28682 "gram.c"
    break;

  case 305:
#line 2521 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_EXTTABLE;
					(yyval.node) = (Node *)n;
				}
#line 28694 "gram.c"
    break;

  case 306:
#line 2529 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28709 "gram.c"
    break;

  case 307:
#line 2540 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28724 "gram.c"
    break;

  case 308:
#line 2551 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28737 "gram.c"
    break;

  case 309:
#line 2560 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28750 "gram.c"
    break;

  case 310:
#line 2569 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28765 "gram.c"
    break;

  case 311:
#line 2580 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28780 "gram.c"
    break;

  case 312:
#line 2591 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28793 "gram.c"
    break;

  case 313:
#line 2600 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28806 "gram.c"
    break;

  case 314:
#line 2609 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28819 "gram.c"
    break;

  case 315:
#line 2618 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28832 "gram.c"
    break;

  case 316:
#line 2627 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28845 "gram.c"
    break;

  case 317:
#line 2636 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28858 "gram.c"
    break;

  case 318:
#line 2645 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28873 "gram.c"
    break;

  case 319:
#line 2656 "gram.y"
                                {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28888 "gram.c"
    break;

  case 320:
#line 2669 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28894 "gram.c"
    break;

  case 321:
#line 2670 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28900 "gram.c"
    break;

  case 322:
#line 2676 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28911 "gram.c"
    break;

  case 323:
#line 2684 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28922 "gram.c"
    break;

  case 324:
#line 2692 "gram.y"
                                {
					ColumnDef *colDef = makeNode(ColumnDef);
					colDef->raw_default = (yyvsp[0].node);
					
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) colDef;
					(yyval.node) = (Node *)n;
				}
#line 28937 "gram.c"
    break;

  case 325:
#line 2704 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28948 "gram.c"
    break;

  case 326:
#line 2712 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 28959 "gram.c"
    break;

  case 327:
#line 2720 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 28971 "gram.c"
    break;

  case 328:
#line 2729 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28983 "gram.c"
    break;

  case 329:
#line 2738 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28995 "gram.c"
    break;

  case 330:
#line 2747 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29007 "gram.c"
    break;

  case 331:
#line 2756 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29020 "gram.c"
    break;

  case 332:
#line 2766 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29033 "gram.c"
    break;

  case 333:
#line 2779 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29051 "gram.c"
    break;

  case 334:
#line 2794 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29063 "gram.c"
    break;

  case 335:
#line 2803 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29074 "gram.c"
    break;

  case 336:
#line 2811 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 29092 "gram.c"
    break;

  case 337:
#line 2826 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29103 "gram.c"
    break;

  case 338:
#line 2834 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 29116 "gram.c"
    break;

  case 339:
#line 2844 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 29129 "gram.c"
    break;

  case 340:
#line 2854 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 29139 "gram.c"
    break;

  case 341:
#line 2861 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 29149 "gram.c"
    break;

  case 342:
#line 2868 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29160 "gram.c"
    break;

  case 343:
#line 2876 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29171 "gram.c"
    break;

  case 344:
#line 2884 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29182 "gram.c"
    break;

  case 345:
#line 2892 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29193 "gram.c"
    break;

  case 346:
#line 2900 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29204 "gram.c"
    break;

  case 347:
#line 2908 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29214 "gram.c"
    break;

  case 348:
#line 2915 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29224 "gram.c"
    break;

  case 349:
#line 2922 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29235 "gram.c"
    break;

  case 350:
#line 2930 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29245 "gram.c"
    break;

  case 351:
#line 2937 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29255 "gram.c"
    break;

  case 352:
#line 2944 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29266 "gram.c"
    break;

  case 353:
#line 2952 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29277 "gram.c"
    break;

  case 354:
#line 2960 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29288 "gram.c"
    break;

  case 355:
#line 2968 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29299 "gram.c"
    break;

  case 356:
#line 2976 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29310 "gram.c"
    break;

  case 357:
#line 2984 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29321 "gram.c"
    break;

  case 358:
#line 2993 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetDistributedBy;
					n->def = (Node *) list_make2(NULL, (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 29332 "gram.c"
    break;

  case 359:
#line 3001 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetDistributedBy;
					n->def = (Node *) list_make2((yyvsp[-1].list), (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 29343 "gram.c"
    break;

  case 360:
#line 3009 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetDistributedBy;
					n->def = (Node *) list_make2((yyvsp[0].list), NULL);
					(yyval.node) = (Node *)n;
				}
#line 29354 "gram.c"
    break;

  case 361:
#line 3016 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 29362 "gram.c"
    break;

  case 362:
#line 3021 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ExpandTable;
					(yyval.node) = (Node *)n;
				}
#line 29372 "gram.c"
    break;

  case 363:
#line 3028 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 29385 "gram.c"
    break;

  case 364:
#line 3038 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 29395 "gram.c"
    break;

  case 365:
#line 3045 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29406 "gram.c"
    break;

  case 366:
#line 3053 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29417 "gram.c"
    break;

  case 367:
#line 3061 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29428 "gram.c"
    break;

  case 368:
#line 3069 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29439 "gram.c"
    break;

  case 369:
#line 3077 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29450 "gram.c"
    break;

  case 370:
#line 3084 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29461 "gram.c"
    break;

  case 371:
#line 3093 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 29467 "gram.c"
    break;

  case 372:
#line 3094 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 29473 "gram.c"
    break;

  case 373:
#line 3098 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_CASCADE; }
#line 29479 "gram.c"
    break;

  case 374:
#line 3099 "gram.y"
                                                                        { (yyval.dbehavior) = DROP_RESTRICT; }
#line 29485 "gram.c"
    break;

  case 375:
#line 3100 "gram.y"
                                                                { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 29491 "gram.c"
    break;

  case 376:
#line 3105 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 29503 "gram.c"
    break;

  case 377:
#line 3112 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 29509 "gram.c"
    break;

  case 378:
#line 3116 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 29515 "gram.c"
    break;

  case 379:
#line 3117 "gram.y"
                                                                { (yyval.node) = NULL; }
#line 29521 "gram.c"
    break;

  case 380:
#line 3122 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 29532 "gram.c"
    break;

  case 381:
#line 3129 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 29543 "gram.c"
    break;

  case 382:
#line 3136 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 29554 "gram.c"
    break;

  case 383:
#line 3143 "gram.y"
                                {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 29565 "gram.c"
    break;

  case 384:
#line 3152 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 29571 "gram.c"
    break;

  case 385:
#line 3155 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 29577 "gram.c"
    break;

  case 386:
#line 3156 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 29583 "gram.c"
    break;

  case 387:
#line 3160 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 29589 "gram.c"
    break;

  case 388:
#line 3161 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 29595 "gram.c"
    break;

  case 389:
#line 3167 "gram.y"
                                {
					/*
					 * appendoptimized is an alias for appendonly in order to
					 * provide a reloption syntax which better reflects the
					 * featureset of AO tables. It is implemented as a very
					 * thin alias, the reloptions and messaging will still
					 * say appendonly.
					 */
					if (strcmp((yyvsp[-2].str), "appendoptimized") == 0)
						(yyval.defelt) = makeDefElem("appendonly", (Node *) (yyvsp[0].node));
					else
						(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 29613 "gram.c"
    break;

  case 390:
#line 3181 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 29621 "gram.c"
    break;

  case 391:
#line 3185 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 29630 "gram.c"
    break;

  case 392:
#line 3190 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 29638 "gram.c"
    break;

  case 393:
#line 3199 "gram.y"
                                {
                    /* re-use alterpartitioncmd struct here... */
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
                    pc->partid = (Node *)(yyvsp[-3].node);
                    pc->arg1 = (Node *)(yyvsp[-1].node);
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);
					(yyval.node) = (Node *)pc;
                }
#line 29652 "gram.c"
    break;

  case 394:
#line 3208 "gram.y"
                                                                                { (yyval.node) = NULL; /* default */ }
#line 29658 "gram.c"
    break;

  case 395:
#line 3212 "gram.y"
                                                                                { (yyval.ival) = +1; }
#line 29664 "gram.c"
    break;

  case 396:
#line 3213 "gram.y"
                                                                        { (yyval.ival) = +0; }
#line 29670 "gram.c"
    break;

  case 397:
#line 3214 "gram.y"
                                                                                        { (yyval.ival) = +1; /* default */ }
#line 29676 "gram.c"
    break;

  case 398:
#line 3219 "gram.y"
                                {
					AlterPartitionId *n = makeNode(AlterPartitionId);
					n->idtype = AT_AP_IDName;
                    n->partiddef = (Node *)makeString((yyvsp[0].str));
                    n->location  = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 29688 "gram.c"
    break;

  case 399:
#line 3228 "gram.y"
                                {
					AlterPartitionId *n = makeNode(AlterPartitionId);
					n->idtype = AT_AP_IDValue;
                    n->partiddef = (Node *)(yyvsp[-1].list);
                    n->location  = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29700 "gram.c"
    break;

  case 400:
#line 3258 "gram.y"
                                {
					Node		   *arg;
					Value		   *val;
					Node		   *fname;
					AlterPartitionId *n;

                    /* allow RANK only */
					if (list_length((yyvsp[-5].list)) != 1)
                        parser_yyerror("syntax error");
					fname = linitial((yyvsp[-5].list));
					if (!(strcmp(strVal(linitial((yyvsp[-5].list))), "rank") == 0))
                        parser_yyerror("syntax error");

					/* expr_list must be a single numeric constant */
					if (list_length((yyvsp[-3].list)) != 1)
						parser_yyerror("syntax error");

					arg = linitial((yyvsp[-3].list));
					if (!IsA(arg, A_Const))
						parser_yyerror("syntax error");
					val = &((A_Const *) arg)->val;
					if (!IsA(val, Integer) && !IsA(val, Float))
						parser_yyerror("syntax error");

					/* we don't want a sort clause */
					if ((yyvsp[-2].list))
						parser_yyerror("syntax error");

					n = makeNode(AlterPartitionId);
					n->idtype = AT_AP_IDRank;
                    n->partiddef = (Node *) val;
                    n->location  = (yylsp[-3]);

					(yyval.node) = (Node *)n;
				}
#line 29740 "gram.c"
    break;

  case 401:
#line 3297 "gram.y"
                                {
					AlterPartitionId *n = (AlterPartitionId*)(yyvsp[0].node);
                    (yyval.node) = (Node *)n;
				}
#line 29749 "gram.c"
    break;

  case 402:
#line 3302 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("cannot specify a name, rank, or value for a DEFAULT partition in this context")));
				}
#line 29759 "gram.c"
    break;

  case 403:
#line 3308 "gram.y"
                                {
					AlterPartitionId *n = makeNode(AlterPartitionId);
					n->idtype = AT_AP_IDDefault;
                    n->partiddef = NULL;
                    n->location  = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 29771 "gram.c"
    break;

  case 404:
#line 3323 "gram.y"
                                {
					AlterPartitionId  *pid   = makeNode(AlterPartitionId);
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd     *n     = makeNode(AlterTableCmd);
                    PartitionElem     *pelem = makeNode(PartitionElem); 

                    pid->idtype = AT_AP_IDNone;
                    pid->location = (yylsp[-2]);
                    pid->partiddef = NULL;

                    pc->partid = (Node *) pid;

                    pelem->partName  = NULL;
                    pelem->boundSpec = (yyvsp[-2].node);
                    pelem->subSpec   = (yyvsp[0].node);
                    pelem->location  = (yylsp[-2]);
                    pelem->isDefault = false; /* not default */
                    pelem->storeAttr = (yyvsp[-1].node);
                    pelem->AddPartDesc = NULL;
					pc->arg1 = (Node *) pelem;

                    pc->location = (yylsp[-2]);

					n->subtype = AT_PartAdd;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29803 "gram.c"
    break;

  case 405:
#line 3355 "gram.y"
                                {
					AlterPartitionId  *pid   = (AlterPartitionId *)(yyvsp[-3].node);
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd     *n     = makeNode(AlterTableCmd);
                    PartitionElem     *pelem = makeNode(PartitionElem); 

                    if (pid->idtype != AT_AP_IDName)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("can only ADD a partition by name")));

                    pc->partid = (Node *) pid;

                    pelem->partName  = NULL;
                    pelem->boundSpec = (yyvsp[-2].node);
                    pelem->subSpec   = (yyvsp[0].node);
                    pelem->location  = (yylsp[-2]);
                    pelem->isDefault = true;
                    pelem->storeAttr = (yyvsp[-1].node);
                    pelem->AddPartDesc = NULL;
					pc->arg1 = (Node *) pelem;
                    pc->location = (yylsp[-2]);

					n->subtype = AT_PartAdd;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29835 "gram.c"
    break;

  case 406:
#line 3387 "gram.y"
                                {
					AlterPartitionId  *pid   = (AlterPartitionId *)(yyvsp[-3].node);
					AlterPartitionCmd *pc    = makeNode(AlterPartitionCmd);
					AlterTableCmd     *n     = makeNode(AlterTableCmd);
                    PartitionElem     *pelem = makeNode(PartitionElem); 

                    if (pid->idtype != AT_AP_IDName)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("can only ADD a partition by name")));

                    pc->partid = (Node *) pid;

                    pelem->partName  = NULL;
                    pelem->boundSpec = (yyvsp[-2].node);
                    pelem->subSpec   = (yyvsp[0].node);
                    pelem->location  = (yylsp[-2]);
                    pelem->isDefault = false;
                    pelem->storeAttr = (yyvsp[-1].node);
                    pelem->AddPartDesc = NULL;
                    pc->arg1 = (Node *) pelem;

                    pc->location = (yylsp[-2]);

					n->subtype = AT_PartAdd;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29868 "gram.c"
    break;

  case 407:
#line 3418 "gram.y"
                                {
                    /* NOTE: only allow a subset of valid ALTER TABLE
                       cmds for partitions.
                    */

					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);

                    pc->partid = (Node *)(yyvsp[-1].node);
                    pc->arg1 = (Node *)(yyvsp[0].node);
                    pc->arg2 = NULL;
                    pc->location = (yylsp[0]);

					n->subtype = AT_PartAlter;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29890 "gram.c"
    break;

  case 408:
#line 3438 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					DropStmt *ds = makeNode(DropStmt);

					ds->missing_ok = TRUE;
					ds->behavior = (yyvsp[0].dbehavior);

                    /* 
                       build an (incomplete) drop statement for arg1: 
                       fill in the rest after the partition id spec is
                       validated
                    */

                    pc->partid = (Node *)(yyvsp[-1].node);
                    pc->arg1 = (Node *)ds;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartDrop;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29918 "gram.c"
    break;

  case 409:
#line 3463 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					DropStmt *ds = makeNode(DropStmt);
					AlterPartitionId *pid = makeNode(AlterPartitionId);

					pid->idtype = AT_AP_IDDefault;
                    pid->partiddef = NULL;
                    pid->location  = (yylsp[-4]);

					ds->missing_ok = TRUE;
					ds->behavior = (yyvsp[0].dbehavior);

                    /* 
                       build an (incomplete) drop statement for arg1: 
                       fill in the rest after the partition id spec is
                       validated
                    */

                    pc->partid = (Node *)pid;
                    pc->arg1 = (Node *)ds;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-3]);

					n->subtype = AT_PartDrop;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29951 "gram.c"
    break;

  case 410:
#line 3494 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					DropStmt *ds = makeNode(DropStmt);

					ds->missing_ok = FALSE;
					ds->behavior = (yyvsp[0].dbehavior);

                    /* 
                       build an (incomplete) drop statement for arg1: 
                       fill in the rest after the partition id spec is
                       validated
                    */

                    pc->partid = (Node *)(yyvsp[-1].node);
                    pc->arg1 = (Node *)ds;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartDrop;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 29979 "gram.c"
    break;

  case 411:
#line 3518 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					DropStmt *ds = makeNode(DropStmt);
					AlterPartitionId *pid = makeNode(AlterPartitionId);

					ds->missing_ok = FALSE;
					ds->behavior = DROP_RESTRICT; /* default */ 

                    /* 
                       build an (incomplete) drop statement for arg1: 
                       fill in the rest after the partition id spec is
                       validated
                    */

                    /* just try to drop the first partition if not specified */
					pid->idtype = AT_AP_IDNone;
                    pid->location  = (yylsp[0]);

                    pc->partid = (Node *)pid;
                    pc->arg1 = (Node *)ds;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[0]);

					n->subtype = AT_PartDrop;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30012 "gram.c"
    break;

  case 412:
#line 3550 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterPartitionCmd *pc2 = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);

                    pc->partid = (Node *)(yyvsp[-4].node);
                    pc->arg1 = (Node *)(yyvsp[-1].range);
                    pc->arg2 = (Node *)pc2;
                    pc2->arg1 = (Node *)makeInteger((yyvsp[0].ival));
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartExchange;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30032 "gram.c"
    break;

  case 413:
#line 3567 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);

                    pc->partid = (Node *)(yyvsp[-2].node);
                    pc->arg1 = (Node *)makeString((yyvsp[0].str));
                    pc->arg2 = NULL;
                    pc->location = (yylsp[0]);

					n->subtype = AT_PartRename;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30050 "gram.c"
    break;

  case 414:
#line 3582 "gram.y"
                                {
					AlterPartitionId  *pid   = makeNode(AlterPartitionId);
					AlterPartitionCmd *pc    = makeNode(AlterPartitionCmd);
					AlterTableCmd     *n     = makeNode(AlterTableCmd);
                    PartitionElem     *pelem = makeNode(PartitionElem); 
					PartitionSpec	  *ps    = makeNode(PartitionSpec); 

					/* treat this case as similar to ADD PARTITION */

                    pid->idtype    = AT_AP_IDName;
                    pid->location  = (yylsp[-3]);
                    pid->partiddef = 
						(Node *)makeString("subpartition_template");

                    pc->partid = (Node *) pid;

					/* build a subpartition spec and add it to CREATE TABLE */
					ps->partElem   = (yyvsp[-1].list); 
					ps->subSpec	   = NULL;
					ps->istemplate = true;
					ps->location   = (yylsp[-2]);

                    pelem->partName  = NULL;
                    pelem->boundSpec = NULL;
                    pelem->subSpec   = (Node *)ps;
                    pelem->location  = (yylsp[-2]);
                    pelem->isDefault = true;
                    pelem->storeAttr = NULL;
                    pelem->AddPartDesc = NULL;
					pc->arg1 = (Node *) pelem;

					/* a little (temporary?) syntax check on templates */
					if (ps->partElem)
					{
						List *elems;
						ListCell *lc;
						Assert(IsA(ps->partElem, List));

						elems = (List *)ps->partElem;
						foreach(lc, elems)
						{
							PartitionElem *e = lfirst(lc);

							if (!IsA(e, PartitionElem))
								continue;

							if (e->subSpec)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("template cannot contain "
												"specification for child "
												"partition")));
						}
					}

                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartSetTemplate;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30116 "gram.c"
    break;

  case 415:
#line 3645 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);

                    pc->partid = NULL; 
                    pc->arg1 = NULL;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartSetTemplate;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30134 "gram.c"
    break;

  case 416:
#line 3662 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					AlterPartitionId *pid = makeNode(AlterPartitionId);

					pid->idtype = AT_AP_IDDefault;
                    pid->partiddef = NULL;
                    pid->location  = (yylsp[-4]);

                    pc->partid = (Node *)pid;
                    pc->arg1 = (Node *)list_make2((yyvsp[-2].node), (yyvsp[-1].node));
                    pc->arg2 = (Node *)(yyvsp[0].node);
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartSplit;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30157 "gram.c"
    break;

  case 417:
#line 3684 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);

                    pc->partid = (Node *)(yyvsp[-5].node);

					/* 
					 * The first element of the list is only defined if
					 * we're doing default splits for range partitioning.
				 	 */
                    pc->arg1 = (Node *)list_make2(NULL, (yyvsp[-2].list));
                    pc->arg2 = (Node *)(yyvsp[0].node);
                    pc->location = (yylsp[-2]);

					n->subtype = AT_PartSplit;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30180 "gram.c"
    break;

  case 418:
#line 3705 "gram.y"
                                {
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TruncateStmt *ts = makeNode(TruncateStmt);

                    /* 
                       build an (incomplete) truncate statement for arg1: 
                       fill in the rest after the partition id spec is
                       validated
                    */
					ts->relations = NULL;
					ts->behavior = (yyvsp[0].dbehavior);

                    pc->partid = (Node *)(yyvsp[-1].node);
                    pc->arg1 = (Node *)ts;
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);

					n->subtype = AT_PartTruncate;
					n->def = (Node *)pc;
					(yyval.node) = (Node *)n;
				}
#line 30207 "gram.c"
    break;

  case 419:
#line 3739 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 30221 "gram.c"
    break;

  case 420:
#line 3751 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30227 "gram.c"
    break;

  case 421:
#line 3752 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30233 "gram.c"
    break;

  case 422:
#line 3758 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30245 "gram.c"
    break;

  case 423:
#line 3767 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 30258 "gram.c"
    break;

  case 424:
#line 3777 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 30271 "gram.c"
    break;

  case 425:
#line 3787 "gram.y"
                                {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 30290 "gram.c"
    break;

  case 426:
#line 3813 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30300 "gram.c"
    break;

  case 427:
#line 3819 "gram.y"
                                {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30310 "gram.c"
    break;

  case 428:
#line 3851 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-10].range);
					n->query = NULL;
					n->attlist = (yyvsp[-9].list);
					n->is_from = (yyvsp[-7].boolean);
					n->is_program = (yyvsp[-6].boolean);
					n->filename = (yyvsp[-5].str);
					n->sreh = (yyvsp[-1].node);
					n->partitions = NULL;
					n->ao_segnos = NIL;

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-5]))));

					n->options = NIL;
					n->skip_ext_partition = (yyvsp[0].boolean);

					/* Concatenate user-supplied flags */
					if ((yyvsp[-11].defelt))
						n->options = lappend(n->options, (yyvsp[-11].defelt));
					if ((yyvsp[-8].defelt))
						n->options = lappend(n->options, (yyvsp[-8].defelt));
					if ((yyvsp[-4].defelt))
						n->options = lappend(n->options, (yyvsp[-4].defelt));
					if ((yyvsp[-2].list))
						n->options = list_concat(n->options, (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 30347 "gram.c"
    break;

  case 429:
#line 3884 "gram.y"
                                {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-5].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->partitions = NULL;
					n->ao_segnos = NIL;
					n->skip_ext_partition = false;

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-2]))));

					(yyval.node) = (Node *)n;
				}
#line 30373 "gram.c"
    break;

  case 430:
#line 3908 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 30379 "gram.c"
    break;

  case 431:
#line 3909 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 30385 "gram.c"
    break;

  case 432:
#line 3913 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 30391 "gram.c"
    break;

  case 433:
#line 3914 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 30397 "gram.c"
    break;

  case 434:
#line 3918 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 30403 "gram.c"
    break;

  case 435:
#line 3919 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 30409 "gram.c"
    break;

  case 436:
#line 3928 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 30415 "gram.c"
    break;

  case 437:
#line 3929 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 30421 "gram.c"
    break;

  case 438:
#line 3930 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 30427 "gram.c"
    break;

  case 439:
#line 3933 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 30433 "gram.c"
    break;

  case 440:
#line 3934 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 30439 "gram.c"
    break;

  case 441:
#line 3939 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30445 "gram.c"
    break;

  case 442:
#line 3940 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30451 "gram.c"
    break;

  case 443:
#line 3945 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 30459 "gram.c"
    break;

  case 444:
#line 3949 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 30467 "gram.c"
    break;

  case 445:
#line 3953 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
#line 30475 "gram.c"
    break;

  case 446:
#line 3957 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 30483 "gram.c"
    break;

  case 447:
#line 3961 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 30491 "gram.c"
    break;

  case 448:
#line 3965 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 30499 "gram.c"
    break;

  case 449:
#line 3969 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 30507 "gram.c"
    break;

  case 450:
#line 3973 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 30515 "gram.c"
    break;

  case 451:
#line 3977 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 30523 "gram.c"
    break;

  case 452:
#line 3981 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 30531 "gram.c"
    break;

  case 453:
#line 3985 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 30539 "gram.c"
    break;

  case 454:
#line 3989 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 30547 "gram.c"
    break;

  case 455:
#line 3993 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list));
				}
#line 30555 "gram.c"
    break;

  case 456:
#line 3997 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 30563 "gram.c"
    break;

  case 457:
#line 4001 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("fill_missing_fields", (Node *)makeInteger(TRUE));
				}
#line 30571 "gram.c"
    break;

  case 458:
#line 4005 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("newline", (Node *)makeString((yyvsp[0].str)));
				}
#line 30579 "gram.c"
    break;

  case 459:
#line 4009 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("on_segment", (Node *)makeInteger(TRUE));
				}
#line 30587 "gram.c"
    break;

  case 460:
#line 4018 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 30595 "gram.c"
    break;

  case 461:
#line 4021 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 30601 "gram.c"
    break;

  case 462:
#line 4026 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 30609 "gram.c"
    break;

  case 463:
#line 4029 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 30615 "gram.c"
    break;

  case 464:
#line 4034 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 30623 "gram.c"
    break;

  case 465:
#line 4037 "gram.y"
                                                                                                { (yyval.defelt) = NULL; }
#line 30629 "gram.c"
    break;

  case 466:
#line 4041 "gram.y"
                                                                                                {}
#line 30635 "gram.c"
    break;

  case 467:
#line 4042 "gram.y"
                                                                                                {}
#line 30641 "gram.c"
    break;

  case 468:
#line 4048 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30649 "gram.c"
    break;

  case 469:
#line 4052 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30657 "gram.c"
    break;

  case 470:
#line 4059 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 30665 "gram.c"
    break;

  case 471:
#line 4065 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30671 "gram.c"
    break;

  case 472:
#line 4066 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 30677 "gram.c"
    break;

  case 473:
#line 4067 "gram.y"
                                                                                { (yyval.node) = (Node *) makeNode(A_Star); }
#line 30683 "gram.c"
    break;

  case 474:
#line 4068 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 30689 "gram.c"
    break;

  case 475:
#line 4069 "gram.y"
                                                                        { (yyval.node) = NULL; }
#line 30695 "gram.c"
    break;

  case 476:
#line 4074 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30703 "gram.c"
    break;

  case 477:
#line 4078 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30711 "gram.c"
    break;

  case 478:
#line 4085 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30717 "gram.c"
    break;

  case 479:
#line 4099 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->distributedBy = (DistributedBy *) (yyvsp[-1].node);
					n->partitionBy = (yyvsp[0].node);
					n->relKind = RELKIND_RELATION;
					(yyval.node) = (Node *)n;
				}
#line 30738 "gram.c"
    break;

  case 480:
#line 4119 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->distributedBy = (DistributedBy *) (yyvsp[-1].node);
					n->partitionBy = (yyvsp[0].node);
					n->relKind = RELKIND_RELATION;
					(yyval.node) = (Node *)n;
				}
#line 30759 "gram.c"
    break;

  case 481:
#line 4138 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->distributedBy = (DistributedBy *) (yyvsp[-1].node);
					n->partitionBy = (yyvsp[0].node);
					n->relKind = RELKIND_RELATION;
					(yyval.node) = (Node *)n;
				}
#line 30781 "gram.c"
    break;

  case 482:
#line 4158 "gram.y"
                                {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->options = (yyvsp[-4].list);
					n->oncommit = (yyvsp[-3].oncommit);
					n->tablespacename = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->distributedBy = (DistributedBy *) (yyvsp[-1].node);
					n->partitionBy = (yyvsp[0].node);
					n->relKind = RELKIND_RELATION;
					(yyval.node) = (Node *)n;
				}
#line 30803 "gram.c"
    break;

  case 483:
#line 4188 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30809 "gram.c"
    break;

  case 484:
#line 4189 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30815 "gram.c"
    break;

  case 485:
#line 4190 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30821 "gram.c"
    break;

  case 486:
#line 4191 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30827 "gram.c"
    break;

  case 487:
#line 4193 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30838 "gram.c"
    break;

  case 488:
#line 4200 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30849 "gram.c"
    break;

  case 489:
#line 4206 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 30855 "gram.c"
    break;

  case 490:
#line 4207 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 30861 "gram.c"
    break;

  case 491:
#line 4211 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 30867 "gram.c"
    break;

  case 492:
#line 4212 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30873 "gram.c"
    break;

  case 493:
#line 4216 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 30879 "gram.c"
    break;

  case 494:
#line 4217 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 30885 "gram.c"
    break;

  case 495:
#line 4222 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30893 "gram.c"
    break;

  case 496:
#line 4226 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30901 "gram.c"
    break;

  case 497:
#line 4233 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30909 "gram.c"
    break;

  case 498:
#line 4237 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30917 "gram.c"
    break;

  case 499:
#line 4243 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 30923 "gram.c"
    break;

  case 500:
#line 4244 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 30929 "gram.c"
    break;

  case 501:
#line 4245 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 30935 "gram.c"
    break;

  case 502:
#line 4246 "gram.y"
                                                             { (yyval.node) = (yyvsp[0].node); }
#line 30941 "gram.c"
    break;

  case 503:
#line 4250 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 30947 "gram.c"
    break;

  case 504:
#line 4251 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 30953 "gram.c"
    break;

  case 505:
#line 4256 "gram.y"
                                {
					ColumnReferenceStorageDirective *n =
						makeNode(ColumnReferenceStorageDirective);

					n->column = (yyvsp[-2].str);
					n->encoding = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 30966 "gram.c"
    break;

  case 506:
#line 4265 "gram.y"
                                {
					ColumnReferenceStorageDirective *n =
						makeNode(ColumnReferenceStorageDirective);

					n->deflt = true;
					n->encoding = (yyvsp[0].list);

					(yyval.node) = (Node *)n;
				}
#line 30980 "gram.c"
    break;

  case 507:
#line 4277 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->encoding = (yyvsp[0].list);
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-2].list);
					SplitColQualList((yyvsp[-1].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31004 "gram.c"
    break;

  case 508:
#line 4299 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31026 "gram.c"
    break;

  case 509:
#line 4319 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31032 "gram.c"
    break;

  case 510:
#line 4320 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31038 "gram.c"
    break;

  case 511:
#line 4325 "gram.y"
                                {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31050 "gram.c"
    break;

  case 512:
#line 4332 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 31056 "gram.c"
    break;

  case 513:
#line 4333 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 31062 "gram.c"
    break;

  case 514:
#line 4335 "gram.y"
                                {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31079 "gram.c"
    break;

  case 515:
#line 4349 "gram.y"
                                          { (yyval.list) = (yyvsp[0].list); }
#line 31085 "gram.c"
    break;

  case 516:
#line 4350 "gram.y"
                                        { (yyval.list) = NIL; }
#line 31091 "gram.c"
    break;

  case 517:
#line 4370 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31102 "gram.c"
    break;

  case 518:
#line 4377 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31113 "gram.c"
    break;

  case 519:
#line 4384 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31128 "gram.c"
    break;

  case 520:
#line 4395 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31143 "gram.c"
    break;

  case 521:
#line 4406 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 31157 "gram.c"
    break;

  case 522:
#line 4416 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 31170 "gram.c"
    break;

  case 523:
#line 4425 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 31189 "gram.c"
    break;

  case 524:
#line 4458 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31200 "gram.c"
    break;

  case 525:
#line 4465 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31211 "gram.c"
    break;

  case 526:
#line 4472 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31222 "gram.c"
    break;

  case 527:
#line 4479 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31233 "gram.c"
    break;

  case 528:
#line 4490 "gram.y"
                                {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 31244 "gram.c"
    break;

  case 529:
#line 4499 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 31250 "gram.c"
    break;

  case 530:
#line 4500 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 31256 "gram.c"
    break;

  case 531:
#line 4501 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 31262 "gram.c"
    break;

  case 532:
#line 4505 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 31268 "gram.c"
    break;

  case 533:
#line 4506 "gram.y"
                                                        { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 31274 "gram.c"
    break;

  case 534:
#line 4507 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 31280 "gram.c"
    break;

  case 535:
#line 4508 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 31286 "gram.c"
    break;

  case 536:
#line 4509 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 31292 "gram.c"
    break;

  case 537:
#line 4510 "gram.y"
                                                                { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 31298 "gram.c"
    break;

  case 538:
#line 4520 "gram.y"
                                {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31310 "gram.c"
    break;

  case 539:
#line 4527 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 31316 "gram.c"
    break;

  case 540:
#line 4532 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31333 "gram.c"
    break;

  case 541:
#line 4546 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31351 "gram.c"
    break;

  case 542:
#line 4560 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31369 "gram.c"
    break;

  case 543:
#line 4575 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31387 "gram.c"
    break;

  case 544:
#line 4589 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31405 "gram.c"
    break;

  case 545:
#line 4605 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31425 "gram.c"
    break;

  case 546:
#line 4622 "gram.y"
                                {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31447 "gram.c"
    break;

  case 547:
#line 4641 "gram.y"
                                                                                {  (yyval.boolean) = TRUE; }
#line 31453 "gram.c"
    break;

  case 548:
#line 4642 "gram.y"
                                                                                        {  (yyval.boolean) = FALSE; }
#line 31459 "gram.c"
    break;

  case 549:
#line 4646 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 31465 "gram.c"
    break;

  case 550:
#line 4647 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31471 "gram.c"
    break;

  case 551:
#line 4651 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31477 "gram.c"
    break;

  case 552:
#line 4652 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31483 "gram.c"
    break;

  case 553:
#line 4656 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 31491 "gram.c"
    break;

  case 554:
#line 4662 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 31497 "gram.c"
    break;

  case 555:
#line 4664 "gram.y"
                                {
					IndexElem *newelem = (yyvsp[0].ielem);
					ListCell *lc;

					foreach(lc, (yyvsp[-2].list))
					{
						IndexElem  *oldelem = (IndexElem *) lfirst(lc);

						if (strcmp(oldelem->name, newelem->name) == 0)
							ereport(ERROR,
									(errcode(ERRCODE_DUPLICATE_COLUMN),
									 errmsg("duplicate column in DISTRIBUTED BY clause"),
									 parser_errposition((yylsp[0]))));
					}

					(yyval.list) = lappend((yyvsp[-2].list), newelem);
				}
#line 31519 "gram.c"
    break;

  case 556:
#line 4684 "gram.y"
                                {
					/*
					 * only these fields are used, leave others as 0/NULL
					 */
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-1].str);
					(yyval.ielem)->opclass = (yyvsp[0].list);
				}
#line 31532 "gram.c"
    break;

  case 557:
#line 4695 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 31540 "gram.c"
    break;

  case 558:
#line 4699 "gram.y"
                        {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 31552 "gram.c"
    break;

  case 559:
#line 4707 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31560 "gram.c"
    break;

  case 560:
#line 4711 "gram.y"
                        {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31568 "gram.c"
    break;

  case 561:
#line 4717 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 31574 "gram.c"
    break;

  case 562:
#line 4719 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 31580 "gram.c"
    break;

  case 563:
#line 4723 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 31588 "gram.c"
    break;

  case 564:
#line 4728 "gram.y"
                        {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 31596 "gram.c"
    break;

  case 565:
#line 4734 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 31602 "gram.c"
    break;

  case 566:
#line 4735 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31608 "gram.c"
    break;

  case 567:
#line 4746 "gram.y"
                                { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31614 "gram.c"
    break;

  case 568:
#line 4748 "gram.y"
                                { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31620 "gram.c"
    break;

  case 569:
#line 4750 "gram.y"
                                { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31626 "gram.c"
    break;

  case 570:
#line 4752 "gram.y"
                                { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 31632 "gram.c"
    break;

  case 571:
#line 4754 "gram.y"
                                { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31638 "gram.c"
    break;

  case 572:
#line 4757 "gram.y"
                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 31644 "gram.c"
    break;

  case 573:
#line 4760 "gram.y"
                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 31650 "gram.c"
    break;

  case 574:
#line 4764 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 31656 "gram.c"
    break;

  case 575:
#line 4765 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 31662 "gram.c"
    break;

  case 576:
#line 4766 "gram.y"
                                                                        { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 31668 "gram.c"
    break;

  case 577:
#line 4767 "gram.y"
                                                                { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 31674 "gram.c"
    break;

  case 578:
#line 4768 "gram.y"
                                                                { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 31680 "gram.c"
    break;

  case 579:
#line 4771 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 31686 "gram.c"
    break;

  case 580:
#line 4772 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 31692 "gram.c"
    break;

  case 581:
#line 4777 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 31698 "gram.c"
    break;

  case 582:
#line 4778 "gram.y"
                                                                        { (yyval.list) = list_make1(defWithOids(true)); }
#line 31704 "gram.c"
    break;

  case 583:
#line 4779 "gram.y"
                                                                { (yyval.list) = list_make1(defWithOids(false)); }
#line 31710 "gram.c"
    break;

  case 584:
#line 4780 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 31716 "gram.c"
    break;

  case 585:
#line 4783 "gram.y"
                                                        { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 31722 "gram.c"
    break;

  case 586:
#line 4784 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 31728 "gram.c"
    break;

  case 587:
#line 4785 "gram.y"
                                                                { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 31734 "gram.c"
    break;

  case 588:
#line 4786 "gram.y"
                                                                                { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 31740 "gram.c"
    break;

  case 589:
#line 4789 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 31746 "gram.c"
    break;

  case 590:
#line 4790 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31752 "gram.c"
    break;

  case 591:
#line 4793 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 31758 "gram.c"
    break;

  case 592:
#line 4794 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 31764 "gram.c"
    break;

  case 593:
#line 4797 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 31770 "gram.c"
    break;

  case 594:
#line 4801 "gram.y"
                        {
				DistributedBy *distributedBy = makeNode(DistributedBy);
				distributedBy->ptype = POLICYTYPE_PARTITIONED;
				distributedBy->numsegments = -1;
				distributedBy->keyCols = (yyvsp[-1].list);
				(yyval.node) = (Node *)distributedBy;
			}
#line 31782 "gram.c"
    break;

  case 595:
#line 4809 "gram.y"
                        {
				DistributedBy *distributedBy = makeNode(DistributedBy);
				distributedBy->ptype = POLICYTYPE_PARTITIONED;
				distributedBy->numsegments = -1;
				distributedBy->keyCols = NIL;
				(yyval.node) = (Node *)distributedBy;
			}
#line 31794 "gram.c"
    break;

  case 596:
#line 4817 "gram.y"
                        {
				DistributedBy *distributedBy = makeNode(DistributedBy);
				distributedBy->ptype = POLICYTYPE_REPLICATED;
				distributedBy->numsegments = -1;
				distributedBy->keyCols = NIL;
				(yyval.node) = (Node *)distributedBy;
			}
#line 31806 "gram.c"
    break;

  case 597:
#line 4826 "gram.y"
                                                        { (yyval.node) = (yyvsp[0].node); }
#line 31812 "gram.c"
    break;

  case 598:
#line 4827 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31818 "gram.c"
    break;

  case 599:
#line 4832 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 31824 "gram.c"
    break;

  case 600:
#line 4833 "gram.y"
                                    { (yyval.list) = NULL; }
#line 31830 "gram.c"
    break;

  case 601:
#line 4837 "gram.y"
                                           { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31836 "gram.c"
    break;

  case 602:
#line 4839 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 31844 "gram.c"
    break;

  case 603:
#line 4845 "gram.y"
                                {
                    /* re-use alterpartitioncmd struct here... */
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
                    pc->partid = NULL;
                    pc->arg1 = (Node *)(yyvsp[-2].list);
                    pc->arg2 = (Node *)makeString((yyvsp[0].str));
                    pc->location = (yylsp[-3]);
					(yyval.node) = (Node *)pc;
                }
#line 31858 "gram.c"
    break;

  case 604:
#line 4855 "gram.y"
                                {
                    /* re-use alterpartitioncmd struct here... */
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
                    pc->partid = NULL;
                    pc->arg1 = (Node *)(yyvsp[0].list);
                    pc->arg2 = NULL;
                    pc->location = (yylsp[-1]);
					(yyval.node) = (Node *)pc;
 				}
#line 31872 "gram.c"
    break;

  case 605:
#line 4865 "gram.y"
                                {
                    /* re-use alterpartitioncmd struct here... */
					AlterPartitionCmd *pc = makeNode(AlterPartitionCmd);
                    pc->partid = NULL;
                    pc->arg1 = NULL;
                    pc->arg2 = (Node *)makeString((yyvsp[0].str));
                    pc->location = (yylsp[-1]);
					(yyval.node) = (Node *)pc;
				}
#line 31886 "gram.c"
    break;

  case 606:
#line 4874 "gram.y"
                                    { (yyval.node) = NULL; }
#line 31892 "gram.c"
    break;

  case 607:
#line 4878 "gram.y"
                                {
                        PartitionSpec *n = makeNode(PartitionSpec); 
                        n->partElem  = (yyvsp[-1].list);
                        n->subSpec   = NULL;
                        n->location  = (yylsp[-1]);
                        (yyval.node) = (Node *)n;
				}
#line 31904 "gram.c"
    break;

  case 608:
#line 4885 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31910 "gram.c"
    break;

  case 609:
#line 4890 "gram.y"
                                {
                        PartitionSpec *n = makeNode(PartitionSpec); 
                        n->partElem  = (yyvsp[-1].list);
                        n->subSpec   = NULL;
                        n->location  = (yylsp[-1]);
                        (yyval.node) = (Node *)n;
				}
#line 31922 "gram.c"
    break;

  case 610:
#line 4897 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 31928 "gram.c"
    break;

  case 611:
#line 4901 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31934 "gram.c"
    break;

  case 612:
#line 4903 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31940 "gram.c"
    break;

  case 613:
#line 4906 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31946 "gram.c"
    break;

  case 614:
#line 4908 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31952 "gram.c"
    break;

  case 615:
#line 4911 "gram.y"
                                  { (yyval.node) = (yyvsp[0].node); }
#line 31958 "gram.c"
    break;

  case 616:
#line 4913 "gram.y"
                                { 
					(yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-2]));
				}
#line 31966 "gram.c"
    break;

  case 617:
#line 4917 "gram.y"
                                { 
					(yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); 
				}
#line 31974 "gram.c"
    break;

  case 618:
#line 4920 "gram.y"
                                                    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 31980 "gram.c"
    break;

  case 619:
#line 4923 "gram.y"
                                    { (yyval.node) = (yyvsp[0].node); }
#line 31986 "gram.c"
    break;

  case 620:
#line 4924 "gram.y"
                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 31992 "gram.c"
    break;

  case 621:
#line 4926 "gram.y"
                                { 
					(yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[0].typnam), (yylsp[-1])); 
				}
#line 32000 "gram.c"
    break;

  case 622:
#line 4932 "gram.y"
                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32006 "gram.c"
    break;

  case 623:
#line 4934 "gram.y"
                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32012 "gram.c"
    break;

  case 624:
#line 4938 "gram.y"
                                                        { (yyval.ival) = PART_EDGE_INCLUSIVE; }
#line 32018 "gram.c"
    break;

  case 625:
#line 4939 "gram.y"
                                                        { (yyval.ival) = PART_EDGE_EXCLUSIVE; }
#line 32024 "gram.c"
    break;

  case 626:
#line 4940 "gram.y"
                                                        { (yyval.ival) = PART_EDGE_UNSPECIFIED; }
#line 32030 "gram.c"
    break;

  case 627:
#line 4947 "gram.y"
                                {
                        PartitionRangeItem *n = makeNode(PartitionRangeItem); 
                        n->partRangeVal  = (yyvsp[-2].list);
                        if (!((yyvsp[0].ival)))
                            n->partedge = PART_EDGE_INCLUSIVE;
                        else
                            n->partedge = (yyvsp[0].ival);
                        n->location  = (yylsp[-4]);
                        (yyval.node) = (Node *)n;
				}
#line 32045 "gram.c"
    break;

  case 628:
#line 4963 "gram.y"
                                {
                        PartitionRangeItem *n = makeNode(PartitionRangeItem); 
                        n->partRangeVal  = (yyvsp[-2].list);
                        if (!((yyvsp[0].ival)))
                            n->partedge = PART_EDGE_EXCLUSIVE;
                        else
                            n->partedge = (yyvsp[0].ival);
                        n->location  = (yylsp[-4]);
                        (yyval.node) = (Node *)n;
				}
#line 32060 "gram.c"
    break;

  case 629:
#line 4977 "gram.y"
                                {
                        PartitionRangeItem *n = makeNode(PartitionRangeItem); 
                        n->partRangeVal  = (yyvsp[-1].list);
                        n->location  = (yylsp[-3]);

                        (yyval.node) = (Node *)n;
				}
#line 32072 "gram.c"
    break;

  case 630:
#line 4984 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 32078 "gram.c"
    break;

  case 631:
#line 4988 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32084 "gram.c"
    break;

  case 632:
#line 4989 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 32090 "gram.c"
    break;

  case 633:
#line 4995 "gram.y"
                                {
                        PartitionValuesSpec *n = makeNode(PartitionValuesSpec); 

                        n->partValues = (yyvsp[0].list);
                        n->location  = (yylsp[0]);
                        (yyval.node) = (Node *)n;
				}
#line 32102 "gram.c"
    break;

  case 634:
#line 5005 "gram.y"
                                {
                        PartitionBoundSpec *n = makeNode(PartitionBoundSpec); 
                        n->partStart = (yyvsp[-2].node);
                        n->partEnd   = (yyvsp[-1].node);
                        n->partEvery = (yyvsp[0].node);
                        n->everyGenList = NIL; 
						n->pWithTnameStr = NULL;
                        n->location  = (yylsp[-2]);
                        (yyval.node) = (Node *)n;
				}
#line 32117 "gram.c"
    break;

  case 635:
#line 5017 "gram.y"
                                {
                        PartitionBoundSpec *n = makeNode(PartitionBoundSpec); 
                        n->partStart = NULL;
                        n->partEnd   = (yyvsp[-1].node);
                        n->partEvery = (yyvsp[0].node);
                        n->everyGenList = NIL; 
						n->pWithTnameStr = NULL;
                        n->location  = (yylsp[-1]);
                        (yyval.node) = (Node *)n;
				}
#line 32132 "gram.c"
    break;

  case 636:
#line 5030 "gram.y"
                                                                { (yyval.node) = (yyvsp[0].node); }
#line 32138 "gram.c"
    break;

  case 637:
#line 5031 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 32144 "gram.c"
    break;

  case 638:
#line 5035 "gram.y"
                                {
					ListCell *lc;
					List *out = NIL;

					foreach(lc, (yyvsp[-1].list))
						out = lappend(out, linitial(lfirst(lc)));

					(yyval.list) = list_make1(out);
				}
#line 32158 "gram.c"
    break;

  case 639:
#line 5045 "gram.y"
                                {
					ListCell *lc;
					List *out = NIL;

					foreach(lc, (yyvsp[-1].list))
						out = lappend(out, linitial(lfirst(lc)));

					(yyval.list) = lappend((yyvsp[-4].list), out);
				}
#line 32172 "gram.c"
    break;

  case 640:
#line 5057 "gram.y"
                                {
					(yyval.list) = list_make1(list_make1((yyvsp[0].node)));
				}
#line 32180 "gram.c"
    break;

  case 641:
#line 5061 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), list_make1((yyvsp[0].node)));
				}
#line 32188 "gram.c"
    break;

  case 642:
#line 5068 "gram.y"
                                {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 32196 "gram.c"
    break;

  case 643:
#line 5072 "gram.y"
                                {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 32204 "gram.c"
    break;

  case 644:
#line 5077 "gram.y"
                                                          { (yyval.list) = (yyvsp[0].list); }
#line 32210 "gram.c"
    break;

  case 645:
#line 5078 "gram.y"
                                             { (yyval.list) = (yyvsp[0].list); }
#line 32216 "gram.c"
    break;

  case 646:
#line 5087 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = (yyvsp[-4].str);
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-4]);
                        n->isDefault = 0;
                        n->storeAttr = (yyvsp[-2].node);
                        n->colencs   = (yyvsp[-1].list);
                        n->AddPartDesc = NULL;
                        (yyval.node) = (Node *)n;
				}
#line 32233 "gram.c"
    break;

  case 647:
#line 5106 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = (yyvsp[-4].str);
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-4]);
                        n->isDefault = true;
                        n->storeAttr = (yyvsp[-2].node);
                        n->colencs   = (yyvsp[-1].list);
                        (yyval.node) = (Node *)n;
				}
#line 32249 "gram.c"
    break;

  case 648:
#line 5121 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = NULL;
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-3]);
                        n->isDefault = 0;
                        n->storeAttr = (yyvsp[-2].node);
                        n->colencs   = (yyvsp[-1].list);
                        n->AddPartDesc = NULL;
                        (yyval.node) = (Node *)n;
				}
#line 32266 "gram.c"
    break;

  case 649:
#line 5134 "gram.y"
                                {
					(yyval.node) = (Node *)(yyvsp[0].node);
				}
#line 32274 "gram.c"
    break;

  case 650:
#line 5144 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = (yyvsp[-4].str);
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-4]);
                        n->isDefault = 0;
                        n->storeAttr = (yyvsp[-2].node);
                        n->colencs   = (yyvsp[-1].list);
                        n->AddPartDesc = NULL;
                        (yyval.node) = (Node *)n;
				}
#line 32291 "gram.c"
    break;

  case 651:
#line 5161 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = (yyvsp[-4].str);
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-4]);
                        n->isDefault = true;
                        n->storeAttr = (yyvsp[-2].node);
                        n->colencs   = (yyvsp[-1].list);
                        n->AddPartDesc = NULL;
                        (yyval.node) = (Node *)n;
				}
#line 32308 "gram.c"
    break;

  case 652:
#line 5177 "gram.y"
                                {
                        PartitionElem *n = makeNode(PartitionElem); 
                        n->partName  = NULL;
                        n->boundSpec = (yyvsp[-3].node);
                        n->subSpec   = (yyvsp[0].node);
                        n->location  = (yylsp[-3]);
                        n->isDefault = false;
                        n->colencs   = (yyvsp[-1].list);
                        n->storeAttr = (yyvsp[-2].node);
                        n->AddPartDesc = NULL;
                        (yyval.node) = (Node *)n;
				}
#line 32325 "gram.c"
    break;

  case 653:
#line 5190 "gram.y"
                                {
					(yyval.node) = (Node *)(yyvsp[0].node);
				}
#line 32333 "gram.c"
    break;

  case 654:
#line 5196 "gram.y"
                                {
					(yyval.str) = (yyvsp[0].str);
				}
#line 32341 "gram.c"
    break;

  case 655:
#line 5201 "gram.y"
                                {
					(yyval.str) = (yyvsp[0].str);
				}
#line 32349 "gram.c"
    break;

  case 656:
#line 5207 "gram.y"
                                {
					(yyval.str) = (yyvsp[0].str);
				}
#line 32357 "gram.c"
    break;

  case 657:
#line 5213 "gram.y"
                                {
					(yyval.str) = (yyvsp[0].str);
				}
#line 32365 "gram.c"
    break;

  case 658:
#line 5219 "gram.y"
                                                        { (yyval.ival) = PARTTYP_RANGE; }
#line 32371 "gram.c"
    break;

  case 659:
#line 5220 "gram.y"
                                                        { (yyval.ival) = PARTTYP_LIST; }
#line 32377 "gram.c"
    break;

  case 660:
#line 5222 "gram.y"
                                {
					(yyval.ival) = PARTTYP_RANGE; 

					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("PARTITION BY must specify RANGE or LIST")));
				}
#line 32389 "gram.c"
    break;

  case 661:
#line 5236 "gram.y"
                                {
					PartitionBy *n = makeNode(PartitionBy); 
						
					n->partType = (yyvsp[-5].ival);
					n->keys     = (yyvsp[-3].list); 
					n->subPart  = (yyvsp[-1].node);
					if (PointerIsValid(n->subPart) &&
						!IsA(n->subPart, PartitionBy))
						parser_yyerror("syntax error");

					n->partSpec = (yyvsp[0].node);
					n->partDepth = 0;
					n->partQuiet = PART_VERBO_NODISTRO;
					n->location  = (yylsp[-5]);
					n->partDefault = NULL;
					(yyval.node) = (Node *)n;
				}
#line 32411 "gram.c"
    break;

  case 662:
#line 5253 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 32417 "gram.c"
    break;

  case 663:
#line 5259 "gram.y"
                                {
					PartitionSpec *n = makeNode(PartitionSpec); 
					n->partElem  = (yyvsp[-1].list);
					n->subSpec   = NULL;
					n->istemplate  = true;
					n->location  = (yylsp[-2]);
					(yyval.node) = (Node *)n;

					/* a little (temporary?) syntax check on templates */
					if (n->partElem)
					{
						List *elems;
						ListCell *lc;
						Assert(IsA(n->partElem, List));

						elems = (List *)n->partElem;
						foreach(lc, elems)
						{
							PartitionElem *e = lfirst(lc);

							if (!IsA(e, PartitionElem)) continue;

							if (e->subSpec)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("template cannot contain "
												"specification for child "
												"partition")));
						}

					}
				}
#line 32454 "gram.c"
    break;

  case 664:
#line 5293 "gram.y"
                                   { (yyval.node) = (yyvsp[0].node); }
#line 32460 "gram.c"
    break;

  case 665:
#line 5294 "gram.y"
                                    { (yyval.node) = NULL; }
#line 32466 "gram.c"
    break;

  case 666:
#line 5300 "gram.y"
                                {
					PartitionBy *n = makeNode(PartitionBy);
					n->partType = (yyvsp[-3].ival);
					n->keys = (yyvsp[-1].list);
					n->subPart  = NULL;
					n->partSpec = NULL;
					n->partDepth = 0;
					n->partQuiet = PART_VERBO_NODISTRO;
					n->location  = (yylsp[-3]);
					n->partDefault = NULL;
					(yyval.node) = (Node *)n;
				}
#line 32483 "gram.c"
    break;

  case 667:
#line 5316 "gram.y"
                                {
					PartitionBy *pby = (PartitionBy *)(yyvsp[-1].node);

					((PartitionBy *)pby)->partSpec = (yyvsp[0].node);

					(yyval.node) = (yyvsp[-1].node);
				}
#line 32495 "gram.c"
    break;

  case 668:
#line 5323 "gram.y"
                                            { (yyval.node) = (yyvsp[0].node); }
#line 32501 "gram.c"
    break;

  case 669:
#line 5325 "gram.y"
                                {
					PartitionBy *pby = (PartitionBy *)(yyvsp[-1].node);
					pby->subPart = (yyvsp[0].node);
					(yyval.node) = (Node *)pby;
				}
#line 32511 "gram.c"
    break;

  case 670:
#line 5331 "gram.y"
                                {
					PartitionBy *pby = (PartitionBy *)(yyvsp[-2].node);
					pby->partSpec = (yyvsp[-1].node);
					pby->subPart = (yyvsp[0].node);
					(yyval.node) = (Node *)pby;
				}
#line 32522 "gram.c"
    break;

  case 671:
#line 5353 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-3].node);
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					ctas->into->distributedBy = (yyvsp[-1].node);

					if ((yyvsp[0].node))
						ereport(ERROR,
                                (errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("Cannot create a partitioned table using CREATE TABLE AS SELECT"),
                                 errhint("Use CREATE TABLE...LIKE (followed by INSERT...SELECT) instead")));

					(yyvsp[-5].into)->skipData = !((yyvsp[-2].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32546 "gram.c"
    break;

  case 672:
#line 5376 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 32561 "gram.c"
    break;

  case 673:
#line 5389 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 32567 "gram.c"
    break;

  case 674:
#line 5390 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 32573 "gram.c"
    break;

  case 675:
#line 5391 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 32579 "gram.c"
    break;

  case 676:
#line 5403 "gram.y"
                                                {
							CreateExternalStmt *n = makeNode(CreateExternalStmt);
							n->iswritable = (yyvsp[-16].boolean);
							n->isweb = (yyvsp[-14].boolean);
							(yyvsp[-11].range)->relpersistence = (yyvsp[-13].ival);
							n->relation = (yyvsp[-11].range);
							n->tableElts = (yyvsp[-9].list);
							n->exttypedesc = (ExtTableTypeDesc *) (yyvsp[-7].node);
							n->format = (yyvsp[-5].str);
							n->formatOpts = (yyvsp[-4].list);
							n->extOptions = (yyvsp[-3].list);
							n->encoding = (yyvsp[-2].list);
							n->sreh = (yyvsp[-1].node);
							n->distributedBy = (DistributedBy *) (yyvsp[0].node);
							
							/* various syntax checks for EXECUTE external table */
							if(((ExtTableTypeDesc *) n->exttypedesc)->exttabletype == EXTTBL_TYPE_EXECUTE)
							{
								ExtTableTypeDesc *extdesc = (ExtTableTypeDesc *) n->exttypedesc;
								
								if(!n->isweb)
									ereport(ERROR,
											(errcode(ERRCODE_SYNTAX_ERROR),
										 	 errmsg("EXECUTE may not be used with a regular external table"),
										 	 errhint("Use CREATE EXTERNAL WEB TABLE instead")));							
								
								/* if no ON clause specified, default to "ON ALL" */
								if(extdesc->on_clause == NIL)
								{									
									extdesc->on_clause = lappend(extdesc->on_clause, 
										   				   		 makeDefElem("all", (Node *)makeInteger(TRUE)));
								}
								else if(n->iswritable)
								{
									ereport(ERROR,
											(errcode(ERRCODE_SYNTAX_ERROR),
									 		 errmsg("ON clause may not be used with a writable external table")));							
								}
							}

							if(n->sreh)
							{
								if (n->iswritable)
									ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("Single row error handling may not be used with a writable external table")));

								if (((SingleRowErrorDesc *)n->sreh)->log_errors_type == LOG_ERRORS_PERSISTENTLY)
								{
									n->extOptions = lappend(n->extOptions,
															makeDefElem("error_log_persistent", (Node *)makeString("true")));
								}
							}

							(yyval.node) = (Node *)n;							
						}
#line 32640 "gram.c"
    break;

  case 677:
#line 5461 "gram.y"
                                                        { (yyval.boolean) = TRUE; }
#line 32646 "gram.c"
    break;

  case 678:
#line 5462 "gram.y"
                                                                        { (yyval.boolean) = FALSE; }
#line 32652 "gram.c"
    break;

  case 679:
#line 5463 "gram.y"
                                                                        { (yyval.boolean) = FALSE; }
#line 32658 "gram.c"
    break;

  case 680:
#line 5466 "gram.y"
                                                                { (yyval.boolean) = TRUE; }
#line 32664 "gram.c"
    break;

  case 681:
#line 5467 "gram.y"
                                                                { (yyval.boolean) = FALSE; }
#line 32670 "gram.c"
    break;

  case 682:
#line 5472 "gram.y"
                        {
				ExtTableTypeDesc *n = makeNode(ExtTableTypeDesc);
				n->exttabletype = EXTTBL_TYPE_LOCATION;
				n->location_list = (yyvsp[-2].list); 
				n->on_clause = (yyvsp[0].list);
				n->command_string = NULL;
				(yyval.node) = (Node *)n;
	
			}
#line 32684 "gram.c"
    break;

  case 683:
#line 5482 "gram.y"
                        {
				ExtTableTypeDesc *n = makeNode(ExtTableTypeDesc);
				n->exttabletype = EXTTBL_TYPE_EXECUTE;
				n->location_list = NIL; 
				n->command_string = (yyvsp[-1].str);
				n->on_clause = (yyvsp[0].list); /* default will get set later if needed */
						
				(yyval.node) = (Node *)n;
			}
#line 32698 "gram.c"
    break;

  case 684:
#line 5494 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32704 "gram.c"
    break;

  case 685:
#line 5495 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 32710 "gram.c"
    break;

  case 686:
#line 5500 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("all", (Node *)makeInteger(TRUE));
			}
#line 32718 "gram.c"
    break;

  case 687:
#line 5504 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("hostname", (Node *)makeString((yyvsp[0].str)));
			}
#line 32726 "gram.c"
    break;

  case 688:
#line 5508 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("eachhost", (Node *)makeInteger(TRUE));
			}
#line 32734 "gram.c"
    break;

  case 689:
#line 5512 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("master", (Node *)makeInteger(TRUE));
			}
#line 32742 "gram.c"
    break;

  case 690:
#line 5516 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("segment", (Node *)makeInteger((yyvsp[0].ival)));
			}
#line 32750 "gram.c"
    break;

  case 691:
#line 5520 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("random", (Node *)makeInteger((yyvsp[0].ival)));
			}
#line 32758 "gram.c"
    break;

  case 692:
#line 5526 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 32764 "gram.c"
    break;

  case 693:
#line 5527 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 32770 "gram.c"
    break;

  case 694:
#line 5528 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 32776 "gram.c"
    break;

  case 695:
#line 5529 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 32782 "gram.c"
    break;

  case 696:
#line 5534 "gram.y"
                        { 
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 32790 "gram.c"
    break;

  case 697:
#line 5538 "gram.y"
                        { 
				(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); 
			}
#line 32798 "gram.c"
    break;

  case 698:
#line 5545 "gram.y"
                        { 
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 32806 "gram.c"
    break;

  case 699:
#line 5549 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 32814 "gram.c"
    break;

  case 700:
#line 5556 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node));
			}
#line 32822 "gram.c"
    break;

  case 701:
#line 5560 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list));
			}
#line 32830 "gram.c"
    break;

  case 702:
#line 5567 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
			}
#line 32838 "gram.c"
    break;

  case 703:
#line 5571 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
			}
#line 32846 "gram.c"
    break;

  case 704:
#line 5575 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("csv", (Node *)makeInteger(TRUE));
			}
#line 32854 "gram.c"
    break;

  case 705:
#line 5579 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
			}
#line 32862 "gram.c"
    break;

  case 706:
#line 5583 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
			}
#line 32870 "gram.c"
    break;

  case 707:
#line 5587 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
			}
#line 32878 "gram.c"
    break;

  case 708:
#line 5591 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
			}
#line 32886 "gram.c"
    break;

  case 709:
#line 5595 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
			}
#line 32894 "gram.c"
    break;

  case 710:
#line 5599 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
			}
#line 32902 "gram.c"
    break;

  case 711:
#line 5603 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("fill_missing_fields", (Node *)makeInteger(TRUE));
			}
#line 32910 "gram.c"
    break;

  case 712:
#line 5607 "gram.y"
                        {
				(yyval.defelt) = makeDefElem("newline", (Node *)makeString((yyvsp[0].str)));
			}
#line 32918 "gram.c"
    break;

  case 713:
#line 5613 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 32924 "gram.c"
    break;

  case 714:
#line 5614 "gram.y"
                                                            { (yyval.list) = NIL; }
#line 32930 "gram.c"
    break;

  case 715:
#line 5618 "gram.y"
                                                           { (yyval.list) = (yyvsp[-1].list); }
#line 32936 "gram.c"
    break;

  case 716:
#line 5619 "gram.y"
                                                            { (yyval.list) = NIL; }
#line 32942 "gram.c"
    break;

  case 717:
#line 5624 "gram.y"
                        {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 32950 "gram.c"
    break;

  case 718:
#line 5628 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 32958 "gram.c"
    break;

  case 719:
#line 5635 "gram.y"
                        {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeString((yyvsp[0].str)));
			}
#line 32966 "gram.c"
    break;

  case 720:
#line 5641 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 32972 "gram.c"
    break;

  case 721:
#line 5642 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 32978 "gram.c"
    break;

  case 722:
#line 5647 "gram.y"
                        {
				(yyval.list) = list_make1((yyvsp[0].node));
			}
#line 32986 "gram.c"
    break;

  case 723:
#line 5651 "gram.y"
                        {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
			}
#line 32994 "gram.c"
    break;

  case 724:
#line 5657 "gram.y"
                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33000 "gram.c"
    break;

  case 725:
#line 5658 "gram.y"
                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 33006 "gram.c"
    break;

  case 726:
#line 5663 "gram.y"
                {
			ColumnDef *n = makeNode(ColumnDef);
			n->colname = (yyvsp[-1].str);
			n->typeName = (yyvsp[0].typnam);
			n->is_local = true;
			n->is_not_null = false;
			n->constraints = NIL;
			(yyval.node) = (Node *)n;
		}
#line 33020 "gram.c"
    break;

  case 727:
#line 5679 "gram.y"
                {
			SingleRowErrorDesc *n = makeNode(SingleRowErrorDesc);
			n->into_file = (yyvsp[-5].boolean) == LOG_ERRORS_DISABLE ? false : true;
			n->log_errors_type = n->into_file ? LOG_ERRORS_ENABLE : LOG_ERRORS_DISABLE;
			n->rejectlimit = (yyvsp[-1].ival);
			n->is_limit_in_rows = (yyvsp[0].boolean); /* true for ROWS false for PERCENT */

			/* PERCENT value check */
			if(!n->is_limit_in_rows && (n->rejectlimit < 1 || n->rejectlimit > 100))
				ereport(ERROR,
						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
						 errmsg("invalid PERCENT value. Should be (1 - 100)")));
			
			/* ROW values check */
			if(n->is_limit_in_rows && n->rejectlimit < 2)
			   ereport(ERROR,
					   (errcode(ERRCODE_INVALID_PARAMETER_VALUE),
						errmsg("invalid (ROWS) reject limit. Should be 2 or larger")));

			(yyval.node) = (Node *)n;
		}
#line 33046 "gram.c"
    break;

  case 728:
#line 5700 "gram.y"
                                        { (yyval.node) = NULL; }
#line 33052 "gram.c"
    break;

  case 729:
#line 5705 "gram.y"
                {
			if (gp_ignore_error_table) /* ignore the [INTO error-table] clause for backward compatibility */
			{
			ereport(WARNING,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("error table is not supported"),
					 errhint("Use gp_read_error_log() and gp_truncate_error_log() to view and manage the internal error log associated with your table.")));
			}
			else
			{
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("error table is not supported"),
					 errhint("Set gp_ignore_error_table to ignore the [INTO error-table] clause for backward compatibility."),
					 parser_errposition((yylsp[-1]))));
			}
			(yyval.boolean) = LOG_ERRORS_ENABLE;
		}
#line 33075 "gram.c"
    break;

  case 730:
#line 5723 "gram.y"
                                                                        { (yyval.boolean) = LOG_ERRORS_ENABLE; }
#line 33081 "gram.c"
    break;

  case 731:
#line 5724 "gram.y"
                                                                                { (yyval.boolean) = LOG_ERRORS_DISABLE; }
#line 33087 "gram.c"
    break;

  case 732:
#line 5728 "gram.y"
                {
			SingleRowErrorDesc *n = makeNode(SingleRowErrorDesc);
			n->log_errors_type = (yyvsp[-5].boolean);
			n->into_file = n->log_errors_type == LOG_ERRORS_DISABLE ? false : true;
			n->rejectlimit = (yyvsp[-1].ival);
			n->is_limit_in_rows = (yyvsp[0].boolean); /* true for ROWS false for PERCENT */

			/* PERCENT value check */
			if(!n->is_limit_in_rows && (n->rejectlimit < 1 || n->rejectlimit > 100))
				ereport(ERROR,
						(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
						 errmsg("invalid PERCENT value. Should be (1 - 100)")));

			/* ROW values check */
			if(n->is_limit_in_rows && n->rejectlimit < 2)
			   ereport(ERROR,
					   (errcode(ERRCODE_INVALID_PARAMETER_VALUE),
						errmsg("invalid (ROWS) reject limit. Should be 2 or larger")));

			(yyval.node) = (Node *)n;
		}
#line 33113 "gram.c"
    break;

  case 733:
#line 5749 "gram.y"
                                        { (yyval.node) = NULL; }
#line 33119 "gram.c"
    break;

  case 734:
#line 5753 "gram.y"
                                                                { (yyval.boolean) = (yyvsp[0].boolean); }
#line 33125 "gram.c"
    break;

  case 735:
#line 5754 "gram.y"
                                                        { (yyval.boolean) = LOG_ERRORS_PERSISTENTLY; }
#line 33131 "gram.c"
    break;

  case 736:
#line 5758 "gram.y"
                                                        { (yyval.boolean) = TRUE; }
#line 33137 "gram.c"
    break;

  case 737:
#line 5759 "gram.y"
                                                        { (yyval.boolean) = FALSE; }
#line 33143 "gram.c"
    break;

  case 738:
#line 5760 "gram.y"
                                        { (yyval.boolean) = TRUE; }
#line 33149 "gram.c"
    break;

  case 739:
#line 5767 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33155 "gram.c"
    break;

  case 740:
#line 5768 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 33161 "gram.c"
    break;

  case 741:
#line 5773 "gram.y"
                {
			(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
		}
#line 33169 "gram.c"
    break;

  case 742:
#line 5777 "gram.y"
                {
			(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
		}
#line 33177 "gram.c"
    break;

  case 743:
#line 5791 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-2].node);
					ctas->into = (yyvsp[-4].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-4].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-4].into)->skipData = !((yyvsp[-1].boolean));
					ctas->into->distributedBy = (yyvsp[0].node);

					(yyval.node) = (Node *) ctas;
				}
#line 33195 "gram.c"
    break;

  case 744:
#line 5808 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-3].range);
					(yyval.into)->colNames = (yyvsp[-2].list);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33210 "gram.c"
    break;

  case 745:
#line 5820 "gram.y"
                                                                { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33216 "gram.c"
    break;

  case 746:
#line 5821 "gram.y"
                                                                        { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33222 "gram.c"
    break;

  case 747:
#line 5834 "gram.y"
                                {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33234 "gram.c"
    break;

  case 748:
#line 5854 "gram.y"
                                {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 33247 "gram.c"
    break;

  case 749:
#line 5866 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 33259 "gram.c"
    break;

  case 750:
#line 5874 "gram.y"
                                {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 33271 "gram.c"
    break;

  case 751:
#line 5884 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33277 "gram.c"
    break;

  case 752:
#line 5885 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33283 "gram.c"
    break;

  case 753:
#line 5888 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33289 "gram.c"
    break;

  case 754:
#line 5889 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33295 "gram.c"
    break;

  case 755:
#line 5893 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 33303 "gram.c"
    break;

  case 756:
#line 5897 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 33311 "gram.c"
    break;

  case 757:
#line 5901 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 33319 "gram.c"
    break;

  case 758:
#line 5905 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 33327 "gram.c"
    break;

  case 759:
#line 5909 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 33335 "gram.c"
    break;

  case 760:
#line 5913 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 33343 "gram.c"
    break;

  case 761:
#line 5917 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 33351 "gram.c"
    break;

  case 762:
#line 5921 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 33359 "gram.c"
    break;

  case 763:
#line 5925 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 33367 "gram.c"
    break;

  case 764:
#line 5929 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 33375 "gram.c"
    break;

  case 765:
#line 5933 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 33383 "gram.c"
    break;

  case 766:
#line 5937 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 33391 "gram.c"
    break;

  case 767:
#line 5942 "gram.y"
                                                {}
#line 33397 "gram.c"
    break;

  case 768:
#line 5943 "gram.y"
                                        {}
#line 33403 "gram.c"
    break;

  case 769:
#line 5947 "gram.y"
                                                                                        { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 33409 "gram.c"
    break;

  case 770:
#line 5948 "gram.y"
                                                                                { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 33415 "gram.c"
    break;

  case 771:
#line 5950 "gram.y"
                                {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 33424 "gram.c"
    break;

  case 772:
#line 5954 "gram.y"
                                                                                { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 33430 "gram.c"
    break;

  case 773:
#line 5957 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 33436 "gram.c"
    break;

  case 774:
#line 5958 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 33442 "gram.c"
    break;

  case 775:
#line 5971 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 33458 "gram.c"
    break;

  case 776:
#line 5984 "gram.y"
                        {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 33473 "gram.c"
    break;

  case 777:
#line 5997 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 33479 "gram.c"
    break;

  case 778:
#line 5998 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 33485 "gram.c"
    break;

  case 779:
#line 6006 "gram.y"
                                                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33491 "gram.c"
    break;

  case 780:
#line 6007 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 33497 "gram.c"
    break;

  case 781:
#line 6011 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33503 "gram.c"
    break;

  case 782:
#line 6012 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33509 "gram.c"
    break;

  case 783:
#line 6016 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 33515 "gram.c"
    break;

  case 784:
#line 6017 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 33521 "gram.c"
    break;

  case 785:
#line 6021 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 33527 "gram.c"
    break;

  case 786:
#line 6022 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 33533 "gram.c"
    break;

  case 787:
#line 6027 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33548 "gram.c"
    break;

  case 788:
#line 6038 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 33562 "gram.c"
    break;

  case 789:
#line 6050 "gram.y"
                                                                                                {}
#line 33568 "gram.c"
    break;

  case 790:
#line 6051 "gram.y"
                                                                                                {}
#line 33574 "gram.c"
    break;

  case 791:
#line 6062 "gram.y"
                                {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].str);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33587 "gram.c"
    break;

  case 792:
#line 6072 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 33593 "gram.c"
    break;

  case 793:
#line 6073 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 33599 "gram.c"
    break;

  case 794:
#line 6087 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33610 "gram.c"
    break;

  case 795:
#line 6094 "gram.y"
                                {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33621 "gram.c"
    break;

  case 796:
#line 6111 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33633 "gram.c"
    break;

  case 797:
#line 6119 "gram.y"
                                {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33645 "gram.c"
    break;

  case 798:
#line 6130 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33651 "gram.c"
    break;

  case 799:
#line 6132 "gram.y"
                                { (yyval.list) = NIL; }
#line 33657 "gram.c"
    break;

  case 800:
#line 6137 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 33665 "gram.c"
    break;

  case 801:
#line 6141 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 33673 "gram.c"
    break;

  case 802:
#line 6145 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 33681 "gram.c"
    break;

  case 803:
#line 6157 "gram.y"
                                {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33692 "gram.c"
    break;

  case 804:
#line 6167 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33698 "gram.c"
    break;

  case 805:
#line 6169 "gram.y"
                                { (yyval.list) = NIL; }
#line 33704 "gram.c"
    break;

  case 806:
#line 6174 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 33712 "gram.c"
    break;

  case 807:
#line 6187 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 33726 "gram.c"
    break;

  case 808:
#line 6197 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 33740 "gram.c"
    break;

  case 809:
#line 6207 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33753 "gram.c"
    break;

  case 810:
#line 6216 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33766 "gram.c"
    break;

  case 811:
#line 6225 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33779 "gram.c"
    break;

  case 812:
#line 6234 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 33793 "gram.c"
    break;

  case 813:
#line 6244 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33806 "gram.c"
    break;

  case 814:
#line 6253 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33820 "gram.c"
    break;

  case 815:
#line 6263 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33834 "gram.c"
    break;

  case 816:
#line 6273 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33848 "gram.c"
    break;

  case 817:
#line 6283 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33861 "gram.c"
    break;

  case 818:
#line 6292 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 33874 "gram.c"
    break;

  case 819:
#line 6301 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33887 "gram.c"
    break;

  case 820:
#line 6310 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33900 "gram.c"
    break;

  case 821:
#line 6319 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33913 "gram.c"
    break;

  case 822:
#line 6328 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33926 "gram.c"
    break;

  case 823:
#line 6337 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33939 "gram.c"
    break;

  case 824:
#line 6346 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33952 "gram.c"
    break;

  case 825:
#line 6355 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33965 "gram.c"
    break;

  case 826:
#line 6364 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33978 "gram.c"
    break;

  case 827:
#line 6373 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 33991 "gram.c"
    break;

  case 828:
#line 6382 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 34004 "gram.c"
    break;

  case 829:
#line 6391 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 34017 "gram.c"
    break;

  case 830:
#line 6400 "gram.y"
                                {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34030 "gram.c"
    break;

  case 831:
#line 6418 "gram.y"
                                {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34042 "gram.c"
    break;

  case 832:
#line 6428 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 34048 "gram.c"
    break;

  case 833:
#line 6429 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 34054 "gram.c"
    break;

  case 834:
#line 6430 "gram.y"
                                                                        { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 34060 "gram.c"
    break;

  case 835:
#line 6431 "gram.y"
                                                                                { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 34066 "gram.c"
    break;

  case 836:
#line 6435 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34072 "gram.c"
    break;

  case 837:
#line 6436 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34078 "gram.c"
    break;

  case 838:
#line 6440 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 34084 "gram.c"
    break;

  case 839:
#line 6441 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 34090 "gram.c"
    break;

  case 840:
#line 6452 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34105 "gram.c"
    break;

  case 841:
#line 6463 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34120 "gram.c"
    break;

  case 842:
#line 6483 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34132 "gram.c"
    break;

  case 843:
#line 6491 "gram.y"
                                {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34144 "gram.c"
    break;

  case 844:
#line 6502 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34150 "gram.c"
    break;

  case 845:
#line 6503 "gram.y"
                                                                                                        { (yyval.list) = NIL; }
#line 34156 "gram.c"
    break;

  case 846:
#line 6508 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34164 "gram.c"
    break;

  case 847:
#line 6512 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34172 "gram.c"
    break;

  case 848:
#line 6519 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 34178 "gram.c"
    break;

  case 849:
#line 6524 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34186 "gram.c"
    break;

  case 850:
#line 6528 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34194 "gram.c"
    break;

  case 851:
#line 6535 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34202 "gram.c"
    break;

  case 852:
#line 6539 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 34211 "gram.c"
    break;

  case 853:
#line 6544 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 34220 "gram.c"
    break;

  case 854:
#line 6549 "gram.y"
                                {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 34228 "gram.c"
    break;

  case 855:
#line 6556 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 34236 "gram.c"
    break;

  case 856:
#line 6562 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 34242 "gram.c"
    break;

  case 857:
#line 6567 "gram.y"
                                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34248 "gram.c"
    break;

  case 858:
#line 6579 "gram.y"
                                {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34262 "gram.c"
    break;

  case 859:
#line 6591 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34268 "gram.c"
    break;

  case 860:
#line 6592 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 34274 "gram.c"
    break;

  case 861:
#line 6597 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 34280 "gram.c"
    break;

  case 862:
#line 6598 "gram.y"
                                                        { (yyval.str) = NULL; }
#line 34286 "gram.c"
    break;

  case 863:
#line 6602 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 34292 "gram.c"
    break;

  case 864:
#line 6603 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 34298 "gram.c"
    break;

  case 865:
#line 6614 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34313 "gram.c"
    break;

  case 866:
#line 6625 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34328 "gram.c"
    break;

  case 867:
#line 6645 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34341 "gram.c"
    break;

  case 868:
#line 6654 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34353 "gram.c"
    break;

  case 869:
#line 6662 "gram.y"
                                {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34364 "gram.c"
    break;

  case 870:
#line 6681 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34381 "gram.c"
    break;

  case 871:
#line 6696 "gram.y"
                                {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-6].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-6].range);
					n->base.tableElts = (yyvsp[-4].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34398 "gram.c"
    break;

  case 872:
#line 6719 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 34411 "gram.c"
    break;

  case 873:
#line 6728 "gram.y"
                                {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 34424 "gram.c"
    break;

  case 874:
#line 6746 "gram.y"
                                {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34436 "gram.c"
    break;

  case 875:
#line 6757 "gram.y"
                                        { (yyval.str) = "current_user"; }
#line 34442 "gram.c"
    break;

  case 876:
#line 6758 "gram.y"
                                                { (yyval.str) = "current_user"; }
#line 34448 "gram.c"
    break;

  case 877:
#line 6759 "gram.y"
                                                { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 34454 "gram.c"
    break;

  case 878:
#line 6770 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34466 "gram.c"
    break;

  case 879:
#line 6778 "gram.y"
                                {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34478 "gram.c"
    break;

  case 880:
#line 6795 "gram.y"
                                {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34490 "gram.c"
    break;

  case 881:
#line 6816 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 34512 "gram.c"
    break;

  case 882:
#line 6837 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 34535 "gram.c"
    break;

  case 883:
#line 6858 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 34541 "gram.c"
    break;

  case 884:
#line 6859 "gram.y"
                                                                                        { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 34547 "gram.c"
    break;

  case 885:
#line 6860 "gram.y"
                                                                                { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 34553 "gram.c"
    break;

  case 886:
#line 6865 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 34559 "gram.c"
    break;

  case 887:
#line 6867 "gram.y"
                                {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 34582 "gram.c"
    break;

  case 888:
#line 6889 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 34588 "gram.c"
    break;

  case 889:
#line 6891 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 34594 "gram.c"
    break;

  case 890:
#line 6893 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 34600 "gram.c"
    break;

  case 891:
#line 6895 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 34606 "gram.c"
    break;

  case 892:
#line 6897 "gram.y"
                                { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 34612 "gram.c"
    break;

  case 893:
#line 6902 "gram.y"
                                {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 34620 "gram.c"
    break;

  case 894:
#line 6906 "gram.y"
                                {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 34632 "gram.c"
    break;

  case 895:
#line 6916 "gram.y"
                                                                                                {}
#line 34638 "gram.c"
    break;

  case 896:
#line 6917 "gram.y"
                                                                                                {}
#line 34644 "gram.c"
    break;

  case 897:
#line 6921 "gram.y"
                                                                                                        { (yyval.boolean) = TRUE; }
#line 34650 "gram.c"
    break;

  case 898:
#line 6922 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 34656 "gram.c"
    break;

  case 899:
#line 6926 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 34662 "gram.c"
    break;

  case 900:
#line 6927 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 34668 "gram.c"
    break;

  case 901:
#line 6931 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 34674 "gram.c"
    break;

  case 902:
#line 6932 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 34680 "gram.c"
    break;

  case 903:
#line 6933 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 34686 "gram.c"
    break;

  case 904:
#line 6938 "gram.y"
                                {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 34696 "gram.c"
    break;

  case 905:
#line 6943 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34702 "gram.c"
    break;

  case 906:
#line 6944 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34708 "gram.c"
    break;

  case 907:
#line 6945 "gram.y"
                                                                                                { (yyval.value) = makeString((yyvsp[0].str)); }
#line 34714 "gram.c"
    break;

  case 908:
#line 6949 "gram.y"
                                                                                        { (yyval.range) = (yyvsp[0].range); }
#line 34720 "gram.c"
    break;

  case 909:
#line 6950 "gram.y"
                                                                                                { (yyval.range) = NULL; }
#line 34726 "gram.c"
    break;

  case 910:
#line 6955 "gram.y"
                                { (yyval.ival) = 0; }
#line 34732 "gram.c"
    break;

  case 911:
#line 6957 "gram.y"
                                {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 34760 "gram.c"
    break;

  case 912:
#line 6983 "gram.y"
                                                                        { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 34766 "gram.c"
    break;

  case 913:
#line 6984 "gram.y"
                                                                        { (yyval.ival) = CAS_DEFERRABLE; }
#line 34772 "gram.c"
    break;

  case 914:
#line 6985 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 34778 "gram.c"
    break;

  case 915:
#line 6986 "gram.y"
                                                                { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 34784 "gram.c"
    break;

  case 916:
#line 6987 "gram.y"
                                                                                { (yyval.ival) = CAS_NOT_VALID; }
#line 34790 "gram.c"
    break;

  case 917:
#line 6988 "gram.y"
                                                                        { (yyval.ival) = CAS_NO_INHERIT; }
#line 34796 "gram.c"
    break;

  case 918:
#line 6994 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34811 "gram.c"
    break;

  case 919:
#line 7005 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34826 "gram.c"
    break;

  case 920:
#line 7029 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 34839 "gram.c"
    break;

  case 921:
#line 7040 "gram.y"
                                {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 34852 "gram.c"
    break;

  case 922:
#line 7052 "gram.y"
                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34858 "gram.c"
    break;

  case 923:
#line 7054 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34864 "gram.c"
    break;

  case 924:
#line 7059 "gram.y"
                        { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list)); }
#line 34870 "gram.c"
    break;

  case 925:
#line 7064 "gram.y"
                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34876 "gram.c"
    break;

  case 926:
#line 7066 "gram.y"
                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34882 "gram.c"
    break;

  case 927:
#line 7071 "gram.y"
                                {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 34893 "gram.c"
    break;

  case 928:
#line 7080 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 34899 "gram.c"
    break;

  case 929:
#line 7081 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 34905 "gram.c"
    break;

  case 930:
#line 7082 "gram.y"
                                                                { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 34911 "gram.c"
    break;

  case 931:
#line 7083 "gram.y"
                                                                        { (yyval.chr) = TRIGGER_DISABLED; }
#line 34917 "gram.c"
    break;

  case 932:
#line 7097 "gram.y"
                                {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 34937 "gram.c"
    break;

  case 933:
#line 7116 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 34953 "gram.c"
    break;

  case 934:
#line 7139 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34967 "gram.c"
    break;

  case 935:
#line 7149 "gram.y"
                                {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34982 "gram.c"
    break;

  case 936:
#line 7160 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34996 "gram.c"
    break;

  case 937:
#line 7170 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35010 "gram.c"
    break;

  case 938:
#line 7180 "gram.y"
                                {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 35025 "gram.c"
    break;

  case 939:
#line 7191 "gram.y"
                                {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35038 "gram.c"
    break;

  case 940:
#line 7200 "gram.y"
                                {
					/*
					 * The opt_or_replace is here just to avoid a grammar conflict.
					 * It's not actually supported.
					 */
					if ((yyvsp[-4].boolean))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("syntax error"),
								 parser_errposition((yylsp[-4]))));

					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_EXTPROTOCOL;
					n->oldstyle = false;
					n->trusted = (yyvsp[-3].boolean);
					n->defnames = list_make1(makeString((yyvsp[-1].str)));
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35063 "gram.c"
    break;

  case 941:
#line 7221 "gram.y"
                                {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 35074 "gram.c"
    break;

  case 942:
#line 7228 "gram.y"
                                {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35085 "gram.c"
    break;

  case 943:
#line 7235 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35098 "gram.c"
    break;

  case 944:
#line 7244 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35111 "gram.c"
    break;

  case 945:
#line 7253 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35124 "gram.c"
    break;

  case 946:
#line 7262 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35137 "gram.c"
    break;

  case 947:
#line 7271 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 35150 "gram.c"
    break;

  case 948:
#line 7280 "gram.y"
                                {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 35163 "gram.c"
    break;

  case 949:
#line 7290 "gram.y"
                        { (yyval.boolean) = TRUE; }
#line 35169 "gram.c"
    break;

  case 950:
#line 7291 "gram.y"
                                        { (yyval.boolean) = FALSE; }
#line 35175 "gram.c"
    break;

  case 951:
#line 7294 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 35181 "gram.c"
    break;

  case 952:
#line 7297 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35187 "gram.c"
    break;

  case 953:
#line 7298 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35193 "gram.c"
    break;

  case 954:
#line 7302 "gram.y"
                                {
					/*
					 * appendoptimized is an alias for appendonly in order to
					 * provide a reloption syntax which better reflects the
					 * featureset of AO tables. It is implemented as a very
					 * thin alias, the reloptions and messaging will still
					 * say appendonly.
					 */
					if (strcmp((yyvsp[-2].str), "appendoptimized") == 0)
						(yyval.defelt) = makeDefElem("appendonly", (Node *) (yyvsp[0].node));
					else
						(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 35211 "gram.c"
    break;

  case 955:
#line 7316 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 35219 "gram.c"
    break;

  case 956:
#line 7322 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 35225 "gram.c"
    break;

  case 957:
#line 7324 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString(pstrdup("row")); }
#line 35231 "gram.c"
    break;

  case 958:
#line 7325 "gram.y"
                                                                        { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 35237 "gram.c"
    break;

  case 959:
#line 7326 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 35243 "gram.c"
    break;

  case 960:
#line 7327 "gram.y"
                                                                        { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 35249 "gram.c"
    break;

  case 961:
#line 7328 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 35255 "gram.c"
    break;

  case 962:
#line 7335 "gram.y"
                                                                                { (yyval.node) = (Node *)makeString(pstrdup("none")); }
#line 35261 "gram.c"
    break;

  case 963:
#line 7338 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 35267 "gram.c"
    break;

  case 964:
#line 7341 "gram.y"
                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35273 "gram.c"
    break;

  case 965:
#line 7342 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35279 "gram.c"
    break;

  case 966:
#line 7351 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 35287 "gram.c"
    break;

  case 967:
#line 7357 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35293 "gram.c"
    break;

  case 968:
#line 7358 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 35299 "gram.c"
    break;

  case 969:
#line 7362 "gram.y"
                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35305 "gram.c"
    break;

  case 970:
#line 7364 "gram.y"
                                { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35311 "gram.c"
    break;

  case 971:
#line 7375 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35325 "gram.c"
    break;

  case 972:
#line 7385 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35339 "gram.c"
    break;

  case 973:
#line 7395 "gram.y"
                        {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 35353 "gram.c"
    break;

  case 974:
#line 7406 "gram.y"
                                                { (yyval.boolean) = true; }
#line 35359 "gram.c"
    break;

  case 975:
#line 7407 "gram.y"
                                                       { (yyval.boolean) = false; }
#line 35365 "gram.c"
    break;

  case 976:
#line 7425 "gram.y"
                                {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35380 "gram.c"
    break;

  case 977:
#line 7438 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35386 "gram.c"
    break;

  case 978:
#line 7439 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35392 "gram.c"
    break;

  case 979:
#line 7444 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35406 "gram.c"
    break;

  case 980:
#line 7455 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35420 "gram.c"
    break;

  case 981:
#line 7465 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 35433 "gram.c"
    break;

  case 982:
#line 7474 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 35447 "gram.c"
    break;

  case 983:
#line 7484 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 35458 "gram.c"
    break;

  case 984:
#line 7492 "gram.y"
                                                                { (yyval.boolean) = TRUE; }
#line 35464 "gram.c"
    break;

  case 985:
#line 7493 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 35470 "gram.c"
    break;

  case 986:
#line 7496 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 35476 "gram.c"
    break;

  case 987:
#line 7497 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 35482 "gram.c"
    break;

  case 988:
#line 7500 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 35488 "gram.c"
    break;

  case 989:
#line 7501 "gram.y"
                                                                { (yyval.list) = (yyvsp[0].list); }
#line 35494 "gram.c"
    break;

  case 990:
#line 7502 "gram.y"
                                                                                { (yyval.list) = NIL; }
#line 35500 "gram.c"
    break;

  case 991:
#line 7506 "gram.y"
                                {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 35518 "gram.c"
    break;

  case 992:
#line 7519 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 35524 "gram.c"
    break;

  case 993:
#line 7525 "gram.y"
                                {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35535 "gram.c"
    break;

  case 994:
#line 7535 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35548 "gram.c"
    break;

  case 995:
#line 7544 "gram.y"
                                {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35561 "gram.c"
    break;

  case 996:
#line 7555 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35567 "gram.c"
    break;

  case 997:
#line 7556 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35573 "gram.c"
    break;

  case 998:
#line 7561 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35585 "gram.c"
    break;

  case 999:
#line 7569 "gram.y"
                                {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35597 "gram.c"
    break;

  case 1000:
#line 7581 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35612 "gram.c"
    break;

  case 1001:
#line 7592 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35627 "gram.c"
    break;

  case 1002:
#line 7606 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35642 "gram.c"
    break;

  case 1003:
#line 7617 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[-3].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[-1].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 35657 "gram.c"
    break;

  case 1004:
#line 7640 "gram.y"
                                {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35668 "gram.c"
    break;

  case 1005:
#line 7650 "gram.y"
                                {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 35679 "gram.c"
    break;

  case 1006:
#line 7668 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35694 "gram.c"
    break;

  case 1007:
#line 7679 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 35709 "gram.c"
    break;

  case 1008:
#line 7690 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 35724 "gram.c"
    break;

  case 1009:
#line 7701 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 35739 "gram.c"
    break;

  case 1010:
#line 7714 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLE; }
#line 35745 "gram.c"
    break;

  case 1011:
#line 7715 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EXTTABLE; }
#line 35751 "gram.c"
    break;

  case 1012:
#line 7716 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_EXTTABLE; }
#line 35757 "gram.c"
    break;

  case 1013:
#line 7717 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 35763 "gram.c"
    break;

  case 1014:
#line 7718 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_VIEW; }
#line 35769 "gram.c"
    break;

  case 1015:
#line 7719 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_MATVIEW; }
#line 35775 "gram.c"
    break;

  case 1016:
#line 7720 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 35781 "gram.c"
    break;

  case 1017:
#line 7721 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 35787 "gram.c"
    break;

  case 1018:
#line 7722 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 35793 "gram.c"
    break;

  case 1019:
#line 7723 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TYPE; }
#line 35799 "gram.c"
    break;

  case 1020:
#line 7724 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_DOMAIN; }
#line 35805 "gram.c"
    break;

  case 1021:
#line 7725 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_COLLATION; }
#line 35811 "gram.c"
    break;

  case 1022:
#line 7726 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_CONVERSION; }
#line 35817 "gram.c"
    break;

  case 1023:
#line 7727 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_SCHEMA; }
#line 35823 "gram.c"
    break;

  case 1024:
#line 7728 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTENSION; }
#line 35829 "gram.c"
    break;

  case 1025:
#line 7729 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSPARSER; }
#line 35835 "gram.c"
    break;

  case 1026:
#line 7730 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 35841 "gram.c"
    break;

  case 1027:
#line 7731 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 35847 "gram.c"
    break;

  case 1028:
#line 7732 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 35853 "gram.c"
    break;

  case 1029:
#line 7733 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_EXTPROTOCOL; }
#line 35859 "gram.c"
    break;

  case 1030:
#line 7737 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35865 "gram.c"
    break;

  case 1031:
#line 7738 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35871 "gram.c"
    break;

  case 1032:
#line 7741 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35877 "gram.c"
    break;

  case 1033:
#line 7742 "gram.y"
                                                                { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 35883 "gram.c"
    break;

  case 1034:
#line 7746 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35889 "gram.c"
    break;

  case 1035:
#line 7748 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35895 "gram.c"
    break;

  case 1036:
#line 7761 "gram.y"
                                {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35907 "gram.c"
    break;

  case 1037:
#line 7771 "gram.y"
                                                        { (yyval.boolean) = false; }
#line 35913 "gram.c"
    break;

  case 1038:
#line 7772 "gram.y"
                                                        { (yyval.boolean) = true; }
#line 35919 "gram.c"
    break;

  case 1039:
#line 7773 "gram.y"
                                                                { (yyval.boolean) = false; }
#line 35925 "gram.c"
    break;

  case 1040:
#line 7806 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35938 "gram.c"
    break;

  case 1041:
#line 7815 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35951 "gram.c"
    break;

  case 1042:
#line 7824 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35964 "gram.c"
    break;

  case 1043:
#line 7833 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35977 "gram.c"
    break;

  case 1044:
#line 7842 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35990 "gram.c"
    break;

  case 1045:
#line 7851 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36003 "gram.c"
    break;

  case 1046:
#line 7860 "gram.y"
                                {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36017 "gram.c"
    break;

  case 1047:
#line 7870 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36030 "gram.c"
    break;

  case 1048:
#line 7879 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36043 "gram.c"
    break;

  case 1049:
#line 7888 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36056 "gram.c"
    break;

  case 1050:
#line 7897 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36069 "gram.c"
    break;

  case 1051:
#line 7906 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36082 "gram.c"
    break;

  case 1052:
#line 7915 "gram.y"
                                {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36095 "gram.c"
    break;

  case 1053:
#line 7926 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLUMN; }
#line 36101 "gram.c"
    break;

  case 1054:
#line 7927 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_DATABASE; }
#line 36107 "gram.c"
    break;

  case 1055:
#line 7928 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36113 "gram.c"
    break;

  case 1056:
#line 7929 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_INDEX; }
#line 36119 "gram.c"
    break;

  case 1057:
#line 7930 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36125 "gram.c"
    break;

  case 1058:
#line 7931 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLE; }
#line 36131 "gram.c"
    break;

  case 1059:
#line 7932 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_DOMAIN; }
#line 36137 "gram.c"
    break;

  case 1060:
#line 7933 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TYPE; }
#line 36143 "gram.c"
    break;

  case 1061:
#line 7934 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_VIEW; }
#line 36149 "gram.c"
    break;

  case 1062:
#line 7935 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36155 "gram.c"
    break;

  case 1063:
#line 7936 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLLATION; }
#line 36161 "gram.c"
    break;

  case 1064:
#line 7937 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36167 "gram.c"
    break;

  case 1065:
#line 7938 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36173 "gram.c"
    break;

  case 1066:
#line 7939 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36179 "gram.c"
    break;

  case 1067:
#line 7940 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ROLE; }
#line 36185 "gram.c"
    break;

  case 1068:
#line 7941 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36191 "gram.c"
    break;

  case 1069:
#line 7942 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36197 "gram.c"
    break;

  case 1070:
#line 7943 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_FDW; }
#line 36203 "gram.c"
    break;

  case 1071:
#line 7944 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36209 "gram.c"
    break;

  case 1072:
#line 7945 "gram.y"
                                                                { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36215 "gram.c"
    break;

  case 1073:
#line 7946 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36221 "gram.c"
    break;

  case 1074:
#line 7947 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36227 "gram.c"
    break;

  case 1075:
#line 7948 "gram.y"
                                                                        { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36233 "gram.c"
    break;

  case 1076:
#line 7949 "gram.y"
                                                            { (yyval.objtype) = OBJECT_RESQUEUE; }
#line 36239 "gram.c"
    break;

  case 1077:
#line 7950 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_RESGROUP; }
#line 36245 "gram.c"
    break;

  case 1078:
#line 7954 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 36251 "gram.c"
    break;

  case 1079:
#line 7955 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 36257 "gram.c"
    break;

  case 1080:
#line 7971 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36271 "gram.c"
    break;

  case 1081:
#line 7982 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractAggrArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36285 "gram.c"
    break;

  case 1082:
#line 7993 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36299 "gram.c"
    break;

  case 1083:
#line 8004 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36313 "gram.c"
    break;

  case 1084:
#line 8015 "gram.y"
                                {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36327 "gram.c"
    break;

  case 1085:
#line 8026 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 36333 "gram.c"
    break;

  case 1086:
#line 8027 "gram.y"
                                                                                { (yyval.str) = NULL; }
#line 36339 "gram.c"
    break;

  case 1087:
#line 8031 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_COLUMN; }
#line 36345 "gram.c"
    break;

  case 1088:
#line 8032 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_DATABASE; }
#line 36351 "gram.c"
    break;

  case 1089:
#line 8033 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36357 "gram.c"
    break;

  case 1090:
#line 8034 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36363 "gram.c"
    break;

  case 1091:
#line 8035 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36369 "gram.c"
    break;

  case 1092:
#line 8036 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36375 "gram.c"
    break;

  case 1093:
#line 8037 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TABLE; }
#line 36381 "gram.c"
    break;

  case 1094:
#line 8038 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TYPE; }
#line 36387 "gram.c"
    break;

  case 1095:
#line 8039 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_ROLE; }
#line 36393 "gram.c"
    break;

  case 1096:
#line 8040 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36399 "gram.c"
    break;

  case 1097:
#line 8041 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_TYPE; }
#line 36405 "gram.c"
    break;

  case 1098:
#line 8042 "gram.y"
                                                                                        { (yyval.objtype) = OBJECT_VIEW; }
#line 36411 "gram.c"
    break;

  case 1099:
#line 8043 "gram.y"
                                                                                { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36417 "gram.c"
    break;

  case 1100:
#line 8046 "gram.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 36423 "gram.c"
    break;

  case 1101:
#line 8047 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 36429 "gram.c"
    break;

  case 1102:
#line 8058 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 36439 "gram.c"
    break;

  case 1103:
#line 8064 "gram.y"
                                {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 36449 "gram.c"
    break;

  case 1104:
#line 8072 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36461 "gram.c"
    break;

  case 1105:
#line 8080 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36473 "gram.c"
    break;

  case 1106:
#line 8088 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36485 "gram.c"
    break;

  case 1107:
#line 8096 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36497 "gram.c"
    break;

  case 1108:
#line 8104 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36509 "gram.c"
    break;

  case 1109:
#line 8112 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 36521 "gram.c"
    break;

  case 1110:
#line 8120 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36533 "gram.c"
    break;

  case 1111:
#line 8128 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36545 "gram.c"
    break;

  case 1112:
#line 8136 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36557 "gram.c"
    break;

  case 1113:
#line 8144 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 36569 "gram.c"
    break;

  case 1114:
#line 8152 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36581 "gram.c"
    break;

  case 1115:
#line 8160 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36593 "gram.c"
    break;

  case 1116:
#line 8168 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 36605 "gram.c"
    break;

  case 1117:
#line 8176 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 36617 "gram.c"
    break;

  case 1118:
#line 8184 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 36629 "gram.c"
    break;

  case 1119:
#line 8192 "gram.y"
                                {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 36641 "gram.c"
    break;

  case 1120:
#line 8201 "gram.y"
                                                                                        {}
#line 36647 "gram.c"
    break;

  case 1121:
#line 8202 "gram.y"
                                                                                                {}
#line 36653 "gram.c"
    break;

  case 1122:
#line 8205 "gram.y"
                                                                                {}
#line 36659 "gram.c"
    break;

  case 1123:
#line 8206 "gram.y"
                                                                                        {}
#line 36665 "gram.c"
    break;

  case 1124:
#line 8218 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 36681 "gram.c"
    break;

  case 1125:
#line 8234 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36698 "gram.c"
    break;

  case 1126:
#line 8248 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36715 "gram.c"
    break;

  case 1127:
#line 8273 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 36721 "gram.c"
    break;

  case 1128:
#line 8275 "gram.y"
                                { (yyval.list) = NIL; }
#line 36727 "gram.c"
    break;

  case 1129:
#line 8277 "gram.y"
                                { (yyval.list) = NIL; }
#line 36733 "gram.c"
    break;

  case 1130:
#line 8279 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 36744 "gram.c"
    break;

  case 1131:
#line 8286 "gram.y"
                                {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 36755 "gram.c"
    break;

  case 1132:
#line 8294 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 36761 "gram.c"
    break;

  case 1133:
#line 8295 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 36767 "gram.c"
    break;

  case 1134:
#line 8299 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36778 "gram.c"
    break;

  case 1135:
#line 8306 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36789 "gram.c"
    break;

  case 1136:
#line 8313 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36800 "gram.c"
    break;

  case 1137:
#line 8320 "gram.y"
                        {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 36811 "gram.c"
    break;

  case 1138:
#line 8334 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36823 "gram.c"
    break;

  case 1139:
#line 8342 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36835 "gram.c"
    break;

  case 1140:
#line 8350 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36847 "gram.c"
    break;

  case 1141:
#line 8358 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36859 "gram.c"
    break;

  case 1142:
#line 8366 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36871 "gram.c"
    break;

  case 1143:
#line 8374 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36883 "gram.c"
    break;

  case 1144:
#line 8382 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36895 "gram.c"
    break;

  case 1145:
#line 8390 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36907 "gram.c"
    break;

  case 1146:
#line 8398 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36919 "gram.c"
    break;

  case 1147:
#line 8406 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36931 "gram.c"
    break;

  case 1148:
#line 8414 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36943 "gram.c"
    break;

  case 1149:
#line 8422 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36955 "gram.c"
    break;

  case 1150:
#line 8430 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_EXTPROTOCOL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36967 "gram.c"
    break;

  case 1151:
#line 8438 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36979 "gram.c"
    break;

  case 1152:
#line 8446 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36991 "gram.c"
    break;

  case 1153:
#line 8454 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37003 "gram.c"
    break;

  case 1154:
#line 8462 "gram.y"
                                {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37015 "gram.c"
    break;

  case 1155:
#line 8473 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37021 "gram.c"
    break;

  case 1156:
#line 8474 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37027 "gram.c"
    break;

  case 1157:
#line 8478 "gram.y"
                                {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37041 "gram.c"
    break;

  case 1158:
#line 8488 "gram.y"
                                {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 37055 "gram.c"
    break;

  case 1159:
#line 8501 "gram.y"
                                          { (yyval.boolean) = TRUE; }
#line 37061 "gram.c"
    break;

  case 1160:
#line 8502 "gram.y"
                                    { (yyval.boolean) = FALSE; }
#line 37067 "gram.c"
    break;

  case 1161:
#line 8506 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 37073 "gram.c"
    break;

  case 1162:
#line 8508 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 37079 "gram.c"
    break;

  case 1163:
#line 8513 "gram.y"
                                {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 37090 "gram.c"
    break;

  case 1164:
#line 8529 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 37104 "gram.c"
    break;

  case 1165:
#line 8542 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 37118 "gram.c"
    break;

  case 1166:
#line 8552 "gram.y"
                                {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 37132 "gram.c"
    break;

  case 1167:
#line 8563 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 37138 "gram.c"
    break;

  case 1168:
#line 8564 "gram.y"
                                                                                                        { (yyval.boolean) = FALSE; }
#line 37144 "gram.c"
    break;

  case 1169:
#line 8567 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 37150 "gram.c"
    break;

  case 1170:
#line 8568 "gram.y"
                                                                                                        { (yyval.str) = NULL; }
#line 37156 "gram.c"
    break;

  case 1171:
#line 8579 "gram.y"
                                {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 37167 "gram.c"
    break;

  case 1172:
#line 8588 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37173 "gram.c"
    break;

  case 1173:
#line 8589 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 37179 "gram.c"
    break;

  case 1174:
#line 8594 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 37187 "gram.c"
    break;

  case 1175:
#line 8598 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 37195 "gram.c"
    break;

  case 1176:
#line 8602 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 37203 "gram.c"
    break;

  case 1177:
#line 8614 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 37219 "gram.c"
    break;

  case 1178:
#line 8627 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37236 "gram.c"
    break;

  case 1179:
#line 8641 "gram.y"
                                {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 37253 "gram.c"
    break;

  case 1180:
#line 8656 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 37259 "gram.c"
    break;

  case 1181:
#line 8657 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 37265 "gram.c"
    break;

  case 1182:
#line 8658 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 37271 "gram.c"
    break;

  case 1183:
#line 8659 "gram.y"
                                                { (yyval.ival) = ACL_OBJECT_TYPE; }
#line 37277 "gram.c"
    break;

  case 1184:
#line 8674 "gram.y"
                                {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;

                    if (n->concurrent)
					{
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE INDEX CONCURRENTLY is not supported")));

					}

					(yyval.node) = (Node *)n;
				}
#line 37312 "gram.c"
    break;

  case 1185:
#line 8707 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 37318 "gram.c"
    break;

  case 1186:
#line 8708 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 37324 "gram.c"
    break;

  case 1187:
#line 8712 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 37330 "gram.c"
    break;

  case 1188:
#line 8713 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 37336 "gram.c"
    break;

  case 1189:
#line 8717 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 37342 "gram.c"
    break;

  case 1190:
#line 8718 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 37348 "gram.c"
    break;

  case 1191:
#line 8722 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 37354 "gram.c"
    break;

  case 1192:
#line 8723 "gram.y"
                                                                                                { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 37360 "gram.c"
    break;

  case 1193:
#line 8726 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 37366 "gram.c"
    break;

  case 1194:
#line 8727 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 37372 "gram.c"
    break;

  case 1195:
#line 8736 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37387 "gram.c"
    break;

  case 1196:
#line 8747 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37402 "gram.c"
    break;

  case 1197:
#line 8758 "gram.y"
                                {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 37417 "gram.c"
    break;

  case 1198:
#line 8770 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37423 "gram.c"
    break;

  case 1199:
#line 8771 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37429 "gram.c"
    break;

  case 1200:
#line 8774 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37435 "gram.c"
    break;

  case 1201:
#line 8775 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 37441 "gram.c"
    break;

  case 1202:
#line 8776 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37447 "gram.c"
    break;

  case 1203:
#line 8779 "gram.y"
                                                                        { (yyval.ival) = SORTBY_ASC; }
#line 37453 "gram.c"
    break;

  case 1204:
#line 8780 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DESC; }
#line 37459 "gram.c"
    break;

  case 1205:
#line 8781 "gram.y"
                                                                                { (yyval.ival) = SORTBY_DEFAULT; }
#line 37465 "gram.c"
    break;

  case 1206:
#line 8784 "gram.y"
                                                        { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 37471 "gram.c"
    break;

  case 1207:
#line 8785 "gram.y"
                                                                        { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 37477 "gram.c"
    break;

  case 1208:
#line 8786 "gram.y"
                                                                                { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 37483 "gram.c"
    break;

  case 1209:
#line 8804 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37498 "gram.c"
    break;

  case 1210:
#line 8816 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37514 "gram.c"
    break;

  case 1211:
#line 8829 "gram.y"
                                {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37529 "gram.c"
    break;

  case 1212:
#line 8842 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 37535 "gram.c"
    break;

  case 1213:
#line 8843 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 37541 "gram.c"
    break;

  case 1214:
#line 8846 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 37547 "gram.c"
    break;

  case 1215:
#line 8847 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37553 "gram.c"
    break;

  case 1216:
#line 8851 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37559 "gram.c"
    break;

  case 1217:
#line 8852 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37565 "gram.c"
    break;

  case 1218:
#line 8860 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 37571 "gram.c"
    break;

  case 1219:
#line 8861 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 37577 "gram.c"
    break;

  case 1220:
#line 8865 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37583 "gram.c"
    break;

  case 1221:
#line 8867 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37589 "gram.c"
    break;

  case 1222:
#line 8882 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37602 "gram.c"
    break;

  case 1223:
#line 8891 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37615 "gram.c"
    break;

  case 1224:
#line 8900 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37628 "gram.c"
    break;

  case 1225:
#line 8909 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37641 "gram.c"
    break;

  case 1226:
#line 8918 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37654 "gram.c"
    break;

  case 1227:
#line 8929 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 37660 "gram.c"
    break;

  case 1228:
#line 8930 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 37666 "gram.c"
    break;

  case 1229:
#line 8931 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 37672 "gram.c"
    break;

  case 1230:
#line 8932 "gram.y"
                                                                                { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 37678 "gram.c"
    break;

  case 1231:
#line 8933 "gram.y"
                                                                                        { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 37684 "gram.c"
    break;

  case 1233:
#line 8944 "gram.y"
                                {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 37696 "gram.c"
    break;

  case 1234:
#line 8958 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 37702 "gram.c"
    break;

  case 1235:
#line 8960 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 37712 "gram.c"
    break;

  case 1236:
#line 8966 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 37723 "gram.c"
    break;

  case 1237:
#line 8976 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 37731 "gram.c"
    break;

  case 1238:
#line 8980 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 37740 "gram.c"
    break;

  case 1239:
#line 8985 "gram.y"
                                {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 37749 "gram.c"
    break;

  case 1240:
#line 8993 "gram.y"
                                {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 37763 "gram.c"
    break;

  case 1241:
#line 9034 "gram.y"
                                {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 37771 "gram.c"
    break;

  case 1242:
#line 9038 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 37779 "gram.c"
    break;

  case 1243:
#line 9042 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 37787 "gram.c"
    break;

  case 1244:
#line 9046 "gram.y"
                                {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 37796 "gram.c"
    break;

  case 1245:
#line 9053 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37802 "gram.c"
    break;

  case 1246:
#line 9054 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37808 "gram.c"
    break;

  case 1247:
#line 9059 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37814 "gram.c"
    break;

  case 1248:
#line 9060 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37820 "gram.c"
    break;

  case 1249:
#line 9068 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 37828 "gram.c"
    break;

  case 1250:
#line 9072 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 37836 "gram.c"
    break;

  case 1251:
#line 9076 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 37844 "gram.c"
    break;

  case 1252:
#line 9080 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 37852 "gram.c"
    break;

  case 1253:
#line 9084 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 37860 "gram.c"
    break;

  case 1254:
#line 9088 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 37868 "gram.c"
    break;

  case 1255:
#line 9092 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 37876 "gram.c"
    break;

  case 1256:
#line 9096 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 37884 "gram.c"
    break;

  case 1257:
#line 9100 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 37892 "gram.c"
    break;

  case 1258:
#line 9104 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 37900 "gram.c"
    break;

  case 1259:
#line 9108 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
#line 37908 "gram.c"
    break;

  case 1260:
#line 9112 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
#line 37916 "gram.c"
    break;

  case 1261:
#line 9116 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 37924 "gram.c"
    break;

  case 1262:
#line 9120 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 37932 "gram.c"
    break;

  case 1263:
#line 9124 "gram.y"
                                {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 37941 "gram.c"
    break;

  case 1264:
#line 9129 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("data_access", (Node *)makeString("none"));
				}
#line 37949 "gram.c"
    break;

  case 1265:
#line 9133 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("data_access", (Node *)makeString("contains"));
				}
#line 37957 "gram.c"
    break;

  case 1266:
#line 9137 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("data_access", (Node *)makeString("reads"));
				}
#line 37965 "gram.c"
    break;

  case 1267:
#line 9141 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("data_access", (Node *)makeString("modifies"));
				}
#line 37973 "gram.c"
    break;

  case 1268:
#line 9145 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exec_location", (Node *)makeString("any"));
				}
#line 37981 "gram.c"
    break;

  case 1269:
#line 9149 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exec_location", (Node *)makeString("master"));
				}
#line 37989 "gram.c"
    break;

  case 1270:
#line 9153 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exec_location", (Node *)makeString("initplan"));
				}
#line 37997 "gram.c"
    break;

  case 1271:
#line 9157 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("exec_location", (Node *)makeString("all_segments"));
				}
#line 38005 "gram.c"
    break;

  case 1272:
#line 9164 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 38013 "gram.c"
    break;

  case 1273:
#line 9168 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 38021 "gram.c"
    break;

  case 1274:
#line 9172 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 38029 "gram.c"
    break;

  case 1275:
#line 9176 "gram.y"
                                {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 38037 "gram.c"
    break;

  case 1276:
#line 9181 "gram.y"
                                                                { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38043 "gram.c"
    break;

  case 1277:
#line 9183 "gram.y"
                                {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 38051 "gram.c"
    break;

  case 1278:
#line 9189 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 38057 "gram.c"
    break;

  case 1279:
#line 9190 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 38063 "gram.c"
    break;

  case 1280:
#line 9194 "gram.y"
                                {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38076 "gram.c"
    break;

  case 1281:
#line 9206 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 38084 "gram.c"
    break;

  case 1282:
#line 9210 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 38092 "gram.c"
    break;

  case 1283:
#line 9225 "gram.y"
                                {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38103 "gram.c"
    break;

  case 1284:
#line 9235 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38109 "gram.c"
    break;

  case 1285:
#line 9236 "gram.y"
                                                                  { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38115 "gram.c"
    break;

  case 1288:
#line 9258 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38130 "gram.c"
    break;

  case 1289:
#line 9269 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38145 "gram.c"
    break;

  case 1290:
#line 9283 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38160 "gram.c"
    break;

  case 1291:
#line 9294 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[-1].list)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38175 "gram.c"
    break;

  case 1292:
#line 9308 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38190 "gram.c"
    break;

  case 1293:
#line 9319 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[-2].list));
					n->arguments = list_make1((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38205 "gram.c"
    break;

  case 1294:
#line 9333 "gram.y"
                                {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 38217 "gram.c"
    break;

  case 1295:
#line 9341 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 38223 "gram.c"
    break;

  case 1296:
#line 9343 "gram.y"
                                        { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 38229 "gram.c"
    break;

  case 1297:
#line 9345 "gram.y"
                                        { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 38235 "gram.c"
    break;

  case 1298:
#line 9350 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38241 "gram.c"
    break;

  case 1299:
#line 9352 "gram.y"
                                        { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 38247 "gram.c"
    break;

  case 1300:
#line 9365 "gram.y"
                                {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38257 "gram.c"
    break;

  case 1301:
#line 9373 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38263 "gram.c"
    break;

  case 1302:
#line 9374 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38269 "gram.c"
    break;

  case 1303:
#line 9379 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 38277 "gram.c"
    break;

  case 1304:
#line 9383 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 38285 "gram.c"
    break;

  case 1305:
#line 9396 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 38299 "gram.c"
    break;

  case 1306:
#line 9407 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 38313 "gram.c"
    break;

  case 1307:
#line 9418 "gram.y"
                                {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 38327 "gram.c"
    break;

  case 1308:
#line 9429 "gram.y"
                                                                { (yyval.ival) = COERCION_IMPLICIT; }
#line 38333 "gram.c"
    break;

  case 1309:
#line 9430 "gram.y"
                                                                                { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 38339 "gram.c"
    break;

  case 1310:
#line 9431 "gram.y"
                                                                                        { (yyval.ival) = COERCION_EXPLICIT; }
#line 38345 "gram.c"
    break;

  case 1311:
#line 9436 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[-4].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 38360 "gram.c"
    break;

  case 1312:
#line 9448 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 38366 "gram.c"
    break;

  case 1313:
#line 9449 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 38372 "gram.c"
    break;

  case 1314:
#line 9464 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 38384 "gram.c"
    break;

  case 1315:
#line 9472 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 38398 "gram.c"
    break;

  case 1316:
#line 9482 "gram.y"
                                {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 38412 "gram.c"
    break;

  case 1317:
#line 9494 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_INDEX; }
#line 38418 "gram.c"
    break;

  case 1318:
#line 9495 "gram.y"
                                                                                                { (yyval.objtype) = OBJECT_TABLE; }
#line 38424 "gram.c"
    break;

  case 1319:
#line 9498 "gram.y"
                                                                                        {  (yyval.boolean) = TRUE; }
#line 38430 "gram.c"
    break;

  case 1320:
#line 9499 "gram.y"
                                                                                        {  (yyval.boolean) = FALSE; }
#line 38436 "gram.c"
    break;

  case 1321:
#line 9508 "gram.y"
                                {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->encoding = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 38448 "gram.c"
    break;

  case 1322:
#line 9525 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 38461 "gram.c"
    break;

  case 1323:
#line 9534 "gram.y"
                                {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 38474 "gram.c"
    break;

  case 1324:
#line 9551 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38488 "gram.c"
    break;

  case 1325:
#line 9561 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38501 "gram.c"
    break;

  case 1326:
#line 9570 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38514 "gram.c"
    break;

  case 1327:
#line 9579 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38527 "gram.c"
    break;

  case 1328:
#line 9588 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38540 "gram.c"
    break;

  case 1329:
#line 9597 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38554 "gram.c"
    break;

  case 1330:
#line 9607 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38567 "gram.c"
    break;

  case 1331:
#line 9616 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38581 "gram.c"
    break;

  case 1332:
#line 9626 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38594 "gram.c"
    break;

  case 1333:
#line 9635 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38607 "gram.c"
    break;

  case 1334:
#line 9644 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38621 "gram.c"
    break;

  case 1335:
#line 9654 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38635 "gram.c"
    break;

  case 1336:
#line 9664 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38648 "gram.c"
    break;

  case 1337:
#line 9673 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38661 "gram.c"
    break;

  case 1338:
#line 9682 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38675 "gram.c"
    break;

  case 1339:
#line 9692 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38689 "gram.c"
    break;

  case 1340:
#line 9702 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38703 "gram.c"
    break;

  case 1341:
#line 9712 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38717 "gram.c"
    break;

  case 1342:
#line 9722 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38731 "gram.c"
    break;

  case 1343:
#line 9732 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38745 "gram.c"
    break;

  case 1344:
#line 9742 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38759 "gram.c"
    break;

  case 1345:
#line 9752 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38773 "gram.c"
    break;

  case 1346:
#line 9762 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38787 "gram.c"
    break;

  case 1347:
#line 9772 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38801 "gram.c"
    break;

  case 1348:
#line 9782 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38815 "gram.c"
    break;

  case 1349:
#line 9792 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38829 "gram.c"
    break;

  case 1350:
#line 9802 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38844 "gram.c"
    break;

  case 1351:
#line 9813 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38859 "gram.c"
    break;

  case 1352:
#line 9824 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38874 "gram.c"
    break;

  case 1353:
#line 9835 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38889 "gram.c"
    break;

  case 1354:
#line 9846 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38903 "gram.c"
    break;

  case 1355:
#line 9856 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38918 "gram.c"
    break;

  case 1356:
#line 9867 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38933 "gram.c"
    break;

  case 1357:
#line 9878 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38947 "gram.c"
    break;

  case 1358:
#line 9888 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38961 "gram.c"
    break;

  case 1359:
#line 9898 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38973 "gram.c"
    break;

  case 1360:
#line 9906 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38986 "gram.c"
    break;

  case 1361:
#line 9915 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38999 "gram.c"
    break;

  case 1362:
#line 9924 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39012 "gram.c"
    break;

  case 1363:
#line 9933 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39025 "gram.c"
    break;

  case 1364:
#line 9942 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39038 "gram.c"
    break;

  case 1365:
#line 9951 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39051 "gram.c"
    break;

  case 1366:
#line 9960 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39064 "gram.c"
    break;

  case 1367:
#line 9969 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39077 "gram.c"
    break;

  case 1368:
#line 9978 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39093 "gram.c"
    break;

  case 1369:
#line 9990 "gram.y"
                                {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EXTPROTOCOL;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39105 "gram.c"
    break;

  case 1370:
#line 9999 "gram.y"
                                                                                        { (yyval.ival) = COLUMN; }
#line 39111 "gram.c"
    break;

  case 1371:
#line 10000 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 39117 "gram.c"
    break;

  case 1372:
#line 10003 "gram.y"
                                                                                { (yyval.ival) = 1; }
#line 39123 "gram.c"
    break;

  case 1373:
#line 10004 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 39129 "gram.c"
    break;

  case 1374:
#line 10015 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39143 "gram.c"
    break;

  case 1375:
#line 10025 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39156 "gram.c"
    break;

  case 1376:
#line 10034 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39169 "gram.c"
    break;

  case 1377:
#line 10043 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39182 "gram.c"
    break;

  case 1378:
#line 10052 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39195 "gram.c"
    break;

  case 1379:
#line 10061 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39209 "gram.c"
    break;

  case 1380:
#line 10071 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39223 "gram.c"
    break;

  case 1381:
#line 10081 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39237 "gram.c"
    break;

  case 1382:
#line 10091 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39251 "gram.c"
    break;

  case 1383:
#line 10101 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39264 "gram.c"
    break;

  case 1384:
#line 10110 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39277 "gram.c"
    break;

  case 1385:
#line 10119 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39290 "gram.c"
    break;

  case 1386:
#line 10128 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39303 "gram.c"
    break;

  case 1387:
#line 10137 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39316 "gram.c"
    break;

  case 1388:
#line 10146 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39329 "gram.c"
    break;

  case 1389:
#line 10155 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39342 "gram.c"
    break;

  case 1390:
#line 10164 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39355 "gram.c"
    break;

  case 1391:
#line 10173 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39368 "gram.c"
    break;

  case 1392:
#line 10182 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39381 "gram.c"
    break;

  case 1393:
#line 10191 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39394 "gram.c"
    break;

  case 1394:
#line 10200 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39407 "gram.c"
    break;

  case 1395:
#line 10209 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39420 "gram.c"
    break;

  case 1396:
#line 10218 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39433 "gram.c"
    break;

  case 1397:
#line 10227 "gram.y"
                                {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39446 "gram.c"
    break;

  case 1398:
#line 10244 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = extractAggrArgTypes((yyvsp[-3].list));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39459 "gram.c"
    break;

  case 1399:
#line 10253 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39471 "gram.c"
    break;

  case 1400:
#line 10261 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39483 "gram.c"
    break;

  case 1401:
#line 10269 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39495 "gram.c"
    break;

  case 1402:
#line 10277 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39507 "gram.c"
    break;

  case 1403:
#line 10285 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39520 "gram.c"
    break;

  case 1404:
#line 10294 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39532 "gram.c"
    break;

  case 1405:
#line 10302 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39544 "gram.c"
    break;

  case 1406:
#line 10310 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39557 "gram.c"
    break;

  case 1407:
#line 10319 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39570 "gram.c"
    break;

  case 1408:
#line 10328 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->objarg = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39583 "gram.c"
    break;

  case 1409:
#line 10337 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39595 "gram.c"
    break;

  case 1410:
#line 10345 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39607 "gram.c"
    break;

  case 1411:
#line 10353 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39619 "gram.c"
    break;

  case 1412:
#line 10361 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EXTPROTOCOL;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39631 "gram.c"
    break;

  case 1413:
#line 10369 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39643 "gram.c"
    break;

  case 1414:
#line 10377 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39655 "gram.c"
    break;

  case 1415:
#line 10385 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39667 "gram.c"
    break;

  case 1416:
#line 10393 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39679 "gram.c"
    break;

  case 1417:
#line 10401 "gram.y"
                                {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39691 "gram.c"
    break;

  case 1418:
#line 10420 "gram.y"
                                {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39707 "gram.c"
    break;

  case 1419:
#line 10434 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 39713 "gram.c"
    break;

  case 1420:
#line 10435 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39719 "gram.c"
    break;

  case 1421:
#line 10436 "gram.y"
                                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 39725 "gram.c"
    break;

  case 1422:
#line 10442 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 39735 "gram.c"
    break;

  case 1423:
#line 10448 "gram.y"
                                { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 39745 "gram.c"
    break;

  case 1429:
#line 10464 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 39751 "gram.c"
    break;

  case 1430:
#line 10465 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 39757 "gram.c"
    break;

  case 1431:
#line 10468 "gram.y"
                                                                                        { (yyval.ival) = CMD_SELECT; }
#line 39763 "gram.c"
    break;

  case 1432:
#line 10469 "gram.y"
                                                                                                { (yyval.ival) = CMD_UPDATE; }
#line 39769 "gram.c"
    break;

  case 1433:
#line 10470 "gram.y"
                                                                                                { (yyval.ival) = CMD_DELETE; }
#line 39775 "gram.c"
    break;

  case 1434:
#line 10471 "gram.y"
                                                                                                { (yyval.ival) = CMD_INSERT; }
#line 39781 "gram.c"
    break;

  case 1435:
#line 10475 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 39787 "gram.c"
    break;

  case 1436:
#line 10476 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 39793 "gram.c"
    break;

  case 1437:
#line 10477 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 39799 "gram.c"
    break;

  case 1438:
#line 10483 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39814 "gram.c"
    break;

  case 1439:
#line 10494 "gram.y"
                                {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39829 "gram.c"
    break;

  case 1440:
#line 10516 "gram.y"
                                {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39840 "gram.c"
    break;

  case 1441:
#line 10525 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 39846 "gram.c"
    break;

  case 1442:
#line 10526 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 39852 "gram.c"
    break;

  case 1443:
#line 10530 "gram.y"
                                {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39862 "gram.c"
    break;

  case 1444:
#line 10539 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39872 "gram.c"
    break;

  case 1445:
#line 10545 "gram.y"
                                {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39882 "gram.c"
    break;

  case 1446:
#line 10564 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 39893 "gram.c"
    break;

  case 1447:
#line 10571 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39904 "gram.c"
    break;

  case 1448:
#line 10578 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39915 "gram.c"
    break;

  case 1449:
#line 10585 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 39926 "gram.c"
    break;

  case 1450:
#line 10592 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 39937 "gram.c"
    break;

  case 1451:
#line 10599 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 39948 "gram.c"
    break;

  case 1452:
#line 10606 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 39960 "gram.c"
    break;

  case 1453:
#line 10614 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 39972 "gram.c"
    break;

  case 1454:
#line 10622 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 39984 "gram.c"
    break;

  case 1455:
#line 10630 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 39996 "gram.c"
    break;

  case 1456:
#line 10638 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 40008 "gram.c"
    break;

  case 1457:
#line 10646 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40019 "gram.c"
    break;

  case 1458:
#line 10653 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40030 "gram.c"
    break;

  case 1459:
#line 10660 "gram.y"
                                {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40041 "gram.c"
    break;

  case 1460:
#line 10668 "gram.y"
                                                                                {}
#line 40047 "gram.c"
    break;

  case 1461:
#line 10669 "gram.y"
                                                                                        {}
#line 40053 "gram.c"
    break;

  case 1462:
#line 10670 "gram.y"
                                                                                                {}
#line 40059 "gram.c"
    break;

  case 1463:
#line 10675 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 40066 "gram.c"
    break;

  case 1464:
#line 10678 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 40073 "gram.c"
    break;

  case 1465:
#line 10681 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 40080 "gram.c"
    break;

  case 1466:
#line 10684 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 40087 "gram.c"
    break;

  case 1467:
#line 10687 "gram.y"
                                        { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 40094 "gram.c"
    break;

  case 1468:
#line 10694 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40100 "gram.c"
    break;

  case 1469:
#line 10696 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40106 "gram.c"
    break;

  case 1470:
#line 10698 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40112 "gram.c"
    break;

  case 1472:
#line 10704 "gram.y"
                                        { (yyval.list) = NIL; }
#line 40118 "gram.c"
    break;

  case 1473:
#line 10718 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40134 "gram.c"
    break;

  case 1474:
#line 10731 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40150 "gram.c"
    break;

  case 1475:
#line 10744 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40171 "gram.c"
    break;

  case 1476:
#line 10762 "gram.y"
                                {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40192 "gram.c"
    break;

  case 1477:
#line 10781 "gram.y"
                                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40198 "gram.c"
    break;

  case 1478:
#line 10782 "gram.y"
                                                { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40204 "gram.c"
    break;

  case 1479:
#line 10783 "gram.y"
                                                        { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 40210 "gram.c"
    break;

  case 1480:
#line 10784 "gram.y"
                                                                { (yyval.ival) = NO_CHECK_OPTION; }
#line 40216 "gram.c"
    break;

  case 1481:
#line 10795 "gram.y"
                                {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40226 "gram.c"
    break;

  case 1482:
#line 10811 "gram.y"
                                {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40237 "gram.c"
    break;

  case 1483:
#line 10820 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40243 "gram.c"
    break;

  case 1484:
#line 10821 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 40249 "gram.c"
    break;

  case 1485:
#line 10826 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 40257 "gram.c"
    break;

  case 1486:
#line 10830 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 40265 "gram.c"
    break;

  case 1487:
#line 10834 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 40273 "gram.c"
    break;

  case 1488:
#line 10838 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 40281 "gram.c"
    break;

  case 1489:
#line 10842 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 40289 "gram.c"
    break;

  case 1490:
#line 10846 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 40297 "gram.c"
    break;

  case 1491:
#line 10850 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 40305 "gram.c"
    break;

  case 1492:
#line 10854 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 40313 "gram.c"
    break;

  case 1493:
#line 10858 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 40321 "gram.c"
    break;

  case 1494:
#line 10862 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 40329 "gram.c"
    break;

  case 1495:
#line 10866 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 40337 "gram.c"
    break;

  case 1496:
#line 10870 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 40345 "gram.c"
    break;

  case 1497:
#line 10874 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 40353 "gram.c"
    break;

  case 1498:
#line 10878 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 40361 "gram.c"
    break;

  case 1499:
#line 10882 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 40369 "gram.c"
    break;

  case 1500:
#line 10886 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 40377 "gram.c"
    break;

  case 1501:
#line 10895 "gram.y"
                                                                                                {}
#line 40383 "gram.c"
    break;

  case 1502:
#line 10896 "gram.y"
                                                                                                {}
#line 40389 "gram.c"
    break;

  case 1503:
#line 10908 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 40400 "gram.c"
    break;

  case 1504:
#line 10915 "gram.y"
                                 {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 40412 "gram.c"
    break;

  case 1505:
#line 10926 "gram.y"
                                {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40423 "gram.c"
    break;

  case 1506:
#line 10936 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40429 "gram.c"
    break;

  case 1507:
#line 10937 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 40435 "gram.c"
    break;

  case 1508:
#line 10942 "gram.y"
                                {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 40443 "gram.c"
    break;

  case 1509:
#line 10956 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 40454 "gram.c"
    break;

  case 1510:
#line 10963 "gram.y"
                                {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 40465 "gram.c"
    break;

  case 1511:
#line 10981 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40475 "gram.c"
    break;

  case 1512:
#line 10987 "gram.y"
                                {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40485 "gram.c"
    break;

  case 1513:
#line 11003 "gram.y"
                                {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 40498 "gram.c"
    break;

  case 1514:
#line 11016 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40510 "gram.c"
    break;

  case 1515:
#line 11025 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40521 "gram.c"
    break;

  case 1516:
#line 11033 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40532 "gram.c"
    break;

  case 1517:
#line 11041 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40544 "gram.c"
    break;

  case 1518:
#line 11050 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40558 "gram.c"
    break;

  case 1519:
#line 11061 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40572 "gram.c"
    break;

  case 1520:
#line 11072 "gram.y"
                                {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40584 "gram.c"
    break;

  case 1521:
#line 11081 "gram.y"
                                                                                                {}
#line 40590 "gram.c"
    break;

  case 1522:
#line 11082 "gram.y"
                                                                                        {}
#line 40596 "gram.c"
    break;

  case 1523:
#line 11094 "gram.y"
                                {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40607 "gram.c"
    break;

  case 1524:
#line 11104 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40621 "gram.c"
    break;

  case 1525:
#line 11114 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40635 "gram.c"
    break;

  case 1526:
#line 11124 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40649 "gram.c"
    break;

  case 1527:
#line 11134 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40663 "gram.c"
    break;

  case 1528:
#line 11144 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 40675 "gram.c"
    break;

  case 1529:
#line 11152 "gram.y"
                                {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 40687 "gram.c"
    break;

  case 1530:
#line 11174 "gram.y"
                        {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 40701 "gram.c"
    break;

  case 1531:
#line 11196 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->verbose = (yyvsp[-2].boolean);
					(yyval.node) = (Node*)n;
				}
#line 40713 "gram.c"
    break;

  case 1532:
#line 11204 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 40725 "gram.c"
    break;

  case 1533:
#line 11213 "gram.y"
                                {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->verbose = (yyvsp[-3].boolean);
					(yyval.node) = (Node*)n;
				}
#line 40737 "gram.c"
    break;

  case 1534:
#line 11223 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 40743 "gram.c"
    break;

  case 1535:
#line 11224 "gram.y"
                                                                { (yyval.str) = NULL; }
#line 40749 "gram.c"
    break;

  case 1536:
#line 11237 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 40769 "gram.c"
    break;

  case 1537:
#line 11253 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 40789 "gram.c"
    break;

  case 1538:
#line 11269 "gram.y"
                                {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 40807 "gram.c"
    break;

  case 1539:
#line 11283 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 40831 "gram.c"
    break;

  case 1540:
#line 11303 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 40857 "gram.c"
    break;

  case 1541:
#line 11327 "gram.y"
                                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 40863 "gram.c"
    break;

  case 1542:
#line 11328 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 40869 "gram.c"
    break;

  case 1543:
#line 11332 "gram.y"
                                                { (yyval.ival) = VACOPT_ANALYZE; }
#line 40875 "gram.c"
    break;

  case 1544:
#line 11333 "gram.y"
                                                        { (yyval.ival) = VACOPT_VERBOSE; }
#line 40881 "gram.c"
    break;

  case 1545:
#line 11334 "gram.y"
                                                        { (yyval.ival) = VACOPT_FREEZE; }
#line 40887 "gram.c"
    break;

  case 1546:
#line 11335 "gram.y"
                                                        { (yyval.ival) = VACOPT_FULL; }
#line 40893 "gram.c"
    break;

  case 1547:
#line 11340 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_ROOTONLY;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 40913 "gram.c"
    break;

  case 1548:
#line 11356 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40931 "gram.c"
    break;

  case 1549:
#line 11370 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_VERBOSE;
					n->options |= VACOPT_FULLSCAN;
					n->freeze_min_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40947 "gram.c"
    break;

  case 1550:
#line 11382 "gram.y"
                                {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_VERBOSE;
					n->options |= VACOPT_ROOTONLY;
					n->freeze_min_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40963 "gram.c"
    break;

  case 1551:
#line 11396 "gram.y"
                                                                                                {}
#line 40969 "gram.c"
    break;

  case 1552:
#line 11397 "gram.y"
                                                                                {}
#line 40975 "gram.c"
    break;

  case 1553:
#line 11401 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 40981 "gram.c"
    break;

  case 1554:
#line 11402 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 40987 "gram.c"
    break;

  case 1555:
#line 11406 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 40993 "gram.c"
    break;

  case 1556:
#line 11407 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 40999 "gram.c"
    break;

  case 1557:
#line 11410 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 41005 "gram.c"
    break;

  case 1558:
#line 11411 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 41011 "gram.c"
    break;

  case 1559:
#line 11414 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 41017 "gram.c"
    break;

  case 1560:
#line 11415 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 41023 "gram.c"
    break;

  case 1561:
#line 11419 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 41029 "gram.c"
    break;

  case 1562:
#line 11420 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 41035 "gram.c"
    break;

  case 1563:
#line 11434 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 41046 "gram.c"
    break;

  case 1564:
#line 11441 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("dxl", NULL));
					(yyval.node) = (Node *) n;
				}
#line 41063 "gram.c"
    break;

  case 1565:
#line 11454 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("dxl", NULL));
					(yyval.node) = (Node *) n;
				}
#line 41077 "gram.c"
    break;

  case 1566:
#line 11464 "gram.y"
                                {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 41088 "gram.c"
    break;

  case 1576:
#line 11483 "gram.y"
                                {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("cannot EXPLAIN CREATE TABLE without AS "
							 		"clause")));
				}
#line 41099 "gram.c"
    break;

  case 1577:
#line 11491 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 41105 "gram.c"
    break;

  case 1578:
#line 11492 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 41111 "gram.c"
    break;

  case 1579:
#line 11497 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 41119 "gram.c"
    break;

  case 1580:
#line 11501 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 41127 "gram.c"
    break;

  case 1581:
#line 11508 "gram.y"
                                {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 41135 "gram.c"
    break;

  case 1582:
#line 11514 "gram.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 41141 "gram.c"
    break;

  case 1583:
#line 11515 "gram.y"
                                                        { (yyval.str) = "analyze"; }
#line 41147 "gram.c"
    break;

  case 1584:
#line 11519 "gram.y"
                                                { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 41153 "gram.c"
    break;

  case 1585:
#line 11520 "gram.y"
                                                        { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 41159 "gram.c"
    break;

  case 1586:
#line 11521 "gram.y"
                                                        { (yyval.node) = NULL; }
#line 41165 "gram.c"
    break;

  case 1587:
#line 11532 "gram.y"
                                {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 41177 "gram.c"
    break;

  case 1588:
#line 11541 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 41183 "gram.c"
    break;

  case 1589:
#line 11542 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 41189 "gram.c"
    break;

  case 1594:
#line 11560 "gram.y"
                                {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41200 "gram.c"
    break;

  case 1595:
#line 11568 "gram.y"
                                {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 41219 "gram.c"
    break;

  case 1596:
#line 11584 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 41225 "gram.c"
    break;

  case 1597:
#line 11585 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 41231 "gram.c"
    break;

  case 1598:
#line 11596 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41241 "gram.c"
    break;

  case 1599:
#line 11602 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41251 "gram.c"
    break;

  case 1600:
#line 11608 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41261 "gram.c"
    break;

  case 1601:
#line 11614 "gram.y"
                                        {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41271 "gram.c"
    break;

  case 1602:
#line 11629 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41277 "gram.c"
    break;

  case 1603:
#line 11631 "gram.y"
                                {
					if (list_member((yyvsp[-2].list), (yyvsp[0].node)))
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
								 errmsg("duplicate location uri"),
								 parser_errposition((yylsp[0]))));
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 41290 "gram.c"
    break;

  case 1604:
#line 11644 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 41298 "gram.c"
    break;

  case 1605:
#line 11658 "gram.y"
                                {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 41309 "gram.c"
    break;

  case 1606:
#line 11668 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41319 "gram.c"
    break;

  case 1607:
#line 11674 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41329 "gram.c"
    break;

  case 1608:
#line 11680 "gram.y"
                                {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 41339 "gram.c"
    break;

  case 1609:
#line 11689 "gram.y"
                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41345 "gram.c"
    break;

  case 1610:
#line 11691 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 41351 "gram.c"
    break;

  case 1611:
#line 11696 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41363 "gram.c"
    break;

  case 1612:
#line 11706 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 41369 "gram.c"
    break;

  case 1613:
#line 11707 "gram.y"
                                                                { (yyval.list) = NIL; }
#line 41375 "gram.c"
    break;

  case 1614:
#line 11720 "gram.y"
                                {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 41389 "gram.c"
    break;

  case 1615:
#line 11732 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 41395 "gram.c"
    break;

  case 1616:
#line 11733 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 41401 "gram.c"
    break;

  case 1617:
#line 11745 "gram.y"
                                {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 41414 "gram.c"
    break;

  case 1618:
#line 11755 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival); }
#line 41420 "gram.c"
    break;

  case 1619:
#line 11756 "gram.y"
                                                                                { (yyval.ival) = AccessExclusiveLock; }
#line 41426 "gram.c"
    break;

  case 1620:
#line 11759 "gram.y"
                                                                { (yyval.ival) = AccessShareLock; }
#line 41432 "gram.c"
    break;

  case 1621:
#line 11760 "gram.y"
                                                                                { (yyval.ival) = RowShareLock; }
#line 41438 "gram.c"
    break;

  case 1622:
#line 11761 "gram.y"
                                                                        { (yyval.ival) = RowExclusiveLock; }
#line 41444 "gram.c"
    break;

  case 1623:
#line 11762 "gram.y"
                                                                { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 41450 "gram.c"
    break;

  case 1624:
#line 11763 "gram.y"
                                                                                { (yyval.ival) = ShareLock; }
#line 41456 "gram.c"
    break;

  case 1625:
#line 11764 "gram.y"
                                                                { (yyval.ival) = ShareRowExclusiveLock; }
#line 41462 "gram.c"
    break;

  case 1626:
#line 11765 "gram.y"
                                                                                { (yyval.ival) = ExclusiveLock; }
#line 41468 "gram.c"
    break;

  case 1627:
#line 11766 "gram.y"
                                                                        { (yyval.ival) = AccessExclusiveLock; }
#line 41474 "gram.c"
    break;

  case 1628:
#line 11769 "gram.y"
                                                                        { (yyval.boolean) = TRUE; }
#line 41480 "gram.c"
    break;

  case 1629:
#line 11770 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 41486 "gram.c"
    break;

  case 1630:
#line 11786 "gram.y"
                                {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 41501 "gram.c"
    break;

  case 1631:
#line 11799 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 41507 "gram.c"
    break;

  case 1632:
#line 11800 "gram.y"
                                                                { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 41513 "gram.c"
    break;

  case 1633:
#line 11804 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41519 "gram.c"
    break;

  case 1634:
#line 11805 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 41525 "gram.c"
    break;

  case 1635:
#line 11810 "gram.y"
                                {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 41534 "gram.c"
    break;

  case 1636:
#line 11818 "gram.y"
                                {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 41563 "gram.c"
    break;

  case 1637:
#line 11846 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41575 "gram.c"
    break;

  case 1638:
#line 11856 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41581 "gram.c"
    break;

  case 1639:
#line 11857 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 41587 "gram.c"
    break;

  case 1640:
#line 11868 "gram.y"
                                {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 41600 "gram.c"
    break;

  case 1641:
#line 11878 "gram.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 41606 "gram.c"
    break;

  case 1642:
#line 11881 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 41612 "gram.c"
    break;

  case 1643:
#line 11882 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 41618 "gram.c"
    break;

  case 1644:
#line 11883 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 41624 "gram.c"
    break;

  case 1645:
#line 11884 "gram.y"
                                                                { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 41630 "gram.c"
    break;

  case 1646:
#line 11885 "gram.y"
                                                        { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 41636 "gram.c"
    break;

  case 1647:
#line 11888 "gram.y"
                                                                { (yyval.ival) = 0; }
#line 41642 "gram.c"
    break;

  case 1648:
#line 11889 "gram.y"
                                                                                { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 41648 "gram.c"
    break;

  case 1649:
#line 11890 "gram.y"
                                                                        { (yyval.ival) = 0; }
#line 41654 "gram.c"
    break;

  case 1652:
#line 11943 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 41660 "gram.c"
    break;

  case 1653:
#line 11944 "gram.y"
                                                                        { (yyval.node) = (yyvsp[-1].node); }
#line 41666 "gram.c"
    break;

  case 1654:
#line 11959 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 41672 "gram.c"
    break;

  case 1655:
#line 11961 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41683 "gram.c"
    break;

  case 1656:
#line 11968 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41695 "gram.c"
    break;

  case 1657:
#line 11976 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41707 "gram.c"
    break;

  case 1658:
#line 11984 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 41719 "gram.c"
    break;

  case 1659:
#line 11992 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41731 "gram.c"
    break;

  case 1660:
#line 12000 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41743 "gram.c"
    break;

  case 1661:
#line 12008 "gram.y"
                                {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41755 "gram.c"
    break;

  case 1662:
#line 12018 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 41761 "gram.c"
    break;

  case 1663:
#line 12019 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 41767 "gram.c"
    break;

  case 1664:
#line 12049 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41784 "gram.c"
    break;

  case 1665:
#line 12061 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 41790 "gram.c"
    break;

  case 1666:
#line 12063 "gram.y"
                                {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 41813 "gram.c"
    break;

  case 1667:
#line 12082 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41821 "gram.c"
    break;

  case 1668:
#line 12086 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41829 "gram.c"
    break;

  case 1669:
#line 12090 "gram.y"
                                {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41837 "gram.c"
    break;

  case 1670:
#line 12105 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41848 "gram.c"
    break;

  case 1671:
#line 12112 "gram.y"
                        {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 41859 "gram.c"
    break;

  case 1672:
#line 12121 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41865 "gram.c"
    break;

  case 1673:
#line 12122 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41871 "gram.c"
    break;

  case 1674:
#line 12126 "gram.y"
                        {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 41884 "gram.c"
    break;

  case 1675:
#line 12137 "gram.y"
                                                                                        { (yyval.with) = (yyvsp[0].with); }
#line 41890 "gram.c"
    break;

  case 1676:
#line 12138 "gram.y"
                                                                                        { (yyval.with) = NULL; }
#line 41896 "gram.c"
    break;

  case 1677:
#line 12143 "gram.y"
                                {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 41911 "gram.c"
    break;

  case 1678:
#line 12154 "gram.y"
                                { (yyval.into) = NULL; }
#line 41917 "gram.c"
    break;

  case 1679:
#line 12163 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41926 "gram.c"
    break;

  case 1680:
#line 12168 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41935 "gram.c"
    break;

  case 1681:
#line 12173 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41944 "gram.c"
    break;

  case 1682:
#line 12178 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41953 "gram.c"
    break;

  case 1683:
#line 12183 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41965 "gram.c"
    break;

  case 1684:
#line 12191 "gram.y"
                                {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 41977 "gram.c"
    break;

  case 1685:
#line 12199 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 41986 "gram.c"
    break;

  case 1686:
#line 12204 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 41995 "gram.c"
    break;

  case 1687:
#line 12209 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 42004 "gram.c"
    break;

  case 1688:
#line 12215 "gram.y"
                                                                                        {}
#line 42010 "gram.c"
    break;

  case 1689:
#line 12216 "gram.y"
                                                                                                {}
#line 42016 "gram.c"
    break;

  case 1690:
#line 12219 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 42022 "gram.c"
    break;

  case 1691:
#line 12220 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 42028 "gram.c"
    break;

  case 1692:
#line 12221 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 42034 "gram.c"
    break;

  case 1693:
#line 12228 "gram.y"
                                                                                                { (yyval.list) = list_make1(NIL); }
#line 42040 "gram.c"
    break;

  case 1694:
#line 12229 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 42046 "gram.c"
    break;

  case 1695:
#line 12230 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42052 "gram.c"
    break;

  case 1696:
#line 12231 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42058 "gram.c"
    break;

  case 1697:
#line 12235 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list);}
#line 42064 "gram.c"
    break;

  case 1698:
#line 12236 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42070 "gram.c"
    break;

  case 1699:
#line 12240 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 42076 "gram.c"
    break;

  case 1700:
#line 12244 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 42082 "gram.c"
    break;

  case 1701:
#line 12245 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 42088 "gram.c"
    break;

  case 1702:
#line 12249 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 42101 "gram.c"
    break;

  case 1703:
#line 12258 "gram.y"
                                {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 42114 "gram.c"
    break;

  case 1704:
#line 12270 "gram.y"
                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 42120 "gram.c"
    break;

  case 1705:
#line 12271 "gram.y"
                                                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 42126 "gram.c"
    break;

  case 1706:
#line 12272 "gram.y"
                                                                                { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 42132 "gram.c"
    break;

  case 1707:
#line 12273 "gram.y"
                                                                                { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 42138 "gram.c"
    break;

  case 1708:
#line 12277 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 42144 "gram.c"
    break;

  case 1709:
#line 12278 "gram.y"
                                                                                { (yyval.list) = list_make2(NULL,NULL); }
#line 42150 "gram.c"
    break;

  case 1710:
#line 12283 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42156 "gram.c"
    break;

  case 1711:
#line 12285 "gram.y"
                                {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 42169 "gram.c"
    break;

  case 1712:
#line 12301 "gram.y"
                                { (yyval.node) = (yyvsp[-2].node); }
#line 42175 "gram.c"
    break;

  case 1713:
#line 12303 "gram.y"
                                { (yyval.node) = makeIntConst(1, -1); }
#line 42181 "gram.c"
    break;

  case 1714:
#line 12308 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 42187 "gram.c"
    break;

  case 1715:
#line 12311 "gram.y"
                                { (yyval.node) = (yyvsp[-1].node); }
#line 42193 "gram.c"
    break;

  case 1716:
#line 12315 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 42199 "gram.c"
    break;

  case 1717:
#line 12317 "gram.y"
                                {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 42208 "gram.c"
    break;

  case 1718:
#line 12324 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 42214 "gram.c"
    break;

  case 1719:
#line 12344 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 42220 "gram.c"
    break;

  case 1720:
#line 12346 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 42226 "gram.c"
    break;

  case 1721:
#line 12348 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 42232 "gram.c"
    break;

  case 1722:
#line 12352 "gram.y"
                                                                                                { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 42238 "gram.c"
    break;

  case 1723:
#line 12353 "gram.y"
                                                                                                { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 42244 "gram.c"
    break;

  case 1724:
#line 12357 "gram.y"
                                                                                        { (yyval.ival) = 0; }
#line 42250 "gram.c"
    break;

  case 1725:
#line 12358 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 42256 "gram.c"
    break;

  case 1726:
#line 12361 "gram.y"
                                                                                { (yyval.ival) = 0; }
#line 42262 "gram.c"
    break;

  case 1727:
#line 12362 "gram.y"
                                                                                                { (yyval.ival) = 0; }
#line 42268 "gram.c"
    break;

  case 1728:
#line 12367 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 42274 "gram.c"
    break;

  case 1729:
#line 12368 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42280 "gram.c"
    break;

  case 1730:
#line 12372 "gram.y"
                                                      { (yyval.list) = (yyvsp[0].list); }
#line 42286 "gram.c"
    break;

  case 1731:
#line 12373 "gram.y"
                                                        { (yyval.list) = list_concat((yyvsp[-2].list), (yyvsp[0].list)); }
#line 42292 "gram.c"
    break;

  case 1732:
#line 12377 "gram.y"
                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42298 "gram.c"
    break;

  case 1733:
#line 12379 "gram.y"
                {
					GroupingClause *n = makeNode(GroupingClause);
					n->groupType = GROUPINGTYPE_ROLLUP;
					n->groupsets = (yyvsp[-1].list);
					(yyval.list) = list_make1 ((Node*)n);
				}
#line 42309 "gram.c"
    break;

  case 1734:
#line 12386 "gram.y"
                {
					GroupingClause *n = makeNode(GroupingClause);
					n->groupType = GROUPINGTYPE_CUBE;
					n->groupsets = (yyvsp[-1].list);
					(yyval.list) = list_make1 ((Node*)n);
				}
#line 42320 "gram.c"
    break;

  case 1735:
#line 12393 "gram.y"
                {
					GroupingClause *n = makeNode(GroupingClause);
					n->groupType = GROUPINGTYPE_GROUPING_SETS;
					n->groupsets = (yyvsp[-1].list);
					(yyval.list) = list_make1 ((Node*)n);
				}
#line 42331 "gram.c"
    break;

  case 1736:
#line 12400 "gram.y"
                { (yyval.list) = list_make1(NIL); }
#line 42337 "gram.c"
    break;

  case 1737:
#line 12404 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42343 "gram.c"
    break;

  case 1738:
#line 12405 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 42349 "gram.c"
    break;

  case 1739:
#line 12409 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 42355 "gram.c"
    break;

  case 1740:
#line 12410 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 42361 "gram.c"
    break;

  case 1741:
#line 12414 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 42367 "gram.c"
    break;

  case 1742:
#line 12415 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 42373 "gram.c"
    break;

  case 1743:
#line 12419 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42379 "gram.c"
    break;

  case 1744:
#line 12420 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 42385 "gram.c"
    break;

  case 1745:
#line 12425 "gram.y"
                                {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42397 "gram.c"
    break;

  case 1746:
#line 12435 "gram.y"
                                                                                        { (yyval.ival) = LCS_FORUPDATE; }
#line 42403 "gram.c"
    break;

  case 1747:
#line 12436 "gram.y"
                                                                        { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 42409 "gram.c"
    break;

  case 1748:
#line 12437 "gram.y"
                                                                                { (yyval.ival) = LCS_FORSHARE; }
#line 42415 "gram.c"
    break;

  case 1749:
#line 12438 "gram.y"
                                                                                { (yyval.ival) = LCS_FORKEYSHARE; }
#line 42421 "gram.c"
    break;

  case 1750:
#line 12442 "gram.y"
                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 42427 "gram.c"
    break;

  case 1751:
#line 12443 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 42433 "gram.c"
    break;

  case 1752:
#line 12449 "gram.y"
                                {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42443 "gram.c"
    break;

  case 1753:
#line 12455 "gram.y"
                                {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42453 "gram.c"
    break;

  case 1754:
#line 12472 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 42459 "gram.c"
    break;

  case 1755:
#line 12473 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42465 "gram.c"
    break;

  case 1756:
#line 12477 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42471 "gram.c"
    break;

  case 1757:
#line 12478 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42477 "gram.c"
    break;

  case 1758:
#line 12485 "gram.y"
                                {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 42486 "gram.c"
    break;

  case 1759:
#line 12490 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42497 "gram.c"
    break;

  case 1760:
#line 12497 "gram.y"
                                {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42509 "gram.c"
    break;

  case 1761:
#line 12505 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42548 "gram.c"
    break;

  case 1762:
#line 12540 "gram.y"
                                {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42577 "gram.c"
    break;

  case 1763:
#line 12565 "gram.y"
                                {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 42585 "gram.c"
    break;

  case 1764:
#line 12569 "gram.y"
                                {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 42594 "gram.c"
    break;

  case 1765:
#line 12595 "gram.y"
                                {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 42602 "gram.c"
    break;

  case 1766:
#line 12599 "gram.y"
                                {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 42618 "gram.c"
    break;

  case 1767:
#line 12611 "gram.y"
                                {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 42635 "gram.c"
    break;

  case 1768:
#line 12624 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 42653 "gram.c"
    break;

  case 1769:
#line 12638 "gram.y"
                                {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42668 "gram.c"
    break;

  case 1770:
#line 12649 "gram.y"
                                {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42684 "gram.c"
    break;

  case 1771:
#line 12664 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42694 "gram.c"
    break;

  case 1772:
#line 12670 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42703 "gram.c"
    break;

  case 1773:
#line 12675 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42713 "gram.c"
    break;

  case 1774:
#line 12681 "gram.y"
                                {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42722 "gram.c"
    break;

  case 1775:
#line 12687 "gram.y"
                                                                        { (yyval.alias) = (yyvsp[0].alias); }
#line 42728 "gram.c"
    break;

  case 1776:
#line 12688 "gram.y"
                                                                                                { (yyval.alias) = NULL; }
#line 42734 "gram.c"
    break;

  case 1777:
#line 12697 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 42742 "gram.c"
    break;

  case 1778:
#line 12701 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 42750 "gram.c"
    break;

  case 1779:
#line 12705 "gram.y"
                                {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42760 "gram.c"
    break;

  case 1780:
#line 12711 "gram.y"
                                {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 42770 "gram.c"
    break;

  case 1781:
#line 12717 "gram.y"
                                {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 42778 "gram.c"
    break;

  case 1782:
#line 12722 "gram.y"
                                                                                { (yyval.jtype) = JOIN_FULL; }
#line 42784 "gram.c"
    break;

  case 1783:
#line 12723 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_LEFT; }
#line 42790 "gram.c"
    break;

  case 1784:
#line 12724 "gram.y"
                                                                                        { (yyval.jtype) = JOIN_RIGHT; }
#line 42796 "gram.c"
    break;

  case 1785:
#line 12725 "gram.y"
                                                                                                { (yyval.jtype) = JOIN_INNER; }
#line 42802 "gram.c"
    break;

  case 1786:
#line 12729 "gram.y"
                                                                                        { (yyval.node) = NULL; }
#line 42808 "gram.c"
    break;

  case 1787:
#line 12730 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 42814 "gram.c"
    break;

  case 1788:
#line 12742 "gram.y"
                                                                        { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 42820 "gram.c"
    break;

  case 1789:
#line 12743 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 42826 "gram.c"
    break;

  case 1790:
#line 12749 "gram.y"
                                {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 42837 "gram.c"
    break;

  case 1791:
#line 12756 "gram.y"
                                {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 42848 "gram.c"
    break;

  case 1792:
#line 12763 "gram.y"
                                {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 42859 "gram.c"
    break;

  case 1793:
#line 12770 "gram.y"
                                {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 42870 "gram.c"
    break;

  case 1794:
#line 12780 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 42876 "gram.c"
    break;

  case 1795:
#line 12781 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 42882 "gram.c"
    break;

  case 1796:
#line 12795 "gram.y"
                                {
					(yyval.range) = (yyvsp[0].range);
				}
#line 42890 "gram.c"
    break;

  case 1797:
#line 12799 "gram.y"
                                {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 42901 "gram.c"
    break;

  case 1798:
#line 12806 "gram.y"
                                {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 42912 "gram.c"
    break;

  case 1799:
#line 12827 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42926 "gram.c"
    break;

  case 1800:
#line 12837 "gram.y"
                                {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 42940 "gram.c"
    break;

  case 1801:
#line 12849 "gram.y"
                                { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 42946 "gram.c"
    break;

  case 1802:
#line 12853 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 42952 "gram.c"
    break;

  case 1803:
#line 12854 "gram.y"
                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 42958 "gram.c"
    break;

  case 1804:
#line 12857 "gram.y"
                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 42964 "gram.c"
    break;

  case 1805:
#line 12858 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 42970 "gram.c"
    break;

  case 1806:
#line 12861 "gram.y"
                                                                        { (yyval.boolean) = true; }
#line 42976 "gram.c"
    break;

  case 1807:
#line 12862 "gram.y"
                                                                                                { (yyval.boolean) = false; }
#line 42982 "gram.c"
    break;

  case 1808:
#line 12867 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 42988 "gram.c"
    break;

  case 1809:
#line 12868 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 42994 "gram.c"
    break;

  case 1810:
#line 12873 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 43000 "gram.c"
    break;

  case 1811:
#line 12875 "gram.y"
                                {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 43012 "gram.c"
    break;

  case 1812:
#line 12882 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 43018 "gram.c"
    break;

  case 1813:
#line 12887 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 43024 "gram.c"
    break;

  case 1814:
#line 12888 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43030 "gram.c"
    break;

  case 1815:
#line 12893 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 43038 "gram.c"
    break;

  case 1816:
#line 12897 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 43046 "gram.c"
    break;

  case 1817:
#line 12903 "gram.y"
                                {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43068 "gram.c"
    break;

  case 1818:
#line 12933 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 43077 "gram.c"
    break;

  case 1819:
#line 12938 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 43087 "gram.c"
    break;

  case 1820:
#line 12945 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 43096 "gram.c"
    break;

  case 1821:
#line 12950 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 43106 "gram.c"
    break;

  case 1822:
#line 12956 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 43115 "gram.c"
    break;

  case 1823:
#line 12961 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 43125 "gram.c"
    break;

  case 1824:
#line 12970 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 43131 "gram.c"
    break;

  case 1825:
#line 12972 "gram.y"
                                        {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 43137 "gram.c"
    break;

  case 1826:
#line 12974 "gram.y"
                                        {  (yyval.list) = NIL; }
#line 43143 "gram.c"
    break;

  case 1827:
#line 12978 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43149 "gram.c"
    break;

  case 1828:
#line 12979 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43155 "gram.c"
    break;

  case 1829:
#line 12980 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43161 "gram.c"
    break;

  case 1830:
#line 12981 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43167 "gram.c"
    break;

  case 1831:
#line 12982 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43173 "gram.c"
    break;

  case 1832:
#line 12984 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 43182 "gram.c"
    break;

  case 1833:
#line 12989 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 43202 "gram.c"
    break;

  case 1834:
#line 13018 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43208 "gram.c"
    break;

  case 1835:
#line 13019 "gram.y"
                                                                                                { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43214 "gram.c"
    break;

  case 1836:
#line 13020 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43220 "gram.c"
    break;

  case 1837:
#line 13021 "gram.y"
                                                                                        { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43226 "gram.c"
    break;

  case 1838:
#line 13033 "gram.y"
                                {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43236 "gram.c"
    break;

  case 1839:
#line 13039 "gram.y"
                                {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 43246 "gram.c"
    break;

  case 1840:
#line 13046 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 43252 "gram.c"
    break;

  case 1841:
#line 13047 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 43258 "gram.c"
    break;

  case 1842:
#line 13054 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43267 "gram.c"
    break;

  case 1843:
#line 13059 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43276 "gram.c"
    break;

  case 1844:
#line 13064 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43285 "gram.c"
    break;

  case 1845:
#line 13069 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43294 "gram.c"
    break;

  case 1846:
#line 13074 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43303 "gram.c"
    break;

  case 1847:
#line 13079 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43312 "gram.c"
    break;

  case 1848:
#line 13084 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43321 "gram.c"
    break;

  case 1849:
#line 13089 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43331 "gram.c"
    break;

  case 1850:
#line 13095 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43341 "gram.c"
    break;

  case 1851:
#line 13101 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43351 "gram.c"
    break;

  case 1852:
#line 13107 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43360 "gram.c"
    break;

  case 1853:
#line 13114 "gram.y"
                                {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 43385 "gram.c"
    break;

  case 1854:
#line 13135 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 43393 "gram.c"
    break;

  case 1855:
#line 13145 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43401 "gram.c"
    break;

  case 1856:
#line 13149 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43409 "gram.c"
    break;

  case 1857:
#line 13157 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43417 "gram.c"
    break;

  case 1858:
#line 13161 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43426 "gram.c"
    break;

  case 1859:
#line 13169 "gram.y"
                                {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43439 "gram.c"
    break;

  case 1860:
#line 13181 "gram.y"
                                {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43457 "gram.c"
    break;

  case 1861:
#line 13202 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43465 "gram.c"
    break;

  case 1862:
#line 13206 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43473 "gram.c"
    break;

  case 1863:
#line 13212 "gram.y"
                                {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43481 "gram.c"
    break;

  case 1864:
#line 13216 "gram.y"
                                {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43496 "gram.c"
    break;

  case 1865:
#line 13229 "gram.y"
                                {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-4].str) = psprintf("%s_%s", (yyvsp[-4].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43509 "gram.c"
    break;

  case 1866:
#line 13240 "gram.y"
                                {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
						(yyvsp[-1].str) = psprintf("%s_%s", (yyvsp[-1].str), (yyvsp[0].str));

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43526 "gram.c"
    break;

  case 1867:
#line 13255 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43532 "gram.c"
    break;

  case 1868:
#line 13257 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43538 "gram.c"
    break;

  case 1869:
#line 13259 "gram.y"
                                                                                { (yyval.str) = "varchar"; }
#line 43544 "gram.c"
    break;

  case 1870:
#line 13261 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43550 "gram.c"
    break;

  case 1871:
#line 13263 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43556 "gram.c"
    break;

  case 1872:
#line 13265 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 43562 "gram.c"
    break;

  case 1873:
#line 13269 "gram.y"
                                                                                                { (yyval.boolean) = TRUE; }
#line 43568 "gram.c"
    break;

  case 1874:
#line 13270 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 43574 "gram.c"
    break;

  case 1875:
#line 13274 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 43580 "gram.c"
    break;

  case 1876:
#line 13275 "gram.y"
                                                                                                { (yyval.str) = NULL; }
#line 43586 "gram.c"
    break;

  case 1877:
#line 13283 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43599 "gram.c"
    break;

  case 1878:
#line 13292 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43611 "gram.c"
    break;

  case 1879:
#line 13300 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43624 "gram.c"
    break;

  case 1880:
#line 13309 "gram.y"
                                {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43636 "gram.c"
    break;

  case 1881:
#line 13320 "gram.y"
                                {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43645 "gram.c"
    break;

  case 1882:
#line 13327 "gram.y"
                                                                                        { (yyval.boolean) = TRUE; }
#line 43651 "gram.c"
    break;

  case 1883:
#line 13328 "gram.y"
                                                                                        { (yyval.boolean) = FALSE; }
#line 43657 "gram.c"
    break;

  case 1884:
#line 13329 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 43663 "gram.c"
    break;

  case 1885:
#line 13334 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 43669 "gram.c"
    break;

  case 1886:
#line 13336 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 43675 "gram.c"
    break;

  case 1887:
#line 13338 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 43681 "gram.c"
    break;

  case 1888:
#line 13340 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 43687 "gram.c"
    break;

  case 1889:
#line 13342 "gram.y"
                                { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 43693 "gram.c"
    break;

  case 1890:
#line 13344 "gram.y"
                                { (yyval.list) = (yyvsp[0].list); }
#line 43699 "gram.c"
    break;

  case 1891:
#line 13346 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 43708 "gram.c"
    break;

  case 1892:
#line 13351 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 43717 "gram.c"
    break;

  case 1893:
#line 13356 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43727 "gram.c"
    break;

  case 1894:
#line 13362 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43739 "gram.c"
    break;

  case 1895:
#line 13370 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 43748 "gram.c"
    break;

  case 1896:
#line 13375 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43759 "gram.c"
    break;

  case 1897:
#line 13382 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 43769 "gram.c"
    break;

  case 1898:
#line 13388 "gram.y"
                                { (yyval.list) = NIL; }
#line 43775 "gram.c"
    break;

  case 1899:
#line 13393 "gram.y"
                                {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 43783 "gram.c"
    break;

  case 1900:
#line 13397 "gram.y"
                                {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 43792 "gram.c"
    break;

  case 1901:
#line 13426 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 43798 "gram.c"
    break;

  case 1902:
#line 13428 "gram.y"
                                        { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 43804 "gram.c"
    break;

  case 1903:
#line 13430 "gram.y"
                                {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 43816 "gram.c"
    break;

  case 1904:
#line 13438 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   (yylsp[-3]));
				}
#line 43826 "gram.c"
    break;

  case 1905:
#line 13453 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43832 "gram.c"
    break;

  case 1906:
#line 13455 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 43838 "gram.c"
    break;

  case 1907:
#line 13457 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43844 "gram.c"
    break;

  case 1908:
#line 13459 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43850 "gram.c"
    break;

  case 1909:
#line 13461 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43856 "gram.c"
    break;

  case 1910:
#line 13463 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43862 "gram.c"
    break;

  case 1911:
#line 13465 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43868 "gram.c"
    break;

  case 1912:
#line 13467 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43874 "gram.c"
    break;

  case 1913:
#line 13469 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43880 "gram.c"
    break;

  case 1914:
#line 13471 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43886 "gram.c"
    break;

  case 1915:
#line 13473 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43892 "gram.c"
    break;

  case 1916:
#line 13476 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43898 "gram.c"
    break;

  case 1917:
#line 13478 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43904 "gram.c"
    break;

  case 1918:
#line 13480 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 43910 "gram.c"
    break;

  case 1919:
#line 13483 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43916 "gram.c"
    break;

  case 1920:
#line 13485 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43922 "gram.c"
    break;

  case 1921:
#line 13487 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 43928 "gram.c"
    break;

  case 1922:
#line 13490 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43934 "gram.c"
    break;

  case 1923:
#line 13492 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43945 "gram.c"
    break;

  case 1924:
#line 13499 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 43951 "gram.c"
    break;

  case 1925:
#line 13501 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43962 "gram.c"
    break;

  case 1926:
#line 13508 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 43968 "gram.c"
    break;

  case 1927:
#line 13510 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 43979 "gram.c"
    break;

  case 1928:
#line 13517 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 43985 "gram.c"
    break;

  case 1929:
#line 13519 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 43996 "gram.c"
    break;

  case 1930:
#line 13527 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 44007 "gram.c"
    break;

  case 1931:
#line 13534 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44018 "gram.c"
    break;

  case 1932:
#line 13541 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[0].node), makeNullAConst(-1)),
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44029 "gram.c"
    break;

  case 1933:
#line 13548 "gram.y"
                                {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 44040 "gram.c"
    break;

  case 1934:
#line 13565 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 44051 "gram.c"
    break;

  case 1935:
#line 13572 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 44062 "gram.c"
    break;

  case 1936:
#line 13579 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 44073 "gram.c"
    break;

  case 1937:
#line 13586 "gram.y"
                                {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 44084 "gram.c"
    break;

  case 1938:
#line 13593 "gram.y"
                                {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   (yylsp[-1]));
				}
#line 44104 "gram.c"
    break;

  case 1939:
#line 13609 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 44115 "gram.c"
    break;

  case 1940:
#line 13616 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 44126 "gram.c"
    break;

  case 1941:
#line 13623 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 44137 "gram.c"
    break;

  case 1942:
#line 13630 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 44148 "gram.c"
    break;

  case 1943:
#line 13637 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 44159 "gram.c"
    break;

  case 1944:
#line 13644 "gram.y"
                                {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 44170 "gram.c"
    break;

  case 1945:
#line 13651 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44178 "gram.c"
    break;

  case 1946:
#line 13655 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 44190 "gram.c"
    break;

  case 1947:
#line 13663 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44198 "gram.c"
    break;

  case 1948:
#line 13667 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 44206 "gram.c"
    break;

  case 1949:
#line 13677 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 44217 "gram.c"
    break;

  case 1950:
#line 13684 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 44228 "gram.c"
    break;

  case 1951:
#line 13691 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 44245 "gram.c"
    break;

  case 1952:
#line 13704 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 44262 "gram.c"
    break;

  case 1953:
#line 13717 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 44285 "gram.c"
    break;

  case 1954:
#line 13736 "gram.y"
                                {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 44310 "gram.c"
    break;

  case 1955:
#line 13757 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44324 "gram.c"
    break;

  case 1956:
#line 13767 "gram.y"
                                {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 44335 "gram.c"
    break;

  case 1957:
#line 13774 "gram.y"
                                {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 44355 "gram.c"
    break;

  case 1958:
#line 13790 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44364 "gram.c"
    break;

  case 1959:
#line 13795 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 44375 "gram.c"
    break;

  case 1960:
#line 13813 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44381 "gram.c"
    break;

  case 1961:
#line 13815 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44387 "gram.c"
    break;

  case 1962:
#line 13817 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44393 "gram.c"
    break;

  case 1963:
#line 13819 "gram.y"
                                { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44399 "gram.c"
    break;

  case 1964:
#line 13821 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44405 "gram.c"
    break;

  case 1965:
#line 13823 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44411 "gram.c"
    break;

  case 1966:
#line 13825 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44417 "gram.c"
    break;

  case 1967:
#line 13827 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44423 "gram.c"
    break;

  case 1968:
#line 13829 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44429 "gram.c"
    break;

  case 1969:
#line 13831 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44435 "gram.c"
    break;

  case 1970:
#line 13833 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44441 "gram.c"
    break;

  case 1971:
#line 13835 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44447 "gram.c"
    break;

  case 1972:
#line 13837 "gram.y"
                                { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44453 "gram.c"
    break;

  case 1973:
#line 13839 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44459 "gram.c"
    break;

  case 1974:
#line 13841 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44465 "gram.c"
    break;

  case 1975:
#line 13843 "gram.y"
                                { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 44471 "gram.c"
    break;

  case 1976:
#line 13845 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44479 "gram.c"
    break;

  case 1977:
#line 13849 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 44488 "gram.c"
    break;

  case 1978:
#line 13854 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 44496 "gram.c"
    break;

  case 1979:
#line 13858 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 44504 "gram.c"
    break;

  case 1980:
#line 13862 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44513 "gram.c"
    break;

  case 1981:
#line 13867 "gram.y"
                                {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 44524 "gram.c"
    break;

  case 1982:
#line 13883 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44530 "gram.c"
    break;

  case 1983:
#line 13884 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44536 "gram.c"
    break;

  case 1984:
#line 13886 "gram.y"
                                {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 44555 "gram.c"
    break;

  case 1985:
#line 13901 "gram.y"
                                {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 44571 "gram.c"
    break;

  case 1986:
#line 13913 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44577 "gram.c"
    break;

  case 1987:
#line 13915 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44583 "gram.c"
    break;

  case 1988:
#line 13917 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44589 "gram.c"
    break;

  case 1989:
#line 13919 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44603 "gram.c"
    break;

  case 1990:
#line 13929 "gram.y"
                                {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 44630 "gram.c"
    break;

  case 1991:
#line 13952 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44644 "gram.c"
    break;

  case 1992:
#line 13962 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44658 "gram.c"
    break;

  case 1993:
#line 13972 "gram.y"
                                {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44670 "gram.c"
    break;

  case 1994:
#line 13980 "gram.y"
                                {
					TableValueExpr *n = makeNode(TableValueExpr);
					n->subquery = (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 44681 "gram.c"
    break;

  case 1995:
#line 13987 "gram.y"
                                {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 44694 "gram.c"
    break;

  case 1996:
#line 13998 "gram.y"
                                                                        { (yyval.list) = NIL; }
#line 44700 "gram.c"
    break;

  case 1997:
#line 13999 "gram.y"
                                                                { (yyval.list) = list_make1(NULL); }
#line 44706 "gram.c"
    break;

  case 1998:
#line 14000 "gram.y"
                                                        { (yyval.list) = (yyvsp[0].list); }
#line 44712 "gram.c"
    break;

  case 1999:
#line 14005 "gram.y"
                {
			SelectStmt	*s	 = (SelectStmt *) (yyvsp[-1].node);
			s->scatterClause = (yyvsp[0].list);
			(yyval.node) = (Node *) s;
		}
#line 44722 "gram.c"
    break;

  case 2000:
#line 14013 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL, (yylsp[-2]));
				}
#line 44730 "gram.c"
    break;

  case 2001:
#line 14017 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list), (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44740 "gram.c"
    break;

  case 2002:
#line 14023 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)), (yylsp[-5]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44751 "gram.c"
    break;

  case 2003:
#line 14030 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)), (yylsp[-7]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 44762 "gram.c"
    break;

  case 2004:
#line 14037 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->location = (yylsp[-5]);
					n->over = NULL;
					(yyval.node) = (Node *)n;
				}
#line 44779 "gram.c"
    break;

  case 2005:
#line 14050 "gram.y"
                                {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list), (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 44790 "gram.c"
    break;

  case 2006:
#line 14057 "gram.y"
                                {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL, (yylsp[-3]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 44810 "gram.c"
    break;

  case 2007:
#line 14085 "gram.y"
                                {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 44849 "gram.c"
    break;

  case 2008:
#line 14120 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 44855 "gram.c"
    break;

  case 2009:
#line 14130 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 44861 "gram.c"
    break;

  case 2010:
#line 14131 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 44867 "gram.c"
    break;

  case 2011:
#line 14139 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   (yylsp[-4]));
				}
#line 44877 "gram.c"
    break;

  case 2012:
#line 14145 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[0]));
				}
#line 44907 "gram.c"
    break;

  case 2013:
#line 14171 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[0]));
				}
#line 44921 "gram.c"
    break;

  case 2014:
#line 14181 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 44938 "gram.c"
    break;

  case 2015:
#line 14194 "gram.y"
                                {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[0]));
				}
#line 44950 "gram.c"
    break;

  case 2016:
#line 14202 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 44967 "gram.c"
    break;

  case 2017:
#line 14215 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[0]));
				}
#line 44981 "gram.c"
    break;

  case 2018:
#line 14225 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[-3]));
				}
#line 44998 "gram.c"
    break;

  case 2019:
#line 14238 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[0]));
				}
#line 45012 "gram.c"
    break;

  case 2020:
#line 14248 "gram.y"
                                {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[-3]));
				}
#line 45029 "gram.c"
    break;

  case 2021:
#line 14261 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 45037 "gram.c"
    break;

  case 2022:
#line 14265 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 45045 "gram.c"
    break;

  case 2023:
#line 14269 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[0]));
				}
#line 45053 "gram.c"
    break;

  case 2024:
#line 14273 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[0]));
				}
#line 45061 "gram.c"
    break;

  case 2025:
#line 14277 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[0]));
				}
#line 45069 "gram.c"
    break;

  case 2026:
#line 14281 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[0]));
				}
#line 45077 "gram.c"
    break;

  case 2027:
#line 14285 "gram.y"
                                { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 45083 "gram.c"
    break;

  case 2028:
#line 14287 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45091 "gram.c"
    break;

  case 2029:
#line 14291 "gram.y"
                                {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45104 "gram.c"
    break;

  case 2030:
#line 14300 "gram.y"
                                {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45113 "gram.c"
    break;

  case 2031:
#line 14305 "gram.y"
                                {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45124 "gram.c"
    break;

  case 2032:
#line 14312 "gram.y"
                                {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str),
												list_make1((yyvsp[-3].node)),
												(yylsp[-5]));
				}
#line 45143 "gram.c"
    break;

  case 2033:
#line 14327 "gram.y"
                                {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45154 "gram.c"
    break;

  case 2034:
#line 14334 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45162 "gram.c"
    break;

  case 2035:
#line 14338 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45170 "gram.c"
    break;

  case 2036:
#line 14342 "gram.y"
                                {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45178 "gram.c"
    break;

  case 2037:
#line 14346 "gram.y"
                                {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 45186 "gram.c"
    break;

  case 2038:
#line 14350 "gram.y"
                                {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 45197 "gram.c"
    break;

  case 2039:
#line 14357 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45209 "gram.c"
    break;

  case 2040:
#line 14365 "gram.y"
                                {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45221 "gram.c"
    break;

  case 2041:
#line 14373 "gram.y"
                {
					GroupingFunc *f = makeNode(GroupingFunc);
					f->args = (yyvsp[-1].list);
					(yyval.node) = (Node*)f;
				}
#line 45231 "gram.c"
    break;

  case 2042:
#line 14380 "gram.y"
                                {
					GroupId *gid = makeNode(GroupId);
					(yyval.node) = (Node *)gid;
				}
#line 45240 "gram.c"
    break;

  case 2043:
#line 14385 "gram.y"
                                {
					/*
					 * MEDIAN is parsed as an alias to percentile_cont(0.5).
					 * We keep track of original expression to deparse
					 * it later in views, etc.
					 */
					FuncCall   *n;
					SortBy	   *sortby;

					n = makeNode(FuncCall);
					n->funcname = SystemFuncName("median");
					n->args = list_make1(makeAConst(makeFloat(pstrdup("0.5")), (yylsp[-3])));

					sortby = makeNode(SortBy);
					sortby->node = (yyvsp[-1].node);
					sortby->sortby_dir = SORTBY_DEFAULT;
					sortby->sortby_nulls = SORTBY_NULLS_DEFAULT;
					sortby->useOp = NIL;
					sortby->location = -1;		/* no operator */
					n->agg_order = list_make1(sortby);

					n->agg_within_group = TRUE;
					n->agg_filter = NULL;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 45272 "gram.c"
    break;

  case 2044:
#line 14413 "gram.y"
                                {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("decode"));
					n->args = list_make2((yyvsp[-3].node), (yyvsp[-1].node));
                    n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->agg_filter = NULL;
					n->location = (yylsp[-5]);
					n->over = NULL;
					(yyval.node) = (Node *)n;
				}
#line 45290 "gram.c"
    break;

  case 2045:
#line 14427 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45298 "gram.c"
    break;

  case 2046:
#line 14431 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 45306 "gram.c"
    break;

  case 2047:
#line 14435 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 45314 "gram.c"
    break;

  case 2048:
#line 14439 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 45322 "gram.c"
    break;

  case 2049:
#line 14443 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 45330 "gram.c"
    break;

  case 2050:
#line 14447 "gram.y"
                                {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-4]));
				}
#line 45340 "gram.c"
    break;

  case 2051:
#line 14461 "gram.y"
                                {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[-3].node), (yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 45357 "gram.c"
    break;

  case 2052:
#line 14474 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 45365 "gram.c"
    break;

  case 2053:
#line 14478 "gram.y"
                                {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 45378 "gram.c"
    break;

  case 2054:
#line 14487 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 45386 "gram.c"
    break;

  case 2055:
#line 14491 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45394 "gram.c"
    break;

  case 2056:
#line 14495 "gram.y"
                                {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45403 "gram.c"
    break;

  case 2057:
#line 14500 "gram.y"
                                {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 45416 "gram.c"
    break;

  case 2058:
#line 14514 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 45422 "gram.c"
    break;

  case 2059:
#line 14516 "gram.y"
                                { (yyval.node) = makeNullAConst(-1); }
#line 45428 "gram.c"
    break;

  case 2060:
#line 14520 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 45434 "gram.c"
    break;

  case 2061:
#line 14522 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 45440 "gram.c"
    break;

  case 2062:
#line 14524 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 45446 "gram.c"
    break;

  case 2063:
#line 14526 "gram.y"
                                { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 45452 "gram.c"
    break;

  case 2064:
#line 14529 "gram.y"
                                                                { (yyval.list) = (yyvsp[-1].list); }
#line 45458 "gram.c"
    break;

  case 2065:
#line 14532 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45464 "gram.c"
    break;

  case 2066:
#line 14533 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45470 "gram.c"
    break;

  case 2067:
#line 14537 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45482 "gram.c"
    break;

  case 2068:
#line 14545 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 45494 "gram.c"
    break;

  case 2069:
#line 14554 "gram.y"
                                                                        { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 45500 "gram.c"
    break;

  case 2070:
#line 14555 "gram.y"
                                                                                                { (yyval.ival) = XMLOPTION_CONTENT; }
#line 45506 "gram.c"
    break;

  case 2071:
#line 14558 "gram.y"
                                                        { (yyval.boolean) = TRUE; }
#line 45512 "gram.c"
    break;

  case 2072:
#line 14559 "gram.y"
                                                                                { (yyval.boolean) = FALSE; }
#line 45518 "gram.c"
    break;

  case 2073:
#line 14560 "gram.y"
                                                                                                { (yyval.boolean) = FALSE; }
#line 45524 "gram.c"
    break;

  case 2074:
#line 14566 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45532 "gram.c"
    break;

  case 2075:
#line 14570 "gram.y"
                                {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 45540 "gram.c"
    break;

  case 2076:
#line 14574 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45548 "gram.c"
    break;

  case 2077:
#line 14578 "gram.y"
                                {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 45556 "gram.c"
    break;

  case 2078:
#line 14588 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45562 "gram.c"
    break;

  case 2079:
#line 14589 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45568 "gram.c"
    break;

  case 2080:
#line 14593 "gram.y"
                                                                                { (yyval.node) = (yyvsp[-1].node); }
#line 45574 "gram.c"
    break;

  case 2081:
#line 14594 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 45580 "gram.c"
    break;

  case 2082:
#line 14602 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 45586 "gram.c"
    break;

  case 2083:
#line 14603 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 45592 "gram.c"
    break;

  case 2084:
#line 14607 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 45598 "gram.c"
    break;

  case 2085:
#line 14609 "gram.y"
                                                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 45604 "gram.c"
    break;

  case 2086:
#line 14614 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 45614 "gram.c"
    break;

  case 2087:
#line 14622 "gram.y"
                                { (yyval.windef) = (yyvsp[0].windef); }
#line 45620 "gram.c"
    break;

  case 2088:
#line 14624 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 45637 "gram.c"
    break;

  case 2089:
#line 14637 "gram.y"
                                { (yyval.windef) = NULL; }
#line 45643 "gram.c"
    break;

  case 2090:
#line 14642 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 45661 "gram.c"
    break;

  case 2091:
#line 14667 "gram.y"
                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 45667 "gram.c"
    break;

  case 2092:
#line 14668 "gram.y"
                                                                                        { (yyval.str) = NULL; }
#line 45673 "gram.c"
    break;

  case 2093:
#line 14671 "gram.y"
                                               { (yyval.list) = (yyvsp[0].list); }
#line 45679 "gram.c"
    break;

  case 2094:
#line 14672 "gram.y"
                                    { (yyval.list) = NIL; }
#line 45685 "gram.c"
    break;

  case 2095:
#line 14685 "gram.y"
                                {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
#if 0
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-2]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-2]))));
#endif
					(yyval.windef) = n;
				}
#line 45709 "gram.c"
    break;

  case 2096:
#line 14706 "gram.y"
                                {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 45719 "gram.c"
    break;

  case 2097:
#line 14712 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45731 "gram.c"
    break;

  case 2098:
#line 14722 "gram.y"
                                {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 45752 "gram.c"
    break;

  case 2099:
#line 14739 "gram.y"
                                {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 45793 "gram.c"
    break;

  case 2100:
#line 14784 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45805 "gram.c"
    break;

  case 2101:
#line 14792 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45817 "gram.c"
    break;

  case 2102:
#line 14800 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45829 "gram.c"
    break;

  case 2103:
#line 14808 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45841 "gram.c"
    break;

  case 2104:
#line 14816 "gram.y"
                                {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 45853 "gram.c"
    break;

  case 2105:
#line 14825 "gram.y"
                                              { checkWindowExclude(); (yyval.ival) = 0; }
#line 45859 "gram.c"
    break;

  case 2106:
#line 14826 "gram.y"
                                          { checkWindowExclude(); (yyval.ival) = 0; }
#line 45865 "gram.c"
    break;

  case 2107:
#line 14827 "gram.y"
                                       { checkWindowExclude(); (yyval.ival) = 0; }
#line 45871 "gram.c"
    break;

  case 2108:
#line 14828 "gram.y"
                                            { checkWindowExclude(); (yyval.ival) = 0; }
#line 45877 "gram.c"
    break;

  case 2109:
#line 14829 "gram.y"
                                    { (yyval.ival) = 0; }
#line 45883 "gram.c"
    break;

  case 2110:
#line 14843 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45889 "gram.c"
    break;

  case 2111:
#line 14844 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 45895 "gram.c"
    break;

  case 2112:
#line 14845 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 45901 "gram.c"
    break;

  case 2113:
#line 14848 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 45907 "gram.c"
    break;

  case 2114:
#line 14849 "gram.y"
                                                                                                { (yyval.ival) = ANY_SUBLINK; }
#line 45913 "gram.c"
    break;

  case 2115:
#line 14850 "gram.y"
                                                                                                { (yyval.ival) = ALL_SUBLINK; }
#line 45919 "gram.c"
    break;

  case 2116:
#line 14853 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 45925 "gram.c"
    break;

  case 2117:
#line 14854 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 45931 "gram.c"
    break;

  case 2118:
#line 14857 "gram.y"
                                                                                        { (yyval.str) = "+"; }
#line 45937 "gram.c"
    break;

  case 2119:
#line 14858 "gram.y"
                                                                                                { (yyval.str) = "-"; }
#line 45943 "gram.c"
    break;

  case 2120:
#line 14859 "gram.y"
                                                                                                { (yyval.str) = "*"; }
#line 45949 "gram.c"
    break;

  case 2121:
#line 14860 "gram.y"
                                                                                                { (yyval.str) = "/"; }
#line 45955 "gram.c"
    break;

  case 2122:
#line 14861 "gram.y"
                                                                                                { (yyval.str) = "%"; }
#line 45961 "gram.c"
    break;

  case 2123:
#line 14862 "gram.y"
                                                                                                { (yyval.str) = "^"; }
#line 45967 "gram.c"
    break;

  case 2124:
#line 14863 "gram.y"
                                                                                                { (yyval.str) = "<"; }
#line 45973 "gram.c"
    break;

  case 2125:
#line 14864 "gram.y"
                                                                                                { (yyval.str) = ">"; }
#line 45979 "gram.c"
    break;

  case 2126:
#line 14865 "gram.y"
                                                                                                { (yyval.str) = "="; }
#line 45985 "gram.c"
    break;

  case 2127:
#line 14869 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 45991 "gram.c"
    break;

  case 2128:
#line 14871 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 45997 "gram.c"
    break;

  case 2129:
#line 14876 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46003 "gram.c"
    break;

  case 2130:
#line 14878 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 46009 "gram.c"
    break;

  case 2131:
#line 14883 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46015 "gram.c"
    break;

  case 2132:
#line 14885 "gram.y"
                                        { (yyval.list) = (yyvsp[-1].list); }
#line 46021 "gram.c"
    break;

  case 2133:
#line 14887 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~")); }
#line 46027 "gram.c"
    break;

  case 2134:
#line 14889 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~")); }
#line 46033 "gram.c"
    break;

  case 2135:
#line 14891 "gram.y"
                                        { (yyval.list) = list_make1(makeString("~~*")); }
#line 46039 "gram.c"
    break;

  case 2136:
#line 14893 "gram.y"
                                        { (yyval.list) = list_make1(makeString("!~~*")); }
#line 46045 "gram.c"
    break;

  case 2137:
#line 14905 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46053 "gram.c"
    break;

  case 2138:
#line 14909 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46061 "gram.c"
    break;

  case 2139:
#line 14916 "gram.y"
                                {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46069 "gram.c"
    break;

  case 2140:
#line 14920 "gram.y"
                                {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46077 "gram.c"
    break;

  case 2141:
#line 14926 "gram.y"
                                {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46085 "gram.c"
    break;

  case 2142:
#line 14930 "gram.y"
                                {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 46098 "gram.c"
    break;

  case 2143:
#line 14940 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 46104 "gram.c"
    break;

  case 2144:
#line 14941 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 46110 "gram.c"
    break;

  case 2145:
#line 14945 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46118 "gram.c"
    break;

  case 2146:
#line 14949 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46126 "gram.c"
    break;

  case 2147:
#line 14953 "gram.y"
                                {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 46134 "gram.c"
    break;

  case 2148:
#line 14958 "gram.y"
                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46140 "gram.c"
    break;

  case 2149:
#line 14959 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46146 "gram.c"
    break;

  case 2150:
#line 14965 "gram.y"
                                {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 46154 "gram.c"
    break;

  case 2151:
#line 14968 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46160 "gram.c"
    break;

  case 2152:
#line 14975 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46166 "gram.c"
    break;

  case 2153:
#line 14976 "gram.y"
                                                                                                { (yyval.str) = "year"; }
#line 46172 "gram.c"
    break;

  case 2154:
#line 14977 "gram.y"
                                                                                                { (yyval.str) = "month"; }
#line 46178 "gram.c"
    break;

  case 2155:
#line 14978 "gram.y"
                                                                                                { (yyval.str) = "day"; }
#line 46184 "gram.c"
    break;

  case 2156:
#line 14979 "gram.y"
                                                                                                { (yyval.str) = "hour"; }
#line 46190 "gram.c"
    break;

  case 2157:
#line 14980 "gram.y"
                                                                                                { (yyval.str) = "minute"; }
#line 46196 "gram.c"
    break;

  case 2158:
#line 14981 "gram.y"
                                                                                                { (yyval.str) = "second"; }
#line 46202 "gram.c"
    break;

  case 2159:
#line 14982 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46208 "gram.c"
    break;

  case 2160:
#line 14993 "gram.y"
                                {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 46216 "gram.c"
    break;

  case 2161:
#line 14997 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 46224 "gram.c"
    break;

  case 2162:
#line 15004 "gram.y"
                                { (yyval.node) = (yyvsp[0].node); }
#line 46230 "gram.c"
    break;

  case 2163:
#line 15010 "gram.y"
                                                                                        { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 46236 "gram.c"
    break;

  case 2164:
#line 15011 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46242 "gram.c"
    break;

  case 2165:
#line 15028 "gram.y"
                                {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 46250 "gram.c"
    break;

  case 2166:
#line 15032 "gram.y"
                                {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 46259 "gram.c"
    break;

  case 2167:
#line 15037 "gram.y"
                                {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 46267 "gram.c"
    break;

  case 2168:
#line 15041 "gram.y"
                                {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 46286 "gram.c"
    break;

  case 2169:
#line 15056 "gram.y"
                                {
					(yyval.list) = (yyvsp[0].list);
				}
#line 46294 "gram.c"
    break;

  case 2170:
#line 15060 "gram.y"
                                { (yyval.list) = NIL; }
#line 46300 "gram.c"
    break;

  case 2171:
#line 15064 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46306 "gram.c"
    break;

  case 2172:
#line 15067 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46312 "gram.c"
    break;

  case 2173:
#line 15070 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 46318 "gram.c"
    break;

  case 2174:
#line 15071 "gram.y"
                                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46324 "gram.c"
    break;

  case 2175:
#line 15072 "gram.y"
                                                                                                { (yyval.list) = (yyvsp[0].list); }
#line 46330 "gram.c"
    break;

  case 2176:
#line 15076 "gram.y"
                                {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 46341 "gram.c"
    break;

  case 2177:
#line 15082 "gram.y"
                                                                                        { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 46347 "gram.c"
    break;

  case 2178:
#line 15093 "gram.y"
                                {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 46361 "gram.c"
    break;

  case 2179:
#line 15106 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46367 "gram.c"
    break;

  case 2180:
#line 15107 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46373 "gram.c"
    break;

  case 2181:
#line 15112 "gram.y"
                                {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 46385 "gram.c"
    break;

  case 2182:
#line 15122 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46391 "gram.c"
    break;

  case 2183:
#line 15123 "gram.y"
                                                        { (yyval.node) = makeIsNotDistinctFromNode((yyvsp[0].node),(yylsp[-3])); }
#line 46397 "gram.c"
    break;

  case 2184:
#line 15127 "gram.y"
                                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46403 "gram.c"
    break;

  case 2185:
#line 15128 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 46409 "gram.c"
    break;

  case 2186:
#line 15131 "gram.y"
                                                                                        { (yyval.node) = (yyvsp[0].node); }
#line 46415 "gram.c"
    break;

  case 2187:
#line 15132 "gram.y"
                                                                                                { (yyval.node) = NULL; }
#line 46421 "gram.c"
    break;

  case 2188:
#line 15147 "gram.y"
                                {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					(yyval.node) = (Node *) c;
				}
#line 46434 "gram.c"
    break;

  case 2189:
#line 15158 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46440 "gram.c"
    break;

  case 2190:
#line 15159 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46446 "gram.c"
    break;

  case 2191:
#line 15164 "gram.y"
                                {
					Node *n = makeIsNotDistinctFromNode((yyvsp[-2].node),(yylsp[-2]));
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) n;
					w->result = (Expr *) (yyvsp[0].node);
					(yyval.node) = (Node *) w;
				}
#line 46458 "gram.c"
    break;

  case 2192:
#line 15174 "gram.y"
                                                                                { (yyval.node) = (yyvsp[0].node); }
#line 46464 "gram.c"
    break;

  case 2193:
#line 15175 "gram.y"
                                                                                { (yyval.node) = NULL; }
#line 46470 "gram.c"
    break;

  case 2194:
#line 15180 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 46478 "gram.c"
    break;

  case 2195:
#line 15184 "gram.y"
                                {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 46486 "gram.c"
    break;

  case 2196:
#line 15191 "gram.y"
                                {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 46494 "gram.c"
    break;

  case 2197:
#line 15195 "gram.y"
                                {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 46502 "gram.c"
    break;

  case 2198:
#line 15199 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46513 "gram.c"
    break;

  case 2199:
#line 15206 "gram.y"
                                {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46524 "gram.c"
    break;

  case 2200:
#line 15215 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46530 "gram.c"
    break;

  case 2201:
#line 15216 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46536 "gram.c"
    break;

  case 2202:
#line 15220 "gram.y"
                                                                                                { (yyval.list) = NIL; }
#line 46542 "gram.c"
    break;

  case 2203:
#line 15221 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46548 "gram.c"
    break;

  case 2206:
#line 15236 "gram.y"
                                                                { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 46554 "gram.c"
    break;

  case 2207:
#line 15238 "gram.y"
                                {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 46564 "gram.c"
    break;

  case 2208:
#line 15246 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46570 "gram.c"
    break;

  case 2209:
#line 15247 "gram.y"
                                                                        { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46576 "gram.c"
    break;

  case 2210:
#line 15255 "gram.y"
                                                                        { (yyval.list) = (yyvsp[-1].list); }
#line 46582 "gram.c"
    break;

  case 2211:
#line 15265 "gram.y"
                                                                        { (yyval.list) = (yyvsp[0].list); }
#line 46588 "gram.c"
    break;

  case 2212:
#line 15266 "gram.y"
                                                                                        { (yyval.list) = NIL; }
#line 46594 "gram.c"
    break;

  case 2213:
#line 15270 "gram.y"
                                                                                                { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46600 "gram.c"
    break;

  case 2214:
#line 15271 "gram.y"
                                                                                { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46606 "gram.c"
    break;

  case 2215:
#line 15275 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46618 "gram.c"
    break;

  case 2216:
#line 15297 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46630 "gram.c"
    break;

  case 2217:
#line 15305 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46642 "gram.c"
    break;

  case 2218:
#line 15313 "gram.y"
                                {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 46654 "gram.c"
    break;

  case 2219:
#line 15321 "gram.y"
                                {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 46670 "gram.c"
    break;

  case 2220:
#line 15342 "gram.y"
                                                                                        { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 46676 "gram.c"
    break;

  case 2221:
#line 15343 "gram.y"
                                                                 { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 46682 "gram.c"
    break;

  case 2222:
#line 15355 "gram.y"
                                {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 46690 "gram.c"
    break;

  case 2223:
#line 15359 "gram.y"
                                {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 46719 "gram.c"
    break;

  case 2224:
#line 15386 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46725 "gram.c"
    break;

  case 2225:
#line 15388 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 46731 "gram.c"
    break;

  case 2226:
#line 15392 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46737 "gram.c"
    break;

  case 2227:
#line 15395 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46743 "gram.c"
    break;

  case 2228:
#line 15398 "gram.y"
                                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46749 "gram.c"
    break;

  case 2229:
#line 15400 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46755 "gram.c"
    break;

  case 2230:
#line 15402 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46761 "gram.c"
    break;

  case 2231:
#line 15404 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46767 "gram.c"
    break;

  case 2232:
#line 15415 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46773 "gram.c"
    break;

  case 2233:
#line 15417 "gram.y"
                                        {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 46782 "gram.c"
    break;

  case 2234:
#line 15428 "gram.y"
                                {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 46790 "gram.c"
    break;

  case 2235:
#line 15432 "gram.y"
                                {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46798 "gram.c"
    break;

  case 2236:
#line 15436 "gram.y"
                                {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46806 "gram.c"
    break;

  case 2237:
#line 15440 "gram.y"
                                {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46814 "gram.c"
    break;

  case 2238:
#line 15444 "gram.y"
                                {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 46827 "gram.c"
    break;

  case 2239:
#line 15453 "gram.y"
                                {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46838 "gram.c"
    break;

  case 2240:
#line 15460 "gram.y"
                                {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 46874 "gram.c"
    break;

  case 2241:
#line 15492 "gram.y"
                                {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 46882 "gram.c"
    break;

  case 2242:
#line 15496 "gram.y"
                                {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 46892 "gram.c"
    break;

  case 2243:
#line 15502 "gram.y"
                                {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 46913 "gram.c"
    break;

  case 2244:
#line 15519 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 46921 "gram.c"
    break;

  case 2245:
#line 15523 "gram.y"
                                {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 46929 "gram.c"
    break;

  case 2246:
#line 15527 "gram.y"
                                {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 46937 "gram.c"
    break;

  case 2247:
#line 15532 "gram.y"
                                                                                        { (yyval.ival) = (yyvsp[0].ival); }
#line 46943 "gram.c"
    break;

  case 2248:
#line 15533 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46949 "gram.c"
    break;

  case 2249:
#line 15534 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46955 "gram.c"
    break;

  case 2250:
#line 15535 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 46961 "gram.c"
    break;

  case 2251:
#line 15538 "gram.y"
                                        { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46967 "gram.c"
    break;

  case 2252:
#line 15540 "gram.y"
                                        { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 46973 "gram.c"
    break;

  case 2253:
#line 15543 "gram.y"
                                                                                { (yyval.ival) = (yyvsp[0].ival); }
#line 46979 "gram.c"
    break;

  case 2254:
#line 15544 "gram.y"
                                                                                        { (yyval.ival) = + (yyvsp[0].ival); }
#line 46985 "gram.c"
    break;

  case 2255:
#line 15545 "gram.y"
                                                                                        { (yyval.ival) = - (yyvsp[0].ival); }
#line 46991 "gram.c"
    break;

  case 2256:
#line 15561 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 46997 "gram.c"
    break;

  case 2257:
#line 15562 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47003 "gram.c"
    break;

  case 2258:
#line 15563 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47009 "gram.c"
    break;

  case 2259:
#line 15568 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 47015 "gram.c"
    break;

  case 2260:
#line 15569 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47021 "gram.c"
    break;

  case 2261:
#line 15570 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47027 "gram.c"
    break;

  case 2262:
#line 15575 "gram.y"
                                                                                { (yyval.str) = (yyvsp[0].str); }
#line 47033 "gram.c"
    break;

  case 2263:
#line 15576 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47039 "gram.c"
    break;

  case 2264:
#line 15577 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47045 "gram.c"
    break;

  case 2265:
#line 15578 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47051 "gram.c"
    break;

  case 2266:
#line 15584 "gram.y"
                                                                                        { (yyval.str) = (yyvsp[0].str); }
#line 47057 "gram.c"
    break;

  case 2267:
#line 15585 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47063 "gram.c"
    break;

  case 2268:
#line 15586 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47069 "gram.c"
    break;

  case 2269:
#line 15587 "gram.y"
                                                                                { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47075 "gram.c"
    break;

  case 2270:
#line 15588 "gram.y"
                                                                                        { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47081 "gram.c"
    break;

  case 2582:
#line 15932 "gram.y"
                                             { (yyval.str)=pstrdup((yyvsp[0].keyword)); }
#line 47087 "gram.c"
    break;

  case 2588:
#line 15942 "gram.y"
                                      { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47093 "gram.c"
    break;

  case 2589:
#line 15943 "gram.y"
                                { (yyval.str) = pstrdup((yyvsp[0].str)); }
#line 47099 "gram.c"
    break;


#line 47103 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 16419 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		switch (p->mode)
		{
			/* Input modes */
			case FUNC_PARAM_IN:
			case FUNC_PARAM_VARIADIC:
				break;  

			/* Output modes */
			case FUNC_PARAM_TABLE:
				Insist(false);  /* not feasible */
				break;
			case FUNC_PARAM_OUT:
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("OUT arguments aren't allowed in TABLE functions")));
				break;
			case FUNC_PARAM_INOUT:
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("INOUT arguments aren't allowed in TABLE functions")));
				break;
		}
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

static void 
checkWindowExclude(void)
{
	/*
	 * because the syntax has historically existed without doing anything
	 * we have chosen to add a guc to allow simply ignoring the exclude clause
	 * rather than raising an error.
	 */
	if (gp_ignore_window_exclude)
		return;

	/* MPP-13628 */
	ereport(ERROR,
			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
			 errmsg("window EXCLUDE clause not yet implemented")));
}

/*
 * Create the IS_NOT_DISTINCT_FROM expression node
 *     used by CASE x WHEN IS NOT DISTINCT FROM and DECODE()
 */
static Node*
makeIsNotDistinctFromNode(Node *expr, int position)
{
	Node *n = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
								(Node *) makeSimpleA_Expr(AEXPR_DISTINCT, 
	 													"=", NULL, expr, position), position);
	return n;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
