/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylval          base_yylval
#define yychar          base_yychar
#define yylloc          base_yylloc

/* First part of user prologue.  */
#line 5 "preproc.y"

#include "postgres_fe.h"

#include "extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N)						\
			(Current) = (Rhs)[1];	\
		else						\
			(Current) = (Rhs)[0];	\
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char	pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int	varchar_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

/*
 * Handle parsing errors and warnings
 */
static void __attribute__((format(PG_PRINTF_ATTRIBUTE, 3, 0)))
vmmerror(int error_code, enum errortype type, const char *error, va_list ap)
{
	/* internationalize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, base_yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	vfprintf(stderr, error, ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
	}
}

void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, type, error, ap);
	va_end(ap);
}

void
mmfatal(int error_code, const char *error, ...)
{
	va_list		ap;

	va_start(ap, error);
	vmmerror(error_code, ET_ERROR, error, ap);
	va_end(ap);

	if (base_yyin)
		fclose(base_yyin);
	if (base_yyout)
		fclose(base_yyout);

	if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
		fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
	exit(error_code);
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return(res_str);
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return(res_str);
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(base_yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essentially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), mm_strdup(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return(result);
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in another functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn't cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = EMPTY;
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char var_text[20];
			char *original_var;
			bool skip_set_var = false;
			bool var_ptr = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(var_text, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable)
					 && (strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement")) == 0))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar
					  && ptr->variable->type->type != ECPGt_char
					  && ptr->variable->type->type != ECPGt_unsigned_char
					  && ptr->variable->type->type != ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																			   mm_strdup("1"),
																			   ptr->variable->type->u.element->counter),
														  ptr->variable->type->size),
									  0);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar
					  || ptr->variable->type->type == ECPGt_char
					  || ptr->variable->type->type == ECPGt_unsigned_char
					  || ptr->variable->type->type == ECPGt_string)
					 && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, mm_strdup("("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				if (ptr->variable->type->type == ECPGt_varchar)
					var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_struct
					 || ptr->variable->type->type == ECPGt_union)
			{
				newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
									  ECPGmake_struct_type(ptr->variable->type->u.members,
														   ptr->variable->type->type,
														   ptr->variable->type->type_name,
														   ptr->variable->type->struct_sizeof),
									  0);
				var_ptr = true;
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct
					|| ptr->variable->type->u.element->type == ECPGt_union)
				{
					newvar = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->variable->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->variable->type->u.element->u.members,
															   ptr->variable->type->u.element->type,
															   ptr->variable->type->u.element->type_name,
															   ptr->variable->type->u.element->struct_sizeof),
										  0);
				}
				else
				{
					newvar = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type,
																				   ptr->variable->type->u.element->size,
																				   ptr->variable->type->u.element->counter),
															  ptr->variable->type->size),
										  0);
					var_ptr = true;
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, mm_strdup("*("),
											  mm_strdup(ecpg_type_name(ptr->variable->type->type)),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text)),
									  ECPGmake_simple_type(ptr->variable->type->type,
														   ptr->variable->type->size,
														   ptr->variable->type->counter),
									  0);
				var_ptr = true;
			}

			/* create call to "ECPGset_var(<counter>, <connection>, <pointer>. <line number>)" */
			if (!skip_set_var)
			{
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(var_text, "%d))", ecpg_internal_var);
				var_ptr = false;

				if (ptr->indicator->type->type == ECPGt_struct
					|| ptr->indicator->type->type == ECPGt_union)
				{
					newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
										  ECPGmake_struct_type(ptr->indicator->type->u.members,
															   ptr->indicator->type->type,
															   ptr->indicator->type->type_name,
															   ptr->indicator->type->struct_sizeof),
										  0);
					var_ptr = true;
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct
						|| ptr->indicator->type->u.element->type == ECPGt_union)
					{
						newind = new_variable(cat_str(5, mm_strdup("(*("),
											  mm_strdup(ptr->indicator->type->u.element->type_name),
											  mm_strdup(" *)(ECPGget_var("),
											  mm_strdup(var_text),
											  mm_strdup(")")),
											  ECPGmake_struct_type(ptr->indicator->type->u.element->u.members,
																   ptr->indicator->type->u.element->type,
																   ptr->indicator->type->u.element->type_name,
																   ptr->indicator->type->u.element->struct_sizeof),
											  0);
					}
					else
					{
						newind = new_variable(cat_str(4, mm_strdup("("),
													  mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)),
													  mm_strdup(" *)(ECPGget_var("), mm_strdup(var_text)),
											  ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type,
																					   ptr->indicator->type->u.element->size,
																					   ptr->indicator->type->u.element->counter),
																  ptr->indicator->type->size),
											  0);
						var_ptr = true;
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, mm_strdup("("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
				}
				else
				{
					newind = new_variable(cat_str(4, mm_strdup("*("),
												  mm_strdup(ecpg_type_name(ptr->indicator->type->type)),
												  mm_strdup(" *)(ECPGget_var("),
												  mm_strdup(var_text)),
										  ECPGmake_simple_type(ptr->indicator->type->type,
															   ptr->indicator->type->size,
															   ptr->variable->type->counter),
										  0);
					var_ptr = true;
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				sprintf(var_text, "%d, %s", ecpg_internal_var++, var_ptr ? "&(" : "(");
				result = cat_str(5, result, mm_strdup("ECPGset_var("),
								 mm_strdup(var_text), mm_strdup(original_var),
								 mm_strdup("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && strcmp(cur->function, current_function) == 0))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;
	int (* strcmp_fn)(const char *, const char *) = ((name[0] == ':' || name[0] == '"') ? strcmp : pg_strcasecmp);

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp_fn(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char *dimension, char *length, enum ECPGttype type_enum,
			char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
		 type_enum == ECPGt_union) &&
		initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}

#line 649 "preproc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_BASE_YY_PREPROC_H_INCLUDED
# define YY_BASE_YY_PREPROC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    SQL_ALLOCATE = 258,            /* SQL_ALLOCATE  */
    SQL_AUTOCOMMIT = 259,          /* SQL_AUTOCOMMIT  */
    SQL_BOOL = 260,                /* SQL_BOOL  */
    SQL_BREAK = 261,               /* SQL_BREAK  */
    SQL_CALL = 262,                /* SQL_CALL  */
    SQL_CARDINALITY = 263,         /* SQL_CARDINALITY  */
    SQL_CONNECT = 264,             /* SQL_CONNECT  */
    SQL_COUNT = 265,               /* SQL_COUNT  */
    SQL_DATETIME_INTERVAL_CODE = 266, /* SQL_DATETIME_INTERVAL_CODE  */
    SQL_DATETIME_INTERVAL_PRECISION = 267, /* SQL_DATETIME_INTERVAL_PRECISION  */
    SQL_DESCRIBE = 268,            /* SQL_DESCRIBE  */
    SQL_DESCRIPTOR = 269,          /* SQL_DESCRIPTOR  */
    SQL_DISCONNECT = 270,          /* SQL_DISCONNECT  */
    SQL_FOUND = 271,               /* SQL_FOUND  */
    SQL_FREE = 272,                /* SQL_FREE  */
    SQL_GET = 273,                 /* SQL_GET  */
    SQL_GO = 274,                  /* SQL_GO  */
    SQL_GOTO = 275,                /* SQL_GOTO  */
    SQL_IDENTIFIED = 276,          /* SQL_IDENTIFIED  */
    SQL_INDICATOR = 277,           /* SQL_INDICATOR  */
    SQL_KEY_MEMBER = 278,          /* SQL_KEY_MEMBER  */
    SQL_LENGTH = 279,              /* SQL_LENGTH  */
    SQL_LONG = 280,                /* SQL_LONG  */
    SQL_NULLABLE = 281,            /* SQL_NULLABLE  */
    SQL_OCTET_LENGTH = 282,        /* SQL_OCTET_LENGTH  */
    SQL_OPEN = 283,                /* SQL_OPEN  */
    SQL_OUTPUT = 284,              /* SQL_OUTPUT  */
    SQL_REFERENCE = 285,           /* SQL_REFERENCE  */
    SQL_RETURNED_LENGTH = 286,     /* SQL_RETURNED_LENGTH  */
    SQL_RETURNED_OCTET_LENGTH = 287, /* SQL_RETURNED_OCTET_LENGTH  */
    SQL_SCALE = 288,               /* SQL_SCALE  */
    SQL_SECTION = 289,             /* SQL_SECTION  */
    SQL_SHORT = 290,               /* SQL_SHORT  */
    SQL_SIGNED = 291,              /* SQL_SIGNED  */
    SQL_SQL = 292,                 /* SQL_SQL  */
    SQL_SQLERROR = 293,            /* SQL_SQLERROR  */
    SQL_SQLPRINT = 294,            /* SQL_SQLPRINT  */
    SQL_SQLWARNING = 295,          /* SQL_SQLWARNING  */
    SQL_START = 296,               /* SQL_START  */
    SQL_STOP = 297,                /* SQL_STOP  */
    SQL_STRUCT = 298,              /* SQL_STRUCT  */
    SQL_UNSIGNED = 299,            /* SQL_UNSIGNED  */
    SQL_VAR = 300,                 /* SQL_VAR  */
    SQL_WHENEVER = 301,            /* SQL_WHENEVER  */
    S_ADD = 302,                   /* S_ADD  */
    S_AND = 303,                   /* S_AND  */
    S_ANYTHING = 304,              /* S_ANYTHING  */
    S_AUTO = 305,                  /* S_AUTO  */
    S_CONST = 306,                 /* S_CONST  */
    S_DEC = 307,                   /* S_DEC  */
    S_DIV = 308,                   /* S_DIV  */
    S_DOTPOINT = 309,              /* S_DOTPOINT  */
    S_EQUAL = 310,                 /* S_EQUAL  */
    S_EXTERN = 311,                /* S_EXTERN  */
    S_INC = 312,                   /* S_INC  */
    S_LSHIFT = 313,                /* S_LSHIFT  */
    S_MEMPOINT = 314,              /* S_MEMPOINT  */
    S_MEMBER = 315,                /* S_MEMBER  */
    S_MOD = 316,                   /* S_MOD  */
    S_MUL = 317,                   /* S_MUL  */
    S_NEQUAL = 318,                /* S_NEQUAL  */
    S_OR = 319,                    /* S_OR  */
    S_REGISTER = 320,              /* S_REGISTER  */
    S_RSHIFT = 321,                /* S_RSHIFT  */
    S_STATIC = 322,                /* S_STATIC  */
    S_SUB = 323,                   /* S_SUB  */
    S_VOLATILE = 324,              /* S_VOLATILE  */
    S_TYPEDEF = 325,               /* S_TYPEDEF  */
    CSTRING = 326,                 /* CSTRING  */
    CVARIABLE = 327,               /* CVARIABLE  */
    CPP_LINE = 328,                /* CPP_LINE  */
    IP = 329,                      /* IP  */
    DOLCONST = 330,                /* DOLCONST  */
    ECONST = 331,                  /* ECONST  */
    NCONST = 332,                  /* NCONST  */
    UCONST = 333,                  /* UCONST  */
    UIDENT = 334,                  /* UIDENT  */
    IDENT = 335,                   /* IDENT  */
    FCONST = 336,                  /* FCONST  */
    SCONST = 337,                  /* SCONST  */
    BCONST = 338,                  /* BCONST  */
    XCONST = 339,                  /* XCONST  */
    Op = 340,                      /* Op  */
    ICONST = 341,                  /* ICONST  */
    PARAM = 342,                   /* PARAM  */
    TYPECAST = 343,                /* TYPECAST  */
    DOT_DOT = 344,                 /* DOT_DOT  */
    COLON_EQUALS = 345,            /* COLON_EQUALS  */
    ABORT_P = 346,                 /* ABORT_P  */
    ABSOLUTE_P = 347,              /* ABSOLUTE_P  */
    ACCESS = 348,                  /* ACCESS  */
    ACTION = 349,                  /* ACTION  */
    ADD_P = 350,                   /* ADD_P  */
    ADMIN = 351,                   /* ADMIN  */
    AFTER = 352,                   /* AFTER  */
    AGGREGATE = 353,               /* AGGREGATE  */
    ALL = 354,                     /* ALL  */
    ALSO = 355,                    /* ALSO  */
    ALTER = 356,                   /* ALTER  */
    ALWAYS = 357,                  /* ALWAYS  */
    ANALYSE = 358,                 /* ANALYSE  */
    ANALYZE = 359,                 /* ANALYZE  */
    AND = 360,                     /* AND  */
    ANY = 361,                     /* ANY  */
    ARRAY = 362,                   /* ARRAY  */
    AS = 363,                      /* AS  */
    ASC = 364,                     /* ASC  */
    ASSERTION = 365,               /* ASSERTION  */
    ASSIGNMENT = 366,              /* ASSIGNMENT  */
    ASYMMETRIC = 367,              /* ASYMMETRIC  */
    AT = 368,                      /* AT  */
    ATTRIBUTE = 369,               /* ATTRIBUTE  */
    AUTHORIZATION = 370,           /* AUTHORIZATION  */
    BACKWARD = 371,                /* BACKWARD  */
    BEFORE = 372,                  /* BEFORE  */
    BEGIN_P = 373,                 /* BEGIN_P  */
    BETWEEN = 374,                 /* BETWEEN  */
    BIGINT = 375,                  /* BIGINT  */
    BINARY = 376,                  /* BINARY  */
    BIT = 377,                     /* BIT  */
    BOOLEAN_P = 378,               /* BOOLEAN_P  */
    BOTH = 379,                    /* BOTH  */
    BY = 380,                      /* BY  */
    CACHE = 381,                   /* CACHE  */
    CALLED = 382,                  /* CALLED  */
    CASCADE = 383,                 /* CASCADE  */
    CASCADED = 384,                /* CASCADED  */
    CASE = 385,                    /* CASE  */
    CAST = 386,                    /* CAST  */
    CATALOG_P = 387,               /* CATALOG_P  */
    CHAIN = 388,                   /* CHAIN  */
    CHAR_P = 389,                  /* CHAR_P  */
    CHARACTER = 390,               /* CHARACTER  */
    CHARACTERISTICS = 391,         /* CHARACTERISTICS  */
    CHECK = 392,                   /* CHECK  */
    CHECKPOINT = 393,              /* CHECKPOINT  */
    CLASS = 394,                   /* CLASS  */
    CLOSE = 395,                   /* CLOSE  */
    CLUSTER = 396,                 /* CLUSTER  */
    COALESCE = 397,                /* COALESCE  */
    COLLATE = 398,                 /* COLLATE  */
    COLLATION = 399,               /* COLLATION  */
    COLUMN = 400,                  /* COLUMN  */
    COMMENT = 401,                 /* COMMENT  */
    COMMENTS = 402,                /* COMMENTS  */
    COMMIT = 403,                  /* COMMIT  */
    COMMITTED = 404,               /* COMMITTED  */
    CONCURRENCY = 405,             /* CONCURRENCY  */
    CONCURRENTLY = 406,            /* CONCURRENTLY  */
    CONFIGURATION = 407,           /* CONFIGURATION  */
    CONNECTION = 408,              /* CONNECTION  */
    CONSTRAINT = 409,              /* CONSTRAINT  */
    CONSTRAINTS = 410,             /* CONSTRAINTS  */
    CONTENT_P = 411,               /* CONTENT_P  */
    CONTINUE_P = 412,              /* CONTINUE_P  */
    CONVERSION_P = 413,            /* CONVERSION_P  */
    COPY = 414,                    /* COPY  */
    COST = 415,                    /* COST  */
    CREATE = 416,                  /* CREATE  */
    CROSS = 417,                   /* CROSS  */
    CSV = 418,                     /* CSV  */
    CURRENT_P = 419,               /* CURRENT_P  */
    CURRENT_CATALOG = 420,         /* CURRENT_CATALOG  */
    CURRENT_DATE = 421,            /* CURRENT_DATE  */
    CURRENT_ROLE = 422,            /* CURRENT_ROLE  */
    CURRENT_SCHEMA = 423,          /* CURRENT_SCHEMA  */
    CURRENT_TIME = 424,            /* CURRENT_TIME  */
    CURRENT_TIMESTAMP = 425,       /* CURRENT_TIMESTAMP  */
    CURRENT_USER = 426,            /* CURRENT_USER  */
    CURSOR = 427,                  /* CURSOR  */
    CYCLE = 428,                   /* CYCLE  */
    DATA_P = 429,                  /* DATA_P  */
    DATABASE = 430,                /* DATABASE  */
    DAY_P = 431,                   /* DAY_P  */
    DEALLOCATE = 432,              /* DEALLOCATE  */
    DEC = 433,                     /* DEC  */
    DECIMAL_P = 434,               /* DECIMAL_P  */
    DECLARE = 435,                 /* DECLARE  */
    DEFAULT = 436,                 /* DEFAULT  */
    DEFAULTS = 437,                /* DEFAULTS  */
    DEFERRABLE = 438,              /* DEFERRABLE  */
    DEFERRED = 439,                /* DEFERRED  */
    DEFINER = 440,                 /* DEFINER  */
    DELETE_P = 441,                /* DELETE_P  */
    DELIMITER = 442,               /* DELIMITER  */
    DELIMITERS = 443,              /* DELIMITERS  */
    DESC = 444,                    /* DESC  */
    DICTIONARY = 445,              /* DICTIONARY  */
    DISABLE_P = 446,               /* DISABLE_P  */
    DISCARD = 447,                 /* DISCARD  */
    DISTINCT = 448,                /* DISTINCT  */
    DO = 449,                      /* DO  */
    DOCUMENT_P = 450,              /* DOCUMENT_P  */
    DOMAIN_P = 451,                /* DOMAIN_P  */
    DOUBLE_P = 452,                /* DOUBLE_P  */
    DROP = 453,                    /* DROP  */
    EACH = 454,                    /* EACH  */
    ELSE = 455,                    /* ELSE  */
    ENABLE_P = 456,                /* ENABLE_P  */
    ENCODING = 457,                /* ENCODING  */
    ENCRYPTED = 458,               /* ENCRYPTED  */
    END_P = 459,                   /* END_P  */
    ENUM_P = 460,                  /* ENUM_P  */
    ESCAPE = 461,                  /* ESCAPE  */
    EVENT = 462,                   /* EVENT  */
    EXCEPT = 463,                  /* EXCEPT  */
    EXCLUDE = 464,                 /* EXCLUDE  */
    EXCLUDING = 465,               /* EXCLUDING  */
    EXCLUSIVE = 466,               /* EXCLUSIVE  */
    EXECUTE = 467,                 /* EXECUTE  */
    EXISTS = 468,                  /* EXISTS  */
    EXPLAIN = 469,                 /* EXPLAIN  */
    EXTENSION = 470,               /* EXTENSION  */
    EXTERNAL = 471,                /* EXTERNAL  */
    EXTRACT = 472,                 /* EXTRACT  */
    FALSE_P = 473,                 /* FALSE_P  */
    FAMILY = 474,                  /* FAMILY  */
    FETCH = 475,                   /* FETCH  */
    FILTER = 476,                  /* FILTER  */
    FIRST_P = 477,                 /* FIRST_P  */
    FLOAT_P = 478,                 /* FLOAT_P  */
    FOLLOWING = 479,               /* FOLLOWING  */
    FOR = 480,                     /* FOR  */
    FORCE = 481,                   /* FORCE  */
    FOREIGN = 482,                 /* FOREIGN  */
    FORWARD = 483,                 /* FORWARD  */
    FREEZE = 484,                  /* FREEZE  */
    FROM = 485,                    /* FROM  */
    FULL = 486,                    /* FULL  */
    FUNCTION = 487,                /* FUNCTION  */
    FUNCTIONS = 488,               /* FUNCTIONS  */
    GLOBAL = 489,                  /* GLOBAL  */
    GRANT = 490,                   /* GRANT  */
    GRANTED = 491,                 /* GRANTED  */
    GREATEST = 492,                /* GREATEST  */
    GROUP_P = 493,                 /* GROUP_P  */
    HANDLER = 494,                 /* HANDLER  */
    HAVING = 495,                  /* HAVING  */
    HEADER_P = 496,                /* HEADER_P  */
    HOLD = 497,                    /* HOLD  */
    HOUR_P = 498,                  /* HOUR_P  */
    IDENTITY_P = 499,              /* IDENTITY_P  */
    IF_P = 500,                    /* IF_P  */
    ILIKE = 501,                   /* ILIKE  */
    IMMEDIATE = 502,               /* IMMEDIATE  */
    IMMUTABLE = 503,               /* IMMUTABLE  */
    IMPLICIT_P = 504,              /* IMPLICIT_P  */
    IN_P = 505,                    /* IN_P  */
    INCLUDING = 506,               /* INCLUDING  */
    INCREMENT = 507,               /* INCREMENT  */
    INDEX = 508,                   /* INDEX  */
    INDEXES = 509,                 /* INDEXES  */
    INHERIT = 510,                 /* INHERIT  */
    INHERITS = 511,                /* INHERITS  */
    INITIALLY = 512,               /* INITIALLY  */
    INLINE_P = 513,                /* INLINE_P  */
    INNER_P = 514,                 /* INNER_P  */
    INOUT = 515,                   /* INOUT  */
    INPUT_P = 516,                 /* INPUT_P  */
    INSENSITIVE = 517,             /* INSENSITIVE  */
    INSERT = 518,                  /* INSERT  */
    INSTEAD = 519,                 /* INSTEAD  */
    INT_P = 520,                   /* INT_P  */
    INTEGER = 521,                 /* INTEGER  */
    INTERSECT = 522,               /* INTERSECT  */
    INTERVAL = 523,                /* INTERVAL  */
    INTO = 524,                    /* INTO  */
    INVOKER = 525,                 /* INVOKER  */
    IS = 526,                      /* IS  */
    ISNULL = 527,                  /* ISNULL  */
    ISOLATION = 528,               /* ISOLATION  */
    JOIN = 529,                    /* JOIN  */
    KEY = 530,                     /* KEY  */
    LABEL = 531,                   /* LABEL  */
    LANGUAGE = 532,                /* LANGUAGE  */
    LARGE_P = 533,                 /* LARGE_P  */
    LAST_P = 534,                  /* LAST_P  */
    LATERAL_P = 535,               /* LATERAL_P  */
    LC_COLLATE_P = 536,            /* LC_COLLATE_P  */
    LC_CTYPE_P = 537,              /* LC_CTYPE_P  */
    LEADING = 538,                 /* LEADING  */
    LEAKPROOF = 539,               /* LEAKPROOF  */
    LEAST = 540,                   /* LEAST  */
    LEFT = 541,                    /* LEFT  */
    LEVEL = 542,                   /* LEVEL  */
    LIKE = 543,                    /* LIKE  */
    LIMIT = 544,                   /* LIMIT  */
    LISTEN = 545,                  /* LISTEN  */
    LOAD = 546,                    /* LOAD  */
    LOCAL = 547,                   /* LOCAL  */
    LOCALTIME = 548,               /* LOCALTIME  */
    LOCALTIMESTAMP = 549,          /* LOCALTIMESTAMP  */
    LOCATION = 550,                /* LOCATION  */
    LOCK_P = 551,                  /* LOCK_P  */
    MAPPING = 552,                 /* MAPPING  */
    MATCH = 553,                   /* MATCH  */
    MATERIALIZED = 554,            /* MATERIALIZED  */
    MAXVALUE = 555,                /* MAXVALUE  */
    MEMORY_LIMIT = 556,            /* MEMORY_LIMIT  */
    MEMORY_SHARED_QUOTA = 557,     /* MEMORY_SHARED_QUOTA  */
    MEMORY_SPILL_RATIO = 558,      /* MEMORY_SPILL_RATIO  */
    MINUTE_P = 559,                /* MINUTE_P  */
    MINVALUE = 560,                /* MINVALUE  */
    MODE = 561,                    /* MODE  */
    MONTH_P = 562,                 /* MONTH_P  */
    MOVE = 563,                    /* MOVE  */
    NAME_P = 564,                  /* NAME_P  */
    NAMES = 565,                   /* NAMES  */
    NATIONAL = 566,                /* NATIONAL  */
    NATURAL = 567,                 /* NATURAL  */
    NCHAR = 568,                   /* NCHAR  */
    NEXT = 569,                    /* NEXT  */
    NO = 570,                      /* NO  */
    NONE = 571,                    /* NONE  */
    NOT = 572,                     /* NOT  */
    NOTHING = 573,                 /* NOTHING  */
    NOTIFY = 574,                  /* NOTIFY  */
    NOTNULL = 575,                 /* NOTNULL  */
    NOWAIT = 576,                  /* NOWAIT  */
    NULL_P = 577,                  /* NULL_P  */
    NULLIF = 578,                  /* NULLIF  */
    NULLS_P = 579,                 /* NULLS_P  */
    NUMERIC = 580,                 /* NUMERIC  */
    OBJECT_P = 581,                /* OBJECT_P  */
    OF = 582,                      /* OF  */
    OFF = 583,                     /* OFF  */
    OFFSET = 584,                  /* OFFSET  */
    OIDS = 585,                    /* OIDS  */
    ON = 586,                      /* ON  */
    ONLY = 587,                    /* ONLY  */
    OPERATOR = 588,                /* OPERATOR  */
    OPTION = 589,                  /* OPTION  */
    OPTIONS = 590,                 /* OPTIONS  */
    OR = 591,                      /* OR  */
    ORDER = 592,                   /* ORDER  */
    ORDINALITY = 593,              /* ORDINALITY  */
    OUT_P = 594,                   /* OUT_P  */
    OUTER_P = 595,                 /* OUTER_P  */
    OVER = 596,                    /* OVER  */
    OVERLAPS = 597,                /* OVERLAPS  */
    OVERLAY = 598,                 /* OVERLAY  */
    OWNED = 599,                   /* OWNED  */
    OWNER = 600,                   /* OWNER  */
    PARSER = 601,                  /* PARSER  */
    PARTIAL = 602,                 /* PARTIAL  */
    PARTITION = 603,               /* PARTITION  */
    PASSING = 604,                 /* PASSING  */
    PASSWORD = 605,                /* PASSWORD  */
    PLACING = 606,                 /* PLACING  */
    PLANS = 607,                   /* PLANS  */
    POSITION = 608,                /* POSITION  */
    PRECEDING = 609,               /* PRECEDING  */
    PRECISION = 610,               /* PRECISION  */
    PRESERVE = 611,                /* PRESERVE  */
    PREPARE = 612,                 /* PREPARE  */
    PREPARED = 613,                /* PREPARED  */
    PRIMARY = 614,                 /* PRIMARY  */
    PRIOR = 615,                   /* PRIOR  */
    PRIVILEGES = 616,              /* PRIVILEGES  */
    PROCEDURAL = 617,              /* PROCEDURAL  */
    PROCEDURE = 618,               /* PROCEDURE  */
    PROGRAM = 619,                 /* PROGRAM  */
    QUOTE = 620,                   /* QUOTE  */
    RANGE = 621,                   /* RANGE  */
    READ = 622,                    /* READ  */
    REAL = 623,                    /* REAL  */
    REASSIGN = 624,                /* REASSIGN  */
    RECHECK = 625,                 /* RECHECK  */
    RECURSIVE = 626,               /* RECURSIVE  */
    REF = 627,                     /* REF  */
    REFERENCES = 628,              /* REFERENCES  */
    REFRESH = 629,                 /* REFRESH  */
    REINDEX = 630,                 /* REINDEX  */
    RELATIVE_P = 631,              /* RELATIVE_P  */
    RELEASE = 632,                 /* RELEASE  */
    RENAME = 633,                  /* RENAME  */
    REPEATABLE = 634,              /* REPEATABLE  */
    REPLACE = 635,                 /* REPLACE  */
    REPLICA = 636,                 /* REPLICA  */
    RESET = 637,                   /* RESET  */
    RESTART = 638,                 /* RESTART  */
    RESTRICT = 639,                /* RESTRICT  */
    RETURNING = 640,               /* RETURNING  */
    RETURNS = 641,                 /* RETURNS  */
    REVOKE = 642,                  /* REVOKE  */
    RIGHT = 643,                   /* RIGHT  */
    ROLE = 644,                    /* ROLE  */
    ROLLBACK = 645,                /* ROLLBACK  */
    ROW = 646,                     /* ROW  */
    ROWS = 647,                    /* ROWS  */
    RULE = 648,                    /* RULE  */
    SAVEPOINT = 649,               /* SAVEPOINT  */
    SCHEMA = 650,                  /* SCHEMA  */
    SCROLL = 651,                  /* SCROLL  */
    SEARCH = 652,                  /* SEARCH  */
    SECOND_P = 653,                /* SECOND_P  */
    SECURITY = 654,                /* SECURITY  */
    SELECT = 655,                  /* SELECT  */
    SEQUENCE = 656,                /* SEQUENCE  */
    SEQUENCES = 657,               /* SEQUENCES  */
    SERIALIZABLE = 658,            /* SERIALIZABLE  */
    SERVER = 659,                  /* SERVER  */
    SESSION = 660,                 /* SESSION  */
    SESSION_USER = 661,            /* SESSION_USER  */
    SET = 662,                     /* SET  */
    SETOF = 663,                   /* SETOF  */
    SHARE = 664,                   /* SHARE  */
    SHOW = 665,                    /* SHOW  */
    SIMILAR = 666,                 /* SIMILAR  */
    SIMPLE = 667,                  /* SIMPLE  */
    SMALLINT = 668,                /* SMALLINT  */
    SNAPSHOT = 669,                /* SNAPSHOT  */
    SOME = 670,                    /* SOME  */
    STABLE = 671,                  /* STABLE  */
    STANDALONE_P = 672,            /* STANDALONE_P  */
    START = 673,                   /* START  */
    STATEMENT = 674,               /* STATEMENT  */
    STATISTICS = 675,              /* STATISTICS  */
    STDIN = 676,                   /* STDIN  */
    STDOUT = 677,                  /* STDOUT  */
    STORAGE = 678,                 /* STORAGE  */
    STRICT_P = 679,                /* STRICT_P  */
    STRIP_P = 680,                 /* STRIP_P  */
    SUBSTRING = 681,               /* SUBSTRING  */
    SYMMETRIC = 682,               /* SYMMETRIC  */
    SYSID = 683,                   /* SYSID  */
    SYSTEM_P = 684,                /* SYSTEM_P  */
    TABLE = 685,                   /* TABLE  */
    TABLES = 686,                  /* TABLES  */
    TABLESPACE = 687,              /* TABLESPACE  */
    TEMP = 688,                    /* TEMP  */
    TEMPLATE = 689,                /* TEMPLATE  */
    TEMPORARY = 690,               /* TEMPORARY  */
    TEXT_P = 691,                  /* TEXT_P  */
    THEN = 692,                    /* THEN  */
    TIME = 693,                    /* TIME  */
    TIMESTAMP = 694,               /* TIMESTAMP  */
    TO = 695,                      /* TO  */
    TRAILING = 696,                /* TRAILING  */
    TRANSACTION = 697,             /* TRANSACTION  */
    TREAT = 698,                   /* TREAT  */
    TRIGGER = 699,                 /* TRIGGER  */
    TRIM = 700,                    /* TRIM  */
    TRUE_P = 701,                  /* TRUE_P  */
    TRUNCATE = 702,                /* TRUNCATE  */
    TRUSTED = 703,                 /* TRUSTED  */
    TYPE_P = 704,                  /* TYPE_P  */
    TYPES_P = 705,                 /* TYPES_P  */
    UNBOUNDED = 706,               /* UNBOUNDED  */
    UNCOMMITTED = 707,             /* UNCOMMITTED  */
    UNENCRYPTED = 708,             /* UNENCRYPTED  */
    UNION = 709,                   /* UNION  */
    UNIQUE = 710,                  /* UNIQUE  */
    UNKNOWN = 711,                 /* UNKNOWN  */
    UNLISTEN = 712,                /* UNLISTEN  */
    UNLOGGED = 713,                /* UNLOGGED  */
    UNTIL = 714,                   /* UNTIL  */
    UPDATE = 715,                  /* UPDATE  */
    USER = 716,                    /* USER  */
    USING = 717,                   /* USING  */
    VACUUM = 718,                  /* VACUUM  */
    VALID = 719,                   /* VALID  */
    VALIDATE = 720,                /* VALIDATE  */
    VALIDATOR = 721,               /* VALIDATOR  */
    VALUE_P = 722,                 /* VALUE_P  */
    VALUES = 723,                  /* VALUES  */
    VARCHAR = 724,                 /* VARCHAR  */
    VARIADIC = 725,                /* VARIADIC  */
    VARYING = 726,                 /* VARYING  */
    VERBOSE = 727,                 /* VERBOSE  */
    VERSION_P = 728,               /* VERSION_P  */
    VIEW = 729,                    /* VIEW  */
    VIEWS = 730,                   /* VIEWS  */
    VOLATILE = 731,                /* VOLATILE  */
    WHEN = 732,                    /* WHEN  */
    WHERE = 733,                   /* WHERE  */
    WHITESPACE_P = 734,            /* WHITESPACE_P  */
    WINDOW = 735,                  /* WINDOW  */
    WITH = 736,                    /* WITH  */
    WITHIN = 737,                  /* WITHIN  */
    WITHOUT = 738,                 /* WITHOUT  */
    WORK = 739,                    /* WORK  */
    WRAPPER = 740,                 /* WRAPPER  */
    WRITE = 741,                   /* WRITE  */
    XML_P = 742,                   /* XML_P  */
    XMLATTRIBUTES = 743,           /* XMLATTRIBUTES  */
    XMLCONCAT = 744,               /* XMLCONCAT  */
    XMLELEMENT = 745,              /* XMLELEMENT  */
    XMLEXISTS = 746,               /* XMLEXISTS  */
    XMLFOREST = 747,               /* XMLFOREST  */
    XMLPARSE = 748,                /* XMLPARSE  */
    XMLPI = 749,                   /* XMLPI  */
    XMLROOT = 750,                 /* XMLROOT  */
    XMLSERIALIZE = 751,            /* XMLSERIALIZE  */
    YEAR_P = 752,                  /* YEAR_P  */
    YES_P = 753,                   /* YES_P  */
    ZONE = 754,                    /* ZONE  */
    ACTIVE = 755,                  /* ACTIVE  */
    CONTAINS = 756,                /* CONTAINS  */
    CPUSET = 757,                  /* CPUSET  */
    CPU_RATE_LIMIT = 758,          /* CPU_RATE_LIMIT  */
    CREATEEXTTABLE = 759,          /* CREATEEXTTABLE  */
    CUBE = 760,                    /* CUBE  */
    DECODE = 761,                  /* DECODE  */
    DENY = 762,                    /* DENY  */
    DISTRIBUTED = 763,             /* DISTRIBUTED  */
    DXL = 764,                     /* DXL  */
    ERRORS = 765,                  /* ERRORS  */
    EVERY = 766,                   /* EVERY  */
    EXCHANGE = 767,                /* EXCHANGE  */
    EXPAND = 768,                  /* EXPAND  */
    FIELDS = 769,                  /* FIELDS  */
    FILL = 770,                    /* FILL  */
    FORMAT = 771,                  /* FORMAT  */
    FULLSCAN = 772,                /* FULLSCAN  */
    GROUP_ID = 773,                /* GROUP_ID  */
    GROUPING = 774,                /* GROUPING  */
    HASH = 775,                    /* HASH  */
    HOST = 776,                    /* HOST  */
    IGNORE_P = 777,                /* IGNORE_P  */
    INCLUSIVE = 778,               /* INCLUSIVE  */
    INITPLAN = 779,                /* INITPLAN  */
    LIST = 780,                    /* LIST  */
    LOG_P = 781,                   /* LOG_P  */
    MASTER = 782,                  /* MASTER  */
    MEDIAN = 783,                  /* MEDIAN  */
    MISSING = 784,                 /* MISSING  */
    MODIFIES = 785,                /* MODIFIES  */
    NEWLINE = 786,                 /* NEWLINE  */
    NOCREATEEXTTABLE = 787,        /* NOCREATEEXTTABLE  */
    NOOVERCOMMIT = 788,            /* NOOVERCOMMIT  */
    ORDERED = 789,                 /* ORDERED  */
    OTHERS = 790,                  /* OTHERS  */
    OVERCOMMIT = 791,              /* OVERCOMMIT  */
    PARTITIONS = 792,              /* PARTITIONS  */
    PERCENT = 793,                 /* PERCENT  */
    PERSISTENTLY = 794,            /* PERSISTENTLY  */
    PROTOCOL = 795,                /* PROTOCOL  */
    QUEUE = 796,                   /* QUEUE  */
    RANDOMLY = 797,                /* RANDOMLY  */
    READABLE = 798,                /* READABLE  */
    READS = 799,                   /* READS  */
    REJECT_P = 800,                /* REJECT_P  */
    REPLICATED = 801,              /* REPLICATED  */
    RESOURCE = 802,                /* RESOURCE  */
    ROLLUP = 803,                  /* ROLLUP  */
    ROOTPARTITION = 804,           /* ROOTPARTITION  */
    SCATTER = 805,                 /* SCATTER  */
    SEGMENT = 806,                 /* SEGMENT  */
    SEGMENTS = 807,                /* SEGMENTS  */
    SETS = 808,                    /* SETS  */
    SPLIT = 809,                   /* SPLIT  */
    SQL = 810,                     /* SQL  */
    SUBPARTITION = 811,            /* SUBPARTITION  */
    THRESHOLD = 812,               /* THRESHOLD  */
    TIES = 813,                    /* TIES  */
    VALIDATION = 814,              /* VALIDATION  */
    WEB = 815,                     /* WEB  */
    WRITABLE = 816,                /* WRITABLE  */
    NULLS_FIRST = 817,             /* NULLS_FIRST  */
    NULLS_LAST = 818,              /* NULLS_LAST  */
    WITH_ORDINALITY = 819,         /* WITH_ORDINALITY  */
    WITH_TIME = 820,               /* WITH_TIME  */
    POSTFIXOP = 821,               /* POSTFIXOP  */
    UMINUS = 822                   /* UMINUS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 579 "preproc.y"

	double	dval;
	char	*str;
	int		ival;
	struct	when		action;
	struct	index		index;
	int		tagname;
	struct	this_type	type;
	enum	ECPGttype	type_enum;
	enum	ECPGdtype	dtype_enum;
	struct	fetch_desc	descriptor;
	struct  su_symbol	struct_union;
	struct	prep		prep;

#line 1281 "preproc.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE base_yylval;
extern YYLTYPE base_yylloc;
int base_yyparse (void);

#endif /* !YY_BASE_YY_PREPROC_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_SQL_ALLOCATE = 3,               /* SQL_ALLOCATE  */
  YYSYMBOL_SQL_AUTOCOMMIT = 4,             /* SQL_AUTOCOMMIT  */
  YYSYMBOL_SQL_BOOL = 5,                   /* SQL_BOOL  */
  YYSYMBOL_SQL_BREAK = 6,                  /* SQL_BREAK  */
  YYSYMBOL_SQL_CALL = 7,                   /* SQL_CALL  */
  YYSYMBOL_SQL_CARDINALITY = 8,            /* SQL_CARDINALITY  */
  YYSYMBOL_SQL_CONNECT = 9,                /* SQL_CONNECT  */
  YYSYMBOL_SQL_COUNT = 10,                 /* SQL_COUNT  */
  YYSYMBOL_SQL_DATETIME_INTERVAL_CODE = 11, /* SQL_DATETIME_INTERVAL_CODE  */
  YYSYMBOL_SQL_DATETIME_INTERVAL_PRECISION = 12, /* SQL_DATETIME_INTERVAL_PRECISION  */
  YYSYMBOL_SQL_DESCRIBE = 13,              /* SQL_DESCRIBE  */
  YYSYMBOL_SQL_DESCRIPTOR = 14,            /* SQL_DESCRIPTOR  */
  YYSYMBOL_SQL_DISCONNECT = 15,            /* SQL_DISCONNECT  */
  YYSYMBOL_SQL_FOUND = 16,                 /* SQL_FOUND  */
  YYSYMBOL_SQL_FREE = 17,                  /* SQL_FREE  */
  YYSYMBOL_SQL_GET = 18,                   /* SQL_GET  */
  YYSYMBOL_SQL_GO = 19,                    /* SQL_GO  */
  YYSYMBOL_SQL_GOTO = 20,                  /* SQL_GOTO  */
  YYSYMBOL_SQL_IDENTIFIED = 21,            /* SQL_IDENTIFIED  */
  YYSYMBOL_SQL_INDICATOR = 22,             /* SQL_INDICATOR  */
  YYSYMBOL_SQL_KEY_MEMBER = 23,            /* SQL_KEY_MEMBER  */
  YYSYMBOL_SQL_LENGTH = 24,                /* SQL_LENGTH  */
  YYSYMBOL_SQL_LONG = 25,                  /* SQL_LONG  */
  YYSYMBOL_SQL_NULLABLE = 26,              /* SQL_NULLABLE  */
  YYSYMBOL_SQL_OCTET_LENGTH = 27,          /* SQL_OCTET_LENGTH  */
  YYSYMBOL_SQL_OPEN = 28,                  /* SQL_OPEN  */
  YYSYMBOL_SQL_OUTPUT = 29,                /* SQL_OUTPUT  */
  YYSYMBOL_SQL_REFERENCE = 30,             /* SQL_REFERENCE  */
  YYSYMBOL_SQL_RETURNED_LENGTH = 31,       /* SQL_RETURNED_LENGTH  */
  YYSYMBOL_SQL_RETURNED_OCTET_LENGTH = 32, /* SQL_RETURNED_OCTET_LENGTH  */
  YYSYMBOL_SQL_SCALE = 33,                 /* SQL_SCALE  */
  YYSYMBOL_SQL_SECTION = 34,               /* SQL_SECTION  */
  YYSYMBOL_SQL_SHORT = 35,                 /* SQL_SHORT  */
  YYSYMBOL_SQL_SIGNED = 36,                /* SQL_SIGNED  */
  YYSYMBOL_SQL_SQL = 37,                   /* SQL_SQL  */
  YYSYMBOL_SQL_SQLERROR = 38,              /* SQL_SQLERROR  */
  YYSYMBOL_SQL_SQLPRINT = 39,              /* SQL_SQLPRINT  */
  YYSYMBOL_SQL_SQLWARNING = 40,            /* SQL_SQLWARNING  */
  YYSYMBOL_SQL_START = 41,                 /* SQL_START  */
  YYSYMBOL_SQL_STOP = 42,                  /* SQL_STOP  */
  YYSYMBOL_SQL_STRUCT = 43,                /* SQL_STRUCT  */
  YYSYMBOL_SQL_UNSIGNED = 44,              /* SQL_UNSIGNED  */
  YYSYMBOL_SQL_VAR = 45,                   /* SQL_VAR  */
  YYSYMBOL_SQL_WHENEVER = 46,              /* SQL_WHENEVER  */
  YYSYMBOL_S_ADD = 47,                     /* S_ADD  */
  YYSYMBOL_S_AND = 48,                     /* S_AND  */
  YYSYMBOL_S_ANYTHING = 49,                /* S_ANYTHING  */
  YYSYMBOL_S_AUTO = 50,                    /* S_AUTO  */
  YYSYMBOL_S_CONST = 51,                   /* S_CONST  */
  YYSYMBOL_S_DEC = 52,                     /* S_DEC  */
  YYSYMBOL_S_DIV = 53,                     /* S_DIV  */
  YYSYMBOL_S_DOTPOINT = 54,                /* S_DOTPOINT  */
  YYSYMBOL_S_EQUAL = 55,                   /* S_EQUAL  */
  YYSYMBOL_S_EXTERN = 56,                  /* S_EXTERN  */
  YYSYMBOL_S_INC = 57,                     /* S_INC  */
  YYSYMBOL_S_LSHIFT = 58,                  /* S_LSHIFT  */
  YYSYMBOL_S_MEMPOINT = 59,                /* S_MEMPOINT  */
  YYSYMBOL_S_MEMBER = 60,                  /* S_MEMBER  */
  YYSYMBOL_S_MOD = 61,                     /* S_MOD  */
  YYSYMBOL_S_MUL = 62,                     /* S_MUL  */
  YYSYMBOL_S_NEQUAL = 63,                  /* S_NEQUAL  */
  YYSYMBOL_S_OR = 64,                      /* S_OR  */
  YYSYMBOL_S_REGISTER = 65,                /* S_REGISTER  */
  YYSYMBOL_S_RSHIFT = 66,                  /* S_RSHIFT  */
  YYSYMBOL_S_STATIC = 67,                  /* S_STATIC  */
  YYSYMBOL_S_SUB = 68,                     /* S_SUB  */
  YYSYMBOL_S_VOLATILE = 69,                /* S_VOLATILE  */
  YYSYMBOL_S_TYPEDEF = 70,                 /* S_TYPEDEF  */
  YYSYMBOL_CSTRING = 71,                   /* CSTRING  */
  YYSYMBOL_CVARIABLE = 72,                 /* CVARIABLE  */
  YYSYMBOL_CPP_LINE = 73,                  /* CPP_LINE  */
  YYSYMBOL_IP = 74,                        /* IP  */
  YYSYMBOL_DOLCONST = 75,                  /* DOLCONST  */
  YYSYMBOL_ECONST = 76,                    /* ECONST  */
  YYSYMBOL_NCONST = 77,                    /* NCONST  */
  YYSYMBOL_UCONST = 78,                    /* UCONST  */
  YYSYMBOL_UIDENT = 79,                    /* UIDENT  */
  YYSYMBOL_IDENT = 80,                     /* IDENT  */
  YYSYMBOL_FCONST = 81,                    /* FCONST  */
  YYSYMBOL_SCONST = 82,                    /* SCONST  */
  YYSYMBOL_BCONST = 83,                    /* BCONST  */
  YYSYMBOL_XCONST = 84,                    /* XCONST  */
  YYSYMBOL_Op = 85,                        /* Op  */
  YYSYMBOL_ICONST = 86,                    /* ICONST  */
  YYSYMBOL_PARAM = 87,                     /* PARAM  */
  YYSYMBOL_TYPECAST = 88,                  /* TYPECAST  */
  YYSYMBOL_DOT_DOT = 89,                   /* DOT_DOT  */
  YYSYMBOL_COLON_EQUALS = 90,              /* COLON_EQUALS  */
  YYSYMBOL_ABORT_P = 91,                   /* ABORT_P  */
  YYSYMBOL_ABSOLUTE_P = 92,                /* ABSOLUTE_P  */
  YYSYMBOL_ACCESS = 93,                    /* ACCESS  */
  YYSYMBOL_ACTION = 94,                    /* ACTION  */
  YYSYMBOL_ADD_P = 95,                     /* ADD_P  */
  YYSYMBOL_ADMIN = 96,                     /* ADMIN  */
  YYSYMBOL_AFTER = 97,                     /* AFTER  */
  YYSYMBOL_AGGREGATE = 98,                 /* AGGREGATE  */
  YYSYMBOL_ALL = 99,                       /* ALL  */
  YYSYMBOL_ALSO = 100,                     /* ALSO  */
  YYSYMBOL_ALTER = 101,                    /* ALTER  */
  YYSYMBOL_ALWAYS = 102,                   /* ALWAYS  */
  YYSYMBOL_ANALYSE = 103,                  /* ANALYSE  */
  YYSYMBOL_ANALYZE = 104,                  /* ANALYZE  */
  YYSYMBOL_AND = 105,                      /* AND  */
  YYSYMBOL_ANY = 106,                      /* ANY  */
  YYSYMBOL_ARRAY = 107,                    /* ARRAY  */
  YYSYMBOL_AS = 108,                       /* AS  */
  YYSYMBOL_ASC = 109,                      /* ASC  */
  YYSYMBOL_ASSERTION = 110,                /* ASSERTION  */
  YYSYMBOL_ASSIGNMENT = 111,               /* ASSIGNMENT  */
  YYSYMBOL_ASYMMETRIC = 112,               /* ASYMMETRIC  */
  YYSYMBOL_AT = 113,                       /* AT  */
  YYSYMBOL_ATTRIBUTE = 114,                /* ATTRIBUTE  */
  YYSYMBOL_AUTHORIZATION = 115,            /* AUTHORIZATION  */
  YYSYMBOL_BACKWARD = 116,                 /* BACKWARD  */
  YYSYMBOL_BEFORE = 117,                   /* BEFORE  */
  YYSYMBOL_BEGIN_P = 118,                  /* BEGIN_P  */
  YYSYMBOL_BETWEEN = 119,                  /* BETWEEN  */
  YYSYMBOL_BIGINT = 120,                   /* BIGINT  */
  YYSYMBOL_BINARY = 121,                   /* BINARY  */
  YYSYMBOL_BIT = 122,                      /* BIT  */
  YYSYMBOL_BOOLEAN_P = 123,                /* BOOLEAN_P  */
  YYSYMBOL_BOTH = 124,                     /* BOTH  */
  YYSYMBOL_BY = 125,                       /* BY  */
  YYSYMBOL_CACHE = 126,                    /* CACHE  */
  YYSYMBOL_CALLED = 127,                   /* CALLED  */
  YYSYMBOL_CASCADE = 128,                  /* CASCADE  */
  YYSYMBOL_CASCADED = 129,                 /* CASCADED  */
  YYSYMBOL_CASE = 130,                     /* CASE  */
  YYSYMBOL_CAST = 131,                     /* CAST  */
  YYSYMBOL_CATALOG_P = 132,                /* CATALOG_P  */
  YYSYMBOL_CHAIN = 133,                    /* CHAIN  */
  YYSYMBOL_CHAR_P = 134,                   /* CHAR_P  */
  YYSYMBOL_CHARACTER = 135,                /* CHARACTER  */
  YYSYMBOL_CHARACTERISTICS = 136,          /* CHARACTERISTICS  */
  YYSYMBOL_CHECK = 137,                    /* CHECK  */
  YYSYMBOL_CHECKPOINT = 138,               /* CHECKPOINT  */
  YYSYMBOL_CLASS = 139,                    /* CLASS  */
  YYSYMBOL_CLOSE = 140,                    /* CLOSE  */
  YYSYMBOL_CLUSTER = 141,                  /* CLUSTER  */
  YYSYMBOL_COALESCE = 142,                 /* COALESCE  */
  YYSYMBOL_COLLATE = 143,                  /* COLLATE  */
  YYSYMBOL_COLLATION = 144,                /* COLLATION  */
  YYSYMBOL_COLUMN = 145,                   /* COLUMN  */
  YYSYMBOL_COMMENT = 146,                  /* COMMENT  */
  YYSYMBOL_COMMENTS = 147,                 /* COMMENTS  */
  YYSYMBOL_COMMIT = 148,                   /* COMMIT  */
  YYSYMBOL_COMMITTED = 149,                /* COMMITTED  */
  YYSYMBOL_CONCURRENCY = 150,              /* CONCURRENCY  */
  YYSYMBOL_CONCURRENTLY = 151,             /* CONCURRENTLY  */
  YYSYMBOL_CONFIGURATION = 152,            /* CONFIGURATION  */
  YYSYMBOL_CONNECTION = 153,               /* CONNECTION  */
  YYSYMBOL_CONSTRAINT = 154,               /* CONSTRAINT  */
  YYSYMBOL_CONSTRAINTS = 155,              /* CONSTRAINTS  */
  YYSYMBOL_CONTENT_P = 156,                /* CONTENT_P  */
  YYSYMBOL_CONTINUE_P = 157,               /* CONTINUE_P  */
  YYSYMBOL_CONVERSION_P = 158,             /* CONVERSION_P  */
  YYSYMBOL_COPY = 159,                     /* COPY  */
  YYSYMBOL_COST = 160,                     /* COST  */
  YYSYMBOL_CREATE = 161,                   /* CREATE  */
  YYSYMBOL_CROSS = 162,                    /* CROSS  */
  YYSYMBOL_CSV = 163,                      /* CSV  */
  YYSYMBOL_CURRENT_P = 164,                /* CURRENT_P  */
  YYSYMBOL_CURRENT_CATALOG = 165,          /* CURRENT_CATALOG  */
  YYSYMBOL_CURRENT_DATE = 166,             /* CURRENT_DATE  */
  YYSYMBOL_CURRENT_ROLE = 167,             /* CURRENT_ROLE  */
  YYSYMBOL_CURRENT_SCHEMA = 168,           /* CURRENT_SCHEMA  */
  YYSYMBOL_CURRENT_TIME = 169,             /* CURRENT_TIME  */
  YYSYMBOL_CURRENT_TIMESTAMP = 170,        /* CURRENT_TIMESTAMP  */
  YYSYMBOL_CURRENT_USER = 171,             /* CURRENT_USER  */
  YYSYMBOL_CURSOR = 172,                   /* CURSOR  */
  YYSYMBOL_CYCLE = 173,                    /* CYCLE  */
  YYSYMBOL_DATA_P = 174,                   /* DATA_P  */
  YYSYMBOL_DATABASE = 175,                 /* DATABASE  */
  YYSYMBOL_DAY_P = 176,                    /* DAY_P  */
  YYSYMBOL_DEALLOCATE = 177,               /* DEALLOCATE  */
  YYSYMBOL_DEC = 178,                      /* DEC  */
  YYSYMBOL_DECIMAL_P = 179,                /* DECIMAL_P  */
  YYSYMBOL_DECLARE = 180,                  /* DECLARE  */
  YYSYMBOL_DEFAULT = 181,                  /* DEFAULT  */
  YYSYMBOL_DEFAULTS = 182,                 /* DEFAULTS  */
  YYSYMBOL_DEFERRABLE = 183,               /* DEFERRABLE  */
  YYSYMBOL_DEFERRED = 184,                 /* DEFERRED  */
  YYSYMBOL_DEFINER = 185,                  /* DEFINER  */
  YYSYMBOL_DELETE_P = 186,                 /* DELETE_P  */
  YYSYMBOL_DELIMITER = 187,                /* DELIMITER  */
  YYSYMBOL_DELIMITERS = 188,               /* DELIMITERS  */
  YYSYMBOL_DESC = 189,                     /* DESC  */
  YYSYMBOL_DICTIONARY = 190,               /* DICTIONARY  */
  YYSYMBOL_DISABLE_P = 191,                /* DISABLE_P  */
  YYSYMBOL_DISCARD = 192,                  /* DISCARD  */
  YYSYMBOL_DISTINCT = 193,                 /* DISTINCT  */
  YYSYMBOL_DO = 194,                       /* DO  */
  YYSYMBOL_DOCUMENT_P = 195,               /* DOCUMENT_P  */
  YYSYMBOL_DOMAIN_P = 196,                 /* DOMAIN_P  */
  YYSYMBOL_DOUBLE_P = 197,                 /* DOUBLE_P  */
  YYSYMBOL_DROP = 198,                     /* DROP  */
  YYSYMBOL_EACH = 199,                     /* EACH  */
  YYSYMBOL_ELSE = 200,                     /* ELSE  */
  YYSYMBOL_ENABLE_P = 201,                 /* ENABLE_P  */
  YYSYMBOL_ENCODING = 202,                 /* ENCODING  */
  YYSYMBOL_ENCRYPTED = 203,                /* ENCRYPTED  */
  YYSYMBOL_END_P = 204,                    /* END_P  */
  YYSYMBOL_ENUM_P = 205,                   /* ENUM_P  */
  YYSYMBOL_ESCAPE = 206,                   /* ESCAPE  */
  YYSYMBOL_EVENT = 207,                    /* EVENT  */
  YYSYMBOL_EXCEPT = 208,                   /* EXCEPT  */
  YYSYMBOL_EXCLUDE = 209,                  /* EXCLUDE  */
  YYSYMBOL_EXCLUDING = 210,                /* EXCLUDING  */
  YYSYMBOL_EXCLUSIVE = 211,                /* EXCLUSIVE  */
  YYSYMBOL_EXECUTE = 212,                  /* EXECUTE  */
  YYSYMBOL_EXISTS = 213,                   /* EXISTS  */
  YYSYMBOL_EXPLAIN = 214,                  /* EXPLAIN  */
  YYSYMBOL_EXTENSION = 215,                /* EXTENSION  */
  YYSYMBOL_EXTERNAL = 216,                 /* EXTERNAL  */
  YYSYMBOL_EXTRACT = 217,                  /* EXTRACT  */
  YYSYMBOL_FALSE_P = 218,                  /* FALSE_P  */
  YYSYMBOL_FAMILY = 219,                   /* FAMILY  */
  YYSYMBOL_FETCH = 220,                    /* FETCH  */
  YYSYMBOL_FILTER = 221,                   /* FILTER  */
  YYSYMBOL_FIRST_P = 222,                  /* FIRST_P  */
  YYSYMBOL_FLOAT_P = 223,                  /* FLOAT_P  */
  YYSYMBOL_FOLLOWING = 224,                /* FOLLOWING  */
  YYSYMBOL_FOR = 225,                      /* FOR  */
  YYSYMBOL_FORCE = 226,                    /* FORCE  */
  YYSYMBOL_FOREIGN = 227,                  /* FOREIGN  */
  YYSYMBOL_FORWARD = 228,                  /* FORWARD  */
  YYSYMBOL_FREEZE = 229,                   /* FREEZE  */
  YYSYMBOL_FROM = 230,                     /* FROM  */
  YYSYMBOL_FULL = 231,                     /* FULL  */
  YYSYMBOL_FUNCTION = 232,                 /* FUNCTION  */
  YYSYMBOL_FUNCTIONS = 233,                /* FUNCTIONS  */
  YYSYMBOL_GLOBAL = 234,                   /* GLOBAL  */
  YYSYMBOL_GRANT = 235,                    /* GRANT  */
  YYSYMBOL_GRANTED = 236,                  /* GRANTED  */
  YYSYMBOL_GREATEST = 237,                 /* GREATEST  */
  YYSYMBOL_GROUP_P = 238,                  /* GROUP_P  */
  YYSYMBOL_HANDLER = 239,                  /* HANDLER  */
  YYSYMBOL_HAVING = 240,                   /* HAVING  */
  YYSYMBOL_HEADER_P = 241,                 /* HEADER_P  */
  YYSYMBOL_HOLD = 242,                     /* HOLD  */
  YYSYMBOL_HOUR_P = 243,                   /* HOUR_P  */
  YYSYMBOL_IDENTITY_P = 244,               /* IDENTITY_P  */
  YYSYMBOL_IF_P = 245,                     /* IF_P  */
  YYSYMBOL_ILIKE = 246,                    /* ILIKE  */
  YYSYMBOL_IMMEDIATE = 247,                /* IMMEDIATE  */
  YYSYMBOL_IMMUTABLE = 248,                /* IMMUTABLE  */
  YYSYMBOL_IMPLICIT_P = 249,               /* IMPLICIT_P  */
  YYSYMBOL_IN_P = 250,                     /* IN_P  */
  YYSYMBOL_INCLUDING = 251,                /* INCLUDING  */
  YYSYMBOL_INCREMENT = 252,                /* INCREMENT  */
  YYSYMBOL_INDEX = 253,                    /* INDEX  */
  YYSYMBOL_INDEXES = 254,                  /* INDEXES  */
  YYSYMBOL_INHERIT = 255,                  /* INHERIT  */
  YYSYMBOL_INHERITS = 256,                 /* INHERITS  */
  YYSYMBOL_INITIALLY = 257,                /* INITIALLY  */
  YYSYMBOL_INLINE_P = 258,                 /* INLINE_P  */
  YYSYMBOL_INNER_P = 259,                  /* INNER_P  */
  YYSYMBOL_INOUT = 260,                    /* INOUT  */
  YYSYMBOL_INPUT_P = 261,                  /* INPUT_P  */
  YYSYMBOL_INSENSITIVE = 262,              /* INSENSITIVE  */
  YYSYMBOL_INSERT = 263,                   /* INSERT  */
  YYSYMBOL_INSTEAD = 264,                  /* INSTEAD  */
  YYSYMBOL_INT_P = 265,                    /* INT_P  */
  YYSYMBOL_INTEGER = 266,                  /* INTEGER  */
  YYSYMBOL_INTERSECT = 267,                /* INTERSECT  */
  YYSYMBOL_INTERVAL = 268,                 /* INTERVAL  */
  YYSYMBOL_INTO = 269,                     /* INTO  */
  YYSYMBOL_INVOKER = 270,                  /* INVOKER  */
  YYSYMBOL_IS = 271,                       /* IS  */
  YYSYMBOL_ISNULL = 272,                   /* ISNULL  */
  YYSYMBOL_ISOLATION = 273,                /* ISOLATION  */
  YYSYMBOL_JOIN = 274,                     /* JOIN  */
  YYSYMBOL_KEY = 275,                      /* KEY  */
  YYSYMBOL_LABEL = 276,                    /* LABEL  */
  YYSYMBOL_LANGUAGE = 277,                 /* LANGUAGE  */
  YYSYMBOL_LARGE_P = 278,                  /* LARGE_P  */
  YYSYMBOL_LAST_P = 279,                   /* LAST_P  */
  YYSYMBOL_LATERAL_P = 280,                /* LATERAL_P  */
  YYSYMBOL_LC_COLLATE_P = 281,             /* LC_COLLATE_P  */
  YYSYMBOL_LC_CTYPE_P = 282,               /* LC_CTYPE_P  */
  YYSYMBOL_LEADING = 283,                  /* LEADING  */
  YYSYMBOL_LEAKPROOF = 284,                /* LEAKPROOF  */
  YYSYMBOL_LEAST = 285,                    /* LEAST  */
  YYSYMBOL_LEFT = 286,                     /* LEFT  */
  YYSYMBOL_LEVEL = 287,                    /* LEVEL  */
  YYSYMBOL_LIKE = 288,                     /* LIKE  */
  YYSYMBOL_LIMIT = 289,                    /* LIMIT  */
  YYSYMBOL_LISTEN = 290,                   /* LISTEN  */
  YYSYMBOL_LOAD = 291,                     /* LOAD  */
  YYSYMBOL_LOCAL = 292,                    /* LOCAL  */
  YYSYMBOL_LOCALTIME = 293,                /* LOCALTIME  */
  YYSYMBOL_LOCALTIMESTAMP = 294,           /* LOCALTIMESTAMP  */
  YYSYMBOL_LOCATION = 295,                 /* LOCATION  */
  YYSYMBOL_LOCK_P = 296,                   /* LOCK_P  */
  YYSYMBOL_MAPPING = 297,                  /* MAPPING  */
  YYSYMBOL_MATCH = 298,                    /* MATCH  */
  YYSYMBOL_MATERIALIZED = 299,             /* MATERIALIZED  */
  YYSYMBOL_MAXVALUE = 300,                 /* MAXVALUE  */
  YYSYMBOL_MEMORY_LIMIT = 301,             /* MEMORY_LIMIT  */
  YYSYMBOL_MEMORY_SHARED_QUOTA = 302,      /* MEMORY_SHARED_QUOTA  */
  YYSYMBOL_MEMORY_SPILL_RATIO = 303,       /* MEMORY_SPILL_RATIO  */
  YYSYMBOL_MINUTE_P = 304,                 /* MINUTE_P  */
  YYSYMBOL_MINVALUE = 305,                 /* MINVALUE  */
  YYSYMBOL_MODE = 306,                     /* MODE  */
  YYSYMBOL_MONTH_P = 307,                  /* MONTH_P  */
  YYSYMBOL_MOVE = 308,                     /* MOVE  */
  YYSYMBOL_NAME_P = 309,                   /* NAME_P  */
  YYSYMBOL_NAMES = 310,                    /* NAMES  */
  YYSYMBOL_NATIONAL = 311,                 /* NATIONAL  */
  YYSYMBOL_NATURAL = 312,                  /* NATURAL  */
  YYSYMBOL_NCHAR = 313,                    /* NCHAR  */
  YYSYMBOL_NEXT = 314,                     /* NEXT  */
  YYSYMBOL_NO = 315,                       /* NO  */
  YYSYMBOL_NONE = 316,                     /* NONE  */
  YYSYMBOL_NOT = 317,                      /* NOT  */
  YYSYMBOL_NOTHING = 318,                  /* NOTHING  */
  YYSYMBOL_NOTIFY = 319,                   /* NOTIFY  */
  YYSYMBOL_NOTNULL = 320,                  /* NOTNULL  */
  YYSYMBOL_NOWAIT = 321,                   /* NOWAIT  */
  YYSYMBOL_NULL_P = 322,                   /* NULL_P  */
  YYSYMBOL_NULLIF = 323,                   /* NULLIF  */
  YYSYMBOL_NULLS_P = 324,                  /* NULLS_P  */
  YYSYMBOL_NUMERIC = 325,                  /* NUMERIC  */
  YYSYMBOL_OBJECT_P = 326,                 /* OBJECT_P  */
  YYSYMBOL_OF = 327,                       /* OF  */
  YYSYMBOL_OFF = 328,                      /* OFF  */
  YYSYMBOL_OFFSET = 329,                   /* OFFSET  */
  YYSYMBOL_OIDS = 330,                     /* OIDS  */
  YYSYMBOL_ON = 331,                       /* ON  */
  YYSYMBOL_ONLY = 332,                     /* ONLY  */
  YYSYMBOL_OPERATOR = 333,                 /* OPERATOR  */
  YYSYMBOL_OPTION = 334,                   /* OPTION  */
  YYSYMBOL_OPTIONS = 335,                  /* OPTIONS  */
  YYSYMBOL_OR = 336,                       /* OR  */
  YYSYMBOL_ORDER = 337,                    /* ORDER  */
  YYSYMBOL_ORDINALITY = 338,               /* ORDINALITY  */
  YYSYMBOL_OUT_P = 339,                    /* OUT_P  */
  YYSYMBOL_OUTER_P = 340,                  /* OUTER_P  */
  YYSYMBOL_OVER = 341,                     /* OVER  */
  YYSYMBOL_OVERLAPS = 342,                 /* OVERLAPS  */
  YYSYMBOL_OVERLAY = 343,                  /* OVERLAY  */
  YYSYMBOL_OWNED = 344,                    /* OWNED  */
  YYSYMBOL_OWNER = 345,                    /* OWNER  */
  YYSYMBOL_PARSER = 346,                   /* PARSER  */
  YYSYMBOL_PARTIAL = 347,                  /* PARTIAL  */
  YYSYMBOL_PARTITION = 348,                /* PARTITION  */
  YYSYMBOL_PASSING = 349,                  /* PASSING  */
  YYSYMBOL_PASSWORD = 350,                 /* PASSWORD  */
  YYSYMBOL_PLACING = 351,                  /* PLACING  */
  YYSYMBOL_PLANS = 352,                    /* PLANS  */
  YYSYMBOL_POSITION = 353,                 /* POSITION  */
  YYSYMBOL_PRECEDING = 354,                /* PRECEDING  */
  YYSYMBOL_PRECISION = 355,                /* PRECISION  */
  YYSYMBOL_PRESERVE = 356,                 /* PRESERVE  */
  YYSYMBOL_PREPARE = 357,                  /* PREPARE  */
  YYSYMBOL_PREPARED = 358,                 /* PREPARED  */
  YYSYMBOL_PRIMARY = 359,                  /* PRIMARY  */
  YYSYMBOL_PRIOR = 360,                    /* PRIOR  */
  YYSYMBOL_PRIVILEGES = 361,               /* PRIVILEGES  */
  YYSYMBOL_PROCEDURAL = 362,               /* PROCEDURAL  */
  YYSYMBOL_PROCEDURE = 363,                /* PROCEDURE  */
  YYSYMBOL_PROGRAM = 364,                  /* PROGRAM  */
  YYSYMBOL_QUOTE = 365,                    /* QUOTE  */
  YYSYMBOL_RANGE = 366,                    /* RANGE  */
  YYSYMBOL_READ = 367,                     /* READ  */
  YYSYMBOL_REAL = 368,                     /* REAL  */
  YYSYMBOL_REASSIGN = 369,                 /* REASSIGN  */
  YYSYMBOL_RECHECK = 370,                  /* RECHECK  */
  YYSYMBOL_RECURSIVE = 371,                /* RECURSIVE  */
  YYSYMBOL_REF = 372,                      /* REF  */
  YYSYMBOL_REFERENCES = 373,               /* REFERENCES  */
  YYSYMBOL_REFRESH = 374,                  /* REFRESH  */
  YYSYMBOL_REINDEX = 375,                  /* REINDEX  */
  YYSYMBOL_RELATIVE_P = 376,               /* RELATIVE_P  */
  YYSYMBOL_RELEASE = 377,                  /* RELEASE  */
  YYSYMBOL_RENAME = 378,                   /* RENAME  */
  YYSYMBOL_REPEATABLE = 379,               /* REPEATABLE  */
  YYSYMBOL_REPLACE = 380,                  /* REPLACE  */
  YYSYMBOL_REPLICA = 381,                  /* REPLICA  */
  YYSYMBOL_RESET = 382,                    /* RESET  */
  YYSYMBOL_RESTART = 383,                  /* RESTART  */
  YYSYMBOL_RESTRICT = 384,                 /* RESTRICT  */
  YYSYMBOL_RETURNING = 385,                /* RETURNING  */
  YYSYMBOL_RETURNS = 386,                  /* RETURNS  */
  YYSYMBOL_REVOKE = 387,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 388,                    /* RIGHT  */
  YYSYMBOL_ROLE = 389,                     /* ROLE  */
  YYSYMBOL_ROLLBACK = 390,                 /* ROLLBACK  */
  YYSYMBOL_ROW = 391,                      /* ROW  */
  YYSYMBOL_ROWS = 392,                     /* ROWS  */
  YYSYMBOL_RULE = 393,                     /* RULE  */
  YYSYMBOL_SAVEPOINT = 394,                /* SAVEPOINT  */
  YYSYMBOL_SCHEMA = 395,                   /* SCHEMA  */
  YYSYMBOL_SCROLL = 396,                   /* SCROLL  */
  YYSYMBOL_SEARCH = 397,                   /* SEARCH  */
  YYSYMBOL_SECOND_P = 398,                 /* SECOND_P  */
  YYSYMBOL_SECURITY = 399,                 /* SECURITY  */
  YYSYMBOL_SELECT = 400,                   /* SELECT  */
  YYSYMBOL_SEQUENCE = 401,                 /* SEQUENCE  */
  YYSYMBOL_SEQUENCES = 402,                /* SEQUENCES  */
  YYSYMBOL_SERIALIZABLE = 403,             /* SERIALIZABLE  */
  YYSYMBOL_SERVER = 404,                   /* SERVER  */
  YYSYMBOL_SESSION = 405,                  /* SESSION  */
  YYSYMBOL_SESSION_USER = 406,             /* SESSION_USER  */
  YYSYMBOL_SET = 407,                      /* SET  */
  YYSYMBOL_SETOF = 408,                    /* SETOF  */
  YYSYMBOL_SHARE = 409,                    /* SHARE  */
  YYSYMBOL_SHOW = 410,                     /* SHOW  */
  YYSYMBOL_SIMILAR = 411,                  /* SIMILAR  */
  YYSYMBOL_SIMPLE = 412,                   /* SIMPLE  */
  YYSYMBOL_SMALLINT = 413,                 /* SMALLINT  */
  YYSYMBOL_SNAPSHOT = 414,                 /* SNAPSHOT  */
  YYSYMBOL_SOME = 415,                     /* SOME  */
  YYSYMBOL_STABLE = 416,                   /* STABLE  */
  YYSYMBOL_STANDALONE_P = 417,             /* STANDALONE_P  */
  YYSYMBOL_START = 418,                    /* START  */
  YYSYMBOL_STATEMENT = 419,                /* STATEMENT  */
  YYSYMBOL_STATISTICS = 420,               /* STATISTICS  */
  YYSYMBOL_STDIN = 421,                    /* STDIN  */
  YYSYMBOL_STDOUT = 422,                   /* STDOUT  */
  YYSYMBOL_STORAGE = 423,                  /* STORAGE  */
  YYSYMBOL_STRICT_P = 424,                 /* STRICT_P  */
  YYSYMBOL_STRIP_P = 425,                  /* STRIP_P  */
  YYSYMBOL_SUBSTRING = 426,                /* SUBSTRING  */
  YYSYMBOL_SYMMETRIC = 427,                /* SYMMETRIC  */
  YYSYMBOL_SYSID = 428,                    /* SYSID  */
  YYSYMBOL_SYSTEM_P = 429,                 /* SYSTEM_P  */
  YYSYMBOL_TABLE = 430,                    /* TABLE  */
  YYSYMBOL_TABLES = 431,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 432,               /* TABLESPACE  */
  YYSYMBOL_TEMP = 433,                     /* TEMP  */
  YYSYMBOL_TEMPLATE = 434,                 /* TEMPLATE  */
  YYSYMBOL_TEMPORARY = 435,                /* TEMPORARY  */
  YYSYMBOL_TEXT_P = 436,                   /* TEXT_P  */
  YYSYMBOL_THEN = 437,                     /* THEN  */
  YYSYMBOL_TIME = 438,                     /* TIME  */
  YYSYMBOL_TIMESTAMP = 439,                /* TIMESTAMP  */
  YYSYMBOL_TO = 440,                       /* TO  */
  YYSYMBOL_TRAILING = 441,                 /* TRAILING  */
  YYSYMBOL_TRANSACTION = 442,              /* TRANSACTION  */
  YYSYMBOL_TREAT = 443,                    /* TREAT  */
  YYSYMBOL_TRIGGER = 444,                  /* TRIGGER  */
  YYSYMBOL_TRIM = 445,                     /* TRIM  */
  YYSYMBOL_TRUE_P = 446,                   /* TRUE_P  */
  YYSYMBOL_TRUNCATE = 447,                 /* TRUNCATE  */
  YYSYMBOL_TRUSTED = 448,                  /* TRUSTED  */
  YYSYMBOL_TYPE_P = 449,                   /* TYPE_P  */
  YYSYMBOL_TYPES_P = 450,                  /* TYPES_P  */
  YYSYMBOL_UNBOUNDED = 451,                /* UNBOUNDED  */
  YYSYMBOL_UNCOMMITTED = 452,              /* UNCOMMITTED  */
  YYSYMBOL_UNENCRYPTED = 453,              /* UNENCRYPTED  */
  YYSYMBOL_UNION = 454,                    /* UNION  */
  YYSYMBOL_UNIQUE = 455,                   /* UNIQUE  */
  YYSYMBOL_UNKNOWN = 456,                  /* UNKNOWN  */
  YYSYMBOL_UNLISTEN = 457,                 /* UNLISTEN  */
  YYSYMBOL_UNLOGGED = 458,                 /* UNLOGGED  */
  YYSYMBOL_UNTIL = 459,                    /* UNTIL  */
  YYSYMBOL_UPDATE = 460,                   /* UPDATE  */
  YYSYMBOL_USER = 461,                     /* USER  */
  YYSYMBOL_USING = 462,                    /* USING  */
  YYSYMBOL_VACUUM = 463,                   /* VACUUM  */
  YYSYMBOL_VALID = 464,                    /* VALID  */
  YYSYMBOL_VALIDATE = 465,                 /* VALIDATE  */
  YYSYMBOL_VALIDATOR = 466,                /* VALIDATOR  */
  YYSYMBOL_VALUE_P = 467,                  /* VALUE_P  */
  YYSYMBOL_VALUES = 468,                   /* VALUES  */
  YYSYMBOL_VARCHAR = 469,                  /* VARCHAR  */
  YYSYMBOL_VARIADIC = 470,                 /* VARIADIC  */
  YYSYMBOL_VARYING = 471,                  /* VARYING  */
  YYSYMBOL_VERBOSE = 472,                  /* VERBOSE  */
  YYSYMBOL_VERSION_P = 473,                /* VERSION_P  */
  YYSYMBOL_VIEW = 474,                     /* VIEW  */
  YYSYMBOL_VIEWS = 475,                    /* VIEWS  */
  YYSYMBOL_VOLATILE = 476,                 /* VOLATILE  */
  YYSYMBOL_WHEN = 477,                     /* WHEN  */
  YYSYMBOL_WHERE = 478,                    /* WHERE  */
  YYSYMBOL_WHITESPACE_P = 479,             /* WHITESPACE_P  */
  YYSYMBOL_WINDOW = 480,                   /* WINDOW  */
  YYSYMBOL_WITH = 481,                     /* WITH  */
  YYSYMBOL_WITHIN = 482,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 483,                  /* WITHOUT  */
  YYSYMBOL_WORK = 484,                     /* WORK  */
  YYSYMBOL_WRAPPER = 485,                  /* WRAPPER  */
  YYSYMBOL_WRITE = 486,                    /* WRITE  */
  YYSYMBOL_XML_P = 487,                    /* XML_P  */
  YYSYMBOL_XMLATTRIBUTES = 488,            /* XMLATTRIBUTES  */
  YYSYMBOL_XMLCONCAT = 489,                /* XMLCONCAT  */
  YYSYMBOL_XMLELEMENT = 490,               /* XMLELEMENT  */
  YYSYMBOL_XMLEXISTS = 491,                /* XMLEXISTS  */
  YYSYMBOL_XMLFOREST = 492,                /* XMLFOREST  */
  YYSYMBOL_XMLPARSE = 493,                 /* XMLPARSE  */
  YYSYMBOL_XMLPI = 494,                    /* XMLPI  */
  YYSYMBOL_XMLROOT = 495,                  /* XMLROOT  */
  YYSYMBOL_XMLSERIALIZE = 496,             /* XMLSERIALIZE  */
  YYSYMBOL_YEAR_P = 497,                   /* YEAR_P  */
  YYSYMBOL_YES_P = 498,                    /* YES_P  */
  YYSYMBOL_ZONE = 499,                     /* ZONE  */
  YYSYMBOL_ACTIVE = 500,                   /* ACTIVE  */
  YYSYMBOL_CONTAINS = 501,                 /* CONTAINS  */
  YYSYMBOL_CPUSET = 502,                   /* CPUSET  */
  YYSYMBOL_CPU_RATE_LIMIT = 503,           /* CPU_RATE_LIMIT  */
  YYSYMBOL_CREATEEXTTABLE = 504,           /* CREATEEXTTABLE  */
  YYSYMBOL_CUBE = 505,                     /* CUBE  */
  YYSYMBOL_DECODE = 506,                   /* DECODE  */
  YYSYMBOL_DENY = 507,                     /* DENY  */
  YYSYMBOL_DISTRIBUTED = 508,              /* DISTRIBUTED  */
  YYSYMBOL_DXL = 509,                      /* DXL  */
  YYSYMBOL_ERRORS = 510,                   /* ERRORS  */
  YYSYMBOL_EVERY = 511,                    /* EVERY  */
  YYSYMBOL_EXCHANGE = 512,                 /* EXCHANGE  */
  YYSYMBOL_EXPAND = 513,                   /* EXPAND  */
  YYSYMBOL_FIELDS = 514,                   /* FIELDS  */
  YYSYMBOL_FILL = 515,                     /* FILL  */
  YYSYMBOL_FORMAT = 516,                   /* FORMAT  */
  YYSYMBOL_FULLSCAN = 517,                 /* FULLSCAN  */
  YYSYMBOL_GROUP_ID = 518,                 /* GROUP_ID  */
  YYSYMBOL_GROUPING = 519,                 /* GROUPING  */
  YYSYMBOL_HASH = 520,                     /* HASH  */
  YYSYMBOL_HOST = 521,                     /* HOST  */
  YYSYMBOL_IGNORE_P = 522,                 /* IGNORE_P  */
  YYSYMBOL_INCLUSIVE = 523,                /* INCLUSIVE  */
  YYSYMBOL_INITPLAN = 524,                 /* INITPLAN  */
  YYSYMBOL_LIST = 525,                     /* LIST  */
  YYSYMBOL_LOG_P = 526,                    /* LOG_P  */
  YYSYMBOL_MASTER = 527,                   /* MASTER  */
  YYSYMBOL_MEDIAN = 528,                   /* MEDIAN  */
  YYSYMBOL_MISSING = 529,                  /* MISSING  */
  YYSYMBOL_MODIFIES = 530,                 /* MODIFIES  */
  YYSYMBOL_NEWLINE = 531,                  /* NEWLINE  */
  YYSYMBOL_NOCREATEEXTTABLE = 532,         /* NOCREATEEXTTABLE  */
  YYSYMBOL_NOOVERCOMMIT = 533,             /* NOOVERCOMMIT  */
  YYSYMBOL_ORDERED = 534,                  /* ORDERED  */
  YYSYMBOL_OTHERS = 535,                   /* OTHERS  */
  YYSYMBOL_OVERCOMMIT = 536,               /* OVERCOMMIT  */
  YYSYMBOL_PARTITIONS = 537,               /* PARTITIONS  */
  YYSYMBOL_PERCENT = 538,                  /* PERCENT  */
  YYSYMBOL_PERSISTENTLY = 539,             /* PERSISTENTLY  */
  YYSYMBOL_PROTOCOL = 540,                 /* PROTOCOL  */
  YYSYMBOL_QUEUE = 541,                    /* QUEUE  */
  YYSYMBOL_RANDOMLY = 542,                 /* RANDOMLY  */
  YYSYMBOL_READABLE = 543,                 /* READABLE  */
  YYSYMBOL_READS = 544,                    /* READS  */
  YYSYMBOL_REJECT_P = 545,                 /* REJECT_P  */
  YYSYMBOL_REPLICATED = 546,               /* REPLICATED  */
  YYSYMBOL_RESOURCE = 547,                 /* RESOURCE  */
  YYSYMBOL_ROLLUP = 548,                   /* ROLLUP  */
  YYSYMBOL_ROOTPARTITION = 549,            /* ROOTPARTITION  */
  YYSYMBOL_SCATTER = 550,                  /* SCATTER  */
  YYSYMBOL_SEGMENT = 551,                  /* SEGMENT  */
  YYSYMBOL_SEGMENTS = 552,                 /* SEGMENTS  */
  YYSYMBOL_SETS = 553,                     /* SETS  */
  YYSYMBOL_SPLIT = 554,                    /* SPLIT  */
  YYSYMBOL_SQL = 555,                      /* SQL  */
  YYSYMBOL_SUBPARTITION = 556,             /* SUBPARTITION  */
  YYSYMBOL_THRESHOLD = 557,                /* THRESHOLD  */
  YYSYMBOL_TIES = 558,                     /* TIES  */
  YYSYMBOL_VALIDATION = 559,               /* VALIDATION  */
  YYSYMBOL_WEB = 560,                      /* WEB  */
  YYSYMBOL_WRITABLE = 561,                 /* WRITABLE  */
  YYSYMBOL_NULLS_FIRST = 562,              /* NULLS_FIRST  */
  YYSYMBOL_NULLS_LAST = 563,               /* NULLS_LAST  */
  YYSYMBOL_WITH_ORDINALITY = 564,          /* WITH_ORDINALITY  */
  YYSYMBOL_WITH_TIME = 565,                /* WITH_TIME  */
  YYSYMBOL_566_ = 566,                     /* '='  */
  YYSYMBOL_567_ = 567,                     /* '<'  */
  YYSYMBOL_568_ = 568,                     /* '>'  */
  YYSYMBOL_POSTFIXOP = 569,                /* POSTFIXOP  */
  YYSYMBOL_570_ = 570,                     /* '+'  */
  YYSYMBOL_571_ = 571,                     /* '-'  */
  YYSYMBOL_572_ = 572,                     /* '*'  */
  YYSYMBOL_573_ = 573,                     /* '/'  */
  YYSYMBOL_574_ = 574,                     /* '%'  */
  YYSYMBOL_575_ = 575,                     /* '^'  */
  YYSYMBOL_UMINUS = 576,                   /* UMINUS  */
  YYSYMBOL_577_ = 577,                     /* '['  */
  YYSYMBOL_578_ = 578,                     /* ']'  */
  YYSYMBOL_579_ = 579,                     /* '('  */
  YYSYMBOL_580_ = 580,                     /* ')'  */
  YYSYMBOL_581_ = 581,                     /* '.'  */
  YYSYMBOL_582_ = 582,                     /* ','  */
  YYSYMBOL_583_ = 583,                     /* ';'  */
  YYSYMBOL_584_ = 584,                     /* ':'  */
  YYSYMBOL_585_ = 585,                     /* '{'  */
  YYSYMBOL_586_ = 586,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 587,                 /* $accept  */
  YYSYMBOL_prog = 588,                     /* prog  */
  YYSYMBOL_stmt = 589,                     /* stmt  */
  YYSYMBOL_CreateQueueStmt = 590,          /* CreateQueueStmt  */
  YYSYMBOL_OptQueueList = 591,             /* OptQueueList  */
  YYSYMBOL_OptQueueElem = 592,             /* OptQueueElem  */
  YYSYMBOL_AlterQueueStmt = 593,           /* AlterQueueStmt  */
  YYSYMBOL_DropQueueStmt = 594,            /* DropQueueStmt  */
  YYSYMBOL_CreateResourceGroupStmt = 595,  /* CreateResourceGroupStmt  */
  YYSYMBOL_DropResourceGroupStmt = 596,    /* DropResourceGroupStmt  */
  YYSYMBOL_AlterResourceGroupStmt = 597,   /* AlterResourceGroupStmt  */
  YYSYMBOL_OptResourceGroupList = 598,     /* OptResourceGroupList  */
  YYSYMBOL_OptResourceGroupElem = 599,     /* OptResourceGroupElem  */
  YYSYMBOL_CreateRoleStmt = 600,           /* CreateRoleStmt  */
  YYSYMBOL_opt_with = 601,                 /* opt_with  */
  YYSYMBOL_OptRoleList = 602,              /* OptRoleList  */
  YYSYMBOL_AlterOptRoleList = 603,         /* AlterOptRoleList  */
  YYSYMBOL_AlterOnlyOptRoleElem = 604,     /* AlterOnlyOptRoleElem  */
  YYSYMBOL_AlterOptRoleElem = 605,         /* AlterOptRoleElem  */
  YYSYMBOL_CreateOptRoleElem = 606,        /* CreateOptRoleElem  */
  YYSYMBOL_deny_login_role = 607,          /* deny_login_role  */
  YYSYMBOL_deny_interval = 608,            /* deny_interval  */
  YYSYMBOL_deny_day_specifier = 609,       /* deny_day_specifier  */
  YYSYMBOL_deny_point = 610,               /* deny_point  */
  YYSYMBOL_opt_time = 611,                 /* opt_time  */
  YYSYMBOL_exttab_auth_list = 612,         /* exttab_auth_list  */
  YYSYMBOL_keyvalue_list = 613,            /* keyvalue_list  */
  YYSYMBOL_keyvalue_pair = 614,            /* keyvalue_pair  */
  YYSYMBOL_CreateUserStmt = 615,           /* CreateUserStmt  */
  YYSYMBOL_AlterRoleStmt = 616,            /* AlterRoleStmt  */
  YYSYMBOL_opt_in_database = 617,          /* opt_in_database  */
  YYSYMBOL_AlterRoleSetStmt = 618,         /* AlterRoleSetStmt  */
  YYSYMBOL_AlterUserStmt = 619,            /* AlterUserStmt  */
  YYSYMBOL_AlterUserSetStmt = 620,         /* AlterUserSetStmt  */
  YYSYMBOL_DropRoleStmt = 621,             /* DropRoleStmt  */
  YYSYMBOL_DropUserStmt = 622,             /* DropUserStmt  */
  YYSYMBOL_CreateGroupStmt = 623,          /* CreateGroupStmt  */
  YYSYMBOL_AlterGroupStmt = 624,           /* AlterGroupStmt  */
  YYSYMBOL_add_drop = 625,                 /* add_drop  */
  YYSYMBOL_DropGroupStmt = 626,            /* DropGroupStmt  */
  YYSYMBOL_CreateSchemaStmt = 627,         /* CreateSchemaStmt  */
  YYSYMBOL_OptSchemaName = 628,            /* OptSchemaName  */
  YYSYMBOL_OptSchemaEltList = 629,         /* OptSchemaEltList  */
  YYSYMBOL_schema_stmt = 630,              /* schema_stmt  */
  YYSYMBOL_VariableSetStmt = 631,          /* VariableSetStmt  */
  YYSYMBOL_set_rest = 632,                 /* set_rest  */
  YYSYMBOL_generic_set = 633,              /* generic_set  */
  YYSYMBOL_set_rest_more = 634,            /* set_rest_more  */
  YYSYMBOL_var_name = 635,                 /* var_name  */
  YYSYMBOL_var_list = 636,                 /* var_list  */
  YYSYMBOL_var_value = 637,                /* var_value  */
  YYSYMBOL_iso_level = 638,                /* iso_level  */
  YYSYMBOL_opt_boolean_or_string = 639,    /* opt_boolean_or_string  */
  YYSYMBOL_zone_value = 640,               /* zone_value  */
  YYSYMBOL_opt_encoding = 641,             /* opt_encoding  */
  YYSYMBOL_NonReservedWord_or_Sconst = 642, /* NonReservedWord_or_Sconst  */
  YYSYMBOL_VariableResetStmt = 643,        /* VariableResetStmt  */
  YYSYMBOL_reset_rest = 644,               /* reset_rest  */
  YYSYMBOL_generic_reset = 645,            /* generic_reset  */
  YYSYMBOL_SetResetClause = 646,           /* SetResetClause  */
  YYSYMBOL_FunctionSetResetClause = 647,   /* FunctionSetResetClause  */
  YYSYMBOL_VariableShowStmt = 648,         /* VariableShowStmt  */
  YYSYMBOL_ConstraintsSetStmt = 649,       /* ConstraintsSetStmt  */
  YYSYMBOL_constraints_set_list = 650,     /* constraints_set_list  */
  YYSYMBOL_constraints_set_mode = 651,     /* constraints_set_mode  */
  YYSYMBOL_CheckPointStmt = 652,           /* CheckPointStmt  */
  YYSYMBOL_DiscardStmt = 653,              /* DiscardStmt  */
  YYSYMBOL_AlterTableStmt = 654,           /* AlterTableStmt  */
  YYSYMBOL_alter_table_cmds = 655,         /* alter_table_cmds  */
  YYSYMBOL_alter_table_cmd = 656,          /* alter_table_cmd  */
  YYSYMBOL_alter_column_default = 657,     /* alter_column_default  */
  YYSYMBOL_opt_drop_behavior = 658,        /* opt_drop_behavior  */
  YYSYMBOL_opt_collate_clause = 659,       /* opt_collate_clause  */
  YYSYMBOL_alter_using = 660,              /* alter_using  */
  YYSYMBOL_replica_identity = 661,         /* replica_identity  */
  YYSYMBOL_reloptions = 662,               /* reloptions  */
  YYSYMBOL_opt_reloptions = 663,           /* opt_reloptions  */
  YYSYMBOL_reloption_list = 664,           /* reloption_list  */
  YYSYMBOL_reloption_elem = 665,           /* reloption_elem  */
  YYSYMBOL_opt_table_partition_split_into = 666, /* opt_table_partition_split_into  */
  YYSYMBOL_opt_table_partition_exchange_validate = 667, /* opt_table_partition_exchange_validate  */
  YYSYMBOL_alter_table_partition_id_spec = 668, /* alter_table_partition_id_spec  */
  YYSYMBOL_alter_table_partition_id_spec_with_opt_default = 669, /* alter_table_partition_id_spec_with_opt_default  */
  YYSYMBOL_alter_table_partition_cmd = 670, /* alter_table_partition_cmd  */
  YYSYMBOL_AlterCompositeTypeStmt = 671,   /* AlterCompositeTypeStmt  */
  YYSYMBOL_alter_type_cmds = 672,          /* alter_type_cmds  */
  YYSYMBOL_alter_type_cmd = 673,           /* alter_type_cmd  */
  YYSYMBOL_ClosePortalStmt = 674,          /* ClosePortalStmt  */
  YYSYMBOL_CopyStmt = 675,                 /* CopyStmt  */
  YYSYMBOL_copy_from = 676,                /* copy_from  */
  YYSYMBOL_opt_program = 677,              /* opt_program  */
  YYSYMBOL_skip_external_partition = 678,  /* skip_external_partition  */
  YYSYMBOL_copy_file_name = 679,           /* copy_file_name  */
  YYSYMBOL_copy_options = 680,             /* copy_options  */
  YYSYMBOL_copy_opt_list = 681,            /* copy_opt_list  */
  YYSYMBOL_copy_opt_item = 682,            /* copy_opt_item  */
  YYSYMBOL_opt_binary = 683,               /* opt_binary  */
  YYSYMBOL_opt_oids = 684,                 /* opt_oids  */
  YYSYMBOL_copy_delimiter = 685,           /* copy_delimiter  */
  YYSYMBOL_opt_using = 686,                /* opt_using  */
  YYSYMBOL_copy_generic_opt_list = 687,    /* copy_generic_opt_list  */
  YYSYMBOL_copy_generic_opt_elem = 688,    /* copy_generic_opt_elem  */
  YYSYMBOL_copy_generic_opt_arg = 689,     /* copy_generic_opt_arg  */
  YYSYMBOL_copy_generic_opt_arg_list = 690, /* copy_generic_opt_arg_list  */
  YYSYMBOL_copy_generic_opt_arg_list_item = 691, /* copy_generic_opt_arg_list_item  */
  YYSYMBOL_CreateStmt = 692,               /* CreateStmt  */
  YYSYMBOL_OptTemp = 693,                  /* OptTemp  */
  YYSYMBOL_OptTableElementList = 694,      /* OptTableElementList  */
  YYSYMBOL_OptTypedTableElementList = 695, /* OptTypedTableElementList  */
  YYSYMBOL_TableElementList = 696,         /* TableElementList  */
  YYSYMBOL_TypedTableElementList = 697,    /* TypedTableElementList  */
  YYSYMBOL_TableElement = 698,             /* TableElement  */
  YYSYMBOL_TypedTableElement = 699,        /* TypedTableElement  */
  YYSYMBOL_column_reference_storage_directive = 700, /* column_reference_storage_directive  */
  YYSYMBOL_columnDef = 701,                /* columnDef  */
  YYSYMBOL_columnOptions = 702,            /* columnOptions  */
  YYSYMBOL_ColQualList = 703,              /* ColQualList  */
  YYSYMBOL_ColConstraint = 704,            /* ColConstraint  */
  YYSYMBOL_opt_storage_encoding = 705,     /* opt_storage_encoding  */
  YYSYMBOL_ColConstraintElem = 706,        /* ColConstraintElem  */
  YYSYMBOL_ConstraintAttr = 707,           /* ConstraintAttr  */
  YYSYMBOL_TableLikeClause = 708,          /* TableLikeClause  */
  YYSYMBOL_TableLikeOptionList = 709,      /* TableLikeOptionList  */
  YYSYMBOL_TableLikeOption = 710,          /* TableLikeOption  */
  YYSYMBOL_TableConstraint = 711,          /* TableConstraint  */
  YYSYMBOL_ConstraintElem = 712,           /* ConstraintElem  */
  YYSYMBOL_opt_no_inherit = 713,           /* opt_no_inherit  */
  YYSYMBOL_opt_column_list = 714,          /* opt_column_list  */
  YYSYMBOL_columnList = 715,               /* columnList  */
  YYSYMBOL_columnElem = 716,               /* columnElem  */
  YYSYMBOL_distributed_by_list = 717,      /* distributed_by_list  */
  YYSYMBOL_distributed_by_elem = 718,      /* distributed_by_elem  */
  YYSYMBOL_key_match = 719,                /* key_match  */
  YYSYMBOL_ExclusionConstraintList = 720,  /* ExclusionConstraintList  */
  YYSYMBOL_ExclusionConstraintElem = 721,  /* ExclusionConstraintElem  */
  YYSYMBOL_ExclusionWhereClause = 722,     /* ExclusionWhereClause  */
  YYSYMBOL_key_actions = 723,              /* key_actions  */
  YYSYMBOL_key_update = 724,               /* key_update  */
  YYSYMBOL_key_delete = 725,               /* key_delete  */
  YYSYMBOL_key_action = 726,               /* key_action  */
  YYSYMBOL_OptInherit = 727,               /* OptInherit  */
  YYSYMBOL_OptWith = 728,                  /* OptWith  */
  YYSYMBOL_OnCommitOption = 729,           /* OnCommitOption  */
  YYSYMBOL_OptTableSpace = 730,            /* OptTableSpace  */
  YYSYMBOL_OptConsTableSpace = 731,        /* OptConsTableSpace  */
  YYSYMBOL_ExistingIndex = 732,            /* ExistingIndex  */
  YYSYMBOL_DistributedBy = 733,            /* DistributedBy  */
  YYSYMBOL_OptDistributedBy = 734,         /* OptDistributedBy  */
  YYSYMBOL_OptTabPartitionColumnEncList = 735, /* OptTabPartitionColumnEncList  */
  YYSYMBOL_TabPartitionColumnEncList = 736, /* TabPartitionColumnEncList  */
  YYSYMBOL_OptTabPartitionStorageAttr = 737, /* OptTabPartitionStorageAttr  */
  YYSYMBOL_OptTabPartitionSpec = 738,      /* OptTabPartitionSpec  */
  YYSYMBOL_OptTabSubPartitionSpec = 739,   /* OptTabSubPartitionSpec  */
  YYSYMBOL_TabPartitionElemList = 740,     /* TabPartitionElemList  */
  YYSYMBOL_TabSubPartitionElemList = 741,  /* TabSubPartitionElemList  */
  YYSYMBOL_tab_part_val_no_paran = 742,    /* tab_part_val_no_paran  */
  YYSYMBOL_tab_part_val = 743,             /* tab_part_val  */
  YYSYMBOL_TabPartitionBoundarySpecValList = 744, /* TabPartitionBoundarySpecValList  */
  YYSYMBOL_OptTabPartitionRangeInclusive = 745, /* OptTabPartitionRangeInclusive  */
  YYSYMBOL_TabPartitionBoundarySpecStart = 746, /* TabPartitionBoundarySpecStart  */
  YYSYMBOL_TabPartitionBoundarySpecEnd = 747, /* TabPartitionBoundarySpecEnd  */
  YYSYMBOL_OptTabPartitionBoundarySpecEvery = 748, /* OptTabPartitionBoundarySpecEvery  */
  YYSYMBOL_OptTabPartitionBoundarySpecEnd = 749, /* OptTabPartitionBoundarySpecEnd  */
  YYSYMBOL_TabPartitionBoundarySpec = 750, /* TabPartitionBoundarySpec  */
  YYSYMBOL_OptTabPartitionBoundarySpec = 751, /* OptTabPartitionBoundarySpec  */
  YYSYMBOL_multi_spec_value_list = 752,    /* multi_spec_value_list  */
  YYSYMBOL_part_values_single = 753,       /* part_values_single  */
  YYSYMBOL_part_values_clause = 754,       /* part_values_clause  */
  YYSYMBOL_part_values_or_spec_list = 755, /* part_values_or_spec_list  */
  YYSYMBOL_TabPartitionElem = 756,         /* TabPartitionElem  */
  YYSYMBOL_TabSubPartitionElem = 757,      /* TabSubPartitionElem  */
  YYSYMBOL_TabPartitionNameDecl = 758,     /* TabPartitionNameDecl  */
  YYSYMBOL_TabPartitionDefaultNameDecl = 759, /* TabPartitionDefaultNameDecl  */
  YYSYMBOL_TabSubPartitionNameDecl = 760,  /* TabSubPartitionNameDecl  */
  YYSYMBOL_TabSubPartitionDefaultNameDecl = 761, /* TabSubPartitionDefaultNameDecl  */
  YYSYMBOL_TabPartitionByType = 762,       /* TabPartitionByType  */
  YYSYMBOL_OptTabPartitionBy = 763,        /* OptTabPartitionBy  */
  YYSYMBOL_TabSubPartitionTemplate = 764,  /* TabSubPartitionTemplate  */
  YYSYMBOL_opt_list_subparts = 765,        /* opt_list_subparts  */
  YYSYMBOL_TabSubPartitionBy = 766,        /* TabSubPartitionBy  */
  YYSYMBOL_TabSubPartition = 767,          /* TabSubPartition  */
  YYSYMBOL_create_as_target = 768,         /* create_as_target  */
  YYSYMBOL_opt_with_data = 769,            /* opt_with_data  */
  YYSYMBOL_CreateExternalStmt = 770,       /* CreateExternalStmt  */
  YYSYMBOL_OptWritable = 771,              /* OptWritable  */
  YYSYMBOL_OptWeb = 772,                   /* OptWeb  */
  YYSYMBOL_ExtTypedesc = 773,              /* ExtTypedesc  */
  YYSYMBOL_ext_on_clause_list = 774,       /* ext_on_clause_list  */
  YYSYMBOL_ext_on_clause_item = 775,       /* ext_on_clause_item  */
  YYSYMBOL_format_opt = 776,               /* format_opt  */
  YYSYMBOL_format_opt_list = 777,          /* format_opt_list  */
  YYSYMBOL_format_def_list = 778,          /* format_def_list  */
  YYSYMBOL_format_def_item = 779,          /* format_def_item  */
  YYSYMBOL_format_opt_item = 780,          /* format_opt_item  */
  YYSYMBOL_ext_options_opt = 781,          /* ext_options_opt  */
  YYSYMBOL_ext_options = 782,              /* ext_options  */
  YYSYMBOL_ext_options_list = 783,         /* ext_options_list  */
  YYSYMBOL_ext_options_item = 784,         /* ext_options_item  */
  YYSYMBOL_OptExtTableElementList = 785,   /* OptExtTableElementList  */
  YYSYMBOL_ExtTableElementList = 786,      /* ExtTableElementList  */
  YYSYMBOL_ExtTableElement = 787,          /* ExtTableElement  */
  YYSYMBOL_ExtcolumnDef = 788,             /* ExtcolumnDef  */
  YYSYMBOL_OptSingleRowErrorHandling = 789, /* OptSingleRowErrorHandling  */
  YYSYMBOL_OptLogErrorTable = 790,         /* OptLogErrorTable  */
  YYSYMBOL_ExtSingleRowErrorHandling = 791, /* ExtSingleRowErrorHandling  */
  YYSYMBOL_ExtLogErrorTable = 792,         /* ExtLogErrorTable  */
  YYSYMBOL_OptSrehLimitType = 793,         /* OptSrehLimitType  */
  YYSYMBOL_ext_opt_encoding_list = 794,    /* ext_opt_encoding_list  */
  YYSYMBOL_ext_opt_encoding_item = 795,    /* ext_opt_encoding_item  */
  YYSYMBOL_CreateMatViewStmt = 796,        /* CreateMatViewStmt  */
  YYSYMBOL_create_mv_target = 797,         /* create_mv_target  */
  YYSYMBOL_OptNoLog = 798,                 /* OptNoLog  */
  YYSYMBOL_RefreshMatViewStmt = 799,       /* RefreshMatViewStmt  */
  YYSYMBOL_CreateSeqStmt = 800,            /* CreateSeqStmt  */
  YYSYMBOL_AlterSeqStmt = 801,             /* AlterSeqStmt  */
  YYSYMBOL_OptSeqOptList = 802,            /* OptSeqOptList  */
  YYSYMBOL_SeqOptList = 803,               /* SeqOptList  */
  YYSYMBOL_SeqOptElem = 804,               /* SeqOptElem  */
  YYSYMBOL_opt_by = 805,                   /* opt_by  */
  YYSYMBOL_NumericOnly = 806,              /* NumericOnly  */
  YYSYMBOL_NumericOnly_list = 807,         /* NumericOnly_list  */
  YYSYMBOL_CreatePLangStmt = 808,          /* CreatePLangStmt  */
  YYSYMBOL_opt_trusted = 809,              /* opt_trusted  */
  YYSYMBOL_handler_name = 810,             /* handler_name  */
  YYSYMBOL_opt_inline_handler = 811,       /* opt_inline_handler  */
  YYSYMBOL_validator_clause = 812,         /* validator_clause  */
  YYSYMBOL_opt_validator = 813,            /* opt_validator  */
  YYSYMBOL_DropPLangStmt = 814,            /* DropPLangStmt  */
  YYSYMBOL_opt_procedural = 815,           /* opt_procedural  */
  YYSYMBOL_CreateTableSpaceStmt = 816,     /* CreateTableSpaceStmt  */
  YYSYMBOL_OptTableSpaceOwner = 817,       /* OptTableSpaceOwner  */
  YYSYMBOL_DropTableSpaceStmt = 818,       /* DropTableSpaceStmt  */
  YYSYMBOL_CreateExtensionStmt = 819,      /* CreateExtensionStmt  */
  YYSYMBOL_create_extension_opt_list = 820, /* create_extension_opt_list  */
  YYSYMBOL_create_extension_opt_item = 821, /* create_extension_opt_item  */
  YYSYMBOL_AlterExtensionStmt = 822,       /* AlterExtensionStmt  */
  YYSYMBOL_alter_extension_opt_list = 823, /* alter_extension_opt_list  */
  YYSYMBOL_alter_extension_opt_item = 824, /* alter_extension_opt_item  */
  YYSYMBOL_AlterExtensionContentsStmt = 825, /* AlterExtensionContentsStmt  */
  YYSYMBOL_CreateFdwStmt = 826,            /* CreateFdwStmt  */
  YYSYMBOL_fdw_option = 827,               /* fdw_option  */
  YYSYMBOL_fdw_options = 828,              /* fdw_options  */
  YYSYMBOL_opt_fdw_options = 829,          /* opt_fdw_options  */
  YYSYMBOL_DropFdwStmt = 830,              /* DropFdwStmt  */
  YYSYMBOL_AlterFdwStmt = 831,             /* AlterFdwStmt  */
  YYSYMBOL_create_generic_options = 832,   /* create_generic_options  */
  YYSYMBOL_generic_option_list = 833,      /* generic_option_list  */
  YYSYMBOL_alter_generic_options = 834,    /* alter_generic_options  */
  YYSYMBOL_alter_generic_option_list = 835, /* alter_generic_option_list  */
  YYSYMBOL_alter_generic_option_elem = 836, /* alter_generic_option_elem  */
  YYSYMBOL_generic_option_elem = 837,      /* generic_option_elem  */
  YYSYMBOL_generic_option_name = 838,      /* generic_option_name  */
  YYSYMBOL_generic_option_arg = 839,       /* generic_option_arg  */
  YYSYMBOL_CreateForeignServerStmt = 840,  /* CreateForeignServerStmt  */
  YYSYMBOL_opt_type = 841,                 /* opt_type  */
  YYSYMBOL_foreign_server_version = 842,   /* foreign_server_version  */
  YYSYMBOL_opt_foreign_server_version = 843, /* opt_foreign_server_version  */
  YYSYMBOL_DropForeignServerStmt = 844,    /* DropForeignServerStmt  */
  YYSYMBOL_AlterForeignServerStmt = 845,   /* AlterForeignServerStmt  */
  YYSYMBOL_CreateForeignTableStmt = 846,   /* CreateForeignTableStmt  */
  YYSYMBOL_AlterForeignTableStmt = 847,    /* AlterForeignTableStmt  */
  YYSYMBOL_CreateUserMappingStmt = 848,    /* CreateUserMappingStmt  */
  YYSYMBOL_auth_ident = 849,               /* auth_ident  */
  YYSYMBOL_DropUserMappingStmt = 850,      /* DropUserMappingStmt  */
  YYSYMBOL_AlterUserMappingStmt = 851,     /* AlterUserMappingStmt  */
  YYSYMBOL_CreateTrigStmt = 852,           /* CreateTrigStmt  */
  YYSYMBOL_TriggerActionTime = 853,        /* TriggerActionTime  */
  YYSYMBOL_TriggerEvents = 854,            /* TriggerEvents  */
  YYSYMBOL_TriggerOneEvent = 855,          /* TriggerOneEvent  */
  YYSYMBOL_TriggerForSpec = 856,           /* TriggerForSpec  */
  YYSYMBOL_TriggerForOptEach = 857,        /* TriggerForOptEach  */
  YYSYMBOL_TriggerForType = 858,           /* TriggerForType  */
  YYSYMBOL_TriggerWhen = 859,              /* TriggerWhen  */
  YYSYMBOL_TriggerFuncArgs = 860,          /* TriggerFuncArgs  */
  YYSYMBOL_TriggerFuncArg = 861,           /* TriggerFuncArg  */
  YYSYMBOL_OptConstrFromTable = 862,       /* OptConstrFromTable  */
  YYSYMBOL_ConstraintAttributeSpec = 863,  /* ConstraintAttributeSpec  */
  YYSYMBOL_ConstraintAttributeElem = 864,  /* ConstraintAttributeElem  */
  YYSYMBOL_DropTrigStmt = 865,             /* DropTrigStmt  */
  YYSYMBOL_CreateEventTrigStmt = 866,      /* CreateEventTrigStmt  */
  YYSYMBOL_event_trigger_when_list = 867,  /* event_trigger_when_list  */
  YYSYMBOL_event_trigger_when_item = 868,  /* event_trigger_when_item  */
  YYSYMBOL_event_trigger_value_list = 869, /* event_trigger_value_list  */
  YYSYMBOL_AlterEventTrigStmt = 870,       /* AlterEventTrigStmt  */
  YYSYMBOL_enable_trigger = 871,           /* enable_trigger  */
  YYSYMBOL_CreateAssertStmt = 872,         /* CreateAssertStmt  */
  YYSYMBOL_DropAssertStmt = 873,           /* DropAssertStmt  */
  YYSYMBOL_DefineStmt = 874,               /* DefineStmt  */
  YYSYMBOL_opt_ordered = 875,              /* opt_ordered  */
  YYSYMBOL_definition = 876,               /* definition  */
  YYSYMBOL_def_list = 877,                 /* def_list  */
  YYSYMBOL_def_elem = 878,                 /* def_elem  */
  YYSYMBOL_def_arg = 879,                  /* def_arg  */
  YYSYMBOL_old_aggr_definition = 880,      /* old_aggr_definition  */
  YYSYMBOL_old_aggr_list = 881,            /* old_aggr_list  */
  YYSYMBOL_old_aggr_elem = 882,            /* old_aggr_elem  */
  YYSYMBOL_opt_enum_val_list = 883,        /* opt_enum_val_list  */
  YYSYMBOL_enum_val_list = 884,            /* enum_val_list  */
  YYSYMBOL_AlterEnumStmt = 885,            /* AlterEnumStmt  */
  YYSYMBOL_opt_if_not_exists = 886,        /* opt_if_not_exists  */
  YYSYMBOL_CreateOpClassStmt = 887,        /* CreateOpClassStmt  */
  YYSYMBOL_opclass_item_list = 888,        /* opclass_item_list  */
  YYSYMBOL_opclass_item = 889,             /* opclass_item  */
  YYSYMBOL_opt_default = 890,              /* opt_default  */
  YYSYMBOL_opt_opfamily = 891,             /* opt_opfamily  */
  YYSYMBOL_opclass_purpose = 892,          /* opclass_purpose  */
  YYSYMBOL_opt_recheck = 893,              /* opt_recheck  */
  YYSYMBOL_CreateOpFamilyStmt = 894,       /* CreateOpFamilyStmt  */
  YYSYMBOL_AlterOpFamilyStmt = 895,        /* AlterOpFamilyStmt  */
  YYSYMBOL_opclass_drop_list = 896,        /* opclass_drop_list  */
  YYSYMBOL_opclass_drop = 897,             /* opclass_drop  */
  YYSYMBOL_DropOpClassStmt = 898,          /* DropOpClassStmt  */
  YYSYMBOL_DropOpFamilyStmt = 899,         /* DropOpFamilyStmt  */
  YYSYMBOL_DropOwnedStmt = 900,            /* DropOwnedStmt  */
  YYSYMBOL_ReassignOwnedStmt = 901,        /* ReassignOwnedStmt  */
  YYSYMBOL_DropStmt = 902,                 /* DropStmt  */
  YYSYMBOL_drop_type = 903,                /* drop_type  */
  YYSYMBOL_any_name_list = 904,            /* any_name_list  */
  YYSYMBOL_any_name = 905,                 /* any_name  */
  YYSYMBOL_attrs = 906,                    /* attrs  */
  YYSYMBOL_TruncateStmt = 907,             /* TruncateStmt  */
  YYSYMBOL_opt_restart_seqs = 908,         /* opt_restart_seqs  */
  YYSYMBOL_CommentStmt = 909,              /* CommentStmt  */
  YYSYMBOL_comment_type = 910,             /* comment_type  */
  YYSYMBOL_comment_text = 911,             /* comment_text  */
  YYSYMBOL_SecLabelStmt = 912,             /* SecLabelStmt  */
  YYSYMBOL_opt_provider = 913,             /* opt_provider  */
  YYSYMBOL_security_label_type = 914,      /* security_label_type  */
  YYSYMBOL_security_label = 915,           /* security_label  */
  YYSYMBOL_FetchStmt = 916,                /* FetchStmt  */
  YYSYMBOL_fetch_args = 917,               /* fetch_args  */
  YYSYMBOL_from_in = 918,                  /* from_in  */
  YYSYMBOL_opt_from_in = 919,              /* opt_from_in  */
  YYSYMBOL_GrantStmt = 920,                /* GrantStmt  */
  YYSYMBOL_RevokeStmt = 921,               /* RevokeStmt  */
  YYSYMBOL_privileges = 922,               /* privileges  */
  YYSYMBOL_privilege_list = 923,           /* privilege_list  */
  YYSYMBOL_privilege = 924,                /* privilege  */
  YYSYMBOL_privilege_target = 925,         /* privilege_target  */
  YYSYMBOL_grantee_list = 926,             /* grantee_list  */
  YYSYMBOL_grantee = 927,                  /* grantee  */
  YYSYMBOL_opt_grant_grant_option = 928,   /* opt_grant_grant_option  */
  YYSYMBOL_function_with_argtypes_list = 929, /* function_with_argtypes_list  */
  YYSYMBOL_function_with_argtypes = 930,   /* function_with_argtypes  */
  YYSYMBOL_GrantRoleStmt = 931,            /* GrantRoleStmt  */
  YYSYMBOL_RevokeRoleStmt = 932,           /* RevokeRoleStmt  */
  YYSYMBOL_opt_grant_admin_option = 933,   /* opt_grant_admin_option  */
  YYSYMBOL_opt_granted_by = 934,           /* opt_granted_by  */
  YYSYMBOL_AlterDefaultPrivilegesStmt = 935, /* AlterDefaultPrivilegesStmt  */
  YYSYMBOL_DefACLOptionList = 936,         /* DefACLOptionList  */
  YYSYMBOL_DefACLOption = 937,             /* DefACLOption  */
  YYSYMBOL_DefACLAction = 938,             /* DefACLAction  */
  YYSYMBOL_defacl_privilege_target = 939,  /* defacl_privilege_target  */
  YYSYMBOL_IndexStmt = 940,                /* IndexStmt  */
  YYSYMBOL_opt_unique = 941,               /* opt_unique  */
  YYSYMBOL_opt_concurrently = 942,         /* opt_concurrently  */
  YYSYMBOL_opt_index_name = 943,           /* opt_index_name  */
  YYSYMBOL_access_method_clause = 944,     /* access_method_clause  */
  YYSYMBOL_index_params = 945,             /* index_params  */
  YYSYMBOL_index_elem = 946,               /* index_elem  */
  YYSYMBOL_opt_collate = 947,              /* opt_collate  */
  YYSYMBOL_opt_class = 948,                /* opt_class  */
  YYSYMBOL_opt_asc_desc = 949,             /* opt_asc_desc  */
  YYSYMBOL_opt_nulls_order = 950,          /* opt_nulls_order  */
  YYSYMBOL_CreateFunctionStmt = 951,       /* CreateFunctionStmt  */
  YYSYMBOL_opt_or_replace = 952,           /* opt_or_replace  */
  YYSYMBOL_func_args = 953,                /* func_args  */
  YYSYMBOL_func_args_list = 954,           /* func_args_list  */
  YYSYMBOL_func_args_with_defaults = 955,  /* func_args_with_defaults  */
  YYSYMBOL_func_args_with_defaults_list = 956, /* func_args_with_defaults_list  */
  YYSYMBOL_func_arg = 957,                 /* func_arg  */
  YYSYMBOL_arg_class = 958,                /* arg_class  */
  YYSYMBOL_param_name = 959,               /* param_name  */
  YYSYMBOL_func_return = 960,              /* func_return  */
  YYSYMBOL_func_type = 961,                /* func_type  */
  YYSYMBOL_func_arg_with_default = 962,    /* func_arg_with_default  */
  YYSYMBOL_aggr_arg = 963,                 /* aggr_arg  */
  YYSYMBOL_aggr_args = 964,                /* aggr_args  */
  YYSYMBOL_aggr_args_list = 965,           /* aggr_args_list  */
  YYSYMBOL_createfunc_opt_list = 966,      /* createfunc_opt_list  */
  YYSYMBOL_common_func_opt_item = 967,     /* common_func_opt_item  */
  YYSYMBOL_createfunc_opt_item = 968,      /* createfunc_opt_item  */
  YYSYMBOL_func_as = 969,                  /* func_as  */
  YYSYMBOL_opt_definition = 970,           /* opt_definition  */
  YYSYMBOL_table_func_column = 971,        /* table_func_column  */
  YYSYMBOL_table_func_column_list = 972,   /* table_func_column_list  */
  YYSYMBOL_AlterFunctionStmt = 973,        /* AlterFunctionStmt  */
  YYSYMBOL_alterfunc_opt_list = 974,       /* alterfunc_opt_list  */
  YYSYMBOL_opt_restrict = 975,             /* opt_restrict  */
  YYSYMBOL_RemoveFuncStmt = 976,           /* RemoveFuncStmt  */
  YYSYMBOL_RemoveAggrStmt = 977,           /* RemoveAggrStmt  */
  YYSYMBOL_RemoveOperStmt = 978,           /* RemoveOperStmt  */
  YYSYMBOL_oper_argtypes = 979,            /* oper_argtypes  */
  YYSYMBOL_any_operator = 980,             /* any_operator  */
  YYSYMBOL_DoStmt = 981,                   /* DoStmt  */
  YYSYMBOL_dostmt_opt_list = 982,          /* dostmt_opt_list  */
  YYSYMBOL_dostmt_opt_item = 983,          /* dostmt_opt_item  */
  YYSYMBOL_CreateCastStmt = 984,           /* CreateCastStmt  */
  YYSYMBOL_cast_context = 985,             /* cast_context  */
  YYSYMBOL_DropCastStmt = 986,             /* DropCastStmt  */
  YYSYMBOL_opt_if_exists = 987,            /* opt_if_exists  */
  YYSYMBOL_ReindexStmt = 988,              /* ReindexStmt  */
  YYSYMBOL_reindex_type = 989,             /* reindex_type  */
  YYSYMBOL_opt_force = 990,                /* opt_force  */
  YYSYMBOL_AlterTypeStmt = 991,            /* AlterTypeStmt  */
  YYSYMBOL_AlterTblSpcStmt = 992,          /* AlterTblSpcStmt  */
  YYSYMBOL_RenameStmt = 993,               /* RenameStmt  */
  YYSYMBOL_opt_column = 994,               /* opt_column  */
  YYSYMBOL_opt_set_data = 995,             /* opt_set_data  */
  YYSYMBOL_AlterObjectSchemaStmt = 996,    /* AlterObjectSchemaStmt  */
  YYSYMBOL_AlterOwnerStmt = 997,           /* AlterOwnerStmt  */
  YYSYMBOL_RuleStmt = 998,                 /* RuleStmt  */
  YYSYMBOL_RuleActionList = 999,           /* RuleActionList  */
  YYSYMBOL_RuleActionMulti = 1000,         /* RuleActionMulti  */
  YYSYMBOL_RuleActionStmt = 1001,          /* RuleActionStmt  */
  YYSYMBOL_RuleActionStmtOrEmpty = 1002,   /* RuleActionStmtOrEmpty  */
  YYSYMBOL_event = 1003,                   /* event  */
  YYSYMBOL_opt_instead = 1004,             /* opt_instead  */
  YYSYMBOL_DropRuleStmt = 1005,            /* DropRuleStmt  */
  YYSYMBOL_NotifyStmt = 1006,              /* NotifyStmt  */
  YYSYMBOL_notify_payload = 1007,          /* notify_payload  */
  YYSYMBOL_ListenStmt = 1008,              /* ListenStmt  */
  YYSYMBOL_UnlistenStmt = 1009,            /* UnlistenStmt  */
  YYSYMBOL_TransactionStmt = 1010,         /* TransactionStmt  */
  YYSYMBOL_opt_transaction = 1011,         /* opt_transaction  */
  YYSYMBOL_transaction_mode_item = 1012,   /* transaction_mode_item  */
  YYSYMBOL_transaction_mode_list = 1013,   /* transaction_mode_list  */
  YYSYMBOL_transaction_mode_list_or_empty = 1014, /* transaction_mode_list_or_empty  */
  YYSYMBOL_ViewStmt = 1015,                /* ViewStmt  */
  YYSYMBOL_opt_check_option = 1016,        /* opt_check_option  */
  YYSYMBOL_LoadStmt = 1017,                /* LoadStmt  */
  YYSYMBOL_CreatedbStmt = 1018,            /* CreatedbStmt  */
  YYSYMBOL_createdb_opt_list = 1019,       /* createdb_opt_list  */
  YYSYMBOL_createdb_opt_item = 1020,       /* createdb_opt_item  */
  YYSYMBOL_opt_equal = 1021,               /* opt_equal  */
  YYSYMBOL_AlterDatabaseStmt = 1022,       /* AlterDatabaseStmt  */
  YYSYMBOL_AlterDatabaseSetStmt = 1023,    /* AlterDatabaseSetStmt  */
  YYSYMBOL_alterdb_opt_list = 1024,        /* alterdb_opt_list  */
  YYSYMBOL_alterdb_opt_item = 1025,        /* alterdb_opt_item  */
  YYSYMBOL_DropdbStmt = 1026,              /* DropdbStmt  */
  YYSYMBOL_AlterSystemStmt = 1027,         /* AlterSystemStmt  */
  YYSYMBOL_CreateDomainStmt = 1028,        /* CreateDomainStmt  */
  YYSYMBOL_AlterDomainStmt = 1029,         /* AlterDomainStmt  */
  YYSYMBOL_opt_as = 1030,                  /* opt_as  */
  YYSYMBOL_AlterTSDictionaryStmt = 1031,   /* AlterTSDictionaryStmt  */
  YYSYMBOL_AlterTSConfigurationStmt = 1032, /* AlterTSConfigurationStmt  */
  YYSYMBOL_CreateConversionStmt = 1033,    /* CreateConversionStmt  */
  YYSYMBOL_ClusterStmt = 1034,             /* ClusterStmt  */
  YYSYMBOL_cluster_index_specification = 1035, /* cluster_index_specification  */
  YYSYMBOL_VacuumStmt = 1036,              /* VacuumStmt  */
  YYSYMBOL_vacuum_option_list = 1037,      /* vacuum_option_list  */
  YYSYMBOL_vacuum_option_elem = 1038,      /* vacuum_option_elem  */
  YYSYMBOL_AnalyzeStmt = 1039,             /* AnalyzeStmt  */
  YYSYMBOL_analyze_keyword = 1040,         /* analyze_keyword  */
  YYSYMBOL_opt_verbose = 1041,             /* opt_verbose  */
  YYSYMBOL_opt_rootonly_all = 1042,        /* opt_rootonly_all  */
  YYSYMBOL_opt_full = 1043,                /* opt_full  */
  YYSYMBOL_opt_freeze = 1044,              /* opt_freeze  */
  YYSYMBOL_opt_name_list = 1045,           /* opt_name_list  */
  YYSYMBOL_ExplainStmt = 1046,             /* ExplainStmt  */
  YYSYMBOL_ExplainableStmt = 1047,         /* ExplainableStmt  */
  YYSYMBOL_opt_dxl = 1048,                 /* opt_dxl  */
  YYSYMBOL_explain_option_list = 1049,     /* explain_option_list  */
  YYSYMBOL_explain_option_elem = 1050,     /* explain_option_elem  */
  YYSYMBOL_explain_option_name = 1051,     /* explain_option_name  */
  YYSYMBOL_explain_option_arg = 1052,      /* explain_option_arg  */
  YYSYMBOL_PrepareStmt = 1053,             /* PrepareStmt  */
  YYSYMBOL_prep_type_clause = 1054,        /* prep_type_clause  */
  YYSYMBOL_PreparableStmt = 1055,          /* PreparableStmt  */
  YYSYMBOL_ExecuteStmt = 1056,             /* ExecuteStmt  */
  YYSYMBOL_execute_param_clause = 1057,    /* execute_param_clause  */
  YYSYMBOL_cdb_string_list = 1058,         /* cdb_string_list  */
  YYSYMBOL_cdb_string = 1059,              /* cdb_string  */
  YYSYMBOL_InsertStmt = 1060,              /* InsertStmt  */
  YYSYMBOL_insert_rest = 1061,             /* insert_rest  */
  YYSYMBOL_insert_column_list = 1062,      /* insert_column_list  */
  YYSYMBOL_insert_column_item = 1063,      /* insert_column_item  */
  YYSYMBOL_returning_clause = 1064,        /* returning_clause  */
  YYSYMBOL_DeleteStmt = 1065,              /* DeleteStmt  */
  YYSYMBOL_using_clause = 1066,            /* using_clause  */
  YYSYMBOL_LockStmt = 1067,                /* LockStmt  */
  YYSYMBOL_opt_lock = 1068,                /* opt_lock  */
  YYSYMBOL_lock_type = 1069,               /* lock_type  */
  YYSYMBOL_opt_nowait = 1070,              /* opt_nowait  */
  YYSYMBOL_UpdateStmt = 1071,              /* UpdateStmt  */
  YYSYMBOL_set_clause_list = 1072,         /* set_clause_list  */
  YYSYMBOL_set_clause = 1073,              /* set_clause  */
  YYSYMBOL_single_set_clause = 1074,       /* single_set_clause  */
  YYSYMBOL_multiple_set_clause = 1075,     /* multiple_set_clause  */
  YYSYMBOL_set_target = 1076,              /* set_target  */
  YYSYMBOL_set_target_list = 1077,         /* set_target_list  */
  YYSYMBOL_DeclareCursorStmt = 1078,       /* DeclareCursorStmt  */
  YYSYMBOL_cursor_name = 1079,             /* cursor_name  */
  YYSYMBOL_cursor_options = 1080,          /* cursor_options  */
  YYSYMBOL_opt_hold = 1081,                /* opt_hold  */
  YYSYMBOL_SelectStmt = 1082,              /* SelectStmt  */
  YYSYMBOL_select_with_parens = 1083,      /* select_with_parens  */
  YYSYMBOL_select_no_parens = 1084,        /* select_no_parens  */
  YYSYMBOL_select_clause = 1085,           /* select_clause  */
  YYSYMBOL_simple_select = 1086,           /* simple_select  */
  YYSYMBOL_with_clause = 1087,             /* with_clause  */
  YYSYMBOL_cte_list = 1088,                /* cte_list  */
  YYSYMBOL_common_table_expr = 1089,       /* common_table_expr  */
  YYSYMBOL_opt_with_clause = 1090,         /* opt_with_clause  */
  YYSYMBOL_into_clause = 1091,             /* into_clause  */
  YYSYMBOL_OptTempTableName = 1092,        /* OptTempTableName  */
  YYSYMBOL_opt_table = 1093,               /* opt_table  */
  YYSYMBOL_opt_all = 1094,                 /* opt_all  */
  YYSYMBOL_opt_distinct = 1095,            /* opt_distinct  */
  YYSYMBOL_opt_sort_clause = 1096,         /* opt_sort_clause  */
  YYSYMBOL_sort_clause = 1097,             /* sort_clause  */
  YYSYMBOL_sortby_list = 1098,             /* sortby_list  */
  YYSYMBOL_sortby = 1099,                  /* sortby  */
  YYSYMBOL_select_limit = 1100,            /* select_limit  */
  YYSYMBOL_opt_select_limit = 1101,        /* opt_select_limit  */
  YYSYMBOL_limit_clause = 1102,            /* limit_clause  */
  YYSYMBOL_offset_clause = 1103,           /* offset_clause  */
  YYSYMBOL_select_limit_value = 1104,      /* select_limit_value  */
  YYSYMBOL_select_offset_value = 1105,     /* select_offset_value  */
  YYSYMBOL_select_fetch_first_value = 1106, /* select_fetch_first_value  */
  YYSYMBOL_I_or_F_const = 1107,            /* I_or_F_const  */
  YYSYMBOL_row_or_rows = 1108,             /* row_or_rows  */
  YYSYMBOL_first_or_next = 1109,           /* first_or_next  */
  YYSYMBOL_group_clause = 1110,            /* group_clause  */
  YYSYMBOL_group_elem_list = 1111,         /* group_elem_list  */
  YYSYMBOL_group_elem = 1112,              /* group_elem  */
  YYSYMBOL_having_clause = 1113,           /* having_clause  */
  YYSYMBOL_for_locking_clause = 1114,      /* for_locking_clause  */
  YYSYMBOL_opt_for_locking_clause = 1115,  /* opt_for_locking_clause  */
  YYSYMBOL_for_locking_items = 1116,       /* for_locking_items  */
  YYSYMBOL_for_locking_item = 1117,        /* for_locking_item  */
  YYSYMBOL_for_locking_strength = 1118,    /* for_locking_strength  */
  YYSYMBOL_locked_rels_list = 1119,        /* locked_rels_list  */
  YYSYMBOL_values_clause = 1120,           /* values_clause  */
  YYSYMBOL_from_clause = 1121,             /* from_clause  */
  YYSYMBOL_from_list = 1122,               /* from_list  */
  YYSYMBOL_table_ref = 1123,               /* table_ref  */
  YYSYMBOL_joined_table = 1124,            /* joined_table  */
  YYSYMBOL_alias_clause = 1125,            /* alias_clause  */
  YYSYMBOL_opt_alias_clause = 1126,        /* opt_alias_clause  */
  YYSYMBOL_func_alias_clause = 1127,       /* func_alias_clause  */
  YYSYMBOL_join_type = 1128,               /* join_type  */
  YYSYMBOL_join_outer = 1129,              /* join_outer  */
  YYSYMBOL_join_qual = 1130,               /* join_qual  */
  YYSYMBOL_relation_expr = 1131,           /* relation_expr  */
  YYSYMBOL_relation_expr_list = 1132,      /* relation_expr_list  */
  YYSYMBOL_relation_expr_opt_alias = 1133, /* relation_expr_opt_alias  */
  YYSYMBOL_func_table = 1134,              /* func_table  */
  YYSYMBOL_rowsfrom_item = 1135,           /* rowsfrom_item  */
  YYSYMBOL_rowsfrom_list = 1136,           /* rowsfrom_list  */
  YYSYMBOL_opt_col_def_list = 1137,        /* opt_col_def_list  */
  YYSYMBOL_opt_ordinality = 1138,          /* opt_ordinality  */
  YYSYMBOL_where_clause = 1139,            /* where_clause  */
  YYSYMBOL_where_or_current_clause = 1140, /* where_or_current_clause  */
  YYSYMBOL_OptTableFuncElementList = 1141, /* OptTableFuncElementList  */
  YYSYMBOL_TableFuncElementList = 1142,    /* TableFuncElementList  */
  YYSYMBOL_TableFuncElement = 1143,        /* TableFuncElement  */
  YYSYMBOL_Typename = 1144,                /* Typename  */
  YYSYMBOL_opt_array_bounds = 1145,        /* opt_array_bounds  */
  YYSYMBOL_SimpleTypename = 1146,          /* SimpleTypename  */
  YYSYMBOL_ConstTypename = 1147,           /* ConstTypename  */
  YYSYMBOL_GenericType = 1148,             /* GenericType  */
  YYSYMBOL_opt_type_modifiers = 1149,      /* opt_type_modifiers  */
  YYSYMBOL_Numeric = 1150,                 /* Numeric  */
  YYSYMBOL_opt_float = 1151,               /* opt_float  */
  YYSYMBOL_Bit = 1152,                     /* Bit  */
  YYSYMBOL_ConstBit = 1153,                /* ConstBit  */
  YYSYMBOL_BitWithLength = 1154,           /* BitWithLength  */
  YYSYMBOL_BitWithoutLength = 1155,        /* BitWithoutLength  */
  YYSYMBOL_Character = 1156,               /* Character  */
  YYSYMBOL_ConstCharacter = 1157,          /* ConstCharacter  */
  YYSYMBOL_CharacterWithLength = 1158,     /* CharacterWithLength  */
  YYSYMBOL_CharacterWithoutLength = 1159,  /* CharacterWithoutLength  */
  YYSYMBOL_character = 1160,               /* character  */
  YYSYMBOL_opt_varying = 1161,             /* opt_varying  */
  YYSYMBOL_opt_charset = 1162,             /* opt_charset  */
  YYSYMBOL_ConstDatetime = 1163,           /* ConstDatetime  */
  YYSYMBOL_ConstInterval = 1164,           /* ConstInterval  */
  YYSYMBOL_opt_timezone = 1165,            /* opt_timezone  */
  YYSYMBOL_opt_interval = 1166,            /* opt_interval  */
  YYSYMBOL_interval_second = 1167,         /* interval_second  */
  YYSYMBOL_a_expr = 1168,                  /* a_expr  */
  YYSYMBOL_b_expr = 1169,                  /* b_expr  */
  YYSYMBOL_c_expr = 1170,                  /* c_expr  */
  YYSYMBOL_scatter_clause = 1171,          /* scatter_clause  */
  YYSYMBOL_table_value_select_clause = 1172, /* table_value_select_clause  */
  YYSYMBOL_func_application = 1173,        /* func_application  */
  YYSYMBOL_func_expr = 1174,               /* func_expr  */
  YYSYMBOL_func_expr_windowless = 1175,    /* func_expr_windowless  */
  YYSYMBOL_func_expr_common_subexpr = 1176, /* func_expr_common_subexpr  */
  YYSYMBOL_xml_root_version = 1177,        /* xml_root_version  */
  YYSYMBOL_opt_xml_root_standalone = 1178, /* opt_xml_root_standalone  */
  YYSYMBOL_xml_attributes = 1179,          /* xml_attributes  */
  YYSYMBOL_xml_attribute_list = 1180,      /* xml_attribute_list  */
  YYSYMBOL_xml_attribute_el = 1181,        /* xml_attribute_el  */
  YYSYMBOL_document_or_content = 1182,     /* document_or_content  */
  YYSYMBOL_xml_whitespace_option = 1183,   /* xml_whitespace_option  */
  YYSYMBOL_xmlexists_argument = 1184,      /* xmlexists_argument  */
  YYSYMBOL_within_group_clause = 1185,     /* within_group_clause  */
  YYSYMBOL_filter_clause = 1186,           /* filter_clause  */
  YYSYMBOL_window_clause = 1187,           /* window_clause  */
  YYSYMBOL_window_definition_list = 1188,  /* window_definition_list  */
  YYSYMBOL_window_definition = 1189,       /* window_definition  */
  YYSYMBOL_over_clause = 1190,             /* over_clause  */
  YYSYMBOL_window_specification = 1191,    /* window_specification  */
  YYSYMBOL_opt_existing_window_name = 1192, /* opt_existing_window_name  */
  YYSYMBOL_opt_partition_clause = 1193,    /* opt_partition_clause  */
  YYSYMBOL_opt_frame_clause = 1194,        /* opt_frame_clause  */
  YYSYMBOL_frame_extent = 1195,            /* frame_extent  */
  YYSYMBOL_frame_bound = 1196,             /* frame_bound  */
  YYSYMBOL_window_frame_exclusion = 1197,  /* window_frame_exclusion  */
  YYSYMBOL_row = 1198,                     /* row  */
  YYSYMBOL_sub_type = 1199,                /* sub_type  */
  YYSYMBOL_all_Op = 1200,                  /* all_Op  */
  YYSYMBOL_MathOp = 1201,                  /* MathOp  */
  YYSYMBOL_qual_Op = 1202,                 /* qual_Op  */
  YYSYMBOL_qual_all_Op = 1203,             /* qual_all_Op  */
  YYSYMBOL_subquery_Op = 1204,             /* subquery_Op  */
  YYSYMBOL_expr_list = 1205,               /* expr_list  */
  YYSYMBOL_func_arg_list = 1206,           /* func_arg_list  */
  YYSYMBOL_func_arg_expr = 1207,           /* func_arg_expr  */
  YYSYMBOL_type_list = 1208,               /* type_list  */
  YYSYMBOL_array_expr = 1209,              /* array_expr  */
  YYSYMBOL_array_expr_list = 1210,         /* array_expr_list  */
  YYSYMBOL_extract_list = 1211,            /* extract_list  */
  YYSYMBOL_extract_arg = 1212,             /* extract_arg  */
  YYSYMBOL_overlay_list = 1213,            /* overlay_list  */
  YYSYMBOL_overlay_placing = 1214,         /* overlay_placing  */
  YYSYMBOL_position_list = 1215,           /* position_list  */
  YYSYMBOL_substr_list = 1216,             /* substr_list  */
  YYSYMBOL_substr_from = 1217,             /* substr_from  */
  YYSYMBOL_substr_for = 1218,              /* substr_for  */
  YYSYMBOL_trim_list = 1219,               /* trim_list  */
  YYSYMBOL_in_expr = 1220,                 /* in_expr  */
  YYSYMBOL_case_expr = 1221,               /* case_expr  */
  YYSYMBOL_when_clause_list = 1222,        /* when_clause_list  */
  YYSYMBOL_when_clause = 1223,             /* when_clause  */
  YYSYMBOL_when_operand = 1224,            /* when_operand  */
  YYSYMBOL_case_default = 1225,            /* case_default  */
  YYSYMBOL_case_arg = 1226,                /* case_arg  */
  YYSYMBOL_decode_expr = 1227,             /* decode_expr  */
  YYSYMBOL_search_result_list = 1228,      /* search_result_list  */
  YYSYMBOL_search_result = 1229,           /* search_result  */
  YYSYMBOL_decode_default = 1230,          /* decode_default  */
  YYSYMBOL_columnref = 1231,               /* columnref  */
  YYSYMBOL_indirection_el = 1232,          /* indirection_el  */
  YYSYMBOL_indirection = 1233,             /* indirection  */
  YYSYMBOL_opt_indirection = 1234,         /* opt_indirection  */
  YYSYMBOL_opt_asymmetric = 1235,          /* opt_asymmetric  */
  YYSYMBOL_ctext_expr = 1236,              /* ctext_expr  */
  YYSYMBOL_ctext_expr_list = 1237,         /* ctext_expr_list  */
  YYSYMBOL_ctext_row = 1238,               /* ctext_row  */
  YYSYMBOL_opt_target_list = 1239,         /* opt_target_list  */
  YYSYMBOL_target_list = 1240,             /* target_list  */
  YYSYMBOL_target_el = 1241,               /* target_el  */
  YYSYMBOL_qualified_name_list = 1242,     /* qualified_name_list  */
  YYSYMBOL_qualified_name = 1243,          /* qualified_name  */
  YYSYMBOL_name_list = 1244,               /* name_list  */
  YYSYMBOL_name = 1245,                    /* name  */
  YYSYMBOL_database_name = 1246,           /* database_name  */
  YYSYMBOL_access_method = 1247,           /* access_method  */
  YYSYMBOL_attr_name = 1248,               /* attr_name  */
  YYSYMBOL_index_name = 1249,              /* index_name  */
  YYSYMBOL_file_name = 1250,               /* file_name  */
  YYSYMBOL_func_name = 1251,               /* func_name  */
  YYSYMBOL_AexprConst = 1252,              /* AexprConst  */
  YYSYMBOL_Iconst = 1253,                  /* Iconst  */
  YYSYMBOL_RoleId = 1254,                  /* RoleId  */
  YYSYMBOL_QueueId = 1255,                 /* QueueId  */
  YYSYMBOL_role_list = 1256,               /* role_list  */
  YYSYMBOL_SignedIconst = 1257,            /* SignedIconst  */
  YYSYMBOL_NonReservedWord = 1258,         /* NonReservedWord  */
  YYSYMBOL_unreserved_keyword = 1259,      /* unreserved_keyword  */
  YYSYMBOL_ColLabelNoAs = 1260,            /* ColLabelNoAs  */
  YYSYMBOL_keywords_ok_in_alias_no_as = 1261, /* keywords_ok_in_alias_no_as  */
  YYSYMBOL_PartitionColId = 1262,          /* PartitionColId  */
  YYSYMBOL_PartitionIdentKeyword = 1263,   /* PartitionIdentKeyword  */
  YYSYMBOL_col_name_keyword = 1264,        /* col_name_keyword  */
  YYSYMBOL_type_func_name_keyword = 1265,  /* type_func_name_keyword  */
  YYSYMBOL_reserved_keyword = 1266,        /* reserved_keyword  */
  YYSYMBOL_statements = 1267,              /* statements  */
  YYSYMBOL_statement = 1268,               /* statement  */
  YYSYMBOL_CreateAsStmt = 1269,            /* CreateAsStmt  */
  YYSYMBOL_1270_1 = 1270,                  /* $@1  */
  YYSYMBOL_at = 1271,                      /* at  */
  YYSYMBOL_ECPGConnect = 1272,             /* ECPGConnect  */
  YYSYMBOL_connection_target = 1273,       /* connection_target  */
  YYSYMBOL_opt_database_name = 1274,       /* opt_database_name  */
  YYSYMBOL_db_prefix = 1275,               /* db_prefix  */
  YYSYMBOL_server = 1276,                  /* server  */
  YYSYMBOL_opt_server = 1277,              /* opt_server  */
  YYSYMBOL_server_name = 1278,             /* server_name  */
  YYSYMBOL_opt_port = 1279,                /* opt_port  */
  YYSYMBOL_opt_connection_name = 1280,     /* opt_connection_name  */
  YYSYMBOL_opt_user = 1281,                /* opt_user  */
  YYSYMBOL_ora_user = 1282,                /* ora_user  */
  YYSYMBOL_user_name = 1283,               /* user_name  */
  YYSYMBOL_char_variable = 1284,           /* char_variable  */
  YYSYMBOL_opt_options = 1285,             /* opt_options  */
  YYSYMBOL_connect_options = 1286,         /* connect_options  */
  YYSYMBOL_opt_opt_value = 1287,           /* opt_opt_value  */
  YYSYMBOL_prepared_name = 1288,           /* prepared_name  */
  YYSYMBOL_ECPGCursorStmt = 1289,          /* ECPGCursorStmt  */
  YYSYMBOL_ECPGExecuteImmediateStmt = 1290, /* ECPGExecuteImmediateStmt  */
  YYSYMBOL_ECPGVarDeclaration = 1291,      /* ECPGVarDeclaration  */
  YYSYMBOL_single_vt_declaration = 1292,   /* single_vt_declaration  */
  YYSYMBOL_precision = 1293,               /* precision  */
  YYSYMBOL_opt_scale = 1294,               /* opt_scale  */
  YYSYMBOL_ecpg_interval = 1295,           /* ecpg_interval  */
  YYSYMBOL_ECPGDeclaration = 1296,         /* ECPGDeclaration  */
  YYSYMBOL_1297_2 = 1297,                  /* $@2  */
  YYSYMBOL_sql_startdeclare = 1298,        /* sql_startdeclare  */
  YYSYMBOL_sql_enddeclare = 1299,          /* sql_enddeclare  */
  YYSYMBOL_var_type_declarations = 1300,   /* var_type_declarations  */
  YYSYMBOL_vt_declarations = 1301,         /* vt_declarations  */
  YYSYMBOL_variable_declarations = 1302,   /* variable_declarations  */
  YYSYMBOL_type_declaration = 1303,        /* type_declaration  */
  YYSYMBOL_1304_3 = 1304,                  /* $@3  */
  YYSYMBOL_var_declaration = 1305,         /* var_declaration  */
  YYSYMBOL_1306_4 = 1306,                  /* $@4  */
  YYSYMBOL_1307_5 = 1307,                  /* $@5  */
  YYSYMBOL_opt_bit_field = 1308,           /* opt_bit_field  */
  YYSYMBOL_storage_declaration = 1309,     /* storage_declaration  */
  YYSYMBOL_storage_clause = 1310,          /* storage_clause  */
  YYSYMBOL_storage_modifier = 1311,        /* storage_modifier  */
  YYSYMBOL_var_type = 1312,                /* var_type  */
  YYSYMBOL_enum_type = 1313,               /* enum_type  */
  YYSYMBOL_enum_definition = 1314,         /* enum_definition  */
  YYSYMBOL_struct_union_type_with_symbol = 1315, /* struct_union_type_with_symbol  */
  YYSYMBOL_1316_6 = 1316,                  /* $@6  */
  YYSYMBOL_struct_union_type = 1317,       /* struct_union_type  */
  YYSYMBOL_1318_7 = 1318,                  /* $@7  */
  YYSYMBOL_s_struct_union_symbol = 1319,   /* s_struct_union_symbol  */
  YYSYMBOL_s_struct_union = 1320,          /* s_struct_union  */
  YYSYMBOL_simple_type = 1321,             /* simple_type  */
  YYSYMBOL_unsigned_type = 1322,           /* unsigned_type  */
  YYSYMBOL_signed_type = 1323,             /* signed_type  */
  YYSYMBOL_opt_signed = 1324,              /* opt_signed  */
  YYSYMBOL_variable_list = 1325,           /* variable_list  */
  YYSYMBOL_variable = 1326,                /* variable  */
  YYSYMBOL_opt_initializer = 1327,         /* opt_initializer  */
  YYSYMBOL_opt_pointer = 1328,             /* opt_pointer  */
  YYSYMBOL_ECPGDeclare = 1329,             /* ECPGDeclare  */
  YYSYMBOL_ECPGDisconnect = 1330,          /* ECPGDisconnect  */
  YYSYMBOL_dis_name = 1331,                /* dis_name  */
  YYSYMBOL_connection_object = 1332,       /* connection_object  */
  YYSYMBOL_execstring = 1333,              /* execstring  */
  YYSYMBOL_ECPGFree = 1334,                /* ECPGFree  */
  YYSYMBOL_ECPGOpen = 1335,                /* ECPGOpen  */
  YYSYMBOL_opt_ecpg_using = 1336,          /* opt_ecpg_using  */
  YYSYMBOL_ecpg_using = 1337,              /* ecpg_using  */
  YYSYMBOL_using_descriptor = 1338,        /* using_descriptor  */
  YYSYMBOL_into_descriptor = 1339,         /* into_descriptor  */
  YYSYMBOL_into_sqlda = 1340,              /* into_sqlda  */
  YYSYMBOL_using_list = 1341,              /* using_list  */
  YYSYMBOL_UsingValue = 1342,              /* UsingValue  */
  YYSYMBOL_UsingConst = 1343,              /* UsingConst  */
  YYSYMBOL_ECPGDescribe = 1344,            /* ECPGDescribe  */
  YYSYMBOL_opt_output = 1345,              /* opt_output  */
  YYSYMBOL_ECPGAllocateDescr = 1346,       /* ECPGAllocateDescr  */
  YYSYMBOL_ECPGDeallocateDescr = 1347,     /* ECPGDeallocateDescr  */
  YYSYMBOL_ECPGGetDescriptorHeader = 1348, /* ECPGGetDescriptorHeader  */
  YYSYMBOL_ECPGGetDescHeaderItems = 1349,  /* ECPGGetDescHeaderItems  */
  YYSYMBOL_ECPGGetDescHeaderItem = 1350,   /* ECPGGetDescHeaderItem  */
  YYSYMBOL_ECPGSetDescriptorHeader = 1351, /* ECPGSetDescriptorHeader  */
  YYSYMBOL_ECPGSetDescHeaderItems = 1352,  /* ECPGSetDescHeaderItems  */
  YYSYMBOL_ECPGSetDescHeaderItem = 1353,   /* ECPGSetDescHeaderItem  */
  YYSYMBOL_IntConstVar = 1354,             /* IntConstVar  */
  YYSYMBOL_desc_header_item = 1355,        /* desc_header_item  */
  YYSYMBOL_ECPGGetDescriptor = 1356,       /* ECPGGetDescriptor  */
  YYSYMBOL_ECPGGetDescItems = 1357,        /* ECPGGetDescItems  */
  YYSYMBOL_ECPGGetDescItem = 1358,         /* ECPGGetDescItem  */
  YYSYMBOL_ECPGSetDescriptor = 1359,       /* ECPGSetDescriptor  */
  YYSYMBOL_ECPGSetDescItems = 1360,        /* ECPGSetDescItems  */
  YYSYMBOL_ECPGSetDescItem = 1361,         /* ECPGSetDescItem  */
  YYSYMBOL_AllConstVar = 1362,             /* AllConstVar  */
  YYSYMBOL_descriptor_item = 1363,         /* descriptor_item  */
  YYSYMBOL_ECPGSetAutocommit = 1364,       /* ECPGSetAutocommit  */
  YYSYMBOL_on_off = 1365,                  /* on_off  */
  YYSYMBOL_ECPGSetConnection = 1366,       /* ECPGSetConnection  */
  YYSYMBOL_ECPGTypedef = 1367,             /* ECPGTypedef  */
  YYSYMBOL_1368_8 = 1368,                  /* $@8  */
  YYSYMBOL_opt_reference = 1369,           /* opt_reference  */
  YYSYMBOL_ECPGVar = 1370,                 /* ECPGVar  */
  YYSYMBOL_1371_9 = 1371,                  /* $@9  */
  YYSYMBOL_ECPGWhenever = 1372,            /* ECPGWhenever  */
  YYSYMBOL_action = 1373,                  /* action  */
  YYSYMBOL_ECPGKeywords = 1374,            /* ECPGKeywords  */
  YYSYMBOL_ECPGKeywords_vanames = 1375,    /* ECPGKeywords_vanames  */
  YYSYMBOL_ECPGKeywords_rest = 1376,       /* ECPGKeywords_rest  */
  YYSYMBOL_ECPGTypeName = 1377,            /* ECPGTypeName  */
  YYSYMBOL_symbol = 1378,                  /* symbol  */
  YYSYMBOL_ECPGColId = 1379,               /* ECPGColId  */
  YYSYMBOL_ColId = 1380,                   /* ColId  */
  YYSYMBOL_type_function_name = 1381,      /* type_function_name  */
  YYSYMBOL_ColLabel = 1382,                /* ColLabel  */
  YYSYMBOL_ECPGColLabel = 1383,            /* ECPGColLabel  */
  YYSYMBOL_ECPGColLabelCommon = 1384,      /* ECPGColLabelCommon  */
  YYSYMBOL_ECPGCKeywords = 1385,           /* ECPGCKeywords  */
  YYSYMBOL_all_unreserved_keyword = 1386,  /* all_unreserved_keyword  */
  YYSYMBOL_ECPGunreserved_interval = 1387, /* ECPGunreserved_interval  */
  YYSYMBOL_into_list = 1388,               /* into_list  */
  YYSYMBOL_ecpgstart = 1389,               /* ecpgstart  */
  YYSYMBOL_c_args = 1390,                  /* c_args  */
  YYSYMBOL_coutputvariable = 1391,         /* coutputvariable  */
  YYSYMBOL_civarind = 1392,                /* civarind  */
  YYSYMBOL_char_civar = 1393,              /* char_civar  */
  YYSYMBOL_civar = 1394,                   /* civar  */
  YYSYMBOL_indicator = 1395,               /* indicator  */
  YYSYMBOL_cvariable = 1396,               /* cvariable  */
  YYSYMBOL_ecpg_param = 1397,              /* ecpg_param  */
  YYSYMBOL_ecpg_bconst = 1398,             /* ecpg_bconst  */
  YYSYMBOL_ecpg_fconst = 1399,             /* ecpg_fconst  */
  YYSYMBOL_ecpg_sconst = 1400,             /* ecpg_sconst  */
  YYSYMBOL_ecpg_xconst = 1401,             /* ecpg_xconst  */
  YYSYMBOL_ecpg_ident = 1402,              /* ecpg_ident  */
  YYSYMBOL_quoted_ident_stringvar = 1403,  /* quoted_ident_stringvar  */
  YYSYMBOL_c_stuff_item = 1404,            /* c_stuff_item  */
  YYSYMBOL_c_stuff = 1405,                 /* c_stuff  */
  YYSYMBOL_c_list = 1406,                  /* c_list  */
  YYSYMBOL_c_term = 1407,                  /* c_term  */
  YYSYMBOL_c_thing = 1408,                 /* c_thing  */
  YYSYMBOL_c_anything = 1409,              /* c_anything  */
  YYSYMBOL_DeallocateStmt = 1410,          /* DeallocateStmt  */
  YYSYMBOL_Iresult = 1411,                 /* Iresult  */
  YYSYMBOL_execute_rest = 1412,            /* execute_rest  */
  YYSYMBOL_ecpg_into = 1413,               /* ecpg_into  */
  YYSYMBOL_opt_ecpg_into = 1414,           /* opt_ecpg_into  */
  YYSYMBOL_ecpg_fetch_into = 1415,         /* ecpg_fetch_into  */
  YYSYMBOL_opt_ecpg_fetch_into = 1416      /* opt_ecpg_fetch_into  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   142731

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  587
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  830
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3502
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6278

#define YYMAXUTOK   822


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   574,     2,     2,
     579,   580,   572,   570,   582,   571,   581,   573,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   584,   583,
     567,   566,   568,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   577,     2,   578,   575,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   585,     2,   586,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   569,   576
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1982,  1982,  1985,  1987,  1989,  1991,  1993,  1995,  1997,
    1999,  2001,  2003,  2005,  2007,  2009,  2011,  2013,  2015,  2017,
    2019,  2021,  2023,  2025,  2027,  2029,  2031,  2033,  2035,  2037,
    2039,  2041,  2043,  2045,  2047,  2049,  2067,  2069,  2071,  2073,
    2075,  2077,  2079,  2081,  2083,  2085,  2087,  2089,  2091,  2093,
    2095,  2097,  2099,  2101,  2103,  2105,  2107,  2109,  2111,  2113,
    2115,  2117,  2119,  2121,  2123,  2125,  2127,  2129,  2131,  2133,
    2137,  2139,  2141,  2143,  2145,  2147,  2149,  2151,  2153,  2155,
    2157,  2159,  2161,  2163,  2165,  2167,  2169,  2171,  2173,  2175,
    2177,  2179,  2181,  2183,  2185,  2187,  2189,  2191,  2193,  2195,
    2197,  2199,  2201,  2203,  2205,  2207,  2209,  2216,  2218,  2220,
    2222,  2224,  2226,  2228,  2230,  2232,  2234,  2236,  2238,  2244,
    2246,  2248,  2250,  2252,  2254,  2256,  2258,  2260,  2266,  2276,
    2280,  2286,  2290,  2300,  2310,  2311,  2325,  2332,  2338,  2349,
    2355,  2364,  2371,  2377,  2386,  2393,  2401,  2406,  2410,  2418,
    2423,  2429,  2433,  2437,  2441,  2445,  2453,  2457,  2461,  2465,
    2473,  2481,  2489,  2497,  2505,  2513,  2517,  2521,  2525,  2529,
    2533,  2541,  2549,  2554,  2560,  2565,  2571,  2576,  2582,  2586,
    2594,  2598,  2602,  2606,  2610,  2614,  2618,  2622,  2626,  2630,
    2634,  2638,  2642,  2646,  2654,  2658,  2662,  2666,  2670,  2674,
    2682,  2686,  2694,  2702,  2706,  2714,  2722,  2727,  2733,  2738,
    2744,  2748,  2756,  2764,  2772,  2781,  2783,  2791,  2795,  2803,
    2811,  2815,  2823,  2827,  2835,  2839,  2847,  2855,  2863,  2867,
    2875,  2879,  2887,  2891,  2895,  2900,  2909,  2914,  2920,  2925,
    2931,  2935,  2939,  2943,  2947,  2951,  2959,  2963,  2967,  2975,
    2979,  2983,  2991,  2995,  2999,  3003,  3011,  3015,  3019,  3023,
    3028,  3032,  3036,  3040,  3044,  3048,  3052,  3060,  3064,  3072,
    3076,  3084,  3088,  3102,  3106,  3110,  3114,  3122,  3126,  3130,
    3134,  3142,  3146,  3150,  3154,  3158,  3162,  3166,  3174,  3178,
    3183,  3189,  3193,  3201,  3209,  3213,  3217,  3221,  3229,  3233,
    3241,  3245,  3253,  3257,  3265,  3269,  3273,  3277,  3281,  3290,
    3298,  3302,  3310,  3314,  3322,  3330,  3334,  3338,  3342,  3346,
    3354,  3358,  3362,  3366,  3370,  3374,  3378,  3382,  3386,  3390,
    3394,  3398,  3402,  3406,  3410,  3414,  3418,  3426,  3430,  3438,
    3442,  3446,  3450,  3454,  3458,  3462,  3466,  3470,  3474,  3478,
    3482,  3486,  3490,  3494,  3498,  3502,  3506,  3510,  3514,  3518,
    3522,  3526,  3530,  3534,  3538,  3542,  3546,  3550,  3554,  3558,
    3562,  3566,  3570,  3574,  3578,  3582,  3586,  3590,  3594,  3598,
    3602,  3606,  3610,  3614,  3618,  3622,  3626,  3630,  3638,  3642,
    3650,  3654,  3659,  3665,  3670,  3676,  3681,  3687,  3691,  3695,
    3699,  3707,  3715,  3720,  3726,  3730,  3738,  3742,  3746,  3750,
    3758,  3763,  3769,  3773,  3778,  3784,  3788,  3792,  3800,  3804,
    3808,  3816,  3820,  3824,  3828,  3832,  3836,  3840,  3844,  3848,
    3852,  3856,  3860,  3864,  3868,  3872,  3880,  3888,  3892,  3900,
    3904,  3908,  3912,  3920,  3925,  3933,  3944,  3955,  3959,  3967,
    3972,  3978,  3983,  3989,  3993,  3997,  4005,  4009,  4017,  4022,
    4028,  4032,  4036,  4040,  4044,  4048,  4052,  4056,  4060,  4064,
    4068,  4072,  4076,  4080,  4084,  4088,  4092,  4100,  4105,  4111,
    4116,  4122,  4127,  4133,  4138,  4144,  4148,  4156,  4164,  4168,
    4172,  4176,  4181,  4187,  4191,  4199,  4207,  4211,  4215,  4219,
    4227,  4231,  4235,  4239,  4243,  4247,  4251,  4256,  4262,  4267,
    4273,  4278,  4284,  4288,  4296,  4300,  4308,  4312,  4316,  4320,
    4328,  4332,  4340,  4344,  4352,  4360,  4368,  4373,  4379,  4383,
    4387,  4391,  4399,  4404,  4410,  4414,  4418,  4422,  4426,  4430,
    4434,  4442,  4446,  4450,  4454,  4462,  4470,  4474,  4479,  4485,
    4489,  4493,  4497,  4501,  4505,  4513,  4517,  4525,  4529,  4533,
    4537,  4541,  4545,  4549,  4557,  4562,  4568,  4573,  4579,  4583,
    4591,  4599,  4603,  4611,  4619,  4623,  4628,  4633,  4639,  4643,
    4651,  4655,  4663,  4668,  4674,  4678,  4682,  4686,  4691,  4697,
    4705,  4713,  4717,  4721,  4725,  4729,  4737,  4742,  4748,  4752,
    4756,  4761,  4767,  4771,  4775,  4780,  4786,  4791,  4797,  4802,
    4808,  4816,  4820,  4824,  4832,  4837,  4843,  4848,  4854,  4858,
    4866,  4870,  4874,  4879,  4885,  4890,  4896,  4901,  4907,  4911,
    4919,  4923,  4931,  4935,  4939,  4943,  4951,  4955,  4959,  4967,
    4971,  4979,  4983,  4988,  4994,  5002,  5010,  5015,  5021,  5026,
    5032,  5036,  5040,  5048,  5053,  5059,  5063,  5071,  5075,  5083,
    5087,  5095,  5099,  5107,  5111,  5115,  5119,  5127,  5131,  5135,
    5139,  5147,  5155,  5163,  5171,  5179,  5183,  5188,  5194,  5199,
    5205,  5213,  5218,  5224,  5232,  5236,  5240,  5244,  5252,  5261,
    5265,  5270,  5276,  5284,  5288,  5293,  5299,  5304,  5310,  5314,
    5322,  5327,  5333,  5337,  5341,  5345,  5349,  5353,  5361,  5365,
    5369,  5374,  5380,  5384,  5392,  5396,  5404,  5408,  5416,  5420,
    5424,  5428,  5432,  5436,  5440,  5444,  5448,  5452,  5456,  5464,
    5469,  5475,  5479,  5487,  5491,  5499,  5507,  5512,  5518,  5522,
    5530,  5534,  5542,  5550,  5555,  5561,  5566,  5571,  5577,  5582,
    5588,  5592,  5600,  5604,  5609,  5615,  5620,  5626,  5630,  5638,
    5646,  5654,  5659,  5665,  5673,  5681,  5685,  5693,  5698,  5704,
    5708,  5716,  5720,  5724,  5728,  5732,  5736,  5740,  5744,  5748,
    5752,  5756,  5760,  5768,  5773,  5779,  5783,  5787,  5791,  5799,
    5803,  5811,  5815,  5823,  5828,  5834,  5838,  5846,  5851,  5857,
    5861,  5869,  5874,  5880,  5884,  5892,  5897,  5903,  5911,  5916,
    5922,  5926,  5934,  5938,  5946,  5951,  5957,  5961,  5965,  5973,
    5981,  5986,  5992,  6000,  6004,  6008,  6012,  6016,  6020,  6024,
    6028,  6032,  6036,  6040,  6044,  6048,  6052,  6056,  6060,  6064,
    6068,  6072,  6076,  6080,  6084,  6088,  6092,  6100,  6108,  6112,
    6116,  6120,  6128,  6132,  6140,  6145,  6151,  6155,  6163,  6167,
    6175,  6180,  6186,  6190,  6198,  6206,  6210,  6218,  6222,  6226,
    6230,  6238,  6246,  6254,  6262,  6270,  6275,  6281,  6285,  6293,
    6298,  6304,  6308,  6316,  6320,  6324,  6332,  6336,  6344,  6348,
    6356,  6364,  6368,  6372,  6380,  6384,  6392,  6400,  6404,  6412,
    6416,  6420,  6428,  6432,  6440,  6444,  6448,  6452,  6456,  6464,
    6469,  6475,  6480,  6486,  6490,  6498,  6503,  6509,  6513,  6518,
    6524,  6528,  6532,  6536,  6544,  6549,  6556,  6558,  6566,  6570,
    6574,  6578,  6582,  6586,  6594,  6598,  6606,  6610,  6618,  6622,
    6630,  6638,  6642,  6650,  6658,  6662,  6666,  6670,  6678,  6687,
    6696,  6700,  6704,  6708,  6712,  6716,  6720,  6724,  6728,  6732,
    6736,  6740,  6744,  6748,  6752,  6760,  6765,  6771,  6779,  6783,
    6791,  6795,  6803,  6807,  6811,  6815,  6819,  6823,  6827,  6835,
    6843,  6847,  6855,  6863,  6868,  6874,  6878,  6886,  6890,  6894,
    6902,  6907,  6913,  6921,  6925,  6933,  6937,  6941,  6945,  6949,
    6957,  6962,  6968,  6973,  6979,  6983,  6988,  6994,  7000,  7006,
    7014,  7018,  7026,  7030,  7038,  7042,  7050,  7054,  7062,  7066,
    7074,  7082,  7090,  7094,  7098,  7102,  7110,  7114,  7118,  7122,
    7126,  7130,  7134,  7138,  7142,  7146,  7150,  7154,  7158,  7162,
    7166,  7170,  7174,  7178,  7182,  7186,  7194,  7198,  7206,  7210,
    7218,  7222,  7230,  7238,  7242,  7247,  7253,  7257,  7261,  7265,
    7269,  7273,  7277,  7281,  7285,  7289,  7293,  7297,  7301,  7309,
    7313,  7317,  7321,  7325,  7329,  7333,  7337,  7341,  7345,  7349,
    7353,  7357,  7361,  7365,  7369,  7373,  7377,  7381,  7385,  7389,
    7393,  7397,  7401,  7405,  7413,  7417,  7425,  7429,  7433,  7437,
    7441,  7449,  7454,  7460,  7464,  7468,  7472,  7476,  7480,  7484,
    7488,  7492,  7496,  7500,  7504,  7508,  7516,  7520,  7528,  7532,
    7536,  7540,  7546,  7552,  7558,  7564,  7570,  7576,  7582,  7592,
    7603,  7614,  7625,  7636,  7647,  7658,  7674,  7690,  7706,  7717,
    7733,  7744,  7760,  7775,  7779,  7787,  7792,  7798,  7806,  7810,
    7818,  7822,  7826,  7830,  7834,  7842,  7846,  7854,  7858,  7862,
    7866,  7874,  7878,  7882,  7886,  7890,  7894,  7898,  7902,  7906,
    7910,  7914,  7918,  7922,  7926,  7930,  7934,  7938,  7946,  7950,
    7958,  7962,  7970,  7975,  7981,  7985,  7993,  8001,  8009,  8013,
    8021,  8026,  8032,  8037,  8043,  8051,  8056,  8062,  8066,  8070,
    8078,  8082,  8086,  8094,  8098,  8102,  8106,  8114,  8123,  8128,
    8134,  8139,  8145,  8150,  8156,  8161,  8167,  8171,  8179,  8183,
    8187,  8195,  8200,  8206,  8210,  8215,  8221,  8225,  8230,  8236,
    8240,  8245,  8251,  8255,  8259,  8267,  8272,  8278,  8282,  8290,
    8294,  8302,  8306,  8314,  8318,  8326,  8330,  8334,  8338,  8342,
    8350,  8354,  8358,  8362,  8366,  8374,  8382,  8390,  8394,  8398,
    8406,  8410,  8414,  8422,  8431,  8435,  8439,  8443,  8451,  8455,
    8463,  8467,  8475,  8479,  8483,  8487,  8491,  8495,  8499,  8503,
    8507,  8511,  8515,  8519,  8523,  8527,  8531,  8535,  8539,  8543,
    8547,  8551,  8555,  8559,  8563,  8571,  8575,  8579,  8583,  8591,
    8595,  8603,  8608,  8614,  8622,  8626,  8634,  8642,  8646,  8654,
    8659,  8665,  8669,  8677,  8681,  8689,  8693,  8701,  8705,  8709,
    8713,  8721,  8725,  8733,  8741,  8745,  8753,  8757,  8765,  8769,
    8773,  8781,  8785,  8790,  8796,  8804,  8809,  8815,  8819,  8823,
    8831,  8835,  8843,  8848,  8854,  8862,  8866,  8874,  8878,  8882,
    8886,  8890,  8894,  8898,  8902,  8906,  8910,  8914,  8918,  8922,
    8926,  8930,  8934,  8938,  8942,  8946,  8950,  8954,  8958,  8962,
    8966,  8970,  8974,  8978,  8982,  8986,  8990,  8994,  8998,  9002,
    9006,  9010,  9014,  9018,  9022,  9026,  9030,  9034,  9038,  9042,
    9046,  9050,  9054,  9062,  9067,  9073,  9078,  9084,  9088,  9092,
    9096,  9100,  9104,  9108,  9112,  9116,  9120,  9124,  9128,  9132,
    9136,  9140,  9144,  9148,  9152,  9156,  9160,  9164,  9168,  9172,
    9176,  9184,  9188,  9192,  9196,  9200,  9204,  9208,  9212,  9216,
    9220,  9224,  9228,  9232,  9236,  9240,  9244,  9248,  9252,  9256,
    9260,  9268,  9276,  9280,  9284,  9292,  9296,  9304,  9308,  9312,
    9316,  9320,  9328,  9333,  9339,  9343,  9347,  9351,  9359,  9363,
    9368,  9374,  9378,  9386,  9394,  9399,  9405,  9413,  9417,  9425,
    9429,  9433,  9437,  9441,  9445,  9449,  9453,  9457,  9461,  9465,
    9469,  9473,  9477,  9485,  9489,  9494,  9500,  9504,  9508,  9512,
    9516,  9524,  9528,  9532,  9540,  9545,  9551,  9555,  9559,  9564,
    9573,  9577,  9581,  9586,  9592,  9600,  9608,  9613,  9619,  9623,
    9627,  9631,  9635,  9639,  9643,  9647,  9651,  9655,  9659,  9663,
    9667,  9671,  9675,  9679,  9687,  9692,  9698,  9702,  9710,  9718,
    9723,  9729,  9737,  9741,  9749,  9753,  9761,  9769,  9773,  9777,
    9781,  9785,  9789,  9793,  9801,  9806,  9812,  9820,  9824,  9828,
    9832,  9836,  9840,  9848,  9856,  9860,  9864,  9872,  9877,  9883,
    9887,  9891,  9895,  9899,  9907,  9911,  9919,  9923,  9927,  9931,
    9939,  9943,  9947,  9951,  9959,  9963,  9971,  9976,  9982,  9987,
    9993,  9998, 10004, 10009, 10015, 10020, 10026, 10030, 10034, 10038,
   10046, 10050, 10054, 10058, 10062, 10066, 10070, 10074, 10078, 10082,
   10091, 10096, 10102, 10106, 10114, 10122, 10126, 10134, 10138, 10143,
   10149, 10155, 10165, 10170, 10176, 10180, 10184, 10188, 10196, 10198,
   10206, 10211, 10217, 10221, 10229, 10237, 10245, 10249, 10253, 10261,
   10265, 10273, 10281, 10286, 10292, 10300, 10305, 10311, 10319, 10324,
   10330, 10334, 10338, 10342, 10346, 10350, 10354, 10358, 10366, 10371,
   10377, 10385, 10389, 10397, 10401, 10409, 10417, 10425, 10433, 10437,
   10445, 10498, 10502, 10515, 10517, 10521, 10525, 10529, 10538, 10544,
   10548, 10556, 10560, 10568, 10572, 10580, 10584, 10588, 10592, 10596,
   10600, 10604, 10608, 10616, 10620, 10628, 10632, 10636, 10640, 10644,
   10648, 10656, 10660, 10668, 10672, 10680, 10688, 10693, 10699, 10704,
   10706, 10712, 10716, 10720, 10724, 10728, 10732, 10736, 10740, 10744,
   10752, 10757, 10763, 10767, 10772, 10778, 10782, 10786, 10791, 10797,
   10802, 10808, 10816, 10820, 10828, 10832, 10840, 10844, 10848, 10852,
   10860, 10865, 10871, 10875, 10880, 10884, 10892, 10896, 10904, 10908,
   10916, 10924, 10928, 10932, 10940, 10944, 10952, 10956, 10964, 10968,
   10976, 10981, 10987, 10991, 10999, 11003, 11007, 11011, 11015, 11023,
   11028, 11034, 11038, 11046, 11051, 11057, 11061, 11069, 11077, 11081,
   11085, 11089, 11097, 11102, 11108, 11112, 11120, 11125, 11131, 11135,
   11143, 11147, 11151, 11155, 11162, 11169, 11173, 11181, 11185, 11189,
   11193, 11197, 11201, 11209, 11213, 11217, 11221, 11229, 11234, 11240,
   11244, 11248, 11252, 11257, 11263, 11267, 11271, 11275, 11283, 11288,
   11294, 11298, 11306, 11310, 11314, 11318, 11326, 11330, 11338, 11342,
   11346, 11354, 11358, 11366, 11374, 11378, 11386, 11391, 11397, 11402,
   11408, 11413, 11419, 11423, 11429, 11435, 11440, 11446, 11450, 11458,
   11466, 11468, 11470, 11474, 11478, 11482, 11490, 11500, 11511, 11520,
   11524, 11528, 11532, 11536, 11540, 11544, 11552, 11556, 11560, 11564,
   11572, 11576, 11584, 11589, 11595, 11599, 11603, 11607, 11611, 11615,
   11619, 11623, 11627, 11631, 11635, 11643, 11648, 11654, 11658, 11666,
   11670, 11678, 11686, 11694, 11698, 11706, 11710, 11718, 11726, 11734,
   11738, 11742, 11746, 11750, 11754, 11762, 11767, 11773, 11778, 11784,
   11788, 11792, 11796, 11804, 11812, 11816, 11821, 11827, 11831, 11835,
   11839, 11843, 11847, 11851, 11855, 11859, 11863, 11867, 11871, 11875,
   11880, 11886, 11890, 11898, 11902, 11906, 11910, 11914, 11918, 11922,
   11926, 11930, 11934, 11938, 11942, 11946, 11950, 11954, 11958, 11962,
   11966, 11970, 11974, 11978, 11982, 11986, 11990, 11994, 11998, 12002,
   12006, 12010, 12014, 12018, 12022, 12026, 12030, 12034, 12038, 12042,
   12046, 12050, 12054, 12058, 12062, 12066, 12070, 12074, 12078, 12082,
   12086, 12090, 12094, 12098, 12102, 12106, 12110, 12114, 12118, 12122,
   12127, 12131, 12139, 12143, 12147, 12151, 12155, 12159, 12163, 12167,
   12171, 12175, 12179, 12183, 12187, 12191, 12195, 12199, 12203, 12207,
   12211, 12215, 12219, 12223, 12231, 12235, 12239, 12243, 12247, 12251,
   12255, 12259, 12263, 12267, 12271, 12275, 12279, 12283, 12292, 12294,
   12298, 12306, 12314, 12318, 12322, 12326, 12330, 12334, 12338, 12346,
   12350, 12358, 12362, 12370, 12374, 12378, 12382, 12386, 12390, 12394,
   12398, 12402, 12406, 12410, 12414, 12418, 12422, 12426, 12430, 12434,
   12438, 12442, 12446, 12450, 12454, 12458, 12462, 12466, 12470, 12474,
   12478, 12482, 12486, 12490, 12494, 12498, 12502, 12506, 12510, 12514,
   12518, 12522, 12526, 12530, 12534, 12538, 12542, 12546, 12550, 12554,
   12562, 12566, 12574, 12578, 12582, 12587, 12593, 12601, 12605, 12613,
   12617, 12625, 12629, 12637, 12641, 12646, 12652, 12656, 12660, 12664,
   12672, 12677, 12683, 12688, 12694, 12699, 12705, 12709, 12717, 12725,
   12729, 12734, 12740, 12748, 12752, 12759, 12764, 12770, 12775, 12780,
   12786, 12790, 12798, 12802, 12806, 12810, 12814, 12822, 12826, 12830,
   12834, 12839, 12845, 12849, 12853, 12861, 12865, 12869, 12877, 12881,
   12889, 12893, 12897, 12901, 12905, 12909, 12913, 12917, 12921, 12929,
   12933, 12941, 12945, 12953, 12957, 12961, 12965, 12969, 12973, 12981,
   12985, 12993, 12997, 13005, 13009, 13017, 13021, 13029, 13033, 13037,
   13045, 13049, 13057, 13062, 13068, 13072, 13076, 13080, 13084, 13088,
   13092, 13096, 13104, 13108, 13116, 13124, 13129, 13135, 13139, 13143,
   13147, 13151, 13156, 13162, 13170, 13178, 13182, 13186, 13194, 13198,
   13206, 13214, 13218, 13226, 13234, 13238, 13246, 13251, 13257, 13262,
   13268, 13276, 13280, 13288, 13296, 13301, 13307, 13311, 13319, 13323,
   13327, 13331, 13339, 13343, 13352, 13354, 13362, 13367, 13373, 13377,
   13385, 13389, 13397, 13405, 13410, 13416, 13420, 13428, 13432, 13436,
   13440, 13444, 13452, 13456, 13464, 13468, 13476, 13480, 13488, 13496,
   13504, 13512, 13520, 13528, 13536, 13540, 13548, 13552, 13556, 13560,
   13564, 13568, 13572, 13576, 13580, 13584, 13588, 13592, 13596, 13600,
   13601, 13606, 13612, 13620, 13628, 13632, 13640, 13644, 13645, 13649,
   13657, 13661, 13665, 13669, 13677, 13681, 13685, 13689, 13693, 13697,
   13701, 13705, 13709, 13713, 13717, 13721, 13725, 13729, 13733, 13737,
   13741, 13745, 13749, 13753, 13757, 13761, 13765, 13769, 13773, 13777,
   13781, 13785, 13789, 13793, 13797, 13801, 13805, 13809, 13813, 13817,
   13821, 13825, 13829, 13833, 13837, 13841, 13845, 13849, 13853, 13857,
   13861, 13865, 13869, 13873, 13877, 13881, 13885, 13889, 13893, 13897,
   13901, 13905, 13909, 13913, 13917, 13921, 13925, 13929, 13933, 13937,
   13941, 13945, 13949, 13953, 13957, 13961, 13965, 13969, 13973, 13977,
   13981, 13985, 13989, 13993, 13997, 14001, 14005, 14009, 14013, 14017,
   14021, 14025, 14029, 14033, 14037, 14041, 14045, 14049, 14053, 14057,
   14061, 14065, 14069, 14073, 14077, 14081, 14085, 14089, 14093, 14097,
   14101, 14105, 14109, 14113, 14117, 14121, 14125, 14129, 14133, 14137,
   14141, 14145, 14149, 14153, 14157, 14161, 14165, 14169, 14173, 14177,
   14181, 14185, 14189, 14193, 14197, 14201, 14205, 14209, 14213, 14217,
   14221, 14225, 14229, 14233, 14237, 14241, 14245, 14249, 14253, 14257,
   14261, 14265, 14269, 14273, 14277, 14281, 14285, 14289, 14293, 14297,
   14301, 14305, 14309, 14313, 14317, 14321, 14325, 14329, 14333, 14337,
   14341, 14345, 14349, 14353, 14357, 14361, 14365, 14369, 14373, 14377,
   14381, 14385, 14389, 14393, 14397, 14401, 14405, 14409, 14413, 14417,
   14421, 14425, 14429, 14433, 14437, 14441, 14445, 14449, 14453, 14457,
   14461, 14465, 14469, 14473, 14477, 14481, 14485, 14489, 14493, 14497,
   14501, 14505, 14509, 14513, 14517, 14521, 14525, 14529, 14533, 14537,
   14541, 14545, 14549, 14553, 14557, 14561, 14565, 14569, 14573, 14577,
   14581, 14585, 14589, 14593, 14597, 14601, 14605, 14609, 14613, 14617,
   14621, 14625, 14629, 14633, 14637, 14641, 14645, 14649, 14653, 14657,
   14661, 14665, 14669, 14673, 14677, 14681, 14685, 14689, 14693, 14697,
   14701, 14705, 14709, 14713, 14717, 14721, 14725, 14729, 14733, 14737,
   14741, 14745, 14749, 14753, 14757, 14761, 14765, 14769, 14773, 14777,
   14781, 14785, 14789, 14793, 14797, 14801, 14805, 14809, 14813, 14817,
   14821, 14825, 14829, 14833, 14837, 14841, 14845, 14849, 14853, 14857,
   14861, 14865, 14869, 14873, 14877, 14881, 14889, 14897, 14901, 14905,
   14909, 14913, 14921, 14925, 14933, 14937, 14941, 14945, 14949, 14953,
   14957, 14961, 14965, 14969, 14973, 14977, 14981, 14985, 14989, 14993,
   14997, 15001, 15005, 15009, 15013, 15017, 15021, 15025, 15029, 15033,
   15037, 15041, 15045, 15049, 15053, 15057, 15061, 15065, 15069, 15073,
   15077, 15081, 15085, 15089, 15093, 15097, 15101, 15105, 15109, 15113,
   15117, 15121, 15125, 15129, 15133, 15137, 15141, 15145, 15149, 15153,
   15157, 15161, 15165, 15169, 15173, 15177, 15181, 15185, 15189, 15193,
   15197, 15201, 15205, 15209, 15213, 15217, 15221, 15225, 15229, 15233,
   15237, 15241, 15245, 15249, 15253, 15257, 15261, 15265, 15269, 15273,
   15277, 15281, 15285, 15289, 15293, 15297, 15301, 15305, 15309, 15313,
   15317, 15321, 15325, 15329, 15333, 15337, 15341, 15345, 15349, 15353,
   15357, 15361, 15365, 15369, 15373, 15377, 15381, 15385, 15389, 15393,
   15397, 15401, 15405, 15409, 15413, 15417, 15421, 15425, 15429, 15433,
   15437, 15441, 15445, 15449, 15453, 15457, 15461, 15465, 15469, 15473,
   15477, 15481, 15485, 15489, 15493, 15497, 15501, 15505, 15509, 15513,
   15517, 15521, 15525, 15529, 15533, 15537, 15541, 15545, 15549, 15553,
   15557, 15561, 15565, 15569, 15573, 15577, 15581, 15585, 15589, 15593,
   15597, 15601, 15605, 15609, 15613, 15617, 15621, 15625, 15629, 15633,
   15637, 15641, 15645, 15649, 15653, 15657, 15661, 15665, 15669, 15673,
   15677, 15681, 15685, 15689, 15693, 15697, 15701, 15705, 15709, 15713,
   15717, 15721, 15725, 15729, 15733, 15737, 15741, 15745, 15749, 15753,
   15757, 15761, 15765, 15769, 15773, 15777, 15781, 15785, 15789, 15793,
   15797, 15801, 15805, 15809, 15813, 15817, 15821, 15825, 15829, 15833,
   15837, 15841, 15845, 15849, 15853, 15857, 15861, 15865, 15869, 15873,
   15877, 15881, 15885, 15889, 15893, 15897, 15901, 15905, 15909, 15913,
   15917, 15921, 15925, 15929, 15933, 15937, 15941, 15945, 15949, 15953,
   15957, 15961, 15965, 15969, 15973, 15977, 15981, 15985, 15989, 15993,
   15997, 16001, 16005, 16009, 16013, 16017, 16021, 16025, 16029, 16033,
   16041, 16045, 16049, 16053, 16057, 16061, 16065, 16069, 16073, 16077,
   16081, 16085, 16089, 16093, 16097, 16101, 16105, 16109, 16113, 16117,
   16121, 16125, 16129, 16133, 16137, 16141, 16145, 16149, 16153, 16157,
   16161, 16165, 16169, 16173, 16177, 16181, 16185, 16189, 16193, 16197,
   16201, 16205, 16209, 16213, 16217, 16221, 16225, 16229, 16233, 16241,
   16245, 16249, 16253, 16257, 16261, 16265, 16269, 16273, 16277, 16281,
   16285, 16289, 16293, 16297, 16301, 16305, 16309, 16313, 16317, 16321,
   16325, 16329, 16337, 16341, 16345, 16349, 16353, 16357, 16361, 16365,
   16369, 16373, 16377, 16381, 16385, 16389, 16393, 16397, 16401, 16405,
   16409, 16413, 16417, 16421, 16425, 16429, 16433, 16437, 16441, 16445,
   16449, 16453, 16457, 16461, 16465, 16469, 16473, 16477, 16481, 16485,
   16489, 16493, 16497, 16501, 16505, 16509, 16513, 16517, 16521, 16525,
   16529, 16533, 16537, 16541, 16545, 16549, 16553, 16557, 16561, 16565,
   16569, 16573, 16577, 16581, 16585, 16589, 16593, 16597, 16601, 16605,
   16609, 16613, 16617, 16621, 16625, 16629, 16633, 16637, 16641, 16645,
   16649, 16653, 16657, 16661, 16665, 16675, 16676, 16679, 16680, 16681,
   16687, 16688, 16689, 16690, 16691, 16704, 16704, 16713, 16728, 16730,
   16733, 16735, 16739, 16751, 16767, 16771, 16782, 16783, 16786, 16798,
   16807, 16808, 16811, 16812, 16813, 16816, 16817, 16820, 16821, 16824,
   16825, 16828, 16830, 16832, 16834, 16838, 16845, 16852, 16868, 16902,
   16912, 16915, 16919, 16932, 16933, 16935, 16937, 16941, 16955, 16962,
   17023, 17032, 17034, 17035, 17038, 17040, 17041, 17044, 17045, 17046,
   17047, 17048, 17055, 17054, 17064, 17066, 17068, 17069, 17072, 17073,
   17074, 17075, 17078, 17079, 17083, 17082, 17099, 17097, 17113, 17112,
   17126, 17132, 17133, 17136, 17138, 17139, 17142, 17143, 17144, 17145,
   17148, 17149, 17152, 17160, 17177, 17185, 17208, 17314, 17348, 17350,
   17352, 17356, 17360, 17359, 17410, 17412, 17411, 17426, 17432, 17439,
   17444, 17450, 17451, 17454, 17455, 17456, 17457, 17458, 17459, 17460,
   17468, 17476, 17479, 17480, 17481, 17482, 17483, 17484, 17492, 17500,
   17501, 17502, 17505, 17506, 17509, 17511, 17520, 17608, 17609, 17616,
   17617, 17618, 17624, 17633, 17636, 17637, 17638, 17639, 17642, 17643,
   17644, 17647, 17649, 17657, 17658, 17664, 17672, 17673, 17676, 17677,
   17680, 17685, 17692, 17697, 17704, 17711, 17711, 17713, 17720, 17721,
   17724, 17725, 17726, 17727, 17728, 17729, 17730, 17731, 17732, 17738,
   17745, 17757, 17763, 17770, 17778, 17779, 17791, 17802, 17813, 17817,
   17818, 17821, 17826, 17830, 17831, 17834, 17840, 17848, 17854, 17861,
   17865, 17866, 17869, 17872, 17876, 17877, 17880, 17886, 17895, 17900,
   17910, 17920, 17932, 17933, 17934, 17935, 17936, 17937, 17938, 17939,
   17940, 17941, 17942, 17943, 17944, 17945, 17946, 17953, 17954, 17957,
   17958, 17965, 17966, 17967, 17974, 17973, 17990, 17991, 17998, 17997,
   18067, 18073, 18079, 18087, 18093, 18099, 18105, 18111, 18117, 18123,
   18129, 18135, 18146, 18147, 18150, 18151, 18152, 18153, 18154, 18155,
   18156, 18157, 18158, 18159, 18160, 18161, 18162, 18163, 18164, 18165,
   18166, 18167, 18168, 18169, 18170, 18171, 18172, 18173, 18176, 18177,
   18178, 18179, 18180, 18181, 18185, 18186, 18187, 18188, 18189, 18190,
   18191, 18194, 18197, 18198, 18199, 18200, 18201, 18202, 18203, 18204,
   18217, 18218, 18219, 18220, 18221, 18222, 18223, 18228, 18229, 18230,
   18231, 18232, 18233, 18239, 18240, 18241, 18242, 18243, 18244, 18245,
   18246, 18247, 18248, 18249, 18252, 18253, 18254, 18255, 18256, 18259,
   18260, 18261, 18262, 18265, 18266, 18267, 18268, 18269, 18270, 18271,
   18288, 18289, 18290, 18293, 18294, 18295, 18296, 18297, 18298, 18302,
   18302, 18305, 18311, 18312, 18315, 18317, 18322, 18332, 18343, 18350,
   18351, 18352, 18355, 18388, 18390, 18392, 18395, 18405, 18415, 18425,
   18426, 18429, 18431, 18432, 18433, 18436, 18438, 18446, 18447, 18448,
   18452, 18453, 18457, 18458, 18461, 18462, 18465, 18466, 18467, 18468,
   18469, 18472, 18473, 18474, 18475, 18476, 18477, 18478, 18479, 18480,
   18481, 18482, 18483, 18484, 18485, 18486, 18487, 18488, 18489, 18490,
   18491, 18492, 18493, 18494, 18495, 18496, 18497, 18498, 18499, 18500,
   18501, 18502, 18503, 18504, 18505, 18506, 18507, 18508, 18509, 18510,
   18511, 18512, 18513, 18514, 18515, 18516, 18517, 18518, 18519, 18520,
   18521, 18522, 18523, 18524, 18525, 18526, 18527, 18530, 18531, 18532,
   18533, 18536, 18537, 18538, 18539, 18540, 18541, 18542, 18543, 18544,
   18545, 18552, 18553, 18554, 18555, 18558, 18559, 18562, 18563, 18566,
   18567, 18578, 18579
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "SQL_ALLOCATE",
  "SQL_AUTOCOMMIT", "SQL_BOOL", "SQL_BREAK", "SQL_CALL", "SQL_CARDINALITY",
  "SQL_CONNECT", "SQL_COUNT", "SQL_DATETIME_INTERVAL_CODE",
  "SQL_DATETIME_INTERVAL_PRECISION", "SQL_DESCRIBE", "SQL_DESCRIPTOR",
  "SQL_DISCONNECT", "SQL_FOUND", "SQL_FREE", "SQL_GET", "SQL_GO",
  "SQL_GOTO", "SQL_IDENTIFIED", "SQL_INDICATOR", "SQL_KEY_MEMBER",
  "SQL_LENGTH", "SQL_LONG", "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN",
  "SQL_OUTPUT", "SQL_REFERENCE", "SQL_RETURNED_LENGTH",
  "SQL_RETURNED_OCTET_LENGTH", "SQL_SCALE", "SQL_SECTION", "SQL_SHORT",
  "SQL_SIGNED", "SQL_SQL", "SQL_SQLERROR", "SQL_SQLPRINT",
  "SQL_SQLWARNING", "SQL_START", "SQL_STOP", "SQL_STRUCT", "SQL_UNSIGNED",
  "SQL_VAR", "SQL_WHENEVER", "S_ADD", "S_AND", "S_ANYTHING", "S_AUTO",
  "S_CONST", "S_DEC", "S_DIV", "S_DOTPOINT", "S_EQUAL", "S_EXTERN",
  "S_INC", "S_LSHIFT", "S_MEMPOINT", "S_MEMBER", "S_MOD", "S_MUL",
  "S_NEQUAL", "S_OR", "S_REGISTER", "S_RSHIFT", "S_STATIC", "S_SUB",
  "S_VOLATILE", "S_TYPEDEF", "CSTRING", "CVARIABLE", "CPP_LINE", "IP",
  "DOLCONST", "ECONST", "NCONST", "UCONST", "UIDENT", "IDENT", "FCONST",
  "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION",
  "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENCY", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL",
  "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM",
  "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED",
  "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IN_P", "INCLUDING", "INCREMENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT",
  "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH",
  "MATERIALIZED", "MAXVALUE", "MEMORY_LIMIT", "MEMORY_SHARED_QUOTA",
  "MEMORY_SPILL_RATIO", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE",
  "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF",
  "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON",
  "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING",
  "PLANS", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROGRAM", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P",
  "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA", "RESET",
  "RESTART", "RESTRICT", "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE",
  "ROLLBACK", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETOF",
  "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC",
  "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE",
  "TEMPORARY", "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE",
  "TRUSTED", "TYPE_P", "TYPES_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER",
  "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "ACTIVE", "CONTAINS", "CPUSET",
  "CPU_RATE_LIMIT", "CREATEEXTTABLE", "CUBE", "DECODE", "DENY",
  "DISTRIBUTED", "DXL", "ERRORS", "EVERY", "EXCHANGE", "EXPAND", "FIELDS",
  "FILL", "FORMAT", "FULLSCAN", "GROUP_ID", "GROUPING", "HASH", "HOST",
  "IGNORE_P", "INCLUSIVE", "INITPLAN", "LIST", "LOG_P", "MASTER", "MEDIAN",
  "MISSING", "MODIFIES", "NEWLINE", "NOCREATEEXTTABLE", "NOOVERCOMMIT",
  "ORDERED", "OTHERS", "OVERCOMMIT", "PARTITIONS", "PERCENT",
  "PERSISTENTLY", "PROTOCOL", "QUEUE", "RANDOMLY", "READABLE", "READS",
  "REJECT_P", "REPLICATED", "RESOURCE", "ROLLUP", "ROOTPARTITION",
  "SCATTER", "SEGMENT", "SEGMENTS", "SETS", "SPLIT", "SQL", "SUBPARTITION",
  "THRESHOLD", "TIES", "VALIDATION", "WEB", "WRITABLE", "NULLS_FIRST",
  "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "','", "';'", "':'", "'{'", "'}'", "$accept",
  "prog", "stmt", "CreateQueueStmt", "OptQueueList", "OptQueueElem",
  "AlterQueueStmt", "DropQueueStmt", "CreateResourceGroupStmt",
  "DropResourceGroupStmt", "AlterResourceGroupStmt",
  "OptResourceGroupList", "OptResourceGroupElem", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOnlyOptRoleElem",
  "AlterOptRoleElem", "CreateOptRoleElem", "deny_login_role",
  "deny_interval", "deny_day_specifier", "deny_point", "opt_time",
  "exttab_auth_list", "keyvalue_list", "keyvalue_pair", "CreateUserStmt",
  "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "opt_table_partition_split_into",
  "opt_table_partition_exchange_validate", "alter_table_partition_id_spec",
  "alter_table_partition_id_spec_with_opt_default",
  "alter_table_partition_cmd", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "skip_external_partition", "copy_file_name",
  "copy_options", "copy_opt_list", "copy_opt_item", "opt_binary",
  "opt_oids", "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement",
  "column_reference_storage_directive", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "opt_storage_encoding",
  "ColConstraintElem", "ConstraintAttr", "TableLikeClause",
  "TableLikeOptionList", "TableLikeOption", "TableConstraint",
  "ConstraintElem", "opt_no_inherit", "opt_column_list", "columnList",
  "columnElem", "distributed_by_list", "distributed_by_elem", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem",
  "ExclusionWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptWith", "OnCommitOption", "OptTableSpace",
  "OptConsTableSpace", "ExistingIndex", "DistributedBy",
  "OptDistributedBy", "OptTabPartitionColumnEncList",
  "TabPartitionColumnEncList", "OptTabPartitionStorageAttr",
  "OptTabPartitionSpec", "OptTabSubPartitionSpec", "TabPartitionElemList",
  "TabSubPartitionElemList", "tab_part_val_no_paran", "tab_part_val",
  "TabPartitionBoundarySpecValList", "OptTabPartitionRangeInclusive",
  "TabPartitionBoundarySpecStart", "TabPartitionBoundarySpecEnd",
  "OptTabPartitionBoundarySpecEvery", "OptTabPartitionBoundarySpecEnd",
  "TabPartitionBoundarySpec", "OptTabPartitionBoundarySpec",
  "multi_spec_value_list", "part_values_single", "part_values_clause",
  "part_values_or_spec_list", "TabPartitionElem", "TabSubPartitionElem",
  "TabPartitionNameDecl", "TabPartitionDefaultNameDecl",
  "TabSubPartitionNameDecl", "TabSubPartitionDefaultNameDecl",
  "TabPartitionByType", "OptTabPartitionBy", "TabSubPartitionTemplate",
  "opt_list_subparts", "TabSubPartitionBy", "TabSubPartition",
  "create_as_target", "opt_with_data", "CreateExternalStmt", "OptWritable",
  "OptWeb", "ExtTypedesc", "ext_on_clause_list", "ext_on_clause_item",
  "format_opt", "format_opt_list", "format_def_list", "format_def_item",
  "format_opt_item", "ext_options_opt", "ext_options", "ext_options_list",
  "ext_options_item", "OptExtTableElementList", "ExtTableElementList",
  "ExtTableElement", "ExtcolumnDef", "OptSingleRowErrorHandling",
  "OptLogErrorTable", "ExtSingleRowErrorHandling", "ExtLogErrorTable",
  "OptSrehLimitType", "ext_opt_encoding_list", "ext_opt_encoding_item",
  "CreateMatViewStmt", "create_mv_target", "OptNoLog",
  "RefreshMatViewStmt", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "opt_ordered", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTypeStmt",
  "AlterTblSpcStmt", "RenameStmt", "opt_column", "opt_set_data",
  "AlterObjectSchemaStmt", "AlterOwnerStmt", "RuleStmt", "RuleActionList",
  "RuleActionMulti", "RuleActionStmt", "RuleActionStmtOrEmpty", "event",
  "opt_instead", "DropRuleStmt", "NotifyStmt", "notify_payload",
  "ListenStmt", "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_rootonly_all", "opt_full", "opt_freeze", "opt_name_list",
  "ExplainStmt", "ExplainableStmt", "opt_dxl", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "cdb_string_list", "cdb_string", "InsertStmt",
  "insert_rest", "insert_column_list", "insert_column_item",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value", "select_fetch_first_value",
  "I_or_F_const", "row_or_rows", "first_or_next", "group_clause",
  "group_elem_list", "group_elem", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "rowsfrom_item",
  "rowsfrom_list", "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "scatter_clause", "table_value_select_clause",
  "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "window_frame_exclusion", "row", "sub_type", "all_Op",
  "MathOp", "qual_Op", "qual_all_Op", "subquery_Op", "expr_list",
  "func_arg_list", "func_arg_expr", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "overlay_list",
  "overlay_placing", "position_list", "substr_list", "substr_from",
  "substr_for", "trim_list", "in_expr", "case_expr", "when_clause_list",
  "when_clause", "when_operand", "case_default", "case_arg", "decode_expr",
  "search_result_list", "search_result", "decode_default", "columnref",
  "indirection_el", "indirection", "opt_indirection", "opt_asymmetric",
  "ctext_expr", "ctext_expr_list", "ctext_row", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "database_name", "access_method", "attr_name",
  "index_name", "file_name", "func_name", "AexprConst", "Iconst", "RoleId",
  "QueueId", "role_list", "SignedIconst", "NonReservedWord",
  "unreserved_keyword", "ColLabelNoAs", "keywords_ok_in_alias_no_as",
  "PartitionColId", "PartitionIdentKeyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "statements", "statement",
  "CreateAsStmt", "$@1", "at", "ECPGConnect", "connection_target",
  "opt_database_name", "db_prefix", "server", "opt_server", "server_name",
  "opt_port", "opt_connection_name", "opt_user", "ora_user", "user_name",
  "char_variable", "opt_options", "connect_options", "opt_opt_value",
  "prepared_name", "ECPGCursorStmt", "ECPGExecuteImmediateStmt",
  "ECPGVarDeclaration", "single_vt_declaration", "precision", "opt_scale",
  "ecpg_interval", "ECPGDeclaration", "$@2", "sql_startdeclare",
  "sql_enddeclare", "var_type_declarations", "vt_declarations",
  "variable_declarations", "type_declaration", "$@3", "var_declaration",
  "$@4", "$@5", "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@6", "struct_union_type", "$@7",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@8", "opt_reference", "ECPGVar",
  "$@9", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "opt_ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,    61,    60,    62,   821,
      43,    45,    42,    47,    37,    94,   822,    91,    93,    40,
      41,    46,    44,    59,    58,   123,   125
};
#endif

#define YYPACT_NINF (-5425)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3342)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   -5425,   476, 10740, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, 30759, -5425,
   -5425, -5425, -5425, -5425,125852,   474, -5425, -5425, -5425,131880,
   -5425, -5425, -5425,  1006, 86932, -5425, 90268,  1043, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, 94716, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, 74131,  1781, -5425,
    1022, -5425, -5425, -5425, -5425, -5425, -5425, -5425,    14, 16000,
   -5425, -5425, 90824, -5425,   644, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, 91380,   769, -5425, -5425,   818,    72, -5425,   138,
   15533, -5425, -5425, 84152, 88044, -5425, -5425, 95272,   541,  2413,
   16224,    14, 33253, 95828, -5425,  3025, -5425, 70192, -5425, -5425,
   -5425, 87488, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,105280,  2769,  1148, 70758, -5425, -5425,
   -5425, -5425,105280, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, 96384, -5425,  1289,  1438,   937,105836,106392, 85264,
   -5425,  1369, -5425,105280,  1660,   320, 73017, -5425,106948, -5425,
   -5425,  1343, -5425, 96940, -5425, -5425, -5425, -5425,  1148, -5425,
   74131, 68518,    85,  1646, -5425, -5425,107504, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425,  2112,  1408, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425,   769, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425,  2690, -5425,  1885,
    2939,    -3,   825,  1599, -5425, -5425, -5425,  7986, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425,127421,  2447, -5425, -5425, -5425,
    1533, -5425,  1685, -5425, -5425, -5425,  1958, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,   851, -5425, -5425, -5425, -5425,  2261,
  126375, 94716, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   83596, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425,   225, -5425, -5425, -5425, -5425, -5425, 94716, 94716,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, 94716,  1879, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425,   970,  2085, -5425, -5425,
   74131,  3065,  3065,  2387,127421, -5425, -5425, -5425, 75802,105280,
  105280,105280,  2110,105280,  1965,105280,  2070,   199, 75802,136790,
   97496,  2198,  2060, 62854, -5425,135317,105280,105280,108060,105280,
    1572, 91936,105280,  2191,105280,105280,135808,108616,105280,   330,
    2273, -5425,  2543,  2048, -5425, -5425, -5425,105280, 15469,  2769,
   -5425, -5425,105280,  2213,105280,  2101,105280,  2215,105280, -5425,
  105280,  2242,109172,   779,  2403,136790,  2458, 63424,  2323,136790,
  109728,105280,105280, -5425, -5425,  2366,105280,105280, -5425,  2395,
  137281, -5425, -5425,   349, -5425,  2194,  2559,  2485,  2702,  2633,
    2553,  1146, -5425, -5425,  2711,  2239, -5425, -5425,  2757, 94716,
   -5425, 92492, -5425, -5425, -5425,  2674, -5425, -5425, -5425, -5425,
   -5425, -5425,133353,  2413, -5425, -5425, 76359,105280,  2587, -5425,
   -5425,110284, -5425,  2391, -5425,    -6,   890, 76916,137772,  2726,
    2418, 63994,  2715,138263,110840, -5425, -5425,111396, -5425,111952,
    2484,112508, -5425,138754, -5425, -5425,   370,  2628,113064, -5425,
   12045, -5425,  2335,  2595,  2353,  2059, 94716, 94716,  2402,128901,
   -5425, -5425, -5425,   769, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425,   182,  1489, 71324,   678, 71890, -5425, -5425,  1034,
    1060,  1174,   182,  2894,  2894,   806, 94716, -5425, -5425,  1489,
   -5425,   594,     0,  2436,  2436,  2436,  2639,  1286, -5425,  2436,
   -5425, -5425, -5425, -5425, 96940, 71324, 71890, -5425,  2404,  2769,
      83,  2893,  2547,105280, -5425,105280, -5425,105280,105280, -5425,
   -5425, -5425,  2920,  2546,  2793, -5425,  2492, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425,  2752,  2758,  2775,    88,
    2769,  2678, -5425,  2886, -5425,  2791, 41246,    60, 94716,  2769,
   72456, 98052,122516,   417,133353,  2769,113620,  2643,  2003,  2809,
   -5425, -5425, -5425,   412, -5425,  3031,  2680,  2887,   131,  2048,
   60040, -5425,  2593,  1496, 96940,127944, -5425, -5425, -5425, -5425,
     228,  2959, 41821, -5425,105280,  2609, -5425,  2616,  2636,  2646,
      -3, -5425,114176,   371,   371,  3071,   371,  2217,  2319, -5425,
    3157, -5425,  2997,  2954, 96940,  1646,    14,  2653, -5425, -5425,
   -5425,  2675, -5425,  2677,  2681, -5425,  1319,  2991, -5425, -5425,
   -5425, -5425,  2817,  2825,  2841,  2859,  2736,  2865,   278, -5425,
   -5425, -5425, -5425,  3119, -5425, -5425, -5425, -5425, -5425, -5425,
    3203,  3152,132371,132371,   958,   960,   235,   326, -5425, -5425,
   -5425,  3074, -5425, -5425,  3053,105280,  2896,105280, -5425, -5425,
   -5425,114732, -5425, -5425,  3065,  2675,  2765, -5425,   261, -5425,
    1496, -5425,   280,   303,   356,  1991,  2770,  2180,  2080, -5425,
    1121,105280,  2943,   186,    28, 96940,  2879, 98608,  4028,  2796,
     310,  3140,  3167,  6469,   278, 99164, -5425,105280,105280, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  2816, -5425,
   -5425,  2788,  3159,  1930,  3092,  1858,  3218,  6909,  1826,115288,
  123072,  3190,  3228,  7171,  2095,  1178,  3113,  1106,  3159,  3222,
    1950,  3238,  8444,  3103,  3142,105280,136790,105280,  2912, -5425,
    3212,  3319,   807, -5425,   652, -5425,  3048,  3186,   844, 75802,
    2934, -5425, -5425,105280, -5425, -5425, -5425,  3078, -5425,   943,
   75802, -5425,  3200,  3056, 64564, -5425,105280, -5425, -5425, -5425,
   -5425, -5425,  3174,105280, -5425, -5425,   701,  3284,105280, -5425,
    2436,  3201,  3429, 79701,   111,105280,  3110,  3480,105280,  3275,
    3110,  3114,115844, -5425, -5425,  3110, -5425, -5425,105280,105280,
    3019,  2507,  3110,  3288,  3495,  3501,  3173,  3282,  1468,  1423,
     130,  3403,  3110,105280,136790,  3158,105280,116400,105280,  3082,
    3183, 75802,105280,  3487, 75802,105280, -5425,  1136, 99720, -5425,
    3047,  2711, -5425, -5425, -5425, -5425, -5425,  1917, -5425, -5425,
   -5425, -5425,  3433,  2765,  1013,  3451,  3096,  3458, -5425, -5425,
   -5425,  3253,  3205, -5425,  3483,  2796,  3486, -5425,  3118,116956,
   -5425,117512,118068,  3491,  2816,136790,  3496,  3118,  3504,  3389,
    3519,  1013,  3524, -5425,  1583,  3540,  3443,  3553,  2104,  3118,
  105280,136790,133844,  3562,   136, -5425, 13778, 12045, -5425, 17745,
    2057, -5425, -5425, -5425, -5425, -5425, -5425, 44696,  1127,  3346,
   -5425, -5425,  1053, -5425,  2317, -5425,130892, -5425,  2402,  1489,
   -5425, 94716,  1489, 94716,   806,  1489, 94716,  1489, 94716,   806,
    1489, 94716, 94716, 94716,  1489, -5425, -5425,  2268,  2269, -5425,
   -5425, -5425, -5425, -5425, 94716,  3198,105280,105280, -5425, -5425,
   -5425, 88600,136790, 89156, -5425, -5425,    56, 94716, -5425, 94716,
   -5425,  2769, -5425, -5425,  2595, 79701,  3670,136790,  3487,  3558,
    3558,  3558, -5425, -5425, -5425,  3498,105280,  3554,  3561, 88600,
  136790, -5425,118624,133353,  3456,  3209, -5425, -5425, -5425, -5425,
    2325,  3464,   434,  3474, 44696,  3210,   218,   218,  3211,  3566,
   -5425, -5425, -5425,   385,  3213,  3214, -5425,   471,   471,  3439,
    3216,  3217, -5425,   484,  3219, -5425,  3492,   528,  3220,  3223,
    3224,  2258,   218, 44696, -5425,  3225,   471,  3226,  3227,  3229,
    3537,  3230, -5425,  3592,  3231,  3232,   373,   403,  3233,  3235,
   -5425,  3216, -5425,   312,  3239,  3240,  3241,  3242,  3243,  3244,
    3245,  3246,  3248,  3249,  3251,  3252, 44696, 44696, -5425, 38946,
    1496,  2769, -5425, -5425, -5425, -5425, -5425, -5425, -5425,   127,
   -5425,   536,129393, -5425,  3325, -5425, -5425,  3459, 44696, -5425,
   -5425, -5425,  3548,  3250, -5425,   575, -5425, -5425,  1496, -5425,
   -5425,  1483, -5425, -5425, -5425, -5425,  2365,  2365,   314, -5425,
   90824, 90824, -5425, -5425,  1592,  3254, -5425,  2211, -5425, -5425,
   -5425, -5425, -5425, -5425,132862,  3726, -5425,  1107,  2769,   652,
    1751,  3671,129898,130395,  3568,  3568,  3552, -5425, -5425,105280,
   -5425, -5425, 44696, 66845, -5425,  1496,   100,  3569, -5425, -5425,
   -5425,  2326, -5425, -5425, -5425,   769, -5425, 14764, -5425,  2332,
    2609,105280,105280,  3733, -5425, -5425,105280,100276, -5425,  2616,
   -5425, -5425,    -3,    -3, 44696,    -3,   214,  1806, 42396, 45271,
    3617,  3514,   848,  1794,  3619, -5425,  3518,  2217,  2319, 96940,
  105280,119180,  3440, -5425, -5425,  2675,  3276,  2277, -5425, 81928,
  126898,126898,  3584, -5425, -5425,  1986,  1582,  3452,  3544,  2894,
    2156,  2508,  2508, -5425, -5425,  3270, -5425,  3673, 90824,  3393,
  132371, -5425, -5425,105280, -5425, -5425,100832, -5425, -5425, -5425,
     400,  3273, -5425,  3290,105280,  3843, -5425,  2508,  2508, -5425,
   -5425,  3277, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
  127421,  3279,105280, -5425,  3281,  3283, -5425,127944, 67403,  2231,
    1496,  3424,  3425,  3471, 74131,  3286,  3428,  3430,  3476,  3432,
    3436,123628, -5425, -5425, -5425, -5425,  1783,  1310,  1621,  3441,
     232,  1346,  3715, -5425,  1543,  3478, -5425, -5425, -5425,  1536,
    9479,105280,  3672,  9488,  3555,   278,  3556,  3484, -5425, -5425,
    3329,  3604,  3449,  3450,  3570,   278,  1647,124184, -5425, -5425,
   -5425,  3338,  3339,  3340, -5425, -5425, -5425,  5304, 36672, -5425,
    3460,  3438,  3469,105280, 82484,  1816,  3565,  1412,  1941,   716,
  105280,  3648,  3577,105280,  3326,  3466,   187,  3663,  3330,  2054,
    1102,  3756,  1102,  3481,  1429,  3331, -5425, -5425, -5425,  3567,
    3664,  3702, 10171,  3454,  3457, 78587,  1383, 65134,  3749,  2000,
    3485, -5425,  2000,105280,  3488,  3489,105280,   278, -5425,  3801,
     278,   278,  2124,  3802,   874,   500,  2393,  3110,  3331,  2296,
   -5425,  3494,  3502,  1946, -5425,  3596, -5425, -5425,  1509,  3500,
   96940,  1447,  2426,  3331,  3503,  3506,  3330,  3330,105280,105280,
  105280,105280,105280,   176,  3824,  3827,  3507,   195,  1202,  3362,
   -5425,  2000,134335,  3508, -5425,  2000,105280,  1145,  2642,  3331,
    3510,  3512,  3546, -5425, -5425,  1978, -5425,  2304, -5425, -5425,
   -5425,  2048, -5425,105280, -5425,105280,  2765, 79701,  3623, -5425,
    3472, -5425,  2796,   278, -5425,105280,105280,  2816,   174,  1631,
    3625, -5425, -5425,105280,  3687,  3479, -5425,  1482,  3380, -5425,
    3490, -5425,  3490,  3490,  3387,  3387,  3388, -5425, -5425,  2258,
    3490,  3387, -5425, 80815, -5425,  1595,  1862, -5425,  3860,  3862,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  1133,
   -5425,  2357, -5425, -5425, -5425,105280, 74131, -5425,  3873, -5425,
   -5425, 79701,  3641,  3760, -5425,105280,  3657,  3397, -5425,  3800,
    3520, -5425, -5425,  1407, -5425,  3770,136790,   863,  2769,  3511,
  105280,  3691,105280,105280,105280,105280, -5425, -5425,  3660,   934,
      77, -5425,134335, -5425,  3509, -5425,105280,  2296,  3674,  3881,
      45,  2436, -5425,  2167,105280,  3413,  3771, -5425,105280,  3416,
    3889,105280,  3721, -5425, -5425,  3418,  2894, -5425,  3047, -5425,
    2456, -5425,  3608, -5425, 75802,  1013, -5425, -5425, -5425, -5425,
   79701,105280, -5425,119736, 75802,  1013,136790,136790,  3806,   136,
    3807,  3551,  3808,  3560, 65134,  1013,   149,136790,105280,105280,
  105280, -5425,105280, -5425, -5425, -5425, -5425,105280,105280,136790,
  134335,  3810, -5425, -5425,  3812,  1013,105280,105280, -5425, -5425,
   16801,  2064, -5425, 12045, -5425, 14764,  2373,  3568, -5425,  1879,
    2072, -5425,  1053,134826, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425,  1053, 94716, -5425, 94716,   806, -5425, -5425, 94716, -5425,
   94716,   806, -5425, 94716, -5425, -5425, -5425, 94716,105280,  4012,
    3445, -5425,  1483, -5425,105280,  2379, -5425, -5425,  2382,  1282,
  105280,105280,   217, 75802,105280,  3706,105280,105280,105280,105280,
  105280,105280,  3593,  3254,   -40, -5425,   811, 96940,  3713, -5425,
   -5425, -5425, -5425, -5425,  2386,  2112,  1298,105280, -5425, -5425,
   -5425, -5425, -5425, -5425, 89156, 87488,  3805,   110,105280, -5425,
   -5425,  4547, 44696, 39521, -5425, -5425, -5425,  3461, 14764,  3559,
   44696, -5425, -5425, 44696,  3462,  2894,  2894, 44696, -5425, -5425,
   -5425, -5425,  1283,  2894, -5425, 44696, 44696,  2894,  2894,  3490,
    3490, -5425,  1081, 44696, -5425, 65134, 44696, 48146, 36096, 44696,
    2112,  3599,  3539,  2894, -5425,  2894, -5425, 44696, 38371, -5425,
   44696,  3734, 44696, 44696,  1751,  3736, 44696,  1751, 44696,  3467,
   44696, 44696,  3954,  3954, 59479,  1646,  1795,  7455,  3470,  1496,
   -5425,  3642,  2894, -5425,  2894,  1226,   451, 79701, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, 44696, 74131,
   -5425, -5425,  3610, -5425, -5425, -5425, -5425,   207, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,105280, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, 44696,
   -5425, -5425, -5425,  3475, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  2804,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, 44696, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  1443,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
    3482, -5425, -5425, 44696, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,  3611, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, 44696, 44696, 44696, 44696, 44696, 44696, 44696, 44696, 44696,
   -5425, 50993,   464, -5425, -5425, -5425, -5425,  3815,  3834,   658,
    2046, 89712,  3828, -5425, 41246, 34944, -5425,   196, 94716, -5425,
   -5425,  1496, -5425, -5425, -5425, -5425, -5425,   400,  3477, -5425,
    3505, -5425, -5425, -5425, -5425, -5425,105280,  3726, -5425, -5425,
    3615, -5425, -5425, -5425, -5425,   583, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,  3493, -5425, -5425, -5425, -5425,  3493,
   -5425, -5425,  3568,  3497,  2295, -5425, -5425, -5425, -5425,  3816,
    3822,  1013,127421,105280,   228, 93048,  3610,  3482, -5425, 41821,
   -5425,  2389, -5425,  3499,  2616, -5425,  2616, -5425,  3803, -5425,
    3513, -5425, 12311,  3803, -5425, -5425, 49296,  3665,  3794,  3740,
   -5425, -5425, -5425,  3515, 14764, 44696, 44696, -5425,  2615, 14764,
    2634, -5425, -5425, -5425, -5425, -5425, -5425,  1518, -5425,105280,
    3713,  3617,  1794,  3621,   826,105280, -5425, 60601,  2457, -5425,
    2675, -5425, -5425, 31895, -5425, 32525, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425,  3522, -5425, -5425, -5425, -5425,
   -5425,   278,  3525,  4039, -5425,132371, -5425, -5425, -5425,  4012,
   -5425,  2757, -5425,  2757,  4069, -5425, 94716, -5425, -5425, -5425,
   -5425,  1176, -5425, 12045, -5425, 12045, -5425,  3742, -5425,  3959,
   -5425, 80815, -5425,  3526, -5425, 80258, 77473, -5425, -5425,   881,
   -5425,   805,  3645,  3646,  3692,136790,105280,105280, -5425, 74131,
  136790,105280,105280,136790,105280,105280, -5425,  3935,    63, 87488,
    3696, 85820, -5425, -5425,  3528,105280,  3630,  3819,  3823,   -45,
   -5425, -5425,120292, -5425,  3777,136790,105280,105280, 44696,  3786,
  105280,105280, -5425,   250,  3669,  3677, -5425,105280,  3679, 75802,
    3533,105280,105280,105280,  3678,   989, 75802,  3639, 65704,105280,
  105280,105280,105280,  3724,105280,105280,  3847,  1102,  3331,  1456,
   96940,   873,  2866,  3331,  3809, -5425,   209,  1868, -5425, -5425,
  136790,105280,  3797, -5425, -5425, -5425, 86376,  4010,  3716, -5425,
   -5425,  3958,  3961, -5425,124740, -5425, -5425, -5425,  2396, -5425,
  136790,136790,105280, 11536,105280,  3785,139245, -5425, -5425, 79701,
   -5425,105280,  3793,139733,  9479,105280,105280,105280, 93604,120848,
    3795,140221,  1013,121404,  1865,  1945,105280, 94160, -5425,105280,
   -5425, -5425, 74688,136790,105280,  3704,   880, 74131, -5425,105280,
     744,   865,   246,  3708, -5425, -5425,  1013,105280,  3666, -5425,
    3804,  4032,  9479,  3718,  3728,105280,  1101,  2905,  3331,105280,
  105280,  3581,  2407,  3729,  3769, -5425,105280,122516, -5425,136790,
    2864, -5425,  3790,136790,105280, 15748, -5425, -5425,   278, -5425,
   -5425, -5425, -5425, -5425,105280,105280,   278,105280,   278,  1750,
   -5425,136790,105280, -5425, -5425, -5425,105280, 12468,105280,105280,
  105280,105280,136790,105280, -5425, -5425,  1220,  1534,  1434,  1439,
    3792,105280,  3926,105280,121960,136790,105280,105280,  3970,105280,
    2126, -5425, -5425, -5425,  3772, -5425,136790,  2864, -5425, 14308,
  105280,105280,105280,136790,   689,   855,  3735,  3737,   814,  3813,
   -5425, -5425, -5425, -5425, -5425, -5425,  3902,  4071,105280, -5425,
    3910,  3913,  3725,  3730,  3915,  2185,105280, -5425, -5425, -5425,
   -5425,105280,  3920,  2185,  3864,  1162, -5425, -5425,  3110, -5425,
   44696,  4088, 79701,  3622,  3626,  3758, -5425,  3764,  2894, -5425,
    2419, -5425, -5425,  2434, -5425,  3634,   934,  2202, -5425, 74131,
  105280,  1245,  1349,  3983, 83040,  3129,  3984,105280,  3739,105280,
    3129,105280, -5425,  1752, 87488, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,  3981, -5425,  2769,  3019,  3019,  3019,
    3019, -5425, -5425, -5425, -5425,  3883,  2318, -5425,  3632,  3019,
  105280,  3811,  3129,  3019,  1233,  3638, -5425,  2296,  4005,  4009,
  105280, 83040,  2568,  3743,  3796,  4117,  2436, 67403, -5425,  3019,
    2769,  3898, -5425, 37234, 10622,  3899,  3019,133353, 99720, -5425,
    3658,  3990,  3991,  4014, -5425,  2765, -5425,  4126, -5425,  4022,
    1013,  2796, -5425,  3118, -5425,105280, -5425,105280,105280,105280,
  105280,  2816, -5425, -5425,  3118,  3906,  1013,  1013, -5425,  3911,
    1013,  3118,  3837,  4018,133353, -5425,   136, -5425, -5425, -5425,
   -5425, -5425, 44696, -5425, -5425, -5425,  2456, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, 94716,
    2757, -5425,  2470, -5425,105280, -5425,  3995,  3997,  4000,  3675,
    3676,  3766,105280,  3680, -5425,  3675,   278,  3675,  3254,  3254,
    3675,  3676,  3675,136299,  4156,  4017,  1212, -5425,  1262,  1248,
    3948, -5425, -5425, -5425, -5425, 79701, -5425, -5425, -5425, -5425,
   -5425,105280,  3774,   234,  3925,  3681,136299,  4134,  1013, -5425,
   75802, -5425, -5425, -5425,  3817,  3841, 75802,  3938,  3798, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425,  3996,105280,  2479, -5425,
    1612, -5425,  2207, 44696, 45846,   192, -5425, 12753,  2498, 44696,
    3694,  3695,  2509, -5425, -5425, -5425, -5425, -5425, -5425,  3697,
    4048, -5425, -5425,  3699,  2523,  2550,  3700,  3701, -5425, -5425,
    4807,  3703, 12926,  3705, 48146, 48146,  1537, -5425, -5425, 48146,
    3707, -5425,  2569, 12354,  3709,  3710,  3738,  3712,  3787, -5425,
    3714,  3720, 12969, 42971, 44696, 42971, 42971, 14093,  3709,  3722,
    2572, 74131,  6378,  3940, 13307,  2576, -5425, 44696, 74131,  6898,
   44696,  8000, -5425,  2586,  8749, -5425, 44696,105280,  3723,  3727,
   -5425, -5425,  1081, -5425,  3799, -5425, 48146, 48146, -5425,  3977,
   38946, -5425, -5425,  4054, -5425, -5425,  1974, -5425,  3717, -5425,
   -5425,  4913,   236, 44696,  3475, 44696,  3853, 65134,  7643, 44696,
    5221,  3435,  3435,   561,   561,   201,   201,   201,  2443,  2046,
   -5425, -5425, -5425,  3732,  3741,  3744,  3960,  3230, 44696, -5425,
    2743,  2750,105280, 13134, 14222, 15979, -5425, -5425, 54429,  3830,
   -5425, 44696, 44696, 44696,  3745, -5425,  4205, 14764,   808, -5425,
    4216, -5425, -5425, -5425,  3207,  4069,   400, -5425,  2048,  2894,
    1226,130892, -5425, -5425, -5425, 44696, -5425, -5425, -5425, -5425,
    2616, -5425, -5425, -5425, -5425, -5425,105280,  2112, -5425, -5425,
   44696, -5425, -5425,  1000,  2467,    17,  3982,  2508,  2508,  2615,
    3985, -5425, -5425,  3849, -5425, 44696, -5425,  2742,  2747, -5425,
   -5425, -5425, -5425,  3254, -5425, -5425, -5425, 54429,  3835,  3851,
   58918,  3930, -5425, -5425,105280,   239, -5425, -5425, -5425,  3755,
   -5425, -5425, -5425,  1880, -5425, -5425, -5425, -5425, -5425, -5425,
    3746, -5425,  3750, -5425,  3761, -5425, -5425, -5425, -5425,   205,
    3751,  3759,  3767,   482, -5425, 77473,  2357, -5425, 80258, -5425,
   80258, -5425,  2357,  4197, -5425, 77473,   852,136790,105280,105280,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
    4035, -5425,136790,136790,  4007,105280,  3992,  4013, 44696,  1108,
  105280,  3773,  3775,   -41,  4095,105280, -5425,  4136,  1013, -5425,
   -5425,  3916, -5425, 14764, -5425, -5425, -5425, -5425, -5425,136790,
  105280, -5425,133353, -5425,  2765, 79701, -5425, -5425, -5425,105280,
    3865,105280, -5425,105280,105280,105280,  2816, -5425, -5425, -5425,
   -5425,  1667, -5425, -5425,105280,105280,   777,  3918,  3919,105280,
   -5425,   521,  3596, 14579,105280,105280,105280,  4090,  3820, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425,  4038, -5425, -5425, -5425,
   -5425, 77473, -5425,  3118,  1503,  1232,  3331, -5425,139733,  3783,
    3789, -5425,  3814,  3818,   904,  4161,  3863, -5425,  1765, -5425,
   -5425, -5425, -5425,  4036, -5425,141685, -5425, -5425,  1278, -5425,
   -5425, -5425, -5425, -5425,  4162,  1013,140709,  4163, -5425,  4164,
    1013,105280,105280,105280,105280, -5425, -5425, -5425, -5425, -5425,
   74131, 74131, 74131,  2612, -5425, -5425,  2769, -5425, -5425, -5425,
    2674, -5425, -5425, -5425,  4125, -5425,  2619, -5425,  1824, -5425,
   -5425,  3871, -5425, -5425,  3821, -5425, -5425,  3825, -5425, -5425,
    3950,141197,  3826, -5425,136790,105280, 15048,105280,105280,105280,
    2297, -5425,  1237, 79701, -5425, 79144,136790,105280, -5425, -5425,
    4092,  3876,  4034, -5425,  2197,  4042,136790,  3927,  3829,  1591,
    3829,   750, -5425, -5425, -5425, -5425,  3945, -5425, -5425,  1344,
    2906,  3331,  2296, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425,  1726,  1235,  2935,  3331,  3949, -5425,  3955, -5425, -5425,
   -5425,  4093,  4097,  4099,  3962,  3963,  4003,  3967,  3969,  4004,
   -5425,  3971,  4006,  3972,  4020,  3973,  1013, 79701,  4100,  2769,
    4011,  4203,  1013, -5425,  3979, -5425,  3019, -5425,  4307, -5425,
  105280, -5425,  1363,  3007,  3331, -5425, -5425, -5425, -5425,   182,
     182,   182,   182,  2769,   182, -5425, -5425,  3866,  3019,  3019,
    3867,  3868, -5425, -5425, -5425,136790,105280, -5425, -5425, -5425,
    2185, 79701,  4151,  2185,  2185,105280,105280,  2185, -5425, -5425,
   -5425,  4157,  4159,  2185, -5425, -5425, -5425, -5425,  3201,  3852,
    8849,  3855,  3626,  3858,  2894, 57235,  1814,  4132,  3861, -5425,
   -5425, 74131, 62284,  2392,  4154,  3879,  3879,  3879,  3879,  3879,
    3879,  3879, -5425,  1608,   377,  3110,133353,105280,133353, -5425,
    1349,  4036,105280,105280,  4301,105280,  3869,  3872, -5425, -5425,
   -5425, -5425, -5425,136790,   178,136790,  2894, -5425, -5425,  3998,
   -5425,105280,  2436,  4333,  3501,   863,  4070,  2321,  4277,  3743,
   -5425, -5425, -5425, -5425,105280,105280,   934,  2769, -5425,  3877,
    3874, -5425,105280, -5425,  3019,105280,105280,105280,  2112,  3880,
    3882, 79701,   800,  4123,  4129,  3330,  4356,105280,  2112,  3743,
    2630, -5425,  3900, -5425,  4025,105280, -5425,  2631,    89, -5425,
    2769,133353, 78030, -5425,  9087, -5425, -5425,  1669, -5425,  4228,
   -5425,105280, -5425, -5425, 58357,  1013, 79701,105280, -5425,  1013,
     136,  4019,  1013,  4021,  1013,  1013,105280, -5425, -5425,105280,
   -5425,105280,134335,  1013, -5425, 14764,  4243, -5425, -5425, -5425,
   -5425,  4089,  4091,  4096,105280,  3675, 75802, -5425,  3903,136790,
    1315, -5425, -5425,  4153, -5425, -5425, -5425, -5425, -5425,  4279,
    4281, -5425, -5425, -5425,   237, -5425,136790, 88600,   238,136790,
   -5425,  2765, -5425, -5425,  2796,   278, -5425,105280,  4222, -5425,
   -5425, -5425,  3924,  2661,  4180, 14764,  4068, 44696, -5425,  4302,
   79701, -5425,  9025, -5425, -5425, -5425, -5425, 44696, -5425, -5425,
   -5425, -5425, -5425, 44696, -5425, 44696,  4280, -5425,  4419,  4419,
   79701, 48146,  2047,  3226, 48146, 48146, 48146, 48146, 48146, 48146,
   48146, 48146, 48146, 51568,   430, -5425, -5425, 44696, 44696,  4284,
    4280, -5425,   155, -5425, -5425, -5425,  1205,  1205, 79701,  3931,
    3709,  3932,  3933, 44696, -5425, -5425,  2666, 44696, 49871,  3936,
   74131, -5425, 44696, 11890,  2671,  4044, 13619, 44696,  3941, -5425,
   -5425, -5425,  1496,  9193, -5425,  4380,  2769, 44696,  2090,  2145,
   44696,  2689, 44696,  4294, -5425, -5425, -5425,  3946, -5425, -5425,
   79701, 44696, 48146, 48146,  6196, -5425,  6263, 44696,  3947,  6727,
   38946, -5425,  4189,  4050, 61162, -5425,  1148,  1148,  1148,  1148,
   -5425,105280,105280,105280, 54990,  4300,  3952, 52143,101388,  3951,
    2672, -5425,101388,101944, -5425,  3968, -5425,  3964,  1496, 44696,
    4299,   828,   828,  4189, -5425, 44696, 43546,  3966, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,  3957, -5425,  3974, -5425, -5425,   652,
    3987, -5425, -5425, 11324,   205, -5425, -5425,  3989, -5425,  3965,
   -5425,  2467, -5425, -5425, -5425, -5425, -5425,  4210, -5425, -5425,
   -5425,  3951, 44121,  3930, -5425,  2693, -5425, -5425, 41246, -5425,
   -5425,  2698, 60601,  3835, 41821,  1496,  2894,  3988, -5425,  2757,
    3207, -5425, -5425, -5425, -5425, -5425,  2705,  2187, -5425, -5425,
   77473, -5425,  4108, -5425, -5425, -5425,  3879,  3118,  3118,  1440,
    3675,  4334,  1440,  9402, -5425, -5425, 55551,105280,105280, -5425,
  105280,  2708,  2188,105280, -5425,105280, -5425, -5425, -5425, -5425,
    4453, -5425,105280, -5425, -5425,  4101,  4102, -5425,105280,105280,
  105280,105280, -5425, -5425,  2770, -5425, -5425,136790,105280, -5425,
   -5425, -5425,  1342,  3064,  3331, -5425,  4131, -5425, -5425, -5425,
    4312, -5425,  4449,  4143,105280,   904, 52704, 52704, 52704, 53279,
    3814,  3818,  1765, -5425,  3863,  3999, -5425,105280,  3019,  4001,
    4015, -5425,  2188, -5425,  1400,  3330,   248, -5425, -5425,  4127,
  105280, -5425,  4366,139733,105280, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, 74688, -5425, -5425, -5425,105280, -5425,
   74131, 62284, 74131, -5425,105280,   683,105280,  4161, 53854, -5425,
    1813,  1525,  3126,  3331, -5425,  4142, -5425,  4148,  4149,  4188,
    1707,  1427,  4150,  4152,  4196,  4016,  4023,  4024, -5425, -5425,
     182,  4368,  2769, -5425, -5425,  2769,  3118,  2769, 74131, -5425,
    4421,  2701, -5425, -5425, -5425,105280,105280,105280,105280,105280,
    4470,  4166,105280,105280,105280,105280,105280,  4374,  1126,  2359,
  136790,105280,105280,136790,105280,105280,105280,105280,105280,105280,
  105280, -5425,  4457,  4388,  2535,  4428,  4158,105280, -5425,105280,
   -5425,  3596,105280,105280, -5425, -5425, -5425, -5425, -5425, -5425,
     278,  4122, -5425,   278,   278, -5425, -5425, -5425,  4026,  2185,
   -5425, -5425,  4337,  4339, -5425,  2185,  2185, -5425,  1482, 74131,
   -5425,  2961, -5425,  2894,  2771,  4033, -5425, 57796, -5425,  4041,
   -5425,  2127,  1226, -5425, -5425,  3965, -5425,  2508,  2508, -5425,
   -5425, -5425, -5425, -5425, -5425,105280,  3879, -5425,  2993,  2956,
    3351,  3396,102500,103056,103612,  4043,105280,105280, 48146, -5425,
    1992,   842, -5425,  4338,105280,  4137, -5425, -5425, -5425,  4249,
  105280, -5425, -5425, -5425, -5425, -5425,  4045,  4417,  4423, -5425,
    4217, 83040,  3118,136790,136790,  3118, -5425, 79701,  4047,  3743,
  136790,   863,  2167,116400,  4138, -5425,  4046,  4404, -5425,  4052,
    4051, -5425, -5425,105280,  4036, -5425,  2724,   869,  2353,  3774,
   84708,  2568,  4378, -5425, -5425, -5425,  4487,  4206, -5425,  2112,
    4058,  3774,  4206, -5425,  2674, 62284,  2769,  3630, -5425, 77473,
   44696, 44696, -5425,  4057, -5425,  4062, 10625, -5425,  3019, -5425,
   -5425, -5425, -5425, -5425, -5425,  4200,105280,  4557, -5425, -5425,
   -5425,  4064,  1013, -5425, -5425,105280, -5425,105280, -5425, -5425,
    1013,  1013, -5425,  4242, -5425,  2112,105280,105280,105280,  3675,
   -5425,   278, -5425,  4412,136299, -5425, -5425, -5425, -5425, -5425,
    4474,   110,  4420, -5425, -5425,  4381,  4384,  4386,  4389,  2210,
   -5425, -5425,  4456, 44696, 14764, -5425,  4081, -5425, 14764,  9538,
   14764,  4284, -5425,  2542,  4433, -5425,  1954,  4072,  2542,  2163,
    2163,   170,   170,   203,   203,   203,  4419,   430, 14764, 14764,
   -5425, -5425, 44696, -5425, -5425, -5425,  4094, -5425, -5425, -5425,
    3709, -5425, 46421,  9626,  4296,  4544, -5425, -5425, -5425,  4191,
    4192,  4098, -5425, 44696, 46996,  4103, 80815,  4248, 44696, -5425,
    4106, -5425, -5425,  1226,  1005, 48146, 48146,  2438, -5425,   154,
   44696, 79701,  2732,  2438,  2237,  2351, 44696, 44696,  7579,   486,
   44696,  9811,  4107, 44696,125296, -5425, -5425,105280,105280,105280,
  105280, -5425, -5425, -5425,101388,101944,  4104, 44696, 56673,  2672,
    4111,105280, -5425, -5425,  4109, 54429,  4398,  4342, -5425, 54429,
    4342,  2132,  4342,  4399, -5425, 61723, -5425, -5425,  4115, -5425,
   -5425, 34944,  2243, 14764,  4552,  4439, 44696,  4120,  4124,  4128,
   14764, 44696, -5425,  2769,  3207,   965,  2769, -5425, -5425, -5425,
   65134, -5425, -5425,  4376, 14764, -5425,  2112,105280,  1496,    96,
    4141,105280, -5425,  3930, -5425, -5425, 12045, -5425, -5425, -5425,
   -5425,  4261,  2739, -5425,   182, -5425, -5425, -5425, -5425,  4272,
   87488,  4483, -5425, 44696,  2740, -5425,  4233,  4573,   104,  2749,
    2753,  2188, -5425,  4137, -5425,  1998,  4462,   416, -5425,  1013,
   -5425, 79701, -5425,105280,105280, -5425, -5425, -5425, -5425,  3286,
   -5425, -5425,105280,105280,105280,105280, -5425,136790,105280, -5425,
    1765,  4139, 67961, 67961,  4633, -5425,  2760,   692, -5425,  2763,
     956,  2774, 67961,  4633,  2779,  2780,  4001, -5425, 52704, -5425,
    4291,   755, -5425, 74131,  3267,  4403, -5425, -5425,  4408,   182,
  105280, -5425, 79701,  1013,  1013,  1013,  1013, -5425, -5425, -5425,
   -5425,  4160,  2790, -5425,104168,   140,142173, -5425, -5425,  2803,
    1765, -5425,   904,   904,  2925,  4463,  3818,  4155, -5425,  4165,
    4606,  4304,105280,105280,105280,105280,136790,105280,105280,  2894,
    2894, 79701,  4167, -5425,  2894,  2894,  4168, -5425,136790,105280,
  105280, -5425, -5425, -5425, -5425,  4421, -5425, -5425, -5425,  2837,
   -5425,  4172,  4634,  4306, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425,136790,105280, -5425,  4308, -5425, -5425, -5425,105280,105280,
  105280,105280,  4527, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425,105280, -5425, -5425,  2769,  2769, 79701,
    1013,  1013, -5425, -5425, -5425, -5425,  3019, -5425, -5425,  4471,
   -5425,  2185,  2185, -5425, -5425,   405,  2850, -5425,128407, -5425,
   -5425,  3480,  2769,  3480,  2153, -5425, -5425,  3480, -5425,  4195,
    3480,  4218,  3480, -5425,  2188,  4175,  2249,  4523, -5425,  2421,
  127421, 57796, 57796, 57796, 57796, 57796, -5425, -5425,  4528,   182,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, 44696, -5425,  1505,  2542, -5425,
   -5425, -5425, -5425,  4137,  2436,  4295, 75802,  1524, -5425,  4511,
    1245, 83040,  3019,  3019,  2084,105280, -5425,  3118,  3118,  4305,
  105280,  4655, -5425,   911,105280,  4565,  4289, -5425,  2769, -5425,
   -5425,  3743,105280, 83040,  3774,  3871,  2855, -5425, -5425, -5425,
    4287,  4129,  4190,  2568,  1493,105280, -5425,  4292,104724,  3871,
   -5425, -5425,  3900, -5425,  4540,  4199, -5425, 14764, 14764,  2769,
   81372,  9087, -5425,105280,  4517,105280, -5425,  1013, -5425,  1013,
    1013, -5425, -5425,105280,  3675,  3675,  3675, -5425,  4442, -5425,
   -5425,  1013,136299,  2210,  2210,  2210,  2210, -5425, -5425, -5425,
    4551, 14764, -5425, -5425, -5425, 48146,  4553, -5425,  4207, 79701,
    3709, -5425,  4209,  2856,  2872, -5425, 50432,  4410, -5425, -5425,
   -5425, 10037,  4318, 14764,  4372,  4211,  4213, -5425, 44696,  8307,
   -5425, -5425,  2314,  2314,   154,  2876, -5425, 48146, 48146,  2438,
    2438, 44696,  2438, -5425, -5425, 10311,  4447, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, 75245,  8650,101388,  4227,105280,  2672,
   54429, -5425, -5425,  2958, -5425, 54429,  4516, -5425, 54429,105280,
    4230,105280,   808, 47571, 44696,  4317, -5425, -5425, -5425,  4189,
   -5425, -5425,  2508, -5425, -5425, -5425, -5425,  1226,  4231, 94716,
   -5425, -5425, -5425,  1646, -5425, -5425, -5425, -5425, -5425, -5425,
  136299,  4476,136299,  2188, 10344,  4137, 55551, 66274,105280,104168,
  104168,  4437,  4137,  4295, -5425, -5425, -5425, -5425, -5425, -5425,
    4232, -5425, -5425, -5425,  4373, -5425, -5425,  1122,  3713,  4001,
   52704,  4633,   167, 79701,   257, 52704, 44696, -5425, 44696,   257,
    2884, -5425,  4238, -5425, 67961, -5425,  2895,105280,  2900,  2918,
   -5425,  3019, -5425, -5425, -5425, -5425, -5425,  4457, -5425, -5425,
   -5425, -5425, 62284, -5425,105280,105280, -5425, -5425,142173, -5425,
   -5425,   755,  2021,  1765,  1765,  4265,  4267, -5425,  4250, -5425,
    4463,136790,105280, -5425,  4387, -5425, -5425, -5425, -5425, -5425,
   56112, 65134, -5425,  1707,  4252,  4253,  1427, -5425, -5425, -5425,
   -5425, -5425, 74131,  2769,  4421,  2769, -5425,  1172,  3713,105280,
    1571,  1277,  4353,  3675,  4610, -5425, -5425, -5425,  4457, -5425,
   -5425, -5425,  2185, -5425, -5425, -5425,  3110,  4648, -5425, 74131,
   -5425,131389, -5425, -5425, -5425,  2769, -5425,  2769,  4515,105280,
   69076,  2769, -5425,  2769,  4328,  2769, -5425, 75802,  4741,  4741,
   -5425,  4270,  2283,  2283, -5425, -5425, -5425,105280, -5425, -5425,
   10815,  4530, -5425,  4295,  4555,  4601, -5425,  4278,105280,  4493,
    4282,  4283, -5425, -5425,  1527,  1527,  4036,105280,  2923,  2112,
     863, 83040,  4036, -5425,  2149,  4288,  4646, -5425,  4751,  3880,
    4297, -5425, -5425,  4512, -5425, 84708,  4533,  4206,105280,  4129,
    4477, -5425,  4479, -5425,  1942, -5425, -5425,  4309,  4293, -5425,
   -5425, 79701, -5425,105280, 55551, -5425, 80258, -5425,  2949, -5425,
   -5425,  3830,105280,   103, -5425,  4310, -5425, -5425, -5425, -5425,
   -5425, -5425,   238, -5425, -5425, -5425, -5425, 44696,   725, 48146,
   79701,  2973, 44696, -5425, 44696, -5425,  4749, -5425, -5425, -5425,
      99, -5425, -5425, 14764, -5425,  2314,  2314,  2438, -5425,  4754,
    4189, -5425,  3001,  4772, 44696, -5425,105280,  3005, -5425, 44696,
    4303, -5425, -5425, 54429,  2958,  3026,105280,  3043, 79701,  4311,
    4314,   -82,  4315, 35520,  4319, -5425, 14764, 14764,105280, -5425,
    4316, -5425, -5425, -5425, -5425, -5425, -5425,  1315,  1440,   238,
    4573,  4295, -5425,  4320, -5425, -5425,   328,   328,105280,  4295,
   -5425, -5425,105280,  4452, -5425, -5425,  4773,  4797, -5425, -5425,
   -5425, -5425, -5425,   828,   828, -5425, -5425, 67961,  4633, -5425,
   -5425, -5425, -5425, 74131, -5425,  4425, -5425, -5425, -5425, -5425,
   -5425, -5425,  4001,  2021,  2021,  2021, -5425, -5425,  1102, -5425,
    1192,  3713,105280, 79701,  2796,    62, -5425, 79701, 79701, -5425,
   -5425, -5425, -5425, -5425,  4458, -5425, -5425,105280,105280,105280,
  105280,105280,  1013, -5425,  3852,  2769, -5425, -5425,  3055, -5425,
   -5425, -5425,105280,  4046, -5425,  4046, -5425, -5425, -5425, -5425,
    4741,  1304, -5425, -5425, -5425, -5425,  1911,  4585, -5425,  1530,
    4571,  4473,  4323, -5425, 75802,  4806,  4502, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425,  4688,  3743,  4292, -5425,
   -5425, -5425, -5425, 44696,  4545,  2112,  2568,  4378,  4785, -5425,
   -5425, -5425,  3871,  3059,  4206, -5425, -5425,  4774,  4579,  4777,
     208,104724, -5425, -5425,  3067, -5425, -5425, 10625, 81372,  4721,
   -5425,  4450,105280, -5425, -5425,  2676,  4833, -5425, 14764,   725,
    3070, -5425,  3073,  3080,  4549,  4460, -5425, 44696,  1579,  3968,
   75245,  4340, -5425, 11151,  3098, -5425, 14764,105280, -5425, -5425,
   -5425,  3106, -5425, -5425, 44696,  4344, 44696, -5425, 47571,  4343,
   -5425,  4816, -5425, -5425,  4698, -5425,104168,  4451, 65134,  2467,
    2467,  2436, -5425,  2188, -5425,105280, 79701, 79701,  4350,  4351,
    3107, -5425, 44696, -5425, -5425, -5425,  4001,  4001,  4352,  4500,
   -5425, -5425,  3111, -5425,  1559,  4563,  4710,  3115,  3130,105280,
    3676,  4459,  3676, -5425,  3675, -5425,  2056, -5425, -5425,131389,
    4046, -5425, -5425, -5425,  4738,  4683, -5425, -5425, -5425, -5425,
     721, -5425,  4608,  4614,105280, -5425,  4367, -5425,  3131,105280,
  105280,  4841,  4843, -5425, 11202, 75802,  4292,  4129,  2568,  1182,
    1608,  4512, -5425,  3871,  4619, -5425,  4621,  2769,  4377,  4441,
   -5425,  3743, 55551,  9087, -5425,  1274, -5425, -5425, -5425, -5425,
   -5425,105280, -5425, -5425, -5425, -5425, -5425,  3513, 40096, 40096,
    4379, -5425, -5425,105280, -5425,  3134, -5425,  3148, 47571,  3151,
   -5425,105280,  4382,136299,   328,  4383, -5425,  4385, -5425, -5425,
    4555,  2188,  3713,  4390, -5425,  2769,   251, -5425, 14764, -5425,
   -5425,  1102,105280, 75802,  4838, -5425, -5425, -5425,  4563, -5425,
   -5425,  3713,105280,  4454,  4445,  4427, -5425,  4577, -5425,   917,
     917,  4786, -5425,  4520, -5425, -5425,  4396, -5425,  4899,  4036,
   -5425,  1707,  2112, -5425,  4405, -5425,  4206,  4129, -5425, -5425,
    4406, -5425,  4512, -5425, -5425, -5425,  2769,  2769,  4206, -5425,
   -5425, -5425, -5425,  1900, -5425, 48721,  4591,   718, 12417,  4780,
   -5425,  4780, -5425,  3156, -5425, -5425,  3160, -5425, -5425, -5425,
     238,  2467, 44696,  2188, -5425,  4571, -5425, -5425, -5425,  4411,
    3713,  2796,105280, -5425, -5425, -5425,  4714,  4778, -5425,  4455,
    4289, -5425,  4896, -5425,   839, -5425, -5425, -5425, -5425, -5425,
    4167,  4292, 73574,  3871,  4206,105280, -5425,  4666,  3161, -5425,
   -5425,  4426,  3830, -5425,  2350, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425,  4894, -5425, -5425, -5425, -5425, -5425,   158, -5425,
   -5425, -5425, -5425, -5425, -5425, 11256, -5425, -5425, -5425, -5425,
   -5425,105280,  4465,  4715,  4794, -5425, -5425, -5425, -5425,  3164,
   -5425, -5425, -5425, -5425, -5425,  4512,  3871,  3165,   296, -5425,
   -5425,  2769, 33820,  4672, -5425,  2144, -5425, -5425,  2169,  2646,
   40671,  4617, -5425,  4475, -5425, -5425,  2188, -5425, -5425,  2894,
    4649, -5425, 73574, -5425,  4512,  4461, -5425,  2769, -5425,  2894,
   -5425,  4666, -5425,  4443,   157,   171,   141,  4448,   190,   191,
    4482,   213, -5425,  1913,  3168, -5425, -5425,  4467,  4434, -5425,
   -5425,  2350, -5425, -5425, -5425,   780, 75802, -5425, -5425,  4891,
    4444,  4466, -5425, -5425, -5425,  2769,  2769,  4703, 69634,  2769,
    2769,  4513,  2769, -5425,  3480,  3480,   141, -5425,  3480,  3480,
    4482,  3480, -5425, -5425, -5425, 74131, 37796, 34382, -5425,   414,
   -5425, -5425, -5425, -5425,  4464,  1182,   688, -5425,   252,  4461,
   -5425, -5425, -5425,105280, -5425,  4046, -5425, -5425, -5425, -5425,
   -5425,105280, -5425, -5425,  3169, -5425,  2769,  3879,  4521, -5425,
    3871,  4484, -5425, 73574,  4468,   230,142173, -5425,  3172,  1765,
   -5425,   904,   904,  4469, -5425,  4046,  3177, -5425, 74131, -5425,
    2701,   810, -5425,  4489,  3178,105280,142173, -5425, -5425,   688,
    2021,  1765,  1765,   755, -5425, -5425, -5425, -5425, -5425,  4747,
   -5425,  3181, -5425, -5425,  4001,  2021,  2021,  3182,  2894, -5425,
   -5425,  4001,  4001, -5425,   780, -5425, -5425, -5425
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
    3025,     0,     2,     1,  3455,  3459,  3463,  3464,  3381,  3465,
    3466,  3431,  3432,  3433,  3434,  3435,  3436,  3437,  3438,  3439,
    3440,  3441,  3442,  3444,  3443,  3445,  3446,  3447,  3448,  3449,
    3450,  3451,  3452,  3454,  3453,  3403,  3032,  3400,  3397,  3398,
    3399,  3404,  3402,  3395,  3396,  2271,  3468,  3456,  3469,  3457,
    3458,  3460,  3461,  3430,  3462,  3470,  3471,  3472,  3467,  3475,
    3426,  3427,  3425,  3428,  3429,  3473,  3474,  3417,  3418,  3419,
    3420,  3476,  3033,  3034,  3422,  3026,  3030,  3092,  3163,  3423,
    3424,  3421,  3031,  3416,  3163,     0,  3284,  3285,  3286,     0,
    3287,  3288,  3289,  3215,  3177,  3290,     0,     0,  3291,  3292,
    3293,  3294,  3295,  3296,  3297,  3298,     0,  3299,  3300,  3301,
    3302,  3162,  3303,  3304,  3305,  3306,  3307,  3139,  3145,  3268,
       0,  3119,  3120,  3116,  3118,  3117,  3121,  3104,  1485,   806,
    1575,  1574,     0,  2919,  1485,  2870,  2871,  2920,  2872,  2873,
    2874,   314,     0,  1577,  2875,  2921,     0,  1485,  2922,   478,
    1236,  2923,  2924,  3047,     0,  2876,  2877,     0,     0,     0,
     806,  1485,     0,     0,  2878,  1697,  2879,     0,  2880,  2925,
    2926,     0,  2881,  2927,  2928,  2884,  2885,  2886,  2929,  2930,
    2931,  2887,  2932,  2933,     0,     0,  1711,     0,  2889,  2935,
    2890,  2891,     0,  2936,  2892,  2893,  2894,  2937,  2938,  2895,
    2896,  2897,     0,  2898,     0,     0,     0,     0,     0,     0,
    2939,  1485,  2900,     0,     0,  1718,     0,  2901,     0,  2940,
    2903,     0,  2904,     0,  2905,  2906,  2907,  2908,  1711,  3264,
    3140,     0,  1581,     0,  2909,  2941,     0,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2918,  2883,  2882,  2934,  2888,
    2899,  2902,     0,     0,    57,    18,    84,    58,    85,    19,
      65,    66,    21,    20,    32,    31,    90,    91,    51,    15,
      79,    59,   124,   123,   125,    38,    34,    73,    27,    28,
      35,    39,    61,    46,    52,   102,    60,    22,    56,    83,
      62,    88,    45,     9,    10,    47,    77,    11,    48,    78,
      12,    49,    13,    67,    92,    30,    63,    89,    64,     3,
      41,    75,    71,     8,    53,    54,    55,    80,    81,    82,
     107,    87,   119,    37,   116,    96,    97,   113,    98,   114,
       6,    99,    50,    14,   110,   109,   111,    74,    42,    76,
     108,    29,    24,   112,    16,    17,   115,    86,   105,   101,
     120,   118,   126,   103,    68,     4,     5,    93,    23,    44,
       7,    26,    25,    43,    36,   122,    33,  1577,    95,   106,
      94,   100,    72,   104,   121,    70,   117,  1672,  1671,  1720,
    1675,  1696,     0,  1686,  3360,  3361,    40,  1697,   128,   129,
     134,  3029,  3081,  3082,  3083,  3163,  3114,  3115,  3108,  3124,
    3134,  3123,  3127,  3135,  3122,  3141,     0,   131,   133,   135,
     138,   132,   127,   130,   137,   142,   136,   141,   139,   140,
     143,   144,   145,  3362,  1920,  3359,    69,  3099,  3098,     0,
    3163,     0,  3392,  2284,  2285,  2286,  2287,  2289,  2290,  2291,
    2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,  2301,
    2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,
    2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,
    2323,  2324,  2325,  2326,  2327,  2331,  2333,  2334,  2335,  2336,
    2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,  2346,  2347,
    2348,  2349,  2350,  2351,  2352,  2354,  2355,  2356,  2357,  2358,
    2360,  2361,  2364,  2365,  2366,  2368,  2369,  2370,  2371,  2374,
    2375,  2376,  2378,  2380,  2381,  2382,  2383,  2384,  2386,  2387,
    2389,  2390,  2392,  2393,  2394,  2395,  2397,  2398,  2399,  2400,
    2401,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,
    2412,  2413,  2414,  2415,  2416,  2417,  2419,  2420,  2421,  2422,
    2423,  2424,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2434,
    2436,  2437,  2438,  2440,  2441,  2444,  2445,  2446,  2447,  2448,
    2449,  2450,  2451,  2452,  2453,  2454,  2456,  2458,  2460,  2461,
    2462,  2463,  2465,  2466,  2469,  2472,  2470,  2471,  2473,  2474,
    2475,  2476,  2477,  2480,  2482,  2483,  2486,  2487,  2488,  2489,
    2490,  2491,  2493,  2494,  2495,  2496,  2497,  2498,  2500,  2502,
    2503,  2504,  2505,  2506,  2507,  2509,  2510,  2511,  2512,  2513,
    2514,  2515,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,
    3047,  2551,  2552,  2553,  2554,  2555,  2556,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,  2568,  2569,  2570,
    2571,  2572,  2573,  2574,  2576,  2577,  2578,  2579,  2580,  2582,
    2583,  2584,  2585,  2288,  2322,  2328,  2329,  2330,  2332,  2345,
    2353,  2359,  2362,  2363,  2367,  2372,  2373,  2377,  2379,  2385,
    2388,  2391,  2396,  2402,  2418,  2425,  2433,  2435,  2439,  2442,
    2443,  2455,  2457,  2459,  2464,  2467,  2468,  2478,  2479,  2481,
    2484,  2485,  2492,  2499,  2501,  2508,  2516,  2517,  2528,  2529,
    2540,  2549,  2550,  2567,  2575,  2581,  3065,  2272,  2281,  2282,
    2283,  3040,  3061,  3067,  3388,  3066,  2280,  3214,     0,     0,
    3308,  3309,  3310,  3311,  3312,  3313,  3363,  3364,  3365,  3366,
    3367,  3369,  3368,  3176,  3335,  3372,  3175,  3373,  3179,  3374,
    3375,  3376,  3377,  3336,  3378,  3178,  3370,  3332,  3180,  3173,
    3174,  3333,  3282,  3283,  2249,  3334,  3331,  3371,  3068,  3330,
    3184,  3183,  1661,  3387,  2248,  1662,     0,  3186,  3314,  3315,
    3316,  3317,  3319,  3318,  3320,  2942,  2943,  2944,  2945,  2946,
    2947,  2948,  2949,  2950,  2951,  2952,  2953,  3345,  2954,  2955,
    2956,  3358,  2957,  2958,  3346,  2959,  2960,  2961,  2962,  2963,
    2964,  2966,  2967,  2968,  2969,  2971,  2972,  2973,  2974,  2975,
    2976,  2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,
    2986,  3347,  3348,  2987,  2988,  2989,  2990,  2991,  2992,  2993,
    2994,  2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,
    3004,  3005,  3006,  3008,  3009,  3010,  3011,  3012,  3013,  3349,
    3014,  3015,  3016,  3350,  3017,  3018,  3019,  3351,  3020,  3021,
    3022,  3023,  3024,  2965,  2970,  3007,  3355,  3356,  3357,  3344,
    3137,  3321,  3343,  3354,  3352,  3353,  3147,  3143,  3151,  3146,
       0,     0,     0,     0,  3163,  1484,  1483,  1469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   805,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3037,     0,  1495,   444,   443,  1576,  1555,   806,     0,
    1472,   477,     0,     0,     0,     0,     0,     0,     0,  1000,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     237,     0,     0,   501,   500,     0,     0,     0,  1208,   506,
       0,   965,   694,     0,   693,     0,     0,     0,     0,     0,
       0,   794,  3046,  3041,  3051,     0,  3044,  3045,  3330,     0,
    3479,  2470,  3077,  3078,  3477,  2533,  1663,   315,   318,   319,
     316,   317,     0,  1323,  1324,  1326,     0,     0,  1336,  1037,
    1038,     0,  1036,     0,  1040,     0,     0,     0,     0,  1032,
       0,     0,     0,     0,     0,  1039,  1029,     0,  1026,     0,
       0,     0,  1035,     0,  1030,  1045,     0,     0,     0,  1473,
       0,  3129,  3130,  2392,  1621,   507,     0,     0,  1601,     0,
    1599,  1596,  1597,  1577,  1586,  1598,  1591,  1593,  1592,  1594,
    1590,  1595,  2285,  1146,  2300,  1146,  2378,  1143,  1144,  1146,
    1146,  1146,  2493,     0,     0,  1118,     0,  1129,  2276,  1146,
    2277,  3388,  1151,   567,   567,   567,     0,  1150,  1155,   567,
    1466,  1504,  2253,  1710,     0,  2300,  2378,  1119,  1465,  2551,
    1613,     0,     0,     0,  1340,     0,  1341,     0,  2511,  1477,
     299,  3328,  2522,  2905,  2551,  3329,   298,   293,   294,  3323,
    3324,  3326,   267,  3327,  3325,  3322,  2290,     0,     0,  1150,
       0,  1474,  1475,  1102,  1717,  1715,  2234,     0,     0,  2308,
       0,  2321,  2421,   290,  2506,  2512,  2522,  2905,  2551,  2583,
     246,   256,   251,     0,   308,  2522,  2905,  2551,     0,  1495,
       0,  1687,  1812,  2244,     0,     0,  3138,  1468,  1467,  1580,
       0,  1583,     0,  1774,  2488,  1691,  1693,  1585,  1684,     0,
       0,  3028,  1579,  1714,  1714,     0,  1714,     0,  1676,  1684,
    1679,  1683,     0,     0,     0,     0,  1485,     0,  3106,  3134,
    3113,  3169,  3110,     0,     0,  3159,  3155,  3152,  3160,  3161,
    3154,  3142,  1909,  1910,  1911,  1908,  1921,  1907,     0,  3087,
    1912,  3126,  3093,     0,  3101,  3100,  3405,  3406,  3216,  3039,
    3058,     0,     0,     0,     0,     0,     0,     0,  3185,  3187,
    3189,  3149,  3148,  3144,     0,     0,     0,     0,  3274,  3275,
    3273,     0,  3270,  3272,     0,  3169,     0,  3339,  3333,  3342,
       0,  2254,  3334,  3331,  3330,     0,  1048,     0,   173,  1196,
       0,     0,     0,     0,  2248,     0,     0,     0,     0,     0,
       0,     0,  2390,     0,     0,     0,  2138,  2312,  2371,  2148,
    2146,  2147,  2140,  2141,  2142,  2143,  2144,  2145,     0,  1321,
    2139,     0,   215,   173,     0,     0,  2390,     0,     0,     0,
       0,     0,  2390,     0,     0,     0,     0,     0,   215,  2424,
     173,  2390,     0,     0,     0,     0,     0,     0,     0,  1489,
       0,     0,     0,  1491,  1494,  1470,  1558,     0,  2244,     0,
       0,  1079,  1069,     0,  1080,  1070,  1075,     0,  1082,     0,
       0,  1072,     0,     0,     0,  1083,     0,  1071,  1073,  1085,
    1074,  1081,     0,     0,  1076,  1077,     0,     0,     0,  1481,
     567,   450,     0,     0,     0,     0,   173,  1545,     0,  2390,
     173,     0,     0,   505,   504,   173,   503,   502,  2312,  2371,
       0,  1235,   173,  2390,     0,   239,   876,   809,     0,     0,
     954,  2424,   173,     0,     0,     0,     0,     0,     0,   697,
       0,     0,     0,  1211,     0,     0,   793,   806,     0,  3050,
    3056,     0,  3048,  3217,  3480,  3478,  3172,     0,  1327,   291,
     292,  1325,  2390,     0,   392,     0,     0,  2390,  1532,  1034,
    1027,     0,     0,  1033,  2390,     0,  2390,  2274,   230,     0,
    1031,  2312,  2371,  2390,     0,     0,  2390,   222,  2390,     0,
    2390,   392,  2390,   810,     0,  2390,     0,  2390,  2424,   224,
       0,     0,     0,  2390,   392,  1046,     0,     0,  3410,  3414,
       0,  3412,  3407,  3128,  3182,  3181,  3080,     0,  3491,     0,
    1663,  1600,  1697,  1606,     0,  1602,  1609,  1605,  1601,  1146,
    1145,     0,  1146,     0,  3501,  1146,     0,  1146,     0,  3501,
    1146,     0,     0,     0,  1146,  2278,  2279,     0,     0,  3500,
    3496,  3499,  1120,  1130,     0,  1152,     0,     0,  1159,  1158,
    1157,     0,     0,     0,  1160,  1816,  1639,     0,  1127,     0,
    1125,     0,  1463,  1480,     0,     0,     0,     0,  1211,  1343,
    1343,  1343,  1476,   297,   295,     0,     0,     0,     0,     0,
       0,  1482,     0,     0,     0,     0,  3394,  2260,  2149,  3393,
       0,  2871,  2872,  2873,  2209,     0,  3335,  2874,  2875,  2921,
    2047,  2034,  2043,  2048,  2035,  2037,  2044,  2876,  2877,  2351,
    2878,  2879,  2267,  2880,  2881,  1864,  2885,  2886,  2887,  2039,
    2041,  2889,  2890,     0,  2268,  2892,  2893,  2452,  2895,  2896,
    2898,  2900,  2045,  2903,  2904,     0,  2905,  2906,  2907,  2908,
    2266,     0,  2046,  2909,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,     0,  2883,  2882,  2888,     0,     0,  2241,     0,
    2011,     0,  1856,  1857,  1879,  1880,  1858,  1885,  1886,  1898,
    1859,     0,  2240,  1923,  2101,  2009,  2030,  2017,     0,  2008,
    2010,  2004,  1700,  2233,  2235,     0,  2005,  2256,  2216,  2270,
    2269,  3388,  2224,  2259,  2257,  2258,     0,     0,     0,   259,
       0,     0,  3263,   310,     0,   311,  2242,  2522,   247,   289,
     261,   288,   262,   260,     0,  2310,   248,     0,     0,   249,
       0,     0,     0,     0,     0,     0,     0,   304,  1471,     0,
    1814,  1813,     0,     0,  2222,  2245,  1055,     0,  1568,  1569,
    1567,     0,  1564,  1566,  1582,  1577,  2229,  2228,  2230,     0,
    1692,     0,     0,     0,  1674,  1673,  2379,  2508,  1570,  1585,
    1712,  1713,     0,     0,     0,     0,     0,     0,     0,     0,
    1764,  1728,  1729,  1731,  1761,  1765,  1773,     0,  1680,     0,
       0,  1818,     0,  1775,  3027,  3169,  3170,     0,  3164,     0,
    3163,  3163,  3157,  3156,  3153,     0,     0,     0,     0,     0,
       0,     0,     0,  3084,   788,  3086,   785,     0,     0,  3060,
       0,  3064,  3062,     0,  3209,  3212,     0,  3210,  3211,  3213,
       0,  3218,  3219,     0,     0,     0,  3401,     0,     0,  3200,
    3188,  3195,  3197,  3199,  3198,  3207,  3203,  3206,  3208,  3150,
    3163,  3281,     0,  3276,  3279,     0,  3271,     0,     0,     0,
    2255,     0,     0,     0,     0,  1049,     0,     0,     0,     0,
       0,     0,   172,  1530,   301,  1528,     0,     0,     0,     0,
       0,     0,     0,  1537,     0,     0,   228,   229,   821,   806,
       0,     0,  2390,     0,     0,     0,     0,     0,  1275,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,  1276,  1274,
    1277,     0,     0,     0,   303,  1286,  1307,  1310,     0,  1186,
       0,     0,     0,     0,     0,  1394,     0,     0,  1394,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   325,   337,   378,   387,     0,
       0,  2390,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   177,     0,     0,     0,     0,     0,     0,   772,   784,
       0,     0,     0,     0,     0,   781,     0,   173,   329,   765,
     769,     0,     0,     0,   885,   884,  1535,  1534,     0,     0,
       0,  1394,     0,   320,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   436,
     437,     0,     0,     0,   177,     0,     0,     0,     0,   331,
       0,     0,     0,   150,  2273,     0,  3094,     0,  1490,  1487,
    1488,     0,  1493,     0,  1554,     0,     0,     0,     0,  1087,
       0,  1084,     0,     0,  1078,  2312,  2371,     0,     0,     0,
       0,  1093,  1092,     0,     0,   480,   449,     0,     0,  1867,
    1896,  1874,  1896,  1896,  1863,  1863,  1876,  1865,  1903,     0,
    1896,  1863,  1868,     0,  1866,  1906,  1906,  1891,     0,  1848,
    1849,  1850,  1851,  1877,  1878,  1852,  1883,  1884,  1853,  1920,
    3340,  1863,  3341,  3338,  3337,     0,     0,   963,     0,  1507,
    1544,     0,     0,     0,   815,     0,  2390,     0,   175,  1001,
       0,   952,   506,     0,   175,     0,     0,   233,     0,   880,
       0,     0,     0,     0,     0,     0,   900,   899,     0,     0,
       0,   953,     0,   175,     0,   150,     0,   768,  2390,     0,
     567,   567,   696,   507,     0,     0,     0,  1210,  1213,     0,
       0,     0,     0,  3054,  3049,  3052,     0,  3042,  3056,  1666,
    1668,  1667,     0,  1665,     0,   392,   390,   391,   949,  1335,
       0,     0,  1028,     0,     0,   392,     0,     0,  2390,   392,
    2390,     0,  2390,     0,     0,   392,   392,     0,     0,     0,
       0,   881,     0,  1044,  1042,  1041,  1043,     0,     0,     0,
       0,     0,   162,   160,  2390,   392,     0,     0,  1023,  3408,
       0,     0,  3411,     0,  3131,  2159,     0,  3497,  1618,  3494,
       0,  1588,  1697,     0,   278,   279,   277,  1607,   280,  1608,
    1604,  1697,     0,  1138,     0,  3501,  3502,  1123,     0,  1133,
       0,  3501,  1121,     0,  1134,  1131,  1132,     0,     0,     0,
    3495,  3379,  3385,  1137,     0,     0,   568,   570,     0,     0,
    2336,  2350,     0,  2380,  2411,  2412,  2512,  2518,     0,  2544,
    2555,  2478,     0,  1161,  1191,  1156,     0,     0,  1649,  1128,
    1126,  1464,  1611,  2165,     0,  1697,     0,     0,  1342,  1339,
    1338,  1337,   296,   268,     0,     0,     0,  1193,  2511,  1479,
    1101,   806,     0,     0,  2014,  2015,  1895,  1882,  2208,     0,
       0,  1890,  1889,     0,     0,     0,     0,     0,  1872,  1871,
    1870,  2013,  2173,     0,  1869,     0,     0,     0,     0,  1896,
    1896,  1894,  1943,     0,  1873,     0,     0,  2186,     0,  2192,
       0,     0,     0,     0,  1902,     0,  1900,     0,     0,  1979,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1927,  1928,     0,  3336,  2011,  2159,     0,  2012,
    2263,     0,     0,  1888,     0,  1920,  2149,     0,  2594,  2595,
    2596,  2597,  2589,  2599,  2600,  2601,  2602,  2590,     0,     0,
    2603,  2604,  2591,  2864,  2605,  2606,  2607,  2227,  2824,  2865,
    2825,  2826,  2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,
    2616,  2617,  2618,  2827,     0,  2619,  2620,  2621,  2622,  2623,
    2624,  2626,  2627,  2628,  2629,  2633,  2634,  2635,  2636,  2637,
    2829,  2830,  2638,  2639,  2640,  2641,  2642,  2643,  2644,  2645,
    2646,  2647,  2648,  2649,  2650,  2651,  2652,  2654,  2655,  2658,
    2659,  2660,  2831,  2661,  2662,  2832,  2665,  2833,  2666,  2668,
    2866,  2669,  2670,  2671,  2834,  2672,  2674,  2675,  2677,  2157,
    2678,  2679,  2680,     0,  2681,  2683,  2684,  2685,  2686,  2687,
    2837,  2688,  2689,  2690,  2691,  2838,  2839,  2840,  2692,     0,
    1957,  2693,  2694,  2695,  2696,  2697,  2841,  2698,  2155,  2700,
    2701,  2702,  2703,  2704,  2706,  2707,  2708,  2709,  2710,  2711,
    2713,  2715,  2716,  2717,  2842,  2843,  2719,  2720,  2844,     0,
    2722,  2723,  1959,  2724,  2845,  2725,  2846,  2726,  2727,  2728,
    2729,  2730,  2731,     0,  2847,  2868,  2848,  2734,  2735,  2736,
    2738,  2849,  2850,  2743,  2741,  2742,  2744,  2745,  2746,  2747,
    2750,  2751,  2752,  2851,  2753,  2754,  2755,  2756,  2757,  2758,
    2759,  2760,  2761,  2763,  2764,  2765,  2766,  2767,  2768,  2853,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2778,  2779,  2780,
    2781,  2854,  2782,  2783,     0,  2784,  2856,  2787,  2788,  2789,
    2790,  2791,  2792,  2793,  2794,  2857,  2796,  2797,  2588,  2798,
    2799,  2800,  2858,  2859,  2803,  2860,  2804,  2861,  2805,  2806,
    2807,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,
    2819,  2862,  2863,  2869,  2817,  2818,  2820,  2821,  2822,  2823,
    2598,  2625,  2630,  2631,  2632,  2828,  2653,  2656,  2657,  2663,
    2664,  2667,  2835,  2836,  2673,  2676,  2682,  2699,  2867,  2705,
    2712,  2714,  2718,  2721,  2732,  2733,  2737,  2739,  2740,  2748,
    2749,  2762,  2852,  2776,  2777,  2855,  2785,  2786,  2795,  2801,
    2802,  2148,  2146,  2147,  2140,  2141,  2142,  2143,  2144,  2145,
    2153,  1940,     0,  2239,  2586,  2587,  2238,     0,  2103,     0,
    1939,     0,  1777,  1699,     0,     0,  2261,  2217,     0,  3386,
    3389,  2006,  3260,  3259,  3258,  3257,  3228,     0,  3222,  3223,
       0,  3261,  3262,   312,   313,   309,     0,     0,   264,   263,
       0,   286,   287,   258,   285,     0,   281,   282,   266,  2092,
    2091,   265,   257,   254,   252,   269,   271,   272,   255,   253,
     307,   305,     0,     0,     0,  2219,  2218,  2251,  2223,     0,
       0,   392,  3163,  1562,     0,  1559,     0,     0,  2232,     0,
    1694,     0,  2246,     0,  1585,  1578,  1585,  1571,  1690,  1689,
    1721,  1722,  1228,  1688,  1748,  1749,     0,     0,     0,     0,
    1770,  1768,  1739,  1732,  1738,     0,     0,  1736,     0,  1740,
    1923,  1763,  1678,  1726,  1727,  1730,  1677,     0,  1766,     0,
    1649,  1764,  1731,  1636,     0,     0,  1819,     0,     0,  3171,
    3169,  3109,  1848,  3163,  3102,  3163,  3158,  3090,  1914,  1915,
    1916,  1917,  1918,  1919,  3091,     0,  3088,  1913,  3089,   786,
     787,     0,     0,     0,  3057,     0,  3038,  3063,  3194,  3303,
    3226,     0,  3227,     0,     0,  3191,     0,  3201,  3204,  3202,
    3205,     0,  1848,  3382,  3277,  3382,  1848,  1250,  1252,     0,
    1251,     0,  1254,     0,  1263,     0,     0,  1249,  1268,     0,
    1257,  1255,     0,     0,     0,     0,     0,     0,  1050,     0,
       0,     0,     0,     0,     0,  2544,   300,  1526,     0,     0,
       0,     0,  1195,  1194,     0,     0,  1215,     0,     0,     0,
    1540,   556,     0,   389,     0,     0,     0,     0,     0,     0,
       0,     0,   947,   944,     0,     0,   943,     0,   819,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   322,   855,
       0,  1394,     0,   888,     0,  1284,     0,     0,  1287,  1283,
       0,     0,     0,  1285,  1280,  1281,  2512,  2522,  2551,   302,
    1288,     0,     0,  1309,     0,  1308,  1306,  1238,     0,  1239,
       0,     0,     0,     0,     0,     0,   654,   339,   352,     0,
    1393,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   428,   392,     0,     0,     0,     0,     0,   373,     0,
     381,   380,     0,     0,     0,     0,     0,     0,   385,     0,
       0,     0,     0,     0,   384,   375,   392,     0,     0,   379,
       0,     0,     0,     0,     0,     0,  1394,     0,   333,     0,
       0,     0,     0,     0,     0,  1322,     0,     0,   218,     0,
     214,   217,     0,     0,     0,     0,   771,   783,     0,   775,
     776,   773,   777,   778,     0,     0,     0,     0,     0,     0,
     770,     0,     0,   878,   877,   883,     0,     0,     0,     0,
       0,     0,     0,     0,  1346,  1345,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,     0,     0,     0,     0,
       0,   221,   891,   892,     0,   893,     0,   219,   220,     0,
       0,     0,     0,     0,     0,   156,     0,     0,     0,     0,
     276,  1486,  1492,  1557,  2252,  1556,     0,     0,     0,  1086,
       0,     0,     0,     0,     0,     0,     0,  1088,  1089,  1090,
    1091,     0,     0,     0,     0,     0,   454,   455,   173,   453,
       0,  1848,     0,  1844,  1840,  1909,  1908,  1907,     0,  1854,
    1863,  1860,   964,     0,   968,   971,     0,  1505,   527,     0,
       0,   812,   855,     0,   509,   226,     0,     0,     0,     0,
     171,   237,   239,   507,     0,   238,   240,   242,   243,   244,
     241,   245,   875,   879,     0,   808,     0,     0,     0,     0,
       0,   901,   905,   904,   908,   906,     0,   902,     0,     0,
    1836,     0,   213,     0,   147,     0,   764,   767,     0,  3035,
       0,   509,   601,   403,     0,     0,   567,     0,   951,     0,
       0,     0,  1212,     0,     0,     0,     0,     0,     0,  3055,
       0,     0,     0,     0,  1664,     0,  1313,     0,  1533,  2390,
     392,     0,  1311,   231,  2275,     0,  1024,     0,     0,     0,
       0,     0,  1315,  1020,   223,     0,   392,   392,   811,     0,
     392,   225,     0,     0,     0,   803,   392,  1047,  3409,  3415,
    3413,  1620,     0,  3498,  3492,  3493,  1668,  1589,  1603,  1587,
    1135,  1142,  1124,  1141,  1140,  1122,  1139,  1136,  3193,     0,
       0,  3384,     0,  1153,     0,   566,     0,     0,     0,  1167,
    1168,     0,     0,  1166,  1184,  1169,     0,  1171,  1163,  1162,
    1172,  1174,  1173,     0,     0,  1193,     0,  1646,     0,  1644,
       0,  1817,  1648,  1637,  1612,     0,  1610,  1615,  1617,  1616,
    1614,     0,   691,     0,     0,  1150,     0,     0,   392,  1478,
       0,  1103,  1104,  1110,     0,     0,     0,     0,     0,  1111,
    1107,  1108,  1109,  1112,  1113,  1114,     0,     0,     0,  2169,
       0,  2170,     0,     0,     0,  2207,  2201,     0,     0,     0,
       0,     0,     0,  2177,  2178,  2179,  2176,  2180,  2175,     0,
       0,  2181,  2174,     0,     0,     0,     0,     0,  1893,  1892,
       0,     0,     0,     0,     0,     0,     0,  1982,  2017,     0,
       0,  2133,     0,  2159,  2191,     0,  2018,     0,     0,  1904,
       0,     0,     0,     0,     0,     0,     0,  2159,  2197,     0,
       0,     0,     0,  1923,  2090,     0,  2087,     0,     0,     0,
       0,     0,  2064,     0,     0,  2224,     0,     0,     0,     0,
    2264,  1924,  1941,  2237,     0,  2226,     0,     0,  1925,  1948,
       0,  2198,  1975,     0,  1980,  1963,     0,  1956,     0,  1961,
    1965,  1944,  2227,  2158,     0,  2156,     0,     0,  1942,     0,
    1937,  1935,  1936,  1929,  1930,  1931,  1932,  1933,  1934,  1938,
    2137,  2135,  2136,     0,     0,     0,  2111,     0,     0,  1960,
    2382,  2421,     0,  1711,  1711,  1711,  1698,  1709,     0,  1831,
    2236,     0,     0,     0,     0,  2022,     0,  2163,  1720,  2161,
    2254,  3391,  3390,  2225,     0,     0,     0,  2243,     0,     0,
    1920,     0,   306,  1815,  2220,     0,  1053,  1054,  1052,  1848,
    1585,  1565,  1561,  1560,  2231,  1584,     0,  1697,  1572,  1573,
       0,  1226,  1227,     0,  1231,  2900,  2509,     0,     0,     0,
       0,  1741,  1771,     0,  1762,     0,  1742,  2256,  2257,  1743,
    1746,  1747,  1737,  1772,  1767,  1682,  1681,     0,  1834,     0,
       0,  1633,  1626,  1820,     0,  1777,  1651,  1653,  1654,     0,
    2224,  3107,  3165,  3112,  3133,  3103,  3136,  1922,  3085,  3125,
       0,  3059,  3229,  3230,     0,  3220,  3221,  3190,  3196,  3267,
       0,  3383,     0,     0,  1253,     0,  1863,  1264,     0,  1248,
       0,  1247,  1863,     0,  1265,     0,  1863,     0,     0,     0,
    1422,  1348,  1398,  1051,  1423,  1349,  1399,  1424,  1350,  1527,
       0,  1529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   926,  2390,   392,  1538,
    1425,     0,  1351,   388,  1539,  1400,  1543,   946,   945,     0,
       0,  1401,     0,   820,     0,     0,   825,   826,   827,     0,
       0,     0,   828,     0,  2312,  2371,     0,   833,   840,   845,
     835,     0,   846,   841,     0,     0,     0,     0,     0,     0,
     852,   854,     0,     0,     0,     0,     0,     0,     0,  1291,
    1293,  1292,  1278,  1279,  1426,  1354,     0,  1402,  1290,  1289,
    1237,     0,  1355,   227,     0,     0,   326,   340,     0,     0,
       0,  2729,  2788,  2862,   654,   649,   647,   653,   623,   650,
     415,  2592,  2593,   861,   926,   420,   418,   424,  1396,   359,
     372,   367,   368,   366,  2390,   392,   420,  2677,   427,  2390,
     392,     0,     0,     0,     0,   369,   364,   365,   361,   374,
    2289,  2352,  2523,     0,   865,   867,     0,   872,   382,  1369,
       0,   399,   398,   397,     0,   386,     0,   404,   407,   383,
     357,   377,   360,   358,     0,   612,   613,     0,   435,   354,
       0,   420,     0,   338,     0,     0,     0,     0,     0,     0,
       0,  2250,     0,     0,  1317,     0,     0,     0,   216,  1383,
       0,     0,     0,   184,     0,     0,     0,     0,   209,     0,
     209,     0,   176,   178,   192,   193,     0,  1432,  1359,     0,
       0,   330,   766,   774,   779,  1363,   782,  1412,   780,  1439,
    1360,     0,  1394,     0,   321,     0,  1361,     0,  1406,  1434,
    1385,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1546,     0,     0,     0,     0,     0,   392,     0,     0,     0,
    1396,  2390,   392,  1433,     0,  1390,     0,  1420,     0,   438,
       0,  1384,     0,     0,   332,  1365,  1414,  1392,  1435,     0,
       0,     0,     0,     0,     0,   163,   164,     0,     0,     0,
       0,     0,   155,   154,   149,     0,     0,   274,   273,   275,
       0,     0,     0,     0,     0,     0,     0,     0,  1095,  1062,
    1094,     0,     0,     0,  1056,   479,   447,   448,   450,   459,
       0,  1845,  1841,     0,     0,     0,     0,     0,     0,  1861,
     967,     0,     0,     0,     0,  1525,  1525,  1525,  1525,  1525,
    1525,  1525,  1506,  1536,     0,   173,     0,     0,     0,   814,
     854,   861,     0,     0,     0,     0,     0,   508,   512,   519,
     516,   517,   518,     0,     0,     0,     0,   194,   174,     0,
    1009,     0,   567,     0,   239,   232,     0,     0,     0,   403,
     962,   960,   959,   961,     0,     0,     0,   984,   958,     0,
    1835,  1837,     0,   161,     0,     0,     0,     0,     0,   511,
       0,   570,     0,     0,   605,     0,     0,     0,     0,   403,
       0,   980,  3337,   950,     0,     0,  1242,     0,  1260,  1243,
       0,     0,     0,  1297,  1302,  1298,  1270,     0,   956,   791,
    3053,  3047,  1669,  1670,     0,   392,     0,     0,   856,   392,
     392,     0,   392,     0,   392,   392,     0,  1461,   882,     0,
     934,     0,     0,   392,  1022,  2160,     0,  3192,  3380,  1154,
     569,     0,     0,     0,     0,  1165,     0,   789,  1170,     0,
    1183,  1178,  1180,     0,  1187,  1647,  1640,  1642,  1641,     0,
       0,  1638,  2166,  1021,     0,   763,     0,     0,   392,     0,
    1188,     0,  1105,  1106,     0,     0,  1115,     0,     0,  1716,
    2167,  2168,     0,     0,  2929,  2204,     0,     0,  2202,     0,
       0,  2060,     0,  2036,  2038,  1862,  2050,     0,  1875,  2061,
    2062,  2040,  2042,     0,  2150,     0,     0,  2051,  1984,  1985,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1997,  1996,  2052,  2132,     0,     0,  2189,
    2190,  2053,     0,  2021,  2016,  1905,  1906,  1906,     0,     0,
    2196,     0,     0,     0,  2058,  2067,     0,     0,     0,     0,
       0,  2074,     0,  2095,     0,     0,     0,     0,  2215,  2211,
    2063,  2065,  2007,  2160,  1897,  1898,     0,     0,     0,     0,
       0,     0,     0,     0,  1981,  1964,  1958,     0,  1962,  1966,
       0,     0,     0,     0,  1950,  1976,  1946,     0,     0,  1952,
       0,  1977,     0,     0,     0,  2029,  1711,  1711,  1711,  1711,
    1708,     0,     0,     0,     0,  2509,     0,     0,  1798,  1776,
    1778,  1785,  1798,  1803,  2031,  1829,  2032,     0,  2244,     0,
    1751,  1720,  1720,  1720,  2028,     0,     0,     0,  1719,  3242,
    3244,  3245,  3246,  3247,  3248,  3250,  3251,  3253,  3254,  3255,
    3243,  3249,  3252,  3256,  3233,  3234,     0,  3224,  3225,   250,
       0,   283,   270,     0,  3267,  1563,  2247,     0,  1723,     0,
    2151,  1231,  1229,  1230,  1725,  1744,  1745,     0,  1735,  1769,
    1733,  1635,     0,  1633,  1628,     0,  1629,  2224,     0,  1625,
    1658,     0,     0,  1834,     0,  1657,     0,  3167,  3095,     0,
       0,  3266,  3269,  3280,  3278,  3105,     0,  1863,  1245,  1246,
       0,  1269,     0,  1421,  1347,  1397,  1525,  1198,  1199,     0,
    1197,     0,     0,     0,   555,  1214,     0,     0,     0,   926,
       0,     0,   559,     0,  1541,     0,  1440,  1382,   822,   823,
       0,   834,     0,   843,   842,     0,     0,   830,     0,     0,
       0,     0,   829,   848,   795,   849,   851,     0,     0,   850,
     853,   858,  1394,     0,   889,  1371,     0,  1418,  1272,  1294,
       0,  1240,     0,     0,     0,   654,     0,     0,     0,     0,
       0,     0,   623,   648,   647,     0,   652,     0,     0,   627,
       0,   527,   353,   419,     0,     0,     0,   341,   351,     0,
       0,   356,  2677,     0,     0,   349,   370,   362,   371,   363,
     869,   870,   868,   864,     0,   871,   873,   430,     0,   401,
       0,     0,     0,   376,     0,     0,     0,     0,     0,  1428,
       0,  1394,     0,   334,  1367,     0,  1416,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,  1403,
       0,     0,     0,   181,   180,     0,   191,     0,     0,   189,
       0,     0,   200,   201,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   439,   394,     0,   987,     0,     0,     0,   441,     0,
    1344,     0,     0,     0,   165,   169,   168,   170,   167,   166,
       0,   157,   158,     0,     0,  1427,  1356,  1057,     0,     0,
    1058,  1066,     0,     0,  1059,     0,     0,  1068,     0,     0,
     446,   456,   926,     0,     0,     0,  1846,     0,  3481,  3489,
    3488,     0,  1920,   969,   978,  2452,   973,  2140,  2141,   976,
     970,   972,   975,   974,   977,     0,  1525,  1524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
       0,     0,   535,     0,     0,  1302,   526,   529,   530,     0,
       0,   815,   818,   816,   817,   847,     0,     0,     0,   548,
       0,     0,   196,     0,     0,   197,   195,     0,     0,   403,
       0,   235,   507,     0,     0,   807,   907,   910,   903,     0,
     983,   985,   955,     0,   861,   148,     0,     0,  1621,   691,
       0,   601,   597,   599,   598,   600,     0,   607,   402,     0,
       0,   691,   607,   979,     0,     0,     0,  1215,  1241,     0,
       0,     0,  1295,  1299,  1296,     0,     0,  1256,     0,  1271,
    1234,  1456,  1457,  1454,  1455,     0,     0,  3070,  1660,  3079,
    1314,     0,   392,  1312,  1025,     0,  1016,     0,  1018,  1316,
     392,   392,   894,     0,   804,     0,     0,     0,     0,  1164,
    1185,     0,  1181,     0,     0,  1147,  1190,  1645,  1643,   689,
       0,  1193,     0,  1148,  1192,     0,     0,     0,     0,     0,
    2171,  1881,     0,     0,  2206,  2200,     0,  2033,  2172,     0,
    2184,  2183,  1983,  2185,     0,  2002,     0,     0,  1994,  1992,
    1993,  1986,  1987,  1988,  1989,  1990,  1991,  1995,  2194,  2193,
    2187,  2188,     0,  2019,  1901,  1899,     0,  2055,  2056,  2057,
    2195,  2068,     0,     0,  2303,  2096,  2072,  2089,  2088,     0,
       0,     0,  2076,     0,     0,  2085,     0,     0,     0,  2212,
       0,  2134,  1887,  1920,  1926,     0,     0,  1949,  2199,  1967,
       0,     0,     0,  1945,     0,     0,     0,     0,  1954,  2150,
       0,     0,     0,     0,  2114,  2109,  2110,     0,     0,     0,
       0,  1702,  1701,  1707,  1798,  1803,     0,     0,  1684,     0,
    1785,     0,  1797,  1783,  1796,     0,     0,  1809,  1807,     0,
    1809,     0,  1809,     0,  1780,     0,  1799,  1781,  1796,  1828,
    1821,     0,  2245,  1830,     0,  1760,     0,     0,     0,     0,
    2164,     0,  2162,  2023,     0,     0,     0,  2221,  3265,  1695,
       0,  1724,  1734,     0,  1832,  1634,     0,     0,  1631,  3497,
       0,     0,  1652,  1633,  1655,  3111,     0,  3166,  3231,  3232,
    1266,     0,     0,  1258,     0,  1204,  1205,  1203,  1206,     0,
       0,     0,   926,     0,     0,   578,     0,  1222,  1222,     0,
       0,   561,   610,  1302,   929,     0,     0,     0,   927,   392,
    1352,     0,   844,     0,     0,   839,   837,   836,   838,   796,
    1438,  1353,     0,     0,     0,     0,  1273,     0,     0,  1370,
     623,     0,     0,     0,   636,   639,     0,     0,   632,     0,
       0,     0,     0,   657,     0,     0,   627,   651,     0,   622,
     621,     0,   421,     0,   533,     0,   346,  1395,     0,     0,
       0,   345,     0,   392,   392,   392,   392,   866,   400,   405,
     406,   409,     0,   571,  1225,     0,     0,   432,   670,     0,
     623,   630,   654,   654,   414,   411,  3336,   661,   662,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1010,   993,     0,     0,  1011,  1012,     0,     0,
       0,  1319,  1320,  1318,   185,     0,   182,   183,   186,     0,
     210,     0,     0,   207,   204,   203,   188,   187,  1380,  1364,
    1413,     0,     0,  1362,     0,  1407,  1377,  1373,     0,     0,
       0,     0,     0,  1437,  1389,  1411,  1436,  1387,  1409,  1386,
    1408,  1388,  1410,  1381,     0,  1839,   990,     0,     0,     0,
     392,   392,   896,  1366,  1415,   152,     0,   151,   153,     0,
    1060,     0,     0,  1061,  1063,   482,     0,   485,   492,   460,
     465,  1545,     0,  1545,     0,   462,   466,  1545,   461,     0,
    1545,     0,  1545,   458,   948,     0,     0,     0,  1842,     0,
    3163,     0,     0,     0,     0,     0,  1847,  1855,   925,     0,
    1516,  1515,  1514,  1518,  1517,  1520,  1519,  1511,  1510,  1523,
    1522,  1509,  1508,  1513,  1512,     0,   531,     0,   539,   543,
     544,   542,   534,  1302,   567,   609,     0,     0,   938,     0,
     813,   509,     0,     0,   545,     0,   513,   199,   198,     0,
       0,     0,   239,     0,     0,   912,   916,   957,     0,  1838,
     890,   403,     0,   509,   691,   615,     0,   514,   520,   521,
       0,   605,     0,   601,     0,     0,   688,  1503,   737,   615,
     760,   981,     0,   982,     0,     0,  1244,  1261,  1262,     0,
       0,  1302,  1301,     0,   798,     0,  3043,   392,   857,   392,
     392,  1462,   935,     0,  1177,  1176,  1175,   790,     0,  1179,
     690,   392,     0,     0,     0,     0,     0,  1117,  1096,  1116,
       0,  2203,  2049,  2059,  2182,     0,     0,  2003,     0,     0,
    2020,  2054,  2910,     0,     0,  2073,     0,     0,  2093,  2094,
    2075,     0,  2441,  2080,     0,     0,     0,  2066,     0,  2214,
    2210,  2265,  1973,  1971,  1968,     0,  1969,     0,     0,  1951,
    1947,     0,  1953,  1978,  2100,     0,  2116,  2113,  1706,  1705,
    1704,  1703,  1784,  1782,     0,     0,  1787,  1794,     0,  1779,
       0,  1808,  1804,     0,  1805,     0,     0,  1806,     0,     0,
    1794,     0,  1720,     0,     0,  2105,  2026,  2027,  2024,  1720,
    2262,  3235,     0,  3238,  3236,  3237,  3241,  1920,     0,     0,
    1627,  1630,  1632,     0,  1659,  1650,  3168,  1259,  1267,  1531,
       0,     0,     0,   557,     0,  1302,     0,     0,     0,  1225,
    1225,     0,  1302,   609,   931,   930,   933,   928,   932,  1542,
       0,   831,   832,  1372,     0,  1419,  1378,     0,  1649,   627,
       0,   635,     0,     0,   643,     0,     0,   416,     0,   643,
       0,   660,     0,   659,     0,   423,     0,     0,     0,     0,
     862,     0,   524,   342,   343,   344,   347,   394,   355,   426,
     425,   348,     0,   611,     0,     0,  1223,   573,     0,   673,
     431,     0,   617,   623,   623,     0,     0,   429,     0,   433,
     411,     0,     0,  1368,     0,  1417,  1375,  1430,  1357,  1404,
       0,     0,   999,     0,     0,     0,     0,  1431,  1358,  1405,
     179,   208,     0,     0,     0,     0,   205,     0,  1649,     0,
       0,     0,     0,  1551,     0,   393,   989,   988,   394,   440,
    1391,   159,     0,  1064,  1065,   483,   173,     0,   457,     0,
     490,     0,   488,   487,   489,     0,   473,     0,     0,     0,
       0,     0,   476,     0,     0,     0,  1843,     0,  1333,  1333,
    3482,     0,  3483,  3484,  3485,  3486,  3487,     0,   926,  1521,
       0,     0,   528,   609,   577,     0,   536,     0,     0,     0,
       0,     0,   522,   523,     0,     0,   861,     0,     0,     0,
     234,   509,   861,   911,     0,     0,     0,   986,     0,   511,
       0,  1619,   614,   679,   510,     0,     0,   607,     0,   605,
       0,   602,     0,   606,     0,  1496,   741,     0,   736,   738,
     740,     0,   759,     0,     0,  1300,     0,  1304,     0,  1255,
    1232,  1831,     0,   802,  3069,  3073,  1334,  1017,  1019,   895,
    1182,  1189,   392,  1097,  1098,  1099,  1100,     0,  1998,     0,
       0,     0,     0,  2069,     0,  2070,  2098,  2097,  2077,  2081,
       0,  2078,  2079,  2213,  1970,  1974,  1972,  1955,  2102,     0,
    1720,  1824,     0,  1827,     0,  1786,     0,     0,  1788,     0,
       0,  1790,  1792,     0,     0,     0,     0,     0,  2248,     0,
    2332,  2882,  2899,     0,  1750,  1752,  1754,  1759,     0,  1685,
       0,  3240,  3239,   284,  2152,  1833,  1656,  1183,     0,   392,
    1222,   609,   579,  2452,   580,  1221,  1228,  1228,     0,   609,
     926,   824,     0,     0,   327,   422,     0,   637,   634,   642,
     641,   645,   640,  1720,  1720,   644,   655,     0,   658,   646,
     620,   626,   860,     0,   532,   396,   408,   572,  1224,   674,
     631,   618,   627,   616,   617,   617,   412,   413,     0,   434,
       0,  1649,     0,     0,     0,  1006,   994,     0,     0,  1013,
     211,   212,   202,   206,     0,   323,  1374,     0,     0,     0,
       0,     0,   392,  1067,   459,     0,   486,   495,     0,   493,
     463,   468,     0,   472,   470,   469,   464,   467,   474,   475,
    1333,     0,  1330,  1329,  3490,   924,     0,   565,   537,     0,
     588,     0,     0,   939,     0,     0,     0,   554,   553,   550,
     549,   551,   552,   547,   546,   886,  1003,   403,  1503,   874,
     913,   914,   909,     0,     0,     0,   601,   597,     0,  3036,
     515,   527,   615,     0,   607,   603,   604,     0,     0,     0,
       0,     0,   742,  1553,     0,  1216,  1303,     0,     0,     0,
     797,     0,     0,   801,   792,     0,  3071,  1149,  2205,  1999,
       0,  2000,     0,     0,     0,  2083,  2082,     0,  2119,  1829,
       0,     0,  1823,     0,     0,  1795,  1811,     0,  1791,  1789,
    1800,     0,  1802,  2023,     0,     0,     0,  1758,     0,  2104,
    2106,     0,  2025,  1200,     0,  1201,  1225,   583,     0,  1231,
    1231,   567,   926,   558,  1379,     0,     0,     0,     0,     0,
       0,   863,     0,   350,   669,   619,   627,   627,     0,     0,
     335,  1376,     0,   997,     0,  1008,  1006,     0,     0,     0,
    1547,     0,  1548,  1549,  1552,   442,   744,   481,   491,     0,
     471,  1328,  1332,  1331,     0,     0,   538,   574,   575,   576,
       0,   540,   584,   585,     0,   936,     0,   941,     0,     0,
       0,     0,     0,  1497,     0,     0,  1503,   605,   601,   677,
     525,   679,   596,   615,     0,  1500,     0,     0,     0,     0,
     739,   403,     0,  1302,  1305,  1460,   800,   799,  3074,  3076,
    3075,     0,  2001,  2086,  2071,  2099,  2084,  2115,     0,     0,
       0,  1822,  1825,     0,  1793,     0,  1801,     0,     0,     0,
    1753,     0,     0,     0,  1228,     0,   926,     0,  1219,  1218,
     577,   560,  1649,     0,   638,     0,     0,   656,   395,   667,
     668,     0,     0,     0,     0,  1004,  1007,   995,  1008,  1015,
    1014,  1649,     0,     0,   452,     0,   494,     0,   564,     0,
       0,     0,   586,     0,   587,   608,     0,   940,     0,   861,
    1002,     0,     0,   915,     0,  1498,   607,   605,   675,   676,
       0,   498,   679,  1501,  1502,   701,     0,     0,   607,  1217,
    1233,  1459,  1458,  1697,  3072,  2870,     0,     0,     0,  2131,
    2120,  2131,  2112,     0,  1810,  1756,     0,  1755,  2107,  2108,
     392,  1231,     0,   562,   581,   588,   328,   633,   417,     0,
    1649,     0,     0,   996,   324,  1550,   746,     0,   445,     0,
     916,   593,     0,   592,     0,   590,   589,   937,   942,   887,
     992,  1503,   919,   615,   607,     0,   496,   699,     0,  1622,
    1624,   711,  1831,  1442,  1697,  1441,  1443,  1451,  1448,  1450,
    1449,  1447,     0,  2124,  2123,  2122,  2126,  2125,     0,  2117,
    2118,  1826,  1757,  1202,  1220,     0,   926,   410,   336,   998,
    1005,     0,     0,     0,     0,   591,   595,   594,  1499,     0,
     917,   920,   923,   921,   922,   679,   615,     0,     0,   700,
     701,     0,     0,   730,  1207,     0,  1452,  1446,  1684,  1671,
       0,     0,  2128,     0,  2129,   582,   563,   745,   451,     0,
       0,   897,     0,   499,   679,   682,   702,   704,   705,     0,
     707,   698,  1623,   720,  1545,  1545,  2376,   721,  1545,  1545,
    2373,  1545,   710,     0,     0,   714,   712,     0,     0,   756,
    1444,  1697,  2121,  2127,  2130,   754,     0,   918,   497,     0,
     625,   685,   681,   703,   706,     0,     0,     0,     0,     0,
       0,     0,     0,   720,  1545,  1545,     0,   721,  1545,  1545,
       0,  1545,   708,   713,   709,     0,     0,     0,   729,   749,
    1445,   752,   753,   743,     0,   677,     0,   678,     0,   684,
     686,   718,   723,     0,   726,   725,   719,   722,   727,   728,
     715,     0,   716,   732,     0,   733,     0,  1525,     0,   750,
     615,     0,   755,   919,     0,     0,     0,   666,     0,   623,
     628,   654,   654,     0,   687,   724,     0,   731,     0,   735,
       0,   746,   692,     0,     0,     0,     0,   671,   624,     0,
     617,   623,   623,     0,   717,   734,   758,   757,   751,     0,
     898,     0,   672,   629,   627,   617,   617,     0,     0,   683,
     665,   627,   627,   680,   754,   663,   664,   748
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5425, -5425,  4650, -5425,  2913, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -1290,   134,  3035, -5425,  -904, -5425,
   -5425, -5425, -5425, -4267, -5425,  1230, -5425,  -371, -5425, -5425,
    1215, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  3752, -5425,
   -5425,  1881, -3055, -5425, -5425,   -16,  3719, -1729,   -24,  3321,
    1535, -5425, -1492, -5425, -5425,  -963,    55, -5425,  3731,   677,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -1207,  -760,
    1317,  -687, -4927, -5425, -5425, -1814, -3843, -5425,   620,  -339,
   -5425, -2806, -1861, -5425, -5425, -5425,  1975, -5425, -5425, -5425,
    1140, -5425,   523,  -630, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425,  -380, -5425, -5425,  -787,   -77,   -98, -3057,  -436, -5425,
   -5425,   463,  -438, -4151, -1724, -5425, -4230, -5425, -5425,   -49,
   -5425, -4948, -5425,  -416, -1832,  1441, -5425, -1078, -1510,  1787,
   -5425,  -302,  -856, -5425,  -241, -5425,  -939,  -786,  -782,  -879,
    -655, -4449, -4954, -4497, -4011,  1452, -3684, -4970, -5424, -5425,
   -4240, -5425, -4695, -5425, -4767, -4183, -2575, -4155,  -263,  1306,
   -3507,   694, -5425, -4305, -3626, -5425, -4719,   656, -5425, -1153,
    -283, -5425, -5425, -5425, -5425, -1096, -4058, -5425, -5425, -5425,
   -3695, -5425, -4393, -5425, -5425, -5425, -5425, -1000, -5425, -5425,
   -5425, -5425, -1084, -1040, -5425, -5425, -5425, -1136, -5425, -5425,
    -647, -5425, -5425, -1083, -5425, -5425, -1169, -5425, -5425,   361,
   -5425, -5425,   409,   443, -5425, -5425, -1925, -1869, -5425, -1012,
   -5425, -5425, -5425, -3585, -5425, -5425, -5425, -5425,   -48, -5425,
   -5425, -5425, -5425,   517, -5425, -5425, -5425, -5425, -5425, -5425,
   -2735,  1955,  1957, -5425, -5425, -3824, -5425, -1256, -5425,   686,
   -3627,  1360, -5425, -5425, -5425,  3003, -5425, -5425, -5425, -5425,
   -5425, -5425, -2003, -5425, -5425,   447, -5425,  1967,  1129, -5425,
   -5425, -5425,  -914, -1106, -1004, -5425, -3548, -5425, -5425, -5425,
   -5425,  -358, -5425, -5425, -5425, -5425, -5425, -5425, -5425, -1317,
   -5425,  1191, -4285, -5425, -5425,   479, -5425, -5425, -5425, -5425,
   -5425,  -846,  -273,  3032, -5425,  -704,  -815, -5425, -5425, -5425,
    -272, -5425, -5425, -5425, -5425, -5425, -5425, -1441, 17960, -1991,
   -5425, -5425, -5425, -5425, -3019, -5425, -5425, -5425, -2389, -5425,
    4948,    37,   318,   458, -5425,  -205,   -75,  3583, -1512, -3251,
     444,  -468, -5425, -2208, -5425, -5425, -5425, -3152, -5425, -5425,
   -5425, -5425, -4153,   473, -5425,  3574, -5425,   497, -5425, -5213,
   -4678, -5044, -4632, -4144, -5425, -5425, -1459, -5425, -5425, -5425,
   -1857,  2289, -1807, -5425, -2794,   499,  1541, -1389, -3386, -4468,
   -1064, -3911, -5425, -4416,  -609, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -1449,  -975, -5425, -5425,  4130, -5425, -4343, -5425,
   -5425, -5425, -5425,  1602, -5425, -5425, -5425, -1842,  1290, -5425,
   -5425, -5425, -5425, -5425,  -842,  -999, -5425, -5425, -5425,   516,
   -5425, -5425, -5425, -5425,  2813, -1306, -1089,  3975,   522, -5374,
   -5425, -5425, -5425, -5425, -3782, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -1379, -5425, -5425, -5425, -5425, -5425, -5425,
   -5425,  2411,  2412,  -107,  -184, -5425, -5425, -5425, -1654, -5425,
   -1297,  3640, -5425,  2947, -5425, -5425, -5425, -5425,  1629,   529,
     533, -5425,  -935,   -67, -5425, -5425,   305, -4070,   -64, -5425,
   -5425, -5425, -5425, -2748,   -62, -5425,   866, -5425, -5425, -3387,
   -5425,   588,   -87,  3659,  1901,   102,  2007,  -247,  -220,  -211,
     -70,  3978,  3420, -5425, -5425, -5425,  -188,  2561, -5425, -1200,
    -349,  -604,  1644,  -978,  2384,  3405,  3407, -5425,  1634,  2415,
   -2565, -2573, -5425, -5425,  -736,  -615, -5425,  -968,  2397, -5425,
    3412, -5425, -5425, -5425,  1622,  1632, -4065,   963, -4047, -4015,
     386,   372, -1049,  -392,  -170,  4029,  3415,   973,  -582, -5425,
   -5425,  -580, -5288,   899, -5425, -5067, -2921, -1328, -2586, -2007,
   -5425, -5425, -1524, 11154, -5425, -5425, -5425, 12883, 18233, -5425,
   -5425, 24348, 24516, -5425, -1369,  1018, 24763, 10496, -1559, -2030,
   -1679, 24344, -2862, -1688, -5425, -5425, -3359, -5425, -4187, -3269,
   -5425, -5425, -5425,  -348,  1033,   425, -5425, -5425, -5425, -5425,
   -5425, -5425,  -715, -5425,  -714, -5425, -5425, -5425,  -702, -4236,
    -791, -1041, -5425,  -930, -5425, 27259,  1686, -5425, -1478, -3350,
   -3329, -4049, -2169, -5425, -5425, -5425, -5425, -5425, -5425, -5425,
   -1870, -3909,  -553,  1767, -5425, -5425,  1872, -5425, -5425, -5425,
   -5425, -5425,  1045, -5425, -5425, -1661, -1234, -3228,  1778, -2606,
   -5425, -1202, -5425,   936,  2548, -1139,  6468, -1631, 22731,  -110,
   -2935, -1658, -1943, -5425,  4431, -4137,    -2,  4040,   667, -1009,
    -155, -1001, 13515, -5425, -5425, -4788,  3563,  5449,  7448, -3840,
   -5425, -5425,   709, -5425, -5425, -5425,  4586,  1207, -5425,  3831,
   -5425,  2022,  3091, -5425, -5425,  2416, -1008,   -55, -5425,  -659,
   -5425,  -116, -5425, -5425, -5425,   290, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425, -5425, -5425,  3453, -5425, -5425, -1599, -5425,
   -5425, -5425, -5425, -5425,  4847,  -388, -5425,  4183,  -375, -5425,
   -5425, -5425, -5425, -5425, -5425, -5425, -5425, -5425,  3465,  2449,
   -5425,  3980, -5425, -5425, -5425,    -1,  3688, -5425, -5425, -5425,
   -1287,  -653,  4002,  4008,  2417, -5425, -5425, -5425, -5425, -5425,
   -5425, -5425, -5425,  2420, -5425, -5425,  1749, -2608,  2425, -5425,
   -5425,   951, -5425, -5425,   418, -5425,   955, -5425,  3564, -5425,
   -5425, -5425,   993, -5425, -5425, -5425,  -626, 19382,   185,    31,
     415,  1473, -5425, 10032, 19100,  -102,  3516,   -61, 15379, 24603,
     266, -5425,  4839,  2424,  1993, -1119, -5425,  3613,  3029, 18292,
   -5425, -1117,   107,  4061, -5425,  1811,  -705, -1274,  3778,  -794,
   -2140, -5425,  5274, -5425, -4217, -5425, -1141,   419,  4182, -1311
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   253,   254,  3095,  3894,   255,   256,   257,   258,
     259,  3885,  3886,   260,  1863,  3155,  3030,  3812,  3967,  3968,
    3814,  4472,  5013,  4473,  5416,  4469,  5009,  5010,   261,   262,
    1949,   263,   264,   265,   266,   267,   268,   269,  1879,   270,
     271,  1414,  2107,  3165,   272,  2876,  1171,  1172,  1173,  2724,
    2725,  3101,  2726,  2713,  1710,  2218,  1904,  1137,  1138,  1865,
    1905,   274,   275,  1704,  2705,   276,   277,   278,  1935,  1936,
    1873,  2158,  5045,  5823,  3765,  3004,  4006,  3766,  3767,  5389,
    5387,  4403,  2995,  1937,   279,  1999,  2000,   280,   281,  3918,
    2047,  6028,  3128,  4540,  4541,  5083,   962,  3125,  5436,  5437,
    5066,  5067,  5443,  5688,  5689,  1070,  2103,  4000,  4631,  3957,
    5156,  3958,  5157,  3959,  3960,  5158,  3943,  4586,  5362,  4587,
    4588,  3961,  5134,  5723,  3962,  2891,  5856,  1548,  2248,  2246,
    4962,  4963,  5710,  4884,  4885,  5926,  5861,  5862,  5863,  6035,
    5163,  4004,  4637,  5166,  5476,  3636,  3005,  5503,  5652,  5653,
    4399,  6197,  4942,  6228,  4969,  4924,  4925,  4926,  5631,  3715,
    3716,  4396,  4394,  3717,  3718,  4934,  4935,  3719,  4979,  6230,
    4971,  6231,  6232,  4972,  4973,  5980,  5739,  6199,  6160,  6161,
    6162,  2129,  4085,   283,   996,  2133,  5889,  6047,  6099,  6103,
    6143,  6144,  6145,  6146,  6149,  6188,  6214,  6215,  5517,  5518,
    5519,  5520,  5954,  5955,  6220,  6221,  6193,  6189,  6222,  1071,
    3205,   997,  1072,  3167,   287,  3196,  1969,  1970,  3038,  4559,
    4068,   288,  1437,  4363,  5533,  5763,  5764,   289,   950,   290,
    2111,   291,   292,  3151,  3949,   293,  2908,  3653,   294,   295,
    3680,  3681,  3682,   296,   297,  4401,  5359,  1938,  3753,  3754,
    3755,  3756,  4425,   298,  2109,  1975,  3174,   299,   300,   301,
     302,   303,  3084,   304,   305,  3168,  2119,  3186,  3187,  5146,
    5494,  5732,  5496,  6089,  6090,  5468,  4342,  4898,   307,   308,
    5127,  5128,  5868,   309,  2906,   310,   311,   312,   998,  2087,
    3143,  3144,  4560,  3208,  4010,  4011,  4619,  4620,   313,  3859,
     314,  4992,  4993,   999,  5871,  5835,  5947,   315,   316,  4996,
    4997,   317,   318,   319,   320,   321,  1058,  1494,  1495,  1855,
     322,  2741,   323,  1388,  3909,   324,  1584,  3347,  5208,   325,
    1095,  1520,  1521,  3169,   327,  1106,  3325,  1108,  2262,  4070,
    4071,  4695,  3293,  1298,   328,   329,  3305,  3328,   330,  1866,
    2882,  2883,  4879,  3170,  1000,  2138,  3211,  3631,  5754,  4886,
    5319,  5377,  3534,  4284,   332,  1001,  1909,  2958,  3214,  4017,
    2854,  2855,  3496,  4656,  2857,  4019,  2858,  1849,  2859,  4024,
    4025,  4026,  4652,  4660,  5527,  5528,   333,  1907,  2956,   334,
     335,   336,  1946,  1318,   337,  1023,  1024,   338,  5702,   339,
    1456,   340,  1127,  2279,   341,   342,   343,  2975,  4409,   344,
     345,   346,  6055,  6105,  6106,  6107,  4665,  5993,   347,  6057,
    1562,   349,   350,   351,   953,  1353,  1354,  1355,  3171,  5515,
     353,   354,  3147,  3942,  4568,   355,   356,  2877,  3621,   357,
     358,   359,   360,  6165,   361,   362,   363,   364,  2024,   365,
    1741,  1742,   366,   367,   957,  1758,  1191,  1745,  1753,   368,
    1074,  1512,  1514,  1515,  1516,  2220,   369,  1566,  3316,  1075,
    1508,  6048,  6049,  1076,  3561,  4295,  4296,  4299,  1077,  3558,
     373,  2268,  3310,  3313,  1078,  3565,  3566,  3567,  3568,  3569,
    4301,  1079,  1097,  1447,  3223,  1080,  1660,   378,   379,   380,
    1200,  1195,  1196,   382,  2682,  3486,  1114,  1762,  1156,  1207,
    4248,  2760,  2761,  2785,  2786,  1771,  1772,  2773,  2777,  2778,
    3546,  3540,  2766,  4835,  5594,  5595,  5285,  2781,  2782,  1774,
    1775,  1776,  2790,   383,  3489,  4229,  4230,  4231,  4812,  4813,
    4827,  4823,  5272,  5581,  4232,  1556,  1782,  4233,  5571,  5572,
    5782,  4830,  4240,  4293,  3989,  3990,  3991,  2860,  3134,  2069,
    1661,  2070,  3141,  1662,  2314,  2072,  1663,  1664,  1665,  2075,
    1666,  1667,  1668,  1669,  2297,  2363,  1670,  1671,  2334,  1239,
    1240,  2205,  3386,  1673,  4153,  3397,  1674,  1675,  4235,  1676,
    4765,  5235,  5223,  3415,  3416,  2721,  4761,  4169,  2678,  3476,
    5599,  5799,  5800,  4215,  4795,  5256,  5570,  5910,  5999,  6000,
    6069,  1677,  3473,  2670,  1320,  1678,  4562,  2672,  3408,  3498,
    3499,  2274,  2295,  3352,  3369,  3370,  3383,  4126,  3390,  3395,
    4149,  4150,  3409,  3442,  1679,  3355,  3356,  4106,  4109,  2299,
    1680,  4178,  4179,  4770,  1681,  1734,  1735,  2691,  3437,  1748,
    1749,  1193,  1682,  1683,  1684,  2263,  1182,  5577,   792,   775,
    3790,  2736,  1357,  1111,  1685,  1686,  1687,  1467,  2013,  1468,
    1804,   737,   776,  2673,  2674,  3720,  3721,   777,  1277,   897,
       2,    75,  1081,  3998,   387,   388,  1003,  1004,  1005,  1439,
    1440,  2144,  2147,  1809,  2826,   741,   742,   793,  5186,  5534,
    5766,  1064,   389,   390,   391,   392,  1805,  2822,  1241,    76,
      84,    77,  1242,   429,   430,  2803,   393,   914,   394,  1785,
    1221,  4307,   395,   396,   397,   398,   399,  1061,   400,  1223,
     401,  1224,   402,   403,   404,   405,  1231,   406,  1787,  1788,
    4867,  1789,   407,   408,   779,   780,  1506,   409,   410,  1258,
    1259,  1539,  1540,  1815,  1830,  1831,  1832,   411,   749,   412,
     413,   414,  1821,  1822,   415,  2698,  2699,  2831,  2700,   416,
    3582,  3583,   417,  4264,  4265,  5294,  4266,   418,  2694,   419,
     420,  1185,  4312,   421,   910,   422,  1272,   781,   782,   783,
    1279,   900,  1142,   794,  1281,  3757,   902,   903,   785,   786,
     787,  2240,    78,  3590,  2241,  1689,   795,  1690,  2689,  1691,
    1692,  1693,  1694,  1695,  1838,   789,  1248,  1498,  1499,  3591,
    1501,    82,  1502,   426,  4551,  2208,  1541,  3264,  2226,  2227
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   282,  1410,  1319,  1148,  1199,  2165,  1218,   381,   791,
    1777,   371,  1099,  1783,   372,   901,   374,   424,  2091,   797,
    1219,  1449,  1705,   424,  2217,  2175,  1549,  1550,  2169,  2206,
    1208,  1554,  1099,  1951,  1477,  2890,  2245,  1727,  1014,   778,
    1184,  2856,  3554,  1002,  1489,  3294,  1850,  1319,  2022,  3139,
    2004,  2959,   995,  1181,  2974,   955,  3131,  2982,  1073,  1448,
     901,  3599,  3601,  3260,  2155,  2068,  1474,  2286,  1517,  3006,
    1016,  3008,  1974,  3011,  2738,  4088,  2983,   778,  2336,  1719,
    3103,  2780,  2968,  2308,  2309,  3792,  1120,  4433,  4392,  3504,
    3140,  1256,  4563,  2101,  4369,   381,  1107,  3956,  1006,  1013,
    3050,  2856,  2324,  2121,  3914,  2757,  2089,  3975,  1013,    79,
    2094,  1319,  1057,  4659,  2998,  2098,  2810,  2812,  2813,  3191,
    1968,  2751,  2104,  4420,  3351,  4422,  1983,  4595,   901,  4234,
    4970,   951,  2123,   273,  1149,  2009,  4615,  4851,  1833,  3060,
    1835,  4241,  4242,  3524,  1260,  5170,  4960,  1013,   898,  4887,
    3856,  4782,  4936,  4074,  4569,  4570,  4571,  4572,  4573,  4574,
    3714,  1210,  4809,  1449,  4243,  1098,  4642,  3726,  2949,  5125,
    1211,  4944,  3064,  3065,  5358,  3726,  4402,  4300,  5379,  4881,
     376,  2358,  5161,  1202,  1136,  1098,  4826,  3252,  5181,  2738,
    2967,  2804,  2804,   898,  1178,  3212,  2868,  4182,  4234,  5522,
    1170,  1712,  3197,  5012,  1096,  3552,  4933,  5507,  4393,  4316,
    5320,  3549,  5585,  5350,  5587,  2211,  3573,  4824,  2232,  4236,
    5516,  2207,  3970,  4855,  1096,  2202,  1803,  2301,  2302,  1770,
    5826,  5827,  4929,  4931,  1906,  4311,  5155,  2273,  2120,  1773,
    4740,  5355,  2367,  5759,  1811,  1812,  1251,  5318,  5169,  4928,
    4928,  4928,  4928,  2321,   432,  5343,  3589,  2739,  4130,   961,
    3593,   898,  2361,   423,  2156,  2090,  1500,  2746,    45,   423,
    4650, -2255, -2255, -2255, -2255,  5616,  5617,  2156, -2255,  2090,
    4742,  1876,  3188,  4977,  4968,  4598,  1273,  5834,  4236,  2367,
    3071,  4130,  1939, -1896, -1896, -1896, -1896,  2404,  2090,  2090,
   -1896,  4928,   423,  4042,  1443,  4044,  2266,   432,  3688,  3076,
     282,  5755,  2045,  1564,  2746,  3689,  1189,   381,  1580,  3435,
     371,  2090,  6111,   372,  2696,   374,    37,    38,    39,    40,
    5089,   130,   131,    44,   424,  3430, -3340, -3340, -3340, -3340,
    1824,  2085,  4305, -3340,  2404,  2014,  3327,   423,  3435, -1746,
     432, -3340,  3647, -1896,  5873, -3341, -3341, -3341, -3341,    43,
    5173,  1545, -3341,  1825,    45,  1537,  2156,  2209,  2972,   424,
   -3341,  3774,  3200,  1296,   428,  4598,  1247,  6195, -3338, -3338,
   -3338, -3338,    45,   905,  1877, -3338,  2896, -1891, -1891, -1891,
   -1891,  3291,  4107, -3338, -1891,  6126,  6112,   215,   432,  2037,
    1537,    37,    38,    39,    40,  1876, -1048,    43,    44,  1586,
    1826,  4699,    45,  2022,  5775,   423,  4603,  3634,  5761,  1154,
    5887,  3634,  4947,  2014,  1460, -3342,  2359,   223,   905,  2898,
     959, -3337, -3337, -3337, -3337, -1048,  2764,  3531, -3337,   284,
    5645,  3304,   273,  3189,  1319,  3115, -3337, -1891, -1906, -1906,
   -1906, -1906,  3622,  1698,  2687, -1906,   915,  1738,  6167,  1739,
   -2924, -2924, -2924, -2924,  4086,   233,  2176, -2924,  5629,  3488,
    1760,  5795,   432,  6113,  1144, -2924,     3,  5323, -1906, -1906,
   -1906, -1906,  1144,  2740,  1144, -1906,    45,   285,   431,   376,
    2014,  1449,    37,    38,    39,    40,   905,  2350,   916,    44,
    1696,  5682,  5975,  5888,  2219,  3116,  6168,  2336,  1877, -1896,
   -1896, -1896, -1896,  1155,   915,  1449, -1896,  3532,  4130,  5791,
    2157,   286,  4128,  4129,  3623,   306,  1275,  4144,  2765,  2195,
    2308,  2309,   899,  2157,  3635,  2973,   326,  2324,  4338,  1219,
    1002,  2683,  2167,  2264,  4874,  3922, -1863, -1863, -1863, -1863,
   -2138,   331,  4700, -1863,  1461,  5744,   916, -2138,  2276, -1876,
   -1876, -1876, -1876,  3470,  1761,  4948, -1876,  4604,  1345,  5762,
    3471,  2287,  -173,  3110,  4188,  4189,   252,   899,  6246,  1546,
     423,  -173,  1449,  2730,  2731, -2154,  -173,  1423,  3114,  4589,
    5649,  4563, -2154,  -484,   348,  1006,  2328,  5776,  1709,  5327,
     352,  1814,  1817, -1903, -1903, -1903, -1903,   370,  1490,  1854,
   -1903,    37,    38,    39,    40,   423,  6217,  3022,    44,  3289,
    2290,  3292,  2157,  3295,  3201,  3297,  1697,  2994,  3300,  1297,
    3302,  3648,  1254,  1255,  3436,  3077,  4970,  3106,  2267,  3387,
    1017,  1945,  1721,  3072,  5625,   899,  1878, -2438,  1846,  2367,
      37,    38,    39,    40,  3413,  4651,  3190,    44,    37,    38,
      39,    40,  1565,  4202,  1190,    44,   375,  6088,  4949,  3354,
    1553,  4950,  2897,  2928,  2746,  3046,  2933,  3048,  2684,  5989,
    5339,  1732,  2267,  2301,  2302,  1733,  6233,  1252,  1910,  2296,
    2086,  2321,  2167,  1013,  1013,  4335,  5378,  4743,  2738,  3107,
    1740,  4132,  1820,  2201,  2404,  2714,  2362,  5473,  3662,  2086,
    2727,  2727,  1576,  1449,  5509,  3102,  6114,   252,  2197,  3055,
    1245,  1449,  1449, -2343,  2664,  2665,  2666,  2667,  2668,  2669,
    5382,  2167,  5245,  3690,  3282,  3018,  3691, -2360,  5410,  5341,
    5342,  1247,  4139,  4140,  4141,  4142,  3209,  5627,   284,  4933,
    5269,  2709,  1093,  1094,  5273,  3256, -2995, -2480,  4826,  4920,
    3675,  5501,  5924,  3148,  6104,  5530,  5141,    37,    38,    39,
      40,  1333,  5881,  1732,    44, -2255,  2669,  1733,  4142, -2439,
    5630,  2697,  3925,  5356,  5099,  4928,  4928,   386,  3775,  5262,
    4968,  4891,  3776,  5305,  2181,  4928,   285, -1896,  1253,  2791,
    5150,  4928,  2827,  5516,  4318,  4563,  4319,  2198,  1264,  2792,
    3290,  1288,  5214,  4130,  3348,  3350,  1553,  6127,  2984,  3301,
    4694,  4302,  1199,  6128,   952,  3358,  6264,  2997,  3953,  3362,
     286,  6018,  3227,  3953,   306,  1349,  3676,  3374,  3375,  3879,
   -3340,  6271,  6272,  2955,  3131,   326,  6003,  6129,  1801,  1802,
    3392,  3394,  1722,   424,  4590,  1260,  2331, -2438,  1396, -3341,
     331,  1778,  3410, -3068,  4965,  4234, -2138,  5435,  4234,  6225,
    3606,  1346,  3423,  2935,  5462,  5463,  5464,  5465,  5466,  3472,
    5328,  4527, -3338,  2943,  4530,  4531,  2331,  3709,  4534,  1518,
    1424, -1891,  3709,  1018,  4537,  1445,  1827,  1828,  4268,  5611,
    3953, -2154,  4385,   348,  3306,  2296,  5619,  5959,  1087,   352,
    1387,  1491, -1863,  5982,  3272,  3267,   370,  4842,  5820,  4611,
    3275,  1458,  3265,  5976,  3269,  1350,  2202,  1519,  1088,  1525,
    4975,  1530,  5806,  4274,  4872, -3337,  4965,  1534,  2332,  2041,
    6218,   898,  6064,  1019,  1555,  3036,  4370, -2375,  3039,  3040,
    3378,  3379,  2333,  1401,  1247,  4236,  1013,  5824,  4236,  3709,
    1525,  1530,  1513,  3897, -2924,  -747,  4287,  1509,  2332,  1351,
    4532,  4533,  3025,  3549,  1020,   375,  1021,  4234,  1723,  1510,
    1210,  1862,  2335, -2438,  5809,  5810, -1863,  3679,  4475,  1211,
    3880,  3881,  3882,  1576,  5084,  1261, -3342,  1524, -2438,  1529,
    4137,  4138,  4139,  4140,  4141,  4142,  3772,  3559,  1505,  1543,
    5742,  1212,  1013, -1896,  1555,  3887,  4365,  1319,  2970,  1352,
    6086,  3111,  3307,  6044,  3163,  5121,  2738,  1232,  1558,  1560,
    3503,    37,    38,    39,    40,   747,  6226,   432,    44,  3431,
      37,    38,    39,    40,  1781,  6031,    43,    44,  3598,  3477,
    2307,    45,  3202,  3203,  2972,  2972, -3068,   796,    74,  3925,
     911,  3761,   912,  2313,  1462,  4315,  3263,  4236,  1766,  4858,
    -173,  -173,  6065,  6095,  3770,  1537,  4970,  5573,  3541,  6081,
    1098,  5184,  1098,  1743,  1098,  1306,   915,  5646,  1213,  3685,
    1098,  1535,  1536,  2367,  1233,   423,   386,  2985,  3164,   423,
    3528,  4390,  3529,  1247,  -859,   778,  4390, -1903,  3709,  2986,
    3822,  3762,  1123,  1098,  1098,  2364,  5703,  2030,  3298,  3299,
    3182,  1523,  2359,  1528,  1737,  1880,  6124,  1883,   916,  4887,
    4633,  5939,  5940,  2666,  2667,  2668,  2669,  1768,  4561,  2019,
   -2375,  2156, -1863,  5654,  5655,  1205,  1708,  5672,  2404,   958,
    1716,  4391,  1557,  1559,  2685,  1234,  4391,  3233,  1235,  1702,
    2987,  6087,  3509,  3660,  5122,  1205,  2366,    79,  3244,  2367,
    5551,  5638,  6191,  4390,  3788, -2252,   905, -3068,    35,   432,
    3251,  5960,    37,    38,    39,    40,    41,    42,    43,    44,
    1124,  3883,  3884,    45,  2746,  3773,  5152,  3183,  3763,  3241,
    2387,  1993,  3308,  4928,  3575,  5578,  3575,  1994,  4928,  1402,
    5582,  3613,  1517,  5584,  1065,  4370,  1867,  4928,  3603,  5575,
    3309,  2973,  2973,  4391,  2404,  2949,   215,  1813,  4657,  1816,
    4968,  5651,  6032,  1066,  2021,  1262,  1098,  3478,  3200,  4966,
    3707,   956,  2042,  4366,  1319,  2884,  2970,  5883,   432,  1236,
    6242,    37,    38,    39,    40,  1829,   223,    43,    44,  1586,
    1826, -2375,    45,  4967,  1087,  1067,  3898,   748,  1538,  4723,
    4659,  5346,  4728,  4729,  4730,  4731,  4732,  4733,  4734,  4735,
    4736,  4737,  2972,  2972,  1088,  1214,  3388,  5877,  2711,  5893,
    1087,  4476,  6011,  2020,   233,  4137,  4138,  4139,  4140,  4141,
    4142,  6033,  1098, -2413,  1995,  1136,  1978,   236,  5498,  3135,
    1088,  4966,  5620,  3684,  3045,  3841,  5360,  2886,  6192,  1868,
    1463,  3842,  4390,  2086,  6034,   899,  2972,  2459,  3050, -2440,
    1988,  2463,  4450,  4279,  5313,  2887,  3888,  4887,  3889,   913,
    4784,  4785,  3764,  1864,  1792,  1806,  5383,  5384,  1237,  6258,
    3381,  5029,  2479,  2480,    35,  3890,  4018,  5851,    37,    38,
      39,    40,    41,    42,  1836,    44,  1125,  1126,  1989,  2488,
     423, -1863,  4391,  2031,  5991,  2058,  1233,  3891,  1434,  2997,
    2970,  3184, -1863,  3078,  2307, -1863,  1854, -1863,  3892,  2142,
    4246,  3893,  3916,  3887,  3185,  1319,  1537,  2157,  2509,  2712,
    2856,  2512,  3135,  1526,  1087,  3560,  2856,  1531,  1532,  1533,
    4836,  1806,  1199,  2972,  2747,  5852,  2972,  1544,  3843,  3661,
    1538,  1732,  1538,  4075,  1088,  1733,  4322,   205,  1144,  5977,
    1238,  2307,  1144,  2869,  2223,  4451,  2225,  1234,  6247,  2229,
    3136,  2231,   381, -2473,  2234,  2235,  2236,  2884,  5153,  2973,
    2973,  1996,  2842,   215,  4933,  5804,  4234,  2243,  6262,  3363,
    4234,  3604,  5708,  3605,  2885,  1219,  1869,  2888,  3226,  1233,
    2269,  5502,  2270,  4077,  5304,  3946,  4404,  5990,  3232,  6043,
    4271,  5282,  3236,   223,  1997,  5502,  6267,  2970,  3242,  3243,
    5491,  6052,  2574,  2973,    74,    74, -2413,    74,   934,  1870,
    4928,  5770,  5825,  5651,  5651,  2688,  5030,  4842,  3255,  1505,
    5060,  5880,  5289,  1998,  1098,  3286,  5063,  5064,  5788,  2886,
    2116,   233, -2440,  2972,  1990,  2972,  3364,  2898,  1871,  5623,
    1234,  1236,  4563,  3136,   236,  5348,  5292,  2887,  5992,  1435,
    2117,  3787,  2758,  2759,  2972,  2763,  4236,  6096,  5978,  5201,
    4236,  1211,  1211,  5853,  1211,   432,  1260,    37,    38,    39,
      40,  2745,  3452,  2889,    44,  3844,  1309,  1310,  1311,  6270,
    1312,  1313,  1314,  1315,  1316,  1317,  6275,  6276,  1113,  5674,
    2973,  2893,  4452,  2973,  1793,  3090,  1872,  3365,  3675,  1257,
    3366,  3512,  2970,  5573,  1436,  1144,  1144,  3079,  3845,  5829,
    5807,  3058,  3917,    79,    79,  4317,    79,  4955,  5812,  1781,
    3010,  3606,  1991,  1924,  5832,  4453,  3929, -2413,  5837,  5838,
    2112,  4076,  1588,  1806,  1236,  4130,  5717,  3846,  2972,  5478,
    3137,  2737,   252,  1121,  2909,  1062, -2473,  4561,  3479,  4079,
    3947,  3723,  4575, -2440,  4454,   778,   778,  2661,  2662,  2663,
    3553,  2664,  2665,  2666,  2667,  2668,  2669,  5678,  2113,  4994,
    4405,  4065,  5725,  2899,  3676,  5928,  5929,  2910,  5729,  2888,
    2970,  4078,  4384,  4875,  5718,  4482,  2141,  1801,  1802,  5510,
    2911,  3367,  5719,  3771,  3287,  4406,  4578,  2118,  2331,  3453,
    2973,  5511,  2973,  3454,  2912,  3675,  3387,  3387,  4864,  2701,
    2702,  3387,  5149,  1186,  2167,  4887,  2972,  5979,  4080,  5720,
    4470,  2973,  3138,  3288,  3994,  1098,  5118,  4945,  3948,  1087,
    1098,  1098,  1833,  3137,  1835,  3388,  1552,  1150,  3023,   424,
     424,  3455,  2913,  3890,  2902,  2183,  5479,  1122,  3321,  1088,
    5189,  2900,  5190,  2914,  2903,  4575,  1827,  1828,  3387,  3387,
    3850,  4576,  2737,   778,  2167,  3891,  3706, -2473,  5679,  6062,
    4995,  5857,  4577,  2915,   898,  2889,  3892,  4471,  2916,  3893,
    2332,  3676,  4039,  2184,  2167,  2892,  2703,  2973,  3158,   424,
    3368,  5721,  4912,  3117,  4478,  1179,  2846,  4131,  2856,  4578,
    3024,  4579,  4045,  2767,  4040,  2973,  4693,  2815,  2856,  1535,
    1536,  3677,  2893,  4512,  3923,  2977,   906,  2824,  4132,  3578,
    3057,   915,  3851,    81,  2114,  3679,   907,  3853,  2830,  4358,
     898,  3118,  5471,  5981,  1806,  2837,  2839,  4582,  3821,  1806,
    1806,  2926,  2944,  2768,  3678,  2917,  4035,  2222,  3919,  2704,
    2224,  3852,  4876,  2228,  4381,  2230,  3854,  4382,  2233,  5512,
    3834,  4561,  2237,   916,  3456,  4661,  2978,  4359,  4690,  3526,
    3980,  3981,  3982,  3983,  4583,  4580,  4275,  6074,  1553,  2918,
    4133,  4877,  3988,  2973,  6152,  4103,  3993,  5858,  4584,  3847,
    2167,  3159,  3874,  1098,  5872,   898,  2811,  3059,  2904,   425,
    4878,  6229,  4013,  1098,  2856,   425,  5944,  4694,   934,  4028,
     746,  6212,  2115,  3126,  3127,  4234,   967,  2719,  2819,  2820,
    4383,  4234,  3848,  5242,  5243,   908,  4234,  2945,   423,  4234,
    5706,  2905,  3679,  3041,  6046,  4581,  4160,  2770,   425,  2185,
    4582,  2919,  4662,  4710,  2838,  2840,  1153,  2920,  2894,  4989,
    2921,  3849,  5859,  3666,  6229,  5908,  2720,  5760,  4970,  1722,
    5722,  5542,  3703,  3050,  1329,  1098,  5945,  4234,  1098,  1098,
    4585,  2970,  4191,  1225,  1008,  4982,  2922,  4583,  5331,  5332,
    2971,  5909,  2923,   425,   423,   423,   423,  3119,  2771,  1330,
    1236,  4584,  4659,  1226,  3145,  2924,   974,  4082,  1319,  6250,
    4483,  1201,  1806,  1227,  4330,  4236,  5633,  2972,  5634,   905,
    2358,  4236,  1806, -1684,  1864, -1209,  4236,  1864,  2878,  4236,
    2925,  6265,  6266,  4360,  1766, -1684,  5821,  2186,  2879,  1145,
   -1684,    37,    38,    39,    40,   423,  3823,  1145,    44,  1145,
    3166,  1098,   423,  2880,  3826,  3204,  3828,  6123,  2149,   423,
    4990,   425,  5433,  5434,   976,  6227,   909,  4236,  5988,  4683,
    3042,  3228,  5677,  3692,  3518,  3043,  1864,  2808,  5502,  5607,
    1864,  5609, -1684,  4585,  1806,  3120,  6158,  1806,  1806,  4663,
    4480,  5747,  5813,  1732,  5481,  1723,  6173,  1733,  2331,  5748,
    3324,  2767,  3929,  1768, -1684,   377,  2970,  5490,  3976,  2150,
    1576,  2125,  1228,  1203,  4894,  2979,  5500,  3311,  6227,  5651,
    6174,  4361,  4968,  4134,  4135,  4136,  1513,  4137,  4138,  4139,
    4140,  4141,  4142,  2086,  5651,  5651,  1222,   898,  2809,  6175,
     905,  2768,  2980,  1769, -1684,  4341,  3813,  1144,  4009,  4664,
    4991,  3587, -1684,  4481,  2367,  3270,  5854,  3271,  3693,  6176,
    1806,  3273,   381,  3274,  3219,  6039,  3276,  5216,   899,  5217,
    3277,   381,  1204,  3526,  6177,  1229,   963,  4980,  2193,  2746,
    2332,  1924,  2807,  1144,  2973,  4234,  3953,  4193,  4895,  4194,
    2881,  1971,   377,  2769,  2333,  1588,  5119,  5897,  4130,  2151,
    1948,  1215,  5324,  3813,  1181,   983,  1349,   984,  4634,  2404,
    4100,  4638,  4195,  2149,  3262,  4775,   986,  4397,    74,  5502,
    1948,    74,  3954,  1954,  1972,   381,   425,   988,  3317,  3323,
    2102,  3318,  1236,  3319,  3727,  2770,  1449,  4357,  6053,   192,
    4981,  3868,  1205,  1230,  4234,  1192,  4896,  1994,  4897,  2808,
    1588,  1349,  2152,  4130,  5749,  6178,  1955,  5293,  3160,  5120,
    4724,   425,  4725,  3346,  3266,  5325,  4398,  2810,  1588, -1684,
    4776,  4130,  3783,  1449,  4029,  4236,  4721,  3192,  3741,  1198,
      37,    38,    39,    40,  5931,  4349,  2771,    44,  3053,   899,
   -3132,   423,    37,    38,    39,    40,  1350,  3433,  6179,    44,
    4741,  5218,  2238,  1824,  4067,    37,    38,    39,    40,  2981,
    2809,  4053,    44,   974,  5484,  3738,  4196,  3041,  4247,  1973,
     215,  4197,     8,  3360,  3361,  2239,  1825,    79,  1950,  3742,
      79,  3373,  -215,  2153,  4236,  3376,  3377,  2479,  2480,  3778,
    1351,  1350,  1588,  3096,  1995,  4130,  1714,  4350,  2003,  2190,
     223,  3400,  -215,  3401,  2151,  5485,  1851,  -215,  3743,  1206,
     432,  1257,  5247,  3388,  3388,  2331,  4563,  2707,  3388,  2191,
    1263,   976,   905,  5548,  3519,  3934,  3097,  -215,  -762,  5502,
    3428,  4132,  3429,  4817,  4726,  1351,  2512,  1219,   233,  1852,
    1352,  4894,  1732,  4909,  4727,  1754,  1733,  3320,  6013,  2989,
    2366,   236,   208,  2367,  1236,  5565,  5566,  2152,  1209,  3744,
    4431,  4818,  2319,  2320,   377,  3388,  3388,  4892,  1853,  1588,
    2378,   974,  4130,  1274,  3935,  4432,  5275,  3027,  2746,  1291,
     898,  1862,  5502,  5683,  2387,  1352,  4132,  1718,  4820,  4269,
    4198,  4234,  1957,  4133,  3042,  1859,  4371,  2332,  6180,  3043,
    4199,  1862,  3396,  4689,  4132,  6240,  1588,  1766,  2404,  4130,
    1984,  2335,  1767,  3387,  6181,  4895,  3387,  3387,  3387,  3387,
    3387,  3387,  3387,  3387,  3387,  3387,  5248,  3925,  1860,   976,
    2816,  1008,   208,  2817,  4306,  4455,  6200,  4457,  2153,  1958,
    5448,  1289,  4408,  1985,  4616,  5449,  4374,  1986,  4133,  6054,
    4755,  5457,  4208,  3936,  3937,  4626,  2999,  1861,    37,    38,
      39,    40,   983,  6182,   984,    44,  4133,  3938,   122,  2727,
    1295,   899,  1987,  4896,  6234,  4897,  1768,  3908,  4132,  5458,
    1449,  4236,   215,  2856,  3387,  3387,   126,   989,  5450,  4463,
    4822,  3503,  5097,  2366,  1304,  1856,  2367,  1319,  6116,  4502,
    4913,  2367,  5207,  4234,  1305,  3000,  5502,  3001,  1952, -1719,
    5730,  2459,   223,  4038, -1719,  2463,  1769,  3939,  1959,  4510,
    1347,  2746,  5726,  2001,  2818,  2005,  2746,  2387,  1857,  4047,
    4048,  1862,  3002,  4050,   423,  1425,  2479,  2480,  5731,  4054,
    4133,  4521,  4522,  4528,  4057,  4702,  2862,  1348,  4561,  4443,
     233,  2404,  5953,  2488,  5031,  4132,  2404,  1858,  1335,    43,
    5624,  4946,  4951,   236,    45,  1426,  1960,  4744,  4745,  4983,
     983,  1961,   984,  4280,  5032,  6251,  6252,  -747, -1719,  2863,
    3003,  3049,  2509,  4327,  4328,  2512,  2664,  2665,  2666,  2667,
    2668,  2669,  4132,  4236,  1427,  2102,  3028,  1588,  2747,  3031,
    4130,  2523,  5047,  2997,  3940,  4706,  3941,  1743,  2864,  2203,
    1963,  4090,  4447,  2204,  3503,   905,  2203,  4133, -1719,  3985,
    3259,  1449,  5048,  1391,  3986,  4591,  4134,  4135,  4136,  1395,
    4137,  4138,  4139,  4140,  4141,  4142,  1504,   432,  1428,   192,
    5675,  3098,  6010,  3723,  3624,  4448,  3627,  4625,  3081,  1965,
    1393,   424,  3088,  3099,  4133,  4750,  1398,  5769,  2463,  4348,
    1022,   252,  1425,  2692,  -761,  2830,  2693,  5091,  5092,  5093,
    5094,  5095,  4705,  1411,  4449,  5096,  2574,  3100,  4671,  2479,
    2480,  4134,  4135,  4136,  1967,  4137,  4138,  4139,  4140,  4141,
    4142,   425,  1426,  4565,  6150,   425,  5306,  6151,  3986,  1284,
   -3342, -3342,  5756,  4137,  4138,  4139,  4140,  4141,  4142,  1284,
     746,   974,   424,  5241,   424,    35,   746,    35,   432,  1754,
     215,  4613, -1672,    41,    42,    41,    42,   746,  2512,  5236,
    3683,  4871,    45,  1418,  3618,  5626,  2307,  2737,  2869,  3417,
    5632,  2747,  3420,  3547,  3547,  1429,    37,    38,    39,    40,
     223,  1247,  4716,    44,  1430,  4101,   746,    45,  3047,  4102,
     746,  1432,  4018,  3929,   899,  1428,  1438,  4466,  5159,   976,
    1431,   746,  4722,  4134,  4135,  4136,  1433,  4137,  4138,  4139,
    4140,  4141,  4142,  4132,  5543,  5544,  5545,  5546,   233,  1098,
    1732,  3061, -2255,  1441,  1733,  2999,  1446,  4889,  4890,   432,
    4746,   236,  1455,   746,  4816,  1459,  1403,  1284,  1404,  1829,
    1475,    74,  2856,    74,    37,    38,    39,    40,  1284,   746,
    4159,    44,  4161,  4162,   746,  5093,  5094,  5095,  2999,  2800,
    2801,  2661,  2662,  2663,   746,  2664,  2665,  2666,  2667,  2668,
    2669,    81,  2273,  3514,  3000,  4133,  3001,  1469,  -507,  3515,
     746,  1484,  3548,  3548,  4137,  4138,  4139,  4140,  4141,  4142,
    3387,  1406,  1470,  1407,  4609,  3768,  3562,  2212, -1684,  2213,
     898,  3002,  2293,  4817,   252,  1492,  2743,  3000,  2744,  3001,
   -1684,  1511,  2748,  5830,  2749, -1684,  3798,  4134,  4135,  4136,
    1060,  4137,  4138,  4139,  4140,  4141,  4142,   423,  1806,   252,
   -1453,  4818,  1507, -1453,  3002,    35,  2307,  3221,  1854,  3222,
     983,   917,   984,    41,    42,  1449,  4819,  1449,  1836,  3003,
      79,  4344,    79,  3261,  4602,  3262,  4605, -1684,  4820,  3283,
     960,  3284,  3285,  2022,  3284,  2102,  3314,  1284,  3315,  3525,
    1551,  3526,  2997,  1145,  1059,   746,  3700,  1145,  3701, -1684,
      45,  -507,  3003,  4592,  4821,  4594,  1561,  3794,   423,  3795,
     423,  5091,  5092,  5093,  5094,  5095,   425,  3443,  2307,  3444,
    2869,  5460,  4280,  1284,  4832,  2997,  3550,  3551,  2664,  2665,
    2666,  2667,  2668,  2669,  3930,  1547,  3931,  3800,  1567, -1684,
    1449,  1568,  3445,   898,  1151, -1741, -1741, -1684,   898,  4282,
    4283,    37,    38,    39,    40,  1573,  1098,  3091,    44,  2800,
    3571,  4837,  4838,  4839,  1098,  1574,  1098,  3944,  4411,  4002,
    4059,  4003,  3284,  4415,   423,  5194,  5195,  5196,  4654,  4099,
    4822,  3262,  3801,   746,   746,  3977,  1575,  3802,    37,    38,
      39,    40,  1265,  1576,  2999,    44,  1198,  4701,  4111,    45,
    3262,  4940,  5069,  4707,  1266,  1267,  1577,  3387,  3387,  4115,
    3388,  3262,  1578,  3388,  3388,  3388,  3388,  3388,  3388,  3388,
    3388,  3388,  3388,  4119,  1268,  3262,  1579,  1269,  4134,  4135,
    4136,  1583,  4137,  4138,  4139,  4140,  4141,  4142,  1582,  3803,
    4816,  3446,  1585,  3000,  5070,  3001,  3447,  3388,   130,   131,
    4120,  3448,  3262, -1744, -1744,   905,  3928,  5103, -1745, -1745,
    1145,  1145,  1717,  1720, -1684,  1806,  1724, -1683,  5071,  4146,
    3002,  3262,  4165,  1806,  3262,  1806,  4171,   746,  4172, -1683,
    1726,  3388,  3388,  5072, -1683,  1731,  4180,  5073,  3262,  4501,
    1284,  2738,  2280,  2281,  5100,  4508,  4216,   423,  4217,  1725,
     898,  1284,   423,  4218,  6016,  4219,  1065,  5074,  1744,  4817,
    5075,  1751,  4423,  1199,  4424,  1752,  1764,  3503,  3003,  4429,
      35,  4430,  5076,  6024,  2084,  1066, -1683,  1209,    41,    42,
    4643,  4648,  4644,  4649,  3804,  4249,  1754,  4818,  4250,  4251,
    1144,  2997,  1270,  1780,  1247,  3963,  1755,  1779, -1683,  4252,
    4253,  4254,  4819,  4255,  4256,   746,  1784,  1067,  4257,  4258,
    4259,  4711,  1284,  3262,  4820,  1284,  4751,  1786,  4752,  5700,
    3449,  4762,  5086,  4763,  5087,  5052,  1794,  1795,   905,  1271,
    3450,  3686,  1790,   905,  5220,  1796,  1791,  5603, -1683,  4778,
    4821,  3262,  6078,  4856,  5224,  4857, -1683,  1810,  4860,  5139,
    4861,  1797,  3800,  5077,   899,  4870,   746,  3605,  4893,  5579,
    3284,  5078,  5079,  1144,  1098,  4221,  4222,  4223,  2999,  1798,
    3789,  4479,   746,   746,  5151,  1800,  3284,    81,    81,  4166,
      81,  1808,  5246,  1199,  3315,  1799,  4174,  3805,  1284,  5308,
    5315,  3605,  5316,  1807,  1840,  3806,  5080,   746,  3807,  5321,
    4484,  3284,  3802,  5322,   423,  3284,  1842,  2999,  2999,  1839,
    5344,  5182,  5345,  5347,  1848,  5345,  4822,  3000,  4670,  3001,
    1875,  1854,  4673,  4674,  5349,  4676,  5345,  4678,  4679,  5351,
    5353,  5352,  5354,   746,  1881,  1203,  4684,  2999,  3808,  1947,
    5373,  3809,  5374,  5526,  3002,  1908,  2084, -1720,   746,  3964,
    1913,  4260, -1720,  5380,  3803,  5381,  3000,  3000,  3001,  3001,
    1912,   746,  4561, -1683,   746,  1945,  3810,  5420,  5421,   205,
    5423,  4703,  4513,  1806,  4575,  1284,  5385,   899,  5386,  1948,
    4576,  3811,   899,  3002,  3002,   905,  3000,  5411,  3001,  5412,
    5580,  4577,  3003,  1953,  1204,   215,    37,    38,    39,    40,
    5438,  1956,  5439,    44,  1284,  5504,  5553,  5505,  5554,  2999,
    1979,  1980,   898,  3002,  1992,  2997, -1720,  2002,  4578,   898,
    4579,  2006,  5555,  2273,  3262,   223,  5564,   381,  3315,  4914,
    3317,  3003,  3003,  3318,  5636,  3319,  5354,  1284,  1284,  5361,
    1284,    37,    38,    39,    40,  5639,  5081,  5345,    44,  3804,
    5641,  2010,  5381,  2676,  2997,  2997, -1720,  2011,  3000,  1284,
    3001,  3003,  5082,   233,  1205,  2016,  2999,  1068,  5642,  2017,
    5643,  4280,  2018,  5727,  2830,  3284,   236,  4270,  5055,  1098,
    2023,  5057,  5058,  2027,  2997,  3002,  4261,  2025,  3965,   377,
    2366,  4984,  2029,  2367,  4580,   746,  2033,  3387,  2717,  5757,
    2034,  5758,  5105,   746,   746,  4285,  4285,  3388,  5556, -1867,
   -1867, -1867, -1867,  1284,   425,  3000, -1867,  3001,  2746, -1874,
   -1874, -1874, -1874,  5771,  2387,  3315, -1874,  3966,  2999,  3387,
    3387,  2043,  4262,  3003,   899,  2046,  2048, -1865, -1865, -1865,
   -1865,  2039,  3002,  5330, -1865,  1284,  5442,  5107,  2404,  1284,
    1284,  5779,  3805,  5780,  4581,  5785,  2997,  3526,  2090,  4582,
    3806,  1862,  2093,  3807,  5137,  5138,   423,  2294,  2086,  2095,
     425,   425,   425,   423,  1069,  2105,  5790,  3000,  4623,  3001,
    2106,  1206, -1868, -1868, -1868, -1868,  -236,  2311,  1806, -1868,
    3003,   746,  2108,  5792,  5367,  4623,  4583,  2110,  2122,  3320,
    5488,  2146,  2126,  3808,  3002,  5848,  3809,  5849,  2137,  5882,
    4584,  2706,  2132,  2997,  4286,  4286,  2154,  5891,  2339,  5892,
    5902,   425,  3315,  5903,  1850,  4172,  4263,  2134,   425,  2084,
    5904,  3810,  3262,  5402,  2159,   425,  2356, -1866, -1866, -1866,
   -1866,  2161,  1145,  5159, -1866,  2160,  3811,   905,  5914,  5197,
    3526,  2459,  3003,  2162,   905,  2463,  5916,  5937,  4623,  5354,
    2163,  5943,  5445,  3315,  5447,  5949,  2164,  3315,  5451,  2166,
    2167,  5453,   743,  5455,  2174,  2997,  2479,  2480,  1145,  2177,
    5950,  5967,  3315,  5968,  6004,  4280,  3526,  2178,  3263,  2084,
    2179,  5428,  4585,  2488,  4514,  4515,  4516,  4517,  6005,  4519,
    3262,  6007,  2180,  3262,  3388,  3388,  6071,  2182,  4623,  5431,
    6072,  6100,  5798,  6101,  6121,  6125,  6122,  3284,  6184,  6237,
    6185,  6238,  6248,  2187,  6249,  2512,  2084,  6254,  6260,  3284,
    6122,  6269,  6273,  3284,  5381,  1763,  2189,  1765,  2747,  1209,
    1209,  5274,  1209,  5277,  2188,  2196,  1427,  2244,  2275,  2284,
    1100,   898,   898,   898,  2278,  2282,  2285,  2291,  2292,  2300,
    2303,  2304,  2305,  2306,  2310,   252,  2312,  5828,  2315,  2316,
    1100,  2679,  2317,  2318,  2323,  2325,  2326,  2677,  2327,  2328,
    2329,  2330,  2337,   746,  2338,  5482,  5483,  2681,  2340,  2341,
    2342,  2343,  2344,  2345,  2346,  2347,   899,  2348,  2349,  3145,
    2350,  2351,  2684,   899,  2710,  2722,  2706,  1537,  2084,  2732,
    2742,  2753,  1767,  1769,  2787,  2789,  2574,  2797,  2799,  2806,
    1236,  2814,  2821,  2823,  2825,  2833,  2834,  2836,  2843,  2841,
   -3284,  3387,  2845,  4792,  2865,  2866,  2867,  2869,  2870,  2901,
    2871,  2872,  2873,  2907,  2084,  5298,  2874,  1098,  1098,  1098,
    1098,  2895,  1098,  2937,  2938,  2930,  2934,  2936,  2939,  2940,
    2941,  2273,  2942,  2950,  2951,  2952,  2976,   425,  3166,  2961,
    2960,  2962,  2084,  2989,  2990,  2992,  2993,  2996,  5337,  2997,
    3007,  3009,  3013,  3012,  3014,  3015,  3019,   746,  4669,  3020,
    1319,  1002,  4545,  4548,  3026,  3029,  3037,  3044,  3033,  3034,
    1098,  1924,  3056,   746,  3051,   423,   423,   423,  3073,  5693,
    5695,  3074,  3052,  3062,  3080,  5784,  3063,  3075,  3086,  5687,
    3092,  5526,  3093,  3094,  3108,  5784,  3121,  3109,  3123,  3130,
    3124,  2296,   898,  1199,  4606,  1284,  2307,  2313,  3132,  3133,
    3146,  2084,  3149,  3150,  3153,  1284,  3154,   746,   746,  1013,
    1199,   969,  3157,  3161,  1973,  5188,  3176,  3181,   746,  3199,
    3193,  3198,  3207,  5191,  5192,  3213,  3210,  3215,  3217,  3218,
     746,   746, -3342, -3342,  3224,  2664,  2665,  2666,  2667,  2668,
    2669,    81,  5417,  3238,    81,  5628,   905,   905,   905,  3235,
    3237,  3239,  3240,  3253,   746,  3254,  3279,  3280,  4797,  4798,
    4799,  4800,  3296,  3303,  3312,  3326,  3354,  3398,  3399,  1806,
    3353,  3359,  2367,  3411,  5644,  3418,  5474,  3422,  3434,  3427,
    5844,  3459,  3426,  3474,  3440,  3475,  5444,  3508,  3488,  3505,
    3516,  3457,  2366,    80,  1284,  2367,  3517,  1449,  4757,  3543,
    1204,  3506,  3544,  3580,  3542,  3511,  5773,  3513,  3527,  2696,
    6019,  3594,  5589,  3557,  3595,  3607,  3608,  3609,  3620,  5600,
    2746,  3625,  3630,  1098,  3632,  3530,  2387,  3545,  3633,  3639,
    4629,  5606,  3577,  1284,  1284,  3579,  3597,  3628,  3644,  3649,
    4641,  1284,  3655,  3663,  1284,  2358,   423,  3650,  1284,  3652,
    2404,  3671,  3659,  3372,  3674,  1714,  1284,  1284,  3696,   736,
    1718,  3687,  3698,  3708,  1284,  3699,  4668,  1284,  1284,  1284,
    1284,  3725,  3777,  3736,  3760,  3782,  5684,  3780,  1284,  1284,
     745,  1284,  3781,  1284,  1284,  1884,  5915,  1284,  3784,  1284,
    3785,  1284,  1284,  3793,  3797,   899,   899,   899,  3816,  3796,
    3855,  3858,  3866,  3900,  3388,  3895,  3870,  3896,  2084,  3901,
    3899,  3903,  5850,  4190,  3904,  3388,  3907,  3905,  1885,  1284,
     425,  3913,  3906,  5752,  3915,  3921,  3952,   905,  3926,  3924,
    3932,   898,  1806,  3925,  3927,  5833,  3388,  3388,  3978,  3969,
    3984,  3987,  5329,  3971,  1007,  3992,  5836,  3995,  3996,   377,
    1025,  3997,  2273, -3342,  4005,  4008,  4007,  2463,   377,  4015,
    4027,  4031,  4032,  4033,  4036,  4037,  5840,  4046,  5842,  4034,
    1886,  4051,  4049,  4052,  1887,  4061,  1112,  4062,  2479,  2480,
    4063,  4064,  4073,  3327,  4081,  4084,  4087,  3526,  2197,  4089,
    4502,  4092,  4066,  1553,  4095, -3342,  5368,  5369,  5370,  5371,
    1284,  4093,  4096,  4097,  4113,  4114,  1888,  4116,  4117,  4118,
    4121,  4122,   377,  4124,  4192,  4127,  4155,  4145,  4152,  4168,
    4151,  3262,  4154,  4207,  4156,  4245,  4200,  2512,  4187,  1284,
    4157,  4214,  4164,  4185,  4865,  5004, -1255,  4186,  4239,  4289,
    2747,  4210,  1889,  4292, -1747,  4298,  5917,  4288,  5919,  4294,
    4212,  4304,  4320,  4213,  4326,  4244,  4331,  4310,  3768,  4308,
    4961,  4313,  4309,  2366,  1284,  2273,  2367,   377,  4329,  2273,
    2273,  2203,  5614,  1890,  4332,  1891,   899,  4314,  4340,  4343,
    4352,  4378,  4336,  2378,  4337,   423,  4345,  5687,  4367,  4368,
    4380,  2746,  4386,  5429,  5430,  3709,  5011,  2387,  4387,  5743,
    5778,  4400,  4379,  1892,  4395,  4410,  4413,  4414,  4428,  3002,
    4436,  4460,  5660,  4461,  4462,  4477,  4467,  1319, -3342,  4485,
    4487,  2404,  4465,  4388,  4488,  4486,  4489,  4389,  4492,  4495,
    4434,  4497,  4490,  4491,  4435,  4438,  1893,  4493,  4468,  4494,
     208,  4496,  4498,  4500,  1894,  4499,  4507,  4503,  4505,  4509,
    1895,  3071,  4529,  4520,  4523,  4524,  5665,  1896,  4535,  1098,
    4536,  4539,  4543,  5818,  5819,  1897,   905,  5068,  4544,  2817,
    1449,  4552,  4280,  4566,  1898,  4567,  4598,  4607,  4610,  4600,
    4612,  4614,  1899,  4635,  4601,   898,  4623,  4622,  1098,  4630,
    4636,   898,  4632,   898,  4639,  4646,  4645,  4666,  4685,  5014,
    3441,  1319,  1284,  1284,  1284,  1284,  1284,  1284,  1284,  1284,
    1284,  4675,  1284,  4677,  4686,  4691,  4687,  4696,  5933,  5934,
    4697,  4688,  4698,  4709,  2459,  1284,  1284,  4712,  2463,   898,
    5536,  2293,  5537,  5538,  1900,  4713,  4715,  4130,  3388,  4147,
    4148,  4747,  4748,  4749,  5541,  2361,  4756,  4764,  1098,  2479,
    2480,  1098,  1098,  4768,  4780,  4781,  1205,  4789,  4793,  1901,
    4806,  4807,  4829,  4815,  3166,  6097,  2488,  4834,  1806,  4844,
    4845,  5085,  4852,  4831,  4850,  4548,  4843,  2664,  2665,  2666,
    2667,  2668,  2669,   425,  4866,  1535,  1536,  4873,  1902,  4880,
    1284,  4901,  6079,  4903,  4904,  2509,  5101,  4846,  2512,  4849,
     898,  4915,  1903,  4916,  4917,  4918,  4952,  1284,  4938,  4954,
    4941,  2747,  4985,  4988,  2523,   899,  1284,  1284,  4986,  4987,
    4998,  5000,  4999,  5005,  4943,  5021,  5001,  4471,  5022,  5028,
    5044,  5046,  4947,  5002,  5003,  5056,  5059,  5049,  5061,   423,
    5062,  5088,  5126,  5123,   425,   423,   425,   423,  4658,  5132,
    5090,  5135,  5115,  5144,  5131,  5133,  5140,  1806,  3284,  5145,
    1806,  1806,  5147,  5148,  5162,  5164,   746,  5168,  5165,  5179,
    5183,  5180,  5185,  1098,  5187,  3330,  5193,  5198,  5200,  5210,
    5202,  5219,  5203,   423,    81,  5204,    81,  5205,  6205,  2574,
    5206,  5212,  2084,  5215,  2819,  2820,  2084,  2084,  5226,  5227,
    5228,  5229,  5270,  5278,  5221,  5311,   746,  5283,  5230,  5284,
     425,   746,  5271,  5264,   746,  5234,  5240,  5254,  5268,  1098,
     905,  5266,  3331,  6235,  5281,  1100,   905,  1100,   905,  1100,
    5286,  6236,  5461,  5299,  5287,  1100,   746,  5303,  5288,  1284,
    5307,  1007,  5310,  5312,  5317,  1219,  5318,  5326,  5340,  5309,
    1284,  5343,  3332,  5357,   423,  5363,  5372,  1284,  1100,  1100,
    5364,  5391,  5388,  5930,   905,  6261,  5392,  5345,  5413,  5414,
    5424,  5167,  5432,  3333,  5415,  5390,  5452,  5454,  5419,  5403,
    5406,   746,  1806,  5456,  3334,  5459,  6166,  5475,  5467,  6169,
    6170,  5480,  6172,  5489,  5493,  1145,  5495,  5487,  5506,  5508,
    5523,   746,   746,  5514,  3335,  5532,  5540,  3722,  5524,  3336,
    2084,  5547,  5557,  5549,  3722,  5559,  5550,  4668,  5552,  5560,
    5583,  5561,  3722,  5562,  5365,  5569,  6166,  5598,  1806,  6169,
    6170,   377,  6172,   425,   746,   905,  5576,  5608,   425,  5586,
    5618,  5604,  5621,  5622,  2661,  2662,  2663,  5637,  2664,  2665,
    2666,  2667,  2668,  2669,  5656,  3337,  5657,  5662,  5237,  5658,
    5238,  5667,  5668,  5927,  5680,  5681,  5685,  5692,  1145,   899,
     746,  3815,  5698,  2830,   746,   899,  3338,   899,  1449,  5701,
    5704,  1100,  5122,  5709,  5711,  5767,  5714,  5712,  5734,  5735,
    5738,  5715,   746,  5716,    74,   743,   743,  5733,  5741,  5745,
    1834,  5746,  1098,   746,  5774,  5751,  5765,  5737,  1319,  5777,
    5781,  5816,  5787,   899,  5815,  5817,   746,  5822,  5867,  5750,
    5839,  5793,  2366,  5794,  5796,  2367,  5802,   746,  3815,  5808,
    5855,  5798,  5860,  5865,   746,  5864,  5869,  5870,  5875,   934,
    5879,  5884,  2378,  5885,  5886,  5895,  5896,  1100,  5901,  5913,
    2746,  5905,  5805,  5918,  5922,  5921,  2387,  5906,  5923,  5925,
    5935,  5936,  5942,  5946,  5941,  5834,  3339,  5957,  5958,  5961,
    5952,  1284,  3340,  2084,  5469,  5963,  5966,  1098,  3341,  5971,
    2404,  5972,  5295,  5983,   899,  5984,  5986,  5987,  5300,  6002,
     425,  4794,  6012,  6022,  6026,  6014,  3815,  6027,  6030,  1300,
    6017,  3815,  5959,    79,   898,  1323,  6037,  3342,  6029,  3343,
    5960,  6038,  6063,  6081,  6042,  6045,  1340,  5400,  5401,  6068,
    6085,  6077,  5404,  5405,  6082,  5845,  3344,  6098,  2366,  6110,
    6083,  2367,  6118,  3815,  6119,  6102,  6120,  6148,  6153, -2331,
    6154,  6171,  6156,  6187, -2386,  1405,  6195,  6159,  4012,  1412,
    1389,  3345,  6198,  6196,  2084,  6203,  2746,  6208,   746,   424,
    1422,  6241,  2387,  6186,  6259,  6243,  6268,  1217,  3194,  3087,
    4474,  5670,  3973,  6223,  2729,  4407,  4272,  6245,  6253,  1977,
    4959,  5659,  1911,  2459,  5846,  3869,  2404,  2463,  4538,  5686,
    1976,  5065,  5956,  5736,  5136,   746,  1098,  5740,  5472,  5724,
    4334,  4060,  5647,  1284,  6015,  5612,  6076,  5964,  2479,  2480,
    5962,  6036,  5878,  1450,  1025,  4339,  5635,  4437,  4937,  4548,
    4548,  4548,  4548,  4548,  4978,  2488,  6263,  1098,  5650,  6224,
    6131,  6210,  6255,  6183,  5890,  6277,  6219,  3950,  5130,  3951,
    4957,  4421,  3173,  3933,   746,  4618,  6084,  6244,  6157,  4201,
    5713,    80,  4553,  5171,  2509,  6040,  2084,  2512,   423,  1100,
    5666,  3156,  5948,  6023,  5669,  1117,  2265,   746,  5199,  5803,
    2747,  1284,  2277,  2523,  5175,  3600,  4321,  1284,  5176,  5894,
    4506,  6056,  6190,  1451,  1728,  3521,  4277,  3522,  2221, -3342,
    3268,  5154,  5301,  2463,  1284,  1284,  6132,  4056,  4862,  2210,
    1284,  2750,  1750,  5907,  4278,  1806,  3556,  2784,  2783,  4290,
    1563,  3539,  6006,  5920,  2479,  2480,  2788,  4303,  3555,  4291,
    4810,  5263,  5789,  5276,  2793,  1284,  1284,  4805,  5912,  5911,
    1284, -3342,  4863,  4772,  5772,  4758,  6008,  6001,  6009,   905,
    6070,  1581,  5605,  1736,  1284,  1284,  1284,  1284,  2574,  4281,
    1699,  4205,   425,  4769,  1711,  1450,  1713,  4108,  1284,   425,
    4203,  1284,  3490,  2512,  4859,  2675,  1250,  1284,  4667,  3220,
    4030,  3581,  5994,  1220,  2805,  1503,  2747,  1284,  1284,  3572,
    2798,  1284,  2272,  3585,  4267,  1847,  4280,  1818,  3588,  3586,
    4868,  2695,  5291,  1819,  1284,  4869,  1284,  4848,  1243,  3592,
    1284,  3281,  2148,  4058,  2200,   423,    83,  1542,  5302,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1284,
    5601,     0,   736,   736,     0,     0,     0,     0,     0,  1284,
       0,     0,  1284,  1284,  1284,  2802,  2366,     0,     0,  2367,
    5011,     0,     0,   745,   745,     0,     0,     0,  1837,     0,
       0,     0,   746,  6073, -3342,     0,  1284,     0,     0,     0,
    1100,     0,     0,     0,  2746,  1100,  1100,  5068,     0,     0,
    2387,  1284,     0,     0,     0,     0,  1199,     0,     0,  1276,
       0,     0,     0,     0,     0,     0,  1284,     0,   899,  1299,
       0,     0,     0,     0,  2404,     0,     0,     0,  1284,     0,
    1098,     0,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,
    2667,  2668,  2669,     0,     0,     0,     0,     0,     0,  4123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5602,
       0,     0,     0,     0,     0,     0,  2084,     0,     0,  2084,
       0,  2084,     0,  3166,     0,     0,  2084,     0,   746,     0,
       0,     0,     0,   743,     0,     0,     0,     0,     0,     0,
       0,  1884,     0,   746,   746,     0,     0,     0,     0,  1284,
       0,     0,     0,   898,     0,     0,     0,  2356,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,     0,
     746,  3441,     0,   746,  1885,     0,  2084,  2459,  1465,     0,
     898,  2463,     0,     0,     0,     0,     0,     0,     0,  1806,
    4211,     0,     0,  2664,  2665,  2666,  2667,  2668,  2669,     0,
       0,     0,  2479,  2480,     0,  4228,     0,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1100,  2488,
       0,     0,  2084,     0,     0,     0,  1886,     0,     0,  3722,
    1887,     0,     0,     0,     0,     0,     0,   384,     0,     0,
       0,     0,     0,   384,   377,     0,  3722,     0,   739,     0,
       0,  2512,     0,     0,     0,     0,     0,  3722,     0,     0,
       0,     0,  1888,  1450,  2747,     0,     0,    80,    80,     0,
      80,   425,   425,   425,  4228,     0,   384,  1198,     0,     0,
    1100,  4427,     0,  1100,  1100,     0,     0,  1450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1889,     0,
       0,  5728,  3722,     0,     0,   746,     0,   423,     0,     0,
       0,     0,     0,     0,  2084,     0,  2084,   746,     0,     0,
       0,   384,     0,     0,     0,     0,     0,   746,     0,  1890,
       0,  1891,  2271,     0,   423,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,  1100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,  1140,  2084,     0,
       0,     0,     0,     0,   898,     0,     0,     0,   905,   384,
       0,     0,     0,     0,     0,     0,   208,     0,  2953,     0,
    1894,     0,     0,     0,     0,     0,  1895,     0,     0,     0,
       0,     0,     0,  1896,     0,   905,   746,     0,     0,     0,
       0,  2954,  2084,     0,     0,     0,     0,     0,     0,     0,
    1898,     0,  2360,     0,     0,     0,     0,     0,  1899,     0,
       0,     0,  2365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   425,  2084,     0,     0,  2686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,   746,
       0,     0,     0,  5898,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   746,  1450,   746,     0,  2716,  2718,
    1900,     0,     0,  1450,  1450,     0,     0,  2661,  2662,  2663,
    2026,  2664,  2665,  2666,  2667,  2668,  2669,     0,     0,     0,
       0,  2032,     0,     0,     0,  1901,     0,  6109,     0,     0,
       0,     0,  2084,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,   423,     0,
       0,     0,   746,  2084,  1902,     0,     0,  5876,     0,     0,
       0,     0,     0,     0,   384,     0,     0,  2084,  1903,     0,
     736,     0,     0,     0,   899,     0,     0,     0,     0,     0,
       0,     0,  2135,   746,     0,  2139,     0,     0,     0,     0,
       0,   745,     0,     0,     0,     0,     0,  1284,     0,   384,
     746,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   746,     0,     0,
     746,     0,     0,     0,     0,     0,     0,     0,     0,   905,
       0,     0,     0,     0,     0,     0,     0,     0,  1284,     0,
       0,  2084,     0,   381,     0,     0,  6058,     0,  1284,  6059,
       0,  6060,     0,     0,  1284,     0,  1284,     0,     0,     0,
    6092,  2084,  1284,     0,     0,  1284,  1284,  1284,  1284,  1284,
    1284,  1284,  1284,  1284,  1284,     0,     0,     0,  1284,  1284,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2084,
       0,     0,     0,     0,  1284,     0,     0,     0,  1284,  1284,
       0,   425,     0,  1284,   381,     0,     0,  6058,  1284,     0,
    6059,     0,  6060,     0,     0,     0,     0,     0,  1284,     0,
    6147,  1284,     0,  1284,     0,   377,     0,     0,     0,     0,
       0,  2084,  1284,  1284,  1284,   377,     0,     0,  1284,     0,
    6092,  1284,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3054,  1284,     0,     0,  1284,     0,
    6091,   377,  3085,     0,     0,     0,     0,     0,     0,     0,
    1284,     0,     0,     0,     0,     0,  1284,  1284,   899,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   898,  6041,     0,     0,     0,     0,     0,
       0,   381,     0,  6147,  6058,  6216,     0,  6059,     0,  6060,
       0,     0,     0,     0,     0,  6061,  6130,     0,     0,     0,
       0,     0,     0,  1284,     0,     0,     0,     0,  3129,  1284,
       0,     0,     0,     0,     0,  1284,     0,  6155,     0,     0,
    6091,  6092,     0,     0,     0,     0,     0,  6164,     0,     0,
       0,  2084,     0,   898,     0,     0,  6216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3162,  1284,     0,  6093,
       0,     0,     0,   898,     0,     0,  6061,     0,     0,     0,
       0,     0,  3085,     0,     0,     0,     0,     0,     0,  3172,
       0,     0,     0,     0,     0,     0,     0,     0,   746,     0,
       0,     0,     0,     0,  1098,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1284,  1284,  1284,
    1284,     0,     0,     0,     0,     0,     0,  3234,     0,     0,
       0,     0,     0,     0,     0,     0,   898,  2356,   898,     0,
       0,  6091,     0,     0,  3722,     0,     0,   423,     0,  6093,
    3085,  4804,     0,     0,  4808,   425,     0,     0,  6256,     0,
       0,   425,  2084,   425,     0,     0,     0,     0,     0,  1284,
       0,     0,     0,  6061,   898,     0,     0,     0,     0,     0,
       0,    80,     0,     0,    80,     0,  6274,     0,     0,   898,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   425,
       0,  2366,     0,     0,  2367,     0,     0,   423,     0,     0,
       0,     0,     0,  1806,     0,     0,     0,     0,     0,     0,
       0,   746,     0,     0,   746,     0,     0,   423,   905,  2746,
       0,     0,     0,     0,     0,  2387,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6093,     0,     0,     0,     0,     0,     0,     0,     0,  2404,
       0,     0,     0,     0,     0,     0,     0,     0,  2366,     0,
     425,  2367,     0,     0,     0,     0,     0,     0,     0,   384,
       0,     0,     0,   384,     0,     0,     0,     0,   905,     0,
     423,     0,   423,  3371,     0,     0,  2746,     0,   739,     0,
       0,     0,  2387,     0,   739,     0,     0,     0,   905,  1284,
       0,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,     0,  4786,     0,     0,     0,  2404,     0,   423,     0,
       0,     0,     0,     0,   746,   746,     0,     0,  2084,     0,
       0,   746,     0,   423,   739,     0,     0,     0,   739,     0,
       0,     0,     0,     0,  1100,     0,     0,     0,   743,   739,
       0,     0, -3342,     0,     0,     0,  2463,     0,     0,     0,
       0,   905,     0,   905,  1834,  5172,  2084,   899,     0,     0,
    2084,  1284,  1284,  2366,     0,     0,  2367,  2479,  2480,  4787,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2378, -3342,     0,     0,   739,     0,   905,
       0,  2746,   739,     0,     0,     0,     0,  2387,     0,     0,
       0,     0,   739,     0,   905,   746,     0,     0,     0, -3342,
       0,     0,     0,  2463,     0,     0,  2512,   899,   739,     0,
       0,  2404,     0,     0,  1284,     0,     0,     0,     0,  2747,
       0,     0,     0,     0,  2479,  2480,     0,   899,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -3342,     0,  1284,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1284,  1914,     0,     0,     0,     0,     0,
    1915,     0,     0,     0,  1284,  1284,     0,  2084,     0,  1284,
       0,     0,     0,  2512,     0,  3225,  1284,  1284,     0,     0,
       0,  1284,  2084,     0,     0,  3231,  2747,  1284,  1284,     0,
     899,  1284,   899,     0,  1284,     0,     0, -3342,     0,     0,
    1916,  1140,     0,   739,     0,  1140,     0,     0,  1284,     0,
       0,     0,     0,     0,  2459,     0,  1284,     0,  2463,     0,
    1284,     0,     0,     0,   384,     0,     0,     0,   899,     0,
       0,     0,  1284,     0,     0,     0,   377,  1284,     0,  2479,
    2480,  1100,  1284,   899,     0,     0,     0,     0,     0,  1100,
    1917,  1100,     0,     0,     0,     0,  2488,  1918,     0,     0,
    1919,     0,     0,     0, -3342,     0,     0,    81,     0,     0,
       0,     0,     0,     0,  1299,     0,     0,     0,     0,     0,
       0,     0,   377,     0,  1284,  2509,     0,     0,  2512,     0,
       0,   739,   739,     0,     0,     0,     0,     0,     0,     0,
       0,  2747,  2084,     0,  2523,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1920,     0,     0,     0,   746,     0,
       0,     0,     0,  1284,  1284,     0,     0,     0,     0,     0,
       0,     0,     0,  1284,     0,     0,     0,     0,     0,  1284,
       0,     0,     0,     0,   425,     0,     0,     0,     0,     0,
       0,     0,     0,  2084,     0,     0,  2664,  2665,  2666,  2667,
    2668,  2669,     0,     0,     0,     0,  3510,  3722,  1140,  1140,
       0,     0,     0,     0,  1921,     0,  1922,     0,     0,  2574,
       0,     0,     0,     0,     0,   739,  1923,   746,     0,     0,
       0,     0,  2084,     0,  1924,     0,     0,     0,     0,   746,
       0,     0,  2366,     0,  1925,  2367,     0,     0,     0,     0,
       0,     0,  4228,     0,     0,     0,  4228,     0,     0,     0,
       0,     0,   746,  2664,  2665,  2666,  2667,  2668,  2669,     0,
    2746,     0,     0,     0,     0,     0,  2387,  1926,     0,     0,
    1927,  1928,     0,     0,     0,     0,     0,     0,     0,     0,
    2084,     0,     0,   377,     0,   736,     0,     0,     0,     0,
    2404,     0,     0,   739,     0,     0,  1929,     0,     0,   746,
       0,     0,     0,     0,     0,     0,   745,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   425,  1837,     0,    80,  3610,    80,     0,     0,  1100,
    3614,     0,     0,  3617,     0,     0,  1930,     0,     0,     0,
       0,     0,     0,     0,   739,     0,  1284,     0,     0,     0,
       0,     0,     0,  4790,  1931,  3640,     0,  1284,     0,     0,
     739,   739,     0,     0,  2661,  2662,  2663,     0,  2664,  2665,
    2666,  2667,  2668,  2669,     0,     0,     0,     0,     0,     0,
    4167,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,     0,     0, -3342,     0,     0,     0,  2463,     0,     0,
    3694,  1932,  1933,  2366,     0,     0,  2367,     0,     0,     0,
       0,  2084,     0,     0,     0,     0,     0,     0,  2479,  2480,
    3702,   739,     0,  2378,  1914,     0,     0,  1713,     0,     0,
    1915,  2746,     0,   746,     0, -3342,   739,  2387,     0,     0,
       0,     0,     0,  1934,     0,     0,  1284,     0,     0,   739,
    2084,     0,   739,  3758,     0,  1957,     0,  1284,     0,     0,
       0,  2404,     0,     0,     0,     0,     0,  2512,     0,  1284,
    1916,     0,     0,     0,     0,     0,     0,     0,  1284,  1284,
    2747,     0,  1284,     0,     0,     0,     0,     0,     0,  3799,
       0,     0,     0,  3817,     0,  1284,     0,     0,     0,     0,
       0,  1284,  1958,     0,     0,     0,  1284,     0,     0,  1284,
       0,  3829,     0,     0,  1284,  1284,     0,     0,     0,     0,
    1917,     0,  3839,     0,     0,     0,     0,  1918,     0,     0,
    1919,     0,     0,     0,     0,  3863,     0,     0,     0,     0,
       0,   746,     0,   746,  1100,     0,  3871,  1284,     0,     0,
       0,     0,     0,  3878,     0,     0,     0,     0, -3342,     0,
       0,     0,     0,     0,  2459,     0,     0,     0,  2463,     0,
       0,  1284,     0,     0,  2084,     0,  1284,  1284,     0,  1284,
       0,  1959,     0,   739,  1920,  1284,     0,     0,     0,  2479,
    2480,   739,   739,     0,     0,     0,  3910,     0,     0,     0,
       0,     0,   384,  2084,  3910,     0,  2488,     0,     0,  3722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,     0,     0,     0,     0,     0,  1960,
       0,  1284,     0,     0,  1961,  2509,     0,     0,  2512,     0,
       0,     0,     0,   425,  1962,     0,  1922,     0,     0,     0,
       0,  2747,     0,     0,  2523,     0,  1923,  3979,   384,   384,
     384,     0,     0,     0,  1924,     0,     0,     0,     0,     0,
     425,     0,   746,  1963,  1925,     0,     0,     0,     0,   739,
       0,     0,     0,     0,     0,     0,  1914,     0,  1284,     0,
       0,  4014,  1915,     0,     0,     0,     0,  4228,  1450,     0,
       0,     0,  4228,     0,     0,  4228,     0,  1964,     0,   384,
    1927,  1928,  1965,     0,     0,     0,   384,  2664,  2665,  2666,
    2667,  2668,  2669,   384,     0,     0,     0,     0,     0,  2574,
    1140,     0,  1916,     0,     0,  1450,  1966,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1967,     0,     0,
       0,     0,  2084,     0,     0,  1284,     0,  2084,     0,     0,
    3654,     0,     0,  4072,     0,     0,  1140,  1299,     0,     0,
       0,     0,     0,     0,     0,     0,  1930,     0,  1284,     0,
    1284,  2084,  1917,  1284,     0,  1284,  4072,     0,     0,  1918,
       0,     0,  1919,     0,  1931,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1284,     0,     0,     0,     0,
    1284,     0,     0,     0,  1284,     0,     0,     0,  1303,  2084,
       0,     0,     0,     0,  1284,     0,  1327,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,  1932,  1933,     0,     0,  1356,  1920,     0,     0,     0,
    1390,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1284,     0,
       0,   739,     0,     0,   425,     0,     0,     0,     0,     0,
       0,     0,     0,  1934,  2661,  2662,  2663,     0,  2664,  2665,
    2666,  2667,  2668,  2669,  2084,     0,     0,     0,  2084,  2084,
    4175,     0,     0,     0,     0,     0,  1921,     0,  1922,     0,
       0,     0,  1100,  1100,  1100,  1100,   377,  1100,  1923,     0,
       0,     0,     0,     0,     0,     0,  1924,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1925,     0,     0,     0,
       0,     0,     0,     0,     0,  1284,   385,     0,     0,     0,
       0,     0,   385,     0,     0,   384,     0,   740,     0,     0,
    2366,     0,     0,  2367,  1284,  1100,     0,     0,     0,  1981,
       0,     0,  1927,  1928,     0,   739,     0,     0,     0,     0,
    2378,     0,     0,     0,     0,   385,     0,     0,  2746,  2084,
       0,   739,  1450,     0,  2387,     0,  5900,     0,  1982,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1284,     0,
    4228,  1284,     0,     0,     0,  1571,     0,     0,  2404,     0,
    2356,     0,     0,     0,     0,  1284,     0,  1284,     0,  1284,
     385,     0,     0,     0,     0,   739,   739,     0,  1930,     0,
       0,     0,     0,     0,     0,     0,   739,  2084,  2084,  1706,
       0,     0,     0,  1284,     0,     0,  1931,     0,   739,   739,
       0,     0,     0,     0,     0,     0,     0,  4323,  1730,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     746,     0,   739,     0,  2366,     0,     0,  2367,     0,     0,
    1759,     0,     0,     0,     0,     0,     0,     0,   385,     0,
       0,     0,     0,  1932,  1933,     0,  1284,     0,     0,  4346,
       0,     0,  2746,     0,     0,     0,     0,     0,  2387,     0,
       0,  2459,     0,  1284,     0,  2463,     0,     0,  1100,     0,
       0,     0,     0,  1450,     0,     0,     0,     0,     0,  1284,
    1284,     0,  2404,     0,     0,  1934,  2479,  2480,  2366,  1284,
       0,  2367,     0,     0,   746,     0,     0,     0,     0,     0,
       0,     0,   377,  2488,     0,     0,     0,     0,  2378,     0,
       0,     0,     0,     0,  1284,     0,  2746,     0,     0,     0,
       0,  4091,  2387,     0,     0,     0,     0,  4094,     0,     0,
       0,     0,  2509,  1942,     0,  2512,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5251,  2404,     0,  2747,     0,
       0,  2523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1284,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4426,     0,     0,
       0,     0,     0,  1284,  4439, -3342,     0,     0,   384,  2463,
       0,     0,     0,     0,     0,     0,  4458,     0,     0,     0,
       0,     0,     0,   385,     0,     0,     0,     0,     0,     0,
    2479,  2480,     0,   425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4464,  2574, -3342,     0,     0,
    2097,     0,     0,     0,     0,     0,     0,     0,   385,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2459,
       0,     0,     0,  2463,  2127,  2130,  2131,     0,     0,  2512,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2747,   425,  2479,  2480,     0,     0,     0,  4237,
    4504,  1284,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2488,     0,   425,     0,  4525,     0,     0,     0,     0,
       0,     0,     0,     0,  4518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2509,  3910,     0,  2512,  3910,  3910,     0,  1284,  3910,     0,
       0,     0,     0,     0,  3910,     0,  2747,     0,     0,   377,
       0,     0,     0,     0,     0,     0,  4550,     0,  4237,    85,
   -3342,     0,     0,  4564,     0,    89,   425,  2084,   425,    93,
     377,    94,     0,    96,    97,     0,     0,  1450,     0,  1450,
       0,     0,     0,     0,   106,     0,     0,     0,     0,  1706,
       0,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,
    2669,   119,   120,     0,   425,  3425,     0,  3722,     0,     0,
       0,     0,     0,     0,  1100,     0,     0,  1706,  4621,   425,
       0,     0,     0,     0,  2574,     0,     0,  3722,     0,     0,
       0,  6108,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1100,     0,     0,     0,   128,     0,     0,
       0,  4653,  1450,     0,     0,  2366,     0,   129,  2367,   130,
     131,     0,  3085,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1216,  2378,     0,     0,     0,  4692,
       0,     0,     0,  2746,     0,     0,     0,     0,     0,  2387,
       0,     0,     0,     0,   141,     0,   142,   143,     0,  4704,
       0,     0,   146,  1100,   147,     0,  1100,  1100,     0,     0,
       0,     0,     0,  2404,     0,   149,     0,   150,     0,  2664,
    2665,  2666,  2667,  2668,  2669,     0,     0,     0,   377,     0,
       0,   153,     0,   154,     0,     0,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
     159,     0,     0,     0,   160,     0,     0,     0,     0,     0,
     161,   384,     0,     0,     0,     0,     0,  2733,   163,     0,
     165,     0,     0,     0,     0,     0,   167,     0,     0,  2661,
    2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,     0,
       0,   171,     0,     0,  2754,  2756,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2459,  4773,  2794,     0,
    2463,     0,   384,     0,   384,     0,     0,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2479,  2480,     0,   739,     0,   184,   185,     0,     0,
       0,     0,   186,     0,     0,     0,     0,     0,  2488,     0,
       0,     0,     0,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1100,   192,     0,     0,     0,     0,
       0,     0,     0,     0,   739,     0,     0,  2509,   384,   739,
    2512,     0,   739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2747,     0,     0,  2523,     0,     0,     0,
       0,     0,     0,   202,   739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   204,     0,     0,   385,     0,
     205,   206,   385,   207,     0,     0,     0,     0,   208,     0,
       0,     0,     0,   209,     0,     0,   211,   740,     0,     0,
     213,  2963,     0,   740,     0,   214,   215,     0,  2988,   739,
       0,     0,  2366,   216,   740,  2367,   218,     0,     0,     0,
       0,     0,     0,  1140,   221,     0,     0,  4910,     0,   739,
     739,  2574,  2378,     0,     0,     0,   223,     0,     0,     0,
    2746,  3032,     0,   740,  3035,     0,  2387,   740,     0,     0,
       0,     0,     0,   228,     0,   229,     0,     0,   740,     0,
       0,   384,   739,   231,     0,     0,   384,     0,     0,   232,
    2404,     0,     0,     0,   233,     0,     0,     0,     0,     0,
    3070,     0,     0,     0,     0,     0,     0,   236,     0,     0,
     740,     0,     0,     0,  3089,     0,  1140,     0,   739,     0,
       0,     0,   739,     0,     0,     0,   740,  1100,     0,     0,
       0,   740,  4564,  3105,     0,     0,     0,  1299,     0,     0,
     739,   740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   739,     0,     0,     0,     0,     0,   740,     0,     0,
       0,     0,     0,  5006,   739,     0,  5007,     0,  5008,     0,
    5033,     0,  5015,  5036,     0,   739,     0,     0,     0,  1914,
       0,     0,   739,     0,     0,  1915,     0,     0,     0,     0,
       0,     0,     0,  2459,     0,     0,     0,  2463,     0,     0,
       0,     0,  1100,     0,     0,   252,  2661,  2662,  2663,  -146,
    2664,  2665,  2666,  2667,  2668,  2669,     0,     0,  2479,  2480,
       0,     0,  4177,     0,     0,  1916,     0,     0,     0,     0,
    3910,     0,     0,     0,  3195,  2488,  3910,  3910,   384,  3129,
       0,     0,  3206,     0,     0,     0,     0,     0,  4550,     0,
       0,     0,   740,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2509,     0,     0,  2512,     0,  5102,
    5104,  5106,  5108,   385,     0,  1917,     0,     0,     0,     0,
    2747,     0,  1918,  2523,     0,  1919,     0,     0,     0,     0,
    5142,     0,     0,     0,     0,  4237,     0,     0,  4237,     0,
       0,     0,     0,     0,     0,     0,   739,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1920,
     740,   740,     0,   739,     0,     0,  4564,  5174,     0,     0,
       0,     0,  1100,     0,     0,     0,     0,     0,  2574,     0,
       0,     0,     0,     0,     0,  1706,  1706,     0,     0,     0,
       0,     0,     0,     0,  4072,  2366,     0,     0,  2367,     0,
       0,     0,     0,     0,     0,  3322,     0,     0,     0,     0,
       0,     0,   739,     0,     0,  2378,     0,     0,     0,  1921,
       0,  1922,     0,  2746,     0,     0,     0,  4237,     0,  2387,
    5209,  1923,     0,     0,     0,   739,     0,     0,     0,  1924,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1925,
       0,     0,     0,  2404,   740,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4927,  4930,  4927,
    4927,     0,  2007,     0,     0,  1927,  1928,     0,     0,     0,
       0,     0,     0,     0,  2366,     0,     0,  2367,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2008,     0,     0,  2378,     0,     0,     0,     0,     0,
     384,     0,  2746,     0,     0,     0,     0,   384,  2387,  4927,
       0,     0,   740,  2661,  2662,  2663,     0,  2664,  2665,  2666,
    2667,  2668,  2669,     0,     0,     0,     0,     0,     0,  5238,
       0,  1930,  2404,     0,     0,     0,  2459,     0,     0,     0,
    2463,     0,     0,     0,  5290,     0,  5296,  5297,     0,  1931,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2479,  2480,   740,     0,     0,     0,    80,     0,     0,
       0,     0,     0,     0,  2366,     0,     0,  2367,  2488,   740,
     740,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2378,     0,  1932,  1933,     0,     0,
     739,     0,  2746,     0,   740,     0,     0,  2509,  2387,     0,
    2512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2747,     0,  1100,  2523,     0,  2686,     0,
       0,  2686,  2404,     0,     0,  2459,     0,     0,  1934,  2463,
     740,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   740,     0,     0,     0,     0,
    2479,  2480,     0,     0,     0,     0,  5397,     0,   740,     0,
       0,   740,     0,     0,     0,     0,     0,  2488,  5407,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   739,     0,     0,     0,
       0,  2574,     0,     0,     0,     0,  2509,     0,     0,  2512,
       0,   739,   739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2747,     0,     0,  2523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2459,     0,     0,   739,  2463,
       0,   739,     0,     0,     0,     0,     0,     0,  5426,  5427,
    2366,     0,     0,  2367,     0,     0,     0,     0,     0,     0,
    2479,  2480,  3910,  3910,     0,     0,     0,     0,     0,  1450,
    2378,     0,     0,  5446,     0,     0,     0,  2488,  2746,     0,
       0,     0,     0,     0,  2387,     0,     0,     0,     0,  3487,
       0,     0,  4550,  4550,  4550,  4550,  4550,     0,     0,     0,
    2574,     0,   740,     0,     0,     0,  2509,     0,  2404,  2512,
     740,   740,     0,     0,  3507,     0,     0,     0,     0,     0,
       0,   385,  2747,     0,     0,  2523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4020,     0,     0,     0,   384,
     384,   384,     0,     0,     0,     0,     0,     0,     0,  5497,
       0,  3520,     0,  3523,  1884,     0,  2661,  2662,  2663,     0,
    2664,  2665,  2666,  2667,  2668,  2669,     0,     0,     0,     0,
       0,     0,  5574,   739,     0,     0,     0,   385,   385,   385,
    5525,     0,  4072,     0,     0,   739,  4237,  1885,     0,     0,
    4237,     0,     0,     0,     0,   739,     0,  1706,   740,     0,
    2574,     0,     0,     0,  5209,  5209,  5209,  5209,     0,     0,
       0,  2459,     0,     0,     0,  2463,     0,     0,  2366,     0,
       0,  2367,     0,     0,     0,     0,     0,     0,   385,     0,
       0,     0,     0,     0,     0,   385,  2479,  2480,  2378,  1886,
       0,     0,   385,  1887,     0,     0,  2746,     0,     0,     0,
       0,     0,  2387,  2488,     0,  2661,  2662,  2663,     0,  2664,
    2665,  2666,  2667,  2668,  2669,     0,     0,     0,     0,  4181,
       0,     0,     0,     0,     0,  1888,  2404,     0,     0,     0,
       0,     0,  2509,     0,   739,  2512,     0,     0,     0,     0,
    4072,     0,  4072,  4927,  4927,     0,     0,     0,  2747,     0,
       0,  2523,     0,  4927,  4021,     0,     0,     0,     0,  4927,
       0,  1889,     0,     0,     0,     0,     0,     0,  5899,     0,
     384,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   739,     0,   739,     0,     0,
       0,     0,  1890,     0,  1891,     0,     0,     0,     0,     0,
       0,     0,   739,     0,   739,  2661,  2662,  2663,     0,  2664,
    2665,  2666,  2667,  2668,  2669,     0,     0,     0,     0,  4542,
       0,     0,     0,  4564,     0,     0,  2574,     0,     0,  2459,
       0,     0,     0,  2463,     0,     0,     0,     0,     0,     0,
     740,     0,     0,     0,     0,     0,     0,  3749,     0,     0,
       0,     0,     0,     0,  2479,  2480,     0,     0,     0,   208,
     739,     0,     0,  1894,  5671,     0,  5673,     0,     0,  1895,
       0,  2488,     0,  3786,     0,     0,  1896,  2366,     0,     0,
    2367,     0,     0,  3910,  2954,     0,     0,     0,     0,     0,
       0,   739,  1450,  1898,     0,     0,  5690,  2378,  5691,     0,
    2509,  1899,  5696,  2512,  5697,  2746,  5699,     0,   739,     0,
       0,  2387,     0,     0,     0,     0,  2747,     0,     0,  2523,
       0,     0,     0,     0,   385,   739,     0,     0,   739,     0,
       0,     0,     0,     0,     0,  2404,     0,     0,     0,     0,
       0,     0,     0,     0,   740,     0,     0,  5477,     0,     0,
       0,     0,     0,  1900,     0,     0,     0,  4023,  4658,     0,
     740,     0,     0,     0,  1914,     0,     0,     0,     0,     0,
    1915,     0,     0,  1914,     0,     0,     0,     0,  1901,  1915,
       0,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,
    2669,     0,     0,     0,  2574,  4717,     0,     0,     0,     0,
       0,     0,     0,     0,   740,   740,     0,  1902,     0,   384,
    1916,     0,     0,  2366,     0,   740,  2367,  3972,     0,  1916,
       0,  1903,     0,     0,     0,     0,     0,   740,   740,     0,
       0,     0,     0,  2378,     0,     0,     0,     0,  2459,     0,
       0,  2746,  2463,     0,     0,     0,     0,  2387,     0,     0,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
    1917,     0,     0,  2479,  2480,     0,     0,  1918,     0,  1917,
    1919,  2404,     0,     0,     0,     0,  1918,     0,     0,  1919,
    2488,     0,     0,     0,     0,  4237,     0,     0,     0,     0,
       0,  4237,     0,     0,     0,     0,  4237,     0,     0,  4237,
       0,  2366,     0,     0,  2367,     0,     0,     0,     0,  2509,
       0,     0,  2512,     0,     0,     0,     0,     0,     0,     0,
       0,  2378,     0,     0,  1920,  2747,     0,     0,  2523,  2746,
       0,     0,     0,  1920,     0,  2387,  5847,  4237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2661,
    2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,  2404,
       0,  4927,     0,  4771,     0,     0,  4927,     0,     0,     0,
       0,     0,     0,     0,  2459,  4927,     0,     0,  2463,     0,
       0,     0,     0,     0,  1921,     0,  1922,     0,     0,  1100,
       0,     0,     0,  1921,     0,  1922,  1923,     0,     0,  2479,
    2480,     0,     0,  2574,  1924,  1923,   739,     0,     0,     0,
       0,     0,     0,  1924,  1925,     0,  2488,   385,     0,     0,
       0,  5664,     0,  1925,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2509,     0,  2927,  2512,     0,
    1927,  1928,     0,     0,     0,     0,  2931,     0,     0,  1927,
    1928,  2747,  2459,   384,  2523,     0,  2463,     0,     0,   384,
       0,   384,     0,     0,     0,     0,  1929,     0,  1299,     0,
       0,     0,     0,     0,     0,  2932,  2366,  2479,  2480,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1450,     0,     0,     0,  2488,     0,  2378,   384,     0,     0,
       0,     0,     0,     0,  2746,     0,  1930,     0,     0,     0,
    2387,     0,     0,     0,     0,  1930,     0,     0,     0,   739,
       0,     0,   739,  2509,  1931,     0,  2512,     0,  5985,  2574,
    4220,     0,     0,  1931,  2404,  4237,     0,     0,     0,  2747,
       0,     0,  2523,  4072,     0,     0,     0,     0,  2661,  2662,
    2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,     0,     0,
       0,     0,  4882,     0,     0,     0,     0,     0,   384,     0,
       0,  1932,  1933,     0,     0,     0,  5290,  5290,     0,     0,
    1932,  1933,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4237,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1934,     0,     0,     0,  2574,     0,     0,
       0,     0,  1934,     0,     0,     0,     0,  6050,  6051,     0,
       0,     0,   739,   739,     0,     0,     0,  2459,     0,   739,
       0,  2463,     0,     0,     0,     0,     0,     0,  4927,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2479,  2480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2488,
       0,     0,     0,  6094,  2661,  2662,  2663,     0,  2664,  2665,
    2666,  2667,  2668,  2669,     0,     0,     0,     0,  5213,     0,
       0,     0,  2366,     0,     0,  2367,   784,     0,  2509,     0,
       0,  2512,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2378,   739,  2747,  5866,     0,  2523,     0,     0,
    2746,     0,     0,     0,     0,     0,  2387,     0,     0,     0,
       0,     0,  6050,     0,   784,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2404,     0,     0,  6094,     0,   784,     0,     0,  6163,     0,
     385,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,
    2668,  2669,     0,  1109,     0,     0,  5225,     0,     0,     0,
       0,  4237,     0,     0,     0,     0,  1110,     0,     0,     0,
       0,     0,  2574,     0,  1118,     0,  6201,  6202,     0,     0,
    6206,  6207,     0,  6209,     0,     0,     0,     0,     0,  1129,
       0,  1109,     0,     0,     0,  1152,     0,  4564,     0,     0,
       0,   385,     0,   385,     0,  1183,     0,     0,     0,     0,
       0,     0,     0,  1188,     0,     0,  1914,     0,     0,     0,
       0,     0,  1915,   740,     0,     0,     0,  6239,     0,     0,
       0,     0,     0,  2459,  6094,     0,     0,  2463,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6257,     0,     0,     0,     0,  5974,     0,  2479,  2480,
       0,     0,  1916,   740,     0,     0,     0,   385,   740,     0,
       0,   740,     0,  4237,     0,  2488,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   740,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2509,     0,     0,  2512,     0,     0,
       0,     0,  1917,     0,     0,     0,   739,     0,     0,  1918,
    2747,     0,  1919,  2523,  6021,     0,     0,  2661,  2662,  2663,
       0,  2664,  2665,  2666,  2667,  2668,  2669,     0,   740,     0,
       0,  5253,   384,     0,     0,     0,  2366,     0,     0,  2367,
       0,     0,     0,     0,     0,     0,     0,     0,   740,   740,
       0,     0,     0,     0,     0,     0,  2378,     0,     0,     0,
    4596,     0,     0,  4599,  2746,     0,  1920,     0,     0,  2366,
    2387,     0,  2367,     0,     0,   739,     0,     0,     0,  4608,
     385,   740,     0,     0,     0,   385,     0,   739,  2574,  2378,
       0,     0,     0,  4617,  2404,     0,     0,  2746,     0,     0,
       0,     0,     0,  2387,  4627,     0,     0,     0,     0,     0,
     739,     0,     0,     0,     0,  4640,     0,   740,     0,     0,
       0,   740,     0,  4647,     0,     0,  1921,  2404,  1922,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1923,   740,
       0,     0,     0,     0,     0,     0,  1924,     0,     0,     0,
     740,     0,     0,     0,     0,     0,  1925,   739,     0,     0,
       0,     0,     0,   740,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   740,     0,     0,     0,     0,   384,
       0,   740,     0,     0,     0,     0,     0,     0,     0,  3016,
       0,     0,  1927,  1928,     0,  1706,     0,  2459,     0,     0,
       0,  2463,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3017,     0,
       0,     0,  2479,  2480,     0,     0,     0,  6194,     0,     0,
    2459,     0,     0,     0,  2463,     0,     0,   385,     0,  2488,
       0,     0,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,
    2667,  2668,  2669,     0,     0,  2479,  2480,  5558,  1930,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2509,     0,
       0,  2512,  2488,     0,     0,     0,  1931,     0,     0,     0,
       0,     0,     0,     0,  2747,     0,     0,  2523,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2509,     0,     0,  2512,   740,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2747,     0,     0,
    2523,     0,   784,  1932,  1933,     0,     0,     0,     0,  4801,
    4802,  4803,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   740,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,  1934,     0,     0,     0,     0,
    4020,     0,     0,  4020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     0,     0,     0,  1884,
       0,   740,  1884,     0,     0,  2574,     0,     0,     0,   739,
       0,   739,     0,     0,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,   740,     6,     7,     0,     0,     0,
       0,     8,  1885,     9,    10,  1885,     0,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,     0,    36,     0,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,     0,    45,     0,     0,     0,
       0,     0,     0,     0,  1886,     0,     0,  1886,  1887,     0,
     739,  1887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   385,
       0,   384,     0,     0,     0,     0,   385,     0,     0,     0,
    1888,     0,     0,  1888,    46,     0,     0,  2661,  2662,  2663,
       0,  2664,  2665,  2666,  2667,  2668,  2669,     0,   384,     0,
     739,  5568,     0,     0,     0,     0,     0,     0,     0,  4021,
    2366,     0,  4021,  2367,  4974,     0,  1889,     0,     0,  1889,
    2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,
    2378,     0,     0,     0,  5610,     0,     0,     0,  2746,     0,
       0,     0,     0,     0,  2387,     0,     0,  1890,     0,  1891,
    1890,     0,  1891,     0,     0,    47,     0,     0,     0,     0,
    1280,  1286,  1286,   784,     0,  1286,     0,  1294,  2404,   740,
    1280,     0,  1183,    48,     0,  1321,     0,     0,     0,     0,
    1183,     0,     0,  1183,     0,     0,     0,  1286,     0,  1183,
    1294,     0,     0,    49,     0,     0,     0,     0,     0,  1358,
       0,     0,     0,     0,  1183,     0,     0,     0,  1286,     0,
     784,     0,  1286,     0,   208,    50,     0,   208,  4022,  1321,
       0,  1894,  1415,     0,  1895,     0,     0,  1895,     0,  1286,
       0,  1896,     0,     0,  1896,     0,     0,     0,     0,  2954,
       0,     0,  2954,  5098,     0,     0,     0,     0,  1898,     0,
       0,  1898,     0,     0,    51,     0,  1899,    52,     0,  1899,
       0,     0,  5124,     0,     0,   740,     0,     0,  1280,     0,
       0,  2459,    53,   784,     0,  2463,     0,     0,     0,  1280,
     740,   740,     0,  1321,     0,     0,     0,     0,     0,     0,
       0,  5143,     0,     0,     0,     0,  2479,  2480,     0,     0,
    1286,     0,   384,     0,     0,     0,     0,   740,  1900,     0,
     740,  1900,  4023,  2488,     0,  4023,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1901,     0,     0,  1901,     0,     0,     0,
       0,     0,  2509,     0,     0,  2512,     0,     0,    54,     0,
       0,     0,     0,     0,     0,     0,  1183,     0,  2747,     0,
       0,  2523,  1902,     0,     0,  1902,     0,     0,     0,  1183,
    1572,     0,     0,     0,     0,     0,  1903,     0,     0,  1903,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,     0,     0,     0,     0,     0,     0,     0,  1688,     0,
       0,     0,   784,  1183,    56,     0,     0,     0,   385,   385,
     385,     0,     0,     0,     0,     0,     0,     0,     0,    57,
       0,     0,  1183,     0,     0,     0,  1183,     0,     0,     0,
       0,     0,     0,     0,  1688,     0,  2574,     0,     0,     0,
       0,     0,   740,     0,  1183,     0,  2366,    58,     0,  2367,
       0,     0,     0,     0,   740,     0,  1183,     0,     0,     0,
       0,     0,     0,     0,   740,     0,  2378,     0,     0,     0,
       0,     0,     0,     0,  2746,  5258,  5259,  5260,  5261,     0,
    2387,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2366,     0,     0,
    2367,     0,     0,     0,  2404,     0,     0,     0,   739,     0,
       0,     0,     0,     0,     0,     0,    59,  2378,     0,     0,
      60,    61,    62,    63,    64,  2746,     0,    65,    66,    67,
      68,  2387,    69,    70,    71,    72,    73,  1183,     0,  1183,
       0,     0,     0,     0,     0,     0,     0,  1183,     0,  1286,
    1286,  2366,     0,   740,  2367,  2404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2378,     0,     0,     0,     0,     0,     0,     0,  2746,
       0,     0,   739,     0,     0,  2387,     0,     0,     0,   385,
       0,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,
    2669,  1280,     0,     0,   740,  5707,   740,  2459,     0,  2404,
       0,  2463,  1280,     0,     0,     0,  1321,     0,     0,  2366,
       0,   740,  2367,   740,     0,     0,     0,     0,     0,     0,
    1286,     0,  2479,  2480,     0,     0,     0,     0,     0,  2378,
       0,     0,     0,     0,  1183,     0,     0,  2746,     0,  2488,
    1286,  1286,     0,  2387,     0,     0,     0,     0,  2459,     0,
       0,     0,  2463,     0,     0,     0,     0,     0,  1183,  1183,
    1183,     0,     0,  1280,  1286,     0,  1280,  2404,  2509,   740,
    2145,  2512,     0,  2479,  2480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2747,     0,     0,  2523,     0,     0,
    2488,   384,     0,     0,     0,     0,     0,     0,     0,     0,
     740,  1286,  2459,  1286,  1286,     0,  2463,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   740,     0,  2509,
       0,     0,  2512,     0,     0,     0,     0,  2479,  2480,     0,
       0,     0,     0,     0,   740,  2747,     0,   740,  2523,  1688,
       0,     0,     0,     0,  2488,     0,     0,     0,     0,     0,
       0,   384,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2574,     0,     0,     0,     0,     0,     0,     0,
    2459,   384,     0,  2509,  2463,     0,  2512,     0,  2247,  2247,
       0,     0,     0,  1183,     0,  1109,     0,     0,     0,  2747,
       0,     0,  2523,     0,     0,  2479,  2480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2283,     0,
       0,  1183,  2488,  2574,  2289,     0,     0,     0,   385,     0,
       0,     0,     0,     0,     0,     0,  1688,     0,     0,     0,
       0,  1914,     0,     0,   384,     0,   384,  1915,     0,     0,
       0,  2509,     0,     0,  2512,     0,     0,     0,     0,     0,
       0,  5531,     0,     0,     0,  1688,     0,  2747,     0,     0,
    2523,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
       0,     0,   384,     0,     0,     0,     0,  1916,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   384,  1688,  1688,
       0,  1688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1688,     0,     0,     0,     0,     0,     0,  2661,  2662,  2663,
       0,  2664,  2665,  2666,  2667,  2668,  2669,  1917,     0,     0,
       0,  5237,   784,   784,  1918,  2574,     0,  1919,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1183,     0,     0,  1688,     0,     0,     0,  2661,  2662,
    2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,     0,     0,
       0,     0,  5973,     0,     0,     0,     0,     0,  1183,  1183,
       0,  1920,     0,     0,     0,     0,  1688,     0,     0,     0,
    1688,  1688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1183,  1183,  2796,     0,   740,     0,     0,     0,     0,
       0,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,
    2668,  2669,     0,     0,     0,     0,  6115,     0,     0,     0,
     784,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1921,     0,  1922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1923,     0,     0,     0,     0,     0,     0,
       0,  1924,   385,     0,     0,     0,     0,     0,   385,     0,
     385,  1925,     0,     0,     0,     0,     0,     0,     0,  2079,
    2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,
       0,     0,  4847,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3705,     0,   385,  1927,  1928,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5705,     0,     0,   740,     0,
       0,   740,     0,  1929,     0,  1183,  2969,     0,     0,     0,
       0,     0,  1183,     0,     0,  1286,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2366,  1706,     0,  2367,  1321,
       0,     0,     0,  1930,     0,  1183,     0,   385,  1183,     0,
       0,     0,     0,     0,     0,  2378,     0,     0,     0,     0,
       0,  1931,     0,  2746,     0,     0,     0,     0,     0,  2387,
       0,     0,  1183,     0,     0,     0,     0,     0,     0,     0,
    1286,  1286,  1286,  1286,  1183,     0,     0,     0,     0,     0,
       0,     0,     0,  2404,     0,     0,     0,     0,  1183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1932,  1933,
       4,   740,   740,     0,     0,  3104,     0,  1183,   740,     0,
       0,  2079,     0,     0,     0,     0,     0,  1286,  1286,     0,
       5,     0,     0,     0,     0,  1286,     0,     0,     0,     0,
       6,     7,     0,     0,     0,     0,  5811,     0,     9,    10,
    1934,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,  1286,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,     0,     0,     0,     0,  2459,     0,     0,     0,
    2463,     0,   740,     0,  1286,  1286,  1286,  1286,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1183,     0,
       0,  2479,  2480,     0,     0,     0,  1183,     0,     0,     0,
    3104,     0,     0,     0,     0,     0,     0,     0,  2488,    46,
       0,     0,     0,     0,     0,     0,  1280,     0,     0,     0,
       0,     0,     0,   784,     0,     0,  1280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1321,  2509,     0,     0,
    2512,  1286,     0,  2715,     0,     0,     0,     0,     0,     0,
    1286,     0,     0,  2747,     0,     0,  2523,     0,  1286,  1286,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4759,     0,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,     0,
       0,     0,     0,     0,     0,     0,  2247,     0,     0,     0,
       0,     0,     0,  1286,     0,  1280,     0,     0,    49,  1183,
    1183,     0,  1286,     0,     0,     0,     0,     0,     0,  1183,
       0,  2574,     0,     0,     0,     0,     0,     0,     0,  1183,
      50,     0,     0,     0,     0,  4760,  1109,  1109,     0,     0,
    3329,     0,     0,     0,  1688,  1688,     0,     0,     0,     0,
       0,     0,  1688,     0,     0,  1688,     0,     0,     0,  1688,
       0,     0,     0,     0,  2079,     0,     0,  1688,  1688,    51,
       0,     0,    52,     0,     0,  1688,     0,  1321,  1688,  1688,
    1688,  1688,     0,     0,     0,   740,     0,    53,     0,  1688,
    1688,     0,  1688,     0,  1688,  1688,     0,     0,  1688,     0,
    1688,     0,  1688,  1688,     0,     0,  1183,     0,     0,     0,
       0,   385,     0,     0,     0,     0,  2366,     0,     0,  2367,
       0,     0,     0,     0,  2079,     0,     0,     0,     0,     0,
    1688,     0,     0,     0,     0,     0,  2378,     0,     0,     0,
    3531,     0,     0,     0,  2746,     0,     0,     0,     0,     0,
    2387,     0,     0,     0,   740,     0,  1286,     0,     0,  2366,
       0,  2079,  2367,    54,     0,     0,   740,     0,     0,     0,
       0,     0,     0,     0,  2404,     0,  2661,  2662,  2663,  2378,
    2664,  2665,  2666,  2667,  2668,  2669,     0,  2746,     0,   740,
       0,     0,     0,  2387,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,     0,     0,     0,     0,
       0,  1688,     0,     0,     0,     0,     0,  2404,     0,    56,
    3532,     0,  2366,     0,     0,  2367,     0,     0,     0,     0,
       0,     0,     0,     0,    57,     0,   740,     0,     0,     0,
    1688,     0,  2378,  2079,     0,     0,     0,     0,     0,     0,
    2746,     0,     0,     0,     0,     0,  2387,     0,   385,     0,
       0,     0,    58,     0,     0,     0,     0,  2071,     0,  6117,
       0,     0,     0,     0,     0,  1688,     0,  2459,     0,  2079,
    2404,  2463,     0,  1914,     0,     0,     0,     0,     0,  1915,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4147,
       0,     0,  2479,  2480,  4148,     0,     0,  2079,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2488,
    2459,     0,     0,     0,  2463,     0,     0,     0,     0,  1916,
       0,    59,     0,     0,     0,    60,    61,    62,    63,    64,
       0,     0,    65,    66,  1496,  2479,  2480,     0,  2509,    71,
    1497,  2512,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6066,  2488,     0,  2747,     0,     0,  2523,     0,     0,
     740,     0,     0,     0,     0,     0,  2079,     0,     0,  1917,
       0,     0,     0,  2459,     0,     0,  1918,  2463,     0,  1919,
       0,  2509,     0,     0,  2512,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2747,  2479,  2480,
    2523,     0,     0,  1688,  1688,  1688,  1688,  1688,  1688,  1688,
    1688,  1688,     0,  1688,     0,  2488,     0,     0,     0,     0,
       0,     0,     0,  1183,     0,     0,  1688,  1688,     0,  2071,
       0,     0,  2574,  1920,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2509,     0,     0,  2512,  1183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2747,     0,     0,  2523,     0,     0,     0,     0,   740,     0,
     740,     0,     0,     0,     0,  2574,     0,     0,     0,     0,
       0,  6067,     0,  3533,     0,  1183,     0,  1183,     0,     0,
       0,  1688,     0,  1921,     0,  1922,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1923,     0,     0,  1688,     0,
       0,     0,     0,  1924,     0,     0,     0,  1688,  1688,     0,
       0,     0,     0,  1925,     0,     0,     0,     0,     0,     0,
       0,  1183,     0,     0,     0,     0,     0,  3563,  2574,  3570,
       0,     0,     0,     0,     0,     0,     0,     0,  2366,   740,
       0,  2367,     0,     0,     0,     0,  3832,     0,     0,  1927,
    1928,     0,     0,     0,     0,     0,     0,     0,  2378,     0,
     385,  4110,     0,  2079,     0,     0,  2746,     0,     0,     0,
       0,     0,  2387,     0,     0,  3833,     0,  2661,  2662,  2663,
       0,  2664,  2665,  2666,  2667,  2668,  2669,   385,     0,   740,
       0,     0,     0,     0,     0,     0,  2404,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   784,     0,     0,     0,
       0,  1109,     0,  1109,     0,  1930,     0,     0,     0,     0,
    2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,
    1688,     0,     0,  1931,     0,     0,     0,     0,     0,     0,
       0,  1280,     0,  1286,  1286,  1286,     0,     0,  1280,     0,
    1321,     0,  1286,     0,  1286,     0,  1286,  1286,     0,     0,
       0,     0,  1183,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1932,  1933,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,
    2667,  2668,  2669,     0,     0,     0,  2969,     0,     0,  2459,
       0,     0,  2071,  2463,     0,     0,     0,  3728,     0,     0,
       0,  2366,     0,     0,  2367,  3740,     0,     0,     0,     0,
       0,  1183,  1934,     0,  2479,  2480,     0,     0,     0,     0,
       0,  2378,     0,     0,     0,     0,     0,     0,     0,  2746,
       0,  2488,     0,     0,     0,  2387,     0,  1183,     0,     0,
       0,  3791,  3791,     0,  2366,     0,     0,  2367,   784,     0,
       0,     0,  2071,     0,     0,     0,     0,     0,     0,  2404,
    2509,     0,     0,  2512,  2378,     0,  1286,  4158,     0,     0,
       0,     0,  2746,     0,     0,     0,  2747,     0,  2387,  2523,
       0,   385,     0,     0,     0,     0,     0,     0,     0,  2071,
       0,     0,     0,  3857,     0,  3860,  3862,     0,     0,     0,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1286,     0,     0,     0,     0,     0,     0,     0,  1286,     0,
       0,     0,     0,  1286,     0,     0,     0,     0,     0,     0,
       0,     0,  1688,     0,  2574,     0,     0,     0,     0,     0,
       0,     0,  2459,     0,     0,     0,  2463,     0,     0,     0,
       0,  2071,     0,     0,     0,     0,  2969,     0,     0,  3791,
       0,  1183,     0,  3974,     0,     0,  1109,  2479,  2480,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2488,  2459,     0,  2071,     0,  2463,
       0,     0,  3857,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1286,  4001,     0,     0,     0,     0,     0,     0,
    2479,  2480,     0,  2509,     0,  2071,  2512,     0,     0,     0,
    2145,     0,     0,     0,     0,     0,     0,  2488,     0,  2747,
       0,     0,  2523,     0,     0,     0,     0,  1286,     0,  1286,
    3791,  1286,  3791,     0,     0,     0,     0,  4125,     0,     0,
       0,     0,     0,     0,     0,     0,  2509,     0,     0,  2512,
       0,     0,     0,     0,  1688, -2545,     0,   740,     0,     0,
       0,     0,  2747,     0,     0,  2523,     0,     0,     0,     0,
       0,     0,     0,     0,  2071,     0,  2247,     0,     0,  2661,
    2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,     0,
       0,     0,     0,     0,     0,     0,     0,  2574,     0,     0,
       0,     0, -2545,     0,     0,     0,     0,  2079,     0,     0,
       0,  2079,  2079,     0, -2545,     0,     0,     0,     0, -2545,
       0,     0,  1280,     0, -2545,     0,     0,     0,  1280, -2545,
       0,   740, -2545,     0, -2545,     0,     0,     0,     0,  1286,
    2574,     0,     0,     0,     0,  1688,  1688,     0,     0,     0,
       0,  1688,  2366,     0,     0,  2367,     0,     0,     0,     0,
       0, -2545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2378,     0,     0,  4170,  1688,  1688,     0,     0,
    2746,  1688,     0, -2545,     0,     0,  2387,     0,     0,     0,
       0,     0,     0,     0,     0,  1688,  1688,  1688,  1688,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1688,
    2404,     0,  1688,     0,     0,     0,     0,     0,  1688,  4184,
       0,     0,     0, -2545,     0,  2079,     0,     0,  1688,  1688,
       0, -2545,  1688,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2545,     0,     0,  1688,     0,  1688,     0,  1321,
     385,  1688,  2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,
    2668,  2669,     0,     0,     0,     0,     0,     0,     0,     0,
    1688,     0,     0,     0,  1183,     0,     0,     0,     0, -2545,
    4238,  2071,     0,  1688,  1688,  1688,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2661,  2662,  2663,     0,  2664,
    2665,  2666,  2667,  2668,  2669,     0,     0,  1688,     0,     0,
     385,     0,     0,  2459,     0,     0,     0,  2463,     0,     0,
       0,     0,  1688,     0,  1113,     0,     0,     0,     0,     0,
     385,     0,     0,     0,     0,     0,     0,  1688,  2479,  2480,
       0,     0,     0,     0,     0,     0,     0,     0, -2545,  4238,
       0,     0,  4297,     0,     0,  2488,  3570,     0,     0,     0,
       0,     0,     0,     0,   738,     0,     0,     0,     0,     0,
       0,     0, -2545,     0, -2545, -2545,     0,     0,     0,     0,
       0,     0,     0,     0,  2509,     0,     0,  2512,  2079,     0,
       0,     0,   896,   385,     0,   385,     0,     0,     0,     0,
    2747,     0, -2545,  2523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1688,     0,  3791,     0,     0,     0,     0,  2247,     0,     0,
       0,   385,     0,     0,     0,     0,     0,   896,     0,     0,
       0,     0,     0,     0, -2545,     0,   385,     0,     0,     0,
       0,     0,     0,  1286,     0,  1286,  1286,  1286,     0,     0,
       0,     0,     0,  2079,  2366,     0,     0,  2367,     0,  2079,
       0, -2545,     0,     0, -2545, -2545,     0, -2545,  2574,     0,
       0,     0,     0,  1139,  2378,     0,     0,  4766,     0,     0,
       0,  1139,  2746,  1139,     0,     0,     0,     0,  2387,     0,
       0,     0,     0,     0,     0,   896,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,  2079,     0,     6,     7,     0,     0,     0,     0,     0,
       0,     9,    10,     0,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,  2459,     0,     0,     0,  2463,
       0,     0,     0,  2661,  2662,  2663,     0,  2664,  2665,  2666,
    2667,  2668,  2669,     0,     0,     0,     0,     0,     0,     0,
    2479,  2480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2488,     0,     0,
       0,     0,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2509,  3791,  3791,  2512,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2747,     0,     0,  2523,     0,  4549,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,  1183,  4597,     0,  1183,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,  1183,     0,  2071,     0,     0,     0,  2071,
    2071,     0,     0,     0,     0,     0,  2247,  1183,     0,     0,
       0,    49,     0,     0,     0,     0,     0,  2247,  1183,     0,
    2574,     0,     0,     0,     0,     0,     0,     0,     0,  1183,
       0,     0,     0,    50,     0,     0,     0,  1183,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1286,     0,
       0,  1286,    51,     0,     0,    52,     0,     0,     0,     0,
       0,  2079,     0,     0,  2079,     0,  2079,     0,  1280,     0,
      53,  2079,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1183,
       0,     0,     0,  2071,     0,     0,     0,     0,     0,  1286,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1688,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1688,
       0,  2079,     0,     0,     0,  1688,     0,  1688,     0,     0,
       0,     0,     0,  1688,     0,     0,  1688,  1688,  1688,  1688,
    1688,  1688,  1688,  1688,  1688,  1688,    54,     0,  2366,  1688,
    1688,  2367,     0,     0,     0,  2661,  2662,  2663,     0,  2664,
    2665,  2666,  2667,  2668,  2669,  1688,     0,  2079,  2378,  1688,
    1688,     0,     0,     0,  1688,     0,  2746,     0,     0,  1688,
       0,     0,  2387,     0,     0,     0,     0,     0,    55,  1688,
       0,     0,  1688,     0,  1688,     0,     0,     0,     0,     0,
       0,     0,    56,  1688,  1688,  1688,  2404,     0,     0,  1688,
       0,     0,  1688,     0,     0,     0,  4796,    57,     0,     0,
       0,     0,     0,  1183,  1183,  1183,  1280,     0,     0,  4238,
    4814,     0,     0,     0,  4814,  4828,     0,     0,     0,     0,
       0,  1688,     0,     0,     0,    58,  2073,  1688,  1688,     0,
       0,     0,     0,     0,     0,     0,  2071,     0,     0,  2079,
       0,  2079,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4163,  1688,     0,     0,     0,     0,     0,
    1688,     0,     0,     0,  3570,     0,  1688,     0,     0,  2459,
       0,     0,     0,  2463,    59,     0,     0,     0,    60,    61,
      62,    63,    64,  2079,     0,    65,    66,  1496,  2199,     0,
       0,  2071,    71,     0,  2479,  2480,     0,  2071,  4888,  2247,
    2247,     0,  3104,     0,     0,     0,     0,     0,     0,     0,
       0,  2488,     0, -2547,     0,     0,     0,     0,     0,     0,
    1286,  1286,  1286,  1286,     0,     0,     0,  2079,     0,     0,
       0,     0,     0,  1914,     0,     0,     0,     0,     0,  1915,
    2509,     0,     0,  2512,     0,     0,     0,     0,  1280,  1280,
    1280,  1280,     0,     0,     0,   896,  2747,     0,  2079,  2523,
   -2547,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2547,     0,   738,     0,  4956, -2547,  2073,  1916,
     738,     0, -2547,     0,     0,     0,     0, -2547,     0,     0,
   -2547,   738, -2547,     0,     0,     0,  4964,     0,  1183,  2071,
    1280,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -2547,
     738,     0,     0,     0,   738,     0,     0,  2079,     0,  1917,
       0,     0,     0,     0,  2574,   738,  1918,  1286,  1286,  1919,
       0, -2547,     0,     0,     0,     0,     0,     0,  2079,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2079,     0,     0,     0,     0,   738,     0,  5050,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2547,     0,   738,     0,     0,     0,     0,   738, -2547,
       0,     0,     0,  1920,     0,     0,     0,     0,   738,     0,
   -2547,     0,     0,     0,     0,     0,     0,     0,     0,  4549,
       0,     0,     0,     0,   738,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1183,     0,     0,
       0,     0,     0,     0,     0,     0,  2079, -2547,  1286,     0,
    1688,     0,     0,     0,     0,     0,  1183,     0,     0,     0,
       0,     0,  5129,  1921,     0,  1922,  2079,     0,     0,     0,
       0,     0,     0,  2969,     0,  1923,     0,     0,     0,     0,
       0,     0,     0,  1924,     0,  1183,     0,     0,     0,     0,
       0,     0,  1113,  1925,  2079,  3857,     0,     0,     0,  2661,
    2662,  2663,  5160,  2664,  2665,  2666,  2667,  2668,  2669,     0,
       0,     0,     0,     0,  1914,     0, -2547,  1139,     0,   738,
    1915,  1139,  1688,  1688,     0,     0,  3872,     0,     0,  1927,
    1928,     0,     0,     0,     0,     0,  2079,     0,     0,     0,
   -2547,     0, -2547, -2547,     0,     0,     0,  3791,     0,  3791,
       0,     0,     0,     0,     0,  3873,     0,     0,     0,     0,
    1916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2547,  2073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1688,     0,     0,     0,  2071,
       0,     0,  2071,     0,  2071,  1930,     0,     0,     0,  2071,
       0,     0,     0,     0,     0,     0,     0,   738,   738,     0,
    1917,     0, -2547,  1931,  1688,     0,     0,  1918,     0,     0,
    1919,     0,     0,     0,  1688,     0,     0,     0,     0,     0,
       0,  2073,     0,     0,     0,  1688,  1688,     0,     0, -2547,
    1688,     0, -2547, -2547,     0, -2547,     0,  1688,  1688,  2071,
       0,     0,  1688,     0,     0,     0,  2079,     0,  1688,  1688,
    1932,  1933,  1688,     0,     0,  1688,  5257,     0,  2073,  1183,
    1183,  1183,  1183,     0,  1920,     0,  4814,  4828,     0,  1688,
    4814,     0,     0,  5267,  1139,  1139,     0,  4238,     0,  2366,
       0,  4238,  2367,     0,     0,  2071,     0,  5280,     0,     0,
       0,   738,  1934,  1688,     0,     0,     0,     0,  1688,  2378,
       0,     0,     0,  1688,     0,     0,     0,  2746,     0,     0,
       0,     0,  1321,  2387,     0,     0,     0,     0,     0,  4297,
       0,     0,     0,  3570,  1921,     0,  1922,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1923,  2404,     0,     0,
    2073,     0,  1109,     0,  1924,  1688,     0,     0,     0,     0,
       0,     0,     0,     0,  1925,     0,     0,  2079,     0,     0,
       0,     0,     0,     0,     0,  3791,  3791,     0,     0,   738,
       0,     0,     0,     0,     0,     0,  2073,  2071,     0,  2071,
       0,     0,     0,     0,  1280,  1280,     0,  4372,     0,     0,
    1927,  1928,     0,     0,  1280,     0,     0,     0,     0,     0,
    1280,     0,     0,     0,  2073,     0,     0,     0,     0,     0,
       0,     0,  5366,     0,     0,     0,  4373,     0,     0,     0,
     738,     0,     0,     0,     0,     0,  1286,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   738,   738,     0,     0,
    2459,  2071,     0,     0,  2463,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1930,     0,     0,     0,
       0,   738,     0,     0,     0,  2479,  2480,     0,     0,     0,
       0,     0,     0,  2073,  1931,     0,     0,     0,     0,     0,
       0,     0,  2488,     0,     0,  2071,     0,     0,     0,     0,
       0,     0,  1286,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,  1286,     0,     0,     0,
       0,  2509,   738,     0,  2512,     0,  2071,     0,     0,     0,
       0,  1932,  1933,     0,     0,   738,     0,  2747,   738,     0,
    2523,     0,     0,  2079,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4549,  4549,  4549,  4549,  4549,     0,     0,
       0,     0,     0,  1934,     0,     0,     0,     0,     0,     0,
       0,  2079,     0,  1914,     0,  2079,     0,  1688,     0,  1915,
       0,     0,     0,     0,     0,  2071,     0,     0,  1280,     0,
       0,     0,     0,  2969,     0,     0,     0,     0,     0,     0,
       0,     0,  2247,     0,     0,  2574,  2071,     0,     0,     0,
       0,     0,     0,     0,  1286,  2969,     0,     0,     0,  1916,
    2071,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5521,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1183,     0,  5535,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   738,
       0,     0,     0,     0,     0,     0,     0,   738,   738,  1917,
       0,     0,     0,     0,     0,     0,  1918,  1688,   896,  1919,
    2073,     0,     0,     0,     0,     0,     0,     0,  1688,     0,
       0,     0,  2079,     0,  2071,     0,     0,     0,     0,     0,
    1688,     0,     0,     0,     0,     0,     0,  2079,     0,  1688,
    1688,     0,     0,  1688,  2071,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1280,     0,  4814,     0,
       0,     0,  4238,  1920,   896,     0,     0,  4238,     0,     0,
    4238,  3857,  2071,  5588,     0,  1688,  1688,     0,     0,     0,
       0,     0,     0,     0,     0,   738,     0,     0,     0,     0,
    2661,  2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,
       0,     0,     0,     0,     0,     0,     0,     0,  4888,  1321,
    1286,  1286,  1286,     0,  2071,     0,     0,     0,     0,     0,
       0,     0,     0,  1921,     0,  1922,     0,     0,     0,   896,
       0,     0,  1280,     0,     0,  1923,  1139,  1280,  1688,     0,
    1688,     0,     0,  1924,     0,     0,  1280,     0,     0,     0,
       0,     0,     0,  1925,     0,     0,     0,  2079,     0,     0,
       0,     0,     0,     0,     0,     0,  4964,  1286,     0,     0,
       0,     0,  1139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4441,     0,     0,  1927,
    1928,     0,  1280,  1321,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2079,     0,
       0,     0,     0,     0,     0,  4442,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2071,     0,     0,     0,     0,     0,
       0,  2247,  2247,     0,     0,     0,     0,  2079,     0,  1280,
       0,     0,     0,     0,     0,  1930,   904,     0,     0,  1183,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5129,     0,     0,  1931,     0,     0,     0,   738,     0,  3791,
       0,     0,     0,  2969,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5160,     0,     0,
    1183,   904,     0,     0,     0,  2079,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1286,  4888,     0,     0,     0,
    1932,  1933,     0,     0,     0,     0,     0,  1359,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1688,
       0,  1688,     0,     0,  1688,  2071,  1688,  1143,     0,     0,
       0,     0,     0,     0,     0,  1143,     0,  1143,     0,     0,
    1360,   896,  1934,     0,     0,     0,  1688,     0,     0,   904,
       0,  1688,     0,  1361,  1362,  4238,     0,     0,  5588,     0,
       0,   738,     0,  1363,     0,  1688,     0,  1364,     0,     0,
    5801,  -966,     0,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,   964,  1365,     0,     0,     0,     0,     0,
    1183,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   965,  1366,     0,     0,     0,  1280,
       0,     0,     0,     0,     0,     0,  1367,   966,     0,     0,
       0,   738,   738,     0,  1368,     0,     0,   967,     0,     0,
       0, -1001,   738,     0,     0,     0,  1369,     0,     0,     0,
       0,  1370,     0,     0,   738,   738,     0,     0,   968,  1286,
    1286,  1286,  1286,     0,   969,  2079,     0,     0,     0,     0,
       0,     0,  1371,     0,  2247,     0,     0,     0,   738,   970,
       0,     0,     0,     0,  2073,     0,     0,     0,  2073,  2073,
     971,     0,     0,     0,     0,     0,  1280,  1372,   972,  -695,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     973,  2071,     0,     0,     0,  1688,     0,   974,  1373,     0,
       0,   975,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5521,     0,     0, -1209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2071,
       0,     0,  1374,  2071,     0,     0,     0,     0,     0,  1688,
       0,     0,  1280,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,  1688,     0,  1688,     0,
    1688,   934,  -762,     0,     0,     0,     0,     0,  1286,  2079,
    1321,     0,     0,  1914,     0,     0,     0,     0,     0,  1915,
       0,     0,  2073,     0,  1688,     0,     0,     0,  1375,     0,
       0,     0,  1376,     0,  1377,     0,   977,     0,  2079,   978,
    1378,     0,     0,  1379,  1957,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1916,
       0,     0,     0,     0,   896,     0,     0,     0,     0,  1380,
       0,  1381,  1286,     0,  -507,  1382,     0,  1280,     0,     0,
       0,     0,     0,  1383,     0,     0,     0,     0,  1384,     0,
    2071,  1958,   979,     0,  4888,     0,     0,     0,   980,     0,
       0,     0,     0,  5535,  -507,  2071,     0,   981,     0,  1917,
    1688,  1688,     0,  1385,     0,  3857,  1918,     0,     0,  1919,
    1688,     0,     0,  5801,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -507,     0,   982,   983,     0,   984,   985,
       0,     0,     0,     0,     0,  1280,     0,   986,     0,     0,
       0,     0,   987,     0,  1286,     0,     0,     0,   988,     0,
       0,   989,     0,     0,   990,     0,     0,     0,     0,     0,
    1959,     0,     0,  1920,     0,     0,     0,  -507,     0,     0,
       0,     0,     0,     0,     0,  2073,  1386,  2079,     0,     0,
       0,     0,  2079,     0,     0,     0,     0,  1688,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1688,     0,  2079,     0,  1960,     0,
       0,     0,     0,  1961,  1286,  2071,     0,     0,     0,     0,
       0,     0,     0,  1962,     0,  1922,     0,   991,     0,     0,
       0,     0,     0,     0,     0,  1923,   992,  2247,     0,     0,
     993,     0,     0,  1924,  2079,     0,     0,     0,     0,     0,
    2073,     0,  1963,  1925,   994,     0,  2073,     0,   918,     0,
       0,     0,     0,     0,     0,     0,  2071,     0,     0,     0,
       0,     0,     0,  1183,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3819,     0,     0,  1927,
    1928,  1965,     0,     0,     0,     0,     0,     0,     0,     0,
   -2561,     0,  1688,     0,   919,  2071,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3820,     0,     0,   920,  2079,
       0,     0,     0,  2079,  2079,     0,  1967,     0,     0,     0,
       0,     0,     0,     0,     0,   921,     0,     0,     0,     0,
       0,   922,     0,     0,     0,     0,     0, -2561,  1280,     0,
       0,     0,     0,     0,     0,  1930,   923,     0,  2073, -2561,
    2247,     0,     0,  2071, -2561,     0,     0,   924,     0, -2561,
       0,     0,     0,  1931, -2561,   925,   926, -2561,     0, -2561,
       0,     0,     0,     0,     0,     0,     0,   927,     0,     0,
       0,     0,   928,     0,     0,  2247,     0,     0,   929,     0,
       0,     0,     0,  2247,     0,     0, -2561,     0,     0,     0,
       0,     0,     0,   930,     0,     0,     0,     0,     0,     0,
    1932,  1933,     0,     0,     0,     0,     0,     0, -2561,     0,
       0,     0,     0,     0,     0,     0,     0,  2247,   931,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,   932,
       0,     0,  1934,     0,     0,     0,     0,  1282, -2561,     0,
       0,     0,  2079,  2079,     0,     0, -2561,     0,     0,     0,
       0,     0,  1026,     0,     0,     0,     0, -2561,     0,     0,
       0,     0,     0,   933,  1027,     0,     0,     0,     0,     0,
     738,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,     0,   934,     0, -2561,     0,     0,     0,  1029,     0,
       0,     0,     0,  2071,     0,     0,     0,     0,     0,     0,
     738,     0,  1030,     0,   896,   738,     0,     0,   738,   935,
       0,     0,     0,   936,     0,   937,     0,     0,     0,  1031,
       0,   938,     0,     0,   939,  1282,     0,     0,     0,  1113,
     738,     0,     0,     0,     0,     0,  1282,     0,     0,     0,
    1032,     0,     0,     0,     0,     0,     0,     0,     0,   940,
     941,  1033,   942, -2561,     0,     0,   943,     0,     0,  1034,
    1035,     0,     0,     0,   944,     0,     0,     0,     0,   945,
       0,  1036,     0,     0,     0,   738,  1037, -2561,     0, -2561,
   -2561,   946,  1038,     0,     0,     0,     0,     0,     0,  1139,
       0,     0,     0,     0,   947,   738,   738,  1039,  2073,     0,
       0,  2073,     0,  2073,     0,     0,     0, -2561,  2073,     0,
       0,     0,     0,     0,     0,     0,     0,  2071,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   896,   738,     0,
       0,     0,   896,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1040,     0,     0,  2071,     0,     0, -2561,
       0,     0,     0,     0,     0,  1282,     0,     0,  2073,     0,
     948,  1143,  1139,     0,   738,  1143,     0,   949,   738,     0,
       0,     0,     0,     0,     0,     0, -2561,  1041,     0, -2561,
   -2561,     0, -2561,     0,     0,     0,   738,     0,  1042,     0,
       0,  1282,     0,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,     0,  2073,     0,   934,     0,     0,     0,
     738,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,     0,     0,     0,     0,     0,     0,   738,     0,
       0,     0,     0,  1043,     0,     0,     0,  1044,     0,  1045,
       0,     0,     0,     0,     0,  1046,     0,     0,  1047,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1048,     0,  1049,     0,     0,     0,
    1050,     0,     0,     0,   896,     0,     0,     0,  1051,     0,
       0,     0,     0,  1052,     0,  2071,  2073,     0,  2073,     0,
    2071,     0,  2079,     0,     0,  1053,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1054,     0,
       0,     0,     0,     0,  2071,     0,     0,     0,  1143,  1143,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   738,     0,     0,     0,     0,     0,  1282,     0,
    2073,     0,  2071,     0,     0,     0,     0,     0,     0,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1055,     0,     0,     0,     0,   738,
       0,  1056,  2082,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2073,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
    1282,     0,     0,  1282,     0,  2073,     0,  2071,   738,     0,
       0,  2071,  2071,     0,     0,     0,     5,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     6,     7,     0,     0,
       0,   738,     0,     0,     9,    10,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  2073,     0,  1282,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,   896,     0,     0,     0,
       0,     0,     0,   896,     0,    46,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2071,  2071,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2073,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,     0,    47,     0,     0,     0,
       0,     0,     0,  2073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    48,     0,   738,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,  1282,     0,  1282,     0,
       0,  2073,     0,     0,    49,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    51,     0,     0,    52,     0,
       0,  1282,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   738,    53,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   738,   738,     0,
       0,     0,     0,  1282,     0,     0,     0,  1282,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   738,     0,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    54,
       0,     0,     0,  2073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2082,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,     0,     0,
    1143,    55,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    56,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   896,   896,   896,     0,     0,
      57,     0,     0,     0,     0,     0,  1143,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2082,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    58,   738,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,     0,     0,  2073,     0,     0,     0,     0,     0,
       0,   738,     0,     0,  2082,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2071,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    59,     0,     0,
       0,    60,    61,    62,    63,    64,     0,     0,    65,    66,
    1496,  3258,     0,     0,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2082,     0,     0,     0,
     738,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2082,     0,     0,     0,   896,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,     0,   738,     0,   904,     0,     0,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,   738,     0,
     738,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2073,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2073,     0,
       0,     0,  2073,  1282,     0,     0,   738,     0,     0,  2082,
       0,     0,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   738,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,     0,     0,   738,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2073,     0,     0,     0,     0,     0,
       0,  1282,  1282,     0,     0,     0,     0,     0,     0,  1282,
       0,     0,  1282,     0,     0,   896,  1282,     0,     0,     0,
       0,     0,     0,     0,  1282,  1282,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,  1282,  1282,  1282,  1282,     0,
       0,     0,     0,     0,     0,     0,  1282,  1282,     0,  1282,
       0,  1282,  1282,     0,     0,  1282,     0,  1282,     0,  1282,
    1282,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2082,     0,     0,     0,
       4,     0,     0,     0,     0,     0,     0,  1282,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       6,     7,     0,     0,  2073,     0,     0,     0,     9,    10,
       0,     0,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,     0,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,     0,     0,     0,  2073,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,  2073,     0,     0,     0,     0,    46,
       0,     0,   738,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2073,     0,     0,     0,     0,     0,     0,   896,
       0,     0,     0,     0,     0,   896,     0,   896,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   896,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   738,     0,     0,   738,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1282,  1282,  1282,  1282,  1282,  1282,  1282,  1282,  1282,    51,
    1282,     0,    52,     0,   896,     0,     0,     0,     0,     0,
       0,     0,     0,  1282,  1282,     0,     0,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2073,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   738,   738,
       0,     0,     0,     0,     0,   738,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    54,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   738,
       0,     0,     0,     0,    57,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2073,     0,     0,     0,
    2082,     0,     0,     0,  2082,  2082,     0,     0,     0,     0,
       0,     0,    58,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,  2073,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,     0,     0,     0,    60,    61,    62,    63,    64,
       0,     0,    65,    66,  1496,     0,     0,     0,     0,    71,
       0,     0,     0,  1143,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2082,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,   904,     0,     0,     0,
       0,   744,     0,     0,     0,     0,   788,     0,   788,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   788,     0,
       0,     0,     0,     0,  2073,     0,  1143,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,     0,     0,     0,
       0,     0,   738,  2073,   788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,   788,     0,     0,   788,
       0,     0,     0,     0,     0,   788,     0,     0,   896,  1101,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2073,     0,     0,     0,     0,     0,     0,     0,  1101,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,     0,     0,     0,
       0,   738,     0,     0,     0,     0,     0,     0,     0,  1282,
       0,  2082,     0,   738,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,     0,   738,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2073,     0,     0,     0,
    2073,  2073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   738,     0,     0,  2082,     0,     0,     0,
       0,     0,  2082,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,     0,     0,  2073,
    2073,     0,     0,     0,     0,     0,     0,     0,     0,  1282,
       0,     0,     0,     0,     0,  1282,     0,   738,     0,     0,
       0,     0,     0,   788,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,  1282,     0,     0,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1282,  1282,     0,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,  1282,  1282,  1282,     0,     0,     0,     0,
     904,     0,     0,     0,     0,     0,  1282,   904,     0,  1282,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,  1282,     0,     0,  1282,
       0,     0,     0,     0,     0,   738,     0,   738,     0,     0,
       0,     0,  1282,     0,  1282,     0,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
    1282,  1282,  1282,     0,     0,     0,     0,     0,     0,  1285,
    1287,     0,     0,  1290,     0,  1292,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1337,   738,     0,  1343,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,  1394,   896,     0,     0,
    1397,     0,     0,     0,     0,     0,  1282,     0,     0,     0,
       0,     0,   788,     0,     0,     0,     0,  1420,     0,     0,
       0,     0,     0,     0,   896,     0,   738,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,  2082,     0,  2082,
       0,     0,     0,     0,  2082,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,     0,     0,     0,
     788,   788,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,   788,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
     904,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   896,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2082,     0,  2082,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2082,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1943,  1944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1442,   788,     0,   788,     0,     0,     0,     0,     0,     0,
     904,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2044,     0,
       0,     0,     0,     0,     0,   788,     0,     0,   788,   788,
       0,     0,     0,     0,   738,     0,     0,     0,  2099,  2100,
       0,     0,     0,     0,   744,     0,  1101,     0,  1101,     0,
    2082,     0,     0,     0,   744,     0,     0,     0,   788,     0,
       0,     0,  2136,     0,     0,     0,     0,     0,     0,     0,
       0,  2082,     0,     0,     0,     0,     0,  1101,  1101,     0,
       0,     0,     0,     0,     0,  2082,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2171,  2173,     0,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
     788,     0,   788,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,     0,  2082,
       0,     0,     0,     0,     0,     0,  1282,     0,     0,     0,
       0,     0,  1282,     0,  1282,     0,     0,     0,     0,  2082,
    1282,     0,     0,  1282,  1282,  1282,  1282,  1282,  1282,  1282,
    1282,  1282,  1282,     0,     0,     0,  1282,  1282,     0,     0,
     744,     0,     0,     0,     0,     0,     0,  2082,     0,     0,
       0,     0,  1282,     0,   744,   744,  1282,  1282,  1823,   904,
       0,  1282,     0,     0,     0,     0,  1282,   896,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,     0,  1282,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,  2082,
    1282,  1282,  1282,     0,     0,     0,  1282,     0,     0,  1282,
    1141,     0,     0,     0,     0,     0,   744,     0,  1141,     0,
    1141,     0,     0,  1282,     0,     0,  1282,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   896,  1282,     0,
       0,     0,     0,     0,  1282,  1282,  2074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   896,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2082,
     896,     0,   896,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   896,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   896,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,  1282,  1282,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2074,     0,
       0,     0,     0,   904,     0,     0,     0,     0,   744,   904,
    2082,   904,     0,   788,     0,   788,     0,  1282,   788,     0,
     788,     0,     0,   788,   788,   788,     0,     0,     0,  2242,
       0,     0,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   904,     0,   788,
       0,   788,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2991,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3066,  3067,
    3068,  3069,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2690,     0,     0,  2082,     0,     0,     0,
       0,     0,   788,   788,     0,  3112,  3113,     0,     0,     0,
       0,     0,     0,  3122,     0,     0,     0,     0,     0,   744,
       0,     0,     0,     0,   744,   744,     0,     0,     0,     0,
       0,     0,     0,     0,  2082,     0,     0,     0,  2082,  1282,
    1282,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3177,  3178,  3179,  3180,     0,     0,     0,     0,
       0,  2074,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,     0,     0,     0,     0,     0,
     788,     0,   744,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2832,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,  3246,
       0,  2074,  1282,  1282,     0,  2082,     0,  1282,  3250,     0,
       0,     0,     0,     0,  1282,  1282,     0,  3257,     0,  1282,
    2082,     0,     0,     0,     0,  1282,  1282,     0,     0,  1282,
       0,     0,  1282,     0,     0,     0,     0,   744,  2074,     0,
       0,     0,     0,     0,     0,     0,  1282,   744,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,     0,  1282,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1282,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
    1282,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   744,
       0,     0,   744,   744,     0,     0,     0,     0,     0,     0,
    2074,     0,  1282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2074,     0,     0,     0,
    1278,  1282,  1282,     0,     0,     0,     0,     0,     0,     0,
    1278,  1282,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,   904,     0,  2074,   744,     0,     0,     0,     0,
       0,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3438,     0,     0,     0,     0,     0,
    2082,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2074,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,  2082,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2081,  1282,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,   788,     0,     0,     0,
     788,     0,   788,     0,     0,   788,     0,     0,     0,   788,
       0,     0,     0,     0,  2690,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,  1141,     0,     0,     0,  1141,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2082,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,     0,  2082,     0,
    2074,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,  1282,     0,     0,
    1282,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1282,     0,     0,     0,     0,     0,  1282,
       0,     0,     0,     0,  1282,     0,     0,  1282,     0,     0,
       0,     0,  1282,  1282,     0,  2081,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1141,  1141,     0,     0,     0,     0,     0,     0,  1282,
       0,     0,  2082,     0,  1282,  1282,     0,  1282,     0,     0,
       0,     0,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2082,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,     0,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1278,     0,     0,  1278,     0,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3656,  3657,  3658,     0,     0,     0,     0,     0,     0,
    3668,     0,  3670,     0,  3672,  3673,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2082,     0,     0,  1282,     0,  2082,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,  1282,  2082,
       0,  1282,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2080,  2861,     0,
       0,     0,     0,  1282,     0,     0,     0,     0,  1282,     0,
       0,     0,  1282,     0,     0,     0,     0,  2082,     0,     0,
       0,     0,  1282,  2242,     0,     0,  1278,     0,     0,     0,
    3502,     0,     0,     0,     0,     0,     0,     0,     0,  2832,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3824,  1278,     0,     0,  2861,     0,
       0,     0,     0,     0,     0,     0,  1282,     0,     0,     0,
       0,     0,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,  1278,
       0,  1278,  2082,     0,     0,  2081,  2082,  2082,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,  3902,     0,
       0,     0,     0,     0,     0,     0,  3911,     0,     0,     0,
       0,  3912,     0,     0,  2074,     0,     0,     0,  2074,  2074,
       0,     0,     0,  1282,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,   744,  1278,     0,     0,   744,     0,     0,
       0,     0,     0,  3584,     0,  1823,     0,  2081,   788,     0,
       0,     0,     0,     0,     0,     0,     0,  2082,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
    1278,  1278,     0,     0,     0,     0,  1282,     0,     0,  1282,
    3999,     0,     0,  2081,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1282,     0,  1282,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2081,     0,     0,     0,  2082,  2082,  4041,     0,  4043,
       0,  1282,  2074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2080,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1141,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,     0,     0,     0,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,  1141,
       0,     0,     0,     0,     0,     0,     0,  1282,  1282,     0,
    2080,     0,     0,     0,     0,     0,     0,  1282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4098,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1282,     0,     0,     0,     0,  2080,     0,     0,
     744,     0,     0,     0,     0,     0,     0,     0,   744,     0,
     744,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2074,     0,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1282,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2074,     0,     0,     0,     0,  2080,  2074,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2081,     0,     0,
       0,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,  1282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1282,  1278,     0,     0,     0,
       0,     0,  2080,     0,     0,     0,  1278,     0,  2074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   904,  2082,   904,     0,     0,     0,
       0,   788,  2242,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   904,     0,     0,
       0,  4353,     0,  4354,  4355,  4356,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,  1278,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,  1278,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,  1278,  1278,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,  1278,  1278,
    1278,  1278,     0,     0,     0,     0,     0,     0,     0,  1278,
    1278,     0,  1278,     0,  1278,  1278,     0,     0,  1278,     0,
    1278,     0,  1278,  1278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2832,     0,
       0,     0,     0,   744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2074,     0,
       0,  2074,     0,  2074,     0,     0,     0,     0,  2074,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3596,     0,     0,     0,  2861,  3602,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4680,     0,     0,  4681,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2074,     0,  2074,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1278,  1278,  1278,  1278,  1278,  1278,  1278,
    1278,  1278,     0,  1278,     0,     0,     0,  4708,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,  1278,     0,  2081,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2074,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1278,     0,     0,  2074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,  1278,  1278,     0,
       0,     0,     0,     0,     0,  2074,     0,     0,     0,     0,
       0,   744,   744,   744,   744,     0,   744,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   744,     0,     0,     0,     0,     0,
       0,     0,  2081,  2080,  2074,     0,     0,  2080,  2080,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2074,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2074,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,  2861,     0,     0,
       0,     0,     0,  2861,     0,     0,     0,     0,  4905,  4906,
    4907,  4908,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1141,     0,     0,     0,
       0,     0,     0,  2074,     0,     0,     0,     0,     0,     0,
       0,  2080,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2074,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   744,     0,     0,
       0,  2074,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1141,
       0,     0,     0,     0,     0,  2081,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2074,     0,  5016,  5017,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1278,     0,  2080,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2074,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,  3500,  3500,  3500,     0,  2080,     0,     0,     0,     0,
       0,  3584,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2861,     0,  2080,  3602,     0,
    3602,     0,     0,     0,     0,  2861,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,   744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,  1278,     0,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   744,     0,     0,  2081,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,  1278,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,  1278,  1278,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,  2861,  1278,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,   744,     0,     0,   744,   744,     0,  1278,  1278,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,  1278,     0,     0,
    2074,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,  1278,  1278,  1278,     0,     0,  2074,     0,
       0,     0,  2074,     0,     0,  1012,     0,     0,     0,     0,
       0,     0,     0,  2081,  1012,  2081,     0,  1278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5376,     0,     0,  1278,     0,     0,
       0,     0,     0,  1012,     0,     0,     0,   744,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2081,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2080,     0,     0,
    2080,     0,  2080,   744,     0,     0,     0,  2080,     0,     0,
    5422,     0,     0,     0,     0,     0,     0,     0,     0,  2074,
       0,  2081,     0,     0,  5425,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,  2074,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3602,     0,     0,     0,     0,  2080,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2081,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3602,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2074,     0,  2081,  2832,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1246,     0,     0,     0,   744,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,  2080,     0,     0,
       0,     0,     0,     0,     0,  2074,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2074,     0,     0,     0,     0,     0,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,  2080,
       0,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2081,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5615,  5376,
    5376,     0,  2074,  2080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2081,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5648,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3500,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     744,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2080,     0,
    2861,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,  2074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1012,
    1012,     0,     0,  5753,     0,     0,     0,     0,     0,  1278,
       0,     0,  2080,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,  1278,     0,  1278,     0,     0,
       0,     0,  2080,  1278,     0,     0,  1278,  1278,  1278,  1278,
    1278,  1278,  1278,  1278,  1278,  1278,     0,  1246,     0,  1278,
    1278,  3602,     0,     0,     0,     0,     0,     0,     0,     0,
    2080,     0,     0,     0,     0,  1278,     0,     0,     0,  1278,
    1278,     0,     0,     0,  1278,     0,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,  1278,     0,  1278,     0,  2074,     0,     0,     0,
       0,     0,  2080,  1278,  1278,  1278,     0,     0,     0,  1278,
       0,   788,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2074,  1278,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,  1278,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5841,     0,
    5843,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1293,     0,     0,     0,
       0,     0,     0,     0,   744,     0,     0,  1324,  1325,     0,
    1328,     0,     0,  1334,  1278,  1336,     0,     0,     0,  1344,
    1278,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
       0,     0,     0,     0,     0,  1392,     0,     0,     0,     0,
       0,     0,  2080,  1400,     0,     0,     0,  2081,     0,     0,
       0,     0,  1416,  1417,     0,     0,     0,  1419,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1246,     0,  1012,     0,     0,  3602,     0,     0,     0,  2861,
       0,     0,     0,     0,  2074,     0,     0,     0,  1454,  2074,
       0,     0,     0,     0,     0,     0,  5376,     0,  1278,  1278,
    1278,  1278,     0,     0,     0,  1479,     0,     0,  1481,     0,
    1483,     0,  1486,  2074,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
    1278,  2074,     0,     0,     0,     0,     0,     0,     0,     0,
    5970,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1569,     0,  1570,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2081,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2081,     0,     0,     0,     0,     0,     0,     0,  1246,
       0,     0,     0,     0,     0,     0,  2074,     0,     0,     0,
    2074,  2074,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1197,     0,     0,     0,     0,
       0,  3500,     0,     0,     0,     0,  3500,     0,     0,     0,
       0,  3500,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6080,     0,     0,     0,     0,     0,     0,  2080,
       0,     0,     0,     0,     0,     0,  1841,     0,  1843,     0,
       0,  2081,  1845,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1874,     0,     0,     0,     0,  2080,     0,     0,
       0,  2080,  1278,  1278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2074,
    2074,     0,  2081,     0,     0,     0,     0,   744,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2012,     0,  2015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2081,     0,     0,  2028,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2038,     0,     0,
       0,     0,     0,     0,  2040,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,  2088,     0,     0,  2092,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,  1278,     0,  2080,  2081,
    1278,     0,     0,     0,  2124,     0,     0,  1278,  1278,     0,
       0,     0,  1278,  2080,     0,     0,  2140,     0,  1278,  1278,
       0,     0,  1278,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,  1278,     0,     0,
       0,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1278,     0,     0,     0,     0,  1278,     0,
       0,  2192,     0,  1278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5529,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,  2081,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2074,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2080,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2081,     0,     0,  3500,     0,  3500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3602,     0,     0,     0,     0,     0,   744,     0,
       0,     0,  1197,  2752,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2828,     0,     0,  2828,     0,     0,
       0,     0,     0,     0,     0,  2835,     0,     0,     0,     0,
       0,     0,  2080,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2844,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1278,     0,     0,
       0,  2080,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,  2929,     0,     0,     0,     0,     0,     0,     0,
    1278,  2081,     0,     0,     0,     0,  3602,     0,     0,  1278,
    1278,     0,     0,  1278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
    2081,     0,  1278,     0,     0,     0,     0,  1278,     0,     0,
    1278,     0,     0,     0,     0,  1278,  1278,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2081,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,  2080,     0,  1278,  1278,     0,
    1278,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2080,     0,     0,     0,     0,     0,
       0,     0,     0,  2081,     0,     0,     0,  2081,  2081,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3152,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,  3175,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3216,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3230,     0,     0,     0,     0,     0,
       0,     0,     0,  2080,     0,     0,  1278,     0,  2080,  3245,
       0,  3247,     0,  3248,     0,     0,  2081,  2081,  3249,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,  1278,  2080,     0,  1278,     0,  1278,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
       0,  1278,     0,     0,     0,  1278,     0,     0,     0,  3278,
    2080,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,  2752,     0,     0,     0,  2752,     0,  2752,     0,     0,
    2752,     0,  2752,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,     0,  2080,
    2080,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2080,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1278,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1278,     0,  1278,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2080,  2080,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3602,     0,     0,     0,
    1278,  1278,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3501,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1278,     0,     0,     0,     0,     0,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,  1747,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1246,  2080,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3611,  3612,     0,
       0,     0,  3615,  3616,     0,     0,  3619,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3629,     0,     0,     0,
       0,     0,     0,  3638,     0,     0,     0,  3641,  3642,  1283,
       0,  3645,  3646,     0,     0,     0,     0,     0,  3651,     0,
    1283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3667,     0,  3669,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3695,     0,     0,     0,     0,  3697,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3704,     0,     0,     0,     0,     0,     0,
       0,     0,  3724,     0,     0,     0,     0,  3729,  3730,  3733,
    3735,     0,     0,     0,     0,     0,     0,  3745,  3748,     0,
       0,     0,     0,     0,     0,  3759,     0,     0,     0,     0,
    3769,     0,     0,     0,     0,     0,     0,     0,  3779,     0,
       0,  2076,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,  3818,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3825,     0,  3827,     0,
       0,     0,     0,  3830,     0,     0,     0,  3831,     0,  3835,
    3836,  3837,  3838,     0,  3840,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3864,  3865,     0,
    3867,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3875,  3876,  3877,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3945,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2077,
       0,     0,     0,  2076,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2298,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,  2322,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,     0,     0,     0,
    2352,  2353,     0,  2357,     0,     0,     0,     0,     0,     0,
    1246,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2680,  2752,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1283,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2734,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2762,     0,
    1283,     0,  2774,  2779,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2076,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2076,  4276,     0,  1283,
    1283,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2076,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,  4324,
    4325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2752,     0,     0,     0,
       0,     0,     0,     0,  2077,     0,     0,  1283,     0,     0,
       0,  1283,  1283,     0,     0,  2076,     0,     0,     0,     0,
       0,  4347,     0,     0,     0,     0,     0,     0,     0,     0,
    4351,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4362,  4364,     0,     0,     0,
    4364,  2076,     0,     0,     0,  4375,  4376,  4377,     0,     0,
       0,     0,     0,     0,  2077,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4416,  4417,  4418,  4419,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2076,     0,
       0,  2083,     0,     0,     0,     0,  4440,     0,  4444,  4445,
    4446,     0,     0,     0,     0,     0,     0,     0,  4459,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2077,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2077,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4511,     0,     0,     0,     0,     0,  2077,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4526,     0,     0,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3357,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2083,  3380,     0,     0,
    3382,  2078,     0,  3393,     0,     0,  2077,     0,  4593,     0,
       0,  3402,  3407,     0,     0,     0,  3412,  3414,     0,     0,
    3419,     0,  3421,     0,  2083,  3424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,  2076,     0,     0,     0,     0,
       0,     0,  3432,  4624,     0,     0,     0,     0,  4628,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,     0,
       0,     0,     0,  2083,     0,  1012,     0,  1283,  4672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4682,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,     0,     0,  2752,     0,     0,     0,     0,
       0,     0,     0,  3439,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2078,     0,     0,     0,
       0,     0,  3451,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3458,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2077,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,  1283,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,  1283,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,     0,     0,  1283,  1283,
       0,     0,     0,  2078,     0,     0,  1283,     0,     0,  1283,
    1283,  1283,  1283,     0,     0,     0,     0,     0,     0,     0,
    1283,  1283,     0,  1283,     0,  1283,  1283,     0,     0,  1283,
       0,  1283,     0,  1283,  1283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3460,  3461,  3462,  3463,  3464,
    3465,  3466,  3467,  3468,     0,  3469,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1672,  3497,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4899,     0,  4900,     0,     0,     0,
       0,     0,     0,  4902,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,  1747,     0,     0,     0,     0,     0,  4911,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4919,     0,     0,     0,  2352,
    2353,     0,     0,     0,     0,     0,  1283,     0,  4939,     0,
    2078,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4953,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4958,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,  2076,  2076,     0,     0,     0,  5018,  5019,
    5020,     0,     0,  5023,  5024,  5025,  5026,  5027,     0,     0,
       0,     0,  5034,  5035,     0,  5037,  5038,  5039,  5040,  5041,
    5042,  5043,     0,     0,     0,     0,     0,     0,     0,     0,
    5051,     0,  3643,  5053,  5054,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1283,  1283,  1283,  1283,  1283,  1283,
    1283,  1283,  1283,     0,  1283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5110,  5112,  5114,     0,     0,  5117,     0,
       0,     0,     0,     0,     0,     0,     0,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2077,     0,  1283,
       0,  2077,  2077,     0,     0,     0,     0,     0,  1283,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2752,  2752,  2752,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,     0,  2083,  2083,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3920,     0,     0,     0,     0,     0,
    2076,     0,     0,     0,     0,  2077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2076,     0,     0,     0,     0,
       0,  2076,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4055,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,  2078,  2078,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5333,  5334,  5335,  5336,     0,  2077,  5338,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2076,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4105,     0,
       0,     0,     0,  4112,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5393,  5394,  5395,  5396,     0,  5398,  5399,
       0,     0,     0,  2077,     0,     0,     0,     0,     0,  2077,
    5408,  5409,  2078,  1283,     0,  2083,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3407,     0,  3407,
    3407,     0,     0,  5418,     0,     0,     0,     0,     0,  2752,
    2752,  4173,  2752,     0,  4176,     0,     0,     0,     0,     0,
    4183,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4204,     0,  4206,
       0,     0,     0,  4209,     0,     0,     0,     0,     0,     0,
    2083,     0,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,  3497,  3497,  3497,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4273,
       0,     0,     0,     0,     0,  1283,  5486,     0,     0,     0,
       0,     0,     0,     0,  2762,  5492,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2779,
       0,     0,     0,     0,     0,  2078,  5513,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,  5539,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,  2076,     0,     0,  2076,     0,  2076,     0,
       0,     0,     0,  2076,     0,     0,  1283,  1283,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,  4333,     0,     0,     0,  2078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,  1283,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,  2752,
       0,     0,     0,  2076,     0,     0,  1283,  1283,  1283,  1283,
       0,     0,  2752,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,  1283,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1283,
    1283,     0,     0,  1283,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,     0,     0,     0,  1283,     0,  1283,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,  5640,     0,
       0,  1283,     0,     0,  1283,  1283,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,  2077,     0,  2077,     0,  1283,     0,
       0,  2077,     0,  5661,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,  2076,     0,  2076,     0,     0,     0,     0,  1283,     0,
    5676,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,  2083,     0,  2083,     0,  2076,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,  2077,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,     0,
       0,     0,     0,  4364,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2076,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,  2752,     0,  2077,
       0,  2077,     0,     0,     0,     0,     0,  2752,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,  5814,     0,     0,     0,     0,  2078,     0,
       0,  2078,     0,  2078,     0,     0,     0,     0,  2078,     0,
    2076,     0,     0,  2077,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2076,     0,     0,     0,     0,     0,
       0,     0,     0,  5831,     0,     0,  2083,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2752,     0,     0,     0,     0,  2077,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2077,     0,
       0,  4714,     0,     0,     0,     0,     0,     0,  2076,     0,
    2083,  4718,     0,     0,  2078,     0,     0,  4719,     0,  4720,
       0,     0,     0,     0,     0,     0,     0,     0,  2076,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4738,  4739,  4364,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,  2076,     0,     0,     0,
       0,  4753,     0,     0,     0,     0,  3414,  2077,  2752,     0,
       0,  4767,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4774,     0,     0,  4777,  2083,  4779,     0,  2077,     0,
       0,     0,     0,     0,     0,  4783,  5932,     0,  2076,     0,
       0,  4788,  2077,     0,  4791,     0,  2078,     0,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4833,     0,     0,     0,     0,     0,  4840,
    3497,     0,     0,     0,     0,  5965,     0,     0,     0,     0,
    5969,     0,     0,     0,  2083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,     0,     0,  2083,  2077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4854,     0,     0,  2083,
       0,     0,  1672,     0,     0,     0,  2077,     0,  1747,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,  2076,  1283,
       0,     0,     0,  6020,  2077,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,  2083,     0,     0,  2077,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,  1283,     0,  1283,     0,
       0,     0,     0,  2083,  1283,     0,     0,  1283,  1283,  1283,
    1283,  1283,  1283,  1283,  1283,  1283,  1283,     0,     0,     0,
    1283,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2083,     0,     0,  2078,     0,  1283,     0,     0,     0,
    1283,  1283,     0,     0,     0,  1283,     0,     0,     0,  2076,
    1283,     0,     0,     0,     0,  2078,     0,     0,     0,     0,
    1283,     0,     0,  1283,     0,  1283,     0,     0,     0,  2078,
       0,     0,     0,  2083,  1283,  1283,  1283,     0,     0,     0,
    1283,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,     0,
    1283,     0,     0,     0,     0,     0,  2077,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,  1283,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,  1283,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,  2671,     0,     0,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,     0,     0,  2077,     0,     0,
       0,     0,     0,     0,     0,  2076,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1283,
    1283,  1283,  1283,  2076,  5177,  5178,     0,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,  2671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5211,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5231,  5233,     0,
       0,     0,  5239,     0,  2076,     0,     0,     0,     0,     0,
       0,     0,     0,  2077,  5244,     0,     0,     0,     0,  2076,
    5249,  5250,     0,     0,  5252,     0,     0,  5255,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5265,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2077,     0,     0,     0,  2077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3497,     0,     0,     0,     0,
    3497,  1283,     0,     0,     0,  3497,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2083,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5314,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2083,  2076,
       0,     0,  2083,  1283,  1283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2077,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2077,     0,     0,
    2076,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,  1283,     0,  2083,
    2078,  1283,     0,     0,     0,     0,     0,     0,  1283,  1283,
       0,     0,     0,  1283,  2083,     0,     0,     0,     0,  1283,
    1283,     0,     0,  1283,     0,     0,  1283,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
    1283,     0,  2078,     0,     0,     0,     0,  2077,  1283,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1283,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,  1283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5470,
       0,     0,     0,     0,  2671,     0,     0,     0,  2077,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,  2077,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,  1283,     0,     0,  2078,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,     0,
       0,  1283,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2083,     0,  2671,     0,     0,
       0,     0,     0,     0,     0,  2077,     0,  2076,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2671,  5563,     0,     0,     0,  3389,     0,     0,     0,
       0,     0,     0,     0,  2083,  5567,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2671,  2671,     0,     0,     0,  2671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5596,  5597,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2083,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3497,  2076,  3497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2078,     0,     0,  1283,     0,
    2076,     0,     0,     0,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,  2077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,  2083,     0,     0,     0,     0,     0,     0,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,  1283,     0,     0,  1283,     0,     0,     0,     0,  2077,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,  2076,
       0,     0,     0,  1283,  2076,     0,     0,     0,  1283,     0,
       0,  1283,     0,     0,     0,     0,  1283,  1283,  2077,     0,
       0,  5768,     0,     0,     0,     0,  3414,     0,  2076,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5783,  1283,
       0,     0,     0,  5786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2076,  2357,     0,  2671,
       0,     0,     0,  1283,     0,     0,  2083,     0,  1283,  1283,
       0,  1283,     0,     0,     0,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2083,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2671,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,  2076,     0,     0,     0,  2076,  2076,     0,     0,     0,
       0,  2671,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2671,     0,     0,     0,  2077,  2671,     0,
       0,     0,  2077,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,  2077,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5874,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2077,     0,  2078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2762,     0,     0,  2083,     0,     0,  1283,     0,  2083,
       0,     0,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,  5596,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,  1283,  2083,     0,  1283,     0,  1283,     0,     0,
       0,     0,     0,     0,  2076,  2076,  5938,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,  2077,
       0,     0,  1283,  2077,  2077,     0,  1283,     0,     0,     0,
       0,  2083,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5998,  5998,     0,     0,     0,     0,     0,     0,
       0,     0,  5596,     0,     0,     0,  2083,     0,     0,     0,
    2083,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2078,     0,     0,     0,     0,  2078,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,  1283,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2077,  2077,     0,     0,  1283,     0,     0,  5998,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,     0,     0,  6075,     0,     0,     0,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,  1283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1283,     0,  1283,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2083,
    2083,     0,     0,     0,     0,  1283,  2078,     0,     0,     0,
    2078,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5998,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2076,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2078,
    2078,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,  2671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2671,
       0,  2671,     0,  3389,  3389,  4143,     0,     0,  3389,     0,
       0,     0,  2671,     0,     0,     0,     0,     0,     0,     0,
       0,  2671,     0,     0,     0,     0,  2671,     0,     0,     0,
       0,  2671,     0,  2671,     0,     0,     0,     0,  2671,     0,
    2671,     0,     0,  2671,     0,     0,     0,     0,     0,     0,
       0,  2671,     0,     0,     0,  3389,  3389,     0,  2671,     0,
       0,     0,  2077,     0,     0,     0,     0,     0,     0,     0,
    2671,     0,     0,  1283,     0,     0,     0,  2671,     0,  2671,
    2671,  2671,  2671,  2671,  2671,  2671,  2671,  2671,  2671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2671,     0,     0,  1283,
       0,     0,    85,     0,     0,    86,    87,    88,    89,    90,
      91,    92,    93,     0,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   106,     0,  2083,
     107,   108,   109,   110,     0,   111,   112,   113,   114,   115,
       0,   116,   117,   118,   119,   120,     0,     0,     0,   121,
     122,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,   124,     0,   125,     0,   126,   127,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     128,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     129,     0,   130,   131,     0,     0,     0,     0,     0,     0,
       0,     0,   132,     0,   133,     0,     0,   134,   135,   136,
     137,   138,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   140,     0,     0,   141,     0,   142,
     143,   144,  2671,   145,     0,   146,     0,   147,     0,     0,
     148,     0,     0,     0,     0,     0,     0,     0,   149,     0,
     150,   151,     0,     0,     0,     0,     0,   152,     0,     0,
       0,     0,     0,     0,   153,     0,   154,   155,   156,   157,
       0,     0,     0,     0,     0, -1697,     0,     0,     0,  2078,
       0,   158,     0,   159,     0,     0,     0,   160,     0,     0,
       0,     0,     0,   161,   162,     0,     0,     0,     0,     0,
       0,   163,   164,   165,     0,     0,   166,     0,     0,   167,
       0,     0,   168,     0,     0,     0,     0,     0,   169,     0,
     170,     0,     0,     0,   171,     0,   172,     0,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
       0,     0, -1697,     0,     0,   176,     0,   177,     0,     0,
     178,   179,     0,   180,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   181,   182,     0,   183,     0,   184,
     185,     0,     0,     0,     0,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   187,     0,     0,
     188,   189,   190,     0,     0,   191,     0,     0,   192,   193,
       0,     0,   194,     0,   195,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   196,   197,
       0,   198,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,     0,   201,     0,   202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
       0,     0,     0,   205,   206,     0,   207,     0,     0,     0,
       0,   208,     0,     0,     0,     0,   209,   210,     0,   211,
     212,     0,     0,   213,     0,     0,     0,     0,   214,   215,
       0,     0,     0,     0,     0,     0,   216,   217,     0,   218,
     219,     0,   220,     0,     0,     0,     0,   221,     0,  2671,
       0,     0,     0,     0,     0,   222,     0,     0,     0,   223,
       0,     0,     0,     0,     0,     0,     0,   224,   225,     0,
       0,     0,   226,     0,   227,     0,   228,     0,   229,     0,
       0,     0,     0,   230,     0,     0,   231,     0,     0, -1697,
       0,     0,   232,     0,     0,     0,     0,   233,   234,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
     236,     0,     0,     0,     0,     0,     0,   237,   238,   239,
     240,   241,   242,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   246,   247,     0,
       0,     0,     0,     0,     0,   248,     0,   249,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   250,     0,     0,
       0,     0,   251,     0,  2671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   252,     0,
       0,     0,  -146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2671,     0,     0,     0,     0,     0,
       0,  2671,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4143,  4143,     0,
    3389,     0,     0,  3389,  3389,  3389,  3389,  3389,  3389,  3389,
    3389,  3389,  3389,  4143,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,     0,     0,  2671,     0,     0,     0,     0,
       0,     0,  2671,     0,     0,     0,     0,  4143,  4143,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3389,  3389,  2671,     0,  2671,     0,     0,  2671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3389,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    86,    87,    88,     0,    90,    91,    92,     0,     0,
       0,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,     0,     0,     0,   107,   108,   109,   110,
       0,   111,   112,   113,   114,   115,     0,   116,   117,   118,
       0,     0,     0,     0,     0,   121,   122,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
     124,     0,   125,     0,   126,     0,    35,     0,     0,     0,
       0,     0,     0,  2671,    41,    42,     0,  2671,  2671,  2671,
       0,     0,  4143,     0,     0,     0,     0,  4143,  4143,  4143,
    4143,  4143,  4143,  4143,  4143,  4143,  4143,  2671,  2671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     133,     0,  2671,     0,   135,   136,   137,   138,   139,     0,
       0,     0,     0,     0,     0,     0,  2671,     0,     0,     0,
     140,     0,     0,  2671,  3389,  3389,  2671,   144,  2671,   145,
       0,     0,  2671,  4143,  4143,     0,   148,  2671,     0,     0,
    2671,     0,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,   152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,     0,     0,     0,     0,     0,     0,  2671,
     162,     0,     0,     0,     0,     0,     0,     0,   164,     0,
       0,     0,   166,  2671,     0,     0,     0,     0,   168,     0,
       0,     0,     0,     0,   169,     0,   170,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,     0,     0,     0,     0,
       0,   176,     0,   177,     0,     0,   178,   179,     0,   180,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     181,   182,     0,   183,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   189,   190,     0,
       0,   191,     0,     0,     0,   193,     0,     0,   194,     0,
     195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   196,   197,     0,   198,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   219,     0,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,     0,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4143,     0,     0,
       0,     0,     0,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,     0,     0,     0,     0,     0,
       0,   248,     0,   249,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2671,  2671,     0,     0,
       0,     0,     0,   250,     0,     0,     0,     0,   251,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2671,     0,     0,     0,  3389,     0,     0,     0,     0,     0,
       0,  3574,     0,     0,     0,     0,     0,     0,     0,     0,
    2671,     0,  2671,     0,     0,     0,     0,     0,  2671,     0,
       0,  4143,  4143,  2671,     0,     0,  3389,  3389,  2671,  2671,
       0,  2671,     0,     0,  2671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2671,     0,     0,     0,     0,     0,
       0,    86,    87,    88,     0,    90,    91,    92,     0,     0,
       0,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,     0,     0,     0,   107,   108,   109,   110,
       0,   111,   112,   113,   114,   115,     0,   116,   117,   118,
       0,     0,     0,  2671,     0,   121,   122,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
     124,     0,   125,     0,   126,     0,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     133,     0,     0,     0,   135,   136,   137,   138,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,     0,     0,     0,     0,     0,     0,   144,     0,   145,
       0,     0,     0,     0,     0,     0,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,   152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2671,
     162,     0,     0,     0,     0,     0,     0,     0,   164,     0,
       0,     0,   166,     0,     0,     0,     0,     0,   168,     0,
       0,     0,     0,     0,   169,     0,   170,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,     0,     0,     0,     0,
       0,   176,     0,   177,     0,     0,   178,   179,     0,   180,
       0,     0,     0,     0,     0,     0,     0,  4143,  3389,     0,
     181,   182,     0,   183,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,     0,  4143,  4143,  2671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   189,   190,     0,
       0,   191,     0,     0,     0,   193,     0,     0,   194,     0,
     195,     0,     0,     0,     0,  2671,  2671,     0,     0,     0,
       0,     0,     0,     0,   196,   197,     0,   198,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   219,     0,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,     0,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,     0,     0,     0,     0,  2671,  4143,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2671,   246,   247,  2671,     0,     0,     0,     0,
       0,   248,     0,   249,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   250,     0,     0,     0,     0,   251,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2671,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2671,   798,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   799,   104,
     105,   753,   800,     0,   107,   108,   109,   110,   801,   802,
     112,   113,   114,   115,     0,   116,   803,   804,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,  2671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   805,   441,   442,   443,   806,   807,   808,   809,
     810,   811,   812,   444,   445,   813,   446,   447,   133,   448,
     449,   450,   135,   136,   137,   138,   139,   814,   451,   452,
     453,   454,   455,   815,   816,   456,   457,   817,   140,   458,
     818,   459,   460,   461,   462,   144,   819,   145,   820,   463,
     464,   465,   466,   467,   148,   468,   821,   822,   469,   470,
     471,   472,   473,   474,   823,   151,   475,   824,   825,   826,
     827,   152,   828,   829,   830,   476,   477,   478,   479,   767,
     480,   155,   156,   481,   831,   482,   832,   483,   484,   485,
     486,   487,   833,   488,   489,   490,   834,   835,   491,   492,
     493,   494,   495,   836,   496,   497,   498,   837,   499,   500,
     501,   838,   839,   502,   503,   504,   164,   505,   506,   507,
     166,   840,   508,   841,   509,   510,   168,   842,   843,   511,
     844,   512,   169,   845,   170,   513,   514,   515,   846,   516,
     172,   847,   517,   848,   518,   519,   769,   520,   521,   173,
     522,   523,   524,   849,   525,   526,   527,   528,   529,   530,
     850,   531,   174,   175,   851,   532,   533,   534,   852,   176,
     853,   177,   854,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,   855,   542,   543,   856,   544,   181,   182,
     545,   183,   857,   546,   547,   548,   858,   859,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,   188,   189,   190,   563,   564,   191,
     860,   565,   566,   193,   567,   861,   194,   568,   195,   569,
     570,   571,   862,   572,   863,   864,   573,   574,   575,   865,
     866,   576,   196,   197,   577,   198,   199,   578,   579,   580,
     581,   867,   582,   583,   868,   584,   200,   869,   201,   585,
     586,   587,   870,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,   871,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   872,   611,
     612,   210,   613,   614,   212,   615,   616,   617,   618,   619,
     620,   772,   621,   873,   622,   623,   624,   625,   626,   874,
     627,   217,   628,   629,   219,   630,   220,   631,   875,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   222,
     876,   642,   643,   877,   644,   645,   646,   647,   648,   649,
     878,   224,   225,   879,   880,   651,   226,   652,   227,   881,
     653,   654,   655,   656,   882,   657,   658,   883,   884,   659,
     660,   661,   662,   663,   885,   886,   664,   665,   666,   667,
     668,   887,   234,   888,   669,   235,   670,   671,   672,   673,
     889,   890,   674,   891,   892,   675,   676,   677,   678,   679,
     680,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     774,   681,   682,   683,   684,   685,   686,   687,   688,   893,
     689,   894,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   246,   247,   699,   700,   701,   702,   703,   704,   248,
     705,   249,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,   895,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   798,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,  1060,    98,
      99,   100,   101,   102,   103,   799,   104,   105,   753,   800,
       0,   107,   108,   109,   110,   801,   802,   112,   113,   114,
     115,     0,   116,   803,   804,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   805,
     441,   442,   443,   806,   807,   808,   809,   810,   811,   812,
     444,   445,   813,   446,   447,   133,   448,   449,   450,   135,
     136,   137,   138,   139,   814,   451,   452,   453,   454,   455,
     815,   816,   456,   457,   817,   140,   458,   818,   459,   460,
     461,   462,   144,   819,   145,   820,   463,   464,   465,   466,
     467,   148,   468,   821,   822,   469,   470,   471,   472,   473,
     474,   823,   151,  6133,   824,   825,   826,   827,   152,   828,
     829,   830,   476,   477,   478,   479,   767,   480,   155,   156,
     481,   831,   482,   832,   483,   484,   485,  6134,   487,   833,
     488,   489,   490,   834,   835,   491,   492,   493,   494,   495,
     836,   496,   497,   498,   837,   499,  6135,   501,   838,   839,
     502,   503,   504,   164,   505,   506,   507,   166,   840,   508,
     841,   509,   510,   168,   842,   843,  6136,   844,   512,   169,
     845,   170,   513,   514,   515,   846,   516,   172,   847,   517,
     848,  6137,   519,   769,   520,   521,   173,   522,   523,   524,
     849,   525,   526,   527,   528,   529,   530,   850,   531,   174,
     175,   851,   532,   533,   534,   852,   176,   853,   177,   854,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
     855,   542,   543,   856,   544,   181,   182,   545,   183,   857,
     546,   547,   548,   858,   859,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,   189,   190,   563,   564,   191,   860,   565,   566,
     193,   567,  6138,   194,   568,   195,   569,   570,   571,   862,
     572,   863,   864,   573,   574,   575,   865,   866,   576,   196,
     197,   577,   198,   199,   578,   579,   580,   581,   867,   582,
     583,   868,   584,   200,   869,   201,   585,   586,   587,   870,
     588,   589,   590,   591,   592,  6139,   594,   595,   203,   596,
     597,   598,   599,   871,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   872,   611,   612,   210,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
     873,   622,   623,   624,   625,   626,   874,   627,   217,   628,
     629,   219,   630,   220,   631,   875,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,   876,   642,   643,
     877,   644,   645,   646,   647,   648,   649,   878,   224,   225,
     879,   880,   651,   226,   652,   227,   881,   653,   654,   655,
     656,   882,   657,   658,   883,   884,   659,   660,   661,   662,
     663,   885,   886,   664,   665,   666,   667,   668,   887,   234,
     888,   669,   235,   670,   671,   672,   673,   889,   890,   674,
     891,   892,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,   893,   689,   894,   690,
     691,   692,   693,   694,   695,  6140,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,   248,   705,   249,   706,
     707,  6141,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
     895,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,     0,     0,     0,     0,     0,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
    6142,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   805,   441,   442,   443,   806,   807,   808,   809,   810,
     811,   812,   444,   445,   813,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,   814,   451,   452,   453,
     454,   455,   815,   816,   456,   457,   817,   140,   458,   818,
     459,   460,   461,   462,   144,   819,   145,   820,   463,   464,
     465,   466,   467,   148,   468,   821,   822,   469,   470,   471,
     472,   473,   474,   823,   151,   475,   824,   825,   826,   827,
     152,   828,   829,   830,   476,   477,   478,   479,   767,   480,
     155,   156,   481,   831,   482,   832,   483,   484,   485,   486,
     487,   833,   488,   489,   490,   834,   835,   491,   492,   493,
     494,   495,   836,   496,   497,   498,   837,   499,   500,   501,
     838,   839,   502,   503,   504,   164,   505,   506,   507,   166,
     840,   508,   841,   509,   510,   168,   842,   843,   511,   844,
     512,   169,   845,   170,   513,   514,   515,   846,   516,   172,
     847,   517,   848,   518,   519,   769,   520,   521,   173,   522,
     523,   524,   849,   525,   526,   527,   528,   529,   530,   850,
     531,   174,   175,   851,   532,   533,   534,   852,   176,   853,
     177,   854,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,   855,   542,   543,   856,   544,   181,   182,   545,
     183,   857,   546,   547,   548,   858,   859,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,   189,   190,   563,   564,   191,   860,
     565,   566,   193,   567,   861,   194,   568,   195,   569,   570,
     571,   862,   572,   863,   864,   573,   574,   575,   865,   866,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
     867,   582,   583,   868,   584,   200,   869,   201,   585,   586,
     587,   870,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,   871,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   872,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,   873,   622,   623,   624,   625,   626,   874,   627,
     217,   628,   629,   219,   630,   220,   631,   875,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,   876,
     642,   643,   877,   644,   645,   646,   647,   648,   649,   878,
     224,   225,   879,   880,   651,   226,   652,   227,   881,   653,
     654,   655,   656,   882,   657,   658,   883,   884,   659,   660,
     661,   662,   663,   885,   886,   664,   665,   666,   667,   668,
     887,   234,   888,   669,   235,   670,   671,   672,   673,   889,
     890,   674,   891,   892,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,   893,   689,
     894,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,   895,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,  6213,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1586,  1587,  1588,
      45,  1589,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,  3491,   441,   442,   443,     0,     0,     0,
       0,  1590,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,   135,  1591,   137,  1592,  1593,     0,   451,
     452,   453,   454,   455,  1594,  1595,   456,   457,  1596,  1597,
     458,     0,   459,   460,   461,   462,  1598,     0,  1599,     0,
     463,   464,   465,   466,   467,   148,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,  1600,
    1601,  1602,  1603,  1604,  1605,  1606,   476,   477,   478,   479,
     767,   480,  1607,  1608,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,  3492,     0,   491,
     492,  1609,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,  1610,   505,   506,
     507,  1611,  1612,   508,     0,   509,   510,  1613,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,  1614,     0,   517,     0,   518,   519,   769,   520,   521,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,   175,     0,   532,   533,   534,  1615,
    1616,     0,  1617,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,  1618,
     182,   545,   183,     0,   546,   547,   548,  1619,  1620,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  1621,   189,  1622,   563,   564,
     191,  1623,   565,   566,   193,   567,  1624,  1625,   568,  1626,
     569,   570,   571,     0,   572,     0,     0,  1627,   574,   575,
       0,     0,   576,   196,   197,   577,   198,  1628,   578,   579,
     580,   581,     0,   582,   583,     0,   584,  1629,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,  1630,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,  1631,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
    1632,   627,   217,   628,   629,   219,   630,  1633,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
    1634,     0,   642,   643,  1635,   644,   645,   646,   647,   648,
     649,     0,  1636,  1637,     0,     0,   651,  1638,   652,  1639,
    1640,   653,   654,   655,   656,     0,   657,   658,     0,  1641,
     659,   660,   661,   662,   663,  1642,     0,   664,   665,   666,
     667,   668,   773,  1643,  3493,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,  1644,  1645,  1646,  1647,  1648,  1649,  1650,
    1651,   774,   681,   682,   683,   684,   685,   686,   687,   688,
    1652,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,  1653,  1654,   699,   700,   701,   702,   703,   704,
     248,   705,  1655,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
       0,     0,     0,     0,  1656,  1657,  3494,     0,     0,     0,
       0,     0,     0,  1659,  3495,   798,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   799,   104,   105,   753,   800,
       0,   107,   108,   109,   110,   801,   802,   112,   113,   114,
     115,     0,   116,   803,   804,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,   432,     0,     0,    37,    38,    39,    40,    41,
      42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,  1590,     0,     0,
     444,   445,     0,   446,   447,   133,   448,   449,   450,   135,
    1591,   137,  1592,  1593,     0,   451,   452,   453,   454,   455,
    1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,   460,
     461,   462,  1598,     0,  1599,     0,   463,   464,   465,   466,
     467,   148,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,  1604,
    1605,  1606,   476,   477,   478,   479,   767,   480,  1607,  1608,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,  1609,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,  1610,   505,   506,   507,  1611,  1612,   508,
       0,   509,   510,  1613,     0,     0,   511,     0,   512,   169,
       0,   170,   513,   514,   515,     0,   516,  1614,     0,   517,
       0,   518,   519,   769,   520,   521,   173,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   174,
     175,     0,   532,   533,   534,  1615,  1616,     0,  1617,     0,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,  1618,   182,   545,   183,     0,
     546,   547,   548,  1619,  1620,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,  1621,   189,  1622,   563,   564,   191,  1623,   565,   566,
     193,   567,  1624,  1625,   568,  1626,   569,   570,   571,     0,
     572,     0,     0,  1627,   574,   575,     0,     0,   576,   196,
     197,   577,   198,  1628,   578,   579,   580,   581,     0,   582,
     583,     0,   584,  1629,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,  1630,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,   210,   613,
     614,  1631,   615,   616,   617,   618,   619,   620,   772,   621,
     215,   622,   623,   624,   625,   626,  1632,   627,   217,   628,
     629,   219,   630,  1633,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,  1634,     0,   642,   643,
    2354,   644,   645,   646,   647,   648,   649,     0,  1636,  1637,
       0,     0,   651,  1638,   652,  1639,  1640,   653,   654,   655,
     656,     0,   657,   658,     0,  1641,   659,   660,   661,   662,
     663,  1642,     0,   664,   665,   666,   667,   668,  2355,  1643,
       0,   669,   235,   670,   671,   672,   673,     0,     0,   674,
       0,   236,   675,   676,   677,   678,   679,   680,   237,  1644,
    1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,   682,
     683,   684,   685,   686,   687,   688,  1652,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,  1653,  1654,
     699,   700,   701,   702,   703,   704,   248,   705,  1655,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,     0,     0,     0,     0,     0,     0,     0,     0,
    1656,  1657,     0,     0,     0,     0,     0,     0,     0,  1659,
    5797,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,  3391,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,     0,  2049,   137,  2050,  2051,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  2052,  2053,   458,     0,
     459,   460,   461,   462,     0,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,   767,   480,
    2054,  2055,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,  1609,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,     0,   505,   506,   507,     0,
       0,   508,     0,   509,   510,  2056,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,     0,
       0,   517,     0,   518,   519,   769,   520,   521,   173,   522,
     523,   524,  2847,   525,   526,   527,   528,   529,   530,     0,
     531,   174,  2848,     0,   532,   533,   534,  1615,  2057,     0,
    2058,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,     0,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,  2059,   189,  2060,   563,   564,     0,     0,
     565,   566,   193,   567,     0,     0,   568,  2061,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,  2850,   197,   577,   198,     0,   578,   579,   580,   581,
       0,   582,   583,     0,   584,     0,     0,     0,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
    2062,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,     0,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
    2851,   628,   629,   219,   630,  2064,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,     0,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
    2065,  2066,     0,     0,   651,     0,   652,     0,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
       0,  2067,  2852,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
       0,     0,   699,   700,   701,   702,   703,   704,   248,   705,
       0,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
       0,   725,     0,   726,   727,     0,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,  2957,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,     0,  2049,   137,  2050,  2051,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,  2052,  2053,
     458,     0,   459,   460,   461,   462,     0,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
     767,   480,  2054,  2055,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,  1609,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,     0,   505,   506,
     507,     0,     0,   508,     0,   509,   510,  2056,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,     0,     0,   517,     0,   518,   519,   769,   520,   521,
     173,   522,   523,   524,  2847,   525,   526,   527,   528,   529,
     530,     0,   531,   174,  2848,     0,   532,   533,   534,  1615,
    2057,     0,  2058,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,     0,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  2059,   189,  2060,   563,   564,
       0,     0,   565,   566,   193,   567,     0,     0,   568,  2061,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,  2850,   197,   577,   198,     0,   578,   579,
     580,   581,     0,   582,   583,     0,   584,     0,     0,     0,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,  2062,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,     0,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,  2851,   628,   629,   219,   630,  2064,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
       0,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,  2065,  2066,     0,     0,   651,     0,   652,     0,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,     0,  2067,  2852,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,     0,     0,   699,   700,   701,   702,   703,   704,
     248,   705,     0,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,     0,   725,     0,   726,   727,     0,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
       0,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,  4016,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,     0,
       0,  1306,    45,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   805,   441,   442,   443,   806,
     807,   808,   809,   810,   811,   812,   444,   445,   813,   446,
     447,   133,   448,   449,   450,     0,  2049,   137,  2050,  2051,
     814,   451,   452,   453,   454,   455,   815,   816,   456,   457,
    2052,  2053,   458,   818,   459,   460,   461,   462,     0,   819,
     145,   820,   463,   464,   465,   466,   467,   148,   468,   765,
     822,   469,   470,   471,   472,   473,   474,   823,   151,   475,
       0,   825,   826,   827,   152,   828,   829,   830,   476,   477,
     478,   479,   767,   480,  2054,  2055,   481,   831,   482,   832,
     483,   484,   485,   486,   487,   833,   488,   489,   490,   834,
     835,   491,   492,  1609,   494,   495,   836,   496,   497,   498,
     837,   499,   500,   501,   838,   839,   502,   503,   504,     0,
     505,   506,   507,     0,   840,   508,   841,   509,   510,  2056,
     842,   843,   511,   844,   512,   169,   845,   170,   513,   514,
     515,   846,   516,     0,   847,   517,   848,   518,   519,   769,
     520,   521,   173,   522,   523,   524,   849,   525,   526,   527,
     528,   529,   530,   850,   531,   174,     0,     0,   532,   533,
     534,  1615,  2057,   853,  2058,   854,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,   855,   542,   543,   856,
     544,     0,   182,   545,   183,   857,   546,   547,   548,   858,
     859,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  2059,   189,  2060,
     563,   564,  4554,   860,   565,   566,   193,   567,   861,     0,
     568,  2061,   569,   570,   571,   862,   572,   863,   864,  4555,
     574,   575,   865,   866,   576,     0,   197,   577,   198,     0,
     578,   579,   580,   581,   867,   582,   583,   868,   584,     0,
     869,     0,   585,   586,   587,   870,   588,   589,   590,   591,
     592,   593,   594,   595,  2062,   596,   597,   598,   599,   871,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   872,   611,   612,   210,   613,   614,  4556,   615,   616,
     617,   618,   619,   620,   772,   621,   873,   622,   623,   624,
     625,   626,   874,   627,  2851,   628,   629,   219,   630,  2064,
     631,   875,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,     0,   876,   642,   643,   877,   644,   645,   646,
     647,   648,   649,   878,  2065,  2066,     0,   880,   651,     0,
     652,     0,   881,   653,   654,   655,   656,   882,   657,   658,
       0,   884,   659,   660,   661,   662,   663,   885,   886,   664,
     665,   666,   667,   668,     0,  2067,   888,   669,   235,   670,
     671,   672,   673,   889,   890,   674,   891,   892,   675,   676,
     677,   678,   679,   680,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   774,   681,   682,   683,   684,   685,   686,
     687,   688,   893,   689,   894,   690,   691,   692,   693,   694,
     695,   696,   697,   698,     0,     0,   699,   700,   701,   702,
     703,   704,   248,   705,     0,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,     0,   725,   895,   726,   727,     0,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,  1309,  1310,  1311,     0,  4557,  4558,  1314,  1315,
    1316,  1317,     0,     0,     0,  6211,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,  3403,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,  3404,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,  3405,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,  3406,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,   215,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  2354,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,  2355,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,   236,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,  2293,  3349,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,  5995,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
    5996,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,  5997,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,  5996,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,  5997,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,  1658,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,  1746,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,  2772,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,  3404,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,  4841,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,  4853,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  2775,  2776,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,  4104,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,  5222,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,  5232,   191,  1623,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,  1641,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  1656,  1657,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,  1623,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,  5590,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    5591,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,  5592,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    5593,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,  1588,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,     0,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,  1627,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  1631,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  3384,  3385,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,  1588,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
   -3342,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,  5996,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,     0,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,     0,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,     0,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,  1627,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,     0,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,  5997,   657,   658,     0,  1641,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,     0,     0,
       0,  1656,  1657,     0,     0,     0,     0,     0,     0,     0,
    1659,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,    43,    44,  1586,
    1587,     0,    45,  1589,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,  1590,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,  1591,   137,  1592,  1593,
       0,   451,   452,   453,   454,   455,  1594,  1595,   456,   457,
    1596,  1597,   458,     0,   459,   460,   461,   462,  1598,     0,
    1599,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,
     478,   479,   767,   480,  1607,  1608,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,  1609,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,  1610,
     505,   506,   507,  1611,  1612,   508,     0,   509,   510,  1613,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,  1614,     0,   517,     0,   518,   519,   769,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,  1615,  1616,     0,  1617,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,  1618,   182,   545,   183,     0,   546,   547,   548,  1619,
    1620,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,  1621,   189,  1622,
     563,   564,   191,     0,   565,   566,   193,   567,  1624,  1625,
     568,  1626,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,   197,   577,   198,  1628,
     578,   579,   580,   581,     0,   582,   583,     0,   584,  1629,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,  1630,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,  3535,  3536,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,  1632,   627,   217,   628,   629,   219,   630,  1633,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,  1634,     0,   642,   643,  1635,   644,   645,   646,
     647,   648,   649,     0,  1636,  1637,     0,     0,   651,  1638,
     652,  1639,  1640,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,  1642,     0,   664,
     665,   666,   667,   668,   773,  1643,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,   774,   681,   682,   683,   684,   685,   686,
     687,   688,  1652,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,  1653,  1654,   699,   700,   701,   702,
     703,   704,   248,   705,  1655,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,     0,     0,     0,  3537,  3538,     0,     0,
       0,     0,     0,     0,     0,  1659,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,     0,    45,  1589,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,  1590,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,  4754,   452,   453,   454,
     455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,  1610,   505,   506,   507,  1611,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,     0,   565,
     566,   193,   567,  1624,  1625,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,  1631,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,  1635,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  1652,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
    1659,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,  1586,  1587,     0,    45,  1589,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,  1590,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,  1591,   137,  1592,  1593,     0,   451,   452,   453,
     454,   455,  1594,  1595,   456,   457,  1596,  1597,   458,     0,
     459,   460,   461,   462,  1598,     0,  1599,     0,   463,   464,
     465,   466,   467,   148,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,  1600,  1601,  1602,
    1603,  1604,  1605,  1606,   476,   477,   478,   479,   767,   480,
    1607,  1608,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,  1609,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,  1610,   505,   506,   507,  1611,
    1612,   508,     0,   509,   510,  1613,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,  1614,
       0,   517,     0,   518,   519,   769,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,  1615,  1616,     0,
    1617,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,  1618,   182,   545,
     183,     0,   546,   547,   548,  1619,  1620,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,  1621,   189,  1622,   563,   564,   191,     0,
     565,   566,   193,   567,  1624,  1625,   568,  1626,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,  1628,   578,   579,   580,   581,
       0,   582,   583,     0,   584,  1629,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
    1630,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,  1631,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,  1632,   627,
     217,   628,   629,   219,   630,  1633,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,  1634,     0,
     642,   643,  1635,   644,   645,   646,   647,   648,   649,     0,
    1636,  1637,     0,     0,   651,  1638,   652,  1639,  1640,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,  1642,     0,   664,   665,   666,   667,   668,
     773,  1643,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,
     681,   682,   683,   684,   685,   686,   687,   688,  1652,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
    1653,  1654,   699,   700,   701,   702,   703,   704,   248,   705,
    1655,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,   798,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,  1659,    98,    99,   100,   101,   102,   103,   799,   104,
     105,   753,   800,     0,   107,   108,   109,   110,   801,   802,
     112,   113,   114,   115,     0,   116,   803,   804,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,   432,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1586,  1587,  1588,    45,
    1589,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
    1590,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,     0,  1591,   137,  1592,  1593,     0,   451,   452,
     453,   454,   455,  1594,  1595,   456,   457,  1596,  1597,   458,
       0,   459,   460,   461,   462,  1598,     0,  1599,     0,   463,
     464,   465,   466,   467,   148,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,   476,   477,   478,   479,   767,
     480,  1607,  1608,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
    1609,   494,   495,     0,   496,   497,   498,     0,   499,     0,
     501,     0,     0,   502,   503,   504,  1610,   505,   506,   507,
    1611,  1612,   508,     0,   509,   510,  1613,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
    1614,     0,   517,     0,   518,   519,   769,   520,   521,     0,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   174,   175,     0,   532,   533,   534,  1615,  1616,
       0,  1617,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,  1618,   182,
     545,     0,     0,   546,   547,   548,  1619,  1620,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,  1621,   189,  1622,   563,   564,   191,
       0,   565,   566,   193,   567,  1624,  1625,   568,  1626,   569,
     570,   571,     0,   572,     0,     0,  1627,   574,   575,     0,
       0,   576,   196,   197,   577,   198,  1628,   578,   579,   580,
     581,     0,   582,   583,     0,   584,  1629,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,  1630,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,  1631,   615,   616,   617,   618,   619,
     620,   772,   621,     0,   622,   623,   624,   625,   626,  1632,
       0,   217,   628,   629,     0,   630,  1633,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,  1634,
       0,   642,   643,  1635,   644,   645,   646,   647,   648,   649,
       0,  1636,  1637,     0,     0,   651,  1638,   652,  1639,  1640,
     653,   654,   655,   656,     0,   657,   658,     0,  1641,   659,
     660,   661,   662,   663,  1642,     0,   664,   665,   666,   667,
     668,   773,  1643,     0,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,   237,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
     774,   681,   682,   683,   684,   685,   686,   687,   688,  1652,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,  1653,  1654,   699,   700,   701,   702,   703,   704,   248,
     705,  1655,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,     0,     0,     0,     0,     0,
       0,     0,     0,  1656,  1657,     0,     0,     0,     0,     0,
       0,     0,  1659,   798,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   799,   104,   105,   753,   800,     0,   107,
     108,   109,   110,   801,   802,   112,   113,   114,   115,     0,
     116,   803,   804,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
     432,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,  1586,  1587,  1588,    45,  1589,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,  1590,     0,     0,   444,   445,
       0,   446,   447,   133,   448,   449,   450,     0,  1591,   137,
    1592,  1593,     0,   451,   452,   453,   454,   455,  1594,  1595,
     456,   457,  1596,  1597,   458,     0,   459,   460,   461,   462,
    1598,     0,  1599,     0,   463,   464,   465,   466,   467,   148,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
     151,   475,     0,  1600,  1601,  1602,  1603,  1604,  1605,  1606,
     476,   477,   478,   479,   767,   480,  1607,  1608,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,  1609,   494,   495,     0,   496,
     497,   498,     0,   499,     0,   501,     0,     0,   502,   503,
     504,  1610,   505,   506,   507,  1611,  1612,   508,     0,   509,
     510,  1613,     0,     0,   511,     0,   512,   169,     0,   170,
     513,   514,   515,     0,   516,  1614,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   174,   175,     0,
     532,   533,   534,  1615,  1616,     0,  1617,     0,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,  1618,   182,   545,     0,     0,   546,   547,
     548,  1619,  1620,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,  1621,
     189,  1622,   563,   564,   191,     0,   565,   566,   193,   567,
    1624,  1625,   568,  1626,   569,   570,   571,     0,   572,     0,
       0,  1627,   574,   575,     0,     0,   576,   196,   197,   577,
     198,  1628,   578,   579,   580,   581,     0,   582,   583,     0,
     584,  1629,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,  1630,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,   210,   613,   614,  1631,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,  1632,     0,   217,   628,   629,     0,
     630,  1633,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,  1634,     0,   642,   643,  1635,   644,
     645,   646,   647,   648,   649,     0,  1636,  1637,     0,     0,
     651,  1638,   652,  1639,  1640,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,  1642,
       0,   664,   665,   666,   667,   668,   773,  1643,     0,   669,
     235,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1651,   774,   681,   682,   683,   684,
     685,   686,   687,   688,  1652,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,  1653,  1654,   699,   700,
     701,   702,   703,   704,   248,   705,  1655,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
       0,     0,     0,     0,     0,     0,     0,     0,  3384,  3385,
       0,     0,     0,     0,     0,     0,     0,  1659,   798,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   799,   104,
     105,   753,   800,     0,   107,   108,   109,   110,   801,   802,
     112,   113,   114,   115,     0,   116,   803,   804,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,   135,   136,   137,   138,   139,     0,   451,   452,
     453,   454,   455,     0,  1595,   456,   457,   764,   140,   458,
       0,   459,   460,   461,   462,  1598,     0,  1599,     0,   463,
     464,   465,   466,   467,   148,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,   476,   477,   478,   479,   767,
     480,   155,   156,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,   164,   505,   506,   507,
    1611,     0,   508,     0,   509,   510,   168,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
    1614,     0,   517,     0,   518,   519,   769,   520,   521,   173,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   174,   175,     0,   532,   533,   534,     0,   176,
       0,   177,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,  4224,   542,   543,     0,   544,  1618,   182,
     545,   183,     0,   546,   547,   548,  1619,  1620,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,   188,   189,   190,   563,   564,   191,
       0,   565,   566,   193,   567,     0,  1625,   568,   195,   569,
     570,   571,     0,   572,     0,  1180,   573,   574,   575,     0,
       0,   576,   196,   197,   577,   198,  1628,   578,   579,   580,
     581,     0,   582,   583,     0,   584,  1629,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,   212,  4225,   616,   617,   618,   619,
     620,   772,   621,   215,   622,   623,   624,   625,   626,  1632,
     627,   217,   628,   629,   219,   630,   220,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,  1634,
       0,   642,   643,   223,   644,   645,   646,   647,   648,   649,
       0,   224,   225,     0,     0,   651,  1638,   652,  1639,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,  1642,     0,   664,   665,   666,   667,
     668,  2355,   234,     0,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,   236,   675,   676,   677,   678,   679,
     680,   237,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
     774,   681,   682,   683,   684,   685,   686,   687,   688,  4226,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,  1653,  1654,   699,   700,   701,   702,   703,   704,   248,
     705,  1655,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,     0,     0,     0,     0,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,  4227,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1586,  1587,     0,
      45,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,   135,  1591,   137,  1592,  1593,     0,   451,
     452,   453,   454,   455,     0,  4921,   456,   457,  1596,  1597,
     458,     0,   459,   460,   461,   462,   144,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
     767,   480,  1607,  1608,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,  1609,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,  1612,   508,     0,   509,   510,  1613,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,   175,     0,   532,   533,   534,  1615,
    1616,     0,  1617,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  1621,   189,  1622,   563,   564,
     191,     0,   565,   566,   193,   567,  1624,   194,   568,  1626,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,   197,   577,   198,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,  1630,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,   219,   630,  1633,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,  1636,  1637,     0,     0,   651,   226,   652,   227,
    1640,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,  1643,     0,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
     248,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4922,     0,     0,     0,     0,
       0,     0,     0,  4923,   798,    86,    87,    88,   750,    90,
      91,    92,   751,     0,   752,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   799,   104,   105,   753,   800,     0,
     107,   108,   109,   110,   801,   802,   112,   113,   114,   115,
       0,   116,   803,   804,   754,   755,     0,     0,     0,   756,
     757,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   760,     0,   761,   762,
      35,   432,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1586,  1587,     0,    45,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,   133,   448,   449,   450,   135,  1591,
     137,  1592,  1593,     0,   451,   452,   453,   454,   455,     0,
    4921,   456,   457,  1596,  1597,   458,     0,   459,   460,   461,
     462,   144,     0,   145,     0,   463,   464,   465,   466,   467,
     148,   468,   765,     0,   469,   470,   471,   472,   473,   474,
       0,   151,   475,     0,     0,     0,     0,   152,     0,     0,
       0,   476,   477,   478,   479,   767,   480,  1607,  1608,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,  1609,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,   166,  1612,   508,     0,
     509,   510,  1613,     0,     0,   511,     0,   512,   169,     0,
     170,   513,   514,   515,     0,   516,   172,     0,   517,     0,
     518,   519,   769,   520,   521,   173,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   174,   175,
       0,   532,   533,   534,  1615,  1616,     0,  1617,     0,   535,
     178,   179,   536,   180,   537,   538,   539,   540,   541,     0,
     542,   543,     0,   544,   181,   182,   545,   183,     0,   546,
     547,   548,     0,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   770,   558,   559,   771,   560,   561,   562,
    1621,   189,  1622,   563,   564,   191,     0,   565,   566,   193,
     567,  1624,   194,   568,  1626,   569,   570,   571,     0,   572,
       0,     0,   573,   574,   575,     0,     0,   576,   196,   197,
     577,   198,   199,   578,   579,   580,   581,     0,   582,   583,
       0,   584,   200,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,  1630,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,   210,   613,   614,
     212,   615,   616,   617,   618,   619,   620,   772,   621,     0,
     622,   623,   624,   625,   626,     0,   627,   217,   628,   629,
     219,   630,  1633,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   222,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,  1636,  1637,     0,
       0,   651,   226,   652,   227,  1640,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
       0,     0,   664,   665,   666,   667,   668,   773,  1643,     0,
     669,   235,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   774,   681,   682,   683,
     684,   685,   686,   687,   688,     0,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   246,   247,   699,
     700,   701,   702,   703,   704,   248,   705,   249,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4922,     0,     0,     0,     0,     0,     0,     0,  4932,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1586,  1587,     0,
      45,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,   135,  1591,   137,  1592,  1593,     0,   451,
     452,   453,   454,   455,     0,  4921,   456,   457,  1596,  1597,
     458,     0,   459,   460,   461,   462,   144,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
     767,   480,  1607,  1608,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,  1609,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,  1612,   508,     0,   509,   510,  1613,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,   175,     0,   532,   533,   534,  1615,
    1616,     0,  1617,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  1621,   189,  1622,   563,   564,
     191,     0,   565,   566,   193,   567,  1624,   194,   568,  1626,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,   197,   577,   198,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,  1630,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,   219,   630,  1633,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,  1636,  1637,     0,     0,   651,   226,   652,   227,
    1640,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,  4976,  1643,     0,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
     248,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4922,     0,     0,     0,     0,
       0,     0,     0,  4923,   798,    86,    87,    88,   750,    90,
      91,    92,   751,     0,   752,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   799,   104,   105,   753,   800,     0,
     107,   108,   109,   110,   801,   802,   112,   113,   114,   115,
       0,   116,   803,   804,   754,   755,     0,     0,     0,   756,
     757,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   760,     0,   761,   762,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,   133,   448,   449,   450,   135,   136,
     137,   138,   139,     0,   451,   452,   453,   454,   455,     0,
    1595,   456,   457,   764,   140,   458,     0,   459,   460,   461,
     462,  1598,     0,  1599,     0,   463,   464,   465,   466,   467,
     148,   468,   765,     0,   469,   470,   471,   472,   473,   474,
       0,   151,   475,     0,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,   476,   477,   478,   479,   767,   480,   155,   156,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,  1611,     0,   508,     0,
     509,   510,   168,     0,     0,   511,     0,   512,   169,     0,
     170,   513,   514,   515,     0,   516,  1614,     0,   517,     0,
     518,   519,   769,   520,   521,   173,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   174,   175,
       0,   532,   533,   534,     0,   176,     0,   177,     0,   535,
     178,   179,   536,   180,   537,   538,   539,   540,   541,  4224,
     542,   543,     0,   544,  1618,   182,   545,   183,     0,   546,
     547,   548,  1619,  1620,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   770,   558,   559,   771,   560,   561,   562,
     188,   189,   190,   563,   564,   191,     0,   565,   566,   193,
     567,     0,  1625,   568,   195,   569,   570,   571,     0,   572,
       0,  1180,   573,   574,   575,     0,     0,   576,   196,   197,
     577,   198,  1628,   578,   579,   580,   581,     0,   582,   583,
       0,   584,  1629,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   203,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,   210,   613,   614,
     212,  4225,   616,   617,   618,   619,   620,   772,   621,     0,
     622,   623,   624,   625,   626,  1632,   627,   217,   628,   629,
     219,   630,   220,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,  1634,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,   224,   225,     0,
       0,   651,  1638,   652,  1639,     0,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
    1642,     0,   664,   665,   666,   667,   668,   773,   234,     0,
     669,   235,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,   774,   681,   682,   683,
     684,   685,   686,   687,   688,  4226,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,  1653,  1654,   699,
     700,   701,   702,   703,   704,   248,   705,  1655,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,     0,     0,     0,     0,   798,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,  4227,    98,
      99,   100,   101,   102,   103,   799,   104,   105,   753,   800,
       0,   107,   108,   109,   110,   801,   802,   112,   113,   114,
     115,     0,   116,   803,   804,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,   133,   448,   449,   450,   135,
     136,   137,   138,   139,     0,   451,   452,   453,   454,   455,
       0,  1595,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,  1598,     0,  1599,     0,   463,   464,   465,   466,
     467,   148,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,  1604,
    1605,  1606,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,  1611,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,   169,
       0,   170,   513,   514,   515,     0,   516,  1614,     0,   517,
       0,   518,   519,   769,   520,   521,   173,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   174,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,  1618,   182,   545,   183,     0,
     546,   547,   548,  1619,  1620,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,   189,   190,   563,   564,   191,     0,   565,   566,
     193,   567,     0,  1625,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
     197,   577,   198,  1628,   578,   579,   580,   581,     0,   582,
     583,     0,   584,  1629,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,   210,   613,
     614,   212,  4225,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,  1632,   627,   217,   628,
     629,   219,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,  1634,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,  1638,   652,  1639,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,  1642,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,   235,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,  1644,
    1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,   682,
     683,   684,   685,   686,   687,   688,  4226,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,  1653,  1654,
     699,   700,   701,   702,   703,   704,   248,   705,  1655,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,     0,     0,     0,     0,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,   252,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,   136,   137,   138,   139,     0,   451,   452,   453,   454,
     455,     0,  1595,   456,   457,   764,   140,   458,     0,   459,
     460,   461,   462,  1598,     0,  1599,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,   476,   477,   478,   479,   767,   480,   155,
     156,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,  1611,     0,
     508,     0,   509,   510,   168,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,  1614,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,     0,   176,     0,   177,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,  1618,   182,   545,   183,
       0,   546,   547,   548,  1619,  1620,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,   188,   189,   190,   563,   564,   191,     0,   565,
     566,   193,   567,     0,  1625,   568,   195,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,  1628,   578,   579,   580,   581,     0,
     582,   583,     0,   584,  1629,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,  1632,   627,   217,
     628,   629,   219,   630,   220,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,  1634,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,   224,
     225,     0,     0,   651,  1638,   652,  1639,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,  1642,     0,   664,   665,   666,   667,   668,   773,
     234,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,   774,   681,
     682,   683,   684,   685,   686,   687,   688,  4226,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,  1653,
    1654,   699,   700,   701,   702,   703,   704,   248,   705,  1655,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
    4883,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,   189,   190,   563,   564,   191,     0,
     565,   566,   193,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,   219,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,  5663,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   753,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,  4811,     0,   444,   445,     0,   446,   447,     0,   448,
     449,   450,   135,   136,     0,   138,   139,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   764,   140,   458,
       0,   459,   460,   461,   462,   144,     0,     0,     0,   463,
     464,   465,   466,   467,     0,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0, -1798,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   767,
     480,   155,   156,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,   164,   505,   506,   507,
     166,     0,   508,     0,   509,   510,   168,     0,     0,   511,
       0,   512,     0,     0, -1798,   513,   514,   515,     0,   516,
     172,     0,   517,     0,   518,   519,   769,   520,   521,     0,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531, -1798,   175,     0,   532,   533,   534,     0,   176,
       0,   177,     0,   535,     0,     0,   536, -1798,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,   181, -1798,
     545,     0,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,   188, -1798,   190,   563,   564,   191,
       0,   565,   566,     0,   567,     0,   194,   568,   195,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
       0,   576,   196,     0,   577,     0,   199,   578,   579,   580,
     581,     0,   582,   583,     0,   584,   200,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612, -1798,   613,   614,   212,   615,   616,   617,   618,   619,
     620,   772,   621,     0,   622,   623,   624,   625,   626,     0,
     627,   217,   628,   629,     0,   630,   220,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   222,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,   224,   225,     0,     0,   651,   226,   652,   227,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,   773,   234,     0,   669,     0,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     774,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   246,   247,   699,   700,   701,   702,   703,   704,     0,
     705,   249,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,     0,     0,     0,     0,     0,
       0,    86,    87,    88,   750,    90,    91,    92,   751,     0,
     752,    95,     0,  1754,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   753,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     754,   755,     0,     0,     0,   756,   757,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,   760,     0,   761,   762,    35,     0,     0,     0,
      37,    38,    39,    40,    41,    42,     0,    44,     0,     0,
       0,    45,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,     0,   441,   442,   443,     0,     0,
       0,     0,     0,     0,     0,   444,   445,     0,   446,   447,
       0,   448,   449,   450,   135,   136,     0,   138,   139,     0,
     451,   452,   453,   454,   455,     0,     0,   456,   457,   764,
     140,   458,     0,   459,   460,   461,   462,   144,     0,     0,
       0,   463,   464,   465,   466,   467,     0,   468,   765,     0,
     469,   470,   471,   472,   473,   474,     0,     0,   475,     0,
       0,     0,     0,     0,     0,     0,     0,   476,   477,   478,
     479,   767,   480,   155,   156,   481,     0,   482,     0,   483,
     484,   485,   486,   487,     0,   488,   489,   490,     0,     0,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     499,   500,   501,     0,     0,   502,   503,   504,   164,   505,
     506,   507,   166,     0,   508,     0,   509,   510,   168,     0,
       0,   511,     0,   512,     0,     0,     0,   513,   514,   515,
       0,   516,   172,     0,   517,     0,   518,   519,   769,   520,
     521,     0,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,     0,   175,     0,   532,   533,   534,
       0,   176,     0,   177,     0,   535,     0,     0,   536,     0,
     537,   538,   539,   540,   541,     0,   542,   543,     0,   544,
     181,     0,   545,     0,     0,   546,   547,   548,     0,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   770,
     558,   559,   771,   560,   561,   562,   188,     0,   190,   563,
     564,   191,     0,   565,   566,     0,   567,     0,   194,   568,
     195,   569,   570,   571,     0,   572,     0,     0,   573,   574,
     575,     0,     0,   576,   196,     0,   577,     0,   199,   578,
     579,   580,   581,     0,   582,   583,     0,   584,   200,     0,
     201,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   203,   596,   597,   598,   599,     0,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,   611,   612,     0,   613,   614,   212,   615,   616,   617,
     618,   619,   620,   772,   621,     0,   622,   623,   624,   625,
     626,     0,   627,   217,   628,   629,     0,   630,   220,   631,
       0,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   222,     0,   642,   643,     0,   644,   645,   646,   647,
     648,   649,     0,   224,   225,     0,     0,   651,   226,   652,
     227,     0,   653,   654,   655,   656,     0,   657,   658,     0,
       0,   659,   660,   661,   662,   663,     0,     0,   664,   665,
     666,   667,   668,   773,   234,     0,   669,     0,   670,   671,
     672,   673,     0,     0,   674,     0,     0,   675,   676,   677,
     678,   679,   680,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   774,   681,   682,   683,   684,   685,   686,   687,
     688,     0,   689,     0,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   246,   247,   699,   700,   701,   702,   703,
     704,     0,   705,   249,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   250,   725,     0,   726,   727,   251,   728,
     729,   730,   731,   732,   733,   734,   735,     0,     0,     0,
       0,     0,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,  4546,  4547,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,    45,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,     0,     0,    86,    87,    88,   750,    90,    91,    92,
     751,     0,   752,    95,     0,  4547,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   753,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,   115,     0,   116,
       0,     0,   754,   755,     0,     0,     0,   756,   757,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,   759,     0,   760,     0,   761,   762,    35,   432,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,     0,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   135,   136,     0,   138,
     139,     0,   451,   452,   453,   454,   455,     0,     0,   456,
     457,   764,   140,   458,     0,   459,   460,   461,   462,   144,
       0,     0,     0,   463,   464,   465,   466,   467,     0,   468,
     765,     0,   469,   470,   471,   472,   473,   474,     0,     0,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   767,   480,   155,   156,   481,     0,   482,
       0,   483,   484,   485,   486,   487,     0,   488,   489,   490,
       0,     0,   491,   492,   493,   494,   495,     0,   496,   497,
     498,     0,   499,   500,   501,     0,     0,   502,   503,   504,
     164,   505,   506,   507,   166,     0,   508,     0,   509,   510,
     168,     0,     0,   511,     0,   512,     0,     0,     0,   513,
     514,   515,     0,   516,   172,     0,   517,     0,   518,   519,
     769,   520,   521,     0,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   175,     0,   532,
     533,   534,     0,   176,     0,   177,     0,   535,     0,     0,
     536,     0,   537,   538,   539,   540,   541,     0,   542,   543,
       0,   544,   181,     0,   545,     0,     0,   546,   547,   548,
       0,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   770,   558,   559,   771,   560,   561,   562,   188,     0,
     190,   563,   564,   191,     0,   565,   566,     0,   567,     0,
     194,   568,   195,   569,   570,   571,     0,   572,     0,     0,
     573,   574,   575,     0,     0,   576,   196,     0,   577,     0,
     199,   578,   579,   580,   581,     0,   582,   583,     0,   584,
     200,     0,   201,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   203,   596,   597,   598,   599,
       0,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,   611,   612,     0,   613,   614,   212,   615,
     616,   617,   618,   619,   620,   772,   621,   215,   622,   623,
     624,   625,   626,     0,   627,   217,   628,   629,     0,   630,
     220,   631,     0,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   222,     0,   642,   643,   223,   644,   645,
     646,   647,   648,   649,     0,   224,   225,     0,     0,   651,
     226,   652,   227,     0,   653,   654,   655,   656,     0,   657,
     658,     0,     0,   659,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,  2355,   234,     0,   669,     0,
     670,   671,   672,   673,     0,     0,   674,     0,   236,   675,
     676,   677,   678,   679,   680,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   774,   681,   682,   683,   684,   685,
     686,   687,   688,     0,   689,     0,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   246,   247,   699,   700,   701,
     702,   703,   704,     0,   705,   249,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   250,   725,     0,   726,   727,
     251,   728,   729,   730,   731,   732,   733,   734,   735,     0,
       0,     0,     0,     0,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,   252,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,   215,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,   223,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,  2355,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,   236,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
       0,     0,     0,     0,     0,    86,    87,    88,   750,    90,
      91,    92,   751,     0,   752,    95,     0,   252,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   753,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   754,   755,     0,     0,     0,   756,
     757,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   760,     0,   761,   762,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,     0,   448,   449,   450,   135,   136,
       0,   138,   139,     0,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   764,   140,   458,     0,   459,   460,   461,
     462,   144,     0,     0,     0,   463,   464,   465,   466,   467,
       0,   468,   765,     0,   469,   470,   471,   472,   473,   474,
       0,     0,   475,     0,     0,     0,     0,     0,     0,     0,
       0,   476,   477,   478,   479,   767,   480,   155,   156,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,   166,     0,   508,     0,
     509,   510,   168,     0,     0,   511,     0,   512,     0,     0,
       0,   513,   514,   515,     0,   516,   172,     0,   517,     0,
     518,   519,   769,   520,   521,     0,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,     0,   175,
       0,   532,   533,   534,     0,   176,     0,   177,     0,   535,
       0,     0,   536,     0,   537,   538,   539,   540,   541,     0,
     542,   543,     0,   544,   181,     0,   545,     0,     0,   546,
     547,   548,     0,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   770,   558,   559,   771,   560,   561,   562,
     188,     0,   190,   563,   564,   191,     0,   565,   566,     0,
     567,     0,   194,   568,   195,   569,   570,   571,     0,   572,
       0,  1180,   573,   574,   575,     0,     0,   576,   196,     0,
     577,     0,   199,   578,   579,   580,   581,     0,   582,   583,
       0,   584,   200,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   203,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,     0,   613,   614,
     212,   615,   616,   617,   618,   619,   620,   772,   621,     0,
     622,   623,   624,   625,   626,     0,   627,   217,   628,   629,
       0,   630,   220,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   222,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,   224,   225,     0,
       0,   651,   226,   652,   227,     0,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
       0,     0,   664,   665,   666,   667,   668,   773,   234,     0,
     669,     0,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   774,   681,   682,   683,
     684,   685,   686,   687,   688,     0,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   246,   247,   699,
     700,   701,   702,   703,   704,     0,   705,   249,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,     0,     0,     0,     0,     0,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,  2330,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,     0,     0,     0,     0,     0,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,  1729,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   753,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,     0,   448,   449,   450,
     135,   136,     0,   138,   139,     0,   451,   452,   453,   454,
     455,     0,     0,   456,   457,   764,   140,   458,     0,   459,
     460,   461,   462,   144,     0,     0,     0,   463,   464,   465,
     466,   467,     0,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,     0,   475,     0,     0,     0,     0,     0,
       0,     0,     0,   476,   477,   478,   479,   767,   480,   155,
     156,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,   166,     0,
     508,     0,   509,   510,   168,     0,     0,   511,     0,   512,
       0,     0,     0,   513,   514,   515,     0,   516,   172,     0,
     517,     0,   518,   519,   769,   520,   521,     0,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
       0,   175,     0,   532,   533,   534,     0,   176,     0,   177,
       0,   535,     0,     0,   536,     0,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,   181,     0,   545,     0,
       0,   546,   547,   548,     0,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,   188,     0,   190,   563,   564,   191,     0,   565,
     566,     0,   567,     0,   194,   568,   195,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,     0,   577,     0,   199,   578,   579,   580,   581,     0,
     582,   583,     0,   584,   200,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,     0,
     613,   614,   212,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,     0,   627,   217,
     628,   629,     0,   630,   220,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,   224,
     225,     0,     0,   651,   226,   652,   227,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,   773,
     234,     0,   669,     0,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   774,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,     0,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,     0,     0,     0,     0,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
    3564,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,  4794,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   753,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,     0,   448,
     449,   450,   135,   136,     0,   138,   139,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,   764,   140,   458,
       0,   459,   460,   461,   462,   144,     0,     0,     0,   463,
     464,   465,   466,   467,     0,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0,     0,   475,     0,     0,     0,
       0,     0,     0,     0,     0,   476,   477,   478,   479,   767,
     480,   155,   156,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,   164,   505,   506,   507,
     166,     0,   508,     0,   509,   510,   168,     0,     0,   511,
       0,   512,     0,     0,     0,   513,   514,   515,     0,   516,
     172,     0,   517,     0,   518,   519,   769,   520,   521,     0,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,     0,   175,     0,   532,   533,   534,     0,   176,
       0,   177,     0,   535,     0,     0,   536,     0,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,   181,     0,
     545,     0,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,   188,     0,   190,   563,   564,   191,
       0,   565,   566,     0,   567,     0,   194,   568,   195,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
       0,   576,   196,     0,   577,     0,   199,   578,   579,   580,
     581,     0,   582,   583,     0,   584,   200,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,     0,   613,   614,   212,   615,   616,   617,   618,   619,
     620,   772,   621,     0,   622,   623,   624,   625,   626,     0,
     627,   217,   628,   629,     0,   630,   220,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   222,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,   224,   225,     0,     0,   651,   226,   652,   227,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,   773,   234,     0,   669,     0,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     774,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   246,   247,   699,   700,   701,   702,   703,   704,     0,
     705,   249,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,     0,     0,     0,     0,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,  5279,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,  1306,
      45,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   805,   441,   442,   443,   806,   807,   808,
     809,   810,   811,   812,   444,   445,   813,   446,   447,   133,
     448,   449,   450,     0,  2049,   137,  2050,  2051,   814,   451,
     452,   453,   454,   455,   815,   816,   456,   457,  2052,  2053,
     458,   818,   459,   460,   461,   462,     0,   819,   145,   820,
     463,   464,   465,   466,   467,   148,   468,   765,   822,   469,
     470,   471,   472,   473,   474,   823,   151,   475,     0,   825,
     826,   827,   152,   828,   829,   830,   476,   477,   478,   479,
     767,   480,  2054,  2055,   481,   831,   482,   832,   483,   484,
     485,   486,   487,   833,   488,   489,   490,   834,   835,   491,
     492,  1609,   494,   495,   836,   496,   497,   498,   837,   499,
     500,   501,   838,   839,   502,   503,   504,     0,   505,   506,
     507,     0,   840,   508,   841,   509,   510,  2056,   842,   843,
     511,   844,   512,   169,   845,   170,   513,   514,   515,   846,
     516,     0,   847,   517,   848,   518,   519,   769,   520,   521,
     173,   522,   523,   524,   849,   525,   526,   527,   528,   529,
     530,   850,   531,   174,     0,     0,   532,   533,   534,  1615,
    2057,   853,  2058,   854,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,   855,   542,   543,   856,   544,     0,
     182,   545,   183,   857,   546,   547,   548,   858,   859,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  2059,   189,  2060,   563,   564,
    4554,   860,   565,   566,   193,   567,   861,     0,   568,  2061,
     569,   570,   571,   862,   572,   863,   864,  4555,   574,   575,
     865,   866,   576,     0,   197,   577,   198,     0,   578,   579,
     580,   581,   867,   582,   583,   868,   584,     0,   869,     0,
     585,   586,   587,   870,   588,   589,   590,   591,   592,   593,
     594,   595,  2062,   596,   597,   598,   599,   871,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   872,
     611,   612,   210,   613,   614,  4556,   615,   616,   617,   618,
     619,   620,   772,   621,   873,   622,   623,   624,   625,   626,
     874,   627,  2851,   628,   629,   219,   630,  2064,   631,   875,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
       0,   876,   642,   643,   877,   644,   645,   646,   647,   648,
     649,   878,  2065,  2066,     0,   880,   651,     0,   652,     0,
     881,   653,   654,   655,   656,   882,   657,   658,     0,   884,
     659,   660,   661,   662,   663,   885,   886,   664,   665,   666,
     667,   668,     0,  2067,   888,   669,   235,   670,   671,   672,
     673,   889,   890,   674,   891,   892,   675,   676,   677,   678,
     679,   680,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,   681,   682,   683,   684,   685,   686,   687,   688,
     893,   689,   894,   690,   691,   692,   693,   694,   695,   696,
     697,   698,     0,     0,   699,   700,   701,   702,   703,   704,
     248,   705,     0,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,     0,   725,   895,   726,   727,     0,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  4557,  4558,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,  1307,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,  1308,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,  1408,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,  1409,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,  1471,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,  1472,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  1473,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,  2035,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,  2036,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,  3664,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,  3665,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,  1306,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,  5613,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
    1309,  1310,  1311,     0,  1312,  1313,  1314,  1315,  1316,  1317,
     798,    86,    87,    88,   750,    90,    91,    92,   751,     0,
     752,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     799,   104,   105,   753,   800,     0,   107,   108,   109,   110,
     801,   802,   112,   113,   114,   115,     0,   116,   803,   804,
     754,   755,     0,     0,     0,   756,   757,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,   760,     0,   761,   762,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   805,   441,   442,   443,   806,   807,
     808,   809,   810,   811,   812,   444,   445,   813,   446,   447,
     133,   448,   449,   450,   135,   136,   137,   138,   139,   814,
     451,   452,   453,   454,   455,   815,   816,   456,   457,   817,
     140,   458,   818,   459,   460,   461,   462,   144,   819,   145,
     820,   463,   464,   465,   466,   467,   148,   468,   821,   822,
     469,   470,   471,   472,   473,   474,   823,   151,   475,   824,
     825,   826,   827,   152,   828,   829,   830,   476,   477,   478,
     479,   767,   480,   155,   156,   481,   831,   482,   832,   483,
     484,   485,   486,   487,   833,   488,   489,   490,   834,   835,
     491,   492,   493,   494,   495,   836,   496,   497,   498,   837,
     499,   500,   501,   838,   839,   502,   503,   504,   164,   505,
     506,   507,   166,   840,   508,   841,   509,   510,   168,   842,
     843,   511,   844,   512,   169,   845,   170,   513,   514,   515,
     846,   516,   172,   847,   517,   848,   518,   519,   769,   520,
     521,   173,   522,   523,   524,   849,   525,   526,   527,   528,
     529,   530,   850,   531,   174,   175,   851,   532,   533,   534,
     852,   176,   853,   177,   854,   535,   178,   179,   536,   180,
     537,   538,   539,   540,   541,   855,   542,   543,   856,   544,
     181,   182,   545,   183,   857,   546,   547,   548,   858,   859,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   770,
     558,   559,   771,   560,   561,   562,   188,   189,   190,   563,
     564,   191,   860,   565,   566,   193,   567,   861,   194,   568,
     195,   569,   570,   571,   862,   572,   863,   864,   573,   574,
     575,   865,   866,   576,   196,   197,   577,   198,   199,   578,
     579,   580,   581,   867,   582,   583,   868,   584,   200,   869,
     201,   585,   586,   587,   870,   588,   589,   590,   591,   592,
     593,   594,   595,   203,   596,   597,   598,   599,   871,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     872,   611,   612,   210,   613,   614,   212,   615,   616,   617,
     618,   619,   620,   772,   621,   873,   622,   623,   624,   625,
     626,   874,   627,   217,   628,   629,   219,   630,   220,   631,
     875,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   222,   876,   642,   643,   877,   644,   645,   646,   647,
     648,   649,   878,   224,   225,   879,   880,   651,   226,   652,
     227,   881,   653,   654,   655,   656,   882,   657,   658,   883,
     884,   659,   660,   661,   662,   663,   885,   886,   664,   665,
     666,   667,   668,   887,   234,   888,   669,   235,   670,   671,
     672,   673,   889,   890,   674,   891,   892,   675,   676,   677,
     678,   679,   680,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   774,   681,   682,   683,   684,   685,   686,   687,
     688,   893,   689,   894,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   246,   247,   699,   700,   701,   702,   703,
     704,   248,   705,   249,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   250,   725,   895,   726,   727,   251,   728,
     729,   730,   731,   732,   733,   734,   735,     0,   798,    86,
      87,    88,   750,    90,    91,    92,   751,  2735,   752,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   799,   104,
     105,   753,   800,     0,   107,   108,   109,   110,   801,   802,
     112,   113,   114,   115,     0,   116,   803,   804,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,     0,  2049,   137,  2050,  2051,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  2052,  2053,   458,
       0,   459,   460,   461,   462,     0,     0,   145,     0,   463,
     464,   465,   466,   467,   148,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,     0,     0,
       0,   152,     0,     0,     0,   476,   477,   478,   479,   767,
     480,  2054,  2055,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
    1609,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,     0,   505,   506,   507,
       0,     0,   508,     0,   509,   510,  2056,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
       0,     0,   517,     0,   518,   519,   769,   520,   521,   173,
     522,   523,   524,  2847,   525,   526,   527,   528,   529,   530,
       0,   531,   174,  2848,     0,   532,   533,   534,  1615,  2057,
       0,  2058,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,     0,   182,
     545,   183,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,  2059,   189,  2060,   563,   564,     0,
       0,   565,   566,   193,   567,     0,     0,   568,  2061,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
    2849,   576,  2850,   197,   577,   198,     0,   578,   579,   580,
     581,     0,   582,   583,     0,   584,     0,     0,     0,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,  2062,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,     0,   615,   616,   617,   618,   619,
     620,   772,   621,     0,   622,   623,   624,   625,   626,     0,
     627,  2851,   628,   629,   219,   630,  2064,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,  2065,  2066,     0,     0,   651,     0,   652,     0,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,     0,  2067,  2852,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     774,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,     0,     0,   699,   700,   701,   702,   703,   704,   248,
     705,     0,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,     0,   725,     0,   726,   727,     0,   728,   729,   730,
     731,   732,   733,   734,   735,     0,   798,    86,    87,    88,
     750,    90,    91,    92,   751,  2853,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1586,  1587,     0,    45,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,  1591,   137,  1592,  1593,     0,   451,   452,   453,   454,
     455,     0,  4921,   456,   457,  1596,  1597,   458,     0,   459,
     460,   461,   462,   144,     0,   145,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,     0,     0,     0,   152,
       0,     0,     0,   476,   477,   478,   479,   767,   480,  1607,
    1608,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,   166,  1612,
     508,     0,   509,   510,  1613,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,   172,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,  1615,  1616,     0,  1617,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,   181,   182,   545,   183,
       0,   546,   547,   548,     0,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  1621,   189,  1622,   563,   564,   191,     0,   565,
     566,   193,   567,  1624,   194,   568,  1626,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,   199,   578,   579,   580,   581,     0,
     582,   583,     0,   584,   200,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  1630,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,     0,   627,   217,
     628,   629,   219,   630,  1633,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,  1636,
    1637,     0,     0,   651,   226,   652,   227,  1640,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,   773,
    1643,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   774,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,   248,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,    86,    87,    88,   750,    90,    91,
      92,   751,  4922,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
       0,     0,    86,    87,    88,   750,    90,    91,    92,   751,
    1187,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
      86,    87,    88,   750,    90,    91,    92,   751,  5694,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,    86,    87,
      88,   750,    90,    91,    92,   751,  6204,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,    45,     0,
       0,     0,     0,   433,  1082,   435,   436,   437,   438,   439,
     440,  1083,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,  1084,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,  1085,   168,     0,     0,   511,     0,
    1086,     0,  1087,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,  1088,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,  1089,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,  1090,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,  1091,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,  1092,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,     0,
       0,     0,  1093,  1094,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
     432,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,    45,     0,     0,     0,     0,   433,
    1082,   435,   436,   437,   438,   439,   440,  1083,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,  1115,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
    1085,   168,     0,     0,   511,     0,  1116,     0,  1087,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,  1088,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,  1089,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,  1090,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,  1091,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,  1092,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
       0,     0,     0,     0,     0,     0,     0,     0,  1093,  1094,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
      45,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,  1522,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,  1087,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,  1088,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,     0,     0,     0,     0,
       0,     0,     0,     0,  1093,  1094,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,   432,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,    45,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,  1527,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
    1087,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
    1088,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,     0,     0,     0,     0,     0,     0,     0,     0,
    1093,  1094,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,   768,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,  1700,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,     0,     0,
       0,  1157,  1701,    86,    87,    88,   750,    90,    91,    92,
     751,  1158,   752,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   753,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,   115,     0,   116,
       0,     0,   754,   755,     0,     0,     0,   756,   757,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,   759,     0,   760,     0,   761,   762,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,     0,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,   444,   445,     0,
     446,   447,     0,   448,   449,   450,   135,   136,     0,   138,
     139,     0,   451,   452,   453,   454,   455,     0,     0,  1159,
     457,  1131,   140,   458,     0,   459,   460,   461,   462,   144,
       0,     0,     0,   463,   464,   465,   466,   467,     0,   468,
    1160,     0,  1161,   470,   471,   472,   473,   474,     0,     0,
     475,     0,     0,     0,     0,     0,     0,     0,     0,   476,
     477,   478,   479,   767,   480,   155,   156,   481,     0,   482,
       0,   483,   484,   485,   486,   487,     0,   488,   489,   490,
       0,     0,   491,   492,   493,   494,   495,     0,   496,   497,
     498,     0,   499,   500,   501,     0,     0,   502,   503,   504,
     164,   505,   506,   507,   166,     0,   508,     0,   509,   510,
     168,     0,     0,   511,     0,   512,     0,     0,     0,   513,
     514,   515,     0,   516,   172,     0,   517,     0,   518,   519,
     769,   520,   521,     0,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,     0,   175,     0,   532,
     533,   534,     0,   176,     0,   177,     0,   535,     0,     0,
     536,     0,   537,   538,   539,   540,   541,     0,   542,   543,
       0,   544,   181,     0,   545,     0,     0,   546,   547,  1162,
       0,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   770,   558,   559,   771,   560,   561,  1163,   188,     0,
     190,   563,   564,   191,     0,   565,   566,     0,   567,     0,
     194,   568,   195,   569,   570,   571,     0,   572,     0,     0,
     573,   574,   575,     0,     0,   576,   196,     0,   577,     0,
     199,   578,   579,   580,   581,     0,   582,   583,     0,   584,
     200,     0,   201,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   203,   596,   597,   598,   599,
       0,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,   611,   612,     0,  1164,   614,   212,   615,
     616,   617,  1165,   619,   620,   772,   621,     0,   622,   623,
     624,   625,  1166,     0,   627,   217,   628,   629,     0,   630,
     220,   631,     0,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   222,     0,   642,   643,     0,   644,   645,
     646,   647,   648,   649,     0,  1167,   225,     0,     0,  1168,
     226,   652,   227,     0,   653,   654,   655,   656,     0,   657,
     658,     0,     0,   659,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,  1135,   234,     0,   669,     0,
     670,   671,   672,   673,     0,     0,   674,     0,     0,   675,
     676,   677,   678,   679,  1169,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   774,   681,   682,   683,   684,   685,
     686,   687,   688,     0,   689,     0,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   246,   247,   699,   700,   701,
     702,   703,   704,     0,   705,   249,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   250,   725,     0,   726,   727,
     251,   728,   729,   730,   731,   732,   733,   734,   735,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      45,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   805,   441,   442,   443,   806,   807,   808,
     809,   810,   811,   812,   444,   445,   813,   446,   447,   133,
     448,   449,   450,   135,   136,   137,   138,   139,   814,   451,
     452,   453,   454,   455,   815,   816,   456,   457,   817,   140,
     458,   818,   459,   460,   461,   462,   144,   819,   145,   820,
     463,   464,   465,   466,   467,   148,   468,   821,   822,   469,
     470,   471,   472,   473,   474,   823,   151,   475,   824,   825,
     826,   827,   152,   828,   829,   830,   476,   477,   478,   479,
     767,   480,   155,   156,   481,   831,   482,   832,   483,   484,
     485,   486,   487,   833,   488,   489,   490,   834,   835,   491,
     492,   493,   494,   495,   836,   496,   497,   498,   837,   499,
     500,   501,   838,   839,   502,   503,   504,   164,   505,   506,
     507,   166,   840,   508,   841,   509,   510,   168,   842,   843,
     511,   844,   512,   169,   845,   170,   513,   514,   515,   846,
     516,   172,   847,   517,   848,   518,   519,   769,   520,   521,
     173,   522,   523,   524,   849,   525,   526,   527,   528,   529,
     530,   850,   531,   174,   175,   851,   532,   533,   534,   852,
     176,   853,   177,   854,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,   855,   542,   543,   856,   544,   181,
     182,   545,   183,   857,   546,   547,   548,   858,   859,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,   189,   190,   563,   564,
     191,   860,   565,   566,   193,   567,   861,   194,   568,   195,
     569,   570,   571,   862,   572,   863,   864,   573,   574,   575,
     865,   866,   576,   196,   197,   577,   198,   199,   578,   579,
     580,   581,   867,   582,   583,   868,   584,   200,   869,   201,
     585,   586,   587,   870,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,   871,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   872,
     611,   612,   210,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,   873,   622,   623,   624,   625,   626,
     874,   627,   217,   628,   629,   219,   630,   220,   631,   875,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,   876,   642,   643,   877,   644,   645,   646,   647,   648,
     649,   878,   224,   225,   879,   880,   651,   226,   652,   227,
     881,   653,   654,   655,   656,   882,   657,   658,   883,   884,
     659,   660,   661,   662,   663,   885,   886,   664,   665,   666,
     667,   668,   887,   234,   888,   669,   235,   670,   671,   672,
     673,   889,   890,   674,   891,   892,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
     893,   689,   894,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
     248,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,   895,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     805,   441,   442,   443,   806,   807,   808,   809,   810,   811,
     812,   444,   445,   813,   446,   447,   133,   448,   449,   450,
     135,   136,   137,   138,   139,   814,   451,   452,   453,   454,
     455,   815,   816,   456,   457,   817,   140,   458,   818,   459,
     460,   461,   462,   144,   819,   145,   820,   463,   464,   465,
     466,   467,   148,   468,   821,   822,   469,   470,   471,   472,
     473,   474,   823,   151,   475,   824,   825,   826,   827,   152,
     828,   829,   830,   476,   477,   478,   479,   767,   480,   155,
     156,   481,   831,   482,   832,   483,   484,   485,   486,   487,
     833,   488,   489,   490,   834,   835,   491,   492,   493,   494,
     495,   836,   496,   497,   498,   837,   499,   500,   501,   838,
     839,   502,   503,   504,   164,   505,   506,   507,   166,   840,
     508,   841,   509,   510,   168,   842,   843,   511,   844,   512,
     169,   845,   170,   513,   514,   515,   846,   516,   172,   847,
     517,   848,   518,   519,   769,   520,   521,   173,   522,   523,
     524,   849,   525,   526,   527,   528,   529,   530,   850,   531,
     174,   175,   851,   532,   533,   534,   852,   176,   853,   177,
     854,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,   855,   542,   543,   856,   544,   181,   182,   545,   183,
     857,   546,   547,   548,   858,   859,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,   188,   189,   190,   563,   564,   191,   860,   565,
     566,   193,   567,   861,   194,   568,   195,   569,   570,   571,
     862,   572,   863,   864,   573,   574,   575,   865,   866,   576,
     196,   197,   577,   198,   199,   578,   579,   580,   581,   867,
     582,   583,   868,   584,   200,   869,   201,   585,   586,   587,
     870,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,   871,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   872,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,   772,
     621,   873,   622,   623,   624,   625,   626,   874,   627,   217,
     628,   629,   219,   630,   220,   631,   875,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,   876,   642,
     643,   877,   644,   645,   646,   647,   648,   649,   878,   224,
     225,   879,   880,   651,   226,   652,   227,   881,   653,   654,
     655,   656,   882,   657,   658,   883,   884,   659,   660,   661,
     662,   663,   885,   886,   664,   665,   666,   667,   668,   887,
     234,   888,   669,   235,   670,   671,   672,   673,   889,   890,
     674,   891,   892,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   774,   681,
     682,   683,   684,   685,   686,   687,   688,   893,   689,   894,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,   248,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,   895,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,   798,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   799,   104,   105,   753,   800,     0,   107,
     108,   109,   110,   801,   802,   112,   113,   114,   115,     0,
     116,   803,   804,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,  3750,   438,   439,   440,   805,   441,   442,
     443,   806,   807,   808,   809,   810,   811,   812,   444,   445,
     813,   446,   447,   133,   448,   449,   450,   135,   136,   137,
     138,   139,   814,   451,   452,   453,   454,   455,   815,   816,
     456,   457,   817,   140,   458,   818,   459,   460,   461,   462,
     144,   819,   145,   820,   463,   464,   465,   466,   467,   148,
     468,   821,   822,   469,   470,   471,   472,   473,   474,   823,
     151,   475,   824,   825,   826,   827,   152,   828,   829,   830,
     476,   477,   478,   479,   767,   480,   155,   156,   481,   831,
     482,   832,   483,   484,   485,   486,   487,   833,   488,   489,
     490,   834,   835,   491,   492,   493,  3751,   495,   836,   496,
     497,   498,   837,   499,   500,   501,   838,   839,   502,   503,
     504,   164,   505,   506,   507,   166,   840,   508,   841,   509,
     510,   168,   842,   843,   511,   844,   512,   169,   845,   170,
     513,   514,   515,   846,   516,   172,   847,   517,   848,   518,
     519,   769,   520,   521,   173,   522,   523,   524,   849,   525,
     526,   527,   528,   529,   530,   850,   531,   174,   175,   851,
     532,   533,   534,   852,   176,   853,   177,   854,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,   855,   542,
     543,   856,   544,   181,   182,   545,   183,   857,   546,   547,
     548,   858,   859,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
     189,   190,   563,   564,   191,   860,   565,   566,   193,   567,
     861,   194,   568,   195,   569,   570,   571,   862,   572,   863,
     864,   573,   574,   575,   865,   866,   576,   196,   197,   577,
     198,   199,   578,   579,   580,   581,   867,   582,   583,   868,
     584,   200,   869,   201,   585,   586,   587,   870,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,   871,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   872,   611,   612,   210,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,   873,   622,
     623,   624,   625,   626,   874,  3752,   217,   628,   629,   219,
     630,   220,   631,   875,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,   876,   642,   643,   877,   644,
     645,   646,   647,   648,   649,   878,   224,   225,   879,   880,
     651,   226,   652,   227,   881,   653,   654,   655,   656,   882,
     657,   658,   883,   884,   659,   660,   661,   662,   663,   885,
     886,   664,   665,   666,   667,   668,   887,   234,   888,   669,
     235,   670,   671,   672,   673,   889,   890,   674,   891,   892,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,   893,   689,   894,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,   248,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,   895,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
     798,    86,    87,    88,   750,    90,    91,    92,   751,     0,
     752,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     799,   104,   105,   753,   800,     0,   107,   108,   109,   110,
     801,   802,   112,   113,   114,   115,     0,   116,   803,   804,
     754,   755,     0,     0,     0,   756,   757,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,   760,     0,   761,   762,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,     0,   441,   442,   443,     0,     0,
       0,     0,     0,     0,     0,   444,   445,     0,   446,   447,
     133,   448,   449,   450,   135,   136,   137,   138,   139,     0,
     451,   452,   453,   454,   455,     0,  1595,   456,   457,   764,
     140,   458,     0,   459,   460,   461,   462,  1598,     0,  1599,
       0,   463,   464,   465,   466,   467,   148,   468,   765,     0,
     469,   470,   471,   472,   473,   474,     0,   151,   475,     0,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,   476,   477,   478,
     479,   767,   480,   155,   156,   481,     0,   482,     0,   483,
     484,   485,   486,   487,     0,   488,   489,   490,     0,     0,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     499,   500,   501,     0,     0,   502,   503,   504,   164,   505,
     506,   507,  1611,     0,   508,     0,   509,   510,   168,     0,
       0,   511,     0,   512,   169,     0,   170,   513,   514,   515,
       0,   516,  1614,     0,   517,     0,   518,   519,   769,   520,
     521,   173,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   174,   175,     0,   532,   533,   534,
       0,   176,     0,   177,     0,   535,   178,   179,   536,   180,
     537,   538,   539,   540,   541,     0,   542,   543,     0,   544,
    1618,   182,   545,   183,     0,   546,   547,   548,  1619,  1620,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   770,
     558,   559,   771,   560,   561,   562,   188,   189,   190,   563,
     564,   191,     0,   565,   566,   193,   567,     0,  1625,   568,
     195,   569,   570,   571,     0,   572,     0,     0,   573,   574,
     575,     0,     0,   576,   196,   197,   577,   198,  1628,   578,
     579,   580,   581,     0,   582,   583,     0,   584,  1629,     0,
     201,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   203,   596,   597,   598,   599,     0,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,   611,   612,   210,   613,   614,   212,   615,   616,   617,
     618,   619,   620,   772,   621,     0,   622,   623,   624,   625,
     626,  1632,   627,   217,   628,   629,   219,   630,   220,   631,
       0,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,  1634,     0,   642,   643,     0,   644,   645,   646,   647,
     648,   649,     0,   224,   225,     0,     0,   651,  1638,   652,
    1639,     0,   653,   654,   655,   656,     0,   657,   658,     0,
       0,   659,   660,   661,   662,   663,  1642,     0,   664,   665,
     666,   667,   668,   773,   234,     0,   669,   235,   670,   671,
     672,   673,     0,     0,   674,     0,     0,   675,   676,   677,
     678,   679,   680,   237,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,   774,   681,   682,   683,   684,   685,   686,   687,
     688,  4226,   689,     0,   690,   691,   692,   693,   694,   695,
     696,   697,   698,  1653,  1654,   699,   700,   701,   702,   703,
     704,   248,   705,  1655,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   250,   725,     0,   726,   727,   251,   728,
     729,   730,   731,   732,   733,   734,   735,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,   189,   190,   563,   564,   191,     0,
     565,   566,   193,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,   219,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,   798,    86,    87,    88,   750,    90,
      91,    92,   751,     0,   752,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   799,   104,   105,   753,   800,     0,
     107,   108,   109,   110,   801,   802,   112,   113,   114,   115,
       0,   116,   803,   804,   754,   755,     0,     0,     0,   756,
     757,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   760,     0,   761,   762,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,   133,   448,   449,   450,   135,   136,
     137,   138,   139,     0,   451,   452,   453,   454,   455,     0,
       0,   456,   457,   764,   140,   458,     0,   459,   460,   461,
     462,   144,     0,   145,     0,   463,   464,   465,   466,   467,
     148,   468,   765,     0,   469,   470,   471,   472,   473,   474,
       0,   151,   475,     0,     0,     0,     0,   152,     0,     0,
       0,   476,   477,   478,   479,   767,   480,   155,   156,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,   166,     0,   508,     0,
     509,   510,   168,     0,     0,   511,     0,   512,   169,     0,
     170,   513,   514,   515,     0,   516,   172,     0,   517,     0,
     518,   519,   769,   520,  1452,   173,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   174,   175,
       0,   532,   533,   534,     0,   176,     0,   177,     0,   535,
     178,   179,   536,   180,   537,   538,   539,   540,   541,     0,
     542,   543,     0,   544,   181,   182,   545,   183,     0,   546,
     547,   548,     0,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   770,   558,   559,   771,   560,   561,   562,
     188,   189,   190,   563,   564,   191,     0,   565,   566,   193,
     567,     0,   194,   568,   195,   569,   570,   571,     0,   572,
       0,     0,   573,   574,   575,     0,     0,   576,   196,   197,
     577,   198,   199,   578,   579,   580,   581,     0,   582,   583,
       0,   584,   200,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   203,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,   210,   613,   614,
     212,   615,   616,   617,   618,   619,   620,   772,   621,     0,
     622,   623,   624,   625,   626,     0,   627,   217,   628,   629,
     219,   630,   220,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   222,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,   224,   225,     0,
       0,   651,   226,   652,   227,     0,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
       0,     0,   664,   665,   666,   667,   668,   773,   234,     0,
     669,   235,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   774,   681,   682,   683,
     684,   685,   686,   687,   688,     0,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   246,   247,   699,
     700,   701,   702,   703,   704,   248,   705,   249,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,   798,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   799,   104,   105,   753,   800,     0,   107,   108,   109,
     110,   801,   802,   112,   113,   114,   115,     0,   116,   803,
     804,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,   136,   137,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
     145,     0,   463,   464,   465,   466,   467,   148,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,     0,     0,     0,   152,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  1464,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,   182,   545,   183,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,   189,   190,
     563,   564,   191,     0,   565,   566,   193,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,   197,   577,   198,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,   219,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,   248,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,   798,    86,
      87,    88,   750,    90,    91,    92,   751,     0,   752,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   799,   104,
     105,   753,   800,     0,   107,   108,   109,   110,   801,   802,
     112,   113,   114,   115,     0,   116,   803,   804,   754,   755,
       0,     0,     0,   756,   757,     0,     0,     0,     0,   758,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
     760,     0,   761,   762,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,     0,  2049,   137,  2050,  2051,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,  2052,  2053,   458,
       0,   459,   460,   461,   462,     0,     0,   145,     0,   463,
     464,   465,   466,   467,   148,   468,   765,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,     0,     0,
       0,   152,     0,     0,     0,   476,   477,   478,   479,   767,
     480,  2054,  2055,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
    1609,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,     0,   505,   506,   507,
       0,     0,   508,     0,   509,   510,  2056,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
       0,     0,   517,     0,   518,   519,   769,   520,   521,   173,
     522,   523,   524,  2847,   525,   526,   527,   528,   529,   530,
       0,   531,   174,  2848,     0,   532,   533,   534,  1615,  2057,
       0,  2058,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,     0,   182,
     545,   183,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   770,   558,   559,
     771,   560,   561,   562,  2059,   189,  2060,   563,   564,     0,
       0,   565,   566,   193,   567,     0,     0,   568,  2061,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
       0,   576,  2850,   197,   577,   198,     0,   578,   579,   580,
     581,     0,   582,   583,     0,   584,     0,     0,     0,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,  2062,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,     0,   615,   616,   617,   618,   619,
     620,   772,   621,     0,   622,   623,   624,   625,   626,     0,
     627,  2851,   628,   629,   219,   630,  2064,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,  2065,  2066,     0,     0,   651,     0,   652,     0,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,     0,  2067,  2852,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     774,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,     0,     0,   699,   700,   701,   702,   703,   704,   248,
     705,     0,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,     0,   725,     0,   726,   727,     0,   728,   729,   730,
     731,   732,   733,   734,   735,   798,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   799,   104,   105,   753,   800,
       0,   107,   108,   109,   110,   801,   802,   112,   113,   114,
     115,     0,   116,   803,   804,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,   133,   448,   449,   450,     0,
    2049,   137,  2050,  2051,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,  2052,  2053,   458,     0,   459,   460,
     461,   462,     0,     0,   145,     0,   463,   464,   465,   466,
     467,   148,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,   151,   475,     0,     0,     0,     0,   152,     0,
       0,     0,   476,   477,   478,   479,   767,   480,  2054,  2055,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,  1609,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,     0,   505,   506,   507,     0,     0,   508,
       0,   509,   510,  2056,     0,     0,   511,     0,   512,   169,
       0,   170,   513,   514,   515,     0,   516,     0,     0,   517,
       0,   518,   519,   769,   520,   521,   173,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   174,
       0,     0,   532,   533,   534,  1615,  2057,     0,  2058,     0,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,     0,   182,   545,   183,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,  2059,   189,  2060,   563,   564,     0,     0,   565,   566,
     193,   567,  2942,     0,   568,  2061,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,     0,
     197,   577,   198,     0,   578,   579,   580,   581,     0,   582,
     583,     0,   584,     0,     0,     0,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,  2062,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,   210,   613,
     614,     0,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,  2851,   628,
     629,   219,   630,  2064,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,     0,     0,   642,   643,
    4655,   644,   645,   646,   647,   648,   649,     0,  2065,  2066,
       0,     0,   651,     0,   652,     0,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,     0,  2067,
       0,   669,   235,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,     0,     0,
     699,   700,   701,   702,   703,   704,   248,   705,     0,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,     0,   725,
       0,   726,   727,     0,   728,   729,   730,   731,   732,   733,
     734,   735,   798,    86,    87,    88,   750,    90,    91,    92,
     751,     0,   752,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   799,   104,   105,   753,   800,     0,   107,   108,
     109,   110,   801,   802,   112,   113,   114,   115,     0,   116,
     803,   804,   754,   755,     0,     0,     0,   756,   757,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,   759,     0,   760,     0,   761,   762,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,     0,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,   444,   445,     0,
     446,   447,   133,   448,   449,   450,     0,  2049,   137,  2050,
    2051,     0,   451,   452,   453,   454,   455,     0,     0,   456,
     457,  2052,  2053,   458,     0,   459,   460,   461,   462,     0,
       0,   145,     0,   463,   464,   465,   466,   467,   148,   468,
     765,     0,   469,   470,   471,   472,   473,   474,     0,   151,
     475,     0,     0,     0,     0,   152,     0,     0,     0,   476,
     477,   478,   479,   767,   480,  2054,  2055,   481,     0,   482,
       0,   483,   484,   485,   486,   487,     0,   488,   489,   490,
       0,     0,   491,   492,  1609,   494,   495,     0,   496,   497,
     498,     0,   499,   500,   501,     0,     0,   502,   503,   504,
       0,   505,   506,   507,     0,     0,   508,     0,   509,   510,
    2056,     0,     0,   511,     0,   512,   169,     0,   170,   513,
     514,   515,     0,   516,     0,     0,   517,     0,   518,   519,
     769,   520,   521,   173,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   174,     0,     0,   532,
     533,   534,  1615,  2057,     0,  2058,     0,   535,   178,   179,
     536,   180,   537,   538,   539,   540,   541,     0,   542,   543,
       0,   544,     0,   182,   545,   183,     0,   546,   547,   548,
       0,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   770,   558,   559,   771,   560,   561,   562,  2059,   189,
    2060,   563,   564,  3021,     0,   565,   566,   193,   567,     0,
       0,   568,  2061,   569,   570,   571,     0,   572,     0,     0,
     573,   574,   575,     0,     0,   576,     0,   197,   577,   198,
       0,   578,   579,   580,   581,     0,   582,   583,     0,   584,
       0,     0,     0,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,  2062,   596,   597,   598,   599,
       0,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,   611,   612,   210,   613,   614,     0,   615,
     616,   617,   618,   619,   620,   772,   621,     0,   622,   623,
     624,   625,   626,     0,   627,  2063,   628,   629,   219,   630,
    2064,   631,     0,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,     0,     0,   642,   643,     0,   644,   645,
     646,   647,   648,   649,     0,  2065,  2066,     0,     0,   651,
       0,   652,     0,     0,   653,   654,   655,   656,     0,   657,
     658,     0,     0,   659,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,     0,  2067,     0,   669,   235,
     670,   671,   672,   673,     0,     0,   674,     0,     0,   675,
     676,   677,   678,   679,   680,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   774,   681,   682,   683,   684,   685,
     686,   687,   688,     0,   689,     0,   690,   691,   692,   693,
     694,   695,   696,   697,   698,     0,     0,   699,   700,   701,
     702,   703,   704,   248,   705,     0,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,     0,   725,     0,   726,   727,
       0,   728,   729,   730,   731,   732,   733,   734,   735,   798,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   799,
     104,   105,   753,   800,     0,   107,   108,   109,   110,   801,
     802,   112,   113,   114,   115,     0,   116,   803,   804,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,     0,  2049,   137,  2050,  2051,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,  2052,  2053,
     458,     0,   459,   460,   461,   462,     0,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
     767,   480,  2054,  2055,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,  1609,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,     0,   505,   506,
     507,     0,     0,   508,     0,   509,   510,  2056,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,     0,     0,   517,     0,   518,   519,   769,   520,   521,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,     0,     0,   532,   533,   534,  1615,
    2057,     0,  2058,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,     0,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,  2059,   189,  2060,   563,   564,
    4456,     0,   565,   566,   193,   567,     0,     0,   568,  2061,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,     0,   197,   577,   198,     0,   578,   579,
     580,   581,     0,   582,   583,     0,   584,     0,     0,     0,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,  2062,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,     0,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,  2063,   628,   629,   219,   630,  2064,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
       0,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,  2065,  2066,     0,     0,   651,     0,   652,     0,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,     0,  2067,     0,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,     0,     0,   699,   700,   701,   702,   703,   704,
     248,   705,     0,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,     0,   725,     0,   726,   727,     0,   728,   729,
     730,   731,   732,   733,   734,   735,   798,    86,    87,    88,
     750,    90,    91,    92,   751,     0,   752,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   799,   104,   105,   753,
     800,     0,   107,   108,   109,   110,   801,   802,   112,   113,
     114,   115,     0,   116,   803,   804,   754,   755,     0,     0,
       0,   756,   757,     0,     0,     0,     0,   758,     0,     0,
       0,     0,     0,     0,     0,     0,   759,     0,   760,     0,
     761,   762,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
       0,  2049,   137,  2050,  2051,     0,   451,   452,   453,   454,
     455,     0,     0,   456,   457,  2052,  2053,   458,     0,   459,
     460,   461,   462,     0,     0,   145,     0,   463,   464,   465,
     466,   467,   148,   468,   765,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,     0,     0,     0,   152,
       0,     0,     0,   476,   477,   478,   479,   767,   480,  2054,
    2055,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,  1609,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,     0,   505,   506,   507,     0,     0,
     508,     0,   509,   510,  2056,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,     0,     0,
     517,     0,   518,   519,   769,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,     0,     0,   532,   533,   534,  1615,  2057,     0,  2058,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,     0,   182,   545,   183,
       0,   546,   547,   548,     0,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   770,   558,   559,   771,   560,
     561,   562,  2059,   189,  2060,   563,   564,     0,     0,   565,
     566,   193,   567,     0,     0,   568,  2061,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
       0,   197,   577,   198,     0,   578,   579,   580,   581,     0,
     582,   583,     0,   584,     0,     0,     0,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,  2062,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,     0,   615,   616,   617,   618,   619,   620,   772,
     621,     0,   622,   623,   624,   625,   626,     0,   627,  2063,
     628,   629,   219,   630,  2064,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,     0,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,  2065,
    2066,     0,     0,   651,     0,   652,     0,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,     0,
    2067,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   774,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,     0,
       0,   699,   700,   701,   702,   703,   704,   248,   705,     0,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,     0,
     725,     0,   726,   727,     0,   728,   729,   730,   731,   732,
     733,   734,   735,   798,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   799,   104,   105,   753,   800,     0,   107,
     108,   109,   110,   801,   802,   112,   113,   114,   115,     0,
     116,   803,   804,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,   133,   448,   449,   450,     0,  2049,   137,
    2050,  2051,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  2052,  2053,   458,     0,   459,   460,   461,   462,
       0,     0,   145,     0,   463,   464,   465,   466,   467,   148,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
     151,   475,     0,     0,     0,     0,   152,     0,     0,     0,
     476,   477,   478,   479,   767,   480,  2054,  2055,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,  1609,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,     0,   505,   506,   507,     0,     0,   508,     0,   509,
     510,  2056,     0,     0,   511,     0,   512,   169,     0,   170,
     513,   514,   515,     0,   516,     0,     0,   517,     0,   518,
     519,   769,   520,   521,   173,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   174,     0,     0,
     532,   533,   534,  1615,  2057,     0,  2058,     0,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,     0,   182,   545,   183,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,  2059,
     189,  2060,   563,   564,     0,     0,   565,   566,   193,   567,
       0,     0,   568,  2061,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,     0,   197,   577,
     198,     0,   578,   579,   580,   581,     0,   582,   583,     0,
     584,     0,     0,     0,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,  2062,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,   210,   613,   614,     0,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,  2851,   628,   629,   219,
     630,  2064,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,     0,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,  2065,  2066,     0,     0,
     651,     0,   652,     0,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,     0,  2067,     0,   669,
     235,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,     0,     0,   699,   700,
     701,   702,   703,   704,   248,   705,     0,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,     0,   725,     0,   726,
     727,     0,   728,   729,   730,   731,   732,   733,   734,   735,
     798,    86,    87,    88,   750,    90,    91,    92,   751,     0,
     752,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     799,   104,   105,   753,   800,     0,   107,   108,   109,   110,
     801,   802,   112,   113,   114,   115,     0,   116,   803,   804,
     754,   755,     0,     0,     0,   756,   757,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,   760,     0,   761,   762,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,     0,   441,   442,   443,     0,     0,
       0,     0,     0,     0,     0,   444,   445,     0,   446,   447,
     133,   448,   449,   450,     0,  2049,   137,  2050,  2051,     0,
     451,   452,   453,   454,   455,     0,     0,   456,   457,  2052,
    2053,   458,     0,   459,   460,   461,   462,     0,     0,   145,
       0,   463,   464,   465,   466,   467,   148,   468,   765,     0,
     469,   470,   471,   472,   473,   474,     0,   151,   475,     0,
       0,     0,     0,   152,     0,     0,     0,   476,   477,   478,
     479,   767,   480,  2054,  2055,   481,     0,   482,     0,   483,
     484,   485,   486,   487,     0,   488,   489,   490,     0,     0,
     491,   492,  1609,   494,   495,     0,   496,   497,   498,     0,
     499,   500,   501,     0,     0,   502,   503,   504,     0,   505,
     506,   507,     0,     0,   508,     0,   509,   510,  2056,     0,
       0,   511,     0,   512,   169,     0,   170,   513,   514,   515,
       0,   516,     0,     0,   517,     0,   518,   519,   769,   520,
     521,   173,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   174,     0,     0,   532,   533,   534,
    1615,  2057,     0,  2058,     0,   535,   178,   179,   536,   180,
     537,   538,   539,   540,   541,     0,   542,   543,     0,   544,
       0,   182,   545,   183,     0,   546,   547,   548,     0,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   770,
     558,   559,   771,   560,   561,   562,  2059,   189,  2060,   563,
     564,     0,     0,   565,   566,   193,   567,     0,     0,   568,
    2061,   569,   570,   571,     0,   572,     0,     0,   573,   574,
     575,     0,     0,   576,     0,   197,   577,   198,     0,   578,
     579,   580,   581,     0,   582,   583,     0,   584,     0,     0,
       0,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,  2062,   596,   597,   598,   599,     0,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,   611,   612,   210,   613,   614,     0,   615,   616,   617,
     618,   619,   620,   772,   621,     0,   622,   623,   624,   625,
     626,     0,   627,     0,   628,   629,   219,   630,  2064,   631,
       0,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,     0,     0,   642,   643,     0,   644,   645,   646,   647,
     648,   649,     0,  2065,  2066,     0,     0,   651,     0,   652,
       0,     0,   653,   654,   655,   656,     0,   657,   658,     0,
       0,   659,   660,   661,   662,   663,     0,     0,   664,   665,
     666,   667,   668,     0,  2067,     0,   669,   235,   670,   671,
     672,   673,     0,     0,   674,     0,     0,   675,   676,   677,
     678,   679,   680,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   774,   681,   682,   683,   684,   685,   686,   687,
     688,     0,   689,     0,   690,   691,   692,   693,   694,   695,
     696,   697,   698,     0,     0,   699,   700,   701,   702,   703,
     704,   248,   705,     0,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,     0,   725,     0,   726,   727,     0,   728,
     729,   730,   731,   732,   733,   734,   735,   798,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   799,   104,   105,
     753,   800,     0,   107,   108,   109,   110,   801,   802,   112,
     113,   114,   115,     0,   116,   803,   804,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,     0,     0,   137,     0,     0,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,     0,   458,     0,
     459,   460,   461,   462,     0,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,   767,   480,
       0,     0,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,     0,   505,   506,   507,     0,
       0,   508,     0,   509,   510,     0,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,     0,
       0,   517,     0,   518,   519,   769,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,     0,     0,   532,   533,   534,     0,     0,     0,
       0,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,     0,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,     0,   189,     0,   563,   564,     0,     0,
     565,   566,   193,   567,     0,     0,   568,     0,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,     0,   197,   577,   198,     0,   578,   579,   580,   581,
       0,   582,   583,     0,   584,     0,     0,     0,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
       0,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,     0,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
       0,   628,   629,   219,   630,     0,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,     0,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
       0,     0,     0,     0,   651,     0,   652,     0,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
       0,     0,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
       0,     0,   699,   700,   701,   702,   703,   704,   248,   705,
       0,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
       0,   725,     0,   726,   727,     0,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   805,   441,   442,
     443,   806,   807,   808,   809,   810,   811,   812,   444,   445,
     813,   446,   447,   133,   448,   449,   450,   135,   136,   137,
     138,   139,   814,   451,   452,   453,   454,   455,   815,   816,
     456,   457,     0,   140,   458,   818,   459,   460,   461,   462,
     144,   819,   145,   820,   463,   464,   465,   466,   467,   148,
     468,   821,   822,   469,   470,   471,   472,   473,   474,   823,
     151,   475,     0,   825,   826,   827,   152,   828,   829,   830,
     476,   477,   478,   479,     0,   480,   155,   156,   481,   831,
     482,   832,   483,   484,   485,   486,   487,   833,   488,   489,
     490,   834,   835,   491,   492,   493,   494,   495,   836,   496,
     497,   498,   837,   499,   500,   501,   838,   839,   502,   503,
     504,   164,   505,   506,   507,   166,   840,   508,   841,   509,
     510,   168,   842,   843,   511,   844,   512,   169,   845,   170,
     513,   514,   515,   846,   516,   172,   847,   517,   848,   518,
     519,     0,   520,   521,   173,   522,   523,   524,   849,   525,
     526,   527,   528,   529,   530,   850,   531,   174,   175,     0,
     532,   533,   534,     0,   176,   853,   177,   854,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,   855,   542,
     543,   856,   544,   181,   182,   545,   183,   857,   546,   547,
     548,   858,   859,   549,   550,   551,   552,   553,   554,   555,
     556,   557,     0,   558,   559,     0,   560,   561,   562,   188,
     189,   190,   563,   564,   191,   860,   565,   566,   193,   567,
     861,   194,   568,   195,   569,   570,   571,   862,   572,   863,
     864,   573,   574,   575,   865,   866,   576,   196,   197,   577,
     198,   199,   578,   579,   580,   581,   867,   582,   583,   868,
     584,   200,   869,   201,   585,   586,   587,   870,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,   871,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   872,   611,   612,   210,   613,   614,   212,
     615,   616,   617,   618,   619,   620,     0,   621,   873,   622,
     623,   624,   625,   626,   874,   627,   217,   628,   629,   219,
     630,   220,   631,   875,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,   876,   642,   643,   877,   644,
     645,   646,   647,   648,   649,   878,   224,   225,     0,   880,
     651,   226,   652,   227,   881,   653,   654,   655,   656,   882,
     657,   658,     0,   884,   659,   660,   661,   662,   663,   885,
     886,   664,   665,   666,   667,   668,     0,   234,   888,   669,
     235,   670,   671,   672,   673,   889,   890,   674,   891,   892,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,   681,   682,   683,   684,
     685,   686,   687,   688,   893,   689,   894,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,   248,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,   895,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,  2884,   459,   460,   461,   462,   144,     0,     0,  2964,
     463,   464,   465,   466,   467,     0,   468,   765,  2885,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,  2965,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,  2886,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,  2887,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,  2966,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,  2888,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,  2889,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,  2884,   459,   460,
     461,   462,   144,     0,     0,  3953,   463,   464,   465,   466,
     467,     0,   468,   765,  2885,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,  3954,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,  2886,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,  2887,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,  3955,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,  2888,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,  2889,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,  1249,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,    37,    38,    39,
      40,    41,    42,     0,    44,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,  2884,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,  2885,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,  2886,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,  2887,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,  2888,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,  2889,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
    1146,   439,   440,  1102,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,  1103,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,  1147,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,  1104,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,  1105,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,  1102,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,  1103,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,  3626,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,  1104,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
    1105,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,    37,    38,    39,    40,    41,    42,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   763,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,   766,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,   768,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,  1102,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,  1103,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,  1104,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,  1105,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,  1009,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,  1010,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,  1011,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,  2249,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,  2250,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,  2251,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,  2252,   512,     0,
       0,     0,  2253,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,  2254,  2255,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,  2256,   619,   620,   772,   621,
       0,  2257,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
    2258,   644,  2259,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,  2260,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
    2261,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,  1103,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,  1104,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,  1105,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,  2238,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,  2829,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,  3480,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,  3481,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,  3482,   644,   645,  3483,   647,  3484,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
    3485,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
     432,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   790,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,   768,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,   432,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   954,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,  1331,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  1332,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,  1180,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,  1444,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,   130,   131,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,  3731,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,  3732,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,  3746,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,  3747,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,   432,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,   432,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,  1015,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
     432,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,  1063,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,   432,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,  1119,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,  1180,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,  1301,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  1302,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,  1703,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,  1882,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
    1180,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,  1940,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  1941,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,  2143,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,  2755,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,  2238,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,  2829,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,  4811,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,  4825,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,  5109,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,  5111,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,  5113,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
    5375,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,  3955,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
    1128,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,  1130,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1131,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,     0,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,  1132,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
    1133,   225,     0,     0,  1134,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
    1135,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,  1174,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  1131,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,     0,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,  1175,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,  1176,   225,     0,     0,
    1177,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,  1135,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,  1194,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,  1326,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  1341,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,  1399,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,  1413,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  1457,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,  1478,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  1480,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,  1482,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,  1485,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  1493,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,  1714,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,  1159,   457,  1131,   140,  1715,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,     0,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
    1163,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,  1164,
     614,   212,   615,   616,   617,  1165,   619,   620,   772,   621,
       0,   622,   623,   624,   625,  1707,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,  1167,   225,
       0,     0,  1168,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,  1135,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,  1169,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,  1756,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,  1757,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,  1844,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,  1130,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,  1131,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,     0,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,  1135,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  2096,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,  2128,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  2168,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,  2170,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,  2172,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,  2288,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,  2795,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,     0,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,  3229,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,   615,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,   764,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,   765,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,  3637,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
     773,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,   764,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,   765,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,  3734,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,   562,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,   613,   614,   212,
     615,   616,   617,   618,   619,   620,   772,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,   773,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,   764,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,   765,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,  3739,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,   562,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,   613,   614,   212,   615,   616,   617,   618,
     619,   620,   772,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,   773,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,   764,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,   765,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,  3861,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
     562,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,   613,
     614,   212,   615,   616,   617,   618,   619,   620,   772,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,   773,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,  1159,   457,
    1131,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,     0,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,  1163,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,  1164,   614,   212,   615,   616,
     617,  1165,   619,   620,   772,   621,     0,   622,   623,   624,
     625,  1707,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,  1167,   225,     0,     0,  1168,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,  1135,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,  1169,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,   750,    90,    91,    92,   751,     0,   752,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     753,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   754,   755,     0,
       0,     0,   756,   757,     0,     0,     0,     0,   758,     0,
       0,     0,     0,     0,     0,     0,     0,   759,     0,   760,
       0,   761,   762,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,     0,   448,   449,
     450,   135,   136,     0,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,  1131,   140,   458,     0,
     459,   460,   461,   462,   144,     0,     0,     0,   463,   464,
     465,   466,   467,     0,   468,     0,     0,   469,   470,   471,
     472,   473,   474,     0,     0,   475,     0,     0,     0,     0,
       0,     0,     0,     0,   476,   477,   478,   479,   767,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,     0,     0,     0,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,   769,   520,   521,     0,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,     0,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,     0,     0,   536,     0,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,     0,   545,
       0,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   770,   558,   559,   771,
     560,   561,   562,   188,     0,   190,   563,   564,   191,     0,
     565,   566,     0,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,     0,   577,     0,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
       0,   613,   614,   212,   615,   616,   617,   618,   619,   620,
     772,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,     0,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
    1135,   234,     0,   669,     0,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   774,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,     0,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    86,    87,    88,   750,    90,    91,
      92,   751,     0,   752,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   753,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   754,   755,     0,     0,     0,   756,   757,
       0,     0,     0,     0,   758,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,   760,     0,   761,   762,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,     0,   448,   449,   450,   135,   136,     0,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
    1159,   457,  1131,   140,   458,     0,   459,   460,   461,   462,
     144,     0,     0,     0,   463,   464,   465,   466,   467,     0,
     468,     0,     0,   469,   470,   471,   472,   473,   474,     0,
       0,   475,     0,     0,     0,     0,     0,     0,     0,     0,
     476,   477,   478,   479,   767,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,     0,     0,     0,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,   769,   520,   521,     0,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,     0,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,     0,
       0,   536,     0,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,     0,   545,     0,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   770,   558,   559,   771,   560,   561,  1163,   188,
       0,   190,   563,   564,   191,     0,   565,   566,     0,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,     0,   577,
       0,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,     0,  1164,   614,   212,
     615,   616,   617,  1165,   619,   620,   772,   621,     0,   622,
     623,   624,   625,  1707,     0,   627,   217,   628,   629,     0,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
    2875,   646,   647,   648,   649,     0,  1167,   225,     0,     0,
    1168,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,  1135,   234,     0,   669,
       0,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,  1169,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   774,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,     0,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      86,    87,    88,   750,    90,    91,    92,   751,     0,   752,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   753,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   754,
     755,     0,     0,     0,   756,   757,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,   760,     0,   761,   762,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,     0,
     448,   449,   450,   135,   136,     0,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,  1159,   457,  1131,   140,
     458,     0,   459,   460,   461,   462,   144,     0,     0,     0,
     463,   464,   465,   466,   467,     0,   468,     0,     0,   469,
     470,   471,   472,   473,   474,     0,     0,   475,     0,     0,
       0,     0,     0,     0,     0,     0,   476,   477,   478,   479,
     767,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,     0,     0,     0,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,   769,   520,   521,
       0,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,     0,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,     0,     0,   536,     0,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
       0,   545,     0,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   770,   558,
     559,   771,   560,   561,  1163,   188,     0,   190,   563,   564,
     191,     0,   565,   566,     0,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,     0,   577,     0,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,     0,  1164,   614,   212,   615,   616,   617,  2946,
     619,   620,   772,   621,     0,   622,   623,   624,   625,  2947,
       0,   627,   217,   628,   629,     0,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,  1167,   225,     0,     0,  2948,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,  1135,   234,     0,   669,     0,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,  1169,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   774,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
       0,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    86,    87,    88,   750,
      90,    91,    92,   751,     0,   752,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   753,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   754,   755,     0,     0,     0,
     756,   757,     0,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,   759,     0,   760,     0,   761,
     762,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,     0,   448,   449,   450,   135,
     136,     0,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,  1159,   457,  1131,   140,   458,     0,   459,   460,
     461,   462,   144,     0,     0,     0,   463,   464,   465,   466,
     467,     0,   468,     0,     0,   469,   470,   471,   472,   473,
     474,     0,     0,   475,     0,     0,     0,     0,     0,     0,
       0,     0,   476,   477,   478,   479,   767,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,     0,
       0,     0,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,   769,   520,   521,     0,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,     0,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,     0,     0,   536,     0,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,     0,   545,     0,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   770,   558,   559,   771,   560,   561,
    1163,   188,     0,   190,   563,   564,   191,     0,   565,   566,
       0,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
       0,   577,     0,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,     0,  1164,
     614,   212,   615,   616,   617,  1165,   619,   620,   772,   621,
       0,   622,   623,   624,   625,  2947,     0,   627,   217,   628,
     629,     0,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,  1167,   225,
       0,     0,  2948,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,  1135,   234,
       0,   669,     0,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,  1169,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   774,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,     0,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    86,    87,    88,   750,    90,    91,    92,   751,
       0,   752,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   753,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   754,   755,     0,     0,     0,   756,   757,     0,     0,
       0,     0,   758,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,   760,     0,   761,   762,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,     0,
       0,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,     0,   448,   449,   450,   135,   136,     0,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
     764,   140,   458,     0,   459,   460,   461,   462,   144,     0,
       0,     0,   463,   464,   465,   466,   467,     0,   468,   765,
       0,   469,   470,   471,   472,   473,   474,     0,     0,   475,
       0,     0,     0,     0,     0,     0,     0,     0,   476,   477,
     478,   479,   767,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,     0,     0,     0,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,   769,
     520,   521,     0,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,     0,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,     0,     0,   536,
       0,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,     0,   545,     0,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     770,   558,   559,   771,   560,   561,   562,   188,     0,   190,
     563,   564,   191,     0,   565,   566,     0,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,     0,   577,     0,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,     0,   613,   614,   212,     0,   616,
     617,   618,   619,   620,   772,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,     0,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,   773,   234,     0,   669,     0,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   774,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,     0,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    86,    87,
      88,     0,    90,    91,    92,     0,     0,     0,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
       0,     0,     0,   107,   108,   109,   110,     0,   111,   112,
     113,   114,   115, -3096,   116,   117,   118,     0,     0,     0,
       0,     0,   121,   122,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,   124,     0,   125,
       0,   126,   127,    35,     0,   427,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
       0,   135,   136,   137,   138,   139,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,     0,     0,
       0,     0,     0,     0,   144,     0,   145,     0,     0,     0,
       0,     0,     0,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   151,     0,     0,     0,     0,     0,
     152,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   156,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   162,     0,     0,
       0,     0,     0,     0,     0,   164,     0,     0,     0,   166,
       0,     0,     0,     0,     0,   168,     0,     0,     0,     0,
       0,   169,     0,   170,     0,     0,     0,     0,     0,   172,
       0,     0,     0,     0,     0,     0,     0,     0,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,     0,     0,     0,     0,     0,   176,     0,
     177,     0,     0,   178,   179,     0,   180,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   181,   182,     0,
     183,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   188,   189,   190,     0,     0,   191,     0,
       0,     0,   193,     0,     0,   194,     0,   195,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   196,   197,     0,   198,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,     0,   201,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     210,     0,     0,   212,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,     0,     0,   219,     0,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,     0,     0,     0,   226,     0,   227,     0,     0,
       0,     0,     0,     0,     0,     0,   230,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,     0,     0,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,   247,     0,     0,     0,     0,     0,     0,   248,     0,
     249,    86,    87,    88,     0,    90,    91,    92,     0,     0,
       0,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     250,   104,   105,     0,     0,   251,   107,   108,   109,   110,
       0,   111,   112,   113,   114,   115, -3097,   116,   117,   118,
       0,     0,     0,     0,     0,   121,   122,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
     124,     0,   125,     0,   126,   127,    35,     0,  1244,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     133,     0,     0,     0,   135,   136,   137,   138,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,     0,     0,     0,     0,     0,     0,   144,     0,   145,
       0,     0,     0,     0,     0,     0,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,   152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     162,     0,     0,     0,     0,     0,     0,     0,   164,     0,
       0,     0,   166,     0,     0,     0,     0,     0,   168,     0,
       0,     0,     0,     0,   169,     0,   170,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,     0,     0,     0,     0,
       0,   176,     0,   177,     0,     0,   178,   179,     0,   180,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     181,   182,     0,   183,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   189,   190,     0,
       0,   191,     0,     0,     0,   193,     0,     0,   194,     0,
     195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   196,   197,     0,   198,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   219,     0,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,     0,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,     0,     0,     0,     0,     0,
       0,   248,     0,   249,    86,    87,    88,     0,    90,    91,
      92,     0,     0,     0,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   250,   104,   105,     0,     0,   251,   107,
     108,   109,   110,     0,   111,   112,   113,   114,   115,     0,
     116,   117,   118,     0,     0,     0,     0,     0,   121,   122,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,   124,     0,   125,     0,   126,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,   135,   136,   137,
     138,   139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   140,     0,     0,     0,     0,     0,     0,
     144,     0,   145,     0,     0,     0,     0,     0,     0,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     151,     0,     0,     0,     0,     0,   152,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,   156,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,     0,     0,
       0,   164,     0,     0,     0,   166,     0,     0,     0,     0,
       0,   168,     0,     0,     0,     0,     0,   169,     0,   170,
       0,     0,     0,     0,     0,   172,     0,     0,     0,     0,
       0,     0,     0,     0,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,     0,
       0,     0,     0,     0,   176,     0,   177,     0,     0,   178,
     179,     0,   180,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   181,   182,     0,   183,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
     189,   190,     0,     0,   191,     0,     0,     0,   193,     0,
       0,   194,     0,   195,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   196,   197,     0,
     198,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,     0,   201,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   210,     0,     0,   212,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,     0,     0,   219,
       0,   220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,   225,     0,     0,
       0,   226,     0,   227,     0,     0,     0,     0,     0,     0,
       0,     0,   230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,     0,     0,
     235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   246,   247,     0,     0,
       0,     0,     0,     0,   248,     0,   249,    86,    87,    88,
       0,    90,    91,    92,     0,     0,     0,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   250,   104,   105,     0,
       0,   251,   107,   108,   109,   110,     0,   111,   112,   113,
     114,   115,     0,   116,   117,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   133,     0,     0,     0,
     135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   140,     0,     0,     0,
       0,     0,     0,   144,     0,   145,     0,     0,     0,     0,
       0,     0,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   151,     0,     0,     0,     0,     0,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
     156,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   162,     0,     0,     0,
       0,     0,     0,     0,   164,     0,     0,     0,   166,     0,
       0,     0,     0,     0,   168,     0,     0,     0,     0,     0,
     169,     0,   170,     0,     0,     0,     0,     0,   172,     0,
       0,     0,     0,     0,     0,     0,     0,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,     0,     0,     0,     0,     0,   176,     0,   177,
       0,     0,   178,   179,     0,   180,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   181,   182,     0,   183,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,   189,   190,     0,     0,   191,     0,     0,
       0,   193,     0,     0,   194,     0,   195,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     196,   197,     0,   198,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,     0,   201,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   210,
       0,     0,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   219,     0,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,     0,     0,     0,   226,     0,   227,     0,     0,     0,
       0,     0,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     234,     0,     0,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   237,
     238,   239,   240,   241,   242,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   246,
     247,     0,     0,     0,     0,     0,     0,   248,     0,   249,
      86,    87,    88,     0,    90,    91,    92,     0,     0,     0,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   250,
     104,   105,     0,     0,   251,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   133,
       0,     0,     0,   135,   136,   137,   138,   139,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   140,
       0,     0,     0,     0,     0,     0,   144,     0,   145,     0,
       0,     0,     0,     0,     0,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   151,     0,     0,     0,
       0,     0,   152,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   155,   156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,     0,     0,
       0,   166,     0,     0,     0,     0,     0,   168,     0,     0,
       0,     0,     0,   169,     0,   170,     0,     0,     0,     0,
       0,   172,     0,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,     0,     0,     0,     0,     0,
     176,     0,   177,     0,     0,   178,   179,     0,   180,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   181,
     182,     0,   183,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   188,   189,   190,     0,     0,
     191,     0,     0,     0,   193,     0,     0,   194,     0,   195,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   196,   197,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,     0,   201,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   210,     0,     0,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,     0,     0,   219,     0,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,     0,     0,     0,   226,     0,   227,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   234,     0,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   237,   238,   239,   240,   241,   242,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,     0,     0,     0,     0,     0,     0,
     248,     0,   249,     0,     0,     0,     0,     0,    35,   432,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,   250,    45,     0,     0,     0,   251,   433,   434,
     435,   436,   437,   438,   439,   440,     0,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,   444,   445,     0,
     446,   447,   133,   448,   449,   450,   135,   136,   137,   138,
     139,     0,   451,   452,   453,   454,   455,     0,     0,   456,
     457,     0,   140,   458,     0,   459,   460,   461,   462,   144,
       0,   145,     0,   463,   464,   465,   466,   467,   148,   468,
       0,     0,   469,   470,   471,   472,   473,   474,     0,   151,
     475,     0,     0,     0,     0,   152,     0,     0,     0,   476,
     477,   478,   479,     0,   480,   155,   156,   481,     0,   482,
       0,   483,   484,   485,   486,   487,     0,   488,   489,   490,
       0,     0,   491,   492,   493,   494,   495,     0,   496,   497,
     498,     0,   499,   500,   501,     0,     0,   502,   503,   504,
     164,   505,   506,   507,   166,  2214,   508,     0,   509,   510,
     168,     0,     0,   511,     0,   512,   169,     0,   170,   513,
     514,   515,     0,   516,   172,     0,   517,     0,   518,   519,
       0,   520,   521,   173,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   174,   175,     0,   532,
     533,   534,     0,   176,     0,   177,     0,   535,   178,   179,
     536,   180,   537,   538,   539,   540,   541,     0,   542,   543,
       0,   544,   181,   182,   545,   183,     0,   546,   547,   548,
       0,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     0,   558,   559,     0,   560,   561,   562,   188,   189,
     190,   563,   564,   191,     0,   565,   566,   193,   567,     0,
     194,   568,   195,   569,   570,   571,     0,   572,  2215,     0,
     573,   574,   575,     0,     0,   576,   196,   197,   577,   198,
     199,   578,   579,   580,   581,     0,   582,   583,     0,   584,
     200,     0,   201,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   203,   596,   597,   598,   599,
       0,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,   611,   612,   210,   613,   614,   212,   615,
     616,   617,   618,   619,   620,     0,   621,     0,   622,   623,
     624,   625,   626,     0,   627,   217,   628,   629,   219,   630,
     220,   631,     0,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   222,     0,   642,   643,     0,   644,   645,
     646,   647,   648,   649,     0,   224,   225,     0,     0,   651,
     226,   652,   227,  2216,   653,   654,   655,   656,     0,   657,
     658,     0,     0,   659,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,     0,   234,     0,   669,   235,
     670,   671,   672,   673,     0,     0,   674,     0,     0,   675,
     676,   677,   678,   679,   680,   237,   238,   239,   240,   241,
     242,   243,   244,   245,     0,   681,   682,   683,   684,   685,
     686,   687,   688,     0,   689,     0,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   246,   247,   699,   700,   701,
     702,   703,   704,   248,   705,   249,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   250,   725,     0,   726,   727,
     251,   728,   729,   730,   731,   732,   733,   734,   735,     0,
       0,     0,    35,     0,     0,     0,     0,  1801,  1802,  5440,
      41,    42,     0,     0,     0,     0,  5441,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,   130,   131,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,   136,   137,   138,   139,     0,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   140,   458,     0,   459,
     460,   461,   462,   144,     0,   145,     0,   463,   464,   465,
     466,   467,   148,   468,     0,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,     0,     0,     0,   152,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   155,
     156,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,   166,     0,
     508,     0,   509,   510,   168,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,   172,     0,
     517,     0,   518,   519,     0,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,     0,   176,     0,   177,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,   181,   182,   545,   183,
       0,   546,   547,   548,     0,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     0,   558,   559,     0,   560,
     561,   562,   188,   189,   190,   563,   564,   191,     0,   565,
     566,   193,   567,     0,   194,   568,   195,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,   199,   578,   579,   580,   581,     0,
     582,   583,     0,   584,   200,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,     0,
     621,   215,   622,   623,   624,   625,   626,     0,   627,   217,
     628,   629,   219,   630,   220,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,     0,   642,
     643,   223,   644,   645,   646,   647,   648,   649,     0,   224,
     225,     0,     0,   651,   226,   652,   227,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,   233,
     234,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,   236,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,     0,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,   248,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,     0,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,  2366,     0,
     252,  2367,     0,     0,  2368,  2369,  2370,  2371,  2372,  2373,
    2374,  2375,     0,  2376,  2377,     0,     0,     0,  2378,     0,
       0,  2379,     0,  2380,  2381,     0,  2382,     0,  2383,  2384,
    2385,  2386,  2387,  2388,  2389,  2390,  2391,     0,  2392,  2393,
    2394,  2395,  2396,     0,     0,     0,  2397,     0,     0,  2398,
       0,  2399,  2400,  2401,  2402,  2403,  2404,     0,     0,  2405,
       0,  2406,  2407,  2408,     0,     0,  2409,     0,  2410,  2411,
       0,  2412,  2413,  2414,     0,     0,  2415,     0,     0,     0,
       0,     0,     0,     0,     0,  2416,  2417,     0,  2418,     0,
    2419,  2420,  2421,  2422,     0,  2423,     0,  2424,  2425,  2426,
    2427,  2428,     0,     0,  2429,     0,     0,     0,     0,  2430,
    2431,  2432,  2433,     0,  2434,  2435,  2436,     0,  2437,  2438,
       0,     0,     0,  2439,  2440,  2441,  2442,  2443,     0,  2444,
    2445,     0,     0,     0,     0,  2446,  2447,     0,     0,  2448,
       0,  2449,  2450,     0,     0,  2451,     0,  2452,     0,  2453,
    2454,     0,  2455,     0,  2456,  2457,     0,     0,  2458,  2459,
    2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,  2469,
       0,     0,     0,  2470,  2471,  2472,  2473,  2474,  2475,  2476,
       0,  2477,     0,  2478,  2479,  2480,  2481,     0,  2482,     0,
    2483,  2484,  2485,     0,     0,     0,     0,     0,  2486,     0,
    2487,  2488,     0,  2489,  2490,  2491,     0,     0,  2492,  2493,
       0,  2494,     0,  2495,  2496,  2497,  2498,     0,  2499,  2500,
       0,  2501,  2502,  2503,  2504,     0,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,     0,  2514,  2515,  2516,  2517,
    2518,     0,     0,  2519,     0,     0,  2520,  2521,  2522,  2523,
       0,     0,  2524,  2525,     0,     0,  2526,  2527,  2528,     0,
    2529,     0,     0,  2530,     0,     0,  2531,     0,  2532,  2533,
    2534,  2535,     0,  2536,  2537,  2538,  2539,     0,  2540,  2541,
    2542,  2543,  2544,  2545,     0,     0,     0,     0,  2546,  2547,
    2548,  2549,  2550,  2551,     0,  2552,  2553,  2554,     0,  2555,
    2556,     0,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,     0,  2566,     0,  2567,     0,  2568,     0,  2569,     0,
    2570,  2571,  2572,  2573,  2574,  2575,  2576,     0,     0,  2577,
       0,  2578,  2579,  2580,  2581,  2582,  2583,  2584,     0,  2585,
       0,  2586,  2587,     0,     0,  2588,  2589,  2590,  2591,     0,
       0,  2592,  2593,     0,     0,  2594,  2595,  2596,  2597,     0,
    2598,  2599,  2600,     0,     0,  2601,  2602,     0,     0,  2603,
    2604,     0,  2605,  2606,     0,     0,  2607,  2608,     0,  2609,
    2610,  2611,  2612,     0,     0,  2613,  2614,  2615,     0,  2616,
       0,     0,     0,     0,     0,     0,     0,  2617,     0,  2618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2619,  2620,  2621,  2622,  2623,  2624,  2625,     0,
       0,     0,     0,  2626,  2627,  2628,     0,  2629,  2630,  2631,
       0,  2632,  2633,  2634,  2635,     0,  2636,     0,  2637,  2638,
    2639,     0,  2640,  2641,  2642,     0,  2643,     0,  2644,  2645,
    2646,  2647,  2648,  2649,  2650,     0,     0,     0,     0,     0,
    2651,  2652,     0,     0,  2653,  2654,  2655,  2656,  2657,  2658,
    2659,  2660,     0,     0,     0,     0,     0,     0,     0,  2661,
    2662,  2663,     0,  2664,  2665,  2666,  2667,  2668,  2669,    35,
     432,     0,     0,    37,    38,    39,    40,    41,    42,    43,
      44,     0,     0,     0,    45,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,     0,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,   133,   448,   449,   450,   135,   136,   137,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,     0,   140,   458,     0,   459,   460,   461,   462,
     144,     0,   145,     0,   463,   464,   465,   466,   467,   148,
     468,     0,     0,   469,   470,   471,   472,   473,   474,     0,
     151,   475,     0,     0,     0,     0,   152,     0,     0,     0,
     476,   477,   478,   479,     0,   480,   155,   156,   481,  2723,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,  2214,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,   169,     0,   170,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,     0,   520,   521,   173,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   174,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,   182,   545,   183,     0,   546,   547,
     548,     0,     0,   549,   550,   551,   552,   553,   554,   555,
     556,   557,     0,   558,   559,     0,   560,   561,   562,   188,
     189,   190,   563,   564,   191,     0,   565,   566,   193,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,  2215,
       0,   573,   574,   575,     0,     0,   576,   196,   197,   577,
     198,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,   210,   613,   614,   212,
     615,   616,   617,   618,   619,   620,     0,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,   219,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,  2216,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,     0,   234,     0,   669,
     235,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,   248,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
       0,     0,     0,     0,     0,     0,    35,   432,  1801,  1802,
      37,    38,    39,    40,    41,    42,    43,    44,     0,     0,
       0,    45,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,     0,   441,   442,   443,     0,     0,
       0,     0,     0,     0,     0,   444,   445,     0,   446,   447,
     133,   448,   449,   450,   135,   136,   137,   138,   139,     0,
     451,   452,   453,   454,   455,     0,     0,   456,   457,     0,
     140,   458,     0,   459,   460,   461,   462,   144,     0,   145,
       0,   463,   464,   465,   466,   467,   148,   468,     0,     0,
     469,   470,   471,   472,   473,   474,     0,   151,   475,     0,
       0,     0,     0,   152,     0,     0,     0,   476,   477,   478,
     479,     0,   480,   155,   156,   481,  2728,   482,     0,   483,
     484,   485,   486,   487,     0,   488,   489,   490,     0,     0,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     499,   500,   501,     0,     0,   502,   503,   504,   164,   505,
     506,   507,   166,  2214,   508,     0,   509,   510,   168,     0,
       0,   511,     0,   512,   169,     0,   170,   513,   514,   515,
       0,   516,   172,     0,   517,     0,   518,   519,     0,   520,
     521,   173,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   174,   175,     0,   532,   533,   534,
       0,   176,     0,   177,     0,   535,   178,   179,   536,   180,
     537,   538,   539,   540,   541,     0,   542,   543,     0,   544,
     181,   182,   545,   183,     0,   546,   547,   548,     0,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     558,   559,     0,   560,   561,   562,   188,   189,   190,   563,
     564,   191,     0,   565,   566,   193,   567,     0,   194,   568,
     195,   569,   570,   571,     0,   572,  2215,     0,   573,   574,
     575,     0,     0,   576,   196,   197,   577,   198,   199,   578,
     579,   580,   581,     0,   582,   583,     0,   584,   200,     0,
     201,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   203,   596,   597,   598,   599,     0,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,   611,   612,   210,   613,   614,   212,   615,   616,   617,
     618,   619,   620,     0,   621,     0,   622,   623,   624,   625,
     626,     0,   627,   217,   628,   629,   219,   630,   220,   631,
       0,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   222,     0,   642,   643,     0,   644,   645,   646,   647,
     648,   649,     0,   224,   225,     0,     0,   651,   226,   652,
     227,  2216,   653,   654,   655,   656,     0,   657,   658,     0,
       0,   659,   660,   661,   662,   663,     0,     0,   664,   665,
     666,   667,   668,     0,   234,     0,   669,   235,   670,   671,
     672,   673,     0,     0,   674,     0,     0,   675,   676,   677,
     678,   679,   680,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,   681,   682,   683,   684,   685,   686,   687,
     688,     0,   689,     0,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   246,   247,   699,   700,   701,   702,   703,
     704,   248,   705,   249,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   250,   725,     0,   726,   727,   251,   728,
     729,   730,   731,   732,   733,   734,   735,     0,     0,     0,
       0,     0,     0,    35,   432,  1801,  1802,    37,    38,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    45,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   140,   458,     0,
     459,   460,   461,   462,   144,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,     0,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,     0,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
    2214,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,     0,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,     0,   558,   559,     0,
     560,   561,   562,   188,   189,   190,   563,   564,   191,     0,
     565,   566,   193,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,  2215,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
       0,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,   219,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,  2216,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
       0,   234,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,     0,     0,     0,     0,     0,     0,
      35,     0,  1801,  1802,    37,    38,    39,    40,    41,    42,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,   133,   448,   449,   450,   135,   136,
     137,   138,   139,     0,   451,   452,   453,   454,   455,     0,
       0,   456,   457,     0,   140,   458,     0,   459,   460,   461,
     462,   144,     0,   145,     0,   463,   464,   465,   466,   467,
     148,   468,     0,     0,   469,   470,   471,   472,   473,   474,
       0,   151,   475,     0,     0,     0,     0,   152,     0,     0,
       0,   476,   477,   478,   479,     0,   480,   155,   156,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,   166,  2214,   508,     0,
     509,   510,   168,     0,     0,   511,     0,   512,   169,     0,
     170,   513,   514,   515,     0,   516,   172,     0,   517,     0,
     518,   519,     0,   520,   521,   173,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   174,   175,
       0,   532,   533,   534,     0,   176,     0,   177,     0,   535,
     178,   179,   536,   180,   537,   538,   539,   540,   541,     0,
     542,   543,     0,   544,   181,   182,   545,   183,     0,   546,
     547,   548,     0,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     0,   558,   559,     0,   560,   561,   562,
     188,   189,   190,   563,   564,   191,     0,   565,   566,   193,
     567,     0,   194,   568,   195,   569,   570,   571,     0,   572,
    2215,     0,   573,   574,   575,     0,     0,   576,   196,   197,
     577,   198,   199,   578,   579,   580,   581,     0,   582,   583,
       0,   584,   200,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   203,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,   210,   613,   614,
     212,   615,   616,   617,   618,   619,   620,     0,   621,     0,
     622,   623,   624,   625,   626,     0,   627,   217,   628,   629,
     219,   630,   220,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   222,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,   224,   225,     0,
       0,   651,   226,   652,   227,  2216,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
       0,     0,   664,   665,   666,   667,   668,     0,   234,     0,
     669,   235,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,   238,   239,
     240,   241,   242,   243,   244,   245,     0,   681,   682,   683,
     684,   685,   686,   687,   688,     0,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   246,   247,   699,
     700,   701,   702,   703,   704,   248,   705,   249,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,    35,   432,     0,     0,    37,    38,    39,    40,    41,
      42,     0,    44,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,   133,   448,   449,   450,   135,
     136,   137,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   140,   458,     0,   459,   460,
     461,   462,   144,     0,   145,     0,   463,   464,   465,   466,
     467,   148,   468,     0,     0,   469,   470,   471,   472,   473,
     474,     0,   151,   475,     0,     0,     0,     0,   152,     0,
       0,     0,   476,   477,   478,   479,     0,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,   169,
       0,   170,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,     0,   520,   521,   173,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   174,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,   182,   545,   183,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,     0,   558,   559,     0,   560,   561,
     562,   188,   189,   190,   563,   564,   191,     0,   565,   566,
     193,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
     197,   577,   198,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,   210,   613,
     614,   212,   615,   616,   617,   618,   619,   620,     0,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,   219,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
     650,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,     0,   234,
       0,   669,   235,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,     0,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,   248,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    35,   432,     0,     0,    37,    38,    39,    40,
      41,    42,     0,    44,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,   136,   137,   138,   139,     0,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   140,   458,     0,   459,
     460,   461,   462,   144,     0,   145,     0,   463,   464,   465,
     466,   467,   148,   468,     0,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,     0,     0,     0,   152,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   155,
     156,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,   166,     0,
     508,     0,   509,   510,   168,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,   172,     0,
     517,     0,   518,   519,     0,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,     0,   176,     0,   177,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,   181,   182,   545,   183,
       0,   546,   547,   548,     0,     0,   549,   550,   551,   552,
     553,   554,   555,   556,   557,     0,   558,   559,     0,   560,
     561,   562,   188,   189,   190,   563,   564,   191,     0,   565,
     566,   193,   567,     0,   194,   568,   195,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,   199,   578,   579,   580,   581,     0,
     582,   583,     0,   584,   200,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,     0,
     621,     0,   622,   623,   624,   625,   626,     0,   627,   217,
     628,   629,   219,   630,   220,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,   224,
     225,     0,     0,   651,   226,   652,   227,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,     0,
     234,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,     0,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,   248,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,    35,     0,     0,     0,    37,    38,    39,
      40,    41,    42,     0,    44,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   140,   458,     0,
     459,   460,   461,   462,   144,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,     0,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,     0,   480,
     155,   156,   481,  2708,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,     0,   520,   521,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,     0,   558,   559,     0,
     560,   561,   562,   188,   189,   190,   563,   564,   191,     0,
     565,   566,   193,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
       0,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,   219,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
       0,   234,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,   135,   136,   137,   138,   139,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   140,   458,
       0,   459,   460,   461,   462,   144,     0,   145,     0,   463,
     464,   465,   466,   467,   148,   468,     0,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,     0,     0,
       0,   152,     0,     0,     0,   476,   477,   478,   479,     0,
     480,   155,   156,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,   164,   505,   506,   507,
     166,     0,   508,     0,   509,   510,   168,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
     172,     0,   517,     0,   518,   519,     0,   520,   521,   173,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   174,   175,     0,   532,   533,   534,     0,   176,
       0,   177,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,   181,   182,
     545,   183,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   558,   559,
       0,   560,   561,   562,   188,   189,   190,   563,   564,   191,
       0,   565,   566,   193,   567,     0,   194,   568,   195,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
       0,   576,   196,   197,   577,   198,   199,   578,   579,   580,
     581,     0,   582,   583,     0,   584,   200,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,   212,   615,   616,   617,   618,   619,
     620,     0,   621,     0,   622,   623,   624,   625,   626,     0,
     627,   217,   628,   629,   219,   630,   220,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   222,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,   224,   225,     0,     0,   651,   226,   652,   227,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,     0,   234,     0,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,   237,   238,   239,   240,   241,   242,   243,   244,   245,
       0,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   246,   247,   699,   700,   701,   702,   703,   704,   248,
     705,   249,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,    35,     0,     0,     0,    37,
      38,    39,    40,    41,    42,     0,    44,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,   135,   136,   137,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,     0,   140,
     458,     0,   459,   460,   461,   462,   144,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,     0,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
       0,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,     0,   520,  2194,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,   551,   552,   553,   554,   555,   556,   557,     0,   558,
     559,     0,   560,   561,   562,   188,   189,   190,   563,   564,
     191,     0,   565,   566,   193,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,   197,   577,   198,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,   212,   615,   616,   617,   618,
     619,   620,     0,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,   219,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,     0,   234,     0,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,     0,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
     248,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   433,   434,   435,   436,
     437,   438,   439,   440,     0,   441,   442,   443,     0,     0,
       0,     0,     0,     0,     0,   444,   445,     0,   446,   447,
     133,   448,   449,   450,   135,   136,   137,   138,   139,     0,
     451,   452,   453,   454,   455,     0,     0,   456,   457,     0,
     140,   458,     0,   459,   460,   461,   462,   144,     0,   145,
       0,   463,   464,   465,   466,   467,   148,   468,     0,     0,
     469,   470,   471,   472,   473,   474,     0,   151,   475,     0,
       0,     0,     0,   152,     0,     0,  3082,   476,   477,   478,
     479,     0,   480,   155,   156,   481,     0,   482,     0,   483,
     484,   485,   486,   487,     0,   488,   489,   490,     0,     0,
     491,   492,   493,   494,   495,     0,   496,   497,   498,     0,
     499,   500,   501,     0,     0,   502,   503,   504,   164,   505,
     506,   507,   166,     0,   508,     0,   509,   510,   168,     0,
       0,   511,     0,   512,   169,     0,   170,   513,   514,   515,
       0,   516,   172,     0,   517,     0,   518,   519,     0,   520,
     521,   173,   522,   523,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   531,   174,   175,     0,   532,   533,   534,
       0,   176,     0,   177,     0,   535,   178,   179,   536,   180,
     537,   538,   539,   540,   541,     0,   542,   543,     0,   544,
     181,   182,   545,   183,     0,   546,   547,   548,     0,     0,
     549,   550,   551,   552,   553,   554,   555,   556,   557,     0,
     558,   559,     0,   560,   561,   562,   188,   189,   190,   563,
     564,   191,     0,   565,   566,   193,   567,     0,   194,   568,
     195,   569,   570,   571,     0,   572,     0,     0,   573,   574,
     575,     0,     0,   576,   196,   197,   577,   198,   199,   578,
     579,   580,   581,     0,   582,   583,     0,   584,   200,     0,
     201,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   203,   596,   597,   598,   599,     0,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
       0,   611,   612,   210,   613,   614,   212,   615,   616,   617,
     618,   619,   620,     0,   621,     0,   622,   623,   624,   625,
     626,     0,   627,   217,   628,   629,   219,   630,   220,   631,
       0,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   222,     0,   642,   643,     0,   644,   645,   646,   647,
     648,   649,     0,   224,   225,     0,     0,   651,   226,   652,
     227,     0,   653,   654,   655,   656,     0,   657,   658,     0,
       0,   659,   660,   661,   662,   663,  3083,     0,   664,   665,
     666,   667,   668,     0,   234,     0,   669,   235,   670,   671,
     672,   673,     0,     0,   674,     0,     0,   675,   676,   677,
     678,   679,   680,   237,   238,   239,   240,   241,   242,   243,
     244,   245,     0,   681,   682,   683,   684,   685,   686,   687,
     688,     0,   689,     0,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   246,   247,   699,   700,   701,   702,   703,
     704,   248,   705,   249,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   250,   725,     0,   726,   727,   251,   728,
     729,   730,   731,   732,   733,   734,   735,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   433,   434,   435,
     436,   437,   438,   439,   440,     0,   441,   442,   443,   130,
     131,     0,     0,     0,     0,     0,   444,   445,     0,   446,
     447,   133,   448,   449,   450,   135,   136,   137,   138,   139,
       0,   451,   452,   453,   454,   455,     0,     0,   456,   457,
       0,   140,   458,     0,   459,   460,   461,   462,   144,     0,
     145,     0,   463,   464,   465,   466,   467,   148,   468,     0,
       0,   469,   470,   471,   472,   473,   474,     0,   151,   475,
       0,     0,     0,     0,   152,     0,     0,     0,   476,   477,
     478,   479,     0,   480,   155,   156,   481,     0,   482,     0,
     483,   484,   485,   486,   487,     0,   488,   489,   490,     0,
       0,   491,   492,   493,   494,   495,     0,   496,   497,   498,
       0,   499,   500,   501,     0,     0,   502,   503,   504,   164,
     505,   506,   507,   166,     0,   508,     0,   509,   510,   168,
       0,     0,   511,     0,   512,   169,     0,   170,   513,   514,
     515,     0,   516,   172,     0,   517,     0,   518,   519,     0,
     520,   521,   173,   522,   523,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   531,   174,   175,     0,   532,   533,
     534,     0,   176,     0,   177,     0,   535,   178,   179,   536,
     180,   537,   538,   539,   540,   541,     0,   542,   543,     0,
     544,   181,   182,   545,   183,     0,   546,   547,   548,     0,
       0,   549,   550,   551,   552,   553,   554,   555,   556,   557,
       0,   558,   559,     0,   560,   561,   562,   188,   189,   190,
     563,   564,   191,     0,   565,   566,   193,   567,     0,   194,
     568,   195,   569,   570,   571,     0,   572,     0,     0,   573,
     574,   575,     0,     0,   576,   196,   197,   577,   198,   199,
     578,   579,   580,   581,     0,   582,   583,     0,   584,   200,
       0,   201,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   203,   596,   597,   598,   599,     0,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,     0,   611,   612,   210,   613,   614,   212,   615,   616,
     617,   618,   619,   620,     0,   621,     0,   622,   623,   624,
     625,   626,     0,   627,   217,   628,   629,   219,   630,   220,
     631,     0,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   222,     0,   642,   643,     0,   644,   645,   646,
     647,   648,   649,     0,   224,   225,     0,     0,   651,   226,
     652,   227,     0,   653,   654,   655,   656,     0,   657,   658,
       0,     0,   659,   660,   661,   662,   663,     0,     0,   664,
     665,   666,   667,   668,     0,   234,     0,   669,   235,   670,
     671,   672,   673,     0,     0,   674,     0,     0,   675,   676,
     677,   678,   679,   680,   237,   238,   239,   240,   241,   242,
     243,   244,   245,     0,   681,   682,   683,   684,   685,   686,
     687,   688,     0,   689,     0,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   246,   247,   699,   700,   701,   702,
     703,   704,   248,   705,   249,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   250,   725,     0,   726,   727,   251,
     728,   729,   730,   731,   732,   733,   734,   735,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   433,   434,
     435,   436,   437,   438,   439,   440,  1322,   441,   442,   443,
       0,     0,     0,     0,     0,     0,     0,   444,   445,     0,
     446,   447,   133,   448,   449,   450,   135,   136,   137,   138,
     139,     0,   451,   452,   453,   454,   455,     0,     0,   456,
     457,     0,   140,   458,     0,   459,   460,   461,   462,   144,
       0,   145,     0,   463,   464,   465,   466,   467,   148,   468,
       0,     0,   469,   470,   471,   472,   473,   474,     0,   151,
     475,     0,     0,     0,     0,   152,     0,     0,     0,   476,
     477,   478,   479,     0,   480,   155,   156,   481,     0,   482,
       0,   483,   484,   485,   486,   487,     0,   488,   489,   490,
       0,     0,   491,   492,   493,   494,   495,     0,   496,   497,
     498,     0,   499,   500,   501,     0,     0,   502,   503,   504,
     164,   505,   506,   507,   166,     0,   508,     0,   509,   510,
     168,     0,     0,   511,     0,   512,   169,     0,   170,   513,
     514,   515,     0,   516,   172,     0,   517,     0,   518,   519,
       0,   520,   521,   173,   522,   523,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   531,   174,   175,     0,   532,
     533,   534,     0,   176,     0,   177,     0,   535,   178,   179,
     536,   180,   537,   538,   539,   540,   541,     0,   542,   543,
       0,   544,   181,   182,   545,   183,     0,   546,   547,   548,
       0,     0,   549,   550,   551,   552,   553,   554,   555,   556,
     557,     0,   558,   559,     0,   560,   561,   562,   188,   189,
     190,   563,   564,   191,     0,   565,   566,   193,   567,     0,
     194,   568,   195,   569,   570,   571,     0,   572,     0,     0,
     573,   574,   575,     0,     0,   576,   196,   197,   577,   198,
     199,   578,   579,   580,   581,     0,   582,   583,     0,   584,
     200,     0,   201,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   203,   596,   597,   598,   599,
       0,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,     0,   611,   612,   210,   613,   614,   212,   615,
     616,   617,   618,   619,   620,     0,   621,     0,   622,   623,
     624,   625,   626,     0,   627,   217,   628,   629,   219,   630,
     220,   631,     0,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   222,     0,   642,   643,     0,   644,   645,
     646,   647,   648,   649,     0,   224,   225,     0,     0,   651,
     226,   652,   227,     0,   653,   654,   655,   656,     0,   657,
     658,     0,     0,   659,   660,   661,   662,   663,     0,     0,
     664,   665,   666,   667,   668,     0,   234,     0,   669,   235,
     670,   671,   672,   673,     0,     0,   674,     0,     0,   675,
     676,   677,   678,   679,   680,   237,   238,   239,   240,   241,
     242,   243,   244,   245,     0,   681,   682,   683,   684,   685,
     686,   687,   688,     0,   689,     0,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   246,   247,   699,   700,   701,
     702,   703,   704,   248,   705,   249,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   250,   725,     0,   726,   727,
     251,   728,   729,   730,   731,   732,   733,   734,   735,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   433,
     434,   435,   436,   437,   438,   439,   440,  1338,   441,   442,
     443,     0,     0,     0,     0,     0,     0,     0,   444,   445,
       0,   446,   447,   133,   448,   449,   450,   135,   136,   137,
     138,   139,     0,   451,   452,   453,   454,   455,     0,     0,
     456,   457,     0,   140,   458,     0,   459,   460,   461,   462,
     144,     0,   145,     0,   463,   464,   465,   466,   467,   148,
     468,     0,     0,   469,   470,   471,   472,   473,   474,     0,
     151,   475,     0,     0,     0,     0,   152,     0,     0,     0,
     476,   477,   478,   479,     0,   480,   155,   156,   481,     0,
     482,     0,   483,   484,   485,   486,   487,     0,   488,   489,
     490,     0,     0,   491,   492,   493,   494,   495,     0,   496,
     497,   498,     0,   499,   500,   501,     0,     0,   502,   503,
     504,   164,   505,   506,   507,   166,     0,   508,     0,   509,
     510,   168,     0,     0,   511,     0,   512,   169,     0,   170,
     513,   514,   515,     0,   516,   172,     0,   517,     0,   518,
     519,     0,   520,   521,   173,   522,   523,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   531,   174,   175,     0,
     532,   533,   534,     0,   176,     0,   177,     0,   535,   178,
     179,   536,   180,   537,   538,   539,   540,   541,     0,   542,
     543,     0,   544,   181,   182,   545,   183,     0,   546,   547,
     548,     0,     0,   549,   550,  1339,   552,   553,   554,   555,
     556,   557,     0,   558,   559,     0,   560,   561,   562,   188,
     189,   190,   563,   564,   191,     0,   565,   566,   193,   567,
       0,   194,   568,   195,   569,   570,   571,     0,   572,     0,
       0,   573,   574,   575,     0,     0,   576,   196,   197,   577,
     198,   199,   578,   579,   580,   581,     0,   582,   583,     0,
     584,   200,     0,   201,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   203,   596,   597,   598,
     599,     0,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,     0,   611,   612,   210,   613,   614,   212,
     615,   616,   617,   618,   619,   620,     0,   621,     0,   622,
     623,   624,   625,   626,     0,   627,   217,   628,   629,   219,
     630,   220,   631,     0,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   222,     0,   642,   643,     0,   644,
     645,   646,   647,   648,   649,     0,   224,   225,     0,     0,
     651,   226,   652,   227,     0,   653,   654,   655,   656,     0,
     657,   658,     0,     0,   659,   660,   661,   662,   663,     0,
       0,   664,   665,   666,   667,   668,     0,   234,     0,   669,
     235,   670,   671,   672,   673,     0,     0,   674,     0,     0,
     675,   676,   677,   678,   679,   680,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,   681,   682,   683,   684,
     685,   686,   687,   688,     0,   689,     0,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   246,   247,   699,   700,
     701,   702,   703,   704,   248,   705,   249,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   250,   725,     0,   726,
     727,   251,   728,   729,   730,   731,   732,   733,   734,   735,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,   434,   435,   436,   437,   438,   439,   440,     0,   441,
     442,   443,     0,     0,     0,     0,     0,     0,     0,   444,
     445,     0,   446,   447,   133,   448,   449,   450,   135,   136,
     137,   138,   139,     0,   451,   452,   453,   454,   455,     0,
       0,   456,   457,     0,   140,   458,     0,   459,   460,   461,
     462,   144,     0,   145,     0,   463,   464,   465,   466,   467,
     148,   468,     0,     0,   469,   470,   471,   472,   473,   474,
       0,   151,   475,     0,     0,     0,     0,   152,     0,     0,
       0,   476,   477,   478,   479,     0,   480,   155,   156,   481,
       0,   482,     0,   483,   484,   485,   486,   487,     0,   488,
     489,   490,     0,     0,   491,   492,   493,   494,   495,     0,
     496,   497,   498,     0,   499,   500,   501,     0,     0,   502,
     503,   504,   164,   505,   506,   507,   166,     0,   508,     0,
     509,   510,   168,     0,     0,   511,     0,   512,   169,     0,
     170,   513,   514,   515,     0,   516,   172,  4069,   517,     0,
     518,   519,     0,   520,   521,   173,   522,   523,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   531,   174,   175,
       0,   532,   533,   534,     0,   176,     0,   177,     0,   535,
     178,   179,   536,   180,   537,   538,   539,   540,   541,     0,
     542,   543,     0,   544,   181,   182,   545,   183,     0,   546,
     547,   548,     0,     0,   549,   550,   551,   552,   553,   554,
     555,   556,   557,     0,   558,   559,     0,   560,   561,   562,
     188,   189,   190,   563,   564,   191,     0,   565,   566,   193,
     567,     0,   194,   568,   195,   569,   570,   571,     0,   572,
       0,     0,   573,   574,   575,     0,     0,   576,   196,   197,
     577,   198,   199,   578,   579,   580,   581,     0,   582,   583,
       0,   584,   200,     0,   201,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   203,   596,   597,
     598,   599,     0,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,     0,   611,   612,   210,   613,   614,
     212,   615,   616,   617,   618,   619,   620,     0,   621,     0,
     622,   623,   624,   625,   626,     0,   627,   217,   628,   629,
     219,   630,   220,   631,     0,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   222,     0,   642,   643,     0,
     644,   645,   646,   647,   648,   649,     0,   224,   225,     0,
       0,   651,   226,   652,   227,     0,   653,   654,   655,   656,
       0,   657,   658,     0,     0,   659,   660,   661,   662,   663,
       0,     0,   664,   665,   666,   667,   668,     0,   234,     0,
     669,   235,   670,   671,   672,   673,     0,     0,   674,     0,
       0,   675,   676,   677,   678,   679,   680,   237,   238,   239,
     240,   241,   242,   243,   244,   245,     0,   681,   682,   683,
     684,   685,   686,   687,   688,     0,   689,     0,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   246,   247,   699,
     700,   701,   702,   703,   704,   248,   705,   249,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   250,   725,     0,
     726,   727,   251,   728,   729,   730,   731,   732,   733,   734,
     735,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   433,   434,   435,   436,   437,   438,   439,   440,     0,
     441,   442,   443,     0,     0,     0,     0,     0,     0,     0,
     444,   445,     0,   446,   447,   133,   448,   449,   450,   135,
     136,   137,   138,   139,     0,   451,   452,   453,   454,   455,
       0,     0,   456,   457,     0,   140,   458,     0,   459,   460,
     461,   462,   144,     0,   145,     0,   463,   464,   465,   466,
     467,   148,   468,     0,     0,   469,   470,   471,   472,   473,
     474,     0,   151,   475,     0,     0,     0,     0,   152,     0,
       0,     0,   476,   477,   478,   479,     0,   480,   155,   156,
     481,     0,   482,     0,   483,   484,   485,   486,   487,     0,
     488,   489,   490,     0,     0,   491,   492,   493,   494,   495,
       0,   496,   497,   498,     0,   499,   500,   501,     0,     0,
     502,   503,   504,   164,   505,   506,   507,   166,     0,   508,
       0,   509,   510,   168,     0,     0,   511,     0,   512,   169,
       0,   170,   513,   514,   515,     0,   516,   172,     0,   517,
       0,   518,   519,     0,   520,   521,   173,   522,   523,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   531,   174,
     175,     0,   532,   533,   534,     0,   176,     0,   177,     0,
     535,   178,   179,   536,   180,   537,   538,   539,   540,   541,
       0,   542,   543,     0,   544,   181,   182,   545,   183,     0,
     546,   547,   548,     0,     0,   549,   550,   551,   552,   553,
     554,   555,   556,   557,     0,   558,   559,     0,   560,   561,
     562,   188,   189,   190,   563,   564,   191,     0,   565,   566,
     193,   567,     0,   194,   568,   195,   569,   570,   571,     0,
     572,     0,     0,   573,   574,   575,     0,     0,   576,   196,
     197,   577,   198,   199,   578,   579,   580,   581,     0,   582,
     583,     0,   584,   200,     0,   201,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   203,   596,
     597,   598,   599,     0,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,     0,   611,   612,   210,   613,
     614,   212,   615,   616,   617,   618,   619,   620,     0,   621,
       0,   622,   623,   624,   625,   626,     0,   627,   217,   628,
     629,   219,   630,   220,   631,     0,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   222,     0,   642,   643,
       0,   644,   645,   646,   647,   648,   649,     0,   224,   225,
       0,     0,   651,   226,   652,   227,     0,   653,   654,   655,
     656,     0,   657,   658,     0,     0,   659,   660,   661,   662,
     663,     0,     0,   664,   665,   666,   667,   668,     0,   234,
       0,   669,   235,   670,   671,   672,   673,     0,     0,   674,
       0,     0,   675,   676,   677,   678,   679,   680,   237,   238,
     239,   240,   241,   242,   243,   244,   245,     0,   681,   682,
     683,   684,   685,   686,   687,   688,     0,   689,     0,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   246,   247,
     699,   700,   701,   702,   703,   704,   248,   705,   249,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   250,   725,
       0,   726,   727,   251,   728,   729,   730,   731,   732,   733,
     734,   735,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   433,   434,   435,   436,   437,   438,   439,   440,
       0,   441,   442,   443,     0,     0,     0,     0,     0,     0,
       0,   444,   445,     0,   446,   447,   133,   448,   449,   450,
     135,   136,   137,   138,   139,     0,   451,   452,   453,   454,
     455,     0,     0,   456,   457,     0,   140,   458,     0,   459,
     460,   461,   462,   144,     0,   145,     0,   463,   464,   465,
     466,   467,   148,   468,     0,     0,   469,   470,   471,   472,
     473,   474,     0,   151,   475,     0,     0,     0,     0,   152,
       0,     0,     0,   476,   477,   478,   479,     0,   480,   155,
     156,   481,     0,   482,     0,   483,   484,   485,   486,   487,
       0,   488,   489,   490,     0,     0,   491,   492,   493,   494,
     495,     0,   496,   497,   498,     0,   499,   500,   501,     0,
       0,   502,   503,   504,   164,   505,   506,   507,   166,     0,
     508,     0,   509,   510,   168,     0,     0,   511,     0,   512,
     169,     0,   170,   513,   514,   515,     0,   516,   172,     0,
     517,     0,   518,   519,     0,   520,   521,   173,   522,   523,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   531,
     174,   175,     0,   532,   533,   534,     0,   176,     0,   177,
       0,   535,   178,   179,   536,   180,   537,   538,   539,   540,
     541,     0,   542,   543,     0,   544,   181,   182,   545,   183,
       0,   546,   547,   548,     0,     0,   549,   550,  1421,   552,
     553,   554,   555,   556,   557,     0,   558,   559,     0,   560,
     561,   562,   188,   189,   190,   563,   564,   191,     0,   565,
     566,   193,   567,     0,   194,   568,   195,   569,   570,   571,
       0,   572,     0,     0,   573,   574,   575,     0,     0,   576,
     196,   197,   577,   198,   199,   578,   579,   580,   581,     0,
     582,   583,     0,   584,   200,     0,   201,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   203,
     596,   597,   598,   599,     0,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,     0,   611,   612,   210,
     613,   614,   212,   615,   616,   617,   618,   619,   620,     0,
     621,     0,   622,   623,   624,   625,   626,     0,   627,   217,
     628,   629,   219,   630,   220,   631,     0,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   222,     0,   642,
     643,     0,   644,   645,   646,   647,   648,   649,     0,   224,
     225,     0,     0,   651,   226,   652,   227,     0,   653,   654,
     655,   656,     0,   657,   658,     0,     0,   659,   660,   661,
     662,   663,     0,     0,   664,   665,   666,   667,   668,     0,
     234,     0,   669,   235,   670,   671,   672,   673,     0,     0,
     674,     0,     0,   675,   676,   677,   678,   679,   680,   237,
     238,   239,   240,   241,   242,   243,   244,   245,     0,   681,
     682,   683,   684,   685,   686,   687,   688,     0,   689,     0,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   246,
     247,   699,   700,   701,   702,   703,   704,   248,   705,   249,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   250,
     725,     0,   726,   727,   251,   728,   729,   730,   731,   732,
     733,   734,   735,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   433,   434,   435,   436,   437,   438,   439,
     440,     0,   441,   442,   443,     0,     0,     0,     0,     0,
       0,     0,   444,   445,     0,   446,   447,   133,   448,   449,
     450,   135,   136,   137,   138,   139,     0,   451,   452,   453,
     454,   455,     0,     0,   456,   457,     0,   140,   458,     0,
     459,   460,   461,   462,   144,     0,   145,     0,   463,   464,
     465,   466,   467,   148,   468,     0,     0,   469,   470,   471,
     472,   473,   474,     0,   151,   475,     0,     0,     0,     0,
     152,     0,     0,     0,   476,   477,   478,   479,     0,   480,
     155,   156,   481,     0,   482,     0,   483,   484,   485,   486,
     487,     0,   488,   489,   490,     0,     0,   491,   492,   493,
     494,   495,     0,   496,   497,   498,     0,   499,   500,   501,
       0,     0,   502,   503,   504,   164,   505,   506,   507,   166,
       0,   508,     0,   509,   510,   168,     0,     0,   511,     0,
     512,   169,     0,   170,   513,   514,   515,     0,   516,   172,
       0,   517,     0,   518,   519,     0,   520,  1466,   173,   522,
     523,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     531,   174,   175,     0,   532,   533,   534,     0,   176,     0,
     177,     0,   535,   178,   179,   536,   180,   537,   538,   539,
     540,   541,     0,   542,   543,     0,   544,   181,   182,   545,
     183,     0,   546,   547,   548,     0,     0,   549,   550,   551,
     552,   553,   554,   555,   556,   557,     0,   558,   559,     0,
     560,   561,   562,   188,   189,   190,   563,   564,   191,     0,
     565,   566,   193,   567,     0,   194,   568,   195,   569,   570,
     571,     0,   572,     0,     0,   573,   574,   575,     0,     0,
     576,   196,   197,   577,   198,   199,   578,   579,   580,   581,
       0,   582,   583,     0,   584,   200,     0,   201,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     203,   596,   597,   598,   599,     0,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,     0,   611,   612,
     210,   613,   614,   212,   615,   616,   617,   618,   619,   620,
       0,   621,     0,   622,   623,   624,   625,   626,     0,   627,
     217,   628,   629,   219,   630,   220,   631,     0,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   222,     0,
     642,   643,     0,   644,   645,   646,   647,   648,   649,     0,
     224,   225,     0,     0,   651,   226,   652,   227,     0,   653,
     654,   655,   656,     0,   657,   658,     0,     0,   659,   660,
     661,   662,   663,     0,     0,   664,   665,   666,   667,   668,
       0,   234,     0,   669,   235,   670,   671,   672,   673,     0,
       0,   674,     0,     0,   675,   676,   677,   678,   679,   680,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     681,   682,   683,   684,   685,   686,   687,   688,     0,   689,
       0,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     246,   247,   699,   700,   701,   702,   703,   704,   248,   705,
     249,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     250,   725,     0,   726,   727,   251,   728,   729,   730,   731,
     732,   733,   734,   735,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   433,   434,   435,   436,   437,   438,
     439,   440,     0,   441,   442,   443,     0,     0,     0,     0,
       0,     0,     0,   444,   445,     0,   446,   447,   133,   448,
     449,   450,   135,   136,   137,   138,   139,     0,   451,   452,
     453,   454,   455,     0,     0,   456,   457,     0,   140,   458,
       0,   459,   460,   461,   462,   144,     0,   145,     0,   463,
     464,   465,   466,   467,   148,   468,     0,     0,   469,   470,
     471,   472,   473,   474,     0,   151,   475,     0,     0,     0,
       0,   152,     0,     0,     0,   476,   477,   478,   479,     0,
     480,   155,   156,   481,     0,   482,     0,   483,   484,   485,
     486,   487,     0,   488,   489,   490,     0,     0,   491,   492,
     493,   494,   495,     0,   496,   497,   498,     0,   499,   500,
     501,     0,     0,   502,   503,   504,   164,   505,   506,   507,
     166,     0,   508,     0,   509,   510,   168,     0,     0,   511,
       0,   512,   169,     0,   170,   513,   514,   515,     0,   516,
     172,     0,   517,     0,   518,   519,     0,   520,  1476,   173,
     522,   523,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   531,   174,   175,     0,   532,   533,   534,     0,   176,
       0,   177,     0,   535,   178,   179,   536,   180,   537,   538,
     539,   540,   541,     0,   542,   543,     0,   544,   181,   182,
     545,   183,     0,   546,   547,   548,     0,     0,   549,   550,
     551,   552,   553,   554,   555,   556,   557,     0,   558,   559,
       0,   560,   561,   562,   188,   189,   190,   563,   564,   191,
       0,   565,   566,   193,   567,     0,   194,   568,   195,   569,
     570,   571,     0,   572,     0,     0,   573,   574,   575,     0,
       0,   576,   196,   197,   577,   198,   199,   578,   579,   580,
     581,     0,   582,   583,     0,   584,   200,     0,   201,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   203,   596,   597,   598,   599,     0,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,     0,   611,
     612,   210,   613,   614,   212,   615,   616,   617,   618,   619,
     620,     0,   621,     0,   622,   623,   624,   625,   626,     0,
     627,   217,   628,   629,   219,   630,   220,   631,     0,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   222,
       0,   642,   643,     0,   644,   645,   646,   647,   648,   649,
       0,   224,   225,     0,     0,   651,   226,   652,   227,     0,
     653,   654,   655,   656,     0,   657,   658,     0,     0,   659,
     660,   661,   662,   663,     0,     0,   664,   665,   666,   667,
     668,     0,   234,     0,   669,   235,   670,   671,   672,   673,
       0,     0,   674,     0,     0,   675,   676,   677,   678,   679,
     680,   237,   238,   239,   240,   241,   242,   243,   244,   245,
       0,   681,   682,   683,   684,   685,   686,   687,   688,     0,
     689,     0,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   246,   247,   699,   700,   701,   702,   703,   704,   248,
     705,   249,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   250,   725,     0,   726,   727,   251,   728,   729,   730,
     731,   732,   733,   734,   735,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   433,   434,   435,   436,   437,
     438,   439,   440,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,     0,   444,   445,     0,   446,   447,   133,
     448,   449,   450,   135,   136,   137,   138,   139,     0,   451,
     452,   453,   454,   455,     0,     0,   456,   457,     0,   140,
     458,     0,   459,   460,   461,   462,   144,     0,   145,     0,
     463,   464,   465,   466,   467,   148,   468,     0,     0,   469,
     470,   471,   472,   473,   474,     0,   151,   475,     0,     0,
       0,     0,   152,     0,     0,     0,   476,   477,   478,   479,
       0,   480,   155,   156,   481,     0,   482,     0,   483,   484,
     485,   486,   487,     0,   488,   489,   490,     0,     0,   491,
     492,   493,   494,   495,     0,   496,   497,   498,     0,   499,
     500,   501,     0,     0,   502,   503,   504,   164,   505,   506,
     507,   166,     0,   508,     0,   509,   510,   168,     0,     0,
     511,     0,   512,   169,     0,   170,   513,   514,   515,     0,
     516,   172,     0,   517,     0,   518,   519,     0,   520,  1487,
     173,   522,   523,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   531,   174,   175,     0,   532,   533,   534,     0,
     176,     0,   177,     0,   535,   178,   179,   536,   180,   537,
     538,   539,   540,   541,     0,   542,   543,     0,   544,   181,
     182,   545,   183,     0,   546,   547,   548,     0,     0,   549,
     550,  1488,   552,   553,   554,   555,   556,   557,     0,   558,
     559,     0,   560,   561,   562,   188,   189,   190,   563,   564,
     191,     0,   565,   566,   193,   567,     0,   194,   568,   195,
     569,   570,   571,     0,   572,     0,     0,   573,   574,   575,
       0,     0,   576,   196,   197,   577,   198,   199,   578,   579,
     580,   581,     0,   582,   583,     0,   584,   200,     0,   201,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   203,   596,   597,   598,   599,     0,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,     0,
     611,   612,   210,   613,   614,   212,   615,   616,   617,   618,
     619,   620,     0,   621,     0,   622,   623,   624,   625,   626,
       0,   627,   217,   628,   629,   219,   630,   220,   631,     0,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     222,     0,   642,   643,     0,   644,   645,   646,   647,   648,
     649,     0,   224,   225,     0,     0,   651,   226,   652,   227,
       0,   653,   654,   655,   656,     0,   657,   658,     0,     0,
     659,   660,   661,   662,   663,     0,     0,   664,   665,   666,
     667,   668,     0,   234,     0,   669,   235,   670,   671,   672,
     673,     0,     0,   674,     0,     0,   675,   676,   677,   678,
     679,   680,   237,   238,   239,   240,   241,   242,   243,   244,
     245,     0,   681,   682,   683,   684,   685,   686,   687,   688,
       0,   689,     0,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   246,   247,   699,   700,   701,   702,   703,   704,
     248,   705,   249,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   250,   725,     0,   726,   727,   251,   728,   729,
     730,   731,   732,   733,   734,   735,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2368,  2369,  2370,  2371,
       0,  2373,  2374,  2375,     0,  2376,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2380,  2381,     0,     0,     0,
    2383,  2384,  2385,  2386,     0,  2388,  2389,  2390,  2391,     0,
    2392,  2393,  2394,  2395,  2396,     0,     0,     0,  2397,     0,
       0,  2398,     0,  2399,  2400,  2401,  2402,  2403,     0,     0,
       0,  2405,     0,  2406,  2407,  2408,     0,     0,  2409,     0,
    2410,  2411,     0,  2412,  2413,  2414,     0,     0,  2415,     0,
       0,     0,     0,     0,     0,     0,     0,  2416,  2417,     0,
    2418,     0,  2419,  2420,  2421,  2422,     0,  2423,     0,  2424,
    2425,  2426,  2427,  2428,     0,     0,  2429,     0,     0,     0,
       0,  2430,  2431,  2432,  2433,     0,  2434,  2435,  2436,  3709,
    2437,  2438,     0,     0,     0,  2439,  2440,  2441,  2442,  2443,
       0,  2444,  2445,     0,     0,     0,     0,  2446,  2447,     0,
    3710,  2448,     0,  2449,  2450,     0,     0,  2451,     0,  2452,
       0,  2453,  2454,     0,  2455,     0,  2456,  2457,     0,     0,
    2458,     0,  2460,  2461,  2462,     0,  2464,  2465,  2466,  2467,
    2468,  2469,     0,     0,     0,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,     0,  2477,     0,  2478,     0,     0,  2481,     0,
    2482,     0,  2483,  2484,  2485,     0,     0,     0,     0,     0,
    2486,     0,  2487,     0,     0,  2489,  2490,  2491,     0,     0,
    2492,  2493,     0,  2494,     0,  2495,  2496,  2497,  2498,     0,
    2499,  2500,     0,  2501,  2502,  2503,  2504,     0,  2505,  2506,
    2507,  2508,     0,  2510,  2511,     0,  2513,     0,  2514,  2515,
    2516,  2517,  2518,     0,     0,  2519,     0,     0,  3711,  2521,
    2522,     0,     0,     0,  2524,  2525,     0,     0,  2526,  2527,
    2528,     0,  2529,     0,     0,  2530,     0,     0,  2531,     0,
    2532,  2533,  2534,  2535,     0,  2536,  2537,  2538,  2539,     0,
    2540,  2541,  2542,  2543,  2544,  2545,     0,     0,     0,     0,
    2546,  2547,  2548,  2549,  2550,  2551,     0,  2552,  2553,  2554,
       0,  2555,  2556,     0,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,     0,  2566,     0,  2567,     0,  2568,     0,
    2569,     0,  2570,  2571,  2572,  2573,     0,  2575,  2576,     0,
       0,  2577,     0,  3712,  2579,  2580,  2581,  2582,  2583,  2584,
       0,  2585,     0,  2586,  2587,     0,     0,     0,  2589,  2590,
    2591,     0,     0,  2592,  2593,     0,     0,  2594,  2595,  2596,
    2597,     0,  2598,  2599,  2600,     0,     0,  2601,  2602,     0,
       0,  2603,  2604,     0,  2605,  2606,     0,     0,  2607,  2608,
       0,  2609,  2610,  3713,  2612,     0,     0,  2613,  2614,  2615,
       0,  2616,     0,     0,     0,     0,     0,     0,     0,  2617,
       0,  2618,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2619,  2620,  2621,  2622,  2623,  2624,
    2625,     0,     0,     0,     0,  2626,  2627,  2628,     0,  2629,
    2630,  2631,     0,  2632,  2633,  2634,  2635,     0,  2636,     0,
    2637,  2638,  2639,     0,  2640,  2641,  2642,     0,  2643,     0,
    2644,  2645,  2646,  2647,  2648,  2649,  2650,     0,     0,     0,
       0,     0,  2651,  2652,     0,     0,  2653,  2654,  2655,  2656,
    2657,  2658,  2659,  2660,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2368,  2369,  2370,  2371,     0,  2373,
    2374,  2375,     0,  2376,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2380,  2381,     0,     0,     0,  2383,  2384,
    2385,  2386,     0,  2388,  2389,  2390,  2391,     0,  2392,  2393,
    2394,  2395,  2396,     0,     0,     0,  2397,     0,     0,  2398,
       0,  2399,  2400,  2401,  2402,  2403,     0,     0,     0,  2405,
       0,  2406,  2407,  2408,     0,     0,  2409,     0,  2410,  2411,
       0,  2412,  2413,  2414,     0,     0,  2415,     0,     0,     0,
       0,     0,     0,     0,     0,  2416,  2417,     0,  2418,     0,
    2419,  2420,  2421,  2422,     0,  2423,     0,  2424,  2425,  2426,
    2427,  2428,     0,     0,  2429,     0,     0,     0,     0,  2430,
    2431,  2432,  2433,     0,  2434,  2435,  2436,     0,  2437,  2438,
       0,     0,     0,  2439,  2440,  2441,  2442,  2443,     0,  2444,
    2445,     0,     0,     0,     0,  2446,  2447,     0,  3710,  2448,
       0,  2449,  2450,     0,     0,  2451,     0,  2452,     0,  2453,
    2454,     0,  2455,     0,  2456,  2457,     0,     0,  2458,     0,
    2460,  2461,  2462,     0,  2464,  2465,  2466,  2467,  2468,  2469,
       0,     0,     0,  2470,  2471,  2472,  2473,  2474,  2475,  2476,
       0,  2477,     0,  2478,     0,     0,  2481,     0,  2482,     0,
    2483,  2484,  2485,     0,     0,     0,     0,     0,  2486,     0,
    2487,     0,     0,  2489,  2490,  2491,     0,     0,  2492,  2493,
       0,  2494,     0,  2495,  2496,  2497,  2498,     0,  2499,  2500,
       0,  2501,  2502,  2503,  2504,     0,  2505,  2506,  2507,  2508,
       0,  2510,  2511,     0,  2513,     0,  2514,  2515,  2516,  2517,
    2518,     0,     0,  2519,     0,     0,  3711,  2521,  2522,     0,
       0,     0,  2524,  2525,     0,     0,  2526,  2527,  2528,     0,
    2529,     0,     0,  2530,     0,     0,  2531,     0,  2532,  2533,
    2534,  2535,     0,  2536,  2537,  2538,  2539,     0,  2540,  2541,
    2542,  2543,  2544,  2545,     0,     0,     0,     0,  2546,  2547,
    2548,  2549,  2550,  2551,     0,  2552,  2553,  2554,     0,  2555,
    2556,     0,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,     0,  2566,     0,  2567,     0,  2568,     0,  2569,     0,
    2570,  2571,  2572,  2573,     0,  2575,  2576,     0,     0,  2577,
       0,  2578,  2579,  2580,  2581,  2582,  2583,  2584,     0,  2585,
       0,  2586,  2587,     0,     0,     0,  2589,  2590,  2591,     0,
       0,  2592,  2593,     0,     0,  2594,  2595,  2596,  2597,     0,
    2598,  2599,  2600,     0,     0,  2601,  2602,     0,     0,  2603,
    2604,     0,  2605,  2606,     0,     0,  2607,  2608,     0,  2609,
    2610,  2611,  2612,     0,     0,  2613,  2614,  2615,     0,  2616,
       0,     0,     0,     0,     0,     0,     0,  2617,     0,  2618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2619,  2620,  2621,  2622,  2623,  2624,  2625,     0,
       0,     0,     0,  2626,  2627,  2628,     0,  2629,  2630,  2631,
       0,  2632,  2633,  2634,  2635,     0,  2636,     0,  2637,  2638,
    2639,     0,  2640,  2641,  2642,     0,  2643,     0,  2644,  2645,
    2646,  2647,  2648,  2649,  2650,     0,     0,     0,     0,     0,
    2651,  2652,     0,     0,  2653,  2654,  2655,  2656,  2657,  2658,
    2659,  2660,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2368,  2369,  2370,  2371,     0,  2373,  2374,  2375,
       0,  2376,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2380,  2381,     0,     0,     0,  2383,  2384,  2385,  2386,
       0,  2388,  2389,  2390,  2391,     0,  2392,  2393,  2394,  2395,
    2396,     0,     0,     0,  2397,     0,     0,  2398,     0,  2399,
    2400,  2401,  2402,  2403,     0,     0,     0,  2405,     0,  2406,
    2407,  2408,     0,     0,  2409,     0,  2410,  2411,     0,  2412,
    2413,  2414,     0,     0,  2415,     0,     0,     0,     0,     0,
       0,     0,     0,  2416,  2417,     0,  2418,     0,  2419,  2420,
    2421,  2422,     0,  2423,     0,  2424,  2425,  2426,  2427,  2428,
       0,     0,  2429,     0,     0,     0,     0,  2430,  2431,  2432,
    2433,     0,  2434,  2435,  2436,     0,  2437,  2438,     0,     0,
       0,  2439,  2440,  2441,  2442,  2443,     0,  2444,  2445,     0,
       0,     0,     0,  2446,  2447,     0,  3710,  2448,     0,  2449,
    2450,     0,     0,  2451,     0,  2452,     0,  2453,  2454,     0,
    2455,     0,  2456,  2457,     0,     0,  3737,     0,  2460,  2461,
    2462,     0,  2464,  2465,  2466,  2467,  2468,  2469,     0,     0,
       0,  2470,  2471,  2472,  2473,  2474,  2475,  2476,     0,  2477,
       0,  2478,     0,     0,  2481,     0,  2482,     0,  2483,  2484,
    2485,     0,     0,     0,     0,     0,  2486,     0,  2487,     0,
       0,  2489,  2490,  2491,     0,     0,  2492,  2493,     0,  2494,
       0,  2495,  2496,  2497,  2498,     0,  2499,  2500,     0,  2501,
    2502,  2503,  2504,     0,  2505,  2506,  2507,  2508,     0,  2510,
    2511,     0,  2513,     0,  2514,  2515,  2516,  2517,  2518,     0,
       0,  2519,     0,     0,  3711,  2521,  2522,     0,     0,     0,
    2524,  2525,     0,     0,  2526,  2527,  2528,     0,  2529,     0,
       0,  2530,     0,     0,  2531,     0,  2532,  2533,  2534,  2535,
       0,  2536,  2537,  2538,  2539,     0,  2540,  2541,  2542,  2543,
    2544,  2545,     0,     0,     0,     0,  2546,  2547,  2548,  2549,
    2550,  2551,     0,  2552,  2553,  2554,     0,  2555,  2556,     0,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,     0,
    2566,     0,  2567,     0,  2568,     0,  2569,     0,  2570,  2571,
    2572,  2573,     0,  2575,  2576,     0,     0,  2577,     0,  2578,
    2579,  2580,  2581,  2582,  2583,  2584,     0,  2585,     0,  2586,
    2587,     0,     0,     0,  2589,  2590,  2591,     0,     0,  2592,
    2593,     0,     0,  2594,  2595,  2596,  2597,     0,  2598,  2599,
    2600,     0,     0,  2601,  2602,     0,     0,  2603,  2604,     0,
    2605,  2606,     0,     0,  2607,  2608,     0,  2609,  2610,  2611,
    2612,     0,     0,  2613,  2614,  2615,     0,  2616,     0,     0,
       0,     0,     0,     0,     0,  2617,     0,  2618,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2619,  2620,  2621,  2622,  2623,  2624,  2625,     0,     0,     0,
       0,  2626,  2627,  2628,     0,  2629,  2630,  2631,     0,  2632,
    2633,  2634,  2635,     0,  2636,     0,  2637,  2638,  2639,     0,
    2640,  2641,  2642,     0,  2643,     0,  2644,  2645,  2646,  2647,
    2648,  2649,  2650,     0,     0,     0,     0,     0,  2651,  2652,
       0,     0,  2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2368,  2369,  2370,  2371,     0,  2373,  2374,  2375,     0,  2376,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2380,
    2381,     0,     0,     0,  2383,  2384,  2385,  2386,     0,  2388,
    2389,  2390,  2391,     0,  2392,  2393,  2394,  2395,  2396,     0,
       0,     0,  2397,     0,     0,  2398,     0,  2399,  2400,  2401,
    2402,  2403,     0,     0,     0,  2405,     0,  2406,  2407,  2408,
       0,     0,  2409,     0,  2410,  2411,     0,  2412,  2413,  2414,
       0,     0,  2415,     0,     0,     0,     0,     0,     0,     0,
       0,  2416,  2417,     0,  2418,     0,  2419,  2420,  2421,  2422,
       0,  2423,     0,  2424,  2425,  2426,  2427,  2428,     0,     0,
    2429,     0,     0,     0,     0,  2430,  2431,  2432,  2433,     0,
    2434,  2435,  2436,     0,  2437,  2438,     0,     0,     0,  2439,
    2440,  2441,  2442,  2443,     0,  2444,  2445,     0,     0,     0,
       0,  2446,  2447,     0,  3710,  2448,     0,  2449,  2450,     0,
       0,  2451,     0,  2452,     0,  2453,  2454,     0,  2455,     0,
    2456,  2457,     0,     0,  4412,     0,  2460,  2461,  2462,     0,
    2464,  2465,  2466,  2467,  2468,  2469,     0,     0,     0,  2470,
    2471,  2472,  2473,  2474,  2475,  2476,     0,  2477,     0,  2478,
       0,     0,  2481,     0,  2482,     0,  2483,  2484,  2485,     0,
       0,     0,     0,     0,  2486,     0,  2487,     0,     0,  2489,
    2490,  2491,     0,     0,  2492,  2493,     0,  2494,     0,  2495,
    2496,  2497,  2498,     0,  2499,  2500,     0,  2501,  2502,  2503,
    2504,     0,  2505,  2506,  2507,  2508,     0,  2510,  2511,     0,
    2513,     0,  2514,  2515,  2516,  2517,  2518,     0,     0,  2519,
       0,     0,  3711,  2521,  2522,     0,     0,     0,  2524,  2525,
       0,     0,  2526,  2527,  2528,     0,  2529,     0,     0,  2530,
       0,     0,  2531,     0,  2532,  2533,  2534,  2535,     0,  2536,
    2537,  2538,  2539,     0,  2540,  2541,  2542,  2543,  2544,  2545,
       0,     0,     0,     0,  2546,  2547,  2548,  2549,  2550,  2551,
       0,  2552,  2553,  2554,     0,  2555,  2556,     0,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,     0,  2566,     0,
    2567,     0,  2568,     0,  2569,     0,  2570,  2571,  2572,  2573,
       0,  2575,  2576,     0,     0,  2577,     0,  2578,  2579,  2580,
    2581,  2582,  2583,  2584,     0,  2585,     0,  2586,  2587,     0,
       0,     0,  2589,  2590,  2591,     0,     0,  2592,  2593,     0,
       0,  2594,  2595,  2596,  2597,     0,  2598,  2599,  2600,     0,
       0,  2601,  2602,     0,     0,  2603,  2604,     0,  2605,  2606,
       0,     0,  2607,  2608,     0,  2609,  2610,  2611,  2612,     0,
       0,  2613,  2614,  2615,     0,  2616,     0,     0,     0,     0,
       0,     0,     0,  2617,     0,  2618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2619,  2620,
    2621,  2622,  2623,  2624,  2625,     0,     0,     0,     0,  2626,
    2627,  2628,     0,  2629,  2630,  2631,     0,  2632,  2633,  2634,
    2635,     0,  2636,     0,  2637,  2638,  2639,     0,  2640,  2641,
    2642,     0,  2643,     0,  2644,  2645,  2646,  2647,  2648,  2649,
    2650,     0,     0,     0,     0,     0,  2651,  2652,     0,     0,
    2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2368,  2369,
    2370,  2371,     0,  2373,  2374,  2375,     0,  2376,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2380,  2381,     0,
       0,     0,  2383,  2384,  2385,  2386,     0,  2388,  2389,  2390,
    2391,     0,  2392,  2393,  2394,  2395,  2396,     0,     0,     0,
    2397,     0,     0,  2398,     0,  2399,  2400,  2401,  2402,  2403,
       0,     0,     0,  2405,     0,  2406,  2407,  2408,     0,     0,
    2409,     0,  2410,  2411,     0,  2412,  2413,  2414,     0,     0,
    2415,     0,     0,     0,     0,     0,     0,     0,     0,  2416,
    2417,     0,  2418,     0,  2419,  2420,  2421,  2422,     0,  2423,
       0,  2424,  2425,  2426,  2427,  2428,     0,     0,  2429,     0,
       0,     0,     0,  2430,  2431,  2432,  2433,     0,  2434,  2435,
    2436,     0,  2437,  2438,     0,     0,     0,  2439,  2440,  2441,
    2442,  2443,     0,  2444,  2445,     0,     0,     0,     0,  2446,
    2447,     0,  3710,  2448,     0,  2449,  2450,     0,     0,  2451,
       0,  2452,     0,  2453,  2454,     0,  2455,     0,  2456,  2457,
       0,     0,  2458,     0,  2460,  2461,  2462,     0,  2464,  2465,
    2466,  2467,  2468,  2469,     0,     0,     0,  2470,  2471,  2472,
    2473,  2474,  2475,  2476,     0,  2477,     0,  2478,     0,     0,
    2481,     0,  2482,     0,  2483,  2484,  2485,     0,     0,     0,
       0,     0,  2486,     0,  2487,     0,     0,  2489,  2490,  2491,
       0,     0,  2492,  2493,     0,  2494,     0,  2495,  2496,  2497,
    2498,     0,  2499,  2500,     0,  2501,  2502,  2503,  2504,     0,
    2505,  2506,  2507,  2508,     0,  2510,  2511,     0,  2513,     0,
    2514,  2515,  2516,  2517,  2518,     0,     0,  2519,     0,     0,
    3711,  2521,  2522,     0,     0,     0,  2524,  2525,     0,     0,
    2526,  2527,  2528,     0,  2529,     0,     0,  2530,     0,     0,
    2531,     0,  2532,  2533,  2534,  2535,     0,  2536,  2537,  2538,
    2539,     0,  2540,  2541,  2542,  2543,  2544,  2545,     0,     0,
       0,     0,  2546,  2547,  2548,  2549,  2550,  2551,     0,  2552,
    2553,  2554,     0,  2555,  2556,     0,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,     0,  2566,     0,  2567,     0,
    2568,     0,  2569,     0,  2570,  2571,  2572,  2573,     0,  2575,
    2576,     0,     0,  2577,     0,  3712,  2579,  2580,  2581,  2582,
    2583,  2584,     0,  2585,     0,  2586,  2587,     0,     0,     0,
    2589,  2590,  2591,     0,     0,  2592,  2593,     0,     0,  2594,
    2595,  2596,  2597,     0,  2598,  2599,  2600,     0,     0,  2601,
    2602,     0,     0,  2603,  2604,     0,  2605,  2606,     0,     0,
    2607,  2608,     0,  2609,  2610,  2611,  2612,     0,     0,  2613,
    2614,  2615,     0,  2616,     0,     0,     0,     0,     0,     0,
       0,  2617,     0,  2618,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2619,  2620,  2621,  2622,
    2623,  2624,  2625,     0,     0,     0,     0,  2626,  2627,  2628,
       0,  2629,  2630,  2631,     0,  2632,  2633,  2634,  2635,     0,
    2636,     0,  2637,  2638,  2639,     0,  2640,  2641,  2642,     0,
    2643,     0,  2644,  2645,  2646,  2647,  2648,  2649,  2650,     0,
       0,     0,     0,     0,  2651,  2652,     0,     0,  2653,  2654,
    2655,  2656,  2657,  2658,  2659,  2660,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2368,  2369,  2370,  2371,
       0,  2373,  2374,  2375,     0,  2376,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2380,  2381,     0,     0,     0,
    2383,  2384,  2385,  2386,     0,  2388,  2389,  2390,  2391,     0,
    2392,  2393,  2394,  2395,  2396,     0,     0,     0,  2397,     0,
       0,  2398,     0,  2399,  2400,  2401,  2402,  2403,     0,     0,
       0,  2405,     0,  2406,  2407,  2408,     0,     0,  2409,     0,
    2410,  2411,     0,  2412,  2413,  2414,     0,     0,  2415,     0,
       0,     0,     0,     0,     0,     0,     0,  2416,  2417,     0,
    2418,     0,  2419,  2420,  2421,  2422,     0,  2423,     0,  2424,
    2425,  2426,  2427,  2428,     0,     0,  2429,     0,     0,     0,
       0,  2430,  2431,  2432,  2433,     0,  2434,  2435,  2436,     0,
    2437,  2438,     0,     0,     0,  2439,  2440,  2441,  2442,  2443,
       0,  2444,  2445,     0,     0,     0,     0,  2446,  2447,     0,
    3710,  2448,     0,  2449,  2450,     0,     0,  2451,     0,  2452,
       0,  2453,  2454,     0,  2455,     0,  2456,  2457,     0,     0,
    2458,     0,  2460,  2461,  2462,     0,  2464,  2465,  2466,  2467,
    2468,  2469,     0,     0,     0,  2470,  2471,  2472,  2473,  2474,
    2475,  2476,     0,  2477,     0,  2478,     0,     0,  2481,     0,
    2482,     0,  2483,  2484,  2485,     0,     0,     0,     0,     0,
    2486,     0,  2487,     0,     0,  2489,  2490,  2491,     0,     0,
    2492,  2493,     0,  2494,     0,  2495,  2496,  2497,  2498,     0,
    2499,  2500,     0,  2501,  2502,  2503,  2504,     0,  2505,  2506,
    2507,  2508,     0,  2510,  2511,     0,  2513,     0,  2514,  2515,
    2516,  2517,  2518,     0,     0,  2519,     0,     0,  3711,  2521,
    2522,     0,     0,     0,  2524,  2525,     0,     0,  2526,  2527,
    2528,     0,  2529,     0,     0,  2530,     0,     0,  2531,     0,
    2532,  2533,  2534,  2535,     0,  2536,  2537,  2538,  2539,     0,
    2540,  2541,  2542,  2543,  2544,  2545,     0,     0,     0,     0,
    2546,  2547,  2548,  2549,  2550,  2551,     0,  2552,  2553,  2554,
       0,  2555,  2556,     0,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,     0,  2566,     0,  2567,     0,  2568,     0,
    2569,     0,     0,  2571,  2572,  2573,     0,  2575,  2576,     0,
       0,  2577,     0,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
       0,  2585,     0,  2586,  2587,     0,     0,     0,  2589,  2590,
    2591,     0,     0,  2592,  2593,     0,     0,  2594,  2595,  2596,
    2597,     0,  2598,  2599,  2600,     0,     0,  2601,  2602,     0,
       0,  2603,  2604,     0,  2605,  2606,     0,     0,  2607,  2608,
       0,  2609,  2610,  2611,  2612,     0,     0,  2613,  2614,  2615,
       0,  2616,     0,     0,     0,     0,     0,     0,     0,  2617,
       0,  2618,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2619,  2620,  2621,  2622,  2623,  2624,
    2625,     0,     0,     0,     0,  2626,  2627,  2628,     0,  2629,
    2630,  2631,     0,  2632,  2633,  2634,  2635,     0,  2636,     0,
    2637,  2638,  2639,     0,  2640,  2641,  2642,     0,  2643,     0,
    2644,  2645,  2646,  2647,  2648,  2649,  2650,     0,     0,     0,
       0,     0,  2651,  2652,     0,     0,  2653,  2654,  2655,  2656,
    2657,  2658,  2659,  2660,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2368,  2369,  2370,  2371,     0,  2373,
    2374,  2375,     0,  2376,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2380,  2381,     0,     0,     0,  2383,  2384,
    2385,  2386,     0,  2388,  2389,  2390,  2391,     0,  2392,  2393,
    2394,  2395,  2396,     0,     0,     0,  2397,     0,     0,  2398,
       0,  2399,  2400,  2401,  2402,  2403,     0,     0,     0,  2405,
       0,  2406,  2407,  2408,     0,     0,  2409,     0,  2410,  2411,
       0,  2412,  2413,  2414,     0,     0,  2415,     0,     0,     0,
       0,     0,     0,     0,     0,  2416,  2417,     0,  2418,     0,
    2419,  2420,  2421,  2422,     0,  2423,     0,  2424,  2425,  2426,
    2427,  2428,     0,     0,  2429,     0,     0,     0,     0,  2430,
    2431,  2432,  2433,     0,  2434,  2435,  2436,     0,  2437,  2438,
       0,     0,     0,  2439,  2440,  2441,  2442,  2443,     0,  2444,
    2445,     0,     0,     0,     0,  2446,  2447,     0,     0,  2448,
       0,  2449,  2450,     0,     0,  2451,     0,  2452,     0,  2453,
    2454,     0,  2455,     0,  2456,  2457,     0,     0,  2458,     0,
    2460,  2461,  2462,     0,  2464,  2465,  2466,  2467,  2468,  2469,
       0,     0,     0,  2470,  2471,  2472,  2473,  2474,  2475,  2476,
       0,  2477,     0,  2478,     0,     0,  2481,     0,  2482,     0,
    2483,  2484,  2485,     0,     0,     0,     0,     0,  2486,     0,
    2487,     0,     0,  2489,  2490,  2491,     0,     0,  2492,  2493,
       0,  2494,     0,  2495,  2496,  2497,  2498,     0,  2499,  2500,
       0,  2501,  2502,  2503,  2504,     0,  2505,  2506,  2507,  2508,
       0,  2510,  2511,     0,  2513,     0,  2514,  2515,  2516,  2517,
    2518,     0,     0,  2519,     0,     0,  3711,  2521,  2522,     0,
       0,     0,  2524,  2525,     0,     0,  2526,  2527,  2528,     0,
    2529,     0,     0,  2530,     0,     0,  2531,     0,  2532,  2533,
    2534,  2535,     0,  2536,  2537,  2538,  2539,     0,  2540,  2541,
    2542,  2543,  2544,  2545,     0,     0,     0,     0,  2546,  2547,
    2548,  2549,  2550,  2551,     0,  2552,  2553,  2554,     0,  2555,
    2556,     0,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,     0,  2566,     0,  2567,     0,  2568,     0,  2569,     0,
    2570,  2571,  2572,  2573,     0,  2575,  2576,     0,     0,  2577,
       0,  2578,  2579,  2580,  2581,  2582,  2583,  2584,     0,  2585,
       0,  2586,  2587,     0,     0,     0,  2589,  2590,  2591,     0,
       0,  2592,  2593,     0,     0,  2594,  2595,  2596,  2597,     0,
    2598,  2599,  2600,     0,     0,  2601,  2602,     0,     0,  2603,
    2604,     0,  2605,  2606,     0,     0,  2607,  2608,     0,  2609,
    2610,  2611,  2612,     0,     0,  2613,  2614,  2615,     0,  2616,
       0,     0,     0,     0,     0,     0,     0,  2617,     0,  2618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2619,  2620,  2621,  2622,  2623,  2624,  2625,     0,
       0,     0,     0,  2626,  2627,  2628,     0,  2629,  2630,  2631,
       0,  2632,  2633,  2634,  2635,     0,  2636,     0,  2637,  2638,
    2639,     0,  2640,  2641,  2642,     0,  2643,     0,  2644,  2645,
    2646,  2647,  2648,  2649,  2650,     0,     0,     0,     0,     0,
    2651,  2652,     0,     0,  2653,  2654,  2655,  2656,  2657,  2658,
    2659,  2660
};

static const yytype_int16 yycheck[] =
{
       2,    78,   977,   933,   209,   252,  1465,   395,    78,    96,
    1210,    78,   167,  1215,    78,   117,    78,    78,  1397,   106,
     395,  1022,  1161,    84,  1516,  1474,  1104,  1105,  1469,  1507,
     379,  1109,   187,  1323,  1043,  1867,  1546,  1178,   154,    94,
     228,  1848,  2790,   153,  1053,  2253,  1280,   977,  1354,  2079,
    1340,  1908,   150,   223,  1915,   142,  2063,  1918,   165,  1022,
     162,  2855,  2856,  2203,  1453,  1393,  1041,  1579,  1069,  1930,
     157,  1932,  1328,  1934,  1735,  3326,  1918,   132,  1637,  1168,
    2023,  1769,  1914,  1607,  1608,  3020,   202,  3771,  3714,  2697,
    2081,   796,  3932,  1410,  3679,   165,   171,  3154,   153,   154,
    1969,  1908,  1626,  1420,  3123,  1759,  1396,  3162,   163,     2,
    1400,  1041,   160,  4024,  1928,  1405,  1795,  1796,  1797,  2122,
    1327,  1752,  1412,  3750,  2293,  3752,  1333,  3951,   230,  3488,
    4435,   132,  1422,    78,   209,  1342,  3979,  4281,  1257,  1981,
    1257,  3491,  3492,  2749,   797,  4642,  4431,   202,   117,  4336,
    3071,  4200,  4392,  3305,  3936,  3937,  3938,  3939,  3940,  3941,
    2966,   381,  4227,  1164,  3493,   167,  4009,  2973,  1897,  4585,
     381,  4401,  1986,  1987,  4941,  2981,  3724,  3564,  4966,  4332,
      78,  1659,  4631,   367,   208,   187,  4233,  2190,  4656,  1850,
    1914,  1790,  1791,   162,   218,  2138,  1854,  3425,  3557,  5169,
     216,  1164,  2127,  4470,   167,  2778,  4389,  5161,  3715,  3595,
    4888,  2776,  5279,  4932,  5281,  1512,  2802,  4232,  1529,  3488,
    5168,  1508,  3157,  4293,   187,  1499,  1238,  1596,  1597,  1207,
    5654,  5655,  4387,  4388,  1298,    30,  4629,  1565,   108,  1207,
    4149,  4936,    88,  5531,  1252,  1253,    21,   143,  4641,  4386,
    4387,  4388,  4389,  1622,    72,    88,  2842,   157,    88,   121,
    2846,   230,   135,    78,   128,   108,  1060,   113,    86,    84,
     181,    75,    76,    77,    78,  5319,  5320,   128,    82,   108,
     125,    95,   205,  4438,  4435,   145,   912,   225,  3557,    88,
     114,    88,  1304,    75,    76,    77,    78,   143,   108,   108,
      82,  4438,   117,  3238,  1009,  3240,   250,    72,    99,   114,
     387,  5524,  1390,   230,   113,   106,   231,   387,   230,   112,
     387,   108,   164,   387,    10,   387,    75,    76,    77,    78,
    4547,   103,   104,    82,   395,  2365,    75,    76,    77,    78,
      14,   230,  3570,    82,   143,  1346,   236,   162,   112,   332,
      72,    90,   102,   135,  5728,    75,    76,    77,    78,    81,
    4645,   361,    82,    37,    86,   269,   128,  1508,   181,   430,
      90,   125,   327,   174,    84,   145,   431,   125,    75,    76,
      77,    78,    86,   117,   198,    82,   154,    75,    76,    77,
      78,   174,   200,    90,    82,    99,   238,   400,    72,  1374,
     269,    75,    76,    77,    78,    95,   378,    81,    82,    83,
      84,   174,    86,  1719,   315,   230,   238,   462,   315,    99,
     212,   462,   174,  1424,   430,   271,  1660,   430,   162,   181,
     358,    75,    76,    77,    78,   407,   222,   109,    82,    78,
    5367,   481,   387,   366,  1374,   271,    90,   135,    75,    76,
      77,    78,   389,  1158,  1688,    82,   442,   229,   317,   231,
      75,    76,    77,    78,   230,   468,  1475,    82,   211,   230,
      99,   553,    72,   315,   208,    90,     0,  4893,    75,    76,
      77,    78,   216,   383,   218,    82,    86,    78,    14,   387,
    1491,  1492,    75,    76,    77,    78,   230,   579,   484,    82,
     440,  5428,  5876,   295,  1516,   331,   365,  2066,   198,    75,
      76,    77,    78,   193,   442,  1516,    82,   189,    88,  5586,
     384,    78,  3384,  3385,   461,    78,   914,  3389,   314,  1492,
    2054,  2055,   117,   384,   579,   348,    78,  2061,   579,   914,
     650,  1682,   582,  1552,  4326,  3131,    75,    76,    77,    78,
      99,    78,   315,    82,   560,  5509,   484,   106,  1567,    75,
      76,    77,    78,    99,   193,   317,    82,   389,   238,   466,
     106,  1580,    72,  2032,  3436,  3437,   579,   162,   348,   579,
     395,    81,  1583,  1724,  1725,    99,    86,   238,  2037,   212,
    5378,  4431,   106,   188,    78,   650,   579,   498,   181,   183,
      78,  1254,  1255,    75,    76,    77,    78,    78,   238,   581,
      82,    75,    76,    77,    78,   430,   202,  1945,    82,  2250,
    1583,   404,   384,  2254,   579,  2256,   566,   440,  2259,   430,
    2261,   381,   748,   749,   427,   440,  4941,  2026,   582,  2327,
      99,   579,   230,   467,  5339,   230,   460,   230,  1274,    88,
      75,    76,    77,    78,  2342,   566,   579,    82,    75,    76,
      77,    78,   579,   427,   579,    82,    78,  6041,   420,   477,
     582,   423,   440,  1880,   113,  1965,  1883,  1967,   582,  5892,
    4920,   577,   582,  2052,  2053,   581,   434,   462,   378,   471,
     579,  2060,   582,   748,   749,  3630,   556,   542,  2359,  2027,
     472,   271,   467,  1497,   143,  1717,   579,  5123,  2916,   579,
    1722,  1723,   581,  1714,  5163,  2021,   558,   579,   582,  1975,
     430,  1722,  1723,   566,   570,   571,   572,   573,   574,   575,
    4970,   582,  4781,   524,  2244,  1942,   527,   566,  5005,  4922,
    4923,   796,   572,   573,   574,   575,  2135,   580,   387,  4932,
    4815,  1714,   570,   571,  4819,  2196,   566,   566,  4805,  4385,
     239,  5154,  5806,  2091,  6052,  5181,  4609,    75,    76,    77,
      78,   941,  5742,   577,    82,   579,   575,   581,   575,   566,
     523,   467,   577,  4938,  4566,  4922,  4923,    78,   542,  4804,
    4941,  4339,   546,  4863,  1481,  4932,   387,   579,   573,  1777,
    4624,  4938,  1810,  5751,  3598,  4645,  3600,  1494,   910,  1777,
    2251,   921,  4721,    88,  2292,  2293,   582,   521,   102,  2260,
     582,   582,  1069,   527,   180,  2303,  6250,   579,   145,  2307,
     387,   580,  2160,   145,   387,   183,   315,  2315,  2316,   150,
     579,  6265,  6266,  1907,  2851,   387,  5913,   551,   570,   571,
    2328,  2329,   440,   914,   477,  1508,   483,   440,   968,   579,
     387,  1210,  2340,   269,   181,  4224,   415,   462,  4227,   181,
    2861,   541,  2350,  1885,  5091,  5092,  5093,  5094,  5095,   415,
     464,  3900,   579,  1895,  3903,  3904,   483,   204,  3907,  1073,
     541,   579,   204,   352,  3913,  1011,   570,   571,  3506,  5315,
     145,   415,  3708,   387,    93,   471,  5322,   186,   230,   387,
     958,   541,   107,  5883,  2225,  2212,   387,  4246,  5637,  3974,
    2231,  1031,  2209,  5877,  2221,   273,  2200,  1082,   250,  1084,
    4437,  1086,  5610,  3519,  4320,   579,   181,  1092,   565,   238,
     526,   910,   224,   402,  1114,  1957,  3681,   269,  1960,  1961,
    2319,  2320,   579,   174,  1009,  4224,  1011,  5652,  4227,   204,
    1115,  1116,  1069,   149,   579,   551,  3539,  1065,   565,   317,
    3905,  3906,  1947,  3538,   433,   387,   435,  4336,   566,  1066,
    1200,   481,   579,   566,  5616,  5617,   181,   466,   238,  1200,
     301,   302,   303,   581,  4542,    25,   271,  1084,   581,  1086,
     570,   571,   572,   573,   574,   575,   141,   181,  1063,  1096,
    5507,   186,  1067,   579,  1184,   160,   239,  1947,   145,   367,
     181,  2033,   211,  5977,   161,   183,  2687,   176,  1115,  1116,
    2691,    75,    76,    77,    78,    29,   348,    72,    82,  2367,
      75,    76,    77,    78,  1214,   128,    81,    82,  2855,   391,
     579,    86,  2130,  2131,   181,   181,   462,    14,  1060,   577,
      38,   181,    40,   579,   174,   583,  2207,  4336,   220,  4297,
     570,   571,   354,  6043,   330,   269,  5381,  5264,  2766,   269,
    1082,  4666,  1084,  1190,  1086,    85,   442,  5372,   263,  2931,
    1092,  1093,  1094,    88,   243,   910,   387,   381,   235,   914,
    2754,   418,  2756,  1158,   583,  1160,   418,   579,   204,   393,
    3035,   231,   175,  1115,  1116,   579,  5459,   174,  2257,  2258,
     186,  1084,  2356,  1086,  1185,  1295,  6096,  1297,   484,  5316,
     330,  5826,  5827,   572,   573,   574,   575,   289,  3932,   332,
     462,   128,   337,  5383,  5384,   337,  1162,  5414,   143,   331,
    1166,   468,  1115,  1116,   579,   304,   468,  2166,   307,  1160,
     444,   322,   579,   174,   322,   337,    85,  1060,  2177,    88,
    5219,  5354,   392,   418,  3016,   331,   910,   583,    71,    72,
    2189,   460,    75,    76,    77,    78,    79,    80,    81,    82,
     253,   502,   503,    86,   113,   330,   327,   263,   318,  2174,
     119,    95,   391,  5340,  2803,  5270,  2805,   101,  5345,   430,
    5275,  2869,  2213,  5278,   161,  3950,    95,  5354,   337,  5266,
     409,   348,   348,   468,   143,  2954,   400,   269,  4022,   269,
    5381,  5382,   315,   180,   582,   265,  1238,   579,   327,   556,
    2964,   472,   541,   466,  2174,   137,   145,  5744,    72,   398,
    6220,    75,    76,    77,    78,  1257,   430,    81,    82,    83,
      84,   583,    86,   580,   230,   212,   452,   261,   462,  4131,
    5181,   579,  4134,  4135,  4136,  4137,  4138,  4139,  4140,  4141,
    4142,  4143,   181,   181,   250,   460,  2327,  5736,   181,  5757,
     230,   541,  5924,   486,   468,   570,   571,   572,   573,   574,
     575,   384,  1304,   269,   198,  1329,  1330,   481,  5151,   176,
     250,   556,  5323,   440,   440,    95,  4943,   209,   538,   198,
     430,   101,   418,   579,   407,   910,   181,   246,  3197,   269,
     152,   250,    95,   333,  4882,   227,   481,  5524,   483,   317,
    4202,  4203,   462,  1288,    25,  1238,  4972,  4973,   497,   539,
    2325,   225,   271,   272,    71,   500,  3213,  5700,    75,    76,
      77,    78,    79,    80,  1257,    82,   429,   430,   190,   288,
    1185,   566,   468,   430,   100,   268,   243,   522,   232,   579,
     145,   447,   577,   181,   579,   580,   581,   582,   533,  1437,
     582,   536,   230,   160,   460,  2325,   269,   384,   317,   292,
    3207,   320,   176,  1085,   230,   579,  3213,  1089,  1090,  1091,
     582,  1304,  1659,   181,   333,   111,   181,  1099,   198,   430,
     462,   577,   462,   211,   250,   581,   574,   374,  1162,  5878,
     579,   579,  1166,   581,  1521,   198,  1523,   304,  6226,  1526,
     307,  1528,  1512,   269,  1531,  1532,  1533,   137,   579,   348,
     348,   345,  1840,   400,  5637,  5608,  4815,  1544,  6246,   176,
    4819,   580,  5473,   582,   154,  1840,   345,   359,  2155,   243,
    1557,  5155,  1559,   211,  4861,   230,   198,  5893,  2165,  5976,
    3510,  4831,  2169,   430,   378,  5169,  6253,   145,  2175,  2176,
     579,  5988,   411,   348,  1496,  1497,   462,  1499,   362,   378,
    5637,  5550,  5653,  5654,  5655,    22,   380,  4836,  2195,  1564,
    4529,  5741,  4841,   407,  1516,   233,  4535,  4536,  5583,   209,
      97,   468,   462,   181,   346,   181,   243,   181,   407,   407,
     304,   398,  5372,   307,   481,   579,   571,   227,   264,   393,
     117,   440,  1762,  1763,   181,  1765,  4815,  6044,   366,  4701,
    4819,  1762,  1763,   249,  1765,    72,  2209,    75,    76,    77,
      78,  1745,   119,   455,    82,   345,   566,   567,   568,  6264,
     570,   571,   572,   573,   574,   575,  6271,  6272,   430,   407,
     348,   181,   345,   348,   265,   440,   465,   304,   239,   462,
     307,  2732,   145,  5780,   448,  1329,  1330,   395,   378,   407,
    5611,   154,   440,  1496,  1497,  3596,  1499,  4413,  5619,  1779,
     181,  3602,   434,   335,  5663,   378,  3140,   583,  5667,  5668,
     152,   409,    85,  1516,   398,    88,    99,   407,   181,   105,
     497,  1733,   579,   344,    98,   162,   462,  4431,  2679,   391,
     395,  2969,   137,   583,   407,  1700,  1701,   566,   567,   568,
    2789,   570,   571,   572,   573,   574,   575,   380,   190,   232,
     382,  3292,  5486,   317,   315,  5809,  5810,   131,  5492,   359,
     145,   409,   440,   233,   147,   440,   540,   570,   571,   186,
     144,   398,   155,  3000,   402,   407,   181,   264,   483,   246,
     348,   198,   348,   250,   158,   239,  3384,  3385,  4304,  1700,
    1701,  3389,  4623,   230,   582,  5892,   181,   525,   460,   182,
     119,   348,   579,   431,   481,  1717,  4578,   317,   473,   230,
    1722,  1723,  2841,   497,  2841,  2766,   440,   358,   345,  1790,
    1791,   288,   196,   500,   191,   152,   212,   299,   440,   250,
    4675,   395,  4677,   207,   201,   137,   570,   571,  3436,  3437,
    3067,   143,  1854,  1808,   582,   522,  2963,   583,   481,  5995,
     333,   231,   154,   227,  1733,   455,   533,   176,   232,   536,
     565,   315,  3231,   190,   582,   154,   184,   348,   371,  1840,
     497,   254,   440,   152,   440,   442,  1847,   250,  3595,   181,
     407,   183,  3241,   275,  3235,   348,   481,  1799,  3605,  1801,
    1802,   345,   181,   440,  3132,   393,    25,  1808,   271,  2821,
    1980,   442,   378,     2,   346,   466,    35,   378,  1820,   152,
    1789,   190,   317,  5881,  1717,  1827,  1828,   322,  3035,  1722,
    1723,  1879,   185,   315,   378,   299,  3225,  1519,  3128,   247,
    1522,   407,   402,  1525,  3701,  1527,   407,   344,  1530,   356,
    3057,  4645,  1534,   484,   411,   186,   444,   190,  4066,   582,
    3177,  3178,  3179,  3180,   359,   257,  3520,  6011,   582,   333,
     333,   431,  3189,   348,  6110,  3353,  3193,   347,   373,   345,
     582,   474,  3089,  1885,  5727,  1854,   304,   440,   345,    78,
     450,  6196,  3209,  1895,  3701,    84,   337,   582,   362,  3216,
      89,  6186,   434,   421,   422,  5264,   154,   156,  1801,  1802,
     407,  5270,   378,  4775,  4776,   134,  5275,   270,  1733,  5278,
    5468,   378,   466,   173,  5982,   317,  3404,   409,   117,   346,
     322,   395,   263,  4102,  1827,  1828,   276,   401,   317,   232,
     404,   407,   412,  2918,  6249,   366,   195,  5532,  6253,   440,
     423,  5202,  2961,  3822,   382,  1957,   397,  5316,  1960,  1961,
     455,   145,  3440,     5,   153,   440,   430,   359,  4903,  4904,
     154,   392,   436,   162,  1789,  1790,  1791,   346,   460,   407,
     398,   373,  5893,    25,  2086,   449,   234,  3315,  2918,  6229,
    3832,   583,  1885,    35,  3625,  5264,  5346,   181,  5348,  1733,
    3478,  5270,  1895,   208,  1949,   253,  5275,  1952,   225,  5278,
     474,  6251,  6252,   346,   220,   220,  5643,   434,   235,   208,
     225,    75,    76,    77,    78,  1840,  3038,   216,    82,   218,
    2107,  2033,  1847,   250,  3046,  2133,  3048,  6095,   121,  1854,
     333,   230,  5061,  5062,   292,  6196,   265,  5316,  5891,  4052,
     300,  2161,   481,   185,  2741,   305,  2001,   243,  5742,  5310,
    2005,  5312,   267,   455,  1957,   434,  6124,  1960,  1961,   400,
     344,   129,  5620,   577,  5131,   566,   163,   581,   483,   137,
    2285,   275,  3606,   289,   289,    78,   145,  5142,   336,   172,
     581,  1424,   134,   208,   183,   154,  5153,  2267,  6249,  6250,
     187,   434,  6253,   566,   567,   568,  2213,   570,   571,   572,
     573,   574,   575,   579,  6265,  6266,   583,  2086,   304,   206,
    1854,   315,   181,   329,   329,  3635,  3030,  1861,  3206,   460,
     423,  2836,   337,   407,    88,  2222,   225,  2224,   270,   226,
    2033,  2228,  2212,  2230,  2146,  5969,  2233,   193,  1733,   195,
    2237,  2221,   267,   582,   241,   197,   149,   344,  1491,   113,
     565,   335,   176,  1897,   348,  5524,   145,   193,   257,   195,
     387,   345,   165,   367,   579,    85,   184,  5762,    88,   262,
     250,   582,   184,  3087,  2354,   433,   183,   435,  4002,   143,
     578,  4005,   218,   121,   582,   105,   444,   432,  2200,  5883,
     250,  2203,   181,   345,   378,  2275,   395,   455,  2275,  2284,
     458,  2275,   398,  2275,  2974,   409,  3217,  3666,   318,   319,
     407,    95,   337,   265,  5583,   579,   315,   101,   317,   243,
      85,   183,   315,    88,   292,   322,   378,  4845,  2104,   247,
     193,   430,   195,  2291,   172,   247,   481,  3926,    85,   454,
     105,    88,  3012,  3254,  3217,  5524,  4126,  2123,   393,   252,
      75,    76,    77,    78,  5812,  3654,   460,    82,   322,  1854,
     585,  2086,    75,    76,    77,    78,   273,  2379,   365,    82,
    4150,   327,    14,    14,  3296,    75,    76,    77,    78,   348,
     304,  3254,    82,   234,   210,  2982,   322,   173,  3498,   473,
     400,   327,    41,  2305,  2306,    37,    37,  2200,   378,   444,
    2203,  2313,   382,   396,  5583,  2317,  2318,   271,   272,  3006,
     317,   273,    85,   345,   198,    88,   115,  3655,   378,   225,
     430,  2333,   382,  2335,   262,   251,   345,   407,   393,   454,
      72,   462,   105,  3384,  3385,   483,  6186,   136,  3389,   245,
     265,   292,  2086,  5215,  2742,   153,   378,   407,   299,  6043,
    2362,   271,  2364,   231,   317,   317,   320,  2742,   468,   378,
     367,   183,   577,  4364,   327,   580,   581,  2275,  5926,   255,
      85,   481,   382,    88,   398,  5247,  5248,   315,   381,   444,
     566,   259,   134,   135,   387,  3436,  3437,  4340,   407,    85,
     105,   234,    88,    16,   202,   581,   274,   407,   113,   444,
    2379,   481,  6096,  5432,   119,   367,   271,   414,   286,  3508,
     446,  5780,   126,   333,   300,   345,  3682,   565,   515,   305,
     456,   481,  2330,  4064,   271,  6217,    85,   220,   143,    88,
     345,   579,   225,  4131,   531,   257,  4134,  4135,  4136,  4137,
    4138,  4139,  4140,  4141,  4142,  4143,   105,   577,   378,   292,
     304,   650,   382,   307,   584,  3793,  6161,  3795,   396,   173,
     317,   361,  3728,   378,  3984,   322,  3683,   382,   333,   579,
    4168,   232,  3457,   281,   282,  3995,   432,   407,    75,    76,
      77,    78,   433,   580,   435,    82,   333,   295,    51,  3511,
     430,  2086,   407,   315,  6199,   317,   289,   322,   271,   260,
    3511,  5780,   400,  4320,  4202,  4203,    69,   458,   365,   322,
     388,  4182,  4552,    85,   326,   345,    88,  3457,  6076,  3857,
    4372,    88,   322,  5892,   474,   481,  6220,   483,  1323,   220,
     391,   246,   430,  3230,   225,   250,   329,   345,   252,  3866,
     277,   113,  5487,  1338,   398,  1340,   113,   119,   378,  3246,
    3247,   481,   508,  3250,  2379,   371,   271,   272,   419,  3256,
     333,  3888,  3889,  3901,  3279,  4087,   345,    34,  5372,  3786,
     468,   143,   526,   288,   225,   271,   143,   407,   397,    81,
    5338,  4405,  4406,   481,    86,   401,   300,  4156,  4157,  4441,
     433,   305,   435,  3533,   245,  6231,  6232,   551,   289,   378,
     556,   315,   317,  3622,  3623,   320,   570,   571,   572,   573,
     574,   575,   271,  5892,   430,   458,  1949,    85,   333,  1952,
      88,   336,    97,   579,   432,  4094,   434,  2744,   407,   582,
     344,  3328,   345,   586,  4305,  2379,   582,   333,   329,   331,
     586,  3652,   117,   440,   336,  3945,   566,   567,   568,   444,
     570,   571,   572,   573,   574,   575,    71,    72,   474,   319,
    5418,   367,  5923,  4001,  2879,   378,  2881,  3994,  2001,   383,
     579,  2742,  2005,   379,   333,  4163,   444,  5549,   250,  3652,
     277,   579,   371,   328,   299,  2697,   331,   570,   571,   572,
     573,   574,  4091,   380,   407,   578,   411,   403,  4036,   271,
     272,   566,   567,   568,   418,   570,   571,   572,   573,   574,
     575,   910,   401,   331,   580,   914,  4866,   583,   336,   918,
     567,   568,  5526,   570,   571,   572,   573,   574,   575,   928,
     929,   234,  2803,  4773,  2805,    71,   935,    71,    72,   580,
     400,   430,   583,    79,    80,    79,    80,   946,   320,  4766,
    2930,   574,    86,   397,  2874,  5340,   579,  2869,   581,  2344,
    5345,   333,  2347,  2775,  2776,   216,    75,    76,    77,    78,
     430,  2836,  4110,    82,   299,   578,   975,    86,   395,   582,
     979,   158,  4649,  4317,  2379,   474,    85,  3806,  4630,   292,
      98,   990,  4130,   566,   567,   568,   253,   570,   571,   572,
     573,   574,   575,   271,  5203,  5204,  5205,  5206,   468,  2821,
     577,   395,   579,   584,   581,   432,  1015,  4337,  4338,    72,
    4158,   481,   245,  1022,   162,   444,   433,  1026,   435,  2841,
     125,  2843,  4649,  2845,    75,    76,    77,    78,  1037,  1038,
    3403,    82,  3405,  3406,  1043,   572,   573,   574,   432,   582,
     583,   566,   567,   568,  1053,   570,   571,   572,   573,   574,
     575,  1060,  4200,   578,   481,   333,   483,   151,   371,   584,
    1069,   397,  2775,  2776,   570,   571,   572,   573,   574,   575,
    4578,   433,   474,   435,  3972,  2997,  2794,   580,   208,   582,
    2869,   508,   577,   231,   579,   277,   580,   481,   582,   483,
     220,   509,   580,  5661,   582,   225,  3026,   566,   567,   568,
     585,   570,   571,   572,   573,   574,   575,  2742,  2821,   579,
     580,   259,   579,   583,   508,    71,   579,   481,   581,   483,
     433,   128,   435,    79,    80,  3946,   274,  3948,  2841,   556,
    2843,  3638,  2845,   580,  3963,   582,  3965,   267,   286,   580,
     147,   582,   580,  4269,   582,   458,   580,  1156,   582,   580,
     331,   582,   579,  1162,   161,  1164,   580,  1166,   582,   289,
      86,   474,   556,  3946,   312,  3948,   582,   580,  2803,   582,
    2805,   570,   571,   572,   573,   574,  1185,   193,   579,   195,
     581,   580,  3932,  1192,  4238,   579,   391,   392,   570,   571,
     572,   573,   574,   575,   580,   579,   582,   153,   125,   329,
    4021,   474,   218,  2992,   211,   391,   392,   337,  2997,   562,
     563,    75,    76,    77,    78,   115,  3038,   395,    82,   582,
     583,  4241,  4242,  4243,  3046,   499,  3048,  3149,  3735,   481,
     580,   483,   582,  3740,  2869,  4686,  4687,  4688,  4021,   580,
     388,   582,   198,  1252,  1253,  3163,   273,   203,    75,    76,
      77,    78,     7,   581,   432,    82,  1069,  4086,   580,    86,
     582,  4398,   121,  4095,    19,    20,   334,  4775,  4776,   580,
    4131,   582,   334,  4134,  4135,  4136,  4137,  4138,  4139,  4140,
    4141,  4142,  4143,   580,    39,   582,   331,    42,   566,   567,
     568,   225,   570,   571,   572,   573,   574,   575,   440,   255,
     162,   317,   331,   481,   163,   483,   322,  4168,   103,   104,
     580,   327,   582,   391,   392,  2869,  3138,   181,   391,   392,
    1329,  1330,   499,   334,   454,  3038,   115,   208,   187,   580,
     508,   582,   580,  3046,   582,  3048,   580,  1346,   582,   220,
     273,  4202,  4203,   202,   225,   572,   580,   206,   582,  3856,
    1359,  4832,  1570,  1571,   181,  3862,   433,  2992,   435,   499,
    3149,  1370,  2997,   433,  5932,   435,   161,   226,   229,   231,
     229,   582,   580,  3440,   582,   579,   125,  4858,   556,   580,
      71,   582,   241,  5951,  1393,   180,   267,  1200,    79,    80,
     580,   580,   582,   582,   350,     8,   580,   259,    11,    12,
    2954,   579,   157,   269,  3279,    96,   580,   230,   289,    22,
      23,    24,   274,    26,    27,  1424,   583,   212,    31,    32,
      33,   580,  1431,   582,   286,  1434,   580,   572,   582,  5457,
     446,   580,   481,   582,   483,  4511,   265,   440,  2992,   194,
     456,   395,   585,  2997,  4742,   440,   585,  5297,   329,   580,
     312,   582,  6020,   580,  4752,   582,   337,   125,   580,  4607,
     582,   440,   153,   322,  2869,   580,  1475,   582,   580,   331,
     582,   330,   331,  3027,  3296,  3483,  3484,  3485,   432,   440,
     395,   395,  1491,  1492,   580,   440,   582,  1496,  1497,  3411,
    1499,   108,   580,  3560,   582,   579,  3418,   453,  1507,   580,
     580,   582,   582,   204,   271,   461,   365,  1516,   464,   580,
     395,   582,   203,   580,  3149,   582,   440,   432,   432,   265,
     580,  4658,   582,   580,   579,   582,   388,   481,  4035,   483,
     407,   581,  4039,  4040,   580,  4042,   582,  4044,  4045,   580,
     580,   582,   582,  1552,   485,   208,  4053,   432,   504,   581,
     580,   507,   582,  5180,   508,   579,  1565,   220,  1567,   250,
     213,   174,   225,   580,   255,   582,   481,   481,   483,   483,
     250,  1580,  6186,   454,  1583,   579,   532,  5028,  5029,   374,
    5031,  4088,   395,  3296,   137,  1594,   481,  2992,   483,   250,
     143,   547,  2997,   508,   508,  3149,   481,   580,   483,   582,
     462,   154,   556,   331,   267,   400,    75,    76,    77,    78,
     580,   213,   582,    82,  1623,   580,   580,   582,   582,   432,
     250,   213,  3411,   508,   331,   579,   289,   225,   181,  3418,
     183,   213,   580,  4781,   582,   430,   580,  3527,   582,   395,
    3527,   556,   556,  3527,   580,  3527,   582,  1656,  1657,   202,
    1659,    75,    76,    77,    78,   580,   515,   582,    82,   350,
     580,   378,   582,  1672,   579,   579,   329,   345,   481,  1678,
     483,   556,   531,   468,   337,   583,   432,   472,   580,   287,
     582,  4431,   183,   580,  3506,   582,   481,  3509,  4520,  3511,
     462,  4523,  4524,   579,   579,   508,   309,   331,   389,  1512,
      85,   395,   444,    88,   257,  1714,   326,  5215,  1717,   580,
     474,   582,   181,  1722,  1723,  3537,  3538,  4578,  5226,    75,
      76,    77,    78,  1732,  1733,   481,    82,   483,   113,    75,
      76,    77,    78,   580,   119,   582,    82,   428,   432,  5247,
    5248,   277,   355,   556,  3149,   364,   137,    75,    76,    77,
      78,   397,   508,  4901,    82,  1764,  5068,   181,   143,  1768,
    1769,   580,   453,   582,   317,   580,   579,   582,   108,   322,
     461,   481,   317,   464,  4603,  4604,  3411,  1590,   579,   485,
    1789,  1790,  1791,  3418,   579,   317,   580,   481,   582,   483,
     115,   454,    75,    76,    77,    78,   115,  1610,  3511,    82,
     556,  1810,   449,   580,  4952,   582,   359,   345,   225,  3527,
    5140,   584,   474,   504,   508,   580,   507,   582,   151,   580,
     373,   582,   560,   579,  3537,  3538,   213,   580,  1641,   582,
     580,  1840,   582,   580,  4888,   582,   449,   474,  1847,  1848,
     580,   532,   582,  4991,   213,  1854,  1659,    75,    76,    77,
      78,   213,  1861,  5505,    82,   579,   547,  3411,   580,  4691,
     582,   246,   556,   430,  3418,   250,   580,   580,   582,   582,
     485,   580,  5071,   582,  5073,   580,   213,   582,  5077,   213,
     582,  5080,    89,  5082,   213,   579,   271,   272,  1897,   213,
     580,   580,   582,   582,   580,  4645,   582,   213,  4859,  1908,
     331,  5049,   455,   288,  3879,  3880,  3881,  3882,   580,  3884,
     582,   580,   213,   582,  4775,  4776,   580,   213,   582,  5056,
     580,   580,   582,   582,   580,   580,   582,   582,   580,   580,
     582,   582,   580,   213,   582,   320,  1945,   580,   580,   582,
     582,   580,   580,   582,   582,  1204,   213,  1206,   333,  1762,
    1763,  4820,  1765,  4822,   331,   213,   430,   579,   108,   225,
     167,  3750,  3751,  3752,   226,   287,   225,   331,   579,   579,
     579,   225,   579,   579,   355,   579,   579,  5658,   579,   579,
     187,   342,   579,   579,   579,   579,   579,   482,   579,   579,
     579,   579,   579,  2002,   579,  5132,  5133,   269,   579,   579,
     579,   579,   579,   579,   579,   579,  3411,   579,   579,  3931,
     579,   579,   582,  3418,   108,   164,   582,   269,  2027,   287,
     271,   108,   225,   329,   225,   327,   411,   407,   572,   265,
     398,   307,   582,   180,   461,   582,   566,    14,   579,   582,
     579,  5549,   579,  4212,   440,   440,   395,   581,   440,   154,
     440,   395,   440,   395,  2063,  4850,   440,  3879,  3880,  3881,
    3882,   440,  3884,   399,   555,   213,   331,   331,   284,   440,
     440,  5219,   322,   555,   555,   555,   331,  2086,  3975,   461,
     440,   432,  2091,   255,   327,   579,   440,   244,  4917,   579,
     154,   430,   345,   582,   250,   213,   462,  2106,  4034,   462,
    4850,  4031,  3924,  3925,   175,   440,   125,   125,   440,   440,
    3932,   335,   432,  2122,   440,  3750,  3751,  3752,   114,  5449,
    5450,   114,   440,   440,   582,  5576,   440,   440,   440,  5441,
     440,  5758,   440,   407,   331,  5586,   331,   485,   271,   579,
     481,   471,  3931,  4210,  3966,  2154,   579,   579,   108,   107,
      97,  2160,   331,   213,   317,  2164,   579,  2166,  2167,  4034,
    4227,   181,   462,   213,   473,  4672,   295,   327,  2177,   108,
     481,   317,   579,  4680,  4681,   579,   225,   108,   277,   581,
    2189,  2190,   567,   568,   396,   570,   571,   572,   573,   574,
     575,  2200,  5021,   462,  2203,  5343,  3750,  3751,  3752,   213,
     213,   213,   462,   213,  2213,   213,    14,   582,  4216,  4217,
    4218,  4219,   326,   440,   321,   230,   477,   438,   499,  3932,
     579,   579,    88,   309,  5361,   309,  5124,   580,   438,   407,
    5681,   440,   582,   238,   579,   221,  5068,   442,   230,   582,
     244,   579,    85,     2,  2253,    88,   244,  5068,  4170,   275,
     267,   566,   332,    34,   409,   582,  5554,   580,   579,    10,
    5941,   339,  5282,   462,   125,   440,   440,   395,   153,  5289,
     113,   395,   462,  4095,   275,   582,   119,   582,   275,   322,
    3998,  5303,   580,  2292,  2293,   580,   580,   579,   322,   440,
    4008,  2300,   579,   474,  2303,  5593,  3931,   440,  2307,   440,
     143,   397,   444,  2312,   277,   115,  2315,  2316,   331,    89,
     414,   322,   174,   348,  2323,   174,  4034,  2326,  2327,  2328,
    2329,   348,   434,   348,   440,   113,  5436,   481,  2337,  2338,
      89,  2340,   348,  2342,  2343,   127,  5787,  2346,   440,  2348,
     432,  2350,  2351,   582,   395,  3750,  3751,  3752,   378,   440,
     378,   245,   202,   271,  5215,   440,   404,   440,  2367,   108,
     367,   271,  5692,   206,   271,  5226,   271,   462,   160,  2378,
    2379,   271,   462,  5521,   330,   107,   213,  3931,   440,   577,
     566,  4170,  4095,   577,   440,  5664,  5247,  5248,   227,   225,
     327,   579,  4899,   474,   153,   404,  5665,   579,   213,  2212,
     159,   212,  5550,   246,   481,   108,   430,   250,  2221,   331,
     331,   573,   242,   242,   108,   213,  5677,   331,  5679,   225,
     212,   404,   331,   225,   216,   250,   185,   250,   271,   272,
     250,   485,    96,   236,   306,   481,   331,   582,   582,   125,
    5588,   444,   582,   582,   326,   288,  4953,  4954,  4955,  4956,
    2459,   430,   474,   277,   580,   580,   248,   580,   230,   580,
     580,   580,  2275,   580,   230,   580,   499,   580,   550,   349,
     580,   582,   580,   440,   580,    90,   579,   320,   499,  2488,
     580,   341,   580,   580,  4306,  4460,    90,   580,   478,   460,
     333,   579,   284,   478,   332,   385,  5794,   332,  5796,   468,
     579,   566,   125,   579,   289,   580,   334,   566,  4430,   583,
    4432,   580,   582,    85,  2523,  5663,    88,  2330,   331,  5667,
    5668,   582,  5317,   315,   331,   317,  3931,   580,   253,   213,
     485,   261,   579,   105,   579,  4170,   440,  5849,   440,   440,
     322,   113,   579,  5050,  5051,   204,  4468,   119,   579,  5508,
    5570,   335,   552,   345,   511,   213,   213,   213,   253,   508,
     430,   289,  5391,   507,   350,   440,   459,  5317,   411,   440,
     297,   143,   350,   579,   297,   440,   297,   579,   395,   395,
     579,   395,   440,   440,   579,   579,   378,   440,   579,   440,
     382,   440,   440,   440,   386,   395,   213,   317,   407,   440,
     392,   114,   271,   557,   557,   557,  5401,   399,   271,  4431,
     271,   579,   577,  5633,  5634,   407,  4170,  4539,   580,   307,
    5441,   580,  5372,   289,   416,   566,   145,   449,   115,   580,
     380,   174,   424,   330,   582,  4424,   582,   580,  4460,   579,
     331,  4430,   580,  4432,   108,   440,   566,   239,   225,  4471,
    2463,  5401,  2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,
    2669,   462,  2671,   462,   395,   582,   395,   334,  5816,  5817,
     211,   395,   211,   271,   246,  2684,  2685,   317,   250,  4468,
    5187,   577,  5189,  5190,   476,   437,   204,    88,  5549,   225,
     230,   580,   580,   580,  5201,   135,   580,   473,  4520,   271,
     272,  4523,  4524,   582,   230,   579,   337,   580,   478,   501,
     230,   579,   564,   582,  4611,  6045,   288,   238,  4431,   582,
     566,  4543,   332,   579,   579,  4547,   580,   570,   571,   572,
     573,   574,   575,  2742,   566,  4557,  4558,   449,   530,   225,
    2749,   108,  6021,   462,   462,   317,  4568,   580,   320,   580,
    4539,   440,   544,   261,   125,   432,   449,  2766,   579,   213,
     579,   333,   440,   395,   336,  4170,  2775,  2776,   440,   440,
     440,   395,   440,   225,   579,   125,   580,   176,   432,   225,
     143,   213,   174,   580,   580,   483,   580,   449,   271,  4424,
     271,   578,   363,   275,  2803,  4430,  2805,  4432,   481,   202,
     579,   404,   579,   485,   579,   202,   579,  4520,   582,   225,
    4523,  4524,   580,   582,   256,   148,  2825,   579,   432,   582,
     440,   579,    85,  4645,   580,    98,   404,   235,   174,   193,
     230,   579,   271,  4468,  2843,   271,  2845,   271,  6168,   411,
     271,   580,  2851,   230,  4557,  4558,  2855,  2856,   372,   125,
     479,   479,   274,   274,   580,  4880,  2865,   125,   580,   240,
    2869,  2870,   340,   579,  2873,   582,   580,   580,   579,  4691,
    4424,   580,   145,  6203,   579,  1082,  4430,  1084,  4432,  1086,
     580,  6211,  5090,   327,   580,  1092,  2895,   566,   580,  2898,
     449,   650,   440,   230,   481,  5090,   143,   255,   579,  4874,
    2909,    88,   175,   432,  4539,   322,   566,  2916,  1115,  1116,
     322,   125,   269,  5811,  4468,  6245,   432,   582,   566,   105,
     213,  4639,   271,   196,   438,   580,   551,   529,   440,   582,
     582,  2940,  4645,   578,   207,   232,  6135,   462,   230,  6138,
    6139,   250,  6141,   108,   199,  2954,   477,   462,   481,   579,
     230,  2960,  2961,   481,   227,   258,   334,  2966,   579,   232,
    2969,   230,   372,   230,  2973,   467,   579,  4685,   579,   417,
     274,   580,  2981,   580,  4949,   348,  6175,   480,  4691,  6178,
    6179,  2794,  6181,  2992,  2993,  4539,   579,   331,  2997,   579,
     373,   580,   580,   440,   566,   567,   568,   579,   570,   571,
     572,   573,   574,   575,   559,   278,   559,   440,   580,   579,
     582,   579,   579,  5808,   481,   225,   188,   322,  3027,  4424,
    3029,  3030,   514,  4845,  3033,  4430,   299,  4432,  5849,   108,
     580,  1238,   322,   298,   253,  5542,   363,   579,   212,   108,
     348,   579,  3051,   580,  4866,  1252,  1253,   579,   335,   392,
    1257,   392,  4874,  3062,   125,   582,   566,   580,  5808,   125,
     108,   108,   579,  4468,   432,    88,  3075,   462,    82,   580,
     432,   580,    85,   579,   579,    88,   580,  3086,  3087,   579,
     315,   582,   331,   580,  3093,   432,   404,   219,   363,   362,
     125,   137,   105,   334,   137,   194,   466,  1304,    85,   579,
     113,   372,  5609,   579,   108,   582,   119,   467,   230,   478,
     580,   580,   432,   370,   582,   225,   389,   199,   255,   331,
     481,  3130,   395,  3132,  5099,   331,   579,  4949,   401,   108,
     143,   108,  4845,   334,  4539,   334,   579,   516,  4856,   580,
    3149,   579,   579,   125,   510,   580,  3155,   522,   391,   929,
     580,  3160,   186,  4866,  4943,   935,   580,   430,   551,   432,
     460,    82,   391,   269,   579,   579,   946,  4989,  4990,   209,
      94,   580,  4994,  4995,   216,  5682,   449,   331,    85,   105,
     545,    88,   537,  3192,   289,   579,   212,   335,   391,   566,
     535,   529,   363,   579,   566,   975,   125,   556,  3207,   979,
     959,   474,   556,   579,  3213,   322,   113,   514,  3217,  5090,
     990,   510,   119,   566,   545,   551,   289,   387,  2125,  2004,
    3810,  5412,  3161,   579,  1723,  3728,  3511,   579,   579,  1330,
    4430,  5390,  1300,   246,  5684,  3080,   143,   250,  3918,  5439,
    1329,  4538,  5849,  5499,  4601,  3254,  5068,  5505,  5117,  5485,
    3629,  3284,  5374,  3262,  5930,  5316,  6015,  5863,   271,   272,
    5862,  5960,  5737,  1022,  1023,  3633,  5349,  3781,  4394,  5091,
    5092,  5093,  5094,  5095,  4438,   288,  6249,  5099,  5381,  6195,
    6100,  6185,  6238,  6143,  5751,  6274,  6189,  3152,  4591,  3152,
    4424,  3751,  2109,  3146,  3303,  3986,  6030,  6223,  6122,   206,
    5478,  1060,  3931,  4644,   317,  5971,  3315,   320,  4943,  1516,
    5403,  2099,  5836,  5948,  5406,   187,  1553,  3326,  4694,  5607,
     333,  3330,  1568,   336,  4647,  2856,  3605,  3336,  4649,  5758,
    3860,  5993,  6151,  1023,  1179,  2744,  3527,  2745,  1518,   246,
    2213,  4628,  4857,   250,  3353,  3354,  6101,  3266,  4302,  1510,
    3359,  1751,  1194,  5777,  3530,  5068,  2792,  1772,  1771,  3545,
    1119,  2766,  5918,  5798,   271,   272,  1774,  3565,  2791,  3557,
    4227,  4805,  5584,  4821,  1779,  3384,  3385,  4224,  5780,  5779,
    3389,   288,  4303,  4185,  5552,  4172,  5921,  5909,  5922,  4943,
    6001,  1150,  5299,  1184,  3403,  3404,  3405,  3406,   411,  3533,
    1159,  3454,  3411,  4178,  1163,  1164,  1165,  3355,  3417,  3418,
    3452,  3420,  2684,   320,  4298,  1672,   650,  3426,  4031,  2148,
    3218,  2825,  5901,   396,  1791,  1062,   333,  3436,  3437,  2800,
    1785,  3440,  1564,  2833,  3505,  1275,  6186,  1255,  2841,  2834,
    4309,  1697,  4844,  1255,  3453,  4310,  3455,  4274,   429,  2845,
    3459,  2242,  1441,  3280,  1496,  5090,     2,  1095,  4859,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3478,
    5292,    -1,  1252,  1253,    -1,    -1,    -1,    -1,    -1,  3488,
      -1,    -1,  3491,  3492,  3493,  1789,    85,    -1,    -1,    88,
    5412,    -1,    -1,  1252,  1253,    -1,    -1,    -1,  1257,    -1,
      -1,    -1,  3511,  6010,   411,    -1,  3515,    -1,    -1,    -1,
    1717,    -1,    -1,    -1,   113,  1722,  1723,  5439,    -1,    -1,
     119,  3530,    -1,    -1,    -1,    -1,  5593,    -1,    -1,   918,
      -1,    -1,    -1,    -1,    -1,    -1,  3545,    -1,  4943,   928,
      -1,    -1,    -1,    -1,   143,    -1,    -1,    -1,  3557,    -1,
    5372,    -1,    -1,   566,   567,   568,    -1,   570,   571,   572,
     573,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,   582,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5292,
      -1,    -1,    -1,    -1,    -1,    -1,  3595,    -1,    -1,  3598,
      -1,  3600,    -1,  5490,    -1,    -1,  3605,    -1,  3607,    -1,
      -1,    -1,    -1,  1810,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,  3622,  3623,    -1,    -1,    -1,    -1,  3628,
      -1,    -1,    -1,  5412,    -1,    -1,    -1,  3440,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1026,    -1,    -1,
    3649,  3454,    -1,  3652,   160,    -1,  3655,   246,  1037,    -1,
    5439,   250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5372,
    3473,    -1,    -1,   570,   571,   572,   573,   574,   575,    -1,
      -1,    -1,   271,   272,    -1,  3488,    -1,    -1,  1885,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,   288,
      -1,    -1,  3701,    -1,    -1,    -1,   212,    -1,    -1,  3708,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    84,  3527,    -1,  3725,    -1,    89,    -1,
      -1,   320,    -1,    -1,    -1,    -1,    -1,  3736,    -1,    -1,
      -1,    -1,   248,  1492,   333,    -1,    -1,  1496,  1497,    -1,
    1499,  3750,  3751,  3752,  3557,    -1,   117,  3560,    -1,    -1,
    1957,  3760,    -1,  1960,  1961,    -1,    -1,  1516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   284,    -1,
      -1,  5489,  3781,    -1,    -1,  3784,    -1,  5412,    -1,    -1,
      -1,    -1,    -1,    -1,  3793,    -1,  3795,  3796,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,  3806,    -1,   315,
      -1,   317,  1561,    -1,  5439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1583,    -1,  2033,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   216,    -1,   218,  3857,    -1,
      -1,    -1,    -1,    -1,  5643,    -1,    -1,    -1,  5412,   230,
      -1,    -1,    -1,    -1,    -1,    -1,   382,    -1,   384,    -1,
     386,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,
      -1,    -1,    -1,   399,    -1,  5439,  3895,    -1,    -1,    -1,
      -1,   407,  3901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     416,    -1,  1661,    -1,    -1,    -1,    -1,    -1,   424,    -1,
      -1,    -1,  1671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3931,  3932,    -1,    -1,  1685,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3946,    -1,  3948,
      -1,    -1,    -1,  5765,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3963,  1714,  3965,    -1,  1717,  1718,
     476,    -1,    -1,  1722,  1723,    -1,    -1,   566,   567,   568,
    1359,   570,   571,   572,   573,   574,   575,    -1,    -1,    -1,
      -1,  1370,    -1,    -1,    -1,   501,    -1,  6054,    -1,    -1,
      -1,    -1,  4001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5412,  5643,    -1,
      -1,    -1,  4021,  4022,   530,    -1,    -1,  5735,    -1,    -1,
      -1,    -1,    -1,    -1,   395,    -1,    -1,  4036,   544,    -1,
    1810,    -1,    -1,    -1,  5439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1431,  4052,    -1,  1434,    -1,    -1,    -1,    -1,
      -1,  1810,    -1,    -1,    -1,    -1,    -1,  4066,    -1,   430,
    4069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4086,    -1,    -1,
    4089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5643,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4107,    -1,
      -1,  4110,    -1,  5993,    -1,    -1,  5993,    -1,  4117,  5993,
      -1,  5993,    -1,    -1,  4123,    -1,  4125,    -1,    -1,    -1,
    6042,  4130,  4131,    -1,    -1,  4134,  4135,  4136,  4137,  4138,
    4139,  4140,  4141,  4142,  4143,    -1,    -1,    -1,  4147,  4148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4158,
      -1,    -1,    -1,    -1,  4163,    -1,    -1,    -1,  4167,  4168,
      -1,  4170,    -1,  4172,  6054,    -1,    -1,  6054,  4177,    -1,
    6054,    -1,  6054,    -1,    -1,    -1,    -1,    -1,  4187,    -1,
    6102,  4190,    -1,  4192,    -1,  3998,    -1,    -1,    -1,    -1,
      -1,  4200,  4201,  4202,  4203,  4008,    -1,    -1,  4207,    -1,
    6122,  4210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1973,  4224,    -1,    -1,  4227,    -1,
    6042,  4034,  2002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4239,    -1,    -1,    -1,    -1,    -1,  4245,  4246,  5643,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6042,  5972,    -1,    -1,    -1,    -1,    -1,
      -1,  6151,    -1,  6185,  6151,  6187,    -1,  6151,    -1,  6151,
      -1,    -1,    -1,    -1,    -1,  5993,  6098,    -1,    -1,    -1,
      -1,    -1,    -1,  4292,    -1,    -1,    -1,    -1,  2047,  4298,
      -1,    -1,    -1,    -1,    -1,  4304,    -1,  6119,    -1,    -1,
    6122,  6223,    -1,    -1,    -1,    -1,    -1,  6129,    -1,    -1,
      -1,  4320,    -1,  6102,    -1,    -1,  6238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2106,  4336,    -1,  6042,
      -1,    -1,    -1,  6122,    -1,    -1,  6054,    -1,    -1,    -1,
      -1,    -1,  2122,    -1,    -1,    -1,    -1,    -1,    -1,  2108,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4367,    -1,
      -1,    -1,    -1,    -1,  6186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4386,  4387,  4388,
    4389,    -1,    -1,    -1,    -1,    -1,    -1,  2167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6185,  4210,  6187,    -1,
      -1,  6223,    -1,    -1,  4413,    -1,    -1,  6042,    -1,  6122,
    2190,  4224,    -1,    -1,  4227,  4424,    -1,    -1,  6240,    -1,
      -1,  4430,  4431,  4432,    -1,    -1,    -1,    -1,    -1,  4438,
      -1,    -1,    -1,  6151,  6223,    -1,    -1,    -1,    -1,    -1,
      -1,  2200,    -1,    -1,  2203,    -1,  6268,    -1,    -1,  6238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4468,
      -1,    85,    -1,    -1,    88,    -1,    -1,  6102,    -1,    -1,
      -1,    -1,    -1,  6186,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4490,    -1,    -1,  4493,    -1,    -1,  6122,  6042,   113,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,    -1,
    4539,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   910,
      -1,    -1,    -1,   914,    -1,    -1,    -1,    -1,  6102,    -1,
    6185,    -1,  6187,  2312,    -1,    -1,   113,    -1,   929,    -1,
      -1,    -1,   119,    -1,   935,    -1,    -1,    -1,  6122,  4578,
      -1,    -1,    -1,    -1,    -1,   946,    -1,    -1,    -1,    -1,
      -1,    -1,   206,    -1,    -1,    -1,   143,    -1,  6223,    -1,
      -1,    -1,    -1,    -1,  4603,  4604,    -1,    -1,  4607,    -1,
      -1,  4610,    -1,  6238,   975,    -1,    -1,    -1,   979,    -1,
      -1,    -1,    -1,    -1,  2821,    -1,    -1,    -1,  2825,   990,
      -1,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,    -1,
      -1,  6185,    -1,  6187,  2841,  4644,  4645,  6042,    -1,    -1,
    4649,  4650,  4651,    85,    -1,    -1,    88,   271,   272,   206,
      -1,  1022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   288,    -1,    -1,  1038,    -1,  6223,
      -1,   113,  1043,    -1,    -1,    -1,    -1,   119,    -1,    -1,
      -1,    -1,  1053,    -1,  6238,  4694,    -1,    -1,    -1,   246,
      -1,    -1,    -1,   250,    -1,    -1,   320,  6102,  1069,    -1,
      -1,   143,    -1,    -1,  4713,    -1,    -1,    -1,    -1,   333,
      -1,    -1,    -1,    -1,   271,   272,    -1,  6122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,  4742,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4752,    95,    -1,    -1,    -1,    -1,    -1,
     101,    -1,    -1,    -1,  4763,  4764,    -1,  4766,    -1,  4768,
      -1,    -1,    -1,   320,    -1,  2154,  4775,  4776,    -1,    -1,
      -1,  4780,  4781,    -1,    -1,  2164,   333,  4786,  4787,    -1,
    6185,  4790,  6187,    -1,  4793,    -1,    -1,   411,    -1,    -1,
     141,  1162,    -1,  1164,    -1,  1166,    -1,    -1,  4807,    -1,
      -1,    -1,    -1,    -1,   246,    -1,  4815,    -1,   250,    -1,
    4819,    -1,    -1,    -1,  1185,    -1,    -1,    -1,  6223,    -1,
      -1,    -1,  4831,    -1,    -1,    -1,  4639,  4836,    -1,   271,
     272,  3038,  4841,  6238,    -1,    -1,    -1,    -1,    -1,  3046,
     191,  3048,    -1,    -1,    -1,    -1,   288,   198,    -1,    -1,
     201,    -1,    -1,    -1,   411,    -1,    -1,  4866,    -1,    -1,
      -1,    -1,    -1,    -1,  2253,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4685,    -1,  4883,   317,    -1,    -1,   320,    -1,
      -1,  1252,  1253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   333,  4901,    -1,   336,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,  4917,    -1,
      -1,    -1,    -1,  4922,  4923,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4932,    -1,    -1,    -1,    -1,    -1,  4938,
      -1,    -1,    -1,    -1,  4943,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4952,    -1,    -1,   570,   571,   572,   573,
     574,   575,    -1,    -1,    -1,    -1,  2715,  4966,  1329,  1330,
      -1,    -1,    -1,    -1,   315,    -1,   317,    -1,    -1,   411,
      -1,    -1,    -1,    -1,    -1,  1346,   327,  4986,    -1,    -1,
      -1,    -1,  4991,    -1,   335,    -1,    -1,    -1,    -1,  4998,
      -1,    -1,    85,    -1,   345,    88,    -1,    -1,    -1,    -1,
      -1,    -1,  4815,    -1,    -1,    -1,  4819,    -1,    -1,    -1,
      -1,    -1,  5021,   570,   571,   572,   573,   574,   575,    -1,
     113,    -1,    -1,    -1,    -1,    -1,   119,   378,    -1,    -1,
     381,   382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5049,    -1,    -1,  4856,    -1,  2825,    -1,    -1,    -1,    -1,
     143,    -1,    -1,  1424,    -1,    -1,   407,    -1,    -1,  5068,
      -1,    -1,    -1,    -1,    -1,    -1,  2825,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5090,  2841,    -1,  2843,  2865,  2845,    -1,    -1,  3296,
    2870,    -1,    -1,  2873,    -1,    -1,   447,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1475,    -1,  5115,    -1,    -1,    -1,
      -1,    -1,    -1,   206,   465,  2895,    -1,  5126,    -1,    -1,
    1491,  1492,    -1,    -1,   566,   567,   568,    -1,   570,   571,
     572,   573,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,
     582,    -1,    -1,    -1,    -1,  1516,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,
    2940,   512,   513,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,  5180,    -1,    -1,    -1,    -1,    -1,    -1,   271,   272,
    2960,  1552,    -1,   105,    95,    -1,    -1,  2946,    -1,    -1,
     101,   113,    -1,  5202,    -1,   288,  1567,   119,    -1,    -1,
      -1,    -1,    -1,   554,    -1,    -1,  5215,    -1,    -1,  1580,
    5219,    -1,  1583,  2993,    -1,   126,    -1,  5226,    -1,    -1,
      -1,   143,    -1,    -1,    -1,    -1,    -1,   320,    -1,  5238,
     141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5247,  5248,
     333,    -1,  5251,    -1,    -1,    -1,    -1,    -1,    -1,  3029,
      -1,    -1,    -1,  3033,    -1,  5264,    -1,    -1,    -1,    -1,
      -1,  5270,   173,    -1,    -1,    -1,  5275,    -1,    -1,  5278,
      -1,  3051,    -1,    -1,  5283,  5284,    -1,    -1,    -1,    -1,
     191,    -1,  3062,    -1,    -1,    -1,    -1,   198,    -1,    -1,
     201,    -1,    -1,    -1,    -1,  3075,    -1,    -1,    -1,    -1,
      -1,  5310,    -1,  5312,  3511,    -1,  3086,  5316,    -1,    -1,
      -1,    -1,    -1,  3093,    -1,    -1,    -1,    -1,   411,    -1,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,   250,    -1,
      -1,  5340,    -1,    -1,  5343,    -1,  5345,  5346,    -1,  5348,
      -1,   252,    -1,  1714,   255,  5354,    -1,    -1,    -1,   271,
     272,  1722,  1723,    -1,    -1,    -1,  3115,    -1,    -1,    -1,
      -1,    -1,  1733,  5372,  3123,    -1,   288,    -1,    -1,  5378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5391,    -1,    -1,    -1,    -1,    -1,    -1,   300,
      -1,  5400,    -1,    -1,   305,   317,    -1,    -1,   320,    -1,
      -1,    -1,    -1,  5412,   315,    -1,   317,    -1,    -1,    -1,
      -1,   333,    -1,    -1,   336,    -1,   327,  3176,  1789,  1790,
    1791,    -1,    -1,    -1,   335,    -1,    -1,    -1,    -1,    -1,
    5439,    -1,  5441,   344,   345,    -1,    -1,    -1,    -1,  1810,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,  5457,    -1,
      -1,  3210,   101,    -1,    -1,    -1,    -1,  5270,  3217,    -1,
      -1,    -1,  5275,    -1,    -1,  5278,    -1,   378,    -1,  1840,
     381,   382,   383,    -1,    -1,    -1,  1847,   570,   571,   572,
     573,   574,   575,  1854,    -1,    -1,    -1,    -1,    -1,   411,
    1861,    -1,   141,    -1,    -1,  3254,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,
      -1,    -1,  5521,    -1,    -1,  5524,    -1,  5526,    -1,    -1,
    2909,    -1,    -1,  3303,    -1,    -1,  1897,  2916,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   447,    -1,  5547,    -1,
    5549,  5550,   191,  5552,    -1,  5554,  3326,    -1,    -1,   198,
      -1,    -1,   201,    -1,   465,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5574,    -1,    -1,    -1,    -1,
    5579,    -1,    -1,    -1,  5583,    -1,    -1,    -1,   930,  5588,
      -1,    -1,    -1,    -1,  5593,    -1,   938,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   947,    -1,    -1,    -1,    -1,
      -1,   512,   513,    -1,    -1,   957,   255,    -1,    -1,    -1,
     962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5637,    -1,
      -1,  2002,    -1,    -1,  5643,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   554,   566,   567,   568,    -1,   570,   571,
     572,   573,   574,   575,  5663,    -1,    -1,    -1,  5667,  5668,
     582,    -1,    -1,    -1,    -1,    -1,   315,    -1,   317,    -1,
      -1,    -1,  3879,  3880,  3881,  3882,  5489,  3884,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   345,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5714,    78,    -1,    -1,    -1,
      -1,    -1,    84,    -1,    -1,  2086,    -1,    89,    -1,    -1,
      85,    -1,    -1,    88,  5733,  3932,    -1,    -1,    -1,   378,
      -1,    -1,   381,   382,    -1,  2106,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    -1,    -1,   117,    -1,    -1,   113,  5758,
      -1,  2122,  3511,    -1,   119,    -1,  5765,    -1,   407,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5777,    -1,
    5583,  5780,    -1,    -1,    -1,  1127,    -1,    -1,   143,    -1,
    5593,    -1,    -1,    -1,    -1,  5794,    -1,  5796,    -1,  5798,
     162,    -1,    -1,    -1,    -1,  2166,  2167,    -1,   447,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2177,  5816,  5817,  1161,
      -1,    -1,    -1,  5822,    -1,    -1,   465,    -1,  2189,  2190,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3607,  1180,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5849,    -1,  2213,    -1,    85,    -1,    -1,    88,    -1,    -1,
    1202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,
      -1,    -1,    -1,   512,   513,    -1,  5875,    -1,    -1,  3649,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   246,    -1,  5892,    -1,   250,    -1,    -1,  4095,    -1,
      -1,    -1,    -1,  3652,    -1,    -1,    -1,    -1,    -1,  5908,
    5909,    -1,   143,    -1,    -1,   554,   271,   272,    85,  5918,
      -1,    88,    -1,    -1,  5923,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5735,   288,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,    -1,  5943,    -1,   113,    -1,    -1,    -1,
      -1,  3330,   119,    -1,    -1,    -1,    -1,  3336,    -1,    -1,
      -1,    -1,   317,  1305,    -1,   320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,   143,    -1,   333,    -1,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5995,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3756,    -1,    -1,
      -1,    -1,    -1,  6012,  3784,   246,    -1,    -1,  2379,   250,
      -1,    -1,    -1,    -1,    -1,    -1,  3796,    -1,    -1,    -1,
      -1,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,
     271,   272,    -1,  6042,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3804,   411,   288,    -1,    -1,
    1402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,   250,  1426,  1427,  1428,    -1,    -1,   320,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   333,  6102,   271,   272,    -1,    -1,    -1,  3488,
    3859,  6110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,  6122,    -1,  3895,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3883,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,  3900,    -1,   320,  3903,  3904,    -1,  6156,  3907,    -1,
      -1,    -1,    -1,    -1,  3913,    -1,   333,    -1,    -1,  5972,
      -1,    -1,    -1,    -1,    -1,    -1,  3925,    -1,  3557,     3,
     411,    -1,    -1,  3932,    -1,     9,  6185,  6186,  6187,    13,
    5993,    15,    -1,    17,    18,    -1,    -1,  3946,    -1,  3948,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,  1551,
      -1,   566,   567,   568,    -1,   570,   571,   572,   573,   574,
     575,    45,    46,    -1,  6223,   580,    -1,  6226,    -1,    -1,
      -1,    -1,    -1,    -1,  4431,    -1,    -1,  1579,  3987,  6238,
      -1,    -1,    -1,    -1,   411,    -1,    -1,  6246,    -1,    -1,
      -1,  6054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4460,    -1,    -1,    -1,    91,    -1,    -1,
      -1,  4020,  4021,    -1,    -1,    85,    -1,   101,    88,   103,
     104,    -1,  4052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   118,   105,    -1,    -1,    -1,  4069,
      -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,    -1,    -1,   138,    -1,   140,   141,    -1,  4089,
      -1,    -1,   146,  4520,   148,    -1,  4523,  4524,    -1,    -1,
      -1,    -1,    -1,   143,    -1,   159,    -1,   161,    -1,   570,
     571,   572,   573,   574,   575,    -1,    -1,    -1,  6151,    -1,
      -1,   175,    -1,   177,    -1,    -1,   180,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,    -1,
     194,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,
     204,  2742,    -1,    -1,    -1,    -1,    -1,  1729,   212,    -1,
     214,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,   566,
     567,   568,    -1,   570,   571,   572,   573,   574,   575,    -1,
      -1,   235,    -1,    -1,  1756,  1757,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,  4186,  1780,    -1,
     250,    -1,  2803,    -1,  2805,    -1,    -1,    -1,  4645,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   271,   272,    -1,  2825,    -1,   290,   291,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,   288,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4691,   319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2865,    -1,    -1,   317,  2869,  2870,
     320,    -1,  2873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   333,    -1,    -1,   336,    -1,    -1,    -1,
      -1,    -1,    -1,   357,  2895,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   369,    -1,    -1,   910,    -1,
     374,   375,   914,   377,    -1,    -1,    -1,    -1,   382,    -1,
      -1,    -1,    -1,   387,    -1,    -1,   390,   929,    -1,    -1,
     394,  1913,    -1,   935,    -1,   399,   400,    -1,  1920,  2940,
      -1,    -1,    85,   407,   946,    88,   410,    -1,    -1,    -1,
      -1,    -1,    -1,  2954,   418,    -1,    -1,  4367,    -1,  2960,
    2961,   411,   105,    -1,    -1,    -1,   430,    -1,    -1,    -1,
     113,  1953,    -1,   975,  1956,    -1,   119,   979,    -1,    -1,
      -1,    -1,    -1,   447,    -1,   449,    -1,    -1,   990,    -1,
      -1,  2992,  2993,   457,    -1,    -1,  2997,    -1,    -1,   463,
     143,    -1,    -1,    -1,   468,    -1,    -1,    -1,    -1,    -1,
    1992,    -1,    -1,    -1,    -1,    -1,    -1,   481,    -1,    -1,
    1022,    -1,    -1,    -1,  2006,    -1,  3027,    -1,  3029,    -1,
      -1,    -1,  3033,    -1,    -1,    -1,  1038,  4874,    -1,    -1,
      -1,  1043,  4431,  2025,    -1,    -1,    -1,  4066,    -1,    -1,
    3051,  1053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3062,    -1,    -1,    -1,    -1,    -1,  1069,    -1,    -1,
      -1,    -1,    -1,  4462,  3075,    -1,  4465,    -1,  4467,    -1,
    4490,    -1,  4471,  4493,    -1,  3086,    -1,    -1,    -1,    95,
      -1,    -1,  3093,    -1,    -1,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,
      -1,    -1,  4949,    -1,    -1,   579,   566,   567,   568,   583,
     570,   571,   572,   573,   574,   575,    -1,    -1,   271,   272,
      -1,    -1,   582,    -1,    -1,   141,    -1,    -1,    -1,    -1,
    4529,    -1,    -1,    -1,  2126,   288,  4535,  4536,  3149,  4538,
      -1,    -1,  2134,    -1,    -1,    -1,    -1,    -1,  4547,    -1,
      -1,    -1,  1164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,  4568,
    4569,  4570,  4571,  1185,    -1,   191,    -1,    -1,    -1,    -1,
     333,    -1,   198,   336,    -1,   201,    -1,    -1,    -1,    -1,
    4610,    -1,    -1,    -1,    -1,  4224,    -1,    -1,  4227,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3217,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,
    1252,  1253,    -1,  3254,    -1,    -1,  4645,  4646,    -1,    -1,
      -1,    -1,  5099,    -1,    -1,    -1,    -1,    -1,   411,    -1,
      -1,    -1,    -1,    -1,    -1,  2257,  2258,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4694,    85,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    -1,    -1,  2277,    -1,    -1,    -1,    -1,
      -1,    -1,  3303,    -1,    -1,   105,    -1,    -1,    -1,   315,
      -1,   317,    -1,   113,    -1,    -1,    -1,  4336,    -1,   119,
    4709,   327,    -1,    -1,    -1,  3326,    -1,    -1,    -1,   335,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   345,
      -1,    -1,    -1,   143,  1346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4386,  4387,  4388,
    4389,    -1,   378,    -1,    -1,   381,   382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,
    3411,    -1,   113,    -1,    -1,    -1,    -1,  3418,   119,  4438,
      -1,    -1,  1424,   566,   567,   568,    -1,   570,   571,   572,
     573,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,   582,
      -1,   447,   143,    -1,    -1,    -1,   246,    -1,    -1,    -1,
     250,    -1,    -1,    -1,  4843,    -1,  4845,  4846,    -1,   465,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   271,   272,  1475,    -1,    -1,    -1,  4866,    -1,    -1,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    88,   288,  1491,
    1492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,   512,   513,    -1,    -1,
    3511,    -1,   113,    -1,  1516,    -1,    -1,   317,   119,    -1,
     320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   333,    -1,  5372,   336,    -1,  4927,    -1,
      -1,  4930,   143,    -1,    -1,   246,    -1,    -1,   554,   250,
    1552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1567,    -1,    -1,    -1,    -1,
     271,   272,    -1,    -1,    -1,    -1,  4986,    -1,  1580,    -1,
      -1,  1583,    -1,    -1,    -1,    -1,    -1,   288,  4998,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,
      -1,   411,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,
      -1,  3622,  3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   333,    -1,    -1,   336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,  3649,   250,
      -1,  3652,    -1,    -1,    -1,    -1,    -1,    -1,  5047,  5048,
      85,    -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,
     271,   272,  5061,  5062,    -1,    -1,    -1,    -1,    -1,  5068,
     105,    -1,    -1,  5072,    -1,    -1,    -1,   288,   113,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,  2681,
      -1,    -1,  5091,  5092,  5093,  5094,  5095,    -1,    -1,    -1,
     411,    -1,  1714,    -1,    -1,    -1,   317,    -1,   143,   320,
    1722,  1723,    -1,    -1,  2706,    -1,    -1,    -1,    -1,    -1,
      -1,  1733,   333,    -1,    -1,   336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,  3750,
    3751,  3752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5148,
      -1,  2743,    -1,  2745,   127,    -1,   566,   567,   568,    -1,
     570,   571,   572,   573,   574,   575,    -1,    -1,    -1,    -1,
      -1,    -1,   582,  3784,    -1,    -1,    -1,  1789,  1790,  1791,
    5179,    -1,  5202,    -1,    -1,  3796,  4815,   160,    -1,    -1,
    4819,    -1,    -1,    -1,    -1,  3806,    -1,  2789,  1810,    -1,
     411,    -1,    -1,    -1,  5203,  5204,  5205,  5206,    -1,    -1,
      -1,   246,    -1,    -1,    -1,   250,    -1,    -1,    85,    -1,
      -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,  1840,    -1,
      -1,    -1,    -1,    -1,    -1,  1847,   271,   272,   105,   212,
      -1,    -1,  1854,   216,    -1,    -1,   113,    -1,    -1,    -1,
      -1,    -1,   119,   288,    -1,   566,   567,   568,    -1,   570,
     571,   572,   573,   574,   575,    -1,    -1,    -1,    -1,   580,
      -1,    -1,    -1,    -1,    -1,   248,   143,    -1,    -1,    -1,
      -1,    -1,   317,    -1,  3895,   320,    -1,    -1,    -1,    -1,
    5310,    -1,  5312,  4922,  4923,    -1,    -1,    -1,   333,    -1,
      -1,   336,    -1,  4932,   277,    -1,    -1,    -1,    -1,  4938,
      -1,   284,    -1,    -1,    -1,    -1,    -1,    -1,  5765,    -1,
    3931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3946,    -1,  3948,    -1,    -1,
      -1,    -1,   315,    -1,   317,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3963,    -1,  3965,   566,   567,   568,    -1,   570,
     571,   572,   573,   574,   575,    -1,    -1,    -1,    -1,   580,
      -1,    -1,    -1,  5372,    -1,    -1,   411,    -1,    -1,   246,
      -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
    2002,    -1,    -1,    -1,    -1,    -1,    -1,  2989,    -1,    -1,
      -1,    -1,    -1,    -1,   271,   272,    -1,    -1,    -1,   382,
    4021,    -1,    -1,   386,  5413,    -1,  5415,    -1,    -1,   392,
      -1,   288,    -1,  3015,    -1,    -1,   399,    85,    -1,    -1,
      88,    -1,    -1,  5432,   407,    -1,    -1,    -1,    -1,    -1,
      -1,  4052,  5441,   416,    -1,    -1,  5445,   105,  5447,    -1,
     317,   424,  5451,   320,  5453,   113,  5455,    -1,  4069,    -1,
      -1,   119,    -1,    -1,    -1,    -1,   333,    -1,    -1,   336,
      -1,    -1,    -1,    -1,  2086,  4086,    -1,    -1,  4089,    -1,
      -1,    -1,    -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2106,    -1,    -1,  5126,    -1,    -1,
      -1,    -1,    -1,   476,    -1,    -1,    -1,   480,   481,    -1,
    2122,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,
     101,    -1,    -1,    95,    -1,    -1,    -1,    -1,   501,   101,
      -1,   566,   567,   568,    -1,   570,   571,   572,   573,   574,
     575,    -1,    -1,    -1,   411,   580,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2166,  2167,    -1,   530,    -1,  4170,
     141,    -1,    -1,    85,    -1,  2177,    88,  3159,    -1,   141,
      -1,   544,    -1,    -1,    -1,    -1,    -1,  2189,  2190,    -1,
      -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,   246,    -1,
      -1,   113,   250,    -1,    -1,    -1,    -1,   119,    -1,    -1,
      -1,  2213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     191,    -1,    -1,   271,   272,    -1,    -1,   198,    -1,   191,
     201,   143,    -1,    -1,    -1,    -1,   198,    -1,    -1,   201,
     288,    -1,    -1,    -1,    -1,  5264,    -1,    -1,    -1,    -1,
      -1,  5270,    -1,    -1,    -1,    -1,  5275,    -1,    -1,  5278,
      -1,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,   317,
      -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,   255,   333,    -1,    -1,   336,   113,
      -1,    -1,    -1,   255,    -1,   119,  5685,  5316,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   566,
     567,   568,    -1,   570,   571,   572,   573,   574,   575,   143,
      -1,  5340,    -1,   580,    -1,    -1,  5345,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,  5354,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    -1,   315,    -1,   317,    -1,    -1,  6186,
      -1,    -1,    -1,   315,    -1,   317,   327,    -1,    -1,   271,
     272,    -1,    -1,   411,   335,   327,  4367,    -1,    -1,    -1,
      -1,    -1,    -1,   335,   345,    -1,   288,  2379,    -1,    -1,
      -1,  5400,    -1,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,    -1,   378,   320,    -1,
     381,   382,    -1,    -1,    -1,    -1,   378,    -1,    -1,   381,
     382,   333,   246,  4424,   336,    -1,   250,    -1,    -1,  4430,
      -1,  4432,    -1,    -1,    -1,    -1,   407,    -1,  5457,    -1,
      -1,    -1,    -1,    -1,    -1,   407,    85,   271,   272,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5849,    -1,    -1,    -1,   288,    -1,   105,  4468,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,   447,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,  4490,
      -1,    -1,  4493,   317,   465,    -1,   320,    -1,  5887,   411,
    3482,    -1,    -1,   465,   143,  5524,    -1,    -1,    -1,   333,
      -1,    -1,   336,  5923,    -1,    -1,    -1,    -1,   566,   567,
     568,    -1,   570,   571,   572,   573,   574,   575,    -1,    -1,
      -1,    -1,   580,    -1,    -1,    -1,    -1,    -1,  4539,    -1,
      -1,   512,   513,    -1,    -1,    -1,  5935,  5936,    -1,    -1,
     512,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5583,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   554,    -1,    -1,    -1,   411,    -1,    -1,
      -1,    -1,   554,    -1,    -1,    -1,    -1,  5986,  5987,    -1,
      -1,    -1,  4603,  4604,    -1,    -1,    -1,   246,    -1,  4610,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,  5637,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   271,   272,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,  6042,   566,   567,   568,    -1,   570,   571,
     572,   573,   574,   575,    -1,    -1,    -1,    -1,   580,    -1,
      -1,    -1,    85,    -1,    -1,    88,    94,    -1,   317,    -1,
      -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,  4694,   333,  5714,    -1,   336,    -1,    -1,
     113,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,  6101,    -1,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     143,    -1,    -1,  6122,    -1,   153,    -1,    -1,  6127,    -1,
    2742,    -1,   566,   567,   568,    -1,   570,   571,   572,   573,
     574,   575,    -1,   171,    -1,    -1,   580,    -1,    -1,    -1,
      -1,  5780,    -1,    -1,    -1,    -1,   184,    -1,    -1,    -1,
      -1,    -1,   411,    -1,   192,    -1,  6165,  6166,    -1,    -1,
    6169,  6170,    -1,  6172,    -1,    -1,    -1,    -1,    -1,   207,
      -1,   209,    -1,    -1,    -1,   213,    -1,  6186,    -1,    -1,
      -1,  2803,    -1,  2805,    -1,   223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   231,    -1,    -1,    95,    -1,    -1,    -1,
      -1,    -1,   101,  2825,    -1,    -1,    -1,  6216,    -1,    -1,
      -1,    -1,    -1,   246,  6223,    -1,    -1,   250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6240,    -1,    -1,    -1,    -1,  5875,    -1,   271,   272,
      -1,    -1,   141,  2865,    -1,    -1,    -1,  2869,  2870,    -1,
      -1,  2873,    -1,  5892,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2895,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,  4917,    -1,    -1,   198,
     333,    -1,   201,   336,  5943,    -1,    -1,   566,   567,   568,
      -1,   570,   571,   572,   573,   574,   575,    -1,  2940,    -1,
      -1,   580,  4943,    -1,    -1,    -1,    85,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2960,  2961,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
    3952,    -1,    -1,  3955,   113,    -1,   255,    -1,    -1,    85,
     119,    -1,    88,    -1,    -1,  4986,    -1,    -1,    -1,  3971,
    2992,  2993,    -1,    -1,    -1,  2997,    -1,  4998,   411,   105,
      -1,    -1,    -1,  3985,   143,    -1,    -1,   113,    -1,    -1,
      -1,    -1,    -1,   119,  3996,    -1,    -1,    -1,    -1,    -1,
    5021,    -1,    -1,    -1,    -1,  4007,    -1,  3029,    -1,    -1,
      -1,  3033,    -1,  4015,    -1,    -1,   315,   143,   317,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,  3051,
      -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
    3062,    -1,    -1,    -1,    -1,    -1,   345,  5068,    -1,    -1,
      -1,    -1,    -1,  3075,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3086,    -1,    -1,    -1,    -1,  5090,
      -1,  3093,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,
      -1,    -1,   381,   382,    -1,  4087,    -1,   246,    -1,    -1,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,
      -1,    -1,   271,   272,    -1,    -1,    -1,  6156,    -1,    -1,
     246,    -1,    -1,    -1,   250,    -1,    -1,  3149,    -1,   288,
      -1,    -1,    -1,   566,   567,   568,    -1,   570,   571,   572,
     573,   574,   575,    -1,    -1,   271,   272,   580,   447,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,
      -1,   320,   288,    -1,    -1,    -1,   465,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   333,    -1,    -1,   336,    -1,    -1,
      -1,  5202,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    -1,    -1,   320,  3217,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,    -1,
     336,    -1,   650,   512,   513,    -1,    -1,    -1,    -1,  4221,
    4222,  4223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   411,    -1,    -1,   554,    -1,    -1,    -1,    -1,
     108,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,   127,
      -1,  3303,   127,    -1,    -1,   411,    -1,    -1,    -1,  5310,
      -1,  5312,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3326,    35,    36,    -1,    -1,    -1,
      -1,    41,   160,    43,    44,   160,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   212,    -1,    -1,   212,   216,    -1,
    5391,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3411,
      -1,  5412,    -1,    -1,    -1,    -1,  3418,    -1,    -1,    -1,
     248,    -1,    -1,   248,   134,    -1,    -1,   566,   567,   568,
      -1,   570,   571,   572,   573,   574,   575,    -1,  5439,    -1,
    5441,   580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,
      85,    -1,   277,    88,  4436,    -1,   284,    -1,    -1,   284,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
     105,    -1,    -1,    -1,   580,    -1,    -1,    -1,   113,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   315,    -1,   317,
     315,    -1,   317,    -1,    -1,   205,    -1,    -1,    -1,    -1,
     918,   919,   920,   921,    -1,   923,    -1,   925,   143,  3511,
     928,    -1,   930,   223,    -1,   933,    -1,    -1,    -1,    -1,
     938,    -1,    -1,   941,    -1,    -1,    -1,   945,    -1,   947,
     948,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,   957,
      -1,    -1,    -1,    -1,   962,    -1,    -1,    -1,   966,    -1,
     968,    -1,   970,    -1,   382,   265,    -1,   382,   386,   977,
      -1,   386,   980,    -1,   392,    -1,    -1,   392,    -1,   987,
      -1,   399,    -1,    -1,   399,    -1,    -1,    -1,    -1,   407,
      -1,    -1,   407,  4565,    -1,    -1,    -1,    -1,   416,    -1,
      -1,   416,    -1,    -1,   304,    -1,   424,   307,    -1,   424,
      -1,    -1,  4584,    -1,    -1,  3607,    -1,    -1,  1026,    -1,
      -1,   246,   322,  1031,    -1,   250,    -1,    -1,    -1,  1037,
    3622,  3623,    -1,  1041,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4613,    -1,    -1,    -1,    -1,   271,   272,    -1,    -1,
    1058,    -1,  5643,    -1,    -1,    -1,    -1,  3649,   476,    -1,
    3652,   476,   480,   288,    -1,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   501,    -1,    -1,   501,    -1,    -1,    -1,
      -1,    -1,   317,    -1,    -1,   320,    -1,    -1,   398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1114,    -1,   333,    -1,
      -1,   336,   530,    -1,    -1,   530,    -1,    -1,    -1,  1127,
    1128,    -1,    -1,    -1,    -1,    -1,   544,    -1,    -1,   544,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1156,    -1,
      -1,    -1,  1160,  1161,   454,    -1,    -1,    -1,  3750,  3751,
    3752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   469,
      -1,    -1,  1180,    -1,    -1,    -1,  1184,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1192,    -1,   411,    -1,    -1,    -1,
      -1,    -1,  3784,    -1,  1202,    -1,    85,   497,    -1,    88,
      -1,    -1,    -1,    -1,  3796,    -1,  1214,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3806,    -1,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,  4797,  4798,  4799,  4800,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      88,    -1,    -1,    -1,   143,    -1,    -1,    -1,  5849,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   566,   105,    -1,    -1,
     570,   571,   572,   573,   574,   113,    -1,   577,   578,   579,
     580,   119,   582,   583,   584,   585,   586,  1295,    -1,  1297,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1305,    -1,  1307,
    1308,    85,    -1,  3895,    88,   143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,    -1,  5923,    -1,    -1,   119,    -1,    -1,    -1,  3931,
      -1,   566,   567,   568,    -1,   570,   571,   572,   573,   574,
     575,  1359,    -1,    -1,  3946,   580,  3948,   246,    -1,   143,
      -1,   250,  1370,    -1,    -1,    -1,  1374,    -1,    -1,    85,
      -1,  3963,    88,  3965,    -1,    -1,    -1,    -1,    -1,    -1,
    1388,    -1,   271,   272,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,    -1,    -1,  1402,    -1,    -1,   113,    -1,   288,
    1408,  1409,    -1,   119,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,  1426,  1427,
    1428,    -1,    -1,  1431,  1432,    -1,  1434,   143,   317,  4021,
    1438,   320,    -1,   271,   272,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   333,    -1,    -1,   336,    -1,    -1,
     288,  6042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4052,  1469,   246,  1471,  1472,    -1,   250,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4069,    -1,   317,
      -1,    -1,   320,    -1,    -1,    -1,    -1,   271,   272,    -1,
      -1,    -1,    -1,    -1,  4086,   333,    -1,  4089,   336,  1507,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,  6102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,  6122,    -1,   317,   250,    -1,   320,    -1,  1546,  1547,
      -1,    -1,    -1,  1551,    -1,  1553,    -1,    -1,    -1,   333,
      -1,    -1,   336,    -1,    -1,   271,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1576,    -1,
      -1,  1579,   288,   411,  1582,    -1,    -1,    -1,  4170,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1594,    -1,    -1,    -1,
      -1,    95,    -1,    -1,  6185,    -1,  6187,   101,    -1,    -1,
      -1,   317,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,
      -1,  5183,    -1,    -1,    -1,  1623,    -1,   333,    -1,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,   411,    -1,    -1,
      -1,    -1,  6223,    -1,    -1,    -1,    -1,   141,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6238,  1656,  1657,
      -1,  1659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1678,    -1,    -1,    -1,    -1,    -1,    -1,   566,   567,   568,
      -1,   570,   571,   572,   573,   574,   575,   191,    -1,    -1,
      -1,   580,  1700,  1701,   198,   411,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1729,    -1,    -1,  1732,    -1,    -1,    -1,   566,   567,
     568,    -1,   570,   571,   572,   573,   574,   575,    -1,    -1,
      -1,    -1,   580,    -1,    -1,    -1,    -1,    -1,  1756,  1757,
      -1,   255,    -1,    -1,    -1,    -1,  1764,    -1,    -1,    -1,
    1768,  1769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1779,  1780,  1781,    -1,  4367,    -1,    -1,    -1,    -1,
      -1,    -1,   566,   567,   568,    -1,   570,   571,   572,   573,
     574,   575,    -1,    -1,    -1,    -1,   580,    -1,    -1,    -1,
    1808,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   315,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   335,  4424,    -1,    -1,    -1,    -1,    -1,  4430,    -1,
    4432,   345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1393,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
      -1,    -1,   578,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   378,    -1,  4468,   381,   382,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5467,    -1,    -1,  4490,    -1,
      -1,  4493,    -1,   407,    -1,  1913,  1914,    -1,    -1,    -1,
      -1,    -1,  1920,    -1,    -1,  1923,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    85,  5508,    -1,    88,  1947,
      -1,    -1,    -1,   447,    -1,  1953,    -1,  4539,  1956,    -1,
      -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,
      -1,   465,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,  1980,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1988,  1989,  1990,  1991,  1992,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,  2006,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   512,   513,
       5,  4603,  4604,    -1,    -1,  2023,    -1,  2025,  4610,    -1,
      -1,  1565,    -1,    -1,    -1,    -1,    -1,  2035,  2036,    -1,
      25,    -1,    -1,    -1,    -1,  2043,    -1,    -1,    -1,    -1,
      35,    36,    -1,    -1,    -1,    -1,  5618,    -1,    43,    44,
     554,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,  2085,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,
     250,    -1,  4694,    -1,  2112,  2113,  2114,  2115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2126,    -1,
      -1,   271,   272,    -1,    -1,    -1,  2134,    -1,    -1,    -1,
    2138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   134,
      -1,    -1,    -1,    -1,    -1,    -1,  2154,    -1,    -1,    -1,
      -1,    -1,    -1,  2161,    -1,    -1,  2164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2174,   317,    -1,    -1,
     320,  2179,    -1,  1717,    -1,    -1,    -1,    -1,    -1,    -1,
    2188,    -1,    -1,   333,    -1,    -1,   336,    -1,  2196,  2197,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,    -1,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2244,    -1,    -1,    -1,
      -1,    -1,    -1,  2251,    -1,  2253,    -1,    -1,   243,  2257,
    2258,    -1,  2260,    -1,    -1,    -1,    -1,    -1,    -1,  2267,
      -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2277,
     265,    -1,    -1,    -1,    -1,   425,  2284,  2285,    -1,    -1,
    2288,    -1,    -1,    -1,  2292,  2293,    -1,    -1,    -1,    -1,
      -1,    -1,  2300,    -1,    -1,  2303,    -1,    -1,    -1,  2307,
      -1,    -1,    -1,    -1,  1848,    -1,    -1,  2315,  2316,   304,
      -1,    -1,   307,    -1,    -1,  2323,    -1,  2325,  2326,  2327,
    2328,  2329,    -1,    -1,    -1,  4917,    -1,   322,    -1,  2337,
    2338,    -1,  2340,    -1,  2342,  2343,    -1,    -1,  2346,    -1,
    2348,    -1,  2350,  2351,    -1,    -1,  2354,    -1,    -1,    -1,
      -1,  4943,    -1,    -1,    -1,    -1,    85,    -1,    -1,    88,
      -1,    -1,    -1,    -1,  1908,    -1,    -1,    -1,    -1,    -1,
    2378,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,  4986,    -1,  2404,    -1,    -1,    85,
      -1,  1945,    88,   398,    -1,    -1,  4998,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   143,    -1,   566,   567,   568,   105,
     570,   571,   572,   573,   574,   575,    -1,   113,    -1,  5021,
      -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,
      -1,  2459,    -1,    -1,    -1,    -1,    -1,   143,    -1,   454,
     189,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   469,    -1,  5068,    -1,    -1,    -1,
    2488,    -1,   105,  2027,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,    -1,   119,    -1,  5090,    -1,
      -1,    -1,   497,    -1,    -1,    -1,    -1,  1393,    -1,  6081,
      -1,    -1,    -1,    -1,    -1,  2523,    -1,   246,    -1,  2063,
     143,   250,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,   271,   272,   230,    -1,    -1,  2091,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,
     246,    -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,   141,
      -1,   566,    -1,    -1,    -1,   570,   571,   572,   573,   574,
      -1,    -1,   577,   578,   579,   271,   272,    -1,   317,   584,
     585,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   288,    -1,   333,    -1,    -1,   336,    -1,    -1,
    5202,    -1,    -1,    -1,    -1,    -1,  2160,    -1,    -1,   191,
      -1,    -1,    -1,   246,    -1,    -1,   198,   250,    -1,   201,
      -1,   317,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,   271,   272,
     336,    -1,    -1,  2661,  2662,  2663,  2664,  2665,  2666,  2667,
    2668,  2669,    -1,  2671,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2681,    -1,    -1,  2684,  2685,    -1,  1565,
      -1,    -1,   411,   255,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,  2706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     333,    -1,    -1,   336,    -1,    -1,    -1,    -1,  5310,    -1,
    5312,    -1,    -1,    -1,    -1,   411,    -1,    -1,    -1,    -1,
      -1,   354,    -1,   462,    -1,  2743,    -1,  2745,    -1,    -1,
      -1,  2749,    -1,   315,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,  2766,    -1,
      -1,    -1,    -1,   335,    -1,    -1,    -1,  2775,  2776,    -1,
      -1,    -1,    -1,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2789,    -1,    -1,    -1,    -1,    -1,  2795,   411,  2797,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,  5391,
      -1,    88,    -1,    -1,    -1,    -1,   378,    -1,    -1,   381,
     382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
    5412,   108,    -1,  2367,    -1,    -1,   113,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   407,    -1,   566,   567,   568,
      -1,   570,   571,   572,   573,   574,   575,  5439,    -1,  5441,
      -1,    -1,    -1,    -1,    -1,    -1,   143,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2874,    -1,    -1,    -1,
      -1,  2879,    -1,  2881,    -1,   447,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
    2898,    -1,    -1,   465,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2909,    -1,  2911,  2912,  2913,    -1,    -1,  2916,    -1,
    2918,    -1,  2920,    -1,  2922,    -1,  2924,  2925,    -1,    -1,
      -1,    -1,  2930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     512,   513,    -1,   566,   567,   568,    -1,   570,   571,   572,
     573,   574,   575,    -1,    -1,    -1,  2964,    -1,    -1,   246,
      -1,    -1,  1848,   250,    -1,    -1,    -1,  2975,    -1,    -1,
      -1,    85,    -1,    -1,    88,  2983,    -1,    -1,    -1,    -1,
      -1,  2989,   554,    -1,   271,   272,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,   288,    -1,    -1,    -1,   119,    -1,  3015,    -1,    -1,
      -1,  3019,  3020,    -1,    85,    -1,    -1,    88,  3026,    -1,
      -1,    -1,  1908,    -1,    -1,    -1,    -1,    -1,    -1,   143,
     317,    -1,    -1,   320,   105,    -1,  3044,   108,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,   333,    -1,   119,   336,
      -1,  5643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1945,
      -1,    -1,    -1,  3071,    -1,  3073,  3074,    -1,    -1,    -1,
      -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3116,    -1,
      -1,    -1,    -1,  3121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3130,    -1,   411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,    -1,
      -1,  2027,    -1,    -1,    -1,    -1,  3154,    -1,    -1,  3157,
      -1,  3159,    -1,  3161,    -1,    -1,  3164,   271,   272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,   246,    -1,  2063,    -1,   250,
      -1,    -1,  3190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3200,  3201,    -1,    -1,    -1,    -1,    -1,    -1,
     271,   272,    -1,   317,    -1,  2091,   320,    -1,    -1,    -1,
    3218,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,   333,
      -1,    -1,   336,    -1,    -1,    -1,    -1,  3235,    -1,  3237,
    3238,  3239,  3240,    -1,    -1,    -1,    -1,   351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,
      -1,    -1,    -1,    -1,  3262,   161,    -1,  5849,    -1,    -1,
      -1,    -1,   333,    -1,    -1,   336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2160,    -1,  3284,    -1,    -1,   566,
     567,   568,    -1,   570,   571,   572,   573,   574,   575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   411,    -1,    -1,
      -1,    -1,   208,    -1,    -1,    -1,    -1,  2851,    -1,    -1,
      -1,  2855,  2856,    -1,   220,    -1,    -1,    -1,    -1,   225,
      -1,    -1,  3330,    -1,   230,    -1,    -1,    -1,  3336,   235,
      -1,  5923,   238,    -1,   240,    -1,    -1,    -1,    -1,  3347,
     411,    -1,    -1,    -1,    -1,  3353,  3354,    -1,    -1,    -1,
      -1,  3359,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,    -1,    -1,   108,  3384,  3385,    -1,    -1,
     113,  3389,    -1,   289,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3403,  3404,  3405,  3406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3417,
     143,    -1,  3420,    -1,    -1,    -1,    -1,    -1,  3426,  3427,
      -1,    -1,    -1,   329,    -1,  2969,    -1,    -1,  3436,  3437,
      -1,   337,  3440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   348,    -1,    -1,  3453,    -1,  3455,    -1,  3457,
    6042,  3459,   566,   567,   568,    -1,   570,   571,   572,   573,
     574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3478,    -1,    -1,    -1,  3482,    -1,    -1,    -1,    -1,   385,
    3488,  2367,    -1,  3491,  3492,  3493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   566,   567,   568,    -1,   570,
     571,   572,   573,   574,   575,    -1,    -1,  3515,    -1,    -1,
    6102,    -1,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,
      -1,    -1,  3530,    -1,   430,    -1,    -1,    -1,    -1,    -1,
    6122,    -1,    -1,    -1,    -1,    -1,    -1,  3545,   271,   272,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,  3557,
      -1,    -1,  3560,    -1,    -1,   288,  3564,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,    -1,   480,   481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,  3132,    -1,
      -1,    -1,   117,  6185,    -1,  6187,    -1,    -1,    -1,    -1,
     333,    -1,   508,   336,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3628,    -1,  3630,    -1,    -1,    -1,    -1,  3635,    -1,    -1,
      -1,  6223,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,    -1,   550,    -1,  6238,    -1,    -1,    -1,
      -1,    -1,    -1,  3661,    -1,  3663,  3664,  3665,    -1,    -1,
      -1,    -1,    -1,  3207,    85,    -1,    -1,    88,    -1,  3213,
      -1,   577,    -1,    -1,   580,   581,    -1,   583,   411,    -1,
      -1,    -1,    -1,   208,   105,    -1,    -1,   108,    -1,    -1,
      -1,   216,   113,   218,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3315,    -1,    35,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    -1,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    86,   246,    -1,    -1,    -1,   250,
      -1,    -1,    -1,   566,   567,   568,    -1,   570,   571,   572,
     573,   574,   575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     271,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,  3905,  3906,   320,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   333,    -1,    -1,   336,    -1,  3925,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   205,  3952,  3953,    -1,  3955,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   223,    -1,  3971,    -1,  2851,    -1,    -1,    -1,  2855,
    2856,    -1,    -1,    -1,    -1,    -1,  3984,  3985,    -1,    -1,
      -1,   243,    -1,    -1,    -1,    -1,    -1,  3995,  3996,    -1,
     411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4007,
      -1,    -1,    -1,   265,    -1,    -1,    -1,  4015,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4031,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4046,    -1,
      -1,  4049,   304,    -1,    -1,   307,    -1,    -1,    -1,    -1,
      -1,  3595,    -1,    -1,  3598,    -1,  3600,    -1,  4066,    -1,
     322,  3605,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4087,
      -1,    -1,    -1,  2969,    -1,    -1,    -1,    -1,    -1,  4097,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4117,
      -1,  3655,    -1,    -1,    -1,  4123,    -1,  4125,    -1,    -1,
      -1,    -1,    -1,  4131,    -1,    -1,  4134,  4135,  4136,  4137,
    4138,  4139,  4140,  4141,  4142,  4143,   398,    -1,    85,  4147,
    4148,    88,    -1,    -1,    -1,   566,   567,   568,    -1,   570,
     571,   572,   573,   574,   575,  4163,    -1,  3701,   105,  4167,
    4168,    -1,    -1,    -1,  4172,    -1,   113,    -1,    -1,  4177,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,   440,  4187,
      -1,    -1,  4190,    -1,  4192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,  4201,  4202,  4203,   143,    -1,    -1,  4207,
      -1,    -1,  4210,    -1,    -1,    -1,  4214,   469,    -1,    -1,
      -1,    -1,    -1,  4221,  4222,  4223,  4224,    -1,    -1,  4227,
    4228,    -1,    -1,    -1,  4232,  4233,    -1,    -1,    -1,    -1,
      -1,  4239,    -1,    -1,    -1,   497,  1393,  4245,  4246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3132,    -1,    -1,  3793,
      -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   230,  4292,    -1,    -1,    -1,    -1,    -1,
    4298,    -1,    -1,    -1,  4302,    -1,  4304,    -1,    -1,   246,
      -1,    -1,    -1,   250,   566,    -1,    -1,    -1,   570,   571,
     572,   573,   574,  3857,    -1,   577,   578,   579,   580,    -1,
      -1,  3207,   584,    -1,   271,   272,    -1,  3213,  4336,  4337,
    4338,    -1,  4340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
    4358,  4359,  4360,  4361,    -1,    -1,    -1,  3901,    -1,    -1,
      -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,
     317,    -1,    -1,   320,    -1,    -1,    -1,    -1,  4386,  4387,
    4388,  4389,    -1,    -1,    -1,   910,   333,    -1,  3932,   336,
     208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,   929,    -1,  4414,   225,  1565,   141,
     935,    -1,   230,    -1,    -1,    -1,    -1,   235,    -1,    -1,
     238,   946,   240,    -1,    -1,    -1,  4434,    -1,  4436,  3315,
    4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,
     975,    -1,    -1,    -1,   979,    -1,    -1,  4001,    -1,   191,
      -1,    -1,    -1,    -1,   411,   990,   198,  4475,  4476,   201,
      -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,  4022,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4036,    -1,    -1,    -1,    -1,  1022,    -1,  4507,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   329,    -1,  1038,    -1,    -1,    -1,    -1,  1043,   337,
      -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,  1053,    -1,
     348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4547,
      -1,    -1,    -1,    -1,  1069,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4565,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4110,   385,  4576,    -1,
    4578,    -1,    -1,    -1,    -1,    -1,  4584,    -1,    -1,    -1,
      -1,    -1,  4590,   315,    -1,   317,  4130,    -1,    -1,    -1,
      -1,    -1,    -1,  4601,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,    -1,  4613,    -1,    -1,    -1,    -1,
      -1,    -1,   430,   345,  4158,  4623,    -1,    -1,    -1,   566,
     567,   568,  4630,   570,   571,   572,   573,   574,   575,    -1,
      -1,    -1,    -1,    -1,    95,    -1,   454,  1162,    -1,  1164,
     101,  1166,  4650,  4651,    -1,    -1,   378,    -1,    -1,   381,
     382,    -1,    -1,    -1,    -1,    -1,  4200,    -1,    -1,    -1,
     478,    -1,   480,   481,    -1,    -1,    -1,  4675,    -1,  4677,
      -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     508,  1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4713,    -1,    -1,    -1,  3595,
      -1,    -1,  3598,    -1,  3600,   447,    -1,    -1,    -1,  3605,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1252,  1253,    -1,
     191,    -1,   550,   465,  4742,    -1,    -1,   198,    -1,    -1,
     201,    -1,    -1,    -1,  4752,    -1,    -1,    -1,    -1,    -1,
      -1,  1908,    -1,    -1,    -1,  4763,  4764,    -1,    -1,   577,
    4768,    -1,   580,   581,    -1,   583,    -1,  4775,  4776,  3655,
      -1,    -1,  4780,    -1,    -1,    -1,  4320,    -1,  4786,  4787,
     512,   513,  4790,    -1,    -1,  4793,  4794,    -1,  1945,  4797,
    4798,  4799,  4800,    -1,   255,    -1,  4804,  4805,    -1,  4807,
    4808,    -1,    -1,  4811,  1329,  1330,    -1,  4815,    -1,    85,
      -1,  4819,    88,    -1,    -1,  3701,    -1,  4825,    -1,    -1,
      -1,  1346,   554,  4831,    -1,    -1,    -1,    -1,  4836,   105,
      -1,    -1,    -1,  4841,    -1,    -1,    -1,   113,    -1,    -1,
      -1,    -1,  4850,   119,    -1,    -1,    -1,    -1,    -1,  4857,
      -1,    -1,    -1,  4861,   315,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   327,   143,    -1,    -1,
    2027,    -1,  4880,    -1,   335,  4883,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   345,    -1,    -1,  4431,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4903,  4904,    -1,    -1,  1424,
      -1,    -1,    -1,    -1,    -1,    -1,  2063,  3793,    -1,  3795,
      -1,    -1,    -1,    -1,  4922,  4923,    -1,   378,    -1,    -1,
     381,   382,    -1,    -1,  4932,    -1,    -1,    -1,    -1,    -1,
    4938,    -1,    -1,    -1,  2091,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4950,    -1,    -1,    -1,   407,    -1,    -1,    -1,
    1475,    -1,    -1,    -1,    -1,    -1,  4964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1491,  1492,    -1,    -1,
     246,  3857,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   447,    -1,    -1,    -1,
      -1,  1516,    -1,    -1,    -1,   271,   272,    -1,    -1,    -1,
      -1,    -1,    -1,  2160,   465,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,    -1,    -1,  3901,    -1,    -1,    -1,    -1,
      -1,    -1,  5030,    -1,    -1,    -1,    -1,  1552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5044,    -1,    -1,    -1,
      -1,   317,  1567,    -1,   320,    -1,  3932,    -1,    -1,    -1,
      -1,   512,   513,    -1,    -1,  1580,    -1,   333,  1583,    -1,
     336,    -1,    -1,  4607,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5091,  5092,  5093,  5094,  5095,    -1,    -1,
      -1,    -1,    -1,   554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4645,    -1,    95,    -1,  4649,    -1,  5115,    -1,   101,
      -1,    -1,    -1,    -1,    -1,  4001,    -1,    -1,  5126,    -1,
      -1,    -1,    -1,  5131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5140,    -1,    -1,   411,  4022,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5152,  5153,    -1,    -1,    -1,   141,
    4036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5183,    -1,  5185,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1714,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1722,  1723,   191,
      -1,    -1,    -1,    -1,    -1,    -1,   198,  5215,  1733,   201,
    2367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5226,    -1,
      -1,    -1,  4766,    -1,  4110,    -1,    -1,    -1,    -1,    -1,
    5238,    -1,    -1,    -1,    -1,    -1,    -1,  4781,    -1,  5247,
    5248,    -1,    -1,  5251,  4130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5264,    -1,  5266,    -1,
      -1,    -1,  5270,   255,  1789,    -1,    -1,  5275,    -1,    -1,
    5278,  5279,  4158,  5281,    -1,  5283,  5284,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1810,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5316,  5317,
    5318,  5319,  5320,    -1,  4200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   315,    -1,   317,    -1,    -1,    -1,  1854,
      -1,    -1,  5340,    -1,    -1,   327,  1861,  5345,  5346,    -1,
    5348,    -1,    -1,   335,    -1,    -1,  5354,    -1,    -1,    -1,
      -1,    -1,    -1,   345,    -1,    -1,    -1,  4901,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5374,  5375,    -1,    -1,
      -1,    -1,  1897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,   381,
     382,    -1,  5400,  5401,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4952,    -1,
      -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,    -1,
      -1,  5449,  5450,    -1,    -1,    -1,    -1,  4991,    -1,  5457,
      -1,    -1,    -1,    -1,    -1,   447,   117,    -1,    -1,  5467,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5478,    -1,    -1,   465,    -1,    -1,    -1,  2002,    -1,  5487,
      -1,    -1,    -1,  5491,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5505,    -1,    -1,
    5508,   162,    -1,    -1,    -1,  5049,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5523,  5524,    -1,    -1,    -1,
     512,   513,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5547,
      -1,  5549,    -1,    -1,  5552,  4431,  5554,   208,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   216,    -1,   218,    -1,    -1,
     131,  2086,   554,    -1,    -1,    -1,  5574,    -1,    -1,   230,
      -1,  5579,    -1,   144,   145,  5583,    -1,    -1,  5586,    -1,
      -1,  2106,    -1,   154,    -1,  5593,    -1,   158,    -1,    -1,
    5598,    98,    -1,    -1,    -1,    -1,    -1,  2122,    -1,    -1,
      -1,    -1,    -1,   110,   175,    -1,    -1,    -1,    -1,    -1,
    5618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,   196,    -1,    -1,    -1,  5637,
      -1,    -1,    -1,    -1,    -1,    -1,   207,   144,    -1,    -1,
      -1,  2166,  2167,    -1,   215,    -1,    -1,   154,    -1,    -1,
      -1,   158,  2177,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,   232,    -1,    -1,  2189,  2190,    -1,    -1,   175,  5677,
    5678,  5679,  5680,    -1,   181,  5219,    -1,    -1,    -1,    -1,
      -1,    -1,   253,    -1,  5692,    -1,    -1,    -1,  2213,   196,
      -1,    -1,    -1,    -1,  2851,    -1,    -1,    -1,  2855,  2856,
     207,    -1,    -1,    -1,    -1,    -1,  5714,   278,   215,   216,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     227,  4607,    -1,    -1,    -1,  5733,    -1,   234,   299,    -1,
      -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5751,    -1,    -1,   253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,
      -1,    -1,   333,  4649,    -1,    -1,    -1,    -1,    -1,  5777,
      -1,    -1,  5780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   292,  5794,    -1,  5796,    -1,
    5798,   362,   299,    -1,    -1,    -1,    -1,    -1,  5806,  5343,
    5808,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,  2969,    -1,  5822,    -1,    -1,    -1,   389,    -1,
      -1,    -1,   393,    -1,   395,    -1,   333,    -1,  5372,   336,
     401,    -1,    -1,   404,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,  2379,    -1,    -1,    -1,    -1,   430,
      -1,   432,  5870,    -1,   371,   436,    -1,  5875,    -1,    -1,
      -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,   449,    -1,
    4766,   173,   389,    -1,  5892,    -1,    -1,    -1,   395,    -1,
      -1,    -1,    -1,  5901,   401,  4781,    -1,   404,    -1,   191,
    5908,  5909,    -1,   474,    -1,  5913,   198,    -1,    -1,   201,
    5918,    -1,    -1,  5921,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   430,    -1,   432,   433,    -1,   435,   436,
      -1,    -1,    -1,    -1,    -1,  5943,    -1,   444,    -1,    -1,
      -1,    -1,   449,    -1,  5952,    -1,    -1,    -1,   455,    -1,
      -1,   458,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,   255,    -1,    -1,    -1,   474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3132,   547,  5521,    -1,    -1,
      -1,    -1,  5526,    -1,    -1,    -1,    -1,  5995,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6012,    -1,  5550,    -1,   300,    -1,
      -1,    -1,    -1,   305,  6022,  4901,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   315,    -1,   317,    -1,   534,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,   543,  6045,    -1,    -1,
     547,    -1,    -1,   335,  5588,    -1,    -1,    -1,    -1,    -1,
    3207,    -1,   344,   345,   561,    -1,  3213,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4952,    -1,    -1,    -1,
      -1,    -1,    -1,  6081,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,   381,
     382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     161,    -1,  6110,    -1,   144,  4991,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,   158,  5663,
      -1,    -1,    -1,  5667,  5668,    -1,   418,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,    -1,    -1,    -1,    -1,
      -1,   181,    -1,    -1,    -1,    -1,    -1,   208,  6156,    -1,
      -1,    -1,    -1,    -1,    -1,   447,   196,    -1,  3315,   220,
    6168,    -1,    -1,  5049,   225,    -1,    -1,   207,    -1,   230,
      -1,    -1,    -1,   465,   235,   215,   216,   238,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,
      -1,    -1,   232,    -1,    -1,  6203,    -1,    -1,   238,    -1,
      -1,    -1,    -1,  6211,    -1,    -1,   267,    -1,    -1,    -1,
      -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,
     512,   513,    -1,    -1,    -1,    -1,    -1,    -1,   289,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6245,   278,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   910,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   918,    -1,   299,
      -1,    -1,   554,    -1,    -1,    -1,    -1,   928,   329,    -1,
      -1,    -1,  5816,  5817,    -1,    -1,   337,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,   348,    -1,    -1,
      -1,    -1,    -1,   333,   110,    -1,    -1,    -1,    -1,    -1,
    2825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,   362,    -1,   385,    -1,    -1,    -1,   144,    -1,
      -1,    -1,    -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,
    2865,    -1,   158,    -1,  2869,  2870,    -1,    -1,  2873,   389,
      -1,    -1,    -1,   393,    -1,   395,    -1,    -1,    -1,   175,
      -1,   401,    -1,    -1,   404,  1026,    -1,    -1,    -1,   430,
    2895,    -1,    -1,    -1,    -1,    -1,  1037,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   429,
     430,   207,   432,   454,    -1,    -1,   436,    -1,    -1,   215,
     216,    -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,   449,
      -1,   227,    -1,    -1,    -1,  2940,   232,   478,    -1,   480,
     481,   461,   238,    -1,    -1,    -1,    -1,    -1,    -1,  2954,
      -1,    -1,    -1,    -1,   474,  2960,  2961,   253,  3595,    -1,
      -1,  3598,    -1,  3600,    -1,    -1,    -1,   508,  3605,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2992,  2993,    -1,
      -1,    -1,  2997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,  5372,    -1,    -1,   550,
      -1,    -1,    -1,    -1,    -1,  1156,    -1,    -1,  3655,    -1,
     540,  1162,  3027,    -1,  3029,  1166,    -1,   547,  3033,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   577,   333,    -1,   580,
     581,    -1,   583,    -1,    -1,    -1,  3051,    -1,   344,    -1,
      -1,  1192,    -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,
      -1,    -1,    -1,    -1,  3701,    -1,   362,    -1,    -1,    -1,
    3075,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3086,    -1,    -1,    -1,    -1,    -1,    -1,  3093,    -1,
      -1,    -1,    -1,   389,    -1,    -1,    -1,   393,    -1,   395,
      -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,   404,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   430,    -1,   432,    -1,    -1,    -1,
     436,    -1,    -1,    -1,  3149,    -1,    -1,    -1,   444,    -1,
      -1,    -1,    -1,   449,    -1,  5521,  3793,    -1,  3795,    -1,
    5526,    -1,  6186,    -1,    -1,   461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   474,    -1,
      -1,    -1,    -1,    -1,  5550,    -1,    -1,    -1,  1329,  1330,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3217,    -1,    -1,    -1,    -1,    -1,  1359,    -1,
    3857,    -1,  5588,    -1,    -1,    -1,    -1,    -1,    -1,  1370,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   540,    -1,    -1,    -1,    -1,  3254,
      -1,   547,  1393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3901,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
    1431,    -1,    -1,  1434,    -1,  3932,    -1,  5663,  3303,    -1,
      -1,  5667,  5668,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,
      -1,  3326,    -1,    -1,    43,    44,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,  4001,    -1,  1507,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4036,
      -1,    -1,    -1,    -1,    -1,    -1,  3411,    -1,    -1,    -1,
      -1,    -1,    -1,  3418,    -1,   134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1565,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5816,  5817,    -1,  1594,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1623,    -1,    -1,    -1,   205,    -1,    -1,    -1,
      -1,    -1,    -1,  4130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   223,    -1,  3511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1656,  1657,    -1,  1659,    -1,
      -1,  4158,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,   307,    -1,
      -1,  1732,  1733,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3607,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3622,  3623,    -1,
      -1,    -1,    -1,  1764,    -1,    -1,    -1,  1768,  1769,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3649,    -1,    -1,  3652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   398,
      -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1848,    -1,    -1,
      -1,    -1,    -1,  1854,    -1,    -1,    -1,    -1,    -1,    -1,
    1861,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3750,  3751,  3752,    -1,    -1,
     469,    -1,    -1,    -1,    -1,    -1,  1897,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1908,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,  3784,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3796,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,
      -1,  3806,    -1,    -1,  1945,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   566,    -1,    -1,
      -1,   570,   571,   572,   573,   574,    -1,    -1,   577,   578,
     579,   580,    -1,    -1,    -1,   584,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2027,    -1,    -1,    -1,
    3895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2063,    -1,    -1,    -1,  3931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3946,    -1,  3948,    -1,  2086,    -1,    -1,    -1,    -1,
    2091,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3963,    -1,
    3965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,    -1,
      -1,    -1,  4649,  2154,    -1,    -1,  4021,    -1,    -1,  2160,
      -1,    -1,    -1,  2164,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4052,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4069,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4086,    -1,    -1,  4089,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4766,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4781,    -1,    -1,    -1,    -1,    -1,
      -1,  2292,  2293,    -1,    -1,    -1,    -1,    -1,    -1,  2300,
      -1,    -1,  2303,    -1,    -1,  4170,  2307,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2315,  2316,    -1,    -1,    -1,    -1,
      -1,    -1,  2323,    -1,    -1,  2326,  2327,  2328,  2329,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2337,  2338,    -1,  2340,
      -1,  2342,  2343,    -1,    -1,  2346,    -1,  2348,    -1,  2350,
    2351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2367,    -1,    -1,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,  2378,  2379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    -1,    -1,  4901,    -1,    -1,    -1,    43,    44,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,  4952,    -1,    -1,  2459,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2488,    -1,    -1,
      -1,    -1,    -1,    -1,  4991,    -1,    -1,    -1,    -1,   134,
      -1,    -1,  4367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2523,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5049,    -1,    -1,    -1,    -1,    -1,    -1,  4424,
      -1,    -1,    -1,    -1,    -1,  4430,    -1,  4432,    -1,    -1,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4468,    -1,    -1,    -1,    -1,   243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4490,    -1,    -1,  4493,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2661,  2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,   304,
    2671,    -1,   307,    -1,  4539,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2684,  2685,    -1,    -1,   322,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4603,  4604,
      -1,    -1,    -1,    -1,    -1,  4610,    -1,    -1,  2749,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   398,    -1,  2766,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2775,  2776,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4694,
      -1,    -1,    -1,    -1,   469,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5343,    -1,    -1,    -1,
    2851,    -1,    -1,    -1,  2855,  2856,    -1,    -1,    -1,    -1,
      -1,    -1,   497,    -1,    -1,    -1,    -1,    -1,  2869,    -1,
      -1,    -1,    -1,    -1,    -1,  5372,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2909,    -1,
      -1,    -1,    -1,    -1,    -1,  2916,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   566,    -1,    -1,    -1,   570,   571,   572,   573,   574,
      -1,    -1,   577,   578,   579,    -1,    -1,    -1,    -1,   584,
      -1,    -1,    -1,  2954,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2969,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2992,    -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    94,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,    -1,
      -1,    -1,    -1,    -1,  5521,    -1,  3027,    -1,    -1,  5526,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4917,  5550,   142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   153,   154,    -1,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,    -1,  4943,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,  4986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3130,
      -1,  3132,    -1,  4998,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5021,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5663,    -1,    -1,    -1,
    5667,  5668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5068,    -1,    -1,  3207,    -1,    -1,    -1,
      -1,    -1,  3213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3315,    -1,    -1,    -1,    -1,  5816,
    5817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3330,
      -1,    -1,    -1,    -1,    -1,  3336,    -1,  5202,    -1,    -1,
      -1,    -1,    -1,   431,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3353,  3354,    -1,    -1,    -1,    -1,  3359,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3384,  3385,    -1,    -1,    -1,  3389,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3403,  3404,  3405,  3406,    -1,    -1,    -1,    -1,
    3411,    -1,    -1,    -1,    -1,    -1,  3417,  3418,    -1,  3420,
      -1,    -1,    -1,    -1,    -1,  3426,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3436,  3437,    -1,    -1,  3440,
      -1,    -1,    -1,    -1,    -1,  5310,    -1,  5312,    -1,    -1,
      -1,    -1,  3453,    -1,  3455,    -1,    -1,    -1,  3459,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3488,    -1,    -1,
    3491,  3492,  3493,    -1,    -1,    -1,    -1,    -1,    -1,   919,
     920,    -1,    -1,   923,    -1,   925,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3515,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   945,  5391,    -1,   948,  3530,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3545,    -1,   966,  5412,    -1,    -1,
     970,    -1,    -1,    -1,    -1,    -1,  3557,    -1,    -1,    -1,
      -1,    -1,   650,    -1,    -1,    -1,    -1,   987,    -1,    -1,
      -1,    -1,    -1,    -1,  5439,    -1,  5441,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3595,    -1,    -1,  3598,    -1,  3600,
      -1,    -1,    -1,    -1,  3605,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3628,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3655,    -1,    -1,    -1,    -1,    -1,
     748,   749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6186,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   796,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3750,
    3751,  3752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5643,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3793,    -1,  3795,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3857,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,  1308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1008,  1009,    -1,  1011,    -1,    -1,    -1,    -1,    -1,    -1,
    3931,  3932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1388,    -1,
      -1,    -1,    -1,    -1,    -1,  1063,    -1,    -1,  1066,  1067,
      -1,    -1,    -1,    -1,  5849,    -1,    -1,    -1,  1408,  1409,
      -1,    -1,    -1,    -1,  1082,    -1,  1084,    -1,  1086,    -1,
    4001,    -1,    -1,    -1,  1092,    -1,    -1,    -1,  1096,    -1,
      -1,    -1,  1432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4022,    -1,    -1,    -1,    -1,    -1,  1115,  1116,    -1,
      -1,    -1,    -1,    -1,    -1,  4036,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1471,  1472,    -1,    -1,    -1,    -1,    -1,  5923,    -1,
      -1,    -1,    -1,    -1,    -1,  4066,    -1,    -1,    -1,    -1,
    1158,    -1,  1160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4107,    -1,    -1,  4110,
      -1,    -1,    -1,    -1,    -1,    -1,  4117,    -1,    -1,    -1,
      -1,    -1,  4123,    -1,  4125,    -1,    -1,    -1,    -1,  4130,
    4131,    -1,    -1,  4134,  4135,  4136,  4137,  4138,  4139,  4140,
    4141,  4142,  4143,    -1,    -1,    -1,  4147,  4148,    -1,    -1,
    1238,    -1,    -1,    -1,    -1,    -1,    -1,  4158,    -1,    -1,
      -1,    -1,  4163,    -1,  1252,  1253,  4167,  4168,  1256,  4170,
      -1,  4172,    -1,    -1,    -1,    -1,  4177,  6042,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4187,    -1,    -1,  4190,
      -1,  4192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4200,
    4201,  4202,  4203,    -1,    -1,    -1,  4207,    -1,    -1,  4210,
     208,    -1,    -1,    -1,    -1,    -1,  1304,    -1,   216,    -1,
     218,    -1,    -1,  4224,    -1,    -1,  4227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6102,  4239,    -1,
      -1,    -1,    -1,    -1,  4245,  4246,  1393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4292,    -1,    -1,    -1,    -1,    -1,  4298,    -1,    -1,
      -1,    -1,    -1,  4304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4320,
    6185,    -1,  6187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4386,  4387,  4388,  4389,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1565,    -1,
      -1,    -1,    -1,  4424,    -1,    -1,    -1,    -1,  1516,  4430,
    4431,  4432,    -1,  1521,    -1,  1523,    -1,  4438,  1526,    -1,
    1528,    -1,    -1,  1531,  1532,  1533,    -1,    -1,    -1,  1537,
      -1,    -1,    -1,    -1,    -1,    -1,  1544,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4468,    -1,  1557,
      -1,  1559,    -1,    -1,    -1,    -1,  1564,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1923,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4539,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1988,  1989,
    1990,  1991,    -1,    -1,    -1,    -1,    -1,  4578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1691,    -1,    -1,  4607,    -1,    -1,    -1,
      -1,    -1,  1700,  1701,    -1,  2035,  2036,    -1,    -1,    -1,
      -1,    -1,    -1,  2043,    -1,    -1,    -1,    -1,    -1,  1717,
      -1,    -1,    -1,    -1,  1722,  1723,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4645,    -1,    -1,    -1,  4649,  4650,
    4651,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2085,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2112,  2113,  2114,  2115,    -1,    -1,    -1,    -1,
      -1,  1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1808,    -1,  1810,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2179,
      -1,  1908,  4763,  4764,    -1,  4766,    -1,  4768,  2188,    -1,
      -1,    -1,    -1,    -1,  4775,  4776,    -1,  2197,    -1,  4780,
    4781,    -1,    -1,    -1,    -1,  4786,  4787,    -1,    -1,  4790,
      -1,    -1,  4793,    -1,    -1,    -1,    -1,  1885,  1945,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4807,  1895,    -1,    -1,
      -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,  4819,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4831,    -1,    -1,    -1,    -1,  4836,    -1,    -1,    -1,    -1,
    4841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1957,
      -1,    -1,  1960,  1961,    -1,    -1,    -1,    -1,    -1,    -1,
    2027,    -1,  4883,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2063,    -1,    -1,    -1,
     918,  4922,  4923,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     928,  4932,    -1,    -1,    -1,    -1,    -1,  4938,    -1,    -1,
      -1,    -1,  4943,    -1,  2091,  2033,    -1,    -1,    -1,    -1,
      -1,  4952,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2404,    -1,    -1,    -1,    -1,    -1,
    4991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1026,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1037,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5049,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1393,  5115,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2222,    -1,  2224,    -1,    -1,    -1,
    2228,    -1,  2230,    -1,    -1,  2233,    -1,    -1,    -1,  2237,
      -1,    -1,    -1,    -1,  2242,    -1,    -1,    -1,  1156,    -1,
      -1,    -1,    -1,    -1,  1162,    -1,    -1,    -1,  1166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5180,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5215,    -1,    -1,    -1,  5219,    -1,
    2367,    -1,    -1,    -1,    -1,  5226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5247,  5248,    -1,    -1,
    5251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5264,    -1,    -1,    -1,    -1,    -1,  5270,
      -1,    -1,    -1,    -1,  5275,    -1,    -1,  5278,    -1,    -1,
      -1,    -1,  5283,  5284,    -1,  1565,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1329,  1330,    -1,    -1,    -1,    -1,    -1,    -1,  5340,
      -1,    -1,  5343,    -1,  5345,  5346,    -1,  5348,    -1,    -1,
      -1,    -1,    -1,  5354,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5372,  1370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,  5400,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5412,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1431,    -1,    -1,  1434,    -1,  5439,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5457,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2911,  2912,  2913,    -1,    -1,    -1,    -1,    -1,    -1,
    2920,    -1,  2922,    -1,  2924,  2925,    -1,    -1,    -1,  1507,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5521,    -1,    -1,  5524,    -1,  5526,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5547,    -1,  5549,  5550,
      -1,  5552,    -1,  5554,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1565,  1848,    -1,
      -1,    -1,    -1,  5574,    -1,    -1,    -1,    -1,  5579,    -1,
      -1,    -1,  5583,    -1,    -1,    -1,    -1,  5588,    -1,    -1,
      -1,    -1,  5593,  2681,    -1,    -1,  1594,    -1,    -1,    -1,
    2688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2697,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3044,  1623,    -1,    -1,  1908,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5637,    -1,    -1,    -1,
      -1,    -1,  5643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1656,  1657,
      -1,  1659,  5663,    -1,    -1,  1945,  5667,  5668,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3116,    -1,    -1,    -1,
      -1,  3121,    -1,    -1,  2851,    -1,    -1,    -1,  2855,  2856,
      -1,    -1,    -1,  5714,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5733,  2821,  1732,    -1,    -1,  2825,    -1,    -1,
      -1,    -1,    -1,  2831,    -1,  2833,    -1,  2027,  2836,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5758,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1764,    -1,    -1,    -1,
    1768,  1769,    -1,    -1,    -1,    -1,  5777,    -1,    -1,  5780,
    3200,    -1,    -1,  2063,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5794,    -1,  5796,    -1,  5798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2091,    -1,    -1,    -1,  5816,  5817,  3237,    -1,  3239,
      -1,  5822,  2969,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1861,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5875,    -1,    -1,    -1,    -1,    -1,
    2160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1897,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5908,  5909,    -1,
    1908,    -1,    -1,    -1,    -1,    -1,    -1,  5918,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3347,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5943,    -1,    -1,    -1,    -1,  1945,    -1,    -1,
    3038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3046,    -1,
    3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5995,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2027,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6042,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3207,    -1,    -1,    -1,    -1,  2063,  3213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2367,    -1,    -1,
      -1,    -1,    -1,  2091,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6110,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6156,  2154,    -1,    -1,    -1,
      -1,    -1,  2160,    -1,    -1,    -1,  2164,    -1,  3315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6185,  6186,  6187,    -1,    -1,    -1,
      -1,  3279,  3280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6238,    -1,    -1,
      -1,  3661,    -1,  3663,  3664,  3665,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2253,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2292,  2293,    -1,    -1,    -1,    -1,
      -1,    -1,  2300,    -1,    -1,  2303,    -1,    -1,    -1,  2307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2315,  2316,    -1,
      -1,    -1,    -1,    -1,    -1,  2323,    -1,    -1,  2326,  2327,
    2328,  2329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2337,
    2338,    -1,  2340,    -1,  2342,  2343,    -1,    -1,  2346,    -1,
    2348,    -1,  2350,  2351,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2367,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2685,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3506,    -1,
      -1,    -1,    -1,  3511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,    -1,
      -1,  3598,    -1,  3600,    -1,    -1,    -1,    -1,  3605,    -1,
      -1,  2459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3655,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2523,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3701,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2851,    -1,    -1,    -1,  2855,  2856,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4046,    -1,    -1,  4049,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3793,    -1,  3795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2661,  2662,  2663,  2664,  2665,  2666,  2667,
    2668,  2669,    -1,  2671,    -1,    -1,    -1,  4097,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2684,  2685,    -1,  2969,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3857,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2749,    -1,    -1,  3901,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2766,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2775,  2776,    -1,
      -1,    -1,    -1,    -1,    -1,  3932,    -1,    -1,    -1,    -1,
      -1,  3879,  3880,  3881,  3882,    -1,  3884,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3132,  2851,  4001,    -1,    -1,  2855,  2856,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4036,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2898,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2909,    -1,    -1,    -1,    -1,    -1,    -1,  2916,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3207,    -1,    -1,
      -1,    -1,    -1,  3213,    -1,    -1,    -1,    -1,  4358,  4359,
    4360,  4361,    -1,    -1,    -1,    -1,  4034,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2954,    -1,    -1,    -1,
      -1,    -1,    -1,  4110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2969,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4095,    -1,    -1,
      -1,  4158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3027,
      -1,    -1,    -1,    -1,    -1,  3315,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4200,    -1,  4475,  4476,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3130,    -1,  3132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4576,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3207,
      -1,  3491,  3492,  3493,    -1,  3213,    -1,    -1,    -1,    -1,
      -1,  4309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3262,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3595,    -1,  3315,  3598,    -1,
    3600,    -1,    -1,    -1,    -1,  3605,    -1,    -1,    -1,    -1,
      -1,    -1,  3330,    -1,    -1,    -1,    -1,    -1,  3336,    -1,
      -1,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3353,  3354,    -1,    -1,    -1,
      -1,  3359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4460,    -1,    -1,  3655,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3384,  3385,    -1,    -1,
      -1,  3389,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3403,  3404,  3405,  3406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3417,
      -1,  3701,  3420,    -1,    -1,    -1,    -1,    -1,  3426,    -1,
      -1,    -1,  4520,    -1,    -1,  4523,  4524,    -1,  3436,  3437,
      -1,    -1,  3440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3453,    -1,  3455,    -1,    -1,
    4607,  3459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3488,    -1,    -1,  3491,  3492,  3493,    -1,    -1,  4645,    -1,
      -1,    -1,  4649,    -1,    -1,   154,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3793,   163,  3795,    -1,  3515,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4964,    -1,    -1,  3545,    -1,    -1,
      -1,    -1,    -1,   202,    -1,    -1,    -1,  4645,    -1,  3557,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3857,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,    -1,    -1,
    3598,    -1,  3600,  4691,    -1,    -1,    -1,  3605,    -1,    -1,
    5030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4766,
      -1,  3901,    -1,    -1,  5044,    -1,    -1,    -1,    -1,    -1,
    3628,    -1,    -1,    -1,  4781,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3932,    -1,    -1,    -1,    -1,  3655,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3701,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4022,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4901,    -1,  4036,  4845,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   431,    -1,    -1,    -1,  4874,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3793,    -1,  3795,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4952,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4991,    -1,    -1,    -1,    -1,    -1,
    4130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3857,
      -1,  4949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5318,  5319,
    5320,    -1,  5049,  3901,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5375,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4001,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4022,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4036,    -1,
    4320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4066,    -1,
      -1,    -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   748,
     749,    -1,    -1,  5523,    -1,    -1,    -1,    -1,    -1,  4107,
      -1,    -1,  4110,    -1,    -1,    -1,    -1,    -1,    -1,  4117,
      -1,    -1,    -1,    -1,    -1,  4123,    -1,  4125,    -1,    -1,
      -1,    -1,  4130,  4131,    -1,    -1,  4134,  4135,  4136,  4137,
    4138,  4139,  4140,  4141,  4142,  4143,    -1,   796,    -1,  4147,
    4148,  4431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4158,    -1,    -1,    -1,    -1,  4163,    -1,    -1,    -1,  4167,
    4168,    -1,    -1,    -1,  4172,    -1,    -1,    -1,    -1,  4177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4187,
      -1,    -1,  4190,    -1,  4192,    -1,  5343,    -1,    -1,    -1,
      -1,    -1,  4200,  4201,  4202,  4203,    -1,    -1,    -1,  4207,
      -1,  5299,  4210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5372,  4224,    -1,    -1,  4227,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4239,    -1,    -1,    -1,    -1,    -1,  4245,  4246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5678,    -1,
    5680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   925,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5372,    -1,    -1,   936,   937,    -1,
     939,    -1,    -1,   942,  4292,   944,    -1,    -1,    -1,   948,
    4298,    -1,    -1,    -1,    -1,    -1,  4304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   964,    -1,    -1,    -1,    -1,
      -1,    -1,  4320,   972,    -1,    -1,    -1,  4607,    -1,    -1,
      -1,    -1,   981,   982,    -1,    -1,    -1,   986,  4336,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1009,    -1,  1011,    -1,    -1,  4645,    -1,    -1,    -1,  4649,
      -1,    -1,    -1,    -1,  5521,    -1,    -1,    -1,  1027,  5526,
      -1,    -1,    -1,    -1,    -1,    -1,  5806,    -1,  4386,  4387,
    4388,  4389,    -1,    -1,    -1,  1044,    -1,    -1,  1047,    -1,
    1049,    -1,  1051,  5550,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1067,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,    -1,
    4438,  5588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1123,    -1,  1125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4766,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4781,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1158,
      -1,    -1,    -1,    -1,    -1,    -1,  5663,    -1,    -1,    -1,
    5667,  5668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5952,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1194,    -1,    -1,    -1,    -1,
      -1,  4831,    -1,    -1,    -1,    -1,  4836,    -1,    -1,    -1,
      -1,  4841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4578,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6022,    -1,    -1,    -1,    -1,    -1,    -1,  4607,
      -1,    -1,    -1,    -1,    -1,    -1,  1265,    -1,  1267,    -1,
      -1,  4901,  1271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1291,    -1,    -1,    -1,    -1,  4645,    -1,    -1,
      -1,  4649,  4650,  4651,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,
    5817,    -1,  4952,    -1,    -1,    -1,    -1,  5765,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1345,    -1,  1347,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4991,    -1,    -1,  1363,  4713,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1376,    -1,    -1,
      -1,    -1,    -1,    -1,  1383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4742,    -1,  1395,    -1,    -1,  1398,
      -1,    -1,    -1,    -1,  4752,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4763,  4764,    -1,  4766,  5049,
    4768,    -1,    -1,    -1,  1423,    -1,    -1,  4775,  4776,    -1,
      -1,    -1,  4780,  4781,    -1,    -1,  1435,    -1,  4786,  4787,
      -1,    -1,  4790,    -1,    -1,  4793,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4807,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,
      -1,  4819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4831,    -1,    -1,    -1,    -1,  4836,    -1,
      -1,  1490,    -1,  4841,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4883,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5180,    -1,    -1,  4901,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4922,  4923,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4932,    -1,    -1,    -1,    -1,  5219,
    4938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4991,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6186,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5343,    -1,    -1,  5346,    -1,  5348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5372,    -1,    -1,    -1,    -1,    -1,  6186,    -1,
      -1,    -1,  1751,  1752,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1813,    -1,    -1,  1816,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1824,    -1,    -1,    -1,    -1,
      -1,    -1,  5180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1842,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5215,    -1,    -1,
      -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,  5226,    -1,
      -1,    -1,  1881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5238,  5521,    -1,    -1,    -1,    -1,  5526,    -1,    -1,  5247,
    5248,    -1,    -1,  5251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5264,    -1,    -1,    -1,
    5550,    -1,  5270,    -1,    -1,    -1,    -1,  5275,    -1,    -1,
    5278,    -1,    -1,    -1,    -1,  5283,  5284,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5588,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5316,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5340,    -1,    -1,  5343,    -1,  5345,  5346,    -1,
    5348,    -1,    -1,    -1,    -1,    -1,  5354,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5372,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5663,    -1,    -1,    -1,  5667,  5668,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2095,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5457,
      -1,  2110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5758,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5521,    -1,    -1,  5524,    -1,  5526,  2178,
      -1,  2180,    -1,  2182,    -1,    -1,  5816,  5817,  2187,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5547,
      -1,  5549,  5550,    -1,  5552,    -1,  5554,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5574,    -1,    -1,    -1,
      -1,  5579,    -1,    -1,    -1,  5583,    -1,    -1,    -1,  2238,
    5588,    -1,    -1,    -1,    -1,  5593,    -1,    -1,    -1,    -1,
      -1,  2250,    -1,    -1,    -1,  2254,    -1,  2256,    -1,    -1,
    2259,    -1,  2261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5637,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5663,    -1,    -1,    -1,  5667,
    5668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5714,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5733,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5758,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5777,
      -1,    -1,  5780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5794,    -1,  5796,    -1,
    5798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,  5817,
      -1,    -1,    -1,    -1,  5822,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5875,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5892,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6186,    -1,    -1,    -1,
    5908,  5909,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5943,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5995,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6012,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   928,    -1,    -1,    -1,    -1,  1192,    -1,  6156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2836,  6186,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2866,  2867,    -1,
      -1,    -1,  2871,  2872,    -1,    -1,  2875,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2885,    -1,    -1,    -1,
      -1,    -1,    -1,  2892,    -1,    -1,    -1,  2896,  2897,  1026,
      -1,  2900,  2901,    -1,    -1,    -1,    -1,    -1,  2907,    -1,
    1037,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2919,    -1,  2921,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2941,    -1,    -1,    -1,    -1,  2946,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2962,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2971,    -1,    -1,    -1,    -1,  2976,  2977,  2978,
    2979,    -1,    -1,    -1,    -1,    -1,    -1,  2986,  2987,    -1,
      -1,    -1,    -1,    -1,    -1,  2994,    -1,    -1,    -1,    -1,
    2999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3007,    -1,
      -1,  1393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1156,
      -1,    -1,    -1,    -1,    -1,  3034,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3045,    -1,  3047,    -1,
      -1,    -1,    -1,  3052,    -1,    -1,    -1,  3056,    -1,  3058,
    3059,  3060,  3061,    -1,  3063,  1192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3076,  3077,    -1,
    3079,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3090,  3091,  3092,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1393,
      -1,    -1,    -1,  1565,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1594,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1359,    -1,    -1,    -1,    -1,  1623,    -1,    -1,
      -1,    -1,    -1,  1370,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
    1656,  1657,    -1,  1659,    -1,    -1,    -1,    -1,    -1,    -1,
    3279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1678,  3292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1431,    -1,    -1,  1434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1732,    -1,    -1,    -1,
      -1,  1565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1764,    -1,
    1507,    -1,  1768,  1769,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1565,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1848,  1594,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1623,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1908,  3526,    -1,  1656,
    1657,    -1,  1659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1945,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1565,    -1,
      -1,    -1,    -1,    -1,    -1,  1732,    -1,    -1,    -1,  3608,
    3609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3625,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1848,    -1,    -1,  1764,    -1,    -1,
      -1,  1768,  1769,    -1,    -1,  2027,    -1,    -1,    -1,    -1,
      -1,  3650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3674,  3675,    -1,    -1,    -1,
    3679,  2063,    -1,    -1,    -1,  3684,  3685,  3686,    -1,    -1,
      -1,    -1,    -1,    -1,  1908,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2091,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3741,  3742,  3743,  3744,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2160,    -1,
      -1,  1908,    -1,    -1,    -1,    -1,  3785,    -1,  3787,  3788,
    3789,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3797,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2027,    -1,    -1,    -1,    -1,  1945,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2063,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3870,    -1,    -1,    -1,    -1,    -1,  2091,    -1,    -1,
      -1,  1848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3896,    -1,    -1,
    2027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2063,  2323,    -1,    -1,
    2326,  1908,    -1,  2329,    -1,    -1,  2160,    -1,  3947,    -1,
      -1,  2337,  2338,    -1,    -1,    -1,  2342,  2343,    -1,    -1,
    2346,    -1,  2348,    -1,  2091,  2351,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1945,    -1,
      -1,    -1,    -1,    -1,    -1,  2367,    -1,    -1,    -1,    -1,
      -1,    -1,  2378,  3992,    -1,    -1,    -1,    -1,  3997,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2154,    -1,    -1,
      -1,    -1,    -1,  2160,    -1,  4034,    -1,  2164,  4037,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4051,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2027,    -1,    -1,    -1,    -1,  4064,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2459,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2063,    -1,    -1,    -1,
      -1,    -1,  2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2091,    -1,  2253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2523,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2367,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2292,  2293,    -1,    -1,    -1,
      -1,    -1,    -1,  2300,    -1,    -1,  2303,    -1,    -1,    -1,
    2307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2315,  2316,
      -1,    -1,    -1,  2160,    -1,    -1,  2323,    -1,    -1,  2326,
    2327,  2328,  2329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2337,  2338,    -1,  2340,    -1,  2342,  2343,    -1,    -1,  2346,
      -1,  2348,    -1,  2350,  2351,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,    -1,  2671,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2684,  2685,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4343,    -1,  4345,    -1,    -1,    -1,
      -1,    -1,    -1,  4352,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2488,    -1,  2749,    -1,    -1,    -1,    -1,    -1,  4368,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4384,    -1,    -1,    -1,  2775,
    2776,    -1,    -1,    -1,    -1,    -1,  2523,    -1,  4397,    -1,
    2367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4428,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2851,
      -1,    -1,    -1,  2855,  2856,    -1,    -1,    -1,  4477,  4478,
    4479,    -1,    -1,  4482,  4483,  4484,  4485,  4486,    -1,    -1,
      -1,    -1,  4491,  4492,    -1,  4494,  4495,  4496,  4497,  4498,
    4499,  4500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4509,    -1,  2898,  4512,  4513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2661,  2662,  2663,  2664,  2665,  2666,
    2667,  2668,  2669,    -1,  2671,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2684,  2685,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4572,  4573,  4574,    -1,    -1,  4577,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2969,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2851,    -1,  2766,
      -1,  2855,  2856,    -1,    -1,    -1,    -1,    -1,  2775,  2776,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4666,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4686,  4687,  4688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2851,    -1,    -1,    -1,  2855,  2856,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3130,    -1,    -1,    -1,    -1,    -1,
    3132,    -1,    -1,    -1,    -1,  2969,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2898,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2909,    -1,    -1,    -1,    -1,    -1,    -1,  2916,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3207,    -1,    -1,    -1,    -1,
      -1,  3213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2969,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2851,    -1,    -1,    -1,  2855,  2856,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4912,  4913,  4914,  4915,    -1,  3132,  4918,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3315,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3354,    -1,
      -1,    -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4982,  4983,  4984,  4985,    -1,  4987,  4988,
      -1,    -1,    -1,  3207,    -1,    -1,    -1,    -1,    -1,  3213,
    4999,  5000,  2969,  3130,    -1,  3132,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3403,    -1,  3405,
    3406,    -1,    -1,  5022,    -1,    -1,    -1,    -1,    -1,  5028,
    5029,  3417,  5031,    -1,  3420,    -1,    -1,    -1,    -1,    -1,
    3426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3453,    -1,  3455,
      -1,    -1,    -1,  3459,    -1,    -1,    -1,    -1,    -1,    -1,
    3207,    -1,    -1,    -1,    -1,    -1,  3213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3315,    -1,    -1,    -1,  3491,  3492,  3493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3515,
      -1,    -1,    -1,    -1,    -1,  3262,  5135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3530,  5144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3545,
      -1,    -1,    -1,    -1,    -1,  3132,  5165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3315,    -1,
      -1,    -1,    -1,    -1,  5193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3330,    -1,    -1,    -1,    -1,    -1,  3336,
      -1,    -1,    -1,  3595,    -1,    -1,  3598,    -1,  3600,    -1,
      -1,    -1,    -1,  3605,    -1,    -1,  3353,  3354,    -1,    -1,
      -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3207,    -1,  3628,    -1,    -1,    -1,  3213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,  3385,    -1,
      -1,    -1,  3389,    -1,    -1,    -1,    -1,    -1,    -1,  5268,
      -1,    -1,    -1,  3655,    -1,    -1,  3403,  3404,  3405,  3406,
      -1,    -1,  5281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3417,    -1,    -1,  3420,    -1,    -1,    -1,    -1,    -1,  3426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3436,
    3437,    -1,    -1,  3440,    -1,    -1,    -1,    -1,    -1,  3701,
      -1,    -1,    -1,    -1,    -1,    -1,  3453,    -1,  3455,    -1,
      -1,    -1,  3459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3315,    -1,
      -1,  3478,    -1,    -1,    -1,    -1,    -1,    -1,  5357,    -1,
      -1,  3488,    -1,    -1,  3491,  3492,  3493,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3595,    -1,    -1,  3598,    -1,  3600,    -1,  3515,    -1,
      -1,  3605,    -1,  5392,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3793,    -1,  3795,    -1,    -1,    -1,    -1,  3545,    -1,
    5419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3557,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3655,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3595,    -1,
      -1,  3598,    -1,  3600,    -1,  3857,    -1,    -1,  3605,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3701,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3901,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3655,    -1,
      -1,    -1,    -1,  5532,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3701,    -1,    -1,  5576,    -1,  3793,
      -1,  3795,    -1,    -1,    -1,    -1,    -1,  5586,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4001,
      -1,    -1,    -1,  5622,    -1,    -1,    -1,    -1,  3595,    -1,
      -1,  3598,    -1,  3600,    -1,    -1,    -1,    -1,  3605,    -1,
    4022,    -1,    -1,  3857,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4036,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5662,    -1,    -1,  3793,    -1,  3795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5681,    -1,    -1,    -1,    -1,  3901,  3655,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3932,    -1,
      -1,  4107,    -1,    -1,    -1,    -1,    -1,    -1,  4110,    -1,
    3857,  4117,    -1,    -1,  3701,    -1,    -1,  4123,    -1,  4125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4147,  4148,  5762,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3901,    -1,  4158,    -1,    -1,    -1,
      -1,  4167,    -1,    -1,    -1,    -1,  4172,  4001,  5787,    -1,
      -1,  4177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4187,    -1,    -1,  4190,  3932,  4192,    -1,  4022,    -1,
      -1,    -1,    -1,    -1,    -1,  4201,  5815,    -1,  4200,    -1,
      -1,  4207,  4036,    -1,  4210,    -1,  3793,    -1,  3795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5839,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4239,    -1,    -1,    -1,    -1,    -1,  4245,
    4246,    -1,    -1,    -1,    -1,  5864,    -1,    -1,    -1,    -1,
    5869,    -1,    -1,    -1,  4001,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3857,    -1,    -1,    -1,    -1,  4022,  4110,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4292,    -1,    -1,  4036,
      -1,    -1,  4298,    -1,    -1,    -1,  4130,    -1,  4304,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3901,    -1,    -1,    -1,  4320,  4066,
      -1,    -1,    -1,  5942,  4158,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3932,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4107,    -1,    -1,  4110,    -1,    -1,  4200,    -1,    -1,    -1,
    4117,    -1,    -1,    -1,    -1,    -1,  4123,    -1,  4125,    -1,
      -1,    -1,    -1,  4130,  4131,    -1,    -1,  4134,  4135,  4136,
    4137,  4138,  4139,  4140,  4141,  4142,  4143,    -1,    -1,    -1,
    4147,  4148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4158,    -1,    -1,  4001,    -1,  4163,    -1,    -1,    -1,
    4167,  4168,    -1,    -1,    -1,  4172,    -1,    -1,    -1,  4431,
    4177,    -1,    -1,    -1,    -1,  4022,    -1,    -1,    -1,    -1,
    4187,    -1,    -1,  4190,    -1,  4192,    -1,    -1,    -1,  4036,
      -1,    -1,    -1,  4200,  4201,  4202,  4203,    -1,    -1,    -1,
    4207,    -1,    -1,  4210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4224,    -1,    -1,
    4227,    -1,    -1,    -1,    -1,    -1,  4320,    -1,    -1,    -1,
      -1,    -1,  4239,    -1,    -1,    -1,    -1,    -1,  4245,  4246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4130,    -1,  4292,    -1,    -1,    -1,    -1,
      -1,  4298,    -1,    -1,    -1,    -1,    -1,  4304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4158,    -1,  4320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4336,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4431,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4607,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4200,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4386,
    4387,  4388,  4389,  4645,  4650,  4651,    -1,  4649,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1747,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,
      -1,  4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4713,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4763,  4764,    -1,
      -1,    -1,  4768,    -1,  4766,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4607,  4780,    -1,    -1,    -1,    -1,  4781,
    4786,  4787,    -1,    -1,  4790,    -1,    -1,  4793,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4645,    -1,    -1,    -1,  4649,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4831,    -1,    -1,    -1,    -1,
    4836,  4578,    -1,    -1,    -1,  4841,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4431,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4883,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,  4901,
      -1,    -1,  4649,  4650,  4651,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4766,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4781,    -1,    -1,
    4952,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4713,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4991,
      -1,    -1,    -1,    -1,    -1,  4742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4752,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4763,  4764,    -1,  4766,
    4607,  4768,    -1,    -1,    -1,    -1,    -1,    -1,  4775,  4776,
      -1,    -1,    -1,  4780,  4781,    -1,    -1,    -1,    -1,  4786,
    4787,    -1,    -1,  4790,    -1,    -1,  4793,  5049,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,    -1,
    4807,    -1,  4649,    -1,    -1,    -1,    -1,  4901,  4815,    -1,
      -1,    -1,  4819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4831,    -1,    -1,    -1,    -1,  4836,
      -1,    -1,    -1,    -1,  4841,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5115,
      -1,    -1,    -1,    -1,  2205,    -1,    -1,    -1,  4952,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4883,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4901,    -1,    -1,  4991,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4922,  4923,    -1,    -1,  4766,
      -1,    -1,    -1,    -1,    -1,  4932,    -1,    -1,    -1,    -1,
      -1,  4938,    -1,    -1,  4781,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4952,    -1,  2298,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5049,    -1,  5219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2322,  5238,    -1,    -1,    -1,  2327,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4991,  5251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2352,  2353,    -1,    -1,    -1,  2357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5283,  5284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4901,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5346,  5343,  5348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4952,    -1,    -1,  5115,    -1,
    5372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5126,
      -1,    -1,    -1,    -1,    -1,  5219,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4991,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5180,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5049,    -1,    -1,    -1,    -1,    -1,  5215,    -1,
      -1,    -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,  5226,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5247,  5248,    -1,    -1,  5251,    -1,    -1,    -1,    -1,  5343,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5264,    -1,  5521,
      -1,    -1,    -1,  5270,  5526,    -1,    -1,    -1,  5275,    -1,
      -1,  5278,    -1,    -1,    -1,    -1,  5283,  5284,  5372,    -1,
      -1,  5547,    -1,    -1,    -1,    -1,  5552,    -1,  5550,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5574,  5316,
      -1,    -1,    -1,  5579,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5588,  5593,    -1,  2680,
      -1,    -1,    -1,  5340,    -1,    -1,  5343,    -1,  5345,  5346,
      -1,  5348,    -1,    -1,    -1,    -1,    -1,  5354,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5372,    -1,    -1,    -1,    -1,
      -1,    -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2734,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5663,    -1,    -1,    -1,  5667,  5668,    -1,    -1,    -1,
      -1,  2762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2774,    -1,    -1,    -1,  5521,  2779,    -1,
      -1,    -1,  5526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5457,    -1,    -1,    -1,    -1,    -1,  5550,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5733,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5588,    -1,  5343,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5777,    -1,    -1,  5521,    -1,    -1,  5524,    -1,  5526,
      -1,    -1,    -1,    -1,    -1,  5372,    -1,    -1,    -1,    -1,
      -1,    -1,  5798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5547,    -1,  5549,  5550,    -1,  5552,    -1,  5554,    -1,    -1,
      -1,    -1,    -1,    -1,  5816,  5817,  5822,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5574,    -1,  5663,
      -1,    -1,  5579,  5667,  5668,    -1,  5583,    -1,    -1,    -1,
      -1,  5588,    -1,    -1,    -1,    -1,  5593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5908,  5909,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5918,    -1,    -1,    -1,  5663,    -1,    -1,    -1,
    5667,  5668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5521,    -1,    -1,    -1,    -1,  5526,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5550,    -1,    -1,    -1,  5714,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5816,  5817,    -1,    -1,  5733,    -1,    -1,  5995,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5588,    -1,    -1,    -1,    -1,  6012,    -1,    -1,    -1,
      -1,  5758,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5777,    -1,    -1,  5780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5794,    -1,  5796,
      -1,  5798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,
    5817,    -1,    -1,    -1,    -1,  5822,  5663,    -1,    -1,    -1,
    5667,  5668,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6110,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5875,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5892,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5908,  5909,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5943,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,
    5817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6012,  3357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3380,
      -1,  3382,    -1,  3384,  3385,  3386,    -1,    -1,  3389,    -1,
      -1,    -1,  3393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3402,    -1,    -1,    -1,    -1,  3407,    -1,    -1,    -1,
      -1,  3412,    -1,  3414,    -1,    -1,    -1,    -1,  3419,    -1,
    3421,    -1,    -1,  3424,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3432,    -1,    -1,    -1,  3436,  3437,    -1,  3439,    -1,
      -1,    -1,  6186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3451,    -1,    -1,  6110,    -1,    -1,    -1,  3458,    -1,  3460,
    3461,  3462,  3463,  3464,  3465,  3466,  3467,  3468,  3469,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3497,    -1,    -1,  6156,
      -1,    -1,     3,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,  6186,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,    -1,   103,   104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,    -1,   115,    -1,    -1,   118,   119,   120,
     121,   122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,   138,    -1,   140,
     141,   142,  3643,   144,    -1,   146,    -1,   148,    -1,    -1,
     151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,
     161,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,   175,    -1,   177,   178,   179,   180,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,  6186,
      -1,   192,    -1,   194,    -1,    -1,    -1,   198,    -1,    -1,
      -1,    -1,    -1,   204,   205,    -1,    -1,    -1,    -1,    -1,
      -1,   212,   213,   214,    -1,    -1,   217,    -1,    -1,   220,
      -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,   229,    -1,
     231,    -1,    -1,    -1,   235,    -1,   237,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,
      -1,    -1,   263,    -1,    -1,   266,    -1,   268,    -1,    -1,
     271,   272,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,    -1,   288,    -1,   290,
     291,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,    -1,    -1,
     311,   312,   313,    -1,    -1,   316,    -1,    -1,   319,   320,
      -1,    -1,   323,    -1,   325,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,   340,
      -1,   342,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   353,    -1,   355,    -1,   357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   368,   369,    -1,
      -1,    -1,    -1,   374,   375,    -1,   377,    -1,    -1,    -1,
      -1,   382,    -1,    -1,    -1,    -1,   387,   388,    -1,   390,
     391,    -1,    -1,   394,    -1,    -1,    -1,    -1,   399,   400,
      -1,    -1,    -1,    -1,    -1,    -1,   407,   408,    -1,   410,
     411,    -1,   413,    -1,    -1,    -1,    -1,   418,    -1,  3920,
      -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,    -1,   430,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   438,   439,    -1,
      -1,    -1,   443,    -1,   445,    -1,   447,    -1,   449,    -1,
      -1,    -1,    -1,   454,    -1,    -1,   457,    -1,    -1,   460,
      -1,    -1,   463,    -1,    -1,    -1,    -1,   468,   469,    -1,
      -1,   472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     481,    -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,
     491,   492,   493,   494,   495,   496,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,    -1,
      -1,    -1,    -1,    -1,    -1,   526,    -1,   528,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   548,    -1,    -1,
      -1,    -1,   553,    -1,  4055,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   579,    -1,
      -1,    -1,   583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4105,    -1,    -1,    -1,    -1,    -1,
      -1,  4112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4128,  4129,    -1,
    4131,    -1,    -1,  4134,  4135,  4136,  4137,  4138,  4139,  4140,
    4141,  4142,  4143,  4144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4173,    -1,    -1,  4176,    -1,    -1,    -1,    -1,
      -1,    -1,  4183,    -1,    -1,    -1,    -1,  4188,  4189,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4202,  4203,  4204,    -1,  4206,    -1,    -1,  4209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4578,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,  4714,    79,    80,    -1,  4718,  4719,  4720,
      -1,    -1,  4723,    -1,    -1,    -1,    -1,  4728,  4729,  4730,
    4731,  4732,  4733,  4734,  4735,  4736,  4737,  4738,  4739,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,  4753,    -1,   119,   120,   121,   122,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4767,    -1,    -1,    -1,
     135,    -1,    -1,  4774,  4775,  4776,  4777,   142,  4779,   144,
      -1,    -1,  4783,  4784,  4785,    -1,   151,  4788,    -1,    -1,
    4791,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4833,    -1,    -1,    -1,    -1,    -1,    -1,  4840,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,    -1,   217,  4854,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,   229,    -1,   231,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,   260,    -1,    -1,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,   312,   313,    -1,
      -1,   316,    -1,    -1,    -1,   320,    -1,    -1,   323,    -1,
     325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,   340,    -1,   342,   343,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   388,    -1,    -1,   391,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,   411,    -1,   413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,   439,    -1,    -1,    -1,   443,    -1,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   469,    -1,    -1,   472,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5118,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,    -1,    -1,    -1,    -1,    -1,
      -1,   526,    -1,   528,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5177,  5178,    -1,    -1,
      -1,    -1,    -1,   548,    -1,    -1,    -1,    -1,   553,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5211,    -1,    -1,    -1,  5215,    -1,    -1,    -1,    -1,    -1,
      -1,   586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5231,    -1,  5233,    -1,    -1,    -1,    -1,    -1,  5239,    -1,
      -1,  5242,  5243,  5244,    -1,    -1,  5247,  5248,  5249,  5250,
      -1,  5252,    -1,    -1,  5255,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5265,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      -1,    -1,    -1,  5314,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,   120,   121,   122,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   144,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5470,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,   229,    -1,   231,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,   260,    -1,    -1,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5548,  5549,    -1,
     285,   286,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5563,    -1,  5565,  5566,  5567,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,   312,   313,    -1,
      -1,   316,    -1,    -1,    -1,   320,    -1,    -1,   323,    -1,
     325,    -1,    -1,    -1,    -1,  5596,  5597,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,   340,    -1,   342,   343,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   388,    -1,    -1,   391,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,   411,    -1,   413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,   439,    -1,    -1,    -1,   443,    -1,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   469,    -1,    -1,   472,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,    -1,    -1,    -1,    -1,  5768,  5769,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5783,   518,   519,  5786,    -1,    -1,    -1,    -1,
      -1,   526,    -1,   528,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   548,    -1,    -1,    -1,    -1,   553,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   586,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5874,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5998,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,  6075,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   585,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     580,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   580,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,   193,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   570,   571,   572,    -1,    -1,    -1,
      -1,    -1,    -1,   579,   580,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,    -1,   262,   263,   264,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,   472,   473,   474,   475,   476,    -1,    -1,   479,
      -1,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   579,
     580,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,   580,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,    -1,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,    -1,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,    -1,   214,   215,   216,    -1,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,    -1,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
     318,   319,   320,   321,    -1,    -1,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,    -1,    -1,    -1,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,    -1,   444,    -1,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
      -1,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
      -1,   549,    -1,   551,   552,    -1,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   580,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,    -1,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,    -1,   214,   215,
     216,    -1,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,    -1,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,    -1,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,    -1,    -1,    -1,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,    -1,   444,    -1,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,    -1,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    -1,   549,    -1,   551,   552,    -1,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,   580,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,    -1,
     214,   215,   216,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,    -1,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,    -1,   441,   442,    -1,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,    -1,    -1,   520,   521,   522,   523,
     524,   525,   526,   527,    -1,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,    -1,   549,   550,   551,   552,    -1,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,   566,   567,   568,    -1,   570,   571,   572,   573,
     574,   575,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,   577,   578,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,   572,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,    -1,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   570,   571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     579,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,   461,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   579,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     579,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,   265,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   579,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
     107,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,    -1,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,   285,   286,
     287,    -1,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,   468,   469,    -1,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   570,   571,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   579,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,   144,    -1,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,    -1,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,    -1,
     262,   263,   264,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,   286,   287,    -1,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,   461,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   570,   571,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   579,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,    -1,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,   332,   333,   334,   335,    -1,
      -1,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,   461,    -1,   463,   464,   465,   466,
     467,   468,   469,    -1,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   579,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   571,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   579,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    -1,    86,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,   144,    -1,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
      -1,   262,   263,   264,   265,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
      -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
      -1,    -1,   463,   464,   465,   466,   467,   468,   469,    -1,
     471,   472,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   579,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   571,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   579,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,   144,    -1,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
      -1,   332,   333,   334,   335,    -1,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
     461,    -1,   463,   464,   465,   466,   467,   468,   469,    -1,
     471,   472,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   579,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,    -1,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,   472,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   579,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,   461,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     579,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   579,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,    -1,   110,   111,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,    -1,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,   146,
     147,   148,   149,   150,    -1,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,    -1,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,    -1,    -1,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,   285,   286,
     287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,   468,   469,    -1,   471,    -1,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,    -1,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   580,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,    -1,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,   132,   133,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,    -1,    -1,
      -1,   146,   147,   148,   149,   150,    -1,   152,   153,    -1,
     155,   156,   157,   158,   159,   160,    -1,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,   207,    -1,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,    -1,   221,   222,   223,    -1,
      -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,    -1,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,    -1,   260,    -1,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
     285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,    -1,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,   328,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,
     345,   346,   347,    -1,   349,   350,    -1,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,    -1,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,    -1,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,    -1,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,    -1,    -1,   463,   464,
     465,   466,   467,   468,   469,    -1,   471,    -1,   473,   474,
     475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,    -1,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,    -1,    -1,    -1,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,   578,   579,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,    -1,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   579,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,    -1,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,   132,
     133,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
      -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,   152,
     153,    -1,   155,   156,   157,   158,   159,   160,    -1,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,   207,    -1,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,    -1,   221,   222,
     223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,    -1,   260,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,    -1,   330,    -1,    -1,
     333,   334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,    -1,    -1,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,    -1,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,
     463,   464,   465,   466,   467,   468,   469,    -1,   471,    -1,
     473,   474,   475,   476,    -1,    -1,   479,    -1,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,    -1,
      -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   579,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,   579,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,    -1,   116,   117,   118,   119,   120,
      -1,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
      -1,   132,   133,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,    -1,    -1,   146,   147,   148,   149,   150,
      -1,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
      -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,
      -1,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,    -1,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,    -1,   260,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
      -1,    -1,   273,    -1,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,    -1,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
      -1,   332,   333,   334,   335,    -1,    -1,   338,   339,    -1,
     341,    -1,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
      -1,    -1,   463,   464,   465,   466,   467,   468,   469,    -1,
     471,    -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,    -1,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,   579,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   579,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,    -1,   116,   117,   118,
     119,   120,    -1,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,    -1,    -1,   146,   147,   148,
     149,   150,    -1,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
      -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,    -1,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
      -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,    -1,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,    -1,   341,    -1,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,    -1,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,    -1,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    -1,    -1,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
     579,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   579,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,    -1,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,   146,
     147,   148,   149,   150,    -1,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,   243,   244,   245,    -1,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,   285,    -1,
     287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,    -1,   341,    -1,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,   468,   469,    -1,   471,    -1,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,    -1,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   579,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,    -1,   214,   215,
     216,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,    -1,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,    -1,   441,   442,    -1,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,    -1,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    -1,   549,   550,   551,   552,    -1,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
     566,   567,   568,    -1,   570,   571,   572,   573,   574,   575,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,    -1,     5,     6,
       7,     8,     9,    10,    11,    12,    13,   572,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,    -1,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,    -1,   214,   215,   216,
      -1,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
      -1,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,    -1,    -1,    -1,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,    -1,   444,    -1,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,    -1,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,    -1,   549,    -1,   551,   552,    -1,   554,   555,   556,
     557,   558,   559,   560,   561,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,   572,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    -1,    86,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,     6,     7,     8,     9,    10,    11,
      12,    13,   571,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
     572,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,   572,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,   572,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,   230,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   570,   571,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,   230,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   570,   571,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,   230,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   570,   571,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
     230,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     570,   571,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,   440,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,    -1,
      -1,     4,   566,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,    -1,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,   132,
     133,   134,   135,   136,    -1,   138,   139,   140,   141,   142,
      -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,   152,
     153,    -1,   155,   156,   157,   158,   159,   160,    -1,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,   207,    -1,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,    -1,   221,   222,
     223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
     243,   244,   245,    -1,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,    -1,   260,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,   328,    -1,   330,    -1,    -1,
     333,   334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,
     343,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,    -1,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,    -1,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,    -1,    -1,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,    -1,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,
     463,   464,   465,   466,   467,   468,   469,    -1,   471,    -1,
     473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,    -1,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,    -1,   138,   139,   140,   141,   142,    -1,   144,
      -1,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,   207,    -1,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,    -1,   221,   222,   223,    -1,
      -1,   226,    -1,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,    -1,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,   349,   350,    -1,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,    -1,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,    -1,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,   468,   469,    -1,   471,   472,   473,   474,
     475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
      -1,   132,   133,   134,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,   144,    -1,   146,   147,   148,   149,   150,
     151,   152,   153,    -1,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
      -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,    -1,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
      -1,    -1,   463,   464,   465,   466,   467,   468,   469,    -1,
     471,   472,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,   134,   135,   136,
      -1,   138,   139,   140,   141,    -1,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,    -1,   214,   215,   216,
      -1,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
      -1,    -1,   239,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,   318,   319,   320,   321,    -1,    -1,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,   340,   341,   342,    -1,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,    -1,    -1,    -1,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,   396,
     397,   398,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,    -1,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,    -1,   444,    -1,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,    -1,    -1,   520,   521,   522,   523,   524,   525,   526,
     527,    -1,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,    -1,   549,    -1,   551,   552,    -1,   554,   555,   556,
     557,   558,   559,   560,   561,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,    -1,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,    -1,    -1,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,    -1,   214,   215,   216,    -1,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,    -1,    -1,   239,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
      -1,    -1,   262,   263,   264,   265,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,   318,   319,
     320,   321,   322,    -1,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,    -1,
     340,   341,   342,    -1,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,    -1,    -1,    -1,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,    -1,    -1,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,    -1,   444,    -1,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,    -1,   469,
      -1,   471,   472,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,    -1,    -1,
     520,   521,   522,   523,   524,   525,   526,   527,    -1,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,    -1,   549,
      -1,   551,   552,    -1,   554,   555,   556,   557,   558,   559,
     560,   561,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,    -1,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,   132,
     133,   134,   135,   136,    -1,   138,   139,   140,   141,    -1,
      -1,   144,    -1,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,   207,    -1,    -1,   210,   211,   212,
      -1,   214,   215,   216,    -1,    -1,   219,    -1,   221,   222,
     223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,    -1,    -1,   239,    -1,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,    -1,    -1,   262,
     263,   264,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
      -1,   324,   325,   326,   327,   328,    -1,   330,    -1,    -1,
     333,   334,   335,    -1,    -1,   338,    -1,   340,   341,   342,
      -1,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
      -1,    -1,    -1,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,   396,   397,   398,   399,    -1,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,    -1,    -1,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,    -1,    -1,   442,
      -1,   444,    -1,    -1,   447,   448,   449,   450,    -1,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,
     463,   464,   465,   466,   467,    -1,   469,    -1,   471,   472,
     473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,
     483,   484,   485,   486,   487,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   497,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,   516,   517,    -1,    -1,   520,   521,   522,
     523,   524,   525,   526,   527,    -1,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,    -1,   549,    -1,   551,   552,
      -1,   554,   555,   556,   557,   558,   559,   560,   561,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,    -1,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,    -1,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,    -1,   214,   215,
     216,    -1,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,    -1,    -1,   239,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,    -1,    -1,   262,   263,   264,   265,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,    -1,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,    -1,   340,   341,   342,    -1,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,    -1,    -1,    -1,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
      -1,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,    -1,   444,    -1,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,    -1,   469,    -1,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,    -1,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,    -1,   549,    -1,   551,   552,    -1,   554,   555,
     556,   557,   558,   559,   560,   561,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
      -1,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,   132,   133,   134,   135,   136,    -1,   138,
     139,   140,   141,    -1,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,    -1,   214,   215,   216,    -1,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,    -1,    -1,
     239,    -1,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,    -1,    -1,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
      -1,   340,   341,   342,    -1,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,    -1,    -1,    -1,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,   396,   397,   398,
     399,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,    -1,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,    -1,   444,    -1,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,    -1,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,    -1,
      -1,   520,   521,   522,   523,   524,   525,   526,   527,    -1,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,    -1,
     549,    -1,   551,   552,    -1,   554,   555,   556,   557,   558,
     559,   560,   561,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,    -1,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
      -1,    -1,   144,    -1,   146,   147,   148,   149,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,    -1,   214,   215,   216,    -1,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,    -1,    -1,   239,    -1,   241,
     242,   243,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,    -1,    -1,
     262,   263,   264,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,   318,   319,   320,   321,
      -1,    -1,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,    -1,   340,   341,
     342,    -1,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,    -1,    -1,    -1,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,    -1,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,    -1,   444,    -1,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,    -1,   469,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,    -1,    -1,   520,   521,
     522,   523,   524,   525,   526,   527,    -1,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,    -1,   549,    -1,   551,
     552,    -1,   554,   555,   556,   557,   558,   559,   560,   561,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,   132,   133,   134,
     135,   136,    -1,   138,   139,   140,   141,    -1,    -1,   144,
      -1,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,   207,    -1,    -1,   210,   211,   212,    -1,   214,
     215,   216,    -1,    -1,   219,    -1,   221,   222,   223,    -1,
      -1,   226,    -1,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,    -1,    -1,   239,    -1,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,    -1,    -1,   262,   263,   264,
     265,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,    -1,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,   318,   319,   320,   321,    -1,    -1,   324,
     325,   326,   327,   328,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,   338,    -1,   340,   341,   342,    -1,   344,
     345,   346,   347,    -1,   349,   350,    -1,   352,    -1,    -1,
      -1,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,   396,   397,   398,   399,    -1,   401,   402,   403,   404,
     405,    -1,   407,    -1,   409,   410,   411,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,    -1,    -1,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,    -1,    -1,   442,    -1,   444,
      -1,    -1,   447,   448,   449,   450,    -1,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,    -1,    -1,   463,   464,
     465,   466,   467,    -1,   469,    -1,   471,   472,   473,   474,
     475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,
     485,   486,   487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   497,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,   516,   517,    -1,    -1,   520,   521,   522,   523,   524,
     525,   526,   527,    -1,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,    -1,   549,    -1,   551,   552,    -1,   554,
     555,   556,   557,   558,   559,   560,   561,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,    -1,    -1,   121,    -1,    -1,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,    -1,    -1,   136,    -1,
     138,   139,   140,   141,    -1,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
      -1,    -1,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,    -1,   214,   215,   216,    -1,
      -1,   219,    -1,   221,   222,    -1,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,    -1,
      -1,   239,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,    -1,    -1,   262,   263,   264,    -1,    -1,    -1,
      -1,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,    -1,   314,   315,    -1,    -1,
     318,   319,   320,   321,    -1,    -1,   324,    -1,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,    -1,   340,   341,   342,    -1,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,    -1,    -1,    -1,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
      -1,   409,   410,   411,   412,    -1,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,    -1,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,   442,    -1,   444,    -1,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
      -1,    -1,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
      -1,    -1,   520,   521,   522,   523,   524,   525,   526,   527,
      -1,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
      -1,   549,    -1,   551,   552,    -1,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,    -1,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,    -1,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,    -1,
     262,   263,   264,    -1,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,    -1,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,   227,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,    -1,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,   227,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,   288,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,   209,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,   227,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,   235,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,   164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,   227,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,   332,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,   461,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,   461,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,   332,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
     332,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,   108,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,   108,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,   108,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,    -1,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,   153,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,   153,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,   153,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,   153,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,    -1,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,    -1,   116,   117,
     118,   119,   120,    -1,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,   134,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,    -1,    -1,   146,   147,
     148,   149,   150,    -1,   152,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,   243,   244,   245,    -1,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,    -1,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,    -1,    -1,   273,    -1,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,    -1,   287,
      -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,   314,   315,   316,    -1,
     318,   319,    -1,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,    -1,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,    -1,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
     468,   469,    -1,   471,    -1,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,    -1,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,    -1,   116,   117,   118,   119,   120,    -1,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,   134,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,    -1,    -1,   146,   147,   148,   149,   150,    -1,
     152,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,    -1,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,    -1,
      -1,   273,    -1,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,    -1,   287,    -1,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,   314,   315,   316,    -1,   318,   319,    -1,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
      -1,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,    -1,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,   468,   469,    -1,   471,
      -1,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,    -1,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,    -1,
     116,   117,   118,   119,   120,    -1,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,   134,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,
     146,   147,   148,   149,   150,    -1,   152,    -1,    -1,   155,
     156,   157,   158,   159,   160,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,   243,   244,   245,
      -1,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,    -1,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
      -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,   313,   314,   315,
     316,    -1,   318,   319,    -1,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,    -1,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,    -1,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,   468,   469,    -1,   471,    -1,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
      -1,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,    -1,   116,   117,   118,   119,
     120,    -1,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,   134,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,    -1,    -1,   146,   147,   148,   149,
     150,    -1,   152,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,   243,   244,   245,    -1,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,    -1,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,    -1,    -1,   273,    -1,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,    -1,   287,    -1,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,   314,   315,   316,    -1,   318,   319,
      -1,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,    -1,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,    -1,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,   468,   469,
      -1,   471,    -1,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,    -1,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,    -1,   116,   117,   118,   119,   120,    -1,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
      -1,    -1,   146,   147,   148,   149,   150,    -1,   152,   153,
      -1,   155,   156,   157,   158,   159,   160,    -1,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,    -1,    -1,    -1,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,   243,
     244,   245,    -1,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,    -1,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,    -1,    -1,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
     314,   315,   316,    -1,   318,   319,    -1,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,    -1,   341,    -1,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,   398,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,   468,   469,    -1,   471,    -1,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,    -1,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,     6,     7,
       8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      -1,    -1,    -1,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,
      -1,   119,   120,   121,   122,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,   144,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     178,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
      -1,   229,    -1,   231,    -1,    -1,    -1,    -1,    -1,   237,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   259,   260,    -1,    -1,    -1,    -1,    -1,   266,    -1,
     268,    -1,    -1,   271,   272,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,   312,   313,    -1,    -1,   316,    -1,
      -1,    -1,   320,    -1,    -1,   323,    -1,   325,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,   340,    -1,   342,   343,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   353,    -1,   355,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     388,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     408,    -1,    -1,   411,    -1,   413,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     438,   439,    -1,    -1,    -1,   443,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   469,    -1,    -1,   472,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     488,   489,   490,   491,   492,   493,   494,   495,   496,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,
     528,     6,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      -1,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
     548,    26,    27,    -1,    -1,   553,    31,    32,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    73,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,   120,   121,   122,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   144,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,
      -1,    -1,   217,    -1,    -1,    -1,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,   229,    -1,   231,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   259,   260,    -1,    -1,    -1,    -1,
      -1,   266,    -1,   268,    -1,    -1,   271,   272,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,   312,   313,    -1,
      -1,   316,    -1,    -1,    -1,   320,    -1,    -1,   323,    -1,
     325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,   340,    -1,   342,   343,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   388,    -1,    -1,   391,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,    -1,    -1,   411,    -1,   413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,   439,    -1,    -1,    -1,   443,    -1,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   454,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   469,    -1,    -1,   472,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,    -1,    -1,    -1,    -1,    -1,
      -1,   526,    -1,   528,     6,     7,     8,    -1,    10,    11,
      12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,   548,    26,    27,    -1,    -1,   553,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,   120,   121,
     122,   123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
     142,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    -1,   217,    -1,    -1,    -1,    -1,
      -1,   223,    -1,    -1,    -1,    -1,    -1,   229,    -1,   231,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,    -1,
      -1,    -1,    -1,    -1,   266,    -1,   268,    -1,    -1,   271,
     272,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,
     312,   313,    -1,    -1,   316,    -1,    -1,    -1,   320,    -1,
      -1,   323,    -1,   325,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,   340,    -1,
     342,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   353,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   368,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   388,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,   411,
      -1,   413,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   438,   439,    -1,    -1,
      -1,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   469,    -1,    -1,
     472,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   488,   489,   490,   491,
     492,   493,   494,   495,   496,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,    -1,    -1,
      -1,    -1,    -1,    -1,   526,    -1,   528,     6,     7,     8,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,   548,    26,    27,    -1,
      -1,   553,    31,    32,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,
     119,   120,   121,   122,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,   142,    -1,   144,    -1,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,   217,    -1,
      -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,
     229,    -1,   231,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     259,   260,    -1,    -1,    -1,    -1,    -1,   266,    -1,   268,
      -1,    -1,   271,   272,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,   312,   313,    -1,    -1,   316,    -1,    -1,
      -1,   320,    -1,    -1,   323,    -1,   325,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,   340,    -1,   342,   343,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   353,    -1,   355,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   368,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   388,
      -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,
      -1,    -1,   411,    -1,   413,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   438,
     439,    -1,    -1,    -1,   443,    -1,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     469,    -1,    -1,   472,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,   528,
       6,     7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,   548,
      26,    27,    -1,    -1,   553,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,   119,   120,   121,   122,   123,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   144,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,
      -1,   217,    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,   229,    -1,   231,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   259,   260,    -1,    -1,    -1,    -1,    -1,
     266,    -1,   268,    -1,    -1,   271,   272,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,   312,   313,    -1,    -1,
     316,    -1,    -1,    -1,   320,    -1,    -1,   323,    -1,   325,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,   340,    -1,   342,   343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   388,    -1,    -1,   391,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   408,    -1,    -1,   411,    -1,   413,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   438,   439,    -1,    -1,    -1,   443,    -1,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   469,    -1,    -1,   472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   488,   489,   490,   491,   492,   493,   494,   495,
     496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,    -1,    -1,    -1,    -1,    -1,    -1,
     526,    -1,   528,    -1,    -1,    -1,    -1,    -1,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,   548,    86,    -1,    -1,    -1,   553,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,   132,
     133,    -1,   135,   136,    -1,   138,   139,   140,   141,   142,
      -1,   144,    -1,   146,   147,   148,   149,   150,   151,   152,
      -1,    -1,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,   207,    -1,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,   222,
     223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,    -1,
     333,   334,   335,    -1,    -1,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,    -1,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,    -1,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,    -1,    -1,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,
     463,   464,   465,   466,   467,    -1,   469,    -1,   471,   472,
     473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,    -1,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,   570,   571,   572,
      79,    80,    -1,    -1,    -1,    -1,   579,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,    -1,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,   468,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,    -1,
     579,    88,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,    -1,    -1,    -1,   105,    -1,
      -1,   108,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,    -1,   133,    -1,    -1,   136,
      -1,   138,   139,   140,   141,   142,   143,    -1,    -1,   146,
      -1,   148,   149,   150,    -1,    -1,   153,    -1,   155,   156,
      -1,   158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,    -1,   175,    -1,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,    -1,    -1,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,    -1,    -1,    -1,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,    -1,   232,    -1,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,    -1,    -1,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,   271,   272,   273,    -1,   275,    -1,
     277,   278,   279,    -1,    -1,    -1,    -1,    -1,   285,    -1,
     287,   288,    -1,   290,   291,   292,    -1,    -1,   295,   296,
      -1,   298,    -1,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,    -1,    -1,   330,    -1,    -1,   333,   334,   335,   336,
      -1,    -1,   339,   340,    -1,    -1,   343,   344,   345,    -1,
     347,    -1,    -1,   350,    -1,    -1,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,    -1,   365,   366,
     367,   368,   369,   370,    -1,    -1,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,    -1,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,    -1,   403,    -1,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,    -1,    -1,   416,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
      -1,   428,   429,    -1,    -1,   432,   433,   434,   435,    -1,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,    -1,    -1,   452,   453,    -1,    -1,   456,
     457,    -1,   459,   460,    -1,    -1,   463,   464,    -1,   466,
     467,   468,   469,    -1,    -1,   472,   473,   474,    -1,   476,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,    -1,   486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,   510,   511,   512,    -1,   514,   515,   516,
      -1,   518,   519,   520,   521,    -1,   523,    -1,   525,   526,
     527,    -1,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,   541,    -1,    -1,    -1,    -1,    -1,
     547,   548,    -1,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   566,
     567,   568,    -1,   570,   571,   572,   573,   574,   575,    71,
      72,    -1,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,    -1,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,   144,    -1,   146,   147,   148,   149,   150,   151,
     152,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,   181,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
      -1,   333,   334,   335,    -1,    -1,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,    -1,   469,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    72,   570,   571,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,   132,   133,    -1,
     135,   136,    -1,   138,   139,   140,   141,   142,    -1,   144,
      -1,   146,   147,   148,   149,   150,   151,   152,    -1,    -1,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,   181,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,   207,    -1,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,   222,   223,    -1,
      -1,   226,    -1,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,    -1,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,    -1,   333,   334,
     335,    -1,    -1,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,   349,   350,    -1,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,    -1,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,    -1,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,    -1,    -1,   463,   464,
     465,   466,   467,    -1,   469,    -1,   471,   472,   473,   474,
     475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    72,   570,   571,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
      -1,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,    -1,    -1,    -1,    -1,    -1,
      71,    -1,   570,   571,    75,    76,    77,    78,    79,    80,
      -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
      -1,   132,   133,    -1,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,   144,    -1,   146,   147,   148,   149,   150,
     151,   152,    -1,    -1,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,    -1,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,    -1,   333,   334,   335,    -1,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,    -1,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
      -1,    -1,   463,   464,   465,   466,   467,    -1,   469,    -1,
     471,   472,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,    -1,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    71,    72,    -1,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,    -1,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
     440,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,    -1,   469,
      -1,   471,   472,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,    -1,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,    -1,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
      -1,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,    -1,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,    -1,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,    -1,   469,    -1,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
      -1,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    71,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,    -1,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,    -1,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,    -1,   469,    -1,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,   132,   133,    -1,
     135,   136,    -1,   138,   139,   140,   141,   142,    -1,   144,
      -1,   146,   147,   148,   149,   150,   151,   152,    -1,    -1,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,   171,   172,   173,   174,
     175,    -1,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,   207,    -1,    -1,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,    -1,   221,   222,   223,    -1,
      -1,   226,    -1,   228,   229,    -1,   231,   232,   233,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,    -1,   262,   263,   264,
      -1,   266,    -1,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,    -1,    -1,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,   349,   350,    -1,   352,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    -1,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,    -1,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,    -1,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,    -1,   452,   453,    -1,
      -1,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,    -1,   469,    -1,   471,   472,   473,   474,
     475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,    -1,   498,   499,   500,   501,   502,   503,   504,
     505,    -1,   507,    -1,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,   126,   127,   128,   129,    -1,    -1,   132,   133,
      -1,   135,   136,    -1,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,    -1,
      -1,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,    -1,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,   207,    -1,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,   219,    -1,   221,   222,   223,
      -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,   233,
     234,    -1,   236,   237,    -1,   239,    -1,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,    -1,   262,   263,
     264,    -1,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,    -1,
      -1,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,    -1,   330,    -1,    -1,   333,
     334,   335,    -1,    -1,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,   349,   350,    -1,   352,   353,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,    -1,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,    -1,   399,    -1,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,    -1,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,    -1,   438,   439,    -1,    -1,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,    -1,   452,   453,
      -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,   463,
     464,   465,   466,   467,    -1,   469,    -1,   471,   472,   473,
     474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,    -1,   498,   499,   500,   501,   502,   503,
     504,   505,    -1,   507,    -1,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,   132,
     133,    -1,   135,   136,    -1,   138,   139,   140,   141,   142,
      -1,   144,    -1,   146,   147,   148,   149,   150,   151,   152,
      -1,    -1,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,   175,    -1,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,   207,    -1,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,    -1,   221,   222,
     223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,   232,
     233,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,    -1,   262,
     263,   264,    -1,   266,    -1,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
      -1,    -1,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,    -1,   330,    -1,    -1,
     333,   334,   335,    -1,    -1,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,   349,   350,    -1,   352,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
      -1,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,    -1,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,    -1,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,    -1,   438,   439,    -1,    -1,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,    -1,   452,
     453,    -1,    -1,   456,   457,   458,   459,   460,    -1,    -1,
     463,   464,   465,   466,   467,    -1,   469,    -1,   471,   472,
     473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,    -1,   498,   499,   500,   501,   502,
     503,   504,   505,    -1,   507,    -1,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,    -1,   125,   126,   127,   128,   129,    -1,    -1,
     132,   133,    -1,   135,   136,    -1,   138,   139,   140,   141,
     142,    -1,   144,    -1,   146,   147,   148,   149,   150,   151,
     152,    -1,    -1,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,   207,    -1,    -1,   210,   211,
     212,   213,   214,   215,   216,   217,    -1,   219,    -1,   221,
     222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,   231,
     232,   233,   234,    -1,   236,   237,    -1,   239,    -1,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,    -1,
     262,   263,   264,    -1,   266,    -1,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,    -1,    -1,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,   327,   328,    -1,   330,    -1,
      -1,   333,   334,   335,    -1,    -1,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,   349,   350,    -1,
     352,   353,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,    -1,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,    -1,   399,    -1,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,    -1,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,    -1,   438,   439,    -1,    -1,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,    -1,
     452,   453,    -1,    -1,   456,   457,   458,   459,   460,    -1,
      -1,   463,   464,   465,   466,   467,    -1,   469,    -1,   471,
     472,   473,   474,   475,   476,    -1,    -1,   479,    -1,    -1,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,    -1,   498,   499,   500,   501,
     502,   503,   504,   505,    -1,   507,    -1,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
      -1,   132,   133,    -1,   135,   136,    -1,   138,   139,   140,
     141,   142,    -1,   144,    -1,   146,   147,   148,   149,   150,
     151,   152,    -1,    -1,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,    -1,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,    -1,
     221,   222,   223,    -1,    -1,   226,    -1,   228,   229,    -1,
     231,   232,   233,   234,    -1,   236,   237,   238,   239,    -1,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
      -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,    -1,    -1,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,   327,   328,    -1,   330,
      -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,   349,   350,
      -1,   352,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,    -1,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,    -1,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,    -1,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
      -1,   452,   453,    -1,    -1,   456,   457,   458,   459,   460,
      -1,    -1,   463,   464,   465,   466,   467,    -1,   469,    -1,
     471,   472,   473,   474,   475,   476,    -1,    -1,   479,    -1,
      -1,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,    -1,   498,   499,   500,
     501,   502,   503,   504,   505,    -1,   507,    -1,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,    -1,   125,   126,   127,   128,   129,
      -1,    -1,   132,   133,    -1,   135,   136,    -1,   138,   139,
     140,   141,   142,    -1,   144,    -1,   146,   147,   148,   149,
     150,   151,   152,    -1,    -1,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,    -1,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,   207,    -1,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,   219,
      -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,   229,
      -1,   231,   232,   233,   234,    -1,   236,   237,    -1,   239,
      -1,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,    -1,   262,   263,   264,    -1,   266,    -1,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,    -1,    -1,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,    -1,
     330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,   349,
     350,    -1,   352,   353,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,    -1,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,   399,
      -1,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,    -1,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,   438,   439,
      -1,    -1,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,    -1,   452,   453,    -1,    -1,   456,   457,   458,   459,
     460,    -1,    -1,   463,   464,   465,   466,   467,    -1,   469,
      -1,   471,   472,   473,   474,   475,   476,    -1,    -1,   479,
      -1,    -1,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,    -1,   498,   499,
     500,   501,   502,   503,   504,   505,    -1,   507,    -1,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,   147,   148,
     149,   150,   151,   152,    -1,    -1,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,   207,    -1,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,   228,
     229,    -1,   231,   232,   233,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,    -1,   262,   263,   264,    -1,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,    -1,    -1,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
     349,   350,    -1,   352,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,    -1,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,    -1,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    -1,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,    -1,   452,   453,    -1,    -1,   456,   457,   458,
     459,   460,    -1,    -1,   463,   464,   465,   466,   467,    -1,
     469,    -1,   471,   472,   473,   474,   475,   476,    -1,    -1,
     479,    -1,    -1,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,    -1,   498,
     499,   500,   501,   502,   503,   504,   505,    -1,   507,    -1,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,    -1,   125,   126,   127,
     128,   129,    -1,    -1,   132,   133,    -1,   135,   136,    -1,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,   147,
     148,   149,   150,   151,   152,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,    -1,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,   207,
      -1,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,    -1,
     228,   229,    -1,   231,   232,   233,   234,    -1,   236,   237,
      -1,   239,    -1,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,    -1,   262,   263,   264,    -1,   266,    -1,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,    -1,    -1,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,   349,   350,    -1,   352,   353,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,    -1,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
      -1,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,    -1,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,    -1,
     438,   439,    -1,    -1,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,    -1,   452,   453,    -1,    -1,   456,   457,
     458,   459,   460,    -1,    -1,   463,   464,   465,   466,   467,
      -1,   469,    -1,   471,   472,   473,   474,   475,   476,    -1,
      -1,   479,    -1,    -1,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,    -1,
     498,   499,   500,   501,   502,   503,   504,   505,    -1,   507,
      -1,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,   132,   133,    -1,   135,   136,
      -1,   138,   139,   140,   141,   142,    -1,   144,    -1,   146,
     147,   148,   149,   150,   151,   152,    -1,    -1,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
     207,    -1,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,   231,   232,   233,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,    -1,   262,   263,   264,    -1,   266,
      -1,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,    -1,    -1,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,   349,   350,    -1,   352,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,    -1,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
      -1,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,    -1,   452,   453,    -1,    -1,   456,
     457,   458,   459,   460,    -1,    -1,   463,   464,   465,   466,
     467,    -1,   469,    -1,   471,   472,   473,   474,   475,   476,
      -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
      -1,   498,   499,   500,   501,   502,   503,   504,   505,    -1,
     507,    -1,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,    -1,   125,
     126,   127,   128,   129,    -1,    -1,   132,   133,    -1,   135,
     136,    -1,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,   147,   148,   149,   150,   151,   152,    -1,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
      -1,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,    -1,   221,   222,   223,    -1,    -1,
     226,    -1,   228,   229,    -1,   231,   232,   233,   234,    -1,
     236,   237,    -1,   239,    -1,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,    -1,   262,   263,   264,    -1,
     266,    -1,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,    -1,    -1,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,    -1,   330,    -1,    -1,   333,   334,   335,
      -1,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,   349,   350,    -1,   352,   353,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,    -1,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,    -1,   399,    -1,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,    -1,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,   438,   439,    -1,    -1,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,    -1,   452,   453,    -1,    -1,
     456,   457,   458,   459,   460,    -1,    -1,   463,   464,   465,
     466,   467,    -1,   469,    -1,   471,   472,   473,   474,   475,
     476,    -1,    -1,   479,    -1,    -1,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,    -1,   498,   499,   500,   501,   502,   503,   504,   505,
      -1,   507,    -1,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,    -1,   133,    -1,
      -1,   136,    -1,   138,   139,   140,   141,   142,    -1,    -1,
      -1,   146,    -1,   148,   149,   150,    -1,    -1,   153,    -1,
     155,   156,    -1,   158,   159,   160,    -1,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,    -1,
     175,    -1,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,   197,   198,   199,    -1,   201,   202,   203,   204,
     205,   206,    -1,    -1,    -1,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,    -1,    -1,    -1,   222,   223,    -1,
     225,   226,    -1,   228,   229,    -1,    -1,   232,    -1,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,    -1,    -1,
     245,    -1,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,   277,   278,   279,    -1,    -1,    -1,    -1,    -1,
     285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,
     295,   296,    -1,   298,    -1,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,    -1,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,    -1,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,    -1,   339,   340,    -1,    -1,   343,   344,
     345,    -1,   347,    -1,    -1,   350,    -1,    -1,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,    -1,
     365,   366,   367,   368,   369,   370,    -1,    -1,    -1,    -1,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
      -1,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,    -1,   401,    -1,   403,    -1,
     405,    -1,   407,   408,   409,   410,    -1,   412,   413,    -1,
      -1,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,    -1,   428,   429,    -1,    -1,    -1,   433,   434,
     435,    -1,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,    -1,   447,   448,   449,    -1,    -1,   452,   453,    -1,
      -1,   456,   457,    -1,   459,   460,    -1,    -1,   463,   464,
      -1,   466,   467,   468,   469,    -1,    -1,   472,   473,   474,
      -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,
      -1,   486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,   514,
     515,   516,    -1,   518,   519,   520,   521,    -1,   523,    -1,
     525,   526,   527,    -1,   529,   530,   531,    -1,   533,    -1,
     535,   536,   537,   538,   539,   540,   541,    -1,    -1,    -1,
      -1,    -1,   547,   548,    -1,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,    -1,   133,    -1,    -1,   136,
      -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,   146,
      -1,   148,   149,   150,    -1,    -1,   153,    -1,   155,   156,
      -1,   158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,    -1,   175,    -1,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,    -1,    -1,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,    -1,    -1,    -1,   222,   223,    -1,   225,   226,
      -1,   228,   229,    -1,    -1,   232,    -1,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,    -1,    -1,   245,    -1,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
     277,   278,   279,    -1,    -1,    -1,    -1,    -1,   285,    -1,
     287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,
      -1,   298,    -1,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,    -1,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,   344,   345,    -1,
     347,    -1,    -1,   350,    -1,    -1,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,    -1,   365,   366,
     367,   368,   369,   370,    -1,    -1,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,    -1,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,    -1,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,   412,   413,    -1,    -1,   416,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
      -1,   428,   429,    -1,    -1,    -1,   433,   434,   435,    -1,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,    -1,    -1,   452,   453,    -1,    -1,   456,
     457,    -1,   459,   460,    -1,    -1,   463,   464,    -1,   466,
     467,   468,   469,    -1,    -1,   472,   473,   474,    -1,   476,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,    -1,   486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,   510,   511,   512,    -1,   514,   515,   516,
      -1,   518,   519,   520,   521,    -1,   523,    -1,   525,   526,
     527,    -1,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,   541,    -1,    -1,    -1,    -1,    -1,
     547,   548,    -1,    -1,   551,   552,   553,   554,   555,   556,
     557,   558,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    -1,    96,    97,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,   115,   116,   117,   118,
      -1,   120,   121,   122,   123,    -1,   125,   126,   127,   128,
     129,    -1,    -1,    -1,   133,    -1,    -1,   136,    -1,   138,
     139,   140,   141,   142,    -1,    -1,    -1,   146,    -1,   148,
     149,   150,    -1,    -1,   153,    -1,   155,   156,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,    -1,   175,    -1,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,    -1,
      -1,   210,   211,   212,   213,   214,    -1,   216,   217,    -1,
      -1,    -1,    -1,   222,   223,    -1,   225,   226,    -1,   228,
     229,    -1,    -1,   232,    -1,   234,    -1,   236,   237,    -1,
     239,    -1,   241,   242,    -1,    -1,   245,    -1,   247,   248,
     249,    -1,   251,   252,   253,   254,   255,   256,    -1,    -1,
      -1,   260,   261,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,    -1,    -1,   273,    -1,   275,    -1,   277,   278,
     279,    -1,    -1,    -1,    -1,    -1,   285,    -1,   287,    -1,
      -1,   290,   291,   292,    -1,    -1,   295,   296,    -1,   298,
      -1,   300,   301,   302,   303,    -1,   305,   306,    -1,   308,
     309,   310,   311,    -1,   313,   314,   315,   316,    -1,   318,
     319,    -1,   321,    -1,   323,   324,   325,   326,   327,    -1,
      -1,   330,    -1,    -1,   333,   334,   335,    -1,    -1,    -1,
     339,   340,    -1,    -1,   343,   344,   345,    -1,   347,    -1,
      -1,   350,    -1,    -1,   353,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,    -1,   365,   366,   367,   368,
     369,   370,    -1,    -1,    -1,    -1,   375,   376,   377,   378,
     379,   380,    -1,   382,   383,   384,    -1,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,   397,    -1,
     399,    -1,   401,    -1,   403,    -1,   405,    -1,   407,   408,
     409,   410,    -1,   412,   413,    -1,    -1,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,    -1,   428,
     429,    -1,    -1,    -1,   433,   434,   435,    -1,    -1,   438,
     439,    -1,    -1,   442,   443,   444,   445,    -1,   447,   448,
     449,    -1,    -1,   452,   453,    -1,    -1,   456,   457,    -1,
     459,   460,    -1,    -1,   463,   464,    -1,   466,   467,   468,
     469,    -1,    -1,   472,   473,   474,    -1,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   484,    -1,   486,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     499,   500,   501,   502,   503,   504,   505,    -1,    -1,    -1,
      -1,   510,   511,   512,    -1,   514,   515,   516,    -1,   518,
     519,   520,   521,    -1,   523,    -1,   525,   526,   527,    -1,
     529,   530,   531,    -1,   533,    -1,   535,   536,   537,   538,
     539,   540,   541,    -1,    -1,    -1,    -1,    -1,   547,   548,
      -1,    -1,   551,   552,   553,   554,   555,   556,   557,   558,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    -1,    96,    97,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,    -1,    -1,   115,   116,   117,   118,    -1,   120,
     121,   122,   123,    -1,   125,   126,   127,   128,   129,    -1,
      -1,    -1,   133,    -1,    -1,   136,    -1,   138,   139,   140,
     141,   142,    -1,    -1,    -1,   146,    -1,   148,   149,   150,
      -1,    -1,   153,    -1,   155,   156,    -1,   158,   159,   160,
      -1,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,    -1,   175,    -1,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,    -1,
     191,    -1,    -1,    -1,    -1,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,    -1,    -1,   210,
     211,   212,   213,   214,    -1,   216,   217,    -1,    -1,    -1,
      -1,   222,   223,    -1,   225,   226,    -1,   228,   229,    -1,
      -1,   232,    -1,   234,    -1,   236,   237,    -1,   239,    -1,
     241,   242,    -1,    -1,   245,    -1,   247,   248,   249,    -1,
     251,   252,   253,   254,   255,   256,    -1,    -1,    -1,   260,
     261,   262,   263,   264,   265,   266,    -1,   268,    -1,   270,
      -1,    -1,   273,    -1,   275,    -1,   277,   278,   279,    -1,
      -1,    -1,    -1,    -1,   285,    -1,   287,    -1,    -1,   290,
     291,   292,    -1,    -1,   295,   296,    -1,   298,    -1,   300,
     301,   302,   303,    -1,   305,   306,    -1,   308,   309,   310,
     311,    -1,   313,   314,   315,   316,    -1,   318,   319,    -1,
     321,    -1,   323,   324,   325,   326,   327,    -1,    -1,   330,
      -1,    -1,   333,   334,   335,    -1,    -1,    -1,   339,   340,
      -1,    -1,   343,   344,   345,    -1,   347,    -1,    -1,   350,
      -1,    -1,   353,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,    -1,   365,   366,   367,   368,   369,   370,
      -1,    -1,    -1,    -1,   375,   376,   377,   378,   379,   380,
      -1,   382,   383,   384,    -1,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,   397,    -1,   399,    -1,
     401,    -1,   403,    -1,   405,    -1,   407,   408,   409,   410,
      -1,   412,   413,    -1,    -1,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,    -1,   428,   429,    -1,
      -1,    -1,   433,   434,   435,    -1,    -1,   438,   439,    -1,
      -1,   442,   443,   444,   445,    -1,   447,   448,   449,    -1,
      -1,   452,   453,    -1,    -1,   456,   457,    -1,   459,   460,
      -1,    -1,   463,   464,    -1,   466,   467,   468,   469,    -1,
      -1,   472,   473,   474,    -1,   476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   484,    -1,   486,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   499,   500,
     501,   502,   503,   504,   505,    -1,    -1,    -1,    -1,   510,
     511,   512,    -1,   514,   515,   516,    -1,   518,   519,   520,
     521,    -1,   523,    -1,   525,   526,   527,    -1,   529,   530,
     531,    -1,   533,    -1,   535,   536,   537,   538,   539,   540,
     541,    -1,    -1,    -1,    -1,    -1,   547,   548,    -1,    -1,
     551,   552,   553,   554,   555,   556,   557,   558,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    -1,    96,    97,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,   116,   117,   118,    -1,   120,   121,   122,
     123,    -1,   125,   126,   127,   128,   129,    -1,    -1,    -1,
     133,    -1,    -1,   136,    -1,   138,   139,   140,   141,   142,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,    -1,    -1,
     153,    -1,   155,   156,    -1,   158,   159,   160,    -1,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,    -1,   175,    -1,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,    -1,   191,    -1,
      -1,    -1,    -1,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,    -1,    -1,   210,   211,   212,
     213,   214,    -1,   216,   217,    -1,    -1,    -1,    -1,   222,
     223,    -1,   225,   226,    -1,   228,   229,    -1,    -1,   232,
      -1,   234,    -1,   236,   237,    -1,   239,    -1,   241,   242,
      -1,    -1,   245,    -1,   247,   248,   249,    -1,   251,   252,
     253,   254,   255,   256,    -1,    -1,    -1,   260,   261,   262,
     263,   264,   265,   266,    -1,   268,    -1,   270,    -1,    -1,
     273,    -1,   275,    -1,   277,   278,   279,    -1,    -1,    -1,
      -1,    -1,   285,    -1,   287,    -1,    -1,   290,   291,   292,
      -1,    -1,   295,   296,    -1,   298,    -1,   300,   301,   302,
     303,    -1,   305,   306,    -1,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,    -1,   318,   319,    -1,   321,    -1,
     323,   324,   325,   326,   327,    -1,    -1,   330,    -1,    -1,
     333,   334,   335,    -1,    -1,    -1,   339,   340,    -1,    -1,
     343,   344,   345,    -1,   347,    -1,    -1,   350,    -1,    -1,
     353,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,    -1,   365,   366,   367,   368,   369,   370,    -1,    -1,
      -1,    -1,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,    -1,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,    -1,   401,    -1,
     403,    -1,   405,    -1,   407,   408,   409,   410,    -1,   412,
     413,    -1,    -1,   416,    -1,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,    -1,   428,   429,    -1,    -1,    -1,
     433,   434,   435,    -1,    -1,   438,   439,    -1,    -1,   442,
     443,   444,   445,    -1,   447,   448,   449,    -1,    -1,   452,
     453,    -1,    -1,   456,   457,    -1,   459,   460,    -1,    -1,
     463,   464,    -1,   466,   467,   468,   469,    -1,    -1,   472,
     473,   474,    -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   484,    -1,   486,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   499,   500,   501,   502,
     503,   504,   505,    -1,    -1,    -1,    -1,   510,   511,   512,
      -1,   514,   515,   516,    -1,   518,   519,   520,   521,    -1,
     523,    -1,   525,   526,   527,    -1,   529,   530,   531,    -1,
     533,    -1,   535,   536,   537,   538,   539,   540,   541,    -1,
      -1,    -1,    -1,    -1,   547,   548,    -1,    -1,   551,   552,
     553,   554,   555,   556,   557,   558,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      -1,    96,    97,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,   116,   117,   118,    -1,   120,   121,   122,   123,    -1,
     125,   126,   127,   128,   129,    -1,    -1,    -1,   133,    -1,
      -1,   136,    -1,   138,   139,   140,   141,   142,    -1,    -1,
      -1,   146,    -1,   148,   149,   150,    -1,    -1,   153,    -1,
     155,   156,    -1,   158,   159,   160,    -1,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,    -1,
     175,    -1,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,    -1,    -1,   210,   211,   212,   213,   214,
      -1,   216,   217,    -1,    -1,    -1,    -1,   222,   223,    -1,
     225,   226,    -1,   228,   229,    -1,    -1,   232,    -1,   234,
      -1,   236,   237,    -1,   239,    -1,   241,   242,    -1,    -1,
     245,    -1,   247,   248,   249,    -1,   251,   252,   253,   254,
     255,   256,    -1,    -1,    -1,   260,   261,   262,   263,   264,
     265,   266,    -1,   268,    -1,   270,    -1,    -1,   273,    -1,
     275,    -1,   277,   278,   279,    -1,    -1,    -1,    -1,    -1,
     285,    -1,   287,    -1,    -1,   290,   291,   292,    -1,    -1,
     295,   296,    -1,   298,    -1,   300,   301,   302,   303,    -1,
     305,   306,    -1,   308,   309,   310,   311,    -1,   313,   314,
     315,   316,    -1,   318,   319,    -1,   321,    -1,   323,   324,
     325,   326,   327,    -1,    -1,   330,    -1,    -1,   333,   334,
     335,    -1,    -1,    -1,   339,   340,    -1,    -1,   343,   344,
     345,    -1,   347,    -1,    -1,   350,    -1,    -1,   353,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,    -1,
     365,   366,   367,   368,   369,   370,    -1,    -1,    -1,    -1,
     375,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
      -1,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,    -1,   401,    -1,   403,    -1,
     405,    -1,    -1,   408,   409,   410,    -1,   412,   413,    -1,
      -1,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,    -1,   428,   429,    -1,    -1,    -1,   433,   434,
     435,    -1,    -1,   438,   439,    -1,    -1,   442,   443,   444,
     445,    -1,   447,   448,   449,    -1,    -1,   452,   453,    -1,
      -1,   456,   457,    -1,   459,   460,    -1,    -1,   463,   464,
      -1,   466,   467,   468,   469,    -1,    -1,   472,   473,   474,
      -1,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,
      -1,   486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,   500,   501,   502,   503,   504,
     505,    -1,    -1,    -1,    -1,   510,   511,   512,    -1,   514,
     515,   516,    -1,   518,   519,   520,   521,    -1,   523,    -1,
     525,   526,   527,    -1,   529,   530,   531,    -1,   533,    -1,
     535,   536,   537,   538,   539,   540,   541,    -1,    -1,    -1,
      -1,    -1,   547,   548,    -1,    -1,   551,   552,   553,   554,
     555,   556,   557,   558,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    -1,    96,
      97,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,   116,
     117,   118,    -1,   120,   121,   122,   123,    -1,   125,   126,
     127,   128,   129,    -1,    -1,    -1,   133,    -1,    -1,   136,
      -1,   138,   139,   140,   141,   142,    -1,    -1,    -1,   146,
      -1,   148,   149,   150,    -1,    -1,   153,    -1,   155,   156,
      -1,   158,   159,   160,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,    -1,   175,    -1,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,    -1,    -1,   210,   211,   212,   213,   214,    -1,   216,
     217,    -1,    -1,    -1,    -1,   222,   223,    -1,    -1,   226,
      -1,   228,   229,    -1,    -1,   232,    -1,   234,    -1,   236,
     237,    -1,   239,    -1,   241,   242,    -1,    -1,   245,    -1,
     247,   248,   249,    -1,   251,   252,   253,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,   263,   264,   265,   266,
      -1,   268,    -1,   270,    -1,    -1,   273,    -1,   275,    -1,
     277,   278,   279,    -1,    -1,    -1,    -1,    -1,   285,    -1,
     287,    -1,    -1,   290,   291,   292,    -1,    -1,   295,   296,
      -1,   298,    -1,   300,   301,   302,   303,    -1,   305,   306,
      -1,   308,   309,   310,   311,    -1,   313,   314,   315,   316,
      -1,   318,   319,    -1,   321,    -1,   323,   324,   325,   326,
     327,    -1,    -1,   330,    -1,    -1,   333,   334,   335,    -1,
      -1,    -1,   339,   340,    -1,    -1,   343,   344,   345,    -1,
     347,    -1,    -1,   350,    -1,    -1,   353,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,    -1,   365,   366,
     367,   368,   369,   370,    -1,    -1,    -1,    -1,   375,   376,
     377,   378,   379,   380,    -1,   382,   383,   384,    -1,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,    -1,   403,    -1,   405,    -1,
     407,   408,   409,   410,    -1,   412,   413,    -1,    -1,   416,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
      -1,   428,   429,    -1,    -1,    -1,   433,   434,   435,    -1,
      -1,   438,   439,    -1,    -1,   442,   443,   444,   445,    -1,
     447,   448,   449,    -1,    -1,   452,   453,    -1,    -1,   456,
     457,    -1,   459,   460,    -1,    -1,   463,   464,    -1,   466,
     467,   468,   469,    -1,    -1,   472,   473,   474,    -1,   476,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   484,    -1,   486,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   499,   500,   501,   502,   503,   504,   505,    -1,
      -1,    -1,    -1,   510,   511,   512,    -1,   514,   515,   516,
      -1,   518,   519,   520,   521,    -1,   523,    -1,   525,   526,
     527,    -1,   529,   530,   531,    -1,   533,    -1,   535,   536,
     537,   538,   539,   540,   541,    -1,    -1,    -1,    -1,    -1,
     547,   548,    -1,    -1,   551,   552,   553,   554,   555,   556,
     557,   558
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   588,  1267,     0,     5,    25,    35,    36,    41,    43,
      44,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    73,    75,    76,    77,
      78,    79,    80,    81,    82,    86,   134,   205,   223,   243,
     265,   304,   307,   322,   398,   440,   454,   469,   497,   566,
     570,   571,   572,   573,   574,   577,   578,   579,   580,   582,
     583,   584,   585,   586,  1253,  1268,  1296,  1298,  1389,  1399,
    1400,  1402,  1408,  1409,  1297,     3,     6,     7,     8,     9,
      10,    11,    12,    13,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    31,    32,    33,
      34,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    50,    51,    56,    65,    67,    69,    70,    91,   101,
     103,   104,   113,   115,   118,   119,   120,   121,   122,   123,
     135,   138,   140,   141,   142,   144,   146,   148,   151,   159,
     161,   162,   168,   175,   177,   178,   179,   180,   192,   194,
     198,   204,   205,   212,   213,   214,   217,   220,   223,   229,
     231,   235,   237,   246,   259,   260,   266,   268,   271,   272,
     274,   285,   286,   288,   290,   291,   296,   308,   311,   312,
     313,   316,   319,   320,   323,   325,   339,   340,   342,   343,
     353,   355,   357,   368,   369,   374,   375,   377,   382,   387,
     388,   390,   391,   394,   399,   400,   407,   408,   410,   411,
     413,   418,   426,   430,   438,   439,   443,   445,   447,   449,
     454,   457,   463,   468,   469,   472,   481,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   518,   519,   526,   528,
     548,   553,   579,   589,   590,   593,   594,   595,   596,   597,
     600,   615,   616,   618,   619,   620,   621,   622,   623,   624,
     626,   627,   631,   643,   648,   649,   652,   653,   654,   671,
     674,   675,   692,   770,   796,   799,   800,   801,   808,   814,
     816,   818,   819,   822,   825,   826,   830,   831,   840,   844,
     845,   846,   847,   848,   850,   851,   852,   865,   866,   870,
     872,   873,   874,   885,   887,   894,   895,   898,   899,   900,
     901,   902,   907,   909,   912,   916,   920,   921,   931,   932,
     935,   940,   951,   973,   976,   977,   978,   981,   984,   986,
     988,   991,   992,   993,   996,   997,   998,  1005,  1006,  1008,
    1009,  1010,  1015,  1017,  1018,  1022,  1023,  1026,  1027,  1028,
    1029,  1031,  1032,  1033,  1034,  1036,  1039,  1040,  1046,  1053,
    1056,  1060,  1065,  1067,  1071,  1078,  1082,  1083,  1084,  1085,
    1086,  1087,  1090,  1120,  1264,  1265,  1269,  1271,  1272,  1289,
    1290,  1291,  1292,  1303,  1305,  1309,  1310,  1311,  1312,  1313,
    1315,  1317,  1319,  1320,  1321,  1322,  1324,  1329,  1330,  1334,
    1335,  1344,  1346,  1347,  1348,  1351,  1356,  1359,  1364,  1366,
    1367,  1370,  1372,  1375,  1384,  1402,  1410,    73,  1292,  1300,
    1301,    14,    72,    91,    92,    93,    94,    95,    96,    97,
      98,   100,   101,   102,   110,   111,   113,   114,   116,   117,
     118,   125,   126,   127,   128,   129,   132,   133,   136,   138,
     139,   140,   141,   146,   147,   148,   149,   150,   152,   155,
     156,   157,   158,   159,   160,   163,   172,   173,   174,   175,
     177,   180,   182,   184,   185,   186,   187,   188,   190,   191,
     192,   195,   196,   197,   198,   199,   201,   202,   203,   205,
     206,   207,   210,   211,   212,   214,   215,   216,   219,   221,
     222,   226,   228,   232,   233,   234,   236,   239,   241,   242,
     244,   245,   247,   248,   249,   251,   252,   253,   254,   255,
     256,   258,   262,   263,   264,   270,   273,   275,   276,   277,
     278,   279,   281,   282,   284,   287,   290,   291,   292,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   305,   306,
     308,   309,   310,   314,   315,   318,   319,   321,   324,   326,
     327,   328,   330,   333,   334,   335,   338,   341,   344,   345,
     346,   347,   349,   350,   352,   356,   357,   358,   360,   361,
     362,   363,   364,   365,   366,   367,   369,   370,   371,   372,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   386,   387,   389,   390,   392,   393,   394,   395,   396,
     397,   399,   401,   402,   403,   404,   405,   407,   409,   410,
     412,   414,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   428,   429,   431,   432,   433,   434,   435,   436,
     440,   442,   444,   447,   448,   449,   450,   452,   453,   456,
     457,   458,   459,   460,   463,   464,   465,   466,   467,   471,
     473,   474,   475,   476,   479,   482,   483,   484,   485,   486,
     487,   498,   499,   500,   501,   502,   503,   504,   505,   507,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   520,
     521,   522,   523,   524,   525,   527,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   549,   551,   552,   554,   555,
     556,   557,   558,   559,   560,   561,  1254,  1258,  1259,  1264,
    1265,  1282,  1283,  1394,  1396,  1400,  1402,    29,   261,  1345,
       9,    13,    15,    28,    45,    46,    50,    51,    56,    65,
      67,    69,    70,    99,   134,   153,   164,   176,   181,   243,
     304,   307,   398,   468,   497,  1246,  1259,  1264,  1284,  1331,
    1332,  1374,  1375,  1376,  1380,  1385,  1386,  1387,  1396,  1402,
      99,  1079,  1245,  1284,  1380,  1393,    14,  1079,     5,    25,
      29,    35,    36,    43,    44,    99,   103,   104,   105,   106,
     107,   108,   109,   112,   124,   130,   131,   134,   137,   143,
     145,   153,   154,   161,   164,   165,   166,   167,   169,   170,
     171,   181,   183,   189,   193,   194,   200,   204,   208,   209,
     218,   220,   224,   225,   227,   230,   235,   238,   240,   250,
     257,   261,   265,   267,   269,   280,   283,   289,   293,   294,
     317,   322,   329,   331,   332,   336,   337,   348,   351,   354,
     359,   373,   385,   400,   406,   415,   427,   430,   437,   440,
     441,   446,   451,   454,   455,   461,   462,   468,   470,   477,
     478,   480,   481,   506,   508,   550,  1259,  1266,  1376,  1377,
    1378,  1382,  1383,  1384,  1385,  1387,    25,    35,   134,   265,
    1371,    38,    40,   317,  1304,   442,   484,  1011,    98,   144,
     158,   175,   181,   196,   207,   215,   216,   227,   232,   238,
     253,   278,   299,   333,   362,   389,   393,   395,   401,   404,
     429,   430,   432,   436,   444,   449,   461,   474,   540,   547,
     815,  1332,   180,  1011,    99,  1079,   472,  1041,   331,   358,
    1011,   121,   683,  1083,   110,   131,   144,   154,   175,   181,
     196,   207,   215,   227,   234,   238,   292,   333,   336,   389,
     395,   404,   432,   433,   435,   436,   444,   449,   455,   458,
     461,   534,   543,   547,   561,   693,   771,   798,   875,   890,
     941,   952,  1246,  1273,  1274,  1275,  1284,  1400,  1402,    14,
      99,   357,  1245,  1284,  1288,   419,  1079,    99,   352,   402,
     433,   435,   277,   982,   983,  1400,    98,   110,   131,   144,
     158,   175,   196,   207,   215,   216,   227,   232,   238,   253,
     299,   333,   344,   389,   393,   395,   401,   404,   430,   432,
     436,   444,   449,   461,   474,   540,   547,   815,   903,  1011,
     585,  1314,  1378,   247,  1288,   161,   180,   212,   472,   579,
     692,   796,   799,  1040,  1047,  1056,  1060,  1065,  1071,  1078,
    1082,  1269,    92,    99,   116,   222,   228,   230,   250,   279,
     314,   360,   376,   570,   571,   917,   918,  1079,  1253,  1257,
    1394,  1396,    99,   161,   373,   400,   922,   923,   924,  1380,
    1380,  1250,  1400,   430,  1093,   116,   228,   917,  1380,   442,
    1288,   344,   299,   175,   253,   429,   430,   989,   394,  1380,
      99,   134,   405,   438,   442,   468,   635,   644,   645,  1259,
    1264,  1374,  1379,  1385,  1387,  1402,    96,   235,   922,   923,
     358,  1011,  1380,   276,    99,   193,  1095,     4,    14,   132,
     153,   155,   292,   310,   389,   395,   405,   438,   442,   487,
     632,   633,   634,   635,    99,   405,   438,   442,   635,   442,
     332,  1131,  1243,  1380,  1093,  1368,  1378,   572,  1380,   231,
     579,  1043,   579,  1238,   371,  1088,  1089,  1245,  1083,  1084,
    1087,   583,  1041,   208,   267,   337,   454,  1096,  1097,  1083,
    1085,  1086,   186,   263,   460,   582,   118,   589,  1312,  1315,
    1311,  1307,   583,  1316,  1318,     5,    25,    35,   134,   197,
     265,  1323,   176,   243,   304,   307,   398,   497,   579,  1166,
    1167,  1295,  1299,  1389,    73,  1292,  1245,  1284,  1403,   181,
    1273,    21,   462,   573,  1288,  1288,  1403,   462,  1336,  1337,
    1338,    25,   265,   265,  1382,     7,    19,    20,    39,    42,
     157,   194,  1373,  1373,    16,  1312,  1251,  1265,  1374,  1377,
    1380,  1381,  1385,  1386,  1402,   905,  1380,   905,  1246,   361,
     905,   444,   905,  1245,  1380,   430,   174,   430,   930,  1251,
    1254,    99,   245,  1243,   326,   474,    85,   139,   219,   566,
     567,   568,   570,   571,   572,   573,   574,   575,   980,  1200,
    1201,  1380,    99,  1254,  1245,  1245,   245,  1243,  1245,   382,
     407,    99,   245,  1131,  1245,   397,  1245,   905,    99,   297,
    1254,   245,  1243,   905,  1245,   238,   541,   277,    34,   183,
     273,   317,   367,  1012,  1013,  1014,  1243,  1249,  1380,    98,
     131,   144,   145,   154,   158,   175,   196,   207,   215,   227,
     232,   253,   278,   299,   333,   389,   393,   395,   401,   404,
     430,   432,   436,   444,   449,   474,   547,   815,   910,  1400,
    1243,   440,  1245,   579,   905,   444,  1246,   905,   444,   245,
    1245,   174,   430,   433,   435,  1254,   433,   435,   139,   219,
     980,   380,  1254,   245,   628,  1380,  1245,  1245,   397,  1245,
     905,   297,  1254,   238,   541,   371,   401,   430,   474,   216,
     299,    98,   158,   253,   232,   393,   448,   809,    85,  1276,
    1277,   584,  1396,  1403,    99,  1288,  1402,  1080,   642,  1258,
    1400,   983,   245,  1251,  1245,   245,   987,   245,  1246,   444,
     430,   560,   174,   430,   245,  1251,   245,  1254,  1256,   151,
     474,   139,   219,   245,   980,   125,   245,  1256,   245,  1245,
     245,  1245,   245,  1245,   397,   245,  1245,   245,   297,  1256,
     238,   541,   277,   245,   904,   905,   579,   585,  1404,  1405,
    1406,  1407,  1409,  1314,    71,  1284,  1333,   579,  1057,   693,
    1079,   509,  1048,  1040,  1049,  1050,  1051,  1258,  1041,  1257,
     918,   919,    99,   918,  1079,  1257,   919,    99,   918,  1079,
    1257,   919,   919,   919,  1257,  1253,  1253,   269,   462,  1338,
    1339,  1413,  1415,  1079,   919,   361,   579,   579,   714,   714,
     714,   331,   440,   582,   714,  1131,  1132,   918,  1079,   918,
    1079,   582,  1007,  1400,   230,   579,  1054,   125,   474,  1245,
    1245,  1243,  1380,   115,   499,   273,   581,   334,   334,   331,
     230,  1400,   440,   225,   913,   331,    83,    84,    85,    87,
     107,   120,   122,   123,   130,   131,   134,   135,   142,   144,
     165,   166,   167,   168,   169,   170,   171,   178,   179,   197,
     213,   217,   218,   223,   237,   265,   266,   268,   285,   293,
     294,   311,   313,   317,   322,   323,   325,   333,   343,   353,
     368,   391,   406,   413,   426,   430,   438,   439,   443,   445,
     446,   455,   461,   469,   489,   490,   491,   492,   493,   494,
     495,   496,   506,   518,   519,   528,   570,   571,   572,   579,
    1083,  1147,  1150,  1153,  1154,  1155,  1157,  1158,  1159,  1160,
    1163,  1164,  1168,  1170,  1173,  1174,  1176,  1198,  1202,  1221,
    1227,  1231,  1239,  1240,  1241,  1251,  1252,  1253,  1380,  1392,
    1394,  1396,  1397,  1398,  1399,  1400,   440,   566,  1403,  1400,
     440,   566,  1332,    99,   650,  1242,  1243,   405,   632,   181,
     641,  1400,   642,  1400,   115,   136,   632,   499,   414,  1013,
     334,   230,   440,   566,   115,   499,   273,  1413,  1014,   579,
    1243,   572,   577,   581,  1232,  1233,  1132,  1384,   229,   231,
     472,  1037,  1038,  1040,   229,  1044,   181,  1168,  1236,  1237,
    1088,   582,   579,  1045,   580,   580,   517,   549,  1042,  1243,
      99,   193,  1094,  1094,   125,  1094,   220,   225,   289,   329,
    1100,  1102,  1103,  1114,  1116,  1117,  1118,  1096,  1097,   230,
     269,  1131,  1133,  1238,   583,  1306,   572,  1325,  1326,  1328,
     585,   585,    25,   265,   265,   440,   440,   440,   440,   579,
     440,   570,   571,   806,  1257,  1293,  1399,   204,   108,  1280,
     125,  1283,  1283,   269,  1338,  1340,   269,  1338,  1339,  1340,
     467,  1349,  1350,  1396,    14,    37,    84,   570,   571,  1253,
    1341,  1342,  1343,  1392,  1394,  1398,  1399,  1400,  1401,   265,
     271,  1245,   440,  1245,     6,  1245,  1373,  1328,   579,   964,
    1233,   345,   378,   407,   581,   906,   345,   378,   407,   345,
     378,   407,   481,   601,   643,   646,   936,    95,   198,   345,
     378,   407,   465,   657,  1245,   407,    95,   198,   460,   625,
    1131,   485,   245,  1131,   127,   160,   212,   216,   248,   284,
     315,   317,   345,   378,   386,   392,   399,   407,   416,   424,
     476,   501,   530,   544,   643,   647,   967,   974,   579,   953,
     378,   625,   250,   213,    95,   101,   141,   191,   198,   201,
     255,   315,   317,   327,   335,   345,   378,   381,   382,   407,
     447,   465,   512,   513,   554,   655,   656,   670,   834,   806,
      99,   245,  1243,   905,   905,   579,   979,   581,   250,   617,
     378,   601,   617,   331,   345,   378,   213,   126,   173,   252,
     300,   305,   315,   344,   378,   383,   407,   418,   655,   803,
     804,   345,   378,   473,   834,   842,   645,   633,   635,   250,
     213,   378,   407,   655,   345,   378,   382,   407,   152,   190,
     346,   434,   331,    95,   101,   198,   345,   378,   407,   672,
     673,   617,   225,   378,   601,   617,   213,   378,   407,   655,
     378,   345,  1245,  1255,  1258,  1245,   583,   287,   183,   332,
     486,   582,  1012,   462,  1035,   331,  1251,   579,  1245,   444,
     174,   430,  1251,   326,   474,   139,   219,   980,  1245,   397,
    1245,   238,   541,   277,   905,   714,   364,   677,   137,   120,
     122,   123,   134,   135,   178,   179,   223,   266,   268,   311,
     313,   325,   368,   408,   413,   438,   439,   469,  1144,  1146,
    1148,  1150,  1152,  1154,  1155,  1156,  1158,  1159,  1163,  1164,
    1374,  1381,  1385,  1386,  1402,   230,   579,   876,  1245,   601,
     108,  1030,  1245,   317,   601,   485,   245,  1243,   601,   905,
     905,   876,   458,   693,   601,   317,   115,   629,   449,   841,
     345,   817,   152,   190,   346,   434,    97,   117,   264,   853,
     108,   876,   225,   601,  1245,  1255,   474,  1243,   245,   768,
    1243,  1243,   560,   772,   474,  1251,   905,   151,   942,  1251,
    1245,   540,   815,    74,  1278,  1380,   584,  1279,  1276,   121,
     172,   262,   315,   396,   213,   964,   128,   384,   658,   213,
     579,   213,   430,   485,   213,   953,   213,   582,   245,   904,
     245,   905,   245,   905,   213,   979,  1256,   213,   213,   331,
     213,   658,   213,   152,   190,   346,   434,   213,   331,   213,
     225,   245,  1245,  1255,   245,   642,   213,   582,   658,   580,
    1405,  1406,  1404,   582,   586,  1168,  1205,  1337,  1412,  1413,
    1080,  1047,   580,   582,   218,   331,   446,   639,   642,   806,
    1052,  1048,   919,  1079,   919,  1079,  1415,  1416,   919,  1079,
     919,  1079,  1416,   919,  1079,  1079,  1079,   919,    14,    37,
    1388,  1391,  1396,  1079,   579,   715,   716,  1380,   715,    99,
     175,   196,   227,   232,   277,   278,   395,   401,   430,   432,
     449,   540,   925,  1242,  1256,   924,   250,   582,  1068,  1079,
    1079,  1400,  1333,  1144,  1208,   108,  1256,   942,   226,   990,
     990,   990,   287,  1380,   225,   225,   925,  1256,   394,  1380,
     642,   331,   579,   577,  1083,  1209,   471,  1161,  1168,  1226,
     579,  1161,  1161,   579,   225,   579,   579,   579,  1149,  1149,
     355,  1083,   579,   579,  1151,   579,   579,   579,   579,   134,
     135,  1161,  1168,   579,  1149,   579,   579,   579,   579,   579,
     579,   483,   565,   579,  1165,   579,  1165,   579,   579,  1083,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,  1168,  1168,   430,   468,  1083,  1168,  1205,  1233,
    1400,   135,   579,  1162,   579,  1400,    85,    88,    91,    92,
      93,    94,    95,    96,    97,    98,   100,   101,   105,   108,
     110,   111,   113,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   125,   126,   127,   128,   129,   133,   136,   138,
     139,   140,   141,   142,   143,   146,   148,   149,   150,   153,
     155,   156,   158,   159,   160,   163,   172,   173,   175,   177,
     178,   179,   180,   182,   184,   185,   186,   187,   188,   191,
     196,   197,   198,   199,   201,   202,   203,   205,   206,   210,
     211,   212,   213,   214,   216,   217,   222,   223,   226,   228,
     229,   232,   234,   236,   237,   239,   241,   242,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     260,   261,   262,   263,   264,   265,   266,   268,   270,   271,
     272,   273,   275,   277,   278,   279,   285,   287,   288,   290,
     291,   292,   295,   296,   298,   300,   301,   302,   303,   305,
     306,   308,   309,   310,   311,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   323,   324,   325,   326,   327,   330,
     333,   334,   335,   336,   339,   340,   343,   344,   345,   347,
     350,   353,   355,   356,   357,   358,   360,   361,   362,   363,
     365,   366,   367,   368,   369,   370,   375,   376,   377,   378,
     379,   380,   382,   383,   384,   386,   387,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   399,   401,   403,   405,
     407,   408,   409,   410,   411,   412,   413,   416,   418,   419,
     420,   421,   422,   423,   424,   426,   428,   429,   432,   433,
     434,   435,   438,   439,   442,   443,   444,   445,   447,   448,
     449,   452,   453,   456,   457,   459,   460,   463,   464,   466,
     467,   468,   469,   472,   473,   474,   476,   484,   486,   499,
     500,   501,   502,   503,   504,   505,   510,   511,   512,   514,
     515,   516,   518,   519,   520,   521,   523,   525,   526,   527,
     529,   530,   531,   533,   535,   536,   537,   538,   539,   540,
     541,   547,   548,   551,   552,   553,   554,   555,   556,   557,
     558,   566,   567,   568,   570,   571,   572,   573,   574,   575,
    1200,  1202,  1204,  1260,  1261,  1263,  1402,   482,  1185,   342,
    1168,   269,  1091,  1413,   582,   579,  1400,  1233,    22,  1395,
    1396,  1234,   328,   331,  1365,  1365,    10,   467,  1352,  1353,
    1355,  1332,  1332,   184,   247,   651,   582,   136,   181,   642,
     108,   181,   292,   640,   806,  1164,  1400,  1402,  1400,   156,
     195,  1182,   164,   181,   636,   637,   639,   806,   181,   636,
    1413,  1413,   287,  1243,  1168,   572,  1248,  1382,  1232,   157,
     383,   908,   271,   580,   582,  1041,   113,   333,   580,   582,
    1089,  1244,  1245,   108,  1243,    99,  1243,  1045,  1085,  1085,
    1098,  1099,  1168,  1085,   222,   314,  1109,   275,   315,   367,
     409,   460,    99,  1104,  1168,   570,   571,  1105,  1106,  1168,
    1170,  1114,  1115,  1103,  1102,  1100,  1101,   225,  1117,   327,
    1119,  1100,  1114,  1133,  1243,   108,  1380,   407,  1325,   572,
     582,   583,  1383,  1302,  1305,  1302,   265,   176,   243,   304,
    1167,   304,  1167,  1167,   307,  1253,   304,   307,   398,  1399,
    1399,   582,  1294,   180,  1332,   461,  1281,  1283,  1245,    37,
    1253,  1354,  1396,   582,   566,  1245,    14,  1253,  1399,  1253,
    1399,   582,  1312,   579,  1245,   579,  1384,   250,   260,   337,
     339,   408,   470,   572,   957,   958,   959,   961,   963,   965,
    1144,  1381,   345,   378,   407,   440,   440,   395,  1248,   581,
     440,   440,   395,   440,   440,   432,   632,  1024,   225,   235,
     250,   387,   937,   938,   137,   154,   209,   227,   359,   455,
     711,   712,   154,   181,   317,   440,   154,   440,   181,   317,
     395,   154,   191,   201,   345,   378,   871,   395,   823,    98,
     131,   144,   158,   196,   207,   227,   232,   299,   333,   395,
     401,   404,   430,   436,   449,   474,   815,   378,   655,  1245,
     213,   378,   407,   655,   331,   806,   331,   399,   555,   284,
     440,   440,   322,   806,   185,   270,   395,   405,   442,   634,
     555,   555,   555,   384,   407,   967,   975,   580,   954,   957,
     440,   461,   432,  1243,   145,   181,   348,   701,   711,  1380,
     145,   154,   181,   348,   669,   994,   331,   393,   444,   154,
     181,   348,   669,   994,   102,   381,   393,   444,  1243,   255,
     327,   905,   579,   440,   440,   669,   244,   579,   662,   432,
     481,   483,   508,   556,   662,   733,   669,   154,   669,   430,
     181,   669,   582,   345,   250,   213,   378,   407,   655,   462,
     462,   316,  1144,   345,   407,   980,   175,   407,   646,   440,
     603,   646,  1243,   440,   440,  1243,   806,   125,   805,   806,
     806,   173,   300,   305,   125,   440,   601,   395,   601,   315,
     804,   440,   440,   322,  1400,   834,   432,  1131,   154,   440,
     994,   395,   440,   440,   662,   662,   905,   905,   905,   905,
    1243,   114,   467,   114,   114,   440,   114,   440,   181,   395,
     582,   646,   171,   461,   849,  1254,   440,   603,   646,  1243,
     440,   395,   440,   440,   407,   591,   345,   378,   367,   379,
     403,   638,  1012,  1249,  1380,  1243,   964,  1144,   331,   485,
     953,   806,   905,   905,   979,   271,   331,   152,   190,   346,
     434,   331,   905,   271,   481,   684,   421,   422,   679,  1400,
     579,  1146,   108,   107,  1145,   176,   307,   497,   579,  1166,
     906,  1149,   905,   877,   878,  1382,    97,  1019,  1144,   331,
     213,   820,  1245,   317,   579,   602,   890,   462,   371,   474,
     602,   213,  1254,   161,   235,   630,   692,   800,   852,   920,
     940,  1015,  1400,   842,   843,  1245,   295,   905,   905,   905,
     905,   327,   186,   263,   447,   460,   854,   855,   205,   366,
     579,   849,   602,   481,   591,  1243,   802,   803,   317,   108,
     327,   579,   714,   714,   693,   797,  1243,   579,   880,   964,
     225,   943,  1249,   579,   955,   108,  1245,   277,   581,  1253,
    1279,   481,   483,  1081,   396,  1251,   658,  1144,  1246,   245,
    1245,  1251,   658,  1256,  1254,   213,   658,   213,   462,   213,
     462,   980,   658,   658,  1256,  1245,   905,  1245,  1245,  1245,
     905,  1256,   849,   213,   213,   658,   904,   905,   580,   586,
    1407,   580,   582,  1413,  1414,  1337,   172,  1047,  1050,  1047,
    1079,  1079,  1416,  1079,  1079,  1416,  1079,  1079,  1245,    14,
     582,  1395,   715,   580,   582,   580,   233,   402,   431,  1244,
     904,   174,   404,   929,   930,  1244,   326,  1244,  1242,  1242,
    1244,   904,  1244,   440,   481,   933,    93,   211,   391,   409,
    1069,  1131,   321,  1070,   580,   582,  1055,  1060,  1065,  1071,
    1082,   440,  1243,   923,   922,   923,   230,   236,   934,  1380,
      98,   145,   175,   196,   207,   227,   232,   278,   299,   389,
     395,   401,   430,   432,   449,   474,   815,   914,  1205,   578,
    1205,  1209,  1210,   579,   477,  1222,  1223,  1168,  1205,   579,
    1253,  1253,  1205,   176,   243,   304,   307,   398,   497,  1211,
    1212,  1400,  1402,  1253,  1205,  1205,  1253,  1253,  1161,  1161,
    1168,   980,  1168,  1213,   570,   571,  1169,  1170,  1198,  1202,
    1215,   580,  1205,  1168,  1205,  1216,  1082,  1172,   438,   499,
    1253,  1253,  1168,   124,   230,   283,   441,  1168,  1205,  1219,
    1205,   309,  1168,  1170,  1168,  1180,  1181,  1182,   309,  1168,
    1182,  1168,   580,  1205,  1168,   580,   582,   407,  1253,  1253,
    1166,  1144,  1168,  1382,   438,   112,   427,  1235,   905,  1168,
     579,  1083,  1220,   193,   195,   218,   317,   322,   327,   446,
     456,  1168,   119,   246,   250,   288,   411,   579,  1168,   440,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
      99,   106,   415,  1199,   238,   221,  1186,   391,   579,  1198,
     234,   292,   430,   433,   435,   458,  1092,  1243,   230,  1121,
    1241,    99,   193,   470,   572,   580,   959,  1168,  1206,  1207,
    1381,  1245,  1396,  1232,  1354,   582,   566,  1243,   442,   579,
    1400,   582,  1413,   580,   578,   584,   244,   244,   658,  1312,
    1243,  1038,  1039,  1243,  1236,   580,   582,   579,  1045,  1045,
     582,   109,   189,   462,   949,   391,   392,   570,   571,  1106,
    1108,  1170,   409,   275,   332,   582,  1107,  1253,  1399,  1107,
     391,   392,  1108,  1242,  1070,  1115,  1101,   462,  1066,   181,
     579,  1061,  1082,  1380,   579,  1072,  1073,  1074,  1075,  1076,
    1380,   583,  1326,  1145,   586,  1305,   586,   580,   806,   580,
      34,  1282,  1357,  1358,  1396,  1350,  1355,  1403,  1341,  1145,
    1390,  1406,  1390,  1145,   339,   125,  1381,   580,   959,   961,
     958,   961,  1381,   337,   580,   582,   906,   440,   440,   395,
    1254,  1245,  1245,  1248,  1254,  1245,  1245,  1254,  1246,  1245,
     153,  1025,   389,   461,   922,   395,   235,   922,   579,  1245,
     462,   944,   275,   275,   462,   579,   732,   245,  1245,   322,
    1254,  1245,  1245,  1168,   322,  1245,  1245,   102,   381,   440,
     440,  1245,   440,   824,  1251,   579,   905,   905,   905,   444,
     174,   430,   930,   474,   139,   219,   980,  1245,   905,  1245,
     905,   397,   905,   905,   277,   239,   315,   345,   378,   466,
     827,   828,   829,  1131,   440,   994,   395,   322,    99,   106,
     524,   527,   185,   270,  1254,  1245,   331,  1245,   174,   174,
     580,   582,  1254,  1256,  1245,   378,   655,   701,   348,   204,
     225,   333,   418,   468,   668,   746,   747,   750,   751,   754,
    1262,  1263,  1402,  1144,  1245,   348,   668,   656,  1380,  1245,
    1245,    99,   461,  1245,   245,  1245,   348,   245,   658,   245,
    1380,   393,   444,   393,   444,  1245,    99,   461,  1245,  1243,
      95,   198,   407,   835,   836,   837,   838,  1382,  1254,  1245,
     440,   181,   231,   318,   462,   661,   664,   665,  1382,  1245,
     330,   876,   141,   330,   125,   542,   546,   434,   658,  1245,
     481,   348,   113,   656,   440,   432,  1243,   440,   994,   395,
    1247,  1380,  1247,   582,   580,   582,   440,   395,  1246,  1254,
     153,   198,   203,   255,   350,   453,   461,   464,   504,   507,
     532,   547,   604,   605,   607,  1402,   378,  1254,  1245,   378,
     407,   655,   803,   806,   905,  1245,   806,  1245,   806,  1254,
    1245,  1245,   378,   407,   655,  1245,  1245,  1245,  1245,  1254,
    1245,    95,   101,   198,   345,   378,   407,   345,   378,   407,
     876,   378,   407,   378,   407,   378,  1143,  1380,   245,   886,
    1380,   245,  1380,  1254,  1245,  1245,   202,  1245,    95,   673,
     404,  1254,   378,   407,   655,  1245,  1245,  1245,  1254,   150,
     301,   302,   303,   502,   503,   598,   599,   160,   481,   483,
     500,   522,   533,   536,   592,   440,   440,   149,   452,   367,
     271,   108,   905,   271,   271,   462,   462,   271,   322,   911,
    1400,   905,   905,   271,   911,   330,   230,   440,   676,   601,
    1168,   107,  1145,  1144,   577,   577,   440,   440,  1253,  1149,
     580,   582,   566,   854,   153,   202,   281,   282,   295,   345,
     432,   434,  1020,   703,  1382,  1245,   230,   395,   473,   821,
     828,   829,   213,   145,   181,   288,   694,   696,   698,   700,
     701,   708,   711,    96,   250,   389,   428,   605,   606,   225,
    1247,   474,  1243,   628,  1380,   629,   336,   693,   227,  1400,
     876,   876,   876,   876,   327,   331,   336,   579,   876,  1141,
    1142,  1143,   404,   876,   481,   579,   213,   212,  1270,   905,
     694,  1380,   481,   483,   728,   481,   663,   430,   108,   714,
     881,   882,  1402,   876,  1400,   331,   580,   956,   957,   962,
     108,   277,   386,   480,   966,   967,   968,   331,   876,   642,
    1278,   573,   242,   242,   225,   964,   108,   213,   658,   953,
     904,   905,  1247,   905,  1247,   979,   331,   658,   658,   331,
     658,   404,   225,   642,   658,  1168,  1081,  1403,  1391,   580,
     716,   250,   250,   250,   485,  1244,   582,   806,   807,   238,
     926,   927,  1254,    96,   934,   211,   409,   211,   409,   391,
     460,   306,  1144,  1245,   481,   769,   230,   331,   926,   125,
     658,  1251,   444,   430,  1251,   326,   474,   277,   905,   580,
     578,   578,   582,  1205,   271,  1168,  1224,   200,  1223,  1225,
     108,   580,  1168,   580,   580,   580,   580,   230,   580,   580,
     580,   580,   580,   582,   580,   351,  1214,   580,  1169,  1169,
      88,   250,   271,   333,   566,   567,   568,   570,   571,   572,
     573,   574,   575,  1202,  1169,   580,   580,   225,   230,  1217,
    1218,   580,   550,  1171,   580,   499,   580,   580,   108,  1219,
    1205,  1219,  1219,   230,   580,   580,  1382,   582,   349,  1184,
     108,   580,   582,  1168,  1382,   582,  1168,   582,  1228,  1229,
     580,   580,  1234,  1168,  1380,   580,   580,   499,  1169,  1169,
     206,  1205,   230,   193,   195,   218,   322,   327,   446,   456,
     579,   206,   427,  1235,  1168,  1220,  1168,   440,   980,  1168,
     579,  1083,   579,   579,   341,  1190,   433,   435,   433,   435,
    1243,  1093,  1093,  1093,   280,   392,   506,   579,  1083,  1122,
    1123,  1124,  1131,  1134,  1173,  1175,  1176,  1251,  1380,   478,
    1139,  1206,  1206,  1207,   580,    90,   582,  1096,  1097,     8,
      11,    12,    22,    23,    24,    26,    27,    31,    32,    33,
     174,   309,   355,   449,  1360,  1361,  1363,  1353,  1354,  1013,
    1253,  1166,   637,  1168,  1145,  1045,  1245,  1055,  1099,   333,
    1200,  1203,   562,   563,   950,  1253,  1399,  1108,   332,   460,
    1105,  1122,   478,  1140,   468,  1062,  1063,  1380,   385,  1064,
    1076,  1077,   582,  1121,   566,  1234,   584,  1308,   583,   582,
     566,    30,  1369,   580,   580,   583,   965,   906,   961,   961,
     125,   963,   574,  1254,  1245,  1245,   289,  1256,  1256,   331,
    1244,   334,   331,  1168,   712,  1247,   579,   579,   579,   732,
     253,   715,   863,   213,   658,   440,  1254,  1245,   642,   964,
    1144,  1245,   485,   905,   905,   905,   905,   979,   152,   190,
     346,   434,  1245,   810,  1245,   239,   466,   440,   440,   810,
     827,   834,   378,   407,   655,  1245,  1245,  1245,   261,   552,
     322,   957,   344,   407,   440,   668,   579,   579,   579,   579,
     418,   468,   751,   747,   749,   511,   748,   432,   481,   737,
     335,   832,   863,   668,   198,   382,   407,   657,   834,   995,
     213,   658,   245,   213,   213,   658,  1245,  1245,  1245,  1245,
     837,   838,   837,   580,   582,   839,  1400,  1402,   253,   580,
     582,   566,   581,   733,   579,   579,   430,   746,   579,  1254,
    1245,   378,   407,   655,  1245,  1245,  1245,   345,   378,   407,
      95,   198,   345,   378,   407,  1144,   316,  1144,  1254,  1245,
     289,   507,   350,   322,  1400,   350,  1256,   459,   579,   612,
     119,   176,   608,   610,   612,   238,   541,   440,   440,   395,
     344,   407,   440,   994,   395,   440,   440,   297,   297,   297,
     440,   440,   395,   440,   440,   395,   440,   395,   440,   395,
     440,   658,  1144,   317,  1400,   407,   995,   213,   658,   440,
     876,  1245,   440,   395,  1257,  1257,  1257,  1257,  1400,  1257,
     557,   876,   876,   557,   557,  1254,  1245,   911,  1144,   271,
     911,   911,  1247,  1247,   911,   271,   271,   911,   677,   579,
     680,   681,   580,   577,   580,  1253,   578,   579,  1253,  1380,
    1400,  1411,   580,   878,   316,   333,   391,   570,   571,   806,
     879,   961,  1203,  1266,  1400,   331,   289,   566,  1021,  1021,
    1021,  1021,  1021,  1021,  1021,   137,   143,   154,   181,   183,
     257,   317,   322,   359,   373,   455,   704,   706,   707,   212,
     477,   601,   642,  1245,   642,   832,  1243,  1380,   145,  1243,
     580,   582,  1256,   238,   389,  1256,  1253,   449,  1243,   714,
     115,   629,   380,   430,   174,   663,   715,  1243,   855,   883,
     884,  1400,   580,   582,  1245,   876,   715,  1243,  1245,  1082,
     579,   695,   580,   330,   662,   330,   331,   729,   662,   108,
    1243,  1082,   663,   580,   582,   566,   440,  1243,   580,   582,
     181,   566,   969,  1400,   642,   430,   960,   961,   481,   968,
     970,   186,   263,   400,   460,  1003,   239,  1274,  1082,  1288,
     658,  1144,  1245,   658,   658,   462,   658,   462,   658,   658,
     905,   905,  1245,   849,   658,   225,   395,   395,   395,  1244,
     930,   582,  1254,   481,   582,   928,   334,   211,   211,   174,
     315,  1256,   925,   658,  1254,   964,   953,   806,   905,   271,
    1209,   580,   317,   437,  1168,   204,  1144,   580,  1168,  1168,
    1168,  1217,  1144,  1169,   193,   195,   317,   327,  1169,  1169,
    1169,  1169,  1169,  1169,  1169,  1169,  1169,  1169,  1168,  1168,
    1218,  1217,   125,   542,  1165,  1165,  1144,   580,   580,   580,
    1205,   580,   582,  1168,   125,  1170,   580,  1382,  1181,   356,
     425,  1183,   580,   582,   473,  1177,   108,  1168,   582,  1229,
    1230,   580,  1162,  1400,  1168,   105,   105,  1168,   580,  1168,
     230,   579,  1208,  1168,  1169,  1169,   206,   206,  1168,   580,
     206,  1168,  1097,   478,   579,  1191,  1380,  1093,  1093,  1093,
    1093,  1243,  1243,  1243,  1083,  1134,   230,   579,  1083,  1123,
    1124,   108,  1125,  1126,  1380,   582,   162,   231,   259,   274,
     286,   312,   388,  1128,  1126,   108,  1125,  1127,  1380,   564,
    1138,   579,  1233,  1168,   238,  1110,   582,  1096,  1096,  1096,
    1168,   470,  1207,   580,   582,   566,   580,   578,  1369,   580,
     579,   950,   332,   164,  1168,  1064,   580,   582,  1234,  1240,
     580,   582,  1073,  1140,  1236,  1253,   566,  1327,  1358,  1363,
     580,   574,   965,   449,  1021,   233,   402,   431,   450,   939,
     225,   939,   580,   579,   720,   721,   946,  1175,  1380,   715,
     715,   863,  1249,   580,   183,   257,   315,   317,   864,  1245,
    1245,   108,  1245,   462,   462,   905,   905,   905,   905,   906,
    1254,  1245,   440,   994,   395,   440,   261,   125,   432,  1245,
     751,   131,   571,   579,   742,   743,   744,  1251,  1252,   744,
    1251,   744,   579,   742,   752,   753,   737,   748,   579,  1245,
     876,   579,   739,   579,   703,   317,   662,   174,   317,   420,
     423,   662,   449,  1245,   213,   668,  1380,   836,  1245,   665,
     879,  1382,   717,   718,  1380,   181,   556,   580,   700,   741,
     750,   757,   760,   761,  1243,   747,   468,   744,   754,   755,
     344,   407,   440,   994,   395,   440,   440,   440,   395,   232,
     333,   423,   888,   889,   232,   333,   896,   897,   440,   440,
     395,   580,   580,   580,  1257,   225,  1400,  1400,  1400,   613,
     614,  1382,   610,   609,  1253,  1400,   905,   905,  1245,  1245,
    1245,   125,   432,  1245,  1245,  1245,  1245,  1245,   225,   225,
     380,   225,   245,  1254,  1245,  1245,  1254,  1245,  1245,  1245,
    1245,  1245,  1245,  1245,   143,   659,   213,    97,   117,   449,
    1380,  1245,   834,  1245,  1245,   806,   483,   806,   806,   580,
     911,   271,   271,   911,   911,   679,   687,   688,  1382,   121,
     163,   187,   202,   206,   226,   229,   241,   322,   330,   331,
     365,   515,   531,   682,   863,  1253,   481,   483,   578,  1411,
     579,   570,   571,   572,   573,   574,   578,  1166,  1243,  1021,
     181,  1253,  1400,   181,  1400,   181,  1400,   181,  1400,   181,
    1245,   181,  1245,   181,  1245,   579,   905,  1245,  1169,   184,
     247,   183,   322,   275,  1243,   970,   363,   867,   868,  1380,
     820,   579,   202,   202,   709,   404,   698,  1256,  1256,  1144,
     579,   663,  1254,  1243,   485,   225,   856,   580,   582,  1143,
     832,   580,   327,   579,  1057,   769,   697,   699,   702,   711,
    1380,   728,   256,   727,   148,   432,   730,  1082,   579,   769,
     730,   882,  1402,   879,  1400,   944,   962,  1168,  1168,   582,
     579,   966,   876,   440,   810,    85,  1285,   580,   658,  1247,
    1247,   658,   658,   404,  1244,  1244,  1244,   806,   235,   927,
     174,   934,   230,   271,   271,   271,   271,   322,   915,  1400,
     193,  1168,   580,   580,  1218,   230,   193,   195,   327,   579,
    1205,   580,   488,  1179,  1205,   580,   372,   125,   479,   479,
     580,  1168,   315,  1168,   582,  1178,  1146,   580,   582,  1168,
     580,  1166,  1169,  1169,  1168,  1208,   580,   105,   105,  1168,
    1168,   206,  1168,   580,   580,  1168,  1192,  1380,  1243,  1243,
    1243,  1243,  1126,  1127,   579,  1168,   580,  1380,   579,  1123,
     274,   340,  1129,  1123,  1129,   274,  1128,  1129,   274,   579,
    1380,   579,  1206,   125,   240,  1113,   580,   580,   580,  1207,
    1400,  1361,   571,  1354,  1362,  1399,  1400,  1400,   980,   327,
    1082,  1063,  1414,   566,  1076,  1064,  1407,   449,   580,  1257,
     440,   922,   230,   863,  1168,   580,   582,   481,   143,   947,
     947,   580,   580,   970,   184,   247,   255,   183,   464,   658,
    1144,  1247,  1247,  1245,  1245,  1245,  1245,  1256,  1245,   737,
     579,   742,   742,    88,   580,   582,   579,   580,   579,   580,
     753,   580,   582,   580,   582,   739,   744,   432,   741,   833,
     837,   202,   705,   322,   322,  1257,  1380,  1144,   658,   658,
     658,   658,   566,   580,   582,   462,   905,   948,   556,  1262,
     580,   582,   737,   751,   751,   481,   483,   667,   269,   666,
     580,   125,   432,  1245,  1245,  1245,  1245,  1254,  1245,  1245,
    1253,  1253,  1144,   582,  1253,  1253,   582,  1254,  1245,  1245,
     610,   580,   582,   566,   105,   438,   611,  1256,  1245,   440,
    1244,  1244,   905,  1244,   213,   905,  1400,  1400,  1144,   658,
     658,   876,   271,   911,   911,   462,   685,   686,   580,   582,
     572,   579,   639,   689,   806,  1030,  1400,  1030,   317,   322,
     365,  1030,   551,  1030,   529,  1030,   578,   232,   260,   232,
     580,  1312,  1411,  1411,  1411,  1411,  1411,   230,   862,  1257,
    1168,   317,   706,   970,   714,   462,   731,  1251,   105,   212,
     250,   694,   876,   876,   210,   251,  1245,   462,   715,   108,
     629,   579,  1245,   199,   857,   477,   859,  1400,   663,   905,
     694,   769,   733,   734,   580,   582,   481,   729,   579,   728,
     186,   198,   356,  1245,   481,  1016,   708,   785,   786,   787,
     788,  1380,   734,   230,   579,  1400,   959,   971,   972,  1381,
     970,  1243,   258,   811,  1286,  1380,   658,   658,   658,  1245,
     334,   658,   926,   915,   915,   915,   915,   230,  1169,   230,
     579,  1208,   579,   580,   582,   580,  1170,   372,   580,   467,
     417,   580,   580,  1168,   580,  1169,  1169,  1168,   580,   348,
    1193,  1135,  1136,  1175,   582,  1125,   579,  1244,  1123,   331,
     462,  1130,  1123,   274,  1123,  1142,   579,  1142,  1380,  1096,
     505,   519,   548,   579,  1111,  1112,  1168,  1168,   480,  1187,
    1096,  1253,  1399,  1166,   580,  1079,  1238,   926,   331,   926,
     580,   970,   721,   333,   980,   905,   948,   948,   373,   970,
     731,   580,   440,   407,  1070,   739,   743,   580,  1144,   211,
     523,   745,   743,  1206,  1206,   745,   580,   579,   742,   580,
    1245,   580,   580,   582,   876,   659,   879,   718,   905,  1262,
     757,   700,   735,   736,   737,   737,   559,   559,   579,   666,
    1256,  1245,   440,   579,  1251,   980,   889,   579,   579,   897,
     614,  1400,   610,  1400,   407,  1070,  1245,   481,   380,   481,
     481,   225,   659,   911,   601,   188,   688,   639,   690,   691,
    1400,  1400,   322,   715,   572,   715,  1400,  1400,   514,  1400,
     930,   108,   985,   985,   580,  1243,   863,   580,   731,   298,
     719,   253,   579,   868,   363,   579,   580,    99,   147,   155,
     182,   254,   423,   710,   710,   832,  1247,   580,  1082,   832,
     391,   419,   858,   579,   212,   108,   695,   580,   348,   763,
     699,   335,   730,  1242,   729,   392,   392,   129,   137,   292,
     580,   582,  1144,   905,   945,   946,   961,   580,   582,  1139,
     810,   315,   466,   812,   813,   566,  1287,   658,  1168,  1169,
    1208,   580,  1180,  1205,   125,   315,   498,   125,  1096,   580,
     582,   108,  1137,  1168,  1244,   580,  1168,   579,  1123,  1130,
     580,  1142,   580,   580,   579,   553,   579,   580,   582,  1188,
    1189,  1380,   580,   928,   939,   658,   947,   731,   579,   949,
     949,  1243,   731,   863,  1245,   432,   108,    88,  1096,  1096,
     753,   837,   462,   660,   739,   700,   735,   735,   669,   407,
    1070,  1245,  1208,   953,   225,   892,   979,  1208,  1208,   432,
     904,   905,   904,   905,  1244,   658,   680,  1400,   580,   582,
     715,   985,   111,   249,   225,   315,   713,   231,   347,   412,
     331,   723,   724,   725,   432,   580,  1251,    82,   869,   404,
     219,   891,   663,  1016,  1168,   363,  1082,   728,   727,   125,
     703,   734,   580,   730,   137,   334,   137,   212,   295,   773,
     787,   580,   582,   966,   971,   194,   466,   810,  1253,  1394,
    1402,    85,   580,   580,   580,   372,   467,  1098,   366,   392,
    1194,  1138,  1135,   579,   580,  1244,   580,  1205,   579,  1205,
    1112,   582,   108,   230,   948,   478,   722,   980,   950,   950,
     714,   863,  1245,  1144,  1144,   580,   580,   580,  1168,   739,
     739,   582,   432,   580,   337,   397,   370,   893,   892,   580,
     580,  1245,   481,   526,   789,   790,   691,   199,   255,   186,
     460,   331,   725,   331,   724,  1245,   579,   580,   582,  1245,
     905,   108,   108,   580,  1251,  1016,   729,   728,   366,   525,
     762,   763,   734,   334,   334,  1400,   579,   516,   663,   946,
     970,   100,   264,  1004,  1286,   119,   164,   451,  1168,  1195,
    1196,  1195,   580,  1142,   580,   580,  1111,   580,  1189,  1191,
     926,   949,   579,   863,   580,   719,  1070,   580,   580,   669,
    1245,  1251,   125,   893,  1070,   905,   510,   522,   678,   551,
     391,   128,   315,   384,   407,   726,   726,   580,    82,   832,
     888,  1082,   579,   730,   729,   579,   763,   774,  1058,  1059,
    1400,  1400,   730,   318,   579,   999,  1001,  1006,  1060,  1065,
    1071,  1082,  1196,   391,   224,   354,   224,   354,   209,  1197,
    1197,   580,   580,   658,   950,  1168,   723,   580,  1070,   953,
     905,   269,   216,   545,   859,    94,   181,   322,  1016,   860,
     861,  1253,  1382,  1399,  1400,   734,   730,   715,   331,   775,
     580,   582,   579,   776,  1139,  1000,  1001,  1002,  1083,  1084,
     105,   164,   238,   315,   558,   580,   863,  1243,   537,   289,
     212,   580,   582,   763,   734,   580,    99,   521,   527,   551,
    1253,   774,  1059,   163,   187,   206,   226,   241,   322,   365,
     515,   531,   580,   777,   778,   779,   780,  1382,   335,   781,
     580,   583,  1196,   391,   535,  1253,   363,   861,   763,   556,
     765,   766,   767,  1400,  1253,  1030,  1030,   317,   365,  1030,
    1030,   529,  1030,   163,   187,   206,   226,   241,   322,   365,
     515,   531,   580,   780,   580,   582,   566,   579,   782,   794,
    1002,   392,   538,   793,  1251,   125,   579,   738,   556,   764,
     767,  1400,  1400,   322,   572,   715,  1400,  1400,   514,  1400,
     779,   579,   879,   580,   783,   784,  1382,   202,   526,   790,
     791,   792,   795,   579,   762,   181,   348,   700,   740,   750,
     756,   758,   759,   434,   767,   715,   715,   580,   582,  1400,
    1021,   510,   734,   551,   860,   579,   348,  1262,   580,   582,
     737,   751,   751,   579,   580,   784,  1253,  1400,   539,   545,
     580,   715,  1262,   756,   735,   737,   737,   741,   289,   580,
     739,   735,   735,   580,  1253,   739,   739,   793
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   587,   588,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   589,   589,   589,   590,   590,   591,
     591,   592,   592,   592,   592,   592,   593,   593,   593,   593,
     594,   595,   596,   597,   598,   599,   599,   599,   599,   599,
     599,   600,   601,   601,   602,   602,   603,   603,   604,   604,
     605,   605,   605,   605,   605,   605,   605,   605,   605,   605,
     605,   605,   605,   605,   606,   606,   606,   606,   606,   606,
     607,   607,   608,   609,   609,   610,   611,   611,   612,   612,
     613,   613,   614,   615,   616,   617,   617,   618,   618,   619,
     620,   620,   621,   621,   622,   622,   623,   624,   625,   625,
     626,   626,   627,   627,   627,   627,   628,   628,   629,   629,
     630,   630,   630,   630,   630,   630,   631,   631,   631,   632,
     632,   632,   633,   633,   633,   633,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   635,   635,   636,
     636,   637,   637,   638,   638,   638,   638,   639,   639,   639,
     639,   640,   640,   640,   640,   640,   640,   640,   641,   641,
     641,   642,   642,   643,   644,   644,   644,   644,   645,   645,
     646,   646,   647,   647,   648,   648,   648,   648,   648,   649,
     650,   650,   651,   651,   652,   653,   653,   653,   653,   653,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   655,   655,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   657,   657,
     658,   658,   658,   659,   659,   660,   660,   661,   661,   661,
     661,   662,   663,   663,   664,   664,   665,   665,   665,   665,
     666,   666,   667,   667,   667,   668,   668,   668,   669,   669,
     669,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   671,   672,   672,   673,
     673,   673,   673,   674,   674,   675,   675,   676,   676,   677,
     677,   678,   678,   679,   679,   679,   680,   680,   681,   681,
     682,   682,   682,   682,   682,   682,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   682,   683,   683,   684,
     684,   685,   685,   686,   686,   687,   687,   688,   689,   689,
     689,   689,   689,   690,   690,   691,   692,   692,   692,   692,
     693,   693,   693,   693,   693,   693,   693,   693,   694,   694,
     695,   695,   696,   696,   697,   697,   698,   698,   698,   698,
     699,   699,   700,   700,   701,   702,   703,   703,   704,   704,
     704,   704,   705,   705,   706,   706,   706,   706,   706,   706,
     706,   707,   707,   707,   707,   708,   709,   709,   709,   710,
     710,   710,   710,   710,   710,   711,   711,   712,   712,   712,
     712,   712,   712,   712,   713,   713,   714,   714,   715,   715,
     716,   717,   717,   718,   719,   719,   719,   719,   720,   720,
     721,   721,   722,   722,   723,   723,   723,   723,   723,   724,
     725,   726,   726,   726,   726,   726,   727,   727,   728,   728,
     728,   728,   729,   729,   729,   729,   730,   730,   731,   731,
     732,   733,   733,   733,   734,   734,   735,   735,   736,   736,
     737,   737,   737,   737,   738,   738,   739,   739,   740,   740,
     741,   741,   742,   742,   742,   742,   743,   743,   743,   744,
     744,   745,   745,   745,   746,   747,   748,   748,   749,   749,
     750,   750,   750,   751,   751,   752,   752,   753,   753,   754,
     754,   755,   755,   756,   756,   756,   756,   757,   757,   757,
     757,   758,   759,   760,   761,   762,   762,   762,   763,   763,
     764,   765,   765,   766,   767,   767,   767,   767,   768,   769,
     769,   769,   770,   771,   771,   771,   772,   772,   773,   773,
     774,   774,   775,   775,   775,   775,   775,   775,   776,   776,
     776,   776,   777,   777,   778,   778,   779,   779,   780,   780,
     780,   780,   780,   780,   780,   780,   780,   780,   780,   781,
     781,   782,   782,   783,   783,   784,   785,   785,   786,   786,
     787,   787,   788,   789,   789,   790,   790,   790,   791,   791,
     792,   792,   793,   793,   793,   794,   794,   795,   795,   796,
     797,   798,   798,   799,   800,   801,   801,   802,   802,   803,
     803,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   805,   805,   806,   806,   806,   806,   807,
     807,   808,   808,   809,   809,   810,   810,   811,   811,   812,
     812,   813,   813,   814,   814,   815,   815,   816,   817,   817,
     818,   818,   819,   819,   820,   820,   821,   821,   821,   822,
     823,   823,   824,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   826,   827,   827,
     827,   827,   828,   828,   829,   829,   830,   830,   831,   831,
     832,   832,   833,   833,   834,   835,   835,   836,   836,   836,
     836,   837,   838,   839,   840,   841,   841,   842,   842,   843,
     843,   844,   844,   845,   845,   845,   846,   846,   847,   847,
     848,   849,   849,   849,   850,   850,   851,   852,   852,   853,
     853,   853,   854,   854,   855,   855,   855,   855,   855,   856,
     856,   857,   857,   858,   858,   859,   859,   860,   860,   860,
     861,   861,   861,   861,   862,   862,   863,   863,   864,   864,
     864,   864,   864,   864,   865,   865,   866,   866,   867,   867,
     868,   869,   869,   870,   871,   871,   871,   871,   872,   873,
     874,   874,   874,   874,   874,   874,   874,   874,   874,   874,
     874,   874,   874,   874,   874,   875,   875,   876,   877,   877,
     878,   878,   879,   879,   879,   879,   879,   879,   879,   880,
     881,   881,   882,   883,   883,   884,   884,   885,   885,   885,
     886,   886,   887,   888,   888,   889,   889,   889,   889,   889,
     890,   890,   891,   891,   892,   892,   892,   893,   893,   894,
     895,   895,   896,   896,   897,   897,   898,   898,   899,   899,
     900,   901,   902,   902,   902,   902,   903,   903,   903,   903,
     903,   903,   903,   903,   903,   903,   903,   903,   903,   903,
     903,   903,   903,   903,   903,   903,   904,   904,   905,   905,
     906,   906,   907,   908,   908,   908,   909,   909,   909,   909,
     909,   909,   909,   909,   909,   909,   909,   909,   909,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   910,   910,
     910,   910,   910,   910,   911,   911,   912,   912,   912,   912,
     912,   913,   913,   914,   914,   914,   914,   914,   914,   914,
     914,   914,   914,   914,   914,   914,   915,   915,   916,   916,
     916,   916,   916,   916,   916,   916,   916,   916,   916,   917,
     917,   917,   917,   917,   917,   917,   917,   917,   917,   917,
     917,   917,   917,   918,   918,   919,   919,   920,   921,   921,
     922,   922,   922,   922,   922,   923,   923,   924,   924,   924,
     924,   925,   925,   925,   925,   925,   925,   925,   925,   925,
     925,   925,   925,   925,   925,   925,   925,   925,   926,   926,
     927,   927,   928,   928,   929,   929,   930,   931,   932,   932,
     933,   933,   934,   934,   935,   936,   936,   937,   937,   937,
     938,   938,   938,   939,   939,   939,   939,   940,   941,   941,
     942,   942,   943,   943,   944,   944,   945,   945,   946,   946,
     946,   947,   947,   948,   948,   948,   949,   949,   949,   950,
     950,   950,   951,   951,   951,   952,   952,   953,   953,   954,
     954,   955,   955,   956,   956,   957,   957,   957,   957,   957,
     958,   958,   958,   958,   958,   959,   960,   961,   961,   961,
     962,   962,   962,   963,   964,   964,   964,   964,   965,   965,
     966,   966,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   968,   968,   968,   968,   969,
     969,   970,   970,   971,   972,   972,   973,   974,   974,   975,
     975,   976,   976,   977,   977,   978,   978,   979,   979,   979,
     979,   980,   980,   981,   982,   982,   983,   983,   984,   984,
     984,   985,   985,   985,   986,   987,   987,   988,   988,   988,
     989,   989,   990,   990,   991,   992,   992,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   993,   993,   993,   993,   993,   993,   993,
     993,   993,   993,   994,   994,   995,   995,   996,   996,   996,
     996,   996,   996,   996,   996,   996,   996,   996,   996,   996,
     996,   996,   996,   996,   996,   996,   996,   996,   996,   996,
     996,   997,   997,   997,   997,   997,   997,   997,   997,   997,
     997,   997,   997,   997,   997,   997,   997,   997,   997,   997,
     997,   998,   999,   999,   999,  1000,  1000,  1001,  1001,  1001,
    1001,  1001,  1002,  1002,  1003,  1003,  1003,  1003,  1004,  1004,
    1004,  1005,  1005,  1006,  1007,  1007,  1008,  1009,  1009,  1010,
    1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,
    1010,  1010,  1010,  1011,  1011,  1011,  1012,  1012,  1012,  1012,
    1012,  1013,  1013,  1013,  1014,  1014,  1015,  1015,  1015,  1015,
    1016,  1016,  1016,  1016,  1017,  1018,  1019,  1019,  1020,  1020,
    1020,  1020,  1020,  1020,  1020,  1020,  1020,  1020,  1020,  1020,
    1020,  1020,  1020,  1020,  1021,  1021,  1022,  1022,  1023,  1024,
    1024,  1025,  1026,  1026,  1027,  1027,  1028,  1029,  1029,  1029,
    1029,  1029,  1029,  1029,  1030,  1030,  1031,  1032,  1032,  1032,
    1032,  1032,  1032,  1033,  1034,  1034,  1034,  1035,  1035,  1036,
    1036,  1036,  1036,  1036,  1037,  1037,  1038,  1038,  1038,  1038,
    1039,  1039,  1039,  1039,  1040,  1040,  1041,  1041,  1042,  1042,
    1043,  1043,  1044,  1044,  1045,  1045,  1046,  1046,  1046,  1046,
    1047,  1047,  1047,  1047,  1047,  1047,  1047,  1047,  1047,  1047,
    1048,  1048,  1049,  1049,  1050,  1051,  1051,  1052,  1052,  1052,
    1053,  1053,  1054,  1054,  1055,  1055,  1055,  1055,  1056,  1056,
    1057,  1057,  1058,  1058,  1059,  1060,  1061,  1061,  1061,  1062,
    1062,  1063,  1064,  1064,  1065,  1066,  1066,  1067,  1068,  1068,
    1069,  1069,  1069,  1069,  1069,  1069,  1069,  1069,  1070,  1070,
    1071,  1072,  1072,  1073,  1073,  1074,  1075,  1076,  1077,  1077,
    1078,  1079,  1079,  1080,  1080,  1080,  1080,  1080,  1081,  1081,
    1081,  1082,  1082,  1083,  1083,  1084,  1084,  1084,  1084,  1084,
    1084,  1084,  1084,  1085,  1085,  1086,  1086,  1086,  1086,  1086,
    1086,  1087,  1087,  1088,  1088,  1089,  1090,  1090,  1091,  1091,
    1091,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,  1092,
    1093,  1093,  1094,  1094,  1094,  1095,  1095,  1095,  1095,  1096,
    1096,  1097,  1098,  1098,  1099,  1099,  1100,  1100,  1100,  1100,
    1101,  1101,  1102,  1102,  1102,  1102,  1103,  1103,  1104,  1104,
    1105,  1106,  1106,  1106,  1107,  1107,  1108,  1108,  1109,  1109,
    1110,  1110,  1111,  1111,  1112,  1112,  1112,  1112,  1112,  1113,
    1113,  1114,  1114,  1115,  1115,  1116,  1116,  1117,  1118,  1118,
    1118,  1118,  1119,  1119,  1120,  1120,  1121,  1121,  1122,  1122,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1124,  1124,  1124,
    1124,  1124,  1124,  1125,  1125,  1125,  1125,  1126,  1126,  1127,
    1127,  1127,  1127,  1127,  1128,  1128,  1128,  1128,  1129,  1129,
    1130,  1130,  1131,  1131,  1131,  1131,  1132,  1132,  1133,  1133,
    1133,  1134,  1134,  1135,  1136,  1136,  1137,  1137,  1138,  1138,
    1139,  1139,  1140,  1140,  1140,  1141,  1141,  1142,  1142,  1143,
    1144,  1144,  1144,  1144,  1144,  1144,  1145,  1145,  1145,  1146,
    1146,  1146,  1146,  1146,  1146,  1146,  1147,  1147,  1147,  1147,
    1148,  1148,  1149,  1149,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1151,  1151,  1152,  1152,  1153,
    1153,  1154,  1155,  1156,  1156,  1157,  1157,  1158,  1159,  1160,
    1160,  1160,  1160,  1160,  1160,  1161,  1161,  1162,  1162,  1163,
    1163,  1163,  1163,  1164,  1165,  1165,  1165,  1166,  1166,  1166,
    1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,  1166,
    1166,  1167,  1167,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1168,  1168,  1169,  1169,  1169,  1169,  1169,  1169,  1169,  1169,
    1169,  1169,  1169,  1169,  1169,  1169,  1169,  1169,  1169,  1169,
    1169,  1169,  1169,  1169,  1170,  1170,  1170,  1170,  1170,  1170,
    1170,  1170,  1170,  1170,  1170,  1170,  1170,  1170,  1171,  1171,
    1171,  1172,  1173,  1173,  1173,  1173,  1173,  1173,  1173,  1174,
    1174,  1175,  1175,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1177,  1177,  1178,  1178,  1178,  1178,  1179,  1180,  1180,  1181,
    1181,  1182,  1182,  1183,  1183,  1183,  1184,  1184,  1184,  1184,
    1185,  1185,  1186,  1186,  1187,  1187,  1188,  1188,  1189,  1190,
    1190,  1190,  1191,  1192,  1192,  1193,  1193,  1194,  1194,  1194,
    1195,  1195,  1196,  1196,  1196,  1196,  1196,  1197,  1197,  1197,
    1197,  1197,  1198,  1198,  1198,  1199,  1199,  1199,  1200,  1200,
    1201,  1201,  1201,  1201,  1201,  1201,  1201,  1201,  1201,  1202,
    1202,  1203,  1203,  1204,  1204,  1204,  1204,  1204,  1204,  1205,
    1205,  1206,  1206,  1207,  1207,  1208,  1208,  1209,  1209,  1209,
    1210,  1210,  1211,  1211,  1212,  1212,  1212,  1212,  1212,  1212,
    1212,  1212,  1213,  1213,  1214,  1215,  1215,  1216,  1216,  1216,
    1216,  1216,  1216,  1217,  1218,  1219,  1219,  1219,  1220,  1220,
    1221,  1222,  1222,  1223,  1224,  1224,  1225,  1225,  1226,  1226,
    1227,  1228,  1228,  1229,  1230,  1230,  1231,  1231,  1232,  1232,
    1232,  1232,  1233,  1233,  1234,  1234,  1235,  1235,  1236,  1236,
    1237,  1237,  1238,  1239,  1239,  1240,  1240,  1241,  1241,  1241,
    1241,  1241,  1242,  1242,  1243,  1243,  1244,  1244,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1251,  1252,  1252,  1252,  1252,
    1252,  1252,  1252,  1252,  1252,  1252,  1252,  1252,  1252,  1252,
    1252,  1253,  1254,  1255,  1256,  1256,  1257,  1257,  1257,  1257,
    1258,  1258,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,  1259,
    1259,  1259,  1259,  1259,  1259,  1259,  1260,  1261,  1261,  1261,
    1261,  1261,  1262,  1262,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1267,  1267,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1270,  1269,  1271,  1272,  1272,
    1272,  1272,  1273,  1273,  1273,  1273,  1274,  1274,  1275,  1276,
    1277,  1277,  1278,  1278,  1278,  1279,  1279,  1280,  1280,  1281,
    1281,  1282,  1282,  1282,  1282,  1283,  1283,  1283,  1284,  1285,
    1285,  1286,  1286,  1287,  1287,  1287,  1287,  1288,  1288,  1289,
    1290,  1291,  1292,  1292,  1293,  1294,  1294,  1295,  1295,  1295,
    1295,  1295,  1297,  1296,  1298,  1299,  1300,  1300,  1301,  1301,
    1301,  1301,  1302,  1302,  1304,  1303,  1306,  1305,  1307,  1305,
    1305,  1308,  1308,  1309,  1309,  1309,  1310,  1310,  1310,  1310,
    1311,  1311,  1312,  1312,  1312,  1312,  1312,  1312,  1313,  1313,
    1313,  1314,  1316,  1315,  1317,  1318,  1317,  1319,  1319,  1320,
    1320,  1321,  1321,  1322,  1322,  1322,  1322,  1322,  1322,  1322,
    1322,  1322,  1323,  1323,  1323,  1323,  1323,  1323,  1323,  1323,
    1323,  1323,  1324,  1324,  1325,  1325,  1326,  1327,  1327,  1328,
    1328,  1328,  1329,  1330,  1331,  1331,  1331,  1331,  1332,  1332,
    1332,  1333,  1333,  1334,  1334,  1335,  1336,  1336,  1337,  1337,
    1338,  1338,  1339,  1339,  1340,  1341,  1341,  1342,  1342,  1342,
    1343,  1343,  1343,  1343,  1343,  1343,  1343,  1343,  1343,  1344,
    1344,  1344,  1344,  1344,  1345,  1345,  1346,  1347,  1348,  1349,
    1349,  1350,  1351,  1352,  1352,  1353,  1354,  1354,  1355,  1356,
    1357,  1357,  1358,  1359,  1360,  1360,  1361,  1362,  1362,  1362,
    1362,  1362,  1363,  1363,  1363,  1363,  1363,  1363,  1363,  1363,
    1363,  1363,  1363,  1363,  1363,  1363,  1363,  1364,  1364,  1365,
    1365,  1366,  1366,  1366,  1368,  1367,  1369,  1369,  1371,  1370,
    1372,  1372,  1372,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
    1373,  1373,  1374,  1374,  1375,  1375,  1375,  1375,  1375,  1375,
    1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,
    1375,  1375,  1375,  1375,  1375,  1375,  1375,  1375,  1376,  1376,
    1376,  1376,  1376,  1376,  1377,  1377,  1377,  1377,  1377,  1377,
    1377,  1378,  1379,  1379,  1379,  1379,  1379,  1379,  1379,  1379,
    1380,  1380,  1380,  1380,  1380,  1380,  1380,  1381,  1381,  1381,
    1381,  1381,  1381,  1382,  1382,  1382,  1382,  1382,  1382,  1382,
    1382,  1382,  1382,  1382,  1383,  1383,  1383,  1383,  1383,  1384,
    1384,  1384,  1384,  1385,  1385,  1385,  1385,  1385,  1385,  1385,
    1386,  1386,  1386,  1387,  1387,  1387,  1387,  1387,  1387,  1388,
    1388,  1389,  1390,  1390,  1391,  1391,  1392,  1393,  1394,  1395,
    1395,  1395,  1396,  1397,  1398,  1399,  1400,  1400,  1400,  1400,
    1400,  1401,  1402,  1402,  1402,  1403,  1403,  1404,  1404,  1404,
    1405,  1405,  1406,  1406,  1407,  1407,  1408,  1408,  1408,  1408,
    1408,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,  1409,
    1409,  1409,  1409,  1409,  1409,  1409,  1409,  1410,  1410,  1410,
    1410,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,  1411,
    1411,  1412,  1412,  1412,  1412,  1413,  1413,  1414,  1414,  1415,
    1415,  1416,  1416
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     7,     2,
       0,     3,     3,     3,     1,     1,     5,     7,     7,     9,
       4,     6,     4,     6,     1,     2,     2,     2,     2,     2,
       2,     5,     1,     0,     2,     0,     2,     0,     1,     4,
       2,     2,     3,     3,     1,     3,     3,     3,     3,     2,
       2,     2,     1,     1,     1,     2,     2,     2,     3,     3,
       2,     2,     4,     1,     1,     3,     2,     0,     3,     0,
       1,     3,     3,     5,     5,     0,     3,     5,     5,     5,
       5,     5,     3,     5,     3,     5,     5,     6,     1,     1,
       3,     5,     6,     4,     9,     7,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     2,
       5,     1,     3,     3,     3,     3,     1,     3,     3,     2,
       2,     2,     2,     3,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     1,     2,     3,     2,     1,     1,
       2,     1,     2,     1,     3,     4,     5,     4,     2,     4,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       4,     6,     5,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     2,
       3,     4,     6,     6,     6,     5,     5,     6,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     4,     3,     1,     2,
       2,     2,     3,     3,     2,     2,     3,     1,     3,     2,
       1,     1,     0,     2,     0,     2,     0,     1,     1,     1,
       3,     3,     2,     0,     1,     3,     3,     1,     5,     3,
       6,     0,     2,     2,     0,     1,     4,     8,     2,     3,
       2,     5,     7,     6,     3,     6,     6,     3,     2,     6,
       4,     6,     5,     6,     7,     3,     4,     1,     3,     4,
       6,     4,     8,     2,     2,    13,     7,     1,     1,     1,
       0,     3,     0,     1,     1,     1,     1,     3,     2,     0,
       1,     1,     1,     3,     3,     1,     1,     3,     3,     3,
       3,     4,     3,     2,     3,     3,     2,     1,     0,     2,
       0,     3,     0,     1,     0,     1,     3,     2,     1,     1,
       1,     3,     0,     1,     3,     1,    13,    16,    12,    15,
       1,     1,     2,     2,     2,     2,     1,     0,     1,     0,
       3,     0,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     4,     4,     5,     4,     2,     0,     3,     1,
       1,     2,     2,     0,     2,     1,     3,     4,     5,     2,
       5,     1,     2,     2,     2,     3,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     3,     1,     5,     7,     3,
       8,     4,     9,    11,     2,     0,     3,     0,     1,     3,
       1,     1,     3,     2,     2,     2,     2,     0,     1,     3,
       3,     6,     4,     0,     1,     1,     2,     2,     0,     3,
       3,     2,     1,     1,     2,     2,     4,     0,     2,     2,
       2,     0,     3,     4,     4,     0,     2,     0,     4,     0,
       3,     5,     2,     2,     1,     0,     1,     0,     1,     2,
       4,     2,     2,     0,     3,     0,     3,     0,     1,     3,
       1,     3,     1,     6,     3,     2,     1,     3,     5,     1,
       3,     1,     1,     0,     5,     5,     4,     0,     1,     0,
       1,     3,     2,     1,     0,     3,     5,     1,     3,     4,
       4,     1,     1,     5,     5,     4,     1,     5,     5,     4,
       1,     2,     3,     2,     3,     1,     1,     0,     8,     0,
       5,     1,     0,     6,     2,     1,     2,     3,     5,     2,
       3,     0,    18,     1,     1,     0,     1,     0,     5,     3,
       2,     0,     2,     3,     2,     2,     3,     2,     3,     3,
       2,     0,     1,     2,     1,     3,     3,     5,     3,     3,
       1,     1,     3,     3,     4,     3,     3,     3,     3,     2,
       0,     3,     2,     1,     3,     2,     1,     0,     1,     3,
       1,     1,     2,     6,     0,     4,     2,     0,     6,     0,
       1,     3,     1,     1,     0,     2,     0,     3,     3,     9,
       4,     1,     0,     6,     5,     4,     6,     1,     0,     1,
       2,     2,     1,     2,     3,     2,     2,     2,     2,     3,
       3,     1,     3,     1,     0,     1,     2,     2,     1,     1,
       3,     6,    10,     1,     0,     1,     2,     2,     0,     2,
       2,     1,     0,     5,     7,     1,     0,     7,     2,     0,
       3,     5,     5,     8,     2,     0,     2,     2,     2,     5,
       2,     0,     2,     7,    10,     6,     6,     6,     6,     7,
       7,     9,     9,     6,     7,     6,     8,     8,     8,     8,
       6,     6,     7,     7,     8,     6,     6,     7,     2,     2,
       2,     2,     1,     2,     1,     0,     6,     8,     7,     6,
       4,     0,     1,     3,     4,     1,     3,     1,     2,     2,
       2,     2,     1,     1,    10,     2,     0,     2,     2,     1,
       0,     4,     6,     5,     4,     4,    10,    13,     5,     7,
       8,     1,     1,     1,     7,     9,     8,    15,    20,     1,
       1,     2,     1,     3,     1,     1,     1,     3,     1,     3,
       0,     1,     0,     1,     1,     4,     0,     1,     3,     0,
       1,     1,     1,     1,     2,     0,     0,     2,     2,     1,
       2,     2,     2,     2,     6,     8,    11,    13,     1,     3,
       5,     1,     3,     5,     1,     2,     2,     1,     8,     4,
       6,     5,     4,     4,     3,     7,     6,     8,     6,     6,
       6,     6,     6,     4,     5,     1,     0,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     3,     1,     0,     1,     3,     7,     9,     9,
       3,     0,    13,     1,     3,     5,     6,     4,     7,     2,
       1,     0,     2,     0,     2,     4,     0,     1,     0,     6,
       8,     8,     1,     3,     5,     5,     7,     9,     7,     9,
       5,     6,     6,     4,     5,     7,     1,     2,     3,     1,
       1,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     1,     1,     3,     1,     2,
       2,     3,     5,     2,     2,     0,     6,     7,     7,     7,
       8,     8,     6,     8,     9,     9,     7,    10,     7,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     1,     3,     2,     3,     3,
       3,     3,     2,     2,     1,     1,     8,     9,     9,     9,
       9,     2,     0,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     2,     2,
       3,     4,     5,     4,     5,     3,     4,     3,     4,     1,
       2,     3,     3,     3,     3,     4,     4,     3,     3,     4,
       4,     4,     4,     1,     1,     1,     0,     7,     7,    10,
       1,     1,     2,     4,     5,     1,     3,     2,     2,     2,
       2,     1,     2,     2,     4,     3,     2,     2,     2,     2,
       3,     2,     2,     2,     2,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     1,     3,     2,     6,     6,     9,
       3,     0,     3,     0,     5,     2,     0,     3,     3,     3,
       7,     7,    10,     1,     1,     1,     1,    14,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     5,     5,
       7,     2,     0,     1,     2,     0,     1,     1,     0,     1,
       1,     0,     9,    12,     7,     2,     0,     3,     2,     1,
       3,     3,     2,     1,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     4,     5,
       1,     3,     3,     1,     3,     3,     5,     6,     1,     3,
       1,     2,     4,     5,     1,     1,     1,     1,     3,     3,
       2,     2,     1,     2,     2,     2,     1,     2,     2,     3,
       3,     3,     3,     3,     4,     2,     2,     1,     1,     1,
       3,     2,     0,     2,     1,     3,     5,     1,     2,     1,
       0,     5,     7,     5,     7,     5,     7,     3,     5,     5,
       5,     1,     3,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,     4,     4,     4,
       1,     1,     1,     0,     7,     5,     5,     7,     6,     6,
       6,     6,     8,     8,     6,     6,     7,     9,     9,     6,
       6,     6,     8,     6,     8,     6,     8,     7,     9,     6,
       8,     7,     9,     8,    10,     9,    11,     8,     9,    11,
       8,     8,     7,     6,     6,     6,     8,     8,     8,     8,
       6,     9,     6,     1,     0,     2,     0,     7,     6,     6,
       6,     6,     6,     7,     9,     9,     6,     8,     8,     8,
       8,     8,     6,     8,     6,     8,     7,     9,     7,     9,
       6,     7,     6,     6,     6,     6,     6,     7,     7,     7,
       9,     9,     6,     6,     6,     6,     8,     8,     8,     6,
       7,    13,     1,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     6,     8,     3,     2,     0,     2,     2,     2,     2,
       3,     3,     2,     2,     2,     2,     3,     2,     5,     4,
       3,     3,     3,     1,     1,     0,     3,     2,     2,     1,
       2,     1,     3,     2,     1,     0,     9,    11,    12,    14,
       3,     4,     4,     0,     2,     5,     2,     0,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     3,     3,     1,     0,     5,     6,     4,     2,
       0,     4,     3,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,    10,     4,     2,     5,     2,     0,     4,
       5,     5,     4,     6,     1,     3,     1,     1,     1,     1,
       3,     4,     5,     5,     1,     1,     1,     0,     2,     0,
       1,     0,     1,     0,     3,     0,     2,     5,     4,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     3,     2,     1,     1,     1,     1,     0,
       5,     4,     3,     0,     1,     1,     1,     1,     4,     9,
       3,     0,     1,     3,     1,     6,     1,     4,     2,     1,
       3,     2,     3,     0,     7,     2,     0,     5,     3,     0,
       2,     2,     2,     3,     1,     3,     1,     2,     1,     0,
       8,     1,     3,     1,     1,     3,     5,     2,     1,     3,
       7,     1,     1,     0,     3,     2,     2,     2,     0,     2,
       2,     1,     1,     3,     3,     1,     2,     4,     4,     2,
       3,     5,     5,     1,     1,     9,     1,     2,     4,     4,
       4,     2,     3,     1,     3,     6,     1,     0,     2,     1,
       0,     3,     3,     4,     4,     4,     4,     3,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       0,     3,     1,     3,     4,     3,     2,     2,     1,     1,
       1,     0,     2,     4,     5,     4,     2,     3,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       3,     0,     1,     3,     1,     4,     4,     5,     2,     2,
       0,     1,     3,     1,     0,     1,     2,     3,     2,     4,
       2,     3,     2,     0,     2,     3,     2,     0,     1,     3,
       2,     2,     3,     2,     3,     1,     4,     3,     4,     5,
       4,     5,     4,     5,     2,     4,     1,     1,     0,     1,
       4,     5,     4,     0,     2,     2,     2,     1,     1,     0,
       4,     2,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     2,     6,     2,     1,     3,     4,     0,     1,     0,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     2,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     3,     5,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     3,     3,     2,     3,     5,     4,     6,     3,     5,
       4,     6,     4,     6,     5,     7,     3,     2,     4,     2,
       3,     3,     4,     3,     4,     3,     4,     5,     6,     6,
       7,     6,     7,     6,     7,     3,     4,     4,     6,     2,
       3,     4,     1,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     5,     6,
       6,     7,     3,     4,     1,     1,     2,     4,     1,     1,
       1,     1,     2,     2,     2,     2,     4,     1,     0,     2,
       3,     2,     3,     5,     6,     8,     6,     6,     4,     4,
       1,     1,     1,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     3,     4,     6,     4,     5,     7,
       7,     9,     5,     6,     4,     6,     5,     7,     7,     7,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     2,     2,     0,     2,     4,     4,     6,
       5,     0,     5,     0,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     3,     3,     0,
       1,     4,     2,     2,     2,     2,     2,     3,     2,     2,
       3,     0,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     3,     0,     3,     3,     2,
       2,     1,     0,     2,     2,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     1,     5,     2,     0,     1,     0,
       6,     1,     2,     4,     2,     0,     1,     2,     2,     2,
       3,     5,     1,     2,     0,     2,     1,     0,     1,     1,
       1,     3,     3,     1,     0,     1,     3,     3,     2,     2,
       1,     1,     1,     3,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     6,     2,     3,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     4,     3,     2,
       1,     1,     1,     1,     1,     0,    10,     2,     5,     3,
       2,     2,     3,     7,     1,     1,     1,     0,     2,     2,
       1,     0,     1,     3,     1,     2,     0,     2,     0,     2,
       0,     1,     3,     4,     3,     1,     1,     1,     1,     2,
       0,     2,     4,     0,     2,     2,     2,     1,     1,     7,
       3,     1,     1,     1,     1,     2,     0,     1,     3,     3,
       3,     3,     0,     4,     5,     5,     0,     1,     1,     1,
       2,     2,     1,     2,     0,     7,     0,     5,     0,     4,
       2,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     2,     1,     3,     2,
       2,     3,     0,     5,     1,     0,     5,     2,     2,     1,
       1,     1,     2,     2,     3,     1,     2,     2,     3,     3,
       4,     2,     1,     2,     1,     1,     2,     2,     3,     1,
       1,     1,     1,     0,     1,     3,     5,     0,     2,     0,
       1,     2,     3,     2,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     2,     2,     3,     0,     1,     2,     1,
       4,     3,     4,     3,     2,     1,     3,     1,     1,     1,
       1,     2,     2,     1,     2,     2,     1,     1,     1,     4,
       4,     4,     4,     4,     1,     0,     3,     3,     4,     1,
       3,     3,     4,     1,     3,     3,     1,     1,     1,     6,
       1,     3,     3,     6,     1,     3,     3,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     1,
       1,     4,     4,     3,     0,     7,     1,     0,     0,     7,
       3,     4,     3,     1,     1,     1,     2,     3,     5,     2,
       5,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     0,     1,     2,     1,     2,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
       1,     2,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     2,
       3,     1,     3,     3,     3,     3,     3,     3,     1,     1,
       4,     0,     2,     2,     1,     2,     1,     0,     1,     1,
       1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 1986 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35867 "preproc.c"
    break;

  case 4:
#line 1988 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35873 "preproc.c"
    break;

  case 5:
#line 1990 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35879 "preproc.c"
    break;

  case 6:
#line 1992 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35885 "preproc.c"
    break;

  case 7:
#line 1994 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35891 "preproc.c"
    break;

  case 8:
#line 1996 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35897 "preproc.c"
    break;

  case 9:
#line 1998 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35903 "preproc.c"
    break;

  case 10:
#line 2000 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35909 "preproc.c"
    break;

  case 11:
#line 2002 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35915 "preproc.c"
    break;

  case 12:
#line 2004 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35921 "preproc.c"
    break;

  case 13:
#line 2006 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35927 "preproc.c"
    break;

  case 14:
#line 2008 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35933 "preproc.c"
    break;

  case 15:
#line 2010 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35939 "preproc.c"
    break;

  case 16:
#line 2012 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35945 "preproc.c"
    break;

  case 17:
#line 2014 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35951 "preproc.c"
    break;

  case 18:
#line 2016 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35957 "preproc.c"
    break;

  case 19:
#line 2018 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35963 "preproc.c"
    break;

  case 20:
#line 2020 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35969 "preproc.c"
    break;

  case 21:
#line 2022 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35975 "preproc.c"
    break;

  case 22:
#line 2024 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35981 "preproc.c"
    break;

  case 23:
#line 2026 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35987 "preproc.c"
    break;

  case 24:
#line 2028 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35993 "preproc.c"
    break;

  case 25:
#line 2030 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 35999 "preproc.c"
    break;

  case 26:
#line 2032 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36005 "preproc.c"
    break;

  case 27:
#line 2034 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36011 "preproc.c"
    break;

  case 28:
#line 2036 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36017 "preproc.c"
    break;

  case 29:
#line 2038 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36023 "preproc.c"
    break;

  case 30:
#line 2040 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36029 "preproc.c"
    break;

  case 31:
#line 2042 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36035 "preproc.c"
    break;

  case 32:
#line 2044 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36041 "preproc.c"
    break;

  case 33:
#line 2046 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36047 "preproc.c"
    break;

  case 34:
#line 2048 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36053 "preproc.c"
    break;

  case 35:
#line 2050 "preproc.y"
        {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[0].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[0].str));
				break;
			}
		}

		output_statement((yyvsp[0].str), 0, ECPGst_normal);
	}
#line 36075 "preproc.c"
    break;

  case 36:
#line 2068 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36081 "preproc.c"
    break;

  case 37:
#line 2070 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36087 "preproc.c"
    break;

  case 38:
#line 2072 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36093 "preproc.c"
    break;

  case 39:
#line 2074 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36099 "preproc.c"
    break;

  case 40:
#line 2076 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36105 "preproc.c"
    break;

  case 41:
#line 2078 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36111 "preproc.c"
    break;

  case 42:
#line 2080 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36117 "preproc.c"
    break;

  case 43:
#line 2082 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36123 "preproc.c"
    break;

  case 44:
#line 2084 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36129 "preproc.c"
    break;

  case 45:
#line 2086 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36135 "preproc.c"
    break;

  case 46:
#line 2088 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36141 "preproc.c"
    break;

  case 47:
#line 2090 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36147 "preproc.c"
    break;

  case 48:
#line 2092 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36153 "preproc.c"
    break;

  case 49:
#line 2094 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36159 "preproc.c"
    break;

  case 50:
#line 2096 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36165 "preproc.c"
    break;

  case 51:
#line 2098 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36171 "preproc.c"
    break;

  case 52:
#line 2100 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36177 "preproc.c"
    break;

  case 53:
#line 2102 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36183 "preproc.c"
    break;

  case 54:
#line 2104 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36189 "preproc.c"
    break;

  case 55:
#line 2106 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36195 "preproc.c"
    break;

  case 56:
#line 2108 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36201 "preproc.c"
    break;

  case 57:
#line 2110 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36207 "preproc.c"
    break;

  case 58:
#line 2112 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36213 "preproc.c"
    break;

  case 59:
#line 2114 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36219 "preproc.c"
    break;

  case 60:
#line 2116 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36225 "preproc.c"
    break;

  case 61:
#line 2118 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36231 "preproc.c"
    break;

  case 62:
#line 2120 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36237 "preproc.c"
    break;

  case 63:
#line 2122 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36243 "preproc.c"
    break;

  case 64:
#line 2124 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36249 "preproc.c"
    break;

  case 65:
#line 2126 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36255 "preproc.c"
    break;

  case 66:
#line 2128 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36261 "preproc.c"
    break;

  case 67:
#line 2130 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36267 "preproc.c"
    break;

  case 68:
#line 2132 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36273 "preproc.c"
    break;

  case 69:
#line 2134 "preproc.y"
        {
		output_deallocate_prepare_statement((yyvsp[0].str));
	}
#line 36281 "preproc.c"
    break;

  case 70:
#line 2138 "preproc.y"
        { output_simple_statement((yyvsp[0].str)); }
#line 36287 "preproc.c"
    break;

  case 71:
#line 2140 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36293 "preproc.c"
    break;

  case 72:
#line 2142 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 36299 "preproc.c"
    break;

  case 73:
#line 2144 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 36305 "preproc.c"
    break;

  case 74:
#line 2146 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36311 "preproc.c"
    break;

  case 75:
#line 2148 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36317 "preproc.c"
    break;

  case 76:
#line 2150 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36323 "preproc.c"
    break;

  case 77:
#line 2152 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36329 "preproc.c"
    break;

  case 78:
#line 2154 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36335 "preproc.c"
    break;

  case 79:
#line 2156 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36341 "preproc.c"
    break;

  case 80:
#line 2158 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36347 "preproc.c"
    break;

  case 81:
#line 2160 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36353 "preproc.c"
    break;

  case 82:
#line 2162 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36359 "preproc.c"
    break;

  case 83:
#line 2164 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36365 "preproc.c"
    break;

  case 84:
#line 2166 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36371 "preproc.c"
    break;

  case 85:
#line 2168 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36377 "preproc.c"
    break;

  case 86:
#line 2170 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36383 "preproc.c"
    break;

  case 87:
#line 2172 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36389 "preproc.c"
    break;

  case 88:
#line 2174 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36395 "preproc.c"
    break;

  case 89:
#line 2176 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36401 "preproc.c"
    break;

  case 90:
#line 2178 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36407 "preproc.c"
    break;

  case 91:
#line 2180 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36413 "preproc.c"
    break;

  case 92:
#line 2182 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36419 "preproc.c"
    break;

  case 93:
#line 2184 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36425 "preproc.c"
    break;

  case 94:
#line 2186 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_execute); }
#line 36431 "preproc.c"
    break;

  case 95:
#line 2188 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36437 "preproc.c"
    break;

  case 96:
#line 2190 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_normal); }
#line 36443 "preproc.c"
    break;

  case 97:
#line 2192 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36449 "preproc.c"
    break;

  case 98:
#line 2194 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36455 "preproc.c"
    break;

  case 99:
#line 2196 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36461 "preproc.c"
    break;

  case 100:
#line 2198 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 36467 "preproc.c"
    break;

  case 101:
#line 2200 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36473 "preproc.c"
    break;

  case 102:
#line 2202 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36479 "preproc.c"
    break;

  case 103:
#line 2204 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36485 "preproc.c"
    break;

  case 104:
#line 2206 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36491 "preproc.c"
    break;

  case 105:
#line 2208 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36497 "preproc.c"
    break;

  case 106:
#line 2210 "preproc.y"
        {
		if ((yyvsp[0].prep).type == NULL || strlen((yyvsp[0].prep).type) == 0)
			output_prepare_statement((yyvsp[0].prep).name, (yyvsp[0].prep).stmt);
		else
			output_statement(cat_str(5, mm_strdup("prepare"), (yyvsp[0].prep).name, (yyvsp[0].prep).type, mm_strdup("as"), (yyvsp[0].prep).stmt), 0, ECPGst_normal);
	}
#line 36508 "preproc.c"
    break;

  case 107:
#line 2217 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36514 "preproc.c"
    break;

  case 108:
#line 2219 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36520 "preproc.c"
    break;

  case 109:
#line 2221 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36526 "preproc.c"
    break;

  case 110:
#line 2223 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36532 "preproc.c"
    break;

  case 111:
#line 2225 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36538 "preproc.c"
    break;

  case 112:
#line 2227 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36544 "preproc.c"
    break;

  case 113:
#line 2229 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36550 "preproc.c"
    break;

  case 114:
#line 2231 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36556 "preproc.c"
    break;

  case 115:
#line 2233 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36562 "preproc.c"
    break;

  case 116:
#line 2235 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36568 "preproc.c"
    break;

  case 117:
#line 2237 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 36574 "preproc.c"
    break;

  case 118:
#line 2239 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36584 "preproc.c"
    break;

  case 119:
#line 2245 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36590 "preproc.c"
    break;

  case 120:
#line 2247 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36596 "preproc.c"
    break;

  case 121:
#line 2249 "preproc.y"
        { output_statement((yyvsp[0].str), 1, ECPGst_prepnormal); }
#line 36602 "preproc.c"
    break;

  case 122:
#line 2251 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36608 "preproc.c"
    break;

  case 123:
#line 2253 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36614 "preproc.c"
    break;

  case 124:
#line 2255 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36620 "preproc.c"
    break;

  case 125:
#line 2257 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36626 "preproc.c"
    break;

  case 126:
#line 2259 "preproc.y"
 { output_statement((yyvsp[0].str), 0, ECPGst_normal); }
#line 36632 "preproc.c"
    break;

  case 127:
#line 2261 "preproc.y"
        {
		fprintf(base_yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 36642 "preproc.c"
    break;

  case 128:
#line 2267 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(base_yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[0].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36656 "preproc.c"
    break;

  case 129:
#line 2277 "preproc.y"
        {
		output_simple_statement((yyvsp[0].str));
	}
#line 36664 "preproc.c"
    break;

  case 130:
#line 2281 "preproc.y"
        {
		fprintf(base_yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[0].str));
		whenever_action(0);
		free((yyvsp[0].str));
	}
#line 36674 "preproc.c"
    break;

  case 131:
#line 2287 "preproc.y"
        {
		output_simple_statement((yyvsp[0].str));
	}
#line 36682 "preproc.c"
    break;

  case 132:
#line 2291 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[0].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", base_yyout);
		fprintf(base_yyout, "}");
		output_line_number();

		free((yyvsp[0].str));
	}
#line 36696 "preproc.c"
    break;

  case 133:
#line 2301 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(base_yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[0].str) ? (yyvsp[0].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36710 "preproc.c"
    break;

  case 134:
#line 2310 "preproc.y"
                                        { output_statement((yyvsp[0].str), 0, ECPGst_exec_immediate); }
#line 36716 "preproc.c"
    break;

  case 135:
#line 2312 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";

		if (strcmp((yyvsp[0].str), "all") == 0)
			fprintf(base_yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[0].str)[0] == ':')
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[0].str)+1);
		else
			fprintf(base_yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[0].str));

		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36734 "preproc.c"
    break;

  case 136:
#line 2326 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_get_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 36745 "preproc.c"
    break;

  case 137:
#line 2333 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].str), connection);
		output_get_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 36755 "preproc.c"
    break;

  case 138:
#line 2339 "preproc.y"
        {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[0].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	}
#line 36770 "preproc.c"
    break;

  case 139:
#line 2350 "preproc.y"
        {
		fprintf(base_yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[0].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36780 "preproc.c"
    break;

  case 140:
#line 2356 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(base_yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[0].str));
		whenever_action(2);
		free((yyvsp[0].str));
	}
#line 36793 "preproc.c"
    break;

  case 141:
#line 2365 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].descriptor).name, connection);
		output_set_descr((yyvsp[0].descriptor).name, (yyvsp[0].descriptor).str);
		free((yyvsp[0].descriptor).name);
		free((yyvsp[0].descriptor).str);
	}
#line 36804 "preproc.c"
    break;

  case 142:
#line 2372 "preproc.y"
        {
		lookup_descriptor((yyvsp[0].str), connection);
		output_set_descr_header((yyvsp[0].str));
		free((yyvsp[0].str));
	}
#line 36814 "preproc.c"
    break;

  case 143:
#line 2378 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(base_yyout, "%s", (yyvsp[0].str));
		free((yyvsp[0].str));
		output_line_number();
	}
#line 36827 "preproc.c"
    break;

  case 144:
#line 2387 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 36838 "preproc.c"
    break;

  case 145:
#line 2394 "preproc.y"
        {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[0].str));
	}
#line 36849 "preproc.c"
    break;

  case 146:
#line 2401 "preproc.y"
 { (yyval.str) = NULL; }
#line 36855 "preproc.c"
    break;

  case 147:
#line 2407 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create resource queue"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36863 "preproc.c"
    break;

  case 148:
#line 2411 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create resource queue"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 36871 "preproc.c"
    break;

  case 149:
#line 2419 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36879 "preproc.c"
    break;

  case 150:
#line 2423 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 36886 "preproc.c"
    break;

  case 151:
#line 2430 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("active threshold"),(yyvsp[0].str));
}
#line 36894 "preproc.c"
    break;

  case 152:
#line 2434 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cost threshold"),(yyvsp[0].str));
}
#line 36902 "preproc.c"
    break;

  case 153:
#line 2438 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("ignore threshold"),(yyvsp[0].str));
}
#line 36910 "preproc.c"
    break;

  case 154:
#line 2442 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overcommit");
}
#line 36918 "preproc.c"
    break;

  case 155:
#line 2446 "preproc.y"
 { 
 (yyval.str) = mm_strdup("noovercommit");
}
#line 36926 "preproc.c"
    break;

  case 156:
#line 2454 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter resource queue"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 36934 "preproc.c"
    break;

  case 157:
#line 2458 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter resource queue"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 36942 "preproc.c"
    break;

  case 158:
#line 2462 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter resource queue"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("without"),(yyvsp[0].str));
}
#line 36950 "preproc.c"
    break;

  case 159:
#line 2466 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter resource queue"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("with"),(yyvsp[-2].str),mm_strdup("without"),(yyvsp[0].str));
}
#line 36958 "preproc.c"
    break;

  case 160:
#line 2474 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop resource queue"),(yyvsp[0].str));
}
#line 36966 "preproc.c"
    break;

  case 161:
#line 2482 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create resource group"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 36974 "preproc.c"
    break;

  case 162:
#line 2490 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop resource group"),(yyvsp[0].str));
}
#line 36982 "preproc.c"
    break;

  case 163:
#line 2498 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter resource group"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 36990 "preproc.c"
    break;

  case 164:
#line 2506 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 36998 "preproc.c"
    break;

  case 165:
#line 2514 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("concurrency"),(yyvsp[0].str));
}
#line 37006 "preproc.c"
    break;

  case 166:
#line 2518 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cpu_rate_limit"),(yyvsp[0].str));
}
#line 37014 "preproc.c"
    break;

  case 167:
#line 2522 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cpuset"),(yyvsp[0].str));
}
#line 37022 "preproc.c"
    break;

  case 168:
#line 2526 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("memory_shared_quota"),(yyvsp[0].str));
}
#line 37030 "preproc.c"
    break;

  case 169:
#line 2530 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("memory_limit"),(yyvsp[0].str));
}
#line 37038 "preproc.c"
    break;

  case 170:
#line 2534 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("memory_spill_ratio"),(yyvsp[0].str));
}
#line 37046 "preproc.c"
    break;

  case 171:
#line 2542 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37054 "preproc.c"
    break;

  case 172:
#line 2550 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 37062 "preproc.c"
    break;

  case 173:
#line 2554 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37069 "preproc.c"
    break;

  case 174:
#line 2561 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37077 "preproc.c"
    break;

  case 175:
#line 2565 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37084 "preproc.c"
    break;

  case 176:
#line 2572 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37092 "preproc.c"
    break;

  case 177:
#line 2576 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37099 "preproc.c"
    break;

  case 178:
#line 2583 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37107 "preproc.c"
    break;

  case 179:
#line 2587 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop deny for"),(yyvsp[0].str));
}
#line 37115 "preproc.c"
    break;

  case 180:
#line 2595 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("password"),(yyvsp[0].str));
}
#line 37123 "preproc.c"
    break;

  case 181:
#line 2599 "preproc.y"
 { 
 (yyval.str) = mm_strdup("password null");
}
#line 37131 "preproc.c"
    break;

  case 182:
#line 2603 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("encrypted password"),(yyvsp[0].str));
}
#line 37139 "preproc.c"
    break;

  case 183:
#line 2607 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("unencrypted password"),(yyvsp[0].str));
}
#line 37147 "preproc.c"
    break;

  case 184:
#line 2611 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherit");
}
#line 37155 "preproc.c"
    break;

  case 185:
#line 2615 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("connection limit"),(yyvsp[0].str));
}
#line 37163 "preproc.c"
    break;

  case 186:
#line 2619 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("valid until"),(yyvsp[0].str));
}
#line 37171 "preproc.c"
    break;

  case 187:
#line 2623 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("resource queue"),(yyvsp[0].str));
}
#line 37179 "preproc.c"
    break;

  case 188:
#line 2627 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("resource group"),(yyvsp[0].str));
}
#line 37187 "preproc.c"
    break;

  case 189:
#line 2631 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("createexttable"),(yyvsp[0].str));
}
#line 37195 "preproc.c"
    break;

  case 190:
#line 2635 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("nocreateexttable"),(yyvsp[0].str));
}
#line 37203 "preproc.c"
    break;

  case 191:
#line 2639 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("user"),(yyvsp[0].str));
}
#line 37211 "preproc.c"
    break;

  case 192:
#line 2643 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37219 "preproc.c"
    break;

  case 193:
#line 2647 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37227 "preproc.c"
    break;

  case 194:
#line 2655 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37235 "preproc.c"
    break;

  case 195:
#line 2659 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sysid"),(yyvsp[0].str));
}
#line 37243 "preproc.c"
    break;

  case 196:
#line 2663 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("admin"),(yyvsp[0].str));
}
#line 37251 "preproc.c"
    break;

  case 197:
#line 2667 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 37259 "preproc.c"
    break;

  case 198:
#line 2671 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in role"),(yyvsp[0].str));
}
#line 37267 "preproc.c"
    break;

  case 199:
#line 2675 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in group"),(yyvsp[0].str));
}
#line 37275 "preproc.c"
    break;

  case 200:
#line 2683 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("deny"),(yyvsp[0].str));
}
#line 37283 "preproc.c"
    break;

  case 201:
#line 2687 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("deny"),(yyvsp[0].str));
}
#line 37291 "preproc.c"
    break;

  case 202:
#line 2695 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("between"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 37299 "preproc.c"
    break;

  case 203:
#line 2703 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37307 "preproc.c"
    break;

  case 204:
#line 2707 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37315 "preproc.c"
    break;

  case 205:
#line 2715 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("day"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37323 "preproc.c"
    break;

  case 206:
#line 2723 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("time"),(yyvsp[0].str));
}
#line 37331 "preproc.c"
    break;

  case 207:
#line 2727 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37338 "preproc.c"
    break;

  case 208:
#line 2734 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 37346 "preproc.c"
    break;

  case 209:
#line 2738 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37353 "preproc.c"
    break;

  case 210:
#line 2745 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37361 "preproc.c"
    break;

  case 211:
#line 2749 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37369 "preproc.c"
    break;

  case 212:
#line 2757 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37377 "preproc.c"
    break;

  case 213:
#line 2765 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37385 "preproc.c"
    break;

  case 214:
#line 2773 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37393 "preproc.c"
    break;

  case 215:
#line 2781 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37400 "preproc.c"
    break;

  case 216:
#line 2784 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in database"),(yyvsp[0].str));
}
#line 37408 "preproc.c"
    break;

  case 217:
#line 2792 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37416 "preproc.c"
    break;

  case 218:
#line 2796 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter role all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37424 "preproc.c"
    break;

  case 219:
#line 2804 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37432 "preproc.c"
    break;

  case 220:
#line 2812 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37440 "preproc.c"
    break;

  case 221:
#line 2816 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter user all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37448 "preproc.c"
    break;

  case 222:
#line 2824 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop role"),(yyvsp[0].str));
}
#line 37456 "preproc.c"
    break;

  case 223:
#line 2828 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop role if exists"),(yyvsp[0].str));
}
#line 37464 "preproc.c"
    break;

  case 224:
#line 2836 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop user"),(yyvsp[0].str));
}
#line 37472 "preproc.c"
    break;

  case 225:
#line 2840 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop user if exists"),(yyvsp[0].str));
}
#line 37480 "preproc.c"
    break;

  case 226:
#line 2848 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create group"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37488 "preproc.c"
    break;

  case 227:
#line 2856 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter group"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("user"),(yyvsp[0].str));
}
#line 37496 "preproc.c"
    break;

  case 228:
#line 2864 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add");
}
#line 37504 "preproc.c"
    break;

  case 229:
#line 2868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop");
}
#line 37512 "preproc.c"
    break;

  case 230:
#line 2876 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop group"),(yyvsp[0].str));
}
#line 37520 "preproc.c"
    break;

  case 231:
#line 2880 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop group if exists"),(yyvsp[0].str));
}
#line 37528 "preproc.c"
    break;

  case 232:
#line 2888 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create schema"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37536 "preproc.c"
    break;

  case 233:
#line 2892 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create schema"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37544 "preproc.c"
    break;

  case 234:
#line 2896 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(5,mm_strdup("create schema if not exists"),(yyvsp[-3].str),mm_strdup("authorization"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37553 "preproc.c"
    break;

  case 235:
#line 2901 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("create schema if not exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37562 "preproc.c"
    break;

  case 236:
#line 2910 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37570 "preproc.c"
    break;

  case 237:
#line 2914 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37577 "preproc.c"
    break;

  case 238:
#line 2921 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37585 "preproc.c"
    break;

  case 239:
#line 2925 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 37592 "preproc.c"
    break;

  case 240:
#line 2932 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37600 "preproc.c"
    break;

  case 241:
#line 2936 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37608 "preproc.c"
    break;

  case 242:
#line 2940 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37616 "preproc.c"
    break;

  case 243:
#line 2944 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37624 "preproc.c"
    break;

  case 244:
#line 2948 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37632 "preproc.c"
    break;

  case 245:
#line 2952 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37640 "preproc.c"
    break;

  case 246:
#line 2960 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 37648 "preproc.c"
    break;

  case 247:
#line 2964 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set local"),(yyvsp[0].str));
}
#line 37656 "preproc.c"
    break;

  case 248:
#line 2968 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set session"),(yyvsp[0].str));
}
#line 37664 "preproc.c"
    break;

  case 249:
#line 2976 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("transaction"),(yyvsp[0].str));
}
#line 37672 "preproc.c"
    break;

  case 250:
#line 2980 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("session characteristics as transaction"),(yyvsp[0].str));
}
#line 37680 "preproc.c"
    break;

  case 251:
#line 2984 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37688 "preproc.c"
    break;

  case 252:
#line 2992 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 37696 "preproc.c"
    break;

  case 253:
#line 2996 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 37704 "preproc.c"
    break;

  case 254:
#line 3000 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("to default"));
}
#line 37712 "preproc.c"
    break;

  case 255:
#line 3004 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("= default"));
}
#line 37720 "preproc.c"
    break;

  case 256:
#line 3012 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37728 "preproc.c"
    break;

  case 257:
#line 3016 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("from current"));
}
#line 37736 "preproc.c"
    break;

  case 258:
#line 3020 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("time zone"),(yyvsp[0].str));
}
#line 37744 "preproc.c"
    break;

  case 259:
#line 3024 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("catalog"),(yyvsp[0].str));
}
#line 37753 "preproc.c"
    break;

  case 260:
#line 3029 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 37761 "preproc.c"
    break;

  case 261:
#line 3033 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("names"),(yyvsp[0].str));
}
#line 37769 "preproc.c"
    break;

  case 262:
#line 3037 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("role"),(yyvsp[0].str));
}
#line 37777 "preproc.c"
    break;

  case 263:
#line 3041 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("session authorization"),(yyvsp[0].str));
}
#line 37785 "preproc.c"
    break;

  case 264:
#line 3045 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session authorization default");
}
#line 37793 "preproc.c"
    break;

  case 265:
#line 3049 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("xml option"),(yyvsp[0].str));
}
#line 37801 "preproc.c"
    break;

  case 266:
#line 3053 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("transaction snapshot"),(yyvsp[0].str));
}
#line 37809 "preproc.c"
    break;

  case 267:
#line 3061 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37817 "preproc.c"
    break;

  case 268:
#line 3065 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 37825 "preproc.c"
    break;

  case 269:
#line 3073 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37833 "preproc.c"
    break;

  case 270:
#line 3077 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 37841 "preproc.c"
    break;

  case 271:
#line 3085 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37849 "preproc.c"
    break;

  case 272:
#line 3089 "preproc.y"
 { 
		if ((yyvsp[0].str)[0] == '$')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 37863 "preproc.c"
    break;

  case 273:
#line 3103 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read uncommitted");
}
#line 37871 "preproc.c"
    break;

  case 274:
#line 3107 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read committed");
}
#line 37879 "preproc.c"
    break;

  case 275:
#line 3111 "preproc.y"
 { 
 (yyval.str) = mm_strdup("repeatable read");
}
#line 37887 "preproc.c"
    break;

  case 276:
#line 3115 "preproc.y"
 { 
 (yyval.str) = mm_strdup("serializable");
}
#line 37895 "preproc.c"
    break;

  case 277:
#line 3123 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 37903 "preproc.c"
    break;

  case 278:
#line 3127 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 37911 "preproc.c"
    break;

  case 279:
#line 3131 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on");
}
#line 37919 "preproc.c"
    break;

  case 280:
#line 3135 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37927 "preproc.c"
    break;

  case 281:
#line 3143 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37935 "preproc.c"
    break;

  case 282:
#line 3147 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37943 "preproc.c"
    break;

  case 283:
#line 3151 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37951 "preproc.c"
    break;

  case 284:
#line 3155 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 37959 "preproc.c"
    break;

  case 285:
#line 3159 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37967 "preproc.c"
    break;

  case 286:
#line 3163 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 37975 "preproc.c"
    break;

  case 287:
#line 3167 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local");
}
#line 37983 "preproc.c"
    break;

  case 288:
#line 3175 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 37991 "preproc.c"
    break;

  case 289:
#line 3179 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 37999 "preproc.c"
    break;

  case 290:
#line 3183 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38006 "preproc.c"
    break;

  case 291:
#line 3190 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38014 "preproc.c"
    break;

  case 292:
#line 3194 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38022 "preproc.c"
    break;

  case 293:
#line 3202 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 38030 "preproc.c"
    break;

  case 294:
#line 3210 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38038 "preproc.c"
    break;

  case 295:
#line 3214 "preproc.y"
 { 
 (yyval.str) = mm_strdup("time zone");
}
#line 38046 "preproc.c"
    break;

  case 296:
#line 3218 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction isolation level");
}
#line 38054 "preproc.c"
    break;

  case 297:
#line 3222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session authorization");
}
#line 38062 "preproc.c"
    break;

  case 298:
#line 3230 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38070 "preproc.c"
    break;

  case 299:
#line 3234 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 38078 "preproc.c"
    break;

  case 300:
#line 3242 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 38086 "preproc.c"
    break;

  case 301:
#line 3246 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38094 "preproc.c"
    break;

  case 302:
#line 3254 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 38102 "preproc.c"
    break;

  case 303:
#line 3258 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38110 "preproc.c"
    break;

  case 304:
#line 3266 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("show"),(yyvsp[-1].str));
}
#line 38118 "preproc.c"
    break;

  case 305:
#line 3270 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show time zone");
}
#line 38126 "preproc.c"
    break;

  case 306:
#line 3274 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show transaction isolation level");
}
#line 38134 "preproc.c"
    break;

  case 307:
#line 3278 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show session authorization");
}
#line 38142 "preproc.c"
    break;

  case 308:
#line 3282 "preproc.y"
        {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	}
#line 38151 "preproc.c"
    break;

  case 309:
#line 3291 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("set constraints"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38159 "preproc.c"
    break;

  case 310:
#line 3299 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 38167 "preproc.c"
    break;

  case 311:
#line 3303 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38175 "preproc.c"
    break;

  case 312:
#line 3311 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferred");
}
#line 38183 "preproc.c"
    break;

  case 313:
#line 3315 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immediate");
}
#line 38191 "preproc.c"
    break;

  case 314:
#line 3323 "preproc.y"
 { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 38199 "preproc.c"
    break;

  case 315:
#line 3331 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard all");
}
#line 38207 "preproc.c"
    break;

  case 316:
#line 3335 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard temp");
}
#line 38215 "preproc.c"
    break;

  case 317:
#line 3339 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard temporary");
}
#line 38223 "preproc.c"
    break;

  case 318:
#line 3343 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard plans");
}
#line 38231 "preproc.c"
    break;

  case 319:
#line 3347 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard sequences");
}
#line 38239 "preproc.c"
    break;

  case 320:
#line 3355 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38247 "preproc.c"
    break;

  case 321:
#line 3359 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38255 "preproc.c"
    break;

  case 322:
#line 3363 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter external table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38263 "preproc.c"
    break;

  case 323:
#line 3367 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter table all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38271 "preproc.c"
    break;

  case 324:
#line 3371 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38279 "preproc.c"
    break;

  case 325:
#line 3375 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter index"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38287 "preproc.c"
    break;

  case 326:
#line 3379 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter index if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38295 "preproc.c"
    break;

  case 327:
#line 3383 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter index all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38303 "preproc.c"
    break;

  case 328:
#line 3387 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter index all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38311 "preproc.c"
    break;

  case 329:
#line 3391 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38319 "preproc.c"
    break;

  case 330:
#line 3395 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38327 "preproc.c"
    break;

  case 331:
#line 3399 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38335 "preproc.c"
    break;

  case 332:
#line 3403 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38343 "preproc.c"
    break;

  case 333:
#line 3407 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38351 "preproc.c"
    break;

  case 334:
#line 3411 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter materialized view if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38359 "preproc.c"
    break;

  case 335:
#line 3415 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38367 "preproc.c"
    break;

  case 336:
#line 3419 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view all in tablespace"),(yyvsp[-7].str),mm_strdup("owned by"),(yyvsp[-4].str),mm_strdup("set tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38375 "preproc.c"
    break;

  case 337:
#line 3427 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38383 "preproc.c"
    break;

  case 338:
#line 3431 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38391 "preproc.c"
    break;

  case 339:
#line 3439 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 38399 "preproc.c"
    break;

  case 340:
#line 3443 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add column"),(yyvsp[0].str));
}
#line 38407 "preproc.c"
    break;

  case 341:
#line 3447 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38415 "preproc.c"
    break;

  case 342:
#line 3451 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 38423 "preproc.c"
    break;

  case 343:
#line 3455 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 38431 "preproc.c"
    break;

  case 344:
#line 3459 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set statistics"),(yyvsp[0].str));
}
#line 38439 "preproc.c"
    break;

  case 345:
#line 3463 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 38447 "preproc.c"
    break;

  case 346:
#line 3467 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 38455 "preproc.c"
    break;

  case 347:
#line 3471 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set storage"),(yyvsp[0].str));
}
#line 38463 "preproc.c"
    break;

  case 348:
#line 3475 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38471 "preproc.c"
    break;

  case 349:
#line 3479 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38479 "preproc.c"
    break;

  case 350:
#line 3483 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38487 "preproc.c"
    break;

  case 351:
#line 3487 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38495 "preproc.c"
    break;

  case 352:
#line 3491 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 38503 "preproc.c"
    break;

  case 353:
#line 3495 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38511 "preproc.c"
    break;

  case 354:
#line 3499 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 38519 "preproc.c"
    break;

  case 355:
#line 3503 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38527 "preproc.c"
    break;

  case 356:
#line 3507 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38535 "preproc.c"
    break;

  case 357:
#line 3511 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set with oids");
}
#line 38543 "preproc.c"
    break;

  case 358:
#line 3515 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set without oids");
}
#line 38551 "preproc.c"
    break;

  case 359:
#line 3519 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cluster on"),(yyvsp[0].str));
}
#line 38559 "preproc.c"
    break;

  case 360:
#line 3523 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set without cluster");
}
#line 38567 "preproc.c"
    break;

  case 361:
#line 3527 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable trigger"),(yyvsp[0].str));
}
#line 38575 "preproc.c"
    break;

  case 362:
#line 3531 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable always trigger"),(yyvsp[0].str));
}
#line 38583 "preproc.c"
    break;

  case 363:
#line 3535 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica trigger"),(yyvsp[0].str));
}
#line 38591 "preproc.c"
    break;

  case 364:
#line 3539 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable trigger all");
}
#line 38599 "preproc.c"
    break;

  case 365:
#line 3543 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable trigger user");
}
#line 38607 "preproc.c"
    break;

  case 366:
#line 3547 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("disable trigger"),(yyvsp[0].str));
}
#line 38615 "preproc.c"
    break;

  case 367:
#line 3551 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable trigger all");
}
#line 38623 "preproc.c"
    break;

  case 368:
#line 3555 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable trigger user");
}
#line 38631 "preproc.c"
    break;

  case 369:
#line 3559 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable rule"),(yyvsp[0].str));
}
#line 38639 "preproc.c"
    break;

  case 370:
#line 3563 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable always rule"),(yyvsp[0].str));
}
#line 38647 "preproc.c"
    break;

  case 371:
#line 3567 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("enable replica rule"),(yyvsp[0].str));
}
#line 38655 "preproc.c"
    break;

  case 372:
#line 3571 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("disable rule"),(yyvsp[0].str));
}
#line 38663 "preproc.c"
    break;

  case 373:
#line 3575 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("inherit"),(yyvsp[0].str));
}
#line 38671 "preproc.c"
    break;

  case 374:
#line 3579 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("no inherit"),(yyvsp[0].str));
}
#line 38679 "preproc.c"
    break;

  case 375:
#line 3583 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 38687 "preproc.c"
    break;

  case 376:
#line 3587 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("set with"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 38695 "preproc.c"
    break;

  case 377:
#line 3591 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set with"),(yyvsp[0].str));
}
#line 38703 "preproc.c"
    break;

  case 378:
#line 3595 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38711 "preproc.c"
    break;

  case 379:
#line 3599 "preproc.y"
 { 
 (yyval.str) = mm_strdup("expand table");
}
#line 38719 "preproc.c"
    break;

  case 380:
#line 3603 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 38727 "preproc.c"
    break;

  case 381:
#line 3607 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not of");
}
#line 38735 "preproc.c"
    break;

  case 382:
#line 3611 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owner to"),(yyvsp[0].str));
}
#line 38743 "preproc.c"
    break;

  case 383:
#line 3615 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 38751 "preproc.c"
    break;

  case 384:
#line 3619 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 38759 "preproc.c"
    break;

  case 385:
#line 3623 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("reset"),(yyvsp[0].str));
}
#line 38767 "preproc.c"
    break;

  case 386:
#line 3627 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("replica identity"),(yyvsp[0].str));
}
#line 38775 "preproc.c"
    break;

  case 387:
#line 3631 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38783 "preproc.c"
    break;

  case 388:
#line 3639 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set default"),(yyvsp[0].str));
}
#line 38791 "preproc.c"
    break;

  case 389:
#line 3643 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop default");
}
#line 38799 "preproc.c"
    break;

  case 390:
#line 3651 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 38807 "preproc.c"
    break;

  case 391:
#line 3655 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 38815 "preproc.c"
    break;

  case 392:
#line 3659 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38822 "preproc.c"
    break;

  case 393:
#line 3666 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 38830 "preproc.c"
    break;

  case 394:
#line 3670 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38837 "preproc.c"
    break;

  case 395:
#line 3677 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 38845 "preproc.c"
    break;

  case 396:
#line 3681 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38852 "preproc.c"
    break;

  case 397:
#line 3688 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 38860 "preproc.c"
    break;

  case 398:
#line 3692 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 38868 "preproc.c"
    break;

  case 399:
#line 3696 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 38876 "preproc.c"
    break;

  case 400:
#line 3700 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 38884 "preproc.c"
    break;

  case 401:
#line 3708 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38892 "preproc.c"
    break;

  case 402:
#line 3716 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 38900 "preproc.c"
    break;

  case 403:
#line 3720 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38907 "preproc.c"
    break;

  case 404:
#line 3727 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38915 "preproc.c"
    break;

  case 405:
#line 3731 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 38923 "preproc.c"
    break;

  case 406:
#line 3739 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 38931 "preproc.c"
    break;

  case 407:
#line 3743 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 38939 "preproc.c"
    break;

  case 408:
#line 3747 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("."),(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 38947 "preproc.c"
    break;

  case 409:
#line 3751 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 38955 "preproc.c"
    break;

  case 410:
#line 3759 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("into ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 38963 "preproc.c"
    break;

  case 411:
#line 3763 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38970 "preproc.c"
    break;

  case 412:
#line 3770 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with validation");
}
#line 38978 "preproc.c"
    break;

  case 413:
#line 3774 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without validation");
}
#line 38986 "preproc.c"
    break;

  case 414:
#line 3778 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 38993 "preproc.c"
    break;

  case 415:
#line 3785 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39001 "preproc.c"
    break;

  case 416:
#line 3789 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39009 "preproc.c"
    break;

  case 417:
#line 3793 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("for ("),(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup(") )"));
}
#line 39017 "preproc.c"
    break;

  case 418:
#line 3801 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("partition"),(yyvsp[0].str));
}
#line 39025 "preproc.c"
    break;

  case 419:
#line 3805 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default partition"),(yyvsp[0].str));
}
#line 39033 "preproc.c"
    break;

  case 420:
#line 3809 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default partition");
}
#line 39041 "preproc.c"
    break;

  case 421:
#line 3817 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("add partition"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39049 "preproc.c"
    break;

  case 422:
#line 3821 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("add default partition"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39057 "preproc.c"
    break;

  case 423:
#line 3825 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("add partition"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39065 "preproc.c"
    break;

  case 424:
#line 3829 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39073 "preproc.c"
    break;

  case 425:
#line 3833 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop partition if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39081 "preproc.c"
    break;

  case 426:
#line 3837 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop default partition if exists"),(yyvsp[0].str));
}
#line 39089 "preproc.c"
    break;

  case 427:
#line 3841 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39097 "preproc.c"
    break;

  case 428:
#line 3845 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop partition");
}
#line 39105 "preproc.c"
    break;

  case 429:
#line 3849 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("exchange"),(yyvsp[-4].str),mm_strdup("with table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39113 "preproc.c"
    break;

  case 430:
#line 3853 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rename"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 39121 "preproc.c"
    break;

  case 431:
#line 3857 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("set subpartition template ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39129 "preproc.c"
    break;

  case 432:
#line 3861 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set subpartition template ( )");
}
#line 39137 "preproc.c"
    break;

  case 433:
#line 3865 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("split default partition"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39145 "preproc.c"
    break;

  case 434:
#line 3869 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("split"),(yyvsp[-5].str),mm_strdup("at ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 39153 "preproc.c"
    break;

  case 435:
#line 3873 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("truncate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39161 "preproc.c"
    break;

  case 436:
#line 3881 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39169 "preproc.c"
    break;

  case 437:
#line 3889 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39177 "preproc.c"
    break;

  case 438:
#line 3893 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39185 "preproc.c"
    break;

  case 439:
#line 3901 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("add attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39193 "preproc.c"
    break;

  case 440:
#line 3905 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39201 "preproc.c"
    break;

  case 441:
#line 3909 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop attribute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39209 "preproc.c"
    break;

  case 442:
#line 3913 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter attribute"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("type"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39217 "preproc.c"
    break;

  case 443:
#line 3921 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat2_str(mm_strdup("close"), cursor_marker);
	}
#line 39226 "preproc.c"
    break;

  case 444:
#line 3926 "preproc.y"
 { 
 (yyval.str) = mm_strdup("close all");
}
#line 39234 "preproc.c"
    break;

  case 445:
#line 3934 "preproc.y"
 { 
			if (strcmp((yyvsp[-7].str), "to") == 0 && strcmp((yyvsp[-6].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");
			else if (strcmp((yyvsp[-7].str), "from") == 0 && strcmp((yyvsp[-6].str), "stdout") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY FROM STDOUT is not possible");
			else if (strcmp((yyvsp[-7].str), "from") == 0 && strcmp((yyvsp[-6].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(13,mm_strdup("copy"),(yyvsp[-11].str),(yyvsp[-10].str),(yyvsp[-9].str),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39249 "preproc.c"
    break;

  case 446:
#line 3945 "preproc.y"
 { 
			if (strcmp((yyvsp[-3].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");

 (yyval.str) = cat_str(7,mm_strdup("copy"),(yyvsp[-5].str),mm_strdup("to"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39260 "preproc.c"
    break;

  case 447:
#line 3956 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 39268 "preproc.c"
    break;

  case 448:
#line 3960 "preproc.y"
 { 
 (yyval.str) = mm_strdup("to");
}
#line 39276 "preproc.c"
    break;

  case 449:
#line 3968 "preproc.y"
 { 
 (yyval.str) = mm_strdup("program");
}
#line 39284 "preproc.c"
    break;

  case 450:
#line 3972 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39291 "preproc.c"
    break;

  case 451:
#line 3979 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ignore external partitions");
}
#line 39299 "preproc.c"
    break;

  case 452:
#line 3983 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39306 "preproc.c"
    break;

  case 453:
#line 3990 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39314 "preproc.c"
    break;

  case 454:
#line 3994 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdin");
}
#line 39322 "preproc.c"
    break;

  case 455:
#line 3998 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdout");
}
#line 39330 "preproc.c"
    break;

  case 456:
#line 4006 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39338 "preproc.c"
    break;

  case 457:
#line 4010 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39346 "preproc.c"
    break;

  case 458:
#line 4018 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39354 "preproc.c"
    break;

  case 459:
#line 4022 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39361 "preproc.c"
    break;

  case 460:
#line 4029 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 39369 "preproc.c"
    break;

  case 461:
#line 4033 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oids");
}
#line 39377 "preproc.c"
    break;

  case 462:
#line 4037 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 39385 "preproc.c"
    break;

  case 463:
#line 4041 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("delimiter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39393 "preproc.c"
    break;

  case 464:
#line 4045 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("null"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39401 "preproc.c"
    break;

  case 465:
#line 4049 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 39409 "preproc.c"
    break;

  case 466:
#line 4053 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 39417 "preproc.c"
    break;

  case 467:
#line 4057 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("quote"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39425 "preproc.c"
    break;

  case 468:
#line 4061 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("escape"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39433 "preproc.c"
    break;

  case 469:
#line 4065 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force quote"),(yyvsp[0].str));
}
#line 39441 "preproc.c"
    break;

  case 470:
#line 4069 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force quote *");
}
#line 39449 "preproc.c"
    break;

  case 471:
#line 4073 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force not null"),(yyvsp[0].str));
}
#line 39457 "preproc.c"
    break;

  case 472:
#line 4077 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force null"),(yyvsp[0].str));
}
#line 39465 "preproc.c"
    break;

  case 473:
#line 4081 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("encoding"),(yyvsp[0].str));
}
#line 39473 "preproc.c"
    break;

  case 474:
#line 4085 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fill missing fields");
}
#line 39481 "preproc.c"
    break;

  case 475:
#line 4089 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("newline"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39489 "preproc.c"
    break;

  case 476:
#line 4093 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on segment");
}
#line 39497 "preproc.c"
    break;

  case 477:
#line 4101 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 39505 "preproc.c"
    break;

  case 478:
#line 4105 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39512 "preproc.c"
    break;

  case 479:
#line 4112 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with oids");
}
#line 39520 "preproc.c"
    break;

  case 480:
#line 4116 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39527 "preproc.c"
    break;

  case 481:
#line 4123 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("delimiters"),(yyvsp[0].str));
}
#line 39535 "preproc.c"
    break;

  case 482:
#line 4127 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39542 "preproc.c"
    break;

  case 483:
#line 4134 "preproc.y"
 { 
 (yyval.str) = mm_strdup("using");
}
#line 39550 "preproc.c"
    break;

  case 484:
#line 4138 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39557 "preproc.c"
    break;

  case 485:
#line 4145 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39565 "preproc.c"
    break;

  case 486:
#line 4149 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39573 "preproc.c"
    break;

  case 487:
#line 4157 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39581 "preproc.c"
    break;

  case 488:
#line 4165 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39589 "preproc.c"
    break;

  case 489:
#line 4169 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39597 "preproc.c"
    break;

  case 490:
#line 4173 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 39605 "preproc.c"
    break;

  case 491:
#line 4177 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39613 "preproc.c"
    break;

  case 492:
#line 4181 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39620 "preproc.c"
    break;

  case 493:
#line 4188 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39628 "preproc.c"
    break;

  case 494:
#line 4192 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39636 "preproc.c"
    break;

  case 495:
#line 4200 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39644 "preproc.c"
    break;

  case 496:
#line 4208 "preproc.y"
 { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("table"),(yyvsp[-9].str),mm_strdup("("),(yyvsp[-7].str),mm_strdup(")"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39652 "preproc.c"
    break;

  case 497:
#line 4212 "preproc.y"
 { 
 (yyval.str) = cat_str(13,mm_strdup("create"),(yyvsp[-14].str),mm_strdup("table if not exists"),(yyvsp[-9].str),mm_strdup("("),(yyvsp[-7].str),mm_strdup(")"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39660 "preproc.c"
    break;

  case 498:
#line 4216 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("table"),(yyvsp[-8].str),mm_strdup("of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39668 "preproc.c"
    break;

  case 499:
#line 4220 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-13].str),mm_strdup("table if not exists"),(yyvsp[-8].str),mm_strdup("of"),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39676 "preproc.c"
    break;

  case 500:
#line 4228 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temporary");
}
#line 39684 "preproc.c"
    break;

  case 501:
#line 4232 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temp");
}
#line 39692 "preproc.c"
    break;

  case 502:
#line 4236 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local temporary");
}
#line 39700 "preproc.c"
    break;

  case 503:
#line 4240 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local temp");
}
#line 39708 "preproc.c"
    break;

  case 504:
#line 4244 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global temporary");
}
#line 39716 "preproc.c"
    break;

  case 505:
#line 4248 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global temp");
}
#line 39724 "preproc.c"
    break;

  case 506:
#line 4252 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 39732 "preproc.c"
    break;

  case 507:
#line 4256 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39739 "preproc.c"
    break;

  case 508:
#line 4263 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39747 "preproc.c"
    break;

  case 509:
#line 4267 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39754 "preproc.c"
    break;

  case 510:
#line 4274 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 39762 "preproc.c"
    break;

  case 511:
#line 4278 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39769 "preproc.c"
    break;

  case 512:
#line 4285 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39777 "preproc.c"
    break;

  case 513:
#line 4289 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39785 "preproc.c"
    break;

  case 514:
#line 4297 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39793 "preproc.c"
    break;

  case 515:
#line 4301 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 39801 "preproc.c"
    break;

  case 516:
#line 4309 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39809 "preproc.c"
    break;

  case 517:
#line 4313 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39817 "preproc.c"
    break;

  case 518:
#line 4317 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39825 "preproc.c"
    break;

  case 519:
#line 4321 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39833 "preproc.c"
    break;

  case 520:
#line 4329 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39841 "preproc.c"
    break;

  case 521:
#line 4333 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39849 "preproc.c"
    break;

  case 522:
#line 4341 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("column"),(yyvsp[-2].str),mm_strdup("encoding"),(yyvsp[0].str));
}
#line 39857 "preproc.c"
    break;

  case 523:
#line 4345 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default column encoding"),(yyvsp[0].str));
}
#line 39865 "preproc.c"
    break;

  case 524:
#line 4353 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39873 "preproc.c"
    break;

  case 525:
#line 4361 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("with options"),(yyvsp[0].str));
}
#line 39881 "preproc.c"
    break;

  case 526:
#line 4369 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39889 "preproc.c"
    break;

  case 527:
#line 4373 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39896 "preproc.c"
    break;

  case 528:
#line 4380 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39904 "preproc.c"
    break;

  case 529:
#line 4384 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39912 "preproc.c"
    break;

  case 530:
#line 4388 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 39920 "preproc.c"
    break;

  case 531:
#line 4392 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 39928 "preproc.c"
    break;

  case 532:
#line 4400 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("encoding"),(yyvsp[0].str));
}
#line 39936 "preproc.c"
    break;

  case 533:
#line 4404 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 39943 "preproc.c"
    break;

  case 534:
#line 4411 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not null");
}
#line 39951 "preproc.c"
    break;

  case 535:
#line 4415 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 39959 "preproc.c"
    break;

  case 536:
#line 4419 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39967 "preproc.c"
    break;

  case 537:
#line 4423 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39975 "preproc.c"
    break;

  case 538:
#line 4427 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 39983 "preproc.c"
    break;

  case 539:
#line 4431 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default"),(yyvsp[0].str));
}
#line 39991 "preproc.c"
    break;

  case 540:
#line 4435 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("references"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 39999 "preproc.c"
    break;

  case 541:
#line 4443 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 40007 "preproc.c"
    break;

  case 542:
#line 4447 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 40015 "preproc.c"
    break;

  case 543:
#line 4451 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 40023 "preproc.c"
    break;

  case 544:
#line 4455 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 40031 "preproc.c"
    break;

  case 545:
#line 4463 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("like"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40039 "preproc.c"
    break;

  case 546:
#line 4471 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("including"),(yyvsp[0].str));
}
#line 40047 "preproc.c"
    break;

  case 547:
#line 4475 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("excluding"),(yyvsp[0].str));
}
#line 40055 "preproc.c"
    break;

  case 548:
#line 4479 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40062 "preproc.c"
    break;

  case 549:
#line 4486 "preproc.y"
 { 
 (yyval.str) = mm_strdup("defaults");
}
#line 40070 "preproc.c"
    break;

  case 550:
#line 4490 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraints");
}
#line 40078 "preproc.c"
    break;

  case 551:
#line 4494 "preproc.y"
 { 
 (yyval.str) = mm_strdup("indexes");
}
#line 40086 "preproc.c"
    break;

  case 552:
#line 4498 "preproc.y"
 { 
 (yyval.str) = mm_strdup("storage");
}
#line 40094 "preproc.c"
    break;

  case 553:
#line 4502 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comments");
}
#line 40102 "preproc.c"
    break;

  case 554:
#line 4506 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 40110 "preproc.c"
    break;

  case 555:
#line 4514 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40118 "preproc.c"
    break;

  case 556:
#line 4518 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40126 "preproc.c"
    break;

  case 557:
#line 4526 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 40134 "preproc.c"
    break;

  case 558:
#line 4530 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("unique ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40142 "preproc.c"
    break;

  case 559:
#line 4534 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unique"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40150 "preproc.c"
    break;

  case 560:
#line 4538 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("primary key ("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40158 "preproc.c"
    break;

  case 561:
#line 4542 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("primary key"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40166 "preproc.c"
    break;

  case 562:
#line 4546 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("exclude"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40174 "preproc.c"
    break;

  case 563:
#line 4550 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("foreign key ("),(yyvsp[-7].str),mm_strdup(") references"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40182 "preproc.c"
    break;

  case 564:
#line 4558 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 40190 "preproc.c"
    break;

  case 565:
#line 4562 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40197 "preproc.c"
    break;

  case 566:
#line 4569 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40205 "preproc.c"
    break;

  case 567:
#line 4573 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40212 "preproc.c"
    break;

  case 568:
#line 4580 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40220 "preproc.c"
    break;

  case 569:
#line 4584 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40228 "preproc.c"
    break;

  case 570:
#line 4592 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40236 "preproc.c"
    break;

  case 571:
#line 4600 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40244 "preproc.c"
    break;

  case 572:
#line 4604 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40252 "preproc.c"
    break;

  case 573:
#line 4612 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40260 "preproc.c"
    break;

  case 574:
#line 4620 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match full");
}
#line 40268 "preproc.c"
    break;

  case 575:
#line 4624 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("match partial");
}
#line 40277 "preproc.c"
    break;

  case 576:
#line 4629 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match simple");
}
#line 40285 "preproc.c"
    break;

  case 577:
#line 4633 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40292 "preproc.c"
    break;

  case 578:
#line 4640 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40300 "preproc.c"
    break;

  case 579:
#line 4644 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40308 "preproc.c"
    break;

  case 580:
#line 4652 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 40316 "preproc.c"
    break;

  case 581:
#line 4656 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("with operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40324 "preproc.c"
    break;

  case 582:
#line 4664 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("where ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40332 "preproc.c"
    break;

  case 583:
#line 4668 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40339 "preproc.c"
    break;

  case 584:
#line 4675 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40347 "preproc.c"
    break;

  case 585:
#line 4679 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40355 "preproc.c"
    break;

  case 586:
#line 4683 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40363 "preproc.c"
    break;

  case 587:
#line 4687 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40371 "preproc.c"
    break;

  case 588:
#line 4691 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40378 "preproc.c"
    break;

  case 589:
#line 4698 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on update"),(yyvsp[0].str));
}
#line 40386 "preproc.c"
    break;

  case 590:
#line 4706 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on delete"),(yyvsp[0].str));
}
#line 40394 "preproc.c"
    break;

  case 591:
#line 4714 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no action");
}
#line 40402 "preproc.c"
    break;

  case 592:
#line 4718 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 40410 "preproc.c"
    break;

  case 593:
#line 4722 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 40418 "preproc.c"
    break;

  case 594:
#line 4726 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set null");
}
#line 40426 "preproc.c"
    break;

  case 595:
#line 4730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set default");
}
#line 40434 "preproc.c"
    break;

  case 596:
#line 4738 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("inherits ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40442 "preproc.c"
    break;

  case 597:
#line 4742 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40449 "preproc.c"
    break;

  case 598:
#line 4749 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 40457 "preproc.c"
    break;

  case 599:
#line 4753 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with oids");
}
#line 40465 "preproc.c"
    break;

  case 600:
#line 4757 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without oids");
}
#line 40473 "preproc.c"
    break;

  case 601:
#line 4761 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40480 "preproc.c"
    break;

  case 602:
#line 4768 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit drop");
}
#line 40488 "preproc.c"
    break;

  case 603:
#line 4772 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit delete rows");
}
#line 40496 "preproc.c"
    break;

  case 604:
#line 4776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on commit preserve rows");
}
#line 40504 "preproc.c"
    break;

  case 605:
#line 4780 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40511 "preproc.c"
    break;

  case 606:
#line 4787 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 40519 "preproc.c"
    break;

  case 607:
#line 4791 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40526 "preproc.c"
    break;

  case 608:
#line 4798 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index tablespace"),(yyvsp[0].str));
}
#line 40534 "preproc.c"
    break;

  case 609:
#line 4802 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40541 "preproc.c"
    break;

  case 610:
#line 4809 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using index"),(yyvsp[0].str));
}
#line 40549 "preproc.c"
    break;

  case 611:
#line 4817 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("distributed by ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40557 "preproc.c"
    break;

  case 612:
#line 4821 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distributed randomly");
}
#line 40565 "preproc.c"
    break;

  case 613:
#line 4825 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distributed replicated");
}
#line 40573 "preproc.c"
    break;

  case 614:
#line 4833 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40581 "preproc.c"
    break;

  case 615:
#line 4837 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40588 "preproc.c"
    break;

  case 616:
#line 4844 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40596 "preproc.c"
    break;

  case 617:
#line 4848 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40603 "preproc.c"
    break;

  case 618:
#line 4855 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40611 "preproc.c"
    break;

  case 619:
#line 4859 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40619 "preproc.c"
    break;

  case 620:
#line 4867 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("with"),(yyvsp[-2].str),mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 40627 "preproc.c"
    break;

  case 621:
#line 4871 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 40635 "preproc.c"
    break;

  case 622:
#line 4875 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 40643 "preproc.c"
    break;

  case 623:
#line 4879 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40650 "preproc.c"
    break;

  case 624:
#line 4886 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40658 "preproc.c"
    break;

  case 625:
#line 4890 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40665 "preproc.c"
    break;

  case 626:
#line 4897 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40673 "preproc.c"
    break;

  case 627:
#line 4901 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40680 "preproc.c"
    break;

  case 628:
#line 4908 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40688 "preproc.c"
    break;

  case 629:
#line 4912 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40696 "preproc.c"
    break;

  case 630:
#line 4920 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40704 "preproc.c"
    break;

  case 631:
#line 4924 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40712 "preproc.c"
    break;

  case 632:
#line 4932 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40720 "preproc.c"
    break;

  case 633:
#line 4936 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40728 "preproc.c"
    break;

  case 634:
#line 4940 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 40736 "preproc.c"
    break;

  case 635:
#line 4944 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 40744 "preproc.c"
    break;

  case 636:
#line 4952 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40752 "preproc.c"
    break;

  case 637:
#line 4956 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40760 "preproc.c"
    break;

  case 638:
#line 4960 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ::"),(yyvsp[0].str));
}
#line 40768 "preproc.c"
    break;

  case 639:
#line 4968 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40776 "preproc.c"
    break;

  case 640:
#line 4972 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40784 "preproc.c"
    break;

  case 641:
#line 4980 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inclusive");
}
#line 40792 "preproc.c"
    break;

  case 642:
#line 4984 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 40800 "preproc.c"
    break;

  case 643:
#line 4988 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40807 "preproc.c"
    break;

  case 644:
#line 4995 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("start ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 40815 "preproc.c"
    break;

  case 645:
#line 5003 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("end ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 40823 "preproc.c"
    break;

  case 646:
#line 5011 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("every ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40831 "preproc.c"
    break;

  case 647:
#line 5015 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40838 "preproc.c"
    break;

  case 648:
#line 5022 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40846 "preproc.c"
    break;

  case 649:
#line 5026 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40853 "preproc.c"
    break;

  case 650:
#line 5033 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40861 "preproc.c"
    break;

  case 651:
#line 5037 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40869 "preproc.c"
    break;

  case 652:
#line 5041 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40877 "preproc.c"
    break;

  case 653:
#line 5049 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40885 "preproc.c"
    break;

  case 654:
#line 5053 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 40892 "preproc.c"
    break;

  case 655:
#line 5060 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40900 "preproc.c"
    break;

  case 656:
#line 5064 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup(", ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40908 "preproc.c"
    break;

  case 657:
#line 5072 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40916 "preproc.c"
    break;

  case 658:
#line 5076 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 40924 "preproc.c"
    break;

  case 659:
#line 5084 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("values ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40932 "preproc.c"
    break;

  case 660:
#line 5088 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("values ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 40940 "preproc.c"
    break;

  case 661:
#line 5096 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40948 "preproc.c"
    break;

  case 662:
#line 5100 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40956 "preproc.c"
    break;

  case 663:
#line 5108 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40964 "preproc.c"
    break;

  case 664:
#line 5112 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40972 "preproc.c"
    break;

  case 665:
#line 5116 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40980 "preproc.c"
    break;

  case 666:
#line 5120 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 40988 "preproc.c"
    break;

  case 667:
#line 5128 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 40996 "preproc.c"
    break;

  case 668:
#line 5132 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41004 "preproc.c"
    break;

  case 669:
#line 5136 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41012 "preproc.c"
    break;

  case 670:
#line 5140 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41020 "preproc.c"
    break;

  case 671:
#line 5148 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("partition"),(yyvsp[0].str));
}
#line 41028 "preproc.c"
    break;

  case 672:
#line 5156 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default partition"),(yyvsp[0].str));
}
#line 41036 "preproc.c"
    break;

  case 673:
#line 5164 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("subpartition"),(yyvsp[0].str));
}
#line 41044 "preproc.c"
    break;

  case 674:
#line 5172 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("default subpartition"),(yyvsp[0].str));
}
#line 41052 "preproc.c"
    break;

  case 675:
#line 5180 "preproc.y"
 { 
 (yyval.str) = mm_strdup("range");
}
#line 41060 "preproc.c"
    break;

  case 676:
#line 5184 "preproc.y"
 { 
 (yyval.str) = mm_strdup("list");
}
#line 41068 "preproc.c"
    break;

  case 677:
#line 5188 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41075 "preproc.c"
    break;

  case 678:
#line 5195 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("partition by"),(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41083 "preproc.c"
    break;

  case 679:
#line 5199 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41090 "preproc.c"
    break;

  case 680:
#line 5206 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("subpartition template ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41098 "preproc.c"
    break;

  case 681:
#line 5214 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41106 "preproc.c"
    break;

  case 682:
#line 5218 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41113 "preproc.c"
    break;

  case 683:
#line 5225 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("subpartition by"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41121 "preproc.c"
    break;

  case 684:
#line 5233 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41129 "preproc.c"
    break;

  case 685:
#line 5237 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41137 "preproc.c"
    break;

  case 686:
#line 5241 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41145 "preproc.c"
    break;

  case 687:
#line 5245 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41153 "preproc.c"
    break;

  case 688:
#line 5253 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41162 "preproc.c"
    break;

  case 689:
#line 5262 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with data");
}
#line 41170 "preproc.c"
    break;

  case 690:
#line 5266 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with no data");
}
#line 41178 "preproc.c"
    break;

  case 691:
#line 5270 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41185 "preproc.c"
    break;

  case 692:
#line 5277 "preproc.y"
 { 
 (yyval.str) = cat_str(18,mm_strdup("create"),(yyvsp[-16].str),mm_strdup("external"),(yyvsp[-14].str),(yyvsp[-13].str),mm_strdup("table"),(yyvsp[-11].str),mm_strdup("("),(yyvsp[-9].str),mm_strdup(")"),(yyvsp[-7].str),mm_strdup("format"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41193 "preproc.c"
    break;

  case 693:
#line 5285 "preproc.y"
 { 
 (yyval.str) = mm_strdup("writable");
}
#line 41201 "preproc.c"
    break;

  case 694:
#line 5289 "preproc.y"
 { 
 (yyval.str) = mm_strdup("readable");
}
#line 41209 "preproc.c"
    break;

  case 695:
#line 5293 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41216 "preproc.c"
    break;

  case 696:
#line 5300 "preproc.y"
 { 
 (yyval.str) = mm_strdup("web");
}
#line 41224 "preproc.c"
    break;

  case 697:
#line 5304 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41231 "preproc.c"
    break;

  case 698:
#line 5311 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("location ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 41239 "preproc.c"
    break;

  case 699:
#line 5315 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("execute"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41247 "preproc.c"
    break;

  case 700:
#line 5323 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41255 "preproc.c"
    break;

  case 701:
#line 5327 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41262 "preproc.c"
    break;

  case 702:
#line 5334 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on all");
}
#line 41270 "preproc.c"
    break;

  case 703:
#line 5338 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on host"),(yyvsp[0].str));
}
#line 41278 "preproc.c"
    break;

  case 704:
#line 5342 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on host");
}
#line 41286 "preproc.c"
    break;

  case 705:
#line 5346 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on master");
}
#line 41294 "preproc.c"
    break;

  case 706:
#line 5350 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on segment"),(yyvsp[0].str));
}
#line 41302 "preproc.c"
    break;

  case 707:
#line 5354 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on"),(yyvsp[0].str));
}
#line 41310 "preproc.c"
    break;

  case 708:
#line 5362 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41318 "preproc.c"
    break;

  case 709:
#line 5366 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41326 "preproc.c"
    break;

  case 710:
#line 5370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 41334 "preproc.c"
    break;

  case 711:
#line 5374 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41341 "preproc.c"
    break;

  case 712:
#line 5381 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41349 "preproc.c"
    break;

  case 713:
#line 5385 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41357 "preproc.c"
    break;

  case 714:
#line 5393 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41365 "preproc.c"
    break;

  case 715:
#line 5397 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41373 "preproc.c"
    break;

  case 716:
#line 5405 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 41381 "preproc.c"
    break;

  case 717:
#line 5409 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("= ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41389 "preproc.c"
    break;

  case 718:
#line 5417 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("delimiter"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41397 "preproc.c"
    break;

  case 719:
#line 5421 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("null"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41405 "preproc.c"
    break;

  case 720:
#line 5425 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 41413 "preproc.c"
    break;

  case 721:
#line 5429 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 41421 "preproc.c"
    break;

  case 722:
#line 5433 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("quote"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41429 "preproc.c"
    break;

  case 723:
#line 5437 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("escape"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41437 "preproc.c"
    break;

  case 724:
#line 5441 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force not null"),(yyvsp[0].str));
}
#line 41445 "preproc.c"
    break;

  case 725:
#line 5445 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("force quote"),(yyvsp[0].str));
}
#line 41453 "preproc.c"
    break;

  case 726:
#line 5449 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force quote *");
}
#line 41461 "preproc.c"
    break;

  case 727:
#line 5453 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fill missing fields");
}
#line 41469 "preproc.c"
    break;

  case 728:
#line 5457 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("newline"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41477 "preproc.c"
    break;

  case 729:
#line 5465 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("options"),(yyvsp[0].str));
}
#line 41485 "preproc.c"
    break;

  case 730:
#line 5469 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41492 "preproc.c"
    break;

  case 731:
#line 5476 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 41500 "preproc.c"
    break;

  case 732:
#line 5480 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 41508 "preproc.c"
    break;

  case 733:
#line 5488 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41516 "preproc.c"
    break;

  case 734:
#line 5492 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41524 "preproc.c"
    break;

  case 735:
#line 5500 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41532 "preproc.c"
    break;

  case 736:
#line 5508 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41540 "preproc.c"
    break;

  case 737:
#line 5512 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41547 "preproc.c"
    break;

  case 738:
#line 5519 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41555 "preproc.c"
    break;

  case 739:
#line 5523 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41563 "preproc.c"
    break;

  case 740:
#line 5531 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41571 "preproc.c"
    break;

  case 741:
#line 5535 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41579 "preproc.c"
    break;

  case 742:
#line 5543 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41587 "preproc.c"
    break;

  case 743:
#line 5551 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("segment reject limit"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41595 "preproc.c"
    break;

  case 744:
#line 5555 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41602 "preproc.c"
    break;

  case 745:
#line 5562 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("log errors into"),(yyvsp[0].str));
}
#line 41611 "preproc.c"
    break;

  case 746:
#line 5567 "preproc.y"
 { 
 (yyval.str) = mm_strdup("log errors");
}
#line 41619 "preproc.c"
    break;

  case 747:
#line 5571 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41626 "preproc.c"
    break;

  case 748:
#line 5578 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("segment reject limit"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41634 "preproc.c"
    break;

  case 749:
#line 5582 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41641 "preproc.c"
    break;

  case 750:
#line 5589 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41649 "preproc.c"
    break;

  case 751:
#line 5593 "preproc.y"
 { 
 (yyval.str) = mm_strdup("log errors persistently");
}
#line 41657 "preproc.c"
    break;

  case 752:
#line 5601 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 41665 "preproc.c"
    break;

  case 753:
#line 5605 "preproc.y"
 { 
 (yyval.str) = mm_strdup("percent");
}
#line 41673 "preproc.c"
    break;

  case 754:
#line 5609 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41680 "preproc.c"
    break;

  case 755:
#line 5616 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41688 "preproc.c"
    break;

  case 756:
#line 5620 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41695 "preproc.c"
    break;

  case 757:
#line 5627 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("encoding"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41703 "preproc.c"
    break;

  case 758:
#line 5631 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("encoding"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41711 "preproc.c"
    break;

  case 759:
#line 5639 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("materialized view"),(yyvsp[-4].str),mm_strdup("as"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41719 "preproc.c"
    break;

  case 760:
#line 5647 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41727 "preproc.c"
    break;

  case 761:
#line 5655 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 41735 "preproc.c"
    break;

  case 762:
#line 5659 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41742 "preproc.c"
    break;

  case 763:
#line 5666 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("refresh materialized view"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41750 "preproc.c"
    break;

  case 764:
#line 5674 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41758 "preproc.c"
    break;

  case 765:
#line 5682 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41766 "preproc.c"
    break;

  case 766:
#line 5686 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter sequence if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41774 "preproc.c"
    break;

  case 767:
#line 5694 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41782 "preproc.c"
    break;

  case 768:
#line 5698 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41789 "preproc.c"
    break;

  case 769:
#line 5705 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41797 "preproc.c"
    break;

  case 770:
#line 5709 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41805 "preproc.c"
    break;

  case 771:
#line 5717 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cache"),(yyvsp[0].str));
}
#line 41813 "preproc.c"
    break;

  case 772:
#line 5721 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cycle");
}
#line 41821 "preproc.c"
    break;

  case 773:
#line 5725 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no cycle");
}
#line 41829 "preproc.c"
    break;

  case 774:
#line 5729 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("increment"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41837 "preproc.c"
    break;

  case 775:
#line 5733 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("maxvalue"),(yyvsp[0].str));
}
#line 41845 "preproc.c"
    break;

  case 776:
#line 5737 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("minvalue"),(yyvsp[0].str));
}
#line 41853 "preproc.c"
    break;

  case 777:
#line 5741 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no maxvalue");
}
#line 41861 "preproc.c"
    break;

  case 778:
#line 5745 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no minvalue");
}
#line 41869 "preproc.c"
    break;

  case 779:
#line 5749 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owned by"),(yyvsp[0].str));
}
#line 41877 "preproc.c"
    break;

  case 780:
#line 5753 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("start"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41885 "preproc.c"
    break;

  case 781:
#line 5757 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 41893 "preproc.c"
    break;

  case 782:
#line 5761 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("restart"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41901 "preproc.c"
    break;

  case 783:
#line 5769 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by");
}
#line 41909 "preproc.c"
    break;

  case 784:
#line 5773 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41916 "preproc.c"
    break;

  case 785:
#line 5780 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41924 "preproc.c"
    break;

  case 786:
#line 5784 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 41932 "preproc.c"
    break;

  case 787:
#line 5788 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 41940 "preproc.c"
    break;

  case 788:
#line 5792 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41948 "preproc.c"
    break;

  case 789:
#line 5800 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 41956 "preproc.c"
    break;

  case 790:
#line 5804 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 41964 "preproc.c"
    break;

  case 791:
#line 5812 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 41972 "preproc.c"
    break;

  case 792:
#line 5816 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("language"),(yyvsp[-4].str),mm_strdup("handler"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 41980 "preproc.c"
    break;

  case 793:
#line 5824 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trusted");
}
#line 41988 "preproc.c"
    break;

  case 794:
#line 5828 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 41995 "preproc.c"
    break;

  case 795:
#line 5835 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42003 "preproc.c"
    break;

  case 796:
#line 5839 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42011 "preproc.c"
    break;

  case 797:
#line 5847 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("inline"),(yyvsp[0].str));
}
#line 42019 "preproc.c"
    break;

  case 798:
#line 5851 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42026 "preproc.c"
    break;

  case 799:
#line 5858 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 42034 "preproc.c"
    break;

  case 800:
#line 5862 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no validator");
}
#line 42042 "preproc.c"
    break;

  case 801:
#line 5870 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42050 "preproc.c"
    break;

  case 802:
#line 5874 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42057 "preproc.c"
    break;

  case 803:
#line 5881 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-3].str),mm_strdup("language"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42065 "preproc.c"
    break;

  case 804:
#line 5885 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-5].str),mm_strdup("language if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42073 "preproc.c"
    break;

  case 805:
#line 5893 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedural");
}
#line 42081 "preproc.c"
    break;

  case 806:
#line 5897 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42088 "preproc.c"
    break;

  case 807:
#line 5904 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create tablespace"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("location"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42096 "preproc.c"
    break;

  case 808:
#line 5912 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("owner"),(yyvsp[0].str));
}
#line 42104 "preproc.c"
    break;

  case 809:
#line 5916 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42111 "preproc.c"
    break;

  case 810:
#line 5923 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace"),(yyvsp[0].str));
}
#line 42119 "preproc.c"
    break;

  case 811:
#line 5927 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop tablespace if exists"),(yyvsp[0].str));
}
#line 42127 "preproc.c"
    break;

  case 812:
#line 5935 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create extension"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42135 "preproc.c"
    break;

  case 813:
#line 5939 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create extension if not exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42143 "preproc.c"
    break;

  case 814:
#line 5947 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42151 "preproc.c"
    break;

  case 815:
#line 5951 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42158 "preproc.c"
    break;

  case 816:
#line 5958 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 42166 "preproc.c"
    break;

  case 817:
#line 5962 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 42174 "preproc.c"
    break;

  case 818:
#line 5966 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 42182 "preproc.c"
    break;

  case 819:
#line 5974 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-2].str),mm_strdup("update"),(yyvsp[0].str));
}
#line 42190 "preproc.c"
    break;

  case 820:
#line 5982 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42198 "preproc.c"
    break;

  case 821:
#line 5986 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42205 "preproc.c"
    break;

  case 822:
#line 5993 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("to"),(yyvsp[0].str));
}
#line 42213 "preproc.c"
    break;

  case 823:
#line 6001 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42221 "preproc.c"
    break;

  case 824:
#line 6005 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter extension"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42229 "preproc.c"
    break;

  case 825:
#line 6009 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("collation"),(yyvsp[0].str));
}
#line 42237 "preproc.c"
    break;

  case 826:
#line 6013 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("conversion"),(yyvsp[0].str));
}
#line 42245 "preproc.c"
    break;

  case 827:
#line 6017 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("domain"),(yyvsp[0].str));
}
#line 42253 "preproc.c"
    break;

  case 828:
#line 6021 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("function"),(yyvsp[0].str));
}
#line 42261 "preproc.c"
    break;

  case 829:
#line 6025 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("language"),(yyvsp[0].str));
}
#line 42269 "preproc.c"
    break;

  case 830:
#line 6029 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42277 "preproc.c"
    break;

  case 831:
#line 6033 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator class"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 42285 "preproc.c"
    break;

  case 832:
#line 6037 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter extension"),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 42293 "preproc.c"
    break;

  case 833:
#line 6041 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("schema"),(yyvsp[0].str));
}
#line 42301 "preproc.c"
    break;

  case 834:
#line 6045 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("event trigger"),(yyvsp[0].str));
}
#line 42309 "preproc.c"
    break;

  case 835:
#line 6049 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("table"),(yyvsp[0].str));
}
#line 42317 "preproc.c"
    break;

  case 836:
#line 6053 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search parser"),(yyvsp[0].str));
}
#line 42325 "preproc.c"
    break;

  case 837:
#line 6057 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search dictionary"),(yyvsp[0].str));
}
#line 42333 "preproc.c"
    break;

  case 838:
#line 6061 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search template"),(yyvsp[0].str));
}
#line 42341 "preproc.c"
    break;

  case 839:
#line 6065 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("text search configuration"),(yyvsp[0].str));
}
#line 42349 "preproc.c"
    break;

  case 840:
#line 6069 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("sequence"),(yyvsp[0].str));
}
#line 42357 "preproc.c"
    break;

  case 841:
#line 6073 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("view"),(yyvsp[0].str));
}
#line 42365 "preproc.c"
    break;

  case 842:
#line 6077 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("materialized view"),(yyvsp[0].str));
}
#line 42373 "preproc.c"
    break;

  case 843:
#line 6081 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("foreign table"),(yyvsp[0].str));
}
#line 42381 "preproc.c"
    break;

  case 844:
#line 6085 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 42389 "preproc.c"
    break;

  case 845:
#line 6089 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 42397 "preproc.c"
    break;

  case 846:
#line 6093 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter extension"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("type"),(yyvsp[0].str));
}
#line 42405 "preproc.c"
    break;

  case 847:
#line 6101 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42413 "preproc.c"
    break;

  case 848:
#line 6109 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("handler"),(yyvsp[0].str));
}
#line 42421 "preproc.c"
    break;

  case 849:
#line 6113 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no handler");
}
#line 42429 "preproc.c"
    break;

  case 850:
#line 6117 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("validator"),(yyvsp[0].str));
}
#line 42437 "preproc.c"
    break;

  case 851:
#line 6121 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no validator");
}
#line 42445 "preproc.c"
    break;

  case 852:
#line 6129 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42453 "preproc.c"
    break;

  case 853:
#line 6133 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42461 "preproc.c"
    break;

  case 854:
#line 6141 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42469 "preproc.c"
    break;

  case 855:
#line 6145 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42476 "preproc.c"
    break;

  case 856:
#line 6152 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42484 "preproc.c"
    break;

  case 857:
#line 6156 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop foreign data wrapper if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42492 "preproc.c"
    break;

  case 858:
#line 6164 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42500 "preproc.c"
    break;

  case 859:
#line 6168 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42508 "preproc.c"
    break;

  case 860:
#line 6176 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42516 "preproc.c"
    break;

  case 861:
#line 6180 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42523 "preproc.c"
    break;

  case 862:
#line 6187 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42531 "preproc.c"
    break;

  case 863:
#line 6191 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42539 "preproc.c"
    break;

  case 864:
#line 6199 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("options ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42547 "preproc.c"
    break;

  case 865:
#line 6207 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42555 "preproc.c"
    break;

  case 866:
#line 6211 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42563 "preproc.c"
    break;

  case 867:
#line 6219 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42571 "preproc.c"
    break;

  case 868:
#line 6223 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("set"),(yyvsp[0].str));
}
#line 42579 "preproc.c"
    break;

  case 869:
#line 6227 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("add"),(yyvsp[0].str));
}
#line 42587 "preproc.c"
    break;

  case 870:
#line 6231 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop"),(yyvsp[0].str));
}
#line 42595 "preproc.c"
    break;

  case 871:
#line 6239 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42603 "preproc.c"
    break;

  case 872:
#line 6247 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42611 "preproc.c"
    break;

  case 873:
#line 6255 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42619 "preproc.c"
    break;

  case 874:
#line 6263 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create server"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),mm_strdup("foreign data wrapper"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42627 "preproc.c"
    break;

  case 875:
#line 6271 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 42635 "preproc.c"
    break;

  case 876:
#line 6275 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42642 "preproc.c"
    break;

  case 877:
#line 6282 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 42650 "preproc.c"
    break;

  case 878:
#line 6286 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version null");
}
#line 42658 "preproc.c"
    break;

  case 879:
#line 6294 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42666 "preproc.c"
    break;

  case 880:
#line 6298 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42673 "preproc.c"
    break;

  case 881:
#line 6305 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42681 "preproc.c"
    break;

  case 882:
#line 6309 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop server if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42689 "preproc.c"
    break;

  case 883:
#line 6317 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42697 "preproc.c"
    break;

  case 884:
#line 6321 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42705 "preproc.c"
    break;

  case 885:
#line 6325 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42713 "preproc.c"
    break;

  case 886:
#line 6333 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create foreign table"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(") server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42721 "preproc.c"
    break;

  case 887:
#line 6337 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create foreign table if not exists"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(") server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42729 "preproc.c"
    break;

  case 888:
#line 6345 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42737 "preproc.c"
    break;

  case 889:
#line 6349 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter foreign table if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42745 "preproc.c"
    break;

  case 890:
#line 6357 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42753 "preproc.c"
    break;

  case 891:
#line 6365 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 42761 "preproc.c"
    break;

  case 892:
#line 6369 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 42769 "preproc.c"
    break;

  case 893:
#line 6373 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42777 "preproc.c"
    break;

  case 894:
#line 6381 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 42785 "preproc.c"
    break;

  case 895:
#line 6385 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop user mapping if exists for"),(yyvsp[-2].str),mm_strdup("server"),(yyvsp[0].str));
}
#line 42793 "preproc.c"
    break;

  case 896:
#line 6393 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter user mapping for"),(yyvsp[-3].str),mm_strdup("server"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42801 "preproc.c"
    break;

  case 897:
#line 6401 "preproc.y"
 { 
 (yyval.str) = cat_str(13,mm_strdup("create trigger"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("on"),(yyvsp[-8].str),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42809 "preproc.c"
    break;

  case 898:
#line 6405 "preproc.y"
 { 
 (yyval.str) = cat_str(15,mm_strdup("create constraint trigger"),(yyvsp[-16].str),mm_strdup("after"),(yyvsp[-14].str),mm_strdup("on"),(yyvsp[-12].str),(yyvsp[-11].str),(yyvsp[-10].str),mm_strdup("for each row"),(yyvsp[-6].str),mm_strdup("execute procedure"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42817 "preproc.c"
    break;

  case 899:
#line 6413 "preproc.y"
 { 
 (yyval.str) = mm_strdup("before");
}
#line 42825 "preproc.c"
    break;

  case 900:
#line 6417 "preproc.y"
 { 
 (yyval.str) = mm_strdup("after");
}
#line 42833 "preproc.c"
    break;

  case 901:
#line 6421 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead of");
}
#line 42841 "preproc.c"
    break;

  case 902:
#line 6429 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42849 "preproc.c"
    break;

  case 903:
#line 6433 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 42857 "preproc.c"
    break;

  case 904:
#line 6441 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 42865 "preproc.c"
    break;

  case 905:
#line 6445 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 42873 "preproc.c"
    break;

  case 906:
#line 6449 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 42881 "preproc.c"
    break;

  case 907:
#line 6453 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("update of"),(yyvsp[0].str));
}
#line 42889 "preproc.c"
    break;

  case 908:
#line 6457 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate");
}
#line 42897 "preproc.c"
    break;

  case 909:
#line 6465 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("for"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 42905 "preproc.c"
    break;

  case 910:
#line 6469 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42912 "preproc.c"
    break;

  case 911:
#line 6476 "preproc.y"
 { 
 (yyval.str) = mm_strdup("each");
}
#line 42920 "preproc.c"
    break;

  case 912:
#line 6480 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42927 "preproc.c"
    break;

  case 913:
#line 6487 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 42935 "preproc.c"
    break;

  case 914:
#line 6491 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statement");
}
#line 42943 "preproc.c"
    break;

  case 915:
#line 6499 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("when ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 42951 "preproc.c"
    break;

  case 916:
#line 6503 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42958 "preproc.c"
    break;

  case 917:
#line 6510 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42966 "preproc.c"
    break;

  case 918:
#line 6514 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 42974 "preproc.c"
    break;

  case 919:
#line 6518 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 42981 "preproc.c"
    break;

  case 920:
#line 6525 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42989 "preproc.c"
    break;

  case 921:
#line 6529 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 42997 "preproc.c"
    break;

  case 922:
#line 6533 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43005 "preproc.c"
    break;

  case 923:
#line 6537 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43013 "preproc.c"
    break;

  case 924:
#line 6545 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 43021 "preproc.c"
    break;

  case 925:
#line 6549 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43028 "preproc.c"
    break;

  case 926:
#line 6556 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43035 "preproc.c"
    break;

  case 927:
#line 6559 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43043 "preproc.c"
    break;

  case 928:
#line 6567 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 43051 "preproc.c"
    break;

  case 929:
#line 6571 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 43059 "preproc.c"
    break;

  case 930:
#line 6575 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially immediate");
}
#line 43067 "preproc.c"
    break;

  case 931:
#line 6579 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially deferred");
}
#line 43075 "preproc.c"
    break;

  case 932:
#line 6583 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not valid");
}
#line 43083 "preproc.c"
    break;

  case 933:
#line 6587 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no inherit");
}
#line 43091 "preproc.c"
    break;

  case 934:
#line 6595 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop trigger"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43099 "preproc.c"
    break;

  case 935:
#line 6599 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop trigger if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43107 "preproc.c"
    break;

  case 936:
#line 6607 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create event trigger"),(yyvsp[-7].str),mm_strdup("on"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 43115 "preproc.c"
    break;

  case 937:
#line 6611 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create event trigger"),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),mm_strdup("when"),(yyvsp[-5].str),mm_strdup("execute procedure"),(yyvsp[-2].str),mm_strdup("( )"));
}
#line 43123 "preproc.c"
    break;

  case 938:
#line 6619 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43131 "preproc.c"
    break;

  case 939:
#line 6623 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 43139 "preproc.c"
    break;

  case 940:
#line 6631 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("in ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43147 "preproc.c"
    break;

  case 941:
#line 6639 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sconst");
}
#line 43155 "preproc.c"
    break;

  case 942:
#line 6643 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup(", sconst"));
}
#line 43163 "preproc.c"
    break;

  case 943:
#line 6651 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter event trigger"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43171 "preproc.c"
    break;

  case 944:
#line 6659 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable");
}
#line 43179 "preproc.c"
    break;

  case 945:
#line 6663 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable replica");
}
#line 43187 "preproc.c"
    break;

  case 946:
#line 6667 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable always");
}
#line 43195 "preproc.c"
    break;

  case 947:
#line 6671 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable");
}
#line 43203 "preproc.c"
    break;

  case 948:
#line 6679 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,mm_strdup("create assertion"),(yyvsp[-5].str),mm_strdup("check ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 43212 "preproc.c"
    break;

  case 949:
#line 6688 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("drop assertion"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43221 "preproc.c"
    break;

  case 950:
#line 6697 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),mm_strdup("aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43229 "preproc.c"
    break;

  case 951:
#line 6701 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create"),(yyvsp[-3].str),mm_strdup("aggregate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43237 "preproc.c"
    break;

  case 952:
#line 6705 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create operator"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43245 "preproc.c"
    break;

  case 953:
#line 6709 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create type"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43253 "preproc.c"
    break;

  case 954:
#line 6713 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create type"),(yyvsp[0].str));
}
#line 43261 "preproc.c"
    break;

  case 955:
#line 6717 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43269 "preproc.c"
    break;

  case 956:
#line 6721 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("protocol"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43277 "preproc.c"
    break;

  case 957:
#line 6725 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create type"),(yyvsp[-5].str),mm_strdup("as enum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43285 "preproc.c"
    break;

  case 958:
#line 6729 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create type"),(yyvsp[-3].str),mm_strdup("as range"),(yyvsp[0].str));
}
#line 43293 "preproc.c"
    break;

  case 959:
#line 6733 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search parser"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43301 "preproc.c"
    break;

  case 960:
#line 6737 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43309 "preproc.c"
    break;

  case 961:
#line 6741 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search template"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43317 "preproc.c"
    break;

  case 962:
#line 6745 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create text search configuration"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43325 "preproc.c"
    break;

  case 963:
#line 6749 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("create collation"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43333 "preproc.c"
    break;

  case 964:
#line 6753 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create collation"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 43341 "preproc.c"
    break;

  case 965:
#line 6761 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ordered");
}
#line 43349 "preproc.c"
    break;

  case 966:
#line 6765 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43356 "preproc.c"
    break;

  case 967:
#line 6772 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43364 "preproc.c"
    break;

  case 968:
#line 6780 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43372 "preproc.c"
    break;

  case 969:
#line 6784 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43380 "preproc.c"
    break;

  case 970:
#line 6792 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 43388 "preproc.c"
    break;

  case 971:
#line 6796 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43396 "preproc.c"
    break;

  case 972:
#line 6804 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43404 "preproc.c"
    break;

  case 973:
#line 6808 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 43412 "preproc.c"
    break;

  case 974:
#line 6812 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43420 "preproc.c"
    break;

  case 975:
#line 6816 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43428 "preproc.c"
    break;

  case 976:
#line 6820 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43436 "preproc.c"
    break;

  case 977:
#line 6824 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43444 "preproc.c"
    break;

  case 978:
#line 6828 "preproc.y"
 { 
 (yyval.str) = mm_strdup("none");
}
#line 43452 "preproc.c"
    break;

  case 979:
#line 6836 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43460 "preproc.c"
    break;

  case 980:
#line 6844 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43468 "preproc.c"
    break;

  case 981:
#line 6848 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43476 "preproc.c"
    break;

  case 982:
#line 6856 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 43484 "preproc.c"
    break;

  case 983:
#line 6864 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43492 "preproc.c"
    break;

  case 984:
#line 6868 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43499 "preproc.c"
    break;

  case 985:
#line 6875 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43507 "preproc.c"
    break;

  case 986:
#line 6879 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43515 "preproc.c"
    break;

  case 987:
#line 6887 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("add value"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43523 "preproc.c"
    break;

  case 988:
#line 6891 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("before"),(yyvsp[0].str));
}
#line 43531 "preproc.c"
    break;

  case 989:
#line 6895 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("add value"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("after"),(yyvsp[0].str));
}
#line 43539 "preproc.c"
    break;

  case 990:
#line 6903 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if not exists");
}
#line 43547 "preproc.c"
    break;

  case 991:
#line 6907 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43554 "preproc.c"
    break;

  case 992:
#line 6914 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create operator class"),(yyvsp[-9].str),(yyvsp[-8].str),mm_strdup("for type"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 43562 "preproc.c"
    break;

  case 993:
#line 6922 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43570 "preproc.c"
    break;

  case 994:
#line 6926 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43578 "preproc.c"
    break;

  case 995:
#line 6934 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43586 "preproc.c"
    break;

  case 996:
#line 6938 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("operator"),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43594 "preproc.c"
    break;

  case 997:
#line 6942 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43602 "preproc.c"
    break;

  case 998:
#line 6946 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("function"),(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43610 "preproc.c"
    break;

  case 999:
#line 6950 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("storage"),(yyvsp[0].str));
}
#line 43618 "preproc.c"
    break;

  case 1000:
#line 6958 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 43626 "preproc.c"
    break;

  case 1001:
#line 6962 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43633 "preproc.c"
    break;

  case 1002:
#line 6969 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("family"),(yyvsp[0].str));
}
#line 43641 "preproc.c"
    break;

  case 1003:
#line 6973 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43648 "preproc.c"
    break;

  case 1004:
#line 6980 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for search");
}
#line 43656 "preproc.c"
    break;

  case 1005:
#line 6984 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for order by"),(yyvsp[0].str));
}
#line 43664 "preproc.c"
    break;

  case 1006:
#line 6988 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43671 "preproc.c"
    break;

  case 1007:
#line 6995 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = mm_strdup("recheck");
}
#line 43680 "preproc.c"
    break;

  case 1008:
#line 7000 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 43687 "preproc.c"
    break;

  case 1009:
#line 7007 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create operator family"),(yyvsp[-2].str),mm_strdup("using"),(yyvsp[0].str));
}
#line 43695 "preproc.c"
    break;

  case 1010:
#line 7015 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 43703 "preproc.c"
    break;

  case 1011:
#line 7019 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("drop"),(yyvsp[0].str));
}
#line 43711 "preproc.c"
    break;

  case 1012:
#line 7027 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43719 "preproc.c"
    break;

  case 1013:
#line 7031 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43727 "preproc.c"
    break;

  case 1014:
#line 7039 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("operator"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43735 "preproc.c"
    break;

  case 1015:
#line 7043 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("function"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 43743 "preproc.c"
    break;

  case 1016:
#line 7051 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43751 "preproc.c"
    break;

  case 1017:
#line 7055 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator class if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43759 "preproc.c"
    break;

  case 1018:
#line 7063 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43767 "preproc.c"
    break;

  case 1019:
#line 7067 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop operator family if exists"),(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43775 "preproc.c"
    break;

  case 1020:
#line 7075 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop owned by"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43783 "preproc.c"
    break;

  case 1021:
#line 7083 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("reassign owned by"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 43791 "preproc.c"
    break;

  case 1022:
#line 7091 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop"),(yyvsp[-4].str),mm_strdup("if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43799 "preproc.c"
    break;

  case 1023:
#line 7095 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43807 "preproc.c"
    break;

  case 1024:
#line 7099 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43815 "preproc.c"
    break;

  case 1025:
#line 7103 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("drop index concurrently if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 43823 "preproc.c"
    break;

  case 1026:
#line 7111 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 43831 "preproc.c"
    break;

  case 1027:
#line 7115 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external table");
}
#line 43839 "preproc.c"
    break;

  case 1028:
#line 7119 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external web table");
}
#line 43847 "preproc.c"
    break;

  case 1029:
#line 7123 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 43855 "preproc.c"
    break;

  case 1030:
#line 7127 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 43863 "preproc.c"
    break;

  case 1031:
#line 7131 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 43871 "preproc.c"
    break;

  case 1032:
#line 7135 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 43879 "preproc.c"
    break;

  case 1033:
#line 7139 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 43887 "preproc.c"
    break;

  case 1034:
#line 7143 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 43895 "preproc.c"
    break;

  case 1035:
#line 7147 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 43903 "preproc.c"
    break;

  case 1036:
#line 7151 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 43911 "preproc.c"
    break;

  case 1037:
#line 7155 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 43919 "preproc.c"
    break;

  case 1038:
#line 7159 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 43927 "preproc.c"
    break;

  case 1039:
#line 7163 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 43935 "preproc.c"
    break;

  case 1040:
#line 7167 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 43943 "preproc.c"
    break;

  case 1041:
#line 7171 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 43951 "preproc.c"
    break;

  case 1042:
#line 7175 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 43959 "preproc.c"
    break;

  case 1043:
#line 7179 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search template");
}
#line 43967 "preproc.c"
    break;

  case 1044:
#line 7183 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 43975 "preproc.c"
    break;

  case 1045:
#line 7187 "preproc.y"
 { 
 (yyval.str) = mm_strdup("protocol");
}
#line 43983 "preproc.c"
    break;

  case 1046:
#line 7195 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 43991 "preproc.c"
    break;

  case 1047:
#line 7199 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 43999 "preproc.c"
    break;

  case 1048:
#line 7207 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44007 "preproc.c"
    break;

  case 1049:
#line 7211 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44015 "preproc.c"
    break;

  case 1050:
#line 7219 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 44023 "preproc.c"
    break;

  case 1051:
#line 7223 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 44031 "preproc.c"
    break;

  case 1052:
#line 7231 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("truncate"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44039 "preproc.c"
    break;

  case 1053:
#line 7239 "preproc.y"
 { 
 (yyval.str) = mm_strdup("continue identity");
}
#line 44047 "preproc.c"
    break;

  case 1054:
#line 7243 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart identity");
}
#line 44055 "preproc.c"
    break;

  case 1055:
#line 7247 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44062 "preproc.c"
    break;

  case 1056:
#line 7254 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44070 "preproc.c"
    break;

  case 1057:
#line 7258 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on aggregate"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44078 "preproc.c"
    break;

  case 1058:
#line 7262 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on function"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44086 "preproc.c"
    break;

  case 1059:
#line 7266 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("comment on operator"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44094 "preproc.c"
    break;

  case 1060:
#line 7270 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on constraint"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44102 "preproc.c"
    break;

  case 1061:
#line 7274 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on rule"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44110 "preproc.c"
    break;

  case 1062:
#line 7278 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on rule"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44118 "preproc.c"
    break;

  case 1063:
#line 7282 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on trigger"),(yyvsp[-4].str),mm_strdup("on"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44126 "preproc.c"
    break;

  case 1064:
#line 7286 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator class"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44134 "preproc.c"
    break;

  case 1065:
#line 7290 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on operator family"),(yyvsp[-4].str),mm_strdup("using"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44142 "preproc.c"
    break;

  case 1066:
#line 7294 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("comment on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44150 "preproc.c"
    break;

  case 1067:
#line 7298 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on cast ("),(yyvsp[-5].str),mm_strdup("as"),(yyvsp[-3].str),mm_strdup(") is"),(yyvsp[0].str));
}
#line 44158 "preproc.c"
    break;

  case 1068:
#line 7302 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("comment on"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44166 "preproc.c"
    break;

  case 1069:
#line 7310 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 44174 "preproc.c"
    break;

  case 1070:
#line 7314 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 44182 "preproc.c"
    break;

  case 1071:
#line 7318 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 44190 "preproc.c"
    break;

  case 1072:
#line 7322 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 44198 "preproc.c"
    break;

  case 1073:
#line 7326 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 44206 "preproc.c"
    break;

  case 1074:
#line 7330 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 44214 "preproc.c"
    break;

  case 1075:
#line 7334 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 44222 "preproc.c"
    break;

  case 1076:
#line 7338 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 44230 "preproc.c"
    break;

  case 1077:
#line 7342 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 44238 "preproc.c"
    break;

  case 1078:
#line 7346 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 44246 "preproc.c"
    break;

  case 1079:
#line 7350 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 44254 "preproc.c"
    break;

  case 1080:
#line 7354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 44262 "preproc.c"
    break;

  case 1081:
#line 7358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 44270 "preproc.c"
    break;

  case 1082:
#line 7362 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 44278 "preproc.c"
    break;

  case 1083:
#line 7366 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 44286 "preproc.c"
    break;

  case 1084:
#line 7370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 44294 "preproc.c"
    break;

  case 1085:
#line 7374 "preproc.y"
 { 
 (yyval.str) = mm_strdup("server");
}
#line 44302 "preproc.c"
    break;

  case 1086:
#line 7378 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign data wrapper");
}
#line 44310 "preproc.c"
    break;

  case 1087:
#line 7382 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 44318 "preproc.c"
    break;

  case 1088:
#line 7386 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search configuration");
}
#line 44326 "preproc.c"
    break;

  case 1089:
#line 7390 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search dictionary");
}
#line 44334 "preproc.c"
    break;

  case 1090:
#line 7394 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search parser");
}
#line 44342 "preproc.c"
    break;

  case 1091:
#line 7398 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text search template");
}
#line 44350 "preproc.c"
    break;

  case 1092:
#line 7402 "preproc.y"
 { 
 (yyval.str) = mm_strdup("resource queue");
}
#line 44358 "preproc.c"
    break;

  case 1093:
#line 7406 "preproc.y"
 { 
 (yyval.str) = mm_strdup("resource group");
}
#line 44366 "preproc.c"
    break;

  case 1094:
#line 7414 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44374 "preproc.c"
    break;

  case 1095:
#line 7418 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 44382 "preproc.c"
    break;

  case 1096:
#line 7426 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44390 "preproc.c"
    break;

  case 1097:
#line 7430 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on aggregate"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44398 "preproc.c"
    break;

  case 1098:
#line 7434 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on function"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44406 "preproc.c"
    break;

  case 1099:
#line 7438 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on large object"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44414 "preproc.c"
    break;

  case 1100:
#line 7442 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("security label"),(yyvsp[-6].str),mm_strdup("on"),(yyvsp[-4].str),mm_strdup("language"),(yyvsp[-2].str),mm_strdup("is"),(yyvsp[0].str));
}
#line 44422 "preproc.c"
    break;

  case 1101:
#line 7450 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 44430 "preproc.c"
    break;

  case 1102:
#line 7454 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44437 "preproc.c"
    break;

  case 1103:
#line 7461 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 44445 "preproc.c"
    break;

  case 1104:
#line 7465 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 44453 "preproc.c"
    break;

  case 1105:
#line 7469 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event trigger");
}
#line 44461 "preproc.c"
    break;

  case 1106:
#line 7473 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign table");
}
#line 44469 "preproc.c"
    break;

  case 1107:
#line 7477 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 44477 "preproc.c"
    break;

  case 1108:
#line 7481 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 44485 "preproc.c"
    break;

  case 1109:
#line 7485 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 44493 "preproc.c"
    break;

  case 1110:
#line 7489 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 44501 "preproc.c"
    break;

  case 1111:
#line 7493 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 44509 "preproc.c"
    break;

  case 1112:
#line 7497 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 44517 "preproc.c"
    break;

  case 1113:
#line 7501 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 44525 "preproc.c"
    break;

  case 1114:
#line 7505 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 44533 "preproc.c"
    break;

  case 1115:
#line 7509 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized view");
}
#line 44541 "preproc.c"
    break;

  case 1116:
#line 7517 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44549 "preproc.c"
    break;

  case 1117:
#line 7521 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 44557 "preproc.c"
    break;

  case 1118:
#line 7529 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("fetch"),(yyvsp[0].str));
}
#line 44565 "preproc.c"
    break;

  case 1119:
#line 7533 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("move"),(yyvsp[0].str));
}
#line 44573 "preproc.c"
    break;

  case 1120:
#line 7537 "preproc.y"
        {
		(yyval.str) = cat2_str(mm_strdup("fetch"), (yyvsp[-1].str));
	}
#line 44581 "preproc.c"
    break;

  case 1121:
#line 7541 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward"), cursor_marker);
	}
#line 44591 "preproc.c"
    break;

  case 1122:
#line 7547 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch forward from"), cursor_marker);
	}
#line 44601 "preproc.c"
    break;

  case 1123:
#line 7553 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward"), cursor_marker);
	}
#line 44611 "preproc.c"
    break;

  case 1124:
#line 7559 "preproc.y"
        {
		char *cursor_marker = (yyvsp[-1].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[-1].str);
		add_additional_variables((yyvsp[-1].str), false);
		(yyval.str) = cat_str(2, mm_strdup("fetch backward from"), cursor_marker);
	}
#line 44621 "preproc.c"
    break;

  case 1125:
#line 7565 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward"), cursor_marker);
	}
#line 44631 "preproc.c"
    break;

  case 1126:
#line 7571 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move forward from"), cursor_marker);
	}
#line 44641 "preproc.c"
    break;

  case 1127:
#line 7577 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward"), cursor_marker);
	}
#line 44651 "preproc.c"
    break;

  case 1128:
#line 7583 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		add_additional_variables((yyvsp[0].str), false);
		(yyval.str) = cat_str(2, mm_strdup("move backward from"), cursor_marker);
	}
#line 44661 "preproc.c"
    break;

  case 1129:
#line 7593 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = (yyvsp[0].str);
}
#line 44676 "preproc.c"
    break;

  case 1130:
#line 7604 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44691 "preproc.c"
    break;

  case 1131:
#line 7615 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("next"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44706 "preproc.c"
    break;

  case 1132:
#line 7626 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("prior"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44721 "preproc.c"
    break;

  case 1133:
#line 7637 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("first"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44736 "preproc.c"
    break;

  case 1134:
#line 7648 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("last"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44751 "preproc.c"
    break;

  case 1135:
#line 7659 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("absolute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44771 "preproc.c"
    break;

  case 1136:
#line 7675 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("relative"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44791 "preproc.c"
    break;

  case 1137:
#line 7691 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44811 "preproc.c"
    break;

  case 1138:
#line 7707 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44826 "preproc.c"
    break;

  case 1139:
#line 7718 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("forward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44846 "preproc.c"
    break;

  case 1140:
#line 7734 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("forward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44861 "preproc.c"
    break;

  case 1141:
#line 7745 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}
		if ((yyvsp[-2].str)[0] == '$')
		{
			free((yyvsp[-2].str));
			(yyvsp[-2].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(4,mm_strdup("backward"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44881 "preproc.c"
    break;

  case 1142:
#line 7761 "preproc.y"
 { 
		add_additional_variables((yyvsp[0].str), false);
		if ((yyvsp[0].str)[0] == ':')
		{
			free((yyvsp[0].str));
			(yyvsp[0].str) = mm_strdup("$0");
		}

 (yyval.str) = cat_str(3,mm_strdup("backward all"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44896 "preproc.c"
    break;

  case 1143:
#line 7776 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 44904 "preproc.c"
    break;

  case 1144:
#line 7780 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 44912 "preproc.c"
    break;

  case 1145:
#line 7788 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44920 "preproc.c"
    break;

  case 1146:
#line 7792 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 44927 "preproc.c"
    break;

  case 1147:
#line 7799 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44935 "preproc.c"
    break;

  case 1148:
#line 7807 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44943 "preproc.c"
    break;

  case 1149:
#line 7811 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 44951 "preproc.c"
    break;

  case 1150:
#line 7819 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44959 "preproc.c"
    break;

  case 1151:
#line 7823 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 44967 "preproc.c"
    break;

  case 1152:
#line 7827 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all privileges");
}
#line 44975 "preproc.c"
    break;

  case 1153:
#line 7831 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("all ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44983 "preproc.c"
    break;

  case 1154:
#line 7835 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("all privileges ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 44991 "preproc.c"
    break;

  case 1155:
#line 7843 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 44999 "preproc.c"
    break;

  case 1156:
#line 7847 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45007 "preproc.c"
    break;

  case 1157:
#line 7855 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("select"),(yyvsp[0].str));
}
#line 45015 "preproc.c"
    break;

  case 1158:
#line 7859 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("references"),(yyvsp[0].str));
}
#line 45023 "preproc.c"
    break;

  case 1159:
#line 7863 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("create"),(yyvsp[0].str));
}
#line 45031 "preproc.c"
    break;

  case 1160:
#line 7867 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45039 "preproc.c"
    break;

  case 1161:
#line 7875 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45047 "preproc.c"
    break;

  case 1162:
#line 7879 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 45055 "preproc.c"
    break;

  case 1163:
#line 7883 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("sequence"),(yyvsp[0].str));
}
#line 45063 "preproc.c"
    break;

  case 1164:
#line 7887 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("foreign data wrapper"),(yyvsp[0].str));
}
#line 45071 "preproc.c"
    break;

  case 1165:
#line 7891 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("foreign server"),(yyvsp[0].str));
}
#line 45079 "preproc.c"
    break;

  case 1166:
#line 7895 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("function"),(yyvsp[0].str));
}
#line 45087 "preproc.c"
    break;

  case 1167:
#line 7899 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("database"),(yyvsp[0].str));
}
#line 45095 "preproc.c"
    break;

  case 1168:
#line 7903 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("domain"),(yyvsp[0].str));
}
#line 45103 "preproc.c"
    break;

  case 1169:
#line 7907 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 45111 "preproc.c"
    break;

  case 1170:
#line 7911 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("large object"),(yyvsp[0].str));
}
#line 45119 "preproc.c"
    break;

  case 1171:
#line 7915 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("schema"),(yyvsp[0].str));
}
#line 45127 "preproc.c"
    break;

  case 1172:
#line 7919 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("tablespace"),(yyvsp[0].str));
}
#line 45135 "preproc.c"
    break;

  case 1173:
#line 7923 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("protocol"),(yyvsp[0].str));
}
#line 45143 "preproc.c"
    break;

  case 1174:
#line 7927 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("type"),(yyvsp[0].str));
}
#line 45151 "preproc.c"
    break;

  case 1175:
#line 7931 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all tables in schema"),(yyvsp[0].str));
}
#line 45159 "preproc.c"
    break;

  case 1176:
#line 7935 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all sequences in schema"),(yyvsp[0].str));
}
#line 45167 "preproc.c"
    break;

  case 1177:
#line 7939 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("all functions in schema"),(yyvsp[0].str));
}
#line 45175 "preproc.c"
    break;

  case 1178:
#line 7947 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45183 "preproc.c"
    break;

  case 1179:
#line 7951 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45191 "preproc.c"
    break;

  case 1180:
#line 7959 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45199 "preproc.c"
    break;

  case 1181:
#line 7963 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("group"),(yyvsp[0].str));
}
#line 45207 "preproc.c"
    break;

  case 1182:
#line 7971 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with grant option");
}
#line 45215 "preproc.c"
    break;

  case 1183:
#line 7975 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45222 "preproc.c"
    break;

  case 1184:
#line 7982 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45230 "preproc.c"
    break;

  case 1185:
#line 7986 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45238 "preproc.c"
    break;

  case 1186:
#line 7994 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45246 "preproc.c"
    break;

  case 1187:
#line 8002 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("grant"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45254 "preproc.c"
    break;

  case 1188:
#line 8010 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("revoke"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45262 "preproc.c"
    break;

  case 1189:
#line 8014 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("revoke admin option for"),(yyvsp[-4].str),mm_strdup("from"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45270 "preproc.c"
    break;

  case 1190:
#line 8022 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with admin option");
}
#line 45278 "preproc.c"
    break;

  case 1191:
#line 8026 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45285 "preproc.c"
    break;

  case 1192:
#line 8033 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("granted by"),(yyvsp[0].str));
}
#line 45293 "preproc.c"
    break;

  case 1193:
#line 8037 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45300 "preproc.c"
    break;

  case 1194:
#line 8044 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter default privileges"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45308 "preproc.c"
    break;

  case 1195:
#line 8052 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45316 "preproc.c"
    break;

  case 1196:
#line 8056 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45323 "preproc.c"
    break;

  case 1197:
#line 8063 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("in schema"),(yyvsp[0].str));
}
#line 45331 "preproc.c"
    break;

  case 1198:
#line 8067 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for role"),(yyvsp[0].str));
}
#line 45339 "preproc.c"
    break;

  case 1199:
#line 8071 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for user"),(yyvsp[0].str));
}
#line 45347 "preproc.c"
    break;

  case 1200:
#line 8079 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("grant"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45355 "preproc.c"
    break;

  case 1201:
#line 8083 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45363 "preproc.c"
    break;

  case 1202:
#line 8087 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("revoke grant option for"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("from"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45371 "preproc.c"
    break;

  case 1203:
#line 8095 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tables");
}
#line 45379 "preproc.c"
    break;

  case 1204:
#line 8099 "preproc.y"
 { 
 (yyval.str) = mm_strdup("functions");
}
#line 45387 "preproc.c"
    break;

  case 1205:
#line 8103 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequences");
}
#line 45395 "preproc.c"
    break;

  case 1206:
#line 8107 "preproc.y"
 { 
 (yyval.str) = mm_strdup("types");
}
#line 45403 "preproc.c"
    break;

  case 1207:
#line 8115 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(14,mm_strdup("create"),(yyvsp[-12].str),mm_strdup("index"),(yyvsp[-10].str),(yyvsp[-9].str),mm_strdup("on"),(yyvsp[-7].str),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup(")"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45412 "preproc.c"
    break;

  case 1208:
#line 8124 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unique");
}
#line 45420 "preproc.c"
    break;

  case 1209:
#line 8128 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45427 "preproc.c"
    break;

  case 1210:
#line 8135 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 45435 "preproc.c"
    break;

  case 1211:
#line 8139 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45442 "preproc.c"
    break;

  case 1212:
#line 8146 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45450 "preproc.c"
    break;

  case 1213:
#line 8150 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45457 "preproc.c"
    break;

  case 1214:
#line 8157 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 45465 "preproc.c"
    break;

  case 1215:
#line 8161 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45472 "preproc.c"
    break;

  case 1216:
#line 8168 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45480 "preproc.c"
    break;

  case 1217:
#line 8172 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45488 "preproc.c"
    break;

  case 1218:
#line 8180 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45496 "preproc.c"
    break;

  case 1219:
#line 8184 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45504 "preproc.c"
    break;

  case 1220:
#line 8188 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45512 "preproc.c"
    break;

  case 1221:
#line 8196 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("collate"),(yyvsp[0].str));
}
#line 45520 "preproc.c"
    break;

  case 1222:
#line 8200 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45527 "preproc.c"
    break;

  case 1223:
#line 8207 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45535 "preproc.c"
    break;

  case 1224:
#line 8211 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 45543 "preproc.c"
    break;

  case 1225:
#line 8215 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45550 "preproc.c"
    break;

  case 1226:
#line 8222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asc");
}
#line 45558 "preproc.c"
    break;

  case 1227:
#line 8226 "preproc.y"
 { 
 (yyval.str) = mm_strdup("desc");
}
#line 45566 "preproc.c"
    break;

  case 1228:
#line 8230 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45573 "preproc.c"
    break;

  case 1229:
#line 8237 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls first");
}
#line 45581 "preproc.c"
    break;

  case 1230:
#line 8241 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls last");
}
#line 45589 "preproc.c"
    break;

  case 1231:
#line 8245 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45596 "preproc.c"
    break;

  case 1232:
#line 8252 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("function"),(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("returns"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45604 "preproc.c"
    break;

  case 1233:
#line 8256 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("function"),(yyvsp[-8].str),(yyvsp[-7].str),mm_strdup("returns table ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45612 "preproc.c"
    break;

  case 1234:
#line 8260 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create"),(yyvsp[-5].str),mm_strdup("function"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45620 "preproc.c"
    break;

  case 1235:
#line 8268 "preproc.y"
 { 
 (yyval.str) = mm_strdup("or replace");
}
#line 45628 "preproc.c"
    break;

  case 1236:
#line 8272 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 45635 "preproc.c"
    break;

  case 1237:
#line 8279 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45643 "preproc.c"
    break;

  case 1238:
#line 8283 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 45651 "preproc.c"
    break;

  case 1239:
#line 8291 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45659 "preproc.c"
    break;

  case 1240:
#line 8295 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45667 "preproc.c"
    break;

  case 1241:
#line 8303 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45675 "preproc.c"
    break;

  case 1242:
#line 8307 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 45683 "preproc.c"
    break;

  case 1243:
#line 8315 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45691 "preproc.c"
    break;

  case 1244:
#line 8319 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45699 "preproc.c"
    break;

  case 1245:
#line 8327 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45707 "preproc.c"
    break;

  case 1246:
#line 8331 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45715 "preproc.c"
    break;

  case 1247:
#line 8335 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45723 "preproc.c"
    break;

  case 1248:
#line 8339 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45731 "preproc.c"
    break;

  case 1249:
#line 8343 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45739 "preproc.c"
    break;

  case 1250:
#line 8351 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 45747 "preproc.c"
    break;

  case 1251:
#line 8355 "preproc.y"
 { 
 (yyval.str) = mm_strdup("out");
}
#line 45755 "preproc.c"
    break;

  case 1252:
#line 8359 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inout");
}
#line 45763 "preproc.c"
    break;

  case 1253:
#line 8363 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in out");
}
#line 45771 "preproc.c"
    break;

  case 1254:
#line 8367 "preproc.y"
 { 
 (yyval.str) = mm_strdup("variadic");
}
#line 45779 "preproc.c"
    break;

  case 1255:
#line 8375 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45787 "preproc.c"
    break;

  case 1256:
#line 8383 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45795 "preproc.c"
    break;

  case 1257:
#line 8391 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45803 "preproc.c"
    break;

  case 1258:
#line 8395 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 45811 "preproc.c"
    break;

  case 1259:
#line 8399 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("setof"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("% type"));
}
#line 45819 "preproc.c"
    break;

  case 1260:
#line 8407 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45827 "preproc.c"
    break;

  case 1261:
#line 8411 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("default"),(yyvsp[0].str));
}
#line 45835 "preproc.c"
    break;

  case 1262:
#line 8415 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 45843 "preproc.c"
    break;

  case 1263:
#line 8423 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = (yyvsp[0].str);
}
#line 45852 "preproc.c"
    break;

  case 1264:
#line 8432 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( * )");
}
#line 45860 "preproc.c"
    break;

  case 1265:
#line 8436 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45868 "preproc.c"
    break;

  case 1266:
#line 8440 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("( order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45876 "preproc.c"
    break;

  case 1267:
#line 8444 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-4].str),mm_strdup("order by"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 45884 "preproc.c"
    break;

  case 1268:
#line 8452 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45892 "preproc.c"
    break;

  case 1269:
#line 8456 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 45900 "preproc.c"
    break;

  case 1270:
#line 8464 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 45908 "preproc.c"
    break;

  case 1271:
#line 8468 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 45916 "preproc.c"
    break;

  case 1272:
#line 8476 "preproc.y"
 { 
 (yyval.str) = mm_strdup("called on null input");
}
#line 45924 "preproc.c"
    break;

  case 1273:
#line 8480 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returns null on null input");
}
#line 45932 "preproc.c"
    break;

  case 1274:
#line 8484 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strict");
}
#line 45940 "preproc.c"
    break;

  case 1275:
#line 8488 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immutable");
}
#line 45948 "preproc.c"
    break;

  case 1276:
#line 8492 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stable");
}
#line 45956 "preproc.c"
    break;

  case 1277:
#line 8496 "preproc.y"
 { 
 (yyval.str) = mm_strdup("volatile");
}
#line 45964 "preproc.c"
    break;

  case 1278:
#line 8500 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external security definer");
}
#line 45972 "preproc.c"
    break;

  case 1279:
#line 8504 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external security invoker");
}
#line 45980 "preproc.c"
    break;

  case 1280:
#line 8508 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security definer");
}
#line 45988 "preproc.c"
    break;

  case 1281:
#line 8512 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security invoker");
}
#line 45996 "preproc.c"
    break;

  case 1282:
#line 8516 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 46004 "preproc.c"
    break;

  case 1283:
#line 8520 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not leakproof");
}
#line 46012 "preproc.c"
    break;

  case 1284:
#line 8524 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cost"),(yyvsp[0].str));
}
#line 46020 "preproc.c"
    break;

  case 1285:
#line 8528 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rows"),(yyvsp[0].str));
}
#line 46028 "preproc.c"
    break;

  case 1286:
#line 8532 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46036 "preproc.c"
    break;

  case 1287:
#line 8536 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no sql");
}
#line 46044 "preproc.c"
    break;

  case 1288:
#line 8540 "preproc.y"
 { 
 (yyval.str) = mm_strdup("contains sql");
}
#line 46052 "preproc.c"
    break;

  case 1289:
#line 8544 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reads sql data");
}
#line 46060 "preproc.c"
    break;

  case 1290:
#line 8548 "preproc.y"
 { 
 (yyval.str) = mm_strdup("modifies sql data");
}
#line 46068 "preproc.c"
    break;

  case 1291:
#line 8552 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute on any");
}
#line 46076 "preproc.c"
    break;

  case 1292:
#line 8556 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute on master");
}
#line 46084 "preproc.c"
    break;

  case 1293:
#line 8560 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute on initplan");
}
#line 46092 "preproc.c"
    break;

  case 1294:
#line 8564 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute on all segments");
}
#line 46100 "preproc.c"
    break;

  case 1295:
#line 8572 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 46108 "preproc.c"
    break;

  case 1296:
#line 8576 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 46116 "preproc.c"
    break;

  case 1297:
#line 8580 "preproc.y"
 { 
 (yyval.str) = mm_strdup("window");
}
#line 46124 "preproc.c"
    break;

  case 1298:
#line 8584 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46132 "preproc.c"
    break;

  case 1299:
#line 8592 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46140 "preproc.c"
    break;

  case 1300:
#line 8596 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46148 "preproc.c"
    break;

  case 1301:
#line 8604 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 46156 "preproc.c"
    break;

  case 1302:
#line 8608 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46163 "preproc.c"
    break;

  case 1303:
#line 8615 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46171 "preproc.c"
    break;

  case 1304:
#line 8623 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46179 "preproc.c"
    break;

  case 1305:
#line 8627 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 46187 "preproc.c"
    break;

  case 1306:
#line 8635 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46195 "preproc.c"
    break;

  case 1307:
#line 8643 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46203 "preproc.c"
    break;

  case 1308:
#line 8647 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46211 "preproc.c"
    break;

  case 1309:
#line 8655 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 46219 "preproc.c"
    break;

  case 1310:
#line 8659 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46226 "preproc.c"
    break;

  case 1311:
#line 8666 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop function"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46234 "preproc.c"
    break;

  case 1312:
#line 8670 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop function if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46242 "preproc.c"
    break;

  case 1313:
#line 8678 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop aggregate"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46250 "preproc.c"
    break;

  case 1314:
#line 8682 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop aggregate if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46258 "preproc.c"
    break;

  case 1315:
#line 8690 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop operator"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46266 "preproc.c"
    break;

  case 1316:
#line 8694 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("drop operator if exists"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46274 "preproc.c"
    break;

  case 1317:
#line 8702 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46282 "preproc.c"
    break;

  case 1318:
#line 8706 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46290 "preproc.c"
    break;

  case 1319:
#line 8710 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("( none ,"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 46298 "preproc.c"
    break;

  case 1320:
#line 8714 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-3].str),mm_strdup(", none )"));
}
#line 46306 "preproc.c"
    break;

  case 1321:
#line 8722 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46314 "preproc.c"
    break;

  case 1322:
#line 8726 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("."),(yyvsp[0].str));
}
#line 46322 "preproc.c"
    break;

  case 1323:
#line 8734 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("do"),(yyvsp[0].str));
}
#line 46330 "preproc.c"
    break;

  case 1324:
#line 8742 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46338 "preproc.c"
    break;

  case 1325:
#line 8746 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46346 "preproc.c"
    break;

  case 1326:
#line 8754 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 46354 "preproc.c"
    break;

  case 1327:
#line 8758 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("language"),(yyvsp[0].str));
}
#line 46362 "preproc.c"
    break;

  case 1328:
#line 8766 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("create cast ("),(yyvsp[-7].str),mm_strdup("as"),(yyvsp[-5].str),mm_strdup(") with function"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46370 "preproc.c"
    break;

  case 1329:
#line 8770 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") without function"),(yyvsp[0].str));
}
#line 46378 "preproc.c"
    break;

  case 1330:
#line 8774 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("create cast ("),(yyvsp[-6].str),mm_strdup("as"),(yyvsp[-4].str),mm_strdup(") with inout"),(yyvsp[0].str));
}
#line 46386 "preproc.c"
    break;

  case 1331:
#line 8782 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as implicit");
}
#line 46394 "preproc.c"
    break;

  case 1332:
#line 8786 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as assignment");
}
#line 46402 "preproc.c"
    break;

  case 1333:
#line 8790 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46409 "preproc.c"
    break;

  case 1334:
#line 8797 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("drop cast"),(yyvsp[-6].str),mm_strdup("("),(yyvsp[-4].str),mm_strdup("as"),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 46417 "preproc.c"
    break;

  case 1335:
#line 8805 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if exists");
}
#line 46425 "preproc.c"
    break;

  case 1336:
#line 8809 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46432 "preproc.c"
    break;

  case 1337:
#line 8816 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("reindex"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46440 "preproc.c"
    break;

  case 1338:
#line 8820 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("reindex system"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46448 "preproc.c"
    break;

  case 1339:
#line 8824 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("reindex database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46456 "preproc.c"
    break;

  case 1340:
#line 8832 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 46464 "preproc.c"
    break;

  case 1341:
#line 8836 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 46472 "preproc.c"
    break;

  case 1342:
#line 8844 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force");
}
#line 46480 "preproc.c"
    break;

  case 1343:
#line 8848 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46487 "preproc.c"
    break;

  case 1344:
#line 8855 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-4].str),mm_strdup("set default encoding"),(yyvsp[0].str));
}
#line 46495 "preproc.c"
    break;

  case 1345:
#line 8863 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("set"),(yyvsp[0].str));
}
#line 46503 "preproc.c"
    break;

  case 1346:
#line 8867 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-2].str),mm_strdup("reset"),(yyvsp[0].str));
}
#line 46511 "preproc.c"
    break;

  case 1347:
#line 8875 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46519 "preproc.c"
    break;

  case 1348:
#line 8879 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46527 "preproc.c"
    break;

  case 1349:
#line 8883 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46535 "preproc.c"
    break;

  case 1350:
#line 8887 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46543 "preproc.c"
    break;

  case 1351:
#line 8891 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46551 "preproc.c"
    break;

  case 1352:
#line 8895 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter domain"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46559 "preproc.c"
    break;

  case 1353:
#line 8899 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46567 "preproc.c"
    break;

  case 1354:
#line 8903 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46575 "preproc.c"
    break;

  case 1355:
#line 8907 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter group"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46583 "preproc.c"
    break;

  case 1356:
#line 8911 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46591 "preproc.c"
    break;

  case 1357:
#line 8915 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46599 "preproc.c"
    break;

  case 1358:
#line 8919 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46607 "preproc.c"
    break;

  case 1359:
#line 8923 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46615 "preproc.c"
    break;

  case 1360:
#line 8927 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46623 "preproc.c"
    break;

  case 1361:
#line 8931 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46631 "preproc.c"
    break;

  case 1362:
#line 8935 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46639 "preproc.c"
    break;

  case 1363:
#line 8939 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46647 "preproc.c"
    break;

  case 1364:
#line 8943 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46655 "preproc.c"
    break;

  case 1365:
#line 8947 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46663 "preproc.c"
    break;

  case 1366:
#line 8951 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46671 "preproc.c"
    break;

  case 1367:
#line 8955 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46679 "preproc.c"
    break;

  case 1368:
#line 8959 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46687 "preproc.c"
    break;

  case 1369:
#line 8963 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter index"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46695 "preproc.c"
    break;

  case 1370:
#line 8967 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter index if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46703 "preproc.c"
    break;

  case 1371:
#line 8971 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46711 "preproc.c"
    break;

  case 1372:
#line 8975 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46719 "preproc.c"
    break;

  case 1373:
#line 8979 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46727 "preproc.c"
    break;

  case 1374:
#line 8983 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46735 "preproc.c"
    break;

  case 1375:
#line 8987 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46743 "preproc.c"
    break;

  case 1376:
#line 8991 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter materialized view if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46751 "preproc.c"
    break;

  case 1377:
#line 8995 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter table"),(yyvsp[-5].str),mm_strdup("rename constraint"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46759 "preproc.c"
    break;

  case 1378:
#line 8999 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46767 "preproc.c"
    break;

  case 1379:
#line 9003 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter foreign table if exists"),(yyvsp[-5].str),mm_strdup("rename"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 46775 "preproc.c"
    break;

  case 1380:
#line 9007 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter rule"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46783 "preproc.c"
    break;

  case 1381:
#line 9011 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter trigger"),(yyvsp[-5].str),mm_strdup("on"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46791 "preproc.c"
    break;

  case 1382:
#line 9015 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46799 "preproc.c"
    break;

  case 1383:
#line 9019 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter role"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46807 "preproc.c"
    break;

  case 1384:
#line 9023 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter user"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46815 "preproc.c"
    break;

  case 1385:
#line 9027 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46823 "preproc.c"
    break;

  case 1386:
#line 9031 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46831 "preproc.c"
    break;

  case 1387:
#line 9035 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46839 "preproc.c"
    break;

  case 1388:
#line 9039 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46847 "preproc.c"
    break;

  case 1389:
#line 9043 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46855 "preproc.c"
    break;

  case 1390:
#line 9047 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46863 "preproc.c"
    break;

  case 1391:
#line 9051 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("alter type"),(yyvsp[-6].str),mm_strdup("rename attribute"),(yyvsp[-3].str),mm_strdup("to"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 46871 "preproc.c"
    break;

  case 1392:
#line 9055 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter protocol"),(yyvsp[-3].str),mm_strdup("rename to"),(yyvsp[0].str));
}
#line 46879 "preproc.c"
    break;

  case 1393:
#line 9063 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 46887 "preproc.c"
    break;

  case 1394:
#line 9067 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46894 "preproc.c"
    break;

  case 1395:
#line 9074 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set data");
}
#line 46902 "preproc.c"
    break;

  case 1396:
#line 9078 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 46909 "preproc.c"
    break;

  case 1397:
#line 9085 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46917 "preproc.c"
    break;

  case 1398:
#line 9089 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46925 "preproc.c"
    break;

  case 1399:
#line 9093 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46933 "preproc.c"
    break;

  case 1400:
#line 9097 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46941 "preproc.c"
    break;

  case 1401:
#line 9101 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter extension"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46949 "preproc.c"
    break;

  case 1402:
#line 9105 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46957 "preproc.c"
    break;

  case 1403:
#line 9109 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46965 "preproc.c"
    break;

  case 1404:
#line 9113 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46973 "preproc.c"
    break;

  case 1405:
#line 9117 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46981 "preproc.c"
    break;

  case 1406:
#line 9121 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46989 "preproc.c"
    break;

  case 1407:
#line 9125 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 46997 "preproc.c"
    break;

  case 1408:
#line 9129 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search parser"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47005 "preproc.c"
    break;

  case 1409:
#line 9133 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47013 "preproc.c"
    break;

  case 1410:
#line 9137 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search template"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47021 "preproc.c"
    break;

  case 1411:
#line 9141 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47029 "preproc.c"
    break;

  case 1412:
#line 9145 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47037 "preproc.c"
    break;

  case 1413:
#line 9149 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter sequence if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47045 "preproc.c"
    break;

  case 1414:
#line 9153 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47053 "preproc.c"
    break;

  case 1415:
#line 9157 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47061 "preproc.c"
    break;

  case 1416:
#line 9161 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47069 "preproc.c"
    break;

  case 1417:
#line 9165 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter materialized view if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47077 "preproc.c"
    break;

  case 1418:
#line 9169 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47085 "preproc.c"
    break;

  case 1419:
#line 9173 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign table if exists"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47093 "preproc.c"
    break;

  case 1420:
#line 9177 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("set schema"),(yyvsp[0].str));
}
#line 47101 "preproc.c"
    break;

  case 1421:
#line 9185 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter aggregate"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47109 "preproc.c"
    break;

  case 1422:
#line 9189 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter collation"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47117 "preproc.c"
    break;

  case 1423:
#line 9193 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter conversion"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47125 "preproc.c"
    break;

  case 1424:
#line 9197 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47133 "preproc.c"
    break;

  case 1425:
#line 9201 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47141 "preproc.c"
    break;

  case 1426:
#line 9205 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter function"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47149 "preproc.c"
    break;

  case 1427:
#line 9209 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter"),(yyvsp[-5].str),mm_strdup("language"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47157 "preproc.c"
    break;

  case 1428:
#line 9213 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter large object"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47165 "preproc.c"
    break;

  case 1429:
#line 9217 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter operator"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47173 "preproc.c"
    break;

  case 1430:
#line 9221 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator class"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47181 "preproc.c"
    break;

  case 1431:
#line 9225 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter operator family"),(yyvsp[-5].str),mm_strdup("using"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47189 "preproc.c"
    break;

  case 1432:
#line 9229 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter schema"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47197 "preproc.c"
    break;

  case 1433:
#line 9233 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter type"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47205 "preproc.c"
    break;

  case 1434:
#line 9237 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter tablespace"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47213 "preproc.c"
    break;

  case 1435:
#line 9241 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter protocol"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47221 "preproc.c"
    break;

  case 1436:
#line 9245 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search dictionary"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47229 "preproc.c"
    break;

  case 1437:
#line 9249 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47237 "preproc.c"
    break;

  case 1438:
#line 9253 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter foreign data wrapper"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47245 "preproc.c"
    break;

  case 1439:
#line 9257 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter server"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47253 "preproc.c"
    break;

  case 1440:
#line 9261 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter event trigger"),(yyvsp[-3].str),mm_strdup("owner to"),(yyvsp[0].str));
}
#line 47261 "preproc.c"
    break;

  case 1441:
#line 9269 "preproc.y"
 { 
 (yyval.str) = cat_str(12,mm_strdup("create"),(yyvsp[-11].str),mm_strdup("rule"),(yyvsp[-9].str),mm_strdup("as on"),(yyvsp[-6].str),mm_strdup("to"),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("do"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47269 "preproc.c"
    break;

  case 1442:
#line 9277 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 47277 "preproc.c"
    break;

  case 1443:
#line 9281 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47285 "preproc.c"
    break;

  case 1444:
#line 9285 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 47293 "preproc.c"
    break;

  case 1445:
#line 9293 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(";"),(yyvsp[0].str));
}
#line 47301 "preproc.c"
    break;

  case 1446:
#line 9297 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47309 "preproc.c"
    break;

  case 1447:
#line 9305 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47317 "preproc.c"
    break;

  case 1448:
#line 9309 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47325 "preproc.c"
    break;

  case 1449:
#line 9313 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47333 "preproc.c"
    break;

  case 1450:
#line 9317 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47341 "preproc.c"
    break;

  case 1451:
#line 9321 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47349 "preproc.c"
    break;

  case 1452:
#line 9329 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47357 "preproc.c"
    break;

  case 1453:
#line 9333 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47364 "preproc.c"
    break;

  case 1454:
#line 9340 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 47372 "preproc.c"
    break;

  case 1455:
#line 9344 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 47380 "preproc.c"
    break;

  case 1456:
#line 9348 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 47388 "preproc.c"
    break;

  case 1457:
#line 9352 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 47396 "preproc.c"
    break;

  case 1458:
#line 9360 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead");
}
#line 47404 "preproc.c"
    break;

  case 1459:
#line 9364 "preproc.y"
 { 
 (yyval.str) = mm_strdup("also");
}
#line 47412 "preproc.c"
    break;

  case 1460:
#line 9368 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47419 "preproc.c"
    break;

  case 1461:
#line 9375 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop rule"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47427 "preproc.c"
    break;

  case 1462:
#line 9379 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("drop rule if exists"),(yyvsp[-3].str),mm_strdup("on"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47435 "preproc.c"
    break;

  case 1463:
#line 9387 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("notify"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47443 "preproc.c"
    break;

  case 1464:
#line 9395 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup(","),(yyvsp[0].str));
}
#line 47451 "preproc.c"
    break;

  case 1465:
#line 9399 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47458 "preproc.c"
    break;

  case 1466:
#line 9406 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("listen"),(yyvsp[0].str));
}
#line 47466 "preproc.c"
    break;

  case 1467:
#line 9414 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("unlisten"),(yyvsp[0].str));
}
#line 47474 "preproc.c"
    break;

  case 1468:
#line 9418 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlisten *");
}
#line 47482 "preproc.c"
    break;

  case 1469:
#line 9426 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("abort"),(yyvsp[0].str));
}
#line 47490 "preproc.c"
    break;

  case 1470:
#line 9430 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("begin"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47498 "preproc.c"
    break;

  case 1471:
#line 9434 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("start transaction"),(yyvsp[0].str));
}
#line 47506 "preproc.c"
    break;

  case 1472:
#line 9438 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("commit"),(yyvsp[0].str));
}
#line 47514 "preproc.c"
    break;

  case 1473:
#line 9442 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("end"),(yyvsp[0].str));
}
#line 47522 "preproc.c"
    break;

  case 1474:
#line 9446 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rollback"),(yyvsp[0].str));
}
#line 47530 "preproc.c"
    break;

  case 1475:
#line 9450 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("savepoint"),(yyvsp[0].str));
}
#line 47538 "preproc.c"
    break;

  case 1476:
#line 9454 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("release savepoint"),(yyvsp[0].str));
}
#line 47546 "preproc.c"
    break;

  case 1477:
#line 9458 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("release"),(yyvsp[0].str));
}
#line 47554 "preproc.c"
    break;

  case 1478:
#line 9462 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-3].str),mm_strdup("to savepoint"),(yyvsp[0].str));
}
#line 47562 "preproc.c"
    break;

  case 1479:
#line 9466 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rollback"),(yyvsp[-2].str),mm_strdup("to"),(yyvsp[0].str));
}
#line 47570 "preproc.c"
    break;

  case 1480:
#line 9470 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("prepare transaction"),(yyvsp[0].str));
}
#line 47578 "preproc.c"
    break;

  case 1481:
#line 9474 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("commit prepared"),(yyvsp[0].str));
}
#line 47586 "preproc.c"
    break;

  case 1482:
#line 9478 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("rollback prepared"),(yyvsp[0].str));
}
#line 47594 "preproc.c"
    break;

  case 1483:
#line 9486 "preproc.y"
 { 
 (yyval.str) = mm_strdup("work");
}
#line 47602 "preproc.c"
    break;

  case 1484:
#line 9490 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction");
}
#line 47610 "preproc.c"
    break;

  case 1485:
#line 9494 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47617 "preproc.c"
    break;

  case 1486:
#line 9501 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("isolation level"),(yyvsp[0].str));
}
#line 47625 "preproc.c"
    break;

  case 1487:
#line 9505 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read only");
}
#line 47633 "preproc.c"
    break;

  case 1488:
#line 9509 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read write");
}
#line 47641 "preproc.c"
    break;

  case 1489:
#line 9513 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 47649 "preproc.c"
    break;

  case 1490:
#line 9517 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not deferrable");
}
#line 47657 "preproc.c"
    break;

  case 1491:
#line 9525 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47665 "preproc.c"
    break;

  case 1492:
#line 9529 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 47673 "preproc.c"
    break;

  case 1493:
#line 9533 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47681 "preproc.c"
    break;

  case 1494:
#line 9541 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 47689 "preproc.c"
    break;

  case 1495:
#line 9545 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47696 "preproc.c"
    break;

  case 1496:
#line 9552 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47704 "preproc.c"
    break;

  case 1497:
#line 9556 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("create or replace"),(yyvsp[-7].str),mm_strdup("view"),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47712 "preproc.c"
    break;

  case 1498:
#line 9560 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47721 "preproc.c"
    break;

  case 1499:
#line 9565 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(11,mm_strdup("create or replace"),(yyvsp[-10].str),mm_strdup("recursive view"),(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(")"),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47730 "preproc.c"
    break;

  case 1500:
#line 9574 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with check option");
}
#line 47738 "preproc.c"
    break;

  case 1501:
#line 9578 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with cascaded check option");
}
#line 47746 "preproc.c"
    break;

  case 1502:
#line 9582 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with local check option");
}
#line 47754 "preproc.c"
    break;

  case 1503:
#line 9586 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47761 "preproc.c"
    break;

  case 1504:
#line 9593 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("load"),(yyvsp[0].str));
}
#line 47769 "preproc.c"
    break;

  case 1505:
#line 9601 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("create database"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47777 "preproc.c"
    break;

  case 1506:
#line 9609 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47785 "preproc.c"
    break;

  case 1507:
#line 9613 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47792 "preproc.c"
    break;

  case 1508:
#line 9620 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("tablespace"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47800 "preproc.c"
    break;

  case 1509:
#line 9624 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("tablespace"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47808 "preproc.c"
    break;

  case 1510:
#line 9628 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("location"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47816 "preproc.c"
    break;

  case 1511:
#line 9632 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("location"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47824 "preproc.c"
    break;

  case 1512:
#line 9636 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("template"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47832 "preproc.c"
    break;

  case 1513:
#line 9640 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("template"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47840 "preproc.c"
    break;

  case 1514:
#line 9644 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("encoding"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47848 "preproc.c"
    break;

  case 1515:
#line 9648 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("encoding"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47856 "preproc.c"
    break;

  case 1516:
#line 9652 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("encoding"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47864 "preproc.c"
    break;

  case 1517:
#line 9656 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lc_collate"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47872 "preproc.c"
    break;

  case 1518:
#line 9660 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lc_collate"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47880 "preproc.c"
    break;

  case 1519:
#line 9664 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lc_ctype"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47888 "preproc.c"
    break;

  case 1520:
#line 9668 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lc_ctype"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47896 "preproc.c"
    break;

  case 1521:
#line 9672 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("connection limit"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47904 "preproc.c"
    break;

  case 1522:
#line 9676 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("owner"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47912 "preproc.c"
    break;

  case 1523:
#line 9680 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("owner"),(yyvsp[-1].str),mm_strdup("default"));
}
#line 47920 "preproc.c"
    break;

  case 1524:
#line 9688 "preproc.y"
 { 
 (yyval.str) = mm_strdup("=");
}
#line 47928 "preproc.c"
    break;

  case 1525:
#line 9692 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47935 "preproc.c"
    break;

  case 1526:
#line 9699 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47943 "preproc.c"
    break;

  case 1527:
#line 9703 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter database"),(yyvsp[-3].str),mm_strdup("set tablespace"),(yyvsp[0].str));
}
#line 47951 "preproc.c"
    break;

  case 1528:
#line 9711 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter database"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47959 "preproc.c"
    break;

  case 1529:
#line 9719 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47967 "preproc.c"
    break;

  case 1530:
#line 9723 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 47974 "preproc.c"
    break;

  case 1531:
#line 9730 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("connection limit"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 47982 "preproc.c"
    break;

  case 1532:
#line 9738 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database"),(yyvsp[0].str));
}
#line 47990 "preproc.c"
    break;

  case 1533:
#line 9742 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("drop database if exists"),(yyvsp[0].str));
}
#line 47998 "preproc.c"
    break;

  case 1534:
#line 9750 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("alter system set"),(yyvsp[0].str));
}
#line 48006 "preproc.c"
    break;

  case 1535:
#line 9754 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("alter system reset"),(yyvsp[0].str));
}
#line 48014 "preproc.c"
    break;

  case 1536:
#line 9762 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("create domain"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48022 "preproc.c"
    break;

  case 1537:
#line 9770 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48030 "preproc.c"
    break;

  case 1538:
#line 9774 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("drop not null"));
}
#line 48038 "preproc.c"
    break;

  case 1539:
#line 9778 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("set not null"));
}
#line 48046 "preproc.c"
    break;

  case 1540:
#line 9782 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-2].str),mm_strdup("add"),(yyvsp[0].str));
}
#line 48054 "preproc.c"
    break;

  case 1541:
#line 9786 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-4].str),mm_strdup("drop constraint"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48062 "preproc.c"
    break;

  case 1542:
#line 9790 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("alter domain"),(yyvsp[-6].str),mm_strdup("drop constraint if exists"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48070 "preproc.c"
    break;

  case 1543:
#line 9794 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter domain"),(yyvsp[-3].str),mm_strdup("validate constraint"),(yyvsp[0].str));
}
#line 48078 "preproc.c"
    break;

  case 1544:
#line 9802 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as");
}
#line 48086 "preproc.c"
    break;

  case 1545:
#line 9806 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48093 "preproc.c"
    break;

  case 1546:
#line 9813 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("alter text search dictionary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48101 "preproc.c"
    break;

  case 1547:
#line 9821 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("add mapping for"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 48109 "preproc.c"
    break;

  case 1548:
#line 9825 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping for"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 48117 "preproc.c"
    break;

  case 1549:
#line 9829 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("alter mapping replace"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 48125 "preproc.c"
    break;

  case 1550:
#line 9833 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("alter text search configuration"),(yyvsp[-8].str),mm_strdup("alter mapping for"),(yyvsp[-4].str),mm_strdup("replace"),(yyvsp[-2].str),mm_strdup("with"),(yyvsp[0].str));
}
#line 48133 "preproc.c"
    break;

  case 1551:
#line 9837 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-4].str),mm_strdup("drop mapping for"),(yyvsp[0].str));
}
#line 48141 "preproc.c"
    break;

  case 1552:
#line 9841 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("alter text search configuration"),(yyvsp[-6].str),mm_strdup("drop mapping if exists for"),(yyvsp[0].str));
}
#line 48149 "preproc.c"
    break;

  case 1553:
#line 9849 "preproc.y"
 { 
 (yyval.str) = cat_str(10,mm_strdup("create"),(yyvsp[-8].str),mm_strdup("conversion"),(yyvsp[-6].str),mm_strdup("for"),(yyvsp[-4].str),mm_strdup("to"),(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 48157 "preproc.c"
    break;

  case 1554:
#line 9857 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("cluster"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48165 "preproc.c"
    break;

  case 1555:
#line 9861 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("cluster"),(yyvsp[0].str));
}
#line 48173 "preproc.c"
    break;

  case 1556:
#line 9865 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("cluster"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("on"),(yyvsp[0].str));
}
#line 48181 "preproc.c"
    break;

  case 1557:
#line 9873 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 48189 "preproc.c"
    break;

  case 1558:
#line 9877 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48196 "preproc.c"
    break;

  case 1559:
#line 9884 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("vacuum"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48204 "preproc.c"
    break;

  case 1560:
#line 9888 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48212 "preproc.c"
    break;

  case 1561:
#line 9892 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48220 "preproc.c"
    break;

  case 1562:
#line 9896 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("vacuum ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48228 "preproc.c"
    break;

  case 1563:
#line 9900 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("vacuum ("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48236 "preproc.c"
    break;

  case 1564:
#line 9908 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48244 "preproc.c"
    break;

  case 1565:
#line 9912 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48252 "preproc.c"
    break;

  case 1566:
#line 9920 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48260 "preproc.c"
    break;

  case 1567:
#line 9924 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 48268 "preproc.c"
    break;

  case 1568:
#line 9928 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 48276 "preproc.c"
    break;

  case 1569:
#line 9932 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 48284 "preproc.c"
    break;

  case 1570:
#line 9940 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48292 "preproc.c"
    break;

  case 1571:
#line 9944 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48300 "preproc.c"
    break;

  case 1572:
#line 9948 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("fullscan"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48308 "preproc.c"
    break;

  case 1573:
#line 9952 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("rootpartition"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48316 "preproc.c"
    break;

  case 1574:
#line 9960 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyze");
}
#line 48324 "preproc.c"
    break;

  case 1575:
#line 9964 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyse");
}
#line 48332 "preproc.c"
    break;

  case 1576:
#line 9972 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 48340 "preproc.c"
    break;

  case 1577:
#line 9976 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48347 "preproc.c"
    break;

  case 1578:
#line 9983 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rootpartition all");
}
#line 48355 "preproc.c"
    break;

  case 1579:
#line 9987 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48362 "preproc.c"
    break;

  case 1580:
#line 9994 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 48370 "preproc.c"
    break;

  case 1581:
#line 9998 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48377 "preproc.c"
    break;

  case 1582:
#line 10005 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 48385 "preproc.c"
    break;

  case 1583:
#line 10009 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48392 "preproc.c"
    break;

  case 1584:
#line 10016 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48400 "preproc.c"
    break;

  case 1585:
#line 10020 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48407 "preproc.c"
    break;

  case 1586:
#line 10027 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("explain"),(yyvsp[0].str));
}
#line 48415 "preproc.c"
    break;

  case 1587:
#line 10031 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("explain"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48423 "preproc.c"
    break;

  case 1588:
#line 10035 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("explain verbose"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48431 "preproc.c"
    break;

  case 1589:
#line 10039 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("explain ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 48439 "preproc.c"
    break;

  case 1590:
#line 10047 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48447 "preproc.c"
    break;

  case 1591:
#line 10051 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48455 "preproc.c"
    break;

  case 1592:
#line 10055 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48463 "preproc.c"
    break;

  case 1593:
#line 10059 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48471 "preproc.c"
    break;

  case 1594:
#line 10063 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48479 "preproc.c"
    break;

  case 1595:
#line 10067 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48487 "preproc.c"
    break;

  case 1596:
#line 10071 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48495 "preproc.c"
    break;

  case 1597:
#line 10075 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48503 "preproc.c"
    break;

  case 1598:
#line 10079 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48511 "preproc.c"
    break;

  case 1599:
#line 10083 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = (yyvsp[0].str);
}
#line 48520 "preproc.c"
    break;

  case 1600:
#line 10092 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dxl");
}
#line 48528 "preproc.c"
    break;

  case 1601:
#line 10096 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48535 "preproc.c"
    break;

  case 1602:
#line 10103 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48543 "preproc.c"
    break;

  case 1603:
#line 10107 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48551 "preproc.c"
    break;

  case 1604:
#line 10115 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48559 "preproc.c"
    break;

  case 1605:
#line 10123 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48567 "preproc.c"
    break;

  case 1606:
#line 10127 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48575 "preproc.c"
    break;

  case 1607:
#line 10135 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48583 "preproc.c"
    break;

  case 1608:
#line 10139 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48591 "preproc.c"
    break;

  case 1609:
#line 10143 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48598 "preproc.c"
    break;

  case 1610:
#line 10150 "preproc.y"
        {
		(yyval.prep).name = (yyvsp[-3].str);
		(yyval.prep).type = (yyvsp[-2].str);
		(yyval.prep).stmt = cat_str(3, mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
	}
#line 48608 "preproc.c"
    break;

  case 1611:
#line 10156 "preproc.y"
        {
		(yyval.prep).name = (yyvsp[-2].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[0].str);
	}
#line 48618 "preproc.c"
    break;

  case 1612:
#line 10166 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48626 "preproc.c"
    break;

  case 1613:
#line 10170 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48633 "preproc.c"
    break;

  case 1614:
#line 10177 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48641 "preproc.c"
    break;

  case 1615:
#line 10181 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48649 "preproc.c"
    break;

  case 1616:
#line 10185 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48657 "preproc.c"
    break;

  case 1617:
#line 10189 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48665 "preproc.c"
    break;

  case 1618:
#line 10197 "preproc.y"
        { (yyval.str) = (yyvsp[-2].str); }
#line 48671 "preproc.c"
    break;

  case 1619:
#line 10199 "preproc.y"
 { 
 (yyval.str) = cat_str(8,mm_strdup("create"),(yyvsp[-7].str),mm_strdup("table"),(yyvsp[-5].str),mm_strdup("as execute"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48679 "preproc.c"
    break;

  case 1620:
#line 10207 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 48687 "preproc.c"
    break;

  case 1621:
#line 10211 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48694 "preproc.c"
    break;

  case 1622:
#line 10218 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48702 "preproc.c"
    break;

  case 1623:
#line 10222 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48710 "preproc.c"
    break;

  case 1624:
#line 10230 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48718 "preproc.c"
    break;

  case 1625:
#line 10238 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("insert into"),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48726 "preproc.c"
    break;

  case 1626:
#line 10246 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48734 "preproc.c"
    break;

  case 1627:
#line 10250 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 48742 "preproc.c"
    break;

  case 1628:
#line 10254 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default values");
}
#line 48750 "preproc.c"
    break;

  case 1629:
#line 10262 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48758 "preproc.c"
    break;

  case 1630:
#line 10266 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48766 "preproc.c"
    break;

  case 1631:
#line 10274 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48774 "preproc.c"
    break;

  case 1632:
#line 10282 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("returning"),(yyvsp[-1].str));
}
#line 48782 "preproc.c"
    break;

  case 1633:
#line 10286 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48789 "preproc.c"
    break;

  case 1634:
#line 10293 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("delete from"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48797 "preproc.c"
    break;

  case 1635:
#line 10301 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("using"),(yyvsp[0].str));
}
#line 48805 "preproc.c"
    break;

  case 1636:
#line 10305 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48812 "preproc.c"
    break;

  case 1637:
#line 10312 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("lock"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48820 "preproc.c"
    break;

  case 1638:
#line 10320 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("in"),(yyvsp[-1].str),mm_strdup("mode"));
}
#line 48828 "preproc.c"
    break;

  case 1639:
#line 10324 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48835 "preproc.c"
    break;

  case 1640:
#line 10331 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access share");
}
#line 48843 "preproc.c"
    break;

  case 1641:
#line 10335 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row share");
}
#line 48851 "preproc.c"
    break;

  case 1642:
#line 10339 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row exclusive");
}
#line 48859 "preproc.c"
    break;

  case 1643:
#line 10343 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share update exclusive");
}
#line 48867 "preproc.c"
    break;

  case 1644:
#line 10347 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share");
}
#line 48875 "preproc.c"
    break;

  case 1645:
#line 10351 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share row exclusive");
}
#line 48883 "preproc.c"
    break;

  case 1646:
#line 10355 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 48891 "preproc.c"
    break;

  case 1647:
#line 10359 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access exclusive");
}
#line 48899 "preproc.c"
    break;

  case 1648:
#line 10367 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 48907 "preproc.c"
    break;

  case 1649:
#line 10371 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 48914 "preproc.c"
    break;

  case 1650:
#line 10378 "preproc.y"
 { 
 (yyval.str) = cat_str(8,(yyvsp[-7].str),mm_strdup("update"),(yyvsp[-5].str),mm_strdup("set"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48922 "preproc.c"
    break;

  case 1651:
#line 10386 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48930 "preproc.c"
    break;

  case 1652:
#line 10390 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48938 "preproc.c"
    break;

  case 1653:
#line 10398 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48946 "preproc.c"
    break;

  case 1654:
#line 10402 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48954 "preproc.c"
    break;

  case 1655:
#line 10410 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 48962 "preproc.c"
    break;

  case 1656:
#line 10418 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-3].str),mm_strdup(") ="),(yyvsp[0].str));
}
#line 48970 "preproc.c"
    break;

  case 1657:
#line 10426 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 48978 "preproc.c"
    break;

  case 1658:
#line 10434 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 48986 "preproc.c"
    break;

  case 1659:
#line 10438 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 48994 "preproc.c"
    break;

  case 1660:
#line 10446 "preproc.y"
        {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
		char *comment, *c1, *c2;
		int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
			{
				if ((yyvsp[-5].str)[0] == ':')
					mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
				else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[-5].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for"), (yyvsp[0].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, mm_strdup("/*"), c1, mm_strdup("*/"));

		if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
			(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
				mm_strdup("ECPG_informix_reset_sqlca();"),
				comment);
		else
			(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	}
#line 49047 "preproc.c"
    break;

  case 1661:
#line 10499 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49055 "preproc.c"
    break;

  case 1662:
#line 10503 "preproc.y"
                {
			char *curname = mm_alloc(strlen((yyvsp[0].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[0].str));
			free((yyvsp[0].str));
			(yyvsp[0].str) = curname;
			(yyval.str) = (yyvsp[0].str);
		}
#line 49067 "preproc.c"
    break;

  case 1663:
#line 10515 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49074 "preproc.c"
    break;

  case 1664:
#line 10518 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("no scroll"));
}
#line 49082 "preproc.c"
    break;

  case 1665:
#line 10522 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("scroll"));
}
#line 49090 "preproc.c"
    break;

  case 1666:
#line 10526 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("binary"));
}
#line 49098 "preproc.c"
    break;

  case 1667:
#line 10530 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("insensitive"));
}
#line 49106 "preproc.c"
    break;

  case 1668:
#line 10538 "preproc.y"
        {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit)
			(yyval.str) = mm_strdup("with hold");
		else
			(yyval.str) = EMPTY;
	}
#line 49117 "preproc.c"
    break;

  case 1669:
#line 10545 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with hold");
}
#line 49125 "preproc.c"
    break;

  case 1670:
#line 10549 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without hold");
}
#line 49133 "preproc.c"
    break;

  case 1671:
#line 10557 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49141 "preproc.c"
    break;

  case 1672:
#line 10561 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49149 "preproc.c"
    break;

  case 1673:
#line 10569 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49157 "preproc.c"
    break;

  case 1674:
#line 10573 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49165 "preproc.c"
    break;

  case 1675:
#line 10581 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49173 "preproc.c"
    break;

  case 1676:
#line 10585 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49181 "preproc.c"
    break;

  case 1677:
#line 10589 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49189 "preproc.c"
    break;

  case 1678:
#line 10593 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49197 "preproc.c"
    break;

  case 1679:
#line 10597 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49205 "preproc.c"
    break;

  case 1680:
#line 10601 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49213 "preproc.c"
    break;

  case 1681:
#line 10605 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49221 "preproc.c"
    break;

  case 1682:
#line 10609 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49229 "preproc.c"
    break;

  case 1683:
#line 10617 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49237 "preproc.c"
    break;

  case 1684:
#line 10621 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49245 "preproc.c"
    break;

  case 1685:
#line 10629 "preproc.y"
 { 
 (yyval.str) = cat_str(9,mm_strdup("select"),(yyvsp[-7].str),(yyvsp[-6].str),(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49253 "preproc.c"
    break;

  case 1686:
#line 10633 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49261 "preproc.c"
    break;

  case 1687:
#line 10637 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 49269 "preproc.c"
    break;

  case 1688:
#line 10641 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("union"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49277 "preproc.c"
    break;

  case 1689:
#line 10645 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("intersect"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49285 "preproc.c"
    break;

  case 1690:
#line 10649 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("except"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49293 "preproc.c"
    break;

  case 1691:
#line 10657 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with"),(yyvsp[0].str));
}
#line 49301 "preproc.c"
    break;

  case 1692:
#line 10661 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("with recursive"),(yyvsp[0].str));
}
#line 49309 "preproc.c"
    break;

  case 1693:
#line 10669 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49317 "preproc.c"
    break;

  case 1694:
#line 10673 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49325 "preproc.c"
    break;

  case 1695:
#line 10681 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),(yyvsp[-4].str),mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49333 "preproc.c"
    break;

  case 1696:
#line 10689 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49341 "preproc.c"
    break;

  case 1697:
#line 10693 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49348 "preproc.c"
    break;

  case 1698:
#line 10700 "preproc.y"
                                        {
						FoundInto = 1;
						(yyval.str)= cat2_str(mm_strdup("into"), (yyvsp[0].str));
					}
#line 49357 "preproc.c"
    break;

  case 1699:
#line 10704 "preproc.y"
                    { (yyval.str) = EMPTY; }
#line 49363 "preproc.c"
    break;

  case 1700:
#line 10706 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49370 "preproc.c"
    break;

  case 1701:
#line 10713 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49378 "preproc.c"
    break;

  case 1702:
#line 10717 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49386 "preproc.c"
    break;

  case 1703:
#line 10721 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("local temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49394 "preproc.c"
    break;

  case 1704:
#line 10725 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("local temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49402 "preproc.c"
    break;

  case 1705:
#line 10729 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("global temporary"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49410 "preproc.c"
    break;

  case 1706:
#line 10733 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("global temp"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49418 "preproc.c"
    break;

  case 1707:
#line 10737 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("unlogged"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49426 "preproc.c"
    break;

  case 1708:
#line 10741 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("table"),(yyvsp[0].str));
}
#line 49434 "preproc.c"
    break;

  case 1709:
#line 10745 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49442 "preproc.c"
    break;

  case 1710:
#line 10753 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 49450 "preproc.c"
    break;

  case 1711:
#line 10757 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49457 "preproc.c"
    break;

  case 1712:
#line 10764 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 49465 "preproc.c"
    break;

  case 1713:
#line 10768 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 49473 "preproc.c"
    break;

  case 1714:
#line 10772 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49480 "preproc.c"
    break;

  case 1715:
#line 10779 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 49488 "preproc.c"
    break;

  case 1716:
#line 10783 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("distinct on ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49496 "preproc.c"
    break;

  case 1717:
#line 10787 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 49504 "preproc.c"
    break;

  case 1718:
#line 10791 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49511 "preproc.c"
    break;

  case 1719:
#line 10798 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49519 "preproc.c"
    break;

  case 1720:
#line 10802 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49526 "preproc.c"
    break;

  case 1721:
#line 10809 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("order by"),(yyvsp[0].str));
}
#line 49534 "preproc.c"
    break;

  case 1722:
#line 10817 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49542 "preproc.c"
    break;

  case 1723:
#line 10821 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49550 "preproc.c"
    break;

  case 1724:
#line 10829 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("using"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49558 "preproc.c"
    break;

  case 1725:
#line 10833 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49566 "preproc.c"
    break;

  case 1726:
#line 10841 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49574 "preproc.c"
    break;

  case 1727:
#line 10845 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49582 "preproc.c"
    break;

  case 1728:
#line 10849 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49590 "preproc.c"
    break;

  case 1729:
#line 10853 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49598 "preproc.c"
    break;

  case 1730:
#line 10861 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49606 "preproc.c"
    break;

  case 1731:
#line 10865 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49613 "preproc.c"
    break;

  case 1732:
#line 10872 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("limit"),(yyvsp[0].str));
}
#line 49621 "preproc.c"
    break;

  case 1733:
#line 10876 "preproc.y"
        {
		mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
		(yyval.str) = cat_str(4, mm_strdup("limit"), (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
	}
#line 49630 "preproc.c"
    break;

  case 1734:
#line 10881 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("fetch"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 49638 "preproc.c"
    break;

  case 1735:
#line 10885 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("fetch"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("only"));
}
#line 49646 "preproc.c"
    break;

  case 1736:
#line 10893 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("offset"),(yyvsp[0].str));
}
#line 49654 "preproc.c"
    break;

  case 1737:
#line 10897 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("offset"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49662 "preproc.c"
    break;

  case 1738:
#line 10905 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49670 "preproc.c"
    break;

  case 1739:
#line 10909 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 49678 "preproc.c"
    break;

  case 1740:
#line 10917 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49686 "preproc.c"
    break;

  case 1741:
#line 10925 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49694 "preproc.c"
    break;

  case 1742:
#line 10929 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 49702 "preproc.c"
    break;

  case 1743:
#line 10933 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 49710 "preproc.c"
    break;

  case 1744:
#line 10941 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49718 "preproc.c"
    break;

  case 1745:
#line 10945 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49726 "preproc.c"
    break;

  case 1746:
#line 10953 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 49734 "preproc.c"
    break;

  case 1747:
#line 10957 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 49742 "preproc.c"
    break;

  case 1748:
#line 10965 "preproc.y"
 { 
 (yyval.str) = mm_strdup("first");
}
#line 49750 "preproc.c"
    break;

  case 1749:
#line 10969 "preproc.y"
 { 
 (yyval.str) = mm_strdup("next");
}
#line 49758 "preproc.c"
    break;

  case 1750:
#line 10977 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("group by"),(yyvsp[0].str));
}
#line 49766 "preproc.c"
    break;

  case 1751:
#line 10981 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49773 "preproc.c"
    break;

  case 1752:
#line 10988 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49781 "preproc.c"
    break;

  case 1753:
#line 10992 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49789 "preproc.c"
    break;

  case 1754:
#line 11000 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49797 "preproc.c"
    break;

  case 1755:
#line 11004 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("rollup ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49805 "preproc.c"
    break;

  case 1756:
#line 11008 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("cube ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49813 "preproc.c"
    break;

  case 1757:
#line 11012 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("grouping sets ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 49821 "preproc.c"
    break;

  case 1758:
#line 11016 "preproc.y"
 { 
 (yyval.str) = mm_strdup("( )");
}
#line 49829 "preproc.c"
    break;

  case 1759:
#line 11024 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("having"),(yyvsp[0].str));
}
#line 49837 "preproc.c"
    break;

  case 1760:
#line 11028 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49844 "preproc.c"
    break;

  case 1761:
#line 11035 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49852 "preproc.c"
    break;

  case 1762:
#line 11039 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for read only");
}
#line 49860 "preproc.c"
    break;

  case 1763:
#line 11047 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49868 "preproc.c"
    break;

  case 1764:
#line 11051 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49875 "preproc.c"
    break;

  case 1765:
#line 11058 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49883 "preproc.c"
    break;

  case 1766:
#line 11062 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49891 "preproc.c"
    break;

  case 1767:
#line 11070 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 49899 "preproc.c"
    break;

  case 1768:
#line 11078 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for update");
}
#line 49907 "preproc.c"
    break;

  case 1769:
#line 11082 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for no key update");
}
#line 49915 "preproc.c"
    break;

  case 1770:
#line 11086 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for share");
}
#line 49923 "preproc.c"
    break;

  case 1771:
#line 11090 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for key share");
}
#line 49931 "preproc.c"
    break;

  case 1772:
#line 11098 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("of"),(yyvsp[0].str));
}
#line 49939 "preproc.c"
    break;

  case 1773:
#line 11102 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49946 "preproc.c"
    break;

  case 1774:
#line 11109 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("values"),(yyvsp[0].str));
}
#line 49954 "preproc.c"
    break;

  case 1775:
#line 11113 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49962 "preproc.c"
    break;

  case 1776:
#line 11121 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 49970 "preproc.c"
    break;

  case 1777:
#line 11125 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 49977 "preproc.c"
    break;

  case 1778:
#line 11132 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 49985 "preproc.c"
    break;

  case 1779:
#line 11136 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 49993 "preproc.c"
    break;

  case 1780:
#line 11144 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50001 "preproc.c"
    break;

  case 1781:
#line 11148 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50009 "preproc.c"
    break;

  case 1782:
#line 11152 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50017 "preproc.c"
    break;

  case 1783:
#line 11156 "preproc.y"
 { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50028 "preproc.c"
    break;

  case 1784:
#line 11163 "preproc.y"
 { 
	if ((yyvsp[0].str) == NULL)
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = cat_str(3,mm_strdup("lateral"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50039 "preproc.c"
    break;

  case 1785:
#line 11170 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50047 "preproc.c"
    break;

  case 1786:
#line 11174 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50055 "preproc.c"
    break;

  case 1787:
#line 11182 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50063 "preproc.c"
    break;

  case 1788:
#line 11186 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("cross join"),(yyvsp[0].str));
}
#line 50071 "preproc.c"
    break;

  case 1789:
#line 11190 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50079 "preproc.c"
    break;

  case 1790:
#line 11194 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("join"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50087 "preproc.c"
    break;

  case 1791:
#line 11198 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("natural"),(yyvsp[-2].str),mm_strdup("join"),(yyvsp[0].str));
}
#line 50095 "preproc.c"
    break;

  case 1792:
#line 11202 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("natural join"),(yyvsp[0].str));
}
#line 50103 "preproc.c"
    break;

  case 1793:
#line 11210 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50111 "preproc.c"
    break;

  case 1794:
#line 11214 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("as"),(yyvsp[0].str));
}
#line 50119 "preproc.c"
    break;

  case 1795:
#line 11218 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50127 "preproc.c"
    break;

  case 1796:
#line 11222 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50135 "preproc.c"
    break;

  case 1797:
#line 11230 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50143 "preproc.c"
    break;

  case 1798:
#line 11234 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50150 "preproc.c"
    break;

  case 1799:
#line 11241 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50158 "preproc.c"
    break;

  case 1800:
#line 11245 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50166 "preproc.c"
    break;

  case 1801:
#line 11249 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("as"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50174 "preproc.c"
    break;

  case 1802:
#line 11253 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50182 "preproc.c"
    break;

  case 1803:
#line 11257 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50189 "preproc.c"
    break;

  case 1804:
#line 11264 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("full"),(yyvsp[0].str));
}
#line 50197 "preproc.c"
    break;

  case 1805:
#line 11268 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("left"),(yyvsp[0].str));
}
#line 50205 "preproc.c"
    break;

  case 1806:
#line 11272 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("right"),(yyvsp[0].str));
}
#line 50213 "preproc.c"
    break;

  case 1807:
#line 11276 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inner");
}
#line 50221 "preproc.c"
    break;

  case 1808:
#line 11284 "preproc.y"
 { 
 (yyval.str) = mm_strdup("outer");
}
#line 50229 "preproc.c"
    break;

  case 1809:
#line 11288 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50236 "preproc.c"
    break;

  case 1810:
#line 11295 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("using ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50244 "preproc.c"
    break;

  case 1811:
#line 11299 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("on"),(yyvsp[0].str));
}
#line 50252 "preproc.c"
    break;

  case 1812:
#line 11307 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50260 "preproc.c"
    break;

  case 1813:
#line 11311 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("*"));
}
#line 50268 "preproc.c"
    break;

  case 1814:
#line 11315 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("only"),(yyvsp[0].str));
}
#line 50276 "preproc.c"
    break;

  case 1815:
#line 11319 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("only ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50284 "preproc.c"
    break;

  case 1816:
#line 11327 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50292 "preproc.c"
    break;

  case 1817:
#line 11331 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50300 "preproc.c"
    break;

  case 1818:
#line 11339 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50308 "preproc.c"
    break;

  case 1819:
#line 11343 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50316 "preproc.c"
    break;

  case 1820:
#line 11347 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 50324 "preproc.c"
    break;

  case 1821:
#line 11355 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50332 "preproc.c"
    break;

  case 1822:
#line 11359 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("rows from ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50340 "preproc.c"
    break;

  case 1823:
#line 11367 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50348 "preproc.c"
    break;

  case 1824:
#line 11375 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50356 "preproc.c"
    break;

  case 1825:
#line 11379 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50364 "preproc.c"
    break;

  case 1826:
#line 11387 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("as ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50372 "preproc.c"
    break;

  case 1827:
#line 11391 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50379 "preproc.c"
    break;

  case 1828:
#line 11398 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with ordinality");
}
#line 50387 "preproc.c"
    break;

  case 1829:
#line 11402 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50394 "preproc.c"
    break;

  case 1830:
#line 11409 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 50402 "preproc.c"
    break;

  case 1831:
#line 11413 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50409 "preproc.c"
    break;

  case 1832:
#line 11420 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("where"),(yyvsp[0].str));
}
#line 50417 "preproc.c"
    break;

  case 1833:
#line 11424 "preproc.y"
        {
		char *cursor_marker = (yyvsp[0].str)[0] == ':' ? mm_strdup("$0") : (yyvsp[0].str);
		(yyval.str) = cat_str(2,mm_strdup("where current of"), cursor_marker);
	}
#line 50426 "preproc.c"
    break;

  case 1834:
#line 11429 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50433 "preproc.c"
    break;

  case 1835:
#line 11436 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50441 "preproc.c"
    break;

  case 1836:
#line 11440 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50448 "preproc.c"
    break;

  case 1837:
#line 11447 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50456 "preproc.c"
    break;

  case 1838:
#line 11451 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 50464 "preproc.c"
    break;

  case 1839:
#line 11459 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50472 "preproc.c"
    break;

  case 1840:
#line 11467 "preproc.y"
        {	(yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].index).str); }
#line 50478 "preproc.c"
    break;

  case 1841:
#line 11469 "preproc.y"
        {	(yyval.str) = cat_str(3, mm_strdup("setof"), (yyvsp[-1].str), (yyvsp[0].index).str); }
#line 50484 "preproc.c"
    break;

  case 1842:
#line 11471 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 50492 "preproc.c"
    break;

  case 1843:
#line 11475 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("setof"),(yyvsp[-4].str),mm_strdup("array ["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 50500 "preproc.c"
    break;

  case 1844:
#line 11479 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("array"));
}
#line 50508 "preproc.c"
    break;

  case 1845:
#line 11483 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("setof"),(yyvsp[-1].str),mm_strdup("array"));
}
#line 50516 "preproc.c"
    break;

  case 1846:
#line 11491 "preproc.y"
        {
		(yyval.index).index1 = (yyvsp[-2].index).index1;
		(yyval.index).index2 = (yyvsp[-2].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup("0");
		else if (strcmp((yyvsp[-2].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup("0");
		(yyval.index).str = cat_str(2, (yyvsp[-2].index).str, mm_strdup("[]"));
	}
#line 50530 "preproc.c"
    break;

  case 1847:
#line 11501 "preproc.y"
        {
		(yyval.index).index1 = (yyvsp[-3].index).index1;
		(yyval.index).index2 = (yyvsp[-3].index).index2;
		if (strcmp((yyvsp[-3].index).index1, "-1") == 0)
			(yyval.index).index1 = mm_strdup((yyvsp[-1].str));
		else if (strcmp((yyvsp[-3].index).index2, "-1") == 0)
			(yyval.index).index2 = mm_strdup((yyvsp[-1].str));
		(yyval.index).str = cat_str(4, (yyvsp[-3].index).str, mm_strdup("["), (yyvsp[-1].str), mm_strdup("]"));
	}
#line 50544 "preproc.c"
    break;

  case 1848:
#line 11511 "preproc.y"
        {
		(yyval.index).index1 = mm_strdup("-1");
		(yyval.index).index2 = mm_strdup("-1");
		(yyval.index).str= EMPTY;
	}
#line 50554 "preproc.c"
    break;

  case 1849:
#line 11521 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50562 "preproc.c"
    break;

  case 1850:
#line 11525 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50570 "preproc.c"
    break;

  case 1851:
#line 11529 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50578 "preproc.c"
    break;

  case 1852:
#line 11533 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50586 "preproc.c"
    break;

  case 1853:
#line 11537 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50594 "preproc.c"
    break;

  case 1854:
#line 11541 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50602 "preproc.c"
    break;

  case 1855:
#line 11545 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50610 "preproc.c"
    break;

  case 1856:
#line 11553 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50618 "preproc.c"
    break;

  case 1857:
#line 11557 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50626 "preproc.c"
    break;

  case 1858:
#line 11561 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50634 "preproc.c"
    break;

  case 1859:
#line 11565 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50642 "preproc.c"
    break;

  case 1860:
#line 11573 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50650 "preproc.c"
    break;

  case 1861:
#line 11577 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50658 "preproc.c"
    break;

  case 1862:
#line 11585 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50666 "preproc.c"
    break;

  case 1863:
#line 11589 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50673 "preproc.c"
    break;

  case 1864:
#line 11596 "preproc.y"
 { 
 (yyval.str) = mm_strdup("int");
}
#line 50681 "preproc.c"
    break;

  case 1865:
#line 11600 "preproc.y"
 { 
 (yyval.str) = mm_strdup("integer");
}
#line 50689 "preproc.c"
    break;

  case 1866:
#line 11604 "preproc.y"
 { 
 (yyval.str) = mm_strdup("smallint");
}
#line 50697 "preproc.c"
    break;

  case 1867:
#line 11608 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bigint");
}
#line 50705 "preproc.c"
    break;

  case 1868:
#line 11612 "preproc.y"
 { 
 (yyval.str) = mm_strdup("real");
}
#line 50713 "preproc.c"
    break;

  case 1869:
#line 11616 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("float"),(yyvsp[0].str));
}
#line 50721 "preproc.c"
    break;

  case 1870:
#line 11620 "preproc.y"
 { 
 (yyval.str) = mm_strdup("double precision");
}
#line 50729 "preproc.c"
    break;

  case 1871:
#line 11624 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("decimal"),(yyvsp[0].str));
}
#line 50737 "preproc.c"
    break;

  case 1872:
#line 11628 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("dec"),(yyvsp[0].str));
}
#line 50745 "preproc.c"
    break;

  case 1873:
#line 11632 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("numeric"),(yyvsp[0].str));
}
#line 50753 "preproc.c"
    break;

  case 1874:
#line 11636 "preproc.y"
 { 
 (yyval.str) = mm_strdup("boolean");
}
#line 50761 "preproc.c"
    break;

  case 1875:
#line 11644 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50769 "preproc.c"
    break;

  case 1876:
#line 11648 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50776 "preproc.c"
    break;

  case 1877:
#line 11655 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50784 "preproc.c"
    break;

  case 1878:
#line 11659 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50792 "preproc.c"
    break;

  case 1879:
#line 11667 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50800 "preproc.c"
    break;

  case 1880:
#line 11671 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50808 "preproc.c"
    break;

  case 1881:
#line 11679 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("bit"),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 50816 "preproc.c"
    break;

  case 1882:
#line 11687 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("bit"),(yyvsp[0].str));
}
#line 50824 "preproc.c"
    break;

  case 1883:
#line 11695 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50832 "preproc.c"
    break;

  case 1884:
#line 11699 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50840 "preproc.c"
    break;

  case 1885:
#line 11707 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50848 "preproc.c"
    break;

  case 1886:
#line 11711 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 50856 "preproc.c"
    break;

  case 1887:
#line 11719 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50864 "preproc.c"
    break;

  case 1888:
#line 11727 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 50872 "preproc.c"
    break;

  case 1889:
#line 11735 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("character"),(yyvsp[0].str));
}
#line 50880 "preproc.c"
    break;

  case 1890:
#line 11739 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("char"),(yyvsp[0].str));
}
#line 50888 "preproc.c"
    break;

  case 1891:
#line 11743 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varchar");
}
#line 50896 "preproc.c"
    break;

  case 1892:
#line 11747 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("national character"),(yyvsp[0].str));
}
#line 50904 "preproc.c"
    break;

  case 1893:
#line 11751 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("national char"),(yyvsp[0].str));
}
#line 50912 "preproc.c"
    break;

  case 1894:
#line 11755 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("nchar"),(yyvsp[0].str));
}
#line 50920 "preproc.c"
    break;

  case 1895:
#line 11763 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varying");
}
#line 50928 "preproc.c"
    break;

  case 1896:
#line 11767 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50935 "preproc.c"
    break;

  case 1897:
#line 11774 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("character set"),(yyvsp[0].str));
}
#line 50943 "preproc.c"
    break;

  case 1898:
#line 11778 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 50950 "preproc.c"
    break;

  case 1899:
#line 11785 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("timestamp ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50958 "preproc.c"
    break;

  case 1900:
#line 11789 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("timestamp"),(yyvsp[0].str));
}
#line 50966 "preproc.c"
    break;

  case 1901:
#line 11793 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("time ("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 50974 "preproc.c"
    break;

  case 1902:
#line 11797 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("time"),(yyvsp[0].str));
}
#line 50982 "preproc.c"
    break;

  case 1903:
#line 11805 "preproc.y"
 { 
 (yyval.str) = mm_strdup("interval");
}
#line 50990 "preproc.c"
    break;

  case 1904:
#line 11813 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with time zone");
}
#line 50998 "preproc.c"
    break;

  case 1905:
#line 11817 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without time zone");
}
#line 51006 "preproc.c"
    break;

  case 1906:
#line 11821 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51013 "preproc.c"
    break;

  case 1907:
#line 11828 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year");
}
#line 51021 "preproc.c"
    break;

  case 1908:
#line 11832 "preproc.y"
 { 
 (yyval.str) = mm_strdup("month");
}
#line 51029 "preproc.c"
    break;

  case 1909:
#line 11836 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day");
}
#line 51037 "preproc.c"
    break;

  case 1910:
#line 11840 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour");
}
#line 51045 "preproc.c"
    break;

  case 1911:
#line 11844 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minute");
}
#line 51053 "preproc.c"
    break;

  case 1912:
#line 11848 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51061 "preproc.c"
    break;

  case 1913:
#line 11852 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year to month");
}
#line 51069 "preproc.c"
    break;

  case 1914:
#line 11856 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day to hour");
}
#line 51077 "preproc.c"
    break;

  case 1915:
#line 11860 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day to minute");
}
#line 51085 "preproc.c"
    break;

  case 1916:
#line 11864 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("day to"),(yyvsp[0].str));
}
#line 51093 "preproc.c"
    break;

  case 1917:
#line 11868 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour to minute");
}
#line 51101 "preproc.c"
    break;

  case 1918:
#line 11872 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("hour to"),(yyvsp[0].str));
}
#line 51109 "preproc.c"
    break;

  case 1919:
#line 11876 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("minute to"),(yyvsp[0].str));
}
#line 51117 "preproc.c"
    break;

  case 1920:
#line 11880 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51124 "preproc.c"
    break;

  case 1921:
#line 11887 "preproc.y"
 { 
 (yyval.str) = mm_strdup("second");
}
#line 51132 "preproc.c"
    break;

  case 1922:
#line 11891 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("second ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51140 "preproc.c"
    break;

  case 1923:
#line 11899 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51148 "preproc.c"
    break;

  case 1924:
#line 11903 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 51156 "preproc.c"
    break;

  case 1925:
#line 11907 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("collate"),(yyvsp[0].str));
}
#line 51164 "preproc.c"
    break;

  case 1926:
#line 11911 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("at time zone"),(yyvsp[0].str));
}
#line 51172 "preproc.c"
    break;

  case 1927:
#line 11915 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 51180 "preproc.c"
    break;

  case 1928:
#line 11919 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 51188 "preproc.c"
    break;

  case 1929:
#line 11923 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 51196 "preproc.c"
    break;

  case 1930:
#line 11927 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 51204 "preproc.c"
    break;

  case 1931:
#line 11931 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 51212 "preproc.c"
    break;

  case 1932:
#line 11935 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 51220 "preproc.c"
    break;

  case 1933:
#line 11939 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 51228 "preproc.c"
    break;

  case 1934:
#line 11943 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 51236 "preproc.c"
    break;

  case 1935:
#line 11947 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 51244 "preproc.c"
    break;

  case 1936:
#line 11951 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 51252 "preproc.c"
    break;

  case 1937:
#line 11955 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 51260 "preproc.c"
    break;

  case 1938:
#line 11959 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51268 "preproc.c"
    break;

  case 1939:
#line 11963 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51276 "preproc.c"
    break;

  case 1940:
#line 11967 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51284 "preproc.c"
    break;

  case 1941:
#line 11971 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51292 "preproc.c"
    break;

  case 1942:
#line 11975 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("or"),(yyvsp[0].str));
}
#line 51300 "preproc.c"
    break;

  case 1943:
#line 11979 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("not"),(yyvsp[0].str));
}
#line 51308 "preproc.c"
    break;

  case 1944:
#line 11983 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("like"),(yyvsp[0].str));
}
#line 51316 "preproc.c"
    break;

  case 1945:
#line 11987 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51324 "preproc.c"
    break;

  case 1946:
#line 11991 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not like"),(yyvsp[0].str));
}
#line 51332 "preproc.c"
    break;

  case 1947:
#line 11995 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not like"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51340 "preproc.c"
    break;

  case 1948:
#line 11999 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("ilike"),(yyvsp[0].str));
}
#line 51348 "preproc.c"
    break;

  case 1949:
#line 12003 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51356 "preproc.c"
    break;

  case 1950:
#line 12007 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not ilike"),(yyvsp[0].str));
}
#line 51364 "preproc.c"
    break;

  case 1951:
#line 12011 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("not ilike"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51372 "preproc.c"
    break;

  case 1952:
#line 12015 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("similar to"),(yyvsp[0].str));
}
#line 51380 "preproc.c"
    break;

  case 1953:
#line 12019 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51388 "preproc.c"
    break;

  case 1954:
#line 12023 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("not similar to"),(yyvsp[0].str));
}
#line 51396 "preproc.c"
    break;

  case 1955:
#line 12027 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not similar to"),(yyvsp[-2].str),mm_strdup("escape"),(yyvsp[0].str));
}
#line 51404 "preproc.c"
    break;

  case 1956:
#line 12031 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is null"));
}
#line 51412 "preproc.c"
    break;

  case 1957:
#line 12035 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("isnull"));
}
#line 51420 "preproc.c"
    break;

  case 1958:
#line 12039 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not null"));
}
#line 51428 "preproc.c"
    break;

  case 1959:
#line 12043 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("notnull"));
}
#line 51436 "preproc.c"
    break;

  case 1960:
#line 12047 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("overlaps"),(yyvsp[0].str));
}
#line 51444 "preproc.c"
    break;

  case 1961:
#line 12051 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is true"));
}
#line 51452 "preproc.c"
    break;

  case 1962:
#line 12055 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not true"));
}
#line 51460 "preproc.c"
    break;

  case 1963:
#line 12059 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is false"));
}
#line 51468 "preproc.c"
    break;

  case 1964:
#line 12063 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not false"));
}
#line 51476 "preproc.c"
    break;

  case 1965:
#line 12067 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is unknown"));
}
#line 51484 "preproc.c"
    break;

  case 1966:
#line 12071 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not unknown"));
}
#line 51492 "preproc.c"
    break;

  case 1967:
#line 12075 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 51500 "preproc.c"
    break;

  case 1968:
#line 12079 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 51508 "preproc.c"
    break;

  case 1969:
#line 12083 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51516 "preproc.c"
    break;

  case 1970:
#line 12087 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51524 "preproc.c"
    break;

  case 1971:
#line 12091 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51532 "preproc.c"
    break;

  case 1972:
#line 12095 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-6].str),mm_strdup("not between"),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51540 "preproc.c"
    break;

  case 1973:
#line 12099 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51548 "preproc.c"
    break;

  case 1974:
#line 12103 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-6].str),mm_strdup("not between symmetric"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 51556 "preproc.c"
    break;

  case 1975:
#line 12107 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 51564 "preproc.c"
    break;

  case 1976:
#line 12111 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-3].str),mm_strdup("not in"),(yyvsp[0].str));
}
#line 51572 "preproc.c"
    break;

  case 1977:
#line 12115 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51580 "preproc.c"
    break;

  case 1978:
#line 12119 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51588 "preproc.c"
    break;

  case 1979:
#line 12123 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,mm_strdup("unique"),(yyvsp[0].str));
}
#line 51597 "preproc.c"
    break;

  case 1980:
#line 12128 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 51605 "preproc.c"
    break;

  case 1981:
#line 12132 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 51613 "preproc.c"
    break;

  case 1982:
#line 12140 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51621 "preproc.c"
    break;

  case 1983:
#line 12144 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("::"),(yyvsp[0].str));
}
#line 51629 "preproc.c"
    break;

  case 1984:
#line 12148 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 51637 "preproc.c"
    break;

  case 1985:
#line 12152 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 51645 "preproc.c"
    break;

  case 1986:
#line 12156 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("+"),(yyvsp[0].str));
}
#line 51653 "preproc.c"
    break;

  case 1987:
#line 12160 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("-"),(yyvsp[0].str));
}
#line 51661 "preproc.c"
    break;

  case 1988:
#line 12164 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("*"),(yyvsp[0].str));
}
#line 51669 "preproc.c"
    break;

  case 1989:
#line 12168 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("/"),(yyvsp[0].str));
}
#line 51677 "preproc.c"
    break;

  case 1990:
#line 12172 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("%"),(yyvsp[0].str));
}
#line 51685 "preproc.c"
    break;

  case 1991:
#line 12176 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("^"),(yyvsp[0].str));
}
#line 51693 "preproc.c"
    break;

  case 1992:
#line 12180 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("<"),(yyvsp[0].str));
}
#line 51701 "preproc.c"
    break;

  case 1993:
#line 12184 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(">"),(yyvsp[0].str));
}
#line 51709 "preproc.c"
    break;

  case 1994:
#line 12188 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("="),(yyvsp[0].str));
}
#line 51717 "preproc.c"
    break;

  case 1995:
#line 12192 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51725 "preproc.c"
    break;

  case 1996:
#line 12196 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51733 "preproc.c"
    break;

  case 1997:
#line 12200 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51741 "preproc.c"
    break;

  case 1998:
#line 12204 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-4].str),mm_strdup("is distinct from"),(yyvsp[0].str));
}
#line 51749 "preproc.c"
    break;

  case 1999:
#line 12208 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-5].str),mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 51757 "preproc.c"
    break;

  case 2000:
#line 12212 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-5].str),mm_strdup("is of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51765 "preproc.c"
    break;

  case 2001:
#line 12216 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-6].str),mm_strdup("is not of ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51773 "preproc.c"
    break;

  case 2002:
#line 12220 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("is document"));
}
#line 51781 "preproc.c"
    break;

  case 2003:
#line 12224 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("is not document"));
}
#line 51789 "preproc.c"
    break;

  case 2004:
#line 12232 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51797 "preproc.c"
    break;

  case 2005:
#line 12236 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51805 "preproc.c"
    break;

  case 2006:
#line 12240 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51813 "preproc.c"
    break;

  case 2007:
#line 12244 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("("),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 51821 "preproc.c"
    break;

  case 2008:
#line 12248 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51829 "preproc.c"
    break;

  case 2009:
#line 12252 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51837 "preproc.c"
    break;

  case 2010:
#line 12256 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51845 "preproc.c"
    break;

  case 2011:
#line 12260 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51853 "preproc.c"
    break;

  case 2012:
#line 12264 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51861 "preproc.c"
    break;

  case 2013:
#line 12268 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("exists"),(yyvsp[0].str));
}
#line 51869 "preproc.c"
    break;

  case 2014:
#line 12272 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 51877 "preproc.c"
    break;

  case 2015:
#line 12276 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("array"),(yyvsp[0].str));
}
#line 51885 "preproc.c"
    break;

  case 2016:
#line 12280 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("table ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51893 "preproc.c"
    break;

  case 2017:
#line 12284 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 51901 "preproc.c"
    break;

  case 2018:
#line 12292 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 51908 "preproc.c"
    break;

  case 2019:
#line 12295 "preproc.y"
 { 
 (yyval.str) = mm_strdup("scatter randomly");
}
#line 51916 "preproc.c"
    break;

  case 2020:
#line 12299 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("scatter by"),(yyvsp[0].str));
}
#line 51924 "preproc.c"
    break;

  case 2021:
#line 12307 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51932 "preproc.c"
    break;

  case 2022:
#line 12315 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-2].str),mm_strdup("( )"));
}
#line 51940 "preproc.c"
    break;

  case 2023:
#line 12319 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-4].str),mm_strdup("("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51948 "preproc.c"
    break;

  case 2024:
#line 12323 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51956 "preproc.c"
    break;

  case 2025:
#line 12327 "preproc.y"
 { 
 (yyval.str) = cat_str(7,(yyvsp[-7].str),mm_strdup("("),(yyvsp[-5].str),mm_strdup(", variadic"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51964 "preproc.c"
    break;

  case 2026:
#line 12331 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( all"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51972 "preproc.c"
    break;

  case 2027:
#line 12335 "preproc.y"
 { 
 (yyval.str) = cat_str(5,(yyvsp[-5].str),mm_strdup("( distinct"),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 51980 "preproc.c"
    break;

  case 2028:
#line 12339 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-3].str),mm_strdup("( * )"));
}
#line 51988 "preproc.c"
    break;

  case 2029:
#line 12347 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 51996 "preproc.c"
    break;

  case 2030:
#line 12351 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52004 "preproc.c"
    break;

  case 2031:
#line 12359 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52012 "preproc.c"
    break;

  case 2032:
#line 12363 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52020 "preproc.c"
    break;

  case 2033:
#line 12371 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("collation for ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52028 "preproc.c"
    break;

  case 2034:
#line 12375 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_date");
}
#line 52036 "preproc.c"
    break;

  case 2035:
#line 12379 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_time");
}
#line 52044 "preproc.c"
    break;

  case 2036:
#line 12383 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("current_time ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52052 "preproc.c"
    break;

  case 2037:
#line 12387 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 52060 "preproc.c"
    break;

  case 2038:
#line 12391 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("current_timestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52068 "preproc.c"
    break;

  case 2039:
#line 12395 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtime");
}
#line 52076 "preproc.c"
    break;

  case 2040:
#line 12399 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("localtime ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52084 "preproc.c"
    break;

  case 2041:
#line 12403 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 52092 "preproc.c"
    break;

  case 2042:
#line 12407 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("localtimestamp ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52100 "preproc.c"
    break;

  case 2043:
#line 12411 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_role");
}
#line 52108 "preproc.c"
    break;

  case 2044:
#line 12415 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 52116 "preproc.c"
    break;

  case 2045:
#line 12419 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session_user");
}
#line 52124 "preproc.c"
    break;

  case 2046:
#line 12423 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 52132 "preproc.c"
    break;

  case 2047:
#line 12427 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 52140 "preproc.c"
    break;

  case 2048:
#line 12431 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 52148 "preproc.c"
    break;

  case 2049:
#line 12435 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("cast ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52156 "preproc.c"
    break;

  case 2050:
#line 12439 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("extract ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52164 "preproc.c"
    break;

  case 2051:
#line 12443 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("overlay ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52172 "preproc.c"
    break;

  case 2052:
#line 12447 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("position ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52180 "preproc.c"
    break;

  case 2053:
#line 12451 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("substring ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52188 "preproc.c"
    break;

  case 2054:
#line 12455 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("treat ("),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52196 "preproc.c"
    break;

  case 2055:
#line 12459 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( both"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52204 "preproc.c"
    break;

  case 2056:
#line 12463 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( leading"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52212 "preproc.c"
    break;

  case 2057:
#line 12467 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ( trailing"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52220 "preproc.c"
    break;

  case 2058:
#line 12471 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("trim ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52228 "preproc.c"
    break;

  case 2059:
#line 12475 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("nullif ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52236 "preproc.c"
    break;

  case 2060:
#line 12479 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("coalesce ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52244 "preproc.c"
    break;

  case 2061:
#line 12483 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("greatest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52252 "preproc.c"
    break;

  case 2062:
#line 12487 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("least ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52260 "preproc.c"
    break;

  case 2063:
#line 12491 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("grouping ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52268 "preproc.c"
    break;

  case 2064:
#line 12495 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group_id ( )");
}
#line 52276 "preproc.c"
    break;

  case 2065:
#line 12499 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("median ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52284 "preproc.c"
    break;

  case 2066:
#line 12503 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("decode ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52292 "preproc.c"
    break;

  case 2067:
#line 12507 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlconcat ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52300 "preproc.c"
    break;

  case 2068:
#line 12511 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlelement ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52308 "preproc.c"
    break;

  case 2069:
#line 12515 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52316 "preproc.c"
    break;

  case 2070:
#line 12519 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlelement ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52324 "preproc.c"
    break;

  case 2071:
#line 12523 "preproc.y"
 { 
 (yyval.str) = cat_str(7,mm_strdup("xmlelement ( name"),(yyvsp[-5].str),mm_strdup(","),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52332 "preproc.c"
    break;

  case 2072:
#line 12527 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("xmlexists ("),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52340 "preproc.c"
    break;

  case 2073:
#line 12531 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlexists ("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52348 "preproc.c"
    break;

  case 2074:
#line 12535 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlforest ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52356 "preproc.c"
    break;

  case 2075:
#line 12539 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlparse ("),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52364 "preproc.c"
    break;

  case 2076:
#line 12543 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlpi ( name"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52372 "preproc.c"
    break;

  case 2077:
#line 12547 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("xmlpi ( name"),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52380 "preproc.c"
    break;

  case 2078:
#line 12551 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("xmlroot ("),(yyvsp[-4].str),mm_strdup(","),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52388 "preproc.c"
    break;

  case 2079:
#line 12555 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("xmlserialize ("),(yyvsp[-4].str),(yyvsp[-3].str),mm_strdup("as"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52396 "preproc.c"
    break;

  case 2080:
#line 12563 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("version"),(yyvsp[0].str));
}
#line 52404 "preproc.c"
    break;

  case 2081:
#line 12567 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version no value");
}
#line 52412 "preproc.c"
    break;

  case 2082:
#line 12575 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone yes");
}
#line 52420 "preproc.c"
    break;

  case 2083:
#line 12579 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone no");
}
#line 52428 "preproc.c"
    break;

  case 2084:
#line 12583 "preproc.y"
 { 
 (yyval.str) = mm_strdup(", standalone no value");
}
#line 52436 "preproc.c"
    break;

  case 2085:
#line 12587 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52443 "preproc.c"
    break;

  case 2086:
#line 12594 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("xmlattributes ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52451 "preproc.c"
    break;

  case 2087:
#line 12602 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52459 "preproc.c"
    break;

  case 2088:
#line 12606 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52467 "preproc.c"
    break;

  case 2089:
#line 12614 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 52475 "preproc.c"
    break;

  case 2090:
#line 12618 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52483 "preproc.c"
    break;

  case 2091:
#line 12626 "preproc.y"
 { 
 (yyval.str) = mm_strdup("document");
}
#line 52491 "preproc.c"
    break;

  case 2092:
#line 12630 "preproc.y"
 { 
 (yyval.str) = mm_strdup("content");
}
#line 52499 "preproc.c"
    break;

  case 2093:
#line 12638 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preserve whitespace");
}
#line 52507 "preproc.c"
    break;

  case 2094:
#line 12642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strip whitespace");
}
#line 52515 "preproc.c"
    break;

  case 2095:
#line 12646 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52522 "preproc.c"
    break;

  case 2096:
#line 12653 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("passing"),(yyvsp[0].str));
}
#line 52530 "preproc.c"
    break;

  case 2097:
#line 12657 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("passing"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 52538 "preproc.c"
    break;

  case 2098:
#line 12661 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("passing by ref"),(yyvsp[0].str));
}
#line 52546 "preproc.c"
    break;

  case 2099:
#line 12665 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("passing by ref"),(yyvsp[-2].str),mm_strdup("by ref"));
}
#line 52554 "preproc.c"
    break;

  case 2100:
#line 12673 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("within group ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52562 "preproc.c"
    break;

  case 2101:
#line 12677 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52569 "preproc.c"
    break;

  case 2102:
#line 12684 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("filter ( where"),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52577 "preproc.c"
    break;

  case 2103:
#line 12688 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52584 "preproc.c"
    break;

  case 2104:
#line 12695 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("window"),(yyvsp[0].str));
}
#line 52592 "preproc.c"
    break;

  case 2105:
#line 12699 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52599 "preproc.c"
    break;

  case 2106:
#line 12706 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52607 "preproc.c"
    break;

  case 2107:
#line 12710 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 52615 "preproc.c"
    break;

  case 2108:
#line 12718 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 52623 "preproc.c"
    break;

  case 2109:
#line 12726 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 52631 "preproc.c"
    break;

  case 2110:
#line 12730 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("over"),(yyvsp[0].str));
}
#line 52639 "preproc.c"
    break;

  case 2111:
#line 12734 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52646 "preproc.c"
    break;

  case 2112:
#line 12741 "preproc.y"
 { 
 (yyval.str) = cat_str(6,mm_strdup("("),(yyvsp[-4].str),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52654 "preproc.c"
    break;

  case 2113:
#line 12749 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52662 "preproc.c"
    break;

  case 2114:
#line 12753 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52669 "preproc.c"
    break;

  case 2115:
#line 12760 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("partition by"),(yyvsp[0].str));
}
#line 52677 "preproc.c"
    break;

  case 2116:
#line 12764 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52684 "preproc.c"
    break;

  case 2117:
#line 12771 "preproc.y"
 { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,mm_strdup("range"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52693 "preproc.c"
    break;

  case 2118:
#line 12776 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("rows"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 52701 "preproc.c"
    break;

  case 2119:
#line 12780 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52708 "preproc.c"
    break;

  case 2120:
#line 12787 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52716 "preproc.c"
    break;

  case 2121:
#line 12791 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("between"),(yyvsp[-2].str),mm_strdup("and"),(yyvsp[0].str));
}
#line 52724 "preproc.c"
    break;

  case 2122:
#line 12799 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded preceding");
}
#line 52732 "preproc.c"
    break;

  case 2123:
#line 12803 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded following");
}
#line 52740 "preproc.c"
    break;

  case 2124:
#line 12807 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current row");
}
#line 52748 "preproc.c"
    break;

  case 2125:
#line 12811 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("preceding"));
}
#line 52756 "preproc.c"
    break;

  case 2126:
#line 12815 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),mm_strdup("following"));
}
#line 52764 "preproc.c"
    break;

  case 2127:
#line 12823 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude current row");
}
#line 52772 "preproc.c"
    break;

  case 2128:
#line 12827 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude group");
}
#line 52780 "preproc.c"
    break;

  case 2129:
#line 12831 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude ties");
}
#line 52788 "preproc.c"
    break;

  case 2130:
#line 12835 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude no others");
}
#line 52796 "preproc.c"
    break;

  case 2131:
#line 12839 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 52803 "preproc.c"
    break;

  case 2132:
#line 12846 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("row ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52811 "preproc.c"
    break;

  case 2133:
#line 12850 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row ( )");
}
#line 52819 "preproc.c"
    break;

  case 2134:
#line 12854 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("("),(yyvsp[-3].str),mm_strdup(","),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52827 "preproc.c"
    break;

  case 2135:
#line 12862 "preproc.y"
 { 
 (yyval.str) = mm_strdup("any");
}
#line 52835 "preproc.c"
    break;

  case 2136:
#line 12866 "preproc.y"
 { 
 (yyval.str) = mm_strdup("some");
}
#line 52843 "preproc.c"
    break;

  case 2137:
#line 12870 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 52851 "preproc.c"
    break;

  case 2138:
#line 12878 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52859 "preproc.c"
    break;

  case 2139:
#line 12882 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52867 "preproc.c"
    break;

  case 2140:
#line 12890 "preproc.y"
 { 
 (yyval.str) = mm_strdup("+");
}
#line 52875 "preproc.c"
    break;

  case 2141:
#line 12894 "preproc.y"
 { 
 (yyval.str) = mm_strdup("-");
}
#line 52883 "preproc.c"
    break;

  case 2142:
#line 12898 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 52891 "preproc.c"
    break;

  case 2143:
#line 12902 "preproc.y"
 { 
 (yyval.str) = mm_strdup("/");
}
#line 52899 "preproc.c"
    break;

  case 2144:
#line 12906 "preproc.y"
 { 
 (yyval.str) = mm_strdup("%");
}
#line 52907 "preproc.c"
    break;

  case 2145:
#line 12910 "preproc.y"
 { 
 (yyval.str) = mm_strdup("^");
}
#line 52915 "preproc.c"
    break;

  case 2146:
#line 12914 "preproc.y"
 { 
 (yyval.str) = mm_strdup("<");
}
#line 52923 "preproc.c"
    break;

  case 2147:
#line 12918 "preproc.y"
 { 
 (yyval.str) = mm_strdup(">");
}
#line 52931 "preproc.c"
    break;

  case 2148:
#line 12922 "preproc.y"
 { 
 (yyval.str) = mm_strdup("=");
}
#line 52939 "preproc.c"
    break;

  case 2149:
#line 12930 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52947 "preproc.c"
    break;

  case 2150:
#line 12934 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52955 "preproc.c"
    break;

  case 2151:
#line 12942 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52963 "preproc.c"
    break;

  case 2152:
#line 12946 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52971 "preproc.c"
    break;

  case 2153:
#line 12954 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 52979 "preproc.c"
    break;

  case 2154:
#line 12958 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("operator ("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 52987 "preproc.c"
    break;

  case 2155:
#line 12962 "preproc.y"
 { 
 (yyval.str) = mm_strdup("like");
}
#line 52995 "preproc.c"
    break;

  case 2156:
#line 12966 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not like");
}
#line 53003 "preproc.c"
    break;

  case 2157:
#line 12970 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ilike");
}
#line 53011 "preproc.c"
    break;

  case 2158:
#line 12974 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not ilike");
}
#line 53019 "preproc.c"
    break;

  case 2159:
#line 12982 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53027 "preproc.c"
    break;

  case 2160:
#line 12986 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53035 "preproc.c"
    break;

  case 2161:
#line 12994 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53043 "preproc.c"
    break;

  case 2162:
#line 12998 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53051 "preproc.c"
    break;

  case 2163:
#line 13006 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53059 "preproc.c"
    break;

  case 2164:
#line 13010 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(":="),(yyvsp[0].str));
}
#line 53067 "preproc.c"
    break;

  case 2165:
#line 13018 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53075 "preproc.c"
    break;

  case 2166:
#line 13022 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53083 "preproc.c"
    break;

  case 2167:
#line 13030 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 53091 "preproc.c"
    break;

  case 2168:
#line 13034 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 53099 "preproc.c"
    break;

  case 2169:
#line 13038 "preproc.y"
 { 
 (yyval.str) = mm_strdup("[ ]");
}
#line 53107 "preproc.c"
    break;

  case 2170:
#line 13046 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53115 "preproc.c"
    break;

  case 2171:
#line 13050 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53123 "preproc.c"
    break;

  case 2172:
#line 13058 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 53131 "preproc.c"
    break;

  case 2173:
#line 13062 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53138 "preproc.c"
    break;

  case 2174:
#line 13069 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53146 "preproc.c"
    break;

  case 2175:
#line 13073 "preproc.y"
 { 
 (yyval.str) = mm_strdup("year");
}
#line 53154 "preproc.c"
    break;

  case 2176:
#line 13077 "preproc.y"
 { 
 (yyval.str) = mm_strdup("month");
}
#line 53162 "preproc.c"
    break;

  case 2177:
#line 13081 "preproc.y"
 { 
 (yyval.str) = mm_strdup("day");
}
#line 53170 "preproc.c"
    break;

  case 2178:
#line 13085 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hour");
}
#line 53178 "preproc.c"
    break;

  case 2179:
#line 13089 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minute");
}
#line 53186 "preproc.c"
    break;

  case 2180:
#line 13093 "preproc.y"
 { 
 (yyval.str) = mm_strdup("second");
}
#line 53194 "preproc.c"
    break;

  case 2181:
#line 13097 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53202 "preproc.c"
    break;

  case 2182:
#line 13105 "preproc.y"
 { 
 (yyval.str) = cat_str(4,(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53210 "preproc.c"
    break;

  case 2183:
#line 13109 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53218 "preproc.c"
    break;

  case 2184:
#line 13117 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("placing"),(yyvsp[0].str));
}
#line 53226 "preproc.c"
    break;

  case 2185:
#line 13125 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("in"),(yyvsp[0].str));
}
#line 53234 "preproc.c"
    break;

  case 2186:
#line 13129 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53241 "preproc.c"
    break;

  case 2187:
#line 13136 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53249 "preproc.c"
    break;

  case 2188:
#line 13140 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53257 "preproc.c"
    break;

  case 2189:
#line 13144 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53265 "preproc.c"
    break;

  case 2190:
#line 13148 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53273 "preproc.c"
    break;

  case 2191:
#line 13152 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53281 "preproc.c"
    break;

  case 2192:
#line 13156 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53288 "preproc.c"
    break;

  case 2193:
#line 13163 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 53296 "preproc.c"
    break;

  case 2194:
#line 13171 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("for"),(yyvsp[0].str));
}
#line 53304 "preproc.c"
    break;

  case 2195:
#line 13179 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("from"),(yyvsp[0].str));
}
#line 53312 "preproc.c"
    break;

  case 2196:
#line 13183 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("from"),(yyvsp[0].str));
}
#line 53320 "preproc.c"
    break;

  case 2197:
#line 13187 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53328 "preproc.c"
    break;

  case 2198:
#line 13195 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53336 "preproc.c"
    break;

  case 2199:
#line 13199 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53344 "preproc.c"
    break;

  case 2200:
#line 13207 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("case"),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup("end"));
}
#line 53352 "preproc.c"
    break;

  case 2201:
#line 13215 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53360 "preproc.c"
    break;

  case 2202:
#line 13219 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53368 "preproc.c"
    break;

  case 2203:
#line 13227 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup("when"),(yyvsp[-2].str),mm_strdup("then"),(yyvsp[0].str));
}
#line 53376 "preproc.c"
    break;

  case 2204:
#line 13235 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53384 "preproc.c"
    break;

  case 2205:
#line 13239 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("is not distinct from"),(yyvsp[0].str));
}
#line 53392 "preproc.c"
    break;

  case 2206:
#line 13247 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("else"),(yyvsp[0].str));
}
#line 53400 "preproc.c"
    break;

  case 2207:
#line 13251 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53407 "preproc.c"
    break;

  case 2208:
#line 13258 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53415 "preproc.c"
    break;

  case 2209:
#line 13262 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53422 "preproc.c"
    break;

  case 2210:
#line 13269 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("decode ("),(yyvsp[-3].str),(yyvsp[-2].str),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53430 "preproc.c"
    break;

  case 2211:
#line 13277 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53438 "preproc.c"
    break;

  case 2212:
#line 13281 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53446 "preproc.c"
    break;

  case 2213:
#line 13289 "preproc.y"
 { 
 (yyval.str) = cat_str(4,mm_strdup(","),(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53454 "preproc.c"
    break;

  case 2214:
#line 13297 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup(","),(yyvsp[0].str));
}
#line 53462 "preproc.c"
    break;

  case 2215:
#line 13301 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53469 "preproc.c"
    break;

  case 2216:
#line 13308 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53477 "preproc.c"
    break;

  case 2217:
#line 13312 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53485 "preproc.c"
    break;

  case 2218:
#line 13320 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("."),(yyvsp[0].str));
}
#line 53493 "preproc.c"
    break;

  case 2219:
#line 13324 "preproc.y"
 { 
 (yyval.str) = mm_strdup(". *");
}
#line 53501 "preproc.c"
    break;

  case 2220:
#line 13328 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("["),(yyvsp[-1].str),mm_strdup("]"));
}
#line 53509 "preproc.c"
    break;

  case 2221:
#line 13332 "preproc.y"
 { 
 (yyval.str) = cat_str(5,mm_strdup("["),(yyvsp[-3].str),mm_strdup(":"),(yyvsp[-1].str),mm_strdup("]"));
}
#line 53517 "preproc.c"
    break;

  case 2222:
#line 13340 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53525 "preproc.c"
    break;

  case 2223:
#line 13344 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53533 "preproc.c"
    break;

  case 2224:
#line 13352 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53540 "preproc.c"
    break;

  case 2225:
#line 13355 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53548 "preproc.c"
    break;

  case 2226:
#line 13363 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 53556 "preproc.c"
    break;

  case 2227:
#line 13367 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53563 "preproc.c"
    break;

  case 2228:
#line 13374 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53571 "preproc.c"
    break;

  case 2229:
#line 13378 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 53579 "preproc.c"
    break;

  case 2230:
#line 13386 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53587 "preproc.c"
    break;

  case 2231:
#line 13390 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53595 "preproc.c"
    break;

  case 2232:
#line 13398 "preproc.y"
 { 
 (yyval.str) = cat_str(3,mm_strdup("("),(yyvsp[-1].str),mm_strdup(")"));
}
#line 53603 "preproc.c"
    break;

  case 2233:
#line 13406 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53611 "preproc.c"
    break;

  case 2234:
#line 13410 "preproc.y"
 { 
 (yyval.str)=EMPTY; }
#line 53618 "preproc.c"
    break;

  case 2235:
#line 13417 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53626 "preproc.c"
    break;

  case 2236:
#line 13421 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53634 "preproc.c"
    break;

  case 2237:
#line 13429 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup("as"),(yyvsp[0].str));
}
#line 53642 "preproc.c"
    break;

  case 2238:
#line 13433 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53650 "preproc.c"
    break;

  case 2239:
#line 13437 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53658 "preproc.c"
    break;

  case 2240:
#line 13441 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53666 "preproc.c"
    break;

  case 2241:
#line 13445 "preproc.y"
 { 
 (yyval.str) = mm_strdup("*");
}
#line 53674 "preproc.c"
    break;

  case 2242:
#line 13453 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53682 "preproc.c"
    break;

  case 2243:
#line 13457 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53690 "preproc.c"
    break;

  case 2244:
#line 13465 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53698 "preproc.c"
    break;

  case 2245:
#line 13469 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53706 "preproc.c"
    break;

  case 2246:
#line 13477 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53714 "preproc.c"
    break;

  case 2247:
#line 13481 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53722 "preproc.c"
    break;

  case 2248:
#line 13489 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53730 "preproc.c"
    break;

  case 2249:
#line 13497 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53738 "preproc.c"
    break;

  case 2250:
#line 13505 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53746 "preproc.c"
    break;

  case 2251:
#line 13513 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53754 "preproc.c"
    break;

  case 2252:
#line 13521 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53762 "preproc.c"
    break;

  case 2253:
#line 13529 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53770 "preproc.c"
    break;

  case 2254:
#line 13537 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53778 "preproc.c"
    break;

  case 2255:
#line 13541 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53786 "preproc.c"
    break;

  case 2256:
#line 13549 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53794 "preproc.c"
    break;

  case 2257:
#line 13553 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53802 "preproc.c"
    break;

  case 2258:
#line 13557 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53810 "preproc.c"
    break;

  case 2259:
#line 13561 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53818 "preproc.c"
    break;

  case 2260:
#line 13565 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xconst");
}
#line 53826 "preproc.c"
    break;

  case 2261:
#line 13569 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53834 "preproc.c"
    break;

  case 2262:
#line 13573 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),(yyvsp[-2].str),mm_strdup(")"),(yyvsp[0].str));
}
#line 53842 "preproc.c"
    break;

  case 2263:
#line 13577 "preproc.y"
 { 
 (yyval.str) = cat_str(2,(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53850 "preproc.c"
    break;

  case 2264:
#line 13581 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53858 "preproc.c"
    break;

  case 2265:
#line 13585 "preproc.y"
 { 
 (yyval.str) = cat_str(6,(yyvsp[-5].str),mm_strdup("("),(yyvsp[-3].str),mm_strdup(")"),(yyvsp[-1].str),(yyvsp[0].str));
}
#line 53866 "preproc.c"
    break;

  case 2266:
#line 13589 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 53874 "preproc.c"
    break;

  case 2267:
#line 13593 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 53882 "preproc.c"
    break;

  case 2268:
#line 13597 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 53890 "preproc.c"
    break;

  case 2269:
#line 13600 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 53896 "preproc.c"
    break;

  case 2270:
#line 13601 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 53902 "preproc.c"
    break;

  case 2271:
#line 13607 "preproc.y"
        { (yyval.str) = make_name(); }
#line 53908 "preproc.c"
    break;

  case 2272:
#line 13613 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53916 "preproc.c"
    break;

  case 2273:
#line 13621 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53924 "preproc.c"
    break;

  case 2274:
#line 13629 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53932 "preproc.c"
    break;

  case 2275:
#line 13633 "preproc.y"
 { 
 (yyval.str) = cat_str(3,(yyvsp[-2].str),mm_strdup(","),(yyvsp[0].str));
}
#line 53940 "preproc.c"
    break;

  case 2276:
#line 13641 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53948 "preproc.c"
    break;

  case 2277:
#line 13644 "preproc.y"
                { (yyval.str) = (yyvsp[0].str); }
#line 53954 "preproc.c"
    break;

  case 2278:
#line 13646 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("+"),(yyvsp[0].str));
}
#line 53962 "preproc.c"
    break;

  case 2279:
#line 13650 "preproc.y"
 { 
 (yyval.str) = cat_str(2,mm_strdup("-"),(yyvsp[0].str));
}
#line 53970 "preproc.c"
    break;

  case 2280:
#line 13658 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53978 "preproc.c"
    break;

  case 2281:
#line 13662 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53986 "preproc.c"
    break;

  case 2282:
#line 13666 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 53994 "preproc.c"
    break;

  case 2283:
#line 13670 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 54002 "preproc.c"
    break;

  case 2284:
#line 13678 "preproc.y"
 { 
 (yyval.str) = mm_strdup("abort");
}
#line 54010 "preproc.c"
    break;

  case 2285:
#line 13682 "preproc.y"
 { 
 (yyval.str) = mm_strdup("absolute");
}
#line 54018 "preproc.c"
    break;

  case 2286:
#line 13686 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access");
}
#line 54026 "preproc.c"
    break;

  case 2287:
#line 13690 "preproc.y"
 { 
 (yyval.str) = mm_strdup("action");
}
#line 54034 "preproc.c"
    break;

  case 2288:
#line 13694 "preproc.y"
 { 
 (yyval.str) = mm_strdup("active");
}
#line 54042 "preproc.c"
    break;

  case 2289:
#line 13698 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add");
}
#line 54050 "preproc.c"
    break;

  case 2290:
#line 13702 "preproc.y"
 { 
 (yyval.str) = mm_strdup("admin");
}
#line 54058 "preproc.c"
    break;

  case 2291:
#line 13706 "preproc.y"
 { 
 (yyval.str) = mm_strdup("after");
}
#line 54066 "preproc.c"
    break;

  case 2292:
#line 13710 "preproc.y"
 { 
 (yyval.str) = mm_strdup("aggregate");
}
#line 54074 "preproc.c"
    break;

  case 2293:
#line 13714 "preproc.y"
 { 
 (yyval.str) = mm_strdup("also");
}
#line 54082 "preproc.c"
    break;

  case 2294:
#line 13718 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter");
}
#line 54090 "preproc.c"
    break;

  case 2295:
#line 13722 "preproc.y"
 { 
 (yyval.str) = mm_strdup("always");
}
#line 54098 "preproc.c"
    break;

  case 2296:
#line 13726 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assertion");
}
#line 54106 "preproc.c"
    break;

  case 2297:
#line 13730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assignment");
}
#line 54114 "preproc.c"
    break;

  case 2298:
#line 13734 "preproc.y"
 { 
 (yyval.str) = mm_strdup("at");
}
#line 54122 "preproc.c"
    break;

  case 2299:
#line 13738 "preproc.y"
 { 
 (yyval.str) = mm_strdup("attribute");
}
#line 54130 "preproc.c"
    break;

  case 2300:
#line 13742 "preproc.y"
 { 
 (yyval.str) = mm_strdup("backward");
}
#line 54138 "preproc.c"
    break;

  case 2301:
#line 13746 "preproc.y"
 { 
 (yyval.str) = mm_strdup("before");
}
#line 54146 "preproc.c"
    break;

  case 2302:
#line 13750 "preproc.y"
 { 
 (yyval.str) = mm_strdup("begin");
}
#line 54154 "preproc.c"
    break;

  case 2303:
#line 13754 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by");
}
#line 54162 "preproc.c"
    break;

  case 2304:
#line 13758 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cache");
}
#line 54170 "preproc.c"
    break;

  case 2305:
#line 13762 "preproc.y"
 { 
 (yyval.str) = mm_strdup("called");
}
#line 54178 "preproc.c"
    break;

  case 2306:
#line 13766 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 54186 "preproc.c"
    break;

  case 2307:
#line 13770 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascaded");
}
#line 54194 "preproc.c"
    break;

  case 2308:
#line 13774 "preproc.y"
 { 
 (yyval.str) = mm_strdup("catalog");
}
#line 54202 "preproc.c"
    break;

  case 2309:
#line 13778 "preproc.y"
 { 
 (yyval.str) = mm_strdup("chain");
}
#line 54210 "preproc.c"
    break;

  case 2310:
#line 13782 "preproc.y"
 { 
 (yyval.str) = mm_strdup("characteristics");
}
#line 54218 "preproc.c"
    break;

  case 2311:
#line 13786 "preproc.y"
 { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 54226 "preproc.c"
    break;

  case 2312:
#line 13790 "preproc.y"
 { 
 (yyval.str) = mm_strdup("class");
}
#line 54234 "preproc.c"
    break;

  case 2313:
#line 13794 "preproc.y"
 { 
 (yyval.str) = mm_strdup("close");
}
#line 54242 "preproc.c"
    break;

  case 2314:
#line 13798 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cluster");
}
#line 54250 "preproc.c"
    break;

  case 2315:
#line 13802 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comment");
}
#line 54258 "preproc.c"
    break;

  case 2316:
#line 13806 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comments");
}
#line 54266 "preproc.c"
    break;

  case 2317:
#line 13810 "preproc.y"
 { 
 (yyval.str) = mm_strdup("commit");
}
#line 54274 "preproc.c"
    break;

  case 2318:
#line 13814 "preproc.y"
 { 
 (yyval.str) = mm_strdup("committed");
}
#line 54282 "preproc.c"
    break;

  case 2319:
#line 13818 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrency");
}
#line 54290 "preproc.c"
    break;

  case 2320:
#line 13822 "preproc.y"
 { 
 (yyval.str) = mm_strdup("configuration");
}
#line 54298 "preproc.c"
    break;

  case 2321:
#line 13826 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraints");
}
#line 54306 "preproc.c"
    break;

  case 2322:
#line 13830 "preproc.y"
 { 
 (yyval.str) = mm_strdup("contains");
}
#line 54314 "preproc.c"
    break;

  case 2323:
#line 13834 "preproc.y"
 { 
 (yyval.str) = mm_strdup("content");
}
#line 54322 "preproc.c"
    break;

  case 2324:
#line 13838 "preproc.y"
 { 
 (yyval.str) = mm_strdup("continue");
}
#line 54330 "preproc.c"
    break;

  case 2325:
#line 13842 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 54338 "preproc.c"
    break;

  case 2326:
#line 13846 "preproc.y"
 { 
 (yyval.str) = mm_strdup("copy");
}
#line 54346 "preproc.c"
    break;

  case 2327:
#line 13850 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cost");
}
#line 54354 "preproc.c"
    break;

  case 2328:
#line 13854 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cpuset");
}
#line 54362 "preproc.c"
    break;

  case 2329:
#line 13858 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cpu_rate_limit");
}
#line 54370 "preproc.c"
    break;

  case 2330:
#line 13862 "preproc.y"
 { 
 (yyval.str) = mm_strdup("createexttable");
}
#line 54378 "preproc.c"
    break;

  case 2331:
#line 13866 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 54386 "preproc.c"
    break;

  case 2332:
#line 13870 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cube");
}
#line 54394 "preproc.c"
    break;

  case 2333:
#line 13874 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cursor");
}
#line 54402 "preproc.c"
    break;

  case 2334:
#line 13878 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cycle");
}
#line 54410 "preproc.c"
    break;

  case 2335:
#line 13882 "preproc.y"
 { 
 (yyval.str) = mm_strdup("data");
}
#line 54418 "preproc.c"
    break;

  case 2336:
#line 13886 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 54426 "preproc.c"
    break;

  case 2337:
#line 13890 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deallocate");
}
#line 54434 "preproc.c"
    break;

  case 2338:
#line 13894 "preproc.y"
 { 
 (yyval.str) = mm_strdup("declare");
}
#line 54442 "preproc.c"
    break;

  case 2339:
#line 13898 "preproc.y"
 { 
 (yyval.str) = mm_strdup("defaults");
}
#line 54450 "preproc.c"
    break;

  case 2340:
#line 13902 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferred");
}
#line 54458 "preproc.c"
    break;

  case 2341:
#line 13906 "preproc.y"
 { 
 (yyval.str) = mm_strdup("definer");
}
#line 54466 "preproc.c"
    break;

  case 2342:
#line 13910 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 54474 "preproc.c"
    break;

  case 2343:
#line 13914 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiter");
}
#line 54482 "preproc.c"
    break;

  case 2344:
#line 13918 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiters");
}
#line 54490 "preproc.c"
    break;

  case 2345:
#line 13922 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deny");
}
#line 54498 "preproc.c"
    break;

  case 2346:
#line 13926 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dictionary");
}
#line 54506 "preproc.c"
    break;

  case 2347:
#line 13930 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable");
}
#line 54514 "preproc.c"
    break;

  case 2348:
#line 13934 "preproc.y"
 { 
 (yyval.str) = mm_strdup("discard");
}
#line 54522 "preproc.c"
    break;

  case 2349:
#line 13938 "preproc.y"
 { 
 (yyval.str) = mm_strdup("document");
}
#line 54530 "preproc.c"
    break;

  case 2350:
#line 13942 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 54538 "preproc.c"
    break;

  case 2351:
#line 13946 "preproc.y"
 { 
 (yyval.str) = mm_strdup("double");
}
#line 54546 "preproc.c"
    break;

  case 2352:
#line 13950 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop");
}
#line 54554 "preproc.c"
    break;

  case 2353:
#line 13954 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dxl");
}
#line 54562 "preproc.c"
    break;

  case 2354:
#line 13958 "preproc.y"
 { 
 (yyval.str) = mm_strdup("each");
}
#line 54570 "preproc.c"
    break;

  case 2355:
#line 13962 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable");
}
#line 54578 "preproc.c"
    break;

  case 2356:
#line 13966 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encoding");
}
#line 54586 "preproc.c"
    break;

  case 2357:
#line 13970 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encrypted");
}
#line 54594 "preproc.c"
    break;

  case 2358:
#line 13974 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enum");
}
#line 54602 "preproc.c"
    break;

  case 2359:
#line 13978 "preproc.y"
 { 
 (yyval.str) = mm_strdup("errors");
}
#line 54610 "preproc.c"
    break;

  case 2360:
#line 13982 "preproc.y"
 { 
 (yyval.str) = mm_strdup("escape");
}
#line 54618 "preproc.c"
    break;

  case 2361:
#line 13986 "preproc.y"
 { 
 (yyval.str) = mm_strdup("event");
}
#line 54626 "preproc.c"
    break;

  case 2362:
#line 13990 "preproc.y"
 { 
 (yyval.str) = mm_strdup("every");
}
#line 54634 "preproc.c"
    break;

  case 2363:
#line 13994 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exchange");
}
#line 54642 "preproc.c"
    break;

  case 2364:
#line 13998 "preproc.y"
 { 
 (yyval.str) = mm_strdup("excluding");
}
#line 54650 "preproc.c"
    break;

  case 2365:
#line 14002 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 54658 "preproc.c"
    break;

  case 2366:
#line 14006 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute");
}
#line 54666 "preproc.c"
    break;

  case 2367:
#line 14010 "preproc.y"
 { 
 (yyval.str) = mm_strdup("expand");
}
#line 54674 "preproc.c"
    break;

  case 2368:
#line 14014 "preproc.y"
 { 
 (yyval.str) = mm_strdup("explain");
}
#line 54682 "preproc.c"
    break;

  case 2369:
#line 14018 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extension");
}
#line 54690 "preproc.c"
    break;

  case 2370:
#line 14022 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external");
}
#line 54698 "preproc.c"
    break;

  case 2371:
#line 14026 "preproc.y"
 { 
 (yyval.str) = mm_strdup("family");
}
#line 54706 "preproc.c"
    break;

  case 2372:
#line 14030 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fields");
}
#line 54714 "preproc.c"
    break;

  case 2373:
#line 14034 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fill");
}
#line 54722 "preproc.c"
    break;

  case 2374:
#line 14038 "preproc.y"
 { 
 (yyval.str) = mm_strdup("filter");
}
#line 54730 "preproc.c"
    break;

  case 2375:
#line 14042 "preproc.y"
 { 
 (yyval.str) = mm_strdup("first");
}
#line 54738 "preproc.c"
    break;

  case 2376:
#line 14046 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force");
}
#line 54746 "preproc.c"
    break;

  case 2377:
#line 14050 "preproc.y"
 { 
 (yyval.str) = mm_strdup("format");
}
#line 54754 "preproc.c"
    break;

  case 2378:
#line 14054 "preproc.y"
 { 
 (yyval.str) = mm_strdup("forward");
}
#line 54762 "preproc.c"
    break;

  case 2379:
#line 14058 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fullscan");
}
#line 54770 "preproc.c"
    break;

  case 2380:
#line 14062 "preproc.y"
 { 
 (yyval.str) = mm_strdup("function");
}
#line 54778 "preproc.c"
    break;

  case 2381:
#line 14066 "preproc.y"
 { 
 (yyval.str) = mm_strdup("functions");
}
#line 54786 "preproc.c"
    break;

  case 2382:
#line 14070 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global");
}
#line 54794 "preproc.c"
    break;

  case 2383:
#line 14074 "preproc.y"
 { 
 (yyval.str) = mm_strdup("granted");
}
#line 54802 "preproc.c"
    break;

  case 2384:
#line 14078 "preproc.y"
 { 
 (yyval.str) = mm_strdup("handler");
}
#line 54810 "preproc.c"
    break;

  case 2385:
#line 14082 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hash");
}
#line 54818 "preproc.c"
    break;

  case 2386:
#line 14086 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 54826 "preproc.c"
    break;

  case 2387:
#line 14090 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hold");
}
#line 54834 "preproc.c"
    break;

  case 2388:
#line 14094 "preproc.y"
 { 
 (yyval.str) = mm_strdup("host");
}
#line 54842 "preproc.c"
    break;

  case 2389:
#line 14098 "preproc.y"
 { 
 (yyval.str) = mm_strdup("identity");
}
#line 54850 "preproc.c"
    break;

  case 2390:
#line 14102 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if");
}
#line 54858 "preproc.c"
    break;

  case 2391:
#line 14106 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ignore");
}
#line 54866 "preproc.c"
    break;

  case 2392:
#line 14110 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immediate");
}
#line 54874 "preproc.c"
    break;

  case 2393:
#line 14114 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immutable");
}
#line 54882 "preproc.c"
    break;

  case 2394:
#line 14118 "preproc.y"
 { 
 (yyval.str) = mm_strdup("implicit");
}
#line 54890 "preproc.c"
    break;

  case 2395:
#line 14122 "preproc.y"
 { 
 (yyval.str) = mm_strdup("including");
}
#line 54898 "preproc.c"
    break;

  case 2396:
#line 14126 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inclusive");
}
#line 54906 "preproc.c"
    break;

  case 2397:
#line 14130 "preproc.y"
 { 
 (yyval.str) = mm_strdup("increment");
}
#line 54914 "preproc.c"
    break;

  case 2398:
#line 14134 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 54922 "preproc.c"
    break;

  case 2399:
#line 14138 "preproc.y"
 { 
 (yyval.str) = mm_strdup("indexes");
}
#line 54930 "preproc.c"
    break;

  case 2400:
#line 14142 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherit");
}
#line 54938 "preproc.c"
    break;

  case 2401:
#line 14146 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherits");
}
#line 54946 "preproc.c"
    break;

  case 2402:
#line 14150 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initplan");
}
#line 54954 "preproc.c"
    break;

  case 2403:
#line 14154 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inline");
}
#line 54962 "preproc.c"
    break;

  case 2404:
#line 14158 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insensitive");
}
#line 54970 "preproc.c"
    break;

  case 2405:
#line 14162 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 54978 "preproc.c"
    break;

  case 2406:
#line 14166 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead");
}
#line 54986 "preproc.c"
    break;

  case 2407:
#line 14170 "preproc.y"
 { 
 (yyval.str) = mm_strdup("invoker");
}
#line 54994 "preproc.c"
    break;

  case 2408:
#line 14174 "preproc.y"
 { 
 (yyval.str) = mm_strdup("isolation");
}
#line 55002 "preproc.c"
    break;

  case 2409:
#line 14178 "preproc.y"
 { 
 (yyval.str) = mm_strdup("key");
}
#line 55010 "preproc.c"
    break;

  case 2410:
#line 14182 "preproc.y"
 { 
 (yyval.str) = mm_strdup("label");
}
#line 55018 "preproc.c"
    break;

  case 2411:
#line 14186 "preproc.y"
 { 
 (yyval.str) = mm_strdup("language");
}
#line 55026 "preproc.c"
    break;

  case 2412:
#line 14190 "preproc.y"
 { 
 (yyval.str) = mm_strdup("large");
}
#line 55034 "preproc.c"
    break;

  case 2413:
#line 14194 "preproc.y"
 { 
 (yyval.str) = mm_strdup("last");
}
#line 55042 "preproc.c"
    break;

  case 2414:
#line 14198 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lc_collate");
}
#line 55050 "preproc.c"
    break;

  case 2415:
#line 14202 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lc_ctype");
}
#line 55058 "preproc.c"
    break;

  case 2416:
#line 14206 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leakproof");
}
#line 55066 "preproc.c"
    break;

  case 2417:
#line 14210 "preproc.y"
 { 
 (yyval.str) = mm_strdup("level");
}
#line 55074 "preproc.c"
    break;

  case 2418:
#line 14214 "preproc.y"
 { 
 (yyval.str) = mm_strdup("list");
}
#line 55082 "preproc.c"
    break;

  case 2419:
#line 14218 "preproc.y"
 { 
 (yyval.str) = mm_strdup("listen");
}
#line 55090 "preproc.c"
    break;

  case 2420:
#line 14222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("load");
}
#line 55098 "preproc.c"
    break;

  case 2421:
#line 14226 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local");
}
#line 55106 "preproc.c"
    break;

  case 2422:
#line 14230 "preproc.y"
 { 
 (yyval.str) = mm_strdup("location");
}
#line 55114 "preproc.c"
    break;

  case 2423:
#line 14234 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lock");
}
#line 55122 "preproc.c"
    break;

  case 2424:
#line 14238 "preproc.y"
 { 
 (yyval.str) = mm_strdup("mapping");
}
#line 55130 "preproc.c"
    break;

  case 2425:
#line 14242 "preproc.y"
 { 
 (yyval.str) = mm_strdup("master");
}
#line 55138 "preproc.c"
    break;

  case 2426:
#line 14246 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match");
}
#line 55146 "preproc.c"
    break;

  case 2427:
#line 14250 "preproc.y"
 { 
 (yyval.str) = mm_strdup("materialized");
}
#line 55154 "preproc.c"
    break;

  case 2428:
#line 14254 "preproc.y"
 { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 55162 "preproc.c"
    break;

  case 2429:
#line 14258 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_limit");
}
#line 55170 "preproc.c"
    break;

  case 2430:
#line 14262 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_shared_quota");
}
#line 55178 "preproc.c"
    break;

  case 2431:
#line 14266 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_spill_ratio");
}
#line 55186 "preproc.c"
    break;

  case 2432:
#line 14270 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 55194 "preproc.c"
    break;

  case 2433:
#line 14274 "preproc.y"
 { 
 (yyval.str) = mm_strdup("missing");
}
#line 55202 "preproc.c"
    break;

  case 2434:
#line 14278 "preproc.y"
 { 
 (yyval.str) = mm_strdup("mode");
}
#line 55210 "preproc.c"
    break;

  case 2435:
#line 14282 "preproc.y"
 { 
 (yyval.str) = mm_strdup("modifies");
}
#line 55218 "preproc.c"
    break;

  case 2436:
#line 14286 "preproc.y"
 { 
 (yyval.str) = mm_strdup("move");
}
#line 55226 "preproc.c"
    break;

  case 2437:
#line 14290 "preproc.y"
 { 
 (yyval.str) = mm_strdup("name");
}
#line 55234 "preproc.c"
    break;

  case 2438:
#line 14294 "preproc.y"
 { 
 (yyval.str) = mm_strdup("names");
}
#line 55242 "preproc.c"
    break;

  case 2439:
#line 14298 "preproc.y"
 { 
 (yyval.str) = mm_strdup("newline");
}
#line 55250 "preproc.c"
    break;

  case 2440:
#line 14302 "preproc.y"
 { 
 (yyval.str) = mm_strdup("next");
}
#line 55258 "preproc.c"
    break;

  case 2441:
#line 14306 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no");
}
#line 55266 "preproc.c"
    break;

  case 2442:
#line 14310 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nocreateexttable");
}
#line 55274 "preproc.c"
    break;

  case 2443:
#line 14314 "preproc.y"
 { 
 (yyval.str) = mm_strdup("noovercommit");
}
#line 55282 "preproc.c"
    break;

  case 2444:
#line 14318 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 55290 "preproc.c"
    break;

  case 2445:
#line 14322 "preproc.y"
 { 
 (yyval.str) = mm_strdup("notify");
}
#line 55298 "preproc.c"
    break;

  case 2446:
#line 14326 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 55306 "preproc.c"
    break;

  case 2447:
#line 14330 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls");
}
#line 55314 "preproc.c"
    break;

  case 2448:
#line 14334 "preproc.y"
 { 
 (yyval.str) = mm_strdup("object");
}
#line 55322 "preproc.c"
    break;

  case 2449:
#line 14338 "preproc.y"
 { 
 (yyval.str) = mm_strdup("of");
}
#line 55330 "preproc.c"
    break;

  case 2450:
#line 14342 "preproc.y"
 { 
 (yyval.str) = mm_strdup("off");
}
#line 55338 "preproc.c"
    break;

  case 2451:
#line 14346 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oids");
}
#line 55346 "preproc.c"
    break;

  case 2452:
#line 14350 "preproc.y"
 { 
 (yyval.str) = mm_strdup("operator");
}
#line 55354 "preproc.c"
    break;

  case 2453:
#line 14354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("option");
}
#line 55362 "preproc.c"
    break;

  case 2454:
#line 14358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("options");
}
#line 55370 "preproc.c"
    break;

  case 2455:
#line 14362 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ordered");
}
#line 55378 "preproc.c"
    break;

  case 2456:
#line 14366 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ordinality");
}
#line 55386 "preproc.c"
    break;

  case 2457:
#line 14370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("others");
}
#line 55394 "preproc.c"
    break;

  case 2458:
#line 14374 "preproc.y"
 { 
 (yyval.str) = mm_strdup("over");
}
#line 55402 "preproc.c"
    break;

  case 2459:
#line 14378 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overcommit");
}
#line 55410 "preproc.c"
    break;

  case 2460:
#line 14382 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owned");
}
#line 55418 "preproc.c"
    break;

  case 2461:
#line 14386 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owner");
}
#line 55426 "preproc.c"
    break;

  case 2462:
#line 14390 "preproc.y"
 { 
 (yyval.str) = mm_strdup("parser");
}
#line 55434 "preproc.c"
    break;

  case 2463:
#line 14394 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partial");
}
#line 55442 "preproc.c"
    break;

  case 2464:
#line 14398 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partitions");
}
#line 55450 "preproc.c"
    break;

  case 2465:
#line 14402 "preproc.y"
 { 
 (yyval.str) = mm_strdup("passing");
}
#line 55458 "preproc.c"
    break;

  case 2466:
#line 14406 "preproc.y"
 { 
 (yyval.str) = mm_strdup("password");
}
#line 55466 "preproc.c"
    break;

  case 2467:
#line 14410 "preproc.y"
 { 
 (yyval.str) = mm_strdup("percent");
}
#line 55474 "preproc.c"
    break;

  case 2468:
#line 14414 "preproc.y"
 { 
 (yyval.str) = mm_strdup("persistently");
}
#line 55482 "preproc.c"
    break;

  case 2469:
#line 14418 "preproc.y"
 { 
 (yyval.str) = mm_strdup("plans");
}
#line 55490 "preproc.c"
    break;

  case 2470:
#line 14422 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepare");
}
#line 55498 "preproc.c"
    break;

  case 2471:
#line 14426 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepared");
}
#line 55506 "preproc.c"
    break;

  case 2472:
#line 14430 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preserve");
}
#line 55514 "preproc.c"
    break;

  case 2473:
#line 14434 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prior");
}
#line 55522 "preproc.c"
    break;

  case 2474:
#line 14438 "preproc.y"
 { 
 (yyval.str) = mm_strdup("privileges");
}
#line 55530 "preproc.c"
    break;

  case 2475:
#line 14442 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedural");
}
#line 55538 "preproc.c"
    break;

  case 2476:
#line 14446 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedure");
}
#line 55546 "preproc.c"
    break;

  case 2477:
#line 14450 "preproc.y"
 { 
 (yyval.str) = mm_strdup("program");
}
#line 55554 "preproc.c"
    break;

  case 2478:
#line 14454 "preproc.y"
 { 
 (yyval.str) = mm_strdup("protocol");
}
#line 55562 "preproc.c"
    break;

  case 2479:
#line 14458 "preproc.y"
 { 
 (yyval.str) = mm_strdup("queue");
}
#line 55570 "preproc.c"
    break;

  case 2480:
#line 14462 "preproc.y"
 { 
 (yyval.str) = mm_strdup("quote");
}
#line 55578 "preproc.c"
    break;

  case 2481:
#line 14466 "preproc.y"
 { 
 (yyval.str) = mm_strdup("randomly");
}
#line 55586 "preproc.c"
    break;

  case 2482:
#line 14470 "preproc.y"
 { 
 (yyval.str) = mm_strdup("range");
}
#line 55594 "preproc.c"
    break;

  case 2483:
#line 14474 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read");
}
#line 55602 "preproc.c"
    break;

  case 2484:
#line 14478 "preproc.y"
 { 
 (yyval.str) = mm_strdup("readable");
}
#line 55610 "preproc.c"
    break;

  case 2485:
#line 14482 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reads");
}
#line 55618 "preproc.c"
    break;

  case 2486:
#line 14486 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reassign");
}
#line 55626 "preproc.c"
    break;

  case 2487:
#line 14490 "preproc.y"
 { 
 (yyval.str) = mm_strdup("recheck");
}
#line 55634 "preproc.c"
    break;

  case 2488:
#line 14494 "preproc.y"
 { 
 (yyval.str) = mm_strdup("recursive");
}
#line 55642 "preproc.c"
    break;

  case 2489:
#line 14498 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ref");
}
#line 55650 "preproc.c"
    break;

  case 2490:
#line 14502 "preproc.y"
 { 
 (yyval.str) = mm_strdup("refresh");
}
#line 55658 "preproc.c"
    break;

  case 2491:
#line 14506 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reindex");
}
#line 55666 "preproc.c"
    break;

  case 2492:
#line 14510 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reject");
}
#line 55674 "preproc.c"
    break;

  case 2493:
#line 14514 "preproc.y"
 { 
 (yyval.str) = mm_strdup("relative");
}
#line 55682 "preproc.c"
    break;

  case 2494:
#line 14518 "preproc.y"
 { 
 (yyval.str) = mm_strdup("release");
}
#line 55690 "preproc.c"
    break;

  case 2495:
#line 14522 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rename");
}
#line 55698 "preproc.c"
    break;

  case 2496:
#line 14526 "preproc.y"
 { 
 (yyval.str) = mm_strdup("repeatable");
}
#line 55706 "preproc.c"
    break;

  case 2497:
#line 14530 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replace");
}
#line 55714 "preproc.c"
    break;

  case 2498:
#line 14534 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replica");
}
#line 55722 "preproc.c"
    break;

  case 2499:
#line 14538 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replicated");
}
#line 55730 "preproc.c"
    break;

  case 2500:
#line 14542 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reset");
}
#line 55738 "preproc.c"
    break;

  case 2501:
#line 14546 "preproc.y"
 { 
 (yyval.str) = mm_strdup("resource");
}
#line 55746 "preproc.c"
    break;

  case 2502:
#line 14550 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 55754 "preproc.c"
    break;

  case 2503:
#line 14554 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 55762 "preproc.c"
    break;

  case 2504:
#line 14558 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returns");
}
#line 55770 "preproc.c"
    break;

  case 2505:
#line 14562 "preproc.y"
 { 
 (yyval.str) = mm_strdup("revoke");
}
#line 55778 "preproc.c"
    break;

  case 2506:
#line 14566 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 55786 "preproc.c"
    break;

  case 2507:
#line 14570 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollback");
}
#line 55794 "preproc.c"
    break;

  case 2508:
#line 14574 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rootpartition");
}
#line 55802 "preproc.c"
    break;

  case 2509:
#line 14578 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 55810 "preproc.c"
    break;

  case 2510:
#line 14582 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rule");
}
#line 55818 "preproc.c"
    break;

  case 2511:
#line 14586 "preproc.y"
 { 
 (yyval.str) = mm_strdup("savepoint");
}
#line 55826 "preproc.c"
    break;

  case 2512:
#line 14590 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 55834 "preproc.c"
    break;

  case 2513:
#line 14594 "preproc.y"
 { 
 (yyval.str) = mm_strdup("scroll");
}
#line 55842 "preproc.c"
    break;

  case 2514:
#line 14598 "preproc.y"
 { 
 (yyval.str) = mm_strdup("search");
}
#line 55850 "preproc.c"
    break;

  case 2515:
#line 14602 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security");
}
#line 55858 "preproc.c"
    break;

  case 2516:
#line 14606 "preproc.y"
 { 
 (yyval.str) = mm_strdup("segment");
}
#line 55866 "preproc.c"
    break;

  case 2517:
#line 14610 "preproc.y"
 { 
 (yyval.str) = mm_strdup("segments");
}
#line 55874 "preproc.c"
    break;

  case 2518:
#line 14614 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 55882 "preproc.c"
    break;

  case 2519:
#line 14618 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequences");
}
#line 55890 "preproc.c"
    break;

  case 2520:
#line 14622 "preproc.y"
 { 
 (yyval.str) = mm_strdup("serializable");
}
#line 55898 "preproc.c"
    break;

  case 2521:
#line 14626 "preproc.y"
 { 
 (yyval.str) = mm_strdup("server");
}
#line 55906 "preproc.c"
    break;

  case 2522:
#line 14630 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session");
}
#line 55914 "preproc.c"
    break;

  case 2523:
#line 14634 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set");
}
#line 55922 "preproc.c"
    break;

  case 2524:
#line 14638 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share");
}
#line 55930 "preproc.c"
    break;

  case 2525:
#line 14642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show");
}
#line 55938 "preproc.c"
    break;

  case 2526:
#line 14646 "preproc.y"
 { 
 (yyval.str) = mm_strdup("simple");
}
#line 55946 "preproc.c"
    break;

  case 2527:
#line 14650 "preproc.y"
 { 
 (yyval.str) = mm_strdup("snapshot");
}
#line 55954 "preproc.c"
    break;

  case 2528:
#line 14654 "preproc.y"
 { 
 (yyval.str) = mm_strdup("split");
}
#line 55962 "preproc.c"
    break;

  case 2529:
#line 14658 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sql");
}
#line 55970 "preproc.c"
    break;

  case 2530:
#line 14662 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stable");
}
#line 55978 "preproc.c"
    break;

  case 2531:
#line 14666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("standalone");
}
#line 55986 "preproc.c"
    break;

  case 2532:
#line 14670 "preproc.y"
 { 
 (yyval.str) = mm_strdup("start");
}
#line 55994 "preproc.c"
    break;

  case 2533:
#line 14674 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statement");
}
#line 56002 "preproc.c"
    break;

  case 2534:
#line 14678 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statistics");
}
#line 56010 "preproc.c"
    break;

  case 2535:
#line 14682 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdin");
}
#line 56018 "preproc.c"
    break;

  case 2536:
#line 14686 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdout");
}
#line 56026 "preproc.c"
    break;

  case 2537:
#line 14690 "preproc.y"
 { 
 (yyval.str) = mm_strdup("storage");
}
#line 56034 "preproc.c"
    break;

  case 2538:
#line 14694 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strict");
}
#line 56042 "preproc.c"
    break;

  case 2539:
#line 14698 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strip");
}
#line 56050 "preproc.c"
    break;

  case 2540:
#line 14702 "preproc.y"
 { 
 (yyval.str) = mm_strdup("subpartition");
}
#line 56058 "preproc.c"
    break;

  case 2541:
#line 14706 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sysid");
}
#line 56066 "preproc.c"
    break;

  case 2542:
#line 14710 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system");
}
#line 56074 "preproc.c"
    break;

  case 2543:
#line 14714 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tables");
}
#line 56082 "preproc.c"
    break;

  case 2544:
#line 14718 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 56090 "preproc.c"
    break;

  case 2545:
#line 14722 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temp");
}
#line 56098 "preproc.c"
    break;

  case 2546:
#line 14726 "preproc.y"
 { 
 (yyval.str) = mm_strdup("template");
}
#line 56106 "preproc.c"
    break;

  case 2547:
#line 14730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temporary");
}
#line 56114 "preproc.c"
    break;

  case 2548:
#line 14734 "preproc.y"
 { 
 (yyval.str) = mm_strdup("text");
}
#line 56122 "preproc.c"
    break;

  case 2549:
#line 14738 "preproc.y"
 { 
 (yyval.str) = mm_strdup("threshold");
}
#line 56130 "preproc.c"
    break;

  case 2550:
#line 14742 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ties");
}
#line 56138 "preproc.c"
    break;

  case 2551:
#line 14746 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction");
}
#line 56146 "preproc.c"
    break;

  case 2552:
#line 14750 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trigger");
}
#line 56154 "preproc.c"
    break;

  case 2553:
#line 14754 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate");
}
#line 56162 "preproc.c"
    break;

  case 2554:
#line 14758 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trusted");
}
#line 56170 "preproc.c"
    break;

  case 2555:
#line 14762 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 56178 "preproc.c"
    break;

  case 2556:
#line 14766 "preproc.y"
 { 
 (yyval.str) = mm_strdup("types");
}
#line 56186 "preproc.c"
    break;

  case 2557:
#line 14770 "preproc.y"
 { 
 (yyval.str) = mm_strdup("uncommitted");
}
#line 56194 "preproc.c"
    break;

  case 2558:
#line 14774 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unencrypted");
}
#line 56202 "preproc.c"
    break;

  case 2559:
#line 14778 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unknown");
}
#line 56210 "preproc.c"
    break;

  case 2560:
#line 14782 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlisten");
}
#line 56218 "preproc.c"
    break;

  case 2561:
#line 14786 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlogged");
}
#line 56226 "preproc.c"
    break;

  case 2562:
#line 14790 "preproc.y"
 { 
 (yyval.str) = mm_strdup("until");
}
#line 56234 "preproc.c"
    break;

  case 2563:
#line 14794 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 56242 "preproc.c"
    break;

  case 2564:
#line 14798 "preproc.y"
 { 
 (yyval.str) = mm_strdup("vacuum");
}
#line 56250 "preproc.c"
    break;

  case 2565:
#line 14802 "preproc.y"
 { 
 (yyval.str) = mm_strdup("valid");
}
#line 56258 "preproc.c"
    break;

  case 2566:
#line 14806 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validate");
}
#line 56266 "preproc.c"
    break;

  case 2567:
#line 14810 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validation");
}
#line 56274 "preproc.c"
    break;

  case 2568:
#line 14814 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validator");
}
#line 56282 "preproc.c"
    break;

  case 2569:
#line 14818 "preproc.y"
 { 
 (yyval.str) = mm_strdup("value");
}
#line 56290 "preproc.c"
    break;

  case 2570:
#line 14822 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varying");
}
#line 56298 "preproc.c"
    break;

  case 2571:
#line 14826 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version");
}
#line 56306 "preproc.c"
    break;

  case 2572:
#line 14830 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 56314 "preproc.c"
    break;

  case 2573:
#line 14834 "preproc.y"
 { 
 (yyval.str) = mm_strdup("views");
}
#line 56322 "preproc.c"
    break;

  case 2574:
#line 14838 "preproc.y"
 { 
 (yyval.str) = mm_strdup("volatile");
}
#line 56330 "preproc.c"
    break;

  case 2575:
#line 14842 "preproc.y"
 { 
 (yyval.str) = mm_strdup("web");
}
#line 56338 "preproc.c"
    break;

  case 2576:
#line 14846 "preproc.y"
 { 
 (yyval.str) = mm_strdup("whitespace");
}
#line 56346 "preproc.c"
    break;

  case 2577:
#line 14850 "preproc.y"
 { 
 (yyval.str) = mm_strdup("within");
}
#line 56354 "preproc.c"
    break;

  case 2578:
#line 14854 "preproc.y"
 { 
 (yyval.str) = mm_strdup("without");
}
#line 56362 "preproc.c"
    break;

  case 2579:
#line 14858 "preproc.y"
 { 
 (yyval.str) = mm_strdup("work");
}
#line 56370 "preproc.c"
    break;

  case 2580:
#line 14862 "preproc.y"
 { 
 (yyval.str) = mm_strdup("wrapper");
}
#line 56378 "preproc.c"
    break;

  case 2581:
#line 14866 "preproc.y"
 { 
 (yyval.str) = mm_strdup("writable");
}
#line 56386 "preproc.c"
    break;

  case 2582:
#line 14870 "preproc.y"
 { 
 (yyval.str) = mm_strdup("write");
}
#line 56394 "preproc.c"
    break;

  case 2583:
#line 14874 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xml");
}
#line 56402 "preproc.c"
    break;

  case 2584:
#line 14878 "preproc.y"
 { 
 (yyval.str) = mm_strdup("yes");
}
#line 56410 "preproc.c"
    break;

  case 2585:
#line 14882 "preproc.y"
 { 
 (yyval.str) = mm_strdup("zone");
}
#line 56418 "preproc.c"
    break;

  case 2586:
#line 14890 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56426 "preproc.c"
    break;

  case 2587:
#line 14898 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56434 "preproc.c"
    break;

  case 2588:
#line 14902 "preproc.y"
 { 
 (yyval.str) = mm_strdup("tablespace");
}
#line 56442 "preproc.c"
    break;

  case 2589:
#line 14906 "preproc.y"
 { 
 (yyval.str) = mm_strdup("add");
}
#line 56450 "preproc.c"
    break;

  case 2590:
#line 14910 "preproc.y"
 { 
 (yyval.str) = mm_strdup("alter");
}
#line 56458 "preproc.c"
    break;

  case 2591:
#line 14914 "preproc.y"
 { 
 (yyval.str) = mm_strdup("at");
}
#line 56466 "preproc.c"
    break;

  case 2592:
#line 14922 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56474 "preproc.c"
    break;

  case 2593:
#line 14926 "preproc.y"
 { 
 (yyval.str) = (yyvsp[0].str);
}
#line 56482 "preproc.c"
    break;

  case 2594:
#line 14934 "preproc.y"
 { 
 (yyval.str) = mm_strdup("abort");
}
#line 56490 "preproc.c"
    break;

  case 2595:
#line 14938 "preproc.y"
 { 
 (yyval.str) = mm_strdup("absolute");
}
#line 56498 "preproc.c"
    break;

  case 2596:
#line 14942 "preproc.y"
 { 
 (yyval.str) = mm_strdup("access");
}
#line 56506 "preproc.c"
    break;

  case 2597:
#line 14946 "preproc.y"
 { 
 (yyval.str) = mm_strdup("action");
}
#line 56514 "preproc.c"
    break;

  case 2598:
#line 14950 "preproc.y"
 { 
 (yyval.str) = mm_strdup("active");
}
#line 56522 "preproc.c"
    break;

  case 2599:
#line 14954 "preproc.y"
 { 
 (yyval.str) = mm_strdup("admin");
}
#line 56530 "preproc.c"
    break;

  case 2600:
#line 14958 "preproc.y"
 { 
 (yyval.str) = mm_strdup("after");
}
#line 56538 "preproc.c"
    break;

  case 2601:
#line 14962 "preproc.y"
 { 
 (yyval.str) = mm_strdup("aggregate");
}
#line 56546 "preproc.c"
    break;

  case 2602:
#line 14966 "preproc.y"
 { 
 (yyval.str) = mm_strdup("also");
}
#line 56554 "preproc.c"
    break;

  case 2603:
#line 14970 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assertion");
}
#line 56562 "preproc.c"
    break;

  case 2604:
#line 14974 "preproc.y"
 { 
 (yyval.str) = mm_strdup("assignment");
}
#line 56570 "preproc.c"
    break;

  case 2605:
#line 14978 "preproc.y"
 { 
 (yyval.str) = mm_strdup("backward");
}
#line 56578 "preproc.c"
    break;

  case 2606:
#line 14982 "preproc.y"
 { 
 (yyval.str) = mm_strdup("before");
}
#line 56586 "preproc.c"
    break;

  case 2607:
#line 14986 "preproc.y"
 { 
 (yyval.str) = mm_strdup("begin");
}
#line 56594 "preproc.c"
    break;

  case 2608:
#line 14990 "preproc.y"
 { 
 (yyval.str) = mm_strdup("by");
}
#line 56602 "preproc.c"
    break;

  case 2609:
#line 14994 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cache");
}
#line 56610 "preproc.c"
    break;

  case 2610:
#line 14998 "preproc.y"
 { 
 (yyval.str) = mm_strdup("called");
}
#line 56618 "preproc.c"
    break;

  case 2611:
#line 15002 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascade");
}
#line 56626 "preproc.c"
    break;

  case 2612:
#line 15006 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cascaded");
}
#line 56634 "preproc.c"
    break;

  case 2613:
#line 15010 "preproc.y"
 { 
 (yyval.str) = mm_strdup("chain");
}
#line 56642 "preproc.c"
    break;

  case 2614:
#line 15014 "preproc.y"
 { 
 (yyval.str) = mm_strdup("characteristics");
}
#line 56650 "preproc.c"
    break;

  case 2615:
#line 15018 "preproc.y"
 { 
 (yyval.str) = mm_strdup("checkpoint");
}
#line 56658 "preproc.c"
    break;

  case 2616:
#line 15022 "preproc.y"
 { 
 (yyval.str) = mm_strdup("class");
}
#line 56666 "preproc.c"
    break;

  case 2617:
#line 15026 "preproc.y"
 { 
 (yyval.str) = mm_strdup("close");
}
#line 56674 "preproc.c"
    break;

  case 2618:
#line 15030 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cluster");
}
#line 56682 "preproc.c"
    break;

  case 2619:
#line 15034 "preproc.y"
 { 
 (yyval.str) = mm_strdup("comment");
}
#line 56690 "preproc.c"
    break;

  case 2620:
#line 15038 "preproc.y"
 { 
 (yyval.str) = mm_strdup("commit");
}
#line 56698 "preproc.c"
    break;

  case 2621:
#line 15042 "preproc.y"
 { 
 (yyval.str) = mm_strdup("committed");
}
#line 56706 "preproc.c"
    break;

  case 2622:
#line 15046 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrency");
}
#line 56714 "preproc.c"
    break;

  case 2623:
#line 15050 "preproc.y"
 { 
 (yyval.str) = mm_strdup("connection");
}
#line 56722 "preproc.c"
    break;

  case 2624:
#line 15054 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraints");
}
#line 56730 "preproc.c"
    break;

  case 2625:
#line 15058 "preproc.y"
 { 
 (yyval.str) = mm_strdup("contains");
}
#line 56738 "preproc.c"
    break;

  case 2626:
#line 15062 "preproc.y"
 { 
 (yyval.str) = mm_strdup("content");
}
#line 56746 "preproc.c"
    break;

  case 2627:
#line 15066 "preproc.y"
 { 
 (yyval.str) = mm_strdup("conversion");
}
#line 56754 "preproc.c"
    break;

  case 2628:
#line 15070 "preproc.y"
 { 
 (yyval.str) = mm_strdup("copy");
}
#line 56762 "preproc.c"
    break;

  case 2629:
#line 15074 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cost");
}
#line 56770 "preproc.c"
    break;

  case 2630:
#line 15078 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cpuset");
}
#line 56778 "preproc.c"
    break;

  case 2631:
#line 15082 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cpu_rate_limit");
}
#line 56786 "preproc.c"
    break;

  case 2632:
#line 15086 "preproc.y"
 { 
 (yyval.str) = mm_strdup("createexttable");
}
#line 56794 "preproc.c"
    break;

  case 2633:
#line 15090 "preproc.y"
 { 
 (yyval.str) = mm_strdup("csv");
}
#line 56802 "preproc.c"
    break;

  case 2634:
#line 15094 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cursor");
}
#line 56810 "preproc.c"
    break;

  case 2635:
#line 15098 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cycle");
}
#line 56818 "preproc.c"
    break;

  case 2636:
#line 15102 "preproc.y"
 { 
 (yyval.str) = mm_strdup("database");
}
#line 56826 "preproc.c"
    break;

  case 2637:
#line 15106 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deallocate");
}
#line 56834 "preproc.c"
    break;

  case 2638:
#line 15110 "preproc.y"
 { 
 (yyval.str) = mm_strdup("declare");
}
#line 56842 "preproc.c"
    break;

  case 2639:
#line 15114 "preproc.y"
 { 
 (yyval.str) = mm_strdup("defaults");
}
#line 56850 "preproc.c"
    break;

  case 2640:
#line 15118 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferred");
}
#line 56858 "preproc.c"
    break;

  case 2641:
#line 15122 "preproc.y"
 { 
 (yyval.str) = mm_strdup("definer");
}
#line 56866 "preproc.c"
    break;

  case 2642:
#line 15126 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delete");
}
#line 56874 "preproc.c"
    break;

  case 2643:
#line 15130 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiter");
}
#line 56882 "preproc.c"
    break;

  case 2644:
#line 15134 "preproc.y"
 { 
 (yyval.str) = mm_strdup("delimiters");
}
#line 56890 "preproc.c"
    break;

  case 2645:
#line 15138 "preproc.y"
 { 
 (yyval.str) = mm_strdup("disable");
}
#line 56898 "preproc.c"
    break;

  case 2646:
#line 15142 "preproc.y"
 { 
 (yyval.str) = mm_strdup("domain");
}
#line 56906 "preproc.c"
    break;

  case 2647:
#line 15146 "preproc.y"
 { 
 (yyval.str) = mm_strdup("double");
}
#line 56914 "preproc.c"
    break;

  case 2648:
#line 15150 "preproc.y"
 { 
 (yyval.str) = mm_strdup("drop");
}
#line 56922 "preproc.c"
    break;

  case 2649:
#line 15154 "preproc.y"
 { 
 (yyval.str) = mm_strdup("each");
}
#line 56930 "preproc.c"
    break;

  case 2650:
#line 15158 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enable");
}
#line 56938 "preproc.c"
    break;

  case 2651:
#line 15162 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encoding");
}
#line 56946 "preproc.c"
    break;

  case 2652:
#line 15166 "preproc.y"
 { 
 (yyval.str) = mm_strdup("encrypted");
}
#line 56954 "preproc.c"
    break;

  case 2653:
#line 15170 "preproc.y"
 { 
 (yyval.str) = mm_strdup("errors");
}
#line 56962 "preproc.c"
    break;

  case 2654:
#line 15174 "preproc.y"
 { 
 (yyval.str) = mm_strdup("enum");
}
#line 56970 "preproc.c"
    break;

  case 2655:
#line 15178 "preproc.y"
 { 
 (yyval.str) = mm_strdup("escape");
}
#line 56978 "preproc.c"
    break;

  case 2656:
#line 15182 "preproc.y"
 { 
 (yyval.str) = mm_strdup("every");
}
#line 56986 "preproc.c"
    break;

  case 2657:
#line 15186 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exchange");
}
#line 56994 "preproc.c"
    break;

  case 2658:
#line 15190 "preproc.y"
 { 
 (yyval.str) = mm_strdup("excluding");
}
#line 57002 "preproc.c"
    break;

  case 2659:
#line 15194 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclusive");
}
#line 57010 "preproc.c"
    break;

  case 2660:
#line 15198 "preproc.y"
 { 
 (yyval.str) = mm_strdup("execute");
}
#line 57018 "preproc.c"
    break;

  case 2661:
#line 15202 "preproc.y"
 { 
 (yyval.str) = mm_strdup("explain");
}
#line 57026 "preproc.c"
    break;

  case 2662:
#line 15206 "preproc.y"
 { 
 (yyval.str) = mm_strdup("external");
}
#line 57034 "preproc.c"
    break;

  case 2663:
#line 15210 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fields");
}
#line 57042 "preproc.c"
    break;

  case 2664:
#line 15214 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fill");
}
#line 57050 "preproc.c"
    break;

  case 2665:
#line 15218 "preproc.y"
 { 
 (yyval.str) = mm_strdup("first");
}
#line 57058 "preproc.c"
    break;

  case 2666:
#line 15222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("force");
}
#line 57066 "preproc.c"
    break;

  case 2667:
#line 15226 "preproc.y"
 { 
 (yyval.str) = mm_strdup("format");
}
#line 57074 "preproc.c"
    break;

  case 2668:
#line 15230 "preproc.y"
 { 
 (yyval.str) = mm_strdup("forward");
}
#line 57082 "preproc.c"
    break;

  case 2669:
#line 15234 "preproc.y"
 { 
 (yyval.str) = mm_strdup("function");
}
#line 57090 "preproc.c"
    break;

  case 2670:
#line 15238 "preproc.y"
 { 
 (yyval.str) = mm_strdup("global");
}
#line 57098 "preproc.c"
    break;

  case 2671:
#line 15242 "preproc.y"
 { 
 (yyval.str) = mm_strdup("granted");
}
#line 57106 "preproc.c"
    break;

  case 2672:
#line 15246 "preproc.y"
 { 
 (yyval.str) = mm_strdup("handler");
}
#line 57114 "preproc.c"
    break;

  case 2673:
#line 15250 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hash");
}
#line 57122 "preproc.c"
    break;

  case 2674:
#line 15254 "preproc.y"
 { 
 (yyval.str) = mm_strdup("header");
}
#line 57130 "preproc.c"
    break;

  case 2675:
#line 15258 "preproc.y"
 { 
 (yyval.str) = mm_strdup("hold");
}
#line 57138 "preproc.c"
    break;

  case 2676:
#line 15262 "preproc.y"
 { 
 (yyval.str) = mm_strdup("host");
}
#line 57146 "preproc.c"
    break;

  case 2677:
#line 15266 "preproc.y"
 { 
 (yyval.str) = mm_strdup("if");
}
#line 57154 "preproc.c"
    break;

  case 2678:
#line 15270 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immediate");
}
#line 57162 "preproc.c"
    break;

  case 2679:
#line 15274 "preproc.y"
 { 
 (yyval.str) = mm_strdup("immutable");
}
#line 57170 "preproc.c"
    break;

  case 2680:
#line 15278 "preproc.y"
 { 
 (yyval.str) = mm_strdup("implicit");
}
#line 57178 "preproc.c"
    break;

  case 2681:
#line 15282 "preproc.y"
 { 
 (yyval.str) = mm_strdup("including");
}
#line 57186 "preproc.c"
    break;

  case 2682:
#line 15286 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inclusive");
}
#line 57194 "preproc.c"
    break;

  case 2683:
#line 15290 "preproc.y"
 { 
 (yyval.str) = mm_strdup("increment");
}
#line 57202 "preproc.c"
    break;

  case 2684:
#line 15294 "preproc.y"
 { 
 (yyval.str) = mm_strdup("index");
}
#line 57210 "preproc.c"
    break;

  case 2685:
#line 15298 "preproc.y"
 { 
 (yyval.str) = mm_strdup("indexes");
}
#line 57218 "preproc.c"
    break;

  case 2686:
#line 15302 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherit");
}
#line 57226 "preproc.c"
    break;

  case 2687:
#line 15306 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inherits");
}
#line 57234 "preproc.c"
    break;

  case 2688:
#line 15310 "preproc.y"
 { 
 (yyval.str) = mm_strdup("input");
}
#line 57242 "preproc.c"
    break;

  case 2689:
#line 15314 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insensitive");
}
#line 57250 "preproc.c"
    break;

  case 2690:
#line 15318 "preproc.y"
 { 
 (yyval.str) = mm_strdup("insert");
}
#line 57258 "preproc.c"
    break;

  case 2691:
#line 15322 "preproc.y"
 { 
 (yyval.str) = mm_strdup("instead");
}
#line 57266 "preproc.c"
    break;

  case 2692:
#line 15326 "preproc.y"
 { 
 (yyval.str) = mm_strdup("invoker");
}
#line 57274 "preproc.c"
    break;

  case 2693:
#line 15330 "preproc.y"
 { 
 (yyval.str) = mm_strdup("isolation");
}
#line 57282 "preproc.c"
    break;

  case 2694:
#line 15334 "preproc.y"
 { 
 (yyval.str) = mm_strdup("key");
}
#line 57290 "preproc.c"
    break;

  case 2695:
#line 15338 "preproc.y"
 { 
 (yyval.str) = mm_strdup("language");
}
#line 57298 "preproc.c"
    break;

  case 2696:
#line 15342 "preproc.y"
 { 
 (yyval.str) = mm_strdup("large");
}
#line 57306 "preproc.c"
    break;

  case 2697:
#line 15346 "preproc.y"
 { 
 (yyval.str) = mm_strdup("last");
}
#line 57314 "preproc.c"
    break;

  case 2698:
#line 15350 "preproc.y"
 { 
 (yyval.str) = mm_strdup("level");
}
#line 57322 "preproc.c"
    break;

  case 2699:
#line 15354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("list");
}
#line 57330 "preproc.c"
    break;

  case 2700:
#line 15358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("listen");
}
#line 57338 "preproc.c"
    break;

  case 2701:
#line 15362 "preproc.y"
 { 
 (yyval.str) = mm_strdup("load");
}
#line 57346 "preproc.c"
    break;

  case 2702:
#line 15366 "preproc.y"
 { 
 (yyval.str) = mm_strdup("local");
}
#line 57354 "preproc.c"
    break;

  case 2703:
#line 15370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("location");
}
#line 57362 "preproc.c"
    break;

  case 2704:
#line 15374 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lock");
}
#line 57370 "preproc.c"
    break;

  case 2705:
#line 15378 "preproc.y"
 { 
 (yyval.str) = mm_strdup("master");
}
#line 57378 "preproc.c"
    break;

  case 2706:
#line 15382 "preproc.y"
 { 
 (yyval.str) = mm_strdup("match");
}
#line 57386 "preproc.c"
    break;

  case 2707:
#line 15386 "preproc.y"
 { 
 (yyval.str) = mm_strdup("maxvalue");
}
#line 57394 "preproc.c"
    break;

  case 2708:
#line 15390 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_limit");
}
#line 57402 "preproc.c"
    break;

  case 2709:
#line 15394 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_shared_quota");
}
#line 57410 "preproc.c"
    break;

  case 2710:
#line 15398 "preproc.y"
 { 
 (yyval.str) = mm_strdup("memory_spill_ratio");
}
#line 57418 "preproc.c"
    break;

  case 2711:
#line 15402 "preproc.y"
 { 
 (yyval.str) = mm_strdup("minvalue");
}
#line 57426 "preproc.c"
    break;

  case 2712:
#line 15406 "preproc.y"
 { 
 (yyval.str) = mm_strdup("missing");
}
#line 57434 "preproc.c"
    break;

  case 2713:
#line 15410 "preproc.y"
 { 
 (yyval.str) = mm_strdup("mode");
}
#line 57442 "preproc.c"
    break;

  case 2714:
#line 15414 "preproc.y"
 { 
 (yyval.str) = mm_strdup("modifies");
}
#line 57450 "preproc.c"
    break;

  case 2715:
#line 15418 "preproc.y"
 { 
 (yyval.str) = mm_strdup("move");
}
#line 57458 "preproc.c"
    break;

  case 2716:
#line 15422 "preproc.y"
 { 
 (yyval.str) = mm_strdup("name");
}
#line 57466 "preproc.c"
    break;

  case 2717:
#line 15426 "preproc.y"
 { 
 (yyval.str) = mm_strdup("names");
}
#line 57474 "preproc.c"
    break;

  case 2718:
#line 15430 "preproc.y"
 { 
 (yyval.str) = mm_strdup("newline");
}
#line 57482 "preproc.c"
    break;

  case 2719:
#line 15434 "preproc.y"
 { 
 (yyval.str) = mm_strdup("next");
}
#line 57490 "preproc.c"
    break;

  case 2720:
#line 15438 "preproc.y"
 { 
 (yyval.str) = mm_strdup("no");
}
#line 57498 "preproc.c"
    break;

  case 2721:
#line 15442 "preproc.y"
 { 
 (yyval.str) = mm_strdup("noovercommit");
}
#line 57506 "preproc.c"
    break;

  case 2722:
#line 15446 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nothing");
}
#line 57514 "preproc.c"
    break;

  case 2723:
#line 15450 "preproc.y"
 { 
 (yyval.str) = mm_strdup("notify");
}
#line 57522 "preproc.c"
    break;

  case 2724:
#line 15454 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nowait");
}
#line 57530 "preproc.c"
    break;

  case 2725:
#line 15458 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nulls");
}
#line 57538 "preproc.c"
    break;

  case 2726:
#line 15462 "preproc.y"
 { 
 (yyval.str) = mm_strdup("object");
}
#line 57546 "preproc.c"
    break;

  case 2727:
#line 15466 "preproc.y"
 { 
 (yyval.str) = mm_strdup("of");
}
#line 57554 "preproc.c"
    break;

  case 2728:
#line 15470 "preproc.y"
 { 
 (yyval.str) = mm_strdup("oids");
}
#line 57562 "preproc.c"
    break;

  case 2729:
#line 15474 "preproc.y"
 { 
 (yyval.str) = mm_strdup("operator");
}
#line 57570 "preproc.c"
    break;

  case 2730:
#line 15478 "preproc.y"
 { 
 (yyval.str) = mm_strdup("option");
}
#line 57578 "preproc.c"
    break;

  case 2731:
#line 15482 "preproc.y"
 { 
 (yyval.str) = mm_strdup("options");
}
#line 57586 "preproc.c"
    break;

  case 2732:
#line 15486 "preproc.y"
 { 
 (yyval.str) = mm_strdup("others");
}
#line 57594 "preproc.c"
    break;

  case 2733:
#line 15490 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overcommit");
}
#line 57602 "preproc.c"
    break;

  case 2734:
#line 15494 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owned");
}
#line 57610 "preproc.c"
    break;

  case 2735:
#line 15498 "preproc.y"
 { 
 (yyval.str) = mm_strdup("owner");
}
#line 57618 "preproc.c"
    break;

  case 2736:
#line 15502 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partial");
}
#line 57626 "preproc.c"
    break;

  case 2737:
#line 15506 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partitions");
}
#line 57634 "preproc.c"
    break;

  case 2738:
#line 15510 "preproc.y"
 { 
 (yyval.str) = mm_strdup("password");
}
#line 57642 "preproc.c"
    break;

  case 2739:
#line 15514 "preproc.y"
 { 
 (yyval.str) = mm_strdup("percent");
}
#line 57650 "preproc.c"
    break;

  case 2740:
#line 15518 "preproc.y"
 { 
 (yyval.str) = mm_strdup("persistently");
}
#line 57658 "preproc.c"
    break;

  case 2741:
#line 15522 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepare");
}
#line 57666 "preproc.c"
    break;

  case 2742:
#line 15526 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prepared");
}
#line 57674 "preproc.c"
    break;

  case 2743:
#line 15530 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preserve");
}
#line 57682 "preproc.c"
    break;

  case 2744:
#line 15534 "preproc.y"
 { 
 (yyval.str) = mm_strdup("prior");
}
#line 57690 "preproc.c"
    break;

  case 2745:
#line 15538 "preproc.y"
 { 
 (yyval.str) = mm_strdup("privileges");
}
#line 57698 "preproc.c"
    break;

  case 2746:
#line 15542 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedural");
}
#line 57706 "preproc.c"
    break;

  case 2747:
#line 15546 "preproc.y"
 { 
 (yyval.str) = mm_strdup("procedure");
}
#line 57714 "preproc.c"
    break;

  case 2748:
#line 15550 "preproc.y"
 { 
 (yyval.str) = mm_strdup("protocol");
}
#line 57722 "preproc.c"
    break;

  case 2749:
#line 15554 "preproc.y"
 { 
 (yyval.str) = mm_strdup("queue");
}
#line 57730 "preproc.c"
    break;

  case 2750:
#line 15558 "preproc.y"
 { 
 (yyval.str) = mm_strdup("quote");
}
#line 57738 "preproc.c"
    break;

  case 2751:
#line 15562 "preproc.y"
 { 
 (yyval.str) = mm_strdup("range");
}
#line 57746 "preproc.c"
    break;

  case 2752:
#line 15566 "preproc.y"
 { 
 (yyval.str) = mm_strdup("read");
}
#line 57754 "preproc.c"
    break;

  case 2753:
#line 15570 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reassign");
}
#line 57762 "preproc.c"
    break;

  case 2754:
#line 15574 "preproc.y"
 { 
 (yyval.str) = mm_strdup("recheck");
}
#line 57770 "preproc.c"
    break;

  case 2755:
#line 15578 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reindex");
}
#line 57778 "preproc.c"
    break;

  case 2756:
#line 15582 "preproc.y"
 { 
 (yyval.str) = mm_strdup("relative");
}
#line 57786 "preproc.c"
    break;

  case 2757:
#line 15586 "preproc.y"
 { 
 (yyval.str) = mm_strdup("release");
}
#line 57794 "preproc.c"
    break;

  case 2758:
#line 15590 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rename");
}
#line 57802 "preproc.c"
    break;

  case 2759:
#line 15594 "preproc.y"
 { 
 (yyval.str) = mm_strdup("repeatable");
}
#line 57810 "preproc.c"
    break;

  case 2760:
#line 15598 "preproc.y"
 { 
 (yyval.str) = mm_strdup("replace");
}
#line 57818 "preproc.c"
    break;

  case 2761:
#line 15602 "preproc.y"
 { 
 (yyval.str) = mm_strdup("reset");
}
#line 57826 "preproc.c"
    break;

  case 2762:
#line 15606 "preproc.y"
 { 
 (yyval.str) = mm_strdup("resource");
}
#line 57834 "preproc.c"
    break;

  case 2763:
#line 15610 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restart");
}
#line 57842 "preproc.c"
    break;

  case 2764:
#line 15614 "preproc.y"
 { 
 (yyval.str) = mm_strdup("restrict");
}
#line 57850 "preproc.c"
    break;

  case 2765:
#line 15618 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returns");
}
#line 57858 "preproc.c"
    break;

  case 2766:
#line 15622 "preproc.y"
 { 
 (yyval.str) = mm_strdup("revoke");
}
#line 57866 "preproc.c"
    break;

  case 2767:
#line 15626 "preproc.y"
 { 
 (yyval.str) = mm_strdup("role");
}
#line 57874 "preproc.c"
    break;

  case 2768:
#line 15630 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollback");
}
#line 57882 "preproc.c"
    break;

  case 2769:
#line 15634 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rows");
}
#line 57890 "preproc.c"
    break;

  case 2770:
#line 15638 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rule");
}
#line 57898 "preproc.c"
    break;

  case 2771:
#line 15642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("savepoint");
}
#line 57906 "preproc.c"
    break;

  case 2772:
#line 15646 "preproc.y"
 { 
 (yyval.str) = mm_strdup("schema");
}
#line 57914 "preproc.c"
    break;

  case 2773:
#line 15650 "preproc.y"
 { 
 (yyval.str) = mm_strdup("scroll");
}
#line 57922 "preproc.c"
    break;

  case 2774:
#line 15654 "preproc.y"
 { 
 (yyval.str) = mm_strdup("search");
}
#line 57930 "preproc.c"
    break;

  case 2775:
#line 15658 "preproc.y"
 { 
 (yyval.str) = mm_strdup("security");
}
#line 57938 "preproc.c"
    break;

  case 2776:
#line 15662 "preproc.y"
 { 
 (yyval.str) = mm_strdup("segment");
}
#line 57946 "preproc.c"
    break;

  case 2777:
#line 15666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("segments");
}
#line 57954 "preproc.c"
    break;

  case 2778:
#line 15670 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sequence");
}
#line 57962 "preproc.c"
    break;

  case 2779:
#line 15674 "preproc.y"
 { 
 (yyval.str) = mm_strdup("serializable");
}
#line 57970 "preproc.c"
    break;

  case 2780:
#line 15678 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session");
}
#line 57978 "preproc.c"
    break;

  case 2781:
#line 15682 "preproc.y"
 { 
 (yyval.str) = mm_strdup("set");
}
#line 57986 "preproc.c"
    break;

  case 2782:
#line 15686 "preproc.y"
 { 
 (yyval.str) = mm_strdup("share");
}
#line 57994 "preproc.c"
    break;

  case 2783:
#line 15690 "preproc.y"
 { 
 (yyval.str) = mm_strdup("show");
}
#line 58002 "preproc.c"
    break;

  case 2784:
#line 15694 "preproc.y"
 { 
 (yyval.str) = mm_strdup("simple");
}
#line 58010 "preproc.c"
    break;

  case 2785:
#line 15698 "preproc.y"
 { 
 (yyval.str) = mm_strdup("split");
}
#line 58018 "preproc.c"
    break;

  case 2786:
#line 15702 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sql");
}
#line 58026 "preproc.c"
    break;

  case 2787:
#line 15706 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stable");
}
#line 58034 "preproc.c"
    break;

  case 2788:
#line 15710 "preproc.y"
 { 
 (yyval.str) = mm_strdup("start");
}
#line 58042 "preproc.c"
    break;

  case 2789:
#line 15714 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statement");
}
#line 58050 "preproc.c"
    break;

  case 2790:
#line 15718 "preproc.y"
 { 
 (yyval.str) = mm_strdup("statistics");
}
#line 58058 "preproc.c"
    break;

  case 2791:
#line 15722 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdin");
}
#line 58066 "preproc.c"
    break;

  case 2792:
#line 15726 "preproc.y"
 { 
 (yyval.str) = mm_strdup("stdout");
}
#line 58074 "preproc.c"
    break;

  case 2793:
#line 15730 "preproc.y"
 { 
 (yyval.str) = mm_strdup("storage");
}
#line 58082 "preproc.c"
    break;

  case 2794:
#line 15734 "preproc.y"
 { 
 (yyval.str) = mm_strdup("strict");
}
#line 58090 "preproc.c"
    break;

  case 2795:
#line 15738 "preproc.y"
 { 
 (yyval.str) = mm_strdup("subpartition");
}
#line 58098 "preproc.c"
    break;

  case 2796:
#line 15742 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sysid");
}
#line 58106 "preproc.c"
    break;

  case 2797:
#line 15746 "preproc.y"
 { 
 (yyval.str) = mm_strdup("system");
}
#line 58114 "preproc.c"
    break;

  case 2798:
#line 15750 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temp");
}
#line 58122 "preproc.c"
    break;

  case 2799:
#line 15754 "preproc.y"
 { 
 (yyval.str) = mm_strdup("template");
}
#line 58130 "preproc.c"
    break;

  case 2800:
#line 15758 "preproc.y"
 { 
 (yyval.str) = mm_strdup("temporary");
}
#line 58138 "preproc.c"
    break;

  case 2801:
#line 15762 "preproc.y"
 { 
 (yyval.str) = mm_strdup("threshold");
}
#line 58146 "preproc.c"
    break;

  case 2802:
#line 15766 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ties");
}
#line 58154 "preproc.c"
    break;

  case 2803:
#line 15770 "preproc.y"
 { 
 (yyval.str) = mm_strdup("transaction");
}
#line 58162 "preproc.c"
    break;

  case 2804:
#line 15774 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trigger");
}
#line 58170 "preproc.c"
    break;

  case 2805:
#line 15778 "preproc.y"
 { 
 (yyval.str) = mm_strdup("truncate");
}
#line 58178 "preproc.c"
    break;

  case 2806:
#line 15782 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trusted");
}
#line 58186 "preproc.c"
    break;

  case 2807:
#line 15786 "preproc.y"
 { 
 (yyval.str) = mm_strdup("type");
}
#line 58194 "preproc.c"
    break;

  case 2808:
#line 15790 "preproc.y"
 { 
 (yyval.str) = mm_strdup("uncommitted");
}
#line 58202 "preproc.c"
    break;

  case 2809:
#line 15794 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unencrypted");
}
#line 58210 "preproc.c"
    break;

  case 2810:
#line 15798 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unknown");
}
#line 58218 "preproc.c"
    break;

  case 2811:
#line 15802 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unlisten");
}
#line 58226 "preproc.c"
    break;

  case 2812:
#line 15806 "preproc.y"
 { 
 (yyval.str) = mm_strdup("until");
}
#line 58234 "preproc.c"
    break;

  case 2813:
#line 15810 "preproc.y"
 { 
 (yyval.str) = mm_strdup("update");
}
#line 58242 "preproc.c"
    break;

  case 2814:
#line 15814 "preproc.y"
 { 
 (yyval.str) = mm_strdup("vacuum");
}
#line 58250 "preproc.c"
    break;

  case 2815:
#line 15818 "preproc.y"
 { 
 (yyval.str) = mm_strdup("valid");
}
#line 58258 "preproc.c"
    break;

  case 2816:
#line 15822 "preproc.y"
 { 
 (yyval.str) = mm_strdup("validator");
}
#line 58266 "preproc.c"
    break;

  case 2817:
#line 15826 "preproc.y"
 { 
 (yyval.str) = mm_strdup("version");
}
#line 58274 "preproc.c"
    break;

  case 2818:
#line 15830 "preproc.y"
 { 
 (yyval.str) = mm_strdup("view");
}
#line 58282 "preproc.c"
    break;

  case 2819:
#line 15834 "preproc.y"
 { 
 (yyval.str) = mm_strdup("value");
}
#line 58290 "preproc.c"
    break;

  case 2820:
#line 15838 "preproc.y"
 { 
 (yyval.str) = mm_strdup("volatile");
}
#line 58298 "preproc.c"
    break;

  case 2821:
#line 15842 "preproc.y"
 { 
 (yyval.str) = mm_strdup("work");
}
#line 58306 "preproc.c"
    break;

  case 2822:
#line 15846 "preproc.y"
 { 
 (yyval.str) = mm_strdup("write");
}
#line 58314 "preproc.c"
    break;

  case 2823:
#line 15850 "preproc.y"
 { 
 (yyval.str) = mm_strdup("zone");
}
#line 58322 "preproc.c"
    break;

  case 2824:
#line 15854 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bigint");
}
#line 58330 "preproc.c"
    break;

  case 2825:
#line 15858 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bit");
}
#line 58338 "preproc.c"
    break;

  case 2826:
#line 15862 "preproc.y"
 { 
 (yyval.str) = mm_strdup("boolean");
}
#line 58346 "preproc.c"
    break;

  case 2827:
#line 15866 "preproc.y"
 { 
 (yyval.str) = mm_strdup("coalesce");
}
#line 58354 "preproc.c"
    break;

  case 2828:
#line 15870 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cube");
}
#line 58362 "preproc.c"
    break;

  case 2829:
#line 15874 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dec");
}
#line 58370 "preproc.c"
    break;

  case 2830:
#line 15878 "preproc.y"
 { 
 (yyval.str) = mm_strdup("decimal");
}
#line 58378 "preproc.c"
    break;

  case 2831:
#line 15882 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exists");
}
#line 58386 "preproc.c"
    break;

  case 2832:
#line 15886 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extract");
}
#line 58394 "preproc.c"
    break;

  case 2833:
#line 15890 "preproc.y"
 { 
 (yyval.str) = mm_strdup("float");
}
#line 58402 "preproc.c"
    break;

  case 2834:
#line 15894 "preproc.y"
 { 
 (yyval.str) = mm_strdup("greatest");
}
#line 58410 "preproc.c"
    break;

  case 2835:
#line 15898 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group_id");
}
#line 58418 "preproc.c"
    break;

  case 2836:
#line 15902 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grouping");
}
#line 58426 "preproc.c"
    break;

  case 2837:
#line 15906 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inout");
}
#line 58434 "preproc.c"
    break;

  case 2838:
#line 15910 "preproc.y"
 { 
 (yyval.str) = mm_strdup("int");
}
#line 58442 "preproc.c"
    break;

  case 2839:
#line 15914 "preproc.y"
 { 
 (yyval.str) = mm_strdup("integer");
}
#line 58450 "preproc.c"
    break;

  case 2840:
#line 15918 "preproc.y"
 { 
 (yyval.str) = mm_strdup("interval");
}
#line 58458 "preproc.c"
    break;

  case 2841:
#line 15922 "preproc.y"
 { 
 (yyval.str) = mm_strdup("least");
}
#line 58466 "preproc.c"
    break;

  case 2842:
#line 15926 "preproc.y"
 { 
 (yyval.str) = mm_strdup("national");
}
#line 58474 "preproc.c"
    break;

  case 2843:
#line 15930 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nchar");
}
#line 58482 "preproc.c"
    break;

  case 2844:
#line 15934 "preproc.y"
 { 
 (yyval.str) = mm_strdup("none");
}
#line 58490 "preproc.c"
    break;

  case 2845:
#line 15938 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nullif");
}
#line 58498 "preproc.c"
    break;

  case 2846:
#line 15942 "preproc.y"
 { 
 (yyval.str) = mm_strdup("numeric");
}
#line 58506 "preproc.c"
    break;

  case 2847:
#line 15946 "preproc.y"
 { 
 (yyval.str) = mm_strdup("out");
}
#line 58514 "preproc.c"
    break;

  case 2848:
#line 15950 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overlay");
}
#line 58522 "preproc.c"
    break;

  case 2849:
#line 15954 "preproc.y"
 { 
 (yyval.str) = mm_strdup("position");
}
#line 58530 "preproc.c"
    break;

  case 2850:
#line 15958 "preproc.y"
 { 
 (yyval.str) = mm_strdup("precision");
}
#line 58538 "preproc.c"
    break;

  case 2851:
#line 15962 "preproc.y"
 { 
 (yyval.str) = mm_strdup("real");
}
#line 58546 "preproc.c"
    break;

  case 2852:
#line 15966 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollup");
}
#line 58554 "preproc.c"
    break;

  case 2853:
#line 15970 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 58562 "preproc.c"
    break;

  case 2854:
#line 15974 "preproc.y"
 { 
 (yyval.str) = mm_strdup("setof");
}
#line 58570 "preproc.c"
    break;

  case 2855:
#line 15978 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sets");
}
#line 58578 "preproc.c"
    break;

  case 2856:
#line 15982 "preproc.y"
 { 
 (yyval.str) = mm_strdup("smallint");
}
#line 58586 "preproc.c"
    break;

  case 2857:
#line 15986 "preproc.y"
 { 
 (yyval.str) = mm_strdup("substring");
}
#line 58594 "preproc.c"
    break;

  case 2858:
#line 15990 "preproc.y"
 { 
 (yyval.str) = mm_strdup("time");
}
#line 58602 "preproc.c"
    break;

  case 2859:
#line 15994 "preproc.y"
 { 
 (yyval.str) = mm_strdup("timestamp");
}
#line 58610 "preproc.c"
    break;

  case 2860:
#line 15998 "preproc.y"
 { 
 (yyval.str) = mm_strdup("treat");
}
#line 58618 "preproc.c"
    break;

  case 2861:
#line 16002 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trim");
}
#line 58626 "preproc.c"
    break;

  case 2862:
#line 16006 "preproc.y"
 { 
 (yyval.str) = mm_strdup("values");
}
#line 58634 "preproc.c"
    break;

  case 2863:
#line 16010 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varchar");
}
#line 58642 "preproc.c"
    break;

  case 2864:
#line 16014 "preproc.y"
 { 
 (yyval.str) = mm_strdup("authorization");
}
#line 58650 "preproc.c"
    break;

  case 2865:
#line 16018 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 58658 "preproc.c"
    break;

  case 2866:
#line 16022 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 58666 "preproc.c"
    break;

  case 2867:
#line 16026 "preproc.y"
 { 
 (yyval.str) = mm_strdup("log");
}
#line 58674 "preproc.c"
    break;

  case 2868:
#line 16030 "preproc.y"
 { 
 (yyval.str) = mm_strdup("outer");
}
#line 58682 "preproc.c"
    break;

  case 2869:
#line 16034 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 58690 "preproc.c"
    break;

  case 2870:
#line 16042 "preproc.y"
 { 
 (yyval.str) = mm_strdup("between");
}
#line 58698 "preproc.c"
    break;

  case 2871:
#line 16046 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bigint");
}
#line 58706 "preproc.c"
    break;

  case 2872:
#line 16050 "preproc.y"
 { 
 (yyval.str) = mm_strdup("bit");
}
#line 58714 "preproc.c"
    break;

  case 2873:
#line 16054 "preproc.y"
 { 
 (yyval.str) = mm_strdup("boolean");
}
#line 58722 "preproc.c"
    break;

  case 2874:
#line 16058 "preproc.y"
 { 
 (yyval.str) = mm_strdup("character");
}
#line 58730 "preproc.c"
    break;

  case 2875:
#line 16062 "preproc.y"
 { 
 (yyval.str) = mm_strdup("coalesce");
}
#line 58738 "preproc.c"
    break;

  case 2876:
#line 16066 "preproc.y"
 { 
 (yyval.str) = mm_strdup("dec");
}
#line 58746 "preproc.c"
    break;

  case 2877:
#line 16070 "preproc.y"
 { 
 (yyval.str) = mm_strdup("decimal");
}
#line 58754 "preproc.c"
    break;

  case 2878:
#line 16074 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exists");
}
#line 58762 "preproc.c"
    break;

  case 2879:
#line 16078 "preproc.y"
 { 
 (yyval.str) = mm_strdup("extract");
}
#line 58770 "preproc.c"
    break;

  case 2880:
#line 16082 "preproc.y"
 { 
 (yyval.str) = mm_strdup("float");
}
#line 58778 "preproc.c"
    break;

  case 2881:
#line 16086 "preproc.y"
 { 
 (yyval.str) = mm_strdup("greatest");
}
#line 58786 "preproc.c"
    break;

  case 2882:
#line 16090 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grouping");
}
#line 58794 "preproc.c"
    break;

  case 2883:
#line 16094 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group_id");
}
#line 58802 "preproc.c"
    break;

  case 2884:
#line 16098 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inout");
}
#line 58810 "preproc.c"
    break;

  case 2885:
#line 16102 "preproc.y"
 { 
 (yyval.str) = mm_strdup("integer");
}
#line 58818 "preproc.c"
    break;

  case 2886:
#line 16106 "preproc.y"
 { 
 (yyval.str) = mm_strdup("interval");
}
#line 58826 "preproc.c"
    break;

  case 2887:
#line 16110 "preproc.y"
 { 
 (yyval.str) = mm_strdup("least");
}
#line 58834 "preproc.c"
    break;

  case 2888:
#line 16114 "preproc.y"
 { 
 (yyval.str) = mm_strdup("median");
}
#line 58842 "preproc.c"
    break;

  case 2889:
#line 16118 "preproc.y"
 { 
 (yyval.str) = mm_strdup("national");
}
#line 58850 "preproc.c"
    break;

  case 2890:
#line 16122 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nchar");
}
#line 58858 "preproc.c"
    break;

  case 2891:
#line 16126 "preproc.y"
 { 
 (yyval.str) = mm_strdup("none");
}
#line 58866 "preproc.c"
    break;

  case 2892:
#line 16130 "preproc.y"
 { 
 (yyval.str) = mm_strdup("nullif");
}
#line 58874 "preproc.c"
    break;

  case 2893:
#line 16134 "preproc.y"
 { 
 (yyval.str) = mm_strdup("numeric");
}
#line 58882 "preproc.c"
    break;

  case 2894:
#line 16138 "preproc.y"
 { 
 (yyval.str) = mm_strdup("out");
}
#line 58890 "preproc.c"
    break;

  case 2895:
#line 16142 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overlay");
}
#line 58898 "preproc.c"
    break;

  case 2896:
#line 16146 "preproc.y"
 { 
 (yyval.str) = mm_strdup("position");
}
#line 58906 "preproc.c"
    break;

  case 2897:
#line 16150 "preproc.y"
 { 
 (yyval.str) = mm_strdup("precision");
}
#line 58914 "preproc.c"
    break;

  case 2898:
#line 16154 "preproc.y"
 { 
 (yyval.str) = mm_strdup("real");
}
#line 58922 "preproc.c"
    break;

  case 2899:
#line 16158 "preproc.y"
 { 
 (yyval.str) = mm_strdup("rollup");
}
#line 58930 "preproc.c"
    break;

  case 2900:
#line 16162 "preproc.y"
 { 
 (yyval.str) = mm_strdup("row");
}
#line 58938 "preproc.c"
    break;

  case 2901:
#line 16166 "preproc.y"
 { 
 (yyval.str) = mm_strdup("setof");
}
#line 58946 "preproc.c"
    break;

  case 2902:
#line 16170 "preproc.y"
 { 
 (yyval.str) = mm_strdup("sets");
}
#line 58954 "preproc.c"
    break;

  case 2903:
#line 16174 "preproc.y"
 { 
 (yyval.str) = mm_strdup("smallint");
}
#line 58962 "preproc.c"
    break;

  case 2904:
#line 16178 "preproc.y"
 { 
 (yyval.str) = mm_strdup("substring");
}
#line 58970 "preproc.c"
    break;

  case 2905:
#line 16182 "preproc.y"
 { 
 (yyval.str) = mm_strdup("time");
}
#line 58978 "preproc.c"
    break;

  case 2906:
#line 16186 "preproc.y"
 { 
 (yyval.str) = mm_strdup("timestamp");
}
#line 58986 "preproc.c"
    break;

  case 2907:
#line 16190 "preproc.y"
 { 
 (yyval.str) = mm_strdup("treat");
}
#line 58994 "preproc.c"
    break;

  case 2908:
#line 16194 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trim");
}
#line 59002 "preproc.c"
    break;

  case 2909:
#line 16198 "preproc.y"
 { 
 (yyval.str) = mm_strdup("varchar");
}
#line 59010 "preproc.c"
    break;

  case 2910:
#line 16202 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlattributes");
}
#line 59018 "preproc.c"
    break;

  case 2911:
#line 16206 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlconcat");
}
#line 59026 "preproc.c"
    break;

  case 2912:
#line 16210 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlelement");
}
#line 59034 "preproc.c"
    break;

  case 2913:
#line 16214 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlexists");
}
#line 59042 "preproc.c"
    break;

  case 2914:
#line 16218 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlforest");
}
#line 59050 "preproc.c"
    break;

  case 2915:
#line 16222 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlparse");
}
#line 59058 "preproc.c"
    break;

  case 2916:
#line 16226 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlpi");
}
#line 59066 "preproc.c"
    break;

  case 2917:
#line 16230 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlroot");
}
#line 59074 "preproc.c"
    break;

  case 2918:
#line 16234 "preproc.y"
 { 
 (yyval.str) = mm_strdup("xmlserialize");
}
#line 59082 "preproc.c"
    break;

  case 2919:
#line 16242 "preproc.y"
 { 
 (yyval.str) = mm_strdup("authorization");
}
#line 59090 "preproc.c"
    break;

  case 2920:
#line 16246 "preproc.y"
 { 
 (yyval.str) = mm_strdup("binary");
}
#line 59098 "preproc.c"
    break;

  case 2921:
#line 16250 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collation");
}
#line 59106 "preproc.c"
    break;

  case 2922:
#line 16254 "preproc.y"
 { 
 (yyval.str) = mm_strdup("concurrently");
}
#line 59114 "preproc.c"
    break;

  case 2923:
#line 16258 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cross");
}
#line 59122 "preproc.c"
    break;

  case 2924:
#line 16262 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_schema");
}
#line 59130 "preproc.c"
    break;

  case 2925:
#line 16266 "preproc.y"
 { 
 (yyval.str) = mm_strdup("freeze");
}
#line 59138 "preproc.c"
    break;

  case 2926:
#line 16270 "preproc.y"
 { 
 (yyval.str) = mm_strdup("full");
}
#line 59146 "preproc.c"
    break;

  case 2927:
#line 16274 "preproc.y"
 { 
 (yyval.str) = mm_strdup("ilike");
}
#line 59154 "preproc.c"
    break;

  case 2928:
#line 16278 "preproc.y"
 { 
 (yyval.str) = mm_strdup("inner");
}
#line 59162 "preproc.c"
    break;

  case 2929:
#line 16282 "preproc.y"
 { 
 (yyval.str) = mm_strdup("is");
}
#line 59170 "preproc.c"
    break;

  case 2930:
#line 16286 "preproc.y"
 { 
 (yyval.str) = mm_strdup("isnull");
}
#line 59178 "preproc.c"
    break;

  case 2931:
#line 16290 "preproc.y"
 { 
 (yyval.str) = mm_strdup("join");
}
#line 59186 "preproc.c"
    break;

  case 2932:
#line 16294 "preproc.y"
 { 
 (yyval.str) = mm_strdup("left");
}
#line 59194 "preproc.c"
    break;

  case 2933:
#line 16298 "preproc.y"
 { 
 (yyval.str) = mm_strdup("like");
}
#line 59202 "preproc.c"
    break;

  case 2934:
#line 16302 "preproc.y"
 { 
 (yyval.str) = mm_strdup("log");
}
#line 59210 "preproc.c"
    break;

  case 2935:
#line 16306 "preproc.y"
 { 
 (yyval.str) = mm_strdup("natural");
}
#line 59218 "preproc.c"
    break;

  case 2936:
#line 16310 "preproc.y"
 { 
 (yyval.str) = mm_strdup("notnull");
}
#line 59226 "preproc.c"
    break;

  case 2937:
#line 16314 "preproc.y"
 { 
 (yyval.str) = mm_strdup("outer");
}
#line 59234 "preproc.c"
    break;

  case 2938:
#line 16318 "preproc.y"
 { 
 (yyval.str) = mm_strdup("overlaps");
}
#line 59242 "preproc.c"
    break;

  case 2939:
#line 16322 "preproc.y"
 { 
 (yyval.str) = mm_strdup("right");
}
#line 59250 "preproc.c"
    break;

  case 2940:
#line 16326 "preproc.y"
 { 
 (yyval.str) = mm_strdup("similar");
}
#line 59258 "preproc.c"
    break;

  case 2941:
#line 16330 "preproc.y"
 { 
 (yyval.str) = mm_strdup("verbose");
}
#line 59266 "preproc.c"
    break;

  case 2942:
#line 16338 "preproc.y"
 { 
 (yyval.str) = mm_strdup("all");
}
#line 59274 "preproc.c"
    break;

  case 2943:
#line 16342 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyse");
}
#line 59282 "preproc.c"
    break;

  case 2944:
#line 16346 "preproc.y"
 { 
 (yyval.str) = mm_strdup("analyze");
}
#line 59290 "preproc.c"
    break;

  case 2945:
#line 16350 "preproc.y"
 { 
 (yyval.str) = mm_strdup("and");
}
#line 59298 "preproc.c"
    break;

  case 2946:
#line 16354 "preproc.y"
 { 
 (yyval.str) = mm_strdup("any");
}
#line 59306 "preproc.c"
    break;

  case 2947:
#line 16358 "preproc.y"
 { 
 (yyval.str) = mm_strdup("array");
}
#line 59314 "preproc.c"
    break;

  case 2948:
#line 16362 "preproc.y"
 { 
 (yyval.str) = mm_strdup("as");
}
#line 59322 "preproc.c"
    break;

  case 2949:
#line 16366 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asc");
}
#line 59330 "preproc.c"
    break;

  case 2950:
#line 16370 "preproc.y"
 { 
 (yyval.str) = mm_strdup("asymmetric");
}
#line 59338 "preproc.c"
    break;

  case 2951:
#line 16374 "preproc.y"
 { 
 (yyval.str) = mm_strdup("both");
}
#line 59346 "preproc.c"
    break;

  case 2952:
#line 16378 "preproc.y"
 { 
 (yyval.str) = mm_strdup("case");
}
#line 59354 "preproc.c"
    break;

  case 2953:
#line 16382 "preproc.y"
 { 
 (yyval.str) = mm_strdup("cast");
}
#line 59362 "preproc.c"
    break;

  case 2954:
#line 16386 "preproc.y"
 { 
 (yyval.str) = mm_strdup("check");
}
#line 59370 "preproc.c"
    break;

  case 2955:
#line 16390 "preproc.y"
 { 
 (yyval.str) = mm_strdup("collate");
}
#line 59378 "preproc.c"
    break;

  case 2956:
#line 16394 "preproc.y"
 { 
 (yyval.str) = mm_strdup("column");
}
#line 59386 "preproc.c"
    break;

  case 2957:
#line 16398 "preproc.y"
 { 
 (yyval.str) = mm_strdup("constraint");
}
#line 59394 "preproc.c"
    break;

  case 2958:
#line 16402 "preproc.y"
 { 
 (yyval.str) = mm_strdup("create");
}
#line 59402 "preproc.c"
    break;

  case 2959:
#line 16406 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_catalog");
}
#line 59410 "preproc.c"
    break;

  case 2960:
#line 16410 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_date");
}
#line 59418 "preproc.c"
    break;

  case 2961:
#line 16414 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_role");
}
#line 59426 "preproc.c"
    break;

  case 2962:
#line 16418 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_time");
}
#line 59434 "preproc.c"
    break;

  case 2963:
#line 16422 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_timestamp");
}
#line 59442 "preproc.c"
    break;

  case 2964:
#line 16426 "preproc.y"
 { 
 (yyval.str) = mm_strdup("current_user");
}
#line 59450 "preproc.c"
    break;

  case 2965:
#line 16430 "preproc.y"
 { 
 (yyval.str) = mm_strdup("decode");
}
#line 59458 "preproc.c"
    break;

  case 2966:
#line 16434 "preproc.y"
 { 
 (yyval.str) = mm_strdup("default");
}
#line 59466 "preproc.c"
    break;

  case 2967:
#line 16438 "preproc.y"
 { 
 (yyval.str) = mm_strdup("deferrable");
}
#line 59474 "preproc.c"
    break;

  case 2968:
#line 16442 "preproc.y"
 { 
 (yyval.str) = mm_strdup("desc");
}
#line 59482 "preproc.c"
    break;

  case 2969:
#line 16446 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distinct");
}
#line 59490 "preproc.c"
    break;

  case 2970:
#line 16450 "preproc.y"
 { 
 (yyval.str) = mm_strdup("distributed");
}
#line 59498 "preproc.c"
    break;

  case 2971:
#line 16454 "preproc.y"
 { 
 (yyval.str) = mm_strdup("do");
}
#line 59506 "preproc.c"
    break;

  case 2972:
#line 16458 "preproc.y"
 { 
 (yyval.str) = mm_strdup("else");
}
#line 59514 "preproc.c"
    break;

  case 2973:
#line 16462 "preproc.y"
 { 
 (yyval.str) = mm_strdup("end");
}
#line 59522 "preproc.c"
    break;

  case 2974:
#line 16466 "preproc.y"
 { 
 (yyval.str) = mm_strdup("except");
}
#line 59530 "preproc.c"
    break;

  case 2975:
#line 16470 "preproc.y"
 { 
 (yyval.str) = mm_strdup("exclude");
}
#line 59538 "preproc.c"
    break;

  case 2976:
#line 16474 "preproc.y"
 { 
 (yyval.str) = mm_strdup("false");
}
#line 59546 "preproc.c"
    break;

  case 2977:
#line 16478 "preproc.y"
 { 
 (yyval.str) = mm_strdup("fetch");
}
#line 59554 "preproc.c"
    break;

  case 2978:
#line 16482 "preproc.y"
 { 
 (yyval.str) = mm_strdup("following");
}
#line 59562 "preproc.c"
    break;

  case 2979:
#line 16486 "preproc.y"
 { 
 (yyval.str) = mm_strdup("for");
}
#line 59570 "preproc.c"
    break;

  case 2980:
#line 16490 "preproc.y"
 { 
 (yyval.str) = mm_strdup("foreign");
}
#line 59578 "preproc.c"
    break;

  case 2981:
#line 16494 "preproc.y"
 { 
 (yyval.str) = mm_strdup("from");
}
#line 59586 "preproc.c"
    break;

  case 2982:
#line 16498 "preproc.y"
 { 
 (yyval.str) = mm_strdup("grant");
}
#line 59594 "preproc.c"
    break;

  case 2983:
#line 16502 "preproc.y"
 { 
 (yyval.str) = mm_strdup("group");
}
#line 59602 "preproc.c"
    break;

  case 2984:
#line 16506 "preproc.y"
 { 
 (yyval.str) = mm_strdup("having");
}
#line 59610 "preproc.c"
    break;

  case 2985:
#line 16510 "preproc.y"
 { 
 (yyval.str) = mm_strdup("in");
}
#line 59618 "preproc.c"
    break;

  case 2986:
#line 16514 "preproc.y"
 { 
 (yyval.str) = mm_strdup("initially");
}
#line 59626 "preproc.c"
    break;

  case 2987:
#line 16518 "preproc.y"
 { 
 (yyval.str) = mm_strdup("intersect");
}
#line 59634 "preproc.c"
    break;

  case 2988:
#line 16522 "preproc.y"
 { 
 (yyval.str) = mm_strdup("into");
}
#line 59642 "preproc.c"
    break;

  case 2989:
#line 16526 "preproc.y"
 { 
 (yyval.str) = mm_strdup("lateral");
}
#line 59650 "preproc.c"
    break;

  case 2990:
#line 16530 "preproc.y"
 { 
 (yyval.str) = mm_strdup("leading");
}
#line 59658 "preproc.c"
    break;

  case 2991:
#line 16534 "preproc.y"
 { 
 (yyval.str) = mm_strdup("limit");
}
#line 59666 "preproc.c"
    break;

  case 2992:
#line 16538 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtime");
}
#line 59674 "preproc.c"
    break;

  case 2993:
#line 16542 "preproc.y"
 { 
 (yyval.str) = mm_strdup("localtimestamp");
}
#line 59682 "preproc.c"
    break;

  case 2994:
#line 16546 "preproc.y"
 { 
 (yyval.str) = mm_strdup("not");
}
#line 59690 "preproc.c"
    break;

  case 2995:
#line 16550 "preproc.y"
 { 
 (yyval.str) = mm_strdup("null");
}
#line 59698 "preproc.c"
    break;

  case 2996:
#line 16554 "preproc.y"
 { 
 (yyval.str) = mm_strdup("offset");
}
#line 59706 "preproc.c"
    break;

  case 2997:
#line 16558 "preproc.y"
 { 
 (yyval.str) = mm_strdup("on");
}
#line 59714 "preproc.c"
    break;

  case 2998:
#line 16562 "preproc.y"
 { 
 (yyval.str) = mm_strdup("only");
}
#line 59722 "preproc.c"
    break;

  case 2999:
#line 16566 "preproc.y"
 { 
 (yyval.str) = mm_strdup("or");
}
#line 59730 "preproc.c"
    break;

  case 3000:
#line 16570 "preproc.y"
 { 
 (yyval.str) = mm_strdup("order");
}
#line 59738 "preproc.c"
    break;

  case 3001:
#line 16574 "preproc.y"
 { 
 (yyval.str) = mm_strdup("partition");
}
#line 59746 "preproc.c"
    break;

  case 3002:
#line 16578 "preproc.y"
 { 
 (yyval.str) = mm_strdup("placing");
}
#line 59754 "preproc.c"
    break;

  case 3003:
#line 16582 "preproc.y"
 { 
 (yyval.str) = mm_strdup("preceding");
}
#line 59762 "preproc.c"
    break;

  case 3004:
#line 16586 "preproc.y"
 { 
 (yyval.str) = mm_strdup("primary");
}
#line 59770 "preproc.c"
    break;

  case 3005:
#line 16590 "preproc.y"
 { 
 (yyval.str) = mm_strdup("references");
}
#line 59778 "preproc.c"
    break;

  case 3006:
#line 16594 "preproc.y"
 { 
 (yyval.str) = mm_strdup("returning");
}
#line 59786 "preproc.c"
    break;

  case 3007:
#line 16598 "preproc.y"
 { 
 (yyval.str) = mm_strdup("scatter");
}
#line 59794 "preproc.c"
    break;

  case 3008:
#line 16602 "preproc.y"
 { 
 (yyval.str) = mm_strdup("select");
}
#line 59802 "preproc.c"
    break;

  case 3009:
#line 16606 "preproc.y"
 { 
 (yyval.str) = mm_strdup("session_user");
}
#line 59810 "preproc.c"
    break;

  case 3010:
#line 16610 "preproc.y"
 { 
 (yyval.str) = mm_strdup("some");
}
#line 59818 "preproc.c"
    break;

  case 3011:
#line 16614 "preproc.y"
 { 
 (yyval.str) = mm_strdup("symmetric");
}
#line 59826 "preproc.c"
    break;

  case 3012:
#line 16618 "preproc.y"
 { 
 (yyval.str) = mm_strdup("table");
}
#line 59834 "preproc.c"
    break;

  case 3013:
#line 16622 "preproc.y"
 { 
 (yyval.str) = mm_strdup("then");
}
#line 59842 "preproc.c"
    break;

  case 3014:
#line 16626 "preproc.y"
 { 
 (yyval.str) = mm_strdup("trailing");
}
#line 59850 "preproc.c"
    break;

  case 3015:
#line 16630 "preproc.y"
 { 
 (yyval.str) = mm_strdup("true");
}
#line 59858 "preproc.c"
    break;

  case 3016:
#line 16634 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unbounded");
}
#line 59866 "preproc.c"
    break;

  case 3017:
#line 16638 "preproc.y"
 { 
 (yyval.str) = mm_strdup("unique");
}
#line 59874 "preproc.c"
    break;

  case 3018:
#line 16642 "preproc.y"
 { 
 (yyval.str) = mm_strdup("user");
}
#line 59882 "preproc.c"
    break;

  case 3019:
#line 16646 "preproc.y"
 { 
 (yyval.str) = mm_strdup("using");
}
#line 59890 "preproc.c"
    break;

  case 3020:
#line 16650 "preproc.y"
 { 
 (yyval.str) = mm_strdup("variadic");
}
#line 59898 "preproc.c"
    break;

  case 3021:
#line 16654 "preproc.y"
 { 
 (yyval.str) = mm_strdup("when");
}
#line 59906 "preproc.c"
    break;

  case 3022:
#line 16658 "preproc.y"
 { 
 (yyval.str) = mm_strdup("where");
}
#line 59914 "preproc.c"
    break;

  case 3023:
#line 16662 "preproc.y"
 { 
 (yyval.str) = mm_strdup("window");
}
#line 59922 "preproc.c"
    break;

  case 3024:
#line 16666 "preproc.y"
 { 
 (yyval.str) = mm_strdup("with");
}
#line 59930 "preproc.c"
    break;

  case 3027:
#line 16679 "preproc.y"
                                 { connection = NULL; }
#line 59936 "preproc.c"
    break;

  case 3029:
#line 16682 "preproc.y"
                                {
					fprintf(base_yyout, "%s", (yyvsp[0].str));
					free((yyvsp[0].str));
					output_line_number();
				}
#line 59946 "preproc.c"
    break;

  case 3031:
#line 16688 "preproc.y"
                                                        { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 59952 "preproc.c"
    break;

  case 3032:
#line 16689 "preproc.y"
                                                        { fprintf(base_yyout, "%s", (yyvsp[0].str)); free((yyvsp[0].str)); }
#line 59958 "preproc.c"
    break;

  case 3033:
#line 16690 "preproc.y"
                                                        { braces_open++; fputs("{", base_yyout); }
#line 59964 "preproc.c"
    break;

  case 3034:
#line 16692 "preproc.y"
                {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", base_yyout);
		}
#line 59979 "preproc.c"
    break;

  case 3035:
#line 16704 "preproc.y"
                                                       {FoundInto = 0;}
#line 59985 "preproc.c"
    break;

  case 3036:
#line 16705 "preproc.y"
                {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(6, mm_strdup("create"), (yyvsp[-8].str), mm_strdup("table"), (yyvsp[-6].str), mm_strdup("as"), (yyvsp[-3].str));
		}
#line 59996 "preproc.c"
    break;

  case 3037:
#line 16714 "preproc.y"
                {
			connection = (yyvsp[0].str);
			/*
			 * Do we have a variable as connection target?  Remove the variable
			 * from the variable list or else it will be used twice.
			 */
			if (argsinsert != NULL)
				argsinsert = NULL;
		}
#line 60010 "preproc.c"
    break;

  case 3038:
#line 16729 "preproc.y"
                        { (yyval.str) = cat_str(5, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str), mm_strdup(","), (yyvsp[-1].str)); }
#line 60016 "preproc.c"
    break;

  case 3039:
#line 16731 "preproc.y"
                        { (yyval.str) = mm_strdup("NULL, NULL, NULL, \"DEFAULT\""); }
#line 60022 "preproc.c"
    break;

  case 3040:
#line 16734 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("NULL,"), (yyvsp[0].str), mm_strdup(", NULL")); }
#line 60028 "preproc.c"
    break;

  case 3041:
#line 16736 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL, NULL, NULL")); }
#line 60034 "preproc.c"
    break;

  case 3042:
#line 16740 "preproc.y"
                {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[-1].str)) > 0 && *((yyvsp[-1].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[-1].str));

			/* C strings need to be handled differently */
			if ((yyvsp[-2].str)[0] == '\"')
				(yyval.str) = (yyvsp[-2].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), make3_str((yyvsp[-2].str), (yyvsp[-1].str), (yyvsp[0].str)), mm_strdup("\""));
		}
#line 60050 "preproc.c"
    break;

  case 3043:
#line 16752 "preproc.y"
                {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[-6].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[-6].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[-4].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[-4].str));

			if (strncmp((yyvsp[-6].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[-4].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[-4].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(mm_strdup("\""), (yyvsp[-6].str), mm_strdup(":")), (yyvsp[-4].str), make3_str(make3_str((yyvsp[-3].str), mm_strdup("/"), (yyvsp[-1].str)), (yyvsp[0].str), mm_strdup("\"")));
		}
#line 60070 "preproc.c"
    break;

  case 3044:
#line 16768 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 60078 "preproc.c"
    break;

  case 3045:
#line 16772 "preproc.y"
                {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[0].str)[0] = '\"';
			(yyvsp[0].str)[strlen((yyvsp[0].str))-1] = '\"';
			(yyval.str) = (yyvsp[0].str);
		}
#line 60091 "preproc.c"
    break;

  case 3046:
#line 16782 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 60097 "preproc.c"
    break;

  case 3047:
#line 16783 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 60103 "preproc.c"
    break;

  case 3048:
#line 16787 "preproc.y"
                {
			if (strcmp((yyvsp[0].str), "postgresql") != 0 && strcmp((yyvsp[0].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[0].str));

			if (strcmp((yyvsp[-1].str), "tcp") != 0 && strcmp((yyvsp[-1].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[-1].str));

			(yyval.str) = make3_str((yyvsp[-1].str), mm_strdup(":"), (yyvsp[0].str));
		}
#line 60117 "preproc.c"
    break;

  case 3049:
#line 16799 "preproc.y"
                {
			if (strcmp((yyvsp[-1].str), "@") != 0 && strcmp((yyvsp[-1].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
		}
#line 60128 "preproc.c"
    break;

  case 3050:
#line 16807 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 60134 "preproc.c"
    break;

  case 3051:
#line 16808 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 60140 "preproc.c"
    break;

  case 3052:
#line 16811 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 60146 "preproc.c"
    break;

  case 3053:
#line 16812 "preproc.y"
                                                { (yyval.str) = make3_str((yyvsp[-2].str), mm_strdup("."), (yyvsp[0].str)); }
#line 60152 "preproc.c"
    break;

  case 3054:
#line 16813 "preproc.y"
                                                                { (yyval.str) = make_name(); }
#line 60158 "preproc.c"
    break;

  case 3055:
#line 16816 "preproc.y"
                                { (yyval.str) = make2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 60164 "preproc.c"
    break;

  case 3056:
#line 16817 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 60170 "preproc.c"
    break;

  case 3057:
#line 16820 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 60176 "preproc.c"
    break;

  case 3058:
#line 16821 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL"); }
#line 60182 "preproc.c"
    break;

  case 3059:
#line 16824 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 60188 "preproc.c"
    break;

  case 3060:
#line 16825 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL, NULL"); }
#line 60194 "preproc.c"
    break;

  case 3061:
#line 16829 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[0].str), mm_strdup(", NULL")); }
#line 60200 "preproc.c"
    break;

  case 3062:
#line 16831 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 60206 "preproc.c"
    break;

  case 3063:
#line 16833 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-3].str), mm_strdup(","), (yyvsp[0].str)); }
#line 60212 "preproc.c"
    break;

  case 3064:
#line 16835 "preproc.y"
                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 60218 "preproc.c"
    break;

  case 3065:
#line 16839 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 60229 "preproc.c"
    break;

  case 3066:
#line 16846 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"')
				(yyval.str) = (yyvsp[0].str);
			else
				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
		}
#line 60240 "preproc.c"
    break;

  case 3067:
#line 16853 "preproc.y"
                {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), mm_strdup(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		}
#line 60258 "preproc.c"
    break;

  case 3068:
#line 16869 "preproc.y"
                {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[0].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[0].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[0].str), mm_strdup(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[0].str);
						break;
				}
			}
		}
#line 60294 "preproc.c"
    break;

  case 3069:
#line 16903 "preproc.y"
                {
			if (strlen((yyvsp[-1].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[-1].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

			(yyval.str) = make2_str(mm_strdup("?"), (yyvsp[0].str));
		}
#line 60308 "preproc.c"
    break;

  case 3070:
#line 16912 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 60314 "preproc.c"
    break;

  case 3071:
#line 16916 "preproc.y"
                        {
				(yyval.str) = make2_str((yyvsp[-1].str), (yyvsp[0].str));
			}
#line 60322 "preproc.c"
    break;

  case 3072:
#line 16920 "preproc.y"
                        {
				if (strlen((yyvsp[-1].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[-1].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[-1].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[-3].str), (yyvsp[-2].str)), (yyvsp[-1].str), (yyvsp[0].str));
			}
#line 60336 "preproc.c"
    break;

  case 3073:
#line 16932 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 60342 "preproc.c"
    break;

  case 3074:
#line 16934 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 60348 "preproc.c"
    break;

  case 3075:
#line 16936 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 60354 "preproc.c"
    break;

  case 3076:
#line 16938 "preproc.y"
                        { (yyval.str) = make2_str(mm_strdup("="), (yyvsp[0].str)); }
#line 60360 "preproc.c"
    break;

  case 3077:
#line 16942 "preproc.y"
                {
			if ((yyvsp[0].str)[0] == '\"' && (yyvsp[0].str)[strlen((yyvsp[0].str))-1] == '\"') /* already quoted? */
				(yyval.str) = (yyvsp[0].str);
			else /* not quoted => convert to lowercase */
			{
				size_t i;

				for (i = 0; i< strlen((yyvsp[0].str)); i++)
					(yyvsp[0].str)[i] = tolower((unsigned char) (yyvsp[0].str)[i]);

				(yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\""));
			}
		}
#line 60378 "preproc.c"
    break;

  case 3078:
#line 16955 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 60384 "preproc.c"
    break;

  case 3079:
#line 16963 "preproc.y"
                {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[-5].str)[0] == ':' ? mm_strdup("$0") : mm_strdup((yyvsp[-5].str));
			int (* strcmp_fn)(const char *, const char *) = (((yyvsp[-5].str)[0] == ':' || (yyvsp[-5].str)[0] == '"') ? strcmp : pg_strcasecmp);
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp_fn((yyvsp[-5].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[-5].str)[0] == ':')
						mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[-5].str)+1);
					else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[-5].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[-5].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, mm_strdup("declare"), cursor_marker, (yyvsp[-4].str), mm_strdup("cursor"), (yyvsp[-2].str), mm_strdup("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[0].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[0].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[-5].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[-5].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, mm_strdup("/*"), mm_strdup(this->command), mm_strdup("*/"));

			if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
				(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
					mm_strdup("ECPG_informix_reset_sqlca();"),
					comment);
			else
				(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
		}
#line 60447 "preproc.c"
    break;

  case 3080:
#line 17024 "preproc.y"
                        {
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[0].str);
			}
#line 60457 "preproc.c"
    break;

  case 3082:
#line 17034 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 60463 "preproc.c"
    break;

  case 3083:
#line 17035 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 60469 "preproc.c"
    break;

  case 3084:
#line 17038 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 60475 "preproc.c"
    break;

  case 3085:
#line 17040 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 60481 "preproc.c"
    break;

  case 3086:
#line 17041 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 60487 "preproc.c"
    break;

  case 3087:
#line 17044 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 60493 "preproc.c"
    break;

  case 3088:
#line 17045 "preproc.y"
                                        { (yyval.str) = mm_strdup("year to minute"); }
#line 60499 "preproc.c"
    break;

  case 3089:
#line 17046 "preproc.y"
                                        { (yyval.str) = mm_strdup("year to second"); }
#line 60505 "preproc.c"
    break;

  case 3090:
#line 17047 "preproc.y"
                                                { (yyval.str) = mm_strdup("day to day"); }
#line 60511 "preproc.c"
    break;

  case 3091:
#line 17048 "preproc.y"
                                        { (yyval.str) = mm_strdup("month to month"); }
#line 60517 "preproc.c"
    break;

  case 3092:
#line 17055 "preproc.y"
                { fputs("/* exec sql begin declare section */", base_yyout); }
#line 60523 "preproc.c"
    break;

  case 3093:
#line 17057 "preproc.y"
                {
			fprintf(base_yyout, "%s/* exec sql end declare section */", (yyvsp[-1].str));
			free((yyvsp[-1].str));
			output_line_number();
		}
#line 60533 "preproc.c"
    break;

  case 3094:
#line 17064 "preproc.y"
                                                            {}
#line 60539 "preproc.c"
    break;

  case 3095:
#line 17066 "preproc.y"
                                                        {}
#line 60545 "preproc.c"
    break;

  case 3096:
#line 17068 "preproc.y"
                                                        { (yyval.str) = EMPTY; }
#line 60551 "preproc.c"
    break;

  case 3097:
#line 17069 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 60557 "preproc.c"
    break;

  case 3098:
#line 17072 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 60563 "preproc.c"
    break;

  case 3099:
#line 17073 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 60569 "preproc.c"
    break;

  case 3100:
#line 17074 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 60575 "preproc.c"
    break;

  case 3101:
#line 17075 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 60581 "preproc.c"
    break;

  case 3102:
#line 17078 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 60587 "preproc.c"
    break;

  case 3103:
#line 17079 "preproc.y"
                                                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 60593 "preproc.c"
    break;

  case 3104:
#line 17083 "preproc.y"
        {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	}
#line 60603 "preproc.c"
    break;

  case 3105:
#line 17089 "preproc.y"
        {
		add_typedef((yyvsp[-2].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-4].type).type_enum, (yyvsp[-4].type).type_dimension, (yyvsp[-4].type).type_index, initializer, *(yyvsp[-3].str) ? 1 : 0);

		fprintf(base_yyout, "typedef %s %s %s %s;\n", (yyvsp[-4].type).type_str, *(yyvsp[-3].str) ? "*" : "", (yyvsp[-2].str), (yyvsp[-1].index).str);
		output_line_number();
		(yyval.str) = mm_strdup("");
	}
#line 60615 "preproc.c"
    break;

  case 3106:
#line 17099 "preproc.y"
                {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 60629 "preproc.c"
    break;

  case 3107:
#line 17109 "preproc.y"
                {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[-4].str), (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 60637 "preproc.c"
    break;

  case 3108:
#line 17113 "preproc.y"
                {
			actual_type[struct_level].type_enum = (yyvsp[0].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[0].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[0].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[0].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[0].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		}
#line 60651 "preproc.c"
    break;

  case 3109:
#line 17123 "preproc.y"
                {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[-3].type).type_str, (yyvsp[-1].str), mm_strdup(";\n"));
		}
#line 60659 "preproc.c"
    break;

  case 3110:
#line 17127 "preproc.y"
                {
			(yyval.str) = cat2_str((yyvsp[-1].str), mm_strdup(";"));
		}
#line 60667 "preproc.c"
    break;

  case 3111:
#line 17132 "preproc.y"
                                { (yyval.str) =cat2_str(mm_strdup(":"), (yyvsp[0].str)); }
#line 60673 "preproc.c"
    break;

  case 3112:
#line 17133 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 60679 "preproc.c"
    break;

  case 3113:
#line 17137 "preproc.y"
                        {(yyval.str) = cat2_str ((yyvsp[-1].str), (yyvsp[0].str)); }
#line 60685 "preproc.c"
    break;

  case 3114:
#line 17138 "preproc.y"
                                                {(yyval.str) = (yyvsp[0].str); }
#line 60691 "preproc.c"
    break;

  case 3115:
#line 17139 "preproc.y"
                                                {(yyval.str) = (yyvsp[0].str); }
#line 60697 "preproc.c"
    break;

  case 3116:
#line 17142 "preproc.y"
                                { (yyval.str) = mm_strdup("extern"); }
#line 60703 "preproc.c"
    break;

  case 3117:
#line 17143 "preproc.y"
                                                { (yyval.str) = mm_strdup("static"); }
#line 60709 "preproc.c"
    break;

  case 3118:
#line 17144 "preproc.y"
                                        { (yyval.str) = mm_strdup("register"); }
#line 60715 "preproc.c"
    break;

  case 3119:
#line 17145 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 60721 "preproc.c"
    break;

  case 3120:
#line 17148 "preproc.y"
                                { (yyval.str) = mm_strdup("const"); }
#line 60727 "preproc.c"
    break;

  case 3121:
#line 17149 "preproc.y"
                                        { (yyval.str) = mm_strdup("volatile"); }
#line 60733 "preproc.c"
    break;

  case 3122:
#line 17153 "preproc.y"
                {
			(yyval.type).type_enum = (yyvsp[0].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[0].type_enum)));
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 60745 "preproc.c"
    break;

  case 3123:
#line 17161 "preproc.y"
                {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");

			if (strncmp((yyvsp[0].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		}
#line 60766 "preproc.c"
    break;

  case 3124:
#line 17178 "preproc.y"
                {
			(yyval.type).type_str = (yyvsp[0].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 60778 "preproc.c"
    break;

  case 3125:
#line 17186 "preproc.y"
                {
			if (strcmp((yyvsp[-4].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}
			else if (strcmp((yyvsp[-4].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
			}

			(yyval.type).type_dimension = mm_strdup("-1");
			(yyval.type).type_index = mm_strdup("-1");
			(yyval.type).type_sizeof = NULL;
		}
#line 60805 "preproc.c"
    break;

  case 3126:
#line 17209 "preproc.y"
                {
			if (strlen((yyvsp[0].str)) != 0 && strcmp ((yyvsp[-1].str), "datetime") != 0 && strcmp ((yyvsp[-1].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[-1].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*mm_strdup("varchar");*/
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = mm_strdup("float");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = mm_strdup("double");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = mm_strdup("numeric");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = mm_strdup("decimal");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = mm_strdup("date");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = mm_strdup("interval");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[-1].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = mm_strdup("timestamp");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[-1].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = mm_strdup("char");
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[-1].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else
					(yyval.type).type_sizeof = cat_str(3, mm_strdup("sizeof("), mm_strdup(this->name), mm_strdup(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		}
#line 60915 "preproc.c"
    break;

  case 3127:
#line 17315 "preproc.y"
                {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[0].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[0].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[0].struct_union).su, (yyvsp[0].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = mm_strdup("-1");
				(yyval.type).type_index = mm_strdup("-1");
				(yyval.type).type_sizeof = mm_strdup("");
				struct_member_list[struct_level] = NULL;
			}
		}
#line 60951 "preproc.c"
    break;

  case 3128:
#line 17349 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("enum"), (yyvsp[-1].str), (yyvsp[0].str)); }
#line 60957 "preproc.c"
    break;

  case 3129:
#line 17351 "preproc.y"
                        { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 60963 "preproc.c"
    break;

  case 3130:
#line 17353 "preproc.y"
                        { (yyval.str) = cat2_str(mm_strdup("enum"), (yyvsp[0].str)); }
#line 60969 "preproc.c"
    break;

  case 3131:
#line 17357 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 60975 "preproc.c"
    break;

  case 3132:
#line 17360 "preproc.y"
                {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[0].struct_union).symbol);
		}
#line 60986 "preproc.c"
    break;

  case 3133:
#line 17367 "preproc.y"
                {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[-4].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[-4].struct_union).su, (yyvsp[-4].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essentially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = mm_strdup("-1"); /* dimension of array */
			this->type->type_index = mm_strdup("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 61032 "preproc.c"
    break;

  case 3134:
#line 17410 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61038 "preproc.c"
    break;

  case 3135:
#line 17412 "preproc.y"
                {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		}
#line 61048 "preproc.c"
    break;

  case 3136:
#line 17418 "preproc.y"
                {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[-4].str), mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}"));
		}
#line 61059 "preproc.c"
    break;

  case 3137:
#line 17427 "preproc.y"
                {
			(yyval.struct_union).su = mm_strdup("struct");
			(yyval.struct_union).symbol = (yyvsp[0].str);
			ECPGstruct_sizeof = cat_str(3, mm_strdup("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), mm_strdup(")"));
		}
#line 61069 "preproc.c"
    break;

  case 3138:
#line 17433 "preproc.y"
                {
			(yyval.struct_union).su = mm_strdup("union");
			(yyval.struct_union).symbol = (yyvsp[0].str);
		}
#line 61078 "preproc.c"
    break;

  case 3139:
#line 17440 "preproc.y"
                {
			ECPGstruct_sizeof = mm_strdup(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = mm_strdup("struct");
		}
#line 61087 "preproc.c"
    break;

  case 3140:
#line 17445 "preproc.y"
                {
			(yyval.str) = mm_strdup("union");
		}
#line 61095 "preproc.c"
    break;

  case 3141:
#line 17450 "preproc.y"
                                                                { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 61101 "preproc.c"
    break;

  case 3142:
#line 17451 "preproc.y"
                                                                { (yyval.type_enum)=(yyvsp[0].type_enum); }
#line 61107 "preproc.c"
    break;

  case 3143:
#line 17454 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 61113 "preproc.c"
    break;

  case 3144:
#line 17455 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_unsigned_short; }
#line 61119 "preproc.c"
    break;

  case 3145:
#line 17456 "preproc.y"
                                                                        { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 61125 "preproc.c"
    break;

  case 3146:
#line 17457 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_unsigned_int; }
#line 61131 "preproc.c"
    break;

  case 3147:
#line 17458 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 61137 "preproc.c"
    break;

  case 3148:
#line 17459 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_unsigned_long; }
#line 61143 "preproc.c"
    break;

  case 3149:
#line 17461 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 61155 "preproc.c"
    break;

  case 3150:
#line 17469 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		}
#line 61167 "preproc.c"
    break;

  case 3151:
#line 17476 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_unsigned_char; }
#line 61173 "preproc.c"
    break;

  case 3152:
#line 17479 "preproc.y"
                                                { (yyval.type_enum) = ECPGt_short; }
#line 61179 "preproc.c"
    break;

  case 3153:
#line 17480 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_short; }
#line 61185 "preproc.c"
    break;

  case 3154:
#line 17481 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_int; }
#line 61191 "preproc.c"
    break;

  case 3155:
#line 17482 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_long; }
#line 61197 "preproc.c"
    break;

  case 3156:
#line 17483 "preproc.y"
                                                        { (yyval.type_enum) = ECPGt_long; }
#line 61203 "preproc.c"
    break;

  case 3157:
#line 17485 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 61215 "preproc.c"
    break;

  case 3158:
#line 17493 "preproc.y"
                {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		}
#line 61227 "preproc.c"
    break;

  case 3159:
#line 17500 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_bool; }
#line 61233 "preproc.c"
    break;

  case 3160:
#line 17501 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_char; }
#line 61239 "preproc.c"
    break;

  case 3161:
#line 17502 "preproc.y"
                                                                { (yyval.type_enum) = ECPGt_double; }
#line 61245 "preproc.c"
    break;

  case 3164:
#line 17510 "preproc.y"
                        { (yyval.str) = (yyvsp[0].str); }
#line 61251 "preproc.c"
    break;

  case 3165:
#line 17512 "preproc.y"
                {
			if (actual_type[struct_level].type_enum == ECPGt_varchar)
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(";"), (yyvsp[0].str));
			else
				(yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str));
		}
#line 61262 "preproc.c"
    break;

  case 3166:
#line 17521 "preproc.y"
                {
			struct ECPGtype * type;
			char *dimension = (yyvsp[-2].index).index1;	/* dimension of array */
			char *length = (yyvsp[-2].index).index2;		/* length of string */
			char *dim_str;
			char *vcn;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[-4].str)), false);

			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				case ECPGt_varchar:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter), dimension);

					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=mm_strdup("");
					else
							dim_str=cat_str(3, mm_strdup("["), mm_strdup(dimension), mm_strdup("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", varchar_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } *"), mm_strdup((yyvsp[-3].str)), (yyvsp[-1].str), (yyvsp[0].str));
					else
						(yyval.str) = cat_str(8, make2_str(mm_strdup(" struct varchar_"), vcn), mm_strdup(" { int len; char arr["), mm_strdup(length), mm_strdup("]; } "), mm_strdup((yyvsp[-3].str)), dim_str, (yyvsp[-1].str), (yyvsp[0].str));
					varchar_counter++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[0].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[0].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, mm_strdup("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[-4].str), mm_strdup((yyvsp[-3].str)), (yyvsp[-2].index).str, (yyvsp[-1].str), (yyvsp[0].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[-3].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[-3].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[-3].str));
		}
#line 61351 "preproc.c"
    break;

  case 3167:
#line 17608 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 61357 "preproc.c"
    break;

  case 3168:
#line 17610 "preproc.y"
                {
			initializer = 1;
			(yyval.str) = cat2_str(mm_strdup("="), (yyvsp[0].str));
		}
#line 61366 "preproc.c"
    break;

  case 3169:
#line 17616 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 61372 "preproc.c"
    break;

  case 3170:
#line 17617 "preproc.y"
                                                                { (yyval.str) = mm_strdup("*"); }
#line 61378 "preproc.c"
    break;

  case 3171:
#line 17618 "preproc.y"
                                                                { (yyval.str) = mm_strdup("**"); }
#line 61384 "preproc.c"
    break;

  case 3172:
#line 17625 "preproc.y"
                {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, mm_strdup("/* declare statement"), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 61393 "preproc.c"
    break;

  case 3173:
#line 17633 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61399 "preproc.c"
    break;

  case 3174:
#line 17636 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61405 "preproc.c"
    break;

  case 3175:
#line 17637 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 61411 "preproc.c"
    break;

  case 3176:
#line 17638 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"ALL\""); }
#line 61417 "preproc.c"
    break;

  case 3177:
#line 17639 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"CURRENT\""); }
#line 61423 "preproc.c"
    break;

  case 3178:
#line 17642 "preproc.y"
                                                { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 61429 "preproc.c"
    break;

  case 3179:
#line 17643 "preproc.y"
                                                { (yyval.str) = mm_strdup("\"DEFAULT\""); }
#line 61435 "preproc.c"
    break;

  case 3180:
#line 17644 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61441 "preproc.c"
    break;

  case 3181:
#line 17648 "preproc.y"
                        { (yyval.str) = (yyvsp[0].str); }
#line 61447 "preproc.c"
    break;

  case 3182:
#line 17650 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 61453 "preproc.c"
    break;

  case 3183:
#line 17657 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61459 "preproc.c"
    break;

  case 3184:
#line 17658 "preproc.y"
                                { (yyval.str) = mm_strdup("all"); }
#line 61465 "preproc.c"
    break;

  case 3185:
#line 17665 "preproc.y"
                {
			if ((yyvsp[-1].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[-1].str) + 1));
			(yyval.str) = (yyvsp[-1].str);
		}
#line 61475 "preproc.c"
    break;

  case 3186:
#line 17672 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 61481 "preproc.c"
    break;

  case 3187:
#line 17673 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61487 "preproc.c"
    break;

  case 3188:
#line 17676 "preproc.y"
                                        { (yyval.str) = EMPTY; }
#line 61493 "preproc.c"
    break;

  case 3189:
#line 17677 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 61499 "preproc.c"
    break;

  case 3190:
#line 17681 "preproc.y"
                {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[0].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 61508 "preproc.c"
    break;

  case 3191:
#line 17686 "preproc.y"
                {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 61517 "preproc.c"
    break;

  case 3192:
#line 17693 "preproc.y"
                {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[0].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 61526 "preproc.c"
    break;

  case 3193:
#line 17698 "preproc.y"
                {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 61535 "preproc.c"
    break;

  case 3194:
#line 17705 "preproc.y"
                {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = EMPTY;
		}
#line 61544 "preproc.c"
    break;

  case 3197:
#line 17714 "preproc.y"
                {
			char *length = mm_alloc(32);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		}
#line 61555 "preproc.c"
    break;

  case 3198:
#line 17720 "preproc.y"
                        { (yyval.str) = EMPTY; }
#line 61561 "preproc.c"
    break;

  case 3199:
#line 17721 "preproc.y"
                           { (yyval.str) = EMPTY; }
#line 61567 "preproc.c"
    break;

  case 3200:
#line 17724 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61573 "preproc.c"
    break;

  case 3201:
#line 17725 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 61579 "preproc.c"
    break;

  case 3202:
#line 17726 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 61585 "preproc.c"
    break;

  case 3203:
#line 17727 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61591 "preproc.c"
    break;

  case 3204:
#line 17728 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("+"), (yyvsp[0].str)); }
#line 61597 "preproc.c"
    break;

  case 3205:
#line 17729 "preproc.y"
                                        { (yyval.str) = cat_str(2, mm_strdup("-"), (yyvsp[0].str)); }
#line 61603 "preproc.c"
    break;

  case 3206:
#line 17730 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61609 "preproc.c"
    break;

  case 3207:
#line 17731 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61615 "preproc.c"
    break;

  case 3208:
#line 17732 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 61621 "preproc.c"
    break;

  case 3209:
#line 17739 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 61632 "preproc.c"
    break;

  case 3210:
#line 17746 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 61648 "preproc.c"
    break;

  case 3211:
#line 17758 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 61658 "preproc.c"
    break;

  case 3212:
#line 17764 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[-1].str));
	}
#line 61669 "preproc.c"
    break;

  case 3213:
#line 17771 "preproc.y"
        {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[-1].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[-1].str));
	}
#line 61679 "preproc.c"
    break;

  case 3214:
#line 17778 "preproc.y"
                                { (yyval.str) = mm_strdup("output"); }
#line 61685 "preproc.c"
    break;

  case 3215:
#line 17779 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 61691 "preproc.c"
    break;

  case 3216:
#line 17792 "preproc.y"
                {
			add_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 61700 "preproc.c"
    break;

  case 3217:
#line 17803 "preproc.y"
                {
			drop_descriptor((yyvsp[0].str),connection);
			(yyval.str) = (yyvsp[0].str);
		}
#line 61709 "preproc.c"
    break;

  case 3218:
#line 17814 "preproc.y"
                        {  (yyval.str) = (yyvsp[-1].str); }
#line 61715 "preproc.c"
    break;

  case 3221:
#line 17822 "preproc.y"
                        { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 61721 "preproc.c"
    break;

  case 3222:
#line 17827 "preproc.y"
                        { (yyval.str) = (yyvsp[-1].str); }
#line 61727 "preproc.c"
    break;

  case 3225:
#line 17835 "preproc.y"
                {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 61735 "preproc.c"
    break;

  case 3226:
#line 17841 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 61747 "preproc.c"
    break;

  case 3227:
#line 17849 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 61755 "preproc.c"
    break;

  case 3228:
#line 17854 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_count; }
#line 61761 "preproc.c"
    break;

  case 3229:
#line 17862 "preproc.y"
                        {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 61767 "preproc.c"
    break;

  case 3232:
#line 17869 "preproc.y"
                                                { push_assignment((yyvsp[-2].str), (yyvsp[0].dtype_enum)); }
#line 61773 "preproc.c"
    break;

  case 3233:
#line 17873 "preproc.y"
                        {  (yyval.descriptor).str = (yyvsp[-1].str); (yyval.descriptor).name = (yyvsp[-3].str); }
#line 61779 "preproc.c"
    break;

  case 3236:
#line 17881 "preproc.y"
                {
			push_assignment((yyvsp[0].str), (yyvsp[-2].dtype_enum));
		}
#line 61787 "preproc.c"
    break;

  case 3237:
#line 17887 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

			sprintf(length, "%d", (int) strlen((yyvsp[0].str)));
			new_variable((yyvsp[0].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = (yyvsp[0].str);
		}
#line 61799 "preproc.c"
    break;

  case 3238:
#line 17896 "preproc.y"
                {
			(yyval.str) = (yyvsp[0].str);
		}
#line 61807 "preproc.c"
    break;

  case 3239:
#line 17901 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 61820 "preproc.c"
    break;

  case 3240:
#line 17911 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = cat2_str(mm_strdup("-"), (yyvsp[0].str));

			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 61833 "preproc.c"
    break;

  case 3241:
#line 17921 "preproc.y"
                {
			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
			char *var = (yyvsp[0].str) + 1;

			var[strlen(var) - 1] = '\0';
			sprintf(length, "%d", (int) strlen(var));
			new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
			(yyval.str) = var;
		}
#line 61847 "preproc.c"
    break;

  case 3242:
#line 17932 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_cardinality; }
#line 61853 "preproc.c"
    break;

  case 3243:
#line 17933 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_data; }
#line 61859 "preproc.c"
    break;

  case 3244:
#line 17934 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_di_code; }
#line 61865 "preproc.c"
    break;

  case 3245:
#line 17935 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_di_precision; }
#line 61871 "preproc.c"
    break;

  case 3246:
#line 17936 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_indicator; }
#line 61877 "preproc.c"
    break;

  case 3247:
#line 17937 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_key_member; }
#line 61883 "preproc.c"
    break;

  case 3248:
#line 17938 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_length; }
#line 61889 "preproc.c"
    break;

  case 3249:
#line 17939 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_name; }
#line 61895 "preproc.c"
    break;

  case 3250:
#line 17940 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_nullable; }
#line 61901 "preproc.c"
    break;

  case 3251:
#line 17941 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_octet; }
#line 61907 "preproc.c"
    break;

  case 3252:
#line 17942 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_precision; }
#line 61913 "preproc.c"
    break;

  case 3253:
#line 17943 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_length; }
#line 61919 "preproc.c"
    break;

  case 3254:
#line 17944 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_ret_octet; }
#line 61925 "preproc.c"
    break;

  case 3255:
#line 17945 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_scale; }
#line 61931 "preproc.c"
    break;

  case 3256:
#line 17946 "preproc.y"
                                                        { (yyval.dtype_enum) = ECPGd_type; }
#line 61937 "preproc.c"
    break;

  case 3257:
#line 17953 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 61943 "preproc.c"
    break;

  case 3258:
#line 17954 "preproc.y"
                                                  { (yyval.str) = (yyvsp[0].str); }
#line 61949 "preproc.c"
    break;

  case 3259:
#line 17957 "preproc.y"
                                        { (yyval.str) = mm_strdup("on"); }
#line 61955 "preproc.c"
    break;

  case 3260:
#line 17958 "preproc.y"
                                        { (yyval.str) = mm_strdup("off"); }
#line 61961 "preproc.c"
    break;

  case 3261:
#line 17965 "preproc.y"
                                                            { (yyval.str) = (yyvsp[0].str); }
#line 61967 "preproc.c"
    break;

  case 3262:
#line 17966 "preproc.y"
                                                       { (yyval.str) = (yyvsp[0].str); }
#line 61973 "preproc.c"
    break;

  case 3263:
#line 17967 "preproc.y"
                                                    { (yyval.str) = (yyvsp[0].str); }
#line 61979 "preproc.c"
    break;

  case 3264:
#line 17974 "preproc.y"
                {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 61989 "preproc.c"
    break;

  case 3265:
#line 17980 "preproc.y"
                {
			add_typedef((yyvsp[-4].str), (yyvsp[-1].index).index1, (yyvsp[-1].index).index2, (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, initializer, *(yyvsp[0].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, mm_strdup("/* exec sql type"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
			else
				(yyval.str) = cat_str(6, mm_strdup("typedef "), mm_strdup((yyvsp[-2].type).type_str), *(yyvsp[0].str)?mm_strdup("*"):mm_strdup(""), mm_strdup((yyvsp[-4].str)), mm_strdup((yyvsp[-1].index).str), mm_strdup(";"));
		}
#line 62002 "preproc.c"
    break;

  case 3266:
#line 17990 "preproc.y"
                                        { (yyval.str) = mm_strdup("reference"); }
#line 62008 "preproc.c"
    break;

  case 3267:
#line 17991 "preproc.y"
                                                                { (yyval.str) = EMPTY; }
#line 62014 "preproc.c"
    break;

  case 3268:
#line 17998 "preproc.y"
                {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		}
#line 62024 "preproc.c"
    break;

  case 3269:
#line 18004 "preproc.y"
                {
			struct variable *p = find_variable((yyvsp[-4].str));
			char *dimension = (yyvsp[-1].index).index1;
			char *length = (yyvsp[-1].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[-2].type).type_enum == ECPGt_struct ||
				 (yyvsp[-2].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[-2].type).type_enum, &dimension, &length, (yyvsp[-2].type).type_dimension, (yyvsp[-2].type).type_index, *(yyvsp[0].str)?1:0, false);

				switch ((yyvsp[-2].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[-2].type).type_enum, (yyvsp[-2].type).type_str, (yyvsp[-2].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[-2].type).type_enum, mm_strdup("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, mm_strdup("/* exec sql var"), mm_strdup((yyvsp[-4].str)), mm_strdup("is"), mm_strdup((yyvsp[-2].type).type_str), mm_strdup((yyvsp[-1].index).str), (yyvsp[0].str), mm_strdup("*/"));
		}
#line 62086 "preproc.c"
    break;

  case 3270:
#line 18068 "preproc.y"
                {
			when_error.code = (yyvsp[0].action).code;
			when_error.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sqlerror "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 62096 "preproc.c"
    break;

  case 3271:
#line 18074 "preproc.y"
                {
			when_nf.code = (yyvsp[0].action).code;
			when_nf.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever not found "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 62106 "preproc.c"
    break;

  case 3272:
#line 18080 "preproc.y"
                {
			when_warn.code = (yyvsp[0].action).code;
			when_warn.command = (yyvsp[0].action).command;
			(yyval.str) = cat_str(3, mm_strdup("/* exec sql whenever sql_warning "), (yyvsp[0].action).str, mm_strdup("; */"));
		}
#line 62116 "preproc.c"
    break;

  case 3273:
#line 18088 "preproc.y"
                {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("continue");
		}
#line 62126 "preproc.c"
    break;

  case 3274:
#line 18094 "preproc.y"
                {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("sqlprint");
		}
#line 62136 "preproc.c"
    break;

  case 3275:
#line 18100 "preproc.y"
                {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("stop");
		}
#line 62146 "preproc.c"
    break;

  case 3276:
#line 18106 "preproc.y"
                {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 62156 "preproc.c"
    break;

  case 3277:
#line 18112 "preproc.y"
                {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = mm_strdup((yyvsp[0].str));
			(yyval.action).str = cat2_str(mm_strdup("goto "), (yyvsp[0].str));
		}
#line 62166 "preproc.c"
    break;

  case 3278:
#line 18118 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("do"), mm_strdup((yyval.action).command));
		}
#line 62176 "preproc.c"
    break;

  case 3279:
#line 18124 "preproc.y"
                {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = mm_strdup("break");
		}
#line 62186 "preproc.c"
    break;

  case 3280:
#line 18130 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].str), mm_strdup(")"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 62196 "preproc.c"
    break;

  case 3281:
#line 18136 "preproc.y"
                {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[0].str), mm_strdup("()"));
			(yyval.action).str = cat2_str(mm_strdup("call"), mm_strdup((yyval.action).command));
		}
#line 62206 "preproc.c"
    break;

  case 3282:
#line 18146 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62212 "preproc.c"
    break;

  case 3283:
#line 18147 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62218 "preproc.c"
    break;

  case 3284:
#line 18150 "preproc.y"
                                                { (yyval.str) = mm_strdup("break"); }
#line 62224 "preproc.c"
    break;

  case 3285:
#line 18151 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("call"); }
#line 62230 "preproc.c"
    break;

  case 3286:
#line 18152 "preproc.y"
                                                                { (yyval.str) = mm_strdup("cardinality"); }
#line 62236 "preproc.c"
    break;

  case 3287:
#line 18153 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("count"); }
#line 62242 "preproc.c"
    break;

  case 3288:
#line 18154 "preproc.y"
                                                { (yyval.str) = mm_strdup("datetime_interval_code"); }
#line 62248 "preproc.c"
    break;

  case 3289:
#line 18155 "preproc.y"
                                                        { (yyval.str) = mm_strdup("datetime_interval_precision"); }
#line 62254 "preproc.c"
    break;

  case 3290:
#line 18156 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("found"); }
#line 62260 "preproc.c"
    break;

  case 3291:
#line 18157 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("go"); }
#line 62266 "preproc.c"
    break;

  case 3292:
#line 18158 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("goto"); }
#line 62272 "preproc.c"
    break;

  case 3293:
#line 18159 "preproc.y"
                                                                { (yyval.str) = mm_strdup("identified"); }
#line 62278 "preproc.c"
    break;

  case 3294:
#line 18160 "preproc.y"
                                                        { (yyval.str) = mm_strdup("indicator"); }
#line 62284 "preproc.c"
    break;

  case 3295:
#line 18161 "preproc.y"
                                                        { (yyval.str) = mm_strdup("key_member"); }
#line 62290 "preproc.c"
    break;

  case 3296:
#line 18162 "preproc.y"
                                                        { (yyval.str) = mm_strdup("length"); }
#line 62296 "preproc.c"
    break;

  case 3297:
#line 18163 "preproc.y"
                                                        { (yyval.str) = mm_strdup("nullable"); }
#line 62302 "preproc.c"
    break;

  case 3298:
#line 18164 "preproc.y"
                                                        { (yyval.str) = mm_strdup("octet_length"); }
#line 62308 "preproc.c"
    break;

  case 3299:
#line 18165 "preproc.y"
                                                { (yyval.str) = mm_strdup("returned_length"); }
#line 62314 "preproc.c"
    break;

  case 3300:
#line 18166 "preproc.y"
                                                { (yyval.str) = mm_strdup("returned_octet_length"); }
#line 62320 "preproc.c"
    break;

  case 3301:
#line 18167 "preproc.y"
                                                                { (yyval.str) = mm_strdup("scale"); }
#line 62326 "preproc.c"
    break;

  case 3302:
#line 18168 "preproc.y"
                                                        { (yyval.str) = mm_strdup("section"); }
#line 62332 "preproc.c"
    break;

  case 3303:
#line 18169 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sql"); }
#line 62338 "preproc.c"
    break;

  case 3304:
#line 18170 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlerror"); }
#line 62344 "preproc.c"
    break;

  case 3305:
#line 18171 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlprint"); }
#line 62350 "preproc.c"
    break;

  case 3306:
#line 18172 "preproc.y"
                                                        { (yyval.str) = mm_strdup("sqlwarning"); }
#line 62356 "preproc.c"
    break;

  case 3307:
#line 18173 "preproc.y"
                                                                { (yyval.str) = mm_strdup("stop"); }
#line 62362 "preproc.c"
    break;

  case 3308:
#line 18176 "preproc.y"
                                        { (yyval.str) = mm_strdup("connect"); }
#line 62368 "preproc.c"
    break;

  case 3309:
#line 18177 "preproc.y"
                                                        { (yyval.str) = mm_strdup("describe"); }
#line 62374 "preproc.c"
    break;

  case 3310:
#line 18178 "preproc.y"
                                                        { (yyval.str) = mm_strdup("disconnect"); }
#line 62380 "preproc.c"
    break;

  case 3311:
#line 18179 "preproc.y"
                                                                { (yyval.str) = mm_strdup("open"); }
#line 62386 "preproc.c"
    break;

  case 3312:
#line 18180 "preproc.y"
                                                                { (yyval.str) = mm_strdup("var"); }
#line 62392 "preproc.c"
    break;

  case 3313:
#line 18181 "preproc.y"
                                                        { (yyval.str) = mm_strdup("whenever"); }
#line 62398 "preproc.c"
    break;

  case 3314:
#line 18185 "preproc.y"
                                                { (yyval.str) = mm_strdup("bool"); }
#line 62404 "preproc.c"
    break;

  case 3315:
#line 18186 "preproc.y"
                                                                { (yyval.str) = mm_strdup("long"); }
#line 62410 "preproc.c"
    break;

  case 3316:
#line 18187 "preproc.y"
                                                        { (yyval.str) = mm_strdup("output"); }
#line 62416 "preproc.c"
    break;

  case 3317:
#line 18188 "preproc.y"
                                                                { (yyval.str) = mm_strdup("short"); }
#line 62422 "preproc.c"
    break;

  case 3318:
#line 18189 "preproc.y"
                                                        { (yyval.str) = mm_strdup("struct"); }
#line 62428 "preproc.c"
    break;

  case 3319:
#line 18190 "preproc.y"
                                                        { (yyval.str) = mm_strdup("signed"); }
#line 62434 "preproc.c"
    break;

  case 3320:
#line 18191 "preproc.y"
                                                        { (yyval.str) = mm_strdup("unsigned"); }
#line 62440 "preproc.c"
    break;

  case 3321:
#line 18194 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62446 "preproc.c"
    break;

  case 3322:
#line 18197 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62452 "preproc.c"
    break;

  case 3323:
#line 18198 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62458 "preproc.c"
    break;

  case 3324:
#line 18199 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62464 "preproc.c"
    break;

  case 3325:
#line 18200 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62470 "preproc.c"
    break;

  case 3326:
#line 18201 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62476 "preproc.c"
    break;

  case 3327:
#line 18202 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62482 "preproc.c"
    break;

  case 3328:
#line 18203 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 62488 "preproc.c"
    break;

  case 3329:
#line 18204 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 62494 "preproc.c"
    break;

  case 3330:
#line 18217 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62500 "preproc.c"
    break;

  case 3331:
#line 18218 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62506 "preproc.c"
    break;

  case 3332:
#line 18219 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62512 "preproc.c"
    break;

  case 3333:
#line 18220 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62518 "preproc.c"
    break;

  case 3334:
#line 18221 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62524 "preproc.c"
    break;

  case 3335:
#line 18222 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 62530 "preproc.c"
    break;

  case 3336:
#line 18223 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 62536 "preproc.c"
    break;

  case 3337:
#line 18228 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62542 "preproc.c"
    break;

  case 3338:
#line 18229 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62548 "preproc.c"
    break;

  case 3339:
#line 18230 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62554 "preproc.c"
    break;

  case 3340:
#line 18231 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62560 "preproc.c"
    break;

  case 3341:
#line 18232 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62566 "preproc.c"
    break;

  case 3342:
#line 18233 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62572 "preproc.c"
    break;

  case 3343:
#line 18239 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62578 "preproc.c"
    break;

  case 3344:
#line 18240 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62584 "preproc.c"
    break;

  case 3345:
#line 18241 "preproc.y"
                                                                { (yyval.str) = mm_strdup("char"); }
#line 62590 "preproc.c"
    break;

  case 3346:
#line 18242 "preproc.y"
                                                                { (yyval.str) = mm_strdup("current"); }
#line 62596 "preproc.c"
    break;

  case 3347:
#line 18243 "preproc.y"
                                                                { (yyval.str) = mm_strdup("input"); }
#line 62602 "preproc.c"
    break;

  case 3348:
#line 18244 "preproc.y"
                                                                { (yyval.str) = mm_strdup("int"); }
#line 62608 "preproc.c"
    break;

  case 3349:
#line 18245 "preproc.y"
                                                                { (yyval.str) = mm_strdup("to"); }
#line 62614 "preproc.c"
    break;

  case 3350:
#line 18246 "preproc.y"
                                                                { (yyval.str) = mm_strdup("union"); }
#line 62620 "preproc.c"
    break;

  case 3351:
#line 18247 "preproc.y"
                                                                { (yyval.str) = mm_strdup("values"); }
#line 62626 "preproc.c"
    break;

  case 3352:
#line 18248 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62632 "preproc.c"
    break;

  case 3353:
#line 18249 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62638 "preproc.c"
    break;

  case 3354:
#line 18252 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62644 "preproc.c"
    break;

  case 3355:
#line 18253 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62650 "preproc.c"
    break;

  case 3356:
#line 18254 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62656 "preproc.c"
    break;

  case 3357:
#line 18255 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62662 "preproc.c"
    break;

  case 3358:
#line 18256 "preproc.y"
                                                        { (yyval.str) = mm_strdup("connection"); }
#line 62668 "preproc.c"
    break;

  case 3359:
#line 18259 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62674 "preproc.c"
    break;

  case 3360:
#line 18260 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 62680 "preproc.c"
    break;

  case 3361:
#line 18261 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62686 "preproc.c"
    break;

  case 3362:
#line 18262 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62692 "preproc.c"
    break;

  case 3363:
#line 18265 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 62698 "preproc.c"
    break;

  case 3364:
#line 18266 "preproc.y"
                                                                { (yyval.str) = mm_strdup("const"); }
#line 62704 "preproc.c"
    break;

  case 3365:
#line 18267 "preproc.y"
                                                                { (yyval.str) = mm_strdup("extern"); }
#line 62710 "preproc.c"
    break;

  case 3366:
#line 18268 "preproc.y"
                                                        { (yyval.str) = mm_strdup("register"); }
#line 62716 "preproc.c"
    break;

  case 3367:
#line 18269 "preproc.y"
                                                                { (yyval.str) = mm_strdup("static"); }
#line 62722 "preproc.c"
    break;

  case 3368:
#line 18270 "preproc.y"
                                                                { (yyval.str) = mm_strdup("typedef"); }
#line 62728 "preproc.c"
    break;

  case 3369:
#line 18271 "preproc.y"
                                                        { (yyval.str) = mm_strdup("volatile"); }
#line 62734 "preproc.c"
    break;

  case 3370:
#line 18288 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 62740 "preproc.c"
    break;

  case 3371:
#line 18289 "preproc.y"
                                                                { (yyval.str) = (yyvsp[0].str); }
#line 62746 "preproc.c"
    break;

  case 3372:
#line 18290 "preproc.y"
                                                                        { (yyval.str) = mm_strdup("connection"); }
#line 62752 "preproc.c"
    break;

  case 3373:
#line 18293 "preproc.y"
                                                        { (yyval.str) = mm_strdup("day"); }
#line 62758 "preproc.c"
    break;

  case 3374:
#line 18294 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("hour"); }
#line 62764 "preproc.c"
    break;

  case 3375:
#line 18295 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("minute"); }
#line 62770 "preproc.c"
    break;

  case 3376:
#line 18296 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("month"); }
#line 62776 "preproc.c"
    break;

  case 3377:
#line 18297 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("second"); }
#line 62782 "preproc.c"
    break;

  case 3378:
#line 18298 "preproc.y"
                                                                                { (yyval.str) = mm_strdup("year"); }
#line 62788 "preproc.c"
    break;

  case 3381:
#line 18305 "preproc.y"
                        {
				reset_variables();
				pacounter = 1;
			}
#line 62797 "preproc.c"
    break;

  case 3382:
#line 18311 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 62803 "preproc.c"
    break;

  case 3383:
#line 18312 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 62809 "preproc.c"
    break;

  case 3384:
#line 18316 "preproc.y"
                        { add_variable_to_head(&argsresult, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str))); }
#line 62815 "preproc.c"
    break;

  case 3385:
#line 18318 "preproc.y"
                        { add_variable_to_head(&argsresult, find_variable((yyvsp[0].str)), &no_indicator); }
#line 62821 "preproc.c"
    break;

  case 3386:
#line 18323 "preproc.y"
                {
			if (find_variable((yyvsp[0].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[-1].str)), find_variable((yyvsp[0].str)));
			(yyval.str) = create_questionmarks((yyvsp[-1].str), false);
		}
#line 62833 "preproc.c"
    break;

  case 3387:
#line 18333 "preproc.y"
                {
			char *ptr = strstr((yyvsp[0].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = (yyvsp[0].str);
		}
#line 62846 "preproc.c"
    break;

  case 3388:
#line 18344 "preproc.y"
                {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[0].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[0].str), false);
		}
#line 62855 "preproc.c"
    break;

  case 3389:
#line 18350 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 62861 "preproc.c"
    break;

  case 3390:
#line 18351 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 62867 "preproc.c"
    break;

  case 3391:
#line 18352 "preproc.y"
                                                { check_indicator((find_variable((yyvsp[0].str)))->type); (yyval.str) = (yyvsp[0].str); }
#line 62873 "preproc.c"
    break;

  case 3392:
#line 18356 "preproc.y"
                {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[0].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmfatal(PARSE_ERROR, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[0].str);
		}
#line 62908 "preproc.c"
    break;

  case 3393:
#line 18388 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 62914 "preproc.c"
    break;

  case 3394:
#line 18390 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 62920 "preproc.c"
    break;

  case 3395:
#line 18392 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 62926 "preproc.c"
    break;

  case 3396:
#line 18396 "preproc.y"
                {
			/* could have been input as '' or $$ */
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 3);
			(yyval.str)[0]='\'';
			strcpy((yyval.str)+1, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+1]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+2]='\0';
			free((yyvsp[0].str));
		}
#line 62940 "preproc.c"
    break;

  case 3397:
#line 18406 "preproc.y"
                {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='E';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 62954 "preproc.c"
    break;

  case 3398:
#line 18416 "preproc.y"
                {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[0].str)) + 4);
			(yyval.str)[0]='N';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[0].str));
			(yyval.str)[strlen((yyvsp[0].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[0].str))+3]='\0';
			free((yyvsp[0].str));
		}
#line 62968 "preproc.c"
    break;

  case 3399:
#line 18425 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 62974 "preproc.c"
    break;

  case 3400:
#line 18426 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 62980 "preproc.c"
    break;

  case 3401:
#line 18429 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 62986 "preproc.c"
    break;

  case 3402:
#line 18431 "preproc.y"
                                { (yyval.str) = make_name(); }
#line 62992 "preproc.c"
    break;

  case 3403:
#line 18432 "preproc.y"
                                { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 62998 "preproc.c"
    break;

  case 3404:
#line 18433 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 63004 "preproc.c"
    break;

  case 3405:
#line 18437 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("\""), (yyvsp[0].str), mm_strdup("\"")); }
#line 63010 "preproc.c"
    break;

  case 3406:
#line 18439 "preproc.y"
                        { (yyval.str) = make3_str(mm_strdup("("), (yyvsp[0].str), mm_strdup(")")); }
#line 63016 "preproc.c"
    break;

  case 3407:
#line 18446 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63022 "preproc.c"
    break;

  case 3408:
#line 18447 "preproc.y"
                                                { (yyval.str) = mm_strdup("()"); }
#line 63028 "preproc.c"
    break;

  case 3409:
#line 18449 "preproc.y"
                        { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 63034 "preproc.c"
    break;

  case 3410:
#line 18452 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63040 "preproc.c"
    break;

  case 3411:
#line 18454 "preproc.y"
                        { (yyval.str) = cat2_str((yyvsp[-1].str), (yyvsp[0].str)); }
#line 63046 "preproc.c"
    break;

  case 3412:
#line 18457 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63052 "preproc.c"
    break;

  case 3413:
#line 18458 "preproc.y"
                                        { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup(","), (yyvsp[0].str)); }
#line 63058 "preproc.c"
    break;

  case 3414:
#line 18461 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63064 "preproc.c"
    break;

  case 3415:
#line 18462 "preproc.y"
                                        { (yyval.str) = cat_str(3, mm_strdup("{"), (yyvsp[-1].str), mm_strdup("}")); }
#line 63070 "preproc.c"
    break;

  case 3416:
#line 18465 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63076 "preproc.c"
    break;

  case 3417:
#line 18466 "preproc.y"
                                        { (yyval.str) = mm_strdup("("); }
#line 63082 "preproc.c"
    break;

  case 3418:
#line 18467 "preproc.y"
                                        { (yyval.str) = mm_strdup(")"); }
#line 63088 "preproc.c"
    break;

  case 3419:
#line 18468 "preproc.y"
                                        { (yyval.str) = mm_strdup(","); }
#line 63094 "preproc.c"
    break;

  case 3420:
#line 18469 "preproc.y"
                                        { (yyval.str) = mm_strdup(";"); }
#line 63100 "preproc.c"
    break;

  case 3421:
#line 18472 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63106 "preproc.c"
    break;

  case 3422:
#line 18473 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63112 "preproc.c"
    break;

  case 3423:
#line 18474 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63118 "preproc.c"
    break;

  case 3424:
#line 18475 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63124 "preproc.c"
    break;

  case 3425:
#line 18476 "preproc.y"
                                                { (yyval.str) = mm_strdup("*"); }
#line 63130 "preproc.c"
    break;

  case 3426:
#line 18477 "preproc.y"
                                                { (yyval.str) = mm_strdup("+"); }
#line 63136 "preproc.c"
    break;

  case 3427:
#line 18478 "preproc.y"
                                                { (yyval.str) = mm_strdup("-"); }
#line 63142 "preproc.c"
    break;

  case 3428:
#line 18479 "preproc.y"
                                                { (yyval.str) = mm_strdup("/"); }
#line 63148 "preproc.c"
    break;

  case 3429:
#line 18480 "preproc.y"
                                                { (yyval.str) = mm_strdup("%"); }
#line 63154 "preproc.c"
    break;

  case 3430:
#line 18481 "preproc.y"
                                                { (yyval.str) = mm_strdup("NULL"); }
#line 63160 "preproc.c"
    break;

  case 3431:
#line 18482 "preproc.y"
                                                { (yyval.str) = mm_strdup("+="); }
#line 63166 "preproc.c"
    break;

  case 3432:
#line 18483 "preproc.y"
                                                { (yyval.str) = mm_strdup("&&"); }
#line 63172 "preproc.c"
    break;

  case 3433:
#line 18484 "preproc.y"
                                                { (yyval.str) = make_name(); }
#line 63178 "preproc.c"
    break;

  case 3434:
#line 18485 "preproc.y"
                                                { (yyval.str) = mm_strdup("auto"); }
#line 63184 "preproc.c"
    break;

  case 3435:
#line 18486 "preproc.y"
                                                { (yyval.str) = mm_strdup("const"); }
#line 63190 "preproc.c"
    break;

  case 3436:
#line 18487 "preproc.y"
                                                { (yyval.str) = mm_strdup("--"); }
#line 63196 "preproc.c"
    break;

  case 3437:
#line 18488 "preproc.y"
                                                { (yyval.str) = mm_strdup("/="); }
#line 63202 "preproc.c"
    break;

  case 3438:
#line 18489 "preproc.y"
                                                { (yyval.str) = mm_strdup(".*"); }
#line 63208 "preproc.c"
    break;

  case 3439:
#line 18490 "preproc.y"
                                                { (yyval.str) = mm_strdup("=="); }
#line 63214 "preproc.c"
    break;

  case 3440:
#line 18491 "preproc.y"
                                                { (yyval.str) = mm_strdup("extern"); }
#line 63220 "preproc.c"
    break;

  case 3441:
#line 18492 "preproc.y"
                                                { (yyval.str) = mm_strdup("++"); }
#line 63226 "preproc.c"
    break;

  case 3442:
#line 18493 "preproc.y"
                                                { (yyval.str) = mm_strdup("<<"); }
#line 63232 "preproc.c"
    break;

  case 3443:
#line 18494 "preproc.y"
                                                { (yyval.str) = mm_strdup("->"); }
#line 63238 "preproc.c"
    break;

  case 3444:
#line 18495 "preproc.y"
                                                { (yyval.str) = mm_strdup("->*"); }
#line 63244 "preproc.c"
    break;

  case 3445:
#line 18496 "preproc.y"
                                                { (yyval.str) = mm_strdup("%="); }
#line 63250 "preproc.c"
    break;

  case 3446:
#line 18497 "preproc.y"
                                                { (yyval.str) = mm_strdup("*="); }
#line 63256 "preproc.c"
    break;

  case 3447:
#line 18498 "preproc.y"
                                                { (yyval.str) = mm_strdup("!="); }
#line 63262 "preproc.c"
    break;

  case 3448:
#line 18499 "preproc.y"
                                                { (yyval.str) = mm_strdup("||"); }
#line 63268 "preproc.c"
    break;

  case 3449:
#line 18500 "preproc.y"
                                                { (yyval.str) = mm_strdup("register"); }
#line 63274 "preproc.c"
    break;

  case 3450:
#line 18501 "preproc.y"
                                                { (yyval.str) = mm_strdup(">>"); }
#line 63280 "preproc.c"
    break;

  case 3451:
#line 18502 "preproc.y"
                                                { (yyval.str) = mm_strdup("static"); }
#line 63286 "preproc.c"
    break;

  case 3452:
#line 18503 "preproc.y"
                                                { (yyval.str) = mm_strdup("-="); }
#line 63292 "preproc.c"
    break;

  case 3453:
#line 18504 "preproc.y"
                                                { (yyval.str) = mm_strdup("typedef"); }
#line 63298 "preproc.c"
    break;

  case 3454:
#line 18505 "preproc.y"
                                                { (yyval.str) = mm_strdup("volatile"); }
#line 63304 "preproc.c"
    break;

  case 3455:
#line 18506 "preproc.y"
                                                { (yyval.str) = mm_strdup("bool"); }
#line 63310 "preproc.c"
    break;

  case 3456:
#line 18507 "preproc.y"
                                                { (yyval.str) = mm_strdup("enum"); }
#line 63316 "preproc.c"
    break;

  case 3457:
#line 18508 "preproc.y"
                                                { (yyval.str) = mm_strdup("hour"); }
#line 63322 "preproc.c"
    break;

  case 3458:
#line 18509 "preproc.y"
                                                { (yyval.str) = mm_strdup("int"); }
#line 63328 "preproc.c"
    break;

  case 3459:
#line 18510 "preproc.y"
                                                { (yyval.str) = mm_strdup("long"); }
#line 63334 "preproc.c"
    break;

  case 3460:
#line 18511 "preproc.y"
                                                { (yyval.str) = mm_strdup("minute"); }
#line 63340 "preproc.c"
    break;

  case 3461:
#line 18512 "preproc.y"
                                                { (yyval.str) = mm_strdup("month"); }
#line 63346 "preproc.c"
    break;

  case 3462:
#line 18513 "preproc.y"
                                                { (yyval.str) = mm_strdup("second"); }
#line 63352 "preproc.c"
    break;

  case 3463:
#line 18514 "preproc.y"
                                                { (yyval.str) = mm_strdup("short"); }
#line 63358 "preproc.c"
    break;

  case 3464:
#line 18515 "preproc.y"
                                                { (yyval.str) = mm_strdup("signed"); }
#line 63364 "preproc.c"
    break;

  case 3465:
#line 18516 "preproc.y"
                                                { (yyval.str) = mm_strdup("struct"); }
#line 63370 "preproc.c"
    break;

  case 3466:
#line 18517 "preproc.y"
                                                { (yyval.str) = mm_strdup("unsigned"); }
#line 63376 "preproc.c"
    break;

  case 3467:
#line 18518 "preproc.y"
                                                { (yyval.str) = mm_strdup("year"); }
#line 63382 "preproc.c"
    break;

  case 3468:
#line 18519 "preproc.y"
                                                { (yyval.str) = mm_strdup("char"); }
#line 63388 "preproc.c"
    break;

  case 3469:
#line 18520 "preproc.y"
                                                { (yyval.str) = mm_strdup("float"); }
#line 63394 "preproc.c"
    break;

  case 3470:
#line 18521 "preproc.y"
                                                { (yyval.str) = mm_strdup("to"); }
#line 63400 "preproc.c"
    break;

  case 3471:
#line 18522 "preproc.y"
                                                { (yyval.str) = mm_strdup("union"); }
#line 63406 "preproc.c"
    break;

  case 3472:
#line 18523 "preproc.y"
                                                { (yyval.str) = mm_strdup("varchar"); }
#line 63412 "preproc.c"
    break;

  case 3473:
#line 18524 "preproc.y"
                                                { (yyval.str) = mm_strdup("["); }
#line 63418 "preproc.c"
    break;

  case 3474:
#line 18525 "preproc.y"
                                                { (yyval.str) = mm_strdup("]"); }
#line 63424 "preproc.c"
    break;

  case 3475:
#line 18526 "preproc.y"
                                                { (yyval.str) = mm_strdup("="); }
#line 63430 "preproc.c"
    break;

  case 3476:
#line 18527 "preproc.y"
                                                { (yyval.str) = mm_strdup(":"); }
#line 63436 "preproc.c"
    break;

  case 3477:
#line 18530 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63442 "preproc.c"
    break;

  case 3478:
#line 18531 "preproc.y"
                                                        { (yyval.str) = (yyvsp[0].str); }
#line 63448 "preproc.c"
    break;

  case 3479:
#line 18532 "preproc.y"
                                                        { (yyval.str) = mm_strdup("all"); }
#line 63454 "preproc.c"
    break;

  case 3480:
#line 18533 "preproc.y"
                                                        { (yyval.str) = mm_strdup("all"); }
#line 63460 "preproc.c"
    break;

  case 3481:
#line 18536 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63466 "preproc.c"
    break;

  case 3482:
#line 18537 "preproc.y"
                                                { (yyval.str) = cat_str(3, mm_strdup("("), (yyvsp[-1].str), mm_strdup(")")); }
#line 63472 "preproc.c"
    break;

  case 3483:
#line 18538 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("+"), (yyvsp[0].str)); }
#line 63478 "preproc.c"
    break;

  case 3484:
#line 18539 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("-"), (yyvsp[0].str)); }
#line 63484 "preproc.c"
    break;

  case 3485:
#line 18540 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("*"), (yyvsp[0].str)); }
#line 63490 "preproc.c"
    break;

  case 3486:
#line 18541 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("/"), (yyvsp[0].str)); }
#line 63496 "preproc.c"
    break;

  case 3487:
#line 18542 "preproc.y"
                                                { (yyval.str) = cat_str(3, (yyvsp[-2].str), mm_strdup("%"), (yyvsp[0].str)); }
#line 63502 "preproc.c"
    break;

  case 3488:
#line 18543 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63508 "preproc.c"
    break;

  case 3489:
#line 18544 "preproc.y"
                                                { (yyval.str) = (yyvsp[0].str); }
#line 63514 "preproc.c"
    break;

  case 3490:
#line 18545 "preproc.y"
                                                { if (pg_strcasecmp((yyvsp[-3].str), "sizeof") != 0)
							mmerror(PARSE_ERROR, ET_ERROR, "operator not allowed in variable definition");
						  else
							(yyval.str) = cat_str(4, (yyvsp[-3].str), mm_strdup("("), (yyvsp[-1].type).type_str, mm_strdup(")"));
						}
#line 63524 "preproc.c"
    break;

  case 3491:
#line 18552 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 63530 "preproc.c"
    break;

  case 3492:
#line 18553 "preproc.y"
                                    { (yyval.str) = EMPTY; }
#line 63536 "preproc.c"
    break;

  case 3493:
#line 18554 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 63542 "preproc.c"
    break;

  case 3494:
#line 18555 "preproc.y"
                                                { (yyval.str) = EMPTY; }
#line 63548 "preproc.c"
    break;

  case 3495:
#line 18558 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 63554 "preproc.c"
    break;

  case 3496:
#line 18559 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63560 "preproc.c"
    break;

  case 3497:
#line 18562 "preproc.y"
                                { (yyval.str) = EMPTY; }
#line 63566 "preproc.c"
    break;

  case 3498:
#line 18563 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 63572 "preproc.c"
    break;

  case 3499:
#line 18566 "preproc.y"
                                { (yyval.str) = (yyvsp[0].str); }
#line 63578 "preproc.c"
    break;

  case 3500:
#line 18568 "preproc.y"
        {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[0].str);
	}
#line 63591 "preproc.c"
    break;

  case 3501:
#line 18578 "preproc.y"
                                        { (yyval.str) = EMPTY; }
#line 63597 "preproc.c"
    break;

  case 3502:
#line 18579 "preproc.y"
                                        { (yyval.str) = (yyvsp[0].str); }
#line 63603 "preproc.c"
    break;


#line 63607 "preproc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 18582 "preproc.y"


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : base_yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}
